#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1148
#define LARGE_STATE_COUNT 732
#define SYMBOL_COUNT 124
#define ALIAS_COUNT 0
#define TOKEN_COUNT 77
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 14
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 15

enum {
  anon_sym_LF = 1,
  anon_sym_SEMI = 2,
  anon_sym_function = 3,
  anon_sym_BSLASH = 4,
  anon_sym_if = 5,
  anon_sym_LPAREN = 6,
  anon_sym_RPAREN = 7,
  anon_sym_else = 8,
  anon_sym_while = 9,
  anon_sym_repeat = 10,
  anon_sym_for = 11,
  anon_sym_in = 12,
  anon_sym_switch = 13,
  anon_sym_COMMA = 14,
  anon_sym_EQ = 15,
  anon_sym_LBRACE = 16,
  anon_sym_RBRACE = 17,
  anon_sym_LT_DASH = 18,
  anon_sym_COLON_EQ = 19,
  anon_sym_LT_LT_DASH = 20,
  anon_sym_DASH_GT_GT = 21,
  anon_sym_DASH_GT = 22,
  anon_sym_LBRACK = 23,
  anon_sym_RBRACK = 24,
  anon_sym_LBRACK_LBRACK = 25,
  anon_sym_RBRACK_RBRACK = 26,
  anon_sym_DOLLAR = 27,
  anon_sym_AT = 28,
  anon_sym_COLON_COLON = 29,
  anon_sym_COLON_COLON_COLON = 30,
  sym_dots = 31,
  anon_sym_PIPE_GT = 32,
  anon_sym_DASH = 33,
  anon_sym_PLUS = 34,
  anon_sym_BANG = 35,
  anon_sym_TILDE = 36,
  anon_sym_STAR = 37,
  anon_sym_SLASH = 38,
  anon_sym_CARET = 39,
  anon_sym_LT = 40,
  anon_sym_GT = 41,
  anon_sym_LT_EQ = 42,
  anon_sym_GT_EQ = 43,
  anon_sym_EQ_EQ = 44,
  anon_sym_BANG_EQ = 45,
  anon_sym_PIPE_PIPE = 46,
  anon_sym_PIPE = 47,
  anon_sym_AMP_AMP = 48,
  anon_sym_AMP = 49,
  anon_sym_COLON = 50,
  sym_break = 51,
  sym_next = 52,
  sym_true = 53,
  sym_false = 54,
  sym_null = 55,
  sym_inf = 56,
  sym_nan = 57,
  anon_sym_NA = 58,
  anon_sym_NA_character_ = 59,
  anon_sym_NA_complex_ = 60,
  anon_sym_NA_integer_ = 61,
  anon_sym_NA_real_ = 62,
  aux_sym_identifier_token1 = 63,
  anon_sym_BQUOTE = 64,
  aux_sym_identifier_token2 = 65,
  sym_integer = 66,
  sym_float = 67,
  anon_sym_i = 68,
  sym_comment = 69,
  anon_sym_DQUOTE = 70,
  aux_sym_string_token1 = 71,
  anon_sym_SQUOTE = 72,
  aux_sym_string_token2 = 73,
  anon_sym_PERCENT = 74,
  aux_sym_special_token1 = 75,
  sym_escape_sequence = 76,
  sym_program = 77,
  sym_function_definition = 78,
  sym_lambda_function = 79,
  sym_if = 80,
  sym_while = 81,
  sym_repeat = 82,
  sym_for = 83,
  sym_switch = 84,
  sym_formal_parameters = 85,
  sym_default_parameter = 86,
  sym__formal_parameter = 87,
  sym_arguments = 88,
  sym_default_argument = 89,
  sym__argument = 90,
  sym_call = 91,
  sym__assignment = 92,
  sym_left_assignment = 93,
  sym_left_assignment2 = 94,
  sym_equals_assignment = 95,
  sym_super_assignment = 96,
  sym_super_right_assignment = 97,
  sym_right_assignment = 98,
  sym_brace_list = 99,
  sym_paren_list = 100,
  sym_subset = 101,
  sym_subset2 = 102,
  sym_dollar = 103,
  sym_slot = 104,
  sym_namespace_get = 105,
  sym_namespace_get_internal = 106,
  sym_pipe = 107,
  sym_unary = 108,
  sym_binary = 109,
  sym_na = 110,
  sym__expression = 111,
  sym_identifier = 112,
  sym_complex = 113,
  sym_string = 114,
  sym_special = 115,
  aux_sym_program_repeat1 = 116,
  aux_sym_formal_parameters_repeat1 = 117,
  aux_sym_block_repeat1 = 118,
  aux_sym_arguments_repeat1 = 119,
  aux_sym_identifier_repeat1 = 120,
  aux_sym_string_repeat1 = 121,
  aux_sym_string_repeat2 = 122,
  aux_sym_special_repeat1 = 123,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_LF] = "\n",
  [anon_sym_SEMI] = ";",
  [anon_sym_function] = "function",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_if] = "if",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_else] = "else",
  [anon_sym_while] = "while",
  [anon_sym_repeat] = "repeat",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_switch] = "switch",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_DASH_GT_GT] = "->>",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_AT] = "@",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COLON_COLON_COLON] = ":::",
  [sym_dots] = "dots",
  [anon_sym_PIPE_GT] = "|>",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_CARET] = "^",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_AMP] = "&",
  [anon_sym_COLON] = ":",
  [sym_break] = "break",
  [sym_next] = "next",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_inf] = "inf",
  [sym_nan] = "nan",
  [anon_sym_NA] = "NA",
  [anon_sym_NA_character_] = "NA_character_",
  [anon_sym_NA_complex_] = "NA_complex_",
  [anon_sym_NA_integer_] = "NA_integer_",
  [anon_sym_NA_real_] = "NA_real_",
  [aux_sym_identifier_token1] = "identifier_token1",
  [anon_sym_BQUOTE] = "`",
  [aux_sym_identifier_token2] = "identifier_token2",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [anon_sym_i] = "i",
  [sym_comment] = "comment",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [anon_sym_PERCENT] = "%",
  [aux_sym_special_token1] = "special_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_program] = "program",
  [sym_function_definition] = "function_definition",
  [sym_lambda_function] = "lambda_function",
  [sym_if] = "if",
  [sym_while] = "while",
  [sym_repeat] = "repeat",
  [sym_for] = "for",
  [sym_switch] = "switch",
  [sym_formal_parameters] = "formal_parameters",
  [sym_default_parameter] = "default_parameter",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_arguments] = "arguments",
  [sym_default_argument] = "default_argument",
  [sym__argument] = "_argument",
  [sym_call] = "call",
  [sym__assignment] = "_assignment",
  [sym_left_assignment] = "left_assignment",
  [sym_left_assignment2] = "left_assignment2",
  [sym_equals_assignment] = "equals_assignment",
  [sym_super_assignment] = "super_assignment",
  [sym_super_right_assignment] = "super_right_assignment",
  [sym_right_assignment] = "right_assignment",
  [sym_brace_list] = "brace_list",
  [sym_paren_list] = "paren_list",
  [sym_subset] = "subset",
  [sym_subset2] = "subset2",
  [sym_dollar] = "dollar",
  [sym_slot] = "slot",
  [sym_namespace_get] = "namespace_get",
  [sym_namespace_get_internal] = "namespace_get_internal",
  [sym_pipe] = "pipe",
  [sym_unary] = "unary",
  [sym_binary] = "binary",
  [sym_na] = "na",
  [sym__expression] = "_expression",
  [sym_identifier] = "identifier",
  [sym_complex] = "complex",
  [sym_string] = "string",
  [sym_special] = "special",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_identifier_repeat1] = "identifier_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_special_repeat1] = "special_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_LT_LT_DASH] = anon_sym_LT_LT_DASH,
  [anon_sym_DASH_GT_GT] = anon_sym_DASH_GT_GT,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_COLON_COLON_COLON] = anon_sym_COLON_COLON_COLON,
  [sym_dots] = sym_dots,
  [anon_sym_PIPE_GT] = anon_sym_PIPE_GT,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_break] = sym_break,
  [sym_next] = sym_next,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_inf] = sym_inf,
  [sym_nan] = sym_nan,
  [anon_sym_NA] = anon_sym_NA,
  [anon_sym_NA_character_] = anon_sym_NA_character_,
  [anon_sym_NA_complex_] = anon_sym_NA_complex_,
  [anon_sym_NA_integer_] = anon_sym_NA_integer_,
  [anon_sym_NA_real_] = anon_sym_NA_real_,
  [aux_sym_identifier_token1] = aux_sym_identifier_token1,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [aux_sym_identifier_token2] = aux_sym_identifier_token2,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [anon_sym_i] = anon_sym_i,
  [sym_comment] = sym_comment,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [aux_sym_special_token1] = aux_sym_special_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_program] = sym_program,
  [sym_function_definition] = sym_function_definition,
  [sym_lambda_function] = sym_lambda_function,
  [sym_if] = sym_if,
  [sym_while] = sym_while,
  [sym_repeat] = sym_repeat,
  [sym_for] = sym_for,
  [sym_switch] = sym_switch,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_default_parameter] = sym_default_parameter,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_arguments] = sym_arguments,
  [sym_default_argument] = sym_default_argument,
  [sym__argument] = sym__argument,
  [sym_call] = sym_call,
  [sym__assignment] = sym__assignment,
  [sym_left_assignment] = sym_left_assignment,
  [sym_left_assignment2] = sym_left_assignment2,
  [sym_equals_assignment] = sym_equals_assignment,
  [sym_super_assignment] = sym_super_assignment,
  [sym_super_right_assignment] = sym_super_right_assignment,
  [sym_right_assignment] = sym_right_assignment,
  [sym_brace_list] = sym_brace_list,
  [sym_paren_list] = sym_paren_list,
  [sym_subset] = sym_subset,
  [sym_subset2] = sym_subset2,
  [sym_dollar] = sym_dollar,
  [sym_slot] = sym_slot,
  [sym_namespace_get] = sym_namespace_get,
  [sym_namespace_get_internal] = sym_namespace_get_internal,
  [sym_pipe] = sym_pipe,
  [sym_unary] = sym_unary,
  [sym_binary] = sym_binary,
  [sym_na] = sym_na,
  [sym__expression] = sym__expression,
  [sym_identifier] = sym_identifier,
  [sym_complex] = sym_complex,
  [sym_string] = sym_string,
  [sym_special] = sym_special,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_identifier_repeat1] = aux_sym_identifier_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_special_repeat1] = aux_sym_special_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_dots] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_inf] = {
    .visible = true,
    .named = true,
  },
  [sym_nan] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_character_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_complex_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_integer_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_real_] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_identifier_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_special_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_function] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_switch] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_default_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_left_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_left_assignment2] = {
    .visible = true,
    .named = true,
  },
  [sym_equals_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_super_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_super_right_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_right_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_brace_list] = {
    .visible = true,
    .named = true,
  },
  [sym_paren_list] = {
    .visible = true,
    .named = true,
  },
  [sym_subset] = {
    .visible = true,
    .named = true,
  },
  [sym_subset2] = {
    .visible = true,
    .named = true,
  },
  [sym_dollar] = {
    .visible = true,
    .named = true,
  },
  [sym_slot] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_get] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_get_internal] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe] = {
    .visible = true,
    .named = true,
  },
  [sym_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_na] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_special] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_identifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_special_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_alternative = 1,
  field_arguments = 2,
  field_body = 3,
  field_condition = 4,
  field_consequence = 5,
  field_function = 6,
  field_left = 7,
  field_name = 8,
  field_namespace = 9,
  field_operand = 10,
  field_operator = 11,
  field_right = 12,
  field_value = 13,
  field_vector = 14,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_function] = "function",
  [field_left] = "left",
  [field_name] = "name",
  [field_namespace] = "namespace",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_right] = "right",
  [field_value] = "value",
  [field_vector] = "vector",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 2},
  [5] = {.index = 6, .length = 2},
  [6] = {.index = 8, .length = 3},
  [7] = {.index = 11, .length = 2},
  [8] = {.index = 13, .length = 1},
  [9] = {.index = 14, .length = 2},
  [10] = {.index = 16, .length = 2},
  [11] = {.index = 18, .length = 2},
  [12] = {.index = 20, .length = 2},
  [13] = {.index = 22, .length = 4},
  [14] = {.index = 26, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 1},
  [1] =
    {field_operand, 1},
    {field_operator, 0},
  [3] =
    {field_function, 0},
  [4] =
    {field_name, 0},
    {field_value, 2},
  [6] =
    {field_name, 2},
    {field_value, 0},
  [8] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [11] =
    {field_function, 2},
    {field_namespace, 0},
  [13] =
    {field_name, 0},
  [14] =
    {field_arguments, 2},
    {field_function, 0},
  [16] =
    {field_condition, 2},
    {field_consequence, 4},
  [18] =
    {field_body, 4},
    {field_condition, 2},
  [20] =
    {field_body, 4},
    {field_value, 2},
  [22] =
    {field_alternative, 5},
    {field_alternative, 6},
    {field_condition, 2},
    {field_consequence, 4},
  [26] =
    {field_body, 6},
    {field_name, 2},
    {field_vector, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(52);
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == ')') ADVANCE(59);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(103);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(77);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'e') ADVANCE(165);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(207);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '}') ADVANCE(70);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(222);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(227);
      if (lookahead != 0) ADVANCE(221);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(223);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(227);
      if (lookahead != 0) ADVANCE(221);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(224);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(227);
      if (lookahead != 0) ADVANCE(221);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(225);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(227);
      if (lookahead != 0) ADVANCE(221);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(214);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(214);
      if (lookahead == '\r') ADVANCE(5);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(196);
      END_STATE();
    case 8:
      if (lookahead == '\n') ADVANCE(196);
      if (lookahead == '\r') ADVANCE(7);
      END_STATE();
    case 9:
      if (lookahead == '\n') ADVANCE(210);
      END_STATE();
    case 10:
      if (lookahead == '\n') ADVANCE(210);
      if (lookahead == '\r') ADVANCE(9);
      END_STATE();
    case 11:
      if (lookahead == '\n') ADVANCE(218);
      END_STATE();
    case 12:
      if (lookahead == '\n') ADVANCE(218);
      if (lookahead == '\r') ADVANCE(11);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(14)
      if (lookahead == '#') ADVANCE(216);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '\\') ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(215);
      if (lookahead != 0) ADVANCE(216);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(14)
      if (lookahead == '#') ADVANCE(216);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(215);
      if (lookahead != 0) ADVANCE(216);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(15)
      if (lookahead == '#') ADVANCE(198);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(197);
      if (lookahead != 0) ADVANCE(198);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(15)
      if (lookahead == '#') ADVANCE(198);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(197);
      if (lookahead != 0) ADVANCE(198);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(17)
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(212);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(211);
      if (lookahead != 0) ADVANCE(212);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(17)
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(212);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(211);
      if (lookahead != 0) ADVANCE(212);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(19)
      if (lookahead == '#') ADVANCE(220);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(219);
      if (lookahead != 0) ADVANCE(220);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(19)
      if (lookahead == '#') ADVANCE(220);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(219);
      if (lookahead != 0) ADVANCE(220);
      END_STATE();
    case 21:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == ')') ADVANCE(59);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(103);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(77);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'e') ADVANCE(165);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 22:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == ')') ADVANCE(59);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(103);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(77);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 23:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == ')') ADVANCE(59);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(104);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(77);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(207);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(23)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 24:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(103);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(33);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'e') ADVANCE(165);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(24)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 25:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(104);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(33);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'e') ADVANCE(165);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(207);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(25)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 26:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(104);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(33);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(207);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(26)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 27:
      if (lookahead == '!') ADVANCE(32);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == ')') ADVANCE(59);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == ':') ADVANCE(103);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == 'e') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(27)
      END_STATE();
    case 28:
      if (lookahead == '!') ADVANCE(32);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == ')') ADVANCE(59);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == ':') ADVANCE(104);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == 'e') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(206);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(28)
      END_STATE();
    case 29:
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(29)
      if (lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 30:
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == ')') ADVANCE(59);
      if (lookahead == '.') ADVANCE(118);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(30)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 31:
      if (lookahead == '-') ADVANCE(73);
      END_STATE();
    case 32:
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 33:
      if (lookahead == ']') ADVANCE(79);
      END_STATE();
    case 34:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 35:
      if (lookahead == 'l') ADVANCE(37);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(65);
      END_STATE();
    case 37:
      if (lookahead == 's') ADVANCE(34);
      END_STATE();
    case 38:
      if (lookahead == '{') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 39:
      if (lookahead == '}') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(205);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(205);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(202);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(221);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 47:
      if (eof) ADVANCE(52);
      if (lookahead == '\n') ADVANCE(53);
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(103);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'e') ADVANCE(165);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '}') ADVANCE(70);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(47)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 48:
      if (eof) ADVANCE(52);
      if (lookahead == '\n') ADVANCE(53);
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(103);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '}') ADVANCE(70);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(48)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 49:
      if (eof) ADVANCE(52);
      if (lookahead == '\n') ADVANCE(53);
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(104);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'e') ADVANCE(165);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(207);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '}') ADVANCE(70);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(49)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 50:
      if (eof) ADVANCE(52);
      if (lookahead == '\n') ADVANCE(53);
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(104);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(207);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '}') ADVANCE(70);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(50)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 51:
      if (eof) ADVANCE(52);
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(209);
      if (lookahead == '#') ADVANCE(208);
      if (lookahead == '$') ADVANCE(80);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(213);
      if (lookahead == '(') ADVANCE(58);
      if (lookahead == ')') ADVANCE(59);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(103);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(68);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == 'F') ADVANCE(120);
      if (lookahead == 'I') ADVANCE(170);
      if (lookahead == 'N') ADVANCE(121);
      if (lookahead == 'T') ADVANCE(128);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(33);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == 'b') ADVANCE(179);
      if (lookahead == 'f') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == 'n') ADVANCE(144);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == 'w') ADVANCE(159);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '}') ADVANCE(70);
      if (lookahead == '~') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(51)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(53);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '0') ADVANCE(201);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_repeat);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_switch);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DASH_GT_GT);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '>') ADVANCE(74);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(78);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      if (lookahead == ':') ADVANCE(83);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_COLON_COLON_COLON);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_dots);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_PIPE_GT);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(75);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(71);
      if (lookahead == '<') ADVANCE(31);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '|') ADVANCE(99);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(101);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(82);
      if (lookahead == '=') ADVANCE(72);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(72);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_break);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_next);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_true);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_false);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_null);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_inf);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_nan);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_NA);
      if (lookahead == '_') ADVANCE(140);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_NA_character_);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_NA_complex_);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_NA_integer_);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_NA_real_);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == '.') ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == '.') ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == '.') ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A') ADVANCE(124);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A') ADVANCE(112);
      if (lookahead == 'U') ADVANCE(126);
      if (lookahead == 'a') ADVANCE(127);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E') ADVANCE(107);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E') ADVANCE(108);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L') ADVANCE(129);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L') ADVANCE(109);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L') ADVANCE(125);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N') ADVANCE(111);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R') ADVANCE(130);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S') ADVANCE(123);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U') ADVANCE(122);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == '_') ADVANCE(116);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == '_') ADVANCE(114);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == '_') ADVANCE(115);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == '_') ADVANCE(113);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'a') ADVANCE(164);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'a') ADVANCE(182);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'a') ADVANCE(166);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'a') ADVANCE(185);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'a') ADVANCE(143);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'c') ADVANCE(160);
      if (lookahead == 'i') ADVANCE(173);
      if (lookahead == 'r') ADVANCE(153);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'c') ADVANCE(158);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'c') ADVANCE(187);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'c') ADVANCE(189);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e') ADVANCE(191);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e') ADVANCE(177);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e') ADVANCE(135);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e') ADVANCE(61);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e') ADVANCE(62);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e') ADVANCE(157);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e') ADVANCE(192);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e') ADVANCE(138);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e') ADVANCE(180);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e') ADVANCE(137);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e') ADVANCE(181);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'f') ADVANCE(57);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'f') ADVANCE(110);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'g') ADVANCE(152);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'h') ADVANCE(66);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'h') ADVANCE(162);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'h') ADVANCE(136);
      if (lookahead == 'o') ADVANCE(169);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'i') ADVANCE(175);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'i') ADVANCE(167);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'i') ADVANCE(186);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'k') ADVANCE(105);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'l') ADVANCE(183);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'l') ADVANCE(131);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'l') ADVANCE(148);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'l') ADVANCE(150);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'm') ADVANCE(176);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'n') ADVANCE(156);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'n') ADVANCE(142);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'n') ADVANCE(55);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'n') ADVANCE(188);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'o') ADVANCE(178);
      if (lookahead == 'u') ADVANCE(171);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'o') ADVANCE(172);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'p') ADVANCE(168);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'p') ADVANCE(151);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'r') ADVANCE(146);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'r') ADVANCE(133);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'r') ADVANCE(134);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'r') ADVANCE(139);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 's') ADVANCE(147);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 't') ADVANCE(106);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 't') ADVANCE(63);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 't') ADVANCE(141);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 't') ADVANCE(161);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 't') ADVANCE(149);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 't') ADVANCE(154);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'w') ADVANCE(163);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'x') ADVANCE(184);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'x') ADVANCE(132);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(205);
      if (lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(aux_sym_identifier_token2);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(aux_sym_identifier_token2);
      if (lookahead == '#') ADVANCE(198);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '`') ADVANCE(198);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(aux_sym_identifier_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(198);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '.') ADVANCE(203);
      if (lookahead == 'L') ADVANCE(199);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '.') ADVANCE(203);
      if (lookahead == 'L') ADVANCE(199);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(42);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'L') ADVANCE(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(202);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(203);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(193);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(205);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_i);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_i);
      if (lookahead == 'f') ADVANCE(57);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(208);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '#') ADVANCE(212);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(211);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"') ADVANCE(212);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(212);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '#') ADVANCE(216);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(215);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'') ADVANCE(216);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(216);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(aux_sym_special_token1);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(aux_sym_special_token1);
      if (lookahead == '#') ADVANCE(220);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '%') ADVANCE(220);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(aux_sym_special_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '%' &&
          lookahead != '\\') ADVANCE(220);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(214);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(196);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(210);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(218);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(221);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(226);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 51},
  [2] = {.lex_state = 51},
  [3] = {.lex_state = 22},
  [4] = {.lex_state = 51},
  [5] = {.lex_state = 22},
  [6] = {.lex_state = 51},
  [7] = {.lex_state = 51},
  [8] = {.lex_state = 51},
  [9] = {.lex_state = 22},
  [10] = {.lex_state = 22},
  [11] = {.lex_state = 22},
  [12] = {.lex_state = 51},
  [13] = {.lex_state = 22},
  [14] = {.lex_state = 51},
  [15] = {.lex_state = 22},
  [16] = {.lex_state = 51},
  [17] = {.lex_state = 51},
  [18] = {.lex_state = 51},
  [19] = {.lex_state = 51},
  [20] = {.lex_state = 22},
  [21] = {.lex_state = 51},
  [22] = {.lex_state = 22},
  [23] = {.lex_state = 51},
  [24] = {.lex_state = 51},
  [25] = {.lex_state = 51},
  [26] = {.lex_state = 22},
  [27] = {.lex_state = 51},
  [28] = {.lex_state = 22},
  [29] = {.lex_state = 51},
  [30] = {.lex_state = 51},
  [31] = {.lex_state = 51},
  [32] = {.lex_state = 51},
  [33] = {.lex_state = 51},
  [34] = {.lex_state = 51},
  [35] = {.lex_state = 51},
  [36] = {.lex_state = 51},
  [37] = {.lex_state = 51},
  [38] = {.lex_state = 51},
  [39] = {.lex_state = 51},
  [40] = {.lex_state = 51},
  [41] = {.lex_state = 51},
  [42] = {.lex_state = 22},
  [43] = {.lex_state = 51},
  [44] = {.lex_state = 51},
  [45] = {.lex_state = 51},
  [46] = {.lex_state = 51},
  [47] = {.lex_state = 51},
  [48] = {.lex_state = 51},
  [49] = {.lex_state = 51},
  [50] = {.lex_state = 51},
  [51] = {.lex_state = 51},
  [52] = {.lex_state = 51},
  [53] = {.lex_state = 51},
  [54] = {.lex_state = 51},
  [55] = {.lex_state = 51},
  [56] = {.lex_state = 51},
  [57] = {.lex_state = 51},
  [58] = {.lex_state = 51},
  [59] = {.lex_state = 51},
  [60] = {.lex_state = 51},
  [61] = {.lex_state = 51},
  [62] = {.lex_state = 51},
  [63] = {.lex_state = 51},
  [64] = {.lex_state = 51},
  [65] = {.lex_state = 51},
  [66] = {.lex_state = 51},
  [67] = {.lex_state = 51},
  [68] = {.lex_state = 51},
  [69] = {.lex_state = 51},
  [70] = {.lex_state = 51},
  [71] = {.lex_state = 51},
  [72] = {.lex_state = 51},
  [73] = {.lex_state = 51},
  [74] = {.lex_state = 51},
  [75] = {.lex_state = 51},
  [76] = {.lex_state = 51},
  [77] = {.lex_state = 51},
  [78] = {.lex_state = 51},
  [79] = {.lex_state = 51},
  [80] = {.lex_state = 51},
  [81] = {.lex_state = 51},
  [82] = {.lex_state = 51},
  [83] = {.lex_state = 51},
  [84] = {.lex_state = 21},
  [85] = {.lex_state = 21},
  [86] = {.lex_state = 21},
  [87] = {.lex_state = 21},
  [88] = {.lex_state = 51},
  [89] = {.lex_state = 51},
  [90] = {.lex_state = 51},
  [91] = {.lex_state = 51},
  [92] = {.lex_state = 24},
  [93] = {.lex_state = 51},
  [94] = {.lex_state = 24},
  [95] = {.lex_state = 22},
  [96] = {.lex_state = 24},
  [97] = {.lex_state = 24},
  [98] = {.lex_state = 51},
  [99] = {.lex_state = 51},
  [100] = {.lex_state = 51},
  [101] = {.lex_state = 51},
  [102] = {.lex_state = 51},
  [103] = {.lex_state = 51},
  [104] = {.lex_state = 51},
  [105] = {.lex_state = 51},
  [106] = {.lex_state = 51},
  [107] = {.lex_state = 51},
  [108] = {.lex_state = 51},
  [109] = {.lex_state = 51},
  [110] = {.lex_state = 51},
  [111] = {.lex_state = 51},
  [112] = {.lex_state = 51},
  [113] = {.lex_state = 51},
  [114] = {.lex_state = 51},
  [115] = {.lex_state = 51},
  [116] = {.lex_state = 21},
  [117] = {.lex_state = 51},
  [118] = {.lex_state = 51},
  [119] = {.lex_state = 51},
  [120] = {.lex_state = 51},
  [121] = {.lex_state = 51},
  [122] = {.lex_state = 51},
  [123] = {.lex_state = 51},
  [124] = {.lex_state = 51},
  [125] = {.lex_state = 51},
  [126] = {.lex_state = 51},
  [127] = {.lex_state = 51},
  [128] = {.lex_state = 51},
  [129] = {.lex_state = 51},
  [130] = {.lex_state = 51},
  [131] = {.lex_state = 51},
  [132] = {.lex_state = 51},
  [133] = {.lex_state = 51},
  [134] = {.lex_state = 51},
  [135] = {.lex_state = 51},
  [136] = {.lex_state = 51},
  [137] = {.lex_state = 51},
  [138] = {.lex_state = 51},
  [139] = {.lex_state = 51},
  [140] = {.lex_state = 51},
  [141] = {.lex_state = 51},
  [142] = {.lex_state = 51},
  [143] = {.lex_state = 51},
  [144] = {.lex_state = 51},
  [145] = {.lex_state = 51},
  [146] = {.lex_state = 51},
  [147] = {.lex_state = 51},
  [148] = {.lex_state = 51},
  [149] = {.lex_state = 51},
  [150] = {.lex_state = 51},
  [151] = {.lex_state = 51},
  [152] = {.lex_state = 51},
  [153] = {.lex_state = 51},
  [154] = {.lex_state = 51},
  [155] = {.lex_state = 51},
  [156] = {.lex_state = 51},
  [157] = {.lex_state = 51},
  [158] = {.lex_state = 51},
  [159] = {.lex_state = 22},
  [160] = {.lex_state = 51},
  [161] = {.lex_state = 51},
  [162] = {.lex_state = 22},
  [163] = {.lex_state = 51},
  [164] = {.lex_state = 51},
  [165] = {.lex_state = 51},
  [166] = {.lex_state = 51},
  [167] = {.lex_state = 51},
  [168] = {.lex_state = 51},
  [169] = {.lex_state = 51},
  [170] = {.lex_state = 51},
  [171] = {.lex_state = 22},
  [172] = {.lex_state = 51},
  [173] = {.lex_state = 51},
  [174] = {.lex_state = 51},
  [175] = {.lex_state = 51},
  [176] = {.lex_state = 51},
  [177] = {.lex_state = 51},
  [178] = {.lex_state = 51},
  [179] = {.lex_state = 51},
  [180] = {.lex_state = 51},
  [181] = {.lex_state = 51},
  [182] = {.lex_state = 51},
  [183] = {.lex_state = 51},
  [184] = {.lex_state = 51},
  [185] = {.lex_state = 51},
  [186] = {.lex_state = 51},
  [187] = {.lex_state = 51},
  [188] = {.lex_state = 51},
  [189] = {.lex_state = 51},
  [190] = {.lex_state = 51},
  [191] = {.lex_state = 51},
  [192] = {.lex_state = 51},
  [193] = {.lex_state = 51},
  [194] = {.lex_state = 51},
  [195] = {.lex_state = 51},
  [196] = {.lex_state = 51},
  [197] = {.lex_state = 51},
  [198] = {.lex_state = 51},
  [199] = {.lex_state = 22},
  [200] = {.lex_state = 51},
  [201] = {.lex_state = 51},
  [202] = {.lex_state = 51},
  [203] = {.lex_state = 51},
  [204] = {.lex_state = 51},
  [205] = {.lex_state = 51},
  [206] = {.lex_state = 21},
  [207] = {.lex_state = 21},
  [208] = {.lex_state = 51},
  [209] = {.lex_state = 51},
  [210] = {.lex_state = 51},
  [211] = {.lex_state = 21},
  [212] = {.lex_state = 51},
  [213] = {.lex_state = 51},
  [214] = {.lex_state = 51},
  [215] = {.lex_state = 51},
  [216] = {.lex_state = 51},
  [217] = {.lex_state = 51},
  [218] = {.lex_state = 21},
  [219] = {.lex_state = 21},
  [220] = {.lex_state = 21},
  [221] = {.lex_state = 21},
  [222] = {.lex_state = 21},
  [223] = {.lex_state = 21},
  [224] = {.lex_state = 21},
  [225] = {.lex_state = 21},
  [226] = {.lex_state = 21},
  [227] = {.lex_state = 51},
  [228] = {.lex_state = 51},
  [229] = {.lex_state = 51},
  [230] = {.lex_state = 51},
  [231] = {.lex_state = 51},
  [232] = {.lex_state = 51},
  [233] = {.lex_state = 51},
  [234] = {.lex_state = 21},
  [235] = {.lex_state = 21},
  [236] = {.lex_state = 21},
  [237] = {.lex_state = 51},
  [238] = {.lex_state = 51},
  [239] = {.lex_state = 21},
  [240] = {.lex_state = 21},
  [241] = {.lex_state = 21},
  [242] = {.lex_state = 51},
  [243] = {.lex_state = 51},
  [244] = {.lex_state = 51},
  [245] = {.lex_state = 51},
  [246] = {.lex_state = 21},
  [247] = {.lex_state = 51},
  [248] = {.lex_state = 51},
  [249] = {.lex_state = 47},
  [250] = {.lex_state = 51},
  [251] = {.lex_state = 51},
  [252] = {.lex_state = 51},
  [253] = {.lex_state = 51},
  [254] = {.lex_state = 51},
  [255] = {.lex_state = 21},
  [256] = {.lex_state = 21},
  [257] = {.lex_state = 51},
  [258] = {.lex_state = 51},
  [259] = {.lex_state = 51},
  [260] = {.lex_state = 51},
  [261] = {.lex_state = 51},
  [262] = {.lex_state = 51},
  [263] = {.lex_state = 51},
  [264] = {.lex_state = 51},
  [265] = {.lex_state = 51},
  [266] = {.lex_state = 51},
  [267] = {.lex_state = 51},
  [268] = {.lex_state = 51},
  [269] = {.lex_state = 51},
  [270] = {.lex_state = 51},
  [271] = {.lex_state = 51},
  [272] = {.lex_state = 51},
  [273] = {.lex_state = 51},
  [274] = {.lex_state = 51},
  [275] = {.lex_state = 51},
  [276] = {.lex_state = 51},
  [277] = {.lex_state = 51},
  [278] = {.lex_state = 51},
  [279] = {.lex_state = 51},
  [280] = {.lex_state = 51},
  [281] = {.lex_state = 51},
  [282] = {.lex_state = 51},
  [283] = {.lex_state = 51},
  [284] = {.lex_state = 51},
  [285] = {.lex_state = 51},
  [286] = {.lex_state = 51},
  [287] = {.lex_state = 51},
  [288] = {.lex_state = 51},
  [289] = {.lex_state = 51},
  [290] = {.lex_state = 51},
  [291] = {.lex_state = 51},
  [292] = {.lex_state = 51},
  [293] = {.lex_state = 51},
  [294] = {.lex_state = 51},
  [295] = {.lex_state = 51},
  [296] = {.lex_state = 51},
  [297] = {.lex_state = 51},
  [298] = {.lex_state = 51},
  [299] = {.lex_state = 51},
  [300] = {.lex_state = 47},
  [301] = {.lex_state = 51},
  [302] = {.lex_state = 51},
  [303] = {.lex_state = 51},
  [304] = {.lex_state = 51},
  [305] = {.lex_state = 51},
  [306] = {.lex_state = 51},
  [307] = {.lex_state = 51},
  [308] = {.lex_state = 51},
  [309] = {.lex_state = 51},
  [310] = {.lex_state = 51},
  [311] = {.lex_state = 51},
  [312] = {.lex_state = 51},
  [313] = {.lex_state = 47},
  [314] = {.lex_state = 51},
  [315] = {.lex_state = 51},
  [316] = {.lex_state = 51},
  [317] = {.lex_state = 51},
  [318] = {.lex_state = 51},
  [319] = {.lex_state = 51},
  [320] = {.lex_state = 51},
  [321] = {.lex_state = 51},
  [322] = {.lex_state = 51},
  [323] = {.lex_state = 51},
  [324] = {.lex_state = 51},
  [325] = {.lex_state = 51},
  [326] = {.lex_state = 51},
  [327] = {.lex_state = 47},
  [328] = {.lex_state = 51},
  [329] = {.lex_state = 51},
  [330] = {.lex_state = 51},
  [331] = {.lex_state = 51},
  [332] = {.lex_state = 51},
  [333] = {.lex_state = 51},
  [334] = {.lex_state = 51},
  [335] = {.lex_state = 51},
  [336] = {.lex_state = 51},
  [337] = {.lex_state = 51},
  [338] = {.lex_state = 51},
  [339] = {.lex_state = 51},
  [340] = {.lex_state = 51},
  [341] = {.lex_state = 51},
  [342] = {.lex_state = 51},
  [343] = {.lex_state = 51},
  [344] = {.lex_state = 51},
  [345] = {.lex_state = 51},
  [346] = {.lex_state = 51},
  [347] = {.lex_state = 51},
  [348] = {.lex_state = 51},
  [349] = {.lex_state = 51},
  [350] = {.lex_state = 51},
  [351] = {.lex_state = 51},
  [352] = {.lex_state = 51},
  [353] = {.lex_state = 51},
  [354] = {.lex_state = 51},
  [355] = {.lex_state = 51},
  [356] = {.lex_state = 51},
  [357] = {.lex_state = 51},
  [358] = {.lex_state = 51},
  [359] = {.lex_state = 51},
  [360] = {.lex_state = 51},
  [361] = {.lex_state = 51},
  [362] = {.lex_state = 51},
  [363] = {.lex_state = 51},
  [364] = {.lex_state = 51},
  [365] = {.lex_state = 51},
  [366] = {.lex_state = 51},
  [367] = {.lex_state = 51},
  [368] = {.lex_state = 51},
  [369] = {.lex_state = 51},
  [370] = {.lex_state = 51},
  [371] = {.lex_state = 51},
  [372] = {.lex_state = 51},
  [373] = {.lex_state = 51},
  [374] = {.lex_state = 51},
  [375] = {.lex_state = 51},
  [376] = {.lex_state = 51},
  [377] = {.lex_state = 51},
  [378] = {.lex_state = 51},
  [379] = {.lex_state = 51},
  [380] = {.lex_state = 51},
  [381] = {.lex_state = 51},
  [382] = {.lex_state = 51},
  [383] = {.lex_state = 51},
  [384] = {.lex_state = 51},
  [385] = {.lex_state = 51},
  [386] = {.lex_state = 51},
  [387] = {.lex_state = 51},
  [388] = {.lex_state = 47},
  [389] = {.lex_state = 0},
  [390] = {.lex_state = 51},
  [391] = {.lex_state = 51},
  [392] = {.lex_state = 51},
  [393] = {.lex_state = 51},
  [394] = {.lex_state = 51},
  [395] = {.lex_state = 51},
  [396] = {.lex_state = 51},
  [397] = {.lex_state = 51},
  [398] = {.lex_state = 51},
  [399] = {.lex_state = 51},
  [400] = {.lex_state = 51},
  [401] = {.lex_state = 51},
  [402] = {.lex_state = 51},
  [403] = {.lex_state = 47},
  [404] = {.lex_state = 51},
  [405] = {.lex_state = 51},
  [406] = {.lex_state = 51},
  [407] = {.lex_state = 51},
  [408] = {.lex_state = 51},
  [409] = {.lex_state = 21},
  [410] = {.lex_state = 51},
  [411] = {.lex_state = 21},
  [412] = {.lex_state = 21},
  [413] = {.lex_state = 21},
  [414] = {.lex_state = 47},
  [415] = {.lex_state = 51},
  [416] = {.lex_state = 47},
  [417] = {.lex_state = 51},
  [418] = {.lex_state = 51},
  [419] = {.lex_state = 51},
  [420] = {.lex_state = 51},
  [421] = {.lex_state = 51},
  [422] = {.lex_state = 51},
  [423] = {.lex_state = 51},
  [424] = {.lex_state = 51},
  [425] = {.lex_state = 51},
  [426] = {.lex_state = 51},
  [427] = {.lex_state = 51},
  [428] = {.lex_state = 51},
  [429] = {.lex_state = 51},
  [430] = {.lex_state = 51},
  [431] = {.lex_state = 48},
  [432] = {.lex_state = 51},
  [433] = {.lex_state = 21},
  [434] = {.lex_state = 21},
  [435] = {.lex_state = 21},
  [436] = {.lex_state = 21},
  [437] = {.lex_state = 24},
  [438] = {.lex_state = 24},
  [439] = {.lex_state = 21},
  [440] = {.lex_state = 21},
  [441] = {.lex_state = 21},
  [442] = {.lex_state = 21},
  [443] = {.lex_state = 24},
  [444] = {.lex_state = 24},
  [445] = {.lex_state = 24},
  [446] = {.lex_state = 24},
  [447] = {.lex_state = 24},
  [448] = {.lex_state = 24},
  [449] = {.lex_state = 21},
  [450] = {.lex_state = 21},
  [451] = {.lex_state = 21},
  [452] = {.lex_state = 21},
  [453] = {.lex_state = 21},
  [454] = {.lex_state = 24},
  [455] = {.lex_state = 24},
  [456] = {.lex_state = 24},
  [457] = {.lex_state = 24},
  [458] = {.lex_state = 24},
  [459] = {.lex_state = 24},
  [460] = {.lex_state = 24},
  [461] = {.lex_state = 24},
  [462] = {.lex_state = 24},
  [463] = {.lex_state = 21},
  [464] = {.lex_state = 21},
  [465] = {.lex_state = 22},
  [466] = {.lex_state = 21},
  [467] = {.lex_state = 21},
  [468] = {.lex_state = 21},
  [469] = {.lex_state = 24},
  [470] = {.lex_state = 24},
  [471] = {.lex_state = 21},
  [472] = {.lex_state = 24},
  [473] = {.lex_state = 21},
  [474] = {.lex_state = 24},
  [475] = {.lex_state = 24},
  [476] = {.lex_state = 24},
  [477] = {.lex_state = 24},
  [478] = {.lex_state = 25},
  [479] = {.lex_state = 47},
  [480] = {.lex_state = 47},
  [481] = {.lex_state = 47},
  [482] = {.lex_state = 47},
  [483] = {.lex_state = 47},
  [484] = {.lex_state = 47},
  [485] = {.lex_state = 47},
  [486] = {.lex_state = 47},
  [487] = {.lex_state = 47},
  [488] = {.lex_state = 47},
  [489] = {.lex_state = 47},
  [490] = {.lex_state = 47},
  [491] = {.lex_state = 47},
  [492] = {.lex_state = 47},
  [493] = {.lex_state = 47},
  [494] = {.lex_state = 47},
  [495] = {.lex_state = 47},
  [496] = {.lex_state = 47},
  [497] = {.lex_state = 47},
  [498] = {.lex_state = 47},
  [499] = {.lex_state = 47},
  [500] = {.lex_state = 47},
  [501] = {.lex_state = 47},
  [502] = {.lex_state = 47},
  [503] = {.lex_state = 47},
  [504] = {.lex_state = 47},
  [505] = {.lex_state = 47},
  [506] = {.lex_state = 47},
  [507] = {.lex_state = 47},
  [508] = {.lex_state = 47},
  [509] = {.lex_state = 51},
  [510] = {.lex_state = 47},
  [511] = {.lex_state = 22},
  [512] = {.lex_state = 47},
  [513] = {.lex_state = 47},
  [514] = {.lex_state = 47},
  [515] = {.lex_state = 47},
  [516] = {.lex_state = 47},
  [517] = {.lex_state = 47},
  [518] = {.lex_state = 47},
  [519] = {.lex_state = 47},
  [520] = {.lex_state = 23},
  [521] = {.lex_state = 22},
  [522] = {.lex_state = 22},
  [523] = {.lex_state = 22},
  [524] = {.lex_state = 47},
  [525] = {.lex_state = 47},
  [526] = {.lex_state = 47},
  [527] = {.lex_state = 47},
  [528] = {.lex_state = 47},
  [529] = {.lex_state = 47},
  [530] = {.lex_state = 47},
  [531] = {.lex_state = 47},
  [532] = {.lex_state = 47},
  [533] = {.lex_state = 22},
  [534] = {.lex_state = 24},
  [535] = {.lex_state = 22},
  [536] = {.lex_state = 22},
  [537] = {.lex_state = 51},
  [538] = {.lex_state = 51},
  [539] = {.lex_state = 47},
  [540] = {.lex_state = 48},
  [541] = {.lex_state = 51},
  [542] = {.lex_state = 22},
  [543] = {.lex_state = 47},
  [544] = {.lex_state = 47},
  [545] = {.lex_state = 22},
  [546] = {.lex_state = 22},
  [547] = {.lex_state = 49},
  [548] = {.lex_state = 47},
  [549] = {.lex_state = 48},
  [550] = {.lex_state = 22},
  [551] = {.lex_state = 22},
  [552] = {.lex_state = 22},
  [553] = {.lex_state = 22},
  [554] = {.lex_state = 22},
  [555] = {.lex_state = 22},
  [556] = {.lex_state = 22},
  [557] = {.lex_state = 22},
  [558] = {.lex_state = 22},
  [559] = {.lex_state = 22},
  [560] = {.lex_state = 22},
  [561] = {.lex_state = 48},
  [562] = {.lex_state = 22},
  [563] = {.lex_state = 22},
  [564] = {.lex_state = 22},
  [565] = {.lex_state = 49},
  [566] = {.lex_state = 48},
  [567] = {.lex_state = 24},
  [568] = {.lex_state = 48},
  [569] = {.lex_state = 48},
  [570] = {.lex_state = 22},
  [571] = {.lex_state = 48},
  [572] = {.lex_state = 48},
  [573] = {.lex_state = 48},
  [574] = {.lex_state = 48},
  [575] = {.lex_state = 48},
  [576] = {.lex_state = 48},
  [577] = {.lex_state = 48},
  [578] = {.lex_state = 48},
  [579] = {.lex_state = 50},
  [580] = {.lex_state = 48},
  [581] = {.lex_state = 50},
  [582] = {.lex_state = 48},
  [583] = {.lex_state = 48},
  [584] = {.lex_state = 48},
  [585] = {.lex_state = 48},
  [586] = {.lex_state = 22},
  [587] = {.lex_state = 51},
  [588] = {.lex_state = 48},
  [589] = {.lex_state = 22},
  [590] = {.lex_state = 22},
  [591] = {.lex_state = 48},
  [592] = {.lex_state = 22},
  [593] = {.lex_state = 22},
  [594] = {.lex_state = 22},
  [595] = {.lex_state = 48},
  [596] = {.lex_state = 48},
  [597] = {.lex_state = 48},
  [598] = {.lex_state = 48},
  [599] = {.lex_state = 48},
  [600] = {.lex_state = 22},
  [601] = {.lex_state = 48},
  [602] = {.lex_state = 48},
  [603] = {.lex_state = 48},
  [604] = {.lex_state = 22},
  [605] = {.lex_state = 22},
  [606] = {.lex_state = 22},
  [607] = {.lex_state = 22},
  [608] = {.lex_state = 22},
  [609] = {.lex_state = 48},
  [610] = {.lex_state = 48},
  [611] = {.lex_state = 48},
  [612] = {.lex_state = 48},
  [613] = {.lex_state = 48},
  [614] = {.lex_state = 47},
  [615] = {.lex_state = 48},
  [616] = {.lex_state = 47},
  [617] = {.lex_state = 47},
  [618] = {.lex_state = 51},
  [619] = {.lex_state = 22},
  [620] = {.lex_state = 22},
  [621] = {.lex_state = 51},
  [622] = {.lex_state = 22},
  [623] = {.lex_state = 51},
  [624] = {.lex_state = 51},
  [625] = {.lex_state = 51},
  [626] = {.lex_state = 47},
  [627] = {.lex_state = 22},
  [628] = {.lex_state = 47},
  [629] = {.lex_state = 47},
  [630] = {.lex_state = 47},
  [631] = {.lex_state = 22},
  [632] = {.lex_state = 22},
  [633] = {.lex_state = 47},
  [634] = {.lex_state = 47},
  [635] = {.lex_state = 47},
  [636] = {.lex_state = 22},
  [637] = {.lex_state = 47},
  [638] = {.lex_state = 22},
  [639] = {.lex_state = 48},
  [640] = {.lex_state = 47},
  [641] = {.lex_state = 22},
  [642] = {.lex_state = 48},
  [643] = {.lex_state = 48},
  [644] = {.lex_state = 47},
  [645] = {.lex_state = 47},
  [646] = {.lex_state = 47},
  [647] = {.lex_state = 48},
  [648] = {.lex_state = 47},
  [649] = {.lex_state = 47},
  [650] = {.lex_state = 48},
  [651] = {.lex_state = 47},
  [652] = {.lex_state = 47},
  [653] = {.lex_state = 47},
  [654] = {.lex_state = 48},
  [655] = {.lex_state = 47},
  [656] = {.lex_state = 47},
  [657] = {.lex_state = 47},
  [658] = {.lex_state = 48},
  [659] = {.lex_state = 48},
  [660] = {.lex_state = 48},
  [661] = {.lex_state = 48},
  [662] = {.lex_state = 47},
  [663] = {.lex_state = 47},
  [664] = {.lex_state = 47},
  [665] = {.lex_state = 47},
  [666] = {.lex_state = 47},
  [667] = {.lex_state = 47},
  [668] = {.lex_state = 47},
  [669] = {.lex_state = 47},
  [670] = {.lex_state = 47},
  [671] = {.lex_state = 48},
  [672] = {.lex_state = 47},
  [673] = {.lex_state = 48},
  [674] = {.lex_state = 48},
  [675] = {.lex_state = 48},
  [676] = {.lex_state = 48},
  [677] = {.lex_state = 47},
  [678] = {.lex_state = 48},
  [679] = {.lex_state = 48},
  [680] = {.lex_state = 48},
  [681] = {.lex_state = 47},
  [682] = {.lex_state = 47},
  [683] = {.lex_state = 24},
  [684] = {.lex_state = 48},
  [685] = {.lex_state = 47},
  [686] = {.lex_state = 48},
  [687] = {.lex_state = 24},
  [688] = {.lex_state = 48},
  [689] = {.lex_state = 24},
  [690] = {.lex_state = 47},
  [691] = {.lex_state = 51},
  [692] = {.lex_state = 51},
  [693] = {.lex_state = 48},
  [694] = {.lex_state = 24},
  [695] = {.lex_state = 24},
  [696] = {.lex_state = 47},
  [697] = {.lex_state = 51},
  [698] = {.lex_state = 24},
  [699] = {.lex_state = 24},
  [700] = {.lex_state = 47},
  [701] = {.lex_state = 24},
  [702] = {.lex_state = 24},
  [703] = {.lex_state = 51},
  [704] = {.lex_state = 51},
  [705] = {.lex_state = 51},
  [706] = {.lex_state = 51},
  [707] = {.lex_state = 51},
  [708] = {.lex_state = 51},
  [709] = {.lex_state = 24},
  [710] = {.lex_state = 24},
  [711] = {.lex_state = 24},
  [712] = {.lex_state = 24},
  [713] = {.lex_state = 24},
  [714] = {.lex_state = 51},
  [715] = {.lex_state = 51},
  [716] = {.lex_state = 51},
  [717] = {.lex_state = 51},
  [718] = {.lex_state = 51},
  [719] = {.lex_state = 51},
  [720] = {.lex_state = 51},
  [721] = {.lex_state = 51},
  [722] = {.lex_state = 51},
  [723] = {.lex_state = 24},
  [724] = {.lex_state = 24},
  [725] = {.lex_state = 24},
  [726] = {.lex_state = 24},
  [727] = {.lex_state = 24},
  [728] = {.lex_state = 51},
  [729] = {.lex_state = 24},
  [730] = {.lex_state = 26},
  [731] = {.lex_state = 51},
  [732] = {.lex_state = 48},
  [733] = {.lex_state = 51},
  [734] = {.lex_state = 48},
  [735] = {.lex_state = 48},
  [736] = {.lex_state = 48},
  [737] = {.lex_state = 48},
  [738] = {.lex_state = 48},
  [739] = {.lex_state = 51},
  [740] = {.lex_state = 48},
  [741] = {.lex_state = 48},
  [742] = {.lex_state = 48},
  [743] = {.lex_state = 48},
  [744] = {.lex_state = 48},
  [745] = {.lex_state = 48},
  [746] = {.lex_state = 48},
  [747] = {.lex_state = 48},
  [748] = {.lex_state = 51},
  [749] = {.lex_state = 48},
  [750] = {.lex_state = 48},
  [751] = {.lex_state = 51},
  [752] = {.lex_state = 51},
  [753] = {.lex_state = 48},
  [754] = {.lex_state = 48},
  [755] = {.lex_state = 51},
  [756] = {.lex_state = 51},
  [757] = {.lex_state = 48},
  [758] = {.lex_state = 48},
  [759] = {.lex_state = 48},
  [760] = {.lex_state = 48},
  [761] = {.lex_state = 48},
  [762] = {.lex_state = 48},
  [763] = {.lex_state = 48},
  [764] = {.lex_state = 48},
  [765] = {.lex_state = 48},
  [766] = {.lex_state = 48},
  [767] = {.lex_state = 48},
  [768] = {.lex_state = 51},
  [769] = {.lex_state = 48},
  [770] = {.lex_state = 48},
  [771] = {.lex_state = 51},
  [772] = {.lex_state = 48},
  [773] = {.lex_state = 51},
  [774] = {.lex_state = 51},
  [775] = {.lex_state = 51},
  [776] = {.lex_state = 48},
  [777] = {.lex_state = 48},
  [778] = {.lex_state = 51},
  [779] = {.lex_state = 51},
  [780] = {.lex_state = 51},
  [781] = {.lex_state = 51},
  [782] = {.lex_state = 48},
  [783] = {.lex_state = 48},
  [784] = {.lex_state = 48},
  [785] = {.lex_state = 51},
  [786] = {.lex_state = 51},
  [787] = {.lex_state = 51},
  [788] = {.lex_state = 51},
  [789] = {.lex_state = 51},
  [790] = {.lex_state = 51},
  [791] = {.lex_state = 48},
  [792] = {.lex_state = 48},
  [793] = {.lex_state = 48},
  [794] = {.lex_state = 27},
  [795] = {.lex_state = 27},
  [796] = {.lex_state = 27},
  [797] = {.lex_state = 27},
  [798] = {.lex_state = 27},
  [799] = {.lex_state = 27},
  [800] = {.lex_state = 27},
  [801] = {.lex_state = 27},
  [802] = {.lex_state = 27},
  [803] = {.lex_state = 27},
  [804] = {.lex_state = 27},
  [805] = {.lex_state = 27},
  [806] = {.lex_state = 27},
  [807] = {.lex_state = 27},
  [808] = {.lex_state = 27},
  [809] = {.lex_state = 51},
  [810] = {.lex_state = 28},
  [811] = {.lex_state = 27},
  [812] = {.lex_state = 27},
  [813] = {.lex_state = 27},
  [814] = {.lex_state = 27},
  [815] = {.lex_state = 27},
  [816] = {.lex_state = 27},
  [817] = {.lex_state = 27},
  [818] = {.lex_state = 27},
  [819] = {.lex_state = 51},
  [820] = {.lex_state = 27},
  [821] = {.lex_state = 27},
  [822] = {.lex_state = 27},
  [823] = {.lex_state = 27},
  [824] = {.lex_state = 27},
  [825] = {.lex_state = 27},
  [826] = {.lex_state = 27},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 0},
  [829] = {.lex_state = 51},
  [830] = {.lex_state = 51},
  [831] = {.lex_state = 27},
  [832] = {.lex_state = 27},
  [833] = {.lex_state = 27},
  [834] = {.lex_state = 27},
  [835] = {.lex_state = 51},
  [836] = {.lex_state = 28},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 0},
  [839] = {.lex_state = 0},
  [840] = {.lex_state = 51},
  [841] = {.lex_state = 27},
  [842] = {.lex_state = 27},
  [843] = {.lex_state = 27},
  [844] = {.lex_state = 27},
  [845] = {.lex_state = 27},
  [846] = {.lex_state = 0},
  [847] = {.lex_state = 51},
  [848] = {.lex_state = 27},
  [849] = {.lex_state = 27},
  [850] = {.lex_state = 27},
  [851] = {.lex_state = 27},
  [852] = {.lex_state = 27},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 51},
  [855] = {.lex_state = 0},
  [856] = {.lex_state = 27},
  [857] = {.lex_state = 0},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 0},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 0},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 27},
  [870] = {.lex_state = 27},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 27},
  [874] = {.lex_state = 27},
  [875] = {.lex_state = 0},
  [876] = {.lex_state = 0},
  [877] = {.lex_state = 0},
  [878] = {.lex_state = 27},
  [879] = {.lex_state = 0},
  [880] = {.lex_state = 0},
  [881] = {.lex_state = 0},
  [882] = {.lex_state = 0},
  [883] = {.lex_state = 0},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 0},
  [887] = {.lex_state = 0},
  [888] = {.lex_state = 0},
  [889] = {.lex_state = 0},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 0},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 0},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 0},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 0},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 0},
  [900] = {.lex_state = 0},
  [901] = {.lex_state = 0},
  [902] = {.lex_state = 0},
  [903] = {.lex_state = 0},
  [904] = {.lex_state = 0},
  [905] = {.lex_state = 0},
  [906] = {.lex_state = 0},
  [907] = {.lex_state = 0},
  [908] = {.lex_state = 0},
  [909] = {.lex_state = 0},
  [910] = {.lex_state = 0},
  [911] = {.lex_state = 0},
  [912] = {.lex_state = 0},
  [913] = {.lex_state = 0},
  [914] = {.lex_state = 0},
  [915] = {.lex_state = 0},
  [916] = {.lex_state = 0},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 0},
  [919] = {.lex_state = 0},
  [920] = {.lex_state = 0},
  [921] = {.lex_state = 0},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 0},
  [926] = {.lex_state = 0},
  [927] = {.lex_state = 30},
  [928] = {.lex_state = 30},
  [929] = {.lex_state = 30},
  [930] = {.lex_state = 29},
  [931] = {.lex_state = 29},
  [932] = {.lex_state = 29},
  [933] = {.lex_state = 29},
  [934] = {.lex_state = 29},
  [935] = {.lex_state = 29},
  [936] = {.lex_state = 30},
  [937] = {.lex_state = 29},
  [938] = {.lex_state = 29},
  [939] = {.lex_state = 29},
  [940] = {.lex_state = 13},
  [941] = {.lex_state = 16},
  [942] = {.lex_state = 16},
  [943] = {.lex_state = 18},
  [944] = {.lex_state = 13},
  [945] = {.lex_state = 16},
  [946] = {.lex_state = 18},
  [947] = {.lex_state = 13},
  [948] = {.lex_state = 16},
  [949] = {.lex_state = 16},
  [950] = {.lex_state = 18},
  [951] = {.lex_state = 13},
  [952] = {.lex_state = 13},
  [953] = {.lex_state = 18},
  [954] = {.lex_state = 18},
  [955] = {.lex_state = 13},
  [956] = {.lex_state = 20},
  [957] = {.lex_state = 18},
  [958] = {.lex_state = 16},
  [959] = {.lex_state = 16},
  [960] = {.lex_state = 16},
  [961] = {.lex_state = 20},
  [962] = {.lex_state = 16},
  [963] = {.lex_state = 16},
  [964] = {.lex_state = 18},
  [965] = {.lex_state = 18},
  [966] = {.lex_state = 16},
  [967] = {.lex_state = 18},
  [968] = {.lex_state = 13},
  [969] = {.lex_state = 13},
  [970] = {.lex_state = 16},
  [971] = {.lex_state = 20},
  [972] = {.lex_state = 18},
  [973] = {.lex_state = 13},
  [974] = {.lex_state = 16},
  [975] = {.lex_state = 16},
  [976] = {.lex_state = 18},
  [977] = {.lex_state = 13},
  [978] = {.lex_state = 18},
  [979] = {.lex_state = 16},
  [980] = {.lex_state = 18},
  [981] = {.lex_state = 13},
  [982] = {.lex_state = 18},
  [983] = {.lex_state = 18},
  [984] = {.lex_state = 13},
  [985] = {.lex_state = 13},
  [986] = {.lex_state = 16},
  [987] = {.lex_state = 13},
  [988] = {.lex_state = 13},
  [989] = {.lex_state = 16},
  [990] = {.lex_state = 18},
  [991] = {.lex_state = 13},
  [992] = {.lex_state = 18},
  [993] = {.lex_state = 16},
  [994] = {.lex_state = 18},
  [995] = {.lex_state = 13},
  [996] = {.lex_state = 16},
  [997] = {.lex_state = 18},
  [998] = {.lex_state = 13},
  [999] = {.lex_state = 13},
  [1000] = {.lex_state = 29},
  [1001] = {.lex_state = 29},
  [1002] = {.lex_state = 29},
  [1003] = {.lex_state = 29},
  [1004] = {.lex_state = 29},
  [1005] = {.lex_state = 29},
  [1006] = {.lex_state = 29},
  [1007] = {.lex_state = 29},
  [1008] = {.lex_state = 29},
  [1009] = {.lex_state = 29},
  [1010] = {.lex_state = 29},
  [1011] = {.lex_state = 29},
  [1012] = {.lex_state = 29},
  [1013] = {.lex_state = 29},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 29},
  [1016] = {.lex_state = 29},
  [1017] = {.lex_state = 29},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 29},
  [1020] = {.lex_state = 29},
  [1021] = {.lex_state = 29},
  [1022] = {.lex_state = 29},
  [1023] = {.lex_state = 29},
  [1024] = {.lex_state = 29},
  [1025] = {.lex_state = 29},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 29},
  [1028] = {.lex_state = 29},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 29},
  [1031] = {.lex_state = 29},
  [1032] = {.lex_state = 29},
  [1033] = {.lex_state = 29},
  [1034] = {.lex_state = 29},
  [1035] = {.lex_state = 29},
  [1036] = {.lex_state = 29},
  [1037] = {.lex_state = 29},
  [1038] = {.lex_state = 29},
  [1039] = {.lex_state = 29},
  [1040] = {.lex_state = 29},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 51},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 51},
  [1073] = {.lex_state = 27},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 27},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 27},
  [1081] = {.lex_state = 51},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 0},
  [1084] = {.lex_state = 27},
  [1085] = {.lex_state = 51},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 27},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 27},
  [1093] = {.lex_state = 27},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 27},
  [1097] = {.lex_state = 51},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 27},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 27},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 51},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 51},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 51},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 51},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_repeat] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_DASH_GT_GT] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1),
    [sym_dots] = ACTIONS(1),
    [anon_sym_PIPE_GT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [sym_break] = ACTIONS(1),
    [sym_next] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_inf] = ACTIONS(1),
    [sym_nan] = ACTIONS(1),
    [anon_sym_NA] = ACTIONS(1),
    [anon_sym_NA_character_] = ACTIONS(1),
    [anon_sym_NA_complex_] = ACTIONS(1),
    [anon_sym_NA_integer_] = ACTIONS(1),
    [anon_sym_NA_real_] = ACTIONS(1),
    [aux_sym_identifier_token1] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_i] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(1116),
    [sym_function_definition] = STATE(654),
    [sym_lambda_function] = STATE(654),
    [sym_if] = STATE(654),
    [sym_while] = STATE(654),
    [sym_repeat] = STATE(654),
    [sym_for] = STATE(654),
    [sym_switch] = STATE(654),
    [sym_call] = STATE(654),
    [sym__assignment] = STATE(654),
    [sym_left_assignment] = STATE(654),
    [sym_left_assignment2] = STATE(654),
    [sym_equals_assignment] = STATE(654),
    [sym_super_assignment] = STATE(654),
    [sym_super_right_assignment] = STATE(654),
    [sym_right_assignment] = STATE(654),
    [sym_brace_list] = STATE(654),
    [sym_paren_list] = STATE(654),
    [sym_subset] = STATE(654),
    [sym_subset2] = STATE(654),
    [sym_dollar] = STATE(654),
    [sym_slot] = STATE(654),
    [sym_namespace_get] = STATE(654),
    [sym_namespace_get_internal] = STATE(654),
    [sym_pipe] = STATE(654),
    [sym_unary] = STATE(654),
    [sym_binary] = STATE(654),
    [sym_na] = STATE(654),
    [sym__expression] = STATE(654),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(654),
    [sym_string] = STATE(654),
    [aux_sym_program_repeat1] = STATE(70),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(27),
    [sym_next] = ACTIONS(27),
    [sym_true] = ACTIONS(27),
    [sym_false] = ACTIONS(27),
    [sym_null] = ACTIONS(27),
    [sym_inf] = ACTIONS(27),
    [sym_nan] = ACTIONS(27),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(7),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [2] = {
    [sym_function_definition] = STATE(618),
    [sym_lambda_function] = STATE(618),
    [sym_if] = STATE(618),
    [sym_while] = STATE(618),
    [sym_repeat] = STATE(618),
    [sym_for] = STATE(618),
    [sym_switch] = STATE(618),
    [sym_arguments] = STATE(1118),
    [sym_default_argument] = STATE(35),
    [sym__argument] = STATE(35),
    [sym_call] = STATE(618),
    [sym__assignment] = STATE(618),
    [sym_left_assignment] = STATE(618),
    [sym_left_assignment2] = STATE(618),
    [sym_equals_assignment] = STATE(618),
    [sym_super_assignment] = STATE(618),
    [sym_super_right_assignment] = STATE(618),
    [sym_right_assignment] = STATE(618),
    [sym_brace_list] = STATE(618),
    [sym_paren_list] = STATE(618),
    [sym_subset] = STATE(618),
    [sym_subset2] = STATE(618),
    [sym_dollar] = STATE(618),
    [sym_slot] = STATE(618),
    [sym_namespace_get] = STATE(618),
    [sym_namespace_get_internal] = STATE(618),
    [sym_pipe] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_binary] = STATE(618),
    [sym_na] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_identifier] = STATE(538),
    [sym_complex] = STATE(618),
    [sym_string] = STATE(739),
    [aux_sym_arguments_repeat1] = STATE(35),
    [anon_sym_SEMI] = ACTIONS(47),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(69),
    [sym_dots] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(79),
    [sym_next] = ACTIONS(79),
    [sym_true] = ACTIONS(79),
    [sym_false] = ACTIONS(79),
    [sym_null] = ACTIONS(79),
    [sym_inf] = ACTIONS(79),
    [sym_nan] = ACTIONS(79),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(47),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [3] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_default_argument] = STATE(15),
    [sym__argument] = STATE(15),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(15),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACK] = ACTIONS(103),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [4] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1101),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [5] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1099),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACK] = ACTIONS(143),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [6] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1125),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(145),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [7] = {
    [sym_function_definition] = STATE(618),
    [sym_lambda_function] = STATE(618),
    [sym_if] = STATE(618),
    [sym_while] = STATE(618),
    [sym_repeat] = STATE(618),
    [sym_for] = STATE(618),
    [sym_switch] = STATE(618),
    [sym_arguments] = STATE(1081),
    [sym_default_argument] = STATE(35),
    [sym__argument] = STATE(35),
    [sym_call] = STATE(618),
    [sym__assignment] = STATE(618),
    [sym_left_assignment] = STATE(618),
    [sym_left_assignment2] = STATE(618),
    [sym_equals_assignment] = STATE(618),
    [sym_super_assignment] = STATE(618),
    [sym_super_right_assignment] = STATE(618),
    [sym_right_assignment] = STATE(618),
    [sym_brace_list] = STATE(618),
    [sym_paren_list] = STATE(618),
    [sym_subset] = STATE(618),
    [sym_subset2] = STATE(618),
    [sym_dollar] = STATE(618),
    [sym_slot] = STATE(618),
    [sym_namespace_get] = STATE(618),
    [sym_namespace_get_internal] = STATE(618),
    [sym_pipe] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_binary] = STATE(618),
    [sym_na] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_identifier] = STATE(538),
    [sym_complex] = STATE(618),
    [sym_string] = STATE(739),
    [aux_sym_arguments_repeat1] = STATE(35),
    [anon_sym_SEMI] = ACTIONS(47),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(147),
    [sym_dots] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(79),
    [sym_next] = ACTIONS(79),
    [sym_true] = ACTIONS(79),
    [sym_false] = ACTIONS(79),
    [sym_null] = ACTIONS(79),
    [sym_inf] = ACTIONS(79),
    [sym_nan] = ACTIONS(79),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(47),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [8] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1068),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [9] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1087),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACK] = ACTIONS(151),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [10] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1067),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACK] = ACTIONS(153),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [11] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1079),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACK] = ACTIONS(155),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [12] = {
    [sym_function_definition] = STATE(618),
    [sym_lambda_function] = STATE(618),
    [sym_if] = STATE(618),
    [sym_while] = STATE(618),
    [sym_repeat] = STATE(618),
    [sym_for] = STATE(618),
    [sym_switch] = STATE(618),
    [sym_arguments] = STATE(1072),
    [sym_default_argument] = STATE(35),
    [sym__argument] = STATE(35),
    [sym_call] = STATE(618),
    [sym__assignment] = STATE(618),
    [sym_left_assignment] = STATE(618),
    [sym_left_assignment2] = STATE(618),
    [sym_equals_assignment] = STATE(618),
    [sym_super_assignment] = STATE(618),
    [sym_super_right_assignment] = STATE(618),
    [sym_right_assignment] = STATE(618),
    [sym_brace_list] = STATE(618),
    [sym_paren_list] = STATE(618),
    [sym_subset] = STATE(618),
    [sym_subset2] = STATE(618),
    [sym_dollar] = STATE(618),
    [sym_slot] = STATE(618),
    [sym_namespace_get] = STATE(618),
    [sym_namespace_get_internal] = STATE(618),
    [sym_pipe] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_binary] = STATE(618),
    [sym_na] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_identifier] = STATE(538),
    [sym_complex] = STATE(618),
    [sym_string] = STATE(739),
    [aux_sym_arguments_repeat1] = STATE(35),
    [anon_sym_SEMI] = ACTIONS(47),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(157),
    [sym_dots] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(79),
    [sym_next] = ACTIONS(79),
    [sym_true] = ACTIONS(79),
    [sym_false] = ACTIONS(79),
    [sym_null] = ACTIONS(79),
    [sym_inf] = ACTIONS(79),
    [sym_nan] = ACTIONS(79),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(47),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [13] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1074),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACK] = ACTIONS(159),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [14] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1076),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(161),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [15] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_default_argument] = STATE(15),
    [sym__argument] = STATE(15),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(15),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_function] = ACTIONS(166),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_if] = ACTIONS(172),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_RPAREN] = ACTIONS(178),
    [anon_sym_while] = ACTIONS(180),
    [anon_sym_repeat] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(186),
    [anon_sym_switch] = ACTIONS(189),
    [anon_sym_COMMA] = ACTIONS(192),
    [anon_sym_LBRACE] = ACTIONS(195),
    [anon_sym_RBRACK] = ACTIONS(178),
    [sym_dots] = ACTIONS(198),
    [anon_sym_DASH] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_BANG] = ACTIONS(204),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_break] = ACTIONS(210),
    [sym_next] = ACTIONS(210),
    [sym_true] = ACTIONS(210),
    [sym_false] = ACTIONS(210),
    [sym_null] = ACTIONS(210),
    [sym_inf] = ACTIONS(210),
    [sym_nan] = ACTIONS(210),
    [anon_sym_NA] = ACTIONS(213),
    [anon_sym_NA_character_] = ACTIONS(213),
    [anon_sym_NA_complex_] = ACTIONS(213),
    [anon_sym_NA_integer_] = ACTIONS(213),
    [anon_sym_NA_real_] = ACTIONS(213),
    [aux_sym_identifier_token1] = ACTIONS(216),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [sym_integer] = ACTIONS(163),
    [sym_float] = ACTIONS(222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(228),
  },
  [16] = {
    [sym_function_definition] = STATE(618),
    [sym_lambda_function] = STATE(618),
    [sym_if] = STATE(618),
    [sym_while] = STATE(618),
    [sym_repeat] = STATE(618),
    [sym_for] = STATE(618),
    [sym_switch] = STATE(618),
    [sym_arguments] = STATE(1066),
    [sym_default_argument] = STATE(35),
    [sym__argument] = STATE(35),
    [sym_call] = STATE(618),
    [sym__assignment] = STATE(618),
    [sym_left_assignment] = STATE(618),
    [sym_left_assignment2] = STATE(618),
    [sym_equals_assignment] = STATE(618),
    [sym_super_assignment] = STATE(618),
    [sym_super_right_assignment] = STATE(618),
    [sym_right_assignment] = STATE(618),
    [sym_brace_list] = STATE(618),
    [sym_paren_list] = STATE(618),
    [sym_subset] = STATE(618),
    [sym_subset2] = STATE(618),
    [sym_dollar] = STATE(618),
    [sym_slot] = STATE(618),
    [sym_namespace_get] = STATE(618),
    [sym_namespace_get_internal] = STATE(618),
    [sym_pipe] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_binary] = STATE(618),
    [sym_na] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_identifier] = STATE(538),
    [sym_complex] = STATE(618),
    [sym_string] = STATE(739),
    [aux_sym_arguments_repeat1] = STATE(35),
    [anon_sym_SEMI] = ACTIONS(47),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(231),
    [sym_dots] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(79),
    [sym_next] = ACTIONS(79),
    [sym_true] = ACTIONS(79),
    [sym_false] = ACTIONS(79),
    [sym_null] = ACTIONS(79),
    [sym_inf] = ACTIONS(79),
    [sym_nan] = ACTIONS(79),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(47),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [17] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1107),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(233),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [18] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1089),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [19] = {
    [sym_function_definition] = STATE(618),
    [sym_lambda_function] = STATE(618),
    [sym_if] = STATE(618),
    [sym_while] = STATE(618),
    [sym_repeat] = STATE(618),
    [sym_for] = STATE(618),
    [sym_switch] = STATE(618),
    [sym_arguments] = STATE(1109),
    [sym_default_argument] = STATE(35),
    [sym__argument] = STATE(35),
    [sym_call] = STATE(618),
    [sym__assignment] = STATE(618),
    [sym_left_assignment] = STATE(618),
    [sym_left_assignment2] = STATE(618),
    [sym_equals_assignment] = STATE(618),
    [sym_super_assignment] = STATE(618),
    [sym_super_right_assignment] = STATE(618),
    [sym_right_assignment] = STATE(618),
    [sym_brace_list] = STATE(618),
    [sym_paren_list] = STATE(618),
    [sym_subset] = STATE(618),
    [sym_subset2] = STATE(618),
    [sym_dollar] = STATE(618),
    [sym_slot] = STATE(618),
    [sym_namespace_get] = STATE(618),
    [sym_namespace_get_internal] = STATE(618),
    [sym_pipe] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_binary] = STATE(618),
    [sym_na] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_identifier] = STATE(538),
    [sym_complex] = STATE(618),
    [sym_string] = STATE(739),
    [aux_sym_arguments_repeat1] = STATE(35),
    [anon_sym_SEMI] = ACTIONS(47),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(237),
    [sym_dots] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(79),
    [sym_next] = ACTIONS(79),
    [sym_true] = ACTIONS(79),
    [sym_false] = ACTIONS(79),
    [sym_null] = ACTIONS(79),
    [sym_inf] = ACTIONS(79),
    [sym_nan] = ACTIONS(79),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(47),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [20] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1112),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACK] = ACTIONS(239),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [21] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1115),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(241),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [22] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1119),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACK] = ACTIONS(243),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [23] = {
    [sym_function_definition] = STATE(618),
    [sym_lambda_function] = STATE(618),
    [sym_if] = STATE(618),
    [sym_while] = STATE(618),
    [sym_repeat] = STATE(618),
    [sym_for] = STATE(618),
    [sym_switch] = STATE(618),
    [sym_arguments] = STATE(1113),
    [sym_default_argument] = STATE(35),
    [sym__argument] = STATE(35),
    [sym_call] = STATE(618),
    [sym__assignment] = STATE(618),
    [sym_left_assignment] = STATE(618),
    [sym_left_assignment2] = STATE(618),
    [sym_equals_assignment] = STATE(618),
    [sym_super_assignment] = STATE(618),
    [sym_super_right_assignment] = STATE(618),
    [sym_right_assignment] = STATE(618),
    [sym_brace_list] = STATE(618),
    [sym_paren_list] = STATE(618),
    [sym_subset] = STATE(618),
    [sym_subset2] = STATE(618),
    [sym_dollar] = STATE(618),
    [sym_slot] = STATE(618),
    [sym_namespace_get] = STATE(618),
    [sym_namespace_get_internal] = STATE(618),
    [sym_pipe] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_binary] = STATE(618),
    [sym_na] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_identifier] = STATE(538),
    [sym_complex] = STATE(618),
    [sym_string] = STATE(739),
    [aux_sym_arguments_repeat1] = STATE(35),
    [anon_sym_SEMI] = ACTIONS(47),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(245),
    [sym_dots] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(79),
    [sym_next] = ACTIONS(79),
    [sym_true] = ACTIONS(79),
    [sym_false] = ACTIONS(79),
    [sym_null] = ACTIONS(79),
    [sym_inf] = ACTIONS(79),
    [sym_nan] = ACTIONS(79),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(47),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [24] = {
    [sym_function_definition] = STATE(618),
    [sym_lambda_function] = STATE(618),
    [sym_if] = STATE(618),
    [sym_while] = STATE(618),
    [sym_repeat] = STATE(618),
    [sym_for] = STATE(618),
    [sym_switch] = STATE(618),
    [sym_arguments] = STATE(1085),
    [sym_default_argument] = STATE(35),
    [sym__argument] = STATE(35),
    [sym_call] = STATE(618),
    [sym__assignment] = STATE(618),
    [sym_left_assignment] = STATE(618),
    [sym_left_assignment2] = STATE(618),
    [sym_equals_assignment] = STATE(618),
    [sym_super_assignment] = STATE(618),
    [sym_super_right_assignment] = STATE(618),
    [sym_right_assignment] = STATE(618),
    [sym_brace_list] = STATE(618),
    [sym_paren_list] = STATE(618),
    [sym_subset] = STATE(618),
    [sym_subset2] = STATE(618),
    [sym_dollar] = STATE(618),
    [sym_slot] = STATE(618),
    [sym_namespace_get] = STATE(618),
    [sym_namespace_get_internal] = STATE(618),
    [sym_pipe] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_binary] = STATE(618),
    [sym_na] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_identifier] = STATE(538),
    [sym_complex] = STATE(618),
    [sym_string] = STATE(739),
    [aux_sym_arguments_repeat1] = STATE(35),
    [anon_sym_SEMI] = ACTIONS(47),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(247),
    [sym_dots] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(79),
    [sym_next] = ACTIONS(79),
    [sym_true] = ACTIONS(79),
    [sym_false] = ACTIONS(79),
    [sym_null] = ACTIONS(79),
    [sym_inf] = ACTIONS(79),
    [sym_nan] = ACTIONS(79),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(47),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [25] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1105),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(249),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [26] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1095),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACK] = ACTIONS(251),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [27] = {
    [sym_function_definition] = STATE(618),
    [sym_lambda_function] = STATE(618),
    [sym_if] = STATE(618),
    [sym_while] = STATE(618),
    [sym_repeat] = STATE(618),
    [sym_for] = STATE(618),
    [sym_switch] = STATE(618),
    [sym_arguments] = STATE(1127),
    [sym_default_argument] = STATE(35),
    [sym__argument] = STATE(35),
    [sym_call] = STATE(618),
    [sym__assignment] = STATE(618),
    [sym_left_assignment] = STATE(618),
    [sym_left_assignment2] = STATE(618),
    [sym_equals_assignment] = STATE(618),
    [sym_super_assignment] = STATE(618),
    [sym_super_right_assignment] = STATE(618),
    [sym_right_assignment] = STATE(618),
    [sym_brace_list] = STATE(618),
    [sym_paren_list] = STATE(618),
    [sym_subset] = STATE(618),
    [sym_subset2] = STATE(618),
    [sym_dollar] = STATE(618),
    [sym_slot] = STATE(618),
    [sym_namespace_get] = STATE(618),
    [sym_namespace_get_internal] = STATE(618),
    [sym_pipe] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_binary] = STATE(618),
    [sym_na] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_identifier] = STATE(538),
    [sym_complex] = STATE(618),
    [sym_string] = STATE(739),
    [aux_sym_arguments_repeat1] = STATE(35),
    [anon_sym_SEMI] = ACTIONS(47),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(253),
    [sym_dots] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(79),
    [sym_next] = ACTIONS(79),
    [sym_true] = ACTIONS(79),
    [sym_false] = ACTIONS(79),
    [sym_null] = ACTIONS(79),
    [sym_inf] = ACTIONS(79),
    [sym_nan] = ACTIONS(79),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(47),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [28] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1129),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACK] = ACTIONS(255),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [29] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1110),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [30] = {
    [sym_function_definition] = STATE(618),
    [sym_lambda_function] = STATE(618),
    [sym_if] = STATE(618),
    [sym_while] = STATE(618),
    [sym_repeat] = STATE(618),
    [sym_for] = STATE(618),
    [sym_switch] = STATE(618),
    [sym_arguments] = STATE(1097),
    [sym_default_argument] = STATE(35),
    [sym__argument] = STATE(35),
    [sym_call] = STATE(618),
    [sym__assignment] = STATE(618),
    [sym_left_assignment] = STATE(618),
    [sym_left_assignment2] = STATE(618),
    [sym_equals_assignment] = STATE(618),
    [sym_super_assignment] = STATE(618),
    [sym_super_right_assignment] = STATE(618),
    [sym_right_assignment] = STATE(618),
    [sym_brace_list] = STATE(618),
    [sym_paren_list] = STATE(618),
    [sym_subset] = STATE(618),
    [sym_subset2] = STATE(618),
    [sym_dollar] = STATE(618),
    [sym_slot] = STATE(618),
    [sym_namespace_get] = STATE(618),
    [sym_namespace_get_internal] = STATE(618),
    [sym_pipe] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_binary] = STATE(618),
    [sym_na] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_identifier] = STATE(538),
    [sym_complex] = STATE(618),
    [sym_string] = STATE(739),
    [aux_sym_arguments_repeat1] = STATE(35),
    [anon_sym_SEMI] = ACTIONS(47),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(259),
    [sym_dots] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(79),
    [sym_next] = ACTIONS(79),
    [sym_true] = ACTIONS(79),
    [sym_false] = ACTIONS(79),
    [sym_null] = ACTIONS(79),
    [sym_inf] = ACTIONS(79),
    [sym_nan] = ACTIONS(79),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(47),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [31] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1070),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [32] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1106),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [33] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1121),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [34] = {
    [sym_function_definition] = STATE(618),
    [sym_lambda_function] = STATE(618),
    [sym_if] = STATE(618),
    [sym_while] = STATE(618),
    [sym_repeat] = STATE(618),
    [sym_for] = STATE(618),
    [sym_switch] = STATE(618),
    [sym_default_argument] = STATE(34),
    [sym__argument] = STATE(34),
    [sym_call] = STATE(618),
    [sym__assignment] = STATE(618),
    [sym_left_assignment] = STATE(618),
    [sym_left_assignment2] = STATE(618),
    [sym_equals_assignment] = STATE(618),
    [sym_super_assignment] = STATE(618),
    [sym_super_right_assignment] = STATE(618),
    [sym_right_assignment] = STATE(618),
    [sym_brace_list] = STATE(618),
    [sym_paren_list] = STATE(618),
    [sym_subset] = STATE(618),
    [sym_subset2] = STATE(618),
    [sym_dollar] = STATE(618),
    [sym_slot] = STATE(618),
    [sym_namespace_get] = STATE(618),
    [sym_namespace_get_internal] = STATE(618),
    [sym_pipe] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_binary] = STATE(618),
    [sym_na] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_identifier] = STATE(538),
    [sym_complex] = STATE(618),
    [sym_string] = STATE(739),
    [aux_sym_arguments_repeat1] = STATE(34),
    [anon_sym_SEMI] = ACTIONS(261),
    [anon_sym_function] = ACTIONS(264),
    [anon_sym_BSLASH] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(276),
    [anon_sym_repeat] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(282),
    [anon_sym_switch] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(288),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(178),
    [sym_dots] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_BANG] = ACTIONS(300),
    [anon_sym_TILDE] = ACTIONS(303),
    [sym_break] = ACTIONS(306),
    [sym_next] = ACTIONS(306),
    [sym_true] = ACTIONS(306),
    [sym_false] = ACTIONS(306),
    [sym_null] = ACTIONS(306),
    [sym_inf] = ACTIONS(306),
    [sym_nan] = ACTIONS(306),
    [anon_sym_NA] = ACTIONS(309),
    [anon_sym_NA_character_] = ACTIONS(309),
    [anon_sym_NA_complex_] = ACTIONS(309),
    [anon_sym_NA_integer_] = ACTIONS(309),
    [anon_sym_NA_real_] = ACTIONS(309),
    [aux_sym_identifier_token1] = ACTIONS(312),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_integer] = ACTIONS(261),
    [sym_float] = ACTIONS(318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_SQUOTE] = ACTIONS(324),
  },
  [35] = {
    [sym_function_definition] = STATE(618),
    [sym_lambda_function] = STATE(618),
    [sym_if] = STATE(618),
    [sym_while] = STATE(618),
    [sym_repeat] = STATE(618),
    [sym_for] = STATE(618),
    [sym_switch] = STATE(618),
    [sym_default_argument] = STATE(34),
    [sym__argument] = STATE(34),
    [sym_call] = STATE(618),
    [sym__assignment] = STATE(618),
    [sym_left_assignment] = STATE(618),
    [sym_left_assignment2] = STATE(618),
    [sym_equals_assignment] = STATE(618),
    [sym_super_assignment] = STATE(618),
    [sym_super_right_assignment] = STATE(618),
    [sym_right_assignment] = STATE(618),
    [sym_brace_list] = STATE(618),
    [sym_paren_list] = STATE(618),
    [sym_subset] = STATE(618),
    [sym_subset2] = STATE(618),
    [sym_dollar] = STATE(618),
    [sym_slot] = STATE(618),
    [sym_namespace_get] = STATE(618),
    [sym_namespace_get_internal] = STATE(618),
    [sym_pipe] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_binary] = STATE(618),
    [sym_na] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_identifier] = STATE(538),
    [sym_complex] = STATE(618),
    [sym_string] = STATE(739),
    [aux_sym_arguments_repeat1] = STATE(34),
    [anon_sym_SEMI] = ACTIONS(47),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(103),
    [sym_dots] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(79),
    [sym_next] = ACTIONS(79),
    [sym_true] = ACTIONS(79),
    [sym_false] = ACTIONS(79),
    [sym_null] = ACTIONS(79),
    [sym_inf] = ACTIONS(79),
    [sym_nan] = ACTIONS(79),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(47),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [36] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1083),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [37] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1062),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [38] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1091),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [39] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1064),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [40] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1128),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [41] = {
    [sym_function_definition] = STATE(465),
    [sym_lambda_function] = STATE(465),
    [sym_if] = STATE(465),
    [sym_while] = STATE(465),
    [sym_repeat] = STATE(465),
    [sym_for] = STATE(465),
    [sym_switch] = STATE(465),
    [sym_arguments] = STATE(1124),
    [sym_default_argument] = STATE(3),
    [sym__argument] = STATE(3),
    [sym_call] = STATE(465),
    [sym__assignment] = STATE(465),
    [sym_left_assignment] = STATE(465),
    [sym_left_assignment2] = STATE(465),
    [sym_equals_assignment] = STATE(465),
    [sym_super_assignment] = STATE(465),
    [sym_super_right_assignment] = STATE(465),
    [sym_right_assignment] = STATE(465),
    [sym_brace_list] = STATE(465),
    [sym_paren_list] = STATE(465),
    [sym_subset] = STATE(465),
    [sym_subset2] = STATE(465),
    [sym_dollar] = STATE(465),
    [sym_slot] = STATE(465),
    [sym_namespace_get] = STATE(465),
    [sym_namespace_get_internal] = STATE(465),
    [sym_pipe] = STATE(465),
    [sym_unary] = STATE(465),
    [sym_binary] = STATE(465),
    [sym_na] = STATE(465),
    [sym__expression] = STATE(465),
    [sym_identifier] = STATE(95),
    [sym_complex] = STATE(465),
    [sym_string] = STATE(600),
    [aux_sym_arguments_repeat1] = STATE(3),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(117),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(125),
    [sym_next] = ACTIONS(125),
    [sym_true] = ACTIONS(125),
    [sym_false] = ACTIONS(125),
    [sym_null] = ACTIONS(125),
    [sym_inf] = ACTIONS(125),
    [sym_nan] = ACTIONS(125),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(93),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [42] = {
    [sym_function_definition] = STATE(511),
    [sym_lambda_function] = STATE(511),
    [sym_if] = STATE(511),
    [sym_while] = STATE(511),
    [sym_repeat] = STATE(511),
    [sym_for] = STATE(511),
    [sym_switch] = STATE(511),
    [sym_call] = STATE(511),
    [sym__assignment] = STATE(511),
    [sym_left_assignment] = STATE(511),
    [sym_left_assignment2] = STATE(511),
    [sym_equals_assignment] = STATE(511),
    [sym_super_assignment] = STATE(511),
    [sym_super_right_assignment] = STATE(511),
    [sym_right_assignment] = STATE(511),
    [sym_brace_list] = STATE(511),
    [sym_paren_list] = STATE(511),
    [sym_subset] = STATE(511),
    [sym_subset2] = STATE(511),
    [sym_dollar] = STATE(511),
    [sym_slot] = STATE(511),
    [sym_namespace_get] = STATE(511),
    [sym_namespace_get_internal] = STATE(511),
    [sym_pipe] = STATE(511),
    [sym_unary] = STATE(511),
    [sym_binary] = STATE(511),
    [sym_na] = STATE(511),
    [sym__expression] = STATE(511),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(511),
    [sym_string] = STATE(511),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACK] = ACTIONS(331),
    [sym_dots] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(333),
    [sym_next] = ACTIONS(333),
    [sym_true] = ACTIONS(333),
    [sym_false] = ACTIONS(333),
    [sym_null] = ACTIONS(333),
    [sym_inf] = ACTIONS(333),
    [sym_nan] = ACTIONS(333),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(329),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [43] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(80),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(355),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [44] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(64),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(377),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [45] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(51),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [46] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(80),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(385),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [47] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(62),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [48] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(79),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [49] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(46),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(391),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [50] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(48),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(393),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [51] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(79),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(395),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [52] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(80),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(397),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [53] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(80),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(399),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [54] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(60),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [55] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(61),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(403),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [56] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(80),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(405),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [57] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(79),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(407),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [58] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(56),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(409),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [59] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(57),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [60] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(79),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [61] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(80),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(415),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [62] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(79),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [63] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(69),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [64] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(80),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(421),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [65] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(79),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [66] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(52),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(425),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [67] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(65),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [68] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(43),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(429),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [69] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(79),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [70] = {
    [sym_function_definition] = STATE(654),
    [sym_lambda_function] = STATE(654),
    [sym_if] = STATE(654),
    [sym_while] = STATE(654),
    [sym_repeat] = STATE(654),
    [sym_for] = STATE(654),
    [sym_switch] = STATE(654),
    [sym_call] = STATE(654),
    [sym__assignment] = STATE(654),
    [sym_left_assignment] = STATE(654),
    [sym_left_assignment2] = STATE(654),
    [sym_equals_assignment] = STATE(654),
    [sym_super_assignment] = STATE(654),
    [sym_super_right_assignment] = STATE(654),
    [sym_right_assignment] = STATE(654),
    [sym_brace_list] = STATE(654),
    [sym_paren_list] = STATE(654),
    [sym_subset] = STATE(654),
    [sym_subset2] = STATE(654),
    [sym_dollar] = STATE(654),
    [sym_slot] = STATE(654),
    [sym_namespace_get] = STATE(654),
    [sym_namespace_get_internal] = STATE(654),
    [sym_pipe] = STATE(654),
    [sym_unary] = STATE(654),
    [sym_binary] = STATE(654),
    [sym_na] = STATE(654),
    [sym__expression] = STATE(654),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(654),
    [sym_string] = STATE(654),
    [aux_sym_program_repeat1] = STATE(71),
    [ts_builtin_sym_end] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(27),
    [sym_next] = ACTIONS(27),
    [sym_true] = ACTIONS(27),
    [sym_false] = ACTIONS(27),
    [sym_null] = ACTIONS(27),
    [sym_inf] = ACTIONS(27),
    [sym_nan] = ACTIONS(27),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(7),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [71] = {
    [sym_function_definition] = STATE(654),
    [sym_lambda_function] = STATE(654),
    [sym_if] = STATE(654),
    [sym_while] = STATE(654),
    [sym_repeat] = STATE(654),
    [sym_for] = STATE(654),
    [sym_switch] = STATE(654),
    [sym_call] = STATE(654),
    [sym__assignment] = STATE(654),
    [sym_left_assignment] = STATE(654),
    [sym_left_assignment2] = STATE(654),
    [sym_equals_assignment] = STATE(654),
    [sym_super_assignment] = STATE(654),
    [sym_super_right_assignment] = STATE(654),
    [sym_right_assignment] = STATE(654),
    [sym_brace_list] = STATE(654),
    [sym_paren_list] = STATE(654),
    [sym_subset] = STATE(654),
    [sym_subset2] = STATE(654),
    [sym_dollar] = STATE(654),
    [sym_slot] = STATE(654),
    [sym_namespace_get] = STATE(654),
    [sym_namespace_get_internal] = STATE(654),
    [sym_pipe] = STATE(654),
    [sym_unary] = STATE(654),
    [sym_binary] = STATE(654),
    [sym_na] = STATE(654),
    [sym__expression] = STATE(654),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(654),
    [sym_string] = STATE(654),
    [aux_sym_program_repeat1] = STATE(71),
    [ts_builtin_sym_end] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(440),
    [anon_sym_BSLASH] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(446),
    [anon_sym_LPAREN] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(452),
    [anon_sym_repeat] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(458),
    [anon_sym_switch] = ACTIONS(461),
    [anon_sym_LBRACE] = ACTIONS(464),
    [sym_dots] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(470),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(476),
    [sym_break] = ACTIONS(467),
    [sym_next] = ACTIONS(467),
    [sym_true] = ACTIONS(467),
    [sym_false] = ACTIONS(467),
    [sym_null] = ACTIONS(467),
    [sym_inf] = ACTIONS(467),
    [sym_nan] = ACTIONS(467),
    [anon_sym_NA] = ACTIONS(479),
    [anon_sym_NA_character_] = ACTIONS(479),
    [anon_sym_NA_complex_] = ACTIONS(479),
    [anon_sym_NA_integer_] = ACTIONS(479),
    [anon_sym_NA_real_] = ACTIONS(479),
    [aux_sym_identifier_token1] = ACTIONS(482),
    [anon_sym_BQUOTE] = ACTIONS(485),
    [sym_integer] = ACTIONS(437),
    [sym_float] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(494),
  },
  [72] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(80),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(497),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [73] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(79),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [74] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(72),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(501),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [75] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(73),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(503),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [76] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(53),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(505),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [77] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(80),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(507),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [78] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(79),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [79] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(79),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(514),
    [anon_sym_BSLASH] = ACTIONS(517),
    [anon_sym_if] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(523),
    [anon_sym_RPAREN] = ACTIONS(526),
    [anon_sym_while] = ACTIONS(528),
    [anon_sym_repeat] = ACTIONS(531),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_switch] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(540),
    [sym_dots] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(546),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(552),
    [sym_break] = ACTIONS(543),
    [sym_next] = ACTIONS(543),
    [sym_true] = ACTIONS(543),
    [sym_false] = ACTIONS(543),
    [sym_null] = ACTIONS(543),
    [sym_inf] = ACTIONS(543),
    [sym_nan] = ACTIONS(543),
    [anon_sym_NA] = ACTIONS(555),
    [anon_sym_NA_character_] = ACTIONS(555),
    [anon_sym_NA_complex_] = ACTIONS(555),
    [anon_sym_NA_integer_] = ACTIONS(555),
    [anon_sym_NA_real_] = ACTIONS(555),
    [aux_sym_identifier_token1] = ACTIONS(558),
    [anon_sym_BQUOTE] = ACTIONS(561),
    [sym_integer] = ACTIONS(511),
    [sym_float] = ACTIONS(564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(567),
    [anon_sym_SQUOTE] = ACTIONS(570),
  },
  [80] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(80),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_function] = ACTIONS(576),
    [anon_sym_BSLASH] = ACTIONS(579),
    [anon_sym_if] = ACTIONS(582),
    [anon_sym_LPAREN] = ACTIONS(585),
    [anon_sym_while] = ACTIONS(588),
    [anon_sym_repeat] = ACTIONS(591),
    [anon_sym_for] = ACTIONS(594),
    [anon_sym_switch] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(600),
    [anon_sym_RBRACE] = ACTIONS(435),
    [sym_dots] = ACTIONS(603),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_TILDE] = ACTIONS(612),
    [sym_break] = ACTIONS(603),
    [sym_next] = ACTIONS(603),
    [sym_true] = ACTIONS(603),
    [sym_false] = ACTIONS(603),
    [sym_null] = ACTIONS(603),
    [sym_inf] = ACTIONS(603),
    [sym_nan] = ACTIONS(603),
    [anon_sym_NA] = ACTIONS(615),
    [anon_sym_NA_character_] = ACTIONS(615),
    [anon_sym_NA_complex_] = ACTIONS(615),
    [anon_sym_NA_integer_] = ACTIONS(615),
    [anon_sym_NA_real_] = ACTIONS(615),
    [aux_sym_identifier_token1] = ACTIONS(618),
    [anon_sym_BQUOTE] = ACTIONS(621),
    [sym_integer] = ACTIONS(573),
    [sym_float] = ACTIONS(624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_SQUOTE] = ACTIONS(630),
  },
  [81] = {
    [sym_function_definition] = STATE(785),
    [sym_lambda_function] = STATE(785),
    [sym_if] = STATE(785),
    [sym_while] = STATE(785),
    [sym_repeat] = STATE(785),
    [sym_for] = STATE(785),
    [sym_switch] = STATE(785),
    [sym_call] = STATE(785),
    [sym__assignment] = STATE(785),
    [sym_left_assignment] = STATE(785),
    [sym_left_assignment2] = STATE(785),
    [sym_equals_assignment] = STATE(785),
    [sym_super_assignment] = STATE(785),
    [sym_super_right_assignment] = STATE(785),
    [sym_right_assignment] = STATE(785),
    [sym_brace_list] = STATE(785),
    [sym_paren_list] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_subset2] = STATE(785),
    [sym_dollar] = STATE(785),
    [sym_slot] = STATE(785),
    [sym_namespace_get] = STATE(785),
    [sym_namespace_get_internal] = STATE(785),
    [sym_pipe] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_na] = STATE(785),
    [sym__expression] = STATE(785),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(785),
    [sym_string] = STATE(785),
    [aux_sym_block_repeat1] = STATE(78),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(633),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(383),
    [sym_next] = ACTIONS(383),
    [sym_true] = ACTIONS(383),
    [sym_false] = ACTIONS(383),
    [sym_null] = ACTIONS(383),
    [sym_inf] = ACTIONS(383),
    [sym_nan] = ACTIONS(383),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(379),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [82] = {
    [sym_function_definition] = STATE(587),
    [sym_lambda_function] = STATE(587),
    [sym_if] = STATE(587),
    [sym_while] = STATE(587),
    [sym_repeat] = STATE(587),
    [sym_for] = STATE(587),
    [sym_switch] = STATE(587),
    [sym_call] = STATE(587),
    [sym__assignment] = STATE(587),
    [sym_left_assignment] = STATE(587),
    [sym_left_assignment2] = STATE(587),
    [sym_equals_assignment] = STATE(587),
    [sym_super_assignment] = STATE(587),
    [sym_super_right_assignment] = STATE(587),
    [sym_right_assignment] = STATE(587),
    [sym_brace_list] = STATE(587),
    [sym_paren_list] = STATE(587),
    [sym_subset] = STATE(587),
    [sym_subset2] = STATE(587),
    [sym_dollar] = STATE(587),
    [sym_slot] = STATE(587),
    [sym_namespace_get] = STATE(587),
    [sym_namespace_get_internal] = STATE(587),
    [sym_pipe] = STATE(587),
    [sym_unary] = STATE(587),
    [sym_binary] = STATE(587),
    [sym_na] = STATE(587),
    [sym__expression] = STATE(587),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(587),
    [sym_string] = STATE(587),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(331),
    [sym_dots] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(637),
    [sym_next] = ACTIONS(637),
    [sym_true] = ACTIONS(637),
    [sym_false] = ACTIONS(637),
    [sym_null] = ACTIONS(637),
    [sym_inf] = ACTIONS(637),
    [sym_nan] = ACTIONS(637),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(635),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [83] = {
    [sym_function_definition] = STATE(639),
    [sym_lambda_function] = STATE(639),
    [sym_if] = STATE(639),
    [sym_while] = STATE(639),
    [sym_repeat] = STATE(639),
    [sym_for] = STATE(639),
    [sym_switch] = STATE(639),
    [sym_call] = STATE(639),
    [sym__assignment] = STATE(639),
    [sym_left_assignment] = STATE(639),
    [sym_left_assignment2] = STATE(639),
    [sym_equals_assignment] = STATE(639),
    [sym_super_assignment] = STATE(639),
    [sym_super_right_assignment] = STATE(639),
    [sym_right_assignment] = STATE(639),
    [sym_brace_list] = STATE(639),
    [sym_paren_list] = STATE(639),
    [sym_subset] = STATE(639),
    [sym_subset2] = STATE(639),
    [sym_dollar] = STATE(639),
    [sym_slot] = STATE(639),
    [sym_namespace_get] = STATE(639),
    [sym_namespace_get_internal] = STATE(639),
    [sym_pipe] = STATE(639),
    [sym_unary] = STATE(639),
    [sym_binary] = STATE(639),
    [sym_na] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(639),
    [sym_string] = STATE(639),
    [aux_sym_program_repeat1] = STATE(77),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(639),
    [sym_dots] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(357),
    [sym_next] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_inf] = ACTIONS(357),
    [sym_nan] = ACTIONS(357),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [84] = {
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(641),
    [anon_sym_else] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(647),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_integer] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
  },
  [85] = {
    [anon_sym_SEMI] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(651),
    [anon_sym_BSLASH] = ACTIONS(649),
    [anon_sym_if] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(649),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_else] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(651),
    [anon_sym_repeat] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_switch] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(649),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_DASH_GT_GT] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_RBRACK] = ACTIONS(649),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(649),
    [anon_sym_DOLLAR] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(649),
    [sym_dots] = ACTIONS(651),
    [anon_sym_PIPE_GT] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_CARET] = ACTIONS(649),
    [anon_sym_LT] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(651),
    [anon_sym_LT_EQ] = ACTIONS(649),
    [anon_sym_GT_EQ] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_BANG_EQ] = ACTIONS(649),
    [anon_sym_PIPE_PIPE] = ACTIONS(649),
    [anon_sym_PIPE] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(649),
    [anon_sym_AMP] = ACTIONS(651),
    [anon_sym_COLON] = ACTIONS(651),
    [sym_break] = ACTIONS(651),
    [sym_next] = ACTIONS(651),
    [sym_true] = ACTIONS(651),
    [sym_false] = ACTIONS(651),
    [sym_null] = ACTIONS(651),
    [sym_inf] = ACTIONS(651),
    [sym_nan] = ACTIONS(651),
    [anon_sym_NA] = ACTIONS(651),
    [anon_sym_NA_character_] = ACTIONS(651),
    [anon_sym_NA_complex_] = ACTIONS(651),
    [anon_sym_NA_integer_] = ACTIONS(651),
    [anon_sym_NA_real_] = ACTIONS(651),
    [aux_sym_identifier_token1] = ACTIONS(651),
    [anon_sym_BQUOTE] = ACTIONS(649),
    [sym_integer] = ACTIONS(649),
    [sym_float] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(649),
    [anon_sym_SQUOTE] = ACTIONS(649),
    [anon_sym_PERCENT] = ACTIONS(649),
  },
  [86] = {
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_function] = ACTIONS(655),
    [anon_sym_BSLASH] = ACTIONS(653),
    [anon_sym_if] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_else] = ACTIONS(655),
    [anon_sym_while] = ACTIONS(655),
    [anon_sym_repeat] = ACTIONS(655),
    [anon_sym_for] = ACTIONS(655),
    [anon_sym_switch] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LT_DASH] = ACTIONS(653),
    [anon_sym_COLON_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_DASH] = ACTIONS(653),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_RBRACK] = ACTIONS(653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(653),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [anon_sym_AT] = ACTIONS(653),
    [anon_sym_COLON_COLON] = ACTIONS(655),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(653),
    [sym_dots] = ACTIONS(655),
    [anon_sym_PIPE_GT] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_SLASH] = ACTIONS(653),
    [anon_sym_CARET] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_COLON] = ACTIONS(655),
    [sym_break] = ACTIONS(655),
    [sym_next] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_null] = ACTIONS(655),
    [sym_inf] = ACTIONS(655),
    [sym_nan] = ACTIONS(655),
    [anon_sym_NA] = ACTIONS(655),
    [anon_sym_NA_character_] = ACTIONS(655),
    [anon_sym_NA_complex_] = ACTIONS(655),
    [anon_sym_NA_integer_] = ACTIONS(655),
    [anon_sym_NA_real_] = ACTIONS(655),
    [aux_sym_identifier_token1] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(653),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_SQUOTE] = ACTIONS(653),
    [anon_sym_PERCENT] = ACTIONS(653),
  },
  [87] = {
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_function] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(657),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_RPAREN] = ACTIONS(657),
    [anon_sym_else] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(659),
    [anon_sym_repeat] = ACTIONS(659),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(659),
    [anon_sym_COMMA] = ACTIONS(657),
    [anon_sym_EQ] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_LT_DASH] = ACTIONS(657),
    [anon_sym_COLON_EQ] = ACTIONS(657),
    [anon_sym_LT_LT_DASH] = ACTIONS(657),
    [anon_sym_DASH_GT_GT] = ACTIONS(657),
    [anon_sym_DASH_GT] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_RBRACK] = ACTIONS(657),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(657),
    [anon_sym_AT] = ACTIONS(657),
    [anon_sym_COLON_COLON] = ACTIONS(659),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(657),
    [sym_dots] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(657),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(657),
    [anon_sym_BANG] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_SLASH] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_LT] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_LT_EQ] = ACTIONS(657),
    [anon_sym_GT_EQ] = ACTIONS(657),
    [anon_sym_EQ_EQ] = ACTIONS(657),
    [anon_sym_BANG_EQ] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(659),
    [sym_break] = ACTIONS(659),
    [sym_next] = ACTIONS(659),
    [sym_true] = ACTIONS(659),
    [sym_false] = ACTIONS(659),
    [sym_null] = ACTIONS(659),
    [sym_inf] = ACTIONS(659),
    [sym_nan] = ACTIONS(659),
    [anon_sym_NA] = ACTIONS(659),
    [anon_sym_NA_character_] = ACTIONS(659),
    [anon_sym_NA_complex_] = ACTIONS(659),
    [anon_sym_NA_integer_] = ACTIONS(659),
    [anon_sym_NA_real_] = ACTIONS(659),
    [aux_sym_identifier_token1] = ACTIONS(659),
    [anon_sym_BQUOTE] = ACTIONS(657),
    [sym_integer] = ACTIONS(657),
    [sym_float] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_PERCENT] = ACTIONS(657),
  },
  [88] = {
    [sym_function_definition] = STATE(457),
    [sym_lambda_function] = STATE(457),
    [sym_if] = STATE(457),
    [sym_while] = STATE(457),
    [sym_repeat] = STATE(457),
    [sym_for] = STATE(457),
    [sym_switch] = STATE(457),
    [sym_call] = STATE(457),
    [sym__assignment] = STATE(457),
    [sym_left_assignment] = STATE(457),
    [sym_left_assignment2] = STATE(457),
    [sym_equals_assignment] = STATE(457),
    [sym_super_assignment] = STATE(457),
    [sym_super_right_assignment] = STATE(457),
    [sym_right_assignment] = STATE(457),
    [sym_brace_list] = STATE(457),
    [sym_paren_list] = STATE(457),
    [sym_subset] = STATE(457),
    [sym_subset2] = STATE(457),
    [sym_dollar] = STATE(457),
    [sym_slot] = STATE(457),
    [sym_namespace_get] = STATE(457),
    [sym_namespace_get_internal] = STATE(457),
    [sym_pipe] = STATE(457),
    [sym_unary] = STATE(457),
    [sym_binary] = STATE(457),
    [sym_na] = STATE(457),
    [sym__expression] = STATE(457),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(457),
    [sym_string] = STATE(457),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(681),
    [sym_next] = ACTIONS(681),
    [sym_true] = ACTIONS(681),
    [sym_false] = ACTIONS(681),
    [sym_null] = ACTIONS(681),
    [sym_inf] = ACTIONS(681),
    [sym_nan] = ACTIONS(681),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(661),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [89] = {
    [sym_function_definition] = STATE(922),
    [sym_lambda_function] = STATE(922),
    [sym_if] = STATE(922),
    [sym_while] = STATE(922),
    [sym_repeat] = STATE(922),
    [sym_for] = STATE(922),
    [sym_switch] = STATE(922),
    [sym_call] = STATE(869),
    [sym__assignment] = STATE(922),
    [sym_left_assignment] = STATE(922),
    [sym_left_assignment2] = STATE(922),
    [sym_equals_assignment] = STATE(922),
    [sym_super_assignment] = STATE(922),
    [sym_super_right_assignment] = STATE(922),
    [sym_right_assignment] = STATE(922),
    [sym_brace_list] = STATE(922),
    [sym_paren_list] = STATE(922),
    [sym_subset] = STATE(922),
    [sym_subset2] = STATE(922),
    [sym_dollar] = STATE(922),
    [sym_slot] = STATE(922),
    [sym_namespace_get] = STATE(922),
    [sym_namespace_get_internal] = STATE(922),
    [sym_pipe] = STATE(922),
    [sym_unary] = STATE(922),
    [sym_binary] = STATE(922),
    [sym_na] = STATE(922),
    [sym__expression] = STATE(922),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(922),
    [sym_string] = STATE(922),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(715),
    [sym_next] = ACTIONS(715),
    [sym_true] = ACTIONS(715),
    [sym_false] = ACTIONS(715),
    [sym_null] = ACTIONS(715),
    [sym_inf] = ACTIONS(715),
    [sym_nan] = ACTIONS(715),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(701),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [90] = {
    [sym_function_definition] = STATE(881),
    [sym_lambda_function] = STATE(881),
    [sym_if] = STATE(881),
    [sym_while] = STATE(881),
    [sym_repeat] = STATE(881),
    [sym_for] = STATE(881),
    [sym_switch] = STATE(881),
    [sym_call] = STATE(881),
    [sym__assignment] = STATE(881),
    [sym_left_assignment] = STATE(881),
    [sym_left_assignment2] = STATE(881),
    [sym_equals_assignment] = STATE(881),
    [sym_super_assignment] = STATE(881),
    [sym_super_right_assignment] = STATE(881),
    [sym_right_assignment] = STATE(881),
    [sym_brace_list] = STATE(881),
    [sym_paren_list] = STATE(881),
    [sym_subset] = STATE(881),
    [sym_subset2] = STATE(881),
    [sym_dollar] = STATE(881),
    [sym_slot] = STATE(881),
    [sym_namespace_get] = STATE(881),
    [sym_namespace_get_internal] = STATE(881),
    [sym_pipe] = STATE(881),
    [sym_unary] = STATE(881),
    [sym_binary] = STATE(881),
    [sym_na] = STATE(881),
    [sym__expression] = STATE(881),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(881),
    [sym_string] = STATE(881),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(727),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(727),
    [sym_next] = ACTIONS(727),
    [sym_true] = ACTIONS(727),
    [sym_false] = ACTIONS(727),
    [sym_null] = ACTIONS(727),
    [sym_inf] = ACTIONS(727),
    [sym_nan] = ACTIONS(727),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(725),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [91] = {
    [sym_function_definition] = STATE(888),
    [sym_lambda_function] = STATE(888),
    [sym_if] = STATE(888),
    [sym_while] = STATE(888),
    [sym_repeat] = STATE(888),
    [sym_for] = STATE(888),
    [sym_switch] = STATE(888),
    [sym_call] = STATE(888),
    [sym__assignment] = STATE(888),
    [sym_left_assignment] = STATE(888),
    [sym_left_assignment2] = STATE(888),
    [sym_equals_assignment] = STATE(888),
    [sym_super_assignment] = STATE(888),
    [sym_super_right_assignment] = STATE(888),
    [sym_right_assignment] = STATE(888),
    [sym_brace_list] = STATE(888),
    [sym_paren_list] = STATE(888),
    [sym_subset] = STATE(888),
    [sym_subset2] = STATE(888),
    [sym_dollar] = STATE(888),
    [sym_slot] = STATE(888),
    [sym_namespace_get] = STATE(888),
    [sym_namespace_get_internal] = STATE(888),
    [sym_pipe] = STATE(888),
    [sym_unary] = STATE(888),
    [sym_binary] = STATE(888),
    [sym_na] = STATE(888),
    [sym__expression] = STATE(888),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(888),
    [sym_string] = STATE(888),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(731),
    [sym_next] = ACTIONS(731),
    [sym_true] = ACTIONS(731),
    [sym_false] = ACTIONS(731),
    [sym_null] = ACTIONS(731),
    [sym_inf] = ACTIONS(731),
    [sym_nan] = ACTIONS(731),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(729),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [92] = {
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_function] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(657),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_else] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(659),
    [anon_sym_repeat] = ACTIONS(659),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(659),
    [anon_sym_COMMA] = ACTIONS(657),
    [anon_sym_EQ] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_LT_DASH] = ACTIONS(657),
    [anon_sym_COLON_EQ] = ACTIONS(657),
    [anon_sym_LT_LT_DASH] = ACTIONS(657),
    [anon_sym_DASH_GT_GT] = ACTIONS(657),
    [anon_sym_DASH_GT] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(657),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(657),
    [anon_sym_AT] = ACTIONS(657),
    [anon_sym_COLON_COLON] = ACTIONS(659),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(657),
    [sym_dots] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(657),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(657),
    [anon_sym_BANG] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_SLASH] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_LT] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_LT_EQ] = ACTIONS(657),
    [anon_sym_GT_EQ] = ACTIONS(657),
    [anon_sym_EQ_EQ] = ACTIONS(657),
    [anon_sym_BANG_EQ] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(659),
    [sym_break] = ACTIONS(659),
    [sym_next] = ACTIONS(659),
    [sym_true] = ACTIONS(659),
    [sym_false] = ACTIONS(659),
    [sym_null] = ACTIONS(659),
    [sym_inf] = ACTIONS(659),
    [sym_nan] = ACTIONS(659),
    [anon_sym_NA] = ACTIONS(659),
    [anon_sym_NA_character_] = ACTIONS(659),
    [anon_sym_NA_complex_] = ACTIONS(659),
    [anon_sym_NA_integer_] = ACTIONS(659),
    [anon_sym_NA_real_] = ACTIONS(659),
    [aux_sym_identifier_token1] = ACTIONS(659),
    [anon_sym_BQUOTE] = ACTIONS(657),
    [sym_integer] = ACTIONS(657),
    [sym_float] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_PERCENT] = ACTIONS(657),
  },
  [93] = {
    [sym_function_definition] = STATE(897),
    [sym_lambda_function] = STATE(897),
    [sym_if] = STATE(897),
    [sym_while] = STATE(897),
    [sym_repeat] = STATE(897),
    [sym_for] = STATE(897),
    [sym_switch] = STATE(897),
    [sym_call] = STATE(897),
    [sym__assignment] = STATE(897),
    [sym_left_assignment] = STATE(897),
    [sym_left_assignment2] = STATE(897),
    [sym_equals_assignment] = STATE(897),
    [sym_super_assignment] = STATE(897),
    [sym_super_right_assignment] = STATE(897),
    [sym_right_assignment] = STATE(897),
    [sym_brace_list] = STATE(897),
    [sym_paren_list] = STATE(897),
    [sym_subset] = STATE(897),
    [sym_subset2] = STATE(897),
    [sym_dollar] = STATE(897),
    [sym_slot] = STATE(897),
    [sym_namespace_get] = STATE(897),
    [sym_namespace_get_internal] = STATE(897),
    [sym_pipe] = STATE(897),
    [sym_unary] = STATE(897),
    [sym_binary] = STATE(897),
    [sym_na] = STATE(897),
    [sym__expression] = STATE(897),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(897),
    [sym_string] = STATE(897),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(735),
    [sym_next] = ACTIONS(735),
    [sym_true] = ACTIONS(735),
    [sym_false] = ACTIONS(735),
    [sym_null] = ACTIONS(735),
    [sym_inf] = ACTIONS(735),
    [sym_nan] = ACTIONS(735),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [94] = {
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_function] = ACTIONS(655),
    [anon_sym_BSLASH] = ACTIONS(653),
    [anon_sym_if] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_else] = ACTIONS(655),
    [anon_sym_while] = ACTIONS(655),
    [anon_sym_repeat] = ACTIONS(655),
    [anon_sym_for] = ACTIONS(655),
    [anon_sym_switch] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LT_DASH] = ACTIONS(653),
    [anon_sym_COLON_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_DASH] = ACTIONS(653),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(653),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(653),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [anon_sym_AT] = ACTIONS(653),
    [anon_sym_COLON_COLON] = ACTIONS(655),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(653),
    [sym_dots] = ACTIONS(655),
    [anon_sym_PIPE_GT] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_SLASH] = ACTIONS(653),
    [anon_sym_CARET] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_COLON] = ACTIONS(655),
    [sym_break] = ACTIONS(655),
    [sym_next] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_null] = ACTIONS(655),
    [sym_inf] = ACTIONS(655),
    [sym_nan] = ACTIONS(655),
    [anon_sym_NA] = ACTIONS(655),
    [anon_sym_NA_character_] = ACTIONS(655),
    [anon_sym_NA_complex_] = ACTIONS(655),
    [anon_sym_NA_integer_] = ACTIONS(655),
    [anon_sym_NA_real_] = ACTIONS(655),
    [aux_sym_identifier_token1] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(653),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_SQUOTE] = ACTIONS(653),
    [anon_sym_PERCENT] = ACTIONS(653),
  },
  [95] = {
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(739),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(741),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_integer] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
  },
  [96] = {
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_else] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(641),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(745),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_integer] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
  },
  [97] = {
    [anon_sym_SEMI] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(651),
    [anon_sym_BSLASH] = ACTIONS(649),
    [anon_sym_if] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(649),
    [anon_sym_else] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(651),
    [anon_sym_repeat] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_switch] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(649),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_DASH_GT_GT] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(649),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(649),
    [anon_sym_DOLLAR] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(649),
    [sym_dots] = ACTIONS(651),
    [anon_sym_PIPE_GT] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_CARET] = ACTIONS(649),
    [anon_sym_LT] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(651),
    [anon_sym_LT_EQ] = ACTIONS(649),
    [anon_sym_GT_EQ] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_BANG_EQ] = ACTIONS(649),
    [anon_sym_PIPE_PIPE] = ACTIONS(649),
    [anon_sym_PIPE] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(649),
    [anon_sym_AMP] = ACTIONS(651),
    [anon_sym_COLON] = ACTIONS(651),
    [sym_break] = ACTIONS(651),
    [sym_next] = ACTIONS(651),
    [sym_true] = ACTIONS(651),
    [sym_false] = ACTIONS(651),
    [sym_null] = ACTIONS(651),
    [sym_inf] = ACTIONS(651),
    [sym_nan] = ACTIONS(651),
    [anon_sym_NA] = ACTIONS(651),
    [anon_sym_NA_character_] = ACTIONS(651),
    [anon_sym_NA_complex_] = ACTIONS(651),
    [anon_sym_NA_integer_] = ACTIONS(651),
    [anon_sym_NA_real_] = ACTIONS(651),
    [aux_sym_identifier_token1] = ACTIONS(651),
    [anon_sym_BQUOTE] = ACTIONS(649),
    [sym_integer] = ACTIONS(649),
    [sym_float] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(649),
    [anon_sym_SQUOTE] = ACTIONS(649),
    [anon_sym_PERCENT] = ACTIONS(649),
  },
  [98] = {
    [sym_function_definition] = STATE(650),
    [sym_lambda_function] = STATE(650),
    [sym_if] = STATE(650),
    [sym_while] = STATE(650),
    [sym_repeat] = STATE(650),
    [sym_for] = STATE(650),
    [sym_switch] = STATE(650),
    [sym_call] = STATE(650),
    [sym__assignment] = STATE(650),
    [sym_left_assignment] = STATE(650),
    [sym_left_assignment2] = STATE(650),
    [sym_equals_assignment] = STATE(650),
    [sym_super_assignment] = STATE(650),
    [sym_super_right_assignment] = STATE(650),
    [sym_right_assignment] = STATE(650),
    [sym_brace_list] = STATE(650),
    [sym_paren_list] = STATE(650),
    [sym_subset] = STATE(650),
    [sym_subset2] = STATE(650),
    [sym_dollar] = STATE(650),
    [sym_slot] = STATE(650),
    [sym_namespace_get] = STATE(650),
    [sym_namespace_get_internal] = STATE(650),
    [sym_pipe] = STATE(650),
    [sym_unary] = STATE(650),
    [sym_binary] = STATE(650),
    [sym_na] = STATE(650),
    [sym__expression] = STATE(650),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(650),
    [sym_string] = STATE(650),
    [anon_sym_SEMI] = ACTIONS(747),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(749),
    [sym_next] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_null] = ACTIONS(749),
    [sym_inf] = ACTIONS(749),
    [sym_nan] = ACTIONS(749),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(747),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [99] = {
    [sym_function_definition] = STATE(808),
    [sym_lambda_function] = STATE(808),
    [sym_if] = STATE(808),
    [sym_while] = STATE(808),
    [sym_repeat] = STATE(808),
    [sym_for] = STATE(808),
    [sym_switch] = STATE(808),
    [sym_call] = STATE(808),
    [sym__assignment] = STATE(808),
    [sym_left_assignment] = STATE(808),
    [sym_left_assignment2] = STATE(808),
    [sym_equals_assignment] = STATE(808),
    [sym_super_assignment] = STATE(808),
    [sym_super_right_assignment] = STATE(808),
    [sym_right_assignment] = STATE(808),
    [sym_brace_list] = STATE(808),
    [sym_paren_list] = STATE(808),
    [sym_subset] = STATE(808),
    [sym_subset2] = STATE(808),
    [sym_dollar] = STATE(808),
    [sym_slot] = STATE(808),
    [sym_namespace_get] = STATE(808),
    [sym_namespace_get_internal] = STATE(808),
    [sym_pipe] = STATE(808),
    [sym_unary] = STATE(808),
    [sym_binary] = STATE(808),
    [sym_na] = STATE(808),
    [sym__expression] = STATE(808),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(808),
    [sym_string] = STATE(808),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(771),
    [sym_next] = ACTIONS(771),
    [sym_true] = ACTIONS(771),
    [sym_false] = ACTIONS(771),
    [sym_null] = ACTIONS(771),
    [sym_inf] = ACTIONS(771),
    [sym_nan] = ACTIONS(771),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(751),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [100] = {
    [sym_function_definition] = STATE(822),
    [sym_lambda_function] = STATE(822),
    [sym_if] = STATE(822),
    [sym_while] = STATE(822),
    [sym_repeat] = STATE(822),
    [sym_for] = STATE(822),
    [sym_switch] = STATE(822),
    [sym_call] = STATE(822),
    [sym__assignment] = STATE(822),
    [sym_left_assignment] = STATE(822),
    [sym_left_assignment2] = STATE(822),
    [sym_equals_assignment] = STATE(822),
    [sym_super_assignment] = STATE(822),
    [sym_super_right_assignment] = STATE(822),
    [sym_right_assignment] = STATE(822),
    [sym_brace_list] = STATE(822),
    [sym_paren_list] = STATE(822),
    [sym_subset] = STATE(822),
    [sym_subset2] = STATE(822),
    [sym_dollar] = STATE(822),
    [sym_slot] = STATE(822),
    [sym_namespace_get] = STATE(822),
    [sym_namespace_get_internal] = STATE(822),
    [sym_pipe] = STATE(822),
    [sym_unary] = STATE(822),
    [sym_binary] = STATE(822),
    [sym_na] = STATE(822),
    [sym__expression] = STATE(822),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(822),
    [sym_string] = STATE(822),
    [anon_sym_SEMI] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(793),
    [sym_next] = ACTIONS(793),
    [sym_true] = ACTIONS(793),
    [sym_false] = ACTIONS(793),
    [sym_null] = ACTIONS(793),
    [sym_inf] = ACTIONS(793),
    [sym_nan] = ACTIONS(793),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(791),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [101] = {
    [sym_function_definition] = STATE(926),
    [sym_lambda_function] = STATE(926),
    [sym_if] = STATE(926),
    [sym_while] = STATE(926),
    [sym_repeat] = STATE(926),
    [sym_for] = STATE(926),
    [sym_switch] = STATE(926),
    [sym_call] = STATE(604),
    [sym__assignment] = STATE(926),
    [sym_left_assignment] = STATE(926),
    [sym_left_assignment2] = STATE(926),
    [sym_equals_assignment] = STATE(926),
    [sym_super_assignment] = STATE(926),
    [sym_super_right_assignment] = STATE(926),
    [sym_right_assignment] = STATE(926),
    [sym_brace_list] = STATE(926),
    [sym_paren_list] = STATE(926),
    [sym_subset] = STATE(926),
    [sym_subset2] = STATE(926),
    [sym_dollar] = STATE(926),
    [sym_slot] = STATE(926),
    [sym_namespace_get] = STATE(926),
    [sym_namespace_get_internal] = STATE(926),
    [sym_pipe] = STATE(926),
    [sym_unary] = STATE(926),
    [sym_binary] = STATE(926),
    [sym_na] = STATE(926),
    [sym__expression] = STATE(926),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(926),
    [sym_string] = STATE(926),
    [anon_sym_SEMI] = ACTIONS(795),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(797),
    [sym_next] = ACTIONS(797),
    [sym_true] = ACTIONS(797),
    [sym_false] = ACTIONS(797),
    [sym_null] = ACTIONS(797),
    [sym_inf] = ACTIONS(797),
    [sym_nan] = ACTIONS(797),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(795),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [102] = {
    [sym_function_definition] = STATE(899),
    [sym_lambda_function] = STATE(899),
    [sym_if] = STATE(899),
    [sym_while] = STATE(899),
    [sym_repeat] = STATE(899),
    [sym_for] = STATE(899),
    [sym_switch] = STATE(899),
    [sym_call] = STATE(899),
    [sym__assignment] = STATE(899),
    [sym_left_assignment] = STATE(899),
    [sym_left_assignment2] = STATE(899),
    [sym_equals_assignment] = STATE(899),
    [sym_super_assignment] = STATE(899),
    [sym_super_right_assignment] = STATE(899),
    [sym_right_assignment] = STATE(899),
    [sym_brace_list] = STATE(899),
    [sym_paren_list] = STATE(899),
    [sym_subset] = STATE(899),
    [sym_subset2] = STATE(899),
    [sym_dollar] = STATE(899),
    [sym_slot] = STATE(899),
    [sym_namespace_get] = STATE(899),
    [sym_namespace_get_internal] = STATE(899),
    [sym_pipe] = STATE(899),
    [sym_unary] = STATE(899),
    [sym_binary] = STATE(899),
    [sym_na] = STATE(899),
    [sym__expression] = STATE(899),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(899),
    [sym_string] = STATE(899),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(801),
    [sym_next] = ACTIONS(801),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(801),
    [sym_inf] = ACTIONS(801),
    [sym_nan] = ACTIONS(801),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(799),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [103] = {
    [sym_function_definition] = STATE(902),
    [sym_lambda_function] = STATE(902),
    [sym_if] = STATE(902),
    [sym_while] = STATE(902),
    [sym_repeat] = STATE(902),
    [sym_for] = STATE(902),
    [sym_switch] = STATE(902),
    [sym_call] = STATE(902),
    [sym__assignment] = STATE(902),
    [sym_left_assignment] = STATE(902),
    [sym_left_assignment2] = STATE(902),
    [sym_equals_assignment] = STATE(902),
    [sym_super_assignment] = STATE(902),
    [sym_super_right_assignment] = STATE(902),
    [sym_right_assignment] = STATE(902),
    [sym_brace_list] = STATE(902),
    [sym_paren_list] = STATE(902),
    [sym_subset] = STATE(902),
    [sym_subset2] = STATE(902),
    [sym_dollar] = STATE(902),
    [sym_slot] = STATE(902),
    [sym_namespace_get] = STATE(902),
    [sym_namespace_get_internal] = STATE(902),
    [sym_pipe] = STATE(902),
    [sym_unary] = STATE(902),
    [sym_binary] = STATE(902),
    [sym_na] = STATE(902),
    [sym__expression] = STATE(902),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(902),
    [sym_string] = STATE(902),
    [anon_sym_SEMI] = ACTIONS(803),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(805),
    [sym_next] = ACTIONS(805),
    [sym_true] = ACTIONS(805),
    [sym_false] = ACTIONS(805),
    [sym_null] = ACTIONS(805),
    [sym_inf] = ACTIONS(805),
    [sym_nan] = ACTIONS(805),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(803),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [104] = {
    [sym_function_definition] = STATE(914),
    [sym_lambda_function] = STATE(914),
    [sym_if] = STATE(914),
    [sym_while] = STATE(914),
    [sym_repeat] = STATE(914),
    [sym_for] = STATE(914),
    [sym_switch] = STATE(914),
    [sym_call] = STATE(914),
    [sym__assignment] = STATE(914),
    [sym_left_assignment] = STATE(914),
    [sym_left_assignment2] = STATE(914),
    [sym_equals_assignment] = STATE(914),
    [sym_super_assignment] = STATE(914),
    [sym_super_right_assignment] = STATE(914),
    [sym_right_assignment] = STATE(914),
    [sym_brace_list] = STATE(914),
    [sym_paren_list] = STATE(914),
    [sym_subset] = STATE(914),
    [sym_subset2] = STATE(914),
    [sym_dollar] = STATE(914),
    [sym_slot] = STATE(914),
    [sym_namespace_get] = STATE(914),
    [sym_namespace_get_internal] = STATE(914),
    [sym_pipe] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_na] = STATE(914),
    [sym__expression] = STATE(914),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(914),
    [sym_string] = STATE(914),
    [anon_sym_SEMI] = ACTIONS(807),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(809),
    [sym_next] = ACTIONS(809),
    [sym_true] = ACTIONS(809),
    [sym_false] = ACTIONS(809),
    [sym_null] = ACTIONS(809),
    [sym_inf] = ACTIONS(809),
    [sym_nan] = ACTIONS(809),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(807),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [105] = {
    [sym_function_definition] = STATE(882),
    [sym_lambda_function] = STATE(882),
    [sym_if] = STATE(882),
    [sym_while] = STATE(882),
    [sym_repeat] = STATE(882),
    [sym_for] = STATE(882),
    [sym_switch] = STATE(882),
    [sym_call] = STATE(882),
    [sym__assignment] = STATE(882),
    [sym_left_assignment] = STATE(882),
    [sym_left_assignment2] = STATE(882),
    [sym_equals_assignment] = STATE(882),
    [sym_super_assignment] = STATE(882),
    [sym_super_right_assignment] = STATE(882),
    [sym_right_assignment] = STATE(882),
    [sym_brace_list] = STATE(882),
    [sym_paren_list] = STATE(882),
    [sym_subset] = STATE(882),
    [sym_subset2] = STATE(882),
    [sym_dollar] = STATE(882),
    [sym_slot] = STATE(882),
    [sym_namespace_get] = STATE(882),
    [sym_namespace_get_internal] = STATE(882),
    [sym_pipe] = STATE(882),
    [sym_unary] = STATE(882),
    [sym_binary] = STATE(882),
    [sym_na] = STATE(882),
    [sym__expression] = STATE(882),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(882),
    [sym_string] = STATE(882),
    [anon_sym_SEMI] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(813),
    [sym_next] = ACTIONS(813),
    [sym_true] = ACTIONS(813),
    [sym_false] = ACTIONS(813),
    [sym_null] = ACTIONS(813),
    [sym_inf] = ACTIONS(813),
    [sym_nan] = ACTIONS(813),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(811),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [106] = {
    [sym_function_definition] = STATE(907),
    [sym_lambda_function] = STATE(907),
    [sym_if] = STATE(907),
    [sym_while] = STATE(907),
    [sym_repeat] = STATE(907),
    [sym_for] = STATE(907),
    [sym_switch] = STATE(907),
    [sym_call] = STATE(907),
    [sym__assignment] = STATE(907),
    [sym_left_assignment] = STATE(907),
    [sym_left_assignment2] = STATE(907),
    [sym_equals_assignment] = STATE(907),
    [sym_super_assignment] = STATE(907),
    [sym_super_right_assignment] = STATE(907),
    [sym_right_assignment] = STATE(907),
    [sym_brace_list] = STATE(907),
    [sym_paren_list] = STATE(907),
    [sym_subset] = STATE(907),
    [sym_subset2] = STATE(907),
    [sym_dollar] = STATE(907),
    [sym_slot] = STATE(907),
    [sym_namespace_get] = STATE(907),
    [sym_namespace_get_internal] = STATE(907),
    [sym_pipe] = STATE(907),
    [sym_unary] = STATE(907),
    [sym_binary] = STATE(907),
    [sym_na] = STATE(907),
    [sym__expression] = STATE(907),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(907),
    [sym_string] = STATE(907),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(817),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(817),
    [sym_next] = ACTIONS(817),
    [sym_true] = ACTIONS(817),
    [sym_false] = ACTIONS(817),
    [sym_null] = ACTIONS(817),
    [sym_inf] = ACTIONS(817),
    [sym_nan] = ACTIONS(817),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [107] = {
    [sym_function_definition] = STATE(906),
    [sym_lambda_function] = STATE(906),
    [sym_if] = STATE(906),
    [sym_while] = STATE(906),
    [sym_repeat] = STATE(906),
    [sym_for] = STATE(906),
    [sym_switch] = STATE(906),
    [sym_call] = STATE(906),
    [sym__assignment] = STATE(906),
    [sym_left_assignment] = STATE(906),
    [sym_left_assignment2] = STATE(906),
    [sym_equals_assignment] = STATE(906),
    [sym_super_assignment] = STATE(906),
    [sym_super_right_assignment] = STATE(906),
    [sym_right_assignment] = STATE(906),
    [sym_brace_list] = STATE(906),
    [sym_paren_list] = STATE(906),
    [sym_subset] = STATE(906),
    [sym_subset2] = STATE(906),
    [sym_dollar] = STATE(906),
    [sym_slot] = STATE(906),
    [sym_namespace_get] = STATE(906),
    [sym_namespace_get_internal] = STATE(906),
    [sym_pipe] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_na] = STATE(906),
    [sym__expression] = STATE(906),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(906),
    [sym_string] = STATE(906),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(821),
    [sym_next] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_null] = ACTIONS(821),
    [sym_inf] = ACTIONS(821),
    [sym_nan] = ACTIONS(821),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [108] = {
    [sym_function_definition] = STATE(890),
    [sym_lambda_function] = STATE(890),
    [sym_if] = STATE(890),
    [sym_while] = STATE(890),
    [sym_repeat] = STATE(890),
    [sym_for] = STATE(890),
    [sym_switch] = STATE(890),
    [sym_call] = STATE(890),
    [sym__assignment] = STATE(890),
    [sym_left_assignment] = STATE(890),
    [sym_left_assignment2] = STATE(890),
    [sym_equals_assignment] = STATE(890),
    [sym_super_assignment] = STATE(890),
    [sym_super_right_assignment] = STATE(890),
    [sym_right_assignment] = STATE(890),
    [sym_brace_list] = STATE(890),
    [sym_paren_list] = STATE(890),
    [sym_subset] = STATE(890),
    [sym_subset2] = STATE(890),
    [sym_dollar] = STATE(890),
    [sym_slot] = STATE(890),
    [sym_namespace_get] = STATE(890),
    [sym_namespace_get_internal] = STATE(890),
    [sym_pipe] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_na] = STATE(890),
    [sym__expression] = STATE(890),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(890),
    [sym_string] = STATE(890),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(825),
    [sym_next] = ACTIONS(825),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [sym_null] = ACTIONS(825),
    [sym_inf] = ACTIONS(825),
    [sym_nan] = ACTIONS(825),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(823),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [109] = {
    [sym_function_definition] = STATE(895),
    [sym_lambda_function] = STATE(895),
    [sym_if] = STATE(895),
    [sym_while] = STATE(895),
    [sym_repeat] = STATE(895),
    [sym_for] = STATE(895),
    [sym_switch] = STATE(895),
    [sym_call] = STATE(895),
    [sym__assignment] = STATE(895),
    [sym_left_assignment] = STATE(895),
    [sym_left_assignment2] = STATE(895),
    [sym_equals_assignment] = STATE(895),
    [sym_super_assignment] = STATE(895),
    [sym_super_right_assignment] = STATE(895),
    [sym_right_assignment] = STATE(895),
    [sym_brace_list] = STATE(895),
    [sym_paren_list] = STATE(895),
    [sym_subset] = STATE(895),
    [sym_subset2] = STATE(895),
    [sym_dollar] = STATE(895),
    [sym_slot] = STATE(895),
    [sym_namespace_get] = STATE(895),
    [sym_namespace_get_internal] = STATE(895),
    [sym_pipe] = STATE(895),
    [sym_unary] = STATE(895),
    [sym_binary] = STATE(895),
    [sym_na] = STATE(895),
    [sym__expression] = STATE(895),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(895),
    [sym_string] = STATE(895),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(829),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(829),
    [sym_next] = ACTIONS(829),
    [sym_true] = ACTIONS(829),
    [sym_false] = ACTIONS(829),
    [sym_null] = ACTIONS(829),
    [sym_inf] = ACTIONS(829),
    [sym_nan] = ACTIONS(829),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(827),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [110] = {
    [sym_function_definition] = STATE(234),
    [sym_lambda_function] = STATE(234),
    [sym_if] = STATE(234),
    [sym_while] = STATE(234),
    [sym_repeat] = STATE(234),
    [sym_for] = STATE(234),
    [sym_switch] = STATE(234),
    [sym_call] = STATE(234),
    [sym__assignment] = STATE(234),
    [sym_left_assignment] = STATE(234),
    [sym_left_assignment2] = STATE(234),
    [sym_equals_assignment] = STATE(234),
    [sym_super_assignment] = STATE(234),
    [sym_super_right_assignment] = STATE(234),
    [sym_right_assignment] = STATE(234),
    [sym_brace_list] = STATE(234),
    [sym_paren_list] = STATE(234),
    [sym_subset] = STATE(234),
    [sym_subset2] = STATE(234),
    [sym_dollar] = STATE(234),
    [sym_slot] = STATE(234),
    [sym_namespace_get] = STATE(234),
    [sym_namespace_get_internal] = STATE(234),
    [sym_pipe] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_na] = STATE(234),
    [sym__expression] = STATE(234),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(234),
    [sym_string] = STATE(234),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(851),
    [sym_next] = ACTIONS(851),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_null] = ACTIONS(851),
    [sym_inf] = ACTIONS(851),
    [sym_nan] = ACTIONS(851),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [111] = {
    [sym_function_definition] = STATE(820),
    [sym_lambda_function] = STATE(820),
    [sym_if] = STATE(820),
    [sym_while] = STATE(820),
    [sym_repeat] = STATE(820),
    [sym_for] = STATE(820),
    [sym_switch] = STATE(820),
    [sym_call] = STATE(820),
    [sym__assignment] = STATE(820),
    [sym_left_assignment] = STATE(820),
    [sym_left_assignment2] = STATE(820),
    [sym_equals_assignment] = STATE(820),
    [sym_super_assignment] = STATE(820),
    [sym_super_right_assignment] = STATE(820),
    [sym_right_assignment] = STATE(820),
    [sym_brace_list] = STATE(820),
    [sym_paren_list] = STATE(820),
    [sym_subset] = STATE(820),
    [sym_subset2] = STATE(820),
    [sym_dollar] = STATE(820),
    [sym_slot] = STATE(820),
    [sym_namespace_get] = STATE(820),
    [sym_namespace_get_internal] = STATE(820),
    [sym_pipe] = STATE(820),
    [sym_unary] = STATE(820),
    [sym_binary] = STATE(820),
    [sym_na] = STATE(820),
    [sym__expression] = STATE(820),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(820),
    [sym_string] = STATE(820),
    [anon_sym_SEMI] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(873),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(873),
    [sym_next] = ACTIONS(873),
    [sym_true] = ACTIONS(873),
    [sym_false] = ACTIONS(873),
    [sym_null] = ACTIONS(873),
    [sym_inf] = ACTIONS(873),
    [sym_nan] = ACTIONS(873),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(871),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [112] = {
    [sym_function_definition] = STATE(838),
    [sym_lambda_function] = STATE(838),
    [sym_if] = STATE(838),
    [sym_while] = STATE(838),
    [sym_repeat] = STATE(838),
    [sym_for] = STATE(838),
    [sym_switch] = STATE(838),
    [sym_call] = STATE(838),
    [sym__assignment] = STATE(838),
    [sym_left_assignment] = STATE(838),
    [sym_left_assignment2] = STATE(838),
    [sym_equals_assignment] = STATE(838),
    [sym_super_assignment] = STATE(838),
    [sym_super_right_assignment] = STATE(838),
    [sym_right_assignment] = STATE(838),
    [sym_brace_list] = STATE(838),
    [sym_paren_list] = STATE(838),
    [sym_subset] = STATE(838),
    [sym_subset2] = STATE(838),
    [sym_dollar] = STATE(838),
    [sym_slot] = STATE(838),
    [sym_namespace_get] = STATE(838),
    [sym_namespace_get_internal] = STATE(838),
    [sym_pipe] = STATE(838),
    [sym_unary] = STATE(838),
    [sym_binary] = STATE(838),
    [sym_na] = STATE(838),
    [sym__expression] = STATE(838),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(838),
    [sym_string] = STATE(838),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(877),
    [sym_next] = ACTIONS(877),
    [sym_true] = ACTIONS(877),
    [sym_false] = ACTIONS(877),
    [sym_null] = ACTIONS(877),
    [sym_inf] = ACTIONS(877),
    [sym_nan] = ACTIONS(877),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(875),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [113] = {
    [sym_function_definition] = STATE(839),
    [sym_lambda_function] = STATE(839),
    [sym_if] = STATE(839),
    [sym_while] = STATE(839),
    [sym_repeat] = STATE(839),
    [sym_for] = STATE(839),
    [sym_switch] = STATE(839),
    [sym_call] = STATE(839),
    [sym__assignment] = STATE(839),
    [sym_left_assignment] = STATE(839),
    [sym_left_assignment2] = STATE(839),
    [sym_equals_assignment] = STATE(839),
    [sym_super_assignment] = STATE(839),
    [sym_super_right_assignment] = STATE(839),
    [sym_right_assignment] = STATE(839),
    [sym_brace_list] = STATE(839),
    [sym_paren_list] = STATE(839),
    [sym_subset] = STATE(839),
    [sym_subset2] = STATE(839),
    [sym_dollar] = STATE(839),
    [sym_slot] = STATE(839),
    [sym_namespace_get] = STATE(839),
    [sym_namespace_get_internal] = STATE(839),
    [sym_pipe] = STATE(839),
    [sym_unary] = STATE(839),
    [sym_binary] = STATE(839),
    [sym_na] = STATE(839),
    [sym__expression] = STATE(839),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(839),
    [sym_string] = STATE(839),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(881),
    [sym_next] = ACTIONS(881),
    [sym_true] = ACTIONS(881),
    [sym_false] = ACTIONS(881),
    [sym_null] = ACTIONS(881),
    [sym_inf] = ACTIONS(881),
    [sym_nan] = ACTIONS(881),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(879),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [114] = {
    [sym_function_definition] = STATE(827),
    [sym_lambda_function] = STATE(827),
    [sym_if] = STATE(827),
    [sym_while] = STATE(827),
    [sym_repeat] = STATE(827),
    [sym_for] = STATE(827),
    [sym_switch] = STATE(827),
    [sym_call] = STATE(827),
    [sym__assignment] = STATE(827),
    [sym_left_assignment] = STATE(827),
    [sym_left_assignment2] = STATE(827),
    [sym_equals_assignment] = STATE(827),
    [sym_super_assignment] = STATE(827),
    [sym_super_right_assignment] = STATE(827),
    [sym_right_assignment] = STATE(827),
    [sym_brace_list] = STATE(827),
    [sym_paren_list] = STATE(827),
    [sym_subset] = STATE(827),
    [sym_subset2] = STATE(827),
    [sym_dollar] = STATE(827),
    [sym_slot] = STATE(827),
    [sym_namespace_get] = STATE(827),
    [sym_namespace_get_internal] = STATE(827),
    [sym_pipe] = STATE(827),
    [sym_unary] = STATE(827),
    [sym_binary] = STATE(827),
    [sym_na] = STATE(827),
    [sym__expression] = STATE(827),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(827),
    [sym_string] = STATE(827),
    [anon_sym_SEMI] = ACTIONS(883),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(885),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(885),
    [sym_next] = ACTIONS(885),
    [sym_true] = ACTIONS(885),
    [sym_false] = ACTIONS(885),
    [sym_null] = ACTIONS(885),
    [sym_inf] = ACTIONS(885),
    [sym_nan] = ACTIONS(885),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(883),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [115] = {
    [sym_function_definition] = STATE(828),
    [sym_lambda_function] = STATE(828),
    [sym_if] = STATE(828),
    [sym_while] = STATE(828),
    [sym_repeat] = STATE(828),
    [sym_for] = STATE(828),
    [sym_switch] = STATE(828),
    [sym_call] = STATE(828),
    [sym__assignment] = STATE(828),
    [sym_left_assignment] = STATE(828),
    [sym_left_assignment2] = STATE(828),
    [sym_equals_assignment] = STATE(828),
    [sym_super_assignment] = STATE(828),
    [sym_super_right_assignment] = STATE(828),
    [sym_right_assignment] = STATE(828),
    [sym_brace_list] = STATE(828),
    [sym_paren_list] = STATE(828),
    [sym_subset] = STATE(828),
    [sym_subset2] = STATE(828),
    [sym_dollar] = STATE(828),
    [sym_slot] = STATE(828),
    [sym_namespace_get] = STATE(828),
    [sym_namespace_get_internal] = STATE(828),
    [sym_pipe] = STATE(828),
    [sym_unary] = STATE(828),
    [sym_binary] = STATE(828),
    [sym_na] = STATE(828),
    [sym__expression] = STATE(828),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(828),
    [sym_string] = STATE(828),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(889),
    [sym_next] = ACTIONS(889),
    [sym_true] = ACTIONS(889),
    [sym_false] = ACTIONS(889),
    [sym_null] = ACTIONS(889),
    [sym_inf] = ACTIONS(889),
    [sym_nan] = ACTIONS(889),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(887),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [116] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_function] = ACTIONS(893),
    [anon_sym_BSLASH] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(897),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_repeat] = ACTIONS(893),
    [anon_sym_for] = ACTIONS(893),
    [anon_sym_switch] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_LT_DASH] = ACTIONS(901),
    [anon_sym_COLON_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT_GT] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(893),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(893),
    [sym_next] = ACTIONS(893),
    [sym_true] = ACTIONS(893),
    [sym_false] = ACTIONS(893),
    [sym_null] = ACTIONS(893),
    [sym_inf] = ACTIONS(893),
    [sym_nan] = ACTIONS(893),
    [anon_sym_NA] = ACTIONS(893),
    [anon_sym_NA_character_] = ACTIONS(893),
    [anon_sym_NA_complex_] = ACTIONS(893),
    [anon_sym_NA_integer_] = ACTIONS(893),
    [anon_sym_NA_real_] = ACTIONS(893),
    [aux_sym_identifier_token1] = ACTIONS(893),
    [anon_sym_BQUOTE] = ACTIONS(891),
    [sym_integer] = ACTIONS(891),
    [sym_float] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [117] = {
    [sym_function_definition] = STATE(409),
    [sym_lambda_function] = STATE(409),
    [sym_if] = STATE(409),
    [sym_while] = STATE(409),
    [sym_repeat] = STATE(409),
    [sym_for] = STATE(409),
    [sym_switch] = STATE(409),
    [sym_call] = STATE(409),
    [sym__assignment] = STATE(409),
    [sym_left_assignment] = STATE(409),
    [sym_left_assignment2] = STATE(409),
    [sym_equals_assignment] = STATE(409),
    [sym_super_assignment] = STATE(409),
    [sym_super_right_assignment] = STATE(409),
    [sym_right_assignment] = STATE(409),
    [sym_brace_list] = STATE(409),
    [sym_paren_list] = STATE(409),
    [sym_subset] = STATE(409),
    [sym_subset2] = STATE(409),
    [sym_dollar] = STATE(409),
    [sym_slot] = STATE(409),
    [sym_namespace_get] = STATE(409),
    [sym_namespace_get_internal] = STATE(409),
    [sym_pipe] = STATE(409),
    [sym_unary] = STATE(409),
    [sym_binary] = STATE(409),
    [sym_na] = STATE(409),
    [sym__expression] = STATE(409),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(409),
    [sym_string] = STATE(409),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(949),
    [sym_next] = ACTIONS(949),
    [sym_true] = ACTIONS(949),
    [sym_false] = ACTIONS(949),
    [sym_null] = ACTIONS(949),
    [sym_inf] = ACTIONS(949),
    [sym_nan] = ACTIONS(949),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(947),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [118] = {
    [sym_function_definition] = STATE(913),
    [sym_lambda_function] = STATE(913),
    [sym_if] = STATE(913),
    [sym_while] = STATE(913),
    [sym_repeat] = STATE(913),
    [sym_for] = STATE(913),
    [sym_switch] = STATE(913),
    [sym_call] = STATE(913),
    [sym__assignment] = STATE(913),
    [sym_left_assignment] = STATE(913),
    [sym_left_assignment2] = STATE(913),
    [sym_equals_assignment] = STATE(913),
    [sym_super_assignment] = STATE(913),
    [sym_super_right_assignment] = STATE(913),
    [sym_right_assignment] = STATE(913),
    [sym_brace_list] = STATE(913),
    [sym_paren_list] = STATE(913),
    [sym_subset] = STATE(913),
    [sym_subset2] = STATE(913),
    [sym_dollar] = STATE(913),
    [sym_slot] = STATE(913),
    [sym_namespace_get] = STATE(913),
    [sym_namespace_get_internal] = STATE(913),
    [sym_pipe] = STATE(913),
    [sym_unary] = STATE(913),
    [sym_binary] = STATE(913),
    [sym_na] = STATE(913),
    [sym__expression] = STATE(913),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(913),
    [sym_string] = STATE(913),
    [anon_sym_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(953),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(953),
    [sym_next] = ACTIONS(953),
    [sym_true] = ACTIONS(953),
    [sym_false] = ACTIONS(953),
    [sym_null] = ACTIONS(953),
    [sym_inf] = ACTIONS(953),
    [sym_nan] = ACTIONS(953),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(951),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [119] = {
    [sym_function_definition] = STATE(904),
    [sym_lambda_function] = STATE(904),
    [sym_if] = STATE(904),
    [sym_while] = STATE(904),
    [sym_repeat] = STATE(904),
    [sym_for] = STATE(904),
    [sym_switch] = STATE(904),
    [sym_call] = STATE(904),
    [sym__assignment] = STATE(904),
    [sym_left_assignment] = STATE(904),
    [sym_left_assignment2] = STATE(904),
    [sym_equals_assignment] = STATE(904),
    [sym_super_assignment] = STATE(904),
    [sym_super_right_assignment] = STATE(904),
    [sym_right_assignment] = STATE(904),
    [sym_brace_list] = STATE(904),
    [sym_paren_list] = STATE(904),
    [sym_subset] = STATE(904),
    [sym_subset2] = STATE(904),
    [sym_dollar] = STATE(904),
    [sym_slot] = STATE(904),
    [sym_namespace_get] = STATE(904),
    [sym_namespace_get_internal] = STATE(904),
    [sym_pipe] = STATE(904),
    [sym_unary] = STATE(904),
    [sym_binary] = STATE(904),
    [sym_na] = STATE(904),
    [sym__expression] = STATE(904),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(904),
    [sym_string] = STATE(904),
    [anon_sym_SEMI] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(957),
    [sym_next] = ACTIONS(957),
    [sym_true] = ACTIONS(957),
    [sym_false] = ACTIONS(957),
    [sym_null] = ACTIONS(957),
    [sym_inf] = ACTIONS(957),
    [sym_nan] = ACTIONS(957),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(955),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [120] = {
    [sym_function_definition] = STATE(411),
    [sym_lambda_function] = STATE(411),
    [sym_if] = STATE(411),
    [sym_while] = STATE(411),
    [sym_repeat] = STATE(411),
    [sym_for] = STATE(411),
    [sym_switch] = STATE(411),
    [sym_call] = STATE(411),
    [sym__assignment] = STATE(411),
    [sym_left_assignment] = STATE(411),
    [sym_left_assignment2] = STATE(411),
    [sym_equals_assignment] = STATE(411),
    [sym_super_assignment] = STATE(411),
    [sym_super_right_assignment] = STATE(411),
    [sym_right_assignment] = STATE(411),
    [sym_brace_list] = STATE(411),
    [sym_paren_list] = STATE(411),
    [sym_subset] = STATE(411),
    [sym_subset2] = STATE(411),
    [sym_dollar] = STATE(411),
    [sym_slot] = STATE(411),
    [sym_namespace_get] = STATE(411),
    [sym_namespace_get_internal] = STATE(411),
    [sym_pipe] = STATE(411),
    [sym_unary] = STATE(411),
    [sym_binary] = STATE(411),
    [sym_na] = STATE(411),
    [sym__expression] = STATE(411),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(411),
    [sym_string] = STATE(411),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(961),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(961),
    [sym_next] = ACTIONS(961),
    [sym_true] = ACTIONS(961),
    [sym_false] = ACTIONS(961),
    [sym_null] = ACTIONS(961),
    [sym_inf] = ACTIONS(961),
    [sym_nan] = ACTIONS(961),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(959),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [121] = {
    [sym_function_definition] = STATE(916),
    [sym_lambda_function] = STATE(916),
    [sym_if] = STATE(916),
    [sym_while] = STATE(916),
    [sym_repeat] = STATE(916),
    [sym_for] = STATE(916),
    [sym_switch] = STATE(916),
    [sym_call] = STATE(916),
    [sym__assignment] = STATE(916),
    [sym_left_assignment] = STATE(916),
    [sym_left_assignment2] = STATE(916),
    [sym_equals_assignment] = STATE(916),
    [sym_super_assignment] = STATE(916),
    [sym_super_right_assignment] = STATE(916),
    [sym_right_assignment] = STATE(916),
    [sym_brace_list] = STATE(916),
    [sym_paren_list] = STATE(916),
    [sym_subset] = STATE(916),
    [sym_subset2] = STATE(916),
    [sym_dollar] = STATE(916),
    [sym_slot] = STATE(916),
    [sym_namespace_get] = STATE(916),
    [sym_namespace_get_internal] = STATE(916),
    [sym_pipe] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_binary] = STATE(916),
    [sym_na] = STATE(916),
    [sym__expression] = STATE(916),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(916),
    [sym_string] = STATE(916),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(965),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(965),
    [sym_next] = ACTIONS(965),
    [sym_true] = ACTIONS(965),
    [sym_false] = ACTIONS(965),
    [sym_null] = ACTIONS(965),
    [sym_inf] = ACTIONS(965),
    [sym_nan] = ACTIONS(965),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(963),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [122] = {
    [sym_function_definition] = STATE(903),
    [sym_lambda_function] = STATE(903),
    [sym_if] = STATE(903),
    [sym_while] = STATE(903),
    [sym_repeat] = STATE(903),
    [sym_for] = STATE(903),
    [sym_switch] = STATE(903),
    [sym_call] = STATE(903),
    [sym__assignment] = STATE(903),
    [sym_left_assignment] = STATE(903),
    [sym_left_assignment2] = STATE(903),
    [sym_equals_assignment] = STATE(903),
    [sym_super_assignment] = STATE(903),
    [sym_super_right_assignment] = STATE(903),
    [sym_right_assignment] = STATE(903),
    [sym_brace_list] = STATE(903),
    [sym_paren_list] = STATE(903),
    [sym_subset] = STATE(903),
    [sym_subset2] = STATE(903),
    [sym_dollar] = STATE(903),
    [sym_slot] = STATE(903),
    [sym_namespace_get] = STATE(903),
    [sym_namespace_get_internal] = STATE(903),
    [sym_pipe] = STATE(903),
    [sym_unary] = STATE(903),
    [sym_binary] = STATE(903),
    [sym_na] = STATE(903),
    [sym__expression] = STATE(903),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(903),
    [sym_string] = STATE(903),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(969),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(969),
    [sym_next] = ACTIONS(969),
    [sym_true] = ACTIONS(969),
    [sym_false] = ACTIONS(969),
    [sym_null] = ACTIONS(969),
    [sym_inf] = ACTIONS(969),
    [sym_nan] = ACTIONS(969),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(967),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [123] = {
    [sym_function_definition] = STATE(910),
    [sym_lambda_function] = STATE(910),
    [sym_if] = STATE(910),
    [sym_while] = STATE(910),
    [sym_repeat] = STATE(910),
    [sym_for] = STATE(910),
    [sym_switch] = STATE(910),
    [sym_call] = STATE(910),
    [sym__assignment] = STATE(910),
    [sym_left_assignment] = STATE(910),
    [sym_left_assignment2] = STATE(910),
    [sym_equals_assignment] = STATE(910),
    [sym_super_assignment] = STATE(910),
    [sym_super_right_assignment] = STATE(910),
    [sym_right_assignment] = STATE(910),
    [sym_brace_list] = STATE(910),
    [sym_paren_list] = STATE(910),
    [sym_subset] = STATE(910),
    [sym_subset2] = STATE(910),
    [sym_dollar] = STATE(910),
    [sym_slot] = STATE(910),
    [sym_namespace_get] = STATE(910),
    [sym_namespace_get_internal] = STATE(910),
    [sym_pipe] = STATE(910),
    [sym_unary] = STATE(910),
    [sym_binary] = STATE(910),
    [sym_na] = STATE(910),
    [sym__expression] = STATE(910),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(910),
    [sym_string] = STATE(910),
    [anon_sym_SEMI] = ACTIONS(971),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(973),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(973),
    [sym_next] = ACTIONS(973),
    [sym_true] = ACTIONS(973),
    [sym_false] = ACTIONS(973),
    [sym_null] = ACTIONS(973),
    [sym_inf] = ACTIONS(973),
    [sym_nan] = ACTIONS(973),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(971),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [124] = {
    [sym_function_definition] = STATE(887),
    [sym_lambda_function] = STATE(887),
    [sym_if] = STATE(887),
    [sym_while] = STATE(887),
    [sym_repeat] = STATE(887),
    [sym_for] = STATE(887),
    [sym_switch] = STATE(887),
    [sym_call] = STATE(887),
    [sym__assignment] = STATE(887),
    [sym_left_assignment] = STATE(887),
    [sym_left_assignment2] = STATE(887),
    [sym_equals_assignment] = STATE(887),
    [sym_super_assignment] = STATE(887),
    [sym_super_right_assignment] = STATE(887),
    [sym_right_assignment] = STATE(887),
    [sym_brace_list] = STATE(887),
    [sym_paren_list] = STATE(887),
    [sym_subset] = STATE(887),
    [sym_subset2] = STATE(887),
    [sym_dollar] = STATE(887),
    [sym_slot] = STATE(887),
    [sym_namespace_get] = STATE(887),
    [sym_namespace_get_internal] = STATE(887),
    [sym_pipe] = STATE(887),
    [sym_unary] = STATE(887),
    [sym_binary] = STATE(887),
    [sym_na] = STATE(887),
    [sym__expression] = STATE(887),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(887),
    [sym_string] = STATE(887),
    [anon_sym_SEMI] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(977),
    [sym_next] = ACTIONS(977),
    [sym_true] = ACTIONS(977),
    [sym_false] = ACTIONS(977),
    [sym_null] = ACTIONS(977),
    [sym_inf] = ACTIONS(977),
    [sym_nan] = ACTIONS(977),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(975),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [125] = {
    [sym_function_definition] = STATE(886),
    [sym_lambda_function] = STATE(886),
    [sym_if] = STATE(886),
    [sym_while] = STATE(886),
    [sym_repeat] = STATE(886),
    [sym_for] = STATE(886),
    [sym_switch] = STATE(886),
    [sym_call] = STATE(886),
    [sym__assignment] = STATE(886),
    [sym_left_assignment] = STATE(886),
    [sym_left_assignment2] = STATE(886),
    [sym_equals_assignment] = STATE(886),
    [sym_super_assignment] = STATE(886),
    [sym_super_right_assignment] = STATE(886),
    [sym_right_assignment] = STATE(886),
    [sym_brace_list] = STATE(886),
    [sym_paren_list] = STATE(886),
    [sym_subset] = STATE(886),
    [sym_subset2] = STATE(886),
    [sym_dollar] = STATE(886),
    [sym_slot] = STATE(886),
    [sym_namespace_get] = STATE(886),
    [sym_namespace_get_internal] = STATE(886),
    [sym_pipe] = STATE(886),
    [sym_unary] = STATE(886),
    [sym_binary] = STATE(886),
    [sym_na] = STATE(886),
    [sym__expression] = STATE(886),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(886),
    [sym_string] = STATE(886),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(981),
    [sym_next] = ACTIONS(981),
    [sym_true] = ACTIONS(981),
    [sym_false] = ACTIONS(981),
    [sym_null] = ACTIONS(981),
    [sym_inf] = ACTIONS(981),
    [sym_nan] = ACTIONS(981),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(979),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [126] = {
    [sym_function_definition] = STATE(837),
    [sym_lambda_function] = STATE(837),
    [sym_if] = STATE(837),
    [sym_while] = STATE(837),
    [sym_repeat] = STATE(837),
    [sym_for] = STATE(837),
    [sym_switch] = STATE(837),
    [sym_call] = STATE(837),
    [sym__assignment] = STATE(837),
    [sym_left_assignment] = STATE(837),
    [sym_left_assignment2] = STATE(837),
    [sym_equals_assignment] = STATE(837),
    [sym_super_assignment] = STATE(837),
    [sym_super_right_assignment] = STATE(837),
    [sym_right_assignment] = STATE(837),
    [sym_brace_list] = STATE(837),
    [sym_paren_list] = STATE(837),
    [sym_subset] = STATE(837),
    [sym_subset2] = STATE(837),
    [sym_dollar] = STATE(837),
    [sym_slot] = STATE(837),
    [sym_namespace_get] = STATE(837),
    [sym_namespace_get_internal] = STATE(837),
    [sym_pipe] = STATE(837),
    [sym_unary] = STATE(837),
    [sym_binary] = STATE(837),
    [sym_na] = STATE(837),
    [sym__expression] = STATE(837),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(837),
    [sym_string] = STATE(837),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(985),
    [sym_next] = ACTIONS(985),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_null] = ACTIONS(985),
    [sym_inf] = ACTIONS(985),
    [sym_nan] = ACTIONS(985),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [127] = {
    [sym_function_definition] = STATE(508),
    [sym_lambda_function] = STATE(508),
    [sym_if] = STATE(508),
    [sym_while] = STATE(508),
    [sym_repeat] = STATE(508),
    [sym_for] = STATE(508),
    [sym_switch] = STATE(508),
    [sym_call] = STATE(508),
    [sym__assignment] = STATE(508),
    [sym_left_assignment] = STATE(508),
    [sym_left_assignment2] = STATE(508),
    [sym_equals_assignment] = STATE(508),
    [sym_super_assignment] = STATE(508),
    [sym_super_right_assignment] = STATE(508),
    [sym_right_assignment] = STATE(508),
    [sym_brace_list] = STATE(508),
    [sym_paren_list] = STATE(508),
    [sym_subset] = STATE(508),
    [sym_subset2] = STATE(508),
    [sym_dollar] = STATE(508),
    [sym_slot] = STATE(508),
    [sym_namespace_get] = STATE(508),
    [sym_namespace_get_internal] = STATE(508),
    [sym_pipe] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_na] = STATE(508),
    [sym__expression] = STATE(508),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(508),
    [sym_string] = STATE(508),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1007),
    [sym_next] = ACTIONS(1007),
    [sym_true] = ACTIONS(1007),
    [sym_false] = ACTIONS(1007),
    [sym_null] = ACTIONS(1007),
    [sym_inf] = ACTIONS(1007),
    [sym_nan] = ACTIONS(1007),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(987),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [128] = {
    [sym_function_definition] = STATE(647),
    [sym_lambda_function] = STATE(647),
    [sym_if] = STATE(647),
    [sym_while] = STATE(647),
    [sym_repeat] = STATE(647),
    [sym_for] = STATE(647),
    [sym_switch] = STATE(647),
    [sym_call] = STATE(647),
    [sym__assignment] = STATE(647),
    [sym_left_assignment] = STATE(647),
    [sym_left_assignment2] = STATE(647),
    [sym_equals_assignment] = STATE(647),
    [sym_super_assignment] = STATE(647),
    [sym_super_right_assignment] = STATE(647),
    [sym_right_assignment] = STATE(647),
    [sym_brace_list] = STATE(647),
    [sym_paren_list] = STATE(647),
    [sym_subset] = STATE(647),
    [sym_subset2] = STATE(647),
    [sym_dollar] = STATE(647),
    [sym_slot] = STATE(647),
    [sym_namespace_get] = STATE(647),
    [sym_namespace_get_internal] = STATE(647),
    [sym_pipe] = STATE(647),
    [sym_unary] = STATE(647),
    [sym_binary] = STATE(647),
    [sym_na] = STATE(647),
    [sym__expression] = STATE(647),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(647),
    [sym_string] = STATE(647),
    [anon_sym_SEMI] = ACTIONS(1027),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1029),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1029),
    [sym_next] = ACTIONS(1029),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [sym_null] = ACTIONS(1029),
    [sym_inf] = ACTIONS(1029),
    [sym_nan] = ACTIONS(1029),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1027),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [129] = {
    [sym_function_definition] = STATE(905),
    [sym_lambda_function] = STATE(905),
    [sym_if] = STATE(905),
    [sym_while] = STATE(905),
    [sym_repeat] = STATE(905),
    [sym_for] = STATE(905),
    [sym_switch] = STATE(905),
    [sym_call] = STATE(905),
    [sym__assignment] = STATE(905),
    [sym_left_assignment] = STATE(905),
    [sym_left_assignment2] = STATE(905),
    [sym_equals_assignment] = STATE(905),
    [sym_super_assignment] = STATE(905),
    [sym_super_right_assignment] = STATE(905),
    [sym_right_assignment] = STATE(905),
    [sym_brace_list] = STATE(905),
    [sym_paren_list] = STATE(905),
    [sym_subset] = STATE(905),
    [sym_subset2] = STATE(905),
    [sym_dollar] = STATE(905),
    [sym_slot] = STATE(905),
    [sym_namespace_get] = STATE(905),
    [sym_namespace_get_internal] = STATE(905),
    [sym_pipe] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_na] = STATE(905),
    [sym__expression] = STATE(905),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(905),
    [sym_string] = STATE(905),
    [anon_sym_SEMI] = ACTIONS(1031),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1033),
    [sym_next] = ACTIONS(1033),
    [sym_true] = ACTIONS(1033),
    [sym_false] = ACTIONS(1033),
    [sym_null] = ACTIONS(1033),
    [sym_inf] = ACTIONS(1033),
    [sym_nan] = ACTIONS(1033),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1031),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [130] = {
    [sym_function_definition] = STATE(884),
    [sym_lambda_function] = STATE(884),
    [sym_if] = STATE(884),
    [sym_while] = STATE(884),
    [sym_repeat] = STATE(884),
    [sym_for] = STATE(884),
    [sym_switch] = STATE(884),
    [sym_call] = STATE(884),
    [sym__assignment] = STATE(884),
    [sym_left_assignment] = STATE(884),
    [sym_left_assignment2] = STATE(884),
    [sym_equals_assignment] = STATE(884),
    [sym_super_assignment] = STATE(884),
    [sym_super_right_assignment] = STATE(884),
    [sym_right_assignment] = STATE(884),
    [sym_brace_list] = STATE(884),
    [sym_paren_list] = STATE(884),
    [sym_subset] = STATE(884),
    [sym_subset2] = STATE(884),
    [sym_dollar] = STATE(884),
    [sym_slot] = STATE(884),
    [sym_namespace_get] = STATE(884),
    [sym_namespace_get_internal] = STATE(884),
    [sym_pipe] = STATE(884),
    [sym_unary] = STATE(884),
    [sym_binary] = STATE(884),
    [sym_na] = STATE(884),
    [sym__expression] = STATE(884),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(884),
    [sym_string] = STATE(884),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1037),
    [sym_next] = ACTIONS(1037),
    [sym_true] = ACTIONS(1037),
    [sym_false] = ACTIONS(1037),
    [sym_null] = ACTIONS(1037),
    [sym_inf] = ACTIONS(1037),
    [sym_nan] = ACTIONS(1037),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1035),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [131] = {
    [sym_function_definition] = STATE(883),
    [sym_lambda_function] = STATE(883),
    [sym_if] = STATE(883),
    [sym_while] = STATE(883),
    [sym_repeat] = STATE(883),
    [sym_for] = STATE(883),
    [sym_switch] = STATE(883),
    [sym_call] = STATE(883),
    [sym__assignment] = STATE(883),
    [sym_left_assignment] = STATE(883),
    [sym_left_assignment2] = STATE(883),
    [sym_equals_assignment] = STATE(883),
    [sym_super_assignment] = STATE(883),
    [sym_super_right_assignment] = STATE(883),
    [sym_right_assignment] = STATE(883),
    [sym_brace_list] = STATE(883),
    [sym_paren_list] = STATE(883),
    [sym_subset] = STATE(883),
    [sym_subset2] = STATE(883),
    [sym_dollar] = STATE(883),
    [sym_slot] = STATE(883),
    [sym_namespace_get] = STATE(883),
    [sym_namespace_get_internal] = STATE(883),
    [sym_pipe] = STATE(883),
    [sym_unary] = STATE(883),
    [sym_binary] = STATE(883),
    [sym_na] = STATE(883),
    [sym__expression] = STATE(883),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(883),
    [sym_string] = STATE(883),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1041),
    [sym_next] = ACTIONS(1041),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_null] = ACTIONS(1041),
    [sym_inf] = ACTIONS(1041),
    [sym_nan] = ACTIONS(1041),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1039),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [132] = {
    [sym_function_definition] = STATE(911),
    [sym_lambda_function] = STATE(911),
    [sym_if] = STATE(911),
    [sym_while] = STATE(911),
    [sym_repeat] = STATE(911),
    [sym_for] = STATE(911),
    [sym_switch] = STATE(911),
    [sym_call] = STATE(911),
    [sym__assignment] = STATE(911),
    [sym_left_assignment] = STATE(911),
    [sym_left_assignment2] = STATE(911),
    [sym_equals_assignment] = STATE(911),
    [sym_super_assignment] = STATE(911),
    [sym_super_right_assignment] = STATE(911),
    [sym_right_assignment] = STATE(911),
    [sym_brace_list] = STATE(911),
    [sym_paren_list] = STATE(911),
    [sym_subset] = STATE(911),
    [sym_subset2] = STATE(911),
    [sym_dollar] = STATE(911),
    [sym_slot] = STATE(911),
    [sym_namespace_get] = STATE(911),
    [sym_namespace_get_internal] = STATE(911),
    [sym_pipe] = STATE(911),
    [sym_unary] = STATE(911),
    [sym_binary] = STATE(911),
    [sym_na] = STATE(911),
    [sym__expression] = STATE(911),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(911),
    [sym_string] = STATE(911),
    [anon_sym_SEMI] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1045),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1045),
    [sym_next] = ACTIONS(1045),
    [sym_true] = ACTIONS(1045),
    [sym_false] = ACTIONS(1045),
    [sym_null] = ACTIONS(1045),
    [sym_inf] = ACTIONS(1045),
    [sym_nan] = ACTIONS(1045),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1043),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [133] = {
    [sym_function_definition] = STATE(892),
    [sym_lambda_function] = STATE(892),
    [sym_if] = STATE(892),
    [sym_while] = STATE(892),
    [sym_repeat] = STATE(892),
    [sym_for] = STATE(892),
    [sym_switch] = STATE(892),
    [sym_call] = STATE(892),
    [sym__assignment] = STATE(892),
    [sym_left_assignment] = STATE(892),
    [sym_left_assignment2] = STATE(892),
    [sym_equals_assignment] = STATE(892),
    [sym_super_assignment] = STATE(892),
    [sym_super_right_assignment] = STATE(892),
    [sym_right_assignment] = STATE(892),
    [sym_brace_list] = STATE(892),
    [sym_paren_list] = STATE(892),
    [sym_subset] = STATE(892),
    [sym_subset2] = STATE(892),
    [sym_dollar] = STATE(892),
    [sym_slot] = STATE(892),
    [sym_namespace_get] = STATE(892),
    [sym_namespace_get_internal] = STATE(892),
    [sym_pipe] = STATE(892),
    [sym_unary] = STATE(892),
    [sym_binary] = STATE(892),
    [sym_na] = STATE(892),
    [sym__expression] = STATE(892),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(892),
    [sym_string] = STATE(892),
    [anon_sym_SEMI] = ACTIONS(1047),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1049),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1049),
    [sym_next] = ACTIONS(1049),
    [sym_true] = ACTIONS(1049),
    [sym_false] = ACTIONS(1049),
    [sym_null] = ACTIONS(1049),
    [sym_inf] = ACTIONS(1049),
    [sym_nan] = ACTIONS(1049),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1047),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [134] = {
    [sym_function_definition] = STATE(880),
    [sym_lambda_function] = STATE(880),
    [sym_if] = STATE(880),
    [sym_while] = STATE(880),
    [sym_repeat] = STATE(880),
    [sym_for] = STATE(880),
    [sym_switch] = STATE(880),
    [sym_call] = STATE(880),
    [sym__assignment] = STATE(880),
    [sym_left_assignment] = STATE(880),
    [sym_left_assignment2] = STATE(880),
    [sym_equals_assignment] = STATE(880),
    [sym_super_assignment] = STATE(880),
    [sym_super_right_assignment] = STATE(880),
    [sym_right_assignment] = STATE(880),
    [sym_brace_list] = STATE(880),
    [sym_paren_list] = STATE(880),
    [sym_subset] = STATE(880),
    [sym_subset2] = STATE(880),
    [sym_dollar] = STATE(880),
    [sym_slot] = STATE(880),
    [sym_namespace_get] = STATE(880),
    [sym_namespace_get_internal] = STATE(880),
    [sym_pipe] = STATE(880),
    [sym_unary] = STATE(880),
    [sym_binary] = STATE(880),
    [sym_na] = STATE(880),
    [sym__expression] = STATE(880),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(880),
    [sym_string] = STATE(880),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1053),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1053),
    [sym_next] = ACTIONS(1053),
    [sym_true] = ACTIONS(1053),
    [sym_false] = ACTIONS(1053),
    [sym_null] = ACTIONS(1053),
    [sym_inf] = ACTIONS(1053),
    [sym_nan] = ACTIONS(1053),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1051),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [135] = {
    [sym_function_definition] = STATE(901),
    [sym_lambda_function] = STATE(901),
    [sym_if] = STATE(901),
    [sym_while] = STATE(901),
    [sym_repeat] = STATE(901),
    [sym_for] = STATE(901),
    [sym_switch] = STATE(901),
    [sym_call] = STATE(901),
    [sym__assignment] = STATE(901),
    [sym_left_assignment] = STATE(901),
    [sym_left_assignment2] = STATE(901),
    [sym_equals_assignment] = STATE(901),
    [sym_super_assignment] = STATE(901),
    [sym_super_right_assignment] = STATE(901),
    [sym_right_assignment] = STATE(901),
    [sym_brace_list] = STATE(901),
    [sym_paren_list] = STATE(901),
    [sym_subset] = STATE(901),
    [sym_subset2] = STATE(901),
    [sym_dollar] = STATE(901),
    [sym_slot] = STATE(901),
    [sym_namespace_get] = STATE(901),
    [sym_namespace_get_internal] = STATE(901),
    [sym_pipe] = STATE(901),
    [sym_unary] = STATE(901),
    [sym_binary] = STATE(901),
    [sym_na] = STATE(901),
    [sym__expression] = STATE(901),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(901),
    [sym_string] = STATE(901),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1057),
    [sym_next] = ACTIONS(1057),
    [sym_true] = ACTIONS(1057),
    [sym_false] = ACTIONS(1057),
    [sym_null] = ACTIONS(1057),
    [sym_inf] = ACTIONS(1057),
    [sym_nan] = ACTIONS(1057),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1055),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [136] = {
    [sym_function_definition] = STATE(908),
    [sym_lambda_function] = STATE(908),
    [sym_if] = STATE(908),
    [sym_while] = STATE(908),
    [sym_repeat] = STATE(908),
    [sym_for] = STATE(908),
    [sym_switch] = STATE(908),
    [sym_call] = STATE(908),
    [sym__assignment] = STATE(908),
    [sym_left_assignment] = STATE(908),
    [sym_left_assignment2] = STATE(908),
    [sym_equals_assignment] = STATE(908),
    [sym_super_assignment] = STATE(908),
    [sym_super_right_assignment] = STATE(908),
    [sym_right_assignment] = STATE(908),
    [sym_brace_list] = STATE(908),
    [sym_paren_list] = STATE(908),
    [sym_subset] = STATE(908),
    [sym_subset2] = STATE(908),
    [sym_dollar] = STATE(908),
    [sym_slot] = STATE(908),
    [sym_namespace_get] = STATE(908),
    [sym_namespace_get_internal] = STATE(908),
    [sym_pipe] = STATE(908),
    [sym_unary] = STATE(908),
    [sym_binary] = STATE(908),
    [sym_na] = STATE(908),
    [sym__expression] = STATE(908),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(908),
    [sym_string] = STATE(908),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1061),
    [sym_next] = ACTIONS(1061),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_inf] = ACTIONS(1061),
    [sym_nan] = ACTIONS(1061),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1059),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [137] = {
    [sym_function_definition] = STATE(588),
    [sym_lambda_function] = STATE(588),
    [sym_if] = STATE(588),
    [sym_while] = STATE(588),
    [sym_repeat] = STATE(588),
    [sym_for] = STATE(588),
    [sym_switch] = STATE(588),
    [sym_call] = STATE(588),
    [sym__assignment] = STATE(588),
    [sym_left_assignment] = STATE(588),
    [sym_left_assignment2] = STATE(588),
    [sym_equals_assignment] = STATE(588),
    [sym_super_assignment] = STATE(588),
    [sym_super_right_assignment] = STATE(588),
    [sym_right_assignment] = STATE(588),
    [sym_brace_list] = STATE(588),
    [sym_paren_list] = STATE(588),
    [sym_subset] = STATE(588),
    [sym_subset2] = STATE(588),
    [sym_dollar] = STATE(588),
    [sym_slot] = STATE(588),
    [sym_namespace_get] = STATE(588),
    [sym_namespace_get_internal] = STATE(588),
    [sym_pipe] = STATE(588),
    [sym_unary] = STATE(588),
    [sym_binary] = STATE(588),
    [sym_na] = STATE(588),
    [sym__expression] = STATE(588),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(588),
    [sym_string] = STATE(588),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1065),
    [sym_next] = ACTIONS(1065),
    [sym_true] = ACTIONS(1065),
    [sym_false] = ACTIONS(1065),
    [sym_null] = ACTIONS(1065),
    [sym_inf] = ACTIONS(1065),
    [sym_nan] = ACTIONS(1065),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1063),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [138] = {
    [sym_function_definition] = STATE(915),
    [sym_lambda_function] = STATE(915),
    [sym_if] = STATE(915),
    [sym_while] = STATE(915),
    [sym_repeat] = STATE(915),
    [sym_for] = STATE(915),
    [sym_switch] = STATE(915),
    [sym_call] = STATE(915),
    [sym__assignment] = STATE(915),
    [sym_left_assignment] = STATE(915),
    [sym_left_assignment2] = STATE(915),
    [sym_equals_assignment] = STATE(915),
    [sym_super_assignment] = STATE(915),
    [sym_super_right_assignment] = STATE(915),
    [sym_right_assignment] = STATE(915),
    [sym_brace_list] = STATE(915),
    [sym_paren_list] = STATE(915),
    [sym_subset] = STATE(915),
    [sym_subset2] = STATE(915),
    [sym_dollar] = STATE(915),
    [sym_slot] = STATE(915),
    [sym_namespace_get] = STATE(915),
    [sym_namespace_get_internal] = STATE(915),
    [sym_pipe] = STATE(915),
    [sym_unary] = STATE(915),
    [sym_binary] = STATE(915),
    [sym_na] = STATE(915),
    [sym__expression] = STATE(915),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(915),
    [sym_string] = STATE(915),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1069),
    [sym_next] = ACTIONS(1069),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_null] = ACTIONS(1069),
    [sym_inf] = ACTIONS(1069),
    [sym_nan] = ACTIONS(1069),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1067),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [139] = {
    [sym_function_definition] = STATE(879),
    [sym_lambda_function] = STATE(879),
    [sym_if] = STATE(879),
    [sym_while] = STATE(879),
    [sym_repeat] = STATE(879),
    [sym_for] = STATE(879),
    [sym_switch] = STATE(879),
    [sym_call] = STATE(879),
    [sym__assignment] = STATE(879),
    [sym_left_assignment] = STATE(879),
    [sym_left_assignment2] = STATE(879),
    [sym_equals_assignment] = STATE(879),
    [sym_super_assignment] = STATE(879),
    [sym_super_right_assignment] = STATE(879),
    [sym_right_assignment] = STATE(879),
    [sym_brace_list] = STATE(879),
    [sym_paren_list] = STATE(879),
    [sym_subset] = STATE(879),
    [sym_subset2] = STATE(879),
    [sym_dollar] = STATE(879),
    [sym_slot] = STATE(879),
    [sym_namespace_get] = STATE(879),
    [sym_namespace_get_internal] = STATE(879),
    [sym_pipe] = STATE(879),
    [sym_unary] = STATE(879),
    [sym_binary] = STATE(879),
    [sym_na] = STATE(879),
    [sym__expression] = STATE(879),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(879),
    [sym_string] = STATE(879),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1073),
    [sym_next] = ACTIONS(1073),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_null] = ACTIONS(1073),
    [sym_inf] = ACTIONS(1073),
    [sym_nan] = ACTIONS(1073),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1071),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [140] = {
    [sym_function_definition] = STATE(909),
    [sym_lambda_function] = STATE(909),
    [sym_if] = STATE(909),
    [sym_while] = STATE(909),
    [sym_repeat] = STATE(909),
    [sym_for] = STATE(909),
    [sym_switch] = STATE(909),
    [sym_call] = STATE(909),
    [sym__assignment] = STATE(909),
    [sym_left_assignment] = STATE(909),
    [sym_left_assignment2] = STATE(909),
    [sym_equals_assignment] = STATE(909),
    [sym_super_assignment] = STATE(909),
    [sym_super_right_assignment] = STATE(909),
    [sym_right_assignment] = STATE(909),
    [sym_brace_list] = STATE(909),
    [sym_paren_list] = STATE(909),
    [sym_subset] = STATE(909),
    [sym_subset2] = STATE(909),
    [sym_dollar] = STATE(909),
    [sym_slot] = STATE(909),
    [sym_namespace_get] = STATE(909),
    [sym_namespace_get_internal] = STATE(909),
    [sym_pipe] = STATE(909),
    [sym_unary] = STATE(909),
    [sym_binary] = STATE(909),
    [sym_na] = STATE(909),
    [sym__expression] = STATE(909),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(909),
    [sym_string] = STATE(909),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1077),
    [sym_next] = ACTIONS(1077),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_null] = ACTIONS(1077),
    [sym_inf] = ACTIONS(1077),
    [sym_nan] = ACTIONS(1077),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1075),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [141] = {
    [sym_function_definition] = STATE(917),
    [sym_lambda_function] = STATE(917),
    [sym_if] = STATE(917),
    [sym_while] = STATE(917),
    [sym_repeat] = STATE(917),
    [sym_for] = STATE(917),
    [sym_switch] = STATE(917),
    [sym_call] = STATE(917),
    [sym__assignment] = STATE(917),
    [sym_left_assignment] = STATE(917),
    [sym_left_assignment2] = STATE(917),
    [sym_equals_assignment] = STATE(917),
    [sym_super_assignment] = STATE(917),
    [sym_super_right_assignment] = STATE(917),
    [sym_right_assignment] = STATE(917),
    [sym_brace_list] = STATE(917),
    [sym_paren_list] = STATE(917),
    [sym_subset] = STATE(917),
    [sym_subset2] = STATE(917),
    [sym_dollar] = STATE(917),
    [sym_slot] = STATE(917),
    [sym_namespace_get] = STATE(917),
    [sym_namespace_get_internal] = STATE(917),
    [sym_pipe] = STATE(917),
    [sym_unary] = STATE(917),
    [sym_binary] = STATE(917),
    [sym_na] = STATE(917),
    [sym__expression] = STATE(917),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(917),
    [sym_string] = STATE(917),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1081),
    [sym_next] = ACTIONS(1081),
    [sym_true] = ACTIONS(1081),
    [sym_false] = ACTIONS(1081),
    [sym_null] = ACTIONS(1081),
    [sym_inf] = ACTIONS(1081),
    [sym_nan] = ACTIONS(1081),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1079),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [142] = {
    [sym_function_definition] = STATE(412),
    [sym_lambda_function] = STATE(412),
    [sym_if] = STATE(412),
    [sym_while] = STATE(412),
    [sym_repeat] = STATE(412),
    [sym_for] = STATE(412),
    [sym_switch] = STATE(412),
    [sym_call] = STATE(412),
    [sym__assignment] = STATE(412),
    [sym_left_assignment] = STATE(412),
    [sym_left_assignment2] = STATE(412),
    [sym_equals_assignment] = STATE(412),
    [sym_super_assignment] = STATE(412),
    [sym_super_right_assignment] = STATE(412),
    [sym_right_assignment] = STATE(412),
    [sym_brace_list] = STATE(412),
    [sym_paren_list] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_subset2] = STATE(412),
    [sym_dollar] = STATE(412),
    [sym_slot] = STATE(412),
    [sym_namespace_get] = STATE(412),
    [sym_namespace_get_internal] = STATE(412),
    [sym_pipe] = STATE(412),
    [sym_unary] = STATE(412),
    [sym_binary] = STATE(412),
    [sym_na] = STATE(412),
    [sym__expression] = STATE(412),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(412),
    [sym_string] = STATE(412),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1085),
    [sym_next] = ACTIONS(1085),
    [sym_true] = ACTIONS(1085),
    [sym_false] = ACTIONS(1085),
    [sym_null] = ACTIONS(1085),
    [sym_inf] = ACTIONS(1085),
    [sym_nan] = ACTIONS(1085),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1083),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [143] = {
    [sym_function_definition] = STATE(519),
    [sym_lambda_function] = STATE(519),
    [sym_if] = STATE(519),
    [sym_while] = STATE(519),
    [sym_repeat] = STATE(519),
    [sym_for] = STATE(519),
    [sym_switch] = STATE(519),
    [sym_call] = STATE(519),
    [sym__assignment] = STATE(519),
    [sym_left_assignment] = STATE(519),
    [sym_left_assignment2] = STATE(519),
    [sym_equals_assignment] = STATE(519),
    [sym_super_assignment] = STATE(519),
    [sym_super_right_assignment] = STATE(519),
    [sym_right_assignment] = STATE(519),
    [sym_brace_list] = STATE(519),
    [sym_paren_list] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_subset2] = STATE(519),
    [sym_dollar] = STATE(519),
    [sym_slot] = STATE(519),
    [sym_namespace_get] = STATE(519),
    [sym_namespace_get_internal] = STATE(519),
    [sym_pipe] = STATE(519),
    [sym_unary] = STATE(519),
    [sym_binary] = STATE(519),
    [sym_na] = STATE(519),
    [sym__expression] = STATE(519),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(519),
    [sym_string] = STATE(519),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1107),
    [sym_next] = ACTIONS(1107),
    [sym_true] = ACTIONS(1107),
    [sym_false] = ACTIONS(1107),
    [sym_null] = ACTIONS(1107),
    [sym_inf] = ACTIONS(1107),
    [sym_nan] = ACTIONS(1107),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1087),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [144] = {
    [sym_function_definition] = STATE(891),
    [sym_lambda_function] = STATE(891),
    [sym_if] = STATE(891),
    [sym_while] = STATE(891),
    [sym_repeat] = STATE(891),
    [sym_for] = STATE(891),
    [sym_switch] = STATE(891),
    [sym_call] = STATE(891),
    [sym__assignment] = STATE(891),
    [sym_left_assignment] = STATE(891),
    [sym_left_assignment2] = STATE(891),
    [sym_equals_assignment] = STATE(891),
    [sym_super_assignment] = STATE(891),
    [sym_super_right_assignment] = STATE(891),
    [sym_right_assignment] = STATE(891),
    [sym_brace_list] = STATE(891),
    [sym_paren_list] = STATE(891),
    [sym_subset] = STATE(891),
    [sym_subset2] = STATE(891),
    [sym_dollar] = STATE(891),
    [sym_slot] = STATE(891),
    [sym_namespace_get] = STATE(891),
    [sym_namespace_get_internal] = STATE(891),
    [sym_pipe] = STATE(891),
    [sym_unary] = STATE(891),
    [sym_binary] = STATE(891),
    [sym_na] = STATE(891),
    [sym__expression] = STATE(891),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(891),
    [sym_string] = STATE(891),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1129),
    [sym_next] = ACTIONS(1129),
    [sym_true] = ACTIONS(1129),
    [sym_false] = ACTIONS(1129),
    [sym_null] = ACTIONS(1129),
    [sym_inf] = ACTIONS(1129),
    [sym_nan] = ACTIONS(1129),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1127),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [145] = {
    [sym_function_definition] = STATE(885),
    [sym_lambda_function] = STATE(885),
    [sym_if] = STATE(885),
    [sym_while] = STATE(885),
    [sym_repeat] = STATE(885),
    [sym_for] = STATE(885),
    [sym_switch] = STATE(885),
    [sym_call] = STATE(885),
    [sym__assignment] = STATE(885),
    [sym_left_assignment] = STATE(885),
    [sym_left_assignment2] = STATE(885),
    [sym_equals_assignment] = STATE(885),
    [sym_super_assignment] = STATE(885),
    [sym_super_right_assignment] = STATE(885),
    [sym_right_assignment] = STATE(885),
    [sym_brace_list] = STATE(885),
    [sym_paren_list] = STATE(885),
    [sym_subset] = STATE(885),
    [sym_subset2] = STATE(885),
    [sym_dollar] = STATE(885),
    [sym_slot] = STATE(885),
    [sym_namespace_get] = STATE(885),
    [sym_namespace_get_internal] = STATE(885),
    [sym_pipe] = STATE(885),
    [sym_unary] = STATE(885),
    [sym_binary] = STATE(885),
    [sym_na] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(885),
    [sym_string] = STATE(885),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1133),
    [sym_next] = ACTIONS(1133),
    [sym_true] = ACTIONS(1133),
    [sym_false] = ACTIONS(1133),
    [sym_null] = ACTIONS(1133),
    [sym_inf] = ACTIONS(1133),
    [sym_nan] = ACTIONS(1133),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1131),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [146] = {
    [sym_function_definition] = STATE(818),
    [sym_lambda_function] = STATE(818),
    [sym_if] = STATE(818),
    [sym_while] = STATE(818),
    [sym_repeat] = STATE(818),
    [sym_for] = STATE(818),
    [sym_switch] = STATE(818),
    [sym_call] = STATE(818),
    [sym__assignment] = STATE(818),
    [sym_left_assignment] = STATE(818),
    [sym_left_assignment2] = STATE(818),
    [sym_equals_assignment] = STATE(818),
    [sym_super_assignment] = STATE(818),
    [sym_super_right_assignment] = STATE(818),
    [sym_right_assignment] = STATE(818),
    [sym_brace_list] = STATE(818),
    [sym_paren_list] = STATE(818),
    [sym_subset] = STATE(818),
    [sym_subset2] = STATE(818),
    [sym_dollar] = STATE(818),
    [sym_slot] = STATE(818),
    [sym_namespace_get] = STATE(818),
    [sym_namespace_get_internal] = STATE(818),
    [sym_pipe] = STATE(818),
    [sym_unary] = STATE(818),
    [sym_binary] = STATE(818),
    [sym_na] = STATE(818),
    [sym__expression] = STATE(818),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(818),
    [sym_string] = STATE(818),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1137),
    [sym_next] = ACTIONS(1137),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_inf] = ACTIONS(1137),
    [sym_nan] = ACTIONS(1137),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1135),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [147] = {
    [sym_function_definition] = STATE(591),
    [sym_lambda_function] = STATE(591),
    [sym_if] = STATE(591),
    [sym_while] = STATE(591),
    [sym_repeat] = STATE(591),
    [sym_for] = STATE(591),
    [sym_switch] = STATE(591),
    [sym_call] = STATE(591),
    [sym__assignment] = STATE(591),
    [sym_left_assignment] = STATE(591),
    [sym_left_assignment2] = STATE(591),
    [sym_equals_assignment] = STATE(591),
    [sym_super_assignment] = STATE(591),
    [sym_super_right_assignment] = STATE(591),
    [sym_right_assignment] = STATE(591),
    [sym_brace_list] = STATE(591),
    [sym_paren_list] = STATE(591),
    [sym_subset] = STATE(591),
    [sym_subset2] = STATE(591),
    [sym_dollar] = STATE(591),
    [sym_slot] = STATE(591),
    [sym_namespace_get] = STATE(591),
    [sym_namespace_get_internal] = STATE(591),
    [sym_pipe] = STATE(591),
    [sym_unary] = STATE(591),
    [sym_binary] = STATE(591),
    [sym_na] = STATE(591),
    [sym__expression] = STATE(591),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(591),
    [sym_string] = STATE(591),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1141),
    [sym_next] = ACTIONS(1141),
    [sym_true] = ACTIONS(1141),
    [sym_false] = ACTIONS(1141),
    [sym_null] = ACTIONS(1141),
    [sym_inf] = ACTIONS(1141),
    [sym_nan] = ACTIONS(1141),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1139),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [148] = {
    [sym_function_definition] = STATE(889),
    [sym_lambda_function] = STATE(889),
    [sym_if] = STATE(889),
    [sym_while] = STATE(889),
    [sym_repeat] = STATE(889),
    [sym_for] = STATE(889),
    [sym_switch] = STATE(889),
    [sym_call] = STATE(889),
    [sym__assignment] = STATE(889),
    [sym_left_assignment] = STATE(889),
    [sym_left_assignment2] = STATE(889),
    [sym_equals_assignment] = STATE(889),
    [sym_super_assignment] = STATE(889),
    [sym_super_right_assignment] = STATE(889),
    [sym_right_assignment] = STATE(889),
    [sym_brace_list] = STATE(889),
    [sym_paren_list] = STATE(889),
    [sym_subset] = STATE(889),
    [sym_subset2] = STATE(889),
    [sym_dollar] = STATE(889),
    [sym_slot] = STATE(889),
    [sym_namespace_get] = STATE(889),
    [sym_namespace_get_internal] = STATE(889),
    [sym_pipe] = STATE(889),
    [sym_unary] = STATE(889),
    [sym_binary] = STATE(889),
    [sym_na] = STATE(889),
    [sym__expression] = STATE(889),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(889),
    [sym_string] = STATE(889),
    [anon_sym_SEMI] = ACTIONS(1143),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1145),
    [sym_next] = ACTIONS(1145),
    [sym_true] = ACTIONS(1145),
    [sym_false] = ACTIONS(1145),
    [sym_null] = ACTIONS(1145),
    [sym_inf] = ACTIONS(1145),
    [sym_nan] = ACTIONS(1145),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1143),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [149] = {
    [sym_function_definition] = STATE(643),
    [sym_lambda_function] = STATE(643),
    [sym_if] = STATE(643),
    [sym_while] = STATE(643),
    [sym_repeat] = STATE(643),
    [sym_for] = STATE(643),
    [sym_switch] = STATE(643),
    [sym_call] = STATE(643),
    [sym__assignment] = STATE(643),
    [sym_left_assignment] = STATE(643),
    [sym_left_assignment2] = STATE(643),
    [sym_equals_assignment] = STATE(643),
    [sym_super_assignment] = STATE(643),
    [sym_super_right_assignment] = STATE(643),
    [sym_right_assignment] = STATE(643),
    [sym_brace_list] = STATE(643),
    [sym_paren_list] = STATE(643),
    [sym_subset] = STATE(643),
    [sym_subset2] = STATE(643),
    [sym_dollar] = STATE(643),
    [sym_slot] = STATE(643),
    [sym_namespace_get] = STATE(643),
    [sym_namespace_get_internal] = STATE(643),
    [sym_pipe] = STATE(643),
    [sym_unary] = STATE(643),
    [sym_binary] = STATE(643),
    [sym_na] = STATE(643),
    [sym__expression] = STATE(643),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(643),
    [sym_string] = STATE(643),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1149),
    [sym_next] = ACTIONS(1149),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [sym_null] = ACTIONS(1149),
    [sym_inf] = ACTIONS(1149),
    [sym_nan] = ACTIONS(1149),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1147),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [150] = {
    [sym_function_definition] = STATE(642),
    [sym_lambda_function] = STATE(642),
    [sym_if] = STATE(642),
    [sym_while] = STATE(642),
    [sym_repeat] = STATE(642),
    [sym_for] = STATE(642),
    [sym_switch] = STATE(642),
    [sym_call] = STATE(642),
    [sym__assignment] = STATE(642),
    [sym_left_assignment] = STATE(642),
    [sym_left_assignment2] = STATE(642),
    [sym_equals_assignment] = STATE(642),
    [sym_super_assignment] = STATE(642),
    [sym_super_right_assignment] = STATE(642),
    [sym_right_assignment] = STATE(642),
    [sym_brace_list] = STATE(642),
    [sym_paren_list] = STATE(642),
    [sym_subset] = STATE(642),
    [sym_subset2] = STATE(642),
    [sym_dollar] = STATE(642),
    [sym_slot] = STATE(642),
    [sym_namespace_get] = STATE(642),
    [sym_namespace_get_internal] = STATE(642),
    [sym_pipe] = STATE(642),
    [sym_unary] = STATE(642),
    [sym_binary] = STATE(642),
    [sym_na] = STATE(642),
    [sym__expression] = STATE(642),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(642),
    [sym_string] = STATE(642),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1153),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1153),
    [sym_next] = ACTIONS(1153),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [sym_null] = ACTIONS(1153),
    [sym_inf] = ACTIONS(1153),
    [sym_nan] = ACTIONS(1153),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1151),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [151] = {
    [sym_function_definition] = STATE(894),
    [sym_lambda_function] = STATE(894),
    [sym_if] = STATE(894),
    [sym_while] = STATE(894),
    [sym_repeat] = STATE(894),
    [sym_for] = STATE(894),
    [sym_switch] = STATE(894),
    [sym_call] = STATE(894),
    [sym__assignment] = STATE(894),
    [sym_left_assignment] = STATE(894),
    [sym_left_assignment2] = STATE(894),
    [sym_equals_assignment] = STATE(894),
    [sym_super_assignment] = STATE(894),
    [sym_super_right_assignment] = STATE(894),
    [sym_right_assignment] = STATE(894),
    [sym_brace_list] = STATE(894),
    [sym_paren_list] = STATE(894),
    [sym_subset] = STATE(894),
    [sym_subset2] = STATE(894),
    [sym_dollar] = STATE(894),
    [sym_slot] = STATE(894),
    [sym_namespace_get] = STATE(894),
    [sym_namespace_get_internal] = STATE(894),
    [sym_pipe] = STATE(894),
    [sym_unary] = STATE(894),
    [sym_binary] = STATE(894),
    [sym_na] = STATE(894),
    [sym__expression] = STATE(894),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(894),
    [sym_string] = STATE(894),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1157),
    [sym_next] = ACTIONS(1157),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [sym_null] = ACTIONS(1157),
    [sym_inf] = ACTIONS(1157),
    [sym_nan] = ACTIONS(1157),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1155),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [152] = {
    [sym_function_definition] = STATE(817),
    [sym_lambda_function] = STATE(817),
    [sym_if] = STATE(817),
    [sym_while] = STATE(817),
    [sym_repeat] = STATE(817),
    [sym_for] = STATE(817),
    [sym_switch] = STATE(817),
    [sym_call] = STATE(817),
    [sym__assignment] = STATE(817),
    [sym_left_assignment] = STATE(817),
    [sym_left_assignment2] = STATE(817),
    [sym_equals_assignment] = STATE(817),
    [sym_super_assignment] = STATE(817),
    [sym_super_right_assignment] = STATE(817),
    [sym_right_assignment] = STATE(817),
    [sym_brace_list] = STATE(817),
    [sym_paren_list] = STATE(817),
    [sym_subset] = STATE(817),
    [sym_subset2] = STATE(817),
    [sym_dollar] = STATE(817),
    [sym_slot] = STATE(817),
    [sym_namespace_get] = STATE(817),
    [sym_namespace_get_internal] = STATE(817),
    [sym_pipe] = STATE(817),
    [sym_unary] = STATE(817),
    [sym_binary] = STATE(817),
    [sym_na] = STATE(817),
    [sym__expression] = STATE(817),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(817),
    [sym_string] = STATE(817),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1161),
    [sym_next] = ACTIONS(1161),
    [sym_true] = ACTIONS(1161),
    [sym_false] = ACTIONS(1161),
    [sym_null] = ACTIONS(1161),
    [sym_inf] = ACTIONS(1161),
    [sym_nan] = ACTIONS(1161),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1159),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [153] = {
    [sym_function_definition] = STATE(815),
    [sym_lambda_function] = STATE(815),
    [sym_if] = STATE(815),
    [sym_while] = STATE(815),
    [sym_repeat] = STATE(815),
    [sym_for] = STATE(815),
    [sym_switch] = STATE(815),
    [sym_call] = STATE(815),
    [sym__assignment] = STATE(815),
    [sym_left_assignment] = STATE(815),
    [sym_left_assignment2] = STATE(815),
    [sym_equals_assignment] = STATE(815),
    [sym_super_assignment] = STATE(815),
    [sym_super_right_assignment] = STATE(815),
    [sym_right_assignment] = STATE(815),
    [sym_brace_list] = STATE(815),
    [sym_paren_list] = STATE(815),
    [sym_subset] = STATE(815),
    [sym_subset2] = STATE(815),
    [sym_dollar] = STATE(815),
    [sym_slot] = STATE(815),
    [sym_namespace_get] = STATE(815),
    [sym_namespace_get_internal] = STATE(815),
    [sym_pipe] = STATE(815),
    [sym_unary] = STATE(815),
    [sym_binary] = STATE(815),
    [sym_na] = STATE(815),
    [sym__expression] = STATE(815),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(815),
    [sym_string] = STATE(815),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1165),
    [sym_next] = ACTIONS(1165),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [sym_null] = ACTIONS(1165),
    [sym_inf] = ACTIONS(1165),
    [sym_nan] = ACTIONS(1165),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1163),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [154] = {
    [sym_function_definition] = STATE(521),
    [sym_lambda_function] = STATE(521),
    [sym_if] = STATE(521),
    [sym_while] = STATE(521),
    [sym_repeat] = STATE(521),
    [sym_for] = STATE(521),
    [sym_switch] = STATE(521),
    [sym_call] = STATE(521),
    [sym__assignment] = STATE(521),
    [sym_left_assignment] = STATE(521),
    [sym_left_assignment2] = STATE(521),
    [sym_equals_assignment] = STATE(521),
    [sym_super_assignment] = STATE(521),
    [sym_super_right_assignment] = STATE(521),
    [sym_right_assignment] = STATE(521),
    [sym_brace_list] = STATE(521),
    [sym_paren_list] = STATE(521),
    [sym_subset] = STATE(521),
    [sym_subset2] = STATE(521),
    [sym_dollar] = STATE(521),
    [sym_slot] = STATE(521),
    [sym_namespace_get] = STATE(521),
    [sym_namespace_get_internal] = STATE(521),
    [sym_pipe] = STATE(521),
    [sym_unary] = STATE(521),
    [sym_binary] = STATE(521),
    [sym_na] = STATE(521),
    [sym__expression] = STATE(521),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(521),
    [sym_string] = STATE(521),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1169),
    [sym_next] = ACTIONS(1169),
    [sym_true] = ACTIONS(1169),
    [sym_false] = ACTIONS(1169),
    [sym_null] = ACTIONS(1169),
    [sym_inf] = ACTIONS(1169),
    [sym_nan] = ACTIONS(1169),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1167),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [155] = {
    [sym_function_definition] = STATE(522),
    [sym_lambda_function] = STATE(522),
    [sym_if] = STATE(522),
    [sym_while] = STATE(522),
    [sym_repeat] = STATE(522),
    [sym_for] = STATE(522),
    [sym_switch] = STATE(522),
    [sym_call] = STATE(522),
    [sym__assignment] = STATE(522),
    [sym_left_assignment] = STATE(522),
    [sym_left_assignment2] = STATE(522),
    [sym_equals_assignment] = STATE(522),
    [sym_super_assignment] = STATE(522),
    [sym_super_right_assignment] = STATE(522),
    [sym_right_assignment] = STATE(522),
    [sym_brace_list] = STATE(522),
    [sym_paren_list] = STATE(522),
    [sym_subset] = STATE(522),
    [sym_subset2] = STATE(522),
    [sym_dollar] = STATE(522),
    [sym_slot] = STATE(522),
    [sym_namespace_get] = STATE(522),
    [sym_namespace_get_internal] = STATE(522),
    [sym_pipe] = STATE(522),
    [sym_unary] = STATE(522),
    [sym_binary] = STATE(522),
    [sym_na] = STATE(522),
    [sym__expression] = STATE(522),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(522),
    [sym_string] = STATE(522),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1173),
    [sym_next] = ACTIONS(1173),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_inf] = ACTIONS(1173),
    [sym_nan] = ACTIONS(1173),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1171),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [156] = {
    [sym_function_definition] = STATE(523),
    [sym_lambda_function] = STATE(523),
    [sym_if] = STATE(523),
    [sym_while] = STATE(523),
    [sym_repeat] = STATE(523),
    [sym_for] = STATE(523),
    [sym_switch] = STATE(523),
    [sym_call] = STATE(523),
    [sym__assignment] = STATE(523),
    [sym_left_assignment] = STATE(523),
    [sym_left_assignment2] = STATE(523),
    [sym_equals_assignment] = STATE(523),
    [sym_super_assignment] = STATE(523),
    [sym_super_right_assignment] = STATE(523),
    [sym_right_assignment] = STATE(523),
    [sym_brace_list] = STATE(523),
    [sym_paren_list] = STATE(523),
    [sym_subset] = STATE(523),
    [sym_subset2] = STATE(523),
    [sym_dollar] = STATE(523),
    [sym_slot] = STATE(523),
    [sym_namespace_get] = STATE(523),
    [sym_namespace_get_internal] = STATE(523),
    [sym_pipe] = STATE(523),
    [sym_unary] = STATE(523),
    [sym_binary] = STATE(523),
    [sym_na] = STATE(523),
    [sym__expression] = STATE(523),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(523),
    [sym_string] = STATE(523),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1177),
    [sym_next] = ACTIONS(1177),
    [sym_true] = ACTIONS(1177),
    [sym_false] = ACTIONS(1177),
    [sym_null] = ACTIONS(1177),
    [sym_inf] = ACTIONS(1177),
    [sym_nan] = ACTIONS(1177),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1175),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [157] = {
    [sym_function_definition] = STATE(533),
    [sym_lambda_function] = STATE(533),
    [sym_if] = STATE(533),
    [sym_while] = STATE(533),
    [sym_repeat] = STATE(533),
    [sym_for] = STATE(533),
    [sym_switch] = STATE(533),
    [sym_call] = STATE(533),
    [sym__assignment] = STATE(533),
    [sym_left_assignment] = STATE(533),
    [sym_left_assignment2] = STATE(533),
    [sym_equals_assignment] = STATE(533),
    [sym_super_assignment] = STATE(533),
    [sym_super_right_assignment] = STATE(533),
    [sym_right_assignment] = STATE(533),
    [sym_brace_list] = STATE(533),
    [sym_paren_list] = STATE(533),
    [sym_subset] = STATE(533),
    [sym_subset2] = STATE(533),
    [sym_dollar] = STATE(533),
    [sym_slot] = STATE(533),
    [sym_namespace_get] = STATE(533),
    [sym_namespace_get_internal] = STATE(533),
    [sym_pipe] = STATE(533),
    [sym_unary] = STATE(533),
    [sym_binary] = STATE(533),
    [sym_na] = STATE(533),
    [sym__expression] = STATE(533),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(533),
    [sym_string] = STATE(533),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1181),
    [sym_next] = ACTIONS(1181),
    [sym_true] = ACTIONS(1181),
    [sym_false] = ACTIONS(1181),
    [sym_null] = ACTIONS(1181),
    [sym_inf] = ACTIONS(1181),
    [sym_nan] = ACTIONS(1181),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1179),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [158] = {
    [sym_function_definition] = STATE(814),
    [sym_lambda_function] = STATE(814),
    [sym_if] = STATE(814),
    [sym_while] = STATE(814),
    [sym_repeat] = STATE(814),
    [sym_for] = STATE(814),
    [sym_switch] = STATE(814),
    [sym_call] = STATE(814),
    [sym__assignment] = STATE(814),
    [sym_left_assignment] = STATE(814),
    [sym_left_assignment2] = STATE(814),
    [sym_equals_assignment] = STATE(814),
    [sym_super_assignment] = STATE(814),
    [sym_super_right_assignment] = STATE(814),
    [sym_right_assignment] = STATE(814),
    [sym_brace_list] = STATE(814),
    [sym_paren_list] = STATE(814),
    [sym_subset] = STATE(814),
    [sym_subset2] = STATE(814),
    [sym_dollar] = STATE(814),
    [sym_slot] = STATE(814),
    [sym_namespace_get] = STATE(814),
    [sym_namespace_get_internal] = STATE(814),
    [sym_pipe] = STATE(814),
    [sym_unary] = STATE(814),
    [sym_binary] = STATE(814),
    [sym_na] = STATE(814),
    [sym__expression] = STATE(814),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(814),
    [sym_string] = STATE(814),
    [anon_sym_SEMI] = ACTIONS(1183),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1185),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1185),
    [sym_next] = ACTIONS(1185),
    [sym_true] = ACTIONS(1185),
    [sym_false] = ACTIONS(1185),
    [sym_null] = ACTIONS(1185),
    [sym_inf] = ACTIONS(1185),
    [sym_nan] = ACTIONS(1185),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1183),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [159] = {
    [anon_sym_SEMI] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(651),
    [anon_sym_BSLASH] = ACTIONS(649),
    [anon_sym_if] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(649),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_while] = ACTIONS(651),
    [anon_sym_repeat] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_switch] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(649),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_DASH_GT_GT] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_RBRACK] = ACTIONS(649),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(649),
    [anon_sym_DOLLAR] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(649),
    [sym_dots] = ACTIONS(651),
    [anon_sym_PIPE_GT] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_CARET] = ACTIONS(649),
    [anon_sym_LT] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(651),
    [anon_sym_LT_EQ] = ACTIONS(649),
    [anon_sym_GT_EQ] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_BANG_EQ] = ACTIONS(649),
    [anon_sym_PIPE_PIPE] = ACTIONS(649),
    [anon_sym_PIPE] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(649),
    [anon_sym_AMP] = ACTIONS(651),
    [anon_sym_COLON] = ACTIONS(651),
    [sym_break] = ACTIONS(651),
    [sym_next] = ACTIONS(651),
    [sym_true] = ACTIONS(651),
    [sym_false] = ACTIONS(651),
    [sym_null] = ACTIONS(651),
    [sym_inf] = ACTIONS(651),
    [sym_nan] = ACTIONS(651),
    [anon_sym_NA] = ACTIONS(651),
    [anon_sym_NA_character_] = ACTIONS(651),
    [anon_sym_NA_complex_] = ACTIONS(651),
    [anon_sym_NA_integer_] = ACTIONS(651),
    [anon_sym_NA_real_] = ACTIONS(651),
    [aux_sym_identifier_token1] = ACTIONS(651),
    [anon_sym_BQUOTE] = ACTIONS(649),
    [sym_integer] = ACTIONS(649),
    [sym_float] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(649),
    [anon_sym_SQUOTE] = ACTIONS(649),
    [anon_sym_PERCENT] = ACTIONS(649),
  },
  [160] = {
    [sym_function_definition] = STATE(799),
    [sym_lambda_function] = STATE(799),
    [sym_if] = STATE(799),
    [sym_while] = STATE(799),
    [sym_repeat] = STATE(799),
    [sym_for] = STATE(799),
    [sym_switch] = STATE(799),
    [sym_call] = STATE(799),
    [sym__assignment] = STATE(799),
    [sym_left_assignment] = STATE(799),
    [sym_left_assignment2] = STATE(799),
    [sym_equals_assignment] = STATE(799),
    [sym_super_assignment] = STATE(799),
    [sym_super_right_assignment] = STATE(799),
    [sym_right_assignment] = STATE(799),
    [sym_brace_list] = STATE(799),
    [sym_paren_list] = STATE(799),
    [sym_subset] = STATE(799),
    [sym_subset2] = STATE(799),
    [sym_dollar] = STATE(799),
    [sym_slot] = STATE(799),
    [sym_namespace_get] = STATE(799),
    [sym_namespace_get_internal] = STATE(799),
    [sym_pipe] = STATE(799),
    [sym_unary] = STATE(799),
    [sym_binary] = STATE(799),
    [sym_na] = STATE(799),
    [sym__expression] = STATE(799),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(799),
    [sym_string] = STATE(799),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1189),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1189),
    [sym_next] = ACTIONS(1189),
    [sym_true] = ACTIONS(1189),
    [sym_false] = ACTIONS(1189),
    [sym_null] = ACTIONS(1189),
    [sym_inf] = ACTIONS(1189),
    [sym_nan] = ACTIONS(1189),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1187),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [161] = {
    [sym_function_definition] = STATE(812),
    [sym_lambda_function] = STATE(812),
    [sym_if] = STATE(812),
    [sym_while] = STATE(812),
    [sym_repeat] = STATE(812),
    [sym_for] = STATE(812),
    [sym_switch] = STATE(812),
    [sym_call] = STATE(812),
    [sym__assignment] = STATE(812),
    [sym_left_assignment] = STATE(812),
    [sym_left_assignment2] = STATE(812),
    [sym_equals_assignment] = STATE(812),
    [sym_super_assignment] = STATE(812),
    [sym_super_right_assignment] = STATE(812),
    [sym_right_assignment] = STATE(812),
    [sym_brace_list] = STATE(812),
    [sym_paren_list] = STATE(812),
    [sym_subset] = STATE(812),
    [sym_subset2] = STATE(812),
    [sym_dollar] = STATE(812),
    [sym_slot] = STATE(812),
    [sym_namespace_get] = STATE(812),
    [sym_namespace_get_internal] = STATE(812),
    [sym_pipe] = STATE(812),
    [sym_unary] = STATE(812),
    [sym_binary] = STATE(812),
    [sym_na] = STATE(812),
    [sym__expression] = STATE(812),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(812),
    [sym_string] = STATE(812),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1193),
    [sym_next] = ACTIONS(1193),
    [sym_true] = ACTIONS(1193),
    [sym_false] = ACTIONS(1193),
    [sym_null] = ACTIONS(1193),
    [sym_inf] = ACTIONS(1193),
    [sym_nan] = ACTIONS(1193),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1191),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [162] = {
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(739),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(741),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_integer] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
  },
  [163] = {
    [sym_function_definition] = STATE(535),
    [sym_lambda_function] = STATE(535),
    [sym_if] = STATE(535),
    [sym_while] = STATE(535),
    [sym_repeat] = STATE(535),
    [sym_for] = STATE(535),
    [sym_switch] = STATE(535),
    [sym_call] = STATE(535),
    [sym__assignment] = STATE(535),
    [sym_left_assignment] = STATE(535),
    [sym_left_assignment2] = STATE(535),
    [sym_equals_assignment] = STATE(535),
    [sym_super_assignment] = STATE(535),
    [sym_super_right_assignment] = STATE(535),
    [sym_right_assignment] = STATE(535),
    [sym_brace_list] = STATE(535),
    [sym_paren_list] = STATE(535),
    [sym_subset] = STATE(535),
    [sym_subset2] = STATE(535),
    [sym_dollar] = STATE(535),
    [sym_slot] = STATE(535),
    [sym_namespace_get] = STATE(535),
    [sym_namespace_get_internal] = STATE(535),
    [sym_pipe] = STATE(535),
    [sym_unary] = STATE(535),
    [sym_binary] = STATE(535),
    [sym_na] = STATE(535),
    [sym__expression] = STATE(535),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(535),
    [sym_string] = STATE(535),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1197),
    [sym_next] = ACTIONS(1197),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [sym_null] = ACTIONS(1197),
    [sym_inf] = ACTIONS(1197),
    [sym_nan] = ACTIONS(1197),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1195),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [164] = {
    [sym_function_definition] = STATE(536),
    [sym_lambda_function] = STATE(536),
    [sym_if] = STATE(536),
    [sym_while] = STATE(536),
    [sym_repeat] = STATE(536),
    [sym_for] = STATE(536),
    [sym_switch] = STATE(536),
    [sym_call] = STATE(536),
    [sym__assignment] = STATE(536),
    [sym_left_assignment] = STATE(536),
    [sym_left_assignment2] = STATE(536),
    [sym_equals_assignment] = STATE(536),
    [sym_super_assignment] = STATE(536),
    [sym_super_right_assignment] = STATE(536),
    [sym_right_assignment] = STATE(536),
    [sym_brace_list] = STATE(536),
    [sym_paren_list] = STATE(536),
    [sym_subset] = STATE(536),
    [sym_subset2] = STATE(536),
    [sym_dollar] = STATE(536),
    [sym_slot] = STATE(536),
    [sym_namespace_get] = STATE(536),
    [sym_namespace_get_internal] = STATE(536),
    [sym_pipe] = STATE(536),
    [sym_unary] = STATE(536),
    [sym_binary] = STATE(536),
    [sym_na] = STATE(536),
    [sym__expression] = STATE(536),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(536),
    [sym_string] = STATE(536),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1201),
    [sym_next] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_inf] = ACTIONS(1201),
    [sym_nan] = ACTIONS(1201),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1199),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [165] = {
    [sym_function_definition] = STATE(811),
    [sym_lambda_function] = STATE(811),
    [sym_if] = STATE(811),
    [sym_while] = STATE(811),
    [sym_repeat] = STATE(811),
    [sym_for] = STATE(811),
    [sym_switch] = STATE(811),
    [sym_call] = STATE(811),
    [sym__assignment] = STATE(811),
    [sym_left_assignment] = STATE(811),
    [sym_left_assignment2] = STATE(811),
    [sym_equals_assignment] = STATE(811),
    [sym_super_assignment] = STATE(811),
    [sym_super_right_assignment] = STATE(811),
    [sym_right_assignment] = STATE(811),
    [sym_brace_list] = STATE(811),
    [sym_paren_list] = STATE(811),
    [sym_subset] = STATE(811),
    [sym_subset2] = STATE(811),
    [sym_dollar] = STATE(811),
    [sym_slot] = STATE(811),
    [sym_namespace_get] = STATE(811),
    [sym_namespace_get_internal] = STATE(811),
    [sym_pipe] = STATE(811),
    [sym_unary] = STATE(811),
    [sym_binary] = STATE(811),
    [sym_na] = STATE(811),
    [sym__expression] = STATE(811),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(811),
    [sym_string] = STATE(811),
    [anon_sym_SEMI] = ACTIONS(1203),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1205),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1205),
    [sym_next] = ACTIONS(1205),
    [sym_true] = ACTIONS(1205),
    [sym_false] = ACTIONS(1205),
    [sym_null] = ACTIONS(1205),
    [sym_inf] = ACTIONS(1205),
    [sym_nan] = ACTIONS(1205),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1203),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [166] = {
    [sym_function_definition] = STATE(798),
    [sym_lambda_function] = STATE(798),
    [sym_if] = STATE(798),
    [sym_while] = STATE(798),
    [sym_repeat] = STATE(798),
    [sym_for] = STATE(798),
    [sym_switch] = STATE(798),
    [sym_call] = STATE(798),
    [sym__assignment] = STATE(798),
    [sym_left_assignment] = STATE(798),
    [sym_left_assignment2] = STATE(798),
    [sym_equals_assignment] = STATE(798),
    [sym_super_assignment] = STATE(798),
    [sym_super_right_assignment] = STATE(798),
    [sym_right_assignment] = STATE(798),
    [sym_brace_list] = STATE(798),
    [sym_paren_list] = STATE(798),
    [sym_subset] = STATE(798),
    [sym_subset2] = STATE(798),
    [sym_dollar] = STATE(798),
    [sym_slot] = STATE(798),
    [sym_namespace_get] = STATE(798),
    [sym_namespace_get_internal] = STATE(798),
    [sym_pipe] = STATE(798),
    [sym_unary] = STATE(798),
    [sym_binary] = STATE(798),
    [sym_na] = STATE(798),
    [sym__expression] = STATE(798),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(798),
    [sym_string] = STATE(798),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1209),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1209),
    [sym_next] = ACTIONS(1209),
    [sym_true] = ACTIONS(1209),
    [sym_false] = ACTIONS(1209),
    [sym_null] = ACTIONS(1209),
    [sym_inf] = ACTIONS(1209),
    [sym_nan] = ACTIONS(1209),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1207),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [167] = {
    [sym_function_definition] = STATE(821),
    [sym_lambda_function] = STATE(821),
    [sym_if] = STATE(821),
    [sym_while] = STATE(821),
    [sym_repeat] = STATE(821),
    [sym_for] = STATE(821),
    [sym_switch] = STATE(821),
    [sym_call] = STATE(821),
    [sym__assignment] = STATE(821),
    [sym_left_assignment] = STATE(821),
    [sym_left_assignment2] = STATE(821),
    [sym_equals_assignment] = STATE(821),
    [sym_super_assignment] = STATE(821),
    [sym_super_right_assignment] = STATE(821),
    [sym_right_assignment] = STATE(821),
    [sym_brace_list] = STATE(821),
    [sym_paren_list] = STATE(821),
    [sym_subset] = STATE(821),
    [sym_subset2] = STATE(821),
    [sym_dollar] = STATE(821),
    [sym_slot] = STATE(821),
    [sym_namespace_get] = STATE(821),
    [sym_namespace_get_internal] = STATE(821),
    [sym_pipe] = STATE(821),
    [sym_unary] = STATE(821),
    [sym_binary] = STATE(821),
    [sym_na] = STATE(821),
    [sym__expression] = STATE(821),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(821),
    [sym_string] = STATE(821),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1213),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1213),
    [sym_next] = ACTIONS(1213),
    [sym_true] = ACTIONS(1213),
    [sym_false] = ACTIONS(1213),
    [sym_null] = ACTIONS(1213),
    [sym_inf] = ACTIONS(1213),
    [sym_nan] = ACTIONS(1213),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1211),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [168] = {
    [sym_function_definition] = STATE(807),
    [sym_lambda_function] = STATE(807),
    [sym_if] = STATE(807),
    [sym_while] = STATE(807),
    [sym_repeat] = STATE(807),
    [sym_for] = STATE(807),
    [sym_switch] = STATE(807),
    [sym_call] = STATE(807),
    [sym__assignment] = STATE(807),
    [sym_left_assignment] = STATE(807),
    [sym_left_assignment2] = STATE(807),
    [sym_equals_assignment] = STATE(807),
    [sym_super_assignment] = STATE(807),
    [sym_super_right_assignment] = STATE(807),
    [sym_right_assignment] = STATE(807),
    [sym_brace_list] = STATE(807),
    [sym_paren_list] = STATE(807),
    [sym_subset] = STATE(807),
    [sym_subset2] = STATE(807),
    [sym_dollar] = STATE(807),
    [sym_slot] = STATE(807),
    [sym_namespace_get] = STATE(807),
    [sym_namespace_get_internal] = STATE(807),
    [sym_pipe] = STATE(807),
    [sym_unary] = STATE(807),
    [sym_binary] = STATE(807),
    [sym_na] = STATE(807),
    [sym__expression] = STATE(807),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(807),
    [sym_string] = STATE(807),
    [anon_sym_SEMI] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1217),
    [sym_next] = ACTIONS(1217),
    [sym_true] = ACTIONS(1217),
    [sym_false] = ACTIONS(1217),
    [sym_null] = ACTIONS(1217),
    [sym_inf] = ACTIONS(1217),
    [sym_nan] = ACTIONS(1217),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1215),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [169] = {
    [sym_function_definition] = STATE(806),
    [sym_lambda_function] = STATE(806),
    [sym_if] = STATE(806),
    [sym_while] = STATE(806),
    [sym_repeat] = STATE(806),
    [sym_for] = STATE(806),
    [sym_switch] = STATE(806),
    [sym_call] = STATE(806),
    [sym__assignment] = STATE(806),
    [sym_left_assignment] = STATE(806),
    [sym_left_assignment2] = STATE(806),
    [sym_equals_assignment] = STATE(806),
    [sym_super_assignment] = STATE(806),
    [sym_super_right_assignment] = STATE(806),
    [sym_right_assignment] = STATE(806),
    [sym_brace_list] = STATE(806),
    [sym_paren_list] = STATE(806),
    [sym_subset] = STATE(806),
    [sym_subset2] = STATE(806),
    [sym_dollar] = STATE(806),
    [sym_slot] = STATE(806),
    [sym_namespace_get] = STATE(806),
    [sym_namespace_get_internal] = STATE(806),
    [sym_pipe] = STATE(806),
    [sym_unary] = STATE(806),
    [sym_binary] = STATE(806),
    [sym_na] = STATE(806),
    [sym__expression] = STATE(806),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(806),
    [sym_string] = STATE(806),
    [anon_sym_SEMI] = ACTIONS(1219),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1221),
    [sym_next] = ACTIONS(1221),
    [sym_true] = ACTIONS(1221),
    [sym_false] = ACTIONS(1221),
    [sym_null] = ACTIONS(1221),
    [sym_inf] = ACTIONS(1221),
    [sym_nan] = ACTIONS(1221),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1219),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [170] = {
    [sym_function_definition] = STATE(805),
    [sym_lambda_function] = STATE(805),
    [sym_if] = STATE(805),
    [sym_while] = STATE(805),
    [sym_repeat] = STATE(805),
    [sym_for] = STATE(805),
    [sym_switch] = STATE(805),
    [sym_call] = STATE(805),
    [sym__assignment] = STATE(805),
    [sym_left_assignment] = STATE(805),
    [sym_left_assignment2] = STATE(805),
    [sym_equals_assignment] = STATE(805),
    [sym_super_assignment] = STATE(805),
    [sym_super_right_assignment] = STATE(805),
    [sym_right_assignment] = STATE(805),
    [sym_brace_list] = STATE(805),
    [sym_paren_list] = STATE(805),
    [sym_subset] = STATE(805),
    [sym_subset2] = STATE(805),
    [sym_dollar] = STATE(805),
    [sym_slot] = STATE(805),
    [sym_namespace_get] = STATE(805),
    [sym_namespace_get_internal] = STATE(805),
    [sym_pipe] = STATE(805),
    [sym_unary] = STATE(805),
    [sym_binary] = STATE(805),
    [sym_na] = STATE(805),
    [sym__expression] = STATE(805),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(805),
    [sym_string] = STATE(805),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1225),
    [sym_next] = ACTIONS(1225),
    [sym_true] = ACTIONS(1225),
    [sym_false] = ACTIONS(1225),
    [sym_null] = ACTIONS(1225),
    [sym_inf] = ACTIONS(1225),
    [sym_nan] = ACTIONS(1225),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [171] = {
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_function] = ACTIONS(655),
    [anon_sym_BSLASH] = ACTIONS(653),
    [anon_sym_if] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_while] = ACTIONS(655),
    [anon_sym_repeat] = ACTIONS(655),
    [anon_sym_for] = ACTIONS(655),
    [anon_sym_switch] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LT_DASH] = ACTIONS(653),
    [anon_sym_COLON_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_DASH] = ACTIONS(653),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_RBRACK] = ACTIONS(653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(653),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [anon_sym_AT] = ACTIONS(653),
    [anon_sym_COLON_COLON] = ACTIONS(655),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(653),
    [sym_dots] = ACTIONS(655),
    [anon_sym_PIPE_GT] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_SLASH] = ACTIONS(653),
    [anon_sym_CARET] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_COLON] = ACTIONS(655),
    [sym_break] = ACTIONS(655),
    [sym_next] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_null] = ACTIONS(655),
    [sym_inf] = ACTIONS(655),
    [sym_nan] = ACTIONS(655),
    [anon_sym_NA] = ACTIONS(655),
    [anon_sym_NA_character_] = ACTIONS(655),
    [anon_sym_NA_complex_] = ACTIONS(655),
    [anon_sym_NA_integer_] = ACTIONS(655),
    [anon_sym_NA_real_] = ACTIONS(655),
    [aux_sym_identifier_token1] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(653),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_SQUOTE] = ACTIONS(653),
    [anon_sym_PERCENT] = ACTIONS(653),
  },
  [172] = {
    [sym_function_definition] = STATE(804),
    [sym_lambda_function] = STATE(804),
    [sym_if] = STATE(804),
    [sym_while] = STATE(804),
    [sym_repeat] = STATE(804),
    [sym_for] = STATE(804),
    [sym_switch] = STATE(804),
    [sym_call] = STATE(804),
    [sym__assignment] = STATE(804),
    [sym_left_assignment] = STATE(804),
    [sym_left_assignment2] = STATE(804),
    [sym_equals_assignment] = STATE(804),
    [sym_super_assignment] = STATE(804),
    [sym_super_right_assignment] = STATE(804),
    [sym_right_assignment] = STATE(804),
    [sym_brace_list] = STATE(804),
    [sym_paren_list] = STATE(804),
    [sym_subset] = STATE(804),
    [sym_subset2] = STATE(804),
    [sym_dollar] = STATE(804),
    [sym_slot] = STATE(804),
    [sym_namespace_get] = STATE(804),
    [sym_namespace_get_internal] = STATE(804),
    [sym_pipe] = STATE(804),
    [sym_unary] = STATE(804),
    [sym_binary] = STATE(804),
    [sym_na] = STATE(804),
    [sym__expression] = STATE(804),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(804),
    [sym_string] = STATE(804),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1229),
    [sym_next] = ACTIONS(1229),
    [sym_true] = ACTIONS(1229),
    [sym_false] = ACTIONS(1229),
    [sym_null] = ACTIONS(1229),
    [sym_inf] = ACTIONS(1229),
    [sym_nan] = ACTIONS(1229),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1227),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [173] = {
    [sym_function_definition] = STATE(803),
    [sym_lambda_function] = STATE(803),
    [sym_if] = STATE(803),
    [sym_while] = STATE(803),
    [sym_repeat] = STATE(803),
    [sym_for] = STATE(803),
    [sym_switch] = STATE(803),
    [sym_call] = STATE(803),
    [sym__assignment] = STATE(803),
    [sym_left_assignment] = STATE(803),
    [sym_left_assignment2] = STATE(803),
    [sym_equals_assignment] = STATE(803),
    [sym_super_assignment] = STATE(803),
    [sym_super_right_assignment] = STATE(803),
    [sym_right_assignment] = STATE(803),
    [sym_brace_list] = STATE(803),
    [sym_paren_list] = STATE(803),
    [sym_subset] = STATE(803),
    [sym_subset2] = STATE(803),
    [sym_dollar] = STATE(803),
    [sym_slot] = STATE(803),
    [sym_namespace_get] = STATE(803),
    [sym_namespace_get_internal] = STATE(803),
    [sym_pipe] = STATE(803),
    [sym_unary] = STATE(803),
    [sym_binary] = STATE(803),
    [sym_na] = STATE(803),
    [sym__expression] = STATE(803),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(803),
    [sym_string] = STATE(803),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1233),
    [sym_next] = ACTIONS(1233),
    [sym_true] = ACTIONS(1233),
    [sym_false] = ACTIONS(1233),
    [sym_null] = ACTIONS(1233),
    [sym_inf] = ACTIONS(1233),
    [sym_nan] = ACTIONS(1233),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1231),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [174] = {
    [sym_function_definition] = STATE(534),
    [sym_lambda_function] = STATE(534),
    [sym_if] = STATE(534),
    [sym_while] = STATE(534),
    [sym_repeat] = STATE(534),
    [sym_for] = STATE(534),
    [sym_switch] = STATE(534),
    [sym_call] = STATE(534),
    [sym__assignment] = STATE(534),
    [sym_left_assignment] = STATE(534),
    [sym_left_assignment2] = STATE(534),
    [sym_equals_assignment] = STATE(534),
    [sym_super_assignment] = STATE(534),
    [sym_super_right_assignment] = STATE(534),
    [sym_right_assignment] = STATE(534),
    [sym_brace_list] = STATE(534),
    [sym_paren_list] = STATE(534),
    [sym_subset] = STATE(534),
    [sym_subset2] = STATE(534),
    [sym_dollar] = STATE(534),
    [sym_slot] = STATE(534),
    [sym_namespace_get] = STATE(534),
    [sym_namespace_get_internal] = STATE(534),
    [sym_pipe] = STATE(534),
    [sym_unary] = STATE(534),
    [sym_binary] = STATE(534),
    [sym_na] = STATE(534),
    [sym__expression] = STATE(534),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(534),
    [sym_string] = STATE(534),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(1237),
    [sym_next] = ACTIONS(1237),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [sym_null] = ACTIONS(1237),
    [sym_inf] = ACTIONS(1237),
    [sym_nan] = ACTIONS(1237),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(1235),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [175] = {
    [sym_function_definition] = STATE(542),
    [sym_lambda_function] = STATE(542),
    [sym_if] = STATE(542),
    [sym_while] = STATE(542),
    [sym_repeat] = STATE(542),
    [sym_for] = STATE(542),
    [sym_switch] = STATE(542),
    [sym_call] = STATE(542),
    [sym__assignment] = STATE(542),
    [sym_left_assignment] = STATE(542),
    [sym_left_assignment2] = STATE(542),
    [sym_equals_assignment] = STATE(542),
    [sym_super_assignment] = STATE(542),
    [sym_super_right_assignment] = STATE(542),
    [sym_right_assignment] = STATE(542),
    [sym_brace_list] = STATE(542),
    [sym_paren_list] = STATE(542),
    [sym_subset] = STATE(542),
    [sym_subset2] = STATE(542),
    [sym_dollar] = STATE(542),
    [sym_slot] = STATE(542),
    [sym_namespace_get] = STATE(542),
    [sym_namespace_get_internal] = STATE(542),
    [sym_pipe] = STATE(542),
    [sym_unary] = STATE(542),
    [sym_binary] = STATE(542),
    [sym_na] = STATE(542),
    [sym__expression] = STATE(542),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(542),
    [sym_string] = STATE(542),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1241),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1241),
    [sym_next] = ACTIONS(1241),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [sym_null] = ACTIONS(1241),
    [sym_inf] = ACTIONS(1241),
    [sym_nan] = ACTIONS(1241),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1239),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [176] = {
    [sym_function_definition] = STATE(545),
    [sym_lambda_function] = STATE(545),
    [sym_if] = STATE(545),
    [sym_while] = STATE(545),
    [sym_repeat] = STATE(545),
    [sym_for] = STATE(545),
    [sym_switch] = STATE(545),
    [sym_call] = STATE(545),
    [sym__assignment] = STATE(545),
    [sym_left_assignment] = STATE(545),
    [sym_left_assignment2] = STATE(545),
    [sym_equals_assignment] = STATE(545),
    [sym_super_assignment] = STATE(545),
    [sym_super_right_assignment] = STATE(545),
    [sym_right_assignment] = STATE(545),
    [sym_brace_list] = STATE(545),
    [sym_paren_list] = STATE(545),
    [sym_subset] = STATE(545),
    [sym_subset2] = STATE(545),
    [sym_dollar] = STATE(545),
    [sym_slot] = STATE(545),
    [sym_namespace_get] = STATE(545),
    [sym_namespace_get_internal] = STATE(545),
    [sym_pipe] = STATE(545),
    [sym_unary] = STATE(545),
    [sym_binary] = STATE(545),
    [sym_na] = STATE(545),
    [sym__expression] = STATE(545),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(545),
    [sym_string] = STATE(545),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1245),
    [sym_next] = ACTIONS(1245),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_inf] = ACTIONS(1245),
    [sym_nan] = ACTIONS(1245),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1243),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [177] = {
    [sym_function_definition] = STATE(546),
    [sym_lambda_function] = STATE(546),
    [sym_if] = STATE(546),
    [sym_while] = STATE(546),
    [sym_repeat] = STATE(546),
    [sym_for] = STATE(546),
    [sym_switch] = STATE(546),
    [sym_call] = STATE(546),
    [sym__assignment] = STATE(546),
    [sym_left_assignment] = STATE(546),
    [sym_left_assignment2] = STATE(546),
    [sym_equals_assignment] = STATE(546),
    [sym_super_assignment] = STATE(546),
    [sym_super_right_assignment] = STATE(546),
    [sym_right_assignment] = STATE(546),
    [sym_brace_list] = STATE(546),
    [sym_paren_list] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_subset2] = STATE(546),
    [sym_dollar] = STATE(546),
    [sym_slot] = STATE(546),
    [sym_namespace_get] = STATE(546),
    [sym_namespace_get_internal] = STATE(546),
    [sym_pipe] = STATE(546),
    [sym_unary] = STATE(546),
    [sym_binary] = STATE(546),
    [sym_na] = STATE(546),
    [sym__expression] = STATE(546),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(546),
    [sym_string] = STATE(546),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1249),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1249),
    [sym_next] = ACTIONS(1249),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [sym_null] = ACTIONS(1249),
    [sym_inf] = ACTIONS(1249),
    [sym_nan] = ACTIONS(1249),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1247),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [178] = {
    [sym_function_definition] = STATE(550),
    [sym_lambda_function] = STATE(550),
    [sym_if] = STATE(550),
    [sym_while] = STATE(550),
    [sym_repeat] = STATE(550),
    [sym_for] = STATE(550),
    [sym_switch] = STATE(550),
    [sym_call] = STATE(550),
    [sym__assignment] = STATE(550),
    [sym_left_assignment] = STATE(550),
    [sym_left_assignment2] = STATE(550),
    [sym_equals_assignment] = STATE(550),
    [sym_super_assignment] = STATE(550),
    [sym_super_right_assignment] = STATE(550),
    [sym_right_assignment] = STATE(550),
    [sym_brace_list] = STATE(550),
    [sym_paren_list] = STATE(550),
    [sym_subset] = STATE(550),
    [sym_subset2] = STATE(550),
    [sym_dollar] = STATE(550),
    [sym_slot] = STATE(550),
    [sym_namespace_get] = STATE(550),
    [sym_namespace_get_internal] = STATE(550),
    [sym_pipe] = STATE(550),
    [sym_unary] = STATE(550),
    [sym_binary] = STATE(550),
    [sym_na] = STATE(550),
    [sym__expression] = STATE(550),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(550),
    [sym_string] = STATE(550),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1253),
    [sym_next] = ACTIONS(1253),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_null] = ACTIONS(1253),
    [sym_inf] = ACTIONS(1253),
    [sym_nan] = ACTIONS(1253),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1251),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [179] = {
    [sym_function_definition] = STATE(551),
    [sym_lambda_function] = STATE(551),
    [sym_if] = STATE(551),
    [sym_while] = STATE(551),
    [sym_repeat] = STATE(551),
    [sym_for] = STATE(551),
    [sym_switch] = STATE(551),
    [sym_call] = STATE(551),
    [sym__assignment] = STATE(551),
    [sym_left_assignment] = STATE(551),
    [sym_left_assignment2] = STATE(551),
    [sym_equals_assignment] = STATE(551),
    [sym_super_assignment] = STATE(551),
    [sym_super_right_assignment] = STATE(551),
    [sym_right_assignment] = STATE(551),
    [sym_brace_list] = STATE(551),
    [sym_paren_list] = STATE(551),
    [sym_subset] = STATE(551),
    [sym_subset2] = STATE(551),
    [sym_dollar] = STATE(551),
    [sym_slot] = STATE(551),
    [sym_namespace_get] = STATE(551),
    [sym_namespace_get_internal] = STATE(551),
    [sym_pipe] = STATE(551),
    [sym_unary] = STATE(551),
    [sym_binary] = STATE(551),
    [sym_na] = STATE(551),
    [sym__expression] = STATE(551),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(551),
    [sym_string] = STATE(551),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1257),
    [sym_next] = ACTIONS(1257),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [sym_null] = ACTIONS(1257),
    [sym_inf] = ACTIONS(1257),
    [sym_nan] = ACTIONS(1257),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1255),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [180] = {
    [sym_function_definition] = STATE(552),
    [sym_lambda_function] = STATE(552),
    [sym_if] = STATE(552),
    [sym_while] = STATE(552),
    [sym_repeat] = STATE(552),
    [sym_for] = STATE(552),
    [sym_switch] = STATE(552),
    [sym_call] = STATE(552),
    [sym__assignment] = STATE(552),
    [sym_left_assignment] = STATE(552),
    [sym_left_assignment2] = STATE(552),
    [sym_equals_assignment] = STATE(552),
    [sym_super_assignment] = STATE(552),
    [sym_super_right_assignment] = STATE(552),
    [sym_right_assignment] = STATE(552),
    [sym_brace_list] = STATE(552),
    [sym_paren_list] = STATE(552),
    [sym_subset] = STATE(552),
    [sym_subset2] = STATE(552),
    [sym_dollar] = STATE(552),
    [sym_slot] = STATE(552),
    [sym_namespace_get] = STATE(552),
    [sym_namespace_get_internal] = STATE(552),
    [sym_pipe] = STATE(552),
    [sym_unary] = STATE(552),
    [sym_binary] = STATE(552),
    [sym_na] = STATE(552),
    [sym__expression] = STATE(552),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(552),
    [sym_string] = STATE(552),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1261),
    [sym_next] = ACTIONS(1261),
    [sym_true] = ACTIONS(1261),
    [sym_false] = ACTIONS(1261),
    [sym_null] = ACTIONS(1261),
    [sym_inf] = ACTIONS(1261),
    [sym_nan] = ACTIONS(1261),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1259),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [181] = {
    [sym_function_definition] = STATE(802),
    [sym_lambda_function] = STATE(802),
    [sym_if] = STATE(802),
    [sym_while] = STATE(802),
    [sym_repeat] = STATE(802),
    [sym_for] = STATE(802),
    [sym_switch] = STATE(802),
    [sym_call] = STATE(802),
    [sym__assignment] = STATE(802),
    [sym_left_assignment] = STATE(802),
    [sym_left_assignment2] = STATE(802),
    [sym_equals_assignment] = STATE(802),
    [sym_super_assignment] = STATE(802),
    [sym_super_right_assignment] = STATE(802),
    [sym_right_assignment] = STATE(802),
    [sym_brace_list] = STATE(802),
    [sym_paren_list] = STATE(802),
    [sym_subset] = STATE(802),
    [sym_subset2] = STATE(802),
    [sym_dollar] = STATE(802),
    [sym_slot] = STATE(802),
    [sym_namespace_get] = STATE(802),
    [sym_namespace_get_internal] = STATE(802),
    [sym_pipe] = STATE(802),
    [sym_unary] = STATE(802),
    [sym_binary] = STATE(802),
    [sym_na] = STATE(802),
    [sym__expression] = STATE(802),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(802),
    [sym_string] = STATE(802),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1265),
    [sym_next] = ACTIONS(1265),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [sym_null] = ACTIONS(1265),
    [sym_inf] = ACTIONS(1265),
    [sym_nan] = ACTIONS(1265),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1263),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [182] = {
    [sym_function_definition] = STATE(610),
    [sym_lambda_function] = STATE(610),
    [sym_if] = STATE(610),
    [sym_while] = STATE(610),
    [sym_repeat] = STATE(610),
    [sym_for] = STATE(610),
    [sym_switch] = STATE(610),
    [sym_call] = STATE(610),
    [sym__assignment] = STATE(610),
    [sym_left_assignment] = STATE(610),
    [sym_left_assignment2] = STATE(610),
    [sym_equals_assignment] = STATE(610),
    [sym_super_assignment] = STATE(610),
    [sym_super_right_assignment] = STATE(610),
    [sym_right_assignment] = STATE(610),
    [sym_brace_list] = STATE(610),
    [sym_paren_list] = STATE(610),
    [sym_subset] = STATE(610),
    [sym_subset2] = STATE(610),
    [sym_dollar] = STATE(610),
    [sym_slot] = STATE(610),
    [sym_namespace_get] = STATE(610),
    [sym_namespace_get_internal] = STATE(610),
    [sym_pipe] = STATE(610),
    [sym_unary] = STATE(610),
    [sym_binary] = STATE(610),
    [sym_na] = STATE(610),
    [sym__expression] = STATE(610),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(610),
    [sym_string] = STATE(610),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1269),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1269),
    [sym_next] = ACTIONS(1269),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [sym_null] = ACTIONS(1269),
    [sym_inf] = ACTIONS(1269),
    [sym_nan] = ACTIONS(1269),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1267),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [183] = {
    [sym_function_definition] = STATE(553),
    [sym_lambda_function] = STATE(553),
    [sym_if] = STATE(553),
    [sym_while] = STATE(553),
    [sym_repeat] = STATE(553),
    [sym_for] = STATE(553),
    [sym_switch] = STATE(553),
    [sym_call] = STATE(553),
    [sym__assignment] = STATE(553),
    [sym_left_assignment] = STATE(553),
    [sym_left_assignment2] = STATE(553),
    [sym_equals_assignment] = STATE(553),
    [sym_super_assignment] = STATE(553),
    [sym_super_right_assignment] = STATE(553),
    [sym_right_assignment] = STATE(553),
    [sym_brace_list] = STATE(553),
    [sym_paren_list] = STATE(553),
    [sym_subset] = STATE(553),
    [sym_subset2] = STATE(553),
    [sym_dollar] = STATE(553),
    [sym_slot] = STATE(553),
    [sym_namespace_get] = STATE(553),
    [sym_namespace_get_internal] = STATE(553),
    [sym_pipe] = STATE(553),
    [sym_unary] = STATE(553),
    [sym_binary] = STATE(553),
    [sym_na] = STATE(553),
    [sym__expression] = STATE(553),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(553),
    [sym_string] = STATE(553),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1273),
    [sym_next] = ACTIONS(1273),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [sym_null] = ACTIONS(1273),
    [sym_inf] = ACTIONS(1273),
    [sym_nan] = ACTIONS(1273),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1271),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [184] = {
    [sym_function_definition] = STATE(554),
    [sym_lambda_function] = STATE(554),
    [sym_if] = STATE(554),
    [sym_while] = STATE(554),
    [sym_repeat] = STATE(554),
    [sym_for] = STATE(554),
    [sym_switch] = STATE(554),
    [sym_call] = STATE(554),
    [sym__assignment] = STATE(554),
    [sym_left_assignment] = STATE(554),
    [sym_left_assignment2] = STATE(554),
    [sym_equals_assignment] = STATE(554),
    [sym_super_assignment] = STATE(554),
    [sym_super_right_assignment] = STATE(554),
    [sym_right_assignment] = STATE(554),
    [sym_brace_list] = STATE(554),
    [sym_paren_list] = STATE(554),
    [sym_subset] = STATE(554),
    [sym_subset2] = STATE(554),
    [sym_dollar] = STATE(554),
    [sym_slot] = STATE(554),
    [sym_namespace_get] = STATE(554),
    [sym_namespace_get_internal] = STATE(554),
    [sym_pipe] = STATE(554),
    [sym_unary] = STATE(554),
    [sym_binary] = STATE(554),
    [sym_na] = STATE(554),
    [sym__expression] = STATE(554),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(554),
    [sym_string] = STATE(554),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1277),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1277),
    [sym_next] = ACTIONS(1277),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [sym_null] = ACTIONS(1277),
    [sym_inf] = ACTIONS(1277),
    [sym_nan] = ACTIONS(1277),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1275),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [185] = {
    [sym_function_definition] = STATE(555),
    [sym_lambda_function] = STATE(555),
    [sym_if] = STATE(555),
    [sym_while] = STATE(555),
    [sym_repeat] = STATE(555),
    [sym_for] = STATE(555),
    [sym_switch] = STATE(555),
    [sym_call] = STATE(555),
    [sym__assignment] = STATE(555),
    [sym_left_assignment] = STATE(555),
    [sym_left_assignment2] = STATE(555),
    [sym_equals_assignment] = STATE(555),
    [sym_super_assignment] = STATE(555),
    [sym_super_right_assignment] = STATE(555),
    [sym_right_assignment] = STATE(555),
    [sym_brace_list] = STATE(555),
    [sym_paren_list] = STATE(555),
    [sym_subset] = STATE(555),
    [sym_subset2] = STATE(555),
    [sym_dollar] = STATE(555),
    [sym_slot] = STATE(555),
    [sym_namespace_get] = STATE(555),
    [sym_namespace_get_internal] = STATE(555),
    [sym_pipe] = STATE(555),
    [sym_unary] = STATE(555),
    [sym_binary] = STATE(555),
    [sym_na] = STATE(555),
    [sym__expression] = STATE(555),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(555),
    [sym_string] = STATE(555),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1281),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1281),
    [sym_next] = ACTIONS(1281),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [sym_null] = ACTIONS(1281),
    [sym_inf] = ACTIONS(1281),
    [sym_nan] = ACTIONS(1281),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1279),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [186] = {
    [sym_function_definition] = STATE(570),
    [sym_lambda_function] = STATE(570),
    [sym_if] = STATE(570),
    [sym_while] = STATE(570),
    [sym_repeat] = STATE(570),
    [sym_for] = STATE(570),
    [sym_switch] = STATE(570),
    [sym_call] = STATE(570),
    [sym__assignment] = STATE(570),
    [sym_left_assignment] = STATE(570),
    [sym_left_assignment2] = STATE(570),
    [sym_equals_assignment] = STATE(570),
    [sym_super_assignment] = STATE(570),
    [sym_super_right_assignment] = STATE(570),
    [sym_right_assignment] = STATE(570),
    [sym_brace_list] = STATE(570),
    [sym_paren_list] = STATE(570),
    [sym_subset] = STATE(570),
    [sym_subset2] = STATE(570),
    [sym_dollar] = STATE(570),
    [sym_slot] = STATE(570),
    [sym_namespace_get] = STATE(570),
    [sym_namespace_get_internal] = STATE(570),
    [sym_pipe] = STATE(570),
    [sym_unary] = STATE(570),
    [sym_binary] = STATE(570),
    [sym_na] = STATE(570),
    [sym__expression] = STATE(570),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(570),
    [sym_string] = STATE(570),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1285),
    [sym_next] = ACTIONS(1285),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [sym_null] = ACTIONS(1285),
    [sym_inf] = ACTIONS(1285),
    [sym_nan] = ACTIONS(1285),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1283),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [187] = {
    [sym_function_definition] = STATE(556),
    [sym_lambda_function] = STATE(556),
    [sym_if] = STATE(556),
    [sym_while] = STATE(556),
    [sym_repeat] = STATE(556),
    [sym_for] = STATE(556),
    [sym_switch] = STATE(556),
    [sym_call] = STATE(556),
    [sym__assignment] = STATE(556),
    [sym_left_assignment] = STATE(556),
    [sym_left_assignment2] = STATE(556),
    [sym_equals_assignment] = STATE(556),
    [sym_super_assignment] = STATE(556),
    [sym_super_right_assignment] = STATE(556),
    [sym_right_assignment] = STATE(556),
    [sym_brace_list] = STATE(556),
    [sym_paren_list] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym_dollar] = STATE(556),
    [sym_slot] = STATE(556),
    [sym_namespace_get] = STATE(556),
    [sym_namespace_get_internal] = STATE(556),
    [sym_pipe] = STATE(556),
    [sym_unary] = STATE(556),
    [sym_binary] = STATE(556),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(556),
    [sym_string] = STATE(556),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1289),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1289),
    [sym_next] = ACTIONS(1289),
    [sym_true] = ACTIONS(1289),
    [sym_false] = ACTIONS(1289),
    [sym_null] = ACTIONS(1289),
    [sym_inf] = ACTIONS(1289),
    [sym_nan] = ACTIONS(1289),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1287),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [188] = {
    [sym_function_definition] = STATE(557),
    [sym_lambda_function] = STATE(557),
    [sym_if] = STATE(557),
    [sym_while] = STATE(557),
    [sym_repeat] = STATE(557),
    [sym_for] = STATE(557),
    [sym_switch] = STATE(557),
    [sym_call] = STATE(557),
    [sym__assignment] = STATE(557),
    [sym_left_assignment] = STATE(557),
    [sym_left_assignment2] = STATE(557),
    [sym_equals_assignment] = STATE(557),
    [sym_super_assignment] = STATE(557),
    [sym_super_right_assignment] = STATE(557),
    [sym_right_assignment] = STATE(557),
    [sym_brace_list] = STATE(557),
    [sym_paren_list] = STATE(557),
    [sym_subset] = STATE(557),
    [sym_subset2] = STATE(557),
    [sym_dollar] = STATE(557),
    [sym_slot] = STATE(557),
    [sym_namespace_get] = STATE(557),
    [sym_namespace_get_internal] = STATE(557),
    [sym_pipe] = STATE(557),
    [sym_unary] = STATE(557),
    [sym_binary] = STATE(557),
    [sym_na] = STATE(557),
    [sym__expression] = STATE(557),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(557),
    [sym_string] = STATE(557),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1293),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1293),
    [sym_next] = ACTIONS(1293),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [sym_null] = ACTIONS(1293),
    [sym_inf] = ACTIONS(1293),
    [sym_nan] = ACTIONS(1293),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [189] = {
    [sym_function_definition] = STATE(558),
    [sym_lambda_function] = STATE(558),
    [sym_if] = STATE(558),
    [sym_while] = STATE(558),
    [sym_repeat] = STATE(558),
    [sym_for] = STATE(558),
    [sym_switch] = STATE(558),
    [sym_call] = STATE(558),
    [sym__assignment] = STATE(558),
    [sym_left_assignment] = STATE(558),
    [sym_left_assignment2] = STATE(558),
    [sym_equals_assignment] = STATE(558),
    [sym_super_assignment] = STATE(558),
    [sym_super_right_assignment] = STATE(558),
    [sym_right_assignment] = STATE(558),
    [sym_brace_list] = STATE(558),
    [sym_paren_list] = STATE(558),
    [sym_subset] = STATE(558),
    [sym_subset2] = STATE(558),
    [sym_dollar] = STATE(558),
    [sym_slot] = STATE(558),
    [sym_namespace_get] = STATE(558),
    [sym_namespace_get_internal] = STATE(558),
    [sym_pipe] = STATE(558),
    [sym_unary] = STATE(558),
    [sym_binary] = STATE(558),
    [sym_na] = STATE(558),
    [sym__expression] = STATE(558),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(558),
    [sym_string] = STATE(558),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1297),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1297),
    [sym_next] = ACTIONS(1297),
    [sym_true] = ACTIONS(1297),
    [sym_false] = ACTIONS(1297),
    [sym_null] = ACTIONS(1297),
    [sym_inf] = ACTIONS(1297),
    [sym_nan] = ACTIONS(1297),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [190] = {
    [sym_function_definition] = STATE(559),
    [sym_lambda_function] = STATE(559),
    [sym_if] = STATE(559),
    [sym_while] = STATE(559),
    [sym_repeat] = STATE(559),
    [sym_for] = STATE(559),
    [sym_switch] = STATE(559),
    [sym_call] = STATE(559),
    [sym__assignment] = STATE(559),
    [sym_left_assignment] = STATE(559),
    [sym_left_assignment2] = STATE(559),
    [sym_equals_assignment] = STATE(559),
    [sym_super_assignment] = STATE(559),
    [sym_super_right_assignment] = STATE(559),
    [sym_right_assignment] = STATE(559),
    [sym_brace_list] = STATE(559),
    [sym_paren_list] = STATE(559),
    [sym_subset] = STATE(559),
    [sym_subset2] = STATE(559),
    [sym_dollar] = STATE(559),
    [sym_slot] = STATE(559),
    [sym_namespace_get] = STATE(559),
    [sym_namespace_get_internal] = STATE(559),
    [sym_pipe] = STATE(559),
    [sym_unary] = STATE(559),
    [sym_binary] = STATE(559),
    [sym_na] = STATE(559),
    [sym__expression] = STATE(559),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(559),
    [sym_string] = STATE(559),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1301),
    [sym_next] = ACTIONS(1301),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_inf] = ACTIONS(1301),
    [sym_nan] = ACTIONS(1301),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1299),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [191] = {
    [sym_function_definition] = STATE(560),
    [sym_lambda_function] = STATE(560),
    [sym_if] = STATE(560),
    [sym_while] = STATE(560),
    [sym_repeat] = STATE(560),
    [sym_for] = STATE(560),
    [sym_switch] = STATE(560),
    [sym_call] = STATE(560),
    [sym__assignment] = STATE(560),
    [sym_left_assignment] = STATE(560),
    [sym_left_assignment2] = STATE(560),
    [sym_equals_assignment] = STATE(560),
    [sym_super_assignment] = STATE(560),
    [sym_super_right_assignment] = STATE(560),
    [sym_right_assignment] = STATE(560),
    [sym_brace_list] = STATE(560),
    [sym_paren_list] = STATE(560),
    [sym_subset] = STATE(560),
    [sym_subset2] = STATE(560),
    [sym_dollar] = STATE(560),
    [sym_slot] = STATE(560),
    [sym_namespace_get] = STATE(560),
    [sym_namespace_get_internal] = STATE(560),
    [sym_pipe] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_na] = STATE(560),
    [sym__expression] = STATE(560),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(560),
    [sym_string] = STATE(560),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1305),
    [sym_next] = ACTIONS(1305),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [sym_null] = ACTIONS(1305),
    [sym_inf] = ACTIONS(1305),
    [sym_nan] = ACTIONS(1305),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1303),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [192] = {
    [sym_function_definition] = STATE(912),
    [sym_lambda_function] = STATE(912),
    [sym_if] = STATE(912),
    [sym_while] = STATE(912),
    [sym_repeat] = STATE(912),
    [sym_for] = STATE(912),
    [sym_switch] = STATE(912),
    [sym_call] = STATE(912),
    [sym__assignment] = STATE(912),
    [sym_left_assignment] = STATE(912),
    [sym_left_assignment2] = STATE(912),
    [sym_equals_assignment] = STATE(912),
    [sym_super_assignment] = STATE(912),
    [sym_super_right_assignment] = STATE(912),
    [sym_right_assignment] = STATE(912),
    [sym_brace_list] = STATE(912),
    [sym_paren_list] = STATE(912),
    [sym_subset] = STATE(912),
    [sym_subset2] = STATE(912),
    [sym_dollar] = STATE(912),
    [sym_slot] = STATE(912),
    [sym_namespace_get] = STATE(912),
    [sym_namespace_get_internal] = STATE(912),
    [sym_pipe] = STATE(912),
    [sym_unary] = STATE(912),
    [sym_binary] = STATE(912),
    [sym_na] = STATE(912),
    [sym__expression] = STATE(912),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(912),
    [sym_string] = STATE(912),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1309),
    [sym_next] = ACTIONS(1309),
    [sym_true] = ACTIONS(1309),
    [sym_false] = ACTIONS(1309),
    [sym_null] = ACTIONS(1309),
    [sym_inf] = ACTIONS(1309),
    [sym_nan] = ACTIONS(1309),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1307),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [193] = {
    [sym_function_definition] = STATE(482),
    [sym_lambda_function] = STATE(482),
    [sym_if] = STATE(482),
    [sym_while] = STATE(482),
    [sym_repeat] = STATE(482),
    [sym_for] = STATE(482),
    [sym_switch] = STATE(482),
    [sym_call] = STATE(482),
    [sym__assignment] = STATE(482),
    [sym_left_assignment] = STATE(482),
    [sym_left_assignment2] = STATE(482),
    [sym_equals_assignment] = STATE(482),
    [sym_super_assignment] = STATE(482),
    [sym_super_right_assignment] = STATE(482),
    [sym_right_assignment] = STATE(482),
    [sym_brace_list] = STATE(482),
    [sym_paren_list] = STATE(482),
    [sym_subset] = STATE(482),
    [sym_subset2] = STATE(482),
    [sym_dollar] = STATE(482),
    [sym_slot] = STATE(482),
    [sym_namespace_get] = STATE(482),
    [sym_namespace_get_internal] = STATE(482),
    [sym_pipe] = STATE(482),
    [sym_unary] = STATE(482),
    [sym_binary] = STATE(482),
    [sym_na] = STATE(482),
    [sym__expression] = STATE(482),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(482),
    [sym_string] = STATE(482),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1313),
    [sym_next] = ACTIONS(1313),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_inf] = ACTIONS(1313),
    [sym_nan] = ACTIONS(1313),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1311),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [194] = {
    [sym_function_definition] = STATE(900),
    [sym_lambda_function] = STATE(900),
    [sym_if] = STATE(900),
    [sym_while] = STATE(900),
    [sym_repeat] = STATE(900),
    [sym_for] = STATE(900),
    [sym_switch] = STATE(900),
    [sym_call] = STATE(900),
    [sym__assignment] = STATE(900),
    [sym_left_assignment] = STATE(900),
    [sym_left_assignment2] = STATE(900),
    [sym_equals_assignment] = STATE(900),
    [sym_super_assignment] = STATE(900),
    [sym_super_right_assignment] = STATE(900),
    [sym_right_assignment] = STATE(900),
    [sym_brace_list] = STATE(900),
    [sym_paren_list] = STATE(900),
    [sym_subset] = STATE(900),
    [sym_subset2] = STATE(900),
    [sym_dollar] = STATE(900),
    [sym_slot] = STATE(900),
    [sym_namespace_get] = STATE(900),
    [sym_namespace_get_internal] = STATE(900),
    [sym_pipe] = STATE(900),
    [sym_unary] = STATE(900),
    [sym_binary] = STATE(900),
    [sym_na] = STATE(900),
    [sym__expression] = STATE(900),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(900),
    [sym_string] = STATE(900),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1317),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1317),
    [sym_next] = ACTIONS(1317),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [sym_null] = ACTIONS(1317),
    [sym_inf] = ACTIONS(1317),
    [sym_nan] = ACTIONS(1317),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1315),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [195] = {
    [sym_function_definition] = STATE(512),
    [sym_lambda_function] = STATE(512),
    [sym_if] = STATE(512),
    [sym_while] = STATE(512),
    [sym_repeat] = STATE(512),
    [sym_for] = STATE(512),
    [sym_switch] = STATE(512),
    [sym_call] = STATE(512),
    [sym__assignment] = STATE(512),
    [sym_left_assignment] = STATE(512),
    [sym_left_assignment2] = STATE(512),
    [sym_equals_assignment] = STATE(512),
    [sym_super_assignment] = STATE(512),
    [sym_super_right_assignment] = STATE(512),
    [sym_right_assignment] = STATE(512),
    [sym_brace_list] = STATE(512),
    [sym_paren_list] = STATE(512),
    [sym_subset] = STATE(512),
    [sym_subset2] = STATE(512),
    [sym_dollar] = STATE(512),
    [sym_slot] = STATE(512),
    [sym_namespace_get] = STATE(512),
    [sym_namespace_get_internal] = STATE(512),
    [sym_pipe] = STATE(512),
    [sym_unary] = STATE(512),
    [sym_binary] = STATE(512),
    [sym_na] = STATE(512),
    [sym__expression] = STATE(512),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(512),
    [sym_string] = STATE(512),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1321),
    [sym_next] = ACTIONS(1321),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [sym_null] = ACTIONS(1321),
    [sym_inf] = ACTIONS(1321),
    [sym_nan] = ACTIONS(1321),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1319),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [196] = {
    [sym_function_definition] = STATE(505),
    [sym_lambda_function] = STATE(505),
    [sym_if] = STATE(505),
    [sym_while] = STATE(505),
    [sym_repeat] = STATE(505),
    [sym_for] = STATE(505),
    [sym_switch] = STATE(505),
    [sym_call] = STATE(505),
    [sym__assignment] = STATE(505),
    [sym_left_assignment] = STATE(505),
    [sym_left_assignment2] = STATE(505),
    [sym_equals_assignment] = STATE(505),
    [sym_super_assignment] = STATE(505),
    [sym_super_right_assignment] = STATE(505),
    [sym_right_assignment] = STATE(505),
    [sym_brace_list] = STATE(505),
    [sym_paren_list] = STATE(505),
    [sym_subset] = STATE(505),
    [sym_subset2] = STATE(505),
    [sym_dollar] = STATE(505),
    [sym_slot] = STATE(505),
    [sym_namespace_get] = STATE(505),
    [sym_namespace_get_internal] = STATE(505),
    [sym_pipe] = STATE(505),
    [sym_unary] = STATE(505),
    [sym_binary] = STATE(505),
    [sym_na] = STATE(505),
    [sym__expression] = STATE(505),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(505),
    [sym_string] = STATE(505),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1325),
    [sym_next] = ACTIONS(1325),
    [sym_true] = ACTIONS(1325),
    [sym_false] = ACTIONS(1325),
    [sym_null] = ACTIONS(1325),
    [sym_inf] = ACTIONS(1325),
    [sym_nan] = ACTIONS(1325),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1323),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [197] = {
    [sym_function_definition] = STATE(501),
    [sym_lambda_function] = STATE(501),
    [sym_if] = STATE(501),
    [sym_while] = STATE(501),
    [sym_repeat] = STATE(501),
    [sym_for] = STATE(501),
    [sym_switch] = STATE(501),
    [sym_call] = STATE(501),
    [sym__assignment] = STATE(501),
    [sym_left_assignment] = STATE(501),
    [sym_left_assignment2] = STATE(501),
    [sym_equals_assignment] = STATE(501),
    [sym_super_assignment] = STATE(501),
    [sym_super_right_assignment] = STATE(501),
    [sym_right_assignment] = STATE(501),
    [sym_brace_list] = STATE(501),
    [sym_paren_list] = STATE(501),
    [sym_subset] = STATE(501),
    [sym_subset2] = STATE(501),
    [sym_dollar] = STATE(501),
    [sym_slot] = STATE(501),
    [sym_namespace_get] = STATE(501),
    [sym_namespace_get_internal] = STATE(501),
    [sym_pipe] = STATE(501),
    [sym_unary] = STATE(501),
    [sym_binary] = STATE(501),
    [sym_na] = STATE(501),
    [sym__expression] = STATE(501),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(501),
    [sym_string] = STATE(501),
    [anon_sym_SEMI] = ACTIONS(1327),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1329),
    [sym_next] = ACTIONS(1329),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [sym_null] = ACTIONS(1329),
    [sym_inf] = ACTIONS(1329),
    [sym_nan] = ACTIONS(1329),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1327),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [198] = {
    [sym_function_definition] = STATE(500),
    [sym_lambda_function] = STATE(500),
    [sym_if] = STATE(500),
    [sym_while] = STATE(500),
    [sym_repeat] = STATE(500),
    [sym_for] = STATE(500),
    [sym_switch] = STATE(500),
    [sym_call] = STATE(500),
    [sym__assignment] = STATE(500),
    [sym_left_assignment] = STATE(500),
    [sym_left_assignment2] = STATE(500),
    [sym_equals_assignment] = STATE(500),
    [sym_super_assignment] = STATE(500),
    [sym_super_right_assignment] = STATE(500),
    [sym_right_assignment] = STATE(500),
    [sym_brace_list] = STATE(500),
    [sym_paren_list] = STATE(500),
    [sym_subset] = STATE(500),
    [sym_subset2] = STATE(500),
    [sym_dollar] = STATE(500),
    [sym_slot] = STATE(500),
    [sym_namespace_get] = STATE(500),
    [sym_namespace_get_internal] = STATE(500),
    [sym_pipe] = STATE(500),
    [sym_unary] = STATE(500),
    [sym_binary] = STATE(500),
    [sym_na] = STATE(500),
    [sym__expression] = STATE(500),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(500),
    [sym_string] = STATE(500),
    [anon_sym_SEMI] = ACTIONS(1331),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1333),
    [sym_next] = ACTIONS(1333),
    [sym_true] = ACTIONS(1333),
    [sym_false] = ACTIONS(1333),
    [sym_null] = ACTIONS(1333),
    [sym_inf] = ACTIONS(1333),
    [sym_nan] = ACTIONS(1333),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1331),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [199] = {
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_function] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(657),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_RPAREN] = ACTIONS(657),
    [anon_sym_while] = ACTIONS(659),
    [anon_sym_repeat] = ACTIONS(659),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(659),
    [anon_sym_COMMA] = ACTIONS(657),
    [anon_sym_EQ] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_LT_DASH] = ACTIONS(657),
    [anon_sym_COLON_EQ] = ACTIONS(657),
    [anon_sym_LT_LT_DASH] = ACTIONS(657),
    [anon_sym_DASH_GT_GT] = ACTIONS(657),
    [anon_sym_DASH_GT] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_RBRACK] = ACTIONS(657),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(657),
    [anon_sym_AT] = ACTIONS(657),
    [anon_sym_COLON_COLON] = ACTIONS(659),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(657),
    [sym_dots] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(657),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(657),
    [anon_sym_BANG] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_SLASH] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_LT] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_LT_EQ] = ACTIONS(657),
    [anon_sym_GT_EQ] = ACTIONS(657),
    [anon_sym_EQ_EQ] = ACTIONS(657),
    [anon_sym_BANG_EQ] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(659),
    [sym_break] = ACTIONS(659),
    [sym_next] = ACTIONS(659),
    [sym_true] = ACTIONS(659),
    [sym_false] = ACTIONS(659),
    [sym_null] = ACTIONS(659),
    [sym_inf] = ACTIONS(659),
    [sym_nan] = ACTIONS(659),
    [anon_sym_NA] = ACTIONS(659),
    [anon_sym_NA_character_] = ACTIONS(659),
    [anon_sym_NA_complex_] = ACTIONS(659),
    [anon_sym_NA_integer_] = ACTIONS(659),
    [anon_sym_NA_real_] = ACTIONS(659),
    [aux_sym_identifier_token1] = ACTIONS(659),
    [anon_sym_BQUOTE] = ACTIONS(657),
    [sym_integer] = ACTIONS(657),
    [sym_float] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_PERCENT] = ACTIONS(657),
  },
  [200] = {
    [sym_function_definition] = STATE(801),
    [sym_lambda_function] = STATE(801),
    [sym_if] = STATE(801),
    [sym_while] = STATE(801),
    [sym_repeat] = STATE(801),
    [sym_for] = STATE(801),
    [sym_switch] = STATE(801),
    [sym_call] = STATE(801),
    [sym__assignment] = STATE(801),
    [sym_left_assignment] = STATE(801),
    [sym_left_assignment2] = STATE(801),
    [sym_equals_assignment] = STATE(801),
    [sym_super_assignment] = STATE(801),
    [sym_super_right_assignment] = STATE(801),
    [sym_right_assignment] = STATE(801),
    [sym_brace_list] = STATE(801),
    [sym_paren_list] = STATE(801),
    [sym_subset] = STATE(801),
    [sym_subset2] = STATE(801),
    [sym_dollar] = STATE(801),
    [sym_slot] = STATE(801),
    [sym_namespace_get] = STATE(801),
    [sym_namespace_get_internal] = STATE(801),
    [sym_pipe] = STATE(801),
    [sym_unary] = STATE(801),
    [sym_binary] = STATE(801),
    [sym_na] = STATE(801),
    [sym__expression] = STATE(801),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(801),
    [sym_string] = STATE(801),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1337),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1337),
    [sym_next] = ACTIONS(1337),
    [sym_true] = ACTIONS(1337),
    [sym_false] = ACTIONS(1337),
    [sym_null] = ACTIONS(1337),
    [sym_inf] = ACTIONS(1337),
    [sym_nan] = ACTIONS(1337),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1335),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [201] = {
    [sym_function_definition] = STATE(499),
    [sym_lambda_function] = STATE(499),
    [sym_if] = STATE(499),
    [sym_while] = STATE(499),
    [sym_repeat] = STATE(499),
    [sym_for] = STATE(499),
    [sym_switch] = STATE(499),
    [sym_call] = STATE(499),
    [sym__assignment] = STATE(499),
    [sym_left_assignment] = STATE(499),
    [sym_left_assignment2] = STATE(499),
    [sym_equals_assignment] = STATE(499),
    [sym_super_assignment] = STATE(499),
    [sym_super_right_assignment] = STATE(499),
    [sym_right_assignment] = STATE(499),
    [sym_brace_list] = STATE(499),
    [sym_paren_list] = STATE(499),
    [sym_subset] = STATE(499),
    [sym_subset2] = STATE(499),
    [sym_dollar] = STATE(499),
    [sym_slot] = STATE(499),
    [sym_namespace_get] = STATE(499),
    [sym_namespace_get_internal] = STATE(499),
    [sym_pipe] = STATE(499),
    [sym_unary] = STATE(499),
    [sym_binary] = STATE(499),
    [sym_na] = STATE(499),
    [sym__expression] = STATE(499),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(499),
    [sym_string] = STATE(499),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1341),
    [sym_next] = ACTIONS(1341),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [sym_null] = ACTIONS(1341),
    [sym_inf] = ACTIONS(1341),
    [sym_nan] = ACTIONS(1341),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1339),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [202] = {
    [sym_function_definition] = STATE(920),
    [sym_lambda_function] = STATE(920),
    [sym_if] = STATE(920),
    [sym_while] = STATE(920),
    [sym_repeat] = STATE(920),
    [sym_for] = STATE(920),
    [sym_switch] = STATE(920),
    [sym_call] = STATE(713),
    [sym__assignment] = STATE(920),
    [sym_left_assignment] = STATE(920),
    [sym_left_assignment2] = STATE(920),
    [sym_equals_assignment] = STATE(920),
    [sym_super_assignment] = STATE(920),
    [sym_super_right_assignment] = STATE(920),
    [sym_right_assignment] = STATE(920),
    [sym_brace_list] = STATE(920),
    [sym_paren_list] = STATE(920),
    [sym_subset] = STATE(920),
    [sym_subset2] = STATE(920),
    [sym_dollar] = STATE(920),
    [sym_slot] = STATE(920),
    [sym_namespace_get] = STATE(920),
    [sym_namespace_get_internal] = STATE(920),
    [sym_pipe] = STATE(920),
    [sym_unary] = STATE(920),
    [sym_binary] = STATE(920),
    [sym_na] = STATE(920),
    [sym__expression] = STATE(920),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(920),
    [sym_string] = STATE(920),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1345),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1345),
    [sym_next] = ACTIONS(1345),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [sym_null] = ACTIONS(1345),
    [sym_inf] = ACTIONS(1345),
    [sym_nan] = ACTIONS(1345),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1343),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [203] = {
    [sym_function_definition] = STATE(498),
    [sym_lambda_function] = STATE(498),
    [sym_if] = STATE(498),
    [sym_while] = STATE(498),
    [sym_repeat] = STATE(498),
    [sym_for] = STATE(498),
    [sym_switch] = STATE(498),
    [sym_call] = STATE(498),
    [sym__assignment] = STATE(498),
    [sym_left_assignment] = STATE(498),
    [sym_left_assignment2] = STATE(498),
    [sym_equals_assignment] = STATE(498),
    [sym_super_assignment] = STATE(498),
    [sym_super_right_assignment] = STATE(498),
    [sym_right_assignment] = STATE(498),
    [sym_brace_list] = STATE(498),
    [sym_paren_list] = STATE(498),
    [sym_subset] = STATE(498),
    [sym_subset2] = STATE(498),
    [sym_dollar] = STATE(498),
    [sym_slot] = STATE(498),
    [sym_namespace_get] = STATE(498),
    [sym_namespace_get_internal] = STATE(498),
    [sym_pipe] = STATE(498),
    [sym_unary] = STATE(498),
    [sym_binary] = STATE(498),
    [sym_na] = STATE(498),
    [sym__expression] = STATE(498),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(498),
    [sym_string] = STATE(498),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1349),
    [sym_next] = ACTIONS(1349),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [sym_null] = ACTIONS(1349),
    [sym_inf] = ACTIONS(1349),
    [sym_nan] = ACTIONS(1349),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [204] = {
    [sym_function_definition] = STATE(413),
    [sym_lambda_function] = STATE(413),
    [sym_if] = STATE(413),
    [sym_while] = STATE(413),
    [sym_repeat] = STATE(413),
    [sym_for] = STATE(413),
    [sym_switch] = STATE(413),
    [sym_call] = STATE(413),
    [sym__assignment] = STATE(413),
    [sym_left_assignment] = STATE(413),
    [sym_left_assignment2] = STATE(413),
    [sym_equals_assignment] = STATE(413),
    [sym_super_assignment] = STATE(413),
    [sym_super_right_assignment] = STATE(413),
    [sym_right_assignment] = STATE(413),
    [sym_brace_list] = STATE(413),
    [sym_paren_list] = STATE(413),
    [sym_subset] = STATE(413),
    [sym_subset2] = STATE(413),
    [sym_dollar] = STATE(413),
    [sym_slot] = STATE(413),
    [sym_namespace_get] = STATE(413),
    [sym_namespace_get_internal] = STATE(413),
    [sym_pipe] = STATE(413),
    [sym_unary] = STATE(413),
    [sym_binary] = STATE(413),
    [sym_na] = STATE(413),
    [sym__expression] = STATE(413),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(413),
    [sym_string] = STATE(413),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1353),
    [sym_next] = ACTIONS(1353),
    [sym_true] = ACTIONS(1353),
    [sym_false] = ACTIONS(1353),
    [sym_null] = ACTIONS(1353),
    [sym_inf] = ACTIONS(1353),
    [sym_nan] = ACTIONS(1353),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1351),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [205] = {
    [sym_function_definition] = STATE(497),
    [sym_lambda_function] = STATE(497),
    [sym_if] = STATE(497),
    [sym_while] = STATE(497),
    [sym_repeat] = STATE(497),
    [sym_for] = STATE(497),
    [sym_switch] = STATE(497),
    [sym_call] = STATE(497),
    [sym__assignment] = STATE(497),
    [sym_left_assignment] = STATE(497),
    [sym_left_assignment2] = STATE(497),
    [sym_equals_assignment] = STATE(497),
    [sym_super_assignment] = STATE(497),
    [sym_super_right_assignment] = STATE(497),
    [sym_right_assignment] = STATE(497),
    [sym_brace_list] = STATE(497),
    [sym_paren_list] = STATE(497),
    [sym_subset] = STATE(497),
    [sym_subset2] = STATE(497),
    [sym_dollar] = STATE(497),
    [sym_slot] = STATE(497),
    [sym_namespace_get] = STATE(497),
    [sym_namespace_get_internal] = STATE(497),
    [sym_pipe] = STATE(497),
    [sym_unary] = STATE(497),
    [sym_binary] = STATE(497),
    [sym_na] = STATE(497),
    [sym__expression] = STATE(497),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(497),
    [sym_string] = STATE(497),
    [anon_sym_SEMI] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1357),
    [sym_next] = ACTIONS(1357),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [sym_null] = ACTIONS(1357),
    [sym_inf] = ACTIONS(1357),
    [sym_nan] = ACTIONS(1357),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1355),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [206] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1359),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_COMMA] = ACTIONS(1359),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(901),
    [anon_sym_COLON_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT_GT] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1359),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1361),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [aux_sym_identifier_token1] = ACTIONS(1361),
    [anon_sym_BQUOTE] = ACTIONS(1359),
    [sym_integer] = ACTIONS(1359),
    [sym_float] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [207] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1363),
    [anon_sym_else] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_COMMA] = ACTIONS(1363),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_LT_DASH] = ACTIONS(901),
    [anon_sym_COLON_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT_GT] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1365),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [aux_sym_identifier_token1] = ACTIONS(1365),
    [anon_sym_BQUOTE] = ACTIONS(1363),
    [sym_integer] = ACTIONS(1363),
    [sym_float] = ACTIONS(1365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [208] = {
    [sym_function_definition] = STATE(495),
    [sym_lambda_function] = STATE(495),
    [sym_if] = STATE(495),
    [sym_while] = STATE(495),
    [sym_repeat] = STATE(495),
    [sym_for] = STATE(495),
    [sym_switch] = STATE(495),
    [sym_call] = STATE(495),
    [sym__assignment] = STATE(495),
    [sym_left_assignment] = STATE(495),
    [sym_left_assignment2] = STATE(495),
    [sym_equals_assignment] = STATE(495),
    [sym_super_assignment] = STATE(495),
    [sym_super_right_assignment] = STATE(495),
    [sym_right_assignment] = STATE(495),
    [sym_brace_list] = STATE(495),
    [sym_paren_list] = STATE(495),
    [sym_subset] = STATE(495),
    [sym_subset2] = STATE(495),
    [sym_dollar] = STATE(495),
    [sym_slot] = STATE(495),
    [sym_namespace_get] = STATE(495),
    [sym_namespace_get_internal] = STATE(495),
    [sym_pipe] = STATE(495),
    [sym_unary] = STATE(495),
    [sym_binary] = STATE(495),
    [sym_na] = STATE(495),
    [sym__expression] = STATE(495),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(495),
    [sym_string] = STATE(495),
    [anon_sym_SEMI] = ACTIONS(1367),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1369),
    [sym_next] = ACTIONS(1369),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [sym_null] = ACTIONS(1369),
    [sym_inf] = ACTIONS(1369),
    [sym_nan] = ACTIONS(1369),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1367),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [209] = {
    [sym_function_definition] = STATE(206),
    [sym_lambda_function] = STATE(206),
    [sym_if] = STATE(206),
    [sym_while] = STATE(206),
    [sym_repeat] = STATE(206),
    [sym_for] = STATE(206),
    [sym_switch] = STATE(206),
    [sym_call] = STATE(206),
    [sym__assignment] = STATE(206),
    [sym_left_assignment] = STATE(206),
    [sym_left_assignment2] = STATE(206),
    [sym_equals_assignment] = STATE(206),
    [sym_super_assignment] = STATE(206),
    [sym_super_right_assignment] = STATE(206),
    [sym_right_assignment] = STATE(206),
    [sym_brace_list] = STATE(206),
    [sym_paren_list] = STATE(206),
    [sym_subset] = STATE(206),
    [sym_subset2] = STATE(206),
    [sym_dollar] = STATE(206),
    [sym_slot] = STATE(206),
    [sym_namespace_get] = STATE(206),
    [sym_namespace_get_internal] = STATE(206),
    [sym_pipe] = STATE(206),
    [sym_unary] = STATE(206),
    [sym_binary] = STATE(206),
    [sym_na] = STATE(206),
    [sym__expression] = STATE(206),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(206),
    [sym_string] = STATE(206),
    [anon_sym_SEMI] = ACTIONS(1371),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1373),
    [sym_next] = ACTIONS(1373),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [sym_null] = ACTIONS(1373),
    [sym_inf] = ACTIONS(1373),
    [sym_nan] = ACTIONS(1373),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1371),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [210] = {
    [sym_function_definition] = STATE(207),
    [sym_lambda_function] = STATE(207),
    [sym_if] = STATE(207),
    [sym_while] = STATE(207),
    [sym_repeat] = STATE(207),
    [sym_for] = STATE(207),
    [sym_switch] = STATE(207),
    [sym_call] = STATE(207),
    [sym__assignment] = STATE(207),
    [sym_left_assignment] = STATE(207),
    [sym_left_assignment2] = STATE(207),
    [sym_equals_assignment] = STATE(207),
    [sym_super_assignment] = STATE(207),
    [sym_super_right_assignment] = STATE(207),
    [sym_right_assignment] = STATE(207),
    [sym_brace_list] = STATE(207),
    [sym_paren_list] = STATE(207),
    [sym_subset] = STATE(207),
    [sym_subset2] = STATE(207),
    [sym_dollar] = STATE(207),
    [sym_slot] = STATE(207),
    [sym_namespace_get] = STATE(207),
    [sym_namespace_get_internal] = STATE(207),
    [sym_pipe] = STATE(207),
    [sym_unary] = STATE(207),
    [sym_binary] = STATE(207),
    [sym_na] = STATE(207),
    [sym__expression] = STATE(207),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(207),
    [sym_string] = STATE(207),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1377),
    [sym_next] = ACTIONS(1377),
    [sym_true] = ACTIONS(1377),
    [sym_false] = ACTIONS(1377),
    [sym_null] = ACTIONS(1377),
    [sym_inf] = ACTIONS(1377),
    [sym_nan] = ACTIONS(1377),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1375),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [211] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_BSLASH] = ACTIONS(1379),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1379),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_repeat] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(1379),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(1379),
    [anon_sym_LT_DASH] = ACTIONS(901),
    [anon_sym_COLON_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT_GT] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1379),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1381),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1381),
    [sym_next] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_inf] = ACTIONS(1381),
    [sym_nan] = ACTIONS(1381),
    [anon_sym_NA] = ACTIONS(1381),
    [anon_sym_NA_character_] = ACTIONS(1381),
    [anon_sym_NA_complex_] = ACTIONS(1381),
    [anon_sym_NA_integer_] = ACTIONS(1381),
    [anon_sym_NA_real_] = ACTIONS(1381),
    [aux_sym_identifier_token1] = ACTIONS(1381),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_integer] = ACTIONS(1379),
    [sym_float] = ACTIONS(1381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [212] = {
    [sym_function_definition] = STATE(494),
    [sym_lambda_function] = STATE(494),
    [sym_if] = STATE(494),
    [sym_while] = STATE(494),
    [sym_repeat] = STATE(494),
    [sym_for] = STATE(494),
    [sym_switch] = STATE(494),
    [sym_call] = STATE(494),
    [sym__assignment] = STATE(494),
    [sym_left_assignment] = STATE(494),
    [sym_left_assignment2] = STATE(494),
    [sym_equals_assignment] = STATE(494),
    [sym_super_assignment] = STATE(494),
    [sym_super_right_assignment] = STATE(494),
    [sym_right_assignment] = STATE(494),
    [sym_brace_list] = STATE(494),
    [sym_paren_list] = STATE(494),
    [sym_subset] = STATE(494),
    [sym_subset2] = STATE(494),
    [sym_dollar] = STATE(494),
    [sym_slot] = STATE(494),
    [sym_namespace_get] = STATE(494),
    [sym_namespace_get_internal] = STATE(494),
    [sym_pipe] = STATE(494),
    [sym_unary] = STATE(494),
    [sym_binary] = STATE(494),
    [sym_na] = STATE(494),
    [sym__expression] = STATE(494),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(494),
    [sym_string] = STATE(494),
    [anon_sym_SEMI] = ACTIONS(1383),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1385),
    [sym_next] = ACTIONS(1385),
    [sym_true] = ACTIONS(1385),
    [sym_false] = ACTIONS(1385),
    [sym_null] = ACTIONS(1385),
    [sym_inf] = ACTIONS(1385),
    [sym_nan] = ACTIONS(1385),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1383),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [213] = {
    [sym_function_definition] = STATE(493),
    [sym_lambda_function] = STATE(493),
    [sym_if] = STATE(493),
    [sym_while] = STATE(493),
    [sym_repeat] = STATE(493),
    [sym_for] = STATE(493),
    [sym_switch] = STATE(493),
    [sym_call] = STATE(493),
    [sym__assignment] = STATE(493),
    [sym_left_assignment] = STATE(493),
    [sym_left_assignment2] = STATE(493),
    [sym_equals_assignment] = STATE(493),
    [sym_super_assignment] = STATE(493),
    [sym_super_right_assignment] = STATE(493),
    [sym_right_assignment] = STATE(493),
    [sym_brace_list] = STATE(493),
    [sym_paren_list] = STATE(493),
    [sym_subset] = STATE(493),
    [sym_subset2] = STATE(493),
    [sym_dollar] = STATE(493),
    [sym_slot] = STATE(493),
    [sym_namespace_get] = STATE(493),
    [sym_namespace_get_internal] = STATE(493),
    [sym_pipe] = STATE(493),
    [sym_unary] = STATE(493),
    [sym_binary] = STATE(493),
    [sym_na] = STATE(493),
    [sym__expression] = STATE(493),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(493),
    [sym_string] = STATE(493),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1389),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1389),
    [sym_next] = ACTIONS(1389),
    [sym_true] = ACTIONS(1389),
    [sym_false] = ACTIONS(1389),
    [sym_null] = ACTIONS(1389),
    [sym_inf] = ACTIONS(1389),
    [sym_nan] = ACTIONS(1389),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1387),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [214] = {
    [sym_function_definition] = STATE(492),
    [sym_lambda_function] = STATE(492),
    [sym_if] = STATE(492),
    [sym_while] = STATE(492),
    [sym_repeat] = STATE(492),
    [sym_for] = STATE(492),
    [sym_switch] = STATE(492),
    [sym_call] = STATE(492),
    [sym__assignment] = STATE(492),
    [sym_left_assignment] = STATE(492),
    [sym_left_assignment2] = STATE(492),
    [sym_equals_assignment] = STATE(492),
    [sym_super_assignment] = STATE(492),
    [sym_super_right_assignment] = STATE(492),
    [sym_right_assignment] = STATE(492),
    [sym_brace_list] = STATE(492),
    [sym_paren_list] = STATE(492),
    [sym_subset] = STATE(492),
    [sym_subset2] = STATE(492),
    [sym_dollar] = STATE(492),
    [sym_slot] = STATE(492),
    [sym_namespace_get] = STATE(492),
    [sym_namespace_get_internal] = STATE(492),
    [sym_pipe] = STATE(492),
    [sym_unary] = STATE(492),
    [sym_binary] = STATE(492),
    [sym_na] = STATE(492),
    [sym__expression] = STATE(492),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(492),
    [sym_string] = STATE(492),
    [anon_sym_SEMI] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1393),
    [sym_next] = ACTIONS(1393),
    [sym_true] = ACTIONS(1393),
    [sym_false] = ACTIONS(1393),
    [sym_null] = ACTIONS(1393),
    [sym_inf] = ACTIONS(1393),
    [sym_nan] = ACTIONS(1393),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1391),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [215] = {
    [sym_function_definition] = STATE(211),
    [sym_lambda_function] = STATE(211),
    [sym_if] = STATE(211),
    [sym_while] = STATE(211),
    [sym_repeat] = STATE(211),
    [sym_for] = STATE(211),
    [sym_switch] = STATE(211),
    [sym_call] = STATE(211),
    [sym__assignment] = STATE(211),
    [sym_left_assignment] = STATE(211),
    [sym_left_assignment2] = STATE(211),
    [sym_equals_assignment] = STATE(211),
    [sym_super_assignment] = STATE(211),
    [sym_super_right_assignment] = STATE(211),
    [sym_right_assignment] = STATE(211),
    [sym_brace_list] = STATE(211),
    [sym_paren_list] = STATE(211),
    [sym_subset] = STATE(211),
    [sym_subset2] = STATE(211),
    [sym_dollar] = STATE(211),
    [sym_slot] = STATE(211),
    [sym_namespace_get] = STATE(211),
    [sym_namespace_get_internal] = STATE(211),
    [sym_pipe] = STATE(211),
    [sym_unary] = STATE(211),
    [sym_binary] = STATE(211),
    [sym_na] = STATE(211),
    [sym__expression] = STATE(211),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(211),
    [sym_string] = STATE(211),
    [anon_sym_SEMI] = ACTIONS(1395),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1397),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1397),
    [sym_next] = ACTIONS(1397),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [sym_null] = ACTIONS(1397),
    [sym_inf] = ACTIONS(1397),
    [sym_nan] = ACTIONS(1397),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1395),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [216] = {
    [sym_function_definition] = STATE(491),
    [sym_lambda_function] = STATE(491),
    [sym_if] = STATE(491),
    [sym_while] = STATE(491),
    [sym_repeat] = STATE(491),
    [sym_for] = STATE(491),
    [sym_switch] = STATE(491),
    [sym_call] = STATE(491),
    [sym__assignment] = STATE(491),
    [sym_left_assignment] = STATE(491),
    [sym_left_assignment2] = STATE(491),
    [sym_equals_assignment] = STATE(491),
    [sym_super_assignment] = STATE(491),
    [sym_super_right_assignment] = STATE(491),
    [sym_right_assignment] = STATE(491),
    [sym_brace_list] = STATE(491),
    [sym_paren_list] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym_dollar] = STATE(491),
    [sym_slot] = STATE(491),
    [sym_namespace_get] = STATE(491),
    [sym_namespace_get_internal] = STATE(491),
    [sym_pipe] = STATE(491),
    [sym_unary] = STATE(491),
    [sym_binary] = STATE(491),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(491),
    [sym_string] = STATE(491),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1401),
    [sym_next] = ACTIONS(1401),
    [sym_true] = ACTIONS(1401),
    [sym_false] = ACTIONS(1401),
    [sym_null] = ACTIONS(1401),
    [sym_inf] = ACTIONS(1401),
    [sym_nan] = ACTIONS(1401),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1399),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [217] = {
    [sym_function_definition] = STATE(490),
    [sym_lambda_function] = STATE(490),
    [sym_if] = STATE(490),
    [sym_while] = STATE(490),
    [sym_repeat] = STATE(490),
    [sym_for] = STATE(490),
    [sym_switch] = STATE(490),
    [sym_call] = STATE(490),
    [sym__assignment] = STATE(490),
    [sym_left_assignment] = STATE(490),
    [sym_left_assignment2] = STATE(490),
    [sym_equals_assignment] = STATE(490),
    [sym_super_assignment] = STATE(490),
    [sym_super_right_assignment] = STATE(490),
    [sym_right_assignment] = STATE(490),
    [sym_brace_list] = STATE(490),
    [sym_paren_list] = STATE(490),
    [sym_subset] = STATE(490),
    [sym_subset2] = STATE(490),
    [sym_dollar] = STATE(490),
    [sym_slot] = STATE(490),
    [sym_namespace_get] = STATE(490),
    [sym_namespace_get_internal] = STATE(490),
    [sym_pipe] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_na] = STATE(490),
    [sym__expression] = STATE(490),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(490),
    [sym_string] = STATE(490),
    [anon_sym_SEMI] = ACTIONS(1403),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1405),
    [sym_next] = ACTIONS(1405),
    [sym_true] = ACTIONS(1405),
    [sym_false] = ACTIONS(1405),
    [sym_null] = ACTIONS(1405),
    [sym_inf] = ACTIONS(1405),
    [sym_nan] = ACTIONS(1405),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1403),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [218] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [219] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [220] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [221] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [222] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [223] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [224] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [225] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [226] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [227] = {
    [sym_function_definition] = STATE(489),
    [sym_lambda_function] = STATE(489),
    [sym_if] = STATE(489),
    [sym_while] = STATE(489),
    [sym_repeat] = STATE(489),
    [sym_for] = STATE(489),
    [sym_switch] = STATE(489),
    [sym_call] = STATE(489),
    [sym__assignment] = STATE(489),
    [sym_left_assignment] = STATE(489),
    [sym_left_assignment2] = STATE(489),
    [sym_equals_assignment] = STATE(489),
    [sym_super_assignment] = STATE(489),
    [sym_super_right_assignment] = STATE(489),
    [sym_right_assignment] = STATE(489),
    [sym_brace_list] = STATE(489),
    [sym_paren_list] = STATE(489),
    [sym_subset] = STATE(489),
    [sym_subset2] = STATE(489),
    [sym_dollar] = STATE(489),
    [sym_slot] = STATE(489),
    [sym_namespace_get] = STATE(489),
    [sym_namespace_get_internal] = STATE(489),
    [sym_pipe] = STATE(489),
    [sym_unary] = STATE(489),
    [sym_binary] = STATE(489),
    [sym_na] = STATE(489),
    [sym__expression] = STATE(489),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(489),
    [sym_string] = STATE(489),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1413),
    [sym_next] = ACTIONS(1413),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_inf] = ACTIONS(1413),
    [sym_nan] = ACTIONS(1413),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1411),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [228] = {
    [sym_function_definition] = STATE(562),
    [sym_lambda_function] = STATE(562),
    [sym_if] = STATE(562),
    [sym_while] = STATE(562),
    [sym_repeat] = STATE(562),
    [sym_for] = STATE(562),
    [sym_switch] = STATE(562),
    [sym_call] = STATE(562),
    [sym__assignment] = STATE(562),
    [sym_left_assignment] = STATE(562),
    [sym_left_assignment2] = STATE(562),
    [sym_equals_assignment] = STATE(562),
    [sym_super_assignment] = STATE(562),
    [sym_super_right_assignment] = STATE(562),
    [sym_right_assignment] = STATE(562),
    [sym_brace_list] = STATE(562),
    [sym_paren_list] = STATE(562),
    [sym_subset] = STATE(562),
    [sym_subset2] = STATE(562),
    [sym_dollar] = STATE(562),
    [sym_slot] = STATE(562),
    [sym_namespace_get] = STATE(562),
    [sym_namespace_get_internal] = STATE(562),
    [sym_pipe] = STATE(562),
    [sym_unary] = STATE(562),
    [sym_binary] = STATE(562),
    [sym_na] = STATE(562),
    [sym__expression] = STATE(562),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(562),
    [sym_string] = STATE(562),
    [anon_sym_SEMI] = ACTIONS(1415),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1417),
    [sym_next] = ACTIONS(1417),
    [sym_true] = ACTIONS(1417),
    [sym_false] = ACTIONS(1417),
    [sym_null] = ACTIONS(1417),
    [sym_inf] = ACTIONS(1417),
    [sym_nan] = ACTIONS(1417),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1415),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [229] = {
    [sym_function_definition] = STATE(611),
    [sym_lambda_function] = STATE(611),
    [sym_if] = STATE(611),
    [sym_while] = STATE(611),
    [sym_repeat] = STATE(611),
    [sym_for] = STATE(611),
    [sym_switch] = STATE(611),
    [sym_call] = STATE(611),
    [sym__assignment] = STATE(611),
    [sym_left_assignment] = STATE(611),
    [sym_left_assignment2] = STATE(611),
    [sym_equals_assignment] = STATE(611),
    [sym_super_assignment] = STATE(611),
    [sym_super_right_assignment] = STATE(611),
    [sym_right_assignment] = STATE(611),
    [sym_brace_list] = STATE(611),
    [sym_paren_list] = STATE(611),
    [sym_subset] = STATE(611),
    [sym_subset2] = STATE(611),
    [sym_dollar] = STATE(611),
    [sym_slot] = STATE(611),
    [sym_namespace_get] = STATE(611),
    [sym_namespace_get_internal] = STATE(611),
    [sym_pipe] = STATE(611),
    [sym_unary] = STATE(611),
    [sym_binary] = STATE(611),
    [sym_na] = STATE(611),
    [sym__expression] = STATE(611),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(611),
    [sym_string] = STATE(611),
    [anon_sym_SEMI] = ACTIONS(1419),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1421),
    [sym_next] = ACTIONS(1421),
    [sym_true] = ACTIONS(1421),
    [sym_false] = ACTIONS(1421),
    [sym_null] = ACTIONS(1421),
    [sym_inf] = ACTIONS(1421),
    [sym_nan] = ACTIONS(1421),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1419),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [230] = {
    [sym_function_definition] = STATE(488),
    [sym_lambda_function] = STATE(488),
    [sym_if] = STATE(488),
    [sym_while] = STATE(488),
    [sym_repeat] = STATE(488),
    [sym_for] = STATE(488),
    [sym_switch] = STATE(488),
    [sym_call] = STATE(488),
    [sym__assignment] = STATE(488),
    [sym_left_assignment] = STATE(488),
    [sym_left_assignment2] = STATE(488),
    [sym_equals_assignment] = STATE(488),
    [sym_super_assignment] = STATE(488),
    [sym_super_right_assignment] = STATE(488),
    [sym_right_assignment] = STATE(488),
    [sym_brace_list] = STATE(488),
    [sym_paren_list] = STATE(488),
    [sym_subset] = STATE(488),
    [sym_subset2] = STATE(488),
    [sym_dollar] = STATE(488),
    [sym_slot] = STATE(488),
    [sym_namespace_get] = STATE(488),
    [sym_namespace_get_internal] = STATE(488),
    [sym_pipe] = STATE(488),
    [sym_unary] = STATE(488),
    [sym_binary] = STATE(488),
    [sym_na] = STATE(488),
    [sym__expression] = STATE(488),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(488),
    [sym_string] = STATE(488),
    [anon_sym_SEMI] = ACTIONS(1423),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1425),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1425),
    [sym_next] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_inf] = ACTIONS(1425),
    [sym_nan] = ACTIONS(1425),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1423),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [231] = {
    [sym_function_definition] = STATE(484),
    [sym_lambda_function] = STATE(484),
    [sym_if] = STATE(484),
    [sym_while] = STATE(484),
    [sym_repeat] = STATE(484),
    [sym_for] = STATE(484),
    [sym_switch] = STATE(484),
    [sym_call] = STATE(484),
    [sym__assignment] = STATE(484),
    [sym_left_assignment] = STATE(484),
    [sym_left_assignment2] = STATE(484),
    [sym_equals_assignment] = STATE(484),
    [sym_super_assignment] = STATE(484),
    [sym_super_right_assignment] = STATE(484),
    [sym_right_assignment] = STATE(484),
    [sym_brace_list] = STATE(484),
    [sym_paren_list] = STATE(484),
    [sym_subset] = STATE(484),
    [sym_subset2] = STATE(484),
    [sym_dollar] = STATE(484),
    [sym_slot] = STATE(484),
    [sym_namespace_get] = STATE(484),
    [sym_namespace_get_internal] = STATE(484),
    [sym_pipe] = STATE(484),
    [sym_unary] = STATE(484),
    [sym_binary] = STATE(484),
    [sym_na] = STATE(484),
    [sym__expression] = STATE(484),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(484),
    [sym_string] = STATE(484),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1429),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1429),
    [sym_next] = ACTIONS(1429),
    [sym_true] = ACTIONS(1429),
    [sym_false] = ACTIONS(1429),
    [sym_null] = ACTIONS(1429),
    [sym_inf] = ACTIONS(1429),
    [sym_nan] = ACTIONS(1429),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1427),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [232] = {
    [sym_function_definition] = STATE(481),
    [sym_lambda_function] = STATE(481),
    [sym_if] = STATE(481),
    [sym_while] = STATE(481),
    [sym_repeat] = STATE(481),
    [sym_for] = STATE(481),
    [sym_switch] = STATE(481),
    [sym_call] = STATE(481),
    [sym__assignment] = STATE(481),
    [sym_left_assignment] = STATE(481),
    [sym_left_assignment2] = STATE(481),
    [sym_equals_assignment] = STATE(481),
    [sym_super_assignment] = STATE(481),
    [sym_super_right_assignment] = STATE(481),
    [sym_right_assignment] = STATE(481),
    [sym_brace_list] = STATE(481),
    [sym_paren_list] = STATE(481),
    [sym_subset] = STATE(481),
    [sym_subset2] = STATE(481),
    [sym_dollar] = STATE(481),
    [sym_slot] = STATE(481),
    [sym_namespace_get] = STATE(481),
    [sym_namespace_get_internal] = STATE(481),
    [sym_pipe] = STATE(481),
    [sym_unary] = STATE(481),
    [sym_binary] = STATE(481),
    [sym_na] = STATE(481),
    [sym__expression] = STATE(481),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(481),
    [sym_string] = STATE(481),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1433),
    [sym_next] = ACTIONS(1433),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [sym_null] = ACTIONS(1433),
    [sym_inf] = ACTIONS(1433),
    [sym_nan] = ACTIONS(1433),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1431),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [233] = {
    [sym_function_definition] = STATE(480),
    [sym_lambda_function] = STATE(480),
    [sym_if] = STATE(480),
    [sym_while] = STATE(480),
    [sym_repeat] = STATE(480),
    [sym_for] = STATE(480),
    [sym_switch] = STATE(480),
    [sym_call] = STATE(480),
    [sym__assignment] = STATE(480),
    [sym_left_assignment] = STATE(480),
    [sym_left_assignment2] = STATE(480),
    [sym_equals_assignment] = STATE(480),
    [sym_super_assignment] = STATE(480),
    [sym_super_right_assignment] = STATE(480),
    [sym_right_assignment] = STATE(480),
    [sym_brace_list] = STATE(480),
    [sym_paren_list] = STATE(480),
    [sym_subset] = STATE(480),
    [sym_subset2] = STATE(480),
    [sym_dollar] = STATE(480),
    [sym_slot] = STATE(480),
    [sym_namespace_get] = STATE(480),
    [sym_namespace_get_internal] = STATE(480),
    [sym_pipe] = STATE(480),
    [sym_unary] = STATE(480),
    [sym_binary] = STATE(480),
    [sym_na] = STATE(480),
    [sym__expression] = STATE(480),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(480),
    [sym_string] = STATE(480),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1437),
    [sym_next] = ACTIONS(1437),
    [sym_true] = ACTIONS(1437),
    [sym_false] = ACTIONS(1437),
    [sym_null] = ACTIONS(1437),
    [sym_inf] = ACTIONS(1437),
    [sym_nan] = ACTIONS(1437),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1435),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [234] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_function] = ACTIONS(893),
    [anon_sym_BSLASH] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(1439),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_repeat] = ACTIONS(893),
    [anon_sym_for] = ACTIONS(893),
    [anon_sym_switch] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_LT_DASH] = ACTIONS(901),
    [anon_sym_COLON_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT_GT] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(893),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(893),
    [sym_next] = ACTIONS(893),
    [sym_true] = ACTIONS(893),
    [sym_false] = ACTIONS(893),
    [sym_null] = ACTIONS(893),
    [sym_inf] = ACTIONS(893),
    [sym_nan] = ACTIONS(893),
    [anon_sym_NA] = ACTIONS(893),
    [anon_sym_NA_character_] = ACTIONS(893),
    [anon_sym_NA_complex_] = ACTIONS(893),
    [anon_sym_NA_integer_] = ACTIONS(893),
    [anon_sym_NA_real_] = ACTIONS(893),
    [aux_sym_identifier_token1] = ACTIONS(893),
    [anon_sym_BQUOTE] = ACTIONS(891),
    [sym_integer] = ACTIONS(891),
    [sym_float] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [235] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_function] = ACTIONS(1443),
    [anon_sym_BSLASH] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_else] = ACTIONS(1443),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_EQ] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_LT_DASH] = ACTIONS(1441),
    [anon_sym_COLON_EQ] = ACTIONS(1441),
    [anon_sym_LT_LT_DASH] = ACTIONS(1441),
    [anon_sym_DASH_GT_GT] = ACTIONS(1441),
    [anon_sym_DASH_GT] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1443),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1443),
    [sym_next] = ACTIONS(1443),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_inf] = ACTIONS(1443),
    [sym_nan] = ACTIONS(1443),
    [anon_sym_NA] = ACTIONS(1443),
    [anon_sym_NA_character_] = ACTIONS(1443),
    [anon_sym_NA_complex_] = ACTIONS(1443),
    [anon_sym_NA_integer_] = ACTIONS(1443),
    [anon_sym_NA_real_] = ACTIONS(1443),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [anon_sym_BQUOTE] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1441),
    [sym_float] = ACTIONS(1443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1441),
    [anon_sym_SQUOTE] = ACTIONS(1441),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [236] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_BSLASH] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1445),
    [anon_sym_else] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_repeat] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_LT_DASH] = ACTIONS(901),
    [anon_sym_COLON_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT_GT] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1447),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1447),
    [sym_next] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_inf] = ACTIONS(1447),
    [sym_nan] = ACTIONS(1447),
    [anon_sym_NA] = ACTIONS(1447),
    [anon_sym_NA_character_] = ACTIONS(1447),
    [anon_sym_NA_complex_] = ACTIONS(1447),
    [anon_sym_NA_integer_] = ACTIONS(1447),
    [anon_sym_NA_real_] = ACTIONS(1447),
    [aux_sym_identifier_token1] = ACTIONS(1447),
    [anon_sym_BQUOTE] = ACTIONS(1445),
    [sym_integer] = ACTIONS(1445),
    [sym_float] = ACTIONS(1447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [237] = {
    [sym_function_definition] = STATE(563),
    [sym_lambda_function] = STATE(563),
    [sym_if] = STATE(563),
    [sym_while] = STATE(563),
    [sym_repeat] = STATE(563),
    [sym_for] = STATE(563),
    [sym_switch] = STATE(563),
    [sym_call] = STATE(563),
    [sym__assignment] = STATE(563),
    [sym_left_assignment] = STATE(563),
    [sym_left_assignment2] = STATE(563),
    [sym_equals_assignment] = STATE(563),
    [sym_super_assignment] = STATE(563),
    [sym_super_right_assignment] = STATE(563),
    [sym_right_assignment] = STATE(563),
    [sym_brace_list] = STATE(563),
    [sym_paren_list] = STATE(563),
    [sym_subset] = STATE(563),
    [sym_subset2] = STATE(563),
    [sym_dollar] = STATE(563),
    [sym_slot] = STATE(563),
    [sym_namespace_get] = STATE(563),
    [sym_namespace_get_internal] = STATE(563),
    [sym_pipe] = STATE(563),
    [sym_unary] = STATE(563),
    [sym_binary] = STATE(563),
    [sym_na] = STATE(563),
    [sym__expression] = STATE(563),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(563),
    [sym_string] = STATE(563),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1451),
    [sym_next] = ACTIONS(1451),
    [sym_true] = ACTIONS(1451),
    [sym_false] = ACTIONS(1451),
    [sym_null] = ACTIONS(1451),
    [sym_inf] = ACTIONS(1451),
    [sym_nan] = ACTIONS(1451),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1449),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [238] = {
    [sym_function_definition] = STATE(564),
    [sym_lambda_function] = STATE(564),
    [sym_if] = STATE(564),
    [sym_while] = STATE(564),
    [sym_repeat] = STATE(564),
    [sym_for] = STATE(564),
    [sym_switch] = STATE(564),
    [sym_call] = STATE(564),
    [sym__assignment] = STATE(564),
    [sym_left_assignment] = STATE(564),
    [sym_left_assignment2] = STATE(564),
    [sym_equals_assignment] = STATE(564),
    [sym_super_assignment] = STATE(564),
    [sym_super_right_assignment] = STATE(564),
    [sym_right_assignment] = STATE(564),
    [sym_brace_list] = STATE(564),
    [sym_paren_list] = STATE(564),
    [sym_subset] = STATE(564),
    [sym_subset2] = STATE(564),
    [sym_dollar] = STATE(564),
    [sym_slot] = STATE(564),
    [sym_namespace_get] = STATE(564),
    [sym_namespace_get_internal] = STATE(564),
    [sym_pipe] = STATE(564),
    [sym_unary] = STATE(564),
    [sym_binary] = STATE(564),
    [sym_na] = STATE(564),
    [sym__expression] = STATE(564),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(564),
    [sym_string] = STATE(564),
    [anon_sym_SEMI] = ACTIONS(1453),
    [anon_sym_function] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(105),
    [anon_sym_repeat] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(123),
    [sym_break] = ACTIONS(1455),
    [sym_next] = ACTIONS(1455),
    [sym_true] = ACTIONS(1455),
    [sym_false] = ACTIONS(1455),
    [sym_null] = ACTIONS(1455),
    [sym_inf] = ACTIONS(1455),
    [sym_nan] = ACTIONS(1455),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1453),
    [sym_float] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [239] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_function] = ACTIONS(1459),
    [anon_sym_BSLASH] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_else] = ACTIONS(1459),
    [anon_sym_while] = ACTIONS(1459),
    [anon_sym_repeat] = ACTIONS(1459),
    [anon_sym_for] = ACTIONS(1459),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_LT_DASH] = ACTIONS(901),
    [anon_sym_COLON_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT_GT] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1459),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1459),
    [sym_next] = ACTIONS(1459),
    [sym_true] = ACTIONS(1459),
    [sym_false] = ACTIONS(1459),
    [sym_null] = ACTIONS(1459),
    [sym_inf] = ACTIONS(1459),
    [sym_nan] = ACTIONS(1459),
    [anon_sym_NA] = ACTIONS(1459),
    [anon_sym_NA_character_] = ACTIONS(1459),
    [anon_sym_NA_complex_] = ACTIONS(1459),
    [anon_sym_NA_integer_] = ACTIONS(1459),
    [anon_sym_NA_real_] = ACTIONS(1459),
    [aux_sym_identifier_token1] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1457),
    [sym_integer] = ACTIONS(1457),
    [sym_float] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1457),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [240] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1463),
    [anon_sym_BSLASH] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1463),
    [anon_sym_while] = ACTIONS(1463),
    [anon_sym_repeat] = ACTIONS(1463),
    [anon_sym_for] = ACTIONS(1463),
    [anon_sym_switch] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_LT_DASH] = ACTIONS(901),
    [anon_sym_COLON_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT_GT] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1461),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1463),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1463),
    [sym_next] = ACTIONS(1463),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_inf] = ACTIONS(1463),
    [sym_nan] = ACTIONS(1463),
    [anon_sym_NA] = ACTIONS(1463),
    [anon_sym_NA_character_] = ACTIONS(1463),
    [anon_sym_NA_complex_] = ACTIONS(1463),
    [anon_sym_NA_integer_] = ACTIONS(1463),
    [anon_sym_NA_real_] = ACTIONS(1463),
    [aux_sym_identifier_token1] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [sym_integer] = ACTIONS(1461),
    [sym_float] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1461),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [241] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(1467),
    [anon_sym_BSLASH] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [anon_sym_else] = ACTIONS(1467),
    [anon_sym_while] = ACTIONS(1467),
    [anon_sym_repeat] = ACTIONS(1467),
    [anon_sym_for] = ACTIONS(1467),
    [anon_sym_switch] = ACTIONS(1467),
    [anon_sym_COMMA] = ACTIONS(1465),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(1465),
    [anon_sym_LT_DASH] = ACTIONS(901),
    [anon_sym_COLON_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT_GT] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1465),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1467),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1467),
    [sym_next] = ACTIONS(1467),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_null] = ACTIONS(1467),
    [sym_inf] = ACTIONS(1467),
    [sym_nan] = ACTIONS(1467),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [aux_sym_identifier_token1] = ACTIONS(1467),
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [sym_integer] = ACTIONS(1465),
    [sym_float] = ACTIONS(1467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_SQUOTE] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [242] = {
    [sym_function_definition] = STATE(578),
    [sym_lambda_function] = STATE(578),
    [sym_if] = STATE(578),
    [sym_while] = STATE(578),
    [sym_repeat] = STATE(578),
    [sym_for] = STATE(578),
    [sym_switch] = STATE(578),
    [sym_call] = STATE(578),
    [sym__assignment] = STATE(578),
    [sym_left_assignment] = STATE(578),
    [sym_left_assignment2] = STATE(578),
    [sym_equals_assignment] = STATE(578),
    [sym_super_assignment] = STATE(578),
    [sym_super_right_assignment] = STATE(578),
    [sym_right_assignment] = STATE(578),
    [sym_brace_list] = STATE(578),
    [sym_paren_list] = STATE(578),
    [sym_subset] = STATE(578),
    [sym_subset2] = STATE(578),
    [sym_dollar] = STATE(578),
    [sym_slot] = STATE(578),
    [sym_namespace_get] = STATE(578),
    [sym_namespace_get_internal] = STATE(578),
    [sym_pipe] = STATE(578),
    [sym_unary] = STATE(578),
    [sym_binary] = STATE(578),
    [sym_na] = STATE(578),
    [sym__expression] = STATE(578),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(578),
    [sym_string] = STATE(578),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1471),
    [sym_next] = ACTIONS(1471),
    [sym_true] = ACTIONS(1471),
    [sym_false] = ACTIONS(1471),
    [sym_null] = ACTIONS(1471),
    [sym_inf] = ACTIONS(1471),
    [sym_nan] = ACTIONS(1471),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1469),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [243] = {
    [sym_function_definition] = STATE(577),
    [sym_lambda_function] = STATE(577),
    [sym_if] = STATE(577),
    [sym_while] = STATE(577),
    [sym_repeat] = STATE(577),
    [sym_for] = STATE(577),
    [sym_switch] = STATE(577),
    [sym_call] = STATE(577),
    [sym__assignment] = STATE(577),
    [sym_left_assignment] = STATE(577),
    [sym_left_assignment2] = STATE(577),
    [sym_equals_assignment] = STATE(577),
    [sym_super_assignment] = STATE(577),
    [sym_super_right_assignment] = STATE(577),
    [sym_right_assignment] = STATE(577),
    [sym_brace_list] = STATE(577),
    [sym_paren_list] = STATE(577),
    [sym_subset] = STATE(577),
    [sym_subset2] = STATE(577),
    [sym_dollar] = STATE(577),
    [sym_slot] = STATE(577),
    [sym_namespace_get] = STATE(577),
    [sym_namespace_get_internal] = STATE(577),
    [sym_pipe] = STATE(577),
    [sym_unary] = STATE(577),
    [sym_binary] = STATE(577),
    [sym_na] = STATE(577),
    [sym__expression] = STATE(577),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(577),
    [sym_string] = STATE(577),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1475),
    [sym_next] = ACTIONS(1475),
    [sym_true] = ACTIONS(1475),
    [sym_false] = ACTIONS(1475),
    [sym_null] = ACTIONS(1475),
    [sym_inf] = ACTIONS(1475),
    [sym_nan] = ACTIONS(1475),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1473),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [244] = {
    [sym_function_definition] = STATE(576),
    [sym_lambda_function] = STATE(576),
    [sym_if] = STATE(576),
    [sym_while] = STATE(576),
    [sym_repeat] = STATE(576),
    [sym_for] = STATE(576),
    [sym_switch] = STATE(576),
    [sym_call] = STATE(576),
    [sym__assignment] = STATE(576),
    [sym_left_assignment] = STATE(576),
    [sym_left_assignment2] = STATE(576),
    [sym_equals_assignment] = STATE(576),
    [sym_super_assignment] = STATE(576),
    [sym_super_right_assignment] = STATE(576),
    [sym_right_assignment] = STATE(576),
    [sym_brace_list] = STATE(576),
    [sym_paren_list] = STATE(576),
    [sym_subset] = STATE(576),
    [sym_subset2] = STATE(576),
    [sym_dollar] = STATE(576),
    [sym_slot] = STATE(576),
    [sym_namespace_get] = STATE(576),
    [sym_namespace_get_internal] = STATE(576),
    [sym_pipe] = STATE(576),
    [sym_unary] = STATE(576),
    [sym_binary] = STATE(576),
    [sym_na] = STATE(576),
    [sym__expression] = STATE(576),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(576),
    [sym_string] = STATE(576),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1479),
    [sym_next] = ACTIONS(1479),
    [sym_true] = ACTIONS(1479),
    [sym_false] = ACTIONS(1479),
    [sym_null] = ACTIONS(1479),
    [sym_inf] = ACTIONS(1479),
    [sym_nan] = ACTIONS(1479),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1477),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [245] = {
    [sym_function_definition] = STATE(575),
    [sym_lambda_function] = STATE(575),
    [sym_if] = STATE(575),
    [sym_while] = STATE(575),
    [sym_repeat] = STATE(575),
    [sym_for] = STATE(575),
    [sym_switch] = STATE(575),
    [sym_call] = STATE(575),
    [sym__assignment] = STATE(575),
    [sym_left_assignment] = STATE(575),
    [sym_left_assignment2] = STATE(575),
    [sym_equals_assignment] = STATE(575),
    [sym_super_assignment] = STATE(575),
    [sym_super_right_assignment] = STATE(575),
    [sym_right_assignment] = STATE(575),
    [sym_brace_list] = STATE(575),
    [sym_paren_list] = STATE(575),
    [sym_subset] = STATE(575),
    [sym_subset2] = STATE(575),
    [sym_dollar] = STATE(575),
    [sym_slot] = STATE(575),
    [sym_namespace_get] = STATE(575),
    [sym_namespace_get_internal] = STATE(575),
    [sym_pipe] = STATE(575),
    [sym_unary] = STATE(575),
    [sym_binary] = STATE(575),
    [sym_na] = STATE(575),
    [sym__expression] = STATE(575),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(575),
    [sym_string] = STATE(575),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1483),
    [sym_next] = ACTIONS(1483),
    [sym_true] = ACTIONS(1483),
    [sym_false] = ACTIONS(1483),
    [sym_null] = ACTIONS(1483),
    [sym_inf] = ACTIONS(1483),
    [sym_nan] = ACTIONS(1483),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1481),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [246] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_BSLASH] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1485),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_LT_DASH] = ACTIONS(901),
    [anon_sym_COLON_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT_GT] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1487),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1487),
    [sym_next] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_inf] = ACTIONS(1487),
    [sym_nan] = ACTIONS(1487),
    [anon_sym_NA] = ACTIONS(1487),
    [anon_sym_NA_character_] = ACTIONS(1487),
    [anon_sym_NA_complex_] = ACTIONS(1487),
    [anon_sym_NA_integer_] = ACTIONS(1487),
    [anon_sym_NA_real_] = ACTIONS(1487),
    [aux_sym_identifier_token1] = ACTIONS(1487),
    [anon_sym_BQUOTE] = ACTIONS(1485),
    [sym_integer] = ACTIONS(1485),
    [sym_float] = ACTIONS(1487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1485),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [247] = {
    [sym_function_definition] = STATE(479),
    [sym_lambda_function] = STATE(479),
    [sym_if] = STATE(479),
    [sym_while] = STATE(479),
    [sym_repeat] = STATE(479),
    [sym_for] = STATE(479),
    [sym_switch] = STATE(479),
    [sym_call] = STATE(479),
    [sym__assignment] = STATE(479),
    [sym_left_assignment] = STATE(479),
    [sym_left_assignment2] = STATE(479),
    [sym_equals_assignment] = STATE(479),
    [sym_super_assignment] = STATE(479),
    [sym_super_right_assignment] = STATE(479),
    [sym_right_assignment] = STATE(479),
    [sym_brace_list] = STATE(479),
    [sym_paren_list] = STATE(479),
    [sym_subset] = STATE(479),
    [sym_subset2] = STATE(479),
    [sym_dollar] = STATE(479),
    [sym_slot] = STATE(479),
    [sym_namespace_get] = STATE(479),
    [sym_namespace_get_internal] = STATE(479),
    [sym_pipe] = STATE(479),
    [sym_unary] = STATE(479),
    [sym_binary] = STATE(479),
    [sym_na] = STATE(479),
    [sym__expression] = STATE(479),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(479),
    [sym_string] = STATE(479),
    [anon_sym_SEMI] = ACTIONS(1489),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1491),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1491),
    [sym_next] = ACTIONS(1491),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_inf] = ACTIONS(1491),
    [sym_nan] = ACTIONS(1491),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1489),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [248] = {
    [sym_function_definition] = STATE(658),
    [sym_lambda_function] = STATE(658),
    [sym_if] = STATE(658),
    [sym_while] = STATE(658),
    [sym_repeat] = STATE(658),
    [sym_for] = STATE(658),
    [sym_switch] = STATE(658),
    [sym_call] = STATE(658),
    [sym__assignment] = STATE(658),
    [sym_left_assignment] = STATE(658),
    [sym_left_assignment2] = STATE(658),
    [sym_equals_assignment] = STATE(658),
    [sym_super_assignment] = STATE(658),
    [sym_super_right_assignment] = STATE(658),
    [sym_right_assignment] = STATE(658),
    [sym_brace_list] = STATE(658),
    [sym_paren_list] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_subset2] = STATE(658),
    [sym_dollar] = STATE(658),
    [sym_slot] = STATE(658),
    [sym_namespace_get] = STATE(658),
    [sym_namespace_get_internal] = STATE(658),
    [sym_pipe] = STATE(658),
    [sym_unary] = STATE(658),
    [sym_binary] = STATE(658),
    [sym_na] = STATE(658),
    [sym__expression] = STATE(658),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(658),
    [sym_string] = STATE(658),
    [anon_sym_SEMI] = ACTIONS(1493),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1495),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1495),
    [sym_next] = ACTIONS(1495),
    [sym_true] = ACTIONS(1495),
    [sym_false] = ACTIONS(1495),
    [sym_null] = ACTIONS(1495),
    [sym_inf] = ACTIONS(1495),
    [sym_nan] = ACTIONS(1495),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1493),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [249] = {
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_SEMI] = ACTIONS(659),
    [anon_sym_function] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(659),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(659),
    [anon_sym_else] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(659),
    [anon_sym_repeat] = ACTIONS(659),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(659),
    [anon_sym_EQ] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_LT_DASH] = ACTIONS(659),
    [anon_sym_COLON_EQ] = ACTIONS(659),
    [anon_sym_LT_LT_DASH] = ACTIONS(659),
    [anon_sym_DASH_GT_GT] = ACTIONS(659),
    [anon_sym_DASH_GT] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(659),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(659),
    [anon_sym_COLON_COLON] = ACTIONS(659),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(659),
    [sym_dots] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(659),
    [anon_sym_SLASH] = ACTIONS(659),
    [anon_sym_CARET] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(659),
    [sym_break] = ACTIONS(659),
    [sym_next] = ACTIONS(659),
    [sym_true] = ACTIONS(659),
    [sym_false] = ACTIONS(659),
    [sym_null] = ACTIONS(659),
    [sym_inf] = ACTIONS(659),
    [sym_nan] = ACTIONS(659),
    [anon_sym_NA] = ACTIONS(659),
    [anon_sym_NA_character_] = ACTIONS(659),
    [anon_sym_NA_complex_] = ACTIONS(659),
    [anon_sym_NA_integer_] = ACTIONS(659),
    [anon_sym_NA_real_] = ACTIONS(659),
    [aux_sym_identifier_token1] = ACTIONS(659),
    [anon_sym_BQUOTE] = ACTIONS(659),
    [sym_integer] = ACTIONS(659),
    [sym_float] = ACTIONS(659),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_PERCENT] = ACTIONS(659),
  },
  [250] = {
    [sym_function_definition] = STATE(572),
    [sym_lambda_function] = STATE(572),
    [sym_if] = STATE(572),
    [sym_while] = STATE(572),
    [sym_repeat] = STATE(572),
    [sym_for] = STATE(572),
    [sym_switch] = STATE(572),
    [sym_call] = STATE(572),
    [sym__assignment] = STATE(572),
    [sym_left_assignment] = STATE(572),
    [sym_left_assignment2] = STATE(572),
    [sym_equals_assignment] = STATE(572),
    [sym_super_assignment] = STATE(572),
    [sym_super_right_assignment] = STATE(572),
    [sym_right_assignment] = STATE(572),
    [sym_brace_list] = STATE(572),
    [sym_paren_list] = STATE(572),
    [sym_subset] = STATE(572),
    [sym_subset2] = STATE(572),
    [sym_dollar] = STATE(572),
    [sym_slot] = STATE(572),
    [sym_namespace_get] = STATE(572),
    [sym_namespace_get_internal] = STATE(572),
    [sym_pipe] = STATE(572),
    [sym_unary] = STATE(572),
    [sym_binary] = STATE(572),
    [sym_na] = STATE(572),
    [sym__expression] = STATE(572),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(572),
    [sym_string] = STATE(572),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1501),
    [sym_next] = ACTIONS(1501),
    [sym_true] = ACTIONS(1501),
    [sym_false] = ACTIONS(1501),
    [sym_null] = ACTIONS(1501),
    [sym_inf] = ACTIONS(1501),
    [sym_nan] = ACTIONS(1501),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1499),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [251] = {
    [sym_function_definition] = STATE(573),
    [sym_lambda_function] = STATE(573),
    [sym_if] = STATE(573),
    [sym_while] = STATE(573),
    [sym_repeat] = STATE(573),
    [sym_for] = STATE(573),
    [sym_switch] = STATE(573),
    [sym_call] = STATE(573),
    [sym__assignment] = STATE(573),
    [sym_left_assignment] = STATE(573),
    [sym_left_assignment2] = STATE(573),
    [sym_equals_assignment] = STATE(573),
    [sym_super_assignment] = STATE(573),
    [sym_super_right_assignment] = STATE(573),
    [sym_right_assignment] = STATE(573),
    [sym_brace_list] = STATE(573),
    [sym_paren_list] = STATE(573),
    [sym_subset] = STATE(573),
    [sym_subset2] = STATE(573),
    [sym_dollar] = STATE(573),
    [sym_slot] = STATE(573),
    [sym_namespace_get] = STATE(573),
    [sym_namespace_get_internal] = STATE(573),
    [sym_pipe] = STATE(573),
    [sym_unary] = STATE(573),
    [sym_binary] = STATE(573),
    [sym_na] = STATE(573),
    [sym__expression] = STATE(573),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(573),
    [sym_string] = STATE(573),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1505),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1505),
    [sym_next] = ACTIONS(1505),
    [sym_true] = ACTIONS(1505),
    [sym_false] = ACTIONS(1505),
    [sym_null] = ACTIONS(1505),
    [sym_inf] = ACTIONS(1505),
    [sym_nan] = ACTIONS(1505),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1503),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [252] = {
    [sym_function_definition] = STATE(659),
    [sym_lambda_function] = STATE(659),
    [sym_if] = STATE(659),
    [sym_while] = STATE(659),
    [sym_repeat] = STATE(659),
    [sym_for] = STATE(659),
    [sym_switch] = STATE(659),
    [sym_call] = STATE(659),
    [sym__assignment] = STATE(659),
    [sym_left_assignment] = STATE(659),
    [sym_left_assignment2] = STATE(659),
    [sym_equals_assignment] = STATE(659),
    [sym_super_assignment] = STATE(659),
    [sym_super_right_assignment] = STATE(659),
    [sym_right_assignment] = STATE(659),
    [sym_brace_list] = STATE(659),
    [sym_paren_list] = STATE(659),
    [sym_subset] = STATE(659),
    [sym_subset2] = STATE(659),
    [sym_dollar] = STATE(659),
    [sym_slot] = STATE(659),
    [sym_namespace_get] = STATE(659),
    [sym_namespace_get_internal] = STATE(659),
    [sym_pipe] = STATE(659),
    [sym_unary] = STATE(659),
    [sym_binary] = STATE(659),
    [sym_na] = STATE(659),
    [sym__expression] = STATE(659),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(659),
    [sym_string] = STATE(659),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1509),
    [sym_next] = ACTIONS(1509),
    [sym_true] = ACTIONS(1509),
    [sym_false] = ACTIONS(1509),
    [sym_null] = ACTIONS(1509),
    [sym_inf] = ACTIONS(1509),
    [sym_nan] = ACTIONS(1509),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1507),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [253] = {
    [sym_function_definition] = STATE(660),
    [sym_lambda_function] = STATE(660),
    [sym_if] = STATE(660),
    [sym_while] = STATE(660),
    [sym_repeat] = STATE(660),
    [sym_for] = STATE(660),
    [sym_switch] = STATE(660),
    [sym_call] = STATE(660),
    [sym__assignment] = STATE(660),
    [sym_left_assignment] = STATE(660),
    [sym_left_assignment2] = STATE(660),
    [sym_equals_assignment] = STATE(660),
    [sym_super_assignment] = STATE(660),
    [sym_super_right_assignment] = STATE(660),
    [sym_right_assignment] = STATE(660),
    [sym_brace_list] = STATE(660),
    [sym_paren_list] = STATE(660),
    [sym_subset] = STATE(660),
    [sym_subset2] = STATE(660),
    [sym_dollar] = STATE(660),
    [sym_slot] = STATE(660),
    [sym_namespace_get] = STATE(660),
    [sym_namespace_get_internal] = STATE(660),
    [sym_pipe] = STATE(660),
    [sym_unary] = STATE(660),
    [sym_binary] = STATE(660),
    [sym_na] = STATE(660),
    [sym__expression] = STATE(660),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(660),
    [sym_string] = STATE(660),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1513),
    [sym_next] = ACTIONS(1513),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [sym_null] = ACTIONS(1513),
    [sym_inf] = ACTIONS(1513),
    [sym_nan] = ACTIONS(1513),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1511),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [254] = {
    [sym_function_definition] = STATE(823),
    [sym_lambda_function] = STATE(823),
    [sym_if] = STATE(823),
    [sym_while] = STATE(823),
    [sym_repeat] = STATE(823),
    [sym_for] = STATE(823),
    [sym_switch] = STATE(823),
    [sym_call] = STATE(823),
    [sym__assignment] = STATE(823),
    [sym_left_assignment] = STATE(823),
    [sym_left_assignment2] = STATE(823),
    [sym_equals_assignment] = STATE(823),
    [sym_super_assignment] = STATE(823),
    [sym_super_right_assignment] = STATE(823),
    [sym_right_assignment] = STATE(823),
    [sym_brace_list] = STATE(823),
    [sym_paren_list] = STATE(823),
    [sym_subset] = STATE(823),
    [sym_subset2] = STATE(823),
    [sym_dollar] = STATE(823),
    [sym_slot] = STATE(823),
    [sym_namespace_get] = STATE(823),
    [sym_namespace_get_internal] = STATE(823),
    [sym_pipe] = STATE(823),
    [sym_unary] = STATE(823),
    [sym_binary] = STATE(823),
    [sym_na] = STATE(823),
    [sym__expression] = STATE(823),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(823),
    [sym_string] = STATE(823),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1517),
    [sym_next] = ACTIONS(1517),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [sym_null] = ACTIONS(1517),
    [sym_inf] = ACTIONS(1517),
    [sym_nan] = ACTIONS(1517),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1515),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [255] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym_function] = ACTIONS(1521),
    [anon_sym_BSLASH] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1519),
    [anon_sym_else] = ACTIONS(1521),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_repeat] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_COMMA] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1519),
    [anon_sym_COLON_EQ] = ACTIONS(1519),
    [anon_sym_LT_LT_DASH] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT] = ACTIONS(1521),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1521),
    [sym_next] = ACTIONS(1521),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [sym_null] = ACTIONS(1521),
    [sym_inf] = ACTIONS(1521),
    [sym_nan] = ACTIONS(1521),
    [anon_sym_NA] = ACTIONS(1521),
    [anon_sym_NA_character_] = ACTIONS(1521),
    [anon_sym_NA_complex_] = ACTIONS(1521),
    [anon_sym_NA_integer_] = ACTIONS(1521),
    [anon_sym_NA_real_] = ACTIONS(1521),
    [aux_sym_identifier_token1] = ACTIONS(1521),
    [anon_sym_BQUOTE] = ACTIONS(1519),
    [sym_integer] = ACTIONS(1519),
    [sym_float] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1519),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [256] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(1525),
    [anon_sym_BSLASH] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(1523),
    [anon_sym_else] = ACTIONS(1525),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_repeat] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_COMMA] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1523),
    [anon_sym_COLON_EQ] = ACTIONS(1523),
    [anon_sym_LT_LT_DASH] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT] = ACTIONS(1525),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(1523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(1525),
    [sym_next] = ACTIONS(1525),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [sym_null] = ACTIONS(1525),
    [sym_inf] = ACTIONS(1525),
    [sym_nan] = ACTIONS(1525),
    [anon_sym_NA] = ACTIONS(1525),
    [anon_sym_NA_character_] = ACTIONS(1525),
    [anon_sym_NA_complex_] = ACTIONS(1525),
    [anon_sym_NA_integer_] = ACTIONS(1525),
    [anon_sym_NA_real_] = ACTIONS(1525),
    [aux_sym_identifier_token1] = ACTIONS(1525),
    [anon_sym_BQUOTE] = ACTIONS(1523),
    [sym_integer] = ACTIONS(1523),
    [sym_float] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1523),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [257] = {
    [sym_function_definition] = STATE(218),
    [sym_lambda_function] = STATE(218),
    [sym_if] = STATE(218),
    [sym_while] = STATE(218),
    [sym_repeat] = STATE(218),
    [sym_for] = STATE(218),
    [sym_switch] = STATE(218),
    [sym_call] = STATE(218),
    [sym__assignment] = STATE(218),
    [sym_left_assignment] = STATE(218),
    [sym_left_assignment2] = STATE(218),
    [sym_equals_assignment] = STATE(218),
    [sym_super_assignment] = STATE(218),
    [sym_super_right_assignment] = STATE(218),
    [sym_right_assignment] = STATE(218),
    [sym_brace_list] = STATE(218),
    [sym_paren_list] = STATE(218),
    [sym_subset] = STATE(218),
    [sym_subset2] = STATE(218),
    [sym_dollar] = STATE(218),
    [sym_slot] = STATE(218),
    [sym_namespace_get] = STATE(218),
    [sym_namespace_get_internal] = STATE(218),
    [sym_pipe] = STATE(218),
    [sym_unary] = STATE(218),
    [sym_binary] = STATE(218),
    [sym_na] = STATE(218),
    [sym__expression] = STATE(218),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(218),
    [sym_string] = STATE(218),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1529),
    [sym_next] = ACTIONS(1529),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_inf] = ACTIONS(1529),
    [sym_nan] = ACTIONS(1529),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1527),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [258] = {
    [sym_function_definition] = STATE(219),
    [sym_lambda_function] = STATE(219),
    [sym_if] = STATE(219),
    [sym_while] = STATE(219),
    [sym_repeat] = STATE(219),
    [sym_for] = STATE(219),
    [sym_switch] = STATE(219),
    [sym_call] = STATE(219),
    [sym__assignment] = STATE(219),
    [sym_left_assignment] = STATE(219),
    [sym_left_assignment2] = STATE(219),
    [sym_equals_assignment] = STATE(219),
    [sym_super_assignment] = STATE(219),
    [sym_super_right_assignment] = STATE(219),
    [sym_right_assignment] = STATE(219),
    [sym_brace_list] = STATE(219),
    [sym_paren_list] = STATE(219),
    [sym_subset] = STATE(219),
    [sym_subset2] = STATE(219),
    [sym_dollar] = STATE(219),
    [sym_slot] = STATE(219),
    [sym_namespace_get] = STATE(219),
    [sym_namespace_get_internal] = STATE(219),
    [sym_pipe] = STATE(219),
    [sym_unary] = STATE(219),
    [sym_binary] = STATE(219),
    [sym_na] = STATE(219),
    [sym__expression] = STATE(219),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(219),
    [sym_string] = STATE(219),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1533),
    [sym_next] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_inf] = ACTIONS(1533),
    [sym_nan] = ACTIONS(1533),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1531),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [259] = {
    [sym_function_definition] = STATE(705),
    [sym_lambda_function] = STATE(705),
    [sym_if] = STATE(705),
    [sym_while] = STATE(705),
    [sym_repeat] = STATE(705),
    [sym_for] = STATE(705),
    [sym_switch] = STATE(705),
    [sym_call] = STATE(705),
    [sym__assignment] = STATE(705),
    [sym_left_assignment] = STATE(705),
    [sym_left_assignment2] = STATE(705),
    [sym_equals_assignment] = STATE(705),
    [sym_super_assignment] = STATE(705),
    [sym_super_right_assignment] = STATE(705),
    [sym_right_assignment] = STATE(705),
    [sym_brace_list] = STATE(705),
    [sym_paren_list] = STATE(705),
    [sym_subset] = STATE(705),
    [sym_subset2] = STATE(705),
    [sym_dollar] = STATE(705),
    [sym_slot] = STATE(705),
    [sym_namespace_get] = STATE(705),
    [sym_namespace_get_internal] = STATE(705),
    [sym_pipe] = STATE(705),
    [sym_unary] = STATE(705),
    [sym_binary] = STATE(705),
    [sym_na] = STATE(705),
    [sym__expression] = STATE(705),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(705),
    [sym_string] = STATE(705),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(1537),
    [sym_next] = ACTIONS(1537),
    [sym_true] = ACTIONS(1537),
    [sym_false] = ACTIONS(1537),
    [sym_null] = ACTIONS(1537),
    [sym_inf] = ACTIONS(1537),
    [sym_nan] = ACTIONS(1537),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(1535),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [260] = {
    [sym_function_definition] = STATE(220),
    [sym_lambda_function] = STATE(220),
    [sym_if] = STATE(220),
    [sym_while] = STATE(220),
    [sym_repeat] = STATE(220),
    [sym_for] = STATE(220),
    [sym_switch] = STATE(220),
    [sym_call] = STATE(220),
    [sym__assignment] = STATE(220),
    [sym_left_assignment] = STATE(220),
    [sym_left_assignment2] = STATE(220),
    [sym_equals_assignment] = STATE(220),
    [sym_super_assignment] = STATE(220),
    [sym_super_right_assignment] = STATE(220),
    [sym_right_assignment] = STATE(220),
    [sym_brace_list] = STATE(220),
    [sym_paren_list] = STATE(220),
    [sym_subset] = STATE(220),
    [sym_subset2] = STATE(220),
    [sym_dollar] = STATE(220),
    [sym_slot] = STATE(220),
    [sym_namespace_get] = STATE(220),
    [sym_namespace_get_internal] = STATE(220),
    [sym_pipe] = STATE(220),
    [sym_unary] = STATE(220),
    [sym_binary] = STATE(220),
    [sym_na] = STATE(220),
    [sym__expression] = STATE(220),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(220),
    [sym_string] = STATE(220),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1541),
    [sym_next] = ACTIONS(1541),
    [sym_true] = ACTIONS(1541),
    [sym_false] = ACTIONS(1541),
    [sym_null] = ACTIONS(1541),
    [sym_inf] = ACTIONS(1541),
    [sym_nan] = ACTIONS(1541),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1539),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [261] = {
    [sym_function_definition] = STATE(574),
    [sym_lambda_function] = STATE(574),
    [sym_if] = STATE(574),
    [sym_while] = STATE(574),
    [sym_repeat] = STATE(574),
    [sym_for] = STATE(574),
    [sym_switch] = STATE(574),
    [sym_call] = STATE(574),
    [sym__assignment] = STATE(574),
    [sym_left_assignment] = STATE(574),
    [sym_left_assignment2] = STATE(574),
    [sym_equals_assignment] = STATE(574),
    [sym_super_assignment] = STATE(574),
    [sym_super_right_assignment] = STATE(574),
    [sym_right_assignment] = STATE(574),
    [sym_brace_list] = STATE(574),
    [sym_paren_list] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_subset2] = STATE(574),
    [sym_dollar] = STATE(574),
    [sym_slot] = STATE(574),
    [sym_namespace_get] = STATE(574),
    [sym_namespace_get_internal] = STATE(574),
    [sym_pipe] = STATE(574),
    [sym_unary] = STATE(574),
    [sym_binary] = STATE(574),
    [sym_na] = STATE(574),
    [sym__expression] = STATE(574),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(574),
    [sym_string] = STATE(574),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1545),
    [sym_next] = ACTIONS(1545),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [sym_null] = ACTIONS(1545),
    [sym_inf] = ACTIONS(1545),
    [sym_nan] = ACTIONS(1545),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1543),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [262] = {
    [sym_function_definition] = STATE(580),
    [sym_lambda_function] = STATE(580),
    [sym_if] = STATE(580),
    [sym_while] = STATE(580),
    [sym_repeat] = STATE(580),
    [sym_for] = STATE(580),
    [sym_switch] = STATE(580),
    [sym_call] = STATE(580),
    [sym__assignment] = STATE(580),
    [sym_left_assignment] = STATE(580),
    [sym_left_assignment2] = STATE(580),
    [sym_equals_assignment] = STATE(580),
    [sym_super_assignment] = STATE(580),
    [sym_super_right_assignment] = STATE(580),
    [sym_right_assignment] = STATE(580),
    [sym_brace_list] = STATE(580),
    [sym_paren_list] = STATE(580),
    [sym_subset] = STATE(580),
    [sym_subset2] = STATE(580),
    [sym_dollar] = STATE(580),
    [sym_slot] = STATE(580),
    [sym_namespace_get] = STATE(580),
    [sym_namespace_get_internal] = STATE(580),
    [sym_pipe] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_na] = STATE(580),
    [sym__expression] = STATE(580),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(580),
    [sym_string] = STATE(580),
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1549),
    [sym_next] = ACTIONS(1549),
    [sym_true] = ACTIONS(1549),
    [sym_false] = ACTIONS(1549),
    [sym_null] = ACTIONS(1549),
    [sym_inf] = ACTIONS(1549),
    [sym_nan] = ACTIONS(1549),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1547),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [263] = {
    [sym_function_definition] = STATE(582),
    [sym_lambda_function] = STATE(582),
    [sym_if] = STATE(582),
    [sym_while] = STATE(582),
    [sym_repeat] = STATE(582),
    [sym_for] = STATE(582),
    [sym_switch] = STATE(582),
    [sym_call] = STATE(582),
    [sym__assignment] = STATE(582),
    [sym_left_assignment] = STATE(582),
    [sym_left_assignment2] = STATE(582),
    [sym_equals_assignment] = STATE(582),
    [sym_super_assignment] = STATE(582),
    [sym_super_right_assignment] = STATE(582),
    [sym_right_assignment] = STATE(582),
    [sym_brace_list] = STATE(582),
    [sym_paren_list] = STATE(582),
    [sym_subset] = STATE(582),
    [sym_subset2] = STATE(582),
    [sym_dollar] = STATE(582),
    [sym_slot] = STATE(582),
    [sym_namespace_get] = STATE(582),
    [sym_namespace_get_internal] = STATE(582),
    [sym_pipe] = STATE(582),
    [sym_unary] = STATE(582),
    [sym_binary] = STATE(582),
    [sym_na] = STATE(582),
    [sym__expression] = STATE(582),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(582),
    [sym_string] = STATE(582),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1553),
    [sym_next] = ACTIONS(1553),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [sym_null] = ACTIONS(1553),
    [sym_inf] = ACTIONS(1553),
    [sym_nan] = ACTIONS(1553),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1551),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [264] = {
    [sym_function_definition] = STATE(583),
    [sym_lambda_function] = STATE(583),
    [sym_if] = STATE(583),
    [sym_while] = STATE(583),
    [sym_repeat] = STATE(583),
    [sym_for] = STATE(583),
    [sym_switch] = STATE(583),
    [sym_call] = STATE(583),
    [sym__assignment] = STATE(583),
    [sym_left_assignment] = STATE(583),
    [sym_left_assignment2] = STATE(583),
    [sym_equals_assignment] = STATE(583),
    [sym_super_assignment] = STATE(583),
    [sym_super_right_assignment] = STATE(583),
    [sym_right_assignment] = STATE(583),
    [sym_brace_list] = STATE(583),
    [sym_paren_list] = STATE(583),
    [sym_subset] = STATE(583),
    [sym_subset2] = STATE(583),
    [sym_dollar] = STATE(583),
    [sym_slot] = STATE(583),
    [sym_namespace_get] = STATE(583),
    [sym_namespace_get_internal] = STATE(583),
    [sym_pipe] = STATE(583),
    [sym_unary] = STATE(583),
    [sym_binary] = STATE(583),
    [sym_na] = STATE(583),
    [sym__expression] = STATE(583),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(583),
    [sym_string] = STATE(583),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1557),
    [sym_next] = ACTIONS(1557),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [sym_null] = ACTIONS(1557),
    [sym_inf] = ACTIONS(1557),
    [sym_nan] = ACTIONS(1557),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1555),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [265] = {
    [sym_function_definition] = STATE(584),
    [sym_lambda_function] = STATE(584),
    [sym_if] = STATE(584),
    [sym_while] = STATE(584),
    [sym_repeat] = STATE(584),
    [sym_for] = STATE(584),
    [sym_switch] = STATE(584),
    [sym_call] = STATE(584),
    [sym__assignment] = STATE(584),
    [sym_left_assignment] = STATE(584),
    [sym_left_assignment2] = STATE(584),
    [sym_equals_assignment] = STATE(584),
    [sym_super_assignment] = STATE(584),
    [sym_super_right_assignment] = STATE(584),
    [sym_right_assignment] = STATE(584),
    [sym_brace_list] = STATE(584),
    [sym_paren_list] = STATE(584),
    [sym_subset] = STATE(584),
    [sym_subset2] = STATE(584),
    [sym_dollar] = STATE(584),
    [sym_slot] = STATE(584),
    [sym_namespace_get] = STATE(584),
    [sym_namespace_get_internal] = STATE(584),
    [sym_pipe] = STATE(584),
    [sym_unary] = STATE(584),
    [sym_binary] = STATE(584),
    [sym_na] = STATE(584),
    [sym__expression] = STATE(584),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(584),
    [sym_string] = STATE(584),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1561),
    [sym_next] = ACTIONS(1561),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [sym_null] = ACTIONS(1561),
    [sym_inf] = ACTIONS(1561),
    [sym_nan] = ACTIONS(1561),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1559),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [266] = {
    [sym_function_definition] = STATE(585),
    [sym_lambda_function] = STATE(585),
    [sym_if] = STATE(585),
    [sym_while] = STATE(585),
    [sym_repeat] = STATE(585),
    [sym_for] = STATE(585),
    [sym_switch] = STATE(585),
    [sym_call] = STATE(585),
    [sym__assignment] = STATE(585),
    [sym_left_assignment] = STATE(585),
    [sym_left_assignment2] = STATE(585),
    [sym_equals_assignment] = STATE(585),
    [sym_super_assignment] = STATE(585),
    [sym_super_right_assignment] = STATE(585),
    [sym_right_assignment] = STATE(585),
    [sym_brace_list] = STATE(585),
    [sym_paren_list] = STATE(585),
    [sym_subset] = STATE(585),
    [sym_subset2] = STATE(585),
    [sym_dollar] = STATE(585),
    [sym_slot] = STATE(585),
    [sym_namespace_get] = STATE(585),
    [sym_namespace_get_internal] = STATE(585),
    [sym_pipe] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_na] = STATE(585),
    [sym__expression] = STATE(585),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(585),
    [sym_string] = STATE(585),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1565),
    [sym_next] = ACTIONS(1565),
    [sym_true] = ACTIONS(1565),
    [sym_false] = ACTIONS(1565),
    [sym_null] = ACTIONS(1565),
    [sym_inf] = ACTIONS(1565),
    [sym_nan] = ACTIONS(1565),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1563),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [267] = {
    [sym_function_definition] = STATE(221),
    [sym_lambda_function] = STATE(221),
    [sym_if] = STATE(221),
    [sym_while] = STATE(221),
    [sym_repeat] = STATE(221),
    [sym_for] = STATE(221),
    [sym_switch] = STATE(221),
    [sym_call] = STATE(221),
    [sym__assignment] = STATE(221),
    [sym_left_assignment] = STATE(221),
    [sym_left_assignment2] = STATE(221),
    [sym_equals_assignment] = STATE(221),
    [sym_super_assignment] = STATE(221),
    [sym_super_right_assignment] = STATE(221),
    [sym_right_assignment] = STATE(221),
    [sym_brace_list] = STATE(221),
    [sym_paren_list] = STATE(221),
    [sym_subset] = STATE(221),
    [sym_subset2] = STATE(221),
    [sym_dollar] = STATE(221),
    [sym_slot] = STATE(221),
    [sym_namespace_get] = STATE(221),
    [sym_namespace_get_internal] = STATE(221),
    [sym_pipe] = STATE(221),
    [sym_unary] = STATE(221),
    [sym_binary] = STATE(221),
    [sym_na] = STATE(221),
    [sym__expression] = STATE(221),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(221),
    [sym_string] = STATE(221),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1569),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1569),
    [sym_next] = ACTIONS(1569),
    [sym_true] = ACTIONS(1569),
    [sym_false] = ACTIONS(1569),
    [sym_null] = ACTIONS(1569),
    [sym_inf] = ACTIONS(1569),
    [sym_nan] = ACTIONS(1569),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1567),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [268] = {
    [sym_function_definition] = STATE(676),
    [sym_lambda_function] = STATE(676),
    [sym_if] = STATE(676),
    [sym_while] = STATE(676),
    [sym_repeat] = STATE(676),
    [sym_for] = STATE(676),
    [sym_switch] = STATE(676),
    [sym_call] = STATE(676),
    [sym__assignment] = STATE(676),
    [sym_left_assignment] = STATE(676),
    [sym_left_assignment2] = STATE(676),
    [sym_equals_assignment] = STATE(676),
    [sym_super_assignment] = STATE(676),
    [sym_super_right_assignment] = STATE(676),
    [sym_right_assignment] = STATE(676),
    [sym_brace_list] = STATE(676),
    [sym_paren_list] = STATE(676),
    [sym_subset] = STATE(676),
    [sym_subset2] = STATE(676),
    [sym_dollar] = STATE(676),
    [sym_slot] = STATE(676),
    [sym_namespace_get] = STATE(676),
    [sym_namespace_get_internal] = STATE(676),
    [sym_pipe] = STATE(676),
    [sym_unary] = STATE(676),
    [sym_binary] = STATE(676),
    [sym_na] = STATE(676),
    [sym__expression] = STATE(676),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(676),
    [sym_string] = STATE(676),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1573),
    [sym_next] = ACTIONS(1573),
    [sym_true] = ACTIONS(1573),
    [sym_false] = ACTIONS(1573),
    [sym_null] = ACTIONS(1573),
    [sym_inf] = ACTIONS(1573),
    [sym_nan] = ACTIONS(1573),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1571),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [269] = {
    [sym_function_definition] = STATE(595),
    [sym_lambda_function] = STATE(595),
    [sym_if] = STATE(595),
    [sym_while] = STATE(595),
    [sym_repeat] = STATE(595),
    [sym_for] = STATE(595),
    [sym_switch] = STATE(595),
    [sym_call] = STATE(595),
    [sym__assignment] = STATE(595),
    [sym_left_assignment] = STATE(595),
    [sym_left_assignment2] = STATE(595),
    [sym_equals_assignment] = STATE(595),
    [sym_super_assignment] = STATE(595),
    [sym_super_right_assignment] = STATE(595),
    [sym_right_assignment] = STATE(595),
    [sym_brace_list] = STATE(595),
    [sym_paren_list] = STATE(595),
    [sym_subset] = STATE(595),
    [sym_subset2] = STATE(595),
    [sym_dollar] = STATE(595),
    [sym_slot] = STATE(595),
    [sym_namespace_get] = STATE(595),
    [sym_namespace_get_internal] = STATE(595),
    [sym_pipe] = STATE(595),
    [sym_unary] = STATE(595),
    [sym_binary] = STATE(595),
    [sym_na] = STATE(595),
    [sym__expression] = STATE(595),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(595),
    [sym_string] = STATE(595),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1577),
    [sym_next] = ACTIONS(1577),
    [sym_true] = ACTIONS(1577),
    [sym_false] = ACTIONS(1577),
    [sym_null] = ACTIONS(1577),
    [sym_inf] = ACTIONS(1577),
    [sym_nan] = ACTIONS(1577),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1575),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [270] = {
    [sym_function_definition] = STATE(596),
    [sym_lambda_function] = STATE(596),
    [sym_if] = STATE(596),
    [sym_while] = STATE(596),
    [sym_repeat] = STATE(596),
    [sym_for] = STATE(596),
    [sym_switch] = STATE(596),
    [sym_call] = STATE(596),
    [sym__assignment] = STATE(596),
    [sym_left_assignment] = STATE(596),
    [sym_left_assignment2] = STATE(596),
    [sym_equals_assignment] = STATE(596),
    [sym_super_assignment] = STATE(596),
    [sym_super_right_assignment] = STATE(596),
    [sym_right_assignment] = STATE(596),
    [sym_brace_list] = STATE(596),
    [sym_paren_list] = STATE(596),
    [sym_subset] = STATE(596),
    [sym_subset2] = STATE(596),
    [sym_dollar] = STATE(596),
    [sym_slot] = STATE(596),
    [sym_namespace_get] = STATE(596),
    [sym_namespace_get_internal] = STATE(596),
    [sym_pipe] = STATE(596),
    [sym_unary] = STATE(596),
    [sym_binary] = STATE(596),
    [sym_na] = STATE(596),
    [sym__expression] = STATE(596),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(596),
    [sym_string] = STATE(596),
    [anon_sym_SEMI] = ACTIONS(1579),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1581),
    [sym_next] = ACTIONS(1581),
    [sym_true] = ACTIONS(1581),
    [sym_false] = ACTIONS(1581),
    [sym_null] = ACTIONS(1581),
    [sym_inf] = ACTIONS(1581),
    [sym_nan] = ACTIONS(1581),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1579),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [271] = {
    [sym_function_definition] = STATE(597),
    [sym_lambda_function] = STATE(597),
    [sym_if] = STATE(597),
    [sym_while] = STATE(597),
    [sym_repeat] = STATE(597),
    [sym_for] = STATE(597),
    [sym_switch] = STATE(597),
    [sym_call] = STATE(597),
    [sym__assignment] = STATE(597),
    [sym_left_assignment] = STATE(597),
    [sym_left_assignment2] = STATE(597),
    [sym_equals_assignment] = STATE(597),
    [sym_super_assignment] = STATE(597),
    [sym_super_right_assignment] = STATE(597),
    [sym_right_assignment] = STATE(597),
    [sym_brace_list] = STATE(597),
    [sym_paren_list] = STATE(597),
    [sym_subset] = STATE(597),
    [sym_subset2] = STATE(597),
    [sym_dollar] = STATE(597),
    [sym_slot] = STATE(597),
    [sym_namespace_get] = STATE(597),
    [sym_namespace_get_internal] = STATE(597),
    [sym_pipe] = STATE(597),
    [sym_unary] = STATE(597),
    [sym_binary] = STATE(597),
    [sym_na] = STATE(597),
    [sym__expression] = STATE(597),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(597),
    [sym_string] = STATE(597),
    [anon_sym_SEMI] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1585),
    [sym_next] = ACTIONS(1585),
    [sym_true] = ACTIONS(1585),
    [sym_false] = ACTIONS(1585),
    [sym_null] = ACTIONS(1585),
    [sym_inf] = ACTIONS(1585),
    [sym_nan] = ACTIONS(1585),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1583),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [272] = {
    [sym_function_definition] = STATE(598),
    [sym_lambda_function] = STATE(598),
    [sym_if] = STATE(598),
    [sym_while] = STATE(598),
    [sym_repeat] = STATE(598),
    [sym_for] = STATE(598),
    [sym_switch] = STATE(598),
    [sym_call] = STATE(598),
    [sym__assignment] = STATE(598),
    [sym_left_assignment] = STATE(598),
    [sym_left_assignment2] = STATE(598),
    [sym_equals_assignment] = STATE(598),
    [sym_super_assignment] = STATE(598),
    [sym_super_right_assignment] = STATE(598),
    [sym_right_assignment] = STATE(598),
    [sym_brace_list] = STATE(598),
    [sym_paren_list] = STATE(598),
    [sym_subset] = STATE(598),
    [sym_subset2] = STATE(598),
    [sym_dollar] = STATE(598),
    [sym_slot] = STATE(598),
    [sym_namespace_get] = STATE(598),
    [sym_namespace_get_internal] = STATE(598),
    [sym_pipe] = STATE(598),
    [sym_unary] = STATE(598),
    [sym_binary] = STATE(598),
    [sym_na] = STATE(598),
    [sym__expression] = STATE(598),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(598),
    [sym_string] = STATE(598),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1589),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1589),
    [sym_next] = ACTIONS(1589),
    [sym_true] = ACTIONS(1589),
    [sym_false] = ACTIONS(1589),
    [sym_null] = ACTIONS(1589),
    [sym_inf] = ACTIONS(1589),
    [sym_nan] = ACTIONS(1589),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1587),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [273] = {
    [sym_function_definition] = STATE(599),
    [sym_lambda_function] = STATE(599),
    [sym_if] = STATE(599),
    [sym_while] = STATE(599),
    [sym_repeat] = STATE(599),
    [sym_for] = STATE(599),
    [sym_switch] = STATE(599),
    [sym_call] = STATE(599),
    [sym__assignment] = STATE(599),
    [sym_left_assignment] = STATE(599),
    [sym_left_assignment2] = STATE(599),
    [sym_equals_assignment] = STATE(599),
    [sym_super_assignment] = STATE(599),
    [sym_super_right_assignment] = STATE(599),
    [sym_right_assignment] = STATE(599),
    [sym_brace_list] = STATE(599),
    [sym_paren_list] = STATE(599),
    [sym_subset] = STATE(599),
    [sym_subset2] = STATE(599),
    [sym_dollar] = STATE(599),
    [sym_slot] = STATE(599),
    [sym_namespace_get] = STATE(599),
    [sym_namespace_get_internal] = STATE(599),
    [sym_pipe] = STATE(599),
    [sym_unary] = STATE(599),
    [sym_binary] = STATE(599),
    [sym_na] = STATE(599),
    [sym__expression] = STATE(599),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(599),
    [sym_string] = STATE(599),
    [anon_sym_SEMI] = ACTIONS(1591),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1593),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1593),
    [sym_next] = ACTIONS(1593),
    [sym_true] = ACTIONS(1593),
    [sym_false] = ACTIONS(1593),
    [sym_null] = ACTIONS(1593),
    [sym_inf] = ACTIONS(1593),
    [sym_nan] = ACTIONS(1593),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1591),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [274] = {
    [sym_function_definition] = STATE(601),
    [sym_lambda_function] = STATE(601),
    [sym_if] = STATE(601),
    [sym_while] = STATE(601),
    [sym_repeat] = STATE(601),
    [sym_for] = STATE(601),
    [sym_switch] = STATE(601),
    [sym_call] = STATE(601),
    [sym__assignment] = STATE(601),
    [sym_left_assignment] = STATE(601),
    [sym_left_assignment2] = STATE(601),
    [sym_equals_assignment] = STATE(601),
    [sym_super_assignment] = STATE(601),
    [sym_super_right_assignment] = STATE(601),
    [sym_right_assignment] = STATE(601),
    [sym_brace_list] = STATE(601),
    [sym_paren_list] = STATE(601),
    [sym_subset] = STATE(601),
    [sym_subset2] = STATE(601),
    [sym_dollar] = STATE(601),
    [sym_slot] = STATE(601),
    [sym_namespace_get] = STATE(601),
    [sym_namespace_get_internal] = STATE(601),
    [sym_pipe] = STATE(601),
    [sym_unary] = STATE(601),
    [sym_binary] = STATE(601),
    [sym_na] = STATE(601),
    [sym__expression] = STATE(601),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(601),
    [sym_string] = STATE(601),
    [anon_sym_SEMI] = ACTIONS(1595),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1597),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1597),
    [sym_next] = ACTIONS(1597),
    [sym_true] = ACTIONS(1597),
    [sym_false] = ACTIONS(1597),
    [sym_null] = ACTIONS(1597),
    [sym_inf] = ACTIONS(1597),
    [sym_nan] = ACTIONS(1597),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1595),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [275] = {
    [sym_function_definition] = STATE(602),
    [sym_lambda_function] = STATE(602),
    [sym_if] = STATE(602),
    [sym_while] = STATE(602),
    [sym_repeat] = STATE(602),
    [sym_for] = STATE(602),
    [sym_switch] = STATE(602),
    [sym_call] = STATE(602),
    [sym__assignment] = STATE(602),
    [sym_left_assignment] = STATE(602),
    [sym_left_assignment2] = STATE(602),
    [sym_equals_assignment] = STATE(602),
    [sym_super_assignment] = STATE(602),
    [sym_super_right_assignment] = STATE(602),
    [sym_right_assignment] = STATE(602),
    [sym_brace_list] = STATE(602),
    [sym_paren_list] = STATE(602),
    [sym_subset] = STATE(602),
    [sym_subset2] = STATE(602),
    [sym_dollar] = STATE(602),
    [sym_slot] = STATE(602),
    [sym_namespace_get] = STATE(602),
    [sym_namespace_get_internal] = STATE(602),
    [sym_pipe] = STATE(602),
    [sym_unary] = STATE(602),
    [sym_binary] = STATE(602),
    [sym_na] = STATE(602),
    [sym__expression] = STATE(602),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(602),
    [sym_string] = STATE(602),
    [anon_sym_SEMI] = ACTIONS(1599),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1601),
    [sym_next] = ACTIONS(1601),
    [sym_true] = ACTIONS(1601),
    [sym_false] = ACTIONS(1601),
    [sym_null] = ACTIONS(1601),
    [sym_inf] = ACTIONS(1601),
    [sym_nan] = ACTIONS(1601),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1599),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [276] = {
    [sym_function_definition] = STATE(603),
    [sym_lambda_function] = STATE(603),
    [sym_if] = STATE(603),
    [sym_while] = STATE(603),
    [sym_repeat] = STATE(603),
    [sym_for] = STATE(603),
    [sym_switch] = STATE(603),
    [sym_call] = STATE(603),
    [sym__assignment] = STATE(603),
    [sym_left_assignment] = STATE(603),
    [sym_left_assignment2] = STATE(603),
    [sym_equals_assignment] = STATE(603),
    [sym_super_assignment] = STATE(603),
    [sym_super_right_assignment] = STATE(603),
    [sym_right_assignment] = STATE(603),
    [sym_brace_list] = STATE(603),
    [sym_paren_list] = STATE(603),
    [sym_subset] = STATE(603),
    [sym_subset2] = STATE(603),
    [sym_dollar] = STATE(603),
    [sym_slot] = STATE(603),
    [sym_namespace_get] = STATE(603),
    [sym_namespace_get_internal] = STATE(603),
    [sym_pipe] = STATE(603),
    [sym_unary] = STATE(603),
    [sym_binary] = STATE(603),
    [sym_na] = STATE(603),
    [sym__expression] = STATE(603),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(603),
    [sym_string] = STATE(603),
    [anon_sym_SEMI] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1605),
    [sym_next] = ACTIONS(1605),
    [sym_true] = ACTIONS(1605),
    [sym_false] = ACTIONS(1605),
    [sym_null] = ACTIONS(1605),
    [sym_inf] = ACTIONS(1605),
    [sym_nan] = ACTIONS(1605),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1603),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [277] = {
    [sym_function_definition] = STATE(609),
    [sym_lambda_function] = STATE(609),
    [sym_if] = STATE(609),
    [sym_while] = STATE(609),
    [sym_repeat] = STATE(609),
    [sym_for] = STATE(609),
    [sym_switch] = STATE(609),
    [sym_call] = STATE(609),
    [sym__assignment] = STATE(609),
    [sym_left_assignment] = STATE(609),
    [sym_left_assignment2] = STATE(609),
    [sym_equals_assignment] = STATE(609),
    [sym_super_assignment] = STATE(609),
    [sym_super_right_assignment] = STATE(609),
    [sym_right_assignment] = STATE(609),
    [sym_brace_list] = STATE(609),
    [sym_paren_list] = STATE(609),
    [sym_subset] = STATE(609),
    [sym_subset2] = STATE(609),
    [sym_dollar] = STATE(609),
    [sym_slot] = STATE(609),
    [sym_namespace_get] = STATE(609),
    [sym_namespace_get_internal] = STATE(609),
    [sym_pipe] = STATE(609),
    [sym_unary] = STATE(609),
    [sym_binary] = STATE(609),
    [sym_na] = STATE(609),
    [sym__expression] = STATE(609),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(609),
    [sym_string] = STATE(609),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1609),
    [sym_next] = ACTIONS(1609),
    [sym_true] = ACTIONS(1609),
    [sym_false] = ACTIONS(1609),
    [sym_null] = ACTIONS(1609),
    [sym_inf] = ACTIONS(1609),
    [sym_nan] = ACTIONS(1609),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1607),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [278] = {
    [sym_function_definition] = STATE(688),
    [sym_lambda_function] = STATE(688),
    [sym_if] = STATE(688),
    [sym_while] = STATE(688),
    [sym_repeat] = STATE(688),
    [sym_for] = STATE(688),
    [sym_switch] = STATE(688),
    [sym_call] = STATE(688),
    [sym__assignment] = STATE(688),
    [sym_left_assignment] = STATE(688),
    [sym_left_assignment2] = STATE(688),
    [sym_equals_assignment] = STATE(688),
    [sym_super_assignment] = STATE(688),
    [sym_super_right_assignment] = STATE(688),
    [sym_right_assignment] = STATE(688),
    [sym_brace_list] = STATE(688),
    [sym_paren_list] = STATE(688),
    [sym_subset] = STATE(688),
    [sym_subset2] = STATE(688),
    [sym_dollar] = STATE(688),
    [sym_slot] = STATE(688),
    [sym_namespace_get] = STATE(688),
    [sym_namespace_get_internal] = STATE(688),
    [sym_pipe] = STATE(688),
    [sym_unary] = STATE(688),
    [sym_binary] = STATE(688),
    [sym_na] = STATE(688),
    [sym__expression] = STATE(688),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(688),
    [sym_string] = STATE(688),
    [anon_sym_SEMI] = ACTIONS(1611),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1613),
    [sym_next] = ACTIONS(1613),
    [sym_true] = ACTIONS(1613),
    [sym_false] = ACTIONS(1613),
    [sym_null] = ACTIONS(1613),
    [sym_inf] = ACTIONS(1613),
    [sym_nan] = ACTIONS(1613),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1611),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [279] = {
    [sym_function_definition] = STATE(898),
    [sym_lambda_function] = STATE(898),
    [sym_if] = STATE(898),
    [sym_while] = STATE(898),
    [sym_repeat] = STATE(898),
    [sym_for] = STATE(898),
    [sym_switch] = STATE(898),
    [sym_call] = STATE(898),
    [sym__assignment] = STATE(898),
    [sym_left_assignment] = STATE(898),
    [sym_left_assignment2] = STATE(898),
    [sym_equals_assignment] = STATE(898),
    [sym_super_assignment] = STATE(898),
    [sym_super_right_assignment] = STATE(898),
    [sym_right_assignment] = STATE(898),
    [sym_brace_list] = STATE(898),
    [sym_paren_list] = STATE(898),
    [sym_subset] = STATE(898),
    [sym_subset2] = STATE(898),
    [sym_dollar] = STATE(898),
    [sym_slot] = STATE(898),
    [sym_namespace_get] = STATE(898),
    [sym_namespace_get_internal] = STATE(898),
    [sym_pipe] = STATE(898),
    [sym_unary] = STATE(898),
    [sym_binary] = STATE(898),
    [sym_na] = STATE(898),
    [sym__expression] = STATE(898),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(898),
    [sym_string] = STATE(898),
    [anon_sym_SEMI] = ACTIONS(1615),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1617),
    [sym_next] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_inf] = ACTIONS(1617),
    [sym_nan] = ACTIONS(1617),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1615),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [280] = {
    [sym_function_definition] = STATE(222),
    [sym_lambda_function] = STATE(222),
    [sym_if] = STATE(222),
    [sym_while] = STATE(222),
    [sym_repeat] = STATE(222),
    [sym_for] = STATE(222),
    [sym_switch] = STATE(222),
    [sym_call] = STATE(222),
    [sym__assignment] = STATE(222),
    [sym_left_assignment] = STATE(222),
    [sym_left_assignment2] = STATE(222),
    [sym_equals_assignment] = STATE(222),
    [sym_super_assignment] = STATE(222),
    [sym_super_right_assignment] = STATE(222),
    [sym_right_assignment] = STATE(222),
    [sym_brace_list] = STATE(222),
    [sym_paren_list] = STATE(222),
    [sym_subset] = STATE(222),
    [sym_subset2] = STATE(222),
    [sym_dollar] = STATE(222),
    [sym_slot] = STATE(222),
    [sym_namespace_get] = STATE(222),
    [sym_namespace_get_internal] = STATE(222),
    [sym_pipe] = STATE(222),
    [sym_unary] = STATE(222),
    [sym_binary] = STATE(222),
    [sym_na] = STATE(222),
    [sym__expression] = STATE(222),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(222),
    [sym_string] = STATE(222),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1621),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1621),
    [sym_next] = ACTIONS(1621),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [sym_null] = ACTIONS(1621),
    [sym_inf] = ACTIONS(1621),
    [sym_nan] = ACTIONS(1621),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1619),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [281] = {
    [sym_function_definition] = STATE(223),
    [sym_lambda_function] = STATE(223),
    [sym_if] = STATE(223),
    [sym_while] = STATE(223),
    [sym_repeat] = STATE(223),
    [sym_for] = STATE(223),
    [sym_switch] = STATE(223),
    [sym_call] = STATE(223),
    [sym__assignment] = STATE(223),
    [sym_left_assignment] = STATE(223),
    [sym_left_assignment2] = STATE(223),
    [sym_equals_assignment] = STATE(223),
    [sym_super_assignment] = STATE(223),
    [sym_super_right_assignment] = STATE(223),
    [sym_right_assignment] = STATE(223),
    [sym_brace_list] = STATE(223),
    [sym_paren_list] = STATE(223),
    [sym_subset] = STATE(223),
    [sym_subset2] = STATE(223),
    [sym_dollar] = STATE(223),
    [sym_slot] = STATE(223),
    [sym_namespace_get] = STATE(223),
    [sym_namespace_get_internal] = STATE(223),
    [sym_pipe] = STATE(223),
    [sym_unary] = STATE(223),
    [sym_binary] = STATE(223),
    [sym_na] = STATE(223),
    [sym__expression] = STATE(223),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(223),
    [sym_string] = STATE(223),
    [anon_sym_SEMI] = ACTIONS(1623),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1625),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1625),
    [sym_next] = ACTIONS(1625),
    [sym_true] = ACTIONS(1625),
    [sym_false] = ACTIONS(1625),
    [sym_null] = ACTIONS(1625),
    [sym_inf] = ACTIONS(1625),
    [sym_nan] = ACTIONS(1625),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1623),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [282] = {
    [sym_function_definition] = STATE(496),
    [sym_lambda_function] = STATE(496),
    [sym_if] = STATE(496),
    [sym_while] = STATE(496),
    [sym_repeat] = STATE(496),
    [sym_for] = STATE(496),
    [sym_switch] = STATE(496),
    [sym_call] = STATE(496),
    [sym__assignment] = STATE(496),
    [sym_left_assignment] = STATE(496),
    [sym_left_assignment2] = STATE(496),
    [sym_equals_assignment] = STATE(496),
    [sym_super_assignment] = STATE(496),
    [sym_super_right_assignment] = STATE(496),
    [sym_right_assignment] = STATE(496),
    [sym_brace_list] = STATE(496),
    [sym_paren_list] = STATE(496),
    [sym_subset] = STATE(496),
    [sym_subset2] = STATE(496),
    [sym_dollar] = STATE(496),
    [sym_slot] = STATE(496),
    [sym_namespace_get] = STATE(496),
    [sym_namespace_get_internal] = STATE(496),
    [sym_pipe] = STATE(496),
    [sym_unary] = STATE(496),
    [sym_binary] = STATE(496),
    [sym_na] = STATE(496),
    [sym__expression] = STATE(496),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(496),
    [sym_string] = STATE(496),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1629),
    [sym_next] = ACTIONS(1629),
    [sym_true] = ACTIONS(1629),
    [sym_false] = ACTIONS(1629),
    [sym_null] = ACTIONS(1629),
    [sym_inf] = ACTIONS(1629),
    [sym_nan] = ACTIONS(1629),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1627),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [283] = {
    [sym_function_definition] = STATE(925),
    [sym_lambda_function] = STATE(925),
    [sym_if] = STATE(925),
    [sym_while] = STATE(925),
    [sym_repeat] = STATE(925),
    [sym_for] = STATE(925),
    [sym_switch] = STATE(925),
    [sym_call] = STATE(634),
    [sym__assignment] = STATE(925),
    [sym_left_assignment] = STATE(925),
    [sym_left_assignment2] = STATE(925),
    [sym_equals_assignment] = STATE(925),
    [sym_super_assignment] = STATE(925),
    [sym_super_right_assignment] = STATE(925),
    [sym_right_assignment] = STATE(925),
    [sym_brace_list] = STATE(925),
    [sym_paren_list] = STATE(925),
    [sym_subset] = STATE(925),
    [sym_subset2] = STATE(925),
    [sym_dollar] = STATE(925),
    [sym_slot] = STATE(925),
    [sym_namespace_get] = STATE(925),
    [sym_namespace_get_internal] = STATE(925),
    [sym_pipe] = STATE(925),
    [sym_unary] = STATE(925),
    [sym_binary] = STATE(925),
    [sym_na] = STATE(925),
    [sym__expression] = STATE(925),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(925),
    [sym_string] = STATE(925),
    [anon_sym_SEMI] = ACTIONS(1631),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1633),
    [sym_next] = ACTIONS(1633),
    [sym_true] = ACTIONS(1633),
    [sym_false] = ACTIONS(1633),
    [sym_null] = ACTIONS(1633),
    [sym_inf] = ACTIONS(1633),
    [sym_nan] = ACTIONS(1633),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1631),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [284] = {
    [sym_function_definition] = STATE(224),
    [sym_lambda_function] = STATE(224),
    [sym_if] = STATE(224),
    [sym_while] = STATE(224),
    [sym_repeat] = STATE(224),
    [sym_for] = STATE(224),
    [sym_switch] = STATE(224),
    [sym_call] = STATE(224),
    [sym__assignment] = STATE(224),
    [sym_left_assignment] = STATE(224),
    [sym_left_assignment2] = STATE(224),
    [sym_equals_assignment] = STATE(224),
    [sym_super_assignment] = STATE(224),
    [sym_super_right_assignment] = STATE(224),
    [sym_right_assignment] = STATE(224),
    [sym_brace_list] = STATE(224),
    [sym_paren_list] = STATE(224),
    [sym_subset] = STATE(224),
    [sym_subset2] = STATE(224),
    [sym_dollar] = STATE(224),
    [sym_slot] = STATE(224),
    [sym_namespace_get] = STATE(224),
    [sym_namespace_get_internal] = STATE(224),
    [sym_pipe] = STATE(224),
    [sym_unary] = STATE(224),
    [sym_binary] = STATE(224),
    [sym_na] = STATE(224),
    [sym__expression] = STATE(224),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(224),
    [sym_string] = STATE(224),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1637),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1637),
    [sym_next] = ACTIONS(1637),
    [sym_true] = ACTIONS(1637),
    [sym_false] = ACTIONS(1637),
    [sym_null] = ACTIONS(1637),
    [sym_inf] = ACTIONS(1637),
    [sym_nan] = ACTIONS(1637),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1635),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [285] = {
    [sym_function_definition] = STATE(800),
    [sym_lambda_function] = STATE(800),
    [sym_if] = STATE(800),
    [sym_while] = STATE(800),
    [sym_repeat] = STATE(800),
    [sym_for] = STATE(800),
    [sym_switch] = STATE(800),
    [sym_call] = STATE(800),
    [sym__assignment] = STATE(800),
    [sym_left_assignment] = STATE(800),
    [sym_left_assignment2] = STATE(800),
    [sym_equals_assignment] = STATE(800),
    [sym_super_assignment] = STATE(800),
    [sym_super_right_assignment] = STATE(800),
    [sym_right_assignment] = STATE(800),
    [sym_brace_list] = STATE(800),
    [sym_paren_list] = STATE(800),
    [sym_subset] = STATE(800),
    [sym_subset2] = STATE(800),
    [sym_dollar] = STATE(800),
    [sym_slot] = STATE(800),
    [sym_namespace_get] = STATE(800),
    [sym_namespace_get_internal] = STATE(800),
    [sym_pipe] = STATE(800),
    [sym_unary] = STATE(800),
    [sym_binary] = STATE(800),
    [sym_na] = STATE(800),
    [sym__expression] = STATE(800),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(800),
    [sym_string] = STATE(800),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1641),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1641),
    [sym_next] = ACTIONS(1641),
    [sym_true] = ACTIONS(1641),
    [sym_false] = ACTIONS(1641),
    [sym_null] = ACTIONS(1641),
    [sym_inf] = ACTIONS(1641),
    [sym_nan] = ACTIONS(1641),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1639),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [286] = {
    [sym_function_definition] = STATE(893),
    [sym_lambda_function] = STATE(893),
    [sym_if] = STATE(893),
    [sym_while] = STATE(893),
    [sym_repeat] = STATE(893),
    [sym_for] = STATE(893),
    [sym_switch] = STATE(893),
    [sym_call] = STATE(893),
    [sym__assignment] = STATE(893),
    [sym_left_assignment] = STATE(893),
    [sym_left_assignment2] = STATE(893),
    [sym_equals_assignment] = STATE(893),
    [sym_super_assignment] = STATE(893),
    [sym_super_right_assignment] = STATE(893),
    [sym_right_assignment] = STATE(893),
    [sym_brace_list] = STATE(893),
    [sym_paren_list] = STATE(893),
    [sym_subset] = STATE(893),
    [sym_subset2] = STATE(893),
    [sym_dollar] = STATE(893),
    [sym_slot] = STATE(893),
    [sym_namespace_get] = STATE(893),
    [sym_namespace_get_internal] = STATE(893),
    [sym_pipe] = STATE(893),
    [sym_unary] = STATE(893),
    [sym_binary] = STATE(893),
    [sym_na] = STATE(893),
    [sym__expression] = STATE(893),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(893),
    [sym_string] = STATE(893),
    [anon_sym_SEMI] = ACTIONS(1643),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1645),
    [sym_next] = ACTIONS(1645),
    [sym_true] = ACTIONS(1645),
    [sym_false] = ACTIONS(1645),
    [sym_null] = ACTIONS(1645),
    [sym_inf] = ACTIONS(1645),
    [sym_nan] = ACTIONS(1645),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1643),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [287] = {
    [sym_function_definition] = STATE(225),
    [sym_lambda_function] = STATE(225),
    [sym_if] = STATE(225),
    [sym_while] = STATE(225),
    [sym_repeat] = STATE(225),
    [sym_for] = STATE(225),
    [sym_switch] = STATE(225),
    [sym_call] = STATE(225),
    [sym__assignment] = STATE(225),
    [sym_left_assignment] = STATE(225),
    [sym_left_assignment2] = STATE(225),
    [sym_equals_assignment] = STATE(225),
    [sym_super_assignment] = STATE(225),
    [sym_super_right_assignment] = STATE(225),
    [sym_right_assignment] = STATE(225),
    [sym_brace_list] = STATE(225),
    [sym_paren_list] = STATE(225),
    [sym_subset] = STATE(225),
    [sym_subset2] = STATE(225),
    [sym_dollar] = STATE(225),
    [sym_slot] = STATE(225),
    [sym_namespace_get] = STATE(225),
    [sym_namespace_get_internal] = STATE(225),
    [sym_pipe] = STATE(225),
    [sym_unary] = STATE(225),
    [sym_binary] = STATE(225),
    [sym_na] = STATE(225),
    [sym__expression] = STATE(225),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(225),
    [sym_string] = STATE(225),
    [anon_sym_SEMI] = ACTIONS(1647),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1649),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1649),
    [sym_next] = ACTIONS(1649),
    [sym_true] = ACTIONS(1649),
    [sym_false] = ACTIONS(1649),
    [sym_null] = ACTIONS(1649),
    [sym_inf] = ACTIONS(1649),
    [sym_nan] = ACTIONS(1649),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1647),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [288] = {
    [sym_function_definition] = STATE(226),
    [sym_lambda_function] = STATE(226),
    [sym_if] = STATE(226),
    [sym_while] = STATE(226),
    [sym_repeat] = STATE(226),
    [sym_for] = STATE(226),
    [sym_switch] = STATE(226),
    [sym_call] = STATE(226),
    [sym__assignment] = STATE(226),
    [sym_left_assignment] = STATE(226),
    [sym_left_assignment2] = STATE(226),
    [sym_equals_assignment] = STATE(226),
    [sym_super_assignment] = STATE(226),
    [sym_super_right_assignment] = STATE(226),
    [sym_right_assignment] = STATE(226),
    [sym_brace_list] = STATE(226),
    [sym_paren_list] = STATE(226),
    [sym_subset] = STATE(226),
    [sym_subset2] = STATE(226),
    [sym_dollar] = STATE(226),
    [sym_slot] = STATE(226),
    [sym_namespace_get] = STATE(226),
    [sym_namespace_get_internal] = STATE(226),
    [sym_pipe] = STATE(226),
    [sym_unary] = STATE(226),
    [sym_binary] = STATE(226),
    [sym_na] = STATE(226),
    [sym__expression] = STATE(226),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(226),
    [sym_string] = STATE(226),
    [anon_sym_SEMI] = ACTIONS(1651),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1653),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1653),
    [sym_next] = ACTIONS(1653),
    [sym_true] = ACTIONS(1653),
    [sym_false] = ACTIONS(1653),
    [sym_null] = ACTIONS(1653),
    [sym_inf] = ACTIONS(1653),
    [sym_nan] = ACTIONS(1653),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1651),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [289] = {
    [sym_function_definition] = STATE(235),
    [sym_lambda_function] = STATE(235),
    [sym_if] = STATE(235),
    [sym_while] = STATE(235),
    [sym_repeat] = STATE(235),
    [sym_for] = STATE(235),
    [sym_switch] = STATE(235),
    [sym_call] = STATE(235),
    [sym__assignment] = STATE(235),
    [sym_left_assignment] = STATE(235),
    [sym_left_assignment2] = STATE(235),
    [sym_equals_assignment] = STATE(235),
    [sym_super_assignment] = STATE(235),
    [sym_super_right_assignment] = STATE(235),
    [sym_right_assignment] = STATE(235),
    [sym_brace_list] = STATE(235),
    [sym_paren_list] = STATE(235),
    [sym_subset] = STATE(235),
    [sym_subset2] = STATE(235),
    [sym_dollar] = STATE(235),
    [sym_slot] = STATE(235),
    [sym_namespace_get] = STATE(235),
    [sym_namespace_get_internal] = STATE(235),
    [sym_pipe] = STATE(235),
    [sym_unary] = STATE(235),
    [sym_binary] = STATE(235),
    [sym_na] = STATE(235),
    [sym__expression] = STATE(235),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(235),
    [sym_string] = STATE(235),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1657),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1657),
    [sym_next] = ACTIONS(1657),
    [sym_true] = ACTIONS(1657),
    [sym_false] = ACTIONS(1657),
    [sym_null] = ACTIONS(1657),
    [sym_inf] = ACTIONS(1657),
    [sym_nan] = ACTIONS(1657),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1655),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [290] = {
    [sym_function_definition] = STATE(236),
    [sym_lambda_function] = STATE(236),
    [sym_if] = STATE(236),
    [sym_while] = STATE(236),
    [sym_repeat] = STATE(236),
    [sym_for] = STATE(236),
    [sym_switch] = STATE(236),
    [sym_call] = STATE(236),
    [sym__assignment] = STATE(236),
    [sym_left_assignment] = STATE(236),
    [sym_left_assignment2] = STATE(236),
    [sym_equals_assignment] = STATE(236),
    [sym_super_assignment] = STATE(236),
    [sym_super_right_assignment] = STATE(236),
    [sym_right_assignment] = STATE(236),
    [sym_brace_list] = STATE(236),
    [sym_paren_list] = STATE(236),
    [sym_subset] = STATE(236),
    [sym_subset2] = STATE(236),
    [sym_dollar] = STATE(236),
    [sym_slot] = STATE(236),
    [sym_namespace_get] = STATE(236),
    [sym_namespace_get_internal] = STATE(236),
    [sym_pipe] = STATE(236),
    [sym_unary] = STATE(236),
    [sym_binary] = STATE(236),
    [sym_na] = STATE(236),
    [sym__expression] = STATE(236),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(236),
    [sym_string] = STATE(236),
    [anon_sym_SEMI] = ACTIONS(1659),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1661),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1661),
    [sym_next] = ACTIONS(1661),
    [sym_true] = ACTIONS(1661),
    [sym_false] = ACTIONS(1661),
    [sym_null] = ACTIONS(1661),
    [sym_inf] = ACTIONS(1661),
    [sym_nan] = ACTIONS(1661),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1659),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [291] = {
    [sym_function_definition] = STATE(239),
    [sym_lambda_function] = STATE(239),
    [sym_if] = STATE(239),
    [sym_while] = STATE(239),
    [sym_repeat] = STATE(239),
    [sym_for] = STATE(239),
    [sym_switch] = STATE(239),
    [sym_call] = STATE(239),
    [sym__assignment] = STATE(239),
    [sym_left_assignment] = STATE(239),
    [sym_left_assignment2] = STATE(239),
    [sym_equals_assignment] = STATE(239),
    [sym_super_assignment] = STATE(239),
    [sym_super_right_assignment] = STATE(239),
    [sym_right_assignment] = STATE(239),
    [sym_brace_list] = STATE(239),
    [sym_paren_list] = STATE(239),
    [sym_subset] = STATE(239),
    [sym_subset2] = STATE(239),
    [sym_dollar] = STATE(239),
    [sym_slot] = STATE(239),
    [sym_namespace_get] = STATE(239),
    [sym_namespace_get_internal] = STATE(239),
    [sym_pipe] = STATE(239),
    [sym_unary] = STATE(239),
    [sym_binary] = STATE(239),
    [sym_na] = STATE(239),
    [sym__expression] = STATE(239),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(239),
    [sym_string] = STATE(239),
    [anon_sym_SEMI] = ACTIONS(1663),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1665),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1665),
    [sym_next] = ACTIONS(1665),
    [sym_true] = ACTIONS(1665),
    [sym_false] = ACTIONS(1665),
    [sym_null] = ACTIONS(1665),
    [sym_inf] = ACTIONS(1665),
    [sym_nan] = ACTIONS(1665),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1663),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [292] = {
    [sym_function_definition] = STATE(240),
    [sym_lambda_function] = STATE(240),
    [sym_if] = STATE(240),
    [sym_while] = STATE(240),
    [sym_repeat] = STATE(240),
    [sym_for] = STATE(240),
    [sym_switch] = STATE(240),
    [sym_call] = STATE(240),
    [sym__assignment] = STATE(240),
    [sym_left_assignment] = STATE(240),
    [sym_left_assignment2] = STATE(240),
    [sym_equals_assignment] = STATE(240),
    [sym_super_assignment] = STATE(240),
    [sym_super_right_assignment] = STATE(240),
    [sym_right_assignment] = STATE(240),
    [sym_brace_list] = STATE(240),
    [sym_paren_list] = STATE(240),
    [sym_subset] = STATE(240),
    [sym_subset2] = STATE(240),
    [sym_dollar] = STATE(240),
    [sym_slot] = STATE(240),
    [sym_namespace_get] = STATE(240),
    [sym_namespace_get_internal] = STATE(240),
    [sym_pipe] = STATE(240),
    [sym_unary] = STATE(240),
    [sym_binary] = STATE(240),
    [sym_na] = STATE(240),
    [sym__expression] = STATE(240),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(240),
    [sym_string] = STATE(240),
    [anon_sym_SEMI] = ACTIONS(1667),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1669),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1669),
    [sym_next] = ACTIONS(1669),
    [sym_true] = ACTIONS(1669),
    [sym_false] = ACTIONS(1669),
    [sym_null] = ACTIONS(1669),
    [sym_inf] = ACTIONS(1669),
    [sym_nan] = ACTIONS(1669),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1667),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [293] = {
    [sym_function_definition] = STATE(241),
    [sym_lambda_function] = STATE(241),
    [sym_if] = STATE(241),
    [sym_while] = STATE(241),
    [sym_repeat] = STATE(241),
    [sym_for] = STATE(241),
    [sym_switch] = STATE(241),
    [sym_call] = STATE(241),
    [sym__assignment] = STATE(241),
    [sym_left_assignment] = STATE(241),
    [sym_left_assignment2] = STATE(241),
    [sym_equals_assignment] = STATE(241),
    [sym_super_assignment] = STATE(241),
    [sym_super_right_assignment] = STATE(241),
    [sym_right_assignment] = STATE(241),
    [sym_brace_list] = STATE(241),
    [sym_paren_list] = STATE(241),
    [sym_subset] = STATE(241),
    [sym_subset2] = STATE(241),
    [sym_dollar] = STATE(241),
    [sym_slot] = STATE(241),
    [sym_namespace_get] = STATE(241),
    [sym_namespace_get_internal] = STATE(241),
    [sym_pipe] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_na] = STATE(241),
    [sym__expression] = STATE(241),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(241),
    [sym_string] = STATE(241),
    [anon_sym_SEMI] = ACTIONS(1671),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1673),
    [sym_next] = ACTIONS(1673),
    [sym_true] = ACTIONS(1673),
    [sym_false] = ACTIONS(1673),
    [sym_null] = ACTIONS(1673),
    [sym_inf] = ACTIONS(1673),
    [sym_nan] = ACTIONS(1673),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1671),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [294] = {
    [sym_function_definition] = STATE(896),
    [sym_lambda_function] = STATE(896),
    [sym_if] = STATE(896),
    [sym_while] = STATE(896),
    [sym_repeat] = STATE(896),
    [sym_for] = STATE(896),
    [sym_switch] = STATE(896),
    [sym_call] = STATE(896),
    [sym__assignment] = STATE(896),
    [sym_left_assignment] = STATE(896),
    [sym_left_assignment2] = STATE(896),
    [sym_equals_assignment] = STATE(896),
    [sym_super_assignment] = STATE(896),
    [sym_super_right_assignment] = STATE(896),
    [sym_right_assignment] = STATE(896),
    [sym_brace_list] = STATE(896),
    [sym_paren_list] = STATE(896),
    [sym_subset] = STATE(896),
    [sym_subset2] = STATE(896),
    [sym_dollar] = STATE(896),
    [sym_slot] = STATE(896),
    [sym_namespace_get] = STATE(896),
    [sym_namespace_get_internal] = STATE(896),
    [sym_pipe] = STATE(896),
    [sym_unary] = STATE(896),
    [sym_binary] = STATE(896),
    [sym_na] = STATE(896),
    [sym__expression] = STATE(896),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(896),
    [sym_string] = STATE(896),
    [anon_sym_SEMI] = ACTIONS(1675),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1677),
    [sym_next] = ACTIONS(1677),
    [sym_true] = ACTIONS(1677),
    [sym_false] = ACTIONS(1677),
    [sym_null] = ACTIONS(1677),
    [sym_inf] = ACTIONS(1677),
    [sym_nan] = ACTIONS(1677),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1675),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [295] = {
    [sym_function_definition] = STATE(116),
    [sym_lambda_function] = STATE(116),
    [sym_if] = STATE(116),
    [sym_while] = STATE(116),
    [sym_repeat] = STATE(116),
    [sym_for] = STATE(116),
    [sym_switch] = STATE(116),
    [sym_call] = STATE(116),
    [sym__assignment] = STATE(116),
    [sym_left_assignment] = STATE(116),
    [sym_left_assignment2] = STATE(116),
    [sym_equals_assignment] = STATE(116),
    [sym_super_assignment] = STATE(116),
    [sym_super_right_assignment] = STATE(116),
    [sym_right_assignment] = STATE(116),
    [sym_brace_list] = STATE(116),
    [sym_paren_list] = STATE(116),
    [sym_subset] = STATE(116),
    [sym_subset2] = STATE(116),
    [sym_dollar] = STATE(116),
    [sym_slot] = STATE(116),
    [sym_namespace_get] = STATE(116),
    [sym_namespace_get_internal] = STATE(116),
    [sym_pipe] = STATE(116),
    [sym_unary] = STATE(116),
    [sym_binary] = STATE(116),
    [sym_na] = STATE(116),
    [sym__expression] = STATE(116),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(116),
    [sym_string] = STATE(116),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1681),
    [sym_next] = ACTIONS(1681),
    [sym_true] = ACTIONS(1681),
    [sym_false] = ACTIONS(1681),
    [sym_null] = ACTIONS(1681),
    [sym_inf] = ACTIONS(1681),
    [sym_nan] = ACTIONS(1681),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1679),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [296] = {
    [sym_function_definition] = STATE(924),
    [sym_lambda_function] = STATE(924),
    [sym_if] = STATE(924),
    [sym_while] = STATE(924),
    [sym_repeat] = STATE(924),
    [sym_for] = STATE(924),
    [sym_switch] = STATE(924),
    [sym_call] = STATE(453),
    [sym__assignment] = STATE(924),
    [sym_left_assignment] = STATE(924),
    [sym_left_assignment2] = STATE(924),
    [sym_equals_assignment] = STATE(924),
    [sym_super_assignment] = STATE(924),
    [sym_super_right_assignment] = STATE(924),
    [sym_right_assignment] = STATE(924),
    [sym_brace_list] = STATE(924),
    [sym_paren_list] = STATE(924),
    [sym_subset] = STATE(924),
    [sym_subset2] = STATE(924),
    [sym_dollar] = STATE(924),
    [sym_slot] = STATE(924),
    [sym_namespace_get] = STATE(924),
    [sym_namespace_get_internal] = STATE(924),
    [sym_pipe] = STATE(924),
    [sym_unary] = STATE(924),
    [sym_binary] = STATE(924),
    [sym_na] = STATE(924),
    [sym__expression] = STATE(924),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(924),
    [sym_string] = STATE(924),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1685),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1685),
    [sym_next] = ACTIONS(1685),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_inf] = ACTIONS(1685),
    [sym_nan] = ACTIONS(1685),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1683),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [297] = {
    [sym_function_definition] = STATE(246),
    [sym_lambda_function] = STATE(246),
    [sym_if] = STATE(246),
    [sym_while] = STATE(246),
    [sym_repeat] = STATE(246),
    [sym_for] = STATE(246),
    [sym_switch] = STATE(246),
    [sym_call] = STATE(246),
    [sym__assignment] = STATE(246),
    [sym_left_assignment] = STATE(246),
    [sym_left_assignment2] = STATE(246),
    [sym_equals_assignment] = STATE(246),
    [sym_super_assignment] = STATE(246),
    [sym_super_right_assignment] = STATE(246),
    [sym_right_assignment] = STATE(246),
    [sym_brace_list] = STATE(246),
    [sym_paren_list] = STATE(246),
    [sym_subset] = STATE(246),
    [sym_subset2] = STATE(246),
    [sym_dollar] = STATE(246),
    [sym_slot] = STATE(246),
    [sym_namespace_get] = STATE(246),
    [sym_namespace_get_internal] = STATE(246),
    [sym_pipe] = STATE(246),
    [sym_unary] = STATE(246),
    [sym_binary] = STATE(246),
    [sym_na] = STATE(246),
    [sym__expression] = STATE(246),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(246),
    [sym_string] = STATE(246),
    [anon_sym_SEMI] = ACTIONS(1687),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1689),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1689),
    [sym_next] = ACTIONS(1689),
    [sym_true] = ACTIONS(1689),
    [sym_false] = ACTIONS(1689),
    [sym_null] = ACTIONS(1689),
    [sym_inf] = ACTIONS(1689),
    [sym_nan] = ACTIONS(1689),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1687),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [298] = {
    [sym_function_definition] = STATE(661),
    [sym_lambda_function] = STATE(661),
    [sym_if] = STATE(661),
    [sym_while] = STATE(661),
    [sym_repeat] = STATE(661),
    [sym_for] = STATE(661),
    [sym_switch] = STATE(661),
    [sym_call] = STATE(661),
    [sym__assignment] = STATE(661),
    [sym_left_assignment] = STATE(661),
    [sym_left_assignment2] = STATE(661),
    [sym_equals_assignment] = STATE(661),
    [sym_super_assignment] = STATE(661),
    [sym_super_right_assignment] = STATE(661),
    [sym_right_assignment] = STATE(661),
    [sym_brace_list] = STATE(661),
    [sym_paren_list] = STATE(661),
    [sym_subset] = STATE(661),
    [sym_subset2] = STATE(661),
    [sym_dollar] = STATE(661),
    [sym_slot] = STATE(661),
    [sym_namespace_get] = STATE(661),
    [sym_namespace_get_internal] = STATE(661),
    [sym_pipe] = STATE(661),
    [sym_unary] = STATE(661),
    [sym_binary] = STATE(661),
    [sym_na] = STATE(661),
    [sym__expression] = STATE(661),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(661),
    [sym_string] = STATE(661),
    [anon_sym_SEMI] = ACTIONS(1691),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1693),
    [sym_next] = ACTIONS(1693),
    [sym_true] = ACTIONS(1693),
    [sym_false] = ACTIONS(1693),
    [sym_null] = ACTIONS(1693),
    [sym_inf] = ACTIONS(1693),
    [sym_nan] = ACTIONS(1693),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1691),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [299] = {
    [sym_function_definition] = STATE(671),
    [sym_lambda_function] = STATE(671),
    [sym_if] = STATE(671),
    [sym_while] = STATE(671),
    [sym_repeat] = STATE(671),
    [sym_for] = STATE(671),
    [sym_switch] = STATE(671),
    [sym_call] = STATE(671),
    [sym__assignment] = STATE(671),
    [sym_left_assignment] = STATE(671),
    [sym_left_assignment2] = STATE(671),
    [sym_equals_assignment] = STATE(671),
    [sym_super_assignment] = STATE(671),
    [sym_super_right_assignment] = STATE(671),
    [sym_right_assignment] = STATE(671),
    [sym_brace_list] = STATE(671),
    [sym_paren_list] = STATE(671),
    [sym_subset] = STATE(671),
    [sym_subset2] = STATE(671),
    [sym_dollar] = STATE(671),
    [sym_slot] = STATE(671),
    [sym_namespace_get] = STATE(671),
    [sym_namespace_get_internal] = STATE(671),
    [sym_pipe] = STATE(671),
    [sym_unary] = STATE(671),
    [sym_binary] = STATE(671),
    [sym_na] = STATE(671),
    [sym__expression] = STATE(671),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(671),
    [sym_string] = STATE(671),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1697),
    [sym_next] = ACTIONS(1697),
    [sym_true] = ACTIONS(1697),
    [sym_false] = ACTIONS(1697),
    [sym_null] = ACTIONS(1697),
    [sym_inf] = ACTIONS(1697),
    [sym_nan] = ACTIONS(1697),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1695),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [300] = {
    [anon_sym_LF] = ACTIONS(655),
    [anon_sym_SEMI] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(655),
    [anon_sym_BSLASH] = ACTIONS(655),
    [anon_sym_if] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_else] = ACTIONS(655),
    [anon_sym_while] = ACTIONS(655),
    [anon_sym_repeat] = ACTIONS(655),
    [anon_sym_for] = ACTIONS(655),
    [anon_sym_switch] = ACTIONS(655),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_LT_DASH] = ACTIONS(655),
    [anon_sym_COLON_EQ] = ACTIONS(655),
    [anon_sym_LT_LT_DASH] = ACTIONS(655),
    [anon_sym_DASH_GT_GT] = ACTIONS(655),
    [anon_sym_DASH_GT] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(655),
    [anon_sym_DOLLAR] = ACTIONS(655),
    [anon_sym_AT] = ACTIONS(655),
    [anon_sym_COLON_COLON] = ACTIONS(655),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(655),
    [sym_dots] = ACTIONS(655),
    [anon_sym_PIPE_GT] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(655),
    [anon_sym_GT_EQ] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(655),
    [anon_sym_BANG_EQ] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(655),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_COLON] = ACTIONS(655),
    [sym_break] = ACTIONS(655),
    [sym_next] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_null] = ACTIONS(655),
    [sym_inf] = ACTIONS(655),
    [sym_nan] = ACTIONS(655),
    [anon_sym_NA] = ACTIONS(655),
    [anon_sym_NA_character_] = ACTIONS(655),
    [anon_sym_NA_complex_] = ACTIONS(655),
    [anon_sym_NA_integer_] = ACTIONS(655),
    [anon_sym_NA_real_] = ACTIONS(655),
    [aux_sym_identifier_token1] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_integer] = ACTIONS(655),
    [sym_float] = ACTIONS(655),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
  },
  [301] = {
    [sym_function_definition] = STATE(919),
    [sym_lambda_function] = STATE(919),
    [sym_if] = STATE(919),
    [sym_while] = STATE(919),
    [sym_repeat] = STATE(919),
    [sym_for] = STATE(919),
    [sym_switch] = STATE(919),
    [sym_call] = STATE(791),
    [sym__assignment] = STATE(919),
    [sym_left_assignment] = STATE(919),
    [sym_left_assignment2] = STATE(919),
    [sym_equals_assignment] = STATE(919),
    [sym_super_assignment] = STATE(919),
    [sym_super_right_assignment] = STATE(919),
    [sym_right_assignment] = STATE(919),
    [sym_brace_list] = STATE(919),
    [sym_paren_list] = STATE(919),
    [sym_subset] = STATE(919),
    [sym_subset2] = STATE(919),
    [sym_dollar] = STATE(919),
    [sym_slot] = STATE(919),
    [sym_namespace_get] = STATE(919),
    [sym_namespace_get_internal] = STATE(919),
    [sym_pipe] = STATE(919),
    [sym_unary] = STATE(919),
    [sym_binary] = STATE(919),
    [sym_na] = STATE(919),
    [sym__expression] = STATE(919),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(919),
    [sym_string] = STATE(919),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1701),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1701),
    [sym_next] = ACTIONS(1701),
    [sym_true] = ACTIONS(1701),
    [sym_false] = ACTIONS(1701),
    [sym_null] = ACTIONS(1701),
    [sym_inf] = ACTIONS(1701),
    [sym_nan] = ACTIONS(1701),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1699),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [302] = {
    [sym_function_definition] = STATE(548),
    [sym_lambda_function] = STATE(548),
    [sym_if] = STATE(548),
    [sym_while] = STATE(548),
    [sym_repeat] = STATE(548),
    [sym_for] = STATE(548),
    [sym_switch] = STATE(548),
    [sym_call] = STATE(548),
    [sym__assignment] = STATE(548),
    [sym_left_assignment] = STATE(548),
    [sym_left_assignment2] = STATE(548),
    [sym_equals_assignment] = STATE(548),
    [sym_super_assignment] = STATE(548),
    [sym_super_right_assignment] = STATE(548),
    [sym_right_assignment] = STATE(548),
    [sym_brace_list] = STATE(548),
    [sym_paren_list] = STATE(548),
    [sym_subset] = STATE(548),
    [sym_subset2] = STATE(548),
    [sym_dollar] = STATE(548),
    [sym_slot] = STATE(548),
    [sym_namespace_get] = STATE(548),
    [sym_namespace_get_internal] = STATE(548),
    [sym_pipe] = STATE(548),
    [sym_unary] = STATE(548),
    [sym_binary] = STATE(548),
    [sym_na] = STATE(548),
    [sym__expression] = STATE(548),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(548),
    [sym_string] = STATE(548),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1705),
    [sym_next] = ACTIONS(1705),
    [sym_true] = ACTIONS(1705),
    [sym_false] = ACTIONS(1705),
    [sym_null] = ACTIONS(1705),
    [sym_inf] = ACTIONS(1705),
    [sym_nan] = ACTIONS(1705),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1703),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [303] = {
    [sym_function_definition] = STATE(483),
    [sym_lambda_function] = STATE(483),
    [sym_if] = STATE(483),
    [sym_while] = STATE(483),
    [sym_repeat] = STATE(483),
    [sym_for] = STATE(483),
    [sym_switch] = STATE(483),
    [sym_call] = STATE(483),
    [sym__assignment] = STATE(483),
    [sym_left_assignment] = STATE(483),
    [sym_left_assignment2] = STATE(483),
    [sym_equals_assignment] = STATE(483),
    [sym_super_assignment] = STATE(483),
    [sym_super_right_assignment] = STATE(483),
    [sym_right_assignment] = STATE(483),
    [sym_brace_list] = STATE(483),
    [sym_paren_list] = STATE(483),
    [sym_subset] = STATE(483),
    [sym_subset2] = STATE(483),
    [sym_dollar] = STATE(483),
    [sym_slot] = STATE(483),
    [sym_namespace_get] = STATE(483),
    [sym_namespace_get_internal] = STATE(483),
    [sym_pipe] = STATE(483),
    [sym_unary] = STATE(483),
    [sym_binary] = STATE(483),
    [sym_na] = STATE(483),
    [sym__expression] = STATE(483),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(483),
    [sym_string] = STATE(483),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1709),
    [sym_next] = ACTIONS(1709),
    [sym_true] = ACTIONS(1709),
    [sym_false] = ACTIONS(1709),
    [sym_null] = ACTIONS(1709),
    [sym_inf] = ACTIONS(1709),
    [sym_nan] = ACTIONS(1709),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1707),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [304] = {
    [sym_function_definition] = STATE(485),
    [sym_lambda_function] = STATE(485),
    [sym_if] = STATE(485),
    [sym_while] = STATE(485),
    [sym_repeat] = STATE(485),
    [sym_for] = STATE(485),
    [sym_switch] = STATE(485),
    [sym_call] = STATE(485),
    [sym__assignment] = STATE(485),
    [sym_left_assignment] = STATE(485),
    [sym_left_assignment2] = STATE(485),
    [sym_equals_assignment] = STATE(485),
    [sym_super_assignment] = STATE(485),
    [sym_super_right_assignment] = STATE(485),
    [sym_right_assignment] = STATE(485),
    [sym_brace_list] = STATE(485),
    [sym_paren_list] = STATE(485),
    [sym_subset] = STATE(485),
    [sym_subset2] = STATE(485),
    [sym_dollar] = STATE(485),
    [sym_slot] = STATE(485),
    [sym_namespace_get] = STATE(485),
    [sym_namespace_get_internal] = STATE(485),
    [sym_pipe] = STATE(485),
    [sym_unary] = STATE(485),
    [sym_binary] = STATE(485),
    [sym_na] = STATE(485),
    [sym__expression] = STATE(485),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(485),
    [sym_string] = STATE(485),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1713),
    [sym_next] = ACTIONS(1713),
    [sym_true] = ACTIONS(1713),
    [sym_false] = ACTIONS(1713),
    [sym_null] = ACTIONS(1713),
    [sym_inf] = ACTIONS(1713),
    [sym_nan] = ACTIONS(1713),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1711),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [305] = {
    [sym_function_definition] = STATE(486),
    [sym_lambda_function] = STATE(486),
    [sym_if] = STATE(486),
    [sym_while] = STATE(486),
    [sym_repeat] = STATE(486),
    [sym_for] = STATE(486),
    [sym_switch] = STATE(486),
    [sym_call] = STATE(486),
    [sym__assignment] = STATE(486),
    [sym_left_assignment] = STATE(486),
    [sym_left_assignment2] = STATE(486),
    [sym_equals_assignment] = STATE(486),
    [sym_super_assignment] = STATE(486),
    [sym_super_right_assignment] = STATE(486),
    [sym_right_assignment] = STATE(486),
    [sym_brace_list] = STATE(486),
    [sym_paren_list] = STATE(486),
    [sym_subset] = STATE(486),
    [sym_subset2] = STATE(486),
    [sym_dollar] = STATE(486),
    [sym_slot] = STATE(486),
    [sym_namespace_get] = STATE(486),
    [sym_namespace_get_internal] = STATE(486),
    [sym_pipe] = STATE(486),
    [sym_unary] = STATE(486),
    [sym_binary] = STATE(486),
    [sym_na] = STATE(486),
    [sym__expression] = STATE(486),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(486),
    [sym_string] = STATE(486),
    [anon_sym_SEMI] = ACTIONS(1715),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1717),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1717),
    [sym_next] = ACTIONS(1717),
    [sym_true] = ACTIONS(1717),
    [sym_false] = ACTIONS(1717),
    [sym_null] = ACTIONS(1717),
    [sym_inf] = ACTIONS(1717),
    [sym_nan] = ACTIONS(1717),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1715),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [306] = {
    [sym_function_definition] = STATE(487),
    [sym_lambda_function] = STATE(487),
    [sym_if] = STATE(487),
    [sym_while] = STATE(487),
    [sym_repeat] = STATE(487),
    [sym_for] = STATE(487),
    [sym_switch] = STATE(487),
    [sym_call] = STATE(487),
    [sym__assignment] = STATE(487),
    [sym_left_assignment] = STATE(487),
    [sym_left_assignment2] = STATE(487),
    [sym_equals_assignment] = STATE(487),
    [sym_super_assignment] = STATE(487),
    [sym_super_right_assignment] = STATE(487),
    [sym_right_assignment] = STATE(487),
    [sym_brace_list] = STATE(487),
    [sym_paren_list] = STATE(487),
    [sym_subset] = STATE(487),
    [sym_subset2] = STATE(487),
    [sym_dollar] = STATE(487),
    [sym_slot] = STATE(487),
    [sym_namespace_get] = STATE(487),
    [sym_namespace_get_internal] = STATE(487),
    [sym_pipe] = STATE(487),
    [sym_unary] = STATE(487),
    [sym_binary] = STATE(487),
    [sym_na] = STATE(487),
    [sym__expression] = STATE(487),
    [sym_identifier] = STATE(388),
    [sym_complex] = STATE(487),
    [sym_string] = STATE(487),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_BSLASH] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_repeat] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_dots] = ACTIONS(1721),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1113),
    [sym_break] = ACTIONS(1721),
    [sym_next] = ACTIONS(1721),
    [sym_true] = ACTIONS(1721),
    [sym_false] = ACTIONS(1721),
    [sym_null] = ACTIONS(1721),
    [sym_inf] = ACTIONS(1721),
    [sym_nan] = ACTIONS(1721),
    [anon_sym_NA] = ACTIONS(1115),
    [anon_sym_NA_character_] = ACTIONS(1115),
    [anon_sym_NA_complex_] = ACTIONS(1115),
    [anon_sym_NA_integer_] = ACTIONS(1115),
    [anon_sym_NA_real_] = ACTIONS(1115),
    [aux_sym_identifier_token1] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1719),
    [sym_float] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1125),
  },
  [307] = {
    [sym_function_definition] = STATE(255),
    [sym_lambda_function] = STATE(255),
    [sym_if] = STATE(255),
    [sym_while] = STATE(255),
    [sym_repeat] = STATE(255),
    [sym_for] = STATE(255),
    [sym_switch] = STATE(255),
    [sym_call] = STATE(255),
    [sym__assignment] = STATE(255),
    [sym_left_assignment] = STATE(255),
    [sym_left_assignment2] = STATE(255),
    [sym_equals_assignment] = STATE(255),
    [sym_super_assignment] = STATE(255),
    [sym_super_right_assignment] = STATE(255),
    [sym_right_assignment] = STATE(255),
    [sym_brace_list] = STATE(255),
    [sym_paren_list] = STATE(255),
    [sym_subset] = STATE(255),
    [sym_subset2] = STATE(255),
    [sym_dollar] = STATE(255),
    [sym_slot] = STATE(255),
    [sym_namespace_get] = STATE(255),
    [sym_namespace_get_internal] = STATE(255),
    [sym_pipe] = STATE(255),
    [sym_unary] = STATE(255),
    [sym_binary] = STATE(255),
    [sym_na] = STATE(255),
    [sym__expression] = STATE(255),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(255),
    [sym_string] = STATE(255),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1725),
    [sym_next] = ACTIONS(1725),
    [sym_true] = ACTIONS(1725),
    [sym_false] = ACTIONS(1725),
    [sym_null] = ACTIONS(1725),
    [sym_inf] = ACTIONS(1725),
    [sym_nan] = ACTIONS(1725),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1723),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [308] = {
    [sym_function_definition] = STATE(256),
    [sym_lambda_function] = STATE(256),
    [sym_if] = STATE(256),
    [sym_while] = STATE(256),
    [sym_repeat] = STATE(256),
    [sym_for] = STATE(256),
    [sym_switch] = STATE(256),
    [sym_call] = STATE(256),
    [sym__assignment] = STATE(256),
    [sym_left_assignment] = STATE(256),
    [sym_left_assignment2] = STATE(256),
    [sym_equals_assignment] = STATE(256),
    [sym_super_assignment] = STATE(256),
    [sym_super_right_assignment] = STATE(256),
    [sym_right_assignment] = STATE(256),
    [sym_brace_list] = STATE(256),
    [sym_paren_list] = STATE(256),
    [sym_subset] = STATE(256),
    [sym_subset2] = STATE(256),
    [sym_dollar] = STATE(256),
    [sym_slot] = STATE(256),
    [sym_namespace_get] = STATE(256),
    [sym_namespace_get_internal] = STATE(256),
    [sym_pipe] = STATE(256),
    [sym_unary] = STATE(256),
    [sym_binary] = STATE(256),
    [sym_na] = STATE(256),
    [sym__expression] = STATE(256),
    [sym_identifier] = STATE(84),
    [sym_complex] = STATE(256),
    [sym_string] = STATE(256),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_BSLASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [sym_dots] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(857),
    [sym_break] = ACTIONS(1729),
    [sym_next] = ACTIONS(1729),
    [sym_true] = ACTIONS(1729),
    [sym_false] = ACTIONS(1729),
    [sym_null] = ACTIONS(1729),
    [sym_inf] = ACTIONS(1729),
    [sym_nan] = ACTIONS(1729),
    [anon_sym_NA] = ACTIONS(859),
    [anon_sym_NA_character_] = ACTIONS(859),
    [anon_sym_NA_complex_] = ACTIONS(859),
    [anon_sym_NA_integer_] = ACTIONS(859),
    [anon_sym_NA_real_] = ACTIONS(859),
    [aux_sym_identifier_token1] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_integer] = ACTIONS(1727),
    [sym_float] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_SQUOTE] = ACTIONS(869),
  },
  [309] = {
    [sym_function_definition] = STATE(612),
    [sym_lambda_function] = STATE(612),
    [sym_if] = STATE(612),
    [sym_while] = STATE(612),
    [sym_repeat] = STATE(612),
    [sym_for] = STATE(612),
    [sym_switch] = STATE(612),
    [sym_call] = STATE(612),
    [sym__assignment] = STATE(612),
    [sym_left_assignment] = STATE(612),
    [sym_left_assignment2] = STATE(612),
    [sym_equals_assignment] = STATE(612),
    [sym_super_assignment] = STATE(612),
    [sym_super_right_assignment] = STATE(612),
    [sym_right_assignment] = STATE(612),
    [sym_brace_list] = STATE(612),
    [sym_paren_list] = STATE(612),
    [sym_subset] = STATE(612),
    [sym_subset2] = STATE(612),
    [sym_dollar] = STATE(612),
    [sym_slot] = STATE(612),
    [sym_namespace_get] = STATE(612),
    [sym_namespace_get_internal] = STATE(612),
    [sym_pipe] = STATE(612),
    [sym_unary] = STATE(612),
    [sym_binary] = STATE(612),
    [sym_na] = STATE(612),
    [sym__expression] = STATE(612),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(612),
    [sym_string] = STATE(612),
    [anon_sym_SEMI] = ACTIONS(1731),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1733),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1733),
    [sym_next] = ACTIONS(1733),
    [sym_true] = ACTIONS(1733),
    [sym_false] = ACTIONS(1733),
    [sym_null] = ACTIONS(1733),
    [sym_inf] = ACTIONS(1733),
    [sym_nan] = ACTIONS(1733),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1731),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [310] = {
    [sym_function_definition] = STATE(437),
    [sym_lambda_function] = STATE(437),
    [sym_if] = STATE(437),
    [sym_while] = STATE(437),
    [sym_repeat] = STATE(437),
    [sym_for] = STATE(437),
    [sym_switch] = STATE(437),
    [sym_call] = STATE(437),
    [sym__assignment] = STATE(437),
    [sym_left_assignment] = STATE(437),
    [sym_left_assignment2] = STATE(437),
    [sym_equals_assignment] = STATE(437),
    [sym_super_assignment] = STATE(437),
    [sym_super_right_assignment] = STATE(437),
    [sym_right_assignment] = STATE(437),
    [sym_brace_list] = STATE(437),
    [sym_paren_list] = STATE(437),
    [sym_subset] = STATE(437),
    [sym_subset2] = STATE(437),
    [sym_dollar] = STATE(437),
    [sym_slot] = STATE(437),
    [sym_namespace_get] = STATE(437),
    [sym_namespace_get_internal] = STATE(437),
    [sym_pipe] = STATE(437),
    [sym_unary] = STATE(437),
    [sym_binary] = STATE(437),
    [sym_na] = STATE(437),
    [sym__expression] = STATE(437),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(437),
    [sym_string] = STATE(437),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(1737),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(1737),
    [sym_next] = ACTIONS(1737),
    [sym_true] = ACTIONS(1737),
    [sym_false] = ACTIONS(1737),
    [sym_null] = ACTIONS(1737),
    [sym_inf] = ACTIONS(1737),
    [sym_nan] = ACTIONS(1737),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(1735),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [311] = {
    [sym_function_definition] = STATE(474),
    [sym_lambda_function] = STATE(474),
    [sym_if] = STATE(474),
    [sym_while] = STATE(474),
    [sym_repeat] = STATE(474),
    [sym_for] = STATE(474),
    [sym_switch] = STATE(474),
    [sym_call] = STATE(474),
    [sym__assignment] = STATE(474),
    [sym_left_assignment] = STATE(474),
    [sym_left_assignment2] = STATE(474),
    [sym_equals_assignment] = STATE(474),
    [sym_super_assignment] = STATE(474),
    [sym_super_right_assignment] = STATE(474),
    [sym_right_assignment] = STATE(474),
    [sym_brace_list] = STATE(474),
    [sym_paren_list] = STATE(474),
    [sym_subset] = STATE(474),
    [sym_subset2] = STATE(474),
    [sym_dollar] = STATE(474),
    [sym_slot] = STATE(474),
    [sym_namespace_get] = STATE(474),
    [sym_namespace_get_internal] = STATE(474),
    [sym_pipe] = STATE(474),
    [sym_unary] = STATE(474),
    [sym_binary] = STATE(474),
    [sym_na] = STATE(474),
    [sym__expression] = STATE(474),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(474),
    [sym_string] = STATE(474),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(1741),
    [sym_next] = ACTIONS(1741),
    [sym_true] = ACTIONS(1741),
    [sym_false] = ACTIONS(1741),
    [sym_null] = ACTIONS(1741),
    [sym_inf] = ACTIONS(1741),
    [sym_nan] = ACTIONS(1741),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(1739),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [312] = {
    [sym_function_definition] = STATE(475),
    [sym_lambda_function] = STATE(475),
    [sym_if] = STATE(475),
    [sym_while] = STATE(475),
    [sym_repeat] = STATE(475),
    [sym_for] = STATE(475),
    [sym_switch] = STATE(475),
    [sym_call] = STATE(475),
    [sym__assignment] = STATE(475),
    [sym_left_assignment] = STATE(475),
    [sym_left_assignment2] = STATE(475),
    [sym_equals_assignment] = STATE(475),
    [sym_super_assignment] = STATE(475),
    [sym_super_right_assignment] = STATE(475),
    [sym_right_assignment] = STATE(475),
    [sym_brace_list] = STATE(475),
    [sym_paren_list] = STATE(475),
    [sym_subset] = STATE(475),
    [sym_subset2] = STATE(475),
    [sym_dollar] = STATE(475),
    [sym_slot] = STATE(475),
    [sym_namespace_get] = STATE(475),
    [sym_namespace_get_internal] = STATE(475),
    [sym_pipe] = STATE(475),
    [sym_unary] = STATE(475),
    [sym_binary] = STATE(475),
    [sym_na] = STATE(475),
    [sym__expression] = STATE(475),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(475),
    [sym_string] = STATE(475),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(1745),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(1745),
    [sym_next] = ACTIONS(1745),
    [sym_true] = ACTIONS(1745),
    [sym_false] = ACTIONS(1745),
    [sym_null] = ACTIONS(1745),
    [sym_inf] = ACTIONS(1745),
    [sym_nan] = ACTIONS(1745),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(1743),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [313] = {
    [anon_sym_LF] = ACTIONS(651),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_function] = ACTIONS(651),
    [anon_sym_BSLASH] = ACTIONS(651),
    [anon_sym_if] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_else] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(651),
    [anon_sym_repeat] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_switch] = ACTIONS(651),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(651),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_LT_DASH] = ACTIONS(651),
    [anon_sym_COLON_EQ] = ACTIONS(651),
    [anon_sym_LT_LT_DASH] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(651),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(651),
    [anon_sym_DOLLAR] = ACTIONS(651),
    [anon_sym_AT] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(651),
    [sym_dots] = ACTIONS(651),
    [anon_sym_PIPE_GT] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_STAR] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(651),
    [anon_sym_CARET] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(651),
    [anon_sym_LT_EQ] = ACTIONS(651),
    [anon_sym_GT_EQ] = ACTIONS(651),
    [anon_sym_EQ_EQ] = ACTIONS(651),
    [anon_sym_BANG_EQ] = ACTIONS(651),
    [anon_sym_PIPE_PIPE] = ACTIONS(651),
    [anon_sym_PIPE] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(651),
    [anon_sym_AMP] = ACTIONS(651),
    [anon_sym_COLON] = ACTIONS(651),
    [sym_break] = ACTIONS(651),
    [sym_next] = ACTIONS(651),
    [sym_true] = ACTIONS(651),
    [sym_false] = ACTIONS(651),
    [sym_null] = ACTIONS(651),
    [sym_inf] = ACTIONS(651),
    [sym_nan] = ACTIONS(651),
    [anon_sym_NA] = ACTIONS(651),
    [anon_sym_NA_character_] = ACTIONS(651),
    [anon_sym_NA_complex_] = ACTIONS(651),
    [anon_sym_NA_integer_] = ACTIONS(651),
    [anon_sym_NA_real_] = ACTIONS(651),
    [aux_sym_identifier_token1] = ACTIONS(651),
    [anon_sym_BQUOTE] = ACTIONS(651),
    [sym_integer] = ACTIONS(651),
    [sym_float] = ACTIONS(651),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(651),
    [anon_sym_SQUOTE] = ACTIONS(651),
    [anon_sym_PERCENT] = ACTIONS(651),
  },
  [314] = {
    [sym_function_definition] = STATE(567),
    [sym_lambda_function] = STATE(567),
    [sym_if] = STATE(567),
    [sym_while] = STATE(567),
    [sym_repeat] = STATE(567),
    [sym_for] = STATE(567),
    [sym_switch] = STATE(567),
    [sym_call] = STATE(567),
    [sym__assignment] = STATE(567),
    [sym_left_assignment] = STATE(567),
    [sym_left_assignment2] = STATE(567),
    [sym_equals_assignment] = STATE(567),
    [sym_super_assignment] = STATE(567),
    [sym_super_right_assignment] = STATE(567),
    [sym_right_assignment] = STATE(567),
    [sym_brace_list] = STATE(567),
    [sym_paren_list] = STATE(567),
    [sym_subset] = STATE(567),
    [sym_subset2] = STATE(567),
    [sym_dollar] = STATE(567),
    [sym_slot] = STATE(567),
    [sym_namespace_get] = STATE(567),
    [sym_namespace_get_internal] = STATE(567),
    [sym_pipe] = STATE(567),
    [sym_unary] = STATE(567),
    [sym_binary] = STATE(567),
    [sym_na] = STATE(567),
    [sym__expression] = STATE(567),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(567),
    [sym_string] = STATE(567),
    [anon_sym_SEMI] = ACTIONS(1747),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(1749),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(1749),
    [sym_next] = ACTIONS(1749),
    [sym_true] = ACTIONS(1749),
    [sym_false] = ACTIONS(1749),
    [sym_null] = ACTIONS(1749),
    [sym_inf] = ACTIONS(1749),
    [sym_nan] = ACTIONS(1749),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(1747),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [315] = {
    [sym_function_definition] = STATE(613),
    [sym_lambda_function] = STATE(613),
    [sym_if] = STATE(613),
    [sym_while] = STATE(613),
    [sym_repeat] = STATE(613),
    [sym_for] = STATE(613),
    [sym_switch] = STATE(613),
    [sym_call] = STATE(613),
    [sym__assignment] = STATE(613),
    [sym_left_assignment] = STATE(613),
    [sym_left_assignment2] = STATE(613),
    [sym_equals_assignment] = STATE(613),
    [sym_super_assignment] = STATE(613),
    [sym_super_right_assignment] = STATE(613),
    [sym_right_assignment] = STATE(613),
    [sym_brace_list] = STATE(613),
    [sym_paren_list] = STATE(613),
    [sym_subset] = STATE(613),
    [sym_subset2] = STATE(613),
    [sym_dollar] = STATE(613),
    [sym_slot] = STATE(613),
    [sym_namespace_get] = STATE(613),
    [sym_namespace_get_internal] = STATE(613),
    [sym_pipe] = STATE(613),
    [sym_unary] = STATE(613),
    [sym_binary] = STATE(613),
    [sym_na] = STATE(613),
    [sym__expression] = STATE(613),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(613),
    [sym_string] = STATE(613),
    [anon_sym_SEMI] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1753),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1753),
    [sym_next] = ACTIONS(1753),
    [sym_true] = ACTIONS(1753),
    [sym_false] = ACTIONS(1753),
    [sym_null] = ACTIONS(1753),
    [sym_inf] = ACTIONS(1753),
    [sym_nan] = ACTIONS(1753),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1751),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [316] = {
    [sym_function_definition] = STATE(615),
    [sym_lambda_function] = STATE(615),
    [sym_if] = STATE(615),
    [sym_while] = STATE(615),
    [sym_repeat] = STATE(615),
    [sym_for] = STATE(615),
    [sym_switch] = STATE(615),
    [sym_call] = STATE(615),
    [sym__assignment] = STATE(615),
    [sym_left_assignment] = STATE(615),
    [sym_left_assignment2] = STATE(615),
    [sym_equals_assignment] = STATE(615),
    [sym_super_assignment] = STATE(615),
    [sym_super_right_assignment] = STATE(615),
    [sym_right_assignment] = STATE(615),
    [sym_brace_list] = STATE(615),
    [sym_paren_list] = STATE(615),
    [sym_subset] = STATE(615),
    [sym_subset2] = STATE(615),
    [sym_dollar] = STATE(615),
    [sym_slot] = STATE(615),
    [sym_namespace_get] = STATE(615),
    [sym_namespace_get_internal] = STATE(615),
    [sym_pipe] = STATE(615),
    [sym_unary] = STATE(615),
    [sym_binary] = STATE(615),
    [sym_na] = STATE(615),
    [sym__expression] = STATE(615),
    [sym_identifier] = STATE(431),
    [sym_complex] = STATE(615),
    [sym_string] = STATE(615),
    [anon_sym_SEMI] = ACTIONS(1755),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_repeat] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(353),
    [sym_dots] = ACTIONS(1757),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(363),
    [sym_break] = ACTIONS(1757),
    [sym_next] = ACTIONS(1757),
    [sym_true] = ACTIONS(1757),
    [sym_false] = ACTIONS(1757),
    [sym_null] = ACTIONS(1757),
    [sym_inf] = ACTIONS(1757),
    [sym_nan] = ACTIONS(1757),
    [anon_sym_NA] = ACTIONS(365),
    [anon_sym_NA_character_] = ACTIONS(365),
    [anon_sym_NA_complex_] = ACTIONS(365),
    [anon_sym_NA_integer_] = ACTIONS(365),
    [anon_sym_NA_real_] = ACTIONS(365),
    [aux_sym_identifier_token1] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [sym_integer] = ACTIONS(1755),
    [sym_float] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(375),
  },
  [317] = {
    [sym_function_definition] = STATE(476),
    [sym_lambda_function] = STATE(476),
    [sym_if] = STATE(476),
    [sym_while] = STATE(476),
    [sym_repeat] = STATE(476),
    [sym_for] = STATE(476),
    [sym_switch] = STATE(476),
    [sym_call] = STATE(476),
    [sym__assignment] = STATE(476),
    [sym_left_assignment] = STATE(476),
    [sym_left_assignment2] = STATE(476),
    [sym_equals_assignment] = STATE(476),
    [sym_super_assignment] = STATE(476),
    [sym_super_right_assignment] = STATE(476),
    [sym_right_assignment] = STATE(476),
    [sym_brace_list] = STATE(476),
    [sym_paren_list] = STATE(476),
    [sym_subset] = STATE(476),
    [sym_subset2] = STATE(476),
    [sym_dollar] = STATE(476),
    [sym_slot] = STATE(476),
    [sym_namespace_get] = STATE(476),
    [sym_namespace_get_internal] = STATE(476),
    [sym_pipe] = STATE(476),
    [sym_unary] = STATE(476),
    [sym_binary] = STATE(476),
    [sym_na] = STATE(476),
    [sym__expression] = STATE(476),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(476),
    [sym_string] = STATE(476),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(1761),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(1761),
    [sym_next] = ACTIONS(1761),
    [sym_true] = ACTIONS(1761),
    [sym_false] = ACTIONS(1761),
    [sym_null] = ACTIONS(1761),
    [sym_inf] = ACTIONS(1761),
    [sym_nan] = ACTIONS(1761),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(1759),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [318] = {
    [sym_function_definition] = STATE(544),
    [sym_lambda_function] = STATE(544),
    [sym_if] = STATE(544),
    [sym_while] = STATE(544),
    [sym_repeat] = STATE(544),
    [sym_for] = STATE(544),
    [sym_switch] = STATE(544),
    [sym_call] = STATE(544),
    [sym__assignment] = STATE(544),
    [sym_left_assignment] = STATE(544),
    [sym_left_assignment2] = STATE(544),
    [sym_equals_assignment] = STATE(544),
    [sym_super_assignment] = STATE(544),
    [sym_super_right_assignment] = STATE(544),
    [sym_right_assignment] = STATE(544),
    [sym_brace_list] = STATE(544),
    [sym_paren_list] = STATE(544),
    [sym_subset] = STATE(544),
    [sym_subset2] = STATE(544),
    [sym_dollar] = STATE(544),
    [sym_slot] = STATE(544),
    [sym_namespace_get] = STATE(544),
    [sym_namespace_get_internal] = STATE(544),
    [sym_pipe] = STATE(544),
    [sym_unary] = STATE(544),
    [sym_binary] = STATE(544),
    [sym_na] = STATE(544),
    [sym__expression] = STATE(544),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(544),
    [sym_string] = STATE(544),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1765),
    [sym_next] = ACTIONS(1765),
    [sym_true] = ACTIONS(1765),
    [sym_false] = ACTIONS(1765),
    [sym_null] = ACTIONS(1765),
    [sym_inf] = ACTIONS(1765),
    [sym_nan] = ACTIONS(1765),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1763),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [319] = {
    [sym_function_definition] = STATE(543),
    [sym_lambda_function] = STATE(543),
    [sym_if] = STATE(543),
    [sym_while] = STATE(543),
    [sym_repeat] = STATE(543),
    [sym_for] = STATE(543),
    [sym_switch] = STATE(543),
    [sym_call] = STATE(543),
    [sym__assignment] = STATE(543),
    [sym_left_assignment] = STATE(543),
    [sym_left_assignment2] = STATE(543),
    [sym_equals_assignment] = STATE(543),
    [sym_super_assignment] = STATE(543),
    [sym_super_right_assignment] = STATE(543),
    [sym_right_assignment] = STATE(543),
    [sym_brace_list] = STATE(543),
    [sym_paren_list] = STATE(543),
    [sym_subset] = STATE(543),
    [sym_subset2] = STATE(543),
    [sym_dollar] = STATE(543),
    [sym_slot] = STATE(543),
    [sym_namespace_get] = STATE(543),
    [sym_namespace_get_internal] = STATE(543),
    [sym_pipe] = STATE(543),
    [sym_unary] = STATE(543),
    [sym_binary] = STATE(543),
    [sym_na] = STATE(543),
    [sym__expression] = STATE(543),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(543),
    [sym_string] = STATE(543),
    [anon_sym_SEMI] = ACTIONS(1767),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1769),
    [sym_next] = ACTIONS(1769),
    [sym_true] = ACTIONS(1769),
    [sym_false] = ACTIONS(1769),
    [sym_null] = ACTIONS(1769),
    [sym_inf] = ACTIONS(1769),
    [sym_nan] = ACTIONS(1769),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1767),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [320] = {
    [sym_function_definition] = STATE(621),
    [sym_lambda_function] = STATE(621),
    [sym_if] = STATE(621),
    [sym_while] = STATE(621),
    [sym_repeat] = STATE(621),
    [sym_for] = STATE(621),
    [sym_switch] = STATE(621),
    [sym_call] = STATE(621),
    [sym__assignment] = STATE(621),
    [sym_left_assignment] = STATE(621),
    [sym_left_assignment2] = STATE(621),
    [sym_equals_assignment] = STATE(621),
    [sym_super_assignment] = STATE(621),
    [sym_super_right_assignment] = STATE(621),
    [sym_right_assignment] = STATE(621),
    [sym_brace_list] = STATE(621),
    [sym_paren_list] = STATE(621),
    [sym_subset] = STATE(621),
    [sym_subset2] = STATE(621),
    [sym_dollar] = STATE(621),
    [sym_slot] = STATE(621),
    [sym_namespace_get] = STATE(621),
    [sym_namespace_get_internal] = STATE(621),
    [sym_pipe] = STATE(621),
    [sym_unary] = STATE(621),
    [sym_binary] = STATE(621),
    [sym_na] = STATE(621),
    [sym__expression] = STATE(621),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(621),
    [sym_string] = STATE(621),
    [anon_sym_SEMI] = ACTIONS(1771),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(1773),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(1773),
    [sym_next] = ACTIONS(1773),
    [sym_true] = ACTIONS(1773),
    [sym_false] = ACTIONS(1773),
    [sym_null] = ACTIONS(1773),
    [sym_inf] = ACTIONS(1773),
    [sym_nan] = ACTIONS(1773),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(1771),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [321] = {
    [sym_function_definition] = STATE(623),
    [sym_lambda_function] = STATE(623),
    [sym_if] = STATE(623),
    [sym_while] = STATE(623),
    [sym_repeat] = STATE(623),
    [sym_for] = STATE(623),
    [sym_switch] = STATE(623),
    [sym_call] = STATE(623),
    [sym__assignment] = STATE(623),
    [sym_left_assignment] = STATE(623),
    [sym_left_assignment2] = STATE(623),
    [sym_equals_assignment] = STATE(623),
    [sym_super_assignment] = STATE(623),
    [sym_super_right_assignment] = STATE(623),
    [sym_right_assignment] = STATE(623),
    [sym_brace_list] = STATE(623),
    [sym_paren_list] = STATE(623),
    [sym_subset] = STATE(623),
    [sym_subset2] = STATE(623),
    [sym_dollar] = STATE(623),
    [sym_slot] = STATE(623),
    [sym_namespace_get] = STATE(623),
    [sym_namespace_get_internal] = STATE(623),
    [sym_pipe] = STATE(623),
    [sym_unary] = STATE(623),
    [sym_binary] = STATE(623),
    [sym_na] = STATE(623),
    [sym__expression] = STATE(623),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(623),
    [sym_string] = STATE(623),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(1777),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(1777),
    [sym_next] = ACTIONS(1777),
    [sym_true] = ACTIONS(1777),
    [sym_false] = ACTIONS(1777),
    [sym_null] = ACTIONS(1777),
    [sym_inf] = ACTIONS(1777),
    [sym_nan] = ACTIONS(1777),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(1775),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [322] = {
    [sym_function_definition] = STATE(624),
    [sym_lambda_function] = STATE(624),
    [sym_if] = STATE(624),
    [sym_while] = STATE(624),
    [sym_repeat] = STATE(624),
    [sym_for] = STATE(624),
    [sym_switch] = STATE(624),
    [sym_call] = STATE(624),
    [sym__assignment] = STATE(624),
    [sym_left_assignment] = STATE(624),
    [sym_left_assignment2] = STATE(624),
    [sym_equals_assignment] = STATE(624),
    [sym_super_assignment] = STATE(624),
    [sym_super_right_assignment] = STATE(624),
    [sym_right_assignment] = STATE(624),
    [sym_brace_list] = STATE(624),
    [sym_paren_list] = STATE(624),
    [sym_subset] = STATE(624),
    [sym_subset2] = STATE(624),
    [sym_dollar] = STATE(624),
    [sym_slot] = STATE(624),
    [sym_namespace_get] = STATE(624),
    [sym_namespace_get_internal] = STATE(624),
    [sym_pipe] = STATE(624),
    [sym_unary] = STATE(624),
    [sym_binary] = STATE(624),
    [sym_na] = STATE(624),
    [sym__expression] = STATE(624),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(624),
    [sym_string] = STATE(624),
    [anon_sym_SEMI] = ACTIONS(1779),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(1781),
    [sym_next] = ACTIONS(1781),
    [sym_true] = ACTIONS(1781),
    [sym_false] = ACTIONS(1781),
    [sym_null] = ACTIONS(1781),
    [sym_inf] = ACTIONS(1781),
    [sym_nan] = ACTIONS(1781),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(1779),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [323] = {
    [sym_function_definition] = STATE(625),
    [sym_lambda_function] = STATE(625),
    [sym_if] = STATE(625),
    [sym_while] = STATE(625),
    [sym_repeat] = STATE(625),
    [sym_for] = STATE(625),
    [sym_switch] = STATE(625),
    [sym_call] = STATE(625),
    [sym__assignment] = STATE(625),
    [sym_left_assignment] = STATE(625),
    [sym_left_assignment2] = STATE(625),
    [sym_equals_assignment] = STATE(625),
    [sym_super_assignment] = STATE(625),
    [sym_super_right_assignment] = STATE(625),
    [sym_right_assignment] = STATE(625),
    [sym_brace_list] = STATE(625),
    [sym_paren_list] = STATE(625),
    [sym_subset] = STATE(625),
    [sym_subset2] = STATE(625),
    [sym_dollar] = STATE(625),
    [sym_slot] = STATE(625),
    [sym_namespace_get] = STATE(625),
    [sym_namespace_get_internal] = STATE(625),
    [sym_pipe] = STATE(625),
    [sym_unary] = STATE(625),
    [sym_binary] = STATE(625),
    [sym_na] = STATE(625),
    [sym__expression] = STATE(625),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(625),
    [sym_string] = STATE(625),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(1785),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(1785),
    [sym_next] = ACTIONS(1785),
    [sym_true] = ACTIONS(1785),
    [sym_false] = ACTIONS(1785),
    [sym_null] = ACTIONS(1785),
    [sym_inf] = ACTIONS(1785),
    [sym_nan] = ACTIONS(1785),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(1783),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [324] = {
    [sym_function_definition] = STATE(539),
    [sym_lambda_function] = STATE(539),
    [sym_if] = STATE(539),
    [sym_while] = STATE(539),
    [sym_repeat] = STATE(539),
    [sym_for] = STATE(539),
    [sym_switch] = STATE(539),
    [sym_call] = STATE(539),
    [sym__assignment] = STATE(539),
    [sym_left_assignment] = STATE(539),
    [sym_left_assignment2] = STATE(539),
    [sym_equals_assignment] = STATE(539),
    [sym_super_assignment] = STATE(539),
    [sym_super_right_assignment] = STATE(539),
    [sym_right_assignment] = STATE(539),
    [sym_brace_list] = STATE(539),
    [sym_paren_list] = STATE(539),
    [sym_subset] = STATE(539),
    [sym_subset2] = STATE(539),
    [sym_dollar] = STATE(539),
    [sym_slot] = STATE(539),
    [sym_namespace_get] = STATE(539),
    [sym_namespace_get_internal] = STATE(539),
    [sym_pipe] = STATE(539),
    [sym_unary] = STATE(539),
    [sym_binary] = STATE(539),
    [sym_na] = STATE(539),
    [sym__expression] = STATE(539),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(539),
    [sym_string] = STATE(539),
    [anon_sym_SEMI] = ACTIONS(1787),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1789),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1789),
    [sym_next] = ACTIONS(1789),
    [sym_true] = ACTIONS(1789),
    [sym_false] = ACTIONS(1789),
    [sym_null] = ACTIONS(1789),
    [sym_inf] = ACTIONS(1789),
    [sym_nan] = ACTIONS(1789),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1787),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [325] = {
    [sym_function_definition] = STATE(477),
    [sym_lambda_function] = STATE(477),
    [sym_if] = STATE(477),
    [sym_while] = STATE(477),
    [sym_repeat] = STATE(477),
    [sym_for] = STATE(477),
    [sym_switch] = STATE(477),
    [sym_call] = STATE(477),
    [sym__assignment] = STATE(477),
    [sym_left_assignment] = STATE(477),
    [sym_left_assignment2] = STATE(477),
    [sym_equals_assignment] = STATE(477),
    [sym_super_assignment] = STATE(477),
    [sym_super_right_assignment] = STATE(477),
    [sym_right_assignment] = STATE(477),
    [sym_brace_list] = STATE(477),
    [sym_paren_list] = STATE(477),
    [sym_subset] = STATE(477),
    [sym_subset2] = STATE(477),
    [sym_dollar] = STATE(477),
    [sym_slot] = STATE(477),
    [sym_namespace_get] = STATE(477),
    [sym_namespace_get_internal] = STATE(477),
    [sym_pipe] = STATE(477),
    [sym_unary] = STATE(477),
    [sym_binary] = STATE(477),
    [sym_na] = STATE(477),
    [sym__expression] = STATE(477),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(477),
    [sym_string] = STATE(477),
    [anon_sym_SEMI] = ACTIONS(1791),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(1793),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(1793),
    [sym_next] = ACTIONS(1793),
    [sym_true] = ACTIONS(1793),
    [sym_false] = ACTIONS(1793),
    [sym_null] = ACTIONS(1793),
    [sym_inf] = ACTIONS(1793),
    [sym_nan] = ACTIONS(1793),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(1791),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [326] = {
    [sym_function_definition] = STATE(469),
    [sym_lambda_function] = STATE(469),
    [sym_if] = STATE(469),
    [sym_while] = STATE(469),
    [sym_repeat] = STATE(469),
    [sym_for] = STATE(469),
    [sym_switch] = STATE(469),
    [sym_call] = STATE(469),
    [sym__assignment] = STATE(469),
    [sym_left_assignment] = STATE(469),
    [sym_left_assignment2] = STATE(469),
    [sym_equals_assignment] = STATE(469),
    [sym_super_assignment] = STATE(469),
    [sym_super_right_assignment] = STATE(469),
    [sym_right_assignment] = STATE(469),
    [sym_brace_list] = STATE(469),
    [sym_paren_list] = STATE(469),
    [sym_subset] = STATE(469),
    [sym_subset2] = STATE(469),
    [sym_dollar] = STATE(469),
    [sym_slot] = STATE(469),
    [sym_namespace_get] = STATE(469),
    [sym_namespace_get_internal] = STATE(469),
    [sym_pipe] = STATE(469),
    [sym_unary] = STATE(469),
    [sym_binary] = STATE(469),
    [sym_na] = STATE(469),
    [sym__expression] = STATE(469),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(469),
    [sym_string] = STATE(469),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(1797),
    [sym_next] = ACTIONS(1797),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [sym_null] = ACTIONS(1797),
    [sym_inf] = ACTIONS(1797),
    [sym_nan] = ACTIONS(1797),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(1795),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [327] = {
    [ts_builtin_sym_end] = ACTIONS(641),
    [anon_sym_LF] = ACTIONS(643),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_else] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(643),
    [anon_sym_COLON_EQ] = ACTIONS(643),
    [anon_sym_LT_LT_DASH] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(643),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(1799),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1801),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(643),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_CARET] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(643),
    [anon_sym_EQ_EQ] = ACTIONS(643),
    [anon_sym_BANG_EQ] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(643),
    [sym_integer] = ACTIONS(643),
    [sym_float] = ACTIONS(643),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(643),
  },
  [328] = {
    [sym_function_definition] = STATE(846),
    [sym_lambda_function] = STATE(846),
    [sym_if] = STATE(846),
    [sym_while] = STATE(846),
    [sym_repeat] = STATE(846),
    [sym_for] = STATE(846),
    [sym_switch] = STATE(846),
    [sym_call] = STATE(846),
    [sym__assignment] = STATE(846),
    [sym_left_assignment] = STATE(846),
    [sym_left_assignment2] = STATE(846),
    [sym_equals_assignment] = STATE(846),
    [sym_super_assignment] = STATE(846),
    [sym_super_right_assignment] = STATE(846),
    [sym_right_assignment] = STATE(846),
    [sym_brace_list] = STATE(846),
    [sym_paren_list] = STATE(846),
    [sym_subset] = STATE(846),
    [sym_subset2] = STATE(846),
    [sym_dollar] = STATE(846),
    [sym_slot] = STATE(846),
    [sym_namespace_get] = STATE(846),
    [sym_namespace_get_internal] = STATE(846),
    [sym_pipe] = STATE(846),
    [sym_unary] = STATE(846),
    [sym_binary] = STATE(846),
    [sym_na] = STATE(846),
    [sym__expression] = STATE(846),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(846),
    [sym_string] = STATE(846),
    [anon_sym_SEMI] = ACTIONS(1803),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1805),
    [sym_next] = ACTIONS(1805),
    [sym_true] = ACTIONS(1805),
    [sym_false] = ACTIONS(1805),
    [sym_null] = ACTIONS(1805),
    [sym_inf] = ACTIONS(1805),
    [sym_nan] = ACTIONS(1805),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1803),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [329] = {
    [sym_function_definition] = STATE(855),
    [sym_lambda_function] = STATE(855),
    [sym_if] = STATE(855),
    [sym_while] = STATE(855),
    [sym_repeat] = STATE(855),
    [sym_for] = STATE(855),
    [sym_switch] = STATE(855),
    [sym_call] = STATE(855),
    [sym__assignment] = STATE(855),
    [sym_left_assignment] = STATE(855),
    [sym_left_assignment2] = STATE(855),
    [sym_equals_assignment] = STATE(855),
    [sym_super_assignment] = STATE(855),
    [sym_super_right_assignment] = STATE(855),
    [sym_right_assignment] = STATE(855),
    [sym_brace_list] = STATE(855),
    [sym_paren_list] = STATE(855),
    [sym_subset] = STATE(855),
    [sym_subset2] = STATE(855),
    [sym_dollar] = STATE(855),
    [sym_slot] = STATE(855),
    [sym_namespace_get] = STATE(855),
    [sym_namespace_get_internal] = STATE(855),
    [sym_pipe] = STATE(855),
    [sym_unary] = STATE(855),
    [sym_binary] = STATE(855),
    [sym_na] = STATE(855),
    [sym__expression] = STATE(855),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(855),
    [sym_string] = STATE(855),
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1809),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1809),
    [sym_next] = ACTIONS(1809),
    [sym_true] = ACTIONS(1809),
    [sym_false] = ACTIONS(1809),
    [sym_null] = ACTIONS(1809),
    [sym_inf] = ACTIONS(1809),
    [sym_nan] = ACTIONS(1809),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1807),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [330] = {
    [sym_function_definition] = STATE(438),
    [sym_lambda_function] = STATE(438),
    [sym_if] = STATE(438),
    [sym_while] = STATE(438),
    [sym_repeat] = STATE(438),
    [sym_for] = STATE(438),
    [sym_switch] = STATE(438),
    [sym_call] = STATE(438),
    [sym__assignment] = STATE(438),
    [sym_left_assignment] = STATE(438),
    [sym_left_assignment2] = STATE(438),
    [sym_equals_assignment] = STATE(438),
    [sym_super_assignment] = STATE(438),
    [sym_super_right_assignment] = STATE(438),
    [sym_right_assignment] = STATE(438),
    [sym_brace_list] = STATE(438),
    [sym_paren_list] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_subset2] = STATE(438),
    [sym_dollar] = STATE(438),
    [sym_slot] = STATE(438),
    [sym_namespace_get] = STATE(438),
    [sym_namespace_get_internal] = STATE(438),
    [sym_pipe] = STATE(438),
    [sym_unary] = STATE(438),
    [sym_binary] = STATE(438),
    [sym_na] = STATE(438),
    [sym__expression] = STATE(438),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(438),
    [sym_string] = STATE(438),
    [anon_sym_SEMI] = ACTIONS(1811),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(1813),
    [sym_next] = ACTIONS(1813),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [sym_null] = ACTIONS(1813),
    [sym_inf] = ACTIONS(1813),
    [sym_nan] = ACTIONS(1813),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(1811),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [331] = {
    [sym_function_definition] = STATE(532),
    [sym_lambda_function] = STATE(532),
    [sym_if] = STATE(532),
    [sym_while] = STATE(532),
    [sym_repeat] = STATE(532),
    [sym_for] = STATE(532),
    [sym_switch] = STATE(532),
    [sym_call] = STATE(532),
    [sym__assignment] = STATE(532),
    [sym_left_assignment] = STATE(532),
    [sym_left_assignment2] = STATE(532),
    [sym_equals_assignment] = STATE(532),
    [sym_super_assignment] = STATE(532),
    [sym_super_right_assignment] = STATE(532),
    [sym_right_assignment] = STATE(532),
    [sym_brace_list] = STATE(532),
    [sym_paren_list] = STATE(532),
    [sym_subset] = STATE(532),
    [sym_subset2] = STATE(532),
    [sym_dollar] = STATE(532),
    [sym_slot] = STATE(532),
    [sym_namespace_get] = STATE(532),
    [sym_namespace_get_internal] = STATE(532),
    [sym_pipe] = STATE(532),
    [sym_unary] = STATE(532),
    [sym_binary] = STATE(532),
    [sym_na] = STATE(532),
    [sym__expression] = STATE(532),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(532),
    [sym_string] = STATE(532),
    [anon_sym_SEMI] = ACTIONS(1815),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1817),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1817),
    [sym_next] = ACTIONS(1817),
    [sym_true] = ACTIONS(1817),
    [sym_false] = ACTIONS(1817),
    [sym_null] = ACTIONS(1817),
    [sym_inf] = ACTIONS(1817),
    [sym_nan] = ACTIONS(1817),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1815),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [332] = {
    [sym_function_definition] = STATE(531),
    [sym_lambda_function] = STATE(531),
    [sym_if] = STATE(531),
    [sym_while] = STATE(531),
    [sym_repeat] = STATE(531),
    [sym_for] = STATE(531),
    [sym_switch] = STATE(531),
    [sym_call] = STATE(531),
    [sym__assignment] = STATE(531),
    [sym_left_assignment] = STATE(531),
    [sym_left_assignment2] = STATE(531),
    [sym_equals_assignment] = STATE(531),
    [sym_super_assignment] = STATE(531),
    [sym_super_right_assignment] = STATE(531),
    [sym_right_assignment] = STATE(531),
    [sym_brace_list] = STATE(531),
    [sym_paren_list] = STATE(531),
    [sym_subset] = STATE(531),
    [sym_subset2] = STATE(531),
    [sym_dollar] = STATE(531),
    [sym_slot] = STATE(531),
    [sym_namespace_get] = STATE(531),
    [sym_namespace_get_internal] = STATE(531),
    [sym_pipe] = STATE(531),
    [sym_unary] = STATE(531),
    [sym_binary] = STATE(531),
    [sym_na] = STATE(531),
    [sym__expression] = STATE(531),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(531),
    [sym_string] = STATE(531),
    [anon_sym_SEMI] = ACTIONS(1819),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1821),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1821),
    [sym_next] = ACTIONS(1821),
    [sym_true] = ACTIONS(1821),
    [sym_false] = ACTIONS(1821),
    [sym_null] = ACTIONS(1821),
    [sym_inf] = ACTIONS(1821),
    [sym_nan] = ACTIONS(1821),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1819),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [333] = {
    [sym_function_definition] = STATE(530),
    [sym_lambda_function] = STATE(530),
    [sym_if] = STATE(530),
    [sym_while] = STATE(530),
    [sym_repeat] = STATE(530),
    [sym_for] = STATE(530),
    [sym_switch] = STATE(530),
    [sym_call] = STATE(530),
    [sym__assignment] = STATE(530),
    [sym_left_assignment] = STATE(530),
    [sym_left_assignment2] = STATE(530),
    [sym_equals_assignment] = STATE(530),
    [sym_super_assignment] = STATE(530),
    [sym_super_right_assignment] = STATE(530),
    [sym_right_assignment] = STATE(530),
    [sym_brace_list] = STATE(530),
    [sym_paren_list] = STATE(530),
    [sym_subset] = STATE(530),
    [sym_subset2] = STATE(530),
    [sym_dollar] = STATE(530),
    [sym_slot] = STATE(530),
    [sym_namespace_get] = STATE(530),
    [sym_namespace_get_internal] = STATE(530),
    [sym_pipe] = STATE(530),
    [sym_unary] = STATE(530),
    [sym_binary] = STATE(530),
    [sym_na] = STATE(530),
    [sym__expression] = STATE(530),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(530),
    [sym_string] = STATE(530),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1825),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1825),
    [sym_next] = ACTIONS(1825),
    [sym_true] = ACTIONS(1825),
    [sym_false] = ACTIONS(1825),
    [sym_null] = ACTIONS(1825),
    [sym_inf] = ACTIONS(1825),
    [sym_nan] = ACTIONS(1825),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1823),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [334] = {
    [sym_function_definition] = STATE(529),
    [sym_lambda_function] = STATE(529),
    [sym_if] = STATE(529),
    [sym_while] = STATE(529),
    [sym_repeat] = STATE(529),
    [sym_for] = STATE(529),
    [sym_switch] = STATE(529),
    [sym_call] = STATE(529),
    [sym__assignment] = STATE(529),
    [sym_left_assignment] = STATE(529),
    [sym_left_assignment2] = STATE(529),
    [sym_equals_assignment] = STATE(529),
    [sym_super_assignment] = STATE(529),
    [sym_super_right_assignment] = STATE(529),
    [sym_right_assignment] = STATE(529),
    [sym_brace_list] = STATE(529),
    [sym_paren_list] = STATE(529),
    [sym_subset] = STATE(529),
    [sym_subset2] = STATE(529),
    [sym_dollar] = STATE(529),
    [sym_slot] = STATE(529),
    [sym_namespace_get] = STATE(529),
    [sym_namespace_get_internal] = STATE(529),
    [sym_pipe] = STATE(529),
    [sym_unary] = STATE(529),
    [sym_binary] = STATE(529),
    [sym_na] = STATE(529),
    [sym__expression] = STATE(529),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(529),
    [sym_string] = STATE(529),
    [anon_sym_SEMI] = ACTIONS(1827),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1829),
    [sym_next] = ACTIONS(1829),
    [sym_true] = ACTIONS(1829),
    [sym_false] = ACTIONS(1829),
    [sym_null] = ACTIONS(1829),
    [sym_inf] = ACTIONS(1829),
    [sym_nan] = ACTIONS(1829),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1827),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [335] = {
    [sym_function_definition] = STATE(528),
    [sym_lambda_function] = STATE(528),
    [sym_if] = STATE(528),
    [sym_while] = STATE(528),
    [sym_repeat] = STATE(528),
    [sym_for] = STATE(528),
    [sym_switch] = STATE(528),
    [sym_call] = STATE(528),
    [sym__assignment] = STATE(528),
    [sym_left_assignment] = STATE(528),
    [sym_left_assignment2] = STATE(528),
    [sym_equals_assignment] = STATE(528),
    [sym_super_assignment] = STATE(528),
    [sym_super_right_assignment] = STATE(528),
    [sym_right_assignment] = STATE(528),
    [sym_brace_list] = STATE(528),
    [sym_paren_list] = STATE(528),
    [sym_subset] = STATE(528),
    [sym_subset2] = STATE(528),
    [sym_dollar] = STATE(528),
    [sym_slot] = STATE(528),
    [sym_namespace_get] = STATE(528),
    [sym_namespace_get_internal] = STATE(528),
    [sym_pipe] = STATE(528),
    [sym_unary] = STATE(528),
    [sym_binary] = STATE(528),
    [sym_na] = STATE(528),
    [sym__expression] = STATE(528),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(528),
    [sym_string] = STATE(528),
    [anon_sym_SEMI] = ACTIONS(1831),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1833),
    [sym_next] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_null] = ACTIONS(1833),
    [sym_inf] = ACTIONS(1833),
    [sym_nan] = ACTIONS(1833),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1831),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [336] = {
    [sym_function_definition] = STATE(921),
    [sym_lambda_function] = STATE(921),
    [sym_if] = STATE(921),
    [sym_while] = STATE(921),
    [sym_repeat] = STATE(921),
    [sym_for] = STATE(921),
    [sym_switch] = STATE(921),
    [sym_call] = STATE(666),
    [sym__assignment] = STATE(921),
    [sym_left_assignment] = STATE(921),
    [sym_left_assignment2] = STATE(921),
    [sym_equals_assignment] = STATE(921),
    [sym_super_assignment] = STATE(921),
    [sym_super_right_assignment] = STATE(921),
    [sym_right_assignment] = STATE(921),
    [sym_brace_list] = STATE(921),
    [sym_paren_list] = STATE(921),
    [sym_subset] = STATE(921),
    [sym_subset2] = STATE(921),
    [sym_dollar] = STATE(921),
    [sym_slot] = STATE(921),
    [sym_namespace_get] = STATE(921),
    [sym_namespace_get_internal] = STATE(921),
    [sym_pipe] = STATE(921),
    [sym_unary] = STATE(921),
    [sym_binary] = STATE(921),
    [sym_na] = STATE(921),
    [sym__expression] = STATE(921),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(921),
    [sym_string] = STATE(921),
    [anon_sym_SEMI] = ACTIONS(1835),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1837),
    [sym_next] = ACTIONS(1837),
    [sym_true] = ACTIONS(1837),
    [sym_false] = ACTIONS(1837),
    [sym_null] = ACTIONS(1837),
    [sym_inf] = ACTIONS(1837),
    [sym_nan] = ACTIONS(1837),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1835),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [337] = {
    [sym_function_definition] = STATE(527),
    [sym_lambda_function] = STATE(527),
    [sym_if] = STATE(527),
    [sym_while] = STATE(527),
    [sym_repeat] = STATE(527),
    [sym_for] = STATE(527),
    [sym_switch] = STATE(527),
    [sym_call] = STATE(527),
    [sym__assignment] = STATE(527),
    [sym_left_assignment] = STATE(527),
    [sym_left_assignment2] = STATE(527),
    [sym_equals_assignment] = STATE(527),
    [sym_super_assignment] = STATE(527),
    [sym_super_right_assignment] = STATE(527),
    [sym_right_assignment] = STATE(527),
    [sym_brace_list] = STATE(527),
    [sym_paren_list] = STATE(527),
    [sym_subset] = STATE(527),
    [sym_subset2] = STATE(527),
    [sym_dollar] = STATE(527),
    [sym_slot] = STATE(527),
    [sym_namespace_get] = STATE(527),
    [sym_namespace_get_internal] = STATE(527),
    [sym_pipe] = STATE(527),
    [sym_unary] = STATE(527),
    [sym_binary] = STATE(527),
    [sym_na] = STATE(527),
    [sym__expression] = STATE(527),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(527),
    [sym_string] = STATE(527),
    [anon_sym_SEMI] = ACTIONS(1839),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1841),
    [sym_next] = ACTIONS(1841),
    [sym_true] = ACTIONS(1841),
    [sym_false] = ACTIONS(1841),
    [sym_null] = ACTIONS(1841),
    [sym_inf] = ACTIONS(1841),
    [sym_nan] = ACTIONS(1841),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1839),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [338] = {
    [sym_function_definition] = STATE(526),
    [sym_lambda_function] = STATE(526),
    [sym_if] = STATE(526),
    [sym_while] = STATE(526),
    [sym_repeat] = STATE(526),
    [sym_for] = STATE(526),
    [sym_switch] = STATE(526),
    [sym_call] = STATE(526),
    [sym__assignment] = STATE(526),
    [sym_left_assignment] = STATE(526),
    [sym_left_assignment2] = STATE(526),
    [sym_equals_assignment] = STATE(526),
    [sym_super_assignment] = STATE(526),
    [sym_super_right_assignment] = STATE(526),
    [sym_right_assignment] = STATE(526),
    [sym_brace_list] = STATE(526),
    [sym_paren_list] = STATE(526),
    [sym_subset] = STATE(526),
    [sym_subset2] = STATE(526),
    [sym_dollar] = STATE(526),
    [sym_slot] = STATE(526),
    [sym_namespace_get] = STATE(526),
    [sym_namespace_get_internal] = STATE(526),
    [sym_pipe] = STATE(526),
    [sym_unary] = STATE(526),
    [sym_binary] = STATE(526),
    [sym_na] = STATE(526),
    [sym__expression] = STATE(526),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(526),
    [sym_string] = STATE(526),
    [anon_sym_SEMI] = ACTIONS(1843),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1845),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1845),
    [sym_next] = ACTIONS(1845),
    [sym_true] = ACTIONS(1845),
    [sym_false] = ACTIONS(1845),
    [sym_null] = ACTIONS(1845),
    [sym_inf] = ACTIONS(1845),
    [sym_nan] = ACTIONS(1845),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1843),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [339] = {
    [sym_function_definition] = STATE(857),
    [sym_lambda_function] = STATE(857),
    [sym_if] = STATE(857),
    [sym_while] = STATE(857),
    [sym_repeat] = STATE(857),
    [sym_for] = STATE(857),
    [sym_switch] = STATE(857),
    [sym_call] = STATE(857),
    [sym__assignment] = STATE(857),
    [sym_left_assignment] = STATE(857),
    [sym_left_assignment2] = STATE(857),
    [sym_equals_assignment] = STATE(857),
    [sym_super_assignment] = STATE(857),
    [sym_super_right_assignment] = STATE(857),
    [sym_right_assignment] = STATE(857),
    [sym_brace_list] = STATE(857),
    [sym_paren_list] = STATE(857),
    [sym_subset] = STATE(857),
    [sym_subset2] = STATE(857),
    [sym_dollar] = STATE(857),
    [sym_slot] = STATE(857),
    [sym_namespace_get] = STATE(857),
    [sym_namespace_get_internal] = STATE(857),
    [sym_pipe] = STATE(857),
    [sym_unary] = STATE(857),
    [sym_binary] = STATE(857),
    [sym_na] = STATE(857),
    [sym__expression] = STATE(857),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(857),
    [sym_string] = STATE(857),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1849),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1849),
    [sym_next] = ACTIONS(1849),
    [sym_true] = ACTIONS(1849),
    [sym_false] = ACTIONS(1849),
    [sym_null] = ACTIONS(1849),
    [sym_inf] = ACTIONS(1849),
    [sym_nan] = ACTIONS(1849),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1847),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [340] = {
    [sym_function_definition] = STATE(858),
    [sym_lambda_function] = STATE(858),
    [sym_if] = STATE(858),
    [sym_while] = STATE(858),
    [sym_repeat] = STATE(858),
    [sym_for] = STATE(858),
    [sym_switch] = STATE(858),
    [sym_call] = STATE(858),
    [sym__assignment] = STATE(858),
    [sym_left_assignment] = STATE(858),
    [sym_left_assignment2] = STATE(858),
    [sym_equals_assignment] = STATE(858),
    [sym_super_assignment] = STATE(858),
    [sym_super_right_assignment] = STATE(858),
    [sym_right_assignment] = STATE(858),
    [sym_brace_list] = STATE(858),
    [sym_paren_list] = STATE(858),
    [sym_subset] = STATE(858),
    [sym_subset2] = STATE(858),
    [sym_dollar] = STATE(858),
    [sym_slot] = STATE(858),
    [sym_namespace_get] = STATE(858),
    [sym_namespace_get_internal] = STATE(858),
    [sym_pipe] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_na] = STATE(858),
    [sym__expression] = STATE(858),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(858),
    [sym_string] = STATE(858),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1853),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1853),
    [sym_next] = ACTIONS(1853),
    [sym_true] = ACTIONS(1853),
    [sym_false] = ACTIONS(1853),
    [sym_null] = ACTIONS(1853),
    [sym_inf] = ACTIONS(1853),
    [sym_nan] = ACTIONS(1853),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1851),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [341] = {
    [sym_function_definition] = STATE(862),
    [sym_lambda_function] = STATE(862),
    [sym_if] = STATE(862),
    [sym_while] = STATE(862),
    [sym_repeat] = STATE(862),
    [sym_for] = STATE(862),
    [sym_switch] = STATE(862),
    [sym_call] = STATE(862),
    [sym__assignment] = STATE(862),
    [sym_left_assignment] = STATE(862),
    [sym_left_assignment2] = STATE(862),
    [sym_equals_assignment] = STATE(862),
    [sym_super_assignment] = STATE(862),
    [sym_super_right_assignment] = STATE(862),
    [sym_right_assignment] = STATE(862),
    [sym_brace_list] = STATE(862),
    [sym_paren_list] = STATE(862),
    [sym_subset] = STATE(862),
    [sym_subset2] = STATE(862),
    [sym_dollar] = STATE(862),
    [sym_slot] = STATE(862),
    [sym_namespace_get] = STATE(862),
    [sym_namespace_get_internal] = STATE(862),
    [sym_pipe] = STATE(862),
    [sym_unary] = STATE(862),
    [sym_binary] = STATE(862),
    [sym_na] = STATE(862),
    [sym__expression] = STATE(862),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(862),
    [sym_string] = STATE(862),
    [anon_sym_SEMI] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1857),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1857),
    [sym_next] = ACTIONS(1857),
    [sym_true] = ACTIONS(1857),
    [sym_false] = ACTIONS(1857),
    [sym_null] = ACTIONS(1857),
    [sym_inf] = ACTIONS(1857),
    [sym_nan] = ACTIONS(1857),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1855),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [342] = {
    [sym_function_definition] = STATE(875),
    [sym_lambda_function] = STATE(875),
    [sym_if] = STATE(875),
    [sym_while] = STATE(875),
    [sym_repeat] = STATE(875),
    [sym_for] = STATE(875),
    [sym_switch] = STATE(875),
    [sym_call] = STATE(875),
    [sym__assignment] = STATE(875),
    [sym_left_assignment] = STATE(875),
    [sym_left_assignment2] = STATE(875),
    [sym_equals_assignment] = STATE(875),
    [sym_super_assignment] = STATE(875),
    [sym_super_right_assignment] = STATE(875),
    [sym_right_assignment] = STATE(875),
    [sym_brace_list] = STATE(875),
    [sym_paren_list] = STATE(875),
    [sym_subset] = STATE(875),
    [sym_subset2] = STATE(875),
    [sym_dollar] = STATE(875),
    [sym_slot] = STATE(875),
    [sym_namespace_get] = STATE(875),
    [sym_namespace_get_internal] = STATE(875),
    [sym_pipe] = STATE(875),
    [sym_unary] = STATE(875),
    [sym_binary] = STATE(875),
    [sym_na] = STATE(875),
    [sym__expression] = STATE(875),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(875),
    [sym_string] = STATE(875),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1861),
    [sym_next] = ACTIONS(1861),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [sym_null] = ACTIONS(1861),
    [sym_inf] = ACTIONS(1861),
    [sym_nan] = ACTIONS(1861),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1859),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [343] = {
    [sym_function_definition] = STATE(876),
    [sym_lambda_function] = STATE(876),
    [sym_if] = STATE(876),
    [sym_while] = STATE(876),
    [sym_repeat] = STATE(876),
    [sym_for] = STATE(876),
    [sym_switch] = STATE(876),
    [sym_call] = STATE(876),
    [sym__assignment] = STATE(876),
    [sym_left_assignment] = STATE(876),
    [sym_left_assignment2] = STATE(876),
    [sym_equals_assignment] = STATE(876),
    [sym_super_assignment] = STATE(876),
    [sym_super_right_assignment] = STATE(876),
    [sym_right_assignment] = STATE(876),
    [sym_brace_list] = STATE(876),
    [sym_paren_list] = STATE(876),
    [sym_subset] = STATE(876),
    [sym_subset2] = STATE(876),
    [sym_dollar] = STATE(876),
    [sym_slot] = STATE(876),
    [sym_namespace_get] = STATE(876),
    [sym_namespace_get_internal] = STATE(876),
    [sym_pipe] = STATE(876),
    [sym_unary] = STATE(876),
    [sym_binary] = STATE(876),
    [sym_na] = STATE(876),
    [sym__expression] = STATE(876),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(876),
    [sym_string] = STATE(876),
    [anon_sym_SEMI] = ACTIONS(1863),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1865),
    [sym_next] = ACTIONS(1865),
    [sym_true] = ACTIONS(1865),
    [sym_false] = ACTIONS(1865),
    [sym_null] = ACTIONS(1865),
    [sym_inf] = ACTIONS(1865),
    [sym_nan] = ACTIONS(1865),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1863),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [344] = {
    [sym_function_definition] = STATE(877),
    [sym_lambda_function] = STATE(877),
    [sym_if] = STATE(877),
    [sym_while] = STATE(877),
    [sym_repeat] = STATE(877),
    [sym_for] = STATE(877),
    [sym_switch] = STATE(877),
    [sym_call] = STATE(877),
    [sym__assignment] = STATE(877),
    [sym_left_assignment] = STATE(877),
    [sym_left_assignment2] = STATE(877),
    [sym_equals_assignment] = STATE(877),
    [sym_super_assignment] = STATE(877),
    [sym_super_right_assignment] = STATE(877),
    [sym_right_assignment] = STATE(877),
    [sym_brace_list] = STATE(877),
    [sym_paren_list] = STATE(877),
    [sym_subset] = STATE(877),
    [sym_subset2] = STATE(877),
    [sym_dollar] = STATE(877),
    [sym_slot] = STATE(877),
    [sym_namespace_get] = STATE(877),
    [sym_namespace_get_internal] = STATE(877),
    [sym_pipe] = STATE(877),
    [sym_unary] = STATE(877),
    [sym_binary] = STATE(877),
    [sym_na] = STATE(877),
    [sym__expression] = STATE(877),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(877),
    [sym_string] = STATE(877),
    [anon_sym_SEMI] = ACTIONS(1867),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1869),
    [sym_next] = ACTIONS(1869),
    [sym_true] = ACTIONS(1869),
    [sym_false] = ACTIONS(1869),
    [sym_null] = ACTIONS(1869),
    [sym_inf] = ACTIONS(1869),
    [sym_nan] = ACTIONS(1869),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1867),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [345] = {
    [sym_function_definition] = STATE(693),
    [sym_lambda_function] = STATE(693),
    [sym_if] = STATE(693),
    [sym_while] = STATE(693),
    [sym_repeat] = STATE(693),
    [sym_for] = STATE(693),
    [sym_switch] = STATE(693),
    [sym_call] = STATE(693),
    [sym__assignment] = STATE(693),
    [sym_left_assignment] = STATE(693),
    [sym_left_assignment2] = STATE(693),
    [sym_equals_assignment] = STATE(693),
    [sym_super_assignment] = STATE(693),
    [sym_super_right_assignment] = STATE(693),
    [sym_right_assignment] = STATE(693),
    [sym_brace_list] = STATE(693),
    [sym_paren_list] = STATE(693),
    [sym_subset] = STATE(693),
    [sym_subset2] = STATE(693),
    [sym_dollar] = STATE(693),
    [sym_slot] = STATE(693),
    [sym_namespace_get] = STATE(693),
    [sym_namespace_get_internal] = STATE(693),
    [sym_pipe] = STATE(693),
    [sym_unary] = STATE(693),
    [sym_binary] = STATE(693),
    [sym_na] = STATE(693),
    [sym__expression] = STATE(693),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(693),
    [sym_string] = STATE(693),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1873),
    [sym_next] = ACTIONS(1873),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [sym_null] = ACTIONS(1873),
    [sym_inf] = ACTIONS(1873),
    [sym_nan] = ACTIONS(1873),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1871),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [346] = {
    [sym_function_definition] = STATE(686),
    [sym_lambda_function] = STATE(686),
    [sym_if] = STATE(686),
    [sym_while] = STATE(686),
    [sym_repeat] = STATE(686),
    [sym_for] = STATE(686),
    [sym_switch] = STATE(686),
    [sym_call] = STATE(686),
    [sym__assignment] = STATE(686),
    [sym_left_assignment] = STATE(686),
    [sym_left_assignment2] = STATE(686),
    [sym_equals_assignment] = STATE(686),
    [sym_super_assignment] = STATE(686),
    [sym_super_right_assignment] = STATE(686),
    [sym_right_assignment] = STATE(686),
    [sym_brace_list] = STATE(686),
    [sym_paren_list] = STATE(686),
    [sym_subset] = STATE(686),
    [sym_subset2] = STATE(686),
    [sym_dollar] = STATE(686),
    [sym_slot] = STATE(686),
    [sym_namespace_get] = STATE(686),
    [sym_namespace_get_internal] = STATE(686),
    [sym_pipe] = STATE(686),
    [sym_unary] = STATE(686),
    [sym_binary] = STATE(686),
    [sym_na] = STATE(686),
    [sym__expression] = STATE(686),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(686),
    [sym_string] = STATE(686),
    [anon_sym_SEMI] = ACTIONS(1875),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1877),
    [sym_next] = ACTIONS(1877),
    [sym_true] = ACTIONS(1877),
    [sym_false] = ACTIONS(1877),
    [sym_null] = ACTIONS(1877),
    [sym_inf] = ACTIONS(1877),
    [sym_nan] = ACTIONS(1877),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1875),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [347] = {
    [sym_function_definition] = STATE(853),
    [sym_lambda_function] = STATE(853),
    [sym_if] = STATE(853),
    [sym_while] = STATE(853),
    [sym_repeat] = STATE(853),
    [sym_for] = STATE(853),
    [sym_switch] = STATE(853),
    [sym_call] = STATE(853),
    [sym__assignment] = STATE(853),
    [sym_left_assignment] = STATE(853),
    [sym_left_assignment2] = STATE(853),
    [sym_equals_assignment] = STATE(853),
    [sym_super_assignment] = STATE(853),
    [sym_super_right_assignment] = STATE(853),
    [sym_right_assignment] = STATE(853),
    [sym_brace_list] = STATE(853),
    [sym_paren_list] = STATE(853),
    [sym_subset] = STATE(853),
    [sym_subset2] = STATE(853),
    [sym_dollar] = STATE(853),
    [sym_slot] = STATE(853),
    [sym_namespace_get] = STATE(853),
    [sym_namespace_get_internal] = STATE(853),
    [sym_pipe] = STATE(853),
    [sym_unary] = STATE(853),
    [sym_binary] = STATE(853),
    [sym_na] = STATE(853),
    [sym__expression] = STATE(853),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(853),
    [sym_string] = STATE(853),
    [anon_sym_SEMI] = ACTIONS(1879),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1881),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1881),
    [sym_next] = ACTIONS(1881),
    [sym_true] = ACTIONS(1881),
    [sym_false] = ACTIONS(1881),
    [sym_null] = ACTIONS(1881),
    [sym_inf] = ACTIONS(1881),
    [sym_nan] = ACTIONS(1881),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1879),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [348] = {
    [sym_function_definition] = STATE(872),
    [sym_lambda_function] = STATE(872),
    [sym_if] = STATE(872),
    [sym_while] = STATE(872),
    [sym_repeat] = STATE(872),
    [sym_for] = STATE(872),
    [sym_switch] = STATE(872),
    [sym_call] = STATE(872),
    [sym__assignment] = STATE(872),
    [sym_left_assignment] = STATE(872),
    [sym_left_assignment2] = STATE(872),
    [sym_equals_assignment] = STATE(872),
    [sym_super_assignment] = STATE(872),
    [sym_super_right_assignment] = STATE(872),
    [sym_right_assignment] = STATE(872),
    [sym_brace_list] = STATE(872),
    [sym_paren_list] = STATE(872),
    [sym_subset] = STATE(872),
    [sym_subset2] = STATE(872),
    [sym_dollar] = STATE(872),
    [sym_slot] = STATE(872),
    [sym_namespace_get] = STATE(872),
    [sym_namespace_get_internal] = STATE(872),
    [sym_pipe] = STATE(872),
    [sym_unary] = STATE(872),
    [sym_binary] = STATE(872),
    [sym_na] = STATE(872),
    [sym__expression] = STATE(872),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(872),
    [sym_string] = STATE(872),
    [anon_sym_SEMI] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1885),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1885),
    [sym_next] = ACTIONS(1885),
    [sym_true] = ACTIONS(1885),
    [sym_false] = ACTIONS(1885),
    [sym_null] = ACTIONS(1885),
    [sym_inf] = ACTIONS(1885),
    [sym_nan] = ACTIONS(1885),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1883),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [349] = {
    [sym_function_definition] = STATE(871),
    [sym_lambda_function] = STATE(871),
    [sym_if] = STATE(871),
    [sym_while] = STATE(871),
    [sym_repeat] = STATE(871),
    [sym_for] = STATE(871),
    [sym_switch] = STATE(871),
    [sym_call] = STATE(871),
    [sym__assignment] = STATE(871),
    [sym_left_assignment] = STATE(871),
    [sym_left_assignment2] = STATE(871),
    [sym_equals_assignment] = STATE(871),
    [sym_super_assignment] = STATE(871),
    [sym_super_right_assignment] = STATE(871),
    [sym_right_assignment] = STATE(871),
    [sym_brace_list] = STATE(871),
    [sym_paren_list] = STATE(871),
    [sym_subset] = STATE(871),
    [sym_subset2] = STATE(871),
    [sym_dollar] = STATE(871),
    [sym_slot] = STATE(871),
    [sym_namespace_get] = STATE(871),
    [sym_namespace_get_internal] = STATE(871),
    [sym_pipe] = STATE(871),
    [sym_unary] = STATE(871),
    [sym_binary] = STATE(871),
    [sym_na] = STATE(871),
    [sym__expression] = STATE(871),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(871),
    [sym_string] = STATE(871),
    [anon_sym_SEMI] = ACTIONS(1887),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1889),
    [sym_next] = ACTIONS(1889),
    [sym_true] = ACTIONS(1889),
    [sym_false] = ACTIONS(1889),
    [sym_null] = ACTIONS(1889),
    [sym_inf] = ACTIONS(1889),
    [sym_nan] = ACTIONS(1889),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1887),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [350] = {
    [sym_function_definition] = STATE(868),
    [sym_lambda_function] = STATE(868),
    [sym_if] = STATE(868),
    [sym_while] = STATE(868),
    [sym_repeat] = STATE(868),
    [sym_for] = STATE(868),
    [sym_switch] = STATE(868),
    [sym_call] = STATE(868),
    [sym__assignment] = STATE(868),
    [sym_left_assignment] = STATE(868),
    [sym_left_assignment2] = STATE(868),
    [sym_equals_assignment] = STATE(868),
    [sym_super_assignment] = STATE(868),
    [sym_super_right_assignment] = STATE(868),
    [sym_right_assignment] = STATE(868),
    [sym_brace_list] = STATE(868),
    [sym_paren_list] = STATE(868),
    [sym_subset] = STATE(868),
    [sym_subset2] = STATE(868),
    [sym_dollar] = STATE(868),
    [sym_slot] = STATE(868),
    [sym_namespace_get] = STATE(868),
    [sym_namespace_get_internal] = STATE(868),
    [sym_pipe] = STATE(868),
    [sym_unary] = STATE(868),
    [sym_binary] = STATE(868),
    [sym_na] = STATE(868),
    [sym__expression] = STATE(868),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(868),
    [sym_string] = STATE(868),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1893),
    [sym_next] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [sym_inf] = ACTIONS(1893),
    [sym_nan] = ACTIONS(1893),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1891),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [351] = {
    [sym_function_definition] = STATE(867),
    [sym_lambda_function] = STATE(867),
    [sym_if] = STATE(867),
    [sym_while] = STATE(867),
    [sym_repeat] = STATE(867),
    [sym_for] = STATE(867),
    [sym_switch] = STATE(867),
    [sym_call] = STATE(867),
    [sym__assignment] = STATE(867),
    [sym_left_assignment] = STATE(867),
    [sym_left_assignment2] = STATE(867),
    [sym_equals_assignment] = STATE(867),
    [sym_super_assignment] = STATE(867),
    [sym_super_right_assignment] = STATE(867),
    [sym_right_assignment] = STATE(867),
    [sym_brace_list] = STATE(867),
    [sym_paren_list] = STATE(867),
    [sym_subset] = STATE(867),
    [sym_subset2] = STATE(867),
    [sym_dollar] = STATE(867),
    [sym_slot] = STATE(867),
    [sym_namespace_get] = STATE(867),
    [sym_namespace_get_internal] = STATE(867),
    [sym_pipe] = STATE(867),
    [sym_unary] = STATE(867),
    [sym_binary] = STATE(867),
    [sym_na] = STATE(867),
    [sym__expression] = STATE(867),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(867),
    [sym_string] = STATE(867),
    [anon_sym_SEMI] = ACTIONS(1895),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1897),
    [sym_next] = ACTIONS(1897),
    [sym_true] = ACTIONS(1897),
    [sym_false] = ACTIONS(1897),
    [sym_null] = ACTIONS(1897),
    [sym_inf] = ACTIONS(1897),
    [sym_nan] = ACTIONS(1897),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1895),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [352] = {
    [sym_function_definition] = STATE(866),
    [sym_lambda_function] = STATE(866),
    [sym_if] = STATE(866),
    [sym_while] = STATE(866),
    [sym_repeat] = STATE(866),
    [sym_for] = STATE(866),
    [sym_switch] = STATE(866),
    [sym_call] = STATE(866),
    [sym__assignment] = STATE(866),
    [sym_left_assignment] = STATE(866),
    [sym_left_assignment2] = STATE(866),
    [sym_equals_assignment] = STATE(866),
    [sym_super_assignment] = STATE(866),
    [sym_super_right_assignment] = STATE(866),
    [sym_right_assignment] = STATE(866),
    [sym_brace_list] = STATE(866),
    [sym_paren_list] = STATE(866),
    [sym_subset] = STATE(866),
    [sym_subset2] = STATE(866),
    [sym_dollar] = STATE(866),
    [sym_slot] = STATE(866),
    [sym_namespace_get] = STATE(866),
    [sym_namespace_get_internal] = STATE(866),
    [sym_pipe] = STATE(866),
    [sym_unary] = STATE(866),
    [sym_binary] = STATE(866),
    [sym_na] = STATE(866),
    [sym__expression] = STATE(866),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(866),
    [sym_string] = STATE(866),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1901),
    [sym_next] = ACTIONS(1901),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [sym_null] = ACTIONS(1901),
    [sym_inf] = ACTIONS(1901),
    [sym_nan] = ACTIONS(1901),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1899),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [353] = {
    [sym_function_definition] = STATE(865),
    [sym_lambda_function] = STATE(865),
    [sym_if] = STATE(865),
    [sym_while] = STATE(865),
    [sym_repeat] = STATE(865),
    [sym_for] = STATE(865),
    [sym_switch] = STATE(865),
    [sym_call] = STATE(865),
    [sym__assignment] = STATE(865),
    [sym_left_assignment] = STATE(865),
    [sym_left_assignment2] = STATE(865),
    [sym_equals_assignment] = STATE(865),
    [sym_super_assignment] = STATE(865),
    [sym_super_right_assignment] = STATE(865),
    [sym_right_assignment] = STATE(865),
    [sym_brace_list] = STATE(865),
    [sym_paren_list] = STATE(865),
    [sym_subset] = STATE(865),
    [sym_subset2] = STATE(865),
    [sym_dollar] = STATE(865),
    [sym_slot] = STATE(865),
    [sym_namespace_get] = STATE(865),
    [sym_namespace_get_internal] = STATE(865),
    [sym_pipe] = STATE(865),
    [sym_unary] = STATE(865),
    [sym_binary] = STATE(865),
    [sym_na] = STATE(865),
    [sym__expression] = STATE(865),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(865),
    [sym_string] = STATE(865),
    [anon_sym_SEMI] = ACTIONS(1903),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1905),
    [sym_next] = ACTIONS(1905),
    [sym_true] = ACTIONS(1905),
    [sym_false] = ACTIONS(1905),
    [sym_null] = ACTIONS(1905),
    [sym_inf] = ACTIONS(1905),
    [sym_nan] = ACTIONS(1905),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1903),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [354] = {
    [sym_function_definition] = STATE(864),
    [sym_lambda_function] = STATE(864),
    [sym_if] = STATE(864),
    [sym_while] = STATE(864),
    [sym_repeat] = STATE(864),
    [sym_for] = STATE(864),
    [sym_switch] = STATE(864),
    [sym_call] = STATE(864),
    [sym__assignment] = STATE(864),
    [sym_left_assignment] = STATE(864),
    [sym_left_assignment2] = STATE(864),
    [sym_equals_assignment] = STATE(864),
    [sym_super_assignment] = STATE(864),
    [sym_super_right_assignment] = STATE(864),
    [sym_right_assignment] = STATE(864),
    [sym_brace_list] = STATE(864),
    [sym_paren_list] = STATE(864),
    [sym_subset] = STATE(864),
    [sym_subset2] = STATE(864),
    [sym_dollar] = STATE(864),
    [sym_slot] = STATE(864),
    [sym_namespace_get] = STATE(864),
    [sym_namespace_get_internal] = STATE(864),
    [sym_pipe] = STATE(864),
    [sym_unary] = STATE(864),
    [sym_binary] = STATE(864),
    [sym_na] = STATE(864),
    [sym__expression] = STATE(864),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(864),
    [sym_string] = STATE(864),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1909),
    [sym_next] = ACTIONS(1909),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [sym_null] = ACTIONS(1909),
    [sym_inf] = ACTIONS(1909),
    [sym_nan] = ACTIONS(1909),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1907),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [355] = {
    [sym_function_definition] = STATE(863),
    [sym_lambda_function] = STATE(863),
    [sym_if] = STATE(863),
    [sym_while] = STATE(863),
    [sym_repeat] = STATE(863),
    [sym_for] = STATE(863),
    [sym_switch] = STATE(863),
    [sym_call] = STATE(863),
    [sym__assignment] = STATE(863),
    [sym_left_assignment] = STATE(863),
    [sym_left_assignment2] = STATE(863),
    [sym_equals_assignment] = STATE(863),
    [sym_super_assignment] = STATE(863),
    [sym_super_right_assignment] = STATE(863),
    [sym_right_assignment] = STATE(863),
    [sym_brace_list] = STATE(863),
    [sym_paren_list] = STATE(863),
    [sym_subset] = STATE(863),
    [sym_subset2] = STATE(863),
    [sym_dollar] = STATE(863),
    [sym_slot] = STATE(863),
    [sym_namespace_get] = STATE(863),
    [sym_namespace_get_internal] = STATE(863),
    [sym_pipe] = STATE(863),
    [sym_unary] = STATE(863),
    [sym_binary] = STATE(863),
    [sym_na] = STATE(863),
    [sym__expression] = STATE(863),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(863),
    [sym_string] = STATE(863),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1913),
    [sym_next] = ACTIONS(1913),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [sym_null] = ACTIONS(1913),
    [sym_inf] = ACTIONS(1913),
    [sym_nan] = ACTIONS(1913),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1911),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [356] = {
    [sym_function_definition] = STATE(684),
    [sym_lambda_function] = STATE(684),
    [sym_if] = STATE(684),
    [sym_while] = STATE(684),
    [sym_repeat] = STATE(684),
    [sym_for] = STATE(684),
    [sym_switch] = STATE(684),
    [sym_call] = STATE(684),
    [sym__assignment] = STATE(684),
    [sym_left_assignment] = STATE(684),
    [sym_left_assignment2] = STATE(684),
    [sym_equals_assignment] = STATE(684),
    [sym_super_assignment] = STATE(684),
    [sym_super_right_assignment] = STATE(684),
    [sym_right_assignment] = STATE(684),
    [sym_brace_list] = STATE(684),
    [sym_paren_list] = STATE(684),
    [sym_subset] = STATE(684),
    [sym_subset2] = STATE(684),
    [sym_dollar] = STATE(684),
    [sym_slot] = STATE(684),
    [sym_namespace_get] = STATE(684),
    [sym_namespace_get_internal] = STATE(684),
    [sym_pipe] = STATE(684),
    [sym_unary] = STATE(684),
    [sym_binary] = STATE(684),
    [sym_na] = STATE(684),
    [sym__expression] = STATE(684),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(684),
    [sym_string] = STATE(684),
    [anon_sym_SEMI] = ACTIONS(1915),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1917),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1917),
    [sym_next] = ACTIONS(1917),
    [sym_true] = ACTIONS(1917),
    [sym_false] = ACTIONS(1917),
    [sym_null] = ACTIONS(1917),
    [sym_inf] = ACTIONS(1917),
    [sym_nan] = ACTIONS(1917),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1915),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [357] = {
    [sym_function_definition] = STATE(680),
    [sym_lambda_function] = STATE(680),
    [sym_if] = STATE(680),
    [sym_while] = STATE(680),
    [sym_repeat] = STATE(680),
    [sym_for] = STATE(680),
    [sym_switch] = STATE(680),
    [sym_call] = STATE(680),
    [sym__assignment] = STATE(680),
    [sym_left_assignment] = STATE(680),
    [sym_left_assignment2] = STATE(680),
    [sym_equals_assignment] = STATE(680),
    [sym_super_assignment] = STATE(680),
    [sym_super_right_assignment] = STATE(680),
    [sym_right_assignment] = STATE(680),
    [sym_brace_list] = STATE(680),
    [sym_paren_list] = STATE(680),
    [sym_subset] = STATE(680),
    [sym_subset2] = STATE(680),
    [sym_dollar] = STATE(680),
    [sym_slot] = STATE(680),
    [sym_namespace_get] = STATE(680),
    [sym_namespace_get_internal] = STATE(680),
    [sym_pipe] = STATE(680),
    [sym_unary] = STATE(680),
    [sym_binary] = STATE(680),
    [sym_na] = STATE(680),
    [sym__expression] = STATE(680),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(680),
    [sym_string] = STATE(680),
    [anon_sym_SEMI] = ACTIONS(1919),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1921),
    [sym_next] = ACTIONS(1921),
    [sym_true] = ACTIONS(1921),
    [sym_false] = ACTIONS(1921),
    [sym_null] = ACTIONS(1921),
    [sym_inf] = ACTIONS(1921),
    [sym_nan] = ACTIONS(1921),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1919),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [358] = {
    [sym_function_definition] = STATE(826),
    [sym_lambda_function] = STATE(826),
    [sym_if] = STATE(826),
    [sym_while] = STATE(826),
    [sym_repeat] = STATE(826),
    [sym_for] = STATE(826),
    [sym_switch] = STATE(826),
    [sym_call] = STATE(826),
    [sym__assignment] = STATE(826),
    [sym_left_assignment] = STATE(826),
    [sym_left_assignment2] = STATE(826),
    [sym_equals_assignment] = STATE(826),
    [sym_super_assignment] = STATE(826),
    [sym_super_right_assignment] = STATE(826),
    [sym_right_assignment] = STATE(826),
    [sym_brace_list] = STATE(826),
    [sym_paren_list] = STATE(826),
    [sym_subset] = STATE(826),
    [sym_subset2] = STATE(826),
    [sym_dollar] = STATE(826),
    [sym_slot] = STATE(826),
    [sym_namespace_get] = STATE(826),
    [sym_namespace_get_internal] = STATE(826),
    [sym_pipe] = STATE(826),
    [sym_unary] = STATE(826),
    [sym_binary] = STATE(826),
    [sym_na] = STATE(826),
    [sym__expression] = STATE(826),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(826),
    [sym_string] = STATE(826),
    [anon_sym_SEMI] = ACTIONS(1923),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1925),
    [sym_next] = ACTIONS(1925),
    [sym_true] = ACTIONS(1925),
    [sym_false] = ACTIONS(1925),
    [sym_null] = ACTIONS(1925),
    [sym_inf] = ACTIONS(1925),
    [sym_nan] = ACTIONS(1925),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1923),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [359] = {
    [sym_function_definition] = STATE(813),
    [sym_lambda_function] = STATE(813),
    [sym_if] = STATE(813),
    [sym_while] = STATE(813),
    [sym_repeat] = STATE(813),
    [sym_for] = STATE(813),
    [sym_switch] = STATE(813),
    [sym_call] = STATE(813),
    [sym__assignment] = STATE(813),
    [sym_left_assignment] = STATE(813),
    [sym_left_assignment2] = STATE(813),
    [sym_equals_assignment] = STATE(813),
    [sym_super_assignment] = STATE(813),
    [sym_super_right_assignment] = STATE(813),
    [sym_right_assignment] = STATE(813),
    [sym_brace_list] = STATE(813),
    [sym_paren_list] = STATE(813),
    [sym_subset] = STATE(813),
    [sym_subset2] = STATE(813),
    [sym_dollar] = STATE(813),
    [sym_slot] = STATE(813),
    [sym_namespace_get] = STATE(813),
    [sym_namespace_get_internal] = STATE(813),
    [sym_pipe] = STATE(813),
    [sym_unary] = STATE(813),
    [sym_binary] = STATE(813),
    [sym_na] = STATE(813),
    [sym__expression] = STATE(813),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(813),
    [sym_string] = STATE(813),
    [anon_sym_SEMI] = ACTIONS(1927),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1929),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1929),
    [sym_next] = ACTIONS(1929),
    [sym_true] = ACTIONS(1929),
    [sym_false] = ACTIONS(1929),
    [sym_null] = ACTIONS(1929),
    [sym_inf] = ACTIONS(1929),
    [sym_nan] = ACTIONS(1929),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1927),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [360] = {
    [sym_function_definition] = STATE(525),
    [sym_lambda_function] = STATE(525),
    [sym_if] = STATE(525),
    [sym_while] = STATE(525),
    [sym_repeat] = STATE(525),
    [sym_for] = STATE(525),
    [sym_switch] = STATE(525),
    [sym_call] = STATE(525),
    [sym__assignment] = STATE(525),
    [sym_left_assignment] = STATE(525),
    [sym_left_assignment2] = STATE(525),
    [sym_equals_assignment] = STATE(525),
    [sym_super_assignment] = STATE(525),
    [sym_super_right_assignment] = STATE(525),
    [sym_right_assignment] = STATE(525),
    [sym_brace_list] = STATE(525),
    [sym_paren_list] = STATE(525),
    [sym_subset] = STATE(525),
    [sym_subset2] = STATE(525),
    [sym_dollar] = STATE(525),
    [sym_slot] = STATE(525),
    [sym_namespace_get] = STATE(525),
    [sym_namespace_get_internal] = STATE(525),
    [sym_pipe] = STATE(525),
    [sym_unary] = STATE(525),
    [sym_binary] = STATE(525),
    [sym_na] = STATE(525),
    [sym__expression] = STATE(525),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(525),
    [sym_string] = STATE(525),
    [anon_sym_SEMI] = ACTIONS(1931),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1933),
    [sym_next] = ACTIONS(1933),
    [sym_true] = ACTIONS(1933),
    [sym_false] = ACTIONS(1933),
    [sym_null] = ACTIONS(1933),
    [sym_inf] = ACTIONS(1933),
    [sym_nan] = ACTIONS(1933),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1931),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [361] = {
    [sym_function_definition] = STATE(524),
    [sym_lambda_function] = STATE(524),
    [sym_if] = STATE(524),
    [sym_while] = STATE(524),
    [sym_repeat] = STATE(524),
    [sym_for] = STATE(524),
    [sym_switch] = STATE(524),
    [sym_call] = STATE(524),
    [sym__assignment] = STATE(524),
    [sym_left_assignment] = STATE(524),
    [sym_left_assignment2] = STATE(524),
    [sym_equals_assignment] = STATE(524),
    [sym_super_assignment] = STATE(524),
    [sym_super_right_assignment] = STATE(524),
    [sym_right_assignment] = STATE(524),
    [sym_brace_list] = STATE(524),
    [sym_paren_list] = STATE(524),
    [sym_subset] = STATE(524),
    [sym_subset2] = STATE(524),
    [sym_dollar] = STATE(524),
    [sym_slot] = STATE(524),
    [sym_namespace_get] = STATE(524),
    [sym_namespace_get_internal] = STATE(524),
    [sym_pipe] = STATE(524),
    [sym_unary] = STATE(524),
    [sym_binary] = STATE(524),
    [sym_na] = STATE(524),
    [sym__expression] = STATE(524),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(524),
    [sym_string] = STATE(524),
    [anon_sym_SEMI] = ACTIONS(1935),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1937),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1937),
    [sym_next] = ACTIONS(1937),
    [sym_true] = ACTIONS(1937),
    [sym_false] = ACTIONS(1937),
    [sym_null] = ACTIONS(1937),
    [sym_inf] = ACTIONS(1937),
    [sym_nan] = ACTIONS(1937),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1935),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [362] = {
    [sym_function_definition] = STATE(825),
    [sym_lambda_function] = STATE(825),
    [sym_if] = STATE(825),
    [sym_while] = STATE(825),
    [sym_repeat] = STATE(825),
    [sym_for] = STATE(825),
    [sym_switch] = STATE(825),
    [sym_call] = STATE(825),
    [sym__assignment] = STATE(825),
    [sym_left_assignment] = STATE(825),
    [sym_left_assignment2] = STATE(825),
    [sym_equals_assignment] = STATE(825),
    [sym_super_assignment] = STATE(825),
    [sym_super_right_assignment] = STATE(825),
    [sym_right_assignment] = STATE(825),
    [sym_brace_list] = STATE(825),
    [sym_paren_list] = STATE(825),
    [sym_subset] = STATE(825),
    [sym_subset2] = STATE(825),
    [sym_dollar] = STATE(825),
    [sym_slot] = STATE(825),
    [sym_namespace_get] = STATE(825),
    [sym_namespace_get_internal] = STATE(825),
    [sym_pipe] = STATE(825),
    [sym_unary] = STATE(825),
    [sym_binary] = STATE(825),
    [sym_na] = STATE(825),
    [sym__expression] = STATE(825),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(825),
    [sym_string] = STATE(825),
    [anon_sym_SEMI] = ACTIONS(1939),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1941),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1941),
    [sym_next] = ACTIONS(1941),
    [sym_true] = ACTIONS(1941),
    [sym_false] = ACTIONS(1941),
    [sym_null] = ACTIONS(1941),
    [sym_inf] = ACTIONS(1941),
    [sym_nan] = ACTIONS(1941),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1939),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [363] = {
    [sym_function_definition] = STATE(518),
    [sym_lambda_function] = STATE(518),
    [sym_if] = STATE(518),
    [sym_while] = STATE(518),
    [sym_repeat] = STATE(518),
    [sym_for] = STATE(518),
    [sym_switch] = STATE(518),
    [sym_call] = STATE(518),
    [sym__assignment] = STATE(518),
    [sym_left_assignment] = STATE(518),
    [sym_left_assignment2] = STATE(518),
    [sym_equals_assignment] = STATE(518),
    [sym_super_assignment] = STATE(518),
    [sym_super_right_assignment] = STATE(518),
    [sym_right_assignment] = STATE(518),
    [sym_brace_list] = STATE(518),
    [sym_paren_list] = STATE(518),
    [sym_subset] = STATE(518),
    [sym_subset2] = STATE(518),
    [sym_dollar] = STATE(518),
    [sym_slot] = STATE(518),
    [sym_namespace_get] = STATE(518),
    [sym_namespace_get_internal] = STATE(518),
    [sym_pipe] = STATE(518),
    [sym_unary] = STATE(518),
    [sym_binary] = STATE(518),
    [sym_na] = STATE(518),
    [sym__expression] = STATE(518),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(518),
    [sym_string] = STATE(518),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1945),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1945),
    [sym_next] = ACTIONS(1945),
    [sym_true] = ACTIONS(1945),
    [sym_false] = ACTIONS(1945),
    [sym_null] = ACTIONS(1945),
    [sym_inf] = ACTIONS(1945),
    [sym_nan] = ACTIONS(1945),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1943),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [364] = {
    [sym_function_definition] = STATE(517),
    [sym_lambda_function] = STATE(517),
    [sym_if] = STATE(517),
    [sym_while] = STATE(517),
    [sym_repeat] = STATE(517),
    [sym_for] = STATE(517),
    [sym_switch] = STATE(517),
    [sym_call] = STATE(517),
    [sym__assignment] = STATE(517),
    [sym_left_assignment] = STATE(517),
    [sym_left_assignment2] = STATE(517),
    [sym_equals_assignment] = STATE(517),
    [sym_super_assignment] = STATE(517),
    [sym_super_right_assignment] = STATE(517),
    [sym_right_assignment] = STATE(517),
    [sym_brace_list] = STATE(517),
    [sym_paren_list] = STATE(517),
    [sym_subset] = STATE(517),
    [sym_subset2] = STATE(517),
    [sym_dollar] = STATE(517),
    [sym_slot] = STATE(517),
    [sym_namespace_get] = STATE(517),
    [sym_namespace_get_internal] = STATE(517),
    [sym_pipe] = STATE(517),
    [sym_unary] = STATE(517),
    [sym_binary] = STATE(517),
    [sym_na] = STATE(517),
    [sym__expression] = STATE(517),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(517),
    [sym_string] = STATE(517),
    [anon_sym_SEMI] = ACTIONS(1947),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1949),
    [sym_next] = ACTIONS(1949),
    [sym_true] = ACTIONS(1949),
    [sym_false] = ACTIONS(1949),
    [sym_null] = ACTIONS(1949),
    [sym_inf] = ACTIONS(1949),
    [sym_nan] = ACTIONS(1949),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1947),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [365] = {
    [sym_function_definition] = STATE(824),
    [sym_lambda_function] = STATE(824),
    [sym_if] = STATE(824),
    [sym_while] = STATE(824),
    [sym_repeat] = STATE(824),
    [sym_for] = STATE(824),
    [sym_switch] = STATE(824),
    [sym_call] = STATE(824),
    [sym__assignment] = STATE(824),
    [sym_left_assignment] = STATE(824),
    [sym_left_assignment2] = STATE(824),
    [sym_equals_assignment] = STATE(824),
    [sym_super_assignment] = STATE(824),
    [sym_super_right_assignment] = STATE(824),
    [sym_right_assignment] = STATE(824),
    [sym_brace_list] = STATE(824),
    [sym_paren_list] = STATE(824),
    [sym_subset] = STATE(824),
    [sym_subset2] = STATE(824),
    [sym_dollar] = STATE(824),
    [sym_slot] = STATE(824),
    [sym_namespace_get] = STATE(824),
    [sym_namespace_get_internal] = STATE(824),
    [sym_pipe] = STATE(824),
    [sym_unary] = STATE(824),
    [sym_binary] = STATE(824),
    [sym_na] = STATE(824),
    [sym__expression] = STATE(824),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(824),
    [sym_string] = STATE(824),
    [anon_sym_SEMI] = ACTIONS(1951),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1953),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1953),
    [sym_next] = ACTIONS(1953),
    [sym_true] = ACTIONS(1953),
    [sym_false] = ACTIONS(1953),
    [sym_null] = ACTIONS(1953),
    [sym_inf] = ACTIONS(1953),
    [sym_nan] = ACTIONS(1953),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1951),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [366] = {
    [sym_function_definition] = STATE(816),
    [sym_lambda_function] = STATE(816),
    [sym_if] = STATE(816),
    [sym_while] = STATE(816),
    [sym_repeat] = STATE(816),
    [sym_for] = STATE(816),
    [sym_switch] = STATE(816),
    [sym_call] = STATE(816),
    [sym__assignment] = STATE(816),
    [sym_left_assignment] = STATE(816),
    [sym_left_assignment2] = STATE(816),
    [sym_equals_assignment] = STATE(816),
    [sym_super_assignment] = STATE(816),
    [sym_super_right_assignment] = STATE(816),
    [sym_right_assignment] = STATE(816),
    [sym_brace_list] = STATE(816),
    [sym_paren_list] = STATE(816),
    [sym_subset] = STATE(816),
    [sym_subset2] = STATE(816),
    [sym_dollar] = STATE(816),
    [sym_slot] = STATE(816),
    [sym_namespace_get] = STATE(816),
    [sym_namespace_get_internal] = STATE(816),
    [sym_pipe] = STATE(816),
    [sym_unary] = STATE(816),
    [sym_binary] = STATE(816),
    [sym_na] = STATE(816),
    [sym__expression] = STATE(816),
    [sym_identifier] = STATE(797),
    [sym_complex] = STATE(816),
    [sym_string] = STATE(816),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_BSLASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_repeat] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(769),
    [sym_dots] = ACTIONS(1957),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(777),
    [sym_break] = ACTIONS(1957),
    [sym_next] = ACTIONS(1957),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [sym_null] = ACTIONS(1957),
    [sym_inf] = ACTIONS(1957),
    [sym_nan] = ACTIONS(1957),
    [anon_sym_NA] = ACTIONS(779),
    [anon_sym_NA_character_] = ACTIONS(779),
    [anon_sym_NA_complex_] = ACTIONS(779),
    [anon_sym_NA_integer_] = ACTIONS(779),
    [anon_sym_NA_real_] = ACTIONS(779),
    [aux_sym_identifier_token1] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_integer] = ACTIONS(1955),
    [sym_float] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
  },
  [367] = {
    [sym_function_definition] = STATE(918),
    [sym_lambda_function] = STATE(918),
    [sym_if] = STATE(918),
    [sym_while] = STATE(918),
    [sym_repeat] = STATE(918),
    [sym_for] = STATE(918),
    [sym_switch] = STATE(918),
    [sym_call] = STATE(780),
    [sym__assignment] = STATE(918),
    [sym_left_assignment] = STATE(918),
    [sym_left_assignment2] = STATE(918),
    [sym_equals_assignment] = STATE(918),
    [sym_super_assignment] = STATE(918),
    [sym_super_right_assignment] = STATE(918),
    [sym_right_assignment] = STATE(918),
    [sym_brace_list] = STATE(918),
    [sym_paren_list] = STATE(918),
    [sym_subset] = STATE(918),
    [sym_subset2] = STATE(918),
    [sym_dollar] = STATE(918),
    [sym_slot] = STATE(918),
    [sym_namespace_get] = STATE(918),
    [sym_namespace_get_internal] = STATE(918),
    [sym_pipe] = STATE(918),
    [sym_unary] = STATE(918),
    [sym_binary] = STATE(918),
    [sym_na] = STATE(918),
    [sym__expression] = STATE(918),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(918),
    [sym_string] = STATE(918),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1961),
    [sym_next] = ACTIONS(1961),
    [sym_true] = ACTIONS(1961),
    [sym_false] = ACTIONS(1961),
    [sym_null] = ACTIONS(1961),
    [sym_inf] = ACTIONS(1961),
    [sym_nan] = ACTIONS(1961),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1959),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [368] = {
    [sym_function_definition] = STATE(679),
    [sym_lambda_function] = STATE(679),
    [sym_if] = STATE(679),
    [sym_while] = STATE(679),
    [sym_repeat] = STATE(679),
    [sym_for] = STATE(679),
    [sym_switch] = STATE(679),
    [sym_call] = STATE(679),
    [sym__assignment] = STATE(679),
    [sym_left_assignment] = STATE(679),
    [sym_left_assignment2] = STATE(679),
    [sym_equals_assignment] = STATE(679),
    [sym_super_assignment] = STATE(679),
    [sym_super_right_assignment] = STATE(679),
    [sym_right_assignment] = STATE(679),
    [sym_brace_list] = STATE(679),
    [sym_paren_list] = STATE(679),
    [sym_subset] = STATE(679),
    [sym_subset2] = STATE(679),
    [sym_dollar] = STATE(679),
    [sym_slot] = STATE(679),
    [sym_namespace_get] = STATE(679),
    [sym_namespace_get_internal] = STATE(679),
    [sym_pipe] = STATE(679),
    [sym_unary] = STATE(679),
    [sym_binary] = STATE(679),
    [sym_na] = STATE(679),
    [sym__expression] = STATE(679),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(679),
    [sym_string] = STATE(679),
    [anon_sym_SEMI] = ACTIONS(1963),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1965),
    [sym_next] = ACTIONS(1965),
    [sym_true] = ACTIONS(1965),
    [sym_false] = ACTIONS(1965),
    [sym_null] = ACTIONS(1965),
    [sym_inf] = ACTIONS(1965),
    [sym_nan] = ACTIONS(1965),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1963),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [369] = {
    [sym_function_definition] = STATE(678),
    [sym_lambda_function] = STATE(678),
    [sym_if] = STATE(678),
    [sym_while] = STATE(678),
    [sym_repeat] = STATE(678),
    [sym_for] = STATE(678),
    [sym_switch] = STATE(678),
    [sym_call] = STATE(678),
    [sym__assignment] = STATE(678),
    [sym_left_assignment] = STATE(678),
    [sym_left_assignment2] = STATE(678),
    [sym_equals_assignment] = STATE(678),
    [sym_super_assignment] = STATE(678),
    [sym_super_right_assignment] = STATE(678),
    [sym_right_assignment] = STATE(678),
    [sym_brace_list] = STATE(678),
    [sym_paren_list] = STATE(678),
    [sym_subset] = STATE(678),
    [sym_subset2] = STATE(678),
    [sym_dollar] = STATE(678),
    [sym_slot] = STATE(678),
    [sym_namespace_get] = STATE(678),
    [sym_namespace_get_internal] = STATE(678),
    [sym_pipe] = STATE(678),
    [sym_unary] = STATE(678),
    [sym_binary] = STATE(678),
    [sym_na] = STATE(678),
    [sym__expression] = STATE(678),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(678),
    [sym_string] = STATE(678),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1969),
    [sym_next] = ACTIONS(1969),
    [sym_true] = ACTIONS(1969),
    [sym_false] = ACTIONS(1969),
    [sym_null] = ACTIONS(1969),
    [sym_inf] = ACTIONS(1969),
    [sym_nan] = ACTIONS(1969),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1967),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [370] = {
    [sym_function_definition] = STATE(923),
    [sym_lambda_function] = STATE(923),
    [sym_if] = STATE(923),
    [sym_while] = STATE(923),
    [sym_repeat] = STATE(923),
    [sym_for] = STATE(923),
    [sym_switch] = STATE(923),
    [sym_call] = STATE(760),
    [sym__assignment] = STATE(923),
    [sym_left_assignment] = STATE(923),
    [sym_left_assignment2] = STATE(923),
    [sym_equals_assignment] = STATE(923),
    [sym_super_assignment] = STATE(923),
    [sym_super_right_assignment] = STATE(923),
    [sym_right_assignment] = STATE(923),
    [sym_brace_list] = STATE(923),
    [sym_paren_list] = STATE(923),
    [sym_subset] = STATE(923),
    [sym_subset2] = STATE(923),
    [sym_dollar] = STATE(923),
    [sym_slot] = STATE(923),
    [sym_namespace_get] = STATE(923),
    [sym_namespace_get_internal] = STATE(923),
    [sym_pipe] = STATE(923),
    [sym_unary] = STATE(923),
    [sym_binary] = STATE(923),
    [sym_na] = STATE(923),
    [sym__expression] = STATE(923),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(923),
    [sym_string] = STATE(923),
    [anon_sym_SEMI] = ACTIONS(1971),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(1973),
    [sym_next] = ACTIONS(1973),
    [sym_true] = ACTIONS(1973),
    [sym_false] = ACTIONS(1973),
    [sym_null] = ACTIONS(1973),
    [sym_inf] = ACTIONS(1973),
    [sym_nan] = ACTIONS(1973),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(1971),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [371] = {
    [sym_function_definition] = STATE(516),
    [sym_lambda_function] = STATE(516),
    [sym_if] = STATE(516),
    [sym_while] = STATE(516),
    [sym_repeat] = STATE(516),
    [sym_for] = STATE(516),
    [sym_switch] = STATE(516),
    [sym_call] = STATE(516),
    [sym__assignment] = STATE(516),
    [sym_left_assignment] = STATE(516),
    [sym_left_assignment2] = STATE(516),
    [sym_equals_assignment] = STATE(516),
    [sym_super_assignment] = STATE(516),
    [sym_super_right_assignment] = STATE(516),
    [sym_right_assignment] = STATE(516),
    [sym_brace_list] = STATE(516),
    [sym_paren_list] = STATE(516),
    [sym_subset] = STATE(516),
    [sym_subset2] = STATE(516),
    [sym_dollar] = STATE(516),
    [sym_slot] = STATE(516),
    [sym_namespace_get] = STATE(516),
    [sym_namespace_get_internal] = STATE(516),
    [sym_pipe] = STATE(516),
    [sym_unary] = STATE(516),
    [sym_binary] = STATE(516),
    [sym_na] = STATE(516),
    [sym__expression] = STATE(516),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(516),
    [sym_string] = STATE(516),
    [anon_sym_SEMI] = ACTIONS(1975),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1977),
    [sym_next] = ACTIONS(1977),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_inf] = ACTIONS(1977),
    [sym_nan] = ACTIONS(1977),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1975),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [372] = {
    [sym_function_definition] = STATE(515),
    [sym_lambda_function] = STATE(515),
    [sym_if] = STATE(515),
    [sym_while] = STATE(515),
    [sym_repeat] = STATE(515),
    [sym_for] = STATE(515),
    [sym_switch] = STATE(515),
    [sym_call] = STATE(515),
    [sym__assignment] = STATE(515),
    [sym_left_assignment] = STATE(515),
    [sym_left_assignment2] = STATE(515),
    [sym_equals_assignment] = STATE(515),
    [sym_super_assignment] = STATE(515),
    [sym_super_right_assignment] = STATE(515),
    [sym_right_assignment] = STATE(515),
    [sym_brace_list] = STATE(515),
    [sym_paren_list] = STATE(515),
    [sym_subset] = STATE(515),
    [sym_subset2] = STATE(515),
    [sym_dollar] = STATE(515),
    [sym_slot] = STATE(515),
    [sym_namespace_get] = STATE(515),
    [sym_namespace_get_internal] = STATE(515),
    [sym_pipe] = STATE(515),
    [sym_unary] = STATE(515),
    [sym_binary] = STATE(515),
    [sym_na] = STATE(515),
    [sym__expression] = STATE(515),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(515),
    [sym_string] = STATE(515),
    [anon_sym_SEMI] = ACTIONS(1979),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1981),
    [sym_next] = ACTIONS(1981),
    [sym_true] = ACTIONS(1981),
    [sym_false] = ACTIONS(1981),
    [sym_null] = ACTIONS(1981),
    [sym_inf] = ACTIONS(1981),
    [sym_nan] = ACTIONS(1981),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1979),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [373] = {
    [sym_function_definition] = STATE(514),
    [sym_lambda_function] = STATE(514),
    [sym_if] = STATE(514),
    [sym_while] = STATE(514),
    [sym_repeat] = STATE(514),
    [sym_for] = STATE(514),
    [sym_switch] = STATE(514),
    [sym_call] = STATE(514),
    [sym__assignment] = STATE(514),
    [sym_left_assignment] = STATE(514),
    [sym_left_assignment2] = STATE(514),
    [sym_equals_assignment] = STATE(514),
    [sym_super_assignment] = STATE(514),
    [sym_super_right_assignment] = STATE(514),
    [sym_right_assignment] = STATE(514),
    [sym_brace_list] = STATE(514),
    [sym_paren_list] = STATE(514),
    [sym_subset] = STATE(514),
    [sym_subset2] = STATE(514),
    [sym_dollar] = STATE(514),
    [sym_slot] = STATE(514),
    [sym_namespace_get] = STATE(514),
    [sym_namespace_get_internal] = STATE(514),
    [sym_pipe] = STATE(514),
    [sym_unary] = STATE(514),
    [sym_binary] = STATE(514),
    [sym_na] = STATE(514),
    [sym__expression] = STATE(514),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(514),
    [sym_string] = STATE(514),
    [anon_sym_SEMI] = ACTIONS(1983),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1985),
    [sym_next] = ACTIONS(1985),
    [sym_true] = ACTIONS(1985),
    [sym_false] = ACTIONS(1985),
    [sym_null] = ACTIONS(1985),
    [sym_inf] = ACTIONS(1985),
    [sym_nan] = ACTIONS(1985),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1983),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [374] = {
    [sym_function_definition] = STATE(513),
    [sym_lambda_function] = STATE(513),
    [sym_if] = STATE(513),
    [sym_while] = STATE(513),
    [sym_repeat] = STATE(513),
    [sym_for] = STATE(513),
    [sym_switch] = STATE(513),
    [sym_call] = STATE(513),
    [sym__assignment] = STATE(513),
    [sym_left_assignment] = STATE(513),
    [sym_left_assignment2] = STATE(513),
    [sym_equals_assignment] = STATE(513),
    [sym_super_assignment] = STATE(513),
    [sym_super_right_assignment] = STATE(513),
    [sym_right_assignment] = STATE(513),
    [sym_brace_list] = STATE(513),
    [sym_paren_list] = STATE(513),
    [sym_subset] = STATE(513),
    [sym_subset2] = STATE(513),
    [sym_dollar] = STATE(513),
    [sym_slot] = STATE(513),
    [sym_namespace_get] = STATE(513),
    [sym_namespace_get_internal] = STATE(513),
    [sym_pipe] = STATE(513),
    [sym_unary] = STATE(513),
    [sym_binary] = STATE(513),
    [sym_na] = STATE(513),
    [sym__expression] = STATE(513),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(513),
    [sym_string] = STATE(513),
    [anon_sym_SEMI] = ACTIONS(1987),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(1989),
    [sym_next] = ACTIONS(1989),
    [sym_true] = ACTIONS(1989),
    [sym_false] = ACTIONS(1989),
    [sym_null] = ACTIONS(1989),
    [sym_inf] = ACTIONS(1989),
    [sym_nan] = ACTIONS(1989),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1987),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [375] = {
    [sym_function_definition] = STATE(443),
    [sym_lambda_function] = STATE(443),
    [sym_if] = STATE(443),
    [sym_while] = STATE(443),
    [sym_repeat] = STATE(443),
    [sym_for] = STATE(443),
    [sym_switch] = STATE(443),
    [sym_call] = STATE(443),
    [sym__assignment] = STATE(443),
    [sym_left_assignment] = STATE(443),
    [sym_left_assignment2] = STATE(443),
    [sym_equals_assignment] = STATE(443),
    [sym_super_assignment] = STATE(443),
    [sym_super_right_assignment] = STATE(443),
    [sym_right_assignment] = STATE(443),
    [sym_brace_list] = STATE(443),
    [sym_paren_list] = STATE(443),
    [sym_subset] = STATE(443),
    [sym_subset2] = STATE(443),
    [sym_dollar] = STATE(443),
    [sym_slot] = STATE(443),
    [sym_namespace_get] = STATE(443),
    [sym_namespace_get_internal] = STATE(443),
    [sym_pipe] = STATE(443),
    [sym_unary] = STATE(443),
    [sym_binary] = STATE(443),
    [sym_na] = STATE(443),
    [sym__expression] = STATE(443),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(443),
    [sym_string] = STATE(443),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(1993),
    [sym_next] = ACTIONS(1993),
    [sym_true] = ACTIONS(1993),
    [sym_false] = ACTIONS(1993),
    [sym_null] = ACTIONS(1993),
    [sym_inf] = ACTIONS(1993),
    [sym_nan] = ACTIONS(1993),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(1991),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [376] = {
    [sym_function_definition] = STATE(675),
    [sym_lambda_function] = STATE(675),
    [sym_if] = STATE(675),
    [sym_while] = STATE(675),
    [sym_repeat] = STATE(675),
    [sym_for] = STATE(675),
    [sym_switch] = STATE(675),
    [sym_call] = STATE(675),
    [sym__assignment] = STATE(675),
    [sym_left_assignment] = STATE(675),
    [sym_left_assignment2] = STATE(675),
    [sym_equals_assignment] = STATE(675),
    [sym_super_assignment] = STATE(675),
    [sym_super_right_assignment] = STATE(675),
    [sym_right_assignment] = STATE(675),
    [sym_brace_list] = STATE(675),
    [sym_paren_list] = STATE(675),
    [sym_subset] = STATE(675),
    [sym_subset2] = STATE(675),
    [sym_dollar] = STATE(675),
    [sym_slot] = STATE(675),
    [sym_namespace_get] = STATE(675),
    [sym_namespace_get_internal] = STATE(675),
    [sym_pipe] = STATE(675),
    [sym_unary] = STATE(675),
    [sym_binary] = STATE(675),
    [sym_na] = STATE(675),
    [sym__expression] = STATE(675),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(675),
    [sym_string] = STATE(675),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(1997),
    [sym_next] = ACTIONS(1997),
    [sym_true] = ACTIONS(1997),
    [sym_false] = ACTIONS(1997),
    [sym_null] = ACTIONS(1997),
    [sym_inf] = ACTIONS(1997),
    [sym_nan] = ACTIONS(1997),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1995),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [377] = {
    [sym_function_definition] = STATE(674),
    [sym_lambda_function] = STATE(674),
    [sym_if] = STATE(674),
    [sym_while] = STATE(674),
    [sym_repeat] = STATE(674),
    [sym_for] = STATE(674),
    [sym_switch] = STATE(674),
    [sym_call] = STATE(674),
    [sym__assignment] = STATE(674),
    [sym_left_assignment] = STATE(674),
    [sym_left_assignment2] = STATE(674),
    [sym_equals_assignment] = STATE(674),
    [sym_super_assignment] = STATE(674),
    [sym_super_right_assignment] = STATE(674),
    [sym_right_assignment] = STATE(674),
    [sym_brace_list] = STATE(674),
    [sym_paren_list] = STATE(674),
    [sym_subset] = STATE(674),
    [sym_subset2] = STATE(674),
    [sym_dollar] = STATE(674),
    [sym_slot] = STATE(674),
    [sym_namespace_get] = STATE(674),
    [sym_namespace_get_internal] = STATE(674),
    [sym_pipe] = STATE(674),
    [sym_unary] = STATE(674),
    [sym_binary] = STATE(674),
    [sym_na] = STATE(674),
    [sym__expression] = STATE(674),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(674),
    [sym_string] = STATE(674),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(2001),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(2001),
    [sym_next] = ACTIONS(2001),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_inf] = ACTIONS(2001),
    [sym_nan] = ACTIONS(2001),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(1999),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [378] = {
    [sym_function_definition] = STATE(472),
    [sym_lambda_function] = STATE(472),
    [sym_if] = STATE(472),
    [sym_while] = STATE(472),
    [sym_repeat] = STATE(472),
    [sym_for] = STATE(472),
    [sym_switch] = STATE(472),
    [sym_call] = STATE(472),
    [sym__assignment] = STATE(472),
    [sym_left_assignment] = STATE(472),
    [sym_left_assignment2] = STATE(472),
    [sym_equals_assignment] = STATE(472),
    [sym_super_assignment] = STATE(472),
    [sym_super_right_assignment] = STATE(472),
    [sym_right_assignment] = STATE(472),
    [sym_brace_list] = STATE(472),
    [sym_paren_list] = STATE(472),
    [sym_subset] = STATE(472),
    [sym_subset2] = STATE(472),
    [sym_dollar] = STATE(472),
    [sym_slot] = STATE(472),
    [sym_namespace_get] = STATE(472),
    [sym_namespace_get_internal] = STATE(472),
    [sym_pipe] = STATE(472),
    [sym_unary] = STATE(472),
    [sym_binary] = STATE(472),
    [sym_na] = STATE(472),
    [sym__expression] = STATE(472),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(472),
    [sym_string] = STATE(472),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2005),
    [sym_next] = ACTIONS(2005),
    [sym_true] = ACTIONS(2005),
    [sym_false] = ACTIONS(2005),
    [sym_null] = ACTIONS(2005),
    [sym_inf] = ACTIONS(2005),
    [sym_nan] = ACTIONS(2005),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2003),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [379] = {
    [sym_function_definition] = STATE(470),
    [sym_lambda_function] = STATE(470),
    [sym_if] = STATE(470),
    [sym_while] = STATE(470),
    [sym_repeat] = STATE(470),
    [sym_for] = STATE(470),
    [sym_switch] = STATE(470),
    [sym_call] = STATE(470),
    [sym__assignment] = STATE(470),
    [sym_left_assignment] = STATE(470),
    [sym_left_assignment2] = STATE(470),
    [sym_equals_assignment] = STATE(470),
    [sym_super_assignment] = STATE(470),
    [sym_super_right_assignment] = STATE(470),
    [sym_right_assignment] = STATE(470),
    [sym_brace_list] = STATE(470),
    [sym_paren_list] = STATE(470),
    [sym_subset] = STATE(470),
    [sym_subset2] = STATE(470),
    [sym_dollar] = STATE(470),
    [sym_slot] = STATE(470),
    [sym_namespace_get] = STATE(470),
    [sym_namespace_get_internal] = STATE(470),
    [sym_pipe] = STATE(470),
    [sym_unary] = STATE(470),
    [sym_binary] = STATE(470),
    [sym_na] = STATE(470),
    [sym__expression] = STATE(470),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(470),
    [sym_string] = STATE(470),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2009),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2009),
    [sym_next] = ACTIONS(2009),
    [sym_true] = ACTIONS(2009),
    [sym_false] = ACTIONS(2009),
    [sym_null] = ACTIONS(2009),
    [sym_inf] = ACTIONS(2009),
    [sym_nan] = ACTIONS(2009),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2007),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [380] = {
    [sym_function_definition] = STATE(462),
    [sym_lambda_function] = STATE(462),
    [sym_if] = STATE(462),
    [sym_while] = STATE(462),
    [sym_repeat] = STATE(462),
    [sym_for] = STATE(462),
    [sym_switch] = STATE(462),
    [sym_call] = STATE(462),
    [sym__assignment] = STATE(462),
    [sym_left_assignment] = STATE(462),
    [sym_left_assignment2] = STATE(462),
    [sym_equals_assignment] = STATE(462),
    [sym_super_assignment] = STATE(462),
    [sym_super_right_assignment] = STATE(462),
    [sym_right_assignment] = STATE(462),
    [sym_brace_list] = STATE(462),
    [sym_paren_list] = STATE(462),
    [sym_subset] = STATE(462),
    [sym_subset2] = STATE(462),
    [sym_dollar] = STATE(462),
    [sym_slot] = STATE(462),
    [sym_namespace_get] = STATE(462),
    [sym_namespace_get_internal] = STATE(462),
    [sym_pipe] = STATE(462),
    [sym_unary] = STATE(462),
    [sym_binary] = STATE(462),
    [sym_na] = STATE(462),
    [sym__expression] = STATE(462),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(462),
    [sym_string] = STATE(462),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2013),
    [sym_next] = ACTIONS(2013),
    [sym_true] = ACTIONS(2013),
    [sym_false] = ACTIONS(2013),
    [sym_null] = ACTIONS(2013),
    [sym_inf] = ACTIONS(2013),
    [sym_nan] = ACTIONS(2013),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2011),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [381] = {
    [sym_function_definition] = STATE(461),
    [sym_lambda_function] = STATE(461),
    [sym_if] = STATE(461),
    [sym_while] = STATE(461),
    [sym_repeat] = STATE(461),
    [sym_for] = STATE(461),
    [sym_switch] = STATE(461),
    [sym_call] = STATE(461),
    [sym__assignment] = STATE(461),
    [sym_left_assignment] = STATE(461),
    [sym_left_assignment2] = STATE(461),
    [sym_equals_assignment] = STATE(461),
    [sym_super_assignment] = STATE(461),
    [sym_super_right_assignment] = STATE(461),
    [sym_right_assignment] = STATE(461),
    [sym_brace_list] = STATE(461),
    [sym_paren_list] = STATE(461),
    [sym_subset] = STATE(461),
    [sym_subset2] = STATE(461),
    [sym_dollar] = STATE(461),
    [sym_slot] = STATE(461),
    [sym_namespace_get] = STATE(461),
    [sym_namespace_get_internal] = STATE(461),
    [sym_pipe] = STATE(461),
    [sym_unary] = STATE(461),
    [sym_binary] = STATE(461),
    [sym_na] = STATE(461),
    [sym__expression] = STATE(461),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(461),
    [sym_string] = STATE(461),
    [anon_sym_SEMI] = ACTIONS(2015),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2017),
    [sym_next] = ACTIONS(2017),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [sym_null] = ACTIONS(2017),
    [sym_inf] = ACTIONS(2017),
    [sym_nan] = ACTIONS(2017),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2015),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [382] = {
    [sym_function_definition] = STATE(460),
    [sym_lambda_function] = STATE(460),
    [sym_if] = STATE(460),
    [sym_while] = STATE(460),
    [sym_repeat] = STATE(460),
    [sym_for] = STATE(460),
    [sym_switch] = STATE(460),
    [sym_call] = STATE(460),
    [sym__assignment] = STATE(460),
    [sym_left_assignment] = STATE(460),
    [sym_left_assignment2] = STATE(460),
    [sym_equals_assignment] = STATE(460),
    [sym_super_assignment] = STATE(460),
    [sym_super_right_assignment] = STATE(460),
    [sym_right_assignment] = STATE(460),
    [sym_brace_list] = STATE(460),
    [sym_paren_list] = STATE(460),
    [sym_subset] = STATE(460),
    [sym_subset2] = STATE(460),
    [sym_dollar] = STATE(460),
    [sym_slot] = STATE(460),
    [sym_namespace_get] = STATE(460),
    [sym_namespace_get_internal] = STATE(460),
    [sym_pipe] = STATE(460),
    [sym_unary] = STATE(460),
    [sym_binary] = STATE(460),
    [sym_na] = STATE(460),
    [sym__expression] = STATE(460),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(460),
    [sym_string] = STATE(460),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2021),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2021),
    [sym_next] = ACTIONS(2021),
    [sym_true] = ACTIONS(2021),
    [sym_false] = ACTIONS(2021),
    [sym_null] = ACTIONS(2021),
    [sym_inf] = ACTIONS(2021),
    [sym_nan] = ACTIONS(2021),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2019),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [383] = {
    [sym_function_definition] = STATE(459),
    [sym_lambda_function] = STATE(459),
    [sym_if] = STATE(459),
    [sym_while] = STATE(459),
    [sym_repeat] = STATE(459),
    [sym_for] = STATE(459),
    [sym_switch] = STATE(459),
    [sym_call] = STATE(459),
    [sym__assignment] = STATE(459),
    [sym_left_assignment] = STATE(459),
    [sym_left_assignment2] = STATE(459),
    [sym_equals_assignment] = STATE(459),
    [sym_super_assignment] = STATE(459),
    [sym_super_right_assignment] = STATE(459),
    [sym_right_assignment] = STATE(459),
    [sym_brace_list] = STATE(459),
    [sym_paren_list] = STATE(459),
    [sym_subset] = STATE(459),
    [sym_subset2] = STATE(459),
    [sym_dollar] = STATE(459),
    [sym_slot] = STATE(459),
    [sym_namespace_get] = STATE(459),
    [sym_namespace_get_internal] = STATE(459),
    [sym_pipe] = STATE(459),
    [sym_unary] = STATE(459),
    [sym_binary] = STATE(459),
    [sym_na] = STATE(459),
    [sym__expression] = STATE(459),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(459),
    [sym_string] = STATE(459),
    [anon_sym_SEMI] = ACTIONS(2023),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2025),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2025),
    [sym_next] = ACTIONS(2025),
    [sym_true] = ACTIONS(2025),
    [sym_false] = ACTIONS(2025),
    [sym_null] = ACTIONS(2025),
    [sym_inf] = ACTIONS(2025),
    [sym_nan] = ACTIONS(2025),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2023),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [384] = {
    [sym_function_definition] = STATE(458),
    [sym_lambda_function] = STATE(458),
    [sym_if] = STATE(458),
    [sym_while] = STATE(458),
    [sym_repeat] = STATE(458),
    [sym_for] = STATE(458),
    [sym_switch] = STATE(458),
    [sym_call] = STATE(458),
    [sym__assignment] = STATE(458),
    [sym_left_assignment] = STATE(458),
    [sym_left_assignment2] = STATE(458),
    [sym_equals_assignment] = STATE(458),
    [sym_super_assignment] = STATE(458),
    [sym_super_right_assignment] = STATE(458),
    [sym_right_assignment] = STATE(458),
    [sym_brace_list] = STATE(458),
    [sym_paren_list] = STATE(458),
    [sym_subset] = STATE(458),
    [sym_subset2] = STATE(458),
    [sym_dollar] = STATE(458),
    [sym_slot] = STATE(458),
    [sym_namespace_get] = STATE(458),
    [sym_namespace_get_internal] = STATE(458),
    [sym_pipe] = STATE(458),
    [sym_unary] = STATE(458),
    [sym_binary] = STATE(458),
    [sym_na] = STATE(458),
    [sym__expression] = STATE(458),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(458),
    [sym_string] = STATE(458),
    [anon_sym_SEMI] = ACTIONS(2027),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2029),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2029),
    [sym_next] = ACTIONS(2029),
    [sym_true] = ACTIONS(2029),
    [sym_false] = ACTIONS(2029),
    [sym_null] = ACTIONS(2029),
    [sym_inf] = ACTIONS(2029),
    [sym_nan] = ACTIONS(2029),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2027),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [385] = {
    [sym_function_definition] = STATE(507),
    [sym_lambda_function] = STATE(507),
    [sym_if] = STATE(507),
    [sym_while] = STATE(507),
    [sym_repeat] = STATE(507),
    [sym_for] = STATE(507),
    [sym_switch] = STATE(507),
    [sym_call] = STATE(507),
    [sym__assignment] = STATE(507),
    [sym_left_assignment] = STATE(507),
    [sym_left_assignment2] = STATE(507),
    [sym_equals_assignment] = STATE(507),
    [sym_super_assignment] = STATE(507),
    [sym_super_right_assignment] = STATE(507),
    [sym_right_assignment] = STATE(507),
    [sym_brace_list] = STATE(507),
    [sym_paren_list] = STATE(507),
    [sym_subset] = STATE(507),
    [sym_subset2] = STATE(507),
    [sym_dollar] = STATE(507),
    [sym_slot] = STATE(507),
    [sym_namespace_get] = STATE(507),
    [sym_namespace_get_internal] = STATE(507),
    [sym_pipe] = STATE(507),
    [sym_unary] = STATE(507),
    [sym_binary] = STATE(507),
    [sym_na] = STATE(507),
    [sym__expression] = STATE(507),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(507),
    [sym_string] = STATE(507),
    [anon_sym_SEMI] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(2033),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(2033),
    [sym_next] = ACTIONS(2033),
    [sym_true] = ACTIONS(2033),
    [sym_false] = ACTIONS(2033),
    [sym_null] = ACTIONS(2033),
    [sym_inf] = ACTIONS(2033),
    [sym_nan] = ACTIONS(2033),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(2031),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [386] = {
    [sym_function_definition] = STATE(506),
    [sym_lambda_function] = STATE(506),
    [sym_if] = STATE(506),
    [sym_while] = STATE(506),
    [sym_repeat] = STATE(506),
    [sym_for] = STATE(506),
    [sym_switch] = STATE(506),
    [sym_call] = STATE(506),
    [sym__assignment] = STATE(506),
    [sym_left_assignment] = STATE(506),
    [sym_left_assignment2] = STATE(506),
    [sym_equals_assignment] = STATE(506),
    [sym_super_assignment] = STATE(506),
    [sym_super_right_assignment] = STATE(506),
    [sym_right_assignment] = STATE(506),
    [sym_brace_list] = STATE(506),
    [sym_paren_list] = STATE(506),
    [sym_subset] = STATE(506),
    [sym_subset2] = STATE(506),
    [sym_dollar] = STATE(506),
    [sym_slot] = STATE(506),
    [sym_namespace_get] = STATE(506),
    [sym_namespace_get_internal] = STATE(506),
    [sym_pipe] = STATE(506),
    [sym_unary] = STATE(506),
    [sym_binary] = STATE(506),
    [sym_na] = STATE(506),
    [sym__expression] = STATE(506),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(506),
    [sym_string] = STATE(506),
    [anon_sym_SEMI] = ACTIONS(2035),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(2037),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(2037),
    [sym_next] = ACTIONS(2037),
    [sym_true] = ACTIONS(2037),
    [sym_false] = ACTIONS(2037),
    [sym_null] = ACTIONS(2037),
    [sym_inf] = ACTIONS(2037),
    [sym_nan] = ACTIONS(2037),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(2035),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [387] = {
    [sym_function_definition] = STATE(861),
    [sym_lambda_function] = STATE(861),
    [sym_if] = STATE(861),
    [sym_while] = STATE(861),
    [sym_repeat] = STATE(861),
    [sym_for] = STATE(861),
    [sym_switch] = STATE(861),
    [sym_call] = STATE(861),
    [sym__assignment] = STATE(861),
    [sym_left_assignment] = STATE(861),
    [sym_left_assignment2] = STATE(861),
    [sym_equals_assignment] = STATE(861),
    [sym_super_assignment] = STATE(861),
    [sym_super_right_assignment] = STATE(861),
    [sym_right_assignment] = STATE(861),
    [sym_brace_list] = STATE(861),
    [sym_paren_list] = STATE(861),
    [sym_subset] = STATE(861),
    [sym_subset2] = STATE(861),
    [sym_dollar] = STATE(861),
    [sym_slot] = STATE(861),
    [sym_namespace_get] = STATE(861),
    [sym_namespace_get_internal] = STATE(861),
    [sym_pipe] = STATE(861),
    [sym_unary] = STATE(861),
    [sym_binary] = STATE(861),
    [sym_na] = STATE(861),
    [sym__expression] = STATE(861),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(861),
    [sym_string] = STATE(861),
    [anon_sym_SEMI] = ACTIONS(2039),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(2041),
    [sym_next] = ACTIONS(2041),
    [sym_true] = ACTIONS(2041),
    [sym_false] = ACTIONS(2041),
    [sym_null] = ACTIONS(2041),
    [sym_inf] = ACTIONS(2041),
    [sym_nan] = ACTIONS(2041),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(2039),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [388] = {
    [anon_sym_LF] = ACTIONS(643),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_else] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(643),
    [anon_sym_COLON_EQ] = ACTIONS(643),
    [anon_sym_LT_LT_DASH] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(643),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(2043),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(2045),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(643),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_CARET] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(643),
    [anon_sym_EQ_EQ] = ACTIONS(643),
    [anon_sym_BANG_EQ] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(643),
    [sym_integer] = ACTIONS(643),
    [sym_float] = ACTIONS(643),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(643),
  },
  [389] = {
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(641),
    [anon_sym_else] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_integer] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [anon_sym_i] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
  },
  [390] = {
    [sym_function_definition] = STATE(691),
    [sym_lambda_function] = STATE(691),
    [sym_if] = STATE(691),
    [sym_while] = STATE(691),
    [sym_repeat] = STATE(691),
    [sym_for] = STATE(691),
    [sym_switch] = STATE(691),
    [sym_call] = STATE(691),
    [sym__assignment] = STATE(691),
    [sym_left_assignment] = STATE(691),
    [sym_left_assignment2] = STATE(691),
    [sym_equals_assignment] = STATE(691),
    [sym_super_assignment] = STATE(691),
    [sym_super_right_assignment] = STATE(691),
    [sym_right_assignment] = STATE(691),
    [sym_brace_list] = STATE(691),
    [sym_paren_list] = STATE(691),
    [sym_subset] = STATE(691),
    [sym_subset2] = STATE(691),
    [sym_dollar] = STATE(691),
    [sym_slot] = STATE(691),
    [sym_namespace_get] = STATE(691),
    [sym_namespace_get_internal] = STATE(691),
    [sym_pipe] = STATE(691),
    [sym_unary] = STATE(691),
    [sym_binary] = STATE(691),
    [sym_na] = STATE(691),
    [sym__expression] = STATE(691),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(691),
    [sym_string] = STATE(691),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2051),
    [sym_next] = ACTIONS(2051),
    [sym_true] = ACTIONS(2051),
    [sym_false] = ACTIONS(2051),
    [sym_null] = ACTIONS(2051),
    [sym_inf] = ACTIONS(2051),
    [sym_nan] = ACTIONS(2051),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2049),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [391] = {
    [sym_function_definition] = STATE(673),
    [sym_lambda_function] = STATE(673),
    [sym_if] = STATE(673),
    [sym_while] = STATE(673),
    [sym_repeat] = STATE(673),
    [sym_for] = STATE(673),
    [sym_switch] = STATE(673),
    [sym_call] = STATE(673),
    [sym__assignment] = STATE(673),
    [sym_left_assignment] = STATE(673),
    [sym_left_assignment2] = STATE(673),
    [sym_equals_assignment] = STATE(673),
    [sym_super_assignment] = STATE(673),
    [sym_super_right_assignment] = STATE(673),
    [sym_right_assignment] = STATE(673),
    [sym_brace_list] = STATE(673),
    [sym_paren_list] = STATE(673),
    [sym_subset] = STATE(673),
    [sym_subset2] = STATE(673),
    [sym_dollar] = STATE(673),
    [sym_slot] = STATE(673),
    [sym_namespace_get] = STATE(673),
    [sym_namespace_get_internal] = STATE(673),
    [sym_pipe] = STATE(673),
    [sym_unary] = STATE(673),
    [sym_binary] = STATE(673),
    [sym_na] = STATE(673),
    [sym__expression] = STATE(673),
    [sym_identifier] = STATE(571),
    [sym_complex] = STATE(673),
    [sym_string] = STATE(673),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_BSLASH] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_dots] = ACTIONS(2055),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_PLUS] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(33),
    [sym_break] = ACTIONS(2055),
    [sym_next] = ACTIONS(2055),
    [sym_true] = ACTIONS(2055),
    [sym_false] = ACTIONS(2055),
    [sym_null] = ACTIONS(2055),
    [sym_inf] = ACTIONS(2055),
    [sym_nan] = ACTIONS(2055),
    [anon_sym_NA] = ACTIONS(35),
    [anon_sym_NA_character_] = ACTIONS(35),
    [anon_sym_NA_complex_] = ACTIONS(35),
    [anon_sym_NA_integer_] = ACTIONS(35),
    [anon_sym_NA_real_] = ACTIONS(35),
    [aux_sym_identifier_token1] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [sym_integer] = ACTIONS(2053),
    [sym_float] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
  },
  [392] = {
    [sym_function_definition] = STATE(456),
    [sym_lambda_function] = STATE(456),
    [sym_if] = STATE(456),
    [sym_while] = STATE(456),
    [sym_repeat] = STATE(456),
    [sym_for] = STATE(456),
    [sym_switch] = STATE(456),
    [sym_call] = STATE(456),
    [sym__assignment] = STATE(456),
    [sym_left_assignment] = STATE(456),
    [sym_left_assignment2] = STATE(456),
    [sym_equals_assignment] = STATE(456),
    [sym_super_assignment] = STATE(456),
    [sym_super_right_assignment] = STATE(456),
    [sym_right_assignment] = STATE(456),
    [sym_brace_list] = STATE(456),
    [sym_paren_list] = STATE(456),
    [sym_subset] = STATE(456),
    [sym_subset2] = STATE(456),
    [sym_dollar] = STATE(456),
    [sym_slot] = STATE(456),
    [sym_namespace_get] = STATE(456),
    [sym_namespace_get_internal] = STATE(456),
    [sym_pipe] = STATE(456),
    [sym_unary] = STATE(456),
    [sym_binary] = STATE(456),
    [sym_na] = STATE(456),
    [sym__expression] = STATE(456),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(456),
    [sym_string] = STATE(456),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2059),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2059),
    [sym_next] = ACTIONS(2059),
    [sym_true] = ACTIONS(2059),
    [sym_false] = ACTIONS(2059),
    [sym_null] = ACTIONS(2059),
    [sym_inf] = ACTIONS(2059),
    [sym_nan] = ACTIONS(2059),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2057),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [393] = {
    [sym_function_definition] = STATE(860),
    [sym_lambda_function] = STATE(860),
    [sym_if] = STATE(860),
    [sym_while] = STATE(860),
    [sym_repeat] = STATE(860),
    [sym_for] = STATE(860),
    [sym_switch] = STATE(860),
    [sym_call] = STATE(860),
    [sym__assignment] = STATE(860),
    [sym_left_assignment] = STATE(860),
    [sym_left_assignment2] = STATE(860),
    [sym_equals_assignment] = STATE(860),
    [sym_super_assignment] = STATE(860),
    [sym_super_right_assignment] = STATE(860),
    [sym_right_assignment] = STATE(860),
    [sym_brace_list] = STATE(860),
    [sym_paren_list] = STATE(860),
    [sym_subset] = STATE(860),
    [sym_subset2] = STATE(860),
    [sym_dollar] = STATE(860),
    [sym_slot] = STATE(860),
    [sym_namespace_get] = STATE(860),
    [sym_namespace_get_internal] = STATE(860),
    [sym_pipe] = STATE(860),
    [sym_unary] = STATE(860),
    [sym_binary] = STATE(860),
    [sym_na] = STATE(860),
    [sym__expression] = STATE(860),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(860),
    [sym_string] = STATE(860),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(2063),
    [sym_next] = ACTIONS(2063),
    [sym_true] = ACTIONS(2063),
    [sym_false] = ACTIONS(2063),
    [sym_null] = ACTIONS(2063),
    [sym_inf] = ACTIONS(2063),
    [sym_nan] = ACTIONS(2063),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(2061),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [394] = {
    [sym_function_definition] = STATE(859),
    [sym_lambda_function] = STATE(859),
    [sym_if] = STATE(859),
    [sym_while] = STATE(859),
    [sym_repeat] = STATE(859),
    [sym_for] = STATE(859),
    [sym_switch] = STATE(859),
    [sym_call] = STATE(859),
    [sym__assignment] = STATE(859),
    [sym_left_assignment] = STATE(859),
    [sym_left_assignment2] = STATE(859),
    [sym_equals_assignment] = STATE(859),
    [sym_super_assignment] = STATE(859),
    [sym_super_right_assignment] = STATE(859),
    [sym_right_assignment] = STATE(859),
    [sym_brace_list] = STATE(859),
    [sym_paren_list] = STATE(859),
    [sym_subset] = STATE(859),
    [sym_subset2] = STATE(859),
    [sym_dollar] = STATE(859),
    [sym_slot] = STATE(859),
    [sym_namespace_get] = STATE(859),
    [sym_namespace_get_internal] = STATE(859),
    [sym_pipe] = STATE(859),
    [sym_unary] = STATE(859),
    [sym_binary] = STATE(859),
    [sym_na] = STATE(859),
    [sym__expression] = STATE(859),
    [sym_identifier] = STATE(162),
    [sym_complex] = STATE(859),
    [sym_string] = STATE(859),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_repeat] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [sym_dots] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(721),
    [sym_break] = ACTIONS(2067),
    [sym_next] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_inf] = ACTIONS(2067),
    [sym_nan] = ACTIONS(2067),
    [anon_sym_NA] = ACTIONS(127),
    [anon_sym_NA_character_] = ACTIONS(127),
    [anon_sym_NA_complex_] = ACTIONS(127),
    [anon_sym_NA_integer_] = ACTIONS(127),
    [anon_sym_NA_real_] = ACTIONS(127),
    [aux_sym_identifier_token1] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_integer] = ACTIONS(2065),
    [sym_float] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(137),
  },
  [395] = {
    [sym_function_definition] = STATE(692),
    [sym_lambda_function] = STATE(692),
    [sym_if] = STATE(692),
    [sym_while] = STATE(692),
    [sym_repeat] = STATE(692),
    [sym_for] = STATE(692),
    [sym_switch] = STATE(692),
    [sym_call] = STATE(692),
    [sym__assignment] = STATE(692),
    [sym_left_assignment] = STATE(692),
    [sym_left_assignment2] = STATE(692),
    [sym_equals_assignment] = STATE(692),
    [sym_super_assignment] = STATE(692),
    [sym_super_right_assignment] = STATE(692),
    [sym_right_assignment] = STATE(692),
    [sym_brace_list] = STATE(692),
    [sym_paren_list] = STATE(692),
    [sym_subset] = STATE(692),
    [sym_subset2] = STATE(692),
    [sym_dollar] = STATE(692),
    [sym_slot] = STATE(692),
    [sym_namespace_get] = STATE(692),
    [sym_namespace_get_internal] = STATE(692),
    [sym_pipe] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_binary] = STATE(692),
    [sym_na] = STATE(692),
    [sym__expression] = STATE(692),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(692),
    [sym_string] = STATE(692),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2071),
    [sym_next] = ACTIONS(2071),
    [sym_true] = ACTIONS(2071),
    [sym_false] = ACTIONS(2071),
    [sym_null] = ACTIONS(2071),
    [sym_inf] = ACTIONS(2071),
    [sym_nan] = ACTIONS(2071),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2069),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [396] = {
    [sym_function_definition] = STATE(455),
    [sym_lambda_function] = STATE(455),
    [sym_if] = STATE(455),
    [sym_while] = STATE(455),
    [sym_repeat] = STATE(455),
    [sym_for] = STATE(455),
    [sym_switch] = STATE(455),
    [sym_call] = STATE(455),
    [sym__assignment] = STATE(455),
    [sym_left_assignment] = STATE(455),
    [sym_left_assignment2] = STATE(455),
    [sym_equals_assignment] = STATE(455),
    [sym_super_assignment] = STATE(455),
    [sym_super_right_assignment] = STATE(455),
    [sym_right_assignment] = STATE(455),
    [sym_brace_list] = STATE(455),
    [sym_paren_list] = STATE(455),
    [sym_subset] = STATE(455),
    [sym_subset2] = STATE(455),
    [sym_dollar] = STATE(455),
    [sym_slot] = STATE(455),
    [sym_namespace_get] = STATE(455),
    [sym_namespace_get_internal] = STATE(455),
    [sym_pipe] = STATE(455),
    [sym_unary] = STATE(455),
    [sym_binary] = STATE(455),
    [sym_na] = STATE(455),
    [sym__expression] = STATE(455),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(455),
    [sym_string] = STATE(455),
    [anon_sym_SEMI] = ACTIONS(2073),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2075),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2075),
    [sym_next] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_null] = ACTIONS(2075),
    [sym_inf] = ACTIONS(2075),
    [sym_nan] = ACTIONS(2075),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2073),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [397] = {
    [sym_function_definition] = STATE(454),
    [sym_lambda_function] = STATE(454),
    [sym_if] = STATE(454),
    [sym_while] = STATE(454),
    [sym_repeat] = STATE(454),
    [sym_for] = STATE(454),
    [sym_switch] = STATE(454),
    [sym_call] = STATE(454),
    [sym__assignment] = STATE(454),
    [sym_left_assignment] = STATE(454),
    [sym_left_assignment2] = STATE(454),
    [sym_equals_assignment] = STATE(454),
    [sym_super_assignment] = STATE(454),
    [sym_super_right_assignment] = STATE(454),
    [sym_right_assignment] = STATE(454),
    [sym_brace_list] = STATE(454),
    [sym_paren_list] = STATE(454),
    [sym_subset] = STATE(454),
    [sym_subset2] = STATE(454),
    [sym_dollar] = STATE(454),
    [sym_slot] = STATE(454),
    [sym_namespace_get] = STATE(454),
    [sym_namespace_get_internal] = STATE(454),
    [sym_pipe] = STATE(454),
    [sym_unary] = STATE(454),
    [sym_binary] = STATE(454),
    [sym_na] = STATE(454),
    [sym__expression] = STATE(454),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(454),
    [sym_string] = STATE(454),
    [anon_sym_SEMI] = ACTIONS(2077),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2079),
    [sym_next] = ACTIONS(2079),
    [sym_true] = ACTIONS(2079),
    [sym_false] = ACTIONS(2079),
    [sym_null] = ACTIONS(2079),
    [sym_inf] = ACTIONS(2079),
    [sym_nan] = ACTIONS(2079),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2077),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [398] = {
    [sym_function_definition] = STATE(510),
    [sym_lambda_function] = STATE(510),
    [sym_if] = STATE(510),
    [sym_while] = STATE(510),
    [sym_repeat] = STATE(510),
    [sym_for] = STATE(510),
    [sym_switch] = STATE(510),
    [sym_call] = STATE(510),
    [sym__assignment] = STATE(510),
    [sym_left_assignment] = STATE(510),
    [sym_left_assignment2] = STATE(510),
    [sym_equals_assignment] = STATE(510),
    [sym_super_assignment] = STATE(510),
    [sym_super_right_assignment] = STATE(510),
    [sym_right_assignment] = STATE(510),
    [sym_brace_list] = STATE(510),
    [sym_paren_list] = STATE(510),
    [sym_subset] = STATE(510),
    [sym_subset2] = STATE(510),
    [sym_dollar] = STATE(510),
    [sym_slot] = STATE(510),
    [sym_namespace_get] = STATE(510),
    [sym_namespace_get_internal] = STATE(510),
    [sym_pipe] = STATE(510),
    [sym_unary] = STATE(510),
    [sym_binary] = STATE(510),
    [sym_na] = STATE(510),
    [sym__expression] = STATE(510),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(510),
    [sym_string] = STATE(510),
    [anon_sym_SEMI] = ACTIONS(2081),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(2083),
    [sym_next] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_inf] = ACTIONS(2083),
    [sym_nan] = ACTIONS(2083),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(2081),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [399] = {
    [sym_function_definition] = STATE(504),
    [sym_lambda_function] = STATE(504),
    [sym_if] = STATE(504),
    [sym_while] = STATE(504),
    [sym_repeat] = STATE(504),
    [sym_for] = STATE(504),
    [sym_switch] = STATE(504),
    [sym_call] = STATE(504),
    [sym__assignment] = STATE(504),
    [sym_left_assignment] = STATE(504),
    [sym_left_assignment2] = STATE(504),
    [sym_equals_assignment] = STATE(504),
    [sym_super_assignment] = STATE(504),
    [sym_super_right_assignment] = STATE(504),
    [sym_right_assignment] = STATE(504),
    [sym_brace_list] = STATE(504),
    [sym_paren_list] = STATE(504),
    [sym_subset] = STATE(504),
    [sym_subset2] = STATE(504),
    [sym_dollar] = STATE(504),
    [sym_slot] = STATE(504),
    [sym_namespace_get] = STATE(504),
    [sym_namespace_get_internal] = STATE(504),
    [sym_pipe] = STATE(504),
    [sym_unary] = STATE(504),
    [sym_binary] = STATE(504),
    [sym_na] = STATE(504),
    [sym__expression] = STATE(504),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(504),
    [sym_string] = STATE(504),
    [anon_sym_SEMI] = ACTIONS(2085),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(2087),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(2087),
    [sym_next] = ACTIONS(2087),
    [sym_true] = ACTIONS(2087),
    [sym_false] = ACTIONS(2087),
    [sym_null] = ACTIONS(2087),
    [sym_inf] = ACTIONS(2087),
    [sym_nan] = ACTIONS(2087),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(2085),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [400] = {
    [sym_function_definition] = STATE(503),
    [sym_lambda_function] = STATE(503),
    [sym_if] = STATE(503),
    [sym_while] = STATE(503),
    [sym_repeat] = STATE(503),
    [sym_for] = STATE(503),
    [sym_switch] = STATE(503),
    [sym_call] = STATE(503),
    [sym__assignment] = STATE(503),
    [sym_left_assignment] = STATE(503),
    [sym_left_assignment2] = STATE(503),
    [sym_equals_assignment] = STATE(503),
    [sym_super_assignment] = STATE(503),
    [sym_super_right_assignment] = STATE(503),
    [sym_right_assignment] = STATE(503),
    [sym_brace_list] = STATE(503),
    [sym_paren_list] = STATE(503),
    [sym_subset] = STATE(503),
    [sym_subset2] = STATE(503),
    [sym_dollar] = STATE(503),
    [sym_slot] = STATE(503),
    [sym_namespace_get] = STATE(503),
    [sym_namespace_get_internal] = STATE(503),
    [sym_pipe] = STATE(503),
    [sym_unary] = STATE(503),
    [sym_binary] = STATE(503),
    [sym_na] = STATE(503),
    [sym__expression] = STATE(503),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(503),
    [sym_string] = STATE(503),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(2091),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(2091),
    [sym_next] = ACTIONS(2091),
    [sym_true] = ACTIONS(2091),
    [sym_false] = ACTIONS(2091),
    [sym_null] = ACTIONS(2091),
    [sym_inf] = ACTIONS(2091),
    [sym_nan] = ACTIONS(2091),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(2089),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [401] = {
    [sym_function_definition] = STATE(502),
    [sym_lambda_function] = STATE(502),
    [sym_if] = STATE(502),
    [sym_while] = STATE(502),
    [sym_repeat] = STATE(502),
    [sym_for] = STATE(502),
    [sym_switch] = STATE(502),
    [sym_call] = STATE(502),
    [sym__assignment] = STATE(502),
    [sym_left_assignment] = STATE(502),
    [sym_left_assignment2] = STATE(502),
    [sym_equals_assignment] = STATE(502),
    [sym_super_assignment] = STATE(502),
    [sym_super_right_assignment] = STATE(502),
    [sym_right_assignment] = STATE(502),
    [sym_brace_list] = STATE(502),
    [sym_paren_list] = STATE(502),
    [sym_subset] = STATE(502),
    [sym_subset2] = STATE(502),
    [sym_dollar] = STATE(502),
    [sym_slot] = STATE(502),
    [sym_namespace_get] = STATE(502),
    [sym_namespace_get_internal] = STATE(502),
    [sym_pipe] = STATE(502),
    [sym_unary] = STATE(502),
    [sym_binary] = STATE(502),
    [sym_na] = STATE(502),
    [sym__expression] = STATE(502),
    [sym_identifier] = STATE(327),
    [sym_complex] = STATE(502),
    [sym_string] = STATE(502),
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_repeat] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [sym_dots] = ACTIONS(2095),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_break] = ACTIONS(2095),
    [sym_next] = ACTIONS(2095),
    [sym_true] = ACTIONS(2095),
    [sym_false] = ACTIONS(2095),
    [sym_null] = ACTIONS(2095),
    [sym_inf] = ACTIONS(2095),
    [sym_nan] = ACTIONS(2095),
    [anon_sym_NA] = ACTIONS(1015),
    [anon_sym_NA_character_] = ACTIONS(1015),
    [anon_sym_NA_complex_] = ACTIONS(1015),
    [anon_sym_NA_integer_] = ACTIONS(1015),
    [anon_sym_NA_real_] = ACTIONS(1015),
    [aux_sym_identifier_token1] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(2093),
    [sym_float] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1025),
  },
  [402] = {
    [sym_function_definition] = STATE(697),
    [sym_lambda_function] = STATE(697),
    [sym_if] = STATE(697),
    [sym_while] = STATE(697),
    [sym_repeat] = STATE(697),
    [sym_for] = STATE(697),
    [sym_switch] = STATE(697),
    [sym_call] = STATE(697),
    [sym__assignment] = STATE(697),
    [sym_left_assignment] = STATE(697),
    [sym_left_assignment2] = STATE(697),
    [sym_equals_assignment] = STATE(697),
    [sym_super_assignment] = STATE(697),
    [sym_super_right_assignment] = STATE(697),
    [sym_right_assignment] = STATE(697),
    [sym_brace_list] = STATE(697),
    [sym_paren_list] = STATE(697),
    [sym_subset] = STATE(697),
    [sym_subset2] = STATE(697),
    [sym_dollar] = STATE(697),
    [sym_slot] = STATE(697),
    [sym_namespace_get] = STATE(697),
    [sym_namespace_get_internal] = STATE(697),
    [sym_pipe] = STATE(697),
    [sym_unary] = STATE(697),
    [sym_binary] = STATE(697),
    [sym_na] = STATE(697),
    [sym__expression] = STATE(697),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(697),
    [sym_string] = STATE(697),
    [anon_sym_SEMI] = ACTIONS(2097),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2099),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2099),
    [sym_next] = ACTIONS(2099),
    [sym_true] = ACTIONS(2099),
    [sym_false] = ACTIONS(2099),
    [sym_null] = ACTIONS(2099),
    [sym_inf] = ACTIONS(2099),
    [sym_nan] = ACTIONS(2099),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2097),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [403] = {
    [ts_builtin_sym_end] = ACTIONS(649),
    [anon_sym_LF] = ACTIONS(651),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_function] = ACTIONS(651),
    [anon_sym_BSLASH] = ACTIONS(651),
    [anon_sym_if] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_else] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(651),
    [anon_sym_repeat] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_switch] = ACTIONS(651),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(651),
    [anon_sym_LT_DASH] = ACTIONS(651),
    [anon_sym_COLON_EQ] = ACTIONS(651),
    [anon_sym_LT_LT_DASH] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(651),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(651),
    [anon_sym_DOLLAR] = ACTIONS(651),
    [anon_sym_AT] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(651),
    [sym_dots] = ACTIONS(651),
    [anon_sym_PIPE_GT] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_STAR] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(651),
    [anon_sym_CARET] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(651),
    [anon_sym_LT_EQ] = ACTIONS(651),
    [anon_sym_GT_EQ] = ACTIONS(651),
    [anon_sym_EQ_EQ] = ACTIONS(651),
    [anon_sym_BANG_EQ] = ACTIONS(651),
    [anon_sym_PIPE_PIPE] = ACTIONS(651),
    [anon_sym_PIPE] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(651),
    [anon_sym_AMP] = ACTIONS(651),
    [anon_sym_COLON] = ACTIONS(651),
    [sym_break] = ACTIONS(651),
    [sym_next] = ACTIONS(651),
    [sym_true] = ACTIONS(651),
    [sym_false] = ACTIONS(651),
    [sym_null] = ACTIONS(651),
    [sym_inf] = ACTIONS(651),
    [sym_nan] = ACTIONS(651),
    [anon_sym_NA] = ACTIONS(651),
    [anon_sym_NA_character_] = ACTIONS(651),
    [anon_sym_NA_complex_] = ACTIONS(651),
    [anon_sym_NA_integer_] = ACTIONS(651),
    [anon_sym_NA_real_] = ACTIONS(651),
    [aux_sym_identifier_token1] = ACTIONS(651),
    [anon_sym_BQUOTE] = ACTIONS(651),
    [sym_integer] = ACTIONS(651),
    [sym_float] = ACTIONS(651),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(651),
    [anon_sym_SQUOTE] = ACTIONS(651),
    [anon_sym_PERCENT] = ACTIONS(651),
  },
  [404] = {
    [sym_function_definition] = STATE(704),
    [sym_lambda_function] = STATE(704),
    [sym_if] = STATE(704),
    [sym_while] = STATE(704),
    [sym_repeat] = STATE(704),
    [sym_for] = STATE(704),
    [sym_switch] = STATE(704),
    [sym_call] = STATE(704),
    [sym__assignment] = STATE(704),
    [sym_left_assignment] = STATE(704),
    [sym_left_assignment2] = STATE(704),
    [sym_equals_assignment] = STATE(704),
    [sym_super_assignment] = STATE(704),
    [sym_super_right_assignment] = STATE(704),
    [sym_right_assignment] = STATE(704),
    [sym_brace_list] = STATE(704),
    [sym_paren_list] = STATE(704),
    [sym_subset] = STATE(704),
    [sym_subset2] = STATE(704),
    [sym_dollar] = STATE(704),
    [sym_slot] = STATE(704),
    [sym_namespace_get] = STATE(704),
    [sym_namespace_get_internal] = STATE(704),
    [sym_pipe] = STATE(704),
    [sym_unary] = STATE(704),
    [sym_binary] = STATE(704),
    [sym_na] = STATE(704),
    [sym__expression] = STATE(704),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(704),
    [sym_string] = STATE(704),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2103),
    [sym_next] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_inf] = ACTIONS(2103),
    [sym_nan] = ACTIONS(2103),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2101),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [405] = {
    [sym_function_definition] = STATE(448),
    [sym_lambda_function] = STATE(448),
    [sym_if] = STATE(448),
    [sym_while] = STATE(448),
    [sym_repeat] = STATE(448),
    [sym_for] = STATE(448),
    [sym_switch] = STATE(448),
    [sym_call] = STATE(448),
    [sym__assignment] = STATE(448),
    [sym_left_assignment] = STATE(448),
    [sym_left_assignment2] = STATE(448),
    [sym_equals_assignment] = STATE(448),
    [sym_super_assignment] = STATE(448),
    [sym_super_right_assignment] = STATE(448),
    [sym_right_assignment] = STATE(448),
    [sym_brace_list] = STATE(448),
    [sym_paren_list] = STATE(448),
    [sym_subset] = STATE(448),
    [sym_subset2] = STATE(448),
    [sym_dollar] = STATE(448),
    [sym_slot] = STATE(448),
    [sym_namespace_get] = STATE(448),
    [sym_namespace_get_internal] = STATE(448),
    [sym_pipe] = STATE(448),
    [sym_unary] = STATE(448),
    [sym_binary] = STATE(448),
    [sym_na] = STATE(448),
    [sym__expression] = STATE(448),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(448),
    [sym_string] = STATE(448),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2107),
    [sym_next] = ACTIONS(2107),
    [sym_true] = ACTIONS(2107),
    [sym_false] = ACTIONS(2107),
    [sym_null] = ACTIONS(2107),
    [sym_inf] = ACTIONS(2107),
    [sym_nan] = ACTIONS(2107),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2105),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [406] = {
    [sym_function_definition] = STATE(731),
    [sym_lambda_function] = STATE(731),
    [sym_if] = STATE(731),
    [sym_while] = STATE(731),
    [sym_repeat] = STATE(731),
    [sym_for] = STATE(731),
    [sym_switch] = STATE(731),
    [sym_call] = STATE(731),
    [sym__assignment] = STATE(731),
    [sym_left_assignment] = STATE(731),
    [sym_left_assignment2] = STATE(731),
    [sym_equals_assignment] = STATE(731),
    [sym_super_assignment] = STATE(731),
    [sym_super_right_assignment] = STATE(731),
    [sym_right_assignment] = STATE(731),
    [sym_brace_list] = STATE(731),
    [sym_paren_list] = STATE(731),
    [sym_subset] = STATE(731),
    [sym_subset2] = STATE(731),
    [sym_dollar] = STATE(731),
    [sym_slot] = STATE(731),
    [sym_namespace_get] = STATE(731),
    [sym_namespace_get_internal] = STATE(731),
    [sym_pipe] = STATE(731),
    [sym_unary] = STATE(731),
    [sym_binary] = STATE(731),
    [sym_na] = STATE(731),
    [sym__expression] = STATE(731),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(731),
    [sym_string] = STATE(731),
    [anon_sym_SEMI] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2111),
    [sym_next] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_inf] = ACTIONS(2111),
    [sym_nan] = ACTIONS(2111),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2109),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [407] = {
    [sym_function_definition] = STATE(728),
    [sym_lambda_function] = STATE(728),
    [sym_if] = STATE(728),
    [sym_while] = STATE(728),
    [sym_repeat] = STATE(728),
    [sym_for] = STATE(728),
    [sym_switch] = STATE(728),
    [sym_call] = STATE(728),
    [sym__assignment] = STATE(728),
    [sym_left_assignment] = STATE(728),
    [sym_left_assignment2] = STATE(728),
    [sym_equals_assignment] = STATE(728),
    [sym_super_assignment] = STATE(728),
    [sym_super_right_assignment] = STATE(728),
    [sym_right_assignment] = STATE(728),
    [sym_brace_list] = STATE(728),
    [sym_paren_list] = STATE(728),
    [sym_subset] = STATE(728),
    [sym_subset2] = STATE(728),
    [sym_dollar] = STATE(728),
    [sym_slot] = STATE(728),
    [sym_namespace_get] = STATE(728),
    [sym_namespace_get_internal] = STATE(728),
    [sym_pipe] = STATE(728),
    [sym_unary] = STATE(728),
    [sym_binary] = STATE(728),
    [sym_na] = STATE(728),
    [sym__expression] = STATE(728),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(728),
    [sym_string] = STATE(728),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2115),
    [sym_next] = ACTIONS(2115),
    [sym_true] = ACTIONS(2115),
    [sym_false] = ACTIONS(2115),
    [sym_null] = ACTIONS(2115),
    [sym_inf] = ACTIONS(2115),
    [sym_nan] = ACTIONS(2115),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2113),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [408] = {
    [sym_function_definition] = STATE(703),
    [sym_lambda_function] = STATE(703),
    [sym_if] = STATE(703),
    [sym_while] = STATE(703),
    [sym_repeat] = STATE(703),
    [sym_for] = STATE(703),
    [sym_switch] = STATE(703),
    [sym_call] = STATE(703),
    [sym__assignment] = STATE(703),
    [sym_left_assignment] = STATE(703),
    [sym_left_assignment2] = STATE(703),
    [sym_equals_assignment] = STATE(703),
    [sym_super_assignment] = STATE(703),
    [sym_super_right_assignment] = STATE(703),
    [sym_right_assignment] = STATE(703),
    [sym_brace_list] = STATE(703),
    [sym_paren_list] = STATE(703),
    [sym_subset] = STATE(703),
    [sym_subset2] = STATE(703),
    [sym_dollar] = STATE(703),
    [sym_slot] = STATE(703),
    [sym_namespace_get] = STATE(703),
    [sym_namespace_get_internal] = STATE(703),
    [sym_pipe] = STATE(703),
    [sym_unary] = STATE(703),
    [sym_binary] = STATE(703),
    [sym_na] = STATE(703),
    [sym__expression] = STATE(703),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(703),
    [sym_string] = STATE(703),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2119),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2119),
    [sym_next] = ACTIONS(2119),
    [sym_true] = ACTIONS(2119),
    [sym_false] = ACTIONS(2119),
    [sym_null] = ACTIONS(2119),
    [sym_inf] = ACTIONS(2119),
    [sym_nan] = ACTIONS(2119),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2117),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [409] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2123),
    [anon_sym_BSLASH] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2123),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(2121),
    [anon_sym_else] = ACTIONS(2123),
    [anon_sym_while] = ACTIONS(2123),
    [anon_sym_repeat] = ACTIONS(2123),
    [anon_sym_for] = ACTIONS(2123),
    [anon_sym_switch] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2121),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_LT_DASH] = ACTIONS(901),
    [anon_sym_COLON_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT_GT] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(2121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(2123),
    [anon_sym_PIPE_GT] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(2123),
    [sym_next] = ACTIONS(2123),
    [sym_true] = ACTIONS(2123),
    [sym_false] = ACTIONS(2123),
    [sym_null] = ACTIONS(2123),
    [sym_inf] = ACTIONS(2123),
    [sym_nan] = ACTIONS(2123),
    [anon_sym_NA] = ACTIONS(2123),
    [anon_sym_NA_character_] = ACTIONS(2123),
    [anon_sym_NA_complex_] = ACTIONS(2123),
    [anon_sym_NA_integer_] = ACTIONS(2123),
    [anon_sym_NA_real_] = ACTIONS(2123),
    [aux_sym_identifier_token1] = ACTIONS(2123),
    [anon_sym_BQUOTE] = ACTIONS(2121),
    [sym_integer] = ACTIONS(2121),
    [sym_float] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2121),
    [anon_sym_SQUOTE] = ACTIONS(2121),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [410] = {
    [sym_function_definition] = STATE(445),
    [sym_lambda_function] = STATE(445),
    [sym_if] = STATE(445),
    [sym_while] = STATE(445),
    [sym_repeat] = STATE(445),
    [sym_for] = STATE(445),
    [sym_switch] = STATE(445),
    [sym_call] = STATE(445),
    [sym__assignment] = STATE(445),
    [sym_left_assignment] = STATE(445),
    [sym_left_assignment2] = STATE(445),
    [sym_equals_assignment] = STATE(445),
    [sym_super_assignment] = STATE(445),
    [sym_super_right_assignment] = STATE(445),
    [sym_right_assignment] = STATE(445),
    [sym_brace_list] = STATE(445),
    [sym_paren_list] = STATE(445),
    [sym_subset] = STATE(445),
    [sym_subset2] = STATE(445),
    [sym_dollar] = STATE(445),
    [sym_slot] = STATE(445),
    [sym_namespace_get] = STATE(445),
    [sym_namespace_get_internal] = STATE(445),
    [sym_pipe] = STATE(445),
    [sym_unary] = STATE(445),
    [sym_binary] = STATE(445),
    [sym_na] = STATE(445),
    [sym__expression] = STATE(445),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(445),
    [sym_string] = STATE(445),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2127),
    [sym_next] = ACTIONS(2127),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [sym_null] = ACTIONS(2127),
    [sym_inf] = ACTIONS(2127),
    [sym_nan] = ACTIONS(2127),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2125),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [411] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(2129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(2131),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2129),
    [anon_sym_GT_EQ] = ACTIONS(2129),
    [anon_sym_EQ_EQ] = ACTIONS(2129),
    [anon_sym_BANG_EQ] = ACTIONS(2129),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2131),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(2129),
  },
  [412] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(2129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [413] = {
    [sym_special] = STATE(257),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(2129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(917),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [414] = {
    [ts_builtin_sym_end] = ACTIONS(653),
    [anon_sym_LF] = ACTIONS(655),
    [anon_sym_SEMI] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(655),
    [anon_sym_BSLASH] = ACTIONS(655),
    [anon_sym_if] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_else] = ACTIONS(655),
    [anon_sym_while] = ACTIONS(655),
    [anon_sym_repeat] = ACTIONS(655),
    [anon_sym_for] = ACTIONS(655),
    [anon_sym_switch] = ACTIONS(655),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LT_DASH] = ACTIONS(655),
    [anon_sym_COLON_EQ] = ACTIONS(655),
    [anon_sym_LT_LT_DASH] = ACTIONS(655),
    [anon_sym_DASH_GT_GT] = ACTIONS(655),
    [anon_sym_DASH_GT] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(655),
    [anon_sym_DOLLAR] = ACTIONS(655),
    [anon_sym_AT] = ACTIONS(655),
    [anon_sym_COLON_COLON] = ACTIONS(655),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(655),
    [sym_dots] = ACTIONS(655),
    [anon_sym_PIPE_GT] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(655),
    [anon_sym_GT_EQ] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(655),
    [anon_sym_BANG_EQ] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(655),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_COLON] = ACTIONS(655),
    [sym_break] = ACTIONS(655),
    [sym_next] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_null] = ACTIONS(655),
    [sym_inf] = ACTIONS(655),
    [sym_nan] = ACTIONS(655),
    [anon_sym_NA] = ACTIONS(655),
    [anon_sym_NA_character_] = ACTIONS(655),
    [anon_sym_NA_complex_] = ACTIONS(655),
    [anon_sym_NA_integer_] = ACTIONS(655),
    [anon_sym_NA_real_] = ACTIONS(655),
    [aux_sym_identifier_token1] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_integer] = ACTIONS(655),
    [sym_float] = ACTIONS(655),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
  },
  [415] = {
    [sym_function_definition] = STATE(444),
    [sym_lambda_function] = STATE(444),
    [sym_if] = STATE(444),
    [sym_while] = STATE(444),
    [sym_repeat] = STATE(444),
    [sym_for] = STATE(444),
    [sym_switch] = STATE(444),
    [sym_call] = STATE(444),
    [sym__assignment] = STATE(444),
    [sym_left_assignment] = STATE(444),
    [sym_left_assignment2] = STATE(444),
    [sym_equals_assignment] = STATE(444),
    [sym_super_assignment] = STATE(444),
    [sym_super_right_assignment] = STATE(444),
    [sym_right_assignment] = STATE(444),
    [sym_brace_list] = STATE(444),
    [sym_paren_list] = STATE(444),
    [sym_subset] = STATE(444),
    [sym_subset2] = STATE(444),
    [sym_dollar] = STATE(444),
    [sym_slot] = STATE(444),
    [sym_namespace_get] = STATE(444),
    [sym_namespace_get_internal] = STATE(444),
    [sym_pipe] = STATE(444),
    [sym_unary] = STATE(444),
    [sym_binary] = STATE(444),
    [sym_na] = STATE(444),
    [sym__expression] = STATE(444),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(444),
    [sym_string] = STATE(444),
    [anon_sym_SEMI] = ACTIONS(2133),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2135),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2135),
    [sym_next] = ACTIONS(2135),
    [sym_true] = ACTIONS(2135),
    [sym_false] = ACTIONS(2135),
    [sym_null] = ACTIONS(2135),
    [sym_inf] = ACTIONS(2135),
    [sym_nan] = ACTIONS(2135),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2133),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [416] = {
    [ts_builtin_sym_end] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_SEMI] = ACTIONS(659),
    [anon_sym_function] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(659),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(659),
    [anon_sym_else] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(659),
    [anon_sym_repeat] = ACTIONS(659),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(659),
    [anon_sym_EQ] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_LT_DASH] = ACTIONS(659),
    [anon_sym_COLON_EQ] = ACTIONS(659),
    [anon_sym_LT_LT_DASH] = ACTIONS(659),
    [anon_sym_DASH_GT_GT] = ACTIONS(659),
    [anon_sym_DASH_GT] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(659),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(659),
    [anon_sym_COLON_COLON] = ACTIONS(659),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(659),
    [sym_dots] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(659),
    [anon_sym_SLASH] = ACTIONS(659),
    [anon_sym_CARET] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(659),
    [sym_break] = ACTIONS(659),
    [sym_next] = ACTIONS(659),
    [sym_true] = ACTIONS(659),
    [sym_false] = ACTIONS(659),
    [sym_null] = ACTIONS(659),
    [sym_inf] = ACTIONS(659),
    [sym_nan] = ACTIONS(659),
    [anon_sym_NA] = ACTIONS(659),
    [anon_sym_NA_character_] = ACTIONS(659),
    [anon_sym_NA_complex_] = ACTIONS(659),
    [anon_sym_NA_integer_] = ACTIONS(659),
    [anon_sym_NA_real_] = ACTIONS(659),
    [aux_sym_identifier_token1] = ACTIONS(659),
    [anon_sym_BQUOTE] = ACTIONS(659),
    [sym_integer] = ACTIONS(659),
    [sym_float] = ACTIONS(659),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_PERCENT] = ACTIONS(659),
  },
  [417] = {
    [sym_function_definition] = STATE(722),
    [sym_lambda_function] = STATE(722),
    [sym_if] = STATE(722),
    [sym_while] = STATE(722),
    [sym_repeat] = STATE(722),
    [sym_for] = STATE(722),
    [sym_switch] = STATE(722),
    [sym_call] = STATE(722),
    [sym__assignment] = STATE(722),
    [sym_left_assignment] = STATE(722),
    [sym_left_assignment2] = STATE(722),
    [sym_equals_assignment] = STATE(722),
    [sym_super_assignment] = STATE(722),
    [sym_super_right_assignment] = STATE(722),
    [sym_right_assignment] = STATE(722),
    [sym_brace_list] = STATE(722),
    [sym_paren_list] = STATE(722),
    [sym_subset] = STATE(722),
    [sym_subset2] = STATE(722),
    [sym_dollar] = STATE(722),
    [sym_slot] = STATE(722),
    [sym_namespace_get] = STATE(722),
    [sym_namespace_get_internal] = STATE(722),
    [sym_pipe] = STATE(722),
    [sym_unary] = STATE(722),
    [sym_binary] = STATE(722),
    [sym_na] = STATE(722),
    [sym__expression] = STATE(722),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(722),
    [sym_string] = STATE(722),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2139),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2139),
    [sym_next] = ACTIONS(2139),
    [sym_true] = ACTIONS(2139),
    [sym_false] = ACTIONS(2139),
    [sym_null] = ACTIONS(2139),
    [sym_inf] = ACTIONS(2139),
    [sym_nan] = ACTIONS(2139),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2137),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [418] = {
    [sym_function_definition] = STATE(721),
    [sym_lambda_function] = STATE(721),
    [sym_if] = STATE(721),
    [sym_while] = STATE(721),
    [sym_repeat] = STATE(721),
    [sym_for] = STATE(721),
    [sym_switch] = STATE(721),
    [sym_call] = STATE(721),
    [sym__assignment] = STATE(721),
    [sym_left_assignment] = STATE(721),
    [sym_left_assignment2] = STATE(721),
    [sym_equals_assignment] = STATE(721),
    [sym_super_assignment] = STATE(721),
    [sym_super_right_assignment] = STATE(721),
    [sym_right_assignment] = STATE(721),
    [sym_brace_list] = STATE(721),
    [sym_paren_list] = STATE(721),
    [sym_subset] = STATE(721),
    [sym_subset2] = STATE(721),
    [sym_dollar] = STATE(721),
    [sym_slot] = STATE(721),
    [sym_namespace_get] = STATE(721),
    [sym_namespace_get_internal] = STATE(721),
    [sym_pipe] = STATE(721),
    [sym_unary] = STATE(721),
    [sym_binary] = STATE(721),
    [sym_na] = STATE(721),
    [sym__expression] = STATE(721),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(721),
    [sym_string] = STATE(721),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2143),
    [sym_next] = ACTIONS(2143),
    [sym_true] = ACTIONS(2143),
    [sym_false] = ACTIONS(2143),
    [sym_null] = ACTIONS(2143),
    [sym_inf] = ACTIONS(2143),
    [sym_nan] = ACTIONS(2143),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2141),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [419] = {
    [sym_function_definition] = STATE(720),
    [sym_lambda_function] = STATE(720),
    [sym_if] = STATE(720),
    [sym_while] = STATE(720),
    [sym_repeat] = STATE(720),
    [sym_for] = STATE(720),
    [sym_switch] = STATE(720),
    [sym_call] = STATE(720),
    [sym__assignment] = STATE(720),
    [sym_left_assignment] = STATE(720),
    [sym_left_assignment2] = STATE(720),
    [sym_equals_assignment] = STATE(720),
    [sym_super_assignment] = STATE(720),
    [sym_super_right_assignment] = STATE(720),
    [sym_right_assignment] = STATE(720),
    [sym_brace_list] = STATE(720),
    [sym_paren_list] = STATE(720),
    [sym_subset] = STATE(720),
    [sym_subset2] = STATE(720),
    [sym_dollar] = STATE(720),
    [sym_slot] = STATE(720),
    [sym_namespace_get] = STATE(720),
    [sym_namespace_get_internal] = STATE(720),
    [sym_pipe] = STATE(720),
    [sym_unary] = STATE(720),
    [sym_binary] = STATE(720),
    [sym_na] = STATE(720),
    [sym__expression] = STATE(720),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(720),
    [sym_string] = STATE(720),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2147),
    [sym_next] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_null] = ACTIONS(2147),
    [sym_inf] = ACTIONS(2147),
    [sym_nan] = ACTIONS(2147),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2145),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [420] = {
    [sym_function_definition] = STATE(719),
    [sym_lambda_function] = STATE(719),
    [sym_if] = STATE(719),
    [sym_while] = STATE(719),
    [sym_repeat] = STATE(719),
    [sym_for] = STATE(719),
    [sym_switch] = STATE(719),
    [sym_call] = STATE(719),
    [sym__assignment] = STATE(719),
    [sym_left_assignment] = STATE(719),
    [sym_left_assignment2] = STATE(719),
    [sym_equals_assignment] = STATE(719),
    [sym_super_assignment] = STATE(719),
    [sym_super_right_assignment] = STATE(719),
    [sym_right_assignment] = STATE(719),
    [sym_brace_list] = STATE(719),
    [sym_paren_list] = STATE(719),
    [sym_subset] = STATE(719),
    [sym_subset2] = STATE(719),
    [sym_dollar] = STATE(719),
    [sym_slot] = STATE(719),
    [sym_namespace_get] = STATE(719),
    [sym_namespace_get_internal] = STATE(719),
    [sym_pipe] = STATE(719),
    [sym_unary] = STATE(719),
    [sym_binary] = STATE(719),
    [sym_na] = STATE(719),
    [sym__expression] = STATE(719),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(719),
    [sym_string] = STATE(719),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2151),
    [sym_next] = ACTIONS(2151),
    [sym_true] = ACTIONS(2151),
    [sym_false] = ACTIONS(2151),
    [sym_null] = ACTIONS(2151),
    [sym_inf] = ACTIONS(2151),
    [sym_nan] = ACTIONS(2151),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2149),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [421] = {
    [sym_function_definition] = STATE(718),
    [sym_lambda_function] = STATE(718),
    [sym_if] = STATE(718),
    [sym_while] = STATE(718),
    [sym_repeat] = STATE(718),
    [sym_for] = STATE(718),
    [sym_switch] = STATE(718),
    [sym_call] = STATE(718),
    [sym__assignment] = STATE(718),
    [sym_left_assignment] = STATE(718),
    [sym_left_assignment2] = STATE(718),
    [sym_equals_assignment] = STATE(718),
    [sym_super_assignment] = STATE(718),
    [sym_super_right_assignment] = STATE(718),
    [sym_right_assignment] = STATE(718),
    [sym_brace_list] = STATE(718),
    [sym_paren_list] = STATE(718),
    [sym_subset] = STATE(718),
    [sym_subset2] = STATE(718),
    [sym_dollar] = STATE(718),
    [sym_slot] = STATE(718),
    [sym_namespace_get] = STATE(718),
    [sym_namespace_get_internal] = STATE(718),
    [sym_pipe] = STATE(718),
    [sym_unary] = STATE(718),
    [sym_binary] = STATE(718),
    [sym_na] = STATE(718),
    [sym__expression] = STATE(718),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(718),
    [sym_string] = STATE(718),
    [anon_sym_SEMI] = ACTIONS(2153),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2155),
    [sym_next] = ACTIONS(2155),
    [sym_true] = ACTIONS(2155),
    [sym_false] = ACTIONS(2155),
    [sym_null] = ACTIONS(2155),
    [sym_inf] = ACTIONS(2155),
    [sym_nan] = ACTIONS(2155),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2153),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [422] = {
    [sym_function_definition] = STATE(717),
    [sym_lambda_function] = STATE(717),
    [sym_if] = STATE(717),
    [sym_while] = STATE(717),
    [sym_repeat] = STATE(717),
    [sym_for] = STATE(717),
    [sym_switch] = STATE(717),
    [sym_call] = STATE(717),
    [sym__assignment] = STATE(717),
    [sym_left_assignment] = STATE(717),
    [sym_left_assignment2] = STATE(717),
    [sym_equals_assignment] = STATE(717),
    [sym_super_assignment] = STATE(717),
    [sym_super_right_assignment] = STATE(717),
    [sym_right_assignment] = STATE(717),
    [sym_brace_list] = STATE(717),
    [sym_paren_list] = STATE(717),
    [sym_subset] = STATE(717),
    [sym_subset2] = STATE(717),
    [sym_dollar] = STATE(717),
    [sym_slot] = STATE(717),
    [sym_namespace_get] = STATE(717),
    [sym_namespace_get_internal] = STATE(717),
    [sym_pipe] = STATE(717),
    [sym_unary] = STATE(717),
    [sym_binary] = STATE(717),
    [sym_na] = STATE(717),
    [sym__expression] = STATE(717),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(717),
    [sym_string] = STATE(717),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2159),
    [sym_next] = ACTIONS(2159),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [sym_null] = ACTIONS(2159),
    [sym_inf] = ACTIONS(2159),
    [sym_nan] = ACTIONS(2159),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2157),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [423] = {
    [sym_function_definition] = STATE(447),
    [sym_lambda_function] = STATE(447),
    [sym_if] = STATE(447),
    [sym_while] = STATE(447),
    [sym_repeat] = STATE(447),
    [sym_for] = STATE(447),
    [sym_switch] = STATE(447),
    [sym_call] = STATE(447),
    [sym__assignment] = STATE(447),
    [sym_left_assignment] = STATE(447),
    [sym_left_assignment2] = STATE(447),
    [sym_equals_assignment] = STATE(447),
    [sym_super_assignment] = STATE(447),
    [sym_super_right_assignment] = STATE(447),
    [sym_right_assignment] = STATE(447),
    [sym_brace_list] = STATE(447),
    [sym_paren_list] = STATE(447),
    [sym_subset] = STATE(447),
    [sym_subset2] = STATE(447),
    [sym_dollar] = STATE(447),
    [sym_slot] = STATE(447),
    [sym_namespace_get] = STATE(447),
    [sym_namespace_get_internal] = STATE(447),
    [sym_pipe] = STATE(447),
    [sym_unary] = STATE(447),
    [sym_binary] = STATE(447),
    [sym_na] = STATE(447),
    [sym__expression] = STATE(447),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(447),
    [sym_string] = STATE(447),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2163),
    [sym_next] = ACTIONS(2163),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_inf] = ACTIONS(2163),
    [sym_nan] = ACTIONS(2163),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2161),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [424] = {
    [sym_function_definition] = STATE(446),
    [sym_lambda_function] = STATE(446),
    [sym_if] = STATE(446),
    [sym_while] = STATE(446),
    [sym_repeat] = STATE(446),
    [sym_for] = STATE(446),
    [sym_switch] = STATE(446),
    [sym_call] = STATE(446),
    [sym__assignment] = STATE(446),
    [sym_left_assignment] = STATE(446),
    [sym_left_assignment2] = STATE(446),
    [sym_equals_assignment] = STATE(446),
    [sym_super_assignment] = STATE(446),
    [sym_super_right_assignment] = STATE(446),
    [sym_right_assignment] = STATE(446),
    [sym_brace_list] = STATE(446),
    [sym_paren_list] = STATE(446),
    [sym_subset] = STATE(446),
    [sym_subset2] = STATE(446),
    [sym_dollar] = STATE(446),
    [sym_slot] = STATE(446),
    [sym_namespace_get] = STATE(446),
    [sym_namespace_get_internal] = STATE(446),
    [sym_pipe] = STATE(446),
    [sym_unary] = STATE(446),
    [sym_binary] = STATE(446),
    [sym_na] = STATE(446),
    [sym__expression] = STATE(446),
    [sym_identifier] = STATE(96),
    [sym_complex] = STATE(446),
    [sym_string] = STATE(446),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_repeat] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [sym_dots] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym_break] = ACTIONS(2167),
    [sym_next] = ACTIONS(2167),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_inf] = ACTIONS(2167),
    [sym_nan] = ACTIONS(2167),
    [anon_sym_NA] = ACTIONS(689),
    [anon_sym_NA_character_] = ACTIONS(689),
    [anon_sym_NA_complex_] = ACTIONS(689),
    [anon_sym_NA_integer_] = ACTIONS(689),
    [anon_sym_NA_real_] = ACTIONS(689),
    [aux_sym_identifier_token1] = ACTIONS(691),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_integer] = ACTIONS(2165),
    [sym_float] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(699),
  },
  [425] = {
    [sym_function_definition] = STATE(716),
    [sym_lambda_function] = STATE(716),
    [sym_if] = STATE(716),
    [sym_while] = STATE(716),
    [sym_repeat] = STATE(716),
    [sym_for] = STATE(716),
    [sym_switch] = STATE(716),
    [sym_call] = STATE(716),
    [sym__assignment] = STATE(716),
    [sym_left_assignment] = STATE(716),
    [sym_left_assignment2] = STATE(716),
    [sym_equals_assignment] = STATE(716),
    [sym_super_assignment] = STATE(716),
    [sym_super_right_assignment] = STATE(716),
    [sym_right_assignment] = STATE(716),
    [sym_brace_list] = STATE(716),
    [sym_paren_list] = STATE(716),
    [sym_subset] = STATE(716),
    [sym_subset2] = STATE(716),
    [sym_dollar] = STATE(716),
    [sym_slot] = STATE(716),
    [sym_namespace_get] = STATE(716),
    [sym_namespace_get_internal] = STATE(716),
    [sym_pipe] = STATE(716),
    [sym_unary] = STATE(716),
    [sym_binary] = STATE(716),
    [sym_na] = STATE(716),
    [sym__expression] = STATE(716),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(716),
    [sym_string] = STATE(716),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2171),
    [sym_next] = ACTIONS(2171),
    [sym_true] = ACTIONS(2171),
    [sym_false] = ACTIONS(2171),
    [sym_null] = ACTIONS(2171),
    [sym_inf] = ACTIONS(2171),
    [sym_nan] = ACTIONS(2171),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2169),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [426] = {
    [sym_function_definition] = STATE(715),
    [sym_lambda_function] = STATE(715),
    [sym_if] = STATE(715),
    [sym_while] = STATE(715),
    [sym_repeat] = STATE(715),
    [sym_for] = STATE(715),
    [sym_switch] = STATE(715),
    [sym_call] = STATE(715),
    [sym__assignment] = STATE(715),
    [sym_left_assignment] = STATE(715),
    [sym_left_assignment2] = STATE(715),
    [sym_equals_assignment] = STATE(715),
    [sym_super_assignment] = STATE(715),
    [sym_super_right_assignment] = STATE(715),
    [sym_right_assignment] = STATE(715),
    [sym_brace_list] = STATE(715),
    [sym_paren_list] = STATE(715),
    [sym_subset] = STATE(715),
    [sym_subset2] = STATE(715),
    [sym_dollar] = STATE(715),
    [sym_slot] = STATE(715),
    [sym_namespace_get] = STATE(715),
    [sym_namespace_get_internal] = STATE(715),
    [sym_pipe] = STATE(715),
    [sym_unary] = STATE(715),
    [sym_binary] = STATE(715),
    [sym_na] = STATE(715),
    [sym__expression] = STATE(715),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(715),
    [sym_string] = STATE(715),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2175),
    [sym_next] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_inf] = ACTIONS(2175),
    [sym_nan] = ACTIONS(2175),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2173),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [427] = {
    [sym_function_definition] = STATE(714),
    [sym_lambda_function] = STATE(714),
    [sym_if] = STATE(714),
    [sym_while] = STATE(714),
    [sym_repeat] = STATE(714),
    [sym_for] = STATE(714),
    [sym_switch] = STATE(714),
    [sym_call] = STATE(714),
    [sym__assignment] = STATE(714),
    [sym_left_assignment] = STATE(714),
    [sym_left_assignment2] = STATE(714),
    [sym_equals_assignment] = STATE(714),
    [sym_super_assignment] = STATE(714),
    [sym_super_right_assignment] = STATE(714),
    [sym_right_assignment] = STATE(714),
    [sym_brace_list] = STATE(714),
    [sym_paren_list] = STATE(714),
    [sym_subset] = STATE(714),
    [sym_subset2] = STATE(714),
    [sym_dollar] = STATE(714),
    [sym_slot] = STATE(714),
    [sym_namespace_get] = STATE(714),
    [sym_namespace_get_internal] = STATE(714),
    [sym_pipe] = STATE(714),
    [sym_unary] = STATE(714),
    [sym_binary] = STATE(714),
    [sym_na] = STATE(714),
    [sym__expression] = STATE(714),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(714),
    [sym_string] = STATE(714),
    [anon_sym_SEMI] = ACTIONS(2177),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2179),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2179),
    [sym_next] = ACTIONS(2179),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [sym_null] = ACTIONS(2179),
    [sym_inf] = ACTIONS(2179),
    [sym_nan] = ACTIONS(2179),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2177),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [428] = {
    [sym_function_definition] = STATE(708),
    [sym_lambda_function] = STATE(708),
    [sym_if] = STATE(708),
    [sym_while] = STATE(708),
    [sym_repeat] = STATE(708),
    [sym_for] = STATE(708),
    [sym_switch] = STATE(708),
    [sym_call] = STATE(708),
    [sym__assignment] = STATE(708),
    [sym_left_assignment] = STATE(708),
    [sym_left_assignment2] = STATE(708),
    [sym_equals_assignment] = STATE(708),
    [sym_super_assignment] = STATE(708),
    [sym_super_right_assignment] = STATE(708),
    [sym_right_assignment] = STATE(708),
    [sym_brace_list] = STATE(708),
    [sym_paren_list] = STATE(708),
    [sym_subset] = STATE(708),
    [sym_subset2] = STATE(708),
    [sym_dollar] = STATE(708),
    [sym_slot] = STATE(708),
    [sym_namespace_get] = STATE(708),
    [sym_namespace_get_internal] = STATE(708),
    [sym_pipe] = STATE(708),
    [sym_unary] = STATE(708),
    [sym_binary] = STATE(708),
    [sym_na] = STATE(708),
    [sym__expression] = STATE(708),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(708),
    [sym_string] = STATE(708),
    [anon_sym_SEMI] = ACTIONS(2181),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2183),
    [sym_next] = ACTIONS(2183),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_inf] = ACTIONS(2183),
    [sym_nan] = ACTIONS(2183),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2181),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [429] = {
    [sym_function_definition] = STATE(707),
    [sym_lambda_function] = STATE(707),
    [sym_if] = STATE(707),
    [sym_while] = STATE(707),
    [sym_repeat] = STATE(707),
    [sym_for] = STATE(707),
    [sym_switch] = STATE(707),
    [sym_call] = STATE(707),
    [sym__assignment] = STATE(707),
    [sym_left_assignment] = STATE(707),
    [sym_left_assignment2] = STATE(707),
    [sym_equals_assignment] = STATE(707),
    [sym_super_assignment] = STATE(707),
    [sym_super_right_assignment] = STATE(707),
    [sym_right_assignment] = STATE(707),
    [sym_brace_list] = STATE(707),
    [sym_paren_list] = STATE(707),
    [sym_subset] = STATE(707),
    [sym_subset2] = STATE(707),
    [sym_dollar] = STATE(707),
    [sym_slot] = STATE(707),
    [sym_namespace_get] = STATE(707),
    [sym_namespace_get_internal] = STATE(707),
    [sym_pipe] = STATE(707),
    [sym_unary] = STATE(707),
    [sym_binary] = STATE(707),
    [sym_na] = STATE(707),
    [sym__expression] = STATE(707),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(707),
    [sym_string] = STATE(707),
    [anon_sym_SEMI] = ACTIONS(2185),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2187),
    [sym_next] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_null] = ACTIONS(2187),
    [sym_inf] = ACTIONS(2187),
    [sym_nan] = ACTIONS(2187),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2185),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [430] = {
    [sym_function_definition] = STATE(706),
    [sym_lambda_function] = STATE(706),
    [sym_if] = STATE(706),
    [sym_while] = STATE(706),
    [sym_repeat] = STATE(706),
    [sym_for] = STATE(706),
    [sym_switch] = STATE(706),
    [sym_call] = STATE(706),
    [sym__assignment] = STATE(706),
    [sym_left_assignment] = STATE(706),
    [sym_left_assignment2] = STATE(706),
    [sym_equals_assignment] = STATE(706),
    [sym_super_assignment] = STATE(706),
    [sym_super_right_assignment] = STATE(706),
    [sym_right_assignment] = STATE(706),
    [sym_brace_list] = STATE(706),
    [sym_paren_list] = STATE(706),
    [sym_subset] = STATE(706),
    [sym_subset2] = STATE(706),
    [sym_dollar] = STATE(706),
    [sym_slot] = STATE(706),
    [sym_namespace_get] = STATE(706),
    [sym_namespace_get_internal] = STATE(706),
    [sym_pipe] = STATE(706),
    [sym_unary] = STATE(706),
    [sym_binary] = STATE(706),
    [sym_na] = STATE(706),
    [sym__expression] = STATE(706),
    [sym_identifier] = STATE(432),
    [sym_complex] = STATE(706),
    [sym_string] = STATE(706),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_function] = ACTIONS(49),
    [anon_sym_BSLASH] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_switch] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_dots] = ACTIONS(2191),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_break] = ACTIONS(2191),
    [sym_next] = ACTIONS(2191),
    [sym_true] = ACTIONS(2191),
    [sym_false] = ACTIONS(2191),
    [sym_null] = ACTIONS(2191),
    [sym_inf] = ACTIONS(2191),
    [sym_nan] = ACTIONS(2191),
    [anon_sym_NA] = ACTIONS(81),
    [anon_sym_NA_character_] = ACTIONS(81),
    [anon_sym_NA_complex_] = ACTIONS(81),
    [anon_sym_NA_integer_] = ACTIONS(81),
    [anon_sym_NA_real_] = ACTIONS(81),
    [aux_sym_identifier_token1] = ACTIONS(83),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_integer] = ACTIONS(2189),
    [sym_float] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_SQUOTE] = ACTIONS(91),
  },
  [431] = {
    [anon_sym_LF] = ACTIONS(643),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(643),
    [anon_sym_COLON_EQ] = ACTIONS(643),
    [anon_sym_LT_LT_DASH] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(643),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(2193),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(2195),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(643),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_CARET] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(643),
    [anon_sym_EQ_EQ] = ACTIONS(643),
    [anon_sym_BANG_EQ] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(643),
    [sym_integer] = ACTIONS(643),
    [sym_float] = ACTIONS(643),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(643),
  },
  [432] = {
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(641),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(2197),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(2199),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_integer] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
  },
  [433] = {
    [anon_sym_SEMI] = ACTIONS(2201),
    [anon_sym_function] = ACTIONS(2203),
    [anon_sym_BSLASH] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_LPAREN] = ACTIONS(2201),
    [anon_sym_RPAREN] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_while] = ACTIONS(2203),
    [anon_sym_repeat] = ACTIONS(2203),
    [anon_sym_for] = ACTIONS(2203),
    [anon_sym_switch] = ACTIONS(2203),
    [anon_sym_COMMA] = ACTIONS(2201),
    [anon_sym_EQ] = ACTIONS(2203),
    [anon_sym_LBRACE] = ACTIONS(2201),
    [anon_sym_LT_DASH] = ACTIONS(2201),
    [anon_sym_COLON_EQ] = ACTIONS(2201),
    [anon_sym_LT_LT_DASH] = ACTIONS(2201),
    [anon_sym_DASH_GT_GT] = ACTIONS(2201),
    [anon_sym_DASH_GT] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_RBRACK] = ACTIONS(2201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2201),
    [anon_sym_DOLLAR] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2201),
    [sym_dots] = ACTIONS(2203),
    [anon_sym_PIPE_GT] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_SLASH] = ACTIONS(2201),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2203),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2201),
    [anon_sym_GT_EQ] = ACTIONS(2201),
    [anon_sym_EQ_EQ] = ACTIONS(2201),
    [anon_sym_BANG_EQ] = ACTIONS(2201),
    [anon_sym_PIPE_PIPE] = ACTIONS(2201),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_COLON] = ACTIONS(2203),
    [sym_break] = ACTIONS(2203),
    [sym_next] = ACTIONS(2203),
    [sym_true] = ACTIONS(2203),
    [sym_false] = ACTIONS(2203),
    [sym_null] = ACTIONS(2203),
    [sym_inf] = ACTIONS(2203),
    [sym_nan] = ACTIONS(2203),
    [anon_sym_NA] = ACTIONS(2203),
    [anon_sym_NA_character_] = ACTIONS(2203),
    [anon_sym_NA_complex_] = ACTIONS(2203),
    [anon_sym_NA_integer_] = ACTIONS(2203),
    [anon_sym_NA_real_] = ACTIONS(2203),
    [aux_sym_identifier_token1] = ACTIONS(2203),
    [anon_sym_BQUOTE] = ACTIONS(2201),
    [sym_integer] = ACTIONS(2201),
    [sym_float] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2201),
    [anon_sym_PERCENT] = ACTIONS(2201),
  },
  [434] = {
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2207),
    [anon_sym_BSLASH] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2207),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_else] = ACTIONS(2207),
    [anon_sym_while] = ACTIONS(2207),
    [anon_sym_repeat] = ACTIONS(2207),
    [anon_sym_for] = ACTIONS(2207),
    [anon_sym_switch] = ACTIONS(2207),
    [anon_sym_COMMA] = ACTIONS(2205),
    [anon_sym_EQ] = ACTIONS(2207),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_LT_DASH] = ACTIONS(2205),
    [anon_sym_COLON_EQ] = ACTIONS(2205),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_DASH_GT_GT] = ACTIONS(2205),
    [anon_sym_DASH_GT] = ACTIONS(2207),
    [anon_sym_LBRACK] = ACTIONS(2207),
    [anon_sym_RBRACK] = ACTIONS(2205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [sym_dots] = ACTIONS(2207),
    [anon_sym_PIPE_GT] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_CARET] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_LT_EQ] = ACTIONS(2205),
    [anon_sym_GT_EQ] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2205),
    [anon_sym_BANG_EQ] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2207),
    [anon_sym_COLON] = ACTIONS(2207),
    [sym_break] = ACTIONS(2207),
    [sym_next] = ACTIONS(2207),
    [sym_true] = ACTIONS(2207),
    [sym_false] = ACTIONS(2207),
    [sym_null] = ACTIONS(2207),
    [sym_inf] = ACTIONS(2207),
    [sym_nan] = ACTIONS(2207),
    [anon_sym_NA] = ACTIONS(2207),
    [anon_sym_NA_character_] = ACTIONS(2207),
    [anon_sym_NA_complex_] = ACTIONS(2207),
    [anon_sym_NA_integer_] = ACTIONS(2207),
    [anon_sym_NA_real_] = ACTIONS(2207),
    [aux_sym_identifier_token1] = ACTIONS(2207),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_integer] = ACTIONS(2205),
    [sym_float] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2205),
  },
  [435] = {
    [anon_sym_SEMI] = ACTIONS(2209),
    [anon_sym_function] = ACTIONS(2211),
    [anon_sym_BSLASH] = ACTIONS(2209),
    [anon_sym_if] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(2209),
    [anon_sym_RPAREN] = ACTIONS(2209),
    [anon_sym_else] = ACTIONS(2211),
    [anon_sym_while] = ACTIONS(2211),
    [anon_sym_repeat] = ACTIONS(2211),
    [anon_sym_for] = ACTIONS(2211),
    [anon_sym_switch] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(2209),
    [anon_sym_EQ] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2209),
    [anon_sym_LT_DASH] = ACTIONS(2209),
    [anon_sym_COLON_EQ] = ACTIONS(2209),
    [anon_sym_LT_LT_DASH] = ACTIONS(2209),
    [anon_sym_DASH_GT_GT] = ACTIONS(2209),
    [anon_sym_DASH_GT] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(2209),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2209),
    [anon_sym_DOLLAR] = ACTIONS(2209),
    [anon_sym_AT] = ACTIONS(2209),
    [sym_dots] = ACTIONS(2211),
    [anon_sym_PIPE_GT] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2209),
    [anon_sym_SLASH] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2209),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_LT_EQ] = ACTIONS(2209),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ] = ACTIONS(2209),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_COLON] = ACTIONS(2211),
    [sym_break] = ACTIONS(2211),
    [sym_next] = ACTIONS(2211),
    [sym_true] = ACTIONS(2211),
    [sym_false] = ACTIONS(2211),
    [sym_null] = ACTIONS(2211),
    [sym_inf] = ACTIONS(2211),
    [sym_nan] = ACTIONS(2211),
    [anon_sym_NA] = ACTIONS(2211),
    [anon_sym_NA_character_] = ACTIONS(2211),
    [anon_sym_NA_complex_] = ACTIONS(2211),
    [anon_sym_NA_integer_] = ACTIONS(2211),
    [anon_sym_NA_real_] = ACTIONS(2211),
    [aux_sym_identifier_token1] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2209),
    [sym_integer] = ACTIONS(2209),
    [sym_float] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_PERCENT] = ACTIONS(2209),
  },
  [436] = {
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2215),
    [anon_sym_BSLASH] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_RPAREN] = ACTIONS(2213),
    [anon_sym_else] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2215),
    [anon_sym_repeat] = ACTIONS(2215),
    [anon_sym_for] = ACTIONS(2215),
    [anon_sym_switch] = ACTIONS(2215),
    [anon_sym_COMMA] = ACTIONS(2213),
    [anon_sym_EQ] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_LT_DASH] = ACTIONS(2213),
    [anon_sym_COLON_EQ] = ACTIONS(2213),
    [anon_sym_LT_LT_DASH] = ACTIONS(2213),
    [anon_sym_DASH_GT_GT] = ACTIONS(2213),
    [anon_sym_DASH_GT] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_RBRACK] = ACTIONS(2213),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2213),
    [anon_sym_DOLLAR] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2213),
    [sym_dots] = ACTIONS(2215),
    [anon_sym_PIPE_GT] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2215),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_LT_EQ] = ACTIONS(2213),
    [anon_sym_GT_EQ] = ACTIONS(2213),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2213),
    [anon_sym_PIPE_PIPE] = ACTIONS(2213),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_COLON] = ACTIONS(2215),
    [sym_break] = ACTIONS(2215),
    [sym_next] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_null] = ACTIONS(2215),
    [sym_inf] = ACTIONS(2215),
    [sym_nan] = ACTIONS(2215),
    [anon_sym_NA] = ACTIONS(2215),
    [anon_sym_NA_character_] = ACTIONS(2215),
    [anon_sym_NA_complex_] = ACTIONS(2215),
    [anon_sym_NA_integer_] = ACTIONS(2215),
    [anon_sym_NA_real_] = ACTIONS(2215),
    [aux_sym_identifier_token1] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_integer] = ACTIONS(2213),
    [sym_float] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_PERCENT] = ACTIONS(2213),
  },
  [437] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(1525),
    [anon_sym_BSLASH] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1525),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_repeat] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_COMMA] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1523),
    [anon_sym_COLON_EQ] = ACTIONS(1523),
    [anon_sym_LT_LT_DASH] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT] = ACTIONS(1525),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1525),
    [sym_next] = ACTIONS(1525),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [sym_null] = ACTIONS(1525),
    [sym_inf] = ACTIONS(1525),
    [sym_nan] = ACTIONS(1525),
    [anon_sym_NA] = ACTIONS(1525),
    [anon_sym_NA_character_] = ACTIONS(1525),
    [anon_sym_NA_complex_] = ACTIONS(1525),
    [anon_sym_NA_integer_] = ACTIONS(1525),
    [anon_sym_NA_real_] = ACTIONS(1525),
    [aux_sym_identifier_token1] = ACTIONS(1525),
    [anon_sym_BQUOTE] = ACTIONS(1523),
    [sym_integer] = ACTIONS(1523),
    [sym_float] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1523),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [438] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_BSLASH] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_LT_DASH] = ACTIONS(2255),
    [anon_sym_COLON_EQ] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(2259),
    [anon_sym_DASH_GT_GT] = ACTIONS(2261),
    [anon_sym_DASH_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1485),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1487),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1487),
    [sym_next] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_inf] = ACTIONS(1487),
    [sym_nan] = ACTIONS(1487),
    [anon_sym_NA] = ACTIONS(1487),
    [anon_sym_NA_character_] = ACTIONS(1487),
    [anon_sym_NA_complex_] = ACTIONS(1487),
    [anon_sym_NA_integer_] = ACTIONS(1487),
    [anon_sym_NA_real_] = ACTIONS(1487),
    [aux_sym_identifier_token1] = ACTIONS(1487),
    [anon_sym_BQUOTE] = ACTIONS(1485),
    [sym_integer] = ACTIONS(1485),
    [sym_float] = ACTIONS(1487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1485),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [439] = {
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym_function] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2265),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_LPAREN] = ACTIONS(2265),
    [anon_sym_RPAREN] = ACTIONS(2265),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_repeat] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(2265),
    [anon_sym_EQ] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_LT_DASH] = ACTIONS(2265),
    [anon_sym_COLON_EQ] = ACTIONS(2265),
    [anon_sym_LT_LT_DASH] = ACTIONS(2265),
    [anon_sym_DASH_GT_GT] = ACTIONS(2265),
    [anon_sym_DASH_GT] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_RBRACK] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym_DOLLAR] = ACTIONS(2265),
    [anon_sym_AT] = ACTIONS(2265),
    [sym_dots] = ACTIONS(2267),
    [anon_sym_PIPE_GT] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_SLASH] = ACTIONS(2265),
    [anon_sym_CARET] = ACTIONS(2265),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_GT] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2265),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_EQ_EQ] = ACTIONS(2265),
    [anon_sym_BANG_EQ] = ACTIONS(2265),
    [anon_sym_PIPE_PIPE] = ACTIONS(2265),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_COLON] = ACTIONS(2267),
    [sym_break] = ACTIONS(2267),
    [sym_next] = ACTIONS(2267),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [sym_null] = ACTIONS(2267),
    [sym_inf] = ACTIONS(2267),
    [sym_nan] = ACTIONS(2267),
    [anon_sym_NA] = ACTIONS(2267),
    [anon_sym_NA_character_] = ACTIONS(2267),
    [anon_sym_NA_complex_] = ACTIONS(2267),
    [anon_sym_NA_integer_] = ACTIONS(2267),
    [anon_sym_NA_real_] = ACTIONS(2267),
    [aux_sym_identifier_token1] = ACTIONS(2267),
    [anon_sym_BQUOTE] = ACTIONS(2265),
    [sym_integer] = ACTIONS(2265),
    [sym_float] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_PERCENT] = ACTIONS(2265),
  },
  [440] = {
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym_function] = ACTIONS(2271),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_LPAREN] = ACTIONS(2269),
    [anon_sym_RPAREN] = ACTIONS(2269),
    [anon_sym_else] = ACTIONS(2271),
    [anon_sym_while] = ACTIONS(2271),
    [anon_sym_repeat] = ACTIONS(2271),
    [anon_sym_for] = ACTIONS(2271),
    [anon_sym_switch] = ACTIONS(2271),
    [anon_sym_COMMA] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2271),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_LT_DASH] = ACTIONS(2269),
    [anon_sym_COLON_EQ] = ACTIONS(2269),
    [anon_sym_LT_LT_DASH] = ACTIONS(2269),
    [anon_sym_DASH_GT_GT] = ACTIONS(2269),
    [anon_sym_DASH_GT] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_RBRACK] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym_DOLLAR] = ACTIONS(2269),
    [anon_sym_AT] = ACTIONS(2269),
    [sym_dots] = ACTIONS(2271),
    [anon_sym_PIPE_GT] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2271),
    [anon_sym_PLUS] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2271),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2271),
    [anon_sym_GT] = ACTIONS(2271),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2271),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym_COLON] = ACTIONS(2271),
    [sym_break] = ACTIONS(2271),
    [sym_next] = ACTIONS(2271),
    [sym_true] = ACTIONS(2271),
    [sym_false] = ACTIONS(2271),
    [sym_null] = ACTIONS(2271),
    [sym_inf] = ACTIONS(2271),
    [sym_nan] = ACTIONS(2271),
    [anon_sym_NA] = ACTIONS(2271),
    [anon_sym_NA_character_] = ACTIONS(2271),
    [anon_sym_NA_complex_] = ACTIONS(2271),
    [anon_sym_NA_integer_] = ACTIONS(2271),
    [anon_sym_NA_real_] = ACTIONS(2271),
    [aux_sym_identifier_token1] = ACTIONS(2271),
    [anon_sym_BQUOTE] = ACTIONS(2269),
    [sym_integer] = ACTIONS(2269),
    [sym_float] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2269),
    [anon_sym_SQUOTE] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2269),
  },
  [441] = {
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym_function] = ACTIONS(2275),
    [anon_sym_BSLASH] = ACTIONS(2273),
    [anon_sym_if] = ACTIONS(2275),
    [anon_sym_LPAREN] = ACTIONS(2273),
    [anon_sym_RPAREN] = ACTIONS(2273),
    [anon_sym_else] = ACTIONS(2275),
    [anon_sym_while] = ACTIONS(2275),
    [anon_sym_repeat] = ACTIONS(2275),
    [anon_sym_for] = ACTIONS(2275),
    [anon_sym_switch] = ACTIONS(2275),
    [anon_sym_COMMA] = ACTIONS(2273),
    [anon_sym_EQ] = ACTIONS(2275),
    [anon_sym_LBRACE] = ACTIONS(2273),
    [anon_sym_LT_DASH] = ACTIONS(2273),
    [anon_sym_COLON_EQ] = ACTIONS(2273),
    [anon_sym_LT_LT_DASH] = ACTIONS(2273),
    [anon_sym_DASH_GT_GT] = ACTIONS(2273),
    [anon_sym_DASH_GT] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_RBRACK] = ACTIONS(2273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2273),
    [anon_sym_DOLLAR] = ACTIONS(2273),
    [anon_sym_AT] = ACTIONS(2273),
    [sym_dots] = ACTIONS(2275),
    [anon_sym_PIPE_GT] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2275),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_CARET] = ACTIONS(2273),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_LT_EQ] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2273),
    [anon_sym_EQ_EQ] = ACTIONS(2273),
    [anon_sym_BANG_EQ] = ACTIONS(2273),
    [anon_sym_PIPE_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE] = ACTIONS(2275),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_COLON] = ACTIONS(2275),
    [sym_break] = ACTIONS(2275),
    [sym_next] = ACTIONS(2275),
    [sym_true] = ACTIONS(2275),
    [sym_false] = ACTIONS(2275),
    [sym_null] = ACTIONS(2275),
    [sym_inf] = ACTIONS(2275),
    [sym_nan] = ACTIONS(2275),
    [anon_sym_NA] = ACTIONS(2275),
    [anon_sym_NA_character_] = ACTIONS(2275),
    [anon_sym_NA_complex_] = ACTIONS(2275),
    [anon_sym_NA_integer_] = ACTIONS(2275),
    [anon_sym_NA_real_] = ACTIONS(2275),
    [aux_sym_identifier_token1] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(2273),
    [sym_integer] = ACTIONS(2273),
    [sym_float] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2273),
    [anon_sym_SQUOTE] = ACTIONS(2273),
    [anon_sym_PERCENT] = ACTIONS(2273),
  },
  [442] = {
    [anon_sym_SEMI] = ACTIONS(2277),
    [anon_sym_function] = ACTIONS(2279),
    [anon_sym_BSLASH] = ACTIONS(2277),
    [anon_sym_if] = ACTIONS(2279),
    [anon_sym_LPAREN] = ACTIONS(2277),
    [anon_sym_RPAREN] = ACTIONS(2277),
    [anon_sym_else] = ACTIONS(2279),
    [anon_sym_while] = ACTIONS(2279),
    [anon_sym_repeat] = ACTIONS(2279),
    [anon_sym_for] = ACTIONS(2279),
    [anon_sym_switch] = ACTIONS(2279),
    [anon_sym_COMMA] = ACTIONS(2277),
    [anon_sym_EQ] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(2277),
    [anon_sym_LT_DASH] = ACTIONS(2277),
    [anon_sym_COLON_EQ] = ACTIONS(2277),
    [anon_sym_LT_LT_DASH] = ACTIONS(2277),
    [anon_sym_DASH_GT_GT] = ACTIONS(2277),
    [anon_sym_DASH_GT] = ACTIONS(2279),
    [anon_sym_LBRACK] = ACTIONS(2279),
    [anon_sym_RBRACK] = ACTIONS(2277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2277),
    [anon_sym_DOLLAR] = ACTIONS(2277),
    [anon_sym_AT] = ACTIONS(2277),
    [sym_dots] = ACTIONS(2279),
    [anon_sym_PIPE_GT] = ACTIONS(2277),
    [anon_sym_DASH] = ACTIONS(2279),
    [anon_sym_PLUS] = ACTIONS(2277),
    [anon_sym_BANG] = ACTIONS(2279),
    [anon_sym_TILDE] = ACTIONS(2277),
    [anon_sym_STAR] = ACTIONS(2277),
    [anon_sym_SLASH] = ACTIONS(2277),
    [anon_sym_CARET] = ACTIONS(2277),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_LT_EQ] = ACTIONS(2277),
    [anon_sym_GT_EQ] = ACTIONS(2277),
    [anon_sym_EQ_EQ] = ACTIONS(2277),
    [anon_sym_BANG_EQ] = ACTIONS(2277),
    [anon_sym_PIPE_PIPE] = ACTIONS(2277),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_AMP] = ACTIONS(2279),
    [anon_sym_COLON] = ACTIONS(2279),
    [sym_break] = ACTIONS(2279),
    [sym_next] = ACTIONS(2279),
    [sym_true] = ACTIONS(2279),
    [sym_false] = ACTIONS(2279),
    [sym_null] = ACTIONS(2279),
    [sym_inf] = ACTIONS(2279),
    [sym_nan] = ACTIONS(2279),
    [anon_sym_NA] = ACTIONS(2279),
    [anon_sym_NA_character_] = ACTIONS(2279),
    [anon_sym_NA_complex_] = ACTIONS(2279),
    [anon_sym_NA_integer_] = ACTIONS(2279),
    [anon_sym_NA_real_] = ACTIONS(2279),
    [aux_sym_identifier_token1] = ACTIONS(2279),
    [anon_sym_BQUOTE] = ACTIONS(2277),
    [sym_integer] = ACTIONS(2277),
    [sym_float] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2277),
    [anon_sym_SQUOTE] = ACTIONS(2277),
    [anon_sym_PERCENT] = ACTIONS(2277),
  },
  [443] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(1467),
    [anon_sym_BSLASH] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1467),
    [anon_sym_while] = ACTIONS(1467),
    [anon_sym_repeat] = ACTIONS(1467),
    [anon_sym_for] = ACTIONS(1467),
    [anon_sym_switch] = ACTIONS(1467),
    [anon_sym_COMMA] = ACTIONS(1465),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(1465),
    [anon_sym_LT_DASH] = ACTIONS(2255),
    [anon_sym_COLON_EQ] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(2259),
    [anon_sym_DASH_GT_GT] = ACTIONS(2261),
    [anon_sym_DASH_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1465),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1467),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1467),
    [sym_next] = ACTIONS(1467),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_null] = ACTIONS(1467),
    [sym_inf] = ACTIONS(1467),
    [sym_nan] = ACTIONS(1467),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [aux_sym_identifier_token1] = ACTIONS(1467),
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [sym_integer] = ACTIONS(1465),
    [sym_float] = ACTIONS(1467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_SQUOTE] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [444] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1463),
    [anon_sym_BSLASH] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1463),
    [anon_sym_while] = ACTIONS(1463),
    [anon_sym_repeat] = ACTIONS(1463),
    [anon_sym_for] = ACTIONS(1463),
    [anon_sym_switch] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_LT_DASH] = ACTIONS(2255),
    [anon_sym_COLON_EQ] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(2259),
    [anon_sym_DASH_GT_GT] = ACTIONS(2261),
    [anon_sym_DASH_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1461),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1463),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1463),
    [sym_next] = ACTIONS(1463),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_inf] = ACTIONS(1463),
    [sym_nan] = ACTIONS(1463),
    [anon_sym_NA] = ACTIONS(1463),
    [anon_sym_NA_character_] = ACTIONS(1463),
    [anon_sym_NA_complex_] = ACTIONS(1463),
    [anon_sym_NA_integer_] = ACTIONS(1463),
    [anon_sym_NA_real_] = ACTIONS(1463),
    [aux_sym_identifier_token1] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [sym_integer] = ACTIONS(1461),
    [sym_float] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1461),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [445] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_function] = ACTIONS(1459),
    [anon_sym_BSLASH] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1459),
    [anon_sym_while] = ACTIONS(1459),
    [anon_sym_repeat] = ACTIONS(1459),
    [anon_sym_for] = ACTIONS(1459),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_LT_DASH] = ACTIONS(2255),
    [anon_sym_COLON_EQ] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(2259),
    [anon_sym_DASH_GT_GT] = ACTIONS(2261),
    [anon_sym_DASH_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1457),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1459),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1459),
    [sym_next] = ACTIONS(1459),
    [sym_true] = ACTIONS(1459),
    [sym_false] = ACTIONS(1459),
    [sym_null] = ACTIONS(1459),
    [sym_inf] = ACTIONS(1459),
    [sym_nan] = ACTIONS(1459),
    [anon_sym_NA] = ACTIONS(1459),
    [anon_sym_NA_character_] = ACTIONS(1459),
    [anon_sym_NA_complex_] = ACTIONS(1459),
    [anon_sym_NA_integer_] = ACTIONS(1459),
    [anon_sym_NA_real_] = ACTIONS(1459),
    [aux_sym_identifier_token1] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1457),
    [sym_integer] = ACTIONS(1457),
    [sym_float] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1457),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [446] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_BSLASH] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_repeat] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_LT_DASH] = ACTIONS(2255),
    [anon_sym_COLON_EQ] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(2259),
    [anon_sym_DASH_GT_GT] = ACTIONS(2261),
    [anon_sym_DASH_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1445),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1447),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1447),
    [sym_next] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_inf] = ACTIONS(1447),
    [sym_nan] = ACTIONS(1447),
    [anon_sym_NA] = ACTIONS(1447),
    [anon_sym_NA_character_] = ACTIONS(1447),
    [anon_sym_NA_complex_] = ACTIONS(1447),
    [anon_sym_NA_integer_] = ACTIONS(1447),
    [anon_sym_NA_real_] = ACTIONS(1447),
    [aux_sym_identifier_token1] = ACTIONS(1447),
    [anon_sym_BQUOTE] = ACTIONS(1445),
    [sym_integer] = ACTIONS(1445),
    [sym_float] = ACTIONS(1447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [447] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_function] = ACTIONS(1443),
    [anon_sym_BSLASH] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1443),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_EQ] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_LT_DASH] = ACTIONS(1441),
    [anon_sym_COLON_EQ] = ACTIONS(1441),
    [anon_sym_LT_LT_DASH] = ACTIONS(1441),
    [anon_sym_DASH_GT_GT] = ACTIONS(1441),
    [anon_sym_DASH_GT] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1441),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1443),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1443),
    [sym_next] = ACTIONS(1443),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_inf] = ACTIONS(1443),
    [sym_nan] = ACTIONS(1443),
    [anon_sym_NA] = ACTIONS(1443),
    [anon_sym_NA_character_] = ACTIONS(1443),
    [anon_sym_NA_complex_] = ACTIONS(1443),
    [anon_sym_NA_integer_] = ACTIONS(1443),
    [anon_sym_NA_real_] = ACTIONS(1443),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [anon_sym_BQUOTE] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1441),
    [sym_float] = ACTIONS(1443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1441),
    [anon_sym_SQUOTE] = ACTIONS(1441),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [448] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [449] = {
    [anon_sym_SEMI] = ACTIONS(2281),
    [anon_sym_function] = ACTIONS(2283),
    [anon_sym_BSLASH] = ACTIONS(2281),
    [anon_sym_if] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2281),
    [anon_sym_RPAREN] = ACTIONS(2281),
    [anon_sym_else] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(2283),
    [anon_sym_repeat] = ACTIONS(2283),
    [anon_sym_for] = ACTIONS(2283),
    [anon_sym_switch] = ACTIONS(2283),
    [anon_sym_COMMA] = ACTIONS(2281),
    [anon_sym_EQ] = ACTIONS(2283),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [anon_sym_LT_DASH] = ACTIONS(2281),
    [anon_sym_COLON_EQ] = ACTIONS(2281),
    [anon_sym_LT_LT_DASH] = ACTIONS(2281),
    [anon_sym_DASH_GT_GT] = ACTIONS(2281),
    [anon_sym_DASH_GT] = ACTIONS(2283),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_RBRACK] = ACTIONS(2281),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2281),
    [anon_sym_DOLLAR] = ACTIONS(2281),
    [anon_sym_AT] = ACTIONS(2281),
    [sym_dots] = ACTIONS(2283),
    [anon_sym_PIPE_GT] = ACTIONS(2281),
    [anon_sym_DASH] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(2281),
    [anon_sym_BANG] = ACTIONS(2283),
    [anon_sym_TILDE] = ACTIONS(2281),
    [anon_sym_STAR] = ACTIONS(2281),
    [anon_sym_SLASH] = ACTIONS(2281),
    [anon_sym_CARET] = ACTIONS(2281),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_LT_EQ] = ACTIONS(2281),
    [anon_sym_GT_EQ] = ACTIONS(2281),
    [anon_sym_EQ_EQ] = ACTIONS(2281),
    [anon_sym_BANG_EQ] = ACTIONS(2281),
    [anon_sym_PIPE_PIPE] = ACTIONS(2281),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_AMP_AMP] = ACTIONS(2281),
    [anon_sym_AMP] = ACTIONS(2283),
    [anon_sym_COLON] = ACTIONS(2283),
    [sym_break] = ACTIONS(2283),
    [sym_next] = ACTIONS(2283),
    [sym_true] = ACTIONS(2283),
    [sym_false] = ACTIONS(2283),
    [sym_null] = ACTIONS(2283),
    [sym_inf] = ACTIONS(2283),
    [sym_nan] = ACTIONS(2283),
    [anon_sym_NA] = ACTIONS(2283),
    [anon_sym_NA_character_] = ACTIONS(2283),
    [anon_sym_NA_complex_] = ACTIONS(2283),
    [anon_sym_NA_integer_] = ACTIONS(2283),
    [anon_sym_NA_real_] = ACTIONS(2283),
    [aux_sym_identifier_token1] = ACTIONS(2283),
    [anon_sym_BQUOTE] = ACTIONS(2281),
    [sym_integer] = ACTIONS(2281),
    [sym_float] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2281),
    [anon_sym_SQUOTE] = ACTIONS(2281),
    [anon_sym_PERCENT] = ACTIONS(2281),
  },
  [450] = {
    [anon_sym_SEMI] = ACTIONS(2285),
    [anon_sym_function] = ACTIONS(2287),
    [anon_sym_BSLASH] = ACTIONS(2285),
    [anon_sym_if] = ACTIONS(2287),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_RPAREN] = ACTIONS(2285),
    [anon_sym_else] = ACTIONS(2287),
    [anon_sym_while] = ACTIONS(2287),
    [anon_sym_repeat] = ACTIONS(2287),
    [anon_sym_for] = ACTIONS(2287),
    [anon_sym_switch] = ACTIONS(2287),
    [anon_sym_COMMA] = ACTIONS(2285),
    [anon_sym_EQ] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2285),
    [anon_sym_LT_DASH] = ACTIONS(2285),
    [anon_sym_COLON_EQ] = ACTIONS(2285),
    [anon_sym_LT_LT_DASH] = ACTIONS(2285),
    [anon_sym_DASH_GT_GT] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(2287),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_RBRACK] = ACTIONS(2285),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2285),
    [anon_sym_DOLLAR] = ACTIONS(2285),
    [anon_sym_AT] = ACTIONS(2285),
    [sym_dots] = ACTIONS(2287),
    [anon_sym_PIPE_GT] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2287),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2285),
    [anon_sym_SLASH] = ACTIONS(2285),
    [anon_sym_CARET] = ACTIONS(2285),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_LT_EQ] = ACTIONS(2285),
    [anon_sym_GT_EQ] = ACTIONS(2285),
    [anon_sym_EQ_EQ] = ACTIONS(2285),
    [anon_sym_BANG_EQ] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2285),
    [anon_sym_PIPE] = ACTIONS(2287),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2287),
    [sym_break] = ACTIONS(2287),
    [sym_next] = ACTIONS(2287),
    [sym_true] = ACTIONS(2287),
    [sym_false] = ACTIONS(2287),
    [sym_null] = ACTIONS(2287),
    [sym_inf] = ACTIONS(2287),
    [sym_nan] = ACTIONS(2287),
    [anon_sym_NA] = ACTIONS(2287),
    [anon_sym_NA_character_] = ACTIONS(2287),
    [anon_sym_NA_complex_] = ACTIONS(2287),
    [anon_sym_NA_integer_] = ACTIONS(2287),
    [anon_sym_NA_real_] = ACTIONS(2287),
    [aux_sym_identifier_token1] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2285),
    [sym_integer] = ACTIONS(2285),
    [sym_float] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_PERCENT] = ACTIONS(2285),
  },
  [451] = {
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_function] = ACTIONS(2291),
    [anon_sym_BSLASH] = ACTIONS(2289),
    [anon_sym_if] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(2289),
    [anon_sym_RPAREN] = ACTIONS(2289),
    [anon_sym_else] = ACTIONS(2291),
    [anon_sym_while] = ACTIONS(2291),
    [anon_sym_repeat] = ACTIONS(2291),
    [anon_sym_for] = ACTIONS(2291),
    [anon_sym_switch] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(2289),
    [anon_sym_EQ] = ACTIONS(2291),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_LT_DASH] = ACTIONS(2289),
    [anon_sym_COLON_EQ] = ACTIONS(2289),
    [anon_sym_LT_LT_DASH] = ACTIONS(2289),
    [anon_sym_DASH_GT_GT] = ACTIONS(2289),
    [anon_sym_DASH_GT] = ACTIONS(2291),
    [anon_sym_LBRACK] = ACTIONS(2291),
    [anon_sym_RBRACK] = ACTIONS(2289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2289),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_AT] = ACTIONS(2289),
    [sym_dots] = ACTIONS(2291),
    [anon_sym_PIPE_GT] = ACTIONS(2289),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_BANG] = ACTIONS(2291),
    [anon_sym_TILDE] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_SLASH] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2289),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2289),
    [anon_sym_GT_EQ] = ACTIONS(2289),
    [anon_sym_EQ_EQ] = ACTIONS(2289),
    [anon_sym_BANG_EQ] = ACTIONS(2289),
    [anon_sym_PIPE_PIPE] = ACTIONS(2289),
    [anon_sym_PIPE] = ACTIONS(2291),
    [anon_sym_AMP_AMP] = ACTIONS(2289),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON] = ACTIONS(2291),
    [sym_break] = ACTIONS(2291),
    [sym_next] = ACTIONS(2291),
    [sym_true] = ACTIONS(2291),
    [sym_false] = ACTIONS(2291),
    [sym_null] = ACTIONS(2291),
    [sym_inf] = ACTIONS(2291),
    [sym_nan] = ACTIONS(2291),
    [anon_sym_NA] = ACTIONS(2291),
    [anon_sym_NA_character_] = ACTIONS(2291),
    [anon_sym_NA_complex_] = ACTIONS(2291),
    [anon_sym_NA_integer_] = ACTIONS(2291),
    [anon_sym_NA_real_] = ACTIONS(2291),
    [aux_sym_identifier_token1] = ACTIONS(2291),
    [anon_sym_BQUOTE] = ACTIONS(2289),
    [sym_integer] = ACTIONS(2289),
    [sym_float] = ACTIONS(2291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2289),
    [anon_sym_SQUOTE] = ACTIONS(2289),
    [anon_sym_PERCENT] = ACTIONS(2289),
  },
  [452] = {
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_function] = ACTIONS(2295),
    [anon_sym_BSLASH] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2295),
    [anon_sym_LPAREN] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2295),
    [anon_sym_while] = ACTIONS(2295),
    [anon_sym_repeat] = ACTIONS(2295),
    [anon_sym_for] = ACTIONS(2295),
    [anon_sym_switch] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_LT_DASH] = ACTIONS(2293),
    [anon_sym_COLON_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_DASH] = ACTIONS(2293),
    [anon_sym_DASH_GT_GT] = ACTIONS(2293),
    [anon_sym_DASH_GT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2295),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2293),
    [anon_sym_DOLLAR] = ACTIONS(2293),
    [anon_sym_AT] = ACTIONS(2293),
    [sym_dots] = ACTIONS(2295),
    [anon_sym_PIPE_GT] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_BANG] = ACTIONS(2295),
    [anon_sym_TILDE] = ACTIONS(2293),
    [anon_sym_STAR] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_LT_EQ] = ACTIONS(2293),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2293),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_COLON] = ACTIONS(2295),
    [sym_break] = ACTIONS(2295),
    [sym_next] = ACTIONS(2295),
    [sym_true] = ACTIONS(2295),
    [sym_false] = ACTIONS(2295),
    [sym_null] = ACTIONS(2295),
    [sym_inf] = ACTIONS(2295),
    [sym_nan] = ACTIONS(2295),
    [anon_sym_NA] = ACTIONS(2295),
    [anon_sym_NA_character_] = ACTIONS(2295),
    [anon_sym_NA_complex_] = ACTIONS(2295),
    [anon_sym_NA_integer_] = ACTIONS(2295),
    [anon_sym_NA_real_] = ACTIONS(2295),
    [aux_sym_identifier_token1] = ACTIONS(2295),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_integer] = ACTIONS(2293),
    [sym_float] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [anon_sym_SQUOTE] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
  },
  [453] = {
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_function] = ACTIONS(2299),
    [anon_sym_BSLASH] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2299),
    [anon_sym_LPAREN] = ACTIONS(2297),
    [anon_sym_RPAREN] = ACTIONS(2297),
    [anon_sym_else] = ACTIONS(2299),
    [anon_sym_while] = ACTIONS(2299),
    [anon_sym_repeat] = ACTIONS(2299),
    [anon_sym_for] = ACTIONS(2299),
    [anon_sym_switch] = ACTIONS(2299),
    [anon_sym_COMMA] = ACTIONS(2297),
    [anon_sym_EQ] = ACTIONS(2299),
    [anon_sym_LBRACE] = ACTIONS(2297),
    [anon_sym_LT_DASH] = ACTIONS(2297),
    [anon_sym_COLON_EQ] = ACTIONS(2297),
    [anon_sym_LT_LT_DASH] = ACTIONS(2297),
    [anon_sym_DASH_GT_GT] = ACTIONS(2297),
    [anon_sym_DASH_GT] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(2299),
    [anon_sym_RBRACK] = ACTIONS(2297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2297),
    [anon_sym_DOLLAR] = ACTIONS(2297),
    [anon_sym_AT] = ACTIONS(2297),
    [sym_dots] = ACTIONS(2299),
    [anon_sym_PIPE_GT] = ACTIONS(2297),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_BANG] = ACTIONS(2299),
    [anon_sym_TILDE] = ACTIONS(2297),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_SLASH] = ACTIONS(2297),
    [anon_sym_CARET] = ACTIONS(2297),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_LT_EQ] = ACTIONS(2297),
    [anon_sym_GT_EQ] = ACTIONS(2297),
    [anon_sym_EQ_EQ] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(2297),
    [anon_sym_PIPE_PIPE] = ACTIONS(2297),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_AMP_AMP] = ACTIONS(2297),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_COLON] = ACTIONS(2299),
    [sym_break] = ACTIONS(2299),
    [sym_next] = ACTIONS(2299),
    [sym_true] = ACTIONS(2299),
    [sym_false] = ACTIONS(2299),
    [sym_null] = ACTIONS(2299),
    [sym_inf] = ACTIONS(2299),
    [sym_nan] = ACTIONS(2299),
    [anon_sym_NA] = ACTIONS(2299),
    [anon_sym_NA_character_] = ACTIONS(2299),
    [anon_sym_NA_complex_] = ACTIONS(2299),
    [anon_sym_NA_integer_] = ACTIONS(2299),
    [anon_sym_NA_real_] = ACTIONS(2299),
    [aux_sym_identifier_token1] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2297),
    [sym_integer] = ACTIONS(2297),
    [sym_float] = ACTIONS(2299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2297),
    [anon_sym_SQUOTE] = ACTIONS(2297),
    [anon_sym_PERCENT] = ACTIONS(2297),
  },
  [454] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [455] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [456] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [457] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [458] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [459] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [460] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [461] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [462] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_BSLASH] = ACTIONS(1379),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_repeat] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(1379),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(1379),
    [anon_sym_LT_DASH] = ACTIONS(2255),
    [anon_sym_COLON_EQ] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(2259),
    [anon_sym_DASH_GT_GT] = ACTIONS(2261),
    [anon_sym_DASH_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1379),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1381),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1381),
    [sym_next] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_inf] = ACTIONS(1381),
    [sym_nan] = ACTIONS(1381),
    [anon_sym_NA] = ACTIONS(1381),
    [anon_sym_NA_character_] = ACTIONS(1381),
    [anon_sym_NA_complex_] = ACTIONS(1381),
    [anon_sym_NA_integer_] = ACTIONS(1381),
    [anon_sym_NA_real_] = ACTIONS(1381),
    [aux_sym_identifier_token1] = ACTIONS(1381),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_integer] = ACTIONS(1379),
    [sym_float] = ACTIONS(1381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [463] = {
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_function] = ACTIONS(2303),
    [anon_sym_BSLASH] = ACTIONS(2301),
    [anon_sym_if] = ACTIONS(2303),
    [anon_sym_LPAREN] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_else] = ACTIONS(2303),
    [anon_sym_while] = ACTIONS(2303),
    [anon_sym_repeat] = ACTIONS(2303),
    [anon_sym_for] = ACTIONS(2303),
    [anon_sym_switch] = ACTIONS(2303),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_EQ] = ACTIONS(2303),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_LT_DASH] = ACTIONS(2301),
    [anon_sym_COLON_EQ] = ACTIONS(2301),
    [anon_sym_LT_LT_DASH] = ACTIONS(2301),
    [anon_sym_DASH_GT_GT] = ACTIONS(2301),
    [anon_sym_DASH_GT] = ACTIONS(2303),
    [anon_sym_LBRACK] = ACTIONS(2303),
    [anon_sym_RBRACK] = ACTIONS(2301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2301),
    [anon_sym_DOLLAR] = ACTIONS(2301),
    [anon_sym_AT] = ACTIONS(2301),
    [sym_dots] = ACTIONS(2303),
    [anon_sym_PIPE_GT] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2303),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2301),
    [anon_sym_STAR] = ACTIONS(2301),
    [anon_sym_SLASH] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_EQ_EQ] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_COLON] = ACTIONS(2303),
    [sym_break] = ACTIONS(2303),
    [sym_next] = ACTIONS(2303),
    [sym_true] = ACTIONS(2303),
    [sym_false] = ACTIONS(2303),
    [sym_null] = ACTIONS(2303),
    [sym_inf] = ACTIONS(2303),
    [sym_nan] = ACTIONS(2303),
    [anon_sym_NA] = ACTIONS(2303),
    [anon_sym_NA_character_] = ACTIONS(2303),
    [anon_sym_NA_complex_] = ACTIONS(2303),
    [anon_sym_NA_integer_] = ACTIONS(2303),
    [anon_sym_NA_real_] = ACTIONS(2303),
    [aux_sym_identifier_token1] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [sym_integer] = ACTIONS(2301),
    [sym_float] = ACTIONS(2303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2301),
    [anon_sym_PERCENT] = ACTIONS(2301),
  },
  [464] = {
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_function] = ACTIONS(2307),
    [anon_sym_BSLASH] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_repeat] = ACTIONS(2307),
    [anon_sym_for] = ACTIONS(2307),
    [anon_sym_switch] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_EQ] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_LT_DASH] = ACTIONS(2305),
    [anon_sym_COLON_EQ] = ACTIONS(2305),
    [anon_sym_LT_LT_DASH] = ACTIONS(2305),
    [anon_sym_DASH_GT_GT] = ACTIONS(2305),
    [anon_sym_DASH_GT] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2305),
    [anon_sym_DOLLAR] = ACTIONS(2305),
    [anon_sym_AT] = ACTIONS(2305),
    [sym_dots] = ACTIONS(2307),
    [anon_sym_PIPE_GT] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(2307),
    [anon_sym_TILDE] = ACTIONS(2305),
    [anon_sym_STAR] = ACTIONS(2305),
    [anon_sym_SLASH] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2305),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP_AMP] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_COLON] = ACTIONS(2307),
    [sym_break] = ACTIONS(2307),
    [sym_next] = ACTIONS(2307),
    [sym_true] = ACTIONS(2307),
    [sym_false] = ACTIONS(2307),
    [sym_null] = ACTIONS(2307),
    [sym_inf] = ACTIONS(2307),
    [sym_nan] = ACTIONS(2307),
    [anon_sym_NA] = ACTIONS(2307),
    [anon_sym_NA_character_] = ACTIONS(2307),
    [anon_sym_NA_complex_] = ACTIONS(2307),
    [anon_sym_NA_integer_] = ACTIONS(2307),
    [anon_sym_NA_real_] = ACTIONS(2307),
    [aux_sym_identifier_token1] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2305),
    [sym_integer] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2305),
    [anon_sym_SQUOTE] = ACTIONS(2305),
    [anon_sym_PERCENT] = ACTIONS(2305),
  },
  [465] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(2309),
    [anon_sym_function] = ACTIONS(2311),
    [anon_sym_BSLASH] = ACTIONS(2309),
    [anon_sym_if] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2309),
    [anon_sym_while] = ACTIONS(2311),
    [anon_sym_repeat] = ACTIONS(2311),
    [anon_sym_for] = ACTIONS(2311),
    [anon_sym_switch] = ACTIONS(2311),
    [anon_sym_COMMA] = ACTIONS(2309),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(2309),
    [anon_sym_LT_DASH] = ACTIONS(2317),
    [anon_sym_COLON_EQ] = ACTIONS(2319),
    [anon_sym_LT_LT_DASH] = ACTIONS(2321),
    [anon_sym_DASH_GT_GT] = ACTIONS(2323),
    [anon_sym_DASH_GT] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(2309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(2311),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(2311),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(2311),
    [sym_next] = ACTIONS(2311),
    [sym_true] = ACTIONS(2311),
    [sym_false] = ACTIONS(2311),
    [sym_null] = ACTIONS(2311),
    [sym_inf] = ACTIONS(2311),
    [sym_nan] = ACTIONS(2311),
    [anon_sym_NA] = ACTIONS(2311),
    [anon_sym_NA_character_] = ACTIONS(2311),
    [anon_sym_NA_complex_] = ACTIONS(2311),
    [anon_sym_NA_integer_] = ACTIONS(2311),
    [anon_sym_NA_real_] = ACTIONS(2311),
    [aux_sym_identifier_token1] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2309),
    [sym_integer] = ACTIONS(2309),
    [sym_float] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2309),
    [anon_sym_SQUOTE] = ACTIONS(2309),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [466] = {
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym_function] = ACTIONS(2363),
    [anon_sym_BSLASH] = ACTIONS(2361),
    [anon_sym_if] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(2361),
    [anon_sym_RPAREN] = ACTIONS(2361),
    [anon_sym_else] = ACTIONS(2363),
    [anon_sym_while] = ACTIONS(2363),
    [anon_sym_repeat] = ACTIONS(2363),
    [anon_sym_for] = ACTIONS(2363),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_COMMA] = ACTIONS(2361),
    [anon_sym_EQ] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_DASH] = ACTIONS(2361),
    [anon_sym_COLON_EQ] = ACTIONS(2361),
    [anon_sym_LT_LT_DASH] = ACTIONS(2361),
    [anon_sym_DASH_GT_GT] = ACTIONS(2361),
    [anon_sym_DASH_GT] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_RBRACK] = ACTIONS(2361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2361),
    [anon_sym_DOLLAR] = ACTIONS(2361),
    [anon_sym_AT] = ACTIONS(2361),
    [sym_dots] = ACTIONS(2363),
    [anon_sym_PIPE_GT] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2361),
    [anon_sym_BANG] = ACTIONS(2363),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_CARET] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2363),
    [anon_sym_LT_EQ] = ACTIONS(2361),
    [anon_sym_GT_EQ] = ACTIONS(2361),
    [anon_sym_EQ_EQ] = ACTIONS(2361),
    [anon_sym_BANG_EQ] = ACTIONS(2361),
    [anon_sym_PIPE_PIPE] = ACTIONS(2361),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2363),
    [sym_break] = ACTIONS(2363),
    [sym_next] = ACTIONS(2363),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [sym_null] = ACTIONS(2363),
    [sym_inf] = ACTIONS(2363),
    [sym_nan] = ACTIONS(2363),
    [anon_sym_NA] = ACTIONS(2363),
    [anon_sym_NA_character_] = ACTIONS(2363),
    [anon_sym_NA_complex_] = ACTIONS(2363),
    [anon_sym_NA_integer_] = ACTIONS(2363),
    [anon_sym_NA_real_] = ACTIONS(2363),
    [aux_sym_identifier_token1] = ACTIONS(2363),
    [anon_sym_BQUOTE] = ACTIONS(2361),
    [sym_integer] = ACTIONS(2361),
    [sym_float] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2361),
    [anon_sym_SQUOTE] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
  },
  [467] = {
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym_function] = ACTIONS(2367),
    [anon_sym_BSLASH] = ACTIONS(2365),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2365),
    [anon_sym_RPAREN] = ACTIONS(2365),
    [anon_sym_else] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_repeat] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(2365),
    [anon_sym_EQ] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_LT_DASH] = ACTIONS(2365),
    [anon_sym_COLON_EQ] = ACTIONS(2365),
    [anon_sym_LT_LT_DASH] = ACTIONS(2365),
    [anon_sym_DASH_GT_GT] = ACTIONS(2365),
    [anon_sym_DASH_GT] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_RBRACK] = ACTIONS(2365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2365),
    [anon_sym_DOLLAR] = ACTIONS(2365),
    [anon_sym_AT] = ACTIONS(2365),
    [sym_dots] = ACTIONS(2367),
    [anon_sym_PIPE_GT] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2367),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2365),
    [anon_sym_CARET] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2365),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [anon_sym_EQ_EQ] = ACTIONS(2365),
    [anon_sym_BANG_EQ] = ACTIONS(2365),
    [anon_sym_PIPE_PIPE] = ACTIONS(2365),
    [anon_sym_PIPE] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [sym_break] = ACTIONS(2367),
    [sym_next] = ACTIONS(2367),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [sym_null] = ACTIONS(2367),
    [sym_inf] = ACTIONS(2367),
    [sym_nan] = ACTIONS(2367),
    [anon_sym_NA] = ACTIONS(2367),
    [anon_sym_NA_character_] = ACTIONS(2367),
    [anon_sym_NA_complex_] = ACTIONS(2367),
    [anon_sym_NA_integer_] = ACTIONS(2367),
    [anon_sym_NA_real_] = ACTIONS(2367),
    [aux_sym_identifier_token1] = ACTIONS(2367),
    [anon_sym_BQUOTE] = ACTIONS(2365),
    [sym_integer] = ACTIONS(2365),
    [sym_float] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2365),
    [anon_sym_SQUOTE] = ACTIONS(2365),
    [anon_sym_PERCENT] = ACTIONS(2365),
  },
  [468] = {
    [anon_sym_SEMI] = ACTIONS(2369),
    [anon_sym_function] = ACTIONS(2371),
    [anon_sym_BSLASH] = ACTIONS(2369),
    [anon_sym_if] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2369),
    [anon_sym_RPAREN] = ACTIONS(2369),
    [anon_sym_else] = ACTIONS(2371),
    [anon_sym_while] = ACTIONS(2371),
    [anon_sym_repeat] = ACTIONS(2371),
    [anon_sym_for] = ACTIONS(2371),
    [anon_sym_switch] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(2369),
    [anon_sym_LT_DASH] = ACTIONS(2369),
    [anon_sym_COLON_EQ] = ACTIONS(2369),
    [anon_sym_LT_LT_DASH] = ACTIONS(2369),
    [anon_sym_DASH_GT_GT] = ACTIONS(2369),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2369),
    [anon_sym_DOLLAR] = ACTIONS(2369),
    [anon_sym_AT] = ACTIONS(2369),
    [sym_dots] = ACTIONS(2371),
    [anon_sym_PIPE_GT] = ACTIONS(2369),
    [anon_sym_DASH] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2369),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_SLASH] = ACTIONS(2369),
    [anon_sym_CARET] = ACTIONS(2369),
    [anon_sym_LT] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2369),
    [anon_sym_GT_EQ] = ACTIONS(2369),
    [anon_sym_EQ_EQ] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2369),
    [anon_sym_PIPE_PIPE] = ACTIONS(2369),
    [anon_sym_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2369),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2371),
    [sym_break] = ACTIONS(2371),
    [sym_next] = ACTIONS(2371),
    [sym_true] = ACTIONS(2371),
    [sym_false] = ACTIONS(2371),
    [sym_null] = ACTIONS(2371),
    [sym_inf] = ACTIONS(2371),
    [sym_nan] = ACTIONS(2371),
    [anon_sym_NA] = ACTIONS(2371),
    [anon_sym_NA_character_] = ACTIONS(2371),
    [anon_sym_NA_complex_] = ACTIONS(2371),
    [anon_sym_NA_integer_] = ACTIONS(2371),
    [anon_sym_NA_real_] = ACTIONS(2371),
    [aux_sym_identifier_token1] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2369),
    [sym_integer] = ACTIONS(2369),
    [sym_float] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2369),
    [anon_sym_SQUOTE] = ACTIONS(2369),
    [anon_sym_PERCENT] = ACTIONS(2369),
  },
  [469] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_function] = ACTIONS(893),
    [anon_sym_BSLASH] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_repeat] = ACTIONS(893),
    [anon_sym_for] = ACTIONS(893),
    [anon_sym_switch] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_LT_DASH] = ACTIONS(2255),
    [anon_sym_COLON_EQ] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(2259),
    [anon_sym_DASH_GT_GT] = ACTIONS(2261),
    [anon_sym_DASH_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(891),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(893),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(893),
    [sym_next] = ACTIONS(893),
    [sym_true] = ACTIONS(893),
    [sym_false] = ACTIONS(893),
    [sym_null] = ACTIONS(893),
    [sym_inf] = ACTIONS(893),
    [sym_nan] = ACTIONS(893),
    [anon_sym_NA] = ACTIONS(893),
    [anon_sym_NA_character_] = ACTIONS(893),
    [anon_sym_NA_complex_] = ACTIONS(893),
    [anon_sym_NA_integer_] = ACTIONS(893),
    [anon_sym_NA_real_] = ACTIONS(893),
    [aux_sym_identifier_token1] = ACTIONS(893),
    [anon_sym_BQUOTE] = ACTIONS(891),
    [sym_integer] = ACTIONS(891),
    [sym_float] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [470] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_COMMA] = ACTIONS(1363),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_LT_DASH] = ACTIONS(2255),
    [anon_sym_COLON_EQ] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(2259),
    [anon_sym_DASH_GT_GT] = ACTIONS(2261),
    [anon_sym_DASH_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1363),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1365),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [aux_sym_identifier_token1] = ACTIONS(1365),
    [anon_sym_BQUOTE] = ACTIONS(1363),
    [sym_integer] = ACTIONS(1363),
    [sym_float] = ACTIONS(1365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [471] = {
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_function] = ACTIONS(2377),
    [anon_sym_BSLASH] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2375),
    [anon_sym_RPAREN] = ACTIONS(2375),
    [anon_sym_else] = ACTIONS(2377),
    [anon_sym_while] = ACTIONS(2377),
    [anon_sym_repeat] = ACTIONS(2377),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_switch] = ACTIONS(2377),
    [anon_sym_COMMA] = ACTIONS(2375),
    [anon_sym_EQ] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2375),
    [anon_sym_LT_DASH] = ACTIONS(2375),
    [anon_sym_COLON_EQ] = ACTIONS(2375),
    [anon_sym_LT_LT_DASH] = ACTIONS(2375),
    [anon_sym_DASH_GT_GT] = ACTIONS(2375),
    [anon_sym_DASH_GT] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2377),
    [anon_sym_RBRACK] = ACTIONS(2375),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2375),
    [anon_sym_DOLLAR] = ACTIONS(2375),
    [anon_sym_AT] = ACTIONS(2375),
    [sym_dots] = ACTIONS(2377),
    [anon_sym_PIPE_GT] = ACTIONS(2375),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2375),
    [anon_sym_BANG] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2375),
    [anon_sym_STAR] = ACTIONS(2375),
    [anon_sym_SLASH] = ACTIONS(2375),
    [anon_sym_CARET] = ACTIONS(2375),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2375),
    [anon_sym_GT_EQ] = ACTIONS(2375),
    [anon_sym_EQ_EQ] = ACTIONS(2375),
    [anon_sym_BANG_EQ] = ACTIONS(2375),
    [anon_sym_PIPE_PIPE] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2375),
    [anon_sym_AMP] = ACTIONS(2377),
    [anon_sym_COLON] = ACTIONS(2377),
    [sym_break] = ACTIONS(2377),
    [sym_next] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_null] = ACTIONS(2377),
    [sym_inf] = ACTIONS(2377),
    [sym_nan] = ACTIONS(2377),
    [anon_sym_NA] = ACTIONS(2377),
    [anon_sym_NA_character_] = ACTIONS(2377),
    [anon_sym_NA_complex_] = ACTIONS(2377),
    [anon_sym_NA_integer_] = ACTIONS(2377),
    [anon_sym_NA_real_] = ACTIONS(2377),
    [aux_sym_identifier_token1] = ACTIONS(2377),
    [anon_sym_BQUOTE] = ACTIONS(2375),
    [sym_integer] = ACTIONS(2375),
    [sym_float] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2375),
    [anon_sym_SQUOTE] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2375),
  },
  [472] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_COMMA] = ACTIONS(1359),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(2255),
    [anon_sym_COLON_EQ] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(2259),
    [anon_sym_DASH_GT_GT] = ACTIONS(2261),
    [anon_sym_DASH_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1359),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1361),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [aux_sym_identifier_token1] = ACTIONS(1361),
    [anon_sym_BQUOTE] = ACTIONS(1359),
    [sym_integer] = ACTIONS(1359),
    [sym_float] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [473] = {
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_BSLASH] = ACTIONS(2379),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2379),
    [anon_sym_RPAREN] = ACTIONS(2379),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_repeat] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_COMMA] = ACTIONS(2379),
    [anon_sym_EQ] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_DASH] = ACTIONS(2379),
    [anon_sym_COLON_EQ] = ACTIONS(2379),
    [anon_sym_LT_LT_DASH] = ACTIONS(2379),
    [anon_sym_DASH_GT_GT] = ACTIONS(2379),
    [anon_sym_DASH_GT] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_RBRACK] = ACTIONS(2379),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2379),
    [anon_sym_DOLLAR] = ACTIONS(2379),
    [anon_sym_AT] = ACTIONS(2379),
    [sym_dots] = ACTIONS(2381),
    [anon_sym_PIPE_GT] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2379),
    [anon_sym_STAR] = ACTIONS(2379),
    [anon_sym_SLASH] = ACTIONS(2379),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_GT] = ACTIONS(2381),
    [anon_sym_LT_EQ] = ACTIONS(2379),
    [anon_sym_GT_EQ] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2379),
    [anon_sym_BANG_EQ] = ACTIONS(2379),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_PIPE] = ACTIONS(2381),
    [anon_sym_AMP_AMP] = ACTIONS(2379),
    [anon_sym_AMP] = ACTIONS(2381),
    [anon_sym_COLON] = ACTIONS(2381),
    [sym_break] = ACTIONS(2381),
    [sym_next] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_inf] = ACTIONS(2381),
    [sym_nan] = ACTIONS(2381),
    [anon_sym_NA] = ACTIONS(2381),
    [anon_sym_NA_character_] = ACTIONS(2381),
    [anon_sym_NA_complex_] = ACTIONS(2381),
    [anon_sym_NA_integer_] = ACTIONS(2381),
    [anon_sym_NA_real_] = ACTIONS(2381),
    [aux_sym_identifier_token1] = ACTIONS(2381),
    [anon_sym_BQUOTE] = ACTIONS(2379),
    [sym_integer] = ACTIONS(2379),
    [sym_float] = ACTIONS(2381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2379),
    [anon_sym_SQUOTE] = ACTIONS(2379),
    [anon_sym_PERCENT] = ACTIONS(2379),
  },
  [474] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2129),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [475] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2129),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [476] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2129),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2131),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2129),
    [anon_sym_GT_EQ] = ACTIONS(2129),
    [anon_sym_EQ_EQ] = ACTIONS(2129),
    [anon_sym_BANG_EQ] = ACTIONS(2129),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2131),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(2129),
  },
  [477] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2123),
    [anon_sym_BSLASH] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2123),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(2123),
    [anon_sym_while] = ACTIONS(2123),
    [anon_sym_repeat] = ACTIONS(2123),
    [anon_sym_for] = ACTIONS(2123),
    [anon_sym_switch] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2121),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_LT_DASH] = ACTIONS(2255),
    [anon_sym_COLON_EQ] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(2259),
    [anon_sym_DASH_GT_GT] = ACTIONS(2261),
    [anon_sym_DASH_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2121),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(2123),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(2123),
    [sym_next] = ACTIONS(2123),
    [sym_true] = ACTIONS(2123),
    [sym_false] = ACTIONS(2123),
    [sym_null] = ACTIONS(2123),
    [sym_inf] = ACTIONS(2123),
    [sym_nan] = ACTIONS(2123),
    [anon_sym_NA] = ACTIONS(2123),
    [anon_sym_NA_character_] = ACTIONS(2123),
    [anon_sym_NA_complex_] = ACTIONS(2123),
    [anon_sym_NA_integer_] = ACTIONS(2123),
    [anon_sym_NA_real_] = ACTIONS(2123),
    [aux_sym_identifier_token1] = ACTIONS(2123),
    [anon_sym_BQUOTE] = ACTIONS(2121),
    [sym_integer] = ACTIONS(2121),
    [sym_float] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2121),
    [anon_sym_SQUOTE] = ACTIONS(2121),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [478] = {
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_else] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(641),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_integer] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [anon_sym_i] = ACTIONS(2383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
  },
  [479] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1361),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(1361),
    [anon_sym_RBRACE] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(2389),
    [anon_sym_COLON_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2393),
    [anon_sym_DASH_GT_GT] = ACTIONS(2395),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1361),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [aux_sym_identifier_token1] = ACTIONS(1361),
    [anon_sym_BQUOTE] = ACTIONS(1361),
    [sym_integer] = ACTIONS(1361),
    [sym_float] = ACTIONS(1361),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [480] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1365),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_RBRACE] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(2389),
    [anon_sym_COLON_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2393),
    [anon_sym_DASH_GT_GT] = ACTIONS(2395),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1365),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [aux_sym_identifier_token1] = ACTIONS(1365),
    [anon_sym_BQUOTE] = ACTIONS(1365),
    [sym_integer] = ACTIONS(1365),
    [sym_float] = ACTIONS(1365),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [481] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_BSLASH] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_repeat] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_RBRACE] = ACTIONS(1381),
    [anon_sym_LT_DASH] = ACTIONS(2389),
    [anon_sym_COLON_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2393),
    [anon_sym_DASH_GT_GT] = ACTIONS(2395),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1381),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1381),
    [sym_next] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_inf] = ACTIONS(1381),
    [sym_nan] = ACTIONS(1381),
    [anon_sym_NA] = ACTIONS(1381),
    [anon_sym_NA_character_] = ACTIONS(1381),
    [anon_sym_NA_complex_] = ACTIONS(1381),
    [anon_sym_NA_integer_] = ACTIONS(1381),
    [anon_sym_NA_real_] = ACTIONS(1381),
    [aux_sym_identifier_token1] = ACTIONS(1381),
    [anon_sym_BQUOTE] = ACTIONS(1381),
    [sym_integer] = ACTIONS(1381),
    [sym_float] = ACTIONS(1381),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1381),
    [anon_sym_SQUOTE] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [482] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(891),
    [anon_sym_LF] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(893),
    [anon_sym_BSLASH] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(2429),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_repeat] = ACTIONS(893),
    [anon_sym_for] = ACTIONS(893),
    [anon_sym_switch] = ACTIONS(893),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(2437),
    [anon_sym_DASH_GT_GT] = ACTIONS(2439),
    [anon_sym_DASH_GT] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(893),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(893),
    [sym_next] = ACTIONS(893),
    [sym_true] = ACTIONS(893),
    [sym_false] = ACTIONS(893),
    [sym_null] = ACTIONS(893),
    [sym_inf] = ACTIONS(893),
    [sym_nan] = ACTIONS(893),
    [anon_sym_NA] = ACTIONS(893),
    [anon_sym_NA_character_] = ACTIONS(893),
    [anon_sym_NA_complex_] = ACTIONS(893),
    [anon_sym_NA_integer_] = ACTIONS(893),
    [anon_sym_NA_real_] = ACTIONS(893),
    [aux_sym_identifier_token1] = ACTIONS(893),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_integer] = ACTIONS(893),
    [sym_float] = ACTIONS(893),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(893),
    [anon_sym_SQUOTE] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [483] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(2123),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_function] = ACTIONS(2123),
    [anon_sym_BSLASH] = ACTIONS(2123),
    [anon_sym_if] = ACTIONS(2123),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(2123),
    [anon_sym_while] = ACTIONS(2123),
    [anon_sym_repeat] = ACTIONS(2123),
    [anon_sym_for] = ACTIONS(2123),
    [anon_sym_switch] = ACTIONS(2123),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_LT_DASH] = ACTIONS(2389),
    [anon_sym_COLON_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2393),
    [anon_sym_DASH_GT_GT] = ACTIONS(2395),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(2123),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(2123),
    [sym_next] = ACTIONS(2123),
    [sym_true] = ACTIONS(2123),
    [sym_false] = ACTIONS(2123),
    [sym_null] = ACTIONS(2123),
    [sym_inf] = ACTIONS(2123),
    [sym_nan] = ACTIONS(2123),
    [anon_sym_NA] = ACTIONS(2123),
    [anon_sym_NA_character_] = ACTIONS(2123),
    [anon_sym_NA_complex_] = ACTIONS(2123),
    [anon_sym_NA_integer_] = ACTIONS(2123),
    [anon_sym_NA_real_] = ACTIONS(2123),
    [aux_sym_identifier_token1] = ACTIONS(2123),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_integer] = ACTIONS(2123),
    [sym_float] = ACTIONS(2123),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [484] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [485] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2131),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2131),
    [anon_sym_SLASH] = ACTIONS(2131),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2131),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2131),
    [anon_sym_GT_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ] = ACTIONS(2131),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2131),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2131),
  },
  [486] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [487] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [488] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [489] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [490] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [491] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [492] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [493] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [494] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [495] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [496] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(893),
    [anon_sym_BSLASH] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_repeat] = ACTIONS(893),
    [anon_sym_for] = ACTIONS(893),
    [anon_sym_switch] = ACTIONS(893),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_LT_DASH] = ACTIONS(2389),
    [anon_sym_COLON_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2393),
    [anon_sym_DASH_GT_GT] = ACTIONS(2395),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(893),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(893),
    [sym_next] = ACTIONS(893),
    [sym_true] = ACTIONS(893),
    [sym_false] = ACTIONS(893),
    [sym_null] = ACTIONS(893),
    [sym_inf] = ACTIONS(893),
    [sym_nan] = ACTIONS(893),
    [anon_sym_NA] = ACTIONS(893),
    [anon_sym_NA_character_] = ACTIONS(893),
    [anon_sym_NA_complex_] = ACTIONS(893),
    [anon_sym_NA_integer_] = ACTIONS(893),
    [anon_sym_NA_real_] = ACTIONS(893),
    [aux_sym_identifier_token1] = ACTIONS(893),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_integer] = ACTIONS(893),
    [sym_float] = ACTIONS(893),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(893),
    [anon_sym_SQUOTE] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [497] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1443),
    [anon_sym_function] = ACTIONS(1443),
    [anon_sym_BSLASH] = ACTIONS(1443),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1443),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1443),
    [anon_sym_RBRACE] = ACTIONS(1443),
    [anon_sym_LT_DASH] = ACTIONS(1443),
    [anon_sym_COLON_EQ] = ACTIONS(1443),
    [anon_sym_LT_LT_DASH] = ACTIONS(1443),
    [anon_sym_DASH_GT_GT] = ACTIONS(1443),
    [anon_sym_DASH_GT] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1443),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1443),
    [sym_next] = ACTIONS(1443),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_inf] = ACTIONS(1443),
    [sym_nan] = ACTIONS(1443),
    [anon_sym_NA] = ACTIONS(1443),
    [anon_sym_NA_character_] = ACTIONS(1443),
    [anon_sym_NA_complex_] = ACTIONS(1443),
    [anon_sym_NA_integer_] = ACTIONS(1443),
    [anon_sym_NA_real_] = ACTIONS(1443),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [anon_sym_BQUOTE] = ACTIONS(1443),
    [sym_integer] = ACTIONS(1443),
    [sym_float] = ACTIONS(1443),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1443),
    [anon_sym_SQUOTE] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [498] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_BSLASH] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_repeat] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_RBRACE] = ACTIONS(1447),
    [anon_sym_LT_DASH] = ACTIONS(2389),
    [anon_sym_COLON_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2393),
    [anon_sym_DASH_GT_GT] = ACTIONS(2395),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1447),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1447),
    [sym_next] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_inf] = ACTIONS(1447),
    [sym_nan] = ACTIONS(1447),
    [anon_sym_NA] = ACTIONS(1447),
    [anon_sym_NA_character_] = ACTIONS(1447),
    [anon_sym_NA_complex_] = ACTIONS(1447),
    [anon_sym_NA_integer_] = ACTIONS(1447),
    [anon_sym_NA_real_] = ACTIONS(1447),
    [aux_sym_identifier_token1] = ACTIONS(1447),
    [anon_sym_BQUOTE] = ACTIONS(1447),
    [sym_integer] = ACTIONS(1447),
    [sym_float] = ACTIONS(1447),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1447),
    [anon_sym_SQUOTE] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [499] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_function] = ACTIONS(1459),
    [anon_sym_BSLASH] = ACTIONS(1459),
    [anon_sym_if] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1459),
    [anon_sym_while] = ACTIONS(1459),
    [anon_sym_repeat] = ACTIONS(1459),
    [anon_sym_for] = ACTIONS(1459),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_LT_DASH] = ACTIONS(2389),
    [anon_sym_COLON_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2393),
    [anon_sym_DASH_GT_GT] = ACTIONS(2395),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1459),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1459),
    [sym_next] = ACTIONS(1459),
    [sym_true] = ACTIONS(1459),
    [sym_false] = ACTIONS(1459),
    [sym_null] = ACTIONS(1459),
    [sym_inf] = ACTIONS(1459),
    [sym_nan] = ACTIONS(1459),
    [anon_sym_NA] = ACTIONS(1459),
    [anon_sym_NA_character_] = ACTIONS(1459),
    [anon_sym_NA_complex_] = ACTIONS(1459),
    [anon_sym_NA_integer_] = ACTIONS(1459),
    [anon_sym_NA_real_] = ACTIONS(1459),
    [aux_sym_identifier_token1] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_integer] = ACTIONS(1459),
    [sym_float] = ACTIONS(1459),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [500] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_function] = ACTIONS(1463),
    [anon_sym_BSLASH] = ACTIONS(1463),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1463),
    [anon_sym_while] = ACTIONS(1463),
    [anon_sym_repeat] = ACTIONS(1463),
    [anon_sym_for] = ACTIONS(1463),
    [anon_sym_switch] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1463),
    [anon_sym_LT_DASH] = ACTIONS(2389),
    [anon_sym_COLON_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2393),
    [anon_sym_DASH_GT_GT] = ACTIONS(2395),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1463),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1463),
    [sym_next] = ACTIONS(1463),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_inf] = ACTIONS(1463),
    [sym_nan] = ACTIONS(1463),
    [anon_sym_NA] = ACTIONS(1463),
    [anon_sym_NA_character_] = ACTIONS(1463),
    [anon_sym_NA_complex_] = ACTIONS(1463),
    [anon_sym_NA_integer_] = ACTIONS(1463),
    [anon_sym_NA_real_] = ACTIONS(1463),
    [aux_sym_identifier_token1] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [sym_integer] = ACTIONS(1463),
    [sym_float] = ACTIONS(1463),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [501] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1467),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_function] = ACTIONS(1467),
    [anon_sym_BSLASH] = ACTIONS(1467),
    [anon_sym_if] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1467),
    [anon_sym_while] = ACTIONS(1467),
    [anon_sym_repeat] = ACTIONS(1467),
    [anon_sym_for] = ACTIONS(1467),
    [anon_sym_switch] = ACTIONS(1467),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [anon_sym_RBRACE] = ACTIONS(1467),
    [anon_sym_LT_DASH] = ACTIONS(2389),
    [anon_sym_COLON_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2393),
    [anon_sym_DASH_GT_GT] = ACTIONS(2395),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1467),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1467),
    [sym_next] = ACTIONS(1467),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_null] = ACTIONS(1467),
    [sym_inf] = ACTIONS(1467),
    [sym_nan] = ACTIONS(1467),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [aux_sym_identifier_token1] = ACTIONS(1467),
    [anon_sym_BQUOTE] = ACTIONS(1467),
    [sym_integer] = ACTIONS(1467),
    [sym_float] = ACTIONS(1467),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1467),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [502] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(2129),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [503] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(2129),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [504] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(2129),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2131),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2131),
    [anon_sym_SLASH] = ACTIONS(2131),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2131),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2131),
    [anon_sym_GT_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ] = ACTIONS(2131),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2131),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2131),
  },
  [505] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_BSLASH] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_LT_DASH] = ACTIONS(2389),
    [anon_sym_COLON_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2393),
    [anon_sym_DASH_GT_GT] = ACTIONS(2395),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1487),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1487),
    [sym_next] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_inf] = ACTIONS(1487),
    [sym_nan] = ACTIONS(1487),
    [anon_sym_NA] = ACTIONS(1487),
    [anon_sym_NA_character_] = ACTIONS(1487),
    [anon_sym_NA_complex_] = ACTIONS(1487),
    [anon_sym_NA_integer_] = ACTIONS(1487),
    [anon_sym_NA_real_] = ACTIONS(1487),
    [aux_sym_identifier_token1] = ACTIONS(1487),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [sym_integer] = ACTIONS(1487),
    [sym_float] = ACTIONS(1487),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1487),
    [anon_sym_SQUOTE] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [506] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1523),
    [anon_sym_LF] = ACTIONS(1525),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1525),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1525),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_repeat] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_EQ] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1525),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1525),
    [sym_next] = ACTIONS(1525),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [sym_null] = ACTIONS(1525),
    [sym_inf] = ACTIONS(1525),
    [sym_nan] = ACTIONS(1525),
    [anon_sym_NA] = ACTIONS(1525),
    [anon_sym_NA_character_] = ACTIONS(1525),
    [anon_sym_NA_complex_] = ACTIONS(1525),
    [anon_sym_NA_integer_] = ACTIONS(1525),
    [anon_sym_NA_real_] = ACTIONS(1525),
    [aux_sym_identifier_token1] = ACTIONS(1525),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [sym_integer] = ACTIONS(1525),
    [sym_float] = ACTIONS(1525),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [507] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1519),
    [anon_sym_LF] = ACTIONS(1521),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1521),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1521),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_repeat] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1521),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1521),
    [sym_next] = ACTIONS(1521),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [sym_null] = ACTIONS(1521),
    [sym_inf] = ACTIONS(1521),
    [sym_nan] = ACTIONS(1521),
    [anon_sym_NA] = ACTIONS(1521),
    [anon_sym_NA_character_] = ACTIONS(1521),
    [anon_sym_NA_complex_] = ACTIONS(1521),
    [anon_sym_NA_integer_] = ACTIONS(1521),
    [anon_sym_NA_real_] = ACTIONS(1521),
    [aux_sym_identifier_token1] = ACTIONS(1521),
    [anon_sym_BQUOTE] = ACTIONS(1521),
    [sym_integer] = ACTIONS(1521),
    [sym_float] = ACTIONS(1521),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [508] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(891),
    [anon_sym_LF] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(893),
    [anon_sym_BSLASH] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(2471),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_repeat] = ACTIONS(893),
    [anon_sym_for] = ACTIONS(893),
    [anon_sym_switch] = ACTIONS(893),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(2437),
    [anon_sym_DASH_GT_GT] = ACTIONS(2439),
    [anon_sym_DASH_GT] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(893),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(893),
    [sym_next] = ACTIONS(893),
    [sym_true] = ACTIONS(893),
    [sym_false] = ACTIONS(893),
    [sym_null] = ACTIONS(893),
    [sym_inf] = ACTIONS(893),
    [sym_nan] = ACTIONS(893),
    [anon_sym_NA] = ACTIONS(893),
    [anon_sym_NA_character_] = ACTIONS(893),
    [anon_sym_NA_complex_] = ACTIONS(893),
    [anon_sym_NA_integer_] = ACTIONS(893),
    [anon_sym_NA_real_] = ACTIONS(893),
    [aux_sym_identifier_token1] = ACTIONS(893),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_integer] = ACTIONS(893),
    [sym_float] = ACTIONS(893),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(893),
    [anon_sym_SQUOTE] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [509] = {
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_function] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(657),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_while] = ACTIONS(659),
    [anon_sym_repeat] = ACTIONS(659),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(659),
    [anon_sym_COMMA] = ACTIONS(657),
    [anon_sym_EQ] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_LT_DASH] = ACTIONS(657),
    [anon_sym_COLON_EQ] = ACTIONS(657),
    [anon_sym_LT_LT_DASH] = ACTIONS(657),
    [anon_sym_DASH_GT_GT] = ACTIONS(657),
    [anon_sym_DASH_GT] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(657),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(657),
    [anon_sym_AT] = ACTIONS(657),
    [anon_sym_COLON_COLON] = ACTIONS(659),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(657),
    [sym_dots] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(657),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(657),
    [anon_sym_BANG] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_SLASH] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_LT] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_LT_EQ] = ACTIONS(657),
    [anon_sym_GT_EQ] = ACTIONS(657),
    [anon_sym_EQ_EQ] = ACTIONS(657),
    [anon_sym_BANG_EQ] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(659),
    [sym_break] = ACTIONS(659),
    [sym_next] = ACTIONS(659),
    [sym_true] = ACTIONS(659),
    [sym_false] = ACTIONS(659),
    [sym_null] = ACTIONS(659),
    [sym_inf] = ACTIONS(659),
    [sym_nan] = ACTIONS(659),
    [anon_sym_NA] = ACTIONS(659),
    [anon_sym_NA_character_] = ACTIONS(659),
    [anon_sym_NA_complex_] = ACTIONS(659),
    [anon_sym_NA_integer_] = ACTIONS(659),
    [anon_sym_NA_real_] = ACTIONS(659),
    [aux_sym_identifier_token1] = ACTIONS(659),
    [anon_sym_BQUOTE] = ACTIONS(657),
    [sym_integer] = ACTIONS(657),
    [sym_float] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_PERCENT] = ACTIONS(657),
  },
  [510] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(2121),
    [anon_sym_LF] = ACTIONS(2123),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_function] = ACTIONS(2123),
    [anon_sym_BSLASH] = ACTIONS(2123),
    [anon_sym_if] = ACTIONS(2123),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(2123),
    [anon_sym_while] = ACTIONS(2123),
    [anon_sym_repeat] = ACTIONS(2123),
    [anon_sym_for] = ACTIONS(2123),
    [anon_sym_switch] = ACTIONS(2123),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(2437),
    [anon_sym_DASH_GT_GT] = ACTIONS(2439),
    [anon_sym_DASH_GT] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(2123),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(2123),
    [sym_next] = ACTIONS(2123),
    [sym_true] = ACTIONS(2123),
    [sym_false] = ACTIONS(2123),
    [sym_null] = ACTIONS(2123),
    [sym_inf] = ACTIONS(2123),
    [sym_nan] = ACTIONS(2123),
    [anon_sym_NA] = ACTIONS(2123),
    [anon_sym_NA_character_] = ACTIONS(2123),
    [anon_sym_NA_complex_] = ACTIONS(2123),
    [anon_sym_NA_integer_] = ACTIONS(2123),
    [anon_sym_NA_real_] = ACTIONS(2123),
    [aux_sym_identifier_token1] = ACTIONS(2123),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_integer] = ACTIONS(2123),
    [sym_float] = ACTIONS(2123),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [511] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(2473),
    [anon_sym_function] = ACTIONS(2475),
    [anon_sym_BSLASH] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2475),
    [anon_sym_repeat] = ACTIONS(2475),
    [anon_sym_for] = ACTIONS(2475),
    [anon_sym_switch] = ACTIONS(2475),
    [anon_sym_COMMA] = ACTIONS(2473),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LT_DASH] = ACTIONS(2317),
    [anon_sym_COLON_EQ] = ACTIONS(2319),
    [anon_sym_LT_LT_DASH] = ACTIONS(2321),
    [anon_sym_DASH_GT_GT] = ACTIONS(2323),
    [anon_sym_DASH_GT] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(2473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(2475),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(2475),
    [sym_next] = ACTIONS(2475),
    [sym_true] = ACTIONS(2475),
    [sym_false] = ACTIONS(2475),
    [sym_null] = ACTIONS(2475),
    [sym_inf] = ACTIONS(2475),
    [sym_nan] = ACTIONS(2475),
    [anon_sym_NA] = ACTIONS(2475),
    [anon_sym_NA_character_] = ACTIONS(2475),
    [anon_sym_NA_complex_] = ACTIONS(2475),
    [anon_sym_NA_integer_] = ACTIONS(2475),
    [anon_sym_NA_real_] = ACTIONS(2475),
    [aux_sym_identifier_token1] = ACTIONS(2475),
    [anon_sym_BQUOTE] = ACTIONS(2473),
    [sym_integer] = ACTIONS(2473),
    [sym_float] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(2473),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [512] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1521),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1521),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1521),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_repeat] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1521),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1521),
    [sym_next] = ACTIONS(1521),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [sym_null] = ACTIONS(1521),
    [sym_inf] = ACTIONS(1521),
    [sym_nan] = ACTIONS(1521),
    [anon_sym_NA] = ACTIONS(1521),
    [anon_sym_NA_character_] = ACTIONS(1521),
    [anon_sym_NA_complex_] = ACTIONS(1521),
    [anon_sym_NA_integer_] = ACTIONS(1521),
    [anon_sym_NA_real_] = ACTIONS(1521),
    [aux_sym_identifier_token1] = ACTIONS(1521),
    [anon_sym_BQUOTE] = ACTIONS(1521),
    [sym_integer] = ACTIONS(1521),
    [sym_float] = ACTIONS(1521),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [513] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1485),
    [anon_sym_LF] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_BSLASH] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(2437),
    [anon_sym_DASH_GT_GT] = ACTIONS(2439),
    [anon_sym_DASH_GT] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1487),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1487),
    [sym_next] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_inf] = ACTIONS(1487),
    [sym_nan] = ACTIONS(1487),
    [anon_sym_NA] = ACTIONS(1487),
    [anon_sym_NA_character_] = ACTIONS(1487),
    [anon_sym_NA_complex_] = ACTIONS(1487),
    [anon_sym_NA_integer_] = ACTIONS(1487),
    [anon_sym_NA_real_] = ACTIONS(1487),
    [aux_sym_identifier_token1] = ACTIONS(1487),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [sym_integer] = ACTIONS(1487),
    [sym_float] = ACTIONS(1487),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1487),
    [anon_sym_SQUOTE] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [514] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1465),
    [anon_sym_LF] = ACTIONS(1467),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_function] = ACTIONS(1467),
    [anon_sym_BSLASH] = ACTIONS(1467),
    [anon_sym_if] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1467),
    [anon_sym_while] = ACTIONS(1467),
    [anon_sym_repeat] = ACTIONS(1467),
    [anon_sym_for] = ACTIONS(1467),
    [anon_sym_switch] = ACTIONS(1467),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(2437),
    [anon_sym_DASH_GT_GT] = ACTIONS(2439),
    [anon_sym_DASH_GT] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1467),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1467),
    [sym_next] = ACTIONS(1467),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_null] = ACTIONS(1467),
    [sym_inf] = ACTIONS(1467),
    [sym_nan] = ACTIONS(1467),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [aux_sym_identifier_token1] = ACTIONS(1467),
    [anon_sym_BQUOTE] = ACTIONS(1467),
    [sym_integer] = ACTIONS(1467),
    [sym_float] = ACTIONS(1467),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1467),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [515] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym_LF] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_function] = ACTIONS(1463),
    [anon_sym_BSLASH] = ACTIONS(1463),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1463),
    [anon_sym_while] = ACTIONS(1463),
    [anon_sym_repeat] = ACTIONS(1463),
    [anon_sym_for] = ACTIONS(1463),
    [anon_sym_switch] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(2437),
    [anon_sym_DASH_GT_GT] = ACTIONS(2439),
    [anon_sym_DASH_GT] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1463),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1463),
    [sym_next] = ACTIONS(1463),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_inf] = ACTIONS(1463),
    [sym_nan] = ACTIONS(1463),
    [anon_sym_NA] = ACTIONS(1463),
    [anon_sym_NA_character_] = ACTIONS(1463),
    [anon_sym_NA_complex_] = ACTIONS(1463),
    [anon_sym_NA_integer_] = ACTIONS(1463),
    [anon_sym_NA_real_] = ACTIONS(1463),
    [aux_sym_identifier_token1] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [sym_integer] = ACTIONS(1463),
    [sym_float] = ACTIONS(1463),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [516] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1457),
    [anon_sym_LF] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_function] = ACTIONS(1459),
    [anon_sym_BSLASH] = ACTIONS(1459),
    [anon_sym_if] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1459),
    [anon_sym_while] = ACTIONS(1459),
    [anon_sym_repeat] = ACTIONS(1459),
    [anon_sym_for] = ACTIONS(1459),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(2437),
    [anon_sym_DASH_GT_GT] = ACTIONS(2439),
    [anon_sym_DASH_GT] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1459),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1459),
    [sym_next] = ACTIONS(1459),
    [sym_true] = ACTIONS(1459),
    [sym_false] = ACTIONS(1459),
    [sym_null] = ACTIONS(1459),
    [sym_inf] = ACTIONS(1459),
    [sym_nan] = ACTIONS(1459),
    [anon_sym_NA] = ACTIONS(1459),
    [anon_sym_NA_character_] = ACTIONS(1459),
    [anon_sym_NA_complex_] = ACTIONS(1459),
    [anon_sym_NA_integer_] = ACTIONS(1459),
    [anon_sym_NA_real_] = ACTIONS(1459),
    [aux_sym_identifier_token1] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_integer] = ACTIONS(1459),
    [sym_float] = ACTIONS(1459),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [517] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1445),
    [anon_sym_LF] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_BSLASH] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_repeat] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(2437),
    [anon_sym_DASH_GT_GT] = ACTIONS(2439),
    [anon_sym_DASH_GT] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1447),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1447),
    [sym_next] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_inf] = ACTIONS(1447),
    [sym_nan] = ACTIONS(1447),
    [anon_sym_NA] = ACTIONS(1447),
    [anon_sym_NA_character_] = ACTIONS(1447),
    [anon_sym_NA_complex_] = ACTIONS(1447),
    [anon_sym_NA_integer_] = ACTIONS(1447),
    [anon_sym_NA_real_] = ACTIONS(1447),
    [aux_sym_identifier_token1] = ACTIONS(1447),
    [anon_sym_BQUOTE] = ACTIONS(1447),
    [sym_integer] = ACTIONS(1447),
    [sym_float] = ACTIONS(1447),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1447),
    [anon_sym_SQUOTE] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [518] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1441),
    [anon_sym_LF] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1443),
    [anon_sym_function] = ACTIONS(1443),
    [anon_sym_BSLASH] = ACTIONS(1443),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1443),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1443),
    [anon_sym_LT_DASH] = ACTIONS(1443),
    [anon_sym_COLON_EQ] = ACTIONS(1443),
    [anon_sym_LT_LT_DASH] = ACTIONS(1443),
    [anon_sym_DASH_GT_GT] = ACTIONS(1443),
    [anon_sym_DASH_GT] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1443),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1443),
    [sym_next] = ACTIONS(1443),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_inf] = ACTIONS(1443),
    [sym_nan] = ACTIONS(1443),
    [anon_sym_NA] = ACTIONS(1443),
    [anon_sym_NA_character_] = ACTIONS(1443),
    [anon_sym_NA_complex_] = ACTIONS(1443),
    [anon_sym_NA_integer_] = ACTIONS(1443),
    [anon_sym_NA_real_] = ACTIONS(1443),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [anon_sym_BQUOTE] = ACTIONS(1443),
    [sym_integer] = ACTIONS(1443),
    [sym_float] = ACTIONS(1443),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1443),
    [anon_sym_SQUOTE] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [519] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(1525),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1525),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(1525),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_repeat] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_EQ] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_RBRACE] = ACTIONS(1525),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1525),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(1525),
    [sym_next] = ACTIONS(1525),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [sym_null] = ACTIONS(1525),
    [sym_inf] = ACTIONS(1525),
    [sym_nan] = ACTIONS(1525),
    [anon_sym_NA] = ACTIONS(1525),
    [anon_sym_NA_character_] = ACTIONS(1525),
    [anon_sym_NA_complex_] = ACTIONS(1525),
    [anon_sym_NA_integer_] = ACTIONS(1525),
    [anon_sym_NA_real_] = ACTIONS(1525),
    [aux_sym_identifier_token1] = ACTIONS(1525),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [sym_integer] = ACTIONS(1525),
    [sym_float] = ACTIONS(1525),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [520] = {
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_integer] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [anon_sym_i] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
  },
  [521] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2123),
    [anon_sym_BSLASH] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2123),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2123),
    [anon_sym_repeat] = ACTIONS(2123),
    [anon_sym_for] = ACTIONS(2123),
    [anon_sym_switch] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2121),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_LT_DASH] = ACTIONS(2317),
    [anon_sym_COLON_EQ] = ACTIONS(2319),
    [anon_sym_LT_LT_DASH] = ACTIONS(2321),
    [anon_sym_DASH_GT_GT] = ACTIONS(2323),
    [anon_sym_DASH_GT] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(2121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(2123),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(2123),
    [sym_next] = ACTIONS(2123),
    [sym_true] = ACTIONS(2123),
    [sym_false] = ACTIONS(2123),
    [sym_null] = ACTIONS(2123),
    [sym_inf] = ACTIONS(2123),
    [sym_nan] = ACTIONS(2123),
    [anon_sym_NA] = ACTIONS(2123),
    [anon_sym_NA_character_] = ACTIONS(2123),
    [anon_sym_NA_complex_] = ACTIONS(2123),
    [anon_sym_NA_integer_] = ACTIONS(2123),
    [anon_sym_NA_real_] = ACTIONS(2123),
    [aux_sym_identifier_token1] = ACTIONS(2123),
    [anon_sym_BQUOTE] = ACTIONS(2121),
    [sym_integer] = ACTIONS(2121),
    [sym_float] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2121),
    [anon_sym_SQUOTE] = ACTIONS(2121),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [522] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(2129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2131),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2129),
    [anon_sym_GT_EQ] = ACTIONS(2129),
    [anon_sym_EQ_EQ] = ACTIONS(2129),
    [anon_sym_BANG_EQ] = ACTIONS(2129),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2131),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(2129),
  },
  [523] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(2129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [524] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [525] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [526] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [527] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [528] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [529] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [530] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [531] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [532] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [533] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(2129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [534] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_function] = ACTIONS(893),
    [anon_sym_BSLASH] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(2479),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_repeat] = ACTIONS(893),
    [anon_sym_for] = ACTIONS(893),
    [anon_sym_switch] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_LT_DASH] = ACTIONS(2255),
    [anon_sym_COLON_EQ] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(2259),
    [anon_sym_DASH_GT_GT] = ACTIONS(2261),
    [anon_sym_DASH_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(891),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(893),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(893),
    [sym_next] = ACTIONS(893),
    [sym_true] = ACTIONS(893),
    [sym_false] = ACTIONS(893),
    [sym_null] = ACTIONS(893),
    [sym_inf] = ACTIONS(893),
    [sym_nan] = ACTIONS(893),
    [anon_sym_NA] = ACTIONS(893),
    [anon_sym_NA_character_] = ACTIONS(893),
    [anon_sym_NA_complex_] = ACTIONS(893),
    [anon_sym_NA_integer_] = ACTIONS(893),
    [anon_sym_NA_real_] = ACTIONS(893),
    [aux_sym_identifier_token1] = ACTIONS(893),
    [anon_sym_BQUOTE] = ACTIONS(891),
    [sym_integer] = ACTIONS(891),
    [sym_float] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [535] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(1525),
    [anon_sym_BSLASH] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_repeat] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_COMMA] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1523),
    [anon_sym_COLON_EQ] = ACTIONS(1523),
    [anon_sym_LT_LT_DASH] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT] = ACTIONS(1525),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1525),
    [sym_next] = ACTIONS(1525),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [sym_null] = ACTIONS(1525),
    [sym_inf] = ACTIONS(1525),
    [sym_nan] = ACTIONS(1525),
    [anon_sym_NA] = ACTIONS(1525),
    [anon_sym_NA_character_] = ACTIONS(1525),
    [anon_sym_NA_complex_] = ACTIONS(1525),
    [anon_sym_NA_integer_] = ACTIONS(1525),
    [anon_sym_NA_real_] = ACTIONS(1525),
    [aux_sym_identifier_token1] = ACTIONS(1525),
    [anon_sym_BQUOTE] = ACTIONS(1523),
    [sym_integer] = ACTIONS(1523),
    [sym_float] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1523),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [536] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym_function] = ACTIONS(1521),
    [anon_sym_BSLASH] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_repeat] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_COMMA] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1519),
    [anon_sym_COLON_EQ] = ACTIONS(1519),
    [anon_sym_LT_LT_DASH] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT] = ACTIONS(1521),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1521),
    [sym_next] = ACTIONS(1521),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [sym_null] = ACTIONS(1521),
    [sym_inf] = ACTIONS(1521),
    [sym_nan] = ACTIONS(1521),
    [anon_sym_NA] = ACTIONS(1521),
    [anon_sym_NA_character_] = ACTIONS(1521),
    [anon_sym_NA_complex_] = ACTIONS(1521),
    [anon_sym_NA_integer_] = ACTIONS(1521),
    [anon_sym_NA_real_] = ACTIONS(1521),
    [aux_sym_identifier_token1] = ACTIONS(1521),
    [anon_sym_BQUOTE] = ACTIONS(1519),
    [sym_integer] = ACTIONS(1519),
    [sym_float] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1519),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [537] = {
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_function] = ACTIONS(655),
    [anon_sym_BSLASH] = ACTIONS(653),
    [anon_sym_if] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_while] = ACTIONS(655),
    [anon_sym_repeat] = ACTIONS(655),
    [anon_sym_for] = ACTIONS(655),
    [anon_sym_switch] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LT_DASH] = ACTIONS(653),
    [anon_sym_COLON_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_DASH] = ACTIONS(653),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(653),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(653),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [anon_sym_AT] = ACTIONS(653),
    [anon_sym_COLON_COLON] = ACTIONS(655),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(653),
    [sym_dots] = ACTIONS(655),
    [anon_sym_PIPE_GT] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_SLASH] = ACTIONS(653),
    [anon_sym_CARET] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_COLON] = ACTIONS(655),
    [sym_break] = ACTIONS(655),
    [sym_next] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_null] = ACTIONS(655),
    [sym_inf] = ACTIONS(655),
    [sym_nan] = ACTIONS(655),
    [anon_sym_NA] = ACTIONS(655),
    [anon_sym_NA_character_] = ACTIONS(655),
    [anon_sym_NA_complex_] = ACTIONS(655),
    [anon_sym_NA_integer_] = ACTIONS(655),
    [anon_sym_NA_real_] = ACTIONS(655),
    [aux_sym_identifier_token1] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(653),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_SQUOTE] = ACTIONS(653),
    [anon_sym_PERCENT] = ACTIONS(653),
  },
  [538] = {
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_EQ] = ACTIONS(2481),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(641),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(2197),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(2199),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_integer] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
  },
  [539] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [anon_sym_LF] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_BSLASH] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_repeat] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(2437),
    [anon_sym_DASH_GT_GT] = ACTIONS(2439),
    [anon_sym_DASH_GT] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1381),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1381),
    [sym_next] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_inf] = ACTIONS(1381),
    [sym_nan] = ACTIONS(1381),
    [anon_sym_NA] = ACTIONS(1381),
    [anon_sym_NA_character_] = ACTIONS(1381),
    [anon_sym_NA_complex_] = ACTIONS(1381),
    [anon_sym_NA_integer_] = ACTIONS(1381),
    [anon_sym_NA_real_] = ACTIONS(1381),
    [aux_sym_identifier_token1] = ACTIONS(1381),
    [anon_sym_BQUOTE] = ACTIONS(1381),
    [sym_integer] = ACTIONS(1381),
    [sym_float] = ACTIONS(1381),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1381),
    [anon_sym_SQUOTE] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_SEMI] = ACTIONS(659),
    [anon_sym_function] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(659),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(659),
    [anon_sym_repeat] = ACTIONS(659),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(659),
    [anon_sym_EQ] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_LT_DASH] = ACTIONS(659),
    [anon_sym_COLON_EQ] = ACTIONS(659),
    [anon_sym_LT_LT_DASH] = ACTIONS(659),
    [anon_sym_DASH_GT_GT] = ACTIONS(659),
    [anon_sym_DASH_GT] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(659),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(659),
    [anon_sym_COLON_COLON] = ACTIONS(659),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(659),
    [sym_dots] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(659),
    [anon_sym_SLASH] = ACTIONS(659),
    [anon_sym_CARET] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(659),
    [sym_break] = ACTIONS(659),
    [sym_next] = ACTIONS(659),
    [sym_true] = ACTIONS(659),
    [sym_false] = ACTIONS(659),
    [sym_null] = ACTIONS(659),
    [sym_inf] = ACTIONS(659),
    [sym_nan] = ACTIONS(659),
    [anon_sym_NA] = ACTIONS(659),
    [anon_sym_NA_character_] = ACTIONS(659),
    [anon_sym_NA_complex_] = ACTIONS(659),
    [anon_sym_NA_integer_] = ACTIONS(659),
    [anon_sym_NA_real_] = ACTIONS(659),
    [aux_sym_identifier_token1] = ACTIONS(659),
    [anon_sym_BQUOTE] = ACTIONS(659),
    [sym_integer] = ACTIONS(659),
    [sym_float] = ACTIONS(659),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_PERCENT] = ACTIONS(659),
  },
  [541] = {
    [anon_sym_SEMI] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(651),
    [anon_sym_BSLASH] = ACTIONS(649),
    [anon_sym_if] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(649),
    [anon_sym_while] = ACTIONS(651),
    [anon_sym_repeat] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_switch] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(649),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_DASH_GT_GT] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(649),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(649),
    [anon_sym_DOLLAR] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(649),
    [sym_dots] = ACTIONS(651),
    [anon_sym_PIPE_GT] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_CARET] = ACTIONS(649),
    [anon_sym_LT] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(651),
    [anon_sym_LT_EQ] = ACTIONS(649),
    [anon_sym_GT_EQ] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_BANG_EQ] = ACTIONS(649),
    [anon_sym_PIPE_PIPE] = ACTIONS(649),
    [anon_sym_PIPE] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(649),
    [anon_sym_AMP] = ACTIONS(651),
    [anon_sym_COLON] = ACTIONS(651),
    [sym_break] = ACTIONS(651),
    [sym_next] = ACTIONS(651),
    [sym_true] = ACTIONS(651),
    [sym_false] = ACTIONS(651),
    [sym_null] = ACTIONS(651),
    [sym_inf] = ACTIONS(651),
    [sym_nan] = ACTIONS(651),
    [anon_sym_NA] = ACTIONS(651),
    [anon_sym_NA_character_] = ACTIONS(651),
    [anon_sym_NA_complex_] = ACTIONS(651),
    [anon_sym_NA_integer_] = ACTIONS(651),
    [anon_sym_NA_real_] = ACTIONS(651),
    [aux_sym_identifier_token1] = ACTIONS(651),
    [anon_sym_BQUOTE] = ACTIONS(649),
    [sym_integer] = ACTIONS(649),
    [sym_float] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(649),
    [anon_sym_SQUOTE] = ACTIONS(649),
    [anon_sym_PERCENT] = ACTIONS(649),
  },
  [542] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_BSLASH] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1485),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_LT_DASH] = ACTIONS(2317),
    [anon_sym_COLON_EQ] = ACTIONS(2319),
    [anon_sym_LT_LT_DASH] = ACTIONS(2321),
    [anon_sym_DASH_GT_GT] = ACTIONS(2323),
    [anon_sym_DASH_GT] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1487),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1487),
    [sym_next] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_inf] = ACTIONS(1487),
    [sym_nan] = ACTIONS(1487),
    [anon_sym_NA] = ACTIONS(1487),
    [anon_sym_NA_character_] = ACTIONS(1487),
    [anon_sym_NA_complex_] = ACTIONS(1487),
    [anon_sym_NA_integer_] = ACTIONS(1487),
    [anon_sym_NA_real_] = ACTIONS(1487),
    [aux_sym_identifier_token1] = ACTIONS(1487),
    [anon_sym_BQUOTE] = ACTIONS(1485),
    [sym_integer] = ACTIONS(1485),
    [sym_float] = ACTIONS(1487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1485),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [543] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1363),
    [anon_sym_LF] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1365),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(2437),
    [anon_sym_DASH_GT_GT] = ACTIONS(2439),
    [anon_sym_DASH_GT] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1365),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [aux_sym_identifier_token1] = ACTIONS(1365),
    [anon_sym_BQUOTE] = ACTIONS(1365),
    [sym_integer] = ACTIONS(1365),
    [sym_float] = ACTIONS(1365),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [544] = {
    [sym_special] = STATE(331),
    [ts_builtin_sym_end] = ACTIONS(1359),
    [anon_sym_LF] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1361),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_LT_LT_DASH] = ACTIONS(2437),
    [anon_sym_DASH_GT_GT] = ACTIONS(2439),
    [anon_sym_DASH_GT] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2445),
    [anon_sym_DOLLAR] = ACTIONS(2447),
    [anon_sym_AT] = ACTIONS(2449),
    [sym_dots] = ACTIONS(1361),
    [anon_sym_PIPE_GT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2461),
    [anon_sym_BANG_EQ] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_COLON] = ACTIONS(2467),
    [sym_break] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [aux_sym_identifier_token1] = ACTIONS(1361),
    [anon_sym_BQUOTE] = ACTIONS(1361),
    [sym_integer] = ACTIONS(1361),
    [sym_float] = ACTIONS(1361),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [545] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(1467),
    [anon_sym_BSLASH] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1467),
    [anon_sym_repeat] = ACTIONS(1467),
    [anon_sym_for] = ACTIONS(1467),
    [anon_sym_switch] = ACTIONS(1467),
    [anon_sym_COMMA] = ACTIONS(1465),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(1465),
    [anon_sym_LT_DASH] = ACTIONS(2317),
    [anon_sym_COLON_EQ] = ACTIONS(2319),
    [anon_sym_LT_LT_DASH] = ACTIONS(2321),
    [anon_sym_DASH_GT_GT] = ACTIONS(2323),
    [anon_sym_DASH_GT] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1465),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1467),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1467),
    [sym_next] = ACTIONS(1467),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_null] = ACTIONS(1467),
    [sym_inf] = ACTIONS(1467),
    [sym_nan] = ACTIONS(1467),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [aux_sym_identifier_token1] = ACTIONS(1467),
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [sym_integer] = ACTIONS(1465),
    [sym_float] = ACTIONS(1467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_SQUOTE] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [546] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1463),
    [anon_sym_BSLASH] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1463),
    [anon_sym_repeat] = ACTIONS(1463),
    [anon_sym_for] = ACTIONS(1463),
    [anon_sym_switch] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_LT_DASH] = ACTIONS(2317),
    [anon_sym_COLON_EQ] = ACTIONS(2319),
    [anon_sym_LT_LT_DASH] = ACTIONS(2321),
    [anon_sym_DASH_GT_GT] = ACTIONS(2323),
    [anon_sym_DASH_GT] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1461),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1463),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1463),
    [sym_next] = ACTIONS(1463),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_inf] = ACTIONS(1463),
    [sym_nan] = ACTIONS(1463),
    [anon_sym_NA] = ACTIONS(1463),
    [anon_sym_NA_character_] = ACTIONS(1463),
    [anon_sym_NA_complex_] = ACTIONS(1463),
    [anon_sym_NA_integer_] = ACTIONS(1463),
    [anon_sym_NA_real_] = ACTIONS(1463),
    [aux_sym_identifier_token1] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [sym_integer] = ACTIONS(1461),
    [sym_float] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1461),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [547] = {
    [anon_sym_LF] = ACTIONS(643),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_else] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(643),
    [anon_sym_COLON_EQ] = ACTIONS(643),
    [anon_sym_LT_LT_DASH] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(643),
    [anon_sym_AT] = ACTIONS(643),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(643),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_CARET] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(643),
    [anon_sym_EQ_EQ] = ACTIONS(643),
    [anon_sym_BANG_EQ] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(643),
    [sym_integer] = ACTIONS(643),
    [sym_float] = ACTIONS(643),
    [anon_sym_i] = ACTIONS(2483),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(643),
  },
  [548] = {
    [sym_special] = STATE(231),
    [anon_sym_LF] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(893),
    [anon_sym_BSLASH] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_else] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_repeat] = ACTIONS(893),
    [anon_sym_for] = ACTIONS(893),
    [anon_sym_switch] = ACTIONS(893),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_LT_DASH] = ACTIONS(2389),
    [anon_sym_COLON_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2393),
    [anon_sym_DASH_GT_GT] = ACTIONS(2395),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2405),
    [sym_dots] = ACTIONS(893),
    [anon_sym_PIPE_GT] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_AMP_AMP] = ACTIONS(2421),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_COLON] = ACTIONS(2423),
    [sym_break] = ACTIONS(893),
    [sym_next] = ACTIONS(893),
    [sym_true] = ACTIONS(893),
    [sym_false] = ACTIONS(893),
    [sym_null] = ACTIONS(893),
    [sym_inf] = ACTIONS(893),
    [sym_nan] = ACTIONS(893),
    [anon_sym_NA] = ACTIONS(893),
    [anon_sym_NA_character_] = ACTIONS(893),
    [anon_sym_NA_complex_] = ACTIONS(893),
    [anon_sym_NA_integer_] = ACTIONS(893),
    [anon_sym_NA_real_] = ACTIONS(893),
    [aux_sym_identifier_token1] = ACTIONS(893),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_integer] = ACTIONS(893),
    [sym_float] = ACTIONS(893),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(893),
    [anon_sym_SQUOTE] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(653),
    [anon_sym_LF] = ACTIONS(655),
    [anon_sym_SEMI] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(655),
    [anon_sym_BSLASH] = ACTIONS(655),
    [anon_sym_if] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_while] = ACTIONS(655),
    [anon_sym_repeat] = ACTIONS(655),
    [anon_sym_for] = ACTIONS(655),
    [anon_sym_switch] = ACTIONS(655),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_LT_DASH] = ACTIONS(655),
    [anon_sym_COLON_EQ] = ACTIONS(655),
    [anon_sym_LT_LT_DASH] = ACTIONS(655),
    [anon_sym_DASH_GT_GT] = ACTIONS(655),
    [anon_sym_DASH_GT] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(655),
    [anon_sym_DOLLAR] = ACTIONS(655),
    [anon_sym_AT] = ACTIONS(655),
    [anon_sym_COLON_COLON] = ACTIONS(655),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(655),
    [sym_dots] = ACTIONS(655),
    [anon_sym_PIPE_GT] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(655),
    [anon_sym_GT_EQ] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(655),
    [anon_sym_BANG_EQ] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(655),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_COLON] = ACTIONS(655),
    [sym_break] = ACTIONS(655),
    [sym_next] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_null] = ACTIONS(655),
    [sym_inf] = ACTIONS(655),
    [sym_nan] = ACTIONS(655),
    [anon_sym_NA] = ACTIONS(655),
    [anon_sym_NA_character_] = ACTIONS(655),
    [anon_sym_NA_complex_] = ACTIONS(655),
    [anon_sym_NA_integer_] = ACTIONS(655),
    [anon_sym_NA_real_] = ACTIONS(655),
    [aux_sym_identifier_token1] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_integer] = ACTIONS(655),
    [sym_float] = ACTIONS(655),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
  },
  [550] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_function] = ACTIONS(1459),
    [anon_sym_BSLASH] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1459),
    [anon_sym_repeat] = ACTIONS(1459),
    [anon_sym_for] = ACTIONS(1459),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_LT_DASH] = ACTIONS(2317),
    [anon_sym_COLON_EQ] = ACTIONS(2319),
    [anon_sym_LT_LT_DASH] = ACTIONS(2321),
    [anon_sym_DASH_GT_GT] = ACTIONS(2323),
    [anon_sym_DASH_GT] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1459),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1459),
    [sym_next] = ACTIONS(1459),
    [sym_true] = ACTIONS(1459),
    [sym_false] = ACTIONS(1459),
    [sym_null] = ACTIONS(1459),
    [sym_inf] = ACTIONS(1459),
    [sym_nan] = ACTIONS(1459),
    [anon_sym_NA] = ACTIONS(1459),
    [anon_sym_NA_character_] = ACTIONS(1459),
    [anon_sym_NA_complex_] = ACTIONS(1459),
    [anon_sym_NA_integer_] = ACTIONS(1459),
    [anon_sym_NA_real_] = ACTIONS(1459),
    [aux_sym_identifier_token1] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1457),
    [sym_integer] = ACTIONS(1457),
    [sym_float] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1457),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [551] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_BSLASH] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_repeat] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_LT_DASH] = ACTIONS(2317),
    [anon_sym_COLON_EQ] = ACTIONS(2319),
    [anon_sym_LT_LT_DASH] = ACTIONS(2321),
    [anon_sym_DASH_GT_GT] = ACTIONS(2323),
    [anon_sym_DASH_GT] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1447),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1447),
    [sym_next] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_inf] = ACTIONS(1447),
    [sym_nan] = ACTIONS(1447),
    [anon_sym_NA] = ACTIONS(1447),
    [anon_sym_NA_character_] = ACTIONS(1447),
    [anon_sym_NA_complex_] = ACTIONS(1447),
    [anon_sym_NA_integer_] = ACTIONS(1447),
    [anon_sym_NA_real_] = ACTIONS(1447),
    [aux_sym_identifier_token1] = ACTIONS(1447),
    [anon_sym_BQUOTE] = ACTIONS(1445),
    [sym_integer] = ACTIONS(1445),
    [sym_float] = ACTIONS(1447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [552] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_function] = ACTIONS(1443),
    [anon_sym_BSLASH] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_EQ] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_LT_DASH] = ACTIONS(1441),
    [anon_sym_COLON_EQ] = ACTIONS(1441),
    [anon_sym_LT_LT_DASH] = ACTIONS(1441),
    [anon_sym_DASH_GT_GT] = ACTIONS(1441),
    [anon_sym_DASH_GT] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1443),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1443),
    [sym_next] = ACTIONS(1443),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_inf] = ACTIONS(1443),
    [sym_nan] = ACTIONS(1443),
    [anon_sym_NA] = ACTIONS(1443),
    [anon_sym_NA_character_] = ACTIONS(1443),
    [anon_sym_NA_complex_] = ACTIONS(1443),
    [anon_sym_NA_integer_] = ACTIONS(1443),
    [anon_sym_NA_real_] = ACTIONS(1443),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [anon_sym_BQUOTE] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1441),
    [sym_float] = ACTIONS(1443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1441),
    [anon_sym_SQUOTE] = ACTIONS(1441),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [553] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [554] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [555] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [556] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [557] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [558] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [559] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [560] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(649),
    [anon_sym_LF] = ACTIONS(651),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_function] = ACTIONS(651),
    [anon_sym_BSLASH] = ACTIONS(651),
    [anon_sym_if] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(651),
    [anon_sym_repeat] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_switch] = ACTIONS(651),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(651),
    [anon_sym_LT_DASH] = ACTIONS(651),
    [anon_sym_COLON_EQ] = ACTIONS(651),
    [anon_sym_LT_LT_DASH] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(651),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(651),
    [anon_sym_DOLLAR] = ACTIONS(651),
    [anon_sym_AT] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(651),
    [sym_dots] = ACTIONS(651),
    [anon_sym_PIPE_GT] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_STAR] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(651),
    [anon_sym_CARET] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(651),
    [anon_sym_LT_EQ] = ACTIONS(651),
    [anon_sym_GT_EQ] = ACTIONS(651),
    [anon_sym_EQ_EQ] = ACTIONS(651),
    [anon_sym_BANG_EQ] = ACTIONS(651),
    [anon_sym_PIPE_PIPE] = ACTIONS(651),
    [anon_sym_PIPE] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(651),
    [anon_sym_AMP] = ACTIONS(651),
    [anon_sym_COLON] = ACTIONS(651),
    [sym_break] = ACTIONS(651),
    [sym_next] = ACTIONS(651),
    [sym_true] = ACTIONS(651),
    [sym_false] = ACTIONS(651),
    [sym_null] = ACTIONS(651),
    [sym_inf] = ACTIONS(651),
    [sym_nan] = ACTIONS(651),
    [anon_sym_NA] = ACTIONS(651),
    [anon_sym_NA_character_] = ACTIONS(651),
    [anon_sym_NA_complex_] = ACTIONS(651),
    [anon_sym_NA_integer_] = ACTIONS(651),
    [anon_sym_NA_real_] = ACTIONS(651),
    [aux_sym_identifier_token1] = ACTIONS(651),
    [anon_sym_BQUOTE] = ACTIONS(651),
    [sym_integer] = ACTIONS(651),
    [sym_float] = ACTIONS(651),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(651),
    [anon_sym_SQUOTE] = ACTIONS(651),
    [anon_sym_PERCENT] = ACTIONS(651),
  },
  [562] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_BSLASH] = ACTIONS(1379),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1379),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_repeat] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(1379),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(1379),
    [anon_sym_LT_DASH] = ACTIONS(2317),
    [anon_sym_COLON_EQ] = ACTIONS(2319),
    [anon_sym_LT_LT_DASH] = ACTIONS(2321),
    [anon_sym_DASH_GT_GT] = ACTIONS(2323),
    [anon_sym_DASH_GT] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1379),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1381),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1381),
    [sym_next] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_inf] = ACTIONS(1381),
    [sym_nan] = ACTIONS(1381),
    [anon_sym_NA] = ACTIONS(1381),
    [anon_sym_NA_character_] = ACTIONS(1381),
    [anon_sym_NA_complex_] = ACTIONS(1381),
    [anon_sym_NA_integer_] = ACTIONS(1381),
    [anon_sym_NA_real_] = ACTIONS(1381),
    [aux_sym_identifier_token1] = ACTIONS(1381),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_integer] = ACTIONS(1379),
    [sym_float] = ACTIONS(1381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [563] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1363),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_COMMA] = ACTIONS(1363),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_LT_DASH] = ACTIONS(2317),
    [anon_sym_COLON_EQ] = ACTIONS(2319),
    [anon_sym_LT_LT_DASH] = ACTIONS(2321),
    [anon_sym_DASH_GT_GT] = ACTIONS(2323),
    [anon_sym_DASH_GT] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1365),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [aux_sym_identifier_token1] = ACTIONS(1365),
    [anon_sym_BQUOTE] = ACTIONS(1363),
    [sym_integer] = ACTIONS(1363),
    [sym_float] = ACTIONS(1365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [564] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1359),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_COMMA] = ACTIONS(1359),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(2317),
    [anon_sym_COLON_EQ] = ACTIONS(2319),
    [anon_sym_LT_LT_DASH] = ACTIONS(2321),
    [anon_sym_DASH_GT_GT] = ACTIONS(2323),
    [anon_sym_DASH_GT] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1359),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1361),
    [anon_sym_PIPE_GT] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2339),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_break] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [aux_sym_identifier_token1] = ACTIONS(1361),
    [anon_sym_BQUOTE] = ACTIONS(1359),
    [sym_integer] = ACTIONS(1359),
    [sym_float] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(641),
    [anon_sym_LF] = ACTIONS(643),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_else] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(643),
    [anon_sym_COLON_EQ] = ACTIONS(643),
    [anon_sym_LT_LT_DASH] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(643),
    [anon_sym_AT] = ACTIONS(643),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(643),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_CARET] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(643),
    [anon_sym_EQ_EQ] = ACTIONS(643),
    [anon_sym_BANG_EQ] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(643),
    [sym_integer] = ACTIONS(643),
    [sym_float] = ACTIONS(643),
    [anon_sym_i] = ACTIONS(2487),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(643),
  },
  [566] = {
    [anon_sym_LF] = ACTIONS(651),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_function] = ACTIONS(651),
    [anon_sym_BSLASH] = ACTIONS(651),
    [anon_sym_if] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(651),
    [anon_sym_repeat] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_switch] = ACTIONS(651),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(651),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_LT_DASH] = ACTIONS(651),
    [anon_sym_COLON_EQ] = ACTIONS(651),
    [anon_sym_LT_LT_DASH] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(651),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(651),
    [anon_sym_DOLLAR] = ACTIONS(651),
    [anon_sym_AT] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(651),
    [sym_dots] = ACTIONS(651),
    [anon_sym_PIPE_GT] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_STAR] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(651),
    [anon_sym_CARET] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(651),
    [anon_sym_LT_EQ] = ACTIONS(651),
    [anon_sym_GT_EQ] = ACTIONS(651),
    [anon_sym_EQ_EQ] = ACTIONS(651),
    [anon_sym_BANG_EQ] = ACTIONS(651),
    [anon_sym_PIPE_PIPE] = ACTIONS(651),
    [anon_sym_PIPE] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(651),
    [anon_sym_AMP] = ACTIONS(651),
    [anon_sym_COLON] = ACTIONS(651),
    [sym_break] = ACTIONS(651),
    [sym_next] = ACTIONS(651),
    [sym_true] = ACTIONS(651),
    [sym_false] = ACTIONS(651),
    [sym_null] = ACTIONS(651),
    [sym_inf] = ACTIONS(651),
    [sym_nan] = ACTIONS(651),
    [anon_sym_NA] = ACTIONS(651),
    [anon_sym_NA_character_] = ACTIONS(651),
    [anon_sym_NA_complex_] = ACTIONS(651),
    [anon_sym_NA_integer_] = ACTIONS(651),
    [anon_sym_NA_real_] = ACTIONS(651),
    [aux_sym_identifier_token1] = ACTIONS(651),
    [anon_sym_BQUOTE] = ACTIONS(651),
    [sym_integer] = ACTIONS(651),
    [sym_float] = ACTIONS(651),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(651),
    [anon_sym_SQUOTE] = ACTIONS(651),
    [anon_sym_PERCENT] = ACTIONS(651),
  },
  [567] = {
    [sym_special] = STATE(381),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym_function] = ACTIONS(1521),
    [anon_sym_BSLASH] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(1521),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_repeat] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_COMMA] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1519),
    [anon_sym_COLON_EQ] = ACTIONS(1519),
    [anon_sym_LT_LT_DASH] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT] = ACTIONS(1521),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(2225),
    [sym_dots] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_break] = ACTIONS(1521),
    [sym_next] = ACTIONS(1521),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [sym_null] = ACTIONS(1521),
    [sym_inf] = ACTIONS(1521),
    [sym_nan] = ACTIONS(1521),
    [anon_sym_NA] = ACTIONS(1521),
    [anon_sym_NA_character_] = ACTIONS(1521),
    [anon_sym_NA_complex_] = ACTIONS(1521),
    [anon_sym_NA_integer_] = ACTIONS(1521),
    [anon_sym_NA_real_] = ACTIONS(1521),
    [aux_sym_identifier_token1] = ACTIONS(1521),
    [anon_sym_BQUOTE] = ACTIONS(1519),
    [sym_integer] = ACTIONS(1519),
    [sym_float] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1519),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [568] = {
    [anon_sym_LF] = ACTIONS(655),
    [anon_sym_SEMI] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(655),
    [anon_sym_BSLASH] = ACTIONS(655),
    [anon_sym_if] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_while] = ACTIONS(655),
    [anon_sym_repeat] = ACTIONS(655),
    [anon_sym_for] = ACTIONS(655),
    [anon_sym_switch] = ACTIONS(655),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_LT_DASH] = ACTIONS(655),
    [anon_sym_COLON_EQ] = ACTIONS(655),
    [anon_sym_LT_LT_DASH] = ACTIONS(655),
    [anon_sym_DASH_GT_GT] = ACTIONS(655),
    [anon_sym_DASH_GT] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(655),
    [anon_sym_DOLLAR] = ACTIONS(655),
    [anon_sym_AT] = ACTIONS(655),
    [anon_sym_COLON_COLON] = ACTIONS(655),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(655),
    [sym_dots] = ACTIONS(655),
    [anon_sym_PIPE_GT] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(655),
    [anon_sym_GT_EQ] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(655),
    [anon_sym_BANG_EQ] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(655),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_COLON] = ACTIONS(655),
    [sym_break] = ACTIONS(655),
    [sym_next] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_null] = ACTIONS(655),
    [sym_inf] = ACTIONS(655),
    [sym_nan] = ACTIONS(655),
    [anon_sym_NA] = ACTIONS(655),
    [anon_sym_NA_character_] = ACTIONS(655),
    [anon_sym_NA_complex_] = ACTIONS(655),
    [anon_sym_NA_integer_] = ACTIONS(655),
    [anon_sym_NA_real_] = ACTIONS(655),
    [aux_sym_identifier_token1] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_integer] = ACTIONS(655),
    [sym_float] = ACTIONS(655),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
  },
  [569] = {
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_SEMI] = ACTIONS(659),
    [anon_sym_function] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(659),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(659),
    [anon_sym_repeat] = ACTIONS(659),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(659),
    [anon_sym_EQ] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_LT_DASH] = ACTIONS(659),
    [anon_sym_COLON_EQ] = ACTIONS(659),
    [anon_sym_LT_LT_DASH] = ACTIONS(659),
    [anon_sym_DASH_GT_GT] = ACTIONS(659),
    [anon_sym_DASH_GT] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(659),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(659),
    [anon_sym_COLON_COLON] = ACTIONS(659),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(659),
    [sym_dots] = ACTIONS(659),
    [anon_sym_PIPE_GT] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(659),
    [anon_sym_SLASH] = ACTIONS(659),
    [anon_sym_CARET] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(659),
    [sym_break] = ACTIONS(659),
    [sym_next] = ACTIONS(659),
    [sym_true] = ACTIONS(659),
    [sym_false] = ACTIONS(659),
    [sym_null] = ACTIONS(659),
    [sym_inf] = ACTIONS(659),
    [sym_nan] = ACTIONS(659),
    [anon_sym_NA] = ACTIONS(659),
    [anon_sym_NA_character_] = ACTIONS(659),
    [anon_sym_NA_complex_] = ACTIONS(659),
    [anon_sym_NA_integer_] = ACTIONS(659),
    [anon_sym_NA_real_] = ACTIONS(659),
    [aux_sym_identifier_token1] = ACTIONS(659),
    [anon_sym_BQUOTE] = ACTIONS(659),
    [sym_integer] = ACTIONS(659),
    [sym_float] = ACTIONS(659),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_PERCENT] = ACTIONS(659),
  },
  [570] = {
    [sym_special] = STATE(191),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_RBRACK] = ACTIONS(1407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2329),
    [anon_sym_DOLLAR] = ACTIONS(2331),
    [anon_sym_AT] = ACTIONS(2333),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(641),
    [anon_sym_LF] = ACTIONS(643),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(643),
    [anon_sym_COLON_EQ] = ACTIONS(643),
    [anon_sym_LT_LT_DASH] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(643),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(2489),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(2491),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(643),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_CARET] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(643),
    [anon_sym_EQ_EQ] = ACTIONS(643),
    [anon_sym_BANG_EQ] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(643),
    [sym_integer] = ACTIONS(643),
    [sym_float] = ACTIONS(643),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(643),
  },
  [572] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1525),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1525),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_repeat] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_EQ] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_RBRACE] = ACTIONS(1525),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1525),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1525),
    [sym_next] = ACTIONS(1525),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [sym_null] = ACTIONS(1525),
    [sym_inf] = ACTIONS(1525),
    [sym_nan] = ACTIONS(1525),
    [anon_sym_NA] = ACTIONS(1525),
    [anon_sym_NA_character_] = ACTIONS(1525),
    [anon_sym_NA_complex_] = ACTIONS(1525),
    [anon_sym_NA_integer_] = ACTIONS(1525),
    [anon_sym_NA_real_] = ACTIONS(1525),
    [aux_sym_identifier_token1] = ACTIONS(1525),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [sym_integer] = ACTIONS(1525),
    [sym_float] = ACTIONS(1525),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [573] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1521),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1521),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_repeat] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1521),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1521),
    [sym_next] = ACTIONS(1521),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [sym_null] = ACTIONS(1521),
    [sym_inf] = ACTIONS(1521),
    [sym_nan] = ACTIONS(1521),
    [anon_sym_NA] = ACTIONS(1521),
    [anon_sym_NA_character_] = ACTIONS(1521),
    [anon_sym_NA_complex_] = ACTIONS(1521),
    [anon_sym_NA_integer_] = ACTIONS(1521),
    [anon_sym_NA_real_] = ACTIONS(1521),
    [aux_sym_identifier_token1] = ACTIONS(1521),
    [anon_sym_BQUOTE] = ACTIONS(1521),
    [sym_integer] = ACTIONS(1521),
    [sym_float] = ACTIONS(1521),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [574] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_BSLASH] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_LT_DASH] = ACTIONS(2523),
    [anon_sym_COLON_EQ] = ACTIONS(2525),
    [anon_sym_LT_LT_DASH] = ACTIONS(2527),
    [anon_sym_DASH_GT_GT] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1487),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1487),
    [sym_next] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_inf] = ACTIONS(1487),
    [sym_nan] = ACTIONS(1487),
    [anon_sym_NA] = ACTIONS(1487),
    [anon_sym_NA_character_] = ACTIONS(1487),
    [anon_sym_NA_complex_] = ACTIONS(1487),
    [anon_sym_NA_integer_] = ACTIONS(1487),
    [anon_sym_NA_real_] = ACTIONS(1487),
    [aux_sym_identifier_token1] = ACTIONS(1487),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [sym_integer] = ACTIONS(1487),
    [sym_float] = ACTIONS(1487),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1487),
    [anon_sym_SQUOTE] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [575] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [576] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [577] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2131),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2131),
    [anon_sym_SLASH] = ACTIONS(2131),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2131),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2131),
    [anon_sym_GT_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ] = ACTIONS(2131),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2131),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2131),
  },
  [578] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(2123),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_function] = ACTIONS(2123),
    [anon_sym_BSLASH] = ACTIONS(2123),
    [anon_sym_if] = ACTIONS(2123),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(2123),
    [anon_sym_repeat] = ACTIONS(2123),
    [anon_sym_for] = ACTIONS(2123),
    [anon_sym_switch] = ACTIONS(2123),
    [anon_sym_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_LT_DASH] = ACTIONS(2523),
    [anon_sym_COLON_EQ] = ACTIONS(2525),
    [anon_sym_LT_LT_DASH] = ACTIONS(2527),
    [anon_sym_DASH_GT_GT] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(2123),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(2123),
    [sym_next] = ACTIONS(2123),
    [sym_true] = ACTIONS(2123),
    [sym_false] = ACTIONS(2123),
    [sym_null] = ACTIONS(2123),
    [sym_inf] = ACTIONS(2123),
    [sym_nan] = ACTIONS(2123),
    [anon_sym_NA] = ACTIONS(2123),
    [anon_sym_NA_character_] = ACTIONS(2123),
    [anon_sym_NA_complex_] = ACTIONS(2123),
    [anon_sym_NA_integer_] = ACTIONS(2123),
    [anon_sym_NA_real_] = ACTIONS(2123),
    [aux_sym_identifier_token1] = ACTIONS(2123),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_integer] = ACTIONS(2123),
    [sym_float] = ACTIONS(2123),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(641),
    [anon_sym_LF] = ACTIONS(643),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(643),
    [anon_sym_COLON_EQ] = ACTIONS(643),
    [anon_sym_LT_LT_DASH] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(643),
    [anon_sym_AT] = ACTIONS(643),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(643),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_CARET] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(643),
    [anon_sym_EQ_EQ] = ACTIONS(643),
    [anon_sym_BANG_EQ] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(643),
    [sym_integer] = ACTIONS(643),
    [sym_float] = ACTIONS(643),
    [anon_sym_i] = ACTIONS(2533),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(643),
  },
  [580] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1467),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_function] = ACTIONS(1467),
    [anon_sym_BSLASH] = ACTIONS(1467),
    [anon_sym_if] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1467),
    [anon_sym_repeat] = ACTIONS(1467),
    [anon_sym_for] = ACTIONS(1467),
    [anon_sym_switch] = ACTIONS(1467),
    [anon_sym_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [anon_sym_RBRACE] = ACTIONS(1467),
    [anon_sym_LT_DASH] = ACTIONS(2523),
    [anon_sym_COLON_EQ] = ACTIONS(2525),
    [anon_sym_LT_LT_DASH] = ACTIONS(2527),
    [anon_sym_DASH_GT_GT] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1467),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1467),
    [sym_next] = ACTIONS(1467),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_null] = ACTIONS(1467),
    [sym_inf] = ACTIONS(1467),
    [sym_nan] = ACTIONS(1467),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [aux_sym_identifier_token1] = ACTIONS(1467),
    [anon_sym_BQUOTE] = ACTIONS(1467),
    [sym_integer] = ACTIONS(1467),
    [sym_float] = ACTIONS(1467),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1467),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [581] = {
    [anon_sym_LF] = ACTIONS(643),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LT_DASH] = ACTIONS(643),
    [anon_sym_COLON_EQ] = ACTIONS(643),
    [anon_sym_LT_LT_DASH] = ACTIONS(643),
    [anon_sym_DASH_GT_GT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(643),
    [anon_sym_AT] = ACTIONS(643),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(643),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_CARET] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(643),
    [anon_sym_GT_EQ] = ACTIONS(643),
    [anon_sym_EQ_EQ] = ACTIONS(643),
    [anon_sym_BANG_EQ] = ACTIONS(643),
    [anon_sym_PIPE_PIPE] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(643),
    [sym_integer] = ACTIONS(643),
    [sym_float] = ACTIONS(643),
    [anon_sym_i] = ACTIONS(2535),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(643),
  },
  [582] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_function] = ACTIONS(1463),
    [anon_sym_BSLASH] = ACTIONS(1463),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1463),
    [anon_sym_repeat] = ACTIONS(1463),
    [anon_sym_for] = ACTIONS(1463),
    [anon_sym_switch] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1463),
    [anon_sym_LT_DASH] = ACTIONS(2523),
    [anon_sym_COLON_EQ] = ACTIONS(2525),
    [anon_sym_LT_LT_DASH] = ACTIONS(2527),
    [anon_sym_DASH_GT_GT] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1463),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1463),
    [sym_next] = ACTIONS(1463),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_inf] = ACTIONS(1463),
    [sym_nan] = ACTIONS(1463),
    [anon_sym_NA] = ACTIONS(1463),
    [anon_sym_NA_character_] = ACTIONS(1463),
    [anon_sym_NA_complex_] = ACTIONS(1463),
    [anon_sym_NA_integer_] = ACTIONS(1463),
    [anon_sym_NA_real_] = ACTIONS(1463),
    [aux_sym_identifier_token1] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [sym_integer] = ACTIONS(1463),
    [sym_float] = ACTIONS(1463),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [583] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_function] = ACTIONS(1459),
    [anon_sym_BSLASH] = ACTIONS(1459),
    [anon_sym_if] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1459),
    [anon_sym_repeat] = ACTIONS(1459),
    [anon_sym_for] = ACTIONS(1459),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_LT_DASH] = ACTIONS(2523),
    [anon_sym_COLON_EQ] = ACTIONS(2525),
    [anon_sym_LT_LT_DASH] = ACTIONS(2527),
    [anon_sym_DASH_GT_GT] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1459),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1459),
    [sym_next] = ACTIONS(1459),
    [sym_true] = ACTIONS(1459),
    [sym_false] = ACTIONS(1459),
    [sym_null] = ACTIONS(1459),
    [sym_inf] = ACTIONS(1459),
    [sym_nan] = ACTIONS(1459),
    [anon_sym_NA] = ACTIONS(1459),
    [anon_sym_NA_character_] = ACTIONS(1459),
    [anon_sym_NA_complex_] = ACTIONS(1459),
    [anon_sym_NA_integer_] = ACTIONS(1459),
    [anon_sym_NA_real_] = ACTIONS(1459),
    [aux_sym_identifier_token1] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_integer] = ACTIONS(1459),
    [sym_float] = ACTIONS(1459),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [584] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_BSLASH] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_repeat] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_RBRACE] = ACTIONS(1447),
    [anon_sym_LT_DASH] = ACTIONS(2523),
    [anon_sym_COLON_EQ] = ACTIONS(2525),
    [anon_sym_LT_LT_DASH] = ACTIONS(2527),
    [anon_sym_DASH_GT_GT] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1447),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1447),
    [sym_next] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_inf] = ACTIONS(1447),
    [sym_nan] = ACTIONS(1447),
    [anon_sym_NA] = ACTIONS(1447),
    [anon_sym_NA_character_] = ACTIONS(1447),
    [anon_sym_NA_complex_] = ACTIONS(1447),
    [anon_sym_NA_integer_] = ACTIONS(1447),
    [anon_sym_NA_real_] = ACTIONS(1447),
    [aux_sym_identifier_token1] = ACTIONS(1447),
    [anon_sym_BQUOTE] = ACTIONS(1447),
    [sym_integer] = ACTIONS(1447),
    [sym_float] = ACTIONS(1447),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1447),
    [anon_sym_SQUOTE] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [585] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1443),
    [anon_sym_function] = ACTIONS(1443),
    [anon_sym_BSLASH] = ACTIONS(1443),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1443),
    [anon_sym_RBRACE] = ACTIONS(1443),
    [anon_sym_LT_DASH] = ACTIONS(1443),
    [anon_sym_COLON_EQ] = ACTIONS(1443),
    [anon_sym_LT_LT_DASH] = ACTIONS(1443),
    [anon_sym_DASH_GT_GT] = ACTIONS(1443),
    [anon_sym_DASH_GT] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1443),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1443),
    [sym_next] = ACTIONS(1443),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_inf] = ACTIONS(1443),
    [sym_nan] = ACTIONS(1443),
    [anon_sym_NA] = ACTIONS(1443),
    [anon_sym_NA_character_] = ACTIONS(1443),
    [anon_sym_NA_complex_] = ACTIONS(1443),
    [anon_sym_NA_integer_] = ACTIONS(1443),
    [anon_sym_NA_real_] = ACTIONS(1443),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [anon_sym_BQUOTE] = ACTIONS(1443),
    [sym_integer] = ACTIONS(1443),
    [sym_float] = ACTIONS(1443),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1443),
    [anon_sym_SQUOTE] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [586] = {
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_BSLASH] = ACTIONS(2379),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2379),
    [anon_sym_RPAREN] = ACTIONS(2379),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_repeat] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_COMMA] = ACTIONS(2379),
    [anon_sym_EQ] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_DASH] = ACTIONS(2379),
    [anon_sym_COLON_EQ] = ACTIONS(2379),
    [anon_sym_LT_LT_DASH] = ACTIONS(2379),
    [anon_sym_DASH_GT_GT] = ACTIONS(2379),
    [anon_sym_DASH_GT] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_RBRACK] = ACTIONS(2379),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2379),
    [anon_sym_DOLLAR] = ACTIONS(2379),
    [anon_sym_AT] = ACTIONS(2379),
    [sym_dots] = ACTIONS(2381),
    [anon_sym_PIPE_GT] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2379),
    [anon_sym_STAR] = ACTIONS(2379),
    [anon_sym_SLASH] = ACTIONS(2379),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_GT] = ACTIONS(2381),
    [anon_sym_LT_EQ] = ACTIONS(2379),
    [anon_sym_GT_EQ] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2379),
    [anon_sym_BANG_EQ] = ACTIONS(2379),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_PIPE] = ACTIONS(2381),
    [anon_sym_AMP_AMP] = ACTIONS(2379),
    [anon_sym_AMP] = ACTIONS(2381),
    [anon_sym_COLON] = ACTIONS(2381),
    [sym_break] = ACTIONS(2381),
    [sym_next] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_inf] = ACTIONS(2381),
    [sym_nan] = ACTIONS(2381),
    [anon_sym_NA] = ACTIONS(2381),
    [anon_sym_NA_character_] = ACTIONS(2381),
    [anon_sym_NA_complex_] = ACTIONS(2381),
    [anon_sym_NA_integer_] = ACTIONS(2381),
    [anon_sym_NA_real_] = ACTIONS(2381),
    [aux_sym_identifier_token1] = ACTIONS(2381),
    [anon_sym_BQUOTE] = ACTIONS(2379),
    [sym_integer] = ACTIONS(2379),
    [sym_float] = ACTIONS(2381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2379),
    [anon_sym_SQUOTE] = ACTIONS(2379),
    [anon_sym_PERCENT] = ACTIONS(2379),
  },
  [587] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(2473),
    [anon_sym_function] = ACTIONS(2475),
    [anon_sym_BSLASH] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2475),
    [anon_sym_repeat] = ACTIONS(2475),
    [anon_sym_for] = ACTIONS(2475),
    [anon_sym_switch] = ACTIONS(2475),
    [anon_sym_COMMA] = ACTIONS(2473),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LT_DASH] = ACTIONS(2541),
    [anon_sym_COLON_EQ] = ACTIONS(2543),
    [anon_sym_LT_LT_DASH] = ACTIONS(2545),
    [anon_sym_DASH_GT_GT] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2473),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(2475),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(2475),
    [sym_next] = ACTIONS(2475),
    [sym_true] = ACTIONS(2475),
    [sym_false] = ACTIONS(2475),
    [sym_null] = ACTIONS(2475),
    [sym_inf] = ACTIONS(2475),
    [sym_nan] = ACTIONS(2475),
    [anon_sym_NA] = ACTIONS(2475),
    [anon_sym_NA_character_] = ACTIONS(2475),
    [anon_sym_NA_complex_] = ACTIONS(2475),
    [anon_sym_NA_integer_] = ACTIONS(2475),
    [anon_sym_NA_real_] = ACTIONS(2475),
    [aux_sym_identifier_token1] = ACTIONS(2475),
    [anon_sym_BQUOTE] = ACTIONS(2473),
    [sym_integer] = ACTIONS(2473),
    [sym_float] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(2473),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [588] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(2121),
    [anon_sym_LF] = ACTIONS(2123),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_function] = ACTIONS(2123),
    [anon_sym_BSLASH] = ACTIONS(2123),
    [anon_sym_if] = ACTIONS(2123),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2123),
    [anon_sym_repeat] = ACTIONS(2123),
    [anon_sym_for] = ACTIONS(2123),
    [anon_sym_switch] = ACTIONS(2123),
    [anon_sym_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_LT_DASH] = ACTIONS(2589),
    [anon_sym_COLON_EQ] = ACTIONS(2591),
    [anon_sym_LT_LT_DASH] = ACTIONS(2593),
    [anon_sym_DASH_GT_GT] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(2123),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(2123),
    [sym_next] = ACTIONS(2123),
    [sym_true] = ACTIONS(2123),
    [sym_false] = ACTIONS(2123),
    [sym_null] = ACTIONS(2123),
    [sym_inf] = ACTIONS(2123),
    [sym_nan] = ACTIONS(2123),
    [anon_sym_NA] = ACTIONS(2123),
    [anon_sym_NA_character_] = ACTIONS(2123),
    [anon_sym_NA_complex_] = ACTIONS(2123),
    [anon_sym_NA_integer_] = ACTIONS(2123),
    [anon_sym_NA_real_] = ACTIONS(2123),
    [aux_sym_identifier_token1] = ACTIONS(2123),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_integer] = ACTIONS(2123),
    [sym_float] = ACTIONS(2123),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [589] = {
    [anon_sym_SEMI] = ACTIONS(2369),
    [anon_sym_function] = ACTIONS(2371),
    [anon_sym_BSLASH] = ACTIONS(2369),
    [anon_sym_if] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2369),
    [anon_sym_RPAREN] = ACTIONS(2369),
    [anon_sym_while] = ACTIONS(2371),
    [anon_sym_repeat] = ACTIONS(2371),
    [anon_sym_for] = ACTIONS(2371),
    [anon_sym_switch] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(2369),
    [anon_sym_LT_DASH] = ACTIONS(2369),
    [anon_sym_COLON_EQ] = ACTIONS(2369),
    [anon_sym_LT_LT_DASH] = ACTIONS(2369),
    [anon_sym_DASH_GT_GT] = ACTIONS(2369),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2369),
    [anon_sym_DOLLAR] = ACTIONS(2369),
    [anon_sym_AT] = ACTIONS(2369),
    [sym_dots] = ACTIONS(2371),
    [anon_sym_PIPE_GT] = ACTIONS(2369),
    [anon_sym_DASH] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2369),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_SLASH] = ACTIONS(2369),
    [anon_sym_CARET] = ACTIONS(2369),
    [anon_sym_LT] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2369),
    [anon_sym_GT_EQ] = ACTIONS(2369),
    [anon_sym_EQ_EQ] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2369),
    [anon_sym_PIPE_PIPE] = ACTIONS(2369),
    [anon_sym_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2369),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2371),
    [sym_break] = ACTIONS(2371),
    [sym_next] = ACTIONS(2371),
    [sym_true] = ACTIONS(2371),
    [sym_false] = ACTIONS(2371),
    [sym_null] = ACTIONS(2371),
    [sym_inf] = ACTIONS(2371),
    [sym_nan] = ACTIONS(2371),
    [anon_sym_NA] = ACTIONS(2371),
    [anon_sym_NA_character_] = ACTIONS(2371),
    [anon_sym_NA_complex_] = ACTIONS(2371),
    [anon_sym_NA_integer_] = ACTIONS(2371),
    [anon_sym_NA_real_] = ACTIONS(2371),
    [aux_sym_identifier_token1] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2369),
    [sym_integer] = ACTIONS(2369),
    [sym_float] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2369),
    [anon_sym_SQUOTE] = ACTIONS(2369),
    [anon_sym_PERCENT] = ACTIONS(2369),
  },
  [590] = {
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym_function] = ACTIONS(2367),
    [anon_sym_BSLASH] = ACTIONS(2365),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2365),
    [anon_sym_RPAREN] = ACTIONS(2365),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_repeat] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(2365),
    [anon_sym_EQ] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_LT_DASH] = ACTIONS(2365),
    [anon_sym_COLON_EQ] = ACTIONS(2365),
    [anon_sym_LT_LT_DASH] = ACTIONS(2365),
    [anon_sym_DASH_GT_GT] = ACTIONS(2365),
    [anon_sym_DASH_GT] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_RBRACK] = ACTIONS(2365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2365),
    [anon_sym_DOLLAR] = ACTIONS(2365),
    [anon_sym_AT] = ACTIONS(2365),
    [sym_dots] = ACTIONS(2367),
    [anon_sym_PIPE_GT] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2367),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2365),
    [anon_sym_CARET] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2365),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [anon_sym_EQ_EQ] = ACTIONS(2365),
    [anon_sym_BANG_EQ] = ACTIONS(2365),
    [anon_sym_PIPE_PIPE] = ACTIONS(2365),
    [anon_sym_PIPE] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [sym_break] = ACTIONS(2367),
    [sym_next] = ACTIONS(2367),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [sym_null] = ACTIONS(2367),
    [sym_inf] = ACTIONS(2367),
    [sym_nan] = ACTIONS(2367),
    [anon_sym_NA] = ACTIONS(2367),
    [anon_sym_NA_character_] = ACTIONS(2367),
    [anon_sym_NA_complex_] = ACTIONS(2367),
    [anon_sym_NA_integer_] = ACTIONS(2367),
    [anon_sym_NA_real_] = ACTIONS(2367),
    [aux_sym_identifier_token1] = ACTIONS(2367),
    [anon_sym_BQUOTE] = ACTIONS(2365),
    [sym_integer] = ACTIONS(2365),
    [sym_float] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2365),
    [anon_sym_SQUOTE] = ACTIONS(2365),
    [anon_sym_PERCENT] = ACTIONS(2365),
  },
  [591] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(2129),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2131),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2131),
    [anon_sym_SLASH] = ACTIONS(2131),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2131),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2131),
    [anon_sym_GT_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ] = ACTIONS(2131),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2131),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2131),
  },
  [592] = {
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym_function] = ACTIONS(2363),
    [anon_sym_BSLASH] = ACTIONS(2361),
    [anon_sym_if] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(2361),
    [anon_sym_RPAREN] = ACTIONS(2361),
    [anon_sym_while] = ACTIONS(2363),
    [anon_sym_repeat] = ACTIONS(2363),
    [anon_sym_for] = ACTIONS(2363),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_COMMA] = ACTIONS(2361),
    [anon_sym_EQ] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_DASH] = ACTIONS(2361),
    [anon_sym_COLON_EQ] = ACTIONS(2361),
    [anon_sym_LT_LT_DASH] = ACTIONS(2361),
    [anon_sym_DASH_GT_GT] = ACTIONS(2361),
    [anon_sym_DASH_GT] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_RBRACK] = ACTIONS(2361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2361),
    [anon_sym_DOLLAR] = ACTIONS(2361),
    [anon_sym_AT] = ACTIONS(2361),
    [sym_dots] = ACTIONS(2363),
    [anon_sym_PIPE_GT] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2361),
    [anon_sym_BANG] = ACTIONS(2363),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_CARET] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2363),
    [anon_sym_LT_EQ] = ACTIONS(2361),
    [anon_sym_GT_EQ] = ACTIONS(2361),
    [anon_sym_EQ_EQ] = ACTIONS(2361),
    [anon_sym_BANG_EQ] = ACTIONS(2361),
    [anon_sym_PIPE_PIPE] = ACTIONS(2361),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2363),
    [sym_break] = ACTIONS(2363),
    [sym_next] = ACTIONS(2363),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [sym_null] = ACTIONS(2363),
    [sym_inf] = ACTIONS(2363),
    [sym_nan] = ACTIONS(2363),
    [anon_sym_NA] = ACTIONS(2363),
    [anon_sym_NA_character_] = ACTIONS(2363),
    [anon_sym_NA_complex_] = ACTIONS(2363),
    [anon_sym_NA_integer_] = ACTIONS(2363),
    [anon_sym_NA_real_] = ACTIONS(2363),
    [aux_sym_identifier_token1] = ACTIONS(2363),
    [anon_sym_BQUOTE] = ACTIONS(2361),
    [sym_integer] = ACTIONS(2361),
    [sym_float] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2361),
    [anon_sym_SQUOTE] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
  },
  [593] = {
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_function] = ACTIONS(2307),
    [anon_sym_BSLASH] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_repeat] = ACTIONS(2307),
    [anon_sym_for] = ACTIONS(2307),
    [anon_sym_switch] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_EQ] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_LT_DASH] = ACTIONS(2305),
    [anon_sym_COLON_EQ] = ACTIONS(2305),
    [anon_sym_LT_LT_DASH] = ACTIONS(2305),
    [anon_sym_DASH_GT_GT] = ACTIONS(2305),
    [anon_sym_DASH_GT] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2305),
    [anon_sym_DOLLAR] = ACTIONS(2305),
    [anon_sym_AT] = ACTIONS(2305),
    [sym_dots] = ACTIONS(2307),
    [anon_sym_PIPE_GT] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(2307),
    [anon_sym_TILDE] = ACTIONS(2305),
    [anon_sym_STAR] = ACTIONS(2305),
    [anon_sym_SLASH] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2305),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP_AMP] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_COLON] = ACTIONS(2307),
    [sym_break] = ACTIONS(2307),
    [sym_next] = ACTIONS(2307),
    [sym_true] = ACTIONS(2307),
    [sym_false] = ACTIONS(2307),
    [sym_null] = ACTIONS(2307),
    [sym_inf] = ACTIONS(2307),
    [sym_nan] = ACTIONS(2307),
    [anon_sym_NA] = ACTIONS(2307),
    [anon_sym_NA_character_] = ACTIONS(2307),
    [anon_sym_NA_complex_] = ACTIONS(2307),
    [anon_sym_NA_integer_] = ACTIONS(2307),
    [anon_sym_NA_real_] = ACTIONS(2307),
    [aux_sym_identifier_token1] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2305),
    [sym_integer] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2305),
    [anon_sym_SQUOTE] = ACTIONS(2305),
    [anon_sym_PERCENT] = ACTIONS(2305),
  },
  [594] = {
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_function] = ACTIONS(2303),
    [anon_sym_BSLASH] = ACTIONS(2301),
    [anon_sym_if] = ACTIONS(2303),
    [anon_sym_LPAREN] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_while] = ACTIONS(2303),
    [anon_sym_repeat] = ACTIONS(2303),
    [anon_sym_for] = ACTIONS(2303),
    [anon_sym_switch] = ACTIONS(2303),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_EQ] = ACTIONS(2303),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_LT_DASH] = ACTIONS(2301),
    [anon_sym_COLON_EQ] = ACTIONS(2301),
    [anon_sym_LT_LT_DASH] = ACTIONS(2301),
    [anon_sym_DASH_GT_GT] = ACTIONS(2301),
    [anon_sym_DASH_GT] = ACTIONS(2303),
    [anon_sym_LBRACK] = ACTIONS(2303),
    [anon_sym_RBRACK] = ACTIONS(2301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2301),
    [anon_sym_DOLLAR] = ACTIONS(2301),
    [anon_sym_AT] = ACTIONS(2301),
    [sym_dots] = ACTIONS(2303),
    [anon_sym_PIPE_GT] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2303),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2301),
    [anon_sym_STAR] = ACTIONS(2301),
    [anon_sym_SLASH] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_EQ_EQ] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_COLON] = ACTIONS(2303),
    [sym_break] = ACTIONS(2303),
    [sym_next] = ACTIONS(2303),
    [sym_true] = ACTIONS(2303),
    [sym_false] = ACTIONS(2303),
    [sym_null] = ACTIONS(2303),
    [sym_inf] = ACTIONS(2303),
    [sym_nan] = ACTIONS(2303),
    [anon_sym_NA] = ACTIONS(2303),
    [anon_sym_NA_character_] = ACTIONS(2303),
    [anon_sym_NA_complex_] = ACTIONS(2303),
    [anon_sym_NA_integer_] = ACTIONS(2303),
    [anon_sym_NA_real_] = ACTIONS(2303),
    [aux_sym_identifier_token1] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [sym_integer] = ACTIONS(2301),
    [sym_float] = ACTIONS(2303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2301),
    [anon_sym_PERCENT] = ACTIONS(2301),
  },
  [595] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [596] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [597] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [598] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [599] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [600] = {
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_integer] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
  },
  [601] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [602] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [603] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [604] = {
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_function] = ACTIONS(2299),
    [anon_sym_BSLASH] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2299),
    [anon_sym_LPAREN] = ACTIONS(2297),
    [anon_sym_RPAREN] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2299),
    [anon_sym_repeat] = ACTIONS(2299),
    [anon_sym_for] = ACTIONS(2299),
    [anon_sym_switch] = ACTIONS(2299),
    [anon_sym_COMMA] = ACTIONS(2297),
    [anon_sym_EQ] = ACTIONS(2299),
    [anon_sym_LBRACE] = ACTIONS(2297),
    [anon_sym_LT_DASH] = ACTIONS(2297),
    [anon_sym_COLON_EQ] = ACTIONS(2297),
    [anon_sym_LT_LT_DASH] = ACTIONS(2297),
    [anon_sym_DASH_GT_GT] = ACTIONS(2297),
    [anon_sym_DASH_GT] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(2299),
    [anon_sym_RBRACK] = ACTIONS(2297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2297),
    [anon_sym_DOLLAR] = ACTIONS(2297),
    [anon_sym_AT] = ACTIONS(2297),
    [sym_dots] = ACTIONS(2299),
    [anon_sym_PIPE_GT] = ACTIONS(2297),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_BANG] = ACTIONS(2299),
    [anon_sym_TILDE] = ACTIONS(2297),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_SLASH] = ACTIONS(2297),
    [anon_sym_CARET] = ACTIONS(2297),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_LT_EQ] = ACTIONS(2297),
    [anon_sym_GT_EQ] = ACTIONS(2297),
    [anon_sym_EQ_EQ] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(2297),
    [anon_sym_PIPE_PIPE] = ACTIONS(2297),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_AMP_AMP] = ACTIONS(2297),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_COLON] = ACTIONS(2299),
    [sym_break] = ACTIONS(2299),
    [sym_next] = ACTIONS(2299),
    [sym_true] = ACTIONS(2299),
    [sym_false] = ACTIONS(2299),
    [sym_null] = ACTIONS(2299),
    [sym_inf] = ACTIONS(2299),
    [sym_nan] = ACTIONS(2299),
    [anon_sym_NA] = ACTIONS(2299),
    [anon_sym_NA_character_] = ACTIONS(2299),
    [anon_sym_NA_complex_] = ACTIONS(2299),
    [anon_sym_NA_integer_] = ACTIONS(2299),
    [anon_sym_NA_real_] = ACTIONS(2299),
    [aux_sym_identifier_token1] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2297),
    [sym_integer] = ACTIONS(2297),
    [sym_float] = ACTIONS(2299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2297),
    [anon_sym_SQUOTE] = ACTIONS(2297),
    [anon_sym_PERCENT] = ACTIONS(2297),
  },
  [605] = {
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_function] = ACTIONS(2295),
    [anon_sym_BSLASH] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2295),
    [anon_sym_LPAREN] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2295),
    [anon_sym_repeat] = ACTIONS(2295),
    [anon_sym_for] = ACTIONS(2295),
    [anon_sym_switch] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_LT_DASH] = ACTIONS(2293),
    [anon_sym_COLON_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_DASH] = ACTIONS(2293),
    [anon_sym_DASH_GT_GT] = ACTIONS(2293),
    [anon_sym_DASH_GT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2295),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2293),
    [anon_sym_DOLLAR] = ACTIONS(2293),
    [anon_sym_AT] = ACTIONS(2293),
    [sym_dots] = ACTIONS(2295),
    [anon_sym_PIPE_GT] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_BANG] = ACTIONS(2295),
    [anon_sym_TILDE] = ACTIONS(2293),
    [anon_sym_STAR] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_LT_EQ] = ACTIONS(2293),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2293),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_COLON] = ACTIONS(2295),
    [sym_break] = ACTIONS(2295),
    [sym_next] = ACTIONS(2295),
    [sym_true] = ACTIONS(2295),
    [sym_false] = ACTIONS(2295),
    [sym_null] = ACTIONS(2295),
    [sym_inf] = ACTIONS(2295),
    [sym_nan] = ACTIONS(2295),
    [anon_sym_NA] = ACTIONS(2295),
    [anon_sym_NA_character_] = ACTIONS(2295),
    [anon_sym_NA_complex_] = ACTIONS(2295),
    [anon_sym_NA_integer_] = ACTIONS(2295),
    [anon_sym_NA_real_] = ACTIONS(2295),
    [aux_sym_identifier_token1] = ACTIONS(2295),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_integer] = ACTIONS(2293),
    [sym_float] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [anon_sym_SQUOTE] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
  },
  [606] = {
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_function] = ACTIONS(2291),
    [anon_sym_BSLASH] = ACTIONS(2289),
    [anon_sym_if] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(2289),
    [anon_sym_RPAREN] = ACTIONS(2289),
    [anon_sym_while] = ACTIONS(2291),
    [anon_sym_repeat] = ACTIONS(2291),
    [anon_sym_for] = ACTIONS(2291),
    [anon_sym_switch] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(2289),
    [anon_sym_EQ] = ACTIONS(2291),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_LT_DASH] = ACTIONS(2289),
    [anon_sym_COLON_EQ] = ACTIONS(2289),
    [anon_sym_LT_LT_DASH] = ACTIONS(2289),
    [anon_sym_DASH_GT_GT] = ACTIONS(2289),
    [anon_sym_DASH_GT] = ACTIONS(2291),
    [anon_sym_LBRACK] = ACTIONS(2291),
    [anon_sym_RBRACK] = ACTIONS(2289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2289),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_AT] = ACTIONS(2289),
    [sym_dots] = ACTIONS(2291),
    [anon_sym_PIPE_GT] = ACTIONS(2289),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_BANG] = ACTIONS(2291),
    [anon_sym_TILDE] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_SLASH] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2289),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2289),
    [anon_sym_GT_EQ] = ACTIONS(2289),
    [anon_sym_EQ_EQ] = ACTIONS(2289),
    [anon_sym_BANG_EQ] = ACTIONS(2289),
    [anon_sym_PIPE_PIPE] = ACTIONS(2289),
    [anon_sym_PIPE] = ACTIONS(2291),
    [anon_sym_AMP_AMP] = ACTIONS(2289),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON] = ACTIONS(2291),
    [sym_break] = ACTIONS(2291),
    [sym_next] = ACTIONS(2291),
    [sym_true] = ACTIONS(2291),
    [sym_false] = ACTIONS(2291),
    [sym_null] = ACTIONS(2291),
    [sym_inf] = ACTIONS(2291),
    [sym_nan] = ACTIONS(2291),
    [anon_sym_NA] = ACTIONS(2291),
    [anon_sym_NA_character_] = ACTIONS(2291),
    [anon_sym_NA_complex_] = ACTIONS(2291),
    [anon_sym_NA_integer_] = ACTIONS(2291),
    [anon_sym_NA_real_] = ACTIONS(2291),
    [aux_sym_identifier_token1] = ACTIONS(2291),
    [anon_sym_BQUOTE] = ACTIONS(2289),
    [sym_integer] = ACTIONS(2289),
    [sym_float] = ACTIONS(2291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2289),
    [anon_sym_SQUOTE] = ACTIONS(2289),
    [anon_sym_PERCENT] = ACTIONS(2289),
  },
  [607] = {
    [anon_sym_SEMI] = ACTIONS(2285),
    [anon_sym_function] = ACTIONS(2287),
    [anon_sym_BSLASH] = ACTIONS(2285),
    [anon_sym_if] = ACTIONS(2287),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_RPAREN] = ACTIONS(2285),
    [anon_sym_while] = ACTIONS(2287),
    [anon_sym_repeat] = ACTIONS(2287),
    [anon_sym_for] = ACTIONS(2287),
    [anon_sym_switch] = ACTIONS(2287),
    [anon_sym_COMMA] = ACTIONS(2285),
    [anon_sym_EQ] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2285),
    [anon_sym_LT_DASH] = ACTIONS(2285),
    [anon_sym_COLON_EQ] = ACTIONS(2285),
    [anon_sym_LT_LT_DASH] = ACTIONS(2285),
    [anon_sym_DASH_GT_GT] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(2287),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_RBRACK] = ACTIONS(2285),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2285),
    [anon_sym_DOLLAR] = ACTIONS(2285),
    [anon_sym_AT] = ACTIONS(2285),
    [sym_dots] = ACTIONS(2287),
    [anon_sym_PIPE_GT] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2287),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2285),
    [anon_sym_SLASH] = ACTIONS(2285),
    [anon_sym_CARET] = ACTIONS(2285),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_LT_EQ] = ACTIONS(2285),
    [anon_sym_GT_EQ] = ACTIONS(2285),
    [anon_sym_EQ_EQ] = ACTIONS(2285),
    [anon_sym_BANG_EQ] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2285),
    [anon_sym_PIPE] = ACTIONS(2287),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2287),
    [sym_break] = ACTIONS(2287),
    [sym_next] = ACTIONS(2287),
    [sym_true] = ACTIONS(2287),
    [sym_false] = ACTIONS(2287),
    [sym_null] = ACTIONS(2287),
    [sym_inf] = ACTIONS(2287),
    [sym_nan] = ACTIONS(2287),
    [anon_sym_NA] = ACTIONS(2287),
    [anon_sym_NA_character_] = ACTIONS(2287),
    [anon_sym_NA_complex_] = ACTIONS(2287),
    [anon_sym_NA_integer_] = ACTIONS(2287),
    [anon_sym_NA_real_] = ACTIONS(2287),
    [aux_sym_identifier_token1] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2285),
    [sym_integer] = ACTIONS(2285),
    [sym_float] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_PERCENT] = ACTIONS(2285),
  },
  [608] = {
    [anon_sym_SEMI] = ACTIONS(2281),
    [anon_sym_function] = ACTIONS(2283),
    [anon_sym_BSLASH] = ACTIONS(2281),
    [anon_sym_if] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2281),
    [anon_sym_RPAREN] = ACTIONS(2281),
    [anon_sym_while] = ACTIONS(2283),
    [anon_sym_repeat] = ACTIONS(2283),
    [anon_sym_for] = ACTIONS(2283),
    [anon_sym_switch] = ACTIONS(2283),
    [anon_sym_COMMA] = ACTIONS(2281),
    [anon_sym_EQ] = ACTIONS(2283),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [anon_sym_LT_DASH] = ACTIONS(2281),
    [anon_sym_COLON_EQ] = ACTIONS(2281),
    [anon_sym_LT_LT_DASH] = ACTIONS(2281),
    [anon_sym_DASH_GT_GT] = ACTIONS(2281),
    [anon_sym_DASH_GT] = ACTIONS(2283),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_RBRACK] = ACTIONS(2281),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2281),
    [anon_sym_DOLLAR] = ACTIONS(2281),
    [anon_sym_AT] = ACTIONS(2281),
    [sym_dots] = ACTIONS(2283),
    [anon_sym_PIPE_GT] = ACTIONS(2281),
    [anon_sym_DASH] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(2281),
    [anon_sym_BANG] = ACTIONS(2283),
    [anon_sym_TILDE] = ACTIONS(2281),
    [anon_sym_STAR] = ACTIONS(2281),
    [anon_sym_SLASH] = ACTIONS(2281),
    [anon_sym_CARET] = ACTIONS(2281),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_LT_EQ] = ACTIONS(2281),
    [anon_sym_GT_EQ] = ACTIONS(2281),
    [anon_sym_EQ_EQ] = ACTIONS(2281),
    [anon_sym_BANG_EQ] = ACTIONS(2281),
    [anon_sym_PIPE_PIPE] = ACTIONS(2281),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_AMP_AMP] = ACTIONS(2281),
    [anon_sym_AMP] = ACTIONS(2283),
    [anon_sym_COLON] = ACTIONS(2283),
    [sym_break] = ACTIONS(2283),
    [sym_next] = ACTIONS(2283),
    [sym_true] = ACTIONS(2283),
    [sym_false] = ACTIONS(2283),
    [sym_null] = ACTIONS(2283),
    [sym_inf] = ACTIONS(2283),
    [sym_nan] = ACTIONS(2283),
    [anon_sym_NA] = ACTIONS(2283),
    [anon_sym_NA_character_] = ACTIONS(2283),
    [anon_sym_NA_complex_] = ACTIONS(2283),
    [anon_sym_NA_integer_] = ACTIONS(2283),
    [anon_sym_NA_real_] = ACTIONS(2283),
    [aux_sym_identifier_token1] = ACTIONS(2283),
    [anon_sym_BQUOTE] = ACTIONS(2281),
    [sym_integer] = ACTIONS(2281),
    [sym_float] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2281),
    [anon_sym_SQUOTE] = ACTIONS(2281),
    [anon_sym_PERCENT] = ACTIONS(2281),
  },
  [609] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [610] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(2129),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [611] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(2129),
    [anon_sym_LF] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_LT_DASH] = ACTIONS(2131),
    [anon_sym_COLON_EQ] = ACTIONS(2131),
    [anon_sym_LT_LT_DASH] = ACTIONS(2131),
    [anon_sym_DASH_GT_GT] = ACTIONS(2131),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_integer] = ACTIONS(2131),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [612] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_BSLASH] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_repeat] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_RBRACE] = ACTIONS(1381),
    [anon_sym_LT_DASH] = ACTIONS(2523),
    [anon_sym_COLON_EQ] = ACTIONS(2525),
    [anon_sym_LT_LT_DASH] = ACTIONS(2527),
    [anon_sym_DASH_GT_GT] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1381),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1381),
    [sym_next] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_inf] = ACTIONS(1381),
    [sym_nan] = ACTIONS(1381),
    [anon_sym_NA] = ACTIONS(1381),
    [anon_sym_NA_character_] = ACTIONS(1381),
    [anon_sym_NA_complex_] = ACTIONS(1381),
    [anon_sym_NA_integer_] = ACTIONS(1381),
    [anon_sym_NA_real_] = ACTIONS(1381),
    [aux_sym_identifier_token1] = ACTIONS(1381),
    [anon_sym_BQUOTE] = ACTIONS(1381),
    [sym_integer] = ACTIONS(1381),
    [sym_float] = ACTIONS(1381),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1381),
    [anon_sym_SQUOTE] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [613] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1365),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_RBRACE] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(2523),
    [anon_sym_COLON_EQ] = ACTIONS(2525),
    [anon_sym_LT_LT_DASH] = ACTIONS(2527),
    [anon_sym_DASH_GT_GT] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1365),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [aux_sym_identifier_token1] = ACTIONS(1365),
    [anon_sym_BQUOTE] = ACTIONS(1365),
    [sym_integer] = ACTIONS(1365),
    [sym_float] = ACTIONS(1365),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [614] = {
    [anon_sym_LF] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2381),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_BSLASH] = ACTIONS(2381),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2381),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_repeat] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_EQ] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2381),
    [anon_sym_RBRACE] = ACTIONS(2381),
    [anon_sym_LT_DASH] = ACTIONS(2381),
    [anon_sym_COLON_EQ] = ACTIONS(2381),
    [anon_sym_LT_LT_DASH] = ACTIONS(2381),
    [anon_sym_DASH_GT_GT] = ACTIONS(2381),
    [anon_sym_DASH_GT] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2381),
    [anon_sym_DOLLAR] = ACTIONS(2381),
    [anon_sym_AT] = ACTIONS(2381),
    [sym_dots] = ACTIONS(2381),
    [anon_sym_PIPE_GT] = ACTIONS(2381),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2381),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [anon_sym_STAR] = ACTIONS(2381),
    [anon_sym_SLASH] = ACTIONS(2381),
    [anon_sym_CARET] = ACTIONS(2381),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_GT] = ACTIONS(2381),
    [anon_sym_LT_EQ] = ACTIONS(2381),
    [anon_sym_GT_EQ] = ACTIONS(2381),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2381),
    [anon_sym_PIPE] = ACTIONS(2381),
    [anon_sym_AMP_AMP] = ACTIONS(2381),
    [anon_sym_AMP] = ACTIONS(2381),
    [anon_sym_COLON] = ACTIONS(2381),
    [sym_break] = ACTIONS(2381),
    [sym_next] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_inf] = ACTIONS(2381),
    [sym_nan] = ACTIONS(2381),
    [anon_sym_NA] = ACTIONS(2381),
    [anon_sym_NA_character_] = ACTIONS(2381),
    [anon_sym_NA_complex_] = ACTIONS(2381),
    [anon_sym_NA_integer_] = ACTIONS(2381),
    [anon_sym_NA_real_] = ACTIONS(2381),
    [aux_sym_identifier_token1] = ACTIONS(2381),
    [anon_sym_BQUOTE] = ACTIONS(2381),
    [sym_integer] = ACTIONS(2381),
    [sym_float] = ACTIONS(2381),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2381),
    [anon_sym_SQUOTE] = ACTIONS(2381),
    [anon_sym_PERCENT] = ACTIONS(2381),
  },
  [615] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1361),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(1361),
    [anon_sym_RBRACE] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(2523),
    [anon_sym_COLON_EQ] = ACTIONS(2525),
    [anon_sym_LT_LT_DASH] = ACTIONS(2527),
    [anon_sym_DASH_GT_GT] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(1361),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [aux_sym_identifier_token1] = ACTIONS(1361),
    [anon_sym_BQUOTE] = ACTIONS(1361),
    [sym_integer] = ACTIONS(1361),
    [sym_float] = ACTIONS(1361),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(2375),
    [anon_sym_LF] = ACTIONS(2377),
    [anon_sym_SEMI] = ACTIONS(2377),
    [anon_sym_function] = ACTIONS(2377),
    [anon_sym_BSLASH] = ACTIONS(2377),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2377),
    [anon_sym_else] = ACTIONS(2377),
    [anon_sym_while] = ACTIONS(2377),
    [anon_sym_repeat] = ACTIONS(2377),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_switch] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2377),
    [anon_sym_LT_DASH] = ACTIONS(2377),
    [anon_sym_COLON_EQ] = ACTIONS(2377),
    [anon_sym_LT_LT_DASH] = ACTIONS(2377),
    [anon_sym_DASH_GT_GT] = ACTIONS(2377),
    [anon_sym_DASH_GT] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2377),
    [anon_sym_DOLLAR] = ACTIONS(2377),
    [anon_sym_AT] = ACTIONS(2377),
    [sym_dots] = ACTIONS(2377),
    [anon_sym_PIPE_GT] = ACTIONS(2377),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2377),
    [anon_sym_STAR] = ACTIONS(2377),
    [anon_sym_SLASH] = ACTIONS(2377),
    [anon_sym_CARET] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_AMP] = ACTIONS(2377),
    [anon_sym_COLON] = ACTIONS(2377),
    [sym_break] = ACTIONS(2377),
    [sym_next] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_null] = ACTIONS(2377),
    [sym_inf] = ACTIONS(2377),
    [sym_nan] = ACTIONS(2377),
    [anon_sym_NA] = ACTIONS(2377),
    [anon_sym_NA_character_] = ACTIONS(2377),
    [anon_sym_NA_complex_] = ACTIONS(2377),
    [anon_sym_NA_integer_] = ACTIONS(2377),
    [anon_sym_NA_real_] = ACTIONS(2377),
    [aux_sym_identifier_token1] = ACTIONS(2377),
    [anon_sym_BQUOTE] = ACTIONS(2377),
    [sym_integer] = ACTIONS(2377),
    [sym_float] = ACTIONS(2377),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2377),
    [anon_sym_SQUOTE] = ACTIONS(2377),
    [anon_sym_PERCENT] = ACTIONS(2377),
  },
  [617] = {
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym_function] = ACTIONS(2371),
    [anon_sym_BSLASH] = ACTIONS(2371),
    [anon_sym_if] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_else] = ACTIONS(2371),
    [anon_sym_while] = ACTIONS(2371),
    [anon_sym_repeat] = ACTIONS(2371),
    [anon_sym_for] = ACTIONS(2371),
    [anon_sym_switch] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_LT_DASH] = ACTIONS(2371),
    [anon_sym_COLON_EQ] = ACTIONS(2371),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_DASH_GT_GT] = ACTIONS(2371),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2371),
    [anon_sym_AT] = ACTIONS(2371),
    [sym_dots] = ACTIONS(2371),
    [anon_sym_PIPE_GT] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_SLASH] = ACTIONS(2371),
    [anon_sym_CARET] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2371),
    [sym_break] = ACTIONS(2371),
    [sym_next] = ACTIONS(2371),
    [sym_true] = ACTIONS(2371),
    [sym_false] = ACTIONS(2371),
    [sym_null] = ACTIONS(2371),
    [sym_inf] = ACTIONS(2371),
    [sym_nan] = ACTIONS(2371),
    [anon_sym_NA] = ACTIONS(2371),
    [anon_sym_NA_character_] = ACTIONS(2371),
    [anon_sym_NA_complex_] = ACTIONS(2371),
    [anon_sym_NA_integer_] = ACTIONS(2371),
    [anon_sym_NA_real_] = ACTIONS(2371),
    [aux_sym_identifier_token1] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [sym_integer] = ACTIONS(2371),
    [sym_float] = ACTIONS(2371),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_PERCENT] = ACTIONS(2371),
  },
  [618] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(2309),
    [anon_sym_function] = ACTIONS(2311),
    [anon_sym_BSLASH] = ACTIONS(2309),
    [anon_sym_if] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2311),
    [anon_sym_repeat] = ACTIONS(2311),
    [anon_sym_for] = ACTIONS(2311),
    [anon_sym_switch] = ACTIONS(2311),
    [anon_sym_COMMA] = ACTIONS(2309),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2309),
    [anon_sym_LT_DASH] = ACTIONS(2541),
    [anon_sym_COLON_EQ] = ACTIONS(2543),
    [anon_sym_LT_LT_DASH] = ACTIONS(2545),
    [anon_sym_DASH_GT_GT] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2309),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(2311),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(2311),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(2311),
    [sym_next] = ACTIONS(2311),
    [sym_true] = ACTIONS(2311),
    [sym_false] = ACTIONS(2311),
    [sym_null] = ACTIONS(2311),
    [sym_inf] = ACTIONS(2311),
    [sym_nan] = ACTIONS(2311),
    [anon_sym_NA] = ACTIONS(2311),
    [anon_sym_NA_character_] = ACTIONS(2311),
    [anon_sym_NA_complex_] = ACTIONS(2311),
    [anon_sym_NA_integer_] = ACTIONS(2311),
    [anon_sym_NA_real_] = ACTIONS(2311),
    [aux_sym_identifier_token1] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2309),
    [sym_integer] = ACTIONS(2309),
    [sym_float] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2309),
    [anon_sym_SQUOTE] = ACTIONS(2309),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [619] = {
    [anon_sym_SEMI] = ACTIONS(2277),
    [anon_sym_function] = ACTIONS(2279),
    [anon_sym_BSLASH] = ACTIONS(2277),
    [anon_sym_if] = ACTIONS(2279),
    [anon_sym_LPAREN] = ACTIONS(2277),
    [anon_sym_RPAREN] = ACTIONS(2277),
    [anon_sym_while] = ACTIONS(2279),
    [anon_sym_repeat] = ACTIONS(2279),
    [anon_sym_for] = ACTIONS(2279),
    [anon_sym_switch] = ACTIONS(2279),
    [anon_sym_COMMA] = ACTIONS(2277),
    [anon_sym_EQ] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(2277),
    [anon_sym_LT_DASH] = ACTIONS(2277),
    [anon_sym_COLON_EQ] = ACTIONS(2277),
    [anon_sym_LT_LT_DASH] = ACTIONS(2277),
    [anon_sym_DASH_GT_GT] = ACTIONS(2277),
    [anon_sym_DASH_GT] = ACTIONS(2279),
    [anon_sym_LBRACK] = ACTIONS(2279),
    [anon_sym_RBRACK] = ACTIONS(2277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2277),
    [anon_sym_DOLLAR] = ACTIONS(2277),
    [anon_sym_AT] = ACTIONS(2277),
    [sym_dots] = ACTIONS(2279),
    [anon_sym_PIPE_GT] = ACTIONS(2277),
    [anon_sym_DASH] = ACTIONS(2279),
    [anon_sym_PLUS] = ACTIONS(2277),
    [anon_sym_BANG] = ACTIONS(2279),
    [anon_sym_TILDE] = ACTIONS(2277),
    [anon_sym_STAR] = ACTIONS(2277),
    [anon_sym_SLASH] = ACTIONS(2277),
    [anon_sym_CARET] = ACTIONS(2277),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_LT_EQ] = ACTIONS(2277),
    [anon_sym_GT_EQ] = ACTIONS(2277),
    [anon_sym_EQ_EQ] = ACTIONS(2277),
    [anon_sym_BANG_EQ] = ACTIONS(2277),
    [anon_sym_PIPE_PIPE] = ACTIONS(2277),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_AMP] = ACTIONS(2279),
    [anon_sym_COLON] = ACTIONS(2279),
    [sym_break] = ACTIONS(2279),
    [sym_next] = ACTIONS(2279),
    [sym_true] = ACTIONS(2279),
    [sym_false] = ACTIONS(2279),
    [sym_null] = ACTIONS(2279),
    [sym_inf] = ACTIONS(2279),
    [sym_nan] = ACTIONS(2279),
    [anon_sym_NA] = ACTIONS(2279),
    [anon_sym_NA_character_] = ACTIONS(2279),
    [anon_sym_NA_complex_] = ACTIONS(2279),
    [anon_sym_NA_integer_] = ACTIONS(2279),
    [anon_sym_NA_real_] = ACTIONS(2279),
    [aux_sym_identifier_token1] = ACTIONS(2279),
    [anon_sym_BQUOTE] = ACTIONS(2277),
    [sym_integer] = ACTIONS(2277),
    [sym_float] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2277),
    [anon_sym_SQUOTE] = ACTIONS(2277),
    [anon_sym_PERCENT] = ACTIONS(2277),
  },
  [620] = {
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym_function] = ACTIONS(2275),
    [anon_sym_BSLASH] = ACTIONS(2273),
    [anon_sym_if] = ACTIONS(2275),
    [anon_sym_LPAREN] = ACTIONS(2273),
    [anon_sym_RPAREN] = ACTIONS(2273),
    [anon_sym_while] = ACTIONS(2275),
    [anon_sym_repeat] = ACTIONS(2275),
    [anon_sym_for] = ACTIONS(2275),
    [anon_sym_switch] = ACTIONS(2275),
    [anon_sym_COMMA] = ACTIONS(2273),
    [anon_sym_EQ] = ACTIONS(2275),
    [anon_sym_LBRACE] = ACTIONS(2273),
    [anon_sym_LT_DASH] = ACTIONS(2273),
    [anon_sym_COLON_EQ] = ACTIONS(2273),
    [anon_sym_LT_LT_DASH] = ACTIONS(2273),
    [anon_sym_DASH_GT_GT] = ACTIONS(2273),
    [anon_sym_DASH_GT] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_RBRACK] = ACTIONS(2273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2273),
    [anon_sym_DOLLAR] = ACTIONS(2273),
    [anon_sym_AT] = ACTIONS(2273),
    [sym_dots] = ACTIONS(2275),
    [anon_sym_PIPE_GT] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2275),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_CARET] = ACTIONS(2273),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_LT_EQ] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2273),
    [anon_sym_EQ_EQ] = ACTIONS(2273),
    [anon_sym_BANG_EQ] = ACTIONS(2273),
    [anon_sym_PIPE_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE] = ACTIONS(2275),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_COLON] = ACTIONS(2275),
    [sym_break] = ACTIONS(2275),
    [sym_next] = ACTIONS(2275),
    [sym_true] = ACTIONS(2275),
    [sym_false] = ACTIONS(2275),
    [sym_null] = ACTIONS(2275),
    [sym_inf] = ACTIONS(2275),
    [sym_nan] = ACTIONS(2275),
    [anon_sym_NA] = ACTIONS(2275),
    [anon_sym_NA_character_] = ACTIONS(2275),
    [anon_sym_NA_complex_] = ACTIONS(2275),
    [anon_sym_NA_integer_] = ACTIONS(2275),
    [anon_sym_NA_real_] = ACTIONS(2275),
    [aux_sym_identifier_token1] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(2273),
    [sym_integer] = ACTIONS(2273),
    [sym_float] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2273),
    [anon_sym_SQUOTE] = ACTIONS(2273),
    [anon_sym_PERCENT] = ACTIONS(2273),
  },
  [621] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2123),
    [anon_sym_BSLASH] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2123),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2123),
    [anon_sym_repeat] = ACTIONS(2123),
    [anon_sym_for] = ACTIONS(2123),
    [anon_sym_switch] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2121),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_LT_DASH] = ACTIONS(2541),
    [anon_sym_COLON_EQ] = ACTIONS(2543),
    [anon_sym_LT_LT_DASH] = ACTIONS(2545),
    [anon_sym_DASH_GT_GT] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2121),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(2123),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(2123),
    [sym_next] = ACTIONS(2123),
    [sym_true] = ACTIONS(2123),
    [sym_false] = ACTIONS(2123),
    [sym_null] = ACTIONS(2123),
    [sym_inf] = ACTIONS(2123),
    [sym_nan] = ACTIONS(2123),
    [anon_sym_NA] = ACTIONS(2123),
    [anon_sym_NA_character_] = ACTIONS(2123),
    [anon_sym_NA_complex_] = ACTIONS(2123),
    [anon_sym_NA_integer_] = ACTIONS(2123),
    [anon_sym_NA_real_] = ACTIONS(2123),
    [aux_sym_identifier_token1] = ACTIONS(2123),
    [anon_sym_BQUOTE] = ACTIONS(2121),
    [sym_integer] = ACTIONS(2121),
    [sym_float] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2121),
    [anon_sym_SQUOTE] = ACTIONS(2121),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [622] = {
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym_function] = ACTIONS(2271),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_LPAREN] = ACTIONS(2269),
    [anon_sym_RPAREN] = ACTIONS(2269),
    [anon_sym_while] = ACTIONS(2271),
    [anon_sym_repeat] = ACTIONS(2271),
    [anon_sym_for] = ACTIONS(2271),
    [anon_sym_switch] = ACTIONS(2271),
    [anon_sym_COMMA] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2271),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_LT_DASH] = ACTIONS(2269),
    [anon_sym_COLON_EQ] = ACTIONS(2269),
    [anon_sym_LT_LT_DASH] = ACTIONS(2269),
    [anon_sym_DASH_GT_GT] = ACTIONS(2269),
    [anon_sym_DASH_GT] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_RBRACK] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym_DOLLAR] = ACTIONS(2269),
    [anon_sym_AT] = ACTIONS(2269),
    [sym_dots] = ACTIONS(2271),
    [anon_sym_PIPE_GT] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2271),
    [anon_sym_PLUS] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2271),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2271),
    [anon_sym_GT] = ACTIONS(2271),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2271),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym_COLON] = ACTIONS(2271),
    [sym_break] = ACTIONS(2271),
    [sym_next] = ACTIONS(2271),
    [sym_true] = ACTIONS(2271),
    [sym_false] = ACTIONS(2271),
    [sym_null] = ACTIONS(2271),
    [sym_inf] = ACTIONS(2271),
    [sym_nan] = ACTIONS(2271),
    [anon_sym_NA] = ACTIONS(2271),
    [anon_sym_NA_character_] = ACTIONS(2271),
    [anon_sym_NA_complex_] = ACTIONS(2271),
    [anon_sym_NA_integer_] = ACTIONS(2271),
    [anon_sym_NA_real_] = ACTIONS(2271),
    [aux_sym_identifier_token1] = ACTIONS(2271),
    [anon_sym_BQUOTE] = ACTIONS(2269),
    [sym_integer] = ACTIONS(2269),
    [sym_float] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2269),
    [anon_sym_SQUOTE] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2269),
  },
  [623] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2129),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2131),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2129),
    [anon_sym_GT_EQ] = ACTIONS(2129),
    [anon_sym_EQ_EQ] = ACTIONS(2129),
    [anon_sym_BANG_EQ] = ACTIONS(2129),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2131),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(2129),
  },
  [624] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2129),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [625] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_BSLASH] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_repeat] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LT_DASH] = ACTIONS(2129),
    [anon_sym_COLON_EQ] = ACTIONS(2129),
    [anon_sym_LT_LT_DASH] = ACTIONS(2129),
    [anon_sym_DASH_GT_GT] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2129),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(2131),
    [anon_sym_PIPE_GT] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(2131),
    [sym_next] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_inf] = ACTIONS(2131),
    [sym_nan] = ACTIONS(2131),
    [anon_sym_NA] = ACTIONS(2131),
    [anon_sym_NA_character_] = ACTIONS(2131),
    [anon_sym_NA_complex_] = ACTIONS(2131),
    [anon_sym_NA_integer_] = ACTIONS(2131),
    [anon_sym_NA_real_] = ACTIONS(2131),
    [aux_sym_identifier_token1] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_integer] = ACTIONS(2129),
    [sym_float] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [626] = {
    [anon_sym_LF] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2367),
    [anon_sym_function] = ACTIONS(2367),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2367),
    [anon_sym_else] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_repeat] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_EQ] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_RBRACE] = ACTIONS(2367),
    [anon_sym_LT_DASH] = ACTIONS(2367),
    [anon_sym_COLON_EQ] = ACTIONS(2367),
    [anon_sym_LT_LT_DASH] = ACTIONS(2367),
    [anon_sym_DASH_GT_GT] = ACTIONS(2367),
    [anon_sym_DASH_GT] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2367),
    [anon_sym_DOLLAR] = ACTIONS(2367),
    [anon_sym_AT] = ACTIONS(2367),
    [sym_dots] = ACTIONS(2367),
    [anon_sym_PIPE_GT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2367),
    [anon_sym_BANG] = ACTIONS(2367),
    [anon_sym_TILDE] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_CARET] = ACTIONS(2367),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_EQ_EQ] = ACTIONS(2367),
    [anon_sym_BANG_EQ] = ACTIONS(2367),
    [anon_sym_PIPE_PIPE] = ACTIONS(2367),
    [anon_sym_PIPE] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [sym_break] = ACTIONS(2367),
    [sym_next] = ACTIONS(2367),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [sym_null] = ACTIONS(2367),
    [sym_inf] = ACTIONS(2367),
    [sym_nan] = ACTIONS(2367),
    [anon_sym_NA] = ACTIONS(2367),
    [anon_sym_NA_character_] = ACTIONS(2367),
    [anon_sym_NA_complex_] = ACTIONS(2367),
    [anon_sym_NA_integer_] = ACTIONS(2367),
    [anon_sym_NA_real_] = ACTIONS(2367),
    [aux_sym_identifier_token1] = ACTIONS(2367),
    [anon_sym_BQUOTE] = ACTIONS(2367),
    [sym_integer] = ACTIONS(2367),
    [sym_float] = ACTIONS(2367),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2367),
    [anon_sym_SQUOTE] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
  },
  [627] = {
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym_function] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2265),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_LPAREN] = ACTIONS(2265),
    [anon_sym_RPAREN] = ACTIONS(2265),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_repeat] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(2265),
    [anon_sym_EQ] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_LT_DASH] = ACTIONS(2265),
    [anon_sym_COLON_EQ] = ACTIONS(2265),
    [anon_sym_LT_LT_DASH] = ACTIONS(2265),
    [anon_sym_DASH_GT_GT] = ACTIONS(2265),
    [anon_sym_DASH_GT] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_RBRACK] = ACTIONS(2265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym_DOLLAR] = ACTIONS(2265),
    [anon_sym_AT] = ACTIONS(2265),
    [sym_dots] = ACTIONS(2267),
    [anon_sym_PIPE_GT] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_SLASH] = ACTIONS(2265),
    [anon_sym_CARET] = ACTIONS(2265),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_GT] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2265),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_EQ_EQ] = ACTIONS(2265),
    [anon_sym_BANG_EQ] = ACTIONS(2265),
    [anon_sym_PIPE_PIPE] = ACTIONS(2265),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_COLON] = ACTIONS(2267),
    [sym_break] = ACTIONS(2267),
    [sym_next] = ACTIONS(2267),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [sym_null] = ACTIONS(2267),
    [sym_inf] = ACTIONS(2267),
    [sym_nan] = ACTIONS(2267),
    [anon_sym_NA] = ACTIONS(2267),
    [anon_sym_NA_character_] = ACTIONS(2267),
    [anon_sym_NA_complex_] = ACTIONS(2267),
    [anon_sym_NA_integer_] = ACTIONS(2267),
    [anon_sym_NA_real_] = ACTIONS(2267),
    [aux_sym_identifier_token1] = ACTIONS(2267),
    [anon_sym_BQUOTE] = ACTIONS(2265),
    [sym_integer] = ACTIONS(2265),
    [sym_float] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_PERCENT] = ACTIONS(2265),
  },
  [628] = {
    [anon_sym_LF] = ACTIONS(2363),
    [anon_sym_SEMI] = ACTIONS(2363),
    [anon_sym_function] = ACTIONS(2363),
    [anon_sym_BSLASH] = ACTIONS(2363),
    [anon_sym_if] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_else] = ACTIONS(2363),
    [anon_sym_while] = ACTIONS(2363),
    [anon_sym_repeat] = ACTIONS(2363),
    [anon_sym_for] = ACTIONS(2363),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_EQ] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2363),
    [anon_sym_RBRACE] = ACTIONS(2363),
    [anon_sym_LT_DASH] = ACTIONS(2363),
    [anon_sym_COLON_EQ] = ACTIONS(2363),
    [anon_sym_LT_LT_DASH] = ACTIONS(2363),
    [anon_sym_DASH_GT_GT] = ACTIONS(2363),
    [anon_sym_DASH_GT] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2363),
    [anon_sym_DOLLAR] = ACTIONS(2363),
    [anon_sym_AT] = ACTIONS(2363),
    [sym_dots] = ACTIONS(2363),
    [anon_sym_PIPE_GT] = ACTIONS(2363),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(2363),
    [anon_sym_TILDE] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2363),
    [anon_sym_CARET] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2363),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_EQ] = ACTIONS(2363),
    [anon_sym_PIPE_PIPE] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_AMP_AMP] = ACTIONS(2363),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2363),
    [sym_break] = ACTIONS(2363),
    [sym_next] = ACTIONS(2363),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [sym_null] = ACTIONS(2363),
    [sym_inf] = ACTIONS(2363),
    [sym_nan] = ACTIONS(2363),
    [anon_sym_NA] = ACTIONS(2363),
    [anon_sym_NA_character_] = ACTIONS(2363),
    [anon_sym_NA_complex_] = ACTIONS(2363),
    [anon_sym_NA_integer_] = ACTIONS(2363),
    [anon_sym_NA_real_] = ACTIONS(2363),
    [aux_sym_identifier_token1] = ACTIONS(2363),
    [anon_sym_BQUOTE] = ACTIONS(2363),
    [sym_integer] = ACTIONS(2363),
    [sym_float] = ACTIONS(2363),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2363),
    [anon_sym_SQUOTE] = ACTIONS(2363),
    [anon_sym_PERCENT] = ACTIONS(2363),
  },
  [629] = {
    [ts_builtin_sym_end] = ACTIONS(2201),
    [anon_sym_LF] = ACTIONS(2203),
    [anon_sym_SEMI] = ACTIONS(2203),
    [anon_sym_function] = ACTIONS(2203),
    [anon_sym_BSLASH] = ACTIONS(2203),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_while] = ACTIONS(2203),
    [anon_sym_repeat] = ACTIONS(2203),
    [anon_sym_for] = ACTIONS(2203),
    [anon_sym_switch] = ACTIONS(2203),
    [anon_sym_EQ] = ACTIONS(2203),
    [anon_sym_LBRACE] = ACTIONS(2203),
    [anon_sym_LT_DASH] = ACTIONS(2203),
    [anon_sym_COLON_EQ] = ACTIONS(2203),
    [anon_sym_LT_LT_DASH] = ACTIONS(2203),
    [anon_sym_DASH_GT_GT] = ACTIONS(2203),
    [anon_sym_DASH_GT] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2203),
    [anon_sym_DOLLAR] = ACTIONS(2203),
    [anon_sym_AT] = ACTIONS(2203),
    [sym_dots] = ACTIONS(2203),
    [anon_sym_PIPE_GT] = ACTIONS(2203),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(2203),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2203),
    [anon_sym_GT_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ] = ACTIONS(2203),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_COLON] = ACTIONS(2203),
    [sym_break] = ACTIONS(2203),
    [sym_next] = ACTIONS(2203),
    [sym_true] = ACTIONS(2203),
    [sym_false] = ACTIONS(2203),
    [sym_null] = ACTIONS(2203),
    [sym_inf] = ACTIONS(2203),
    [sym_nan] = ACTIONS(2203),
    [anon_sym_NA] = ACTIONS(2203),
    [anon_sym_NA_character_] = ACTIONS(2203),
    [anon_sym_NA_complex_] = ACTIONS(2203),
    [anon_sym_NA_integer_] = ACTIONS(2203),
    [anon_sym_NA_real_] = ACTIONS(2203),
    [aux_sym_identifier_token1] = ACTIONS(2203),
    [anon_sym_BQUOTE] = ACTIONS(2203),
    [sym_integer] = ACTIONS(2203),
    [sym_float] = ACTIONS(2203),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2203),
    [anon_sym_SQUOTE] = ACTIONS(2203),
    [anon_sym_PERCENT] = ACTIONS(2203),
  },
  [630] = {
    [anon_sym_LF] = ACTIONS(2307),
    [anon_sym_SEMI] = ACTIONS(2307),
    [anon_sym_function] = ACTIONS(2307),
    [anon_sym_BSLASH] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(2307),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_repeat] = ACTIONS(2307),
    [anon_sym_for] = ACTIONS(2307),
    [anon_sym_switch] = ACTIONS(2307),
    [anon_sym_EQ] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_LT_DASH] = ACTIONS(2307),
    [anon_sym_COLON_EQ] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_DASH_GT_GT] = ACTIONS(2307),
    [anon_sym_DASH_GT] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_AT] = ACTIONS(2307),
    [sym_dots] = ACTIONS(2307),
    [anon_sym_PIPE_GT] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(2307),
    [anon_sym_TILDE] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2307),
    [anon_sym_CARET] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_COLON] = ACTIONS(2307),
    [sym_break] = ACTIONS(2307),
    [sym_next] = ACTIONS(2307),
    [sym_true] = ACTIONS(2307),
    [sym_false] = ACTIONS(2307),
    [sym_null] = ACTIONS(2307),
    [sym_inf] = ACTIONS(2307),
    [sym_nan] = ACTIONS(2307),
    [anon_sym_NA] = ACTIONS(2307),
    [anon_sym_NA_character_] = ACTIONS(2307),
    [anon_sym_NA_complex_] = ACTIONS(2307),
    [anon_sym_NA_integer_] = ACTIONS(2307),
    [anon_sym_NA_real_] = ACTIONS(2307),
    [aux_sym_identifier_token1] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [sym_integer] = ACTIONS(2307),
    [sym_float] = ACTIONS(2307),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2307),
  },
  [631] = {
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2215),
    [anon_sym_BSLASH] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_RPAREN] = ACTIONS(2213),
    [anon_sym_while] = ACTIONS(2215),
    [anon_sym_repeat] = ACTIONS(2215),
    [anon_sym_for] = ACTIONS(2215),
    [anon_sym_switch] = ACTIONS(2215),
    [anon_sym_COMMA] = ACTIONS(2213),
    [anon_sym_EQ] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_LT_DASH] = ACTIONS(2213),
    [anon_sym_COLON_EQ] = ACTIONS(2213),
    [anon_sym_LT_LT_DASH] = ACTIONS(2213),
    [anon_sym_DASH_GT_GT] = ACTIONS(2213),
    [anon_sym_DASH_GT] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_RBRACK] = ACTIONS(2213),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2213),
    [anon_sym_DOLLAR] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2213),
    [sym_dots] = ACTIONS(2215),
    [anon_sym_PIPE_GT] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2215),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_LT_EQ] = ACTIONS(2213),
    [anon_sym_GT_EQ] = ACTIONS(2213),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2213),
    [anon_sym_PIPE_PIPE] = ACTIONS(2213),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_COLON] = ACTIONS(2215),
    [sym_break] = ACTIONS(2215),
    [sym_next] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_null] = ACTIONS(2215),
    [sym_inf] = ACTIONS(2215),
    [sym_nan] = ACTIONS(2215),
    [anon_sym_NA] = ACTIONS(2215),
    [anon_sym_NA_character_] = ACTIONS(2215),
    [anon_sym_NA_complex_] = ACTIONS(2215),
    [anon_sym_NA_integer_] = ACTIONS(2215),
    [anon_sym_NA_real_] = ACTIONS(2215),
    [aux_sym_identifier_token1] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_integer] = ACTIONS(2213),
    [sym_float] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_PERCENT] = ACTIONS(2213),
  },
  [632] = {
    [anon_sym_SEMI] = ACTIONS(2209),
    [anon_sym_function] = ACTIONS(2211),
    [anon_sym_BSLASH] = ACTIONS(2209),
    [anon_sym_if] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(2209),
    [anon_sym_RPAREN] = ACTIONS(2209),
    [anon_sym_while] = ACTIONS(2211),
    [anon_sym_repeat] = ACTIONS(2211),
    [anon_sym_for] = ACTIONS(2211),
    [anon_sym_switch] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(2209),
    [anon_sym_EQ] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2209),
    [anon_sym_LT_DASH] = ACTIONS(2209),
    [anon_sym_COLON_EQ] = ACTIONS(2209),
    [anon_sym_LT_LT_DASH] = ACTIONS(2209),
    [anon_sym_DASH_GT_GT] = ACTIONS(2209),
    [anon_sym_DASH_GT] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(2209),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2209),
    [anon_sym_DOLLAR] = ACTIONS(2209),
    [anon_sym_AT] = ACTIONS(2209),
    [sym_dots] = ACTIONS(2211),
    [anon_sym_PIPE_GT] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2209),
    [anon_sym_SLASH] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2209),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_LT_EQ] = ACTIONS(2209),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ] = ACTIONS(2209),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_COLON] = ACTIONS(2211),
    [sym_break] = ACTIONS(2211),
    [sym_next] = ACTIONS(2211),
    [sym_true] = ACTIONS(2211),
    [sym_false] = ACTIONS(2211),
    [sym_null] = ACTIONS(2211),
    [sym_inf] = ACTIONS(2211),
    [sym_nan] = ACTIONS(2211),
    [anon_sym_NA] = ACTIONS(2211),
    [anon_sym_NA_character_] = ACTIONS(2211),
    [anon_sym_NA_complex_] = ACTIONS(2211),
    [anon_sym_NA_integer_] = ACTIONS(2211),
    [anon_sym_NA_real_] = ACTIONS(2211),
    [aux_sym_identifier_token1] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2209),
    [sym_integer] = ACTIONS(2209),
    [sym_float] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_PERCENT] = ACTIONS(2209),
  },
  [633] = {
    [anon_sym_LF] = ACTIONS(2303),
    [anon_sym_SEMI] = ACTIONS(2303),
    [anon_sym_function] = ACTIONS(2303),
    [anon_sym_BSLASH] = ACTIONS(2303),
    [anon_sym_if] = ACTIONS(2303),
    [anon_sym_LPAREN] = ACTIONS(2303),
    [anon_sym_else] = ACTIONS(2303),
    [anon_sym_while] = ACTIONS(2303),
    [anon_sym_repeat] = ACTIONS(2303),
    [anon_sym_for] = ACTIONS(2303),
    [anon_sym_switch] = ACTIONS(2303),
    [anon_sym_EQ] = ACTIONS(2303),
    [anon_sym_LBRACE] = ACTIONS(2303),
    [anon_sym_RBRACE] = ACTIONS(2303),
    [anon_sym_LT_DASH] = ACTIONS(2303),
    [anon_sym_COLON_EQ] = ACTIONS(2303),
    [anon_sym_LT_LT_DASH] = ACTIONS(2303),
    [anon_sym_DASH_GT_GT] = ACTIONS(2303),
    [anon_sym_DASH_GT] = ACTIONS(2303),
    [anon_sym_LBRACK] = ACTIONS(2303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2303),
    [sym_dots] = ACTIONS(2303),
    [anon_sym_PIPE_GT] = ACTIONS(2303),
    [anon_sym_DASH] = ACTIONS(2303),
    [anon_sym_PLUS] = ACTIONS(2303),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [anon_sym_STAR] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [anon_sym_GT_EQ] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_BANG_EQ] = ACTIONS(2303),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_COLON] = ACTIONS(2303),
    [sym_break] = ACTIONS(2303),
    [sym_next] = ACTIONS(2303),
    [sym_true] = ACTIONS(2303),
    [sym_false] = ACTIONS(2303),
    [sym_null] = ACTIONS(2303),
    [sym_inf] = ACTIONS(2303),
    [sym_nan] = ACTIONS(2303),
    [anon_sym_NA] = ACTIONS(2303),
    [anon_sym_NA_character_] = ACTIONS(2303),
    [anon_sym_NA_complex_] = ACTIONS(2303),
    [anon_sym_NA_integer_] = ACTIONS(2303),
    [anon_sym_NA_real_] = ACTIONS(2303),
    [aux_sym_identifier_token1] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(2303),
    [sym_integer] = ACTIONS(2303),
    [sym_float] = ACTIONS(2303),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2303),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2303),
  },
  [634] = {
    [anon_sym_LF] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2299),
    [anon_sym_function] = ACTIONS(2299),
    [anon_sym_BSLASH] = ACTIONS(2299),
    [anon_sym_if] = ACTIONS(2299),
    [anon_sym_LPAREN] = ACTIONS(2299),
    [anon_sym_else] = ACTIONS(2299),
    [anon_sym_while] = ACTIONS(2299),
    [anon_sym_repeat] = ACTIONS(2299),
    [anon_sym_for] = ACTIONS(2299),
    [anon_sym_switch] = ACTIONS(2299),
    [anon_sym_EQ] = ACTIONS(2299),
    [anon_sym_LBRACE] = ACTIONS(2299),
    [anon_sym_RBRACE] = ACTIONS(2299),
    [anon_sym_LT_DASH] = ACTIONS(2299),
    [anon_sym_COLON_EQ] = ACTIONS(2299),
    [anon_sym_LT_LT_DASH] = ACTIONS(2299),
    [anon_sym_DASH_GT_GT] = ACTIONS(2299),
    [anon_sym_DASH_GT] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(2299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2299),
    [anon_sym_DOLLAR] = ACTIONS(2299),
    [anon_sym_AT] = ACTIONS(2299),
    [sym_dots] = ACTIONS(2299),
    [anon_sym_PIPE_GT] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_BANG] = ACTIONS(2299),
    [anon_sym_TILDE] = ACTIONS(2299),
    [anon_sym_STAR] = ACTIONS(2299),
    [anon_sym_SLASH] = ACTIONS(2299),
    [anon_sym_CARET] = ACTIONS(2299),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [anon_sym_GT_EQ] = ACTIONS(2299),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_BANG_EQ] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2299),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_COLON] = ACTIONS(2299),
    [sym_break] = ACTIONS(2299),
    [sym_next] = ACTIONS(2299),
    [sym_true] = ACTIONS(2299),
    [sym_false] = ACTIONS(2299),
    [sym_null] = ACTIONS(2299),
    [sym_inf] = ACTIONS(2299),
    [sym_nan] = ACTIONS(2299),
    [anon_sym_NA] = ACTIONS(2299),
    [anon_sym_NA_character_] = ACTIONS(2299),
    [anon_sym_NA_complex_] = ACTIONS(2299),
    [anon_sym_NA_integer_] = ACTIONS(2299),
    [anon_sym_NA_real_] = ACTIONS(2299),
    [aux_sym_identifier_token1] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2299),
    [sym_integer] = ACTIONS(2299),
    [sym_float] = ACTIONS(2299),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2299),
    [anon_sym_SQUOTE] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2299),
  },
  [635] = {
    [anon_sym_LF] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_function] = ACTIONS(2295),
    [anon_sym_BSLASH] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2295),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [anon_sym_else] = ACTIONS(2295),
    [anon_sym_while] = ACTIONS(2295),
    [anon_sym_repeat] = ACTIONS(2295),
    [anon_sym_for] = ACTIONS(2295),
    [anon_sym_switch] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LBRACE] = ACTIONS(2295),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_LT_DASH] = ACTIONS(2295),
    [anon_sym_COLON_EQ] = ACTIONS(2295),
    [anon_sym_LT_LT_DASH] = ACTIONS(2295),
    [anon_sym_DASH_GT_GT] = ACTIONS(2295),
    [anon_sym_DASH_GT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2295),
    [anon_sym_DOLLAR] = ACTIONS(2295),
    [anon_sym_AT] = ACTIONS(2295),
    [sym_dots] = ACTIONS(2295),
    [anon_sym_PIPE_GT] = ACTIONS(2295),
    [anon_sym_DASH] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2295),
    [anon_sym_TILDE] = ACTIONS(2295),
    [anon_sym_STAR] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2295),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_COLON] = ACTIONS(2295),
    [sym_break] = ACTIONS(2295),
    [sym_next] = ACTIONS(2295),
    [sym_true] = ACTIONS(2295),
    [sym_false] = ACTIONS(2295),
    [sym_null] = ACTIONS(2295),
    [sym_inf] = ACTIONS(2295),
    [sym_nan] = ACTIONS(2295),
    [anon_sym_NA] = ACTIONS(2295),
    [anon_sym_NA_character_] = ACTIONS(2295),
    [anon_sym_NA_complex_] = ACTIONS(2295),
    [anon_sym_NA_integer_] = ACTIONS(2295),
    [anon_sym_NA_real_] = ACTIONS(2295),
    [aux_sym_identifier_token1] = ACTIONS(2295),
    [anon_sym_BQUOTE] = ACTIONS(2295),
    [sym_integer] = ACTIONS(2295),
    [sym_float] = ACTIONS(2295),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2295),
    [anon_sym_SQUOTE] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
  },
  [636] = {
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2207),
    [anon_sym_BSLASH] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2207),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(2207),
    [anon_sym_repeat] = ACTIONS(2207),
    [anon_sym_for] = ACTIONS(2207),
    [anon_sym_switch] = ACTIONS(2207),
    [anon_sym_COMMA] = ACTIONS(2205),
    [anon_sym_EQ] = ACTIONS(2207),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_LT_DASH] = ACTIONS(2205),
    [anon_sym_COLON_EQ] = ACTIONS(2205),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_DASH_GT_GT] = ACTIONS(2205),
    [anon_sym_DASH_GT] = ACTIONS(2207),
    [anon_sym_LBRACK] = ACTIONS(2207),
    [anon_sym_RBRACK] = ACTIONS(2205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [sym_dots] = ACTIONS(2207),
    [anon_sym_PIPE_GT] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_CARET] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_LT_EQ] = ACTIONS(2205),
    [anon_sym_GT_EQ] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2205),
    [anon_sym_BANG_EQ] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2207),
    [anon_sym_COLON] = ACTIONS(2207),
    [sym_break] = ACTIONS(2207),
    [sym_next] = ACTIONS(2207),
    [sym_true] = ACTIONS(2207),
    [sym_false] = ACTIONS(2207),
    [sym_null] = ACTIONS(2207),
    [sym_inf] = ACTIONS(2207),
    [sym_nan] = ACTIONS(2207),
    [anon_sym_NA] = ACTIONS(2207),
    [anon_sym_NA_character_] = ACTIONS(2207),
    [anon_sym_NA_complex_] = ACTIONS(2207),
    [anon_sym_NA_integer_] = ACTIONS(2207),
    [anon_sym_NA_real_] = ACTIONS(2207),
    [aux_sym_identifier_token1] = ACTIONS(2207),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_integer] = ACTIONS(2205),
    [sym_float] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2205),
  },
  [637] = {
    [anon_sym_LF] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(2291),
    [anon_sym_function] = ACTIONS(2291),
    [anon_sym_BSLASH] = ACTIONS(2291),
    [anon_sym_if] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(2291),
    [anon_sym_else] = ACTIONS(2291),
    [anon_sym_while] = ACTIONS(2291),
    [anon_sym_repeat] = ACTIONS(2291),
    [anon_sym_for] = ACTIONS(2291),
    [anon_sym_switch] = ACTIONS(2291),
    [anon_sym_EQ] = ACTIONS(2291),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_LT_DASH] = ACTIONS(2291),
    [anon_sym_COLON_EQ] = ACTIONS(2291),
    [anon_sym_LT_LT_DASH] = ACTIONS(2291),
    [anon_sym_DASH_GT_GT] = ACTIONS(2291),
    [anon_sym_DASH_GT] = ACTIONS(2291),
    [anon_sym_LBRACK] = ACTIONS(2291),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2291),
    [anon_sym_DOLLAR] = ACTIONS(2291),
    [anon_sym_AT] = ACTIONS(2291),
    [sym_dots] = ACTIONS(2291),
    [anon_sym_PIPE_GT] = ACTIONS(2291),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_BANG] = ACTIONS(2291),
    [anon_sym_TILDE] = ACTIONS(2291),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_SLASH] = ACTIONS(2291),
    [anon_sym_CARET] = ACTIONS(2291),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2291),
    [anon_sym_GT_EQ] = ACTIONS(2291),
    [anon_sym_EQ_EQ] = ACTIONS(2291),
    [anon_sym_BANG_EQ] = ACTIONS(2291),
    [anon_sym_PIPE_PIPE] = ACTIONS(2291),
    [anon_sym_PIPE] = ACTIONS(2291),
    [anon_sym_AMP_AMP] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON] = ACTIONS(2291),
    [sym_break] = ACTIONS(2291),
    [sym_next] = ACTIONS(2291),
    [sym_true] = ACTIONS(2291),
    [sym_false] = ACTIONS(2291),
    [sym_null] = ACTIONS(2291),
    [sym_inf] = ACTIONS(2291),
    [sym_nan] = ACTIONS(2291),
    [anon_sym_NA] = ACTIONS(2291),
    [anon_sym_NA_character_] = ACTIONS(2291),
    [anon_sym_NA_complex_] = ACTIONS(2291),
    [anon_sym_NA_integer_] = ACTIONS(2291),
    [anon_sym_NA_real_] = ACTIONS(2291),
    [aux_sym_identifier_token1] = ACTIONS(2291),
    [anon_sym_BQUOTE] = ACTIONS(2291),
    [sym_integer] = ACTIONS(2291),
    [sym_float] = ACTIONS(2291),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2291),
    [anon_sym_SQUOTE] = ACTIONS(2291),
    [anon_sym_PERCENT] = ACTIONS(2291),
  },
  [638] = {
    [anon_sym_SEMI] = ACTIONS(2201),
    [anon_sym_function] = ACTIONS(2203),
    [anon_sym_BSLASH] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_LPAREN] = ACTIONS(2201),
    [anon_sym_RPAREN] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2203),
    [anon_sym_repeat] = ACTIONS(2203),
    [anon_sym_for] = ACTIONS(2203),
    [anon_sym_switch] = ACTIONS(2203),
    [anon_sym_COMMA] = ACTIONS(2201),
    [anon_sym_EQ] = ACTIONS(2203),
    [anon_sym_LBRACE] = ACTIONS(2201),
    [anon_sym_LT_DASH] = ACTIONS(2201),
    [anon_sym_COLON_EQ] = ACTIONS(2201),
    [anon_sym_LT_LT_DASH] = ACTIONS(2201),
    [anon_sym_DASH_GT_GT] = ACTIONS(2201),
    [anon_sym_DASH_GT] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_RBRACK] = ACTIONS(2201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2201),
    [anon_sym_DOLLAR] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2201),
    [sym_dots] = ACTIONS(2203),
    [anon_sym_PIPE_GT] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_SLASH] = ACTIONS(2201),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2203),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2201),
    [anon_sym_GT_EQ] = ACTIONS(2201),
    [anon_sym_EQ_EQ] = ACTIONS(2201),
    [anon_sym_BANG_EQ] = ACTIONS(2201),
    [anon_sym_PIPE_PIPE] = ACTIONS(2201),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_COLON] = ACTIONS(2203),
    [sym_break] = ACTIONS(2203),
    [sym_next] = ACTIONS(2203),
    [sym_true] = ACTIONS(2203),
    [sym_false] = ACTIONS(2203),
    [sym_null] = ACTIONS(2203),
    [sym_inf] = ACTIONS(2203),
    [sym_nan] = ACTIONS(2203),
    [anon_sym_NA] = ACTIONS(2203),
    [anon_sym_NA_character_] = ACTIONS(2203),
    [anon_sym_NA_complex_] = ACTIONS(2203),
    [anon_sym_NA_integer_] = ACTIONS(2203),
    [anon_sym_NA_real_] = ACTIONS(2203),
    [aux_sym_identifier_token1] = ACTIONS(2203),
    [anon_sym_BQUOTE] = ACTIONS(2201),
    [sym_integer] = ACTIONS(2201),
    [sym_float] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2201),
    [anon_sym_PERCENT] = ACTIONS(2201),
  },
  [639] = {
    [sym_special] = STATE(277),
    [anon_sym_LF] = ACTIONS(2625),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym_function] = ACTIONS(2630),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_if] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(2630),
    [anon_sym_repeat] = ACTIONS(2630),
    [anon_sym_for] = ACTIONS(2630),
    [anon_sym_switch] = ACTIONS(2630),
    [anon_sym_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_LT_DASH] = ACTIONS(2523),
    [anon_sym_COLON_EQ] = ACTIONS(2525),
    [anon_sym_LT_LT_DASH] = ACTIONS(2527),
    [anon_sym_DASH_GT_GT] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2501),
    [sym_dots] = ACTIONS(2630),
    [anon_sym_PIPE_GT] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2513),
    [anon_sym_BANG_EQ] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2519),
    [sym_break] = ACTIONS(2630),
    [sym_next] = ACTIONS(2630),
    [sym_true] = ACTIONS(2630),
    [sym_false] = ACTIONS(2630),
    [sym_null] = ACTIONS(2630),
    [sym_inf] = ACTIONS(2630),
    [sym_nan] = ACTIONS(2630),
    [anon_sym_NA] = ACTIONS(2630),
    [anon_sym_NA_character_] = ACTIONS(2630),
    [anon_sym_NA_complex_] = ACTIONS(2630),
    [anon_sym_NA_integer_] = ACTIONS(2630),
    [anon_sym_NA_real_] = ACTIONS(2630),
    [aux_sym_identifier_token1] = ACTIONS(2630),
    [anon_sym_BQUOTE] = ACTIONS(2630),
    [sym_integer] = ACTIONS(2630),
    [sym_float] = ACTIONS(2630),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2630),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [640] = {
    [anon_sym_LF] = ACTIONS(2287),
    [anon_sym_SEMI] = ACTIONS(2287),
    [anon_sym_function] = ACTIONS(2287),
    [anon_sym_BSLASH] = ACTIONS(2287),
    [anon_sym_if] = ACTIONS(2287),
    [anon_sym_LPAREN] = ACTIONS(2287),
    [anon_sym_else] = ACTIONS(2287),
    [anon_sym_while] = ACTIONS(2287),
    [anon_sym_repeat] = ACTIONS(2287),
    [anon_sym_for] = ACTIONS(2287),
    [anon_sym_switch] = ACTIONS(2287),
    [anon_sym_EQ] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2287),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_LT_DASH] = ACTIONS(2287),
    [anon_sym_COLON_EQ] = ACTIONS(2287),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_DASH_GT_GT] = ACTIONS(2287),
    [anon_sym_DASH_GT] = ACTIONS(2287),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2287),
    [anon_sym_DOLLAR] = ACTIONS(2287),
    [anon_sym_AT] = ACTIONS(2287),
    [sym_dots] = ACTIONS(2287),
    [anon_sym_PIPE_GT] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2287),
    [anon_sym_PLUS] = ACTIONS(2287),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_STAR] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2287),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_LT_EQ] = ACTIONS(2287),
    [anon_sym_GT_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(2287),
    [anon_sym_AMP_AMP] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2287),
    [sym_break] = ACTIONS(2287),
    [sym_next] = ACTIONS(2287),
    [sym_true] = ACTIONS(2287),
    [sym_false] = ACTIONS(2287),
    [sym_null] = ACTIONS(2287),
    [sym_inf] = ACTIONS(2287),
    [sym_nan] = ACTIONS(2287),
    [anon_sym_NA] = ACTIONS(2287),
    [anon_sym_NA_character_] = ACTIONS(2287),
    [anon_sym_NA_complex_] = ACTIONS(2287),
    [anon_sym_NA_integer_] = ACTIONS(2287),
    [anon_sym_NA_real_] = ACTIONS(2287),
    [aux_sym_identifier_token1] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [sym_integer] = ACTIONS(2287),
    [sym_float] = ACTIONS(2287),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [anon_sym_SQUOTE] = ACTIONS(2287),
    [anon_sym_PERCENT] = ACTIONS(2287),
  },
  [641] = {
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_function] = ACTIONS(2377),
    [anon_sym_BSLASH] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2375),
    [anon_sym_RPAREN] = ACTIONS(2375),
    [anon_sym_while] = ACTIONS(2377),
    [anon_sym_repeat] = ACTIONS(2377),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_switch] = ACTIONS(2377),
    [anon_sym_COMMA] = ACTIONS(2375),
    [anon_sym_EQ] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2375),
    [anon_sym_LT_DASH] = ACTIONS(2375),
    [anon_sym_COLON_EQ] = ACTIONS(2375),
    [anon_sym_LT_LT_DASH] = ACTIONS(2375),
    [anon_sym_DASH_GT_GT] = ACTIONS(2375),
    [anon_sym_DASH_GT] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2377),
    [anon_sym_RBRACK] = ACTIONS(2375),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2375),
    [anon_sym_DOLLAR] = ACTIONS(2375),
    [anon_sym_AT] = ACTIONS(2375),
    [sym_dots] = ACTIONS(2377),
    [anon_sym_PIPE_GT] = ACTIONS(2375),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2375),
    [anon_sym_BANG] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2375),
    [anon_sym_STAR] = ACTIONS(2375),
    [anon_sym_SLASH] = ACTIONS(2375),
    [anon_sym_CARET] = ACTIONS(2375),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2375),
    [anon_sym_GT_EQ] = ACTIONS(2375),
    [anon_sym_EQ_EQ] = ACTIONS(2375),
    [anon_sym_BANG_EQ] = ACTIONS(2375),
    [anon_sym_PIPE_PIPE] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2375),
    [anon_sym_AMP] = ACTIONS(2377),
    [anon_sym_COLON] = ACTIONS(2377),
    [sym_break] = ACTIONS(2377),
    [sym_next] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_null] = ACTIONS(2377),
    [sym_inf] = ACTIONS(2377),
    [sym_nan] = ACTIONS(2377),
    [anon_sym_NA] = ACTIONS(2377),
    [anon_sym_NA_character_] = ACTIONS(2377),
    [anon_sym_NA_complex_] = ACTIONS(2377),
    [anon_sym_NA_integer_] = ACTIONS(2377),
    [anon_sym_NA_real_] = ACTIONS(2377),
    [aux_sym_identifier_token1] = ACTIONS(2377),
    [anon_sym_BQUOTE] = ACTIONS(2375),
    [sym_integer] = ACTIONS(2375),
    [sym_float] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2375),
    [anon_sym_SQUOTE] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2375),
  },
  [642] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1359),
    [anon_sym_LF] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1361),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(2589),
    [anon_sym_COLON_EQ] = ACTIONS(2591),
    [anon_sym_LT_LT_DASH] = ACTIONS(2593),
    [anon_sym_DASH_GT_GT] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1361),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [aux_sym_identifier_token1] = ACTIONS(1361),
    [anon_sym_BQUOTE] = ACTIONS(1361),
    [sym_integer] = ACTIONS(1361),
    [sym_float] = ACTIONS(1361),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [643] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1363),
    [anon_sym_LF] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1365),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(2589),
    [anon_sym_COLON_EQ] = ACTIONS(2591),
    [anon_sym_LT_LT_DASH] = ACTIONS(2593),
    [anon_sym_DASH_GT_GT] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1365),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [aux_sym_identifier_token1] = ACTIONS(1365),
    [anon_sym_BQUOTE] = ACTIONS(1365),
    [sym_integer] = ACTIONS(1365),
    [sym_float] = ACTIONS(1365),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [644] = {
    [anon_sym_LF] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_function] = ACTIONS(2283),
    [anon_sym_BSLASH] = ACTIONS(2283),
    [anon_sym_if] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2283),
    [anon_sym_else] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(2283),
    [anon_sym_repeat] = ACTIONS(2283),
    [anon_sym_for] = ACTIONS(2283),
    [anon_sym_switch] = ACTIONS(2283),
    [anon_sym_EQ] = ACTIONS(2283),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_RBRACE] = ACTIONS(2283),
    [anon_sym_LT_DASH] = ACTIONS(2283),
    [anon_sym_COLON_EQ] = ACTIONS(2283),
    [anon_sym_LT_LT_DASH] = ACTIONS(2283),
    [anon_sym_DASH_GT_GT] = ACTIONS(2283),
    [anon_sym_DASH_GT] = ACTIONS(2283),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2283),
    [anon_sym_DOLLAR] = ACTIONS(2283),
    [anon_sym_AT] = ACTIONS(2283),
    [sym_dots] = ACTIONS(2283),
    [anon_sym_PIPE_GT] = ACTIONS(2283),
    [anon_sym_DASH] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(2283),
    [anon_sym_BANG] = ACTIONS(2283),
    [anon_sym_TILDE] = ACTIONS(2283),
    [anon_sym_STAR] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2283),
    [anon_sym_CARET] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_LT_EQ] = ACTIONS(2283),
    [anon_sym_GT_EQ] = ACTIONS(2283),
    [anon_sym_EQ_EQ] = ACTIONS(2283),
    [anon_sym_BANG_EQ] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [anon_sym_AMP] = ACTIONS(2283),
    [anon_sym_COLON] = ACTIONS(2283),
    [sym_break] = ACTIONS(2283),
    [sym_next] = ACTIONS(2283),
    [sym_true] = ACTIONS(2283),
    [sym_false] = ACTIONS(2283),
    [sym_null] = ACTIONS(2283),
    [sym_inf] = ACTIONS(2283),
    [sym_nan] = ACTIONS(2283),
    [anon_sym_NA] = ACTIONS(2283),
    [anon_sym_NA_character_] = ACTIONS(2283),
    [anon_sym_NA_complex_] = ACTIONS(2283),
    [anon_sym_NA_integer_] = ACTIONS(2283),
    [anon_sym_NA_real_] = ACTIONS(2283),
    [aux_sym_identifier_token1] = ACTIONS(2283),
    [anon_sym_BQUOTE] = ACTIONS(2283),
    [sym_integer] = ACTIONS(2283),
    [sym_float] = ACTIONS(2283),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2283),
    [anon_sym_SQUOTE] = ACTIONS(2283),
    [anon_sym_PERCENT] = ACTIONS(2283),
  },
  [645] = {
    [anon_sym_LF] = ACTIONS(2279),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_function] = ACTIONS(2279),
    [anon_sym_BSLASH] = ACTIONS(2279),
    [anon_sym_if] = ACTIONS(2279),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_else] = ACTIONS(2279),
    [anon_sym_while] = ACTIONS(2279),
    [anon_sym_repeat] = ACTIONS(2279),
    [anon_sym_for] = ACTIONS(2279),
    [anon_sym_switch] = ACTIONS(2279),
    [anon_sym_EQ] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(2279),
    [anon_sym_RBRACE] = ACTIONS(2279),
    [anon_sym_LT_DASH] = ACTIONS(2279),
    [anon_sym_COLON_EQ] = ACTIONS(2279),
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_DASH_GT_GT] = ACTIONS(2279),
    [anon_sym_DASH_GT] = ACTIONS(2279),
    [anon_sym_LBRACK] = ACTIONS(2279),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2279),
    [anon_sym_DOLLAR] = ACTIONS(2279),
    [anon_sym_AT] = ACTIONS(2279),
    [sym_dots] = ACTIONS(2279),
    [anon_sym_PIPE_GT] = ACTIONS(2279),
    [anon_sym_DASH] = ACTIONS(2279),
    [anon_sym_PLUS] = ACTIONS(2279),
    [anon_sym_BANG] = ACTIONS(2279),
    [anon_sym_TILDE] = ACTIONS(2279),
    [anon_sym_STAR] = ACTIONS(2279),
    [anon_sym_SLASH] = ACTIONS(2279),
    [anon_sym_CARET] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_LT_EQ] = ACTIONS(2279),
    [anon_sym_GT_EQ] = ACTIONS(2279),
    [anon_sym_EQ_EQ] = ACTIONS(2279),
    [anon_sym_BANG_EQ] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [anon_sym_COLON] = ACTIONS(2279),
    [sym_break] = ACTIONS(2279),
    [sym_next] = ACTIONS(2279),
    [sym_true] = ACTIONS(2279),
    [sym_false] = ACTIONS(2279),
    [sym_null] = ACTIONS(2279),
    [sym_inf] = ACTIONS(2279),
    [sym_nan] = ACTIONS(2279),
    [anon_sym_NA] = ACTIONS(2279),
    [anon_sym_NA_character_] = ACTIONS(2279),
    [anon_sym_NA_complex_] = ACTIONS(2279),
    [anon_sym_NA_integer_] = ACTIONS(2279),
    [anon_sym_NA_real_] = ACTIONS(2279),
    [aux_sym_identifier_token1] = ACTIONS(2279),
    [anon_sym_BQUOTE] = ACTIONS(2279),
    [sym_integer] = ACTIONS(2279),
    [sym_float] = ACTIONS(2279),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2279),
    [anon_sym_SQUOTE] = ACTIONS(2279),
    [anon_sym_PERCENT] = ACTIONS(2279),
  },
  [646] = {
    [anon_sym_LF] = ACTIONS(2275),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_function] = ACTIONS(2275),
    [anon_sym_BSLASH] = ACTIONS(2275),
    [anon_sym_if] = ACTIONS(2275),
    [anon_sym_LPAREN] = ACTIONS(2275),
    [anon_sym_else] = ACTIONS(2275),
    [anon_sym_while] = ACTIONS(2275),
    [anon_sym_repeat] = ACTIONS(2275),
    [anon_sym_for] = ACTIONS(2275),
    [anon_sym_switch] = ACTIONS(2275),
    [anon_sym_EQ] = ACTIONS(2275),
    [anon_sym_LBRACE] = ACTIONS(2275),
    [anon_sym_RBRACE] = ACTIONS(2275),
    [anon_sym_LT_DASH] = ACTIONS(2275),
    [anon_sym_COLON_EQ] = ACTIONS(2275),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_DASH_GT_GT] = ACTIONS(2275),
    [anon_sym_DASH_GT] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2275),
    [anon_sym_DOLLAR] = ACTIONS(2275),
    [anon_sym_AT] = ACTIONS(2275),
    [sym_dots] = ACTIONS(2275),
    [anon_sym_PIPE_GT] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2275),
    [anon_sym_PLUS] = ACTIONS(2275),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_CARET] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_LT_EQ] = ACTIONS(2275),
    [anon_sym_GT_EQ] = ACTIONS(2275),
    [anon_sym_EQ_EQ] = ACTIONS(2275),
    [anon_sym_BANG_EQ] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_PIPE] = ACTIONS(2275),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_COLON] = ACTIONS(2275),
    [sym_break] = ACTIONS(2275),
    [sym_next] = ACTIONS(2275),
    [sym_true] = ACTIONS(2275),
    [sym_false] = ACTIONS(2275),
    [sym_null] = ACTIONS(2275),
    [sym_inf] = ACTIONS(2275),
    [sym_nan] = ACTIONS(2275),
    [anon_sym_NA] = ACTIONS(2275),
    [anon_sym_NA_character_] = ACTIONS(2275),
    [anon_sym_NA_complex_] = ACTIONS(2275),
    [anon_sym_NA_integer_] = ACTIONS(2275),
    [anon_sym_NA_real_] = ACTIONS(2275),
    [aux_sym_identifier_token1] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(2275),
    [sym_integer] = ACTIONS(2275),
    [sym_float] = ACTIONS(2275),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2275),
    [anon_sym_SQUOTE] = ACTIONS(2275),
    [anon_sym_PERCENT] = ACTIONS(2275),
  },
  [647] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [anon_sym_LF] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_BSLASH] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_repeat] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_LT_DASH] = ACTIONS(2589),
    [anon_sym_COLON_EQ] = ACTIONS(2591),
    [anon_sym_LT_LT_DASH] = ACTIONS(2593),
    [anon_sym_DASH_GT_GT] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1381),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1381),
    [sym_next] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_inf] = ACTIONS(1381),
    [sym_nan] = ACTIONS(1381),
    [anon_sym_NA] = ACTIONS(1381),
    [anon_sym_NA_character_] = ACTIONS(1381),
    [anon_sym_NA_complex_] = ACTIONS(1381),
    [anon_sym_NA_integer_] = ACTIONS(1381),
    [anon_sym_NA_real_] = ACTIONS(1381),
    [aux_sym_identifier_token1] = ACTIONS(1381),
    [anon_sym_BQUOTE] = ACTIONS(1381),
    [sym_integer] = ACTIONS(1381),
    [sym_float] = ACTIONS(1381),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1381),
    [anon_sym_SQUOTE] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [648] = {
    [anon_sym_LF] = ACTIONS(2271),
    [anon_sym_SEMI] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2271),
    [anon_sym_BSLASH] = ACTIONS(2271),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_LPAREN] = ACTIONS(2271),
    [anon_sym_else] = ACTIONS(2271),
    [anon_sym_while] = ACTIONS(2271),
    [anon_sym_repeat] = ACTIONS(2271),
    [anon_sym_for] = ACTIONS(2271),
    [anon_sym_switch] = ACTIONS(2271),
    [anon_sym_EQ] = ACTIONS(2271),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_RBRACE] = ACTIONS(2271),
    [anon_sym_LT_DASH] = ACTIONS(2271),
    [anon_sym_COLON_EQ] = ACTIONS(2271),
    [anon_sym_LT_LT_DASH] = ACTIONS(2271),
    [anon_sym_DASH_GT_GT] = ACTIONS(2271),
    [anon_sym_DASH_GT] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym_DOLLAR] = ACTIONS(2271),
    [anon_sym_AT] = ACTIONS(2271),
    [sym_dots] = ACTIONS(2271),
    [anon_sym_PIPE_GT] = ACTIONS(2271),
    [anon_sym_DASH] = ACTIONS(2271),
    [anon_sym_PLUS] = ACTIONS(2271),
    [anon_sym_BANG] = ACTIONS(2271),
    [anon_sym_TILDE] = ACTIONS(2271),
    [anon_sym_STAR] = ACTIONS(2271),
    [anon_sym_SLASH] = ACTIONS(2271),
    [anon_sym_CARET] = ACTIONS(2271),
    [anon_sym_LT] = ACTIONS(2271),
    [anon_sym_GT] = ACTIONS(2271),
    [anon_sym_LT_EQ] = ACTIONS(2271),
    [anon_sym_GT_EQ] = ACTIONS(2271),
    [anon_sym_EQ_EQ] = ACTIONS(2271),
    [anon_sym_BANG_EQ] = ACTIONS(2271),
    [anon_sym_PIPE_PIPE] = ACTIONS(2271),
    [anon_sym_PIPE] = ACTIONS(2271),
    [anon_sym_AMP_AMP] = ACTIONS(2271),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym_COLON] = ACTIONS(2271),
    [sym_break] = ACTIONS(2271),
    [sym_next] = ACTIONS(2271),
    [sym_true] = ACTIONS(2271),
    [sym_false] = ACTIONS(2271),
    [sym_null] = ACTIONS(2271),
    [sym_inf] = ACTIONS(2271),
    [sym_nan] = ACTIONS(2271),
    [anon_sym_NA] = ACTIONS(2271),
    [anon_sym_NA_character_] = ACTIONS(2271),
    [anon_sym_NA_complex_] = ACTIONS(2271),
    [anon_sym_NA_integer_] = ACTIONS(2271),
    [anon_sym_NA_real_] = ACTIONS(2271),
    [aux_sym_identifier_token1] = ACTIONS(2271),
    [anon_sym_BQUOTE] = ACTIONS(2271),
    [sym_integer] = ACTIONS(2271),
    [sym_float] = ACTIONS(2271),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2271),
    [anon_sym_SQUOTE] = ACTIONS(2271),
    [anon_sym_PERCENT] = ACTIONS(2271),
  },
  [649] = {
    [anon_sym_LF] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_function] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_LPAREN] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_repeat] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_EQ] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_LT_DASH] = ACTIONS(2267),
    [anon_sym_COLON_EQ] = ACTIONS(2267),
    [anon_sym_LT_LT_DASH] = ACTIONS(2267),
    [anon_sym_DASH_GT_GT] = ACTIONS(2267),
    [anon_sym_DASH_GT] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2267),
    [anon_sym_DOLLAR] = ACTIONS(2267),
    [anon_sym_AT] = ACTIONS(2267),
    [sym_dots] = ACTIONS(2267),
    [anon_sym_PIPE_GT] = ACTIONS(2267),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2267),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_GT] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2267),
    [anon_sym_GT_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ] = ACTIONS(2267),
    [anon_sym_BANG_EQ] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_AMP_AMP] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_COLON] = ACTIONS(2267),
    [sym_break] = ACTIONS(2267),
    [sym_next] = ACTIONS(2267),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [sym_null] = ACTIONS(2267),
    [sym_inf] = ACTIONS(2267),
    [sym_nan] = ACTIONS(2267),
    [anon_sym_NA] = ACTIONS(2267),
    [anon_sym_NA_character_] = ACTIONS(2267),
    [anon_sym_NA_complex_] = ACTIONS(2267),
    [anon_sym_NA_integer_] = ACTIONS(2267),
    [anon_sym_NA_real_] = ACTIONS(2267),
    [aux_sym_identifier_token1] = ACTIONS(2267),
    [anon_sym_BQUOTE] = ACTIONS(2267),
    [sym_integer] = ACTIONS(2267),
    [sym_float] = ACTIONS(2267),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2267),
    [anon_sym_SQUOTE] = ACTIONS(2267),
    [anon_sym_PERCENT] = ACTIONS(2267),
  },
  [650] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_function] = ACTIONS(2207),
    [anon_sym_BSLASH] = ACTIONS(2207),
    [anon_sym_if] = ACTIONS(2207),
    [anon_sym_LPAREN] = ACTIONS(2207),
    [anon_sym_else] = ACTIONS(2207),
    [anon_sym_while] = ACTIONS(2207),
    [anon_sym_repeat] = ACTIONS(2207),
    [anon_sym_for] = ACTIONS(2207),
    [anon_sym_switch] = ACTIONS(2207),
    [anon_sym_EQ] = ACTIONS(2207),
    [anon_sym_LBRACE] = ACTIONS(2207),
    [anon_sym_LT_DASH] = ACTIONS(2207),
    [anon_sym_COLON_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_DASH] = ACTIONS(2207),
    [anon_sym_DASH_GT_GT] = ACTIONS(2207),
    [anon_sym_DASH_GT] = ACTIONS(2207),
    [anon_sym_LBRACK] = ACTIONS(2207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2207),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_AT] = ACTIONS(2207),
    [sym_dots] = ACTIONS(2207),
    [anon_sym_PIPE_GT] = ACTIONS(2207),
    [anon_sym_DASH] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2207),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_TILDE] = ACTIONS(2207),
    [anon_sym_STAR] = ACTIONS(2207),
    [anon_sym_SLASH] = ACTIONS(2207),
    [anon_sym_CARET] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_EQ] = ACTIONS(2207),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
    [anon_sym_COLON] = ACTIONS(2207),
    [sym_break] = ACTIONS(2207),
    [sym_next] = ACTIONS(2207),
    [sym_true] = ACTIONS(2207),
    [sym_false] = ACTIONS(2207),
    [sym_null] = ACTIONS(2207),
    [sym_inf] = ACTIONS(2207),
    [sym_nan] = ACTIONS(2207),
    [anon_sym_NA] = ACTIONS(2207),
    [anon_sym_NA_character_] = ACTIONS(2207),
    [anon_sym_NA_complex_] = ACTIONS(2207),
    [anon_sym_NA_integer_] = ACTIONS(2207),
    [anon_sym_NA_real_] = ACTIONS(2207),
    [aux_sym_identifier_token1] = ACTIONS(2207),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_integer] = ACTIONS(2207),
    [sym_float] = ACTIONS(2207),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [anon_sym_SQUOTE] = ACTIONS(2207),
    [anon_sym_PERCENT] = ACTIONS(2207),
  },
  [652] = {
    [ts_builtin_sym_end] = ACTIONS(2209),
    [anon_sym_LF] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_function] = ACTIONS(2211),
    [anon_sym_BSLASH] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(2211),
    [anon_sym_else] = ACTIONS(2211),
    [anon_sym_while] = ACTIONS(2211),
    [anon_sym_repeat] = ACTIONS(2211),
    [anon_sym_for] = ACTIONS(2211),
    [anon_sym_switch] = ACTIONS(2211),
    [anon_sym_EQ] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_LT_DASH] = ACTIONS(2211),
    [anon_sym_COLON_EQ] = ACTIONS(2211),
    [anon_sym_LT_LT_DASH] = ACTIONS(2211),
    [anon_sym_DASH_GT_GT] = ACTIONS(2211),
    [anon_sym_DASH_GT] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2211),
    [anon_sym_DOLLAR] = ACTIONS(2211),
    [anon_sym_AT] = ACTIONS(2211),
    [sym_dots] = ACTIONS(2211),
    [anon_sym_PIPE_GT] = ACTIONS(2211),
    [anon_sym_DASH] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2211),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(2211),
    [anon_sym_SLASH] = ACTIONS(2211),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_LT_EQ] = ACTIONS(2211),
    [anon_sym_GT_EQ] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2211),
    [anon_sym_BANG_EQ] = ACTIONS(2211),
    [anon_sym_PIPE_PIPE] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_COLON] = ACTIONS(2211),
    [sym_break] = ACTIONS(2211),
    [sym_next] = ACTIONS(2211),
    [sym_true] = ACTIONS(2211),
    [sym_false] = ACTIONS(2211),
    [sym_null] = ACTIONS(2211),
    [sym_inf] = ACTIONS(2211),
    [sym_nan] = ACTIONS(2211),
    [anon_sym_NA] = ACTIONS(2211),
    [anon_sym_NA_character_] = ACTIONS(2211),
    [anon_sym_NA_complex_] = ACTIONS(2211),
    [anon_sym_NA_integer_] = ACTIONS(2211),
    [anon_sym_NA_real_] = ACTIONS(2211),
    [aux_sym_identifier_token1] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [sym_integer] = ACTIONS(2211),
    [sym_float] = ACTIONS(2211),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [anon_sym_SQUOTE] = ACTIONS(2211),
    [anon_sym_PERCENT] = ACTIONS(2211),
  },
  [653] = {
    [ts_builtin_sym_end] = ACTIONS(2213),
    [anon_sym_LF] = ACTIONS(2215),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_function] = ACTIONS(2215),
    [anon_sym_BSLASH] = ACTIONS(2215),
    [anon_sym_if] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_else] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2215),
    [anon_sym_repeat] = ACTIONS(2215),
    [anon_sym_for] = ACTIONS(2215),
    [anon_sym_switch] = ACTIONS(2215),
    [anon_sym_EQ] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2215),
    [anon_sym_LT_DASH] = ACTIONS(2215),
    [anon_sym_COLON_EQ] = ACTIONS(2215),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_DASH_GT_GT] = ACTIONS(2215),
    [anon_sym_DASH_GT] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(2215),
    [anon_sym_AT] = ACTIONS(2215),
    [sym_dots] = ACTIONS(2215),
    [anon_sym_PIPE_GT] = ACTIONS(2215),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2215),
    [anon_sym_BANG] = ACTIONS(2215),
    [anon_sym_TILDE] = ACTIONS(2215),
    [anon_sym_STAR] = ACTIONS(2215),
    [anon_sym_SLASH] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_LT_EQ] = ACTIONS(2215),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_EQ_EQ] = ACTIONS(2215),
    [anon_sym_BANG_EQ] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_COLON] = ACTIONS(2215),
    [sym_break] = ACTIONS(2215),
    [sym_next] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_null] = ACTIONS(2215),
    [sym_inf] = ACTIONS(2215),
    [sym_nan] = ACTIONS(2215),
    [anon_sym_NA] = ACTIONS(2215),
    [anon_sym_NA_character_] = ACTIONS(2215),
    [anon_sym_NA_complex_] = ACTIONS(2215),
    [anon_sym_NA_integer_] = ACTIONS(2215),
    [anon_sym_NA_real_] = ACTIONS(2215),
    [aux_sym_identifier_token1] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(2215),
    [sym_integer] = ACTIONS(2215),
    [sym_float] = ACTIONS(2215),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2215),
    [anon_sym_SQUOTE] = ACTIONS(2215),
    [anon_sym_PERCENT] = ACTIONS(2215),
  },
  [654] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(2632),
    [anon_sym_LF] = ACTIONS(2634),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_function] = ACTIONS(2630),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_if] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2630),
    [anon_sym_repeat] = ACTIONS(2630),
    [anon_sym_for] = ACTIONS(2630),
    [anon_sym_switch] = ACTIONS(2630),
    [anon_sym_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_LT_DASH] = ACTIONS(2589),
    [anon_sym_COLON_EQ] = ACTIONS(2591),
    [anon_sym_LT_LT_DASH] = ACTIONS(2593),
    [anon_sym_DASH_GT_GT] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(2630),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(2630),
    [sym_next] = ACTIONS(2630),
    [sym_true] = ACTIONS(2630),
    [sym_false] = ACTIONS(2630),
    [sym_null] = ACTIONS(2630),
    [sym_inf] = ACTIONS(2630),
    [sym_nan] = ACTIONS(2630),
    [anon_sym_NA] = ACTIONS(2630),
    [anon_sym_NA_character_] = ACTIONS(2630),
    [anon_sym_NA_complex_] = ACTIONS(2630),
    [anon_sym_NA_integer_] = ACTIONS(2630),
    [anon_sym_NA_real_] = ACTIONS(2630),
    [aux_sym_identifier_token1] = ACTIONS(2630),
    [anon_sym_BQUOTE] = ACTIONS(2630),
    [sym_integer] = ACTIONS(2630),
    [sym_float] = ACTIONS(2630),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2630),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [655] = {
    [ts_builtin_sym_end] = ACTIONS(2269),
    [anon_sym_LF] = ACTIONS(2271),
    [anon_sym_SEMI] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2271),
    [anon_sym_BSLASH] = ACTIONS(2271),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_LPAREN] = ACTIONS(2271),
    [anon_sym_else] = ACTIONS(2271),
    [anon_sym_while] = ACTIONS(2271),
    [anon_sym_repeat] = ACTIONS(2271),
    [anon_sym_for] = ACTIONS(2271),
    [anon_sym_switch] = ACTIONS(2271),
    [anon_sym_EQ] = ACTIONS(2271),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_DASH] = ACTIONS(2271),
    [anon_sym_COLON_EQ] = ACTIONS(2271),
    [anon_sym_LT_LT_DASH] = ACTIONS(2271),
    [anon_sym_DASH_GT_GT] = ACTIONS(2271),
    [anon_sym_DASH_GT] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2271),
    [anon_sym_DOLLAR] = ACTIONS(2271),
    [anon_sym_AT] = ACTIONS(2271),
    [sym_dots] = ACTIONS(2271),
    [anon_sym_PIPE_GT] = ACTIONS(2271),
    [anon_sym_DASH] = ACTIONS(2271),
    [anon_sym_PLUS] = ACTIONS(2271),
    [anon_sym_BANG] = ACTIONS(2271),
    [anon_sym_TILDE] = ACTIONS(2271),
    [anon_sym_STAR] = ACTIONS(2271),
    [anon_sym_SLASH] = ACTIONS(2271),
    [anon_sym_CARET] = ACTIONS(2271),
    [anon_sym_LT] = ACTIONS(2271),
    [anon_sym_GT] = ACTIONS(2271),
    [anon_sym_LT_EQ] = ACTIONS(2271),
    [anon_sym_GT_EQ] = ACTIONS(2271),
    [anon_sym_EQ_EQ] = ACTIONS(2271),
    [anon_sym_BANG_EQ] = ACTIONS(2271),
    [anon_sym_PIPE_PIPE] = ACTIONS(2271),
    [anon_sym_PIPE] = ACTIONS(2271),
    [anon_sym_AMP_AMP] = ACTIONS(2271),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym_COLON] = ACTIONS(2271),
    [sym_break] = ACTIONS(2271),
    [sym_next] = ACTIONS(2271),
    [sym_true] = ACTIONS(2271),
    [sym_false] = ACTIONS(2271),
    [sym_null] = ACTIONS(2271),
    [sym_inf] = ACTIONS(2271),
    [sym_nan] = ACTIONS(2271),
    [anon_sym_NA] = ACTIONS(2271),
    [anon_sym_NA_character_] = ACTIONS(2271),
    [anon_sym_NA_complex_] = ACTIONS(2271),
    [anon_sym_NA_integer_] = ACTIONS(2271),
    [anon_sym_NA_real_] = ACTIONS(2271),
    [aux_sym_identifier_token1] = ACTIONS(2271),
    [anon_sym_BQUOTE] = ACTIONS(2271),
    [sym_integer] = ACTIONS(2271),
    [sym_float] = ACTIONS(2271),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2271),
    [anon_sym_SQUOTE] = ACTIONS(2271),
    [anon_sym_PERCENT] = ACTIONS(2271),
  },
  [656] = {
    [ts_builtin_sym_end] = ACTIONS(2273),
    [anon_sym_LF] = ACTIONS(2275),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_function] = ACTIONS(2275),
    [anon_sym_BSLASH] = ACTIONS(2275),
    [anon_sym_if] = ACTIONS(2275),
    [anon_sym_LPAREN] = ACTIONS(2275),
    [anon_sym_else] = ACTIONS(2275),
    [anon_sym_while] = ACTIONS(2275),
    [anon_sym_repeat] = ACTIONS(2275),
    [anon_sym_for] = ACTIONS(2275),
    [anon_sym_switch] = ACTIONS(2275),
    [anon_sym_EQ] = ACTIONS(2275),
    [anon_sym_LBRACE] = ACTIONS(2275),
    [anon_sym_LT_DASH] = ACTIONS(2275),
    [anon_sym_COLON_EQ] = ACTIONS(2275),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_DASH_GT_GT] = ACTIONS(2275),
    [anon_sym_DASH_GT] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2275),
    [anon_sym_DOLLAR] = ACTIONS(2275),
    [anon_sym_AT] = ACTIONS(2275),
    [sym_dots] = ACTIONS(2275),
    [anon_sym_PIPE_GT] = ACTIONS(2275),
    [anon_sym_DASH] = ACTIONS(2275),
    [anon_sym_PLUS] = ACTIONS(2275),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_CARET] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_LT_EQ] = ACTIONS(2275),
    [anon_sym_GT_EQ] = ACTIONS(2275),
    [anon_sym_EQ_EQ] = ACTIONS(2275),
    [anon_sym_BANG_EQ] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_PIPE] = ACTIONS(2275),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_COLON] = ACTIONS(2275),
    [sym_break] = ACTIONS(2275),
    [sym_next] = ACTIONS(2275),
    [sym_true] = ACTIONS(2275),
    [sym_false] = ACTIONS(2275),
    [sym_null] = ACTIONS(2275),
    [sym_inf] = ACTIONS(2275),
    [sym_nan] = ACTIONS(2275),
    [anon_sym_NA] = ACTIONS(2275),
    [anon_sym_NA_character_] = ACTIONS(2275),
    [anon_sym_NA_complex_] = ACTIONS(2275),
    [anon_sym_NA_integer_] = ACTIONS(2275),
    [anon_sym_NA_real_] = ACTIONS(2275),
    [aux_sym_identifier_token1] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(2275),
    [sym_integer] = ACTIONS(2275),
    [sym_float] = ACTIONS(2275),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2275),
    [anon_sym_SQUOTE] = ACTIONS(2275),
    [anon_sym_PERCENT] = ACTIONS(2275),
  },
  [657] = {
    [ts_builtin_sym_end] = ACTIONS(2277),
    [anon_sym_LF] = ACTIONS(2279),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_function] = ACTIONS(2279),
    [anon_sym_BSLASH] = ACTIONS(2279),
    [anon_sym_if] = ACTIONS(2279),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_else] = ACTIONS(2279),
    [anon_sym_while] = ACTIONS(2279),
    [anon_sym_repeat] = ACTIONS(2279),
    [anon_sym_for] = ACTIONS(2279),
    [anon_sym_switch] = ACTIONS(2279),
    [anon_sym_EQ] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(2279),
    [anon_sym_LT_DASH] = ACTIONS(2279),
    [anon_sym_COLON_EQ] = ACTIONS(2279),
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_DASH_GT_GT] = ACTIONS(2279),
    [anon_sym_DASH_GT] = ACTIONS(2279),
    [anon_sym_LBRACK] = ACTIONS(2279),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2279),
    [anon_sym_DOLLAR] = ACTIONS(2279),
    [anon_sym_AT] = ACTIONS(2279),
    [sym_dots] = ACTIONS(2279),
    [anon_sym_PIPE_GT] = ACTIONS(2279),
    [anon_sym_DASH] = ACTIONS(2279),
    [anon_sym_PLUS] = ACTIONS(2279),
    [anon_sym_BANG] = ACTIONS(2279),
    [anon_sym_TILDE] = ACTIONS(2279),
    [anon_sym_STAR] = ACTIONS(2279),
    [anon_sym_SLASH] = ACTIONS(2279),
    [anon_sym_CARET] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_LT_EQ] = ACTIONS(2279),
    [anon_sym_GT_EQ] = ACTIONS(2279),
    [anon_sym_EQ_EQ] = ACTIONS(2279),
    [anon_sym_BANG_EQ] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [anon_sym_COLON] = ACTIONS(2279),
    [sym_break] = ACTIONS(2279),
    [sym_next] = ACTIONS(2279),
    [sym_true] = ACTIONS(2279),
    [sym_false] = ACTIONS(2279),
    [sym_null] = ACTIONS(2279),
    [sym_inf] = ACTIONS(2279),
    [sym_nan] = ACTIONS(2279),
    [anon_sym_NA] = ACTIONS(2279),
    [anon_sym_NA_character_] = ACTIONS(2279),
    [anon_sym_NA_complex_] = ACTIONS(2279),
    [anon_sym_NA_integer_] = ACTIONS(2279),
    [anon_sym_NA_real_] = ACTIONS(2279),
    [aux_sym_identifier_token1] = ACTIONS(2279),
    [anon_sym_BQUOTE] = ACTIONS(2279),
    [sym_integer] = ACTIONS(2279),
    [sym_float] = ACTIONS(2279),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2279),
    [anon_sym_SQUOTE] = ACTIONS(2279),
    [anon_sym_PERCENT] = ACTIONS(2279),
  },
  [658] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [659] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [660] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [661] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [662] = {
    [ts_builtin_sym_end] = ACTIONS(2281),
    [anon_sym_LF] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_function] = ACTIONS(2283),
    [anon_sym_BSLASH] = ACTIONS(2283),
    [anon_sym_if] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2283),
    [anon_sym_else] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(2283),
    [anon_sym_repeat] = ACTIONS(2283),
    [anon_sym_for] = ACTIONS(2283),
    [anon_sym_switch] = ACTIONS(2283),
    [anon_sym_EQ] = ACTIONS(2283),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_LT_DASH] = ACTIONS(2283),
    [anon_sym_COLON_EQ] = ACTIONS(2283),
    [anon_sym_LT_LT_DASH] = ACTIONS(2283),
    [anon_sym_DASH_GT_GT] = ACTIONS(2283),
    [anon_sym_DASH_GT] = ACTIONS(2283),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2283),
    [anon_sym_DOLLAR] = ACTIONS(2283),
    [anon_sym_AT] = ACTIONS(2283),
    [sym_dots] = ACTIONS(2283),
    [anon_sym_PIPE_GT] = ACTIONS(2283),
    [anon_sym_DASH] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(2283),
    [anon_sym_BANG] = ACTIONS(2283),
    [anon_sym_TILDE] = ACTIONS(2283),
    [anon_sym_STAR] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2283),
    [anon_sym_CARET] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_LT_EQ] = ACTIONS(2283),
    [anon_sym_GT_EQ] = ACTIONS(2283),
    [anon_sym_EQ_EQ] = ACTIONS(2283),
    [anon_sym_BANG_EQ] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [anon_sym_AMP] = ACTIONS(2283),
    [anon_sym_COLON] = ACTIONS(2283),
    [sym_break] = ACTIONS(2283),
    [sym_next] = ACTIONS(2283),
    [sym_true] = ACTIONS(2283),
    [sym_false] = ACTIONS(2283),
    [sym_null] = ACTIONS(2283),
    [sym_inf] = ACTIONS(2283),
    [sym_nan] = ACTIONS(2283),
    [anon_sym_NA] = ACTIONS(2283),
    [anon_sym_NA_character_] = ACTIONS(2283),
    [anon_sym_NA_complex_] = ACTIONS(2283),
    [anon_sym_NA_integer_] = ACTIONS(2283),
    [anon_sym_NA_real_] = ACTIONS(2283),
    [aux_sym_identifier_token1] = ACTIONS(2283),
    [anon_sym_BQUOTE] = ACTIONS(2283),
    [sym_integer] = ACTIONS(2283),
    [sym_float] = ACTIONS(2283),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2283),
    [anon_sym_SQUOTE] = ACTIONS(2283),
    [anon_sym_PERCENT] = ACTIONS(2283),
  },
  [663] = {
    [ts_builtin_sym_end] = ACTIONS(2285),
    [anon_sym_LF] = ACTIONS(2287),
    [anon_sym_SEMI] = ACTIONS(2287),
    [anon_sym_function] = ACTIONS(2287),
    [anon_sym_BSLASH] = ACTIONS(2287),
    [anon_sym_if] = ACTIONS(2287),
    [anon_sym_LPAREN] = ACTIONS(2287),
    [anon_sym_else] = ACTIONS(2287),
    [anon_sym_while] = ACTIONS(2287),
    [anon_sym_repeat] = ACTIONS(2287),
    [anon_sym_for] = ACTIONS(2287),
    [anon_sym_switch] = ACTIONS(2287),
    [anon_sym_EQ] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2287),
    [anon_sym_LT_DASH] = ACTIONS(2287),
    [anon_sym_COLON_EQ] = ACTIONS(2287),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_DASH_GT_GT] = ACTIONS(2287),
    [anon_sym_DASH_GT] = ACTIONS(2287),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2287),
    [anon_sym_DOLLAR] = ACTIONS(2287),
    [anon_sym_AT] = ACTIONS(2287),
    [sym_dots] = ACTIONS(2287),
    [anon_sym_PIPE_GT] = ACTIONS(2287),
    [anon_sym_DASH] = ACTIONS(2287),
    [anon_sym_PLUS] = ACTIONS(2287),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_STAR] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2287),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_LT_EQ] = ACTIONS(2287),
    [anon_sym_GT_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(2287),
    [anon_sym_AMP_AMP] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2287),
    [sym_break] = ACTIONS(2287),
    [sym_next] = ACTIONS(2287),
    [sym_true] = ACTIONS(2287),
    [sym_false] = ACTIONS(2287),
    [sym_null] = ACTIONS(2287),
    [sym_inf] = ACTIONS(2287),
    [sym_nan] = ACTIONS(2287),
    [anon_sym_NA] = ACTIONS(2287),
    [anon_sym_NA_character_] = ACTIONS(2287),
    [anon_sym_NA_complex_] = ACTIONS(2287),
    [anon_sym_NA_integer_] = ACTIONS(2287),
    [anon_sym_NA_real_] = ACTIONS(2287),
    [aux_sym_identifier_token1] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [sym_integer] = ACTIONS(2287),
    [sym_float] = ACTIONS(2287),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [anon_sym_SQUOTE] = ACTIONS(2287),
    [anon_sym_PERCENT] = ACTIONS(2287),
  },
  [664] = {
    [ts_builtin_sym_end] = ACTIONS(2289),
    [anon_sym_LF] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(2291),
    [anon_sym_function] = ACTIONS(2291),
    [anon_sym_BSLASH] = ACTIONS(2291),
    [anon_sym_if] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(2291),
    [anon_sym_else] = ACTIONS(2291),
    [anon_sym_while] = ACTIONS(2291),
    [anon_sym_repeat] = ACTIONS(2291),
    [anon_sym_for] = ACTIONS(2291),
    [anon_sym_switch] = ACTIONS(2291),
    [anon_sym_EQ] = ACTIONS(2291),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_DASH] = ACTIONS(2291),
    [anon_sym_COLON_EQ] = ACTIONS(2291),
    [anon_sym_LT_LT_DASH] = ACTIONS(2291),
    [anon_sym_DASH_GT_GT] = ACTIONS(2291),
    [anon_sym_DASH_GT] = ACTIONS(2291),
    [anon_sym_LBRACK] = ACTIONS(2291),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2291),
    [anon_sym_DOLLAR] = ACTIONS(2291),
    [anon_sym_AT] = ACTIONS(2291),
    [sym_dots] = ACTIONS(2291),
    [anon_sym_PIPE_GT] = ACTIONS(2291),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_PLUS] = ACTIONS(2291),
    [anon_sym_BANG] = ACTIONS(2291),
    [anon_sym_TILDE] = ACTIONS(2291),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_SLASH] = ACTIONS(2291),
    [anon_sym_CARET] = ACTIONS(2291),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2291),
    [anon_sym_GT_EQ] = ACTIONS(2291),
    [anon_sym_EQ_EQ] = ACTIONS(2291),
    [anon_sym_BANG_EQ] = ACTIONS(2291),
    [anon_sym_PIPE_PIPE] = ACTIONS(2291),
    [anon_sym_PIPE] = ACTIONS(2291),
    [anon_sym_AMP_AMP] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON] = ACTIONS(2291),
    [sym_break] = ACTIONS(2291),
    [sym_next] = ACTIONS(2291),
    [sym_true] = ACTIONS(2291),
    [sym_false] = ACTIONS(2291),
    [sym_null] = ACTIONS(2291),
    [sym_inf] = ACTIONS(2291),
    [sym_nan] = ACTIONS(2291),
    [anon_sym_NA] = ACTIONS(2291),
    [anon_sym_NA_character_] = ACTIONS(2291),
    [anon_sym_NA_complex_] = ACTIONS(2291),
    [anon_sym_NA_integer_] = ACTIONS(2291),
    [anon_sym_NA_real_] = ACTIONS(2291),
    [aux_sym_identifier_token1] = ACTIONS(2291),
    [anon_sym_BQUOTE] = ACTIONS(2291),
    [sym_integer] = ACTIONS(2291),
    [sym_float] = ACTIONS(2291),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2291),
    [anon_sym_SQUOTE] = ACTIONS(2291),
    [anon_sym_PERCENT] = ACTIONS(2291),
  },
  [665] = {
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym_LF] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_function] = ACTIONS(2295),
    [anon_sym_BSLASH] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2295),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [anon_sym_else] = ACTIONS(2295),
    [anon_sym_while] = ACTIONS(2295),
    [anon_sym_repeat] = ACTIONS(2295),
    [anon_sym_for] = ACTIONS(2295),
    [anon_sym_switch] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LBRACE] = ACTIONS(2295),
    [anon_sym_LT_DASH] = ACTIONS(2295),
    [anon_sym_COLON_EQ] = ACTIONS(2295),
    [anon_sym_LT_LT_DASH] = ACTIONS(2295),
    [anon_sym_DASH_GT_GT] = ACTIONS(2295),
    [anon_sym_DASH_GT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2295),
    [anon_sym_DOLLAR] = ACTIONS(2295),
    [anon_sym_AT] = ACTIONS(2295),
    [sym_dots] = ACTIONS(2295),
    [anon_sym_PIPE_GT] = ACTIONS(2295),
    [anon_sym_DASH] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(2295),
    [anon_sym_TILDE] = ACTIONS(2295),
    [anon_sym_STAR] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2295),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_COLON] = ACTIONS(2295),
    [sym_break] = ACTIONS(2295),
    [sym_next] = ACTIONS(2295),
    [sym_true] = ACTIONS(2295),
    [sym_false] = ACTIONS(2295),
    [sym_null] = ACTIONS(2295),
    [sym_inf] = ACTIONS(2295),
    [sym_nan] = ACTIONS(2295),
    [anon_sym_NA] = ACTIONS(2295),
    [anon_sym_NA_character_] = ACTIONS(2295),
    [anon_sym_NA_complex_] = ACTIONS(2295),
    [anon_sym_NA_integer_] = ACTIONS(2295),
    [anon_sym_NA_real_] = ACTIONS(2295),
    [aux_sym_identifier_token1] = ACTIONS(2295),
    [anon_sym_BQUOTE] = ACTIONS(2295),
    [sym_integer] = ACTIONS(2295),
    [sym_float] = ACTIONS(2295),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2295),
    [anon_sym_SQUOTE] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
  },
  [666] = {
    [ts_builtin_sym_end] = ACTIONS(2297),
    [anon_sym_LF] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2299),
    [anon_sym_function] = ACTIONS(2299),
    [anon_sym_BSLASH] = ACTIONS(2299),
    [anon_sym_if] = ACTIONS(2299),
    [anon_sym_LPAREN] = ACTIONS(2299),
    [anon_sym_else] = ACTIONS(2299),
    [anon_sym_while] = ACTIONS(2299),
    [anon_sym_repeat] = ACTIONS(2299),
    [anon_sym_for] = ACTIONS(2299),
    [anon_sym_switch] = ACTIONS(2299),
    [anon_sym_EQ] = ACTIONS(2299),
    [anon_sym_LBRACE] = ACTIONS(2299),
    [anon_sym_LT_DASH] = ACTIONS(2299),
    [anon_sym_COLON_EQ] = ACTIONS(2299),
    [anon_sym_LT_LT_DASH] = ACTIONS(2299),
    [anon_sym_DASH_GT_GT] = ACTIONS(2299),
    [anon_sym_DASH_GT] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(2299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2299),
    [anon_sym_DOLLAR] = ACTIONS(2299),
    [anon_sym_AT] = ACTIONS(2299),
    [sym_dots] = ACTIONS(2299),
    [anon_sym_PIPE_GT] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_BANG] = ACTIONS(2299),
    [anon_sym_TILDE] = ACTIONS(2299),
    [anon_sym_STAR] = ACTIONS(2299),
    [anon_sym_SLASH] = ACTIONS(2299),
    [anon_sym_CARET] = ACTIONS(2299),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [anon_sym_GT_EQ] = ACTIONS(2299),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_BANG_EQ] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2299),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_COLON] = ACTIONS(2299),
    [sym_break] = ACTIONS(2299),
    [sym_next] = ACTIONS(2299),
    [sym_true] = ACTIONS(2299),
    [sym_false] = ACTIONS(2299),
    [sym_null] = ACTIONS(2299),
    [sym_inf] = ACTIONS(2299),
    [sym_nan] = ACTIONS(2299),
    [anon_sym_NA] = ACTIONS(2299),
    [anon_sym_NA_character_] = ACTIONS(2299),
    [anon_sym_NA_complex_] = ACTIONS(2299),
    [anon_sym_NA_integer_] = ACTIONS(2299),
    [anon_sym_NA_real_] = ACTIONS(2299),
    [aux_sym_identifier_token1] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2299),
    [sym_integer] = ACTIONS(2299),
    [sym_float] = ACTIONS(2299),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2299),
    [anon_sym_SQUOTE] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2299),
  },
  [667] = {
    [anon_sym_LF] = ACTIONS(2215),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_function] = ACTIONS(2215),
    [anon_sym_BSLASH] = ACTIONS(2215),
    [anon_sym_if] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_else] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2215),
    [anon_sym_repeat] = ACTIONS(2215),
    [anon_sym_for] = ACTIONS(2215),
    [anon_sym_switch] = ACTIONS(2215),
    [anon_sym_EQ] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_LT_DASH] = ACTIONS(2215),
    [anon_sym_COLON_EQ] = ACTIONS(2215),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_DASH_GT_GT] = ACTIONS(2215),
    [anon_sym_DASH_GT] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(2215),
    [anon_sym_AT] = ACTIONS(2215),
    [sym_dots] = ACTIONS(2215),
    [anon_sym_PIPE_GT] = ACTIONS(2215),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2215),
    [anon_sym_BANG] = ACTIONS(2215),
    [anon_sym_TILDE] = ACTIONS(2215),
    [anon_sym_STAR] = ACTIONS(2215),
    [anon_sym_SLASH] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_LT_EQ] = ACTIONS(2215),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_EQ_EQ] = ACTIONS(2215),
    [anon_sym_BANG_EQ] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_COLON] = ACTIONS(2215),
    [sym_break] = ACTIONS(2215),
    [sym_next] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_null] = ACTIONS(2215),
    [sym_inf] = ACTIONS(2215),
    [sym_nan] = ACTIONS(2215),
    [anon_sym_NA] = ACTIONS(2215),
    [anon_sym_NA_character_] = ACTIONS(2215),
    [anon_sym_NA_complex_] = ACTIONS(2215),
    [anon_sym_NA_integer_] = ACTIONS(2215),
    [anon_sym_NA_real_] = ACTIONS(2215),
    [aux_sym_identifier_token1] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(2215),
    [sym_integer] = ACTIONS(2215),
    [sym_float] = ACTIONS(2215),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2215),
    [anon_sym_SQUOTE] = ACTIONS(2215),
    [anon_sym_PERCENT] = ACTIONS(2215),
  },
  [668] = {
    [anon_sym_LF] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_function] = ACTIONS(2211),
    [anon_sym_BSLASH] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(2211),
    [anon_sym_else] = ACTIONS(2211),
    [anon_sym_while] = ACTIONS(2211),
    [anon_sym_repeat] = ACTIONS(2211),
    [anon_sym_for] = ACTIONS(2211),
    [anon_sym_switch] = ACTIONS(2211),
    [anon_sym_EQ] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_RBRACE] = ACTIONS(2211),
    [anon_sym_LT_DASH] = ACTIONS(2211),
    [anon_sym_COLON_EQ] = ACTIONS(2211),
    [anon_sym_LT_LT_DASH] = ACTIONS(2211),
    [anon_sym_DASH_GT_GT] = ACTIONS(2211),
    [anon_sym_DASH_GT] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2211),
    [anon_sym_DOLLAR] = ACTIONS(2211),
    [anon_sym_AT] = ACTIONS(2211),
    [sym_dots] = ACTIONS(2211),
    [anon_sym_PIPE_GT] = ACTIONS(2211),
    [anon_sym_DASH] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2211),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(2211),
    [anon_sym_SLASH] = ACTIONS(2211),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_LT_EQ] = ACTIONS(2211),
    [anon_sym_GT_EQ] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2211),
    [anon_sym_BANG_EQ] = ACTIONS(2211),
    [anon_sym_PIPE_PIPE] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_COLON] = ACTIONS(2211),
    [sym_break] = ACTIONS(2211),
    [sym_next] = ACTIONS(2211),
    [sym_true] = ACTIONS(2211),
    [sym_false] = ACTIONS(2211),
    [sym_null] = ACTIONS(2211),
    [sym_inf] = ACTIONS(2211),
    [sym_nan] = ACTIONS(2211),
    [anon_sym_NA] = ACTIONS(2211),
    [anon_sym_NA_character_] = ACTIONS(2211),
    [anon_sym_NA_complex_] = ACTIONS(2211),
    [anon_sym_NA_integer_] = ACTIONS(2211),
    [anon_sym_NA_real_] = ACTIONS(2211),
    [aux_sym_identifier_token1] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [sym_integer] = ACTIONS(2211),
    [sym_float] = ACTIONS(2211),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [anon_sym_SQUOTE] = ACTIONS(2211),
    [anon_sym_PERCENT] = ACTIONS(2211),
  },
  [669] = {
    [ts_builtin_sym_end] = ACTIONS(2301),
    [anon_sym_LF] = ACTIONS(2303),
    [anon_sym_SEMI] = ACTIONS(2303),
    [anon_sym_function] = ACTIONS(2303),
    [anon_sym_BSLASH] = ACTIONS(2303),
    [anon_sym_if] = ACTIONS(2303),
    [anon_sym_LPAREN] = ACTIONS(2303),
    [anon_sym_else] = ACTIONS(2303),
    [anon_sym_while] = ACTIONS(2303),
    [anon_sym_repeat] = ACTIONS(2303),
    [anon_sym_for] = ACTIONS(2303),
    [anon_sym_switch] = ACTIONS(2303),
    [anon_sym_EQ] = ACTIONS(2303),
    [anon_sym_LBRACE] = ACTIONS(2303),
    [anon_sym_LT_DASH] = ACTIONS(2303),
    [anon_sym_COLON_EQ] = ACTIONS(2303),
    [anon_sym_LT_LT_DASH] = ACTIONS(2303),
    [anon_sym_DASH_GT_GT] = ACTIONS(2303),
    [anon_sym_DASH_GT] = ACTIONS(2303),
    [anon_sym_LBRACK] = ACTIONS(2303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2303),
    [sym_dots] = ACTIONS(2303),
    [anon_sym_PIPE_GT] = ACTIONS(2303),
    [anon_sym_DASH] = ACTIONS(2303),
    [anon_sym_PLUS] = ACTIONS(2303),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [anon_sym_STAR] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [anon_sym_GT_EQ] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_BANG_EQ] = ACTIONS(2303),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_COLON] = ACTIONS(2303),
    [sym_break] = ACTIONS(2303),
    [sym_next] = ACTIONS(2303),
    [sym_true] = ACTIONS(2303),
    [sym_false] = ACTIONS(2303),
    [sym_null] = ACTIONS(2303),
    [sym_inf] = ACTIONS(2303),
    [sym_nan] = ACTIONS(2303),
    [anon_sym_NA] = ACTIONS(2303),
    [anon_sym_NA_character_] = ACTIONS(2303),
    [anon_sym_NA_complex_] = ACTIONS(2303),
    [anon_sym_NA_integer_] = ACTIONS(2303),
    [anon_sym_NA_real_] = ACTIONS(2303),
    [aux_sym_identifier_token1] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(2303),
    [sym_integer] = ACTIONS(2303),
    [sym_float] = ACTIONS(2303),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2303),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2303),
  },
  [670] = {
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_function] = ACTIONS(2207),
    [anon_sym_BSLASH] = ACTIONS(2207),
    [anon_sym_if] = ACTIONS(2207),
    [anon_sym_LPAREN] = ACTIONS(2207),
    [anon_sym_else] = ACTIONS(2207),
    [anon_sym_while] = ACTIONS(2207),
    [anon_sym_repeat] = ACTIONS(2207),
    [anon_sym_for] = ACTIONS(2207),
    [anon_sym_switch] = ACTIONS(2207),
    [anon_sym_EQ] = ACTIONS(2207),
    [anon_sym_LBRACE] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2207),
    [anon_sym_LT_DASH] = ACTIONS(2207),
    [anon_sym_COLON_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_DASH] = ACTIONS(2207),
    [anon_sym_DASH_GT_GT] = ACTIONS(2207),
    [anon_sym_DASH_GT] = ACTIONS(2207),
    [anon_sym_LBRACK] = ACTIONS(2207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2207),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_AT] = ACTIONS(2207),
    [sym_dots] = ACTIONS(2207),
    [anon_sym_PIPE_GT] = ACTIONS(2207),
    [anon_sym_DASH] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2207),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_TILDE] = ACTIONS(2207),
    [anon_sym_STAR] = ACTIONS(2207),
    [anon_sym_SLASH] = ACTIONS(2207),
    [anon_sym_CARET] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_EQ] = ACTIONS(2207),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
    [anon_sym_COLON] = ACTIONS(2207),
    [sym_break] = ACTIONS(2207),
    [sym_next] = ACTIONS(2207),
    [sym_true] = ACTIONS(2207),
    [sym_false] = ACTIONS(2207),
    [sym_null] = ACTIONS(2207),
    [sym_inf] = ACTIONS(2207),
    [sym_nan] = ACTIONS(2207),
    [anon_sym_NA] = ACTIONS(2207),
    [anon_sym_NA_character_] = ACTIONS(2207),
    [anon_sym_NA_complex_] = ACTIONS(2207),
    [anon_sym_NA_integer_] = ACTIONS(2207),
    [anon_sym_NA_real_] = ACTIONS(2207),
    [aux_sym_identifier_token1] = ACTIONS(2207),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_integer] = ACTIONS(2207),
    [sym_float] = ACTIONS(2207),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [anon_sym_SQUOTE] = ACTIONS(2207),
    [anon_sym_PERCENT] = ACTIONS(2207),
  },
  [671] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
  },
  [672] = {
    [anon_sym_LF] = ACTIONS(2203),
    [anon_sym_SEMI] = ACTIONS(2203),
    [anon_sym_function] = ACTIONS(2203),
    [anon_sym_BSLASH] = ACTIONS(2203),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_while] = ACTIONS(2203),
    [anon_sym_repeat] = ACTIONS(2203),
    [anon_sym_for] = ACTIONS(2203),
    [anon_sym_switch] = ACTIONS(2203),
    [anon_sym_EQ] = ACTIONS(2203),
    [anon_sym_LBRACE] = ACTIONS(2203),
    [anon_sym_RBRACE] = ACTIONS(2203),
    [anon_sym_LT_DASH] = ACTIONS(2203),
    [anon_sym_COLON_EQ] = ACTIONS(2203),
    [anon_sym_LT_LT_DASH] = ACTIONS(2203),
    [anon_sym_DASH_GT_GT] = ACTIONS(2203),
    [anon_sym_DASH_GT] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2203),
    [anon_sym_DOLLAR] = ACTIONS(2203),
    [anon_sym_AT] = ACTIONS(2203),
    [sym_dots] = ACTIONS(2203),
    [anon_sym_PIPE_GT] = ACTIONS(2203),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(2203),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2203),
    [anon_sym_GT_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ] = ACTIONS(2203),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_PIPE_PIPE] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_COLON] = ACTIONS(2203),
    [sym_break] = ACTIONS(2203),
    [sym_next] = ACTIONS(2203),
    [sym_true] = ACTIONS(2203),
    [sym_false] = ACTIONS(2203),
    [sym_null] = ACTIONS(2203),
    [sym_inf] = ACTIONS(2203),
    [sym_nan] = ACTIONS(2203),
    [anon_sym_NA] = ACTIONS(2203),
    [anon_sym_NA_character_] = ACTIONS(2203),
    [anon_sym_NA_complex_] = ACTIONS(2203),
    [anon_sym_NA_integer_] = ACTIONS(2203),
    [anon_sym_NA_real_] = ACTIONS(2203),
    [aux_sym_identifier_token1] = ACTIONS(2203),
    [anon_sym_BQUOTE] = ACTIONS(2203),
    [sym_integer] = ACTIONS(2203),
    [sym_float] = ACTIONS(2203),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2203),
    [anon_sym_SQUOTE] = ACTIONS(2203),
    [anon_sym_PERCENT] = ACTIONS(2203),
  },
  [673] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [674] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [675] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_LT_DASH] = ACTIONS(1409),
    [anon_sym_COLON_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_DASH] = ACTIONS(1409),
    [anon_sym_DASH_GT_GT] = ACTIONS(1409),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1409),
    [sym_integer] = ACTIONS(1409),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [676] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1523),
    [anon_sym_LF] = ACTIONS(1525),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1525),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_repeat] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_EQ] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1525),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1525),
    [sym_next] = ACTIONS(1525),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [sym_null] = ACTIONS(1525),
    [sym_inf] = ACTIONS(1525),
    [sym_nan] = ACTIONS(1525),
    [anon_sym_NA] = ACTIONS(1525),
    [anon_sym_NA_character_] = ACTIONS(1525),
    [anon_sym_NA_complex_] = ACTIONS(1525),
    [anon_sym_NA_integer_] = ACTIONS(1525),
    [anon_sym_NA_real_] = ACTIONS(1525),
    [aux_sym_identifier_token1] = ACTIONS(1525),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [sym_integer] = ACTIONS(1525),
    [sym_float] = ACTIONS(1525),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [677] = {
    [ts_builtin_sym_end] = ACTIONS(2305),
    [anon_sym_LF] = ACTIONS(2307),
    [anon_sym_SEMI] = ACTIONS(2307),
    [anon_sym_function] = ACTIONS(2307),
    [anon_sym_BSLASH] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(2307),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_repeat] = ACTIONS(2307),
    [anon_sym_for] = ACTIONS(2307),
    [anon_sym_switch] = ACTIONS(2307),
    [anon_sym_EQ] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_LT_DASH] = ACTIONS(2307),
    [anon_sym_COLON_EQ] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_DASH_GT_GT] = ACTIONS(2307),
    [anon_sym_DASH_GT] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_AT] = ACTIONS(2307),
    [sym_dots] = ACTIONS(2307),
    [anon_sym_PIPE_GT] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(2307),
    [anon_sym_TILDE] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2307),
    [anon_sym_CARET] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_COLON] = ACTIONS(2307),
    [sym_break] = ACTIONS(2307),
    [sym_next] = ACTIONS(2307),
    [sym_true] = ACTIONS(2307),
    [sym_false] = ACTIONS(2307),
    [sym_null] = ACTIONS(2307),
    [sym_inf] = ACTIONS(2307),
    [sym_nan] = ACTIONS(2307),
    [anon_sym_NA] = ACTIONS(2307),
    [anon_sym_NA_character_] = ACTIONS(2307),
    [anon_sym_NA_complex_] = ACTIONS(2307),
    [anon_sym_NA_integer_] = ACTIONS(2307),
    [anon_sym_NA_real_] = ACTIONS(2307),
    [aux_sym_identifier_token1] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [sym_integer] = ACTIONS(2307),
    [sym_float] = ACTIONS(2307),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2307),
  },
  [678] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1441),
    [anon_sym_LF] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1443),
    [anon_sym_function] = ACTIONS(1443),
    [anon_sym_BSLASH] = ACTIONS(1443),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1443),
    [anon_sym_LT_DASH] = ACTIONS(1443),
    [anon_sym_COLON_EQ] = ACTIONS(1443),
    [anon_sym_LT_LT_DASH] = ACTIONS(1443),
    [anon_sym_DASH_GT_GT] = ACTIONS(1443),
    [anon_sym_DASH_GT] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1443),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1443),
    [sym_next] = ACTIONS(1443),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_inf] = ACTIONS(1443),
    [sym_nan] = ACTIONS(1443),
    [anon_sym_NA] = ACTIONS(1443),
    [anon_sym_NA_character_] = ACTIONS(1443),
    [anon_sym_NA_complex_] = ACTIONS(1443),
    [anon_sym_NA_integer_] = ACTIONS(1443),
    [anon_sym_NA_real_] = ACTIONS(1443),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [anon_sym_BQUOTE] = ACTIONS(1443),
    [sym_integer] = ACTIONS(1443),
    [sym_float] = ACTIONS(1443),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1443),
    [anon_sym_SQUOTE] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [679] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1445),
    [anon_sym_LF] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_BSLASH] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_repeat] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_LT_DASH] = ACTIONS(2589),
    [anon_sym_COLON_EQ] = ACTIONS(2591),
    [anon_sym_LT_LT_DASH] = ACTIONS(2593),
    [anon_sym_DASH_GT_GT] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1447),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1447),
    [sym_next] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_inf] = ACTIONS(1447),
    [sym_nan] = ACTIONS(1447),
    [anon_sym_NA] = ACTIONS(1447),
    [anon_sym_NA_character_] = ACTIONS(1447),
    [anon_sym_NA_complex_] = ACTIONS(1447),
    [anon_sym_NA_integer_] = ACTIONS(1447),
    [anon_sym_NA_real_] = ACTIONS(1447),
    [aux_sym_identifier_token1] = ACTIONS(1447),
    [anon_sym_BQUOTE] = ACTIONS(1447),
    [sym_integer] = ACTIONS(1447),
    [sym_float] = ACTIONS(1447),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1447),
    [anon_sym_SQUOTE] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [680] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1457),
    [anon_sym_LF] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_function] = ACTIONS(1459),
    [anon_sym_BSLASH] = ACTIONS(1459),
    [anon_sym_if] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1459),
    [anon_sym_repeat] = ACTIONS(1459),
    [anon_sym_for] = ACTIONS(1459),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_LT_DASH] = ACTIONS(2589),
    [anon_sym_COLON_EQ] = ACTIONS(2591),
    [anon_sym_LT_LT_DASH] = ACTIONS(2593),
    [anon_sym_DASH_GT_GT] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1459),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1459),
    [sym_next] = ACTIONS(1459),
    [sym_true] = ACTIONS(1459),
    [sym_false] = ACTIONS(1459),
    [sym_null] = ACTIONS(1459),
    [sym_inf] = ACTIONS(1459),
    [sym_nan] = ACTIONS(1459),
    [anon_sym_NA] = ACTIONS(1459),
    [anon_sym_NA_character_] = ACTIONS(1459),
    [anon_sym_NA_complex_] = ACTIONS(1459),
    [anon_sym_NA_integer_] = ACTIONS(1459),
    [anon_sym_NA_real_] = ACTIONS(1459),
    [aux_sym_identifier_token1] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_integer] = ACTIONS(1459),
    [sym_float] = ACTIONS(1459),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [681] = {
    [ts_builtin_sym_end] = ACTIONS(2361),
    [anon_sym_LF] = ACTIONS(2363),
    [anon_sym_SEMI] = ACTIONS(2363),
    [anon_sym_function] = ACTIONS(2363),
    [anon_sym_BSLASH] = ACTIONS(2363),
    [anon_sym_if] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_else] = ACTIONS(2363),
    [anon_sym_while] = ACTIONS(2363),
    [anon_sym_repeat] = ACTIONS(2363),
    [anon_sym_for] = ACTIONS(2363),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_EQ] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2363),
    [anon_sym_LT_DASH] = ACTIONS(2363),
    [anon_sym_COLON_EQ] = ACTIONS(2363),
    [anon_sym_LT_LT_DASH] = ACTIONS(2363),
    [anon_sym_DASH_GT_GT] = ACTIONS(2363),
    [anon_sym_DASH_GT] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2363),
    [anon_sym_DOLLAR] = ACTIONS(2363),
    [anon_sym_AT] = ACTIONS(2363),
    [sym_dots] = ACTIONS(2363),
    [anon_sym_PIPE_GT] = ACTIONS(2363),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(2363),
    [anon_sym_TILDE] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2363),
    [anon_sym_CARET] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2363),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_EQ] = ACTIONS(2363),
    [anon_sym_PIPE_PIPE] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_AMP_AMP] = ACTIONS(2363),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2363),
    [sym_break] = ACTIONS(2363),
    [sym_next] = ACTIONS(2363),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [sym_null] = ACTIONS(2363),
    [sym_inf] = ACTIONS(2363),
    [sym_nan] = ACTIONS(2363),
    [anon_sym_NA] = ACTIONS(2363),
    [anon_sym_NA_character_] = ACTIONS(2363),
    [anon_sym_NA_complex_] = ACTIONS(2363),
    [anon_sym_NA_integer_] = ACTIONS(2363),
    [anon_sym_NA_real_] = ACTIONS(2363),
    [aux_sym_identifier_token1] = ACTIONS(2363),
    [anon_sym_BQUOTE] = ACTIONS(2363),
    [sym_integer] = ACTIONS(2363),
    [sym_float] = ACTIONS(2363),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2363),
    [anon_sym_SQUOTE] = ACTIONS(2363),
    [anon_sym_PERCENT] = ACTIONS(2363),
  },
  [682] = {
    [ts_builtin_sym_end] = ACTIONS(2365),
    [anon_sym_LF] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2367),
    [anon_sym_function] = ACTIONS(2367),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2367),
    [anon_sym_else] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_repeat] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_EQ] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_LT_DASH] = ACTIONS(2367),
    [anon_sym_COLON_EQ] = ACTIONS(2367),
    [anon_sym_LT_LT_DASH] = ACTIONS(2367),
    [anon_sym_DASH_GT_GT] = ACTIONS(2367),
    [anon_sym_DASH_GT] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2367),
    [anon_sym_DOLLAR] = ACTIONS(2367),
    [anon_sym_AT] = ACTIONS(2367),
    [sym_dots] = ACTIONS(2367),
    [anon_sym_PIPE_GT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2367),
    [anon_sym_BANG] = ACTIONS(2367),
    [anon_sym_TILDE] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_CARET] = ACTIONS(2367),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_EQ_EQ] = ACTIONS(2367),
    [anon_sym_BANG_EQ] = ACTIONS(2367),
    [anon_sym_PIPE_PIPE] = ACTIONS(2367),
    [anon_sym_PIPE] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [sym_break] = ACTIONS(2367),
    [sym_next] = ACTIONS(2367),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [sym_null] = ACTIONS(2367),
    [sym_inf] = ACTIONS(2367),
    [sym_nan] = ACTIONS(2367),
    [anon_sym_NA] = ACTIONS(2367),
    [anon_sym_NA_character_] = ACTIONS(2367),
    [anon_sym_NA_complex_] = ACTIONS(2367),
    [anon_sym_NA_integer_] = ACTIONS(2367),
    [anon_sym_NA_real_] = ACTIONS(2367),
    [aux_sym_identifier_token1] = ACTIONS(2367),
    [anon_sym_BQUOTE] = ACTIONS(2367),
    [sym_integer] = ACTIONS(2367),
    [sym_float] = ACTIONS(2367),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2367),
    [anon_sym_SQUOTE] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
  },
  [683] = {
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_function] = ACTIONS(2377),
    [anon_sym_BSLASH] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2375),
    [anon_sym_else] = ACTIONS(2377),
    [anon_sym_while] = ACTIONS(2377),
    [anon_sym_repeat] = ACTIONS(2377),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_switch] = ACTIONS(2377),
    [anon_sym_COMMA] = ACTIONS(2375),
    [anon_sym_EQ] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2375),
    [anon_sym_LT_DASH] = ACTIONS(2375),
    [anon_sym_COLON_EQ] = ACTIONS(2375),
    [anon_sym_LT_LT_DASH] = ACTIONS(2375),
    [anon_sym_DASH_GT_GT] = ACTIONS(2375),
    [anon_sym_DASH_GT] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2375),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2375),
    [anon_sym_DOLLAR] = ACTIONS(2375),
    [anon_sym_AT] = ACTIONS(2375),
    [sym_dots] = ACTIONS(2377),
    [anon_sym_PIPE_GT] = ACTIONS(2375),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2375),
    [anon_sym_BANG] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2375),
    [anon_sym_STAR] = ACTIONS(2375),
    [anon_sym_SLASH] = ACTIONS(2375),
    [anon_sym_CARET] = ACTIONS(2375),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2375),
    [anon_sym_GT_EQ] = ACTIONS(2375),
    [anon_sym_EQ_EQ] = ACTIONS(2375),
    [anon_sym_BANG_EQ] = ACTIONS(2375),
    [anon_sym_PIPE_PIPE] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2375),
    [anon_sym_AMP] = ACTIONS(2377),
    [anon_sym_COLON] = ACTIONS(2377),
    [sym_break] = ACTIONS(2377),
    [sym_next] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_null] = ACTIONS(2377),
    [sym_inf] = ACTIONS(2377),
    [sym_nan] = ACTIONS(2377),
    [anon_sym_NA] = ACTIONS(2377),
    [anon_sym_NA_character_] = ACTIONS(2377),
    [anon_sym_NA_complex_] = ACTIONS(2377),
    [anon_sym_NA_integer_] = ACTIONS(2377),
    [anon_sym_NA_real_] = ACTIONS(2377),
    [aux_sym_identifier_token1] = ACTIONS(2377),
    [anon_sym_BQUOTE] = ACTIONS(2375),
    [sym_integer] = ACTIONS(2375),
    [sym_float] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2375),
    [anon_sym_SQUOTE] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2375),
  },
  [684] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym_LF] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_function] = ACTIONS(1463),
    [anon_sym_BSLASH] = ACTIONS(1463),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1463),
    [anon_sym_repeat] = ACTIONS(1463),
    [anon_sym_for] = ACTIONS(1463),
    [anon_sym_switch] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_LT_DASH] = ACTIONS(2589),
    [anon_sym_COLON_EQ] = ACTIONS(2591),
    [anon_sym_LT_LT_DASH] = ACTIONS(2593),
    [anon_sym_DASH_GT_GT] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1463),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1463),
    [sym_next] = ACTIONS(1463),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_inf] = ACTIONS(1463),
    [sym_nan] = ACTIONS(1463),
    [anon_sym_NA] = ACTIONS(1463),
    [anon_sym_NA_character_] = ACTIONS(1463),
    [anon_sym_NA_complex_] = ACTIONS(1463),
    [anon_sym_NA_integer_] = ACTIONS(1463),
    [anon_sym_NA_real_] = ACTIONS(1463),
    [aux_sym_identifier_token1] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [sym_integer] = ACTIONS(1463),
    [sym_float] = ACTIONS(1463),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [685] = {
    [ts_builtin_sym_end] = ACTIONS(2369),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym_function] = ACTIONS(2371),
    [anon_sym_BSLASH] = ACTIONS(2371),
    [anon_sym_if] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_else] = ACTIONS(2371),
    [anon_sym_while] = ACTIONS(2371),
    [anon_sym_repeat] = ACTIONS(2371),
    [anon_sym_for] = ACTIONS(2371),
    [anon_sym_switch] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_LT_DASH] = ACTIONS(2371),
    [anon_sym_COLON_EQ] = ACTIONS(2371),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_DASH_GT_GT] = ACTIONS(2371),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2371),
    [anon_sym_AT] = ACTIONS(2371),
    [sym_dots] = ACTIONS(2371),
    [anon_sym_PIPE_GT] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(2371),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_SLASH] = ACTIONS(2371),
    [anon_sym_CARET] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2371),
    [sym_break] = ACTIONS(2371),
    [sym_next] = ACTIONS(2371),
    [sym_true] = ACTIONS(2371),
    [sym_false] = ACTIONS(2371),
    [sym_null] = ACTIONS(2371),
    [sym_inf] = ACTIONS(2371),
    [sym_nan] = ACTIONS(2371),
    [anon_sym_NA] = ACTIONS(2371),
    [anon_sym_NA_character_] = ACTIONS(2371),
    [anon_sym_NA_complex_] = ACTIONS(2371),
    [anon_sym_NA_integer_] = ACTIONS(2371),
    [anon_sym_NA_real_] = ACTIONS(2371),
    [aux_sym_identifier_token1] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [sym_integer] = ACTIONS(2371),
    [sym_float] = ACTIONS(2371),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_PERCENT] = ACTIONS(2371),
  },
  [686] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1465),
    [anon_sym_LF] = ACTIONS(1467),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_function] = ACTIONS(1467),
    [anon_sym_BSLASH] = ACTIONS(1467),
    [anon_sym_if] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1467),
    [anon_sym_repeat] = ACTIONS(1467),
    [anon_sym_for] = ACTIONS(1467),
    [anon_sym_switch] = ACTIONS(1467),
    [anon_sym_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [anon_sym_LT_DASH] = ACTIONS(2589),
    [anon_sym_COLON_EQ] = ACTIONS(2591),
    [anon_sym_LT_LT_DASH] = ACTIONS(2593),
    [anon_sym_DASH_GT_GT] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1467),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1467),
    [sym_next] = ACTIONS(1467),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_null] = ACTIONS(1467),
    [sym_inf] = ACTIONS(1467),
    [sym_nan] = ACTIONS(1467),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [aux_sym_identifier_token1] = ACTIONS(1467),
    [anon_sym_BQUOTE] = ACTIONS(1467),
    [sym_integer] = ACTIONS(1467),
    [sym_float] = ACTIONS(1467),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1467),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [687] = {
    [anon_sym_SEMI] = ACTIONS(2201),
    [anon_sym_function] = ACTIONS(2203),
    [anon_sym_BSLASH] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_LPAREN] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_while] = ACTIONS(2203),
    [anon_sym_repeat] = ACTIONS(2203),
    [anon_sym_for] = ACTIONS(2203),
    [anon_sym_switch] = ACTIONS(2203),
    [anon_sym_COMMA] = ACTIONS(2201),
    [anon_sym_EQ] = ACTIONS(2203),
    [anon_sym_LBRACE] = ACTIONS(2201),
    [anon_sym_LT_DASH] = ACTIONS(2201),
    [anon_sym_COLON_EQ] = ACTIONS(2201),
    [anon_sym_LT_LT_DASH] = ACTIONS(2201),
    [anon_sym_DASH_GT_GT] = ACTIONS(2201),
    [anon_sym_DASH_GT] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2201),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2201),
    [anon_sym_DOLLAR] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2201),
    [sym_dots] = ACTIONS(2203),
    [anon_sym_PIPE_GT] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_SLASH] = ACTIONS(2201),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2203),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2201),
    [anon_sym_GT_EQ] = ACTIONS(2201),
    [anon_sym_EQ_EQ] = ACTIONS(2201),
    [anon_sym_BANG_EQ] = ACTIONS(2201),
    [anon_sym_PIPE_PIPE] = ACTIONS(2201),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_AMP_AMP] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_COLON] = ACTIONS(2203),
    [sym_break] = ACTIONS(2203),
    [sym_next] = ACTIONS(2203),
    [sym_true] = ACTIONS(2203),
    [sym_false] = ACTIONS(2203),
    [sym_null] = ACTIONS(2203),
    [sym_inf] = ACTIONS(2203),
    [sym_nan] = ACTIONS(2203),
    [anon_sym_NA] = ACTIONS(2203),
    [anon_sym_NA_character_] = ACTIONS(2203),
    [anon_sym_NA_complex_] = ACTIONS(2203),
    [anon_sym_NA_integer_] = ACTIONS(2203),
    [anon_sym_NA_real_] = ACTIONS(2203),
    [aux_sym_identifier_token1] = ACTIONS(2203),
    [anon_sym_BQUOTE] = ACTIONS(2201),
    [sym_integer] = ACTIONS(2201),
    [sym_float] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2201),
    [anon_sym_PERCENT] = ACTIONS(2201),
  },
  [688] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1519),
    [anon_sym_LF] = ACTIONS(1521),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1521),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_repeat] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1521),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1521),
    [sym_next] = ACTIONS(1521),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [sym_null] = ACTIONS(1521),
    [sym_inf] = ACTIONS(1521),
    [sym_nan] = ACTIONS(1521),
    [anon_sym_NA] = ACTIONS(1521),
    [anon_sym_NA_character_] = ACTIONS(1521),
    [anon_sym_NA_complex_] = ACTIONS(1521),
    [anon_sym_NA_integer_] = ACTIONS(1521),
    [anon_sym_NA_real_] = ACTIONS(1521),
    [aux_sym_identifier_token1] = ACTIONS(1521),
    [anon_sym_BQUOTE] = ACTIONS(1521),
    [sym_integer] = ACTIONS(1521),
    [sym_float] = ACTIONS(1521),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [689] = {
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2207),
    [anon_sym_BSLASH] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2207),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_else] = ACTIONS(2207),
    [anon_sym_while] = ACTIONS(2207),
    [anon_sym_repeat] = ACTIONS(2207),
    [anon_sym_for] = ACTIONS(2207),
    [anon_sym_switch] = ACTIONS(2207),
    [anon_sym_COMMA] = ACTIONS(2205),
    [anon_sym_EQ] = ACTIONS(2207),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_LT_DASH] = ACTIONS(2205),
    [anon_sym_COLON_EQ] = ACTIONS(2205),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_DASH_GT_GT] = ACTIONS(2205),
    [anon_sym_DASH_GT] = ACTIONS(2207),
    [anon_sym_LBRACK] = ACTIONS(2207),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2205),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [sym_dots] = ACTIONS(2207),
    [anon_sym_PIPE_GT] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_CARET] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_LT_EQ] = ACTIONS(2205),
    [anon_sym_GT_EQ] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2205),
    [anon_sym_BANG_EQ] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2207),
    [anon_sym_COLON] = ACTIONS(2207),
    [sym_break] = ACTIONS(2207),
    [sym_next] = ACTIONS(2207),
    [sym_true] = ACTIONS(2207),
    [sym_false] = ACTIONS(2207),
    [sym_null] = ACTIONS(2207),
    [sym_inf] = ACTIONS(2207),
    [sym_nan] = ACTIONS(2207),
    [anon_sym_NA] = ACTIONS(2207),
    [anon_sym_NA_character_] = ACTIONS(2207),
    [anon_sym_NA_complex_] = ACTIONS(2207),
    [anon_sym_NA_integer_] = ACTIONS(2207),
    [anon_sym_NA_real_] = ACTIONS(2207),
    [aux_sym_identifier_token1] = ACTIONS(2207),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_integer] = ACTIONS(2205),
    [sym_float] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2205),
  },
  [690] = {
    [anon_sym_LF] = ACTIONS(2377),
    [anon_sym_SEMI] = ACTIONS(2377),
    [anon_sym_function] = ACTIONS(2377),
    [anon_sym_BSLASH] = ACTIONS(2377),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2377),
    [anon_sym_else] = ACTIONS(2377),
    [anon_sym_while] = ACTIONS(2377),
    [anon_sym_repeat] = ACTIONS(2377),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_switch] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2377),
    [anon_sym_RBRACE] = ACTIONS(2377),
    [anon_sym_LT_DASH] = ACTIONS(2377),
    [anon_sym_COLON_EQ] = ACTIONS(2377),
    [anon_sym_LT_LT_DASH] = ACTIONS(2377),
    [anon_sym_DASH_GT_GT] = ACTIONS(2377),
    [anon_sym_DASH_GT] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2377),
    [anon_sym_DOLLAR] = ACTIONS(2377),
    [anon_sym_AT] = ACTIONS(2377),
    [sym_dots] = ACTIONS(2377),
    [anon_sym_PIPE_GT] = ACTIONS(2377),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2377),
    [anon_sym_STAR] = ACTIONS(2377),
    [anon_sym_SLASH] = ACTIONS(2377),
    [anon_sym_CARET] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_AMP] = ACTIONS(2377),
    [anon_sym_COLON] = ACTIONS(2377),
    [sym_break] = ACTIONS(2377),
    [sym_next] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_null] = ACTIONS(2377),
    [sym_inf] = ACTIONS(2377),
    [sym_nan] = ACTIONS(2377),
    [anon_sym_NA] = ACTIONS(2377),
    [anon_sym_NA_character_] = ACTIONS(2377),
    [anon_sym_NA_complex_] = ACTIONS(2377),
    [anon_sym_NA_integer_] = ACTIONS(2377),
    [anon_sym_NA_real_] = ACTIONS(2377),
    [aux_sym_identifier_token1] = ACTIONS(2377),
    [anon_sym_BQUOTE] = ACTIONS(2377),
    [sym_integer] = ACTIONS(2377),
    [sym_float] = ACTIONS(2377),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2377),
    [anon_sym_SQUOTE] = ACTIONS(2377),
    [anon_sym_PERCENT] = ACTIONS(2377),
  },
  [691] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_COMMA] = ACTIONS(1359),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_LT_DASH] = ACTIONS(2541),
    [anon_sym_COLON_EQ] = ACTIONS(2543),
    [anon_sym_LT_LT_DASH] = ACTIONS(2545),
    [anon_sym_DASH_GT_GT] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1359),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1361),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [aux_sym_identifier_token1] = ACTIONS(1361),
    [anon_sym_BQUOTE] = ACTIONS(1359),
    [sym_integer] = ACTIONS(1359),
    [sym_float] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [692] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_COMMA] = ACTIONS(1363),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_LT_DASH] = ACTIONS(2541),
    [anon_sym_COLON_EQ] = ACTIONS(2543),
    [anon_sym_LT_LT_DASH] = ACTIONS(2545),
    [anon_sym_DASH_GT_GT] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1363),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1365),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [aux_sym_identifier_token1] = ACTIONS(1365),
    [anon_sym_BQUOTE] = ACTIONS(1363),
    [sym_integer] = ACTIONS(1363),
    [sym_float] = ACTIONS(1365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [693] = {
    [sym_special] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1485),
    [anon_sym_LF] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_BSLASH] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_LT_DASH] = ACTIONS(2589),
    [anon_sym_COLON_EQ] = ACTIONS(2591),
    [anon_sym_LT_LT_DASH] = ACTIONS(2593),
    [anon_sym_DASH_GT_GT] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2605),
    [sym_dots] = ACTIONS(1487),
    [anon_sym_PIPE_GT] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_LT_EQ] = ACTIONS(2617),
    [anon_sym_GT_EQ] = ACTIONS(2617),
    [anon_sym_EQ_EQ] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_COLON] = ACTIONS(2623),
    [sym_break] = ACTIONS(1487),
    [sym_next] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_inf] = ACTIONS(1487),
    [sym_nan] = ACTIONS(1487),
    [anon_sym_NA] = ACTIONS(1487),
    [anon_sym_NA_character_] = ACTIONS(1487),
    [anon_sym_NA_complex_] = ACTIONS(1487),
    [anon_sym_NA_integer_] = ACTIONS(1487),
    [anon_sym_NA_real_] = ACTIONS(1487),
    [aux_sym_identifier_token1] = ACTIONS(1487),
    [anon_sym_BQUOTE] = ACTIONS(1487),
    [sym_integer] = ACTIONS(1487),
    [sym_float] = ACTIONS(1487),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(1487),
    [anon_sym_SQUOTE] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(2425),
  },
  [694] = {
    [anon_sym_SEMI] = ACTIONS(2209),
    [anon_sym_function] = ACTIONS(2211),
    [anon_sym_BSLASH] = ACTIONS(2209),
    [anon_sym_if] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(2209),
    [anon_sym_else] = ACTIONS(2211),
    [anon_sym_while] = ACTIONS(2211),
    [anon_sym_repeat] = ACTIONS(2211),
    [anon_sym_for] = ACTIONS(2211),
    [anon_sym_switch] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(2209),
    [anon_sym_EQ] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2209),
    [anon_sym_LT_DASH] = ACTIONS(2209),
    [anon_sym_COLON_EQ] = ACTIONS(2209),
    [anon_sym_LT_LT_DASH] = ACTIONS(2209),
    [anon_sym_DASH_GT_GT] = ACTIONS(2209),
    [anon_sym_DASH_GT] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2209),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2209),
    [anon_sym_DOLLAR] = ACTIONS(2209),
    [anon_sym_AT] = ACTIONS(2209),
    [sym_dots] = ACTIONS(2211),
    [anon_sym_PIPE_GT] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2209),
    [anon_sym_SLASH] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2209),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_LT_EQ] = ACTIONS(2209),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ] = ACTIONS(2209),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_COLON] = ACTIONS(2211),
    [sym_break] = ACTIONS(2211),
    [sym_next] = ACTIONS(2211),
    [sym_true] = ACTIONS(2211),
    [sym_false] = ACTIONS(2211),
    [sym_null] = ACTIONS(2211),
    [sym_inf] = ACTIONS(2211),
    [sym_nan] = ACTIONS(2211),
    [anon_sym_NA] = ACTIONS(2211),
    [anon_sym_NA_character_] = ACTIONS(2211),
    [anon_sym_NA_complex_] = ACTIONS(2211),
    [anon_sym_NA_integer_] = ACTIONS(2211),
    [anon_sym_NA_real_] = ACTIONS(2211),
    [aux_sym_identifier_token1] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2209),
    [sym_integer] = ACTIONS(2209),
    [sym_float] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [anon_sym_SQUOTE] = ACTIONS(2209),
    [anon_sym_PERCENT] = ACTIONS(2209),
  },
  [695] = {
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2215),
    [anon_sym_BSLASH] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_else] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2215),
    [anon_sym_repeat] = ACTIONS(2215),
    [anon_sym_for] = ACTIONS(2215),
    [anon_sym_switch] = ACTIONS(2215),
    [anon_sym_COMMA] = ACTIONS(2213),
    [anon_sym_EQ] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_LT_DASH] = ACTIONS(2213),
    [anon_sym_COLON_EQ] = ACTIONS(2213),
    [anon_sym_LT_LT_DASH] = ACTIONS(2213),
    [anon_sym_DASH_GT_GT] = ACTIONS(2213),
    [anon_sym_DASH_GT] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2213),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2213),
    [anon_sym_DOLLAR] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2213),
    [sym_dots] = ACTIONS(2215),
    [anon_sym_PIPE_GT] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2215),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_LT_EQ] = ACTIONS(2213),
    [anon_sym_GT_EQ] = ACTIONS(2213),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2213),
    [anon_sym_PIPE_PIPE] = ACTIONS(2213),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_COLON] = ACTIONS(2215),
    [sym_break] = ACTIONS(2215),
    [sym_next] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_null] = ACTIONS(2215),
    [sym_inf] = ACTIONS(2215),
    [sym_nan] = ACTIONS(2215),
    [anon_sym_NA] = ACTIONS(2215),
    [anon_sym_NA_character_] = ACTIONS(2215),
    [anon_sym_NA_complex_] = ACTIONS(2215),
    [anon_sym_NA_integer_] = ACTIONS(2215),
    [anon_sym_NA_real_] = ACTIONS(2215),
    [aux_sym_identifier_token1] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_integer] = ACTIONS(2213),
    [sym_float] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_PERCENT] = ACTIONS(2213),
  },
  [696] = {
    [ts_builtin_sym_end] = ACTIONS(2379),
    [anon_sym_LF] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2381),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_BSLASH] = ACTIONS(2381),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2381),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_repeat] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_EQ] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2381),
    [anon_sym_LT_DASH] = ACTIONS(2381),
    [anon_sym_COLON_EQ] = ACTIONS(2381),
    [anon_sym_LT_LT_DASH] = ACTIONS(2381),
    [anon_sym_DASH_GT_GT] = ACTIONS(2381),
    [anon_sym_DASH_GT] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2381),
    [anon_sym_DOLLAR] = ACTIONS(2381),
    [anon_sym_AT] = ACTIONS(2381),
    [sym_dots] = ACTIONS(2381),
    [anon_sym_PIPE_GT] = ACTIONS(2381),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2381),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [anon_sym_STAR] = ACTIONS(2381),
    [anon_sym_SLASH] = ACTIONS(2381),
    [anon_sym_CARET] = ACTIONS(2381),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_GT] = ACTIONS(2381),
    [anon_sym_LT_EQ] = ACTIONS(2381),
    [anon_sym_GT_EQ] = ACTIONS(2381),
    [anon_sym_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2381),
    [anon_sym_PIPE] = ACTIONS(2381),
    [anon_sym_AMP_AMP] = ACTIONS(2381),
    [anon_sym_AMP] = ACTIONS(2381),
    [anon_sym_COLON] = ACTIONS(2381),
    [sym_break] = ACTIONS(2381),
    [sym_next] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_inf] = ACTIONS(2381),
    [sym_nan] = ACTIONS(2381),
    [anon_sym_NA] = ACTIONS(2381),
    [anon_sym_NA_character_] = ACTIONS(2381),
    [anon_sym_NA_complex_] = ACTIONS(2381),
    [anon_sym_NA_integer_] = ACTIONS(2381),
    [anon_sym_NA_real_] = ACTIONS(2381),
    [aux_sym_identifier_token1] = ACTIONS(2381),
    [anon_sym_BQUOTE] = ACTIONS(2381),
    [sym_integer] = ACTIONS(2381),
    [sym_float] = ACTIONS(2381),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2381),
    [anon_sym_SQUOTE] = ACTIONS(2381),
    [anon_sym_PERCENT] = ACTIONS(2381),
  },
  [697] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_BSLASH] = ACTIONS(1379),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_repeat] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(1379),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(1379),
    [anon_sym_LT_DASH] = ACTIONS(2541),
    [anon_sym_COLON_EQ] = ACTIONS(2543),
    [anon_sym_LT_LT_DASH] = ACTIONS(2545),
    [anon_sym_DASH_GT_GT] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1379),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1381),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1381),
    [sym_next] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_inf] = ACTIONS(1381),
    [sym_nan] = ACTIONS(1381),
    [anon_sym_NA] = ACTIONS(1381),
    [anon_sym_NA_character_] = ACTIONS(1381),
    [anon_sym_NA_complex_] = ACTIONS(1381),
    [anon_sym_NA_integer_] = ACTIONS(1381),
    [anon_sym_NA_real_] = ACTIONS(1381),
    [aux_sym_identifier_token1] = ACTIONS(1381),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_integer] = ACTIONS(1379),
    [sym_float] = ACTIONS(1381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [698] = {
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym_function] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2265),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_LPAREN] = ACTIONS(2265),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_repeat] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(2265),
    [anon_sym_EQ] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_LT_DASH] = ACTIONS(2265),
    [anon_sym_COLON_EQ] = ACTIONS(2265),
    [anon_sym_LT_LT_DASH] = ACTIONS(2265),
    [anon_sym_DASH_GT_GT] = ACTIONS(2265),
    [anon_sym_DASH_GT] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2265),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2265),
    [anon_sym_DOLLAR] = ACTIONS(2265),
    [anon_sym_AT] = ACTIONS(2265),
    [sym_dots] = ACTIONS(2267),
    [anon_sym_PIPE_GT] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_SLASH] = ACTIONS(2265),
    [anon_sym_CARET] = ACTIONS(2265),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_GT] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2265),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_EQ_EQ] = ACTIONS(2265),
    [anon_sym_BANG_EQ] = ACTIONS(2265),
    [anon_sym_PIPE_PIPE] = ACTIONS(2265),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_COLON] = ACTIONS(2267),
    [sym_break] = ACTIONS(2267),
    [sym_next] = ACTIONS(2267),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [sym_null] = ACTIONS(2267),
    [sym_inf] = ACTIONS(2267),
    [sym_nan] = ACTIONS(2267),
    [anon_sym_NA] = ACTIONS(2267),
    [anon_sym_NA_character_] = ACTIONS(2267),
    [anon_sym_NA_complex_] = ACTIONS(2267),
    [anon_sym_NA_integer_] = ACTIONS(2267),
    [anon_sym_NA_real_] = ACTIONS(2267),
    [aux_sym_identifier_token1] = ACTIONS(2267),
    [anon_sym_BQUOTE] = ACTIONS(2265),
    [sym_integer] = ACTIONS(2265),
    [sym_float] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [anon_sym_PERCENT] = ACTIONS(2265),
  },
  [699] = {
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym_function] = ACTIONS(2271),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_LPAREN] = ACTIONS(2269),
    [anon_sym_else] = ACTIONS(2271),
    [anon_sym_while] = ACTIONS(2271),
    [anon_sym_repeat] = ACTIONS(2271),
    [anon_sym_for] = ACTIONS(2271),
    [anon_sym_switch] = ACTIONS(2271),
    [anon_sym_COMMA] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2271),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_LT_DASH] = ACTIONS(2269),
    [anon_sym_COLON_EQ] = ACTIONS(2269),
    [anon_sym_LT_LT_DASH] = ACTIONS(2269),
    [anon_sym_DASH_GT_GT] = ACTIONS(2269),
    [anon_sym_DASH_GT] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2269),
    [anon_sym_DOLLAR] = ACTIONS(2269),
    [anon_sym_AT] = ACTIONS(2269),
    [sym_dots] = ACTIONS(2271),
    [anon_sym_PIPE_GT] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2271),
    [anon_sym_PLUS] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2271),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2271),
    [anon_sym_GT] = ACTIONS(2271),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2271),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym_COLON] = ACTIONS(2271),
    [sym_break] = ACTIONS(2271),
    [sym_next] = ACTIONS(2271),
    [sym_true] = ACTIONS(2271),
    [sym_false] = ACTIONS(2271),
    [sym_null] = ACTIONS(2271),
    [sym_inf] = ACTIONS(2271),
    [sym_nan] = ACTIONS(2271),
    [anon_sym_NA] = ACTIONS(2271),
    [anon_sym_NA_character_] = ACTIONS(2271),
    [anon_sym_NA_complex_] = ACTIONS(2271),
    [anon_sym_NA_integer_] = ACTIONS(2271),
    [anon_sym_NA_real_] = ACTIONS(2271),
    [aux_sym_identifier_token1] = ACTIONS(2271),
    [anon_sym_BQUOTE] = ACTIONS(2269),
    [sym_integer] = ACTIONS(2269),
    [sym_float] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2269),
    [anon_sym_SQUOTE] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2269),
  },
  [700] = {
    [ts_builtin_sym_end] = ACTIONS(2265),
    [anon_sym_LF] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_function] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_LPAREN] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_repeat] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_EQ] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_LT_DASH] = ACTIONS(2267),
    [anon_sym_COLON_EQ] = ACTIONS(2267),
    [anon_sym_LT_LT_DASH] = ACTIONS(2267),
    [anon_sym_DASH_GT_GT] = ACTIONS(2267),
    [anon_sym_DASH_GT] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2267),
    [anon_sym_DOLLAR] = ACTIONS(2267),
    [anon_sym_AT] = ACTIONS(2267),
    [sym_dots] = ACTIONS(2267),
    [anon_sym_PIPE_GT] = ACTIONS(2267),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2267),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_GT] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2267),
    [anon_sym_GT_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ] = ACTIONS(2267),
    [anon_sym_BANG_EQ] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_AMP_AMP] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_COLON] = ACTIONS(2267),
    [sym_break] = ACTIONS(2267),
    [sym_next] = ACTIONS(2267),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [sym_null] = ACTIONS(2267),
    [sym_inf] = ACTIONS(2267),
    [sym_nan] = ACTIONS(2267),
    [anon_sym_NA] = ACTIONS(2267),
    [anon_sym_NA_character_] = ACTIONS(2267),
    [anon_sym_NA_complex_] = ACTIONS(2267),
    [anon_sym_NA_integer_] = ACTIONS(2267),
    [anon_sym_NA_real_] = ACTIONS(2267),
    [aux_sym_identifier_token1] = ACTIONS(2267),
    [anon_sym_BQUOTE] = ACTIONS(2267),
    [sym_integer] = ACTIONS(2267),
    [sym_float] = ACTIONS(2267),
    [sym_comment] = ACTIONS(1497),
    [anon_sym_DQUOTE] = ACTIONS(2267),
    [anon_sym_SQUOTE] = ACTIONS(2267),
    [anon_sym_PERCENT] = ACTIONS(2267),
  },
  [701] = {
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym_function] = ACTIONS(2275),
    [anon_sym_BSLASH] = ACTIONS(2273),
    [anon_sym_if] = ACTIONS(2275),
    [anon_sym_LPAREN] = ACTIONS(2273),
    [anon_sym_else] = ACTIONS(2275),
    [anon_sym_while] = ACTIONS(2275),
    [anon_sym_repeat] = ACTIONS(2275),
    [anon_sym_for] = ACTIONS(2275),
    [anon_sym_switch] = ACTIONS(2275),
    [anon_sym_COMMA] = ACTIONS(2273),
    [anon_sym_EQ] = ACTIONS(2275),
    [anon_sym_LBRACE] = ACTIONS(2273),
    [anon_sym_LT_DASH] = ACTIONS(2273),
    [anon_sym_COLON_EQ] = ACTIONS(2273),
    [anon_sym_LT_LT_DASH] = ACTIONS(2273),
    [anon_sym_DASH_GT_GT] = ACTIONS(2273),
    [anon_sym_DASH_GT] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2273),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2273),
    [anon_sym_DOLLAR] = ACTIONS(2273),
    [anon_sym_AT] = ACTIONS(2273),
    [sym_dots] = ACTIONS(2275),
    [anon_sym_PIPE_GT] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2275),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_CARET] = ACTIONS(2273),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_LT_EQ] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2273),
    [anon_sym_EQ_EQ] = ACTIONS(2273),
    [anon_sym_BANG_EQ] = ACTIONS(2273),
    [anon_sym_PIPE_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE] = ACTIONS(2275),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_COLON] = ACTIONS(2275),
    [sym_break] = ACTIONS(2275),
    [sym_next] = ACTIONS(2275),
    [sym_true] = ACTIONS(2275),
    [sym_false] = ACTIONS(2275),
    [sym_null] = ACTIONS(2275),
    [sym_inf] = ACTIONS(2275),
    [sym_nan] = ACTIONS(2275),
    [anon_sym_NA] = ACTIONS(2275),
    [anon_sym_NA_character_] = ACTIONS(2275),
    [anon_sym_NA_complex_] = ACTIONS(2275),
    [anon_sym_NA_integer_] = ACTIONS(2275),
    [anon_sym_NA_real_] = ACTIONS(2275),
    [aux_sym_identifier_token1] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(2273),
    [sym_integer] = ACTIONS(2273),
    [sym_float] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2273),
    [anon_sym_SQUOTE] = ACTIONS(2273),
    [anon_sym_PERCENT] = ACTIONS(2273),
  },
  [702] = {
    [anon_sym_SEMI] = ACTIONS(2277),
    [anon_sym_function] = ACTIONS(2279),
    [anon_sym_BSLASH] = ACTIONS(2277),
    [anon_sym_if] = ACTIONS(2279),
    [anon_sym_LPAREN] = ACTIONS(2277),
    [anon_sym_else] = ACTIONS(2279),
    [anon_sym_while] = ACTIONS(2279),
    [anon_sym_repeat] = ACTIONS(2279),
    [anon_sym_for] = ACTIONS(2279),
    [anon_sym_switch] = ACTIONS(2279),
    [anon_sym_COMMA] = ACTIONS(2277),
    [anon_sym_EQ] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(2277),
    [anon_sym_LT_DASH] = ACTIONS(2277),
    [anon_sym_COLON_EQ] = ACTIONS(2277),
    [anon_sym_LT_LT_DASH] = ACTIONS(2277),
    [anon_sym_DASH_GT_GT] = ACTIONS(2277),
    [anon_sym_DASH_GT] = ACTIONS(2279),
    [anon_sym_LBRACK] = ACTIONS(2279),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2277),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2277),
    [anon_sym_DOLLAR] = ACTIONS(2277),
    [anon_sym_AT] = ACTIONS(2277),
    [sym_dots] = ACTIONS(2279),
    [anon_sym_PIPE_GT] = ACTIONS(2277),
    [anon_sym_DASH] = ACTIONS(2279),
    [anon_sym_PLUS] = ACTIONS(2277),
    [anon_sym_BANG] = ACTIONS(2279),
    [anon_sym_TILDE] = ACTIONS(2277),
    [anon_sym_STAR] = ACTIONS(2277),
    [anon_sym_SLASH] = ACTIONS(2277),
    [anon_sym_CARET] = ACTIONS(2277),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_LT_EQ] = ACTIONS(2277),
    [anon_sym_GT_EQ] = ACTIONS(2277),
    [anon_sym_EQ_EQ] = ACTIONS(2277),
    [anon_sym_BANG_EQ] = ACTIONS(2277),
    [anon_sym_PIPE_PIPE] = ACTIONS(2277),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_AMP] = ACTIONS(2279),
    [anon_sym_COLON] = ACTIONS(2279),
    [sym_break] = ACTIONS(2279),
    [sym_next] = ACTIONS(2279),
    [sym_true] = ACTIONS(2279),
    [sym_false] = ACTIONS(2279),
    [sym_null] = ACTIONS(2279),
    [sym_inf] = ACTIONS(2279),
    [sym_nan] = ACTIONS(2279),
    [anon_sym_NA] = ACTIONS(2279),
    [anon_sym_NA_character_] = ACTIONS(2279),
    [anon_sym_NA_complex_] = ACTIONS(2279),
    [anon_sym_NA_integer_] = ACTIONS(2279),
    [anon_sym_NA_real_] = ACTIONS(2279),
    [aux_sym_identifier_token1] = ACTIONS(2279),
    [anon_sym_BQUOTE] = ACTIONS(2277),
    [sym_integer] = ACTIONS(2277),
    [sym_float] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2277),
    [anon_sym_SQUOTE] = ACTIONS(2277),
    [anon_sym_PERCENT] = ACTIONS(2277),
  },
  [703] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [704] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [705] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [706] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [707] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [708] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
  },
  [709] = {
    [anon_sym_SEMI] = ACTIONS(2281),
    [anon_sym_function] = ACTIONS(2283),
    [anon_sym_BSLASH] = ACTIONS(2281),
    [anon_sym_if] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2281),
    [anon_sym_else] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(2283),
    [anon_sym_repeat] = ACTIONS(2283),
    [anon_sym_for] = ACTIONS(2283),
    [anon_sym_switch] = ACTIONS(2283),
    [anon_sym_COMMA] = ACTIONS(2281),
    [anon_sym_EQ] = ACTIONS(2283),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [anon_sym_LT_DASH] = ACTIONS(2281),
    [anon_sym_COLON_EQ] = ACTIONS(2281),
    [anon_sym_LT_LT_DASH] = ACTIONS(2281),
    [anon_sym_DASH_GT_GT] = ACTIONS(2281),
    [anon_sym_DASH_GT] = ACTIONS(2283),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2281),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2281),
    [anon_sym_DOLLAR] = ACTIONS(2281),
    [anon_sym_AT] = ACTIONS(2281),
    [sym_dots] = ACTIONS(2283),
    [anon_sym_PIPE_GT] = ACTIONS(2281),
    [anon_sym_DASH] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(2281),
    [anon_sym_BANG] = ACTIONS(2283),
    [anon_sym_TILDE] = ACTIONS(2281),
    [anon_sym_STAR] = ACTIONS(2281),
    [anon_sym_SLASH] = ACTIONS(2281),
    [anon_sym_CARET] = ACTIONS(2281),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_LT_EQ] = ACTIONS(2281),
    [anon_sym_GT_EQ] = ACTIONS(2281),
    [anon_sym_EQ_EQ] = ACTIONS(2281),
    [anon_sym_BANG_EQ] = ACTIONS(2281),
    [anon_sym_PIPE_PIPE] = ACTIONS(2281),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_AMP_AMP] = ACTIONS(2281),
    [anon_sym_AMP] = ACTIONS(2283),
    [anon_sym_COLON] = ACTIONS(2283),
    [sym_break] = ACTIONS(2283),
    [sym_next] = ACTIONS(2283),
    [sym_true] = ACTIONS(2283),
    [sym_false] = ACTIONS(2283),
    [sym_null] = ACTIONS(2283),
    [sym_inf] = ACTIONS(2283),
    [sym_nan] = ACTIONS(2283),
    [anon_sym_NA] = ACTIONS(2283),
    [anon_sym_NA_character_] = ACTIONS(2283),
    [anon_sym_NA_complex_] = ACTIONS(2283),
    [anon_sym_NA_integer_] = ACTIONS(2283),
    [anon_sym_NA_real_] = ACTIONS(2283),
    [aux_sym_identifier_token1] = ACTIONS(2283),
    [anon_sym_BQUOTE] = ACTIONS(2281),
    [sym_integer] = ACTIONS(2281),
    [sym_float] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2281),
    [anon_sym_SQUOTE] = ACTIONS(2281),
    [anon_sym_PERCENT] = ACTIONS(2281),
  },
  [710] = {
    [anon_sym_SEMI] = ACTIONS(2285),
    [anon_sym_function] = ACTIONS(2287),
    [anon_sym_BSLASH] = ACTIONS(2285),
    [anon_sym_if] = ACTIONS(2287),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_else] = ACTIONS(2287),
    [anon_sym_while] = ACTIONS(2287),
    [anon_sym_repeat] = ACTIONS(2287),
    [anon_sym_for] = ACTIONS(2287),
    [anon_sym_switch] = ACTIONS(2287),
    [anon_sym_COMMA] = ACTIONS(2285),
    [anon_sym_EQ] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2285),
    [anon_sym_LT_DASH] = ACTIONS(2285),
    [anon_sym_COLON_EQ] = ACTIONS(2285),
    [anon_sym_LT_LT_DASH] = ACTIONS(2285),
    [anon_sym_DASH_GT_GT] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(2287),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2285),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2285),
    [anon_sym_DOLLAR] = ACTIONS(2285),
    [anon_sym_AT] = ACTIONS(2285),
    [sym_dots] = ACTIONS(2287),
    [anon_sym_PIPE_GT] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2287),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2285),
    [anon_sym_SLASH] = ACTIONS(2285),
    [anon_sym_CARET] = ACTIONS(2285),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_LT_EQ] = ACTIONS(2285),
    [anon_sym_GT_EQ] = ACTIONS(2285),
    [anon_sym_EQ_EQ] = ACTIONS(2285),
    [anon_sym_BANG_EQ] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2285),
    [anon_sym_PIPE] = ACTIONS(2287),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2287),
    [sym_break] = ACTIONS(2287),
    [sym_next] = ACTIONS(2287),
    [sym_true] = ACTIONS(2287),
    [sym_false] = ACTIONS(2287),
    [sym_null] = ACTIONS(2287),
    [sym_inf] = ACTIONS(2287),
    [sym_nan] = ACTIONS(2287),
    [anon_sym_NA] = ACTIONS(2287),
    [anon_sym_NA_character_] = ACTIONS(2287),
    [anon_sym_NA_complex_] = ACTIONS(2287),
    [anon_sym_NA_integer_] = ACTIONS(2287),
    [anon_sym_NA_real_] = ACTIONS(2287),
    [aux_sym_identifier_token1] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2285),
    [sym_integer] = ACTIONS(2285),
    [sym_float] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [anon_sym_PERCENT] = ACTIONS(2285),
  },
  [711] = {
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_function] = ACTIONS(2291),
    [anon_sym_BSLASH] = ACTIONS(2289),
    [anon_sym_if] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(2289),
    [anon_sym_else] = ACTIONS(2291),
    [anon_sym_while] = ACTIONS(2291),
    [anon_sym_repeat] = ACTIONS(2291),
    [anon_sym_for] = ACTIONS(2291),
    [anon_sym_switch] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(2289),
    [anon_sym_EQ] = ACTIONS(2291),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_LT_DASH] = ACTIONS(2289),
    [anon_sym_COLON_EQ] = ACTIONS(2289),
    [anon_sym_LT_LT_DASH] = ACTIONS(2289),
    [anon_sym_DASH_GT_GT] = ACTIONS(2289),
    [anon_sym_DASH_GT] = ACTIONS(2291),
    [anon_sym_LBRACK] = ACTIONS(2291),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2289),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2289),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_AT] = ACTIONS(2289),
    [sym_dots] = ACTIONS(2291),
    [anon_sym_PIPE_GT] = ACTIONS(2289),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_BANG] = ACTIONS(2291),
    [anon_sym_TILDE] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_SLASH] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2289),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2289),
    [anon_sym_GT_EQ] = ACTIONS(2289),
    [anon_sym_EQ_EQ] = ACTIONS(2289),
    [anon_sym_BANG_EQ] = ACTIONS(2289),
    [anon_sym_PIPE_PIPE] = ACTIONS(2289),
    [anon_sym_PIPE] = ACTIONS(2291),
    [anon_sym_AMP_AMP] = ACTIONS(2289),
    [anon_sym_AMP] = ACTIONS(2291),
    [anon_sym_COLON] = ACTIONS(2291),
    [sym_break] = ACTIONS(2291),
    [sym_next] = ACTIONS(2291),
    [sym_true] = ACTIONS(2291),
    [sym_false] = ACTIONS(2291),
    [sym_null] = ACTIONS(2291),
    [sym_inf] = ACTIONS(2291),
    [sym_nan] = ACTIONS(2291),
    [anon_sym_NA] = ACTIONS(2291),
    [anon_sym_NA_character_] = ACTIONS(2291),
    [anon_sym_NA_complex_] = ACTIONS(2291),
    [anon_sym_NA_integer_] = ACTIONS(2291),
    [anon_sym_NA_real_] = ACTIONS(2291),
    [aux_sym_identifier_token1] = ACTIONS(2291),
    [anon_sym_BQUOTE] = ACTIONS(2289),
    [sym_integer] = ACTIONS(2289),
    [sym_float] = ACTIONS(2291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2289),
    [anon_sym_SQUOTE] = ACTIONS(2289),
    [anon_sym_PERCENT] = ACTIONS(2289),
  },
  [712] = {
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_function] = ACTIONS(2295),
    [anon_sym_BSLASH] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2295),
    [anon_sym_LPAREN] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2295),
    [anon_sym_while] = ACTIONS(2295),
    [anon_sym_repeat] = ACTIONS(2295),
    [anon_sym_for] = ACTIONS(2295),
    [anon_sym_switch] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_LT_DASH] = ACTIONS(2293),
    [anon_sym_COLON_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_DASH] = ACTIONS(2293),
    [anon_sym_DASH_GT_GT] = ACTIONS(2293),
    [anon_sym_DASH_GT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2293),
    [anon_sym_DOLLAR] = ACTIONS(2293),
    [anon_sym_AT] = ACTIONS(2293),
    [sym_dots] = ACTIONS(2295),
    [anon_sym_PIPE_GT] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_BANG] = ACTIONS(2295),
    [anon_sym_TILDE] = ACTIONS(2293),
    [anon_sym_STAR] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_LT_EQ] = ACTIONS(2293),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2293),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_COLON] = ACTIONS(2295),
    [sym_break] = ACTIONS(2295),
    [sym_next] = ACTIONS(2295),
    [sym_true] = ACTIONS(2295),
    [sym_false] = ACTIONS(2295),
    [sym_null] = ACTIONS(2295),
    [sym_inf] = ACTIONS(2295),
    [sym_nan] = ACTIONS(2295),
    [anon_sym_NA] = ACTIONS(2295),
    [anon_sym_NA_character_] = ACTIONS(2295),
    [anon_sym_NA_complex_] = ACTIONS(2295),
    [anon_sym_NA_integer_] = ACTIONS(2295),
    [anon_sym_NA_real_] = ACTIONS(2295),
    [aux_sym_identifier_token1] = ACTIONS(2295),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_integer] = ACTIONS(2293),
    [sym_float] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [anon_sym_SQUOTE] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
  },
  [713] = {
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_function] = ACTIONS(2299),
    [anon_sym_BSLASH] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2299),
    [anon_sym_LPAREN] = ACTIONS(2297),
    [anon_sym_else] = ACTIONS(2299),
    [anon_sym_while] = ACTIONS(2299),
    [anon_sym_repeat] = ACTIONS(2299),
    [anon_sym_for] = ACTIONS(2299),
    [anon_sym_switch] = ACTIONS(2299),
    [anon_sym_COMMA] = ACTIONS(2297),
    [anon_sym_EQ] = ACTIONS(2299),
    [anon_sym_LBRACE] = ACTIONS(2297),
    [anon_sym_LT_DASH] = ACTIONS(2297),
    [anon_sym_COLON_EQ] = ACTIONS(2297),
    [anon_sym_LT_LT_DASH] = ACTIONS(2297),
    [anon_sym_DASH_GT_GT] = ACTIONS(2297),
    [anon_sym_DASH_GT] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(2299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2297),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2297),
    [anon_sym_DOLLAR] = ACTIONS(2297),
    [anon_sym_AT] = ACTIONS(2297),
    [sym_dots] = ACTIONS(2299),
    [anon_sym_PIPE_GT] = ACTIONS(2297),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_BANG] = ACTIONS(2299),
    [anon_sym_TILDE] = ACTIONS(2297),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_SLASH] = ACTIONS(2297),
    [anon_sym_CARET] = ACTIONS(2297),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_LT_EQ] = ACTIONS(2297),
    [anon_sym_GT_EQ] = ACTIONS(2297),
    [anon_sym_EQ_EQ] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(2297),
    [anon_sym_PIPE_PIPE] = ACTIONS(2297),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_AMP_AMP] = ACTIONS(2297),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_COLON] = ACTIONS(2299),
    [sym_break] = ACTIONS(2299),
    [sym_next] = ACTIONS(2299),
    [sym_true] = ACTIONS(2299),
    [sym_false] = ACTIONS(2299),
    [sym_null] = ACTIONS(2299),
    [sym_inf] = ACTIONS(2299),
    [sym_nan] = ACTIONS(2299),
    [anon_sym_NA] = ACTIONS(2299),
    [anon_sym_NA_character_] = ACTIONS(2299),
    [anon_sym_NA_complex_] = ACTIONS(2299),
    [anon_sym_NA_integer_] = ACTIONS(2299),
    [anon_sym_NA_real_] = ACTIONS(2299),
    [aux_sym_identifier_token1] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2297),
    [sym_integer] = ACTIONS(2297),
    [sym_float] = ACTIONS(2299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2297),
    [anon_sym_SQUOTE] = ACTIONS(2297),
    [anon_sym_PERCENT] = ACTIONS(2297),
  },
  [714] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [715] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [716] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_function] = ACTIONS(1409),
    [anon_sym_BSLASH] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_repeat] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_LT_DASH] = ACTIONS(1407),
    [anon_sym_COLON_EQ] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_DASH_GT_GT] = ACTIONS(1407),
    [anon_sym_DASH_GT] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1407),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1409),
    [anon_sym_PIPE_GT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1409),
    [sym_next] = ACTIONS(1409),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [sym_null] = ACTIONS(1409),
    [sym_inf] = ACTIONS(1409),
    [sym_nan] = ACTIONS(1409),
    [anon_sym_NA] = ACTIONS(1409),
    [anon_sym_NA_character_] = ACTIONS(1409),
    [anon_sym_NA_complex_] = ACTIONS(1409),
    [anon_sym_NA_integer_] = ACTIONS(1409),
    [anon_sym_NA_real_] = ACTIONS(1409),
    [aux_sym_identifier_token1] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_integer] = ACTIONS(1407),
    [sym_float] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [717] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_function] = ACTIONS(1443),
    [anon_sym_BSLASH] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_repeat] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_EQ] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_LT_DASH] = ACTIONS(1441),
    [anon_sym_COLON_EQ] = ACTIONS(1441),
    [anon_sym_LT_LT_DASH] = ACTIONS(1441),
    [anon_sym_DASH_GT_GT] = ACTIONS(1441),
    [anon_sym_DASH_GT] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1441),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1443),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1443),
    [sym_next] = ACTIONS(1443),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_inf] = ACTIONS(1443),
    [sym_nan] = ACTIONS(1443),
    [anon_sym_NA] = ACTIONS(1443),
    [anon_sym_NA_character_] = ACTIONS(1443),
    [anon_sym_NA_complex_] = ACTIONS(1443),
    [anon_sym_NA_integer_] = ACTIONS(1443),
    [anon_sym_NA_real_] = ACTIONS(1443),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [anon_sym_BQUOTE] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1441),
    [sym_float] = ACTIONS(1443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1441),
    [anon_sym_SQUOTE] = ACTIONS(1441),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [718] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_BSLASH] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_repeat] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_LT_DASH] = ACTIONS(2541),
    [anon_sym_COLON_EQ] = ACTIONS(2543),
    [anon_sym_LT_LT_DASH] = ACTIONS(2545),
    [anon_sym_DASH_GT_GT] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1445),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1447),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1447),
    [sym_next] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_inf] = ACTIONS(1447),
    [sym_nan] = ACTIONS(1447),
    [anon_sym_NA] = ACTIONS(1447),
    [anon_sym_NA_character_] = ACTIONS(1447),
    [anon_sym_NA_complex_] = ACTIONS(1447),
    [anon_sym_NA_integer_] = ACTIONS(1447),
    [anon_sym_NA_real_] = ACTIONS(1447),
    [aux_sym_identifier_token1] = ACTIONS(1447),
    [anon_sym_BQUOTE] = ACTIONS(1445),
    [sym_integer] = ACTIONS(1445),
    [sym_float] = ACTIONS(1447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [719] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_function] = ACTIONS(1459),
    [anon_sym_BSLASH] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1459),
    [anon_sym_repeat] = ACTIONS(1459),
    [anon_sym_for] = ACTIONS(1459),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_LT_DASH] = ACTIONS(2541),
    [anon_sym_COLON_EQ] = ACTIONS(2543),
    [anon_sym_LT_LT_DASH] = ACTIONS(2545),
    [anon_sym_DASH_GT_GT] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1457),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1459),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1459),
    [sym_next] = ACTIONS(1459),
    [sym_true] = ACTIONS(1459),
    [sym_false] = ACTIONS(1459),
    [sym_null] = ACTIONS(1459),
    [sym_inf] = ACTIONS(1459),
    [sym_nan] = ACTIONS(1459),
    [anon_sym_NA] = ACTIONS(1459),
    [anon_sym_NA_character_] = ACTIONS(1459),
    [anon_sym_NA_complex_] = ACTIONS(1459),
    [anon_sym_NA_integer_] = ACTIONS(1459),
    [anon_sym_NA_real_] = ACTIONS(1459),
    [aux_sym_identifier_token1] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1457),
    [sym_integer] = ACTIONS(1457),
    [sym_float] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1457),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [720] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1463),
    [anon_sym_BSLASH] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1463),
    [anon_sym_repeat] = ACTIONS(1463),
    [anon_sym_for] = ACTIONS(1463),
    [anon_sym_switch] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_LT_DASH] = ACTIONS(2541),
    [anon_sym_COLON_EQ] = ACTIONS(2543),
    [anon_sym_LT_LT_DASH] = ACTIONS(2545),
    [anon_sym_DASH_GT_GT] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1461),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1463),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1463),
    [sym_next] = ACTIONS(1463),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_inf] = ACTIONS(1463),
    [sym_nan] = ACTIONS(1463),
    [anon_sym_NA] = ACTIONS(1463),
    [anon_sym_NA_character_] = ACTIONS(1463),
    [anon_sym_NA_complex_] = ACTIONS(1463),
    [anon_sym_NA_integer_] = ACTIONS(1463),
    [anon_sym_NA_real_] = ACTIONS(1463),
    [aux_sym_identifier_token1] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [sym_integer] = ACTIONS(1461),
    [sym_float] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1461),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [721] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(1467),
    [anon_sym_BSLASH] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1467),
    [anon_sym_repeat] = ACTIONS(1467),
    [anon_sym_for] = ACTIONS(1467),
    [anon_sym_switch] = ACTIONS(1467),
    [anon_sym_COMMA] = ACTIONS(1465),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(1465),
    [anon_sym_LT_DASH] = ACTIONS(2541),
    [anon_sym_COLON_EQ] = ACTIONS(2543),
    [anon_sym_LT_LT_DASH] = ACTIONS(2545),
    [anon_sym_DASH_GT_GT] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1465),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1467),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1467),
    [sym_next] = ACTIONS(1467),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_null] = ACTIONS(1467),
    [sym_inf] = ACTIONS(1467),
    [sym_nan] = ACTIONS(1467),
    [anon_sym_NA] = ACTIONS(1467),
    [anon_sym_NA_character_] = ACTIONS(1467),
    [anon_sym_NA_complex_] = ACTIONS(1467),
    [anon_sym_NA_integer_] = ACTIONS(1467),
    [anon_sym_NA_real_] = ACTIONS(1467),
    [aux_sym_identifier_token1] = ACTIONS(1467),
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [sym_integer] = ACTIONS(1465),
    [sym_float] = ACTIONS(1467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_SQUOTE] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [722] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_BSLASH] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_LT_DASH] = ACTIONS(2541),
    [anon_sym_COLON_EQ] = ACTIONS(2543),
    [anon_sym_LT_LT_DASH] = ACTIONS(2545),
    [anon_sym_DASH_GT_GT] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1485),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1487),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1487),
    [sym_next] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_inf] = ACTIONS(1487),
    [sym_nan] = ACTIONS(1487),
    [anon_sym_NA] = ACTIONS(1487),
    [anon_sym_NA_character_] = ACTIONS(1487),
    [anon_sym_NA_complex_] = ACTIONS(1487),
    [anon_sym_NA_integer_] = ACTIONS(1487),
    [anon_sym_NA_real_] = ACTIONS(1487),
    [aux_sym_identifier_token1] = ACTIONS(1487),
    [anon_sym_BQUOTE] = ACTIONS(1485),
    [sym_integer] = ACTIONS(1485),
    [sym_float] = ACTIONS(1487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1485),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [723] = {
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_function] = ACTIONS(2303),
    [anon_sym_BSLASH] = ACTIONS(2301),
    [anon_sym_if] = ACTIONS(2303),
    [anon_sym_LPAREN] = ACTIONS(2301),
    [anon_sym_else] = ACTIONS(2303),
    [anon_sym_while] = ACTIONS(2303),
    [anon_sym_repeat] = ACTIONS(2303),
    [anon_sym_for] = ACTIONS(2303),
    [anon_sym_switch] = ACTIONS(2303),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_EQ] = ACTIONS(2303),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_LT_DASH] = ACTIONS(2301),
    [anon_sym_COLON_EQ] = ACTIONS(2301),
    [anon_sym_LT_LT_DASH] = ACTIONS(2301),
    [anon_sym_DASH_GT_GT] = ACTIONS(2301),
    [anon_sym_DASH_GT] = ACTIONS(2303),
    [anon_sym_LBRACK] = ACTIONS(2303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2301),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2301),
    [anon_sym_DOLLAR] = ACTIONS(2301),
    [anon_sym_AT] = ACTIONS(2301),
    [sym_dots] = ACTIONS(2303),
    [anon_sym_PIPE_GT] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2303),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2301),
    [anon_sym_STAR] = ACTIONS(2301),
    [anon_sym_SLASH] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_EQ_EQ] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_COLON] = ACTIONS(2303),
    [sym_break] = ACTIONS(2303),
    [sym_next] = ACTIONS(2303),
    [sym_true] = ACTIONS(2303),
    [sym_false] = ACTIONS(2303),
    [sym_null] = ACTIONS(2303),
    [sym_inf] = ACTIONS(2303),
    [sym_nan] = ACTIONS(2303),
    [anon_sym_NA] = ACTIONS(2303),
    [anon_sym_NA_character_] = ACTIONS(2303),
    [anon_sym_NA_complex_] = ACTIONS(2303),
    [anon_sym_NA_integer_] = ACTIONS(2303),
    [anon_sym_NA_real_] = ACTIONS(2303),
    [aux_sym_identifier_token1] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [sym_integer] = ACTIONS(2301),
    [sym_float] = ACTIONS(2303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2301),
    [anon_sym_PERCENT] = ACTIONS(2301),
  },
  [724] = {
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_function] = ACTIONS(2307),
    [anon_sym_BSLASH] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(2305),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_repeat] = ACTIONS(2307),
    [anon_sym_for] = ACTIONS(2307),
    [anon_sym_switch] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_EQ] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_LT_DASH] = ACTIONS(2305),
    [anon_sym_COLON_EQ] = ACTIONS(2305),
    [anon_sym_LT_LT_DASH] = ACTIONS(2305),
    [anon_sym_DASH_GT_GT] = ACTIONS(2305),
    [anon_sym_DASH_GT] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2305),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2305),
    [anon_sym_DOLLAR] = ACTIONS(2305),
    [anon_sym_AT] = ACTIONS(2305),
    [sym_dots] = ACTIONS(2307),
    [anon_sym_PIPE_GT] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(2307),
    [anon_sym_TILDE] = ACTIONS(2305),
    [anon_sym_STAR] = ACTIONS(2305),
    [anon_sym_SLASH] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2305),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP_AMP] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_COLON] = ACTIONS(2307),
    [sym_break] = ACTIONS(2307),
    [sym_next] = ACTIONS(2307),
    [sym_true] = ACTIONS(2307),
    [sym_false] = ACTIONS(2307),
    [sym_null] = ACTIONS(2307),
    [sym_inf] = ACTIONS(2307),
    [sym_nan] = ACTIONS(2307),
    [anon_sym_NA] = ACTIONS(2307),
    [anon_sym_NA_character_] = ACTIONS(2307),
    [anon_sym_NA_complex_] = ACTIONS(2307),
    [anon_sym_NA_integer_] = ACTIONS(2307),
    [anon_sym_NA_real_] = ACTIONS(2307),
    [aux_sym_identifier_token1] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2305),
    [sym_integer] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2305),
    [anon_sym_SQUOTE] = ACTIONS(2305),
    [anon_sym_PERCENT] = ACTIONS(2305),
  },
  [725] = {
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym_function] = ACTIONS(2363),
    [anon_sym_BSLASH] = ACTIONS(2361),
    [anon_sym_if] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(2361),
    [anon_sym_else] = ACTIONS(2363),
    [anon_sym_while] = ACTIONS(2363),
    [anon_sym_repeat] = ACTIONS(2363),
    [anon_sym_for] = ACTIONS(2363),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_COMMA] = ACTIONS(2361),
    [anon_sym_EQ] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_DASH] = ACTIONS(2361),
    [anon_sym_COLON_EQ] = ACTIONS(2361),
    [anon_sym_LT_LT_DASH] = ACTIONS(2361),
    [anon_sym_DASH_GT_GT] = ACTIONS(2361),
    [anon_sym_DASH_GT] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2361),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2361),
    [anon_sym_DOLLAR] = ACTIONS(2361),
    [anon_sym_AT] = ACTIONS(2361),
    [sym_dots] = ACTIONS(2363),
    [anon_sym_PIPE_GT] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_PLUS] = ACTIONS(2361),
    [anon_sym_BANG] = ACTIONS(2363),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_CARET] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2363),
    [anon_sym_LT_EQ] = ACTIONS(2361),
    [anon_sym_GT_EQ] = ACTIONS(2361),
    [anon_sym_EQ_EQ] = ACTIONS(2361),
    [anon_sym_BANG_EQ] = ACTIONS(2361),
    [anon_sym_PIPE_PIPE] = ACTIONS(2361),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2363),
    [sym_break] = ACTIONS(2363),
    [sym_next] = ACTIONS(2363),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [sym_null] = ACTIONS(2363),
    [sym_inf] = ACTIONS(2363),
    [sym_nan] = ACTIONS(2363),
    [anon_sym_NA] = ACTIONS(2363),
    [anon_sym_NA_character_] = ACTIONS(2363),
    [anon_sym_NA_complex_] = ACTIONS(2363),
    [anon_sym_NA_integer_] = ACTIONS(2363),
    [anon_sym_NA_real_] = ACTIONS(2363),
    [aux_sym_identifier_token1] = ACTIONS(2363),
    [anon_sym_BQUOTE] = ACTIONS(2361),
    [sym_integer] = ACTIONS(2361),
    [sym_float] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2361),
    [anon_sym_SQUOTE] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2361),
  },
  [726] = {
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym_function] = ACTIONS(2367),
    [anon_sym_BSLASH] = ACTIONS(2365),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2365),
    [anon_sym_else] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_repeat] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(2365),
    [anon_sym_EQ] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_LT_DASH] = ACTIONS(2365),
    [anon_sym_COLON_EQ] = ACTIONS(2365),
    [anon_sym_LT_LT_DASH] = ACTIONS(2365),
    [anon_sym_DASH_GT_GT] = ACTIONS(2365),
    [anon_sym_DASH_GT] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2365),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2365),
    [anon_sym_DOLLAR] = ACTIONS(2365),
    [anon_sym_AT] = ACTIONS(2365),
    [sym_dots] = ACTIONS(2367),
    [anon_sym_PIPE_GT] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2367),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2365),
    [anon_sym_CARET] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2365),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [anon_sym_EQ_EQ] = ACTIONS(2365),
    [anon_sym_BANG_EQ] = ACTIONS(2365),
    [anon_sym_PIPE_PIPE] = ACTIONS(2365),
    [anon_sym_PIPE] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2365),
    [anon_sym_AMP] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [sym_break] = ACTIONS(2367),
    [sym_next] = ACTIONS(2367),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [sym_null] = ACTIONS(2367),
    [sym_inf] = ACTIONS(2367),
    [sym_nan] = ACTIONS(2367),
    [anon_sym_NA] = ACTIONS(2367),
    [anon_sym_NA_character_] = ACTIONS(2367),
    [anon_sym_NA_complex_] = ACTIONS(2367),
    [anon_sym_NA_integer_] = ACTIONS(2367),
    [anon_sym_NA_real_] = ACTIONS(2367),
    [aux_sym_identifier_token1] = ACTIONS(2367),
    [anon_sym_BQUOTE] = ACTIONS(2365),
    [sym_integer] = ACTIONS(2365),
    [sym_float] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2365),
    [anon_sym_SQUOTE] = ACTIONS(2365),
    [anon_sym_PERCENT] = ACTIONS(2365),
  },
  [727] = {
    [anon_sym_SEMI] = ACTIONS(2369),
    [anon_sym_function] = ACTIONS(2371),
    [anon_sym_BSLASH] = ACTIONS(2369),
    [anon_sym_if] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2369),
    [anon_sym_else] = ACTIONS(2371),
    [anon_sym_while] = ACTIONS(2371),
    [anon_sym_repeat] = ACTIONS(2371),
    [anon_sym_for] = ACTIONS(2371),
    [anon_sym_switch] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(2369),
    [anon_sym_LT_DASH] = ACTIONS(2369),
    [anon_sym_COLON_EQ] = ACTIONS(2369),
    [anon_sym_LT_LT_DASH] = ACTIONS(2369),
    [anon_sym_DASH_GT_GT] = ACTIONS(2369),
    [anon_sym_DASH_GT] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2369),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2369),
    [anon_sym_DOLLAR] = ACTIONS(2369),
    [anon_sym_AT] = ACTIONS(2369),
    [sym_dots] = ACTIONS(2371),
    [anon_sym_PIPE_GT] = ACTIONS(2369),
    [anon_sym_DASH] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2369),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_SLASH] = ACTIONS(2369),
    [anon_sym_CARET] = ACTIONS(2369),
    [anon_sym_LT] = ACTIONS(2371),
    [anon_sym_GT] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2369),
    [anon_sym_GT_EQ] = ACTIONS(2369),
    [anon_sym_EQ_EQ] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2369),
    [anon_sym_PIPE_PIPE] = ACTIONS(2369),
    [anon_sym_PIPE] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2369),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2371),
    [sym_break] = ACTIONS(2371),
    [sym_next] = ACTIONS(2371),
    [sym_true] = ACTIONS(2371),
    [sym_false] = ACTIONS(2371),
    [sym_null] = ACTIONS(2371),
    [sym_inf] = ACTIONS(2371),
    [sym_nan] = ACTIONS(2371),
    [anon_sym_NA] = ACTIONS(2371),
    [anon_sym_NA_character_] = ACTIONS(2371),
    [anon_sym_NA_complex_] = ACTIONS(2371),
    [anon_sym_NA_integer_] = ACTIONS(2371),
    [anon_sym_NA_real_] = ACTIONS(2371),
    [aux_sym_identifier_token1] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2369),
    [sym_integer] = ACTIONS(2369),
    [sym_float] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2369),
    [anon_sym_SQUOTE] = ACTIONS(2369),
    [anon_sym_PERCENT] = ACTIONS(2369),
  },
  [728] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym_function] = ACTIONS(1521),
    [anon_sym_BSLASH] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1521),
    [anon_sym_repeat] = ACTIONS(1521),
    [anon_sym_for] = ACTIONS(1521),
    [anon_sym_switch] = ACTIONS(1521),
    [anon_sym_COMMA] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1519),
    [anon_sym_COLON_EQ] = ACTIONS(1519),
    [anon_sym_LT_LT_DASH] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT] = ACTIONS(1521),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1521),
    [sym_next] = ACTIONS(1521),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [sym_null] = ACTIONS(1521),
    [sym_inf] = ACTIONS(1521),
    [sym_nan] = ACTIONS(1521),
    [anon_sym_NA] = ACTIONS(1521),
    [anon_sym_NA_character_] = ACTIONS(1521),
    [anon_sym_NA_complex_] = ACTIONS(1521),
    [anon_sym_NA_integer_] = ACTIONS(1521),
    [anon_sym_NA_real_] = ACTIONS(1521),
    [aux_sym_identifier_token1] = ACTIONS(1521),
    [anon_sym_BQUOTE] = ACTIONS(1519),
    [sym_integer] = ACTIONS(1519),
    [sym_float] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1519),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
  [729] = {
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_BSLASH] = ACTIONS(2379),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2379),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_repeat] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_COMMA] = ACTIONS(2379),
    [anon_sym_EQ] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_DASH] = ACTIONS(2379),
    [anon_sym_COLON_EQ] = ACTIONS(2379),
    [anon_sym_LT_LT_DASH] = ACTIONS(2379),
    [anon_sym_DASH_GT_GT] = ACTIONS(2379),
    [anon_sym_DASH_GT] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2379),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2379),
    [anon_sym_DOLLAR] = ACTIONS(2379),
    [anon_sym_AT] = ACTIONS(2379),
    [sym_dots] = ACTIONS(2381),
    [anon_sym_PIPE_GT] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2379),
    [anon_sym_STAR] = ACTIONS(2379),
    [anon_sym_SLASH] = ACTIONS(2379),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_GT] = ACTIONS(2381),
    [anon_sym_LT_EQ] = ACTIONS(2379),
    [anon_sym_GT_EQ] = ACTIONS(2379),
    [anon_sym_EQ_EQ] = ACTIONS(2379),
    [anon_sym_BANG_EQ] = ACTIONS(2379),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_PIPE] = ACTIONS(2381),
    [anon_sym_AMP_AMP] = ACTIONS(2379),
    [anon_sym_AMP] = ACTIONS(2381),
    [anon_sym_COLON] = ACTIONS(2381),
    [sym_break] = ACTIONS(2381),
    [sym_next] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_inf] = ACTIONS(2381),
    [sym_nan] = ACTIONS(2381),
    [anon_sym_NA] = ACTIONS(2381),
    [anon_sym_NA_character_] = ACTIONS(2381),
    [anon_sym_NA_complex_] = ACTIONS(2381),
    [anon_sym_NA_integer_] = ACTIONS(2381),
    [anon_sym_NA_real_] = ACTIONS(2381),
    [aux_sym_identifier_token1] = ACTIONS(2381),
    [anon_sym_BQUOTE] = ACTIONS(2379),
    [sym_integer] = ACTIONS(2379),
    [sym_float] = ACTIONS(2381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(2379),
    [anon_sym_SQUOTE] = ACTIONS(2379),
    [anon_sym_PERCENT] = ACTIONS(2379),
  },
  [730] = {
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_BSLASH] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_repeat] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LT_DASH] = ACTIONS(641),
    [anon_sym_COLON_EQ] = ACTIONS(641),
    [anon_sym_LT_LT_DASH] = ACTIONS(641),
    [anon_sym_DASH_GT_GT] = ACTIONS(641),
    [anon_sym_DASH_GT] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(641),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [sym_dots] = ACTIONS(643),
    [anon_sym_PIPE_GT] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(643),
    [sym_break] = ACTIONS(643),
    [sym_next] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_null] = ACTIONS(643),
    [sym_inf] = ACTIONS(643),
    [sym_nan] = ACTIONS(643),
    [anon_sym_NA] = ACTIONS(643),
    [anon_sym_NA_character_] = ACTIONS(643),
    [anon_sym_NA_complex_] = ACTIONS(643),
    [anon_sym_NA_integer_] = ACTIONS(643),
    [anon_sym_NA_real_] = ACTIONS(643),
    [aux_sym_identifier_token1] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_integer] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [anon_sym_i] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
  },
  [731] = {
    [sym_special] = STATE(408),
    [anon_sym_SEMI] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(1525),
    [anon_sym_BSLASH] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(1525),
    [anon_sym_repeat] = ACTIONS(1525),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1525),
    [anon_sym_COMMA] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1523),
    [anon_sym_COLON_EQ] = ACTIONS(1523),
    [anon_sym_LT_LT_DASH] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT] = ACTIONS(1525),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [sym_dots] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(2559),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_SLASH] = ACTIONS(2567),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON] = ACTIONS(2583),
    [sym_break] = ACTIONS(1525),
    [sym_next] = ACTIONS(1525),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [sym_null] = ACTIONS(1525),
    [sym_inf] = ACTIONS(1525),
    [sym_nan] = ACTIONS(1525),
    [anon_sym_NA] = ACTIONS(1525),
    [anon_sym_NA_character_] = ACTIONS(1525),
    [anon_sym_NA_complex_] = ACTIONS(1525),
    [anon_sym_NA_integer_] = ACTIONS(1525),
    [anon_sym_NA_real_] = ACTIONS(1525),
    [aux_sym_identifier_token1] = ACTIONS(1525),
    [anon_sym_BQUOTE] = ACTIONS(1523),
    [sym_integer] = ACTIONS(1523),
    [sym_float] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1523),
    [anon_sym_PERCENT] = ACTIONS(945),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2275), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [67] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2303), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [136] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2379), 1,
      ts_builtin_sym_end,
    ACTIONS(2381), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [205] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2369), 1,
      ts_builtin_sym_end,
    ACTIONS(2371), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [274] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2365), 1,
      ts_builtin_sym_end,
    ACTIONS(2367), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [343] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2273), 1,
      ts_builtin_sym_end,
    ACTIONS(2275), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [412] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2361), 1,
      ts_builtin_sym_end,
    ACTIONS(2363), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_EQ,
    ACTIONS(641), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(643), 30,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [552] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2375), 1,
      ts_builtin_sym_end,
    ACTIONS(2377), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [621] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2377), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [688] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2203), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [755] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2265), 1,
      ts_builtin_sym_end,
    ACTIONS(2267), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [824] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2207), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [891] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2269), 1,
      ts_builtin_sym_end,
    ACTIONS(2271), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [960] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2367), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [1027] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2215), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [1094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2377), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [1163] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2363), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [1230] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2307), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [1297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2203), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [1366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2207), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [1435] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2277), 1,
      ts_builtin_sym_end,
    ACTIONS(2279), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [1504] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2281), 1,
      ts_builtin_sym_end,
    ACTIONS(2283), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [1573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2209), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2211), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [1642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2381), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [1711] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2285), 1,
      ts_builtin_sym_end,
    ACTIONS(2287), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [1780] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2289), 1,
      ts_builtin_sym_end,
    ACTIONS(2291), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [1849] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2293), 1,
      ts_builtin_sym_end,
    ACTIONS(2295), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [1918] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2297), 1,
      ts_builtin_sym_end,
    ACTIONS(2299), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [1987] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2271), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [2054] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2209), 1,
      ts_builtin_sym_end,
    ACTIONS(2211), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [2123] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2213), 1,
      ts_builtin_sym_end,
    ACTIONS(2215), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [2192] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2267), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [2259] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2291), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [2326] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2205), 1,
      ts_builtin_sym_end,
    ACTIONS(2207), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [2395] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2371), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [2462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2371), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [2531] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2381), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [2598] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2301), 1,
      ts_builtin_sym_end,
    ACTIONS(2303), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [2667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2215), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [2736] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2305), 1,
      ts_builtin_sym_end,
    ACTIONS(2307), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [2805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2265), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2267), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [2874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2367), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [2943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2363), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [3012] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2279), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [3079] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2295), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [3146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2305), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2307), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [3215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2271), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [3284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2299), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [3353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2295), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [3422] = 3,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2201), 1,
      ts_builtin_sym_end,
    ACTIONS(2203), 60,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [3491] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2303), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [3558] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2287), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [3625] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2315), 1,
      anon_sym_EQ,
    ACTIONS(2317), 1,
      anon_sym_LT_DASH,
    ACTIONS(2319), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2321), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2323), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2325), 1,
      anon_sym_DASH_GT,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2337), 1,
      anon_sym_DASH,
    ACTIONS(2339), 1,
      anon_sym_PLUS,
    ACTIONS(2341), 1,
      anon_sym_TILDE,
    ACTIONS(2345), 1,
      anon_sym_CARET,
    ACTIONS(2351), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2353), 1,
      anon_sym_PIPE,
    ACTIONS(2355), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2357), 1,
      anon_sym_AMP,
    ACTIONS(2359), 1,
      anon_sym_COLON,
    STATE(191), 1,
      sym_special,
    ACTIONS(2343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2349), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2641), 8,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(2643), 22,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      sym_dots,
      anon_sym_BANG,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [3746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2289), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2291), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [3815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2287), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [3884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2283), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [3953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2279), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [4022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 30,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACK_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
    ACTIONS(2275), 31,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_dots,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [4091] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2299), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [4158] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2283), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [4225] = 2,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2211), 61,
      anon_sym_LF,
      anon_sym_SEMI,
      anon_sym_function,
      anon_sym_BSLASH,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_dots,
      anon_sym_PIPE_GT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_AMP,
      anon_sym_COLON,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      anon_sym_BQUOTE,
      sym_integer,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PERCENT,
  [4292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 10,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(653), 26,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_in,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [4336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 10,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(657), 26,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_in,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [4380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 10,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(649), 26,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_in,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [4424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2645), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2647), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(643), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(641), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [4471] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    STATE(146), 1,
      sym_special,
    ACTIONS(1409), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 9,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
  [4549] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1409), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1407), 15,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [4615] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    STATE(146), 1,
      sym_special,
    ACTIONS(1525), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1523), 7,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
  [4697] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    STATE(146), 1,
      sym_special,
    ACTIONS(1521), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1519), 7,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
  [4779] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    ACTIONS(2685), 1,
      anon_sym_EQ,
    ACTIONS(2687), 1,
      anon_sym_LT_DASH,
    ACTIONS(2689), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2691), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2693), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1485), 3,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [4871] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    ACTIONS(2685), 1,
      anon_sym_EQ,
    ACTIONS(2687), 1,
      anon_sym_LT_DASH,
    ACTIONS(2689), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2691), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2693), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1465), 3,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [4963] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    ACTIONS(2685), 1,
      anon_sym_EQ,
    ACTIONS(2687), 1,
      anon_sym_LT_DASH,
    ACTIONS(2689), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2691), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2693), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1461), 3,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [5055] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    ACTIONS(2685), 1,
      anon_sym_EQ,
    ACTIONS(2687), 1,
      anon_sym_LT_DASH,
    ACTIONS(2689), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2691), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2693), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1457), 3,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [5147] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    ACTIONS(2685), 1,
      anon_sym_EQ,
    ACTIONS(2687), 1,
      anon_sym_LT_DASH,
    ACTIONS(2689), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2691), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2693), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1445), 3,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [5239] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    STATE(146), 1,
      sym_special,
    ACTIONS(1443), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1441), 7,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
  [5321] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    ACTIONS(2685), 1,
      anon_sym_EQ,
    ACTIONS(2687), 1,
      anon_sym_LT_DASH,
    ACTIONS(2689), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2691), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2693), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1359), 3,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [5413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(435), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(2697), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      sym_dots,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [5455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2699), 1,
      anon_sym_i,
    ACTIONS(643), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(641), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [5499] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    STATE(146), 1,
      sym_special,
    ACTIONS(1409), 7,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1407), 18,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [5559] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    STATE(146), 1,
      sym_special,
    ACTIONS(1409), 8,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(1407), 19,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [5615] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2131), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2129), 11,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [5685] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1409), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 10,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
  [5759] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1409), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 11,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [5829] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    ACTIONS(2685), 1,
      anon_sym_EQ,
    ACTIONS(2687), 1,
      anon_sym_LT_DASH,
    ACTIONS(2689), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2691), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2693), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(2701), 1,
      anon_sym_else,
    STATE(146), 1,
      sym_special,
    ACTIONS(891), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [5923] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    STATE(146), 1,
      sym_special,
    ACTIONS(1409), 8,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(1407), 19,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [5979] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    STATE(146), 1,
      sym_special,
    ACTIONS(1409), 7,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1407), 19,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [6037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(435), 13,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(2697), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      sym_dots,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [6079] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    ACTIONS(2685), 1,
      anon_sym_EQ,
    ACTIONS(2687), 1,
      anon_sym_LT_DASH,
    ACTIONS(2689), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2691), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2693), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1379), 3,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [6171] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1409), 7,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1407), 16,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [6233] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    ACTIONS(2685), 1,
      anon_sym_EQ,
    ACTIONS(2687), 1,
      anon_sym_LT_DASH,
    ACTIONS(2689), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2691), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2693), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1363), 3,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [6325] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    ACTIONS(2685), 1,
      anon_sym_EQ,
    ACTIONS(2687), 1,
      anon_sym_LT_DASH,
    ACTIONS(2689), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2691), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2693), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(2703), 1,
      anon_sym_else,
    STATE(146), 1,
      sym_special,
    ACTIONS(891), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [6419] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(2681), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2683), 1,
      anon_sym_TILDE,
    ACTIONS(2685), 1,
      anon_sym_EQ,
    ACTIONS(2687), 1,
      anon_sym_LT_DASH,
    ACTIONS(2689), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2691), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2693), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    STATE(146), 1,
      sym_special,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2121), 3,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [6511] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    STATE(146), 1,
      sym_special,
    ACTIONS(2131), 8,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2129), 19,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [6567] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2655), 1,
      anon_sym_DOLLAR,
    ACTIONS(2657), 1,
      anon_sym_AT,
    ACTIONS(2659), 1,
      anon_sym_DASH,
    ACTIONS(2661), 1,
      anon_sym_PLUS,
    ACTIONS(2665), 1,
      anon_sym_CARET,
    ACTIONS(2671), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2673), 1,
      anon_sym_PIPE,
    ACTIONS(2675), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2677), 1,
      anon_sym_AMP,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    STATE(146), 1,
      sym_special,
    ACTIONS(2131), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(2663), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2669), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2129), 9,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
  [6645] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2131), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2129), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [6714] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    STATE(355), 1,
      sym_special,
    ACTIONS(2131), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2129), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
  [6791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2727), 12,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(2729), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      sym_dots,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [6832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2731), 12,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(2733), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      sym_dots,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [6873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2271), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2269), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [6914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2265), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [6955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2213), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [6996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2209), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2735), 12,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(2737), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      sym_dots,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [7078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_i,
    ACTIONS(643), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(641), 23,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7121] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2741), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7212] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(2121), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7303] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_special,
    ACTIONS(2131), 8,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2129), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2757), 12,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(2759), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      sym_dots,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [7399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2381), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2379), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2301), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2205), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2273), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2371), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2369), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7604] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(1525), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1523), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
  [7685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2761), 12,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(2763), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      sym_dots,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [7726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2367), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2365), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2201), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2277), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2375), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2363), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2361), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [7931] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1409), 7,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1407), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [7992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2765), 12,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_BQUOTE,
      sym_integer,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(2767), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_for,
      anon_sym_switch,
      sym_dots,
      sym_break,
      sym_next,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_character_,
      anon_sym_NA_complex_,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      aux_sym_identifier_token1,
      sym_float,
  [8033] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(1521), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1519), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
  [8114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2307), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2305), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [8155] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(1485), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8246] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(1465), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8337] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(1359), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8428] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(1363), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8519] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(1379), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8610] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(1461), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8701] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    STATE(355), 1,
      sym_special,
    ACTIONS(1409), 7,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1407), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [8758] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_special,
    ACTIONS(1409), 8,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(1407), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [8813] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1409), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [8882] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1409), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
  [8955] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1409), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1407), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [9020] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_special,
    ACTIONS(1409), 8,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(1407), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [9075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2297), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [9116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2295), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2293), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [9157] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    STATE(355), 1,
      sym_special,
    ACTIONS(1409), 7,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1407), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [9216] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    STATE(355), 1,
      sym_special,
    ACTIONS(1409), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_GT,
      anon_sym_TILDE,
  [9293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2281), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [9334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2291), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2289), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [9375] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(1457), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9466] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(1445), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9557] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(1443), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1441), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
  [9638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 9,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
    ACTIONS(2285), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_LT_LT_DASH,
      anon_sym_DASH_GT_GT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PERCENT,
  [9679] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2769), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9769] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2771), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9859] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2773), 1,
      anon_sym_COMMA,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9949] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2775), 1,
      anon_sym_COMMA,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10039] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2777), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10129] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2779), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10219] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2781), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10309] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2783), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10399] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2785), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10489] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2787), 1,
      anon_sym_COMMA,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10579] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2789), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10669] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2791), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10759] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2793), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10849] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2795), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10939] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2797), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11029] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2799), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11119] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2801), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11209] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2803), 1,
      anon_sym_COMMA,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11299] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2805), 1,
      anon_sym_COMMA,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11389] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2807), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11479] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2809), 1,
      anon_sym_COMMA,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11569] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2811), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11659] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2813), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11749] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2815), 1,
      anon_sym_COMMA,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11839] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2817), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11929] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2819), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12019] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2821), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12109] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2823), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12199] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2825), 1,
      anon_sym_COMMA,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12289] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2827), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12379] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2829), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12469] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2831), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12559] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2833), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12649] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2835), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12739] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2837), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12829] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2839), 1,
      anon_sym_COMMA,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12919] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2841), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13009] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2843), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13099] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_RPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13189] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2537), 1,
      anon_sym_LPAREN,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13276] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2847), 1,
      anon_sym_LPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13363] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2217), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13450] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2849), 1,
      anon_sym_LPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13537] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13624] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2851), 1,
      anon_sym_LPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13711] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13798] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    ACTIONS(2853), 1,
      anon_sym_LPAREN,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13885] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_PERCENT,
    ACTIONS(2313), 1,
      anon_sym_LPAREN,
    ACTIONS(2327), 1,
      anon_sym_LBRACK,
    ACTIONS(2329), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_DOLLAR,
    ACTIONS(2333), 1,
      anon_sym_AT,
    ACTIONS(2335), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2705), 1,
      anon_sym_DASH,
    ACTIONS(2707), 1,
      anon_sym_PLUS,
    ACTIONS(2711), 1,
      anon_sym_CARET,
    ACTIONS(2717), 1,
      anon_sym_COLON,
    ACTIONS(2719), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2725), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_EQ,
    ACTIONS(2745), 1,
      anon_sym_LT_DASH,
    ACTIONS(2747), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2749), 1,
      anon_sym_LT_LT_DASH,
    ACTIONS(2751), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(2753), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_TILDE,
    STATE(355), 1,
      sym_special,
    ACTIONS(2709), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2715), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13972] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      aux_sym_identifier_token1,
    ACTIONS(131), 1,
      anon_sym_BQUOTE,
    ACTIONS(2855), 1,
      anon_sym_RPAREN,
    ACTIONS(2857), 1,
      sym_dots,
    STATE(1014), 1,
      sym_identifier,
    STATE(1054), 2,
      sym_default_parameter,
      sym__formal_parameter,
  [13995] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      aux_sym_identifier_token1,
    ACTIONS(131), 1,
      anon_sym_BQUOTE,
    ACTIONS(2857), 1,
      sym_dots,
    ACTIONS(2859), 1,
      anon_sym_RPAREN,
    STATE(1014), 1,
      sym_identifier,
    STATE(1054), 2,
      sym_default_parameter,
      sym__formal_parameter,
  [14018] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      aux_sym_identifier_token1,
    ACTIONS(131), 1,
      anon_sym_BQUOTE,
    ACTIONS(2861), 1,
      anon_sym_RPAREN,
    ACTIONS(2863), 1,
      sym_dots,
    STATE(1014), 1,
      sym_identifier,
    STATE(1018), 2,
      sym_default_parameter,
      sym__formal_parameter,
  [14041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(2865), 1,
      aux_sym_identifier_token1,
    STATE(758), 2,
      sym_identifier,
      sym_string,
  [14061] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_BQUOTE,
    ACTIONS(697), 1,
      anon_sym_DQUOTE,
    ACTIONS(699), 1,
      anon_sym_SQUOTE,
    ACTIONS(2867), 1,
      aux_sym_identifier_token1,
    STATE(711), 2,
      sym_identifier,
      sym_string,
  [14081] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(863), 1,
      anon_sym_BQUOTE,
    ACTIONS(867), 1,
      anon_sym_DQUOTE,
    ACTIONS(869), 1,
      anon_sym_SQUOTE,
    ACTIONS(2869), 1,
      aux_sym_identifier_token1,
    STATE(451), 2,
      sym_identifier,
      sym_string,
  [14101] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_DQUOTE,
    ACTIONS(91), 1,
      anon_sym_SQUOTE,
    ACTIONS(2871), 1,
      aux_sym_identifier_token1,
    STATE(786), 2,
      sym_identifier,
      sym_string,
  [14121] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(1123), 1,
      anon_sym_DQUOTE,
    ACTIONS(1125), 1,
      anon_sym_SQUOTE,
    ACTIONS(2873), 1,
      aux_sym_identifier_token1,
    STATE(637), 2,
      sym_identifier,
      sym_string,
  [14141] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(787), 1,
      anon_sym_DQUOTE,
    ACTIONS(789), 1,
      anon_sym_SQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(874), 2,
      sym_identifier,
      sym_string,
  [14161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      aux_sym_identifier_token1,
    ACTIONS(131), 1,
      anon_sym_BQUOTE,
    ACTIONS(2857), 1,
      sym_dots,
    STATE(1014), 1,
      sym_identifier,
    STATE(1054), 2,
      sym_default_parameter,
      sym__formal_parameter,
  [14181] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_BQUOTE,
    ACTIONS(135), 1,
      anon_sym_DQUOTE,
    ACTIONS(137), 1,
      anon_sym_SQUOTE,
    ACTIONS(2877), 1,
      aux_sym_identifier_token1,
    STATE(606), 2,
      sym_identifier,
      sym_string,
  [14201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1019), 1,
      anon_sym_BQUOTE,
    ACTIONS(1023), 1,
      anon_sym_DQUOTE,
    ACTIONS(1025), 1,
      anon_sym_SQUOTE,
    ACTIONS(2879), 1,
      aux_sym_identifier_token1,
    STATE(664), 2,
      sym_identifier,
      sym_string,
  [14221] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_BQUOTE,
    ACTIONS(373), 1,
      anon_sym_DQUOTE,
    ACTIONS(375), 1,
      anon_sym_SQUOTE,
    ACTIONS(2881), 1,
      aux_sym_identifier_token1,
    STATE(765), 2,
      sym_identifier,
      sym_string,
  [14241] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2883), 1,
      anon_sym_SQUOTE,
    STATE(968), 1,
      aux_sym_string_repeat2,
    ACTIONS(2885), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14255] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_BQUOTE,
    STATE(960), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2889), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14269] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2891), 1,
      anon_sym_BQUOTE,
    STATE(948), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2893), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14283] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2895), 1,
      anon_sym_DQUOTE,
    STATE(954), 1,
      aux_sym_string_repeat1,
    ACTIONS(2897), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14297] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2895), 1,
      anon_sym_SQUOTE,
    STATE(955), 1,
      aux_sym_string_repeat2,
    ACTIONS(2899), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14311] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_BQUOTE,
    STATE(949), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2903), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14325] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2905), 1,
      anon_sym_DQUOTE,
    STATE(950), 1,
      aux_sym_string_repeat1,
    ACTIONS(2907), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14339] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2905), 1,
      anon_sym_SQUOTE,
    STATE(951), 1,
      aux_sym_string_repeat2,
    ACTIONS(2909), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14353] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2911), 1,
      anon_sym_BQUOTE,
    STATE(959), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2913), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14367] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_BQUOTE,
    STATE(959), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2913), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14381] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_DQUOTE,
    STATE(957), 1,
      aux_sym_string_repeat1,
    ACTIONS(2919), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14395] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_SQUOTE,
    STATE(999), 1,
      aux_sym_string_repeat2,
    ACTIONS(2921), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14409] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_SQUOTE,
    STATE(999), 1,
      aux_sym_string_repeat2,
    ACTIONS(2921), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14423] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_DQUOTE,
    STATE(957), 1,
      aux_sym_string_repeat1,
    ACTIONS(2919), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14437] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_DQUOTE,
    STATE(957), 1,
      aux_sym_string_repeat1,
    ACTIONS(2919), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14451] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_SQUOTE,
    STATE(999), 1,
      aux_sym_string_repeat2,
    ACTIONS(2921), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14465] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2927), 1,
      anon_sym_PERCENT,
    STATE(971), 1,
      aux_sym_special_repeat1,
    ACTIONS(2929), 2,
      aux_sym_special_token1,
      sym_escape_sequence,
  [14479] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_DQUOTE,
    STATE(957), 1,
      aux_sym_string_repeat1,
    ACTIONS(2933), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14493] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_BQUOTE,
    STATE(959), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2913), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14507] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2938), 1,
      anon_sym_BQUOTE,
    STATE(959), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2940), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14521] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_BQUOTE,
    STATE(959), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2913), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14535] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_PERCENT,
    STATE(956), 1,
      aux_sym_special_repeat1,
    ACTIONS(2947), 2,
      aux_sym_special_token1,
      sym_escape_sequence,
  [14549] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2949), 1,
      anon_sym_BQUOTE,
    STATE(970), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2951), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14563] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_BQUOTE,
    STATE(966), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2955), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14577] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2883), 1,
      anon_sym_DQUOTE,
    STATE(967), 1,
      aux_sym_string_repeat1,
    ACTIONS(2957), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14591] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_DQUOTE,
    STATE(972), 1,
      aux_sym_string_repeat1,
    ACTIONS(2961), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14605] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_BQUOTE,
    STATE(959), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2913), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14619] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_DQUOTE,
    STATE(957), 1,
      aux_sym_string_repeat1,
    ACTIONS(2919), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14633] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_SQUOTE,
    STATE(999), 1,
      aux_sym_string_repeat2,
    ACTIONS(2921), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14647] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_SQUOTE,
    STATE(973), 1,
      aux_sym_string_repeat2,
    ACTIONS(2967), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14661] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_BQUOTE,
    STATE(959), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2913), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14675] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_PERCENT,
    STATE(971), 1,
      aux_sym_special_repeat1,
    ACTIONS(2973), 2,
      aux_sym_special_token1,
      sym_escape_sequence,
  [14689] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2976), 1,
      anon_sym_DQUOTE,
    STATE(957), 1,
      aux_sym_string_repeat1,
    ACTIONS(2919), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14703] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2976), 1,
      anon_sym_SQUOTE,
    STATE(999), 1,
      aux_sym_string_repeat2,
    ACTIONS(2921), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14717] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2978), 1,
      anon_sym_BQUOTE,
    STATE(986), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2980), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14731] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2982), 1,
      anon_sym_BQUOTE,
    STATE(979), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2984), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14745] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2986), 1,
      anon_sym_DQUOTE,
    STATE(980), 1,
      aux_sym_string_repeat1,
    ACTIONS(2988), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14759] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2986), 1,
      anon_sym_SQUOTE,
    STATE(981), 1,
      aux_sym_string_repeat2,
    ACTIONS(2990), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14773] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_DQUOTE,
    STATE(982), 1,
      aux_sym_string_repeat1,
    ACTIONS(2994), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14787] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2996), 1,
      anon_sym_BQUOTE,
    STATE(959), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2913), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14801] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2998), 1,
      anon_sym_DQUOTE,
    STATE(957), 1,
      aux_sym_string_repeat1,
    ACTIONS(2919), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14815] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2998), 1,
      anon_sym_SQUOTE,
    STATE(999), 1,
      aux_sym_string_repeat2,
    ACTIONS(2921), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14829] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_DQUOTE,
    STATE(957), 1,
      aux_sym_string_repeat1,
    ACTIONS(2919), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14843] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3002), 1,
      anon_sym_DQUOTE,
    STATE(957), 1,
      aux_sym_string_repeat1,
    ACTIONS(2919), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14857] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3002), 1,
      anon_sym_SQUOTE,
    STATE(999), 1,
      aux_sym_string_repeat2,
    ACTIONS(2921), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14871] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_SQUOTE,
    STATE(987), 1,
      aux_sym_string_repeat2,
    ACTIONS(3004), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14885] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3006), 1,
      anon_sym_BQUOTE,
    STATE(959), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2913), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14899] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_SQUOTE,
    STATE(999), 1,
      aux_sym_string_repeat2,
    ACTIONS(2921), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14913] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_SQUOTE,
    STATE(952), 1,
      aux_sym_string_repeat2,
    ACTIONS(3010), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14927] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3012), 1,
      anon_sym_BQUOTE,
    STATE(993), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(3014), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14941] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3016), 1,
      anon_sym_DQUOTE,
    STATE(994), 1,
      aux_sym_string_repeat1,
    ACTIONS(3018), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14955] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3016), 1,
      anon_sym_SQUOTE,
    STATE(995), 1,
      aux_sym_string_repeat2,
    ACTIONS(3020), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [14969] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_DQUOTE,
    STATE(953), 1,
      aux_sym_string_repeat1,
    ACTIONS(3022), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [14983] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_BQUOTE,
    STATE(959), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(2913), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [14997] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3026), 1,
      anon_sym_DQUOTE,
    STATE(957), 1,
      aux_sym_string_repeat1,
    ACTIONS(2919), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [15011] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3026), 1,
      anon_sym_SQUOTE,
    STATE(999), 1,
      aux_sym_string_repeat2,
    ACTIONS(2921), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [15025] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_BQUOTE,
    STATE(958), 1,
      aux_sym_identifier_repeat1,
    ACTIONS(3030), 2,
      aux_sym_identifier_token2,
      sym_escape_sequence,
  [15039] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_DQUOTE,
    STATE(983), 1,
      aux_sym_string_repeat1,
    ACTIONS(3034), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [15053] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_SQUOTE,
    STATE(984), 1,
      aux_sym_string_repeat2,
    ACTIONS(3036), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [15067] = 4,
    ACTIONS(1497), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym_SQUOTE,
    STATE(999), 1,
      aux_sym_string_repeat2,
    ACTIONS(3040), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [15081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(863), 1,
      anon_sym_BQUOTE,
    ACTIONS(2869), 1,
      aux_sym_identifier_token1,
    STATE(464), 1,
      sym_identifier,
  [15094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2871), 1,
      aux_sym_identifier_token1,
    STATE(733), 1,
      sym_identifier,
  [15107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(1103), 1,
      sym_identifier,
  [15120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(1100), 1,
      sym_identifier,
  [15133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(1096), 1,
      sym_identifier,
  [15146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(1092), 1,
      sym_identifier,
  [15159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(1088), 1,
      sym_identifier,
  [15172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_BQUOTE,
    ACTIONS(2881), 1,
      aux_sym_identifier_token1,
    STATE(750), 1,
      sym_identifier,
  [15185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_BQUOTE,
    ACTIONS(2881), 1,
      aux_sym_identifier_token1,
    STATE(783), 1,
      sym_identifier,
  [15198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_BQUOTE,
    ACTIONS(2881), 1,
      aux_sym_identifier_token1,
    STATE(777), 1,
      sym_identifier,
  [15211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2871), 1,
      aux_sym_identifier_token1,
    STATE(778), 1,
      sym_identifier,
  [15224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(1084), 1,
      sym_identifier,
  [15237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(1080), 1,
      sym_identifier,
  [15250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(1077), 1,
      sym_identifier,
  [15263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3045), 1,
      anon_sym_EQ,
    ACTIONS(3043), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [15274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(2873), 1,
      aux_sym_identifier_token1,
    STATE(633), 1,
      sym_identifier,
  [15287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(2873), 1,
      aux_sym_identifier_token1,
    STATE(635), 1,
      sym_identifier,
  [15300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(1073), 1,
      sym_identifier,
  [15313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3047), 1,
      anon_sym_RPAREN,
    ACTIONS(3049), 1,
      anon_sym_COMMA,
    STATE(1026), 1,
      aux_sym_formal_parameters_repeat1,
  [15326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_BQUOTE,
    ACTIONS(2865), 1,
      aux_sym_identifier_token1,
    STATE(772), 1,
      sym_identifier,
  [15339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_BQUOTE,
    ACTIONS(2865), 1,
      aux_sym_identifier_token1,
    STATE(770), 1,
      sym_identifier,
  [15352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1019), 1,
      anon_sym_BQUOTE,
    ACTIONS(2879), 1,
      aux_sym_identifier_token1,
    STATE(665), 1,
      sym_identifier,
  [15365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1019), 1,
      anon_sym_BQUOTE,
    ACTIONS(2879), 1,
      aux_sym_identifier_token1,
    STATE(669), 1,
      sym_identifier,
  [15378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1019), 1,
      anon_sym_BQUOTE,
    ACTIONS(2879), 1,
      aux_sym_identifier_token1,
    STATE(677), 1,
      sym_identifier,
  [15391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_BQUOTE,
    ACTIONS(2867), 1,
      aux_sym_identifier_token1,
    STATE(712), 1,
      sym_identifier,
  [15404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_BQUOTE,
    ACTIONS(2867), 1,
      aux_sym_identifier_token1,
    STATE(723), 1,
      sym_identifier,
  [15417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2855), 1,
      anon_sym_RPAREN,
    ACTIONS(3051), 1,
      anon_sym_COMMA,
    STATE(1029), 1,
      aux_sym_formal_parameters_repeat1,
  [15430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_BQUOTE,
    ACTIONS(2865), 1,
      aux_sym_identifier_token1,
    STATE(759), 1,
      sym_identifier,
  [15443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_BQUOTE,
    ACTIONS(2867), 1,
      aux_sym_identifier_token1,
    STATE(724), 1,
      sym_identifier,
  [15456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 1,
      anon_sym_RPAREN,
    ACTIONS(3055), 1,
      anon_sym_COMMA,
    STATE(1029), 1,
      aux_sym_formal_parameters_repeat1,
  [15469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(863), 1,
      anon_sym_BQUOTE,
    ACTIONS(2869), 1,
      aux_sym_identifier_token1,
    STATE(452), 1,
      sym_identifier,
  [15482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2871), 1,
      aux_sym_identifier_token1,
    STATE(781), 1,
      sym_identifier,
  [15495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(863), 1,
      anon_sym_BQUOTE,
    ACTIONS(2869), 1,
      aux_sym_identifier_token1,
    STATE(463), 1,
      sym_identifier,
  [15508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(1093), 1,
      sym_identifier,
  [15521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(2873), 1,
      aux_sym_identifier_token1,
    STATE(630), 1,
      sym_identifier,
  [15534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_BQUOTE,
    ACTIONS(2877), 1,
      aux_sym_identifier_token1,
    STATE(593), 1,
      sym_identifier,
  [15547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_BQUOTE,
    ACTIONS(2877), 1,
      aux_sym_identifier_token1,
    STATE(594), 1,
      sym_identifier,
  [15560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_BQUOTE,
    ACTIONS(2877), 1,
      aux_sym_identifier_token1,
    STATE(605), 1,
      sym_identifier,
  [15573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(856), 1,
      sym_identifier,
  [15586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(842), 1,
      sym_identifier,
  [15599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_BQUOTE,
    ACTIONS(2875), 1,
      aux_sym_identifier_token1,
    STATE(870), 1,
      sym_identifier,
  [15612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(250), 1,
      sym_formal_parameters,
  [15622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(329), 1,
      sym_formal_parameters,
  [15632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(164), 1,
      sym_formal_parameters,
  [15642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(406), 1,
      sym_formal_parameters,
  [15652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(407), 1,
      sym_formal_parameters,
  [15662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(143), 1,
      sym_formal_parameters,
  [15672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(314), 1,
      sym_formal_parameters,
  [15682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(195), 1,
      sym_formal_parameters,
  [15692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(285), 1,
      sym_formal_parameters,
  [15702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(200), 1,
      sym_formal_parameters,
  [15712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(310), 1,
      sym_formal_parameters,
  [15722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(328), 1,
      sym_formal_parameters,
  [15732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(268), 1,
      sym_formal_parameters,
  [15742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [15750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(307), 1,
      sym_formal_parameters,
  [15760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(308), 1,
      sym_formal_parameters,
  [15770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(385), 1,
      sym_formal_parameters,
  [15780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(386), 1,
      sym_formal_parameters,
  [15790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(278), 1,
      sym_formal_parameters,
  [15800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(251), 1,
      sym_formal_parameters,
  [15810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LPAREN,
    STATE(163), 1,
      sym_formal_parameters,
  [15820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3060), 1,
      anon_sym_RPAREN,
  [15827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_LPAREN,
  [15834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3064), 1,
      anon_sym_RPAREN,
  [15841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
  [15848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_RBRACK_RBRACK,
  [15855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_RBRACK,
  [15862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_RPAREN,
  [15869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_LPAREN,
  [15876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_RPAREN,
  [15883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LPAREN,
  [15890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 1,
      anon_sym_RBRACK_RBRACK,
  [15897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      anon_sym_in,
  [15904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3084), 1,
      anon_sym_RBRACK,
  [15911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
  [15918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3088), 1,
      anon_sym_RPAREN,
  [15925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 1,
      anon_sym_in,
  [15932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_LPAREN,
  [15939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_RBRACK,
  [15946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_in,
  [15953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 1,
      anon_sym_RBRACK_RBRACK,
  [15960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_LPAREN,
  [15967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 1,
      anon_sym_RPAREN,
  [15974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 1,
      anon_sym_in,
  [15981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3106), 1,
      anon_sym_RBRACK_RBRACK,
  [15988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3108), 1,
      anon_sym_LPAREN,
  [15995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3110), 1,
      anon_sym_RBRACK,
  [16002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3112), 1,
      anon_sym_in,
  [16009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3114), 1,
      anon_sym_RPAREN,
  [16016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3116), 1,
      anon_sym_LPAREN,
  [16023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3118), 1,
      anon_sym_RPAREN,
  [16030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_in,
  [16037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3122), 1,
      anon_sym_in,
  [16044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3124), 1,
      anon_sym_LPAREN,
  [16051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3126), 1,
      anon_sym_RBRACK,
  [16058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3128), 1,
      anon_sym_in,
  [16065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_RBRACK_RBRACK,
  [16072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3132), 1,
      anon_sym_LPAREN,
  [16079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3134), 1,
      anon_sym_RBRACK,
  [16086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3136), 1,
      anon_sym_in,
  [16093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3138), 1,
      anon_sym_RPAREN,
  [16100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3140), 1,
      anon_sym_LPAREN,
  [16107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_in,
  [16114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3144), 1,
      anon_sym_LPAREN,
  [16121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3146), 1,
      anon_sym_RPAREN,
  [16128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 1,
      anon_sym_RPAREN,
  [16135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3150), 1,
      anon_sym_RPAREN,
  [16142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 1,
      anon_sym_LPAREN,
  [16149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_RBRACK_RBRACK,
  [16156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 1,
      anon_sym_RPAREN,
  [16163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3158), 1,
      anon_sym_LPAREN,
  [16170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3160), 1,
      anon_sym_RBRACK,
  [16177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3162), 1,
      anon_sym_RBRACK_RBRACK,
  [16184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_LPAREN,
  [16191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3166), 1,
      anon_sym_RPAREN,
  [16198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3168), 1,
      ts_builtin_sym_end,
  [16205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
  [16212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3172), 1,
      anon_sym_RBRACK_RBRACK,
  [16219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 1,
      anon_sym_RBRACK,
  [16226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 1,
      anon_sym_LPAREN,
  [16233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3178), 1,
      anon_sym_RPAREN,
  [16240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3180), 1,
      anon_sym_LPAREN,
  [16247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3182), 1,
      anon_sym_LPAREN,
  [16254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3184), 1,
      anon_sym_RPAREN,
  [16261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3186), 1,
      anon_sym_RPAREN,
  [16268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3188), 1,
      anon_sym_LPAREN,
  [16275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 1,
      anon_sym_RBRACK_RBRACK,
  [16282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_RPAREN,
  [16289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_RBRACK,
  [16296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3196), 1,
      anon_sym_LPAREN,
  [16303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3198), 1,
      anon_sym_LPAREN,
  [16310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_LPAREN,
  [16317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 1,
      anon_sym_LPAREN,
  [16324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3204), 1,
      anon_sym_LPAREN,
  [16331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_LPAREN,
  [16338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LPAREN,
  [16345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 1,
      anon_sym_LPAREN,
  [16352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_LPAREN,
  [16359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
  [16366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_LPAREN,
  [16373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3218), 1,
      anon_sym_LPAREN,
  [16380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3220), 1,
      anon_sym_LPAREN,
  [16387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3222), 1,
      anon_sym_LPAREN,
  [16394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3224), 1,
      anon_sym_LPAREN,
  [16401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3226), 1,
      anon_sym_LPAREN,
  [16408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
  [16415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(732)] = 0,
  [SMALL_STATE(733)] = 67,
  [SMALL_STATE(734)] = 136,
  [SMALL_STATE(735)] = 205,
  [SMALL_STATE(736)] = 274,
  [SMALL_STATE(737)] = 343,
  [SMALL_STATE(738)] = 412,
  [SMALL_STATE(739)] = 481,
  [SMALL_STATE(740)] = 552,
  [SMALL_STATE(741)] = 621,
  [SMALL_STATE(742)] = 688,
  [SMALL_STATE(743)] = 755,
  [SMALL_STATE(744)] = 824,
  [SMALL_STATE(745)] = 891,
  [SMALL_STATE(746)] = 960,
  [SMALL_STATE(747)] = 1027,
  [SMALL_STATE(748)] = 1094,
  [SMALL_STATE(749)] = 1163,
  [SMALL_STATE(750)] = 1230,
  [SMALL_STATE(751)] = 1297,
  [SMALL_STATE(752)] = 1366,
  [SMALL_STATE(753)] = 1435,
  [SMALL_STATE(754)] = 1504,
  [SMALL_STATE(755)] = 1573,
  [SMALL_STATE(756)] = 1642,
  [SMALL_STATE(757)] = 1711,
  [SMALL_STATE(758)] = 1780,
  [SMALL_STATE(759)] = 1849,
  [SMALL_STATE(760)] = 1918,
  [SMALL_STATE(761)] = 1987,
  [SMALL_STATE(762)] = 2054,
  [SMALL_STATE(763)] = 2123,
  [SMALL_STATE(764)] = 2192,
  [SMALL_STATE(765)] = 2259,
  [SMALL_STATE(766)] = 2326,
  [SMALL_STATE(767)] = 2395,
  [SMALL_STATE(768)] = 2462,
  [SMALL_STATE(769)] = 2531,
  [SMALL_STATE(770)] = 2598,
  [SMALL_STATE(771)] = 2667,
  [SMALL_STATE(772)] = 2736,
  [SMALL_STATE(773)] = 2805,
  [SMALL_STATE(774)] = 2874,
  [SMALL_STATE(775)] = 2943,
  [SMALL_STATE(776)] = 3012,
  [SMALL_STATE(777)] = 3079,
  [SMALL_STATE(778)] = 3146,
  [SMALL_STATE(779)] = 3215,
  [SMALL_STATE(780)] = 3284,
  [SMALL_STATE(781)] = 3353,
  [SMALL_STATE(782)] = 3422,
  [SMALL_STATE(783)] = 3491,
  [SMALL_STATE(784)] = 3558,
  [SMALL_STATE(785)] = 3625,
  [SMALL_STATE(786)] = 3746,
  [SMALL_STATE(787)] = 3815,
  [SMALL_STATE(788)] = 3884,
  [SMALL_STATE(789)] = 3953,
  [SMALL_STATE(790)] = 4022,
  [SMALL_STATE(791)] = 4091,
  [SMALL_STATE(792)] = 4158,
  [SMALL_STATE(793)] = 4225,
  [SMALL_STATE(794)] = 4292,
  [SMALL_STATE(795)] = 4336,
  [SMALL_STATE(796)] = 4380,
  [SMALL_STATE(797)] = 4424,
  [SMALL_STATE(798)] = 4471,
  [SMALL_STATE(799)] = 4549,
  [SMALL_STATE(800)] = 4615,
  [SMALL_STATE(801)] = 4697,
  [SMALL_STATE(802)] = 4779,
  [SMALL_STATE(803)] = 4871,
  [SMALL_STATE(804)] = 4963,
  [SMALL_STATE(805)] = 5055,
  [SMALL_STATE(806)] = 5147,
  [SMALL_STATE(807)] = 5239,
  [SMALL_STATE(808)] = 5321,
  [SMALL_STATE(809)] = 5413,
  [SMALL_STATE(810)] = 5455,
  [SMALL_STATE(811)] = 5499,
  [SMALL_STATE(812)] = 5559,
  [SMALL_STATE(813)] = 5615,
  [SMALL_STATE(814)] = 5685,
  [SMALL_STATE(815)] = 5759,
  [SMALL_STATE(816)] = 5829,
  [SMALL_STATE(817)] = 5923,
  [SMALL_STATE(818)] = 5979,
  [SMALL_STATE(819)] = 6037,
  [SMALL_STATE(820)] = 6079,
  [SMALL_STATE(821)] = 6171,
  [SMALL_STATE(822)] = 6233,
  [SMALL_STATE(823)] = 6325,
  [SMALL_STATE(824)] = 6419,
  [SMALL_STATE(825)] = 6511,
  [SMALL_STATE(826)] = 6567,
  [SMALL_STATE(827)] = 6645,
  [SMALL_STATE(828)] = 6714,
  [SMALL_STATE(829)] = 6791,
  [SMALL_STATE(830)] = 6832,
  [SMALL_STATE(831)] = 6873,
  [SMALL_STATE(832)] = 6914,
  [SMALL_STATE(833)] = 6955,
  [SMALL_STATE(834)] = 6996,
  [SMALL_STATE(835)] = 7037,
  [SMALL_STATE(836)] = 7078,
  [SMALL_STATE(837)] = 7121,
  [SMALL_STATE(838)] = 7212,
  [SMALL_STATE(839)] = 7303,
  [SMALL_STATE(840)] = 7358,
  [SMALL_STATE(841)] = 7399,
  [SMALL_STATE(842)] = 7440,
  [SMALL_STATE(843)] = 7481,
  [SMALL_STATE(844)] = 7522,
  [SMALL_STATE(845)] = 7563,
  [SMALL_STATE(846)] = 7604,
  [SMALL_STATE(847)] = 7685,
  [SMALL_STATE(848)] = 7726,
  [SMALL_STATE(849)] = 7767,
  [SMALL_STATE(850)] = 7808,
  [SMALL_STATE(851)] = 7849,
  [SMALL_STATE(852)] = 7890,
  [SMALL_STATE(853)] = 7931,
  [SMALL_STATE(854)] = 7992,
  [SMALL_STATE(855)] = 8033,
  [SMALL_STATE(856)] = 8114,
  [SMALL_STATE(857)] = 8155,
  [SMALL_STATE(858)] = 8246,
  [SMALL_STATE(859)] = 8337,
  [SMALL_STATE(860)] = 8428,
  [SMALL_STATE(861)] = 8519,
  [SMALL_STATE(862)] = 8610,
  [SMALL_STATE(863)] = 8701,
  [SMALL_STATE(864)] = 8758,
  [SMALL_STATE(865)] = 8813,
  [SMALL_STATE(866)] = 8882,
  [SMALL_STATE(867)] = 8955,
  [SMALL_STATE(868)] = 9020,
  [SMALL_STATE(869)] = 9075,
  [SMALL_STATE(870)] = 9116,
  [SMALL_STATE(871)] = 9157,
  [SMALL_STATE(872)] = 9216,
  [SMALL_STATE(873)] = 9293,
  [SMALL_STATE(874)] = 9334,
  [SMALL_STATE(875)] = 9375,
  [SMALL_STATE(876)] = 9466,
  [SMALL_STATE(877)] = 9557,
  [SMALL_STATE(878)] = 9638,
  [SMALL_STATE(879)] = 9679,
  [SMALL_STATE(880)] = 9769,
  [SMALL_STATE(881)] = 9859,
  [SMALL_STATE(882)] = 9949,
  [SMALL_STATE(883)] = 10039,
  [SMALL_STATE(884)] = 10129,
  [SMALL_STATE(885)] = 10219,
  [SMALL_STATE(886)] = 10309,
  [SMALL_STATE(887)] = 10399,
  [SMALL_STATE(888)] = 10489,
  [SMALL_STATE(889)] = 10579,
  [SMALL_STATE(890)] = 10669,
  [SMALL_STATE(891)] = 10759,
  [SMALL_STATE(892)] = 10849,
  [SMALL_STATE(893)] = 10939,
  [SMALL_STATE(894)] = 11029,
  [SMALL_STATE(895)] = 11119,
  [SMALL_STATE(896)] = 11209,
  [SMALL_STATE(897)] = 11299,
  [SMALL_STATE(898)] = 11389,
  [SMALL_STATE(899)] = 11479,
  [SMALL_STATE(900)] = 11569,
  [SMALL_STATE(901)] = 11659,
  [SMALL_STATE(902)] = 11749,
  [SMALL_STATE(903)] = 11839,
  [SMALL_STATE(904)] = 11929,
  [SMALL_STATE(905)] = 12019,
  [SMALL_STATE(906)] = 12109,
  [SMALL_STATE(907)] = 12199,
  [SMALL_STATE(908)] = 12289,
  [SMALL_STATE(909)] = 12379,
  [SMALL_STATE(910)] = 12469,
  [SMALL_STATE(911)] = 12559,
  [SMALL_STATE(912)] = 12649,
  [SMALL_STATE(913)] = 12739,
  [SMALL_STATE(914)] = 12829,
  [SMALL_STATE(915)] = 12919,
  [SMALL_STATE(916)] = 13009,
  [SMALL_STATE(917)] = 13099,
  [SMALL_STATE(918)] = 13189,
  [SMALL_STATE(919)] = 13276,
  [SMALL_STATE(920)] = 13363,
  [SMALL_STATE(921)] = 13450,
  [SMALL_STATE(922)] = 13537,
  [SMALL_STATE(923)] = 13624,
  [SMALL_STATE(924)] = 13711,
  [SMALL_STATE(925)] = 13798,
  [SMALL_STATE(926)] = 13885,
  [SMALL_STATE(927)] = 13972,
  [SMALL_STATE(928)] = 13995,
  [SMALL_STATE(929)] = 14018,
  [SMALL_STATE(930)] = 14041,
  [SMALL_STATE(931)] = 14061,
  [SMALL_STATE(932)] = 14081,
  [SMALL_STATE(933)] = 14101,
  [SMALL_STATE(934)] = 14121,
  [SMALL_STATE(935)] = 14141,
  [SMALL_STATE(936)] = 14161,
  [SMALL_STATE(937)] = 14181,
  [SMALL_STATE(938)] = 14201,
  [SMALL_STATE(939)] = 14221,
  [SMALL_STATE(940)] = 14241,
  [SMALL_STATE(941)] = 14255,
  [SMALL_STATE(942)] = 14269,
  [SMALL_STATE(943)] = 14283,
  [SMALL_STATE(944)] = 14297,
  [SMALL_STATE(945)] = 14311,
  [SMALL_STATE(946)] = 14325,
  [SMALL_STATE(947)] = 14339,
  [SMALL_STATE(948)] = 14353,
  [SMALL_STATE(949)] = 14367,
  [SMALL_STATE(950)] = 14381,
  [SMALL_STATE(951)] = 14395,
  [SMALL_STATE(952)] = 14409,
  [SMALL_STATE(953)] = 14423,
  [SMALL_STATE(954)] = 14437,
  [SMALL_STATE(955)] = 14451,
  [SMALL_STATE(956)] = 14465,
  [SMALL_STATE(957)] = 14479,
  [SMALL_STATE(958)] = 14493,
  [SMALL_STATE(959)] = 14507,
  [SMALL_STATE(960)] = 14521,
  [SMALL_STATE(961)] = 14535,
  [SMALL_STATE(962)] = 14549,
  [SMALL_STATE(963)] = 14563,
  [SMALL_STATE(964)] = 14577,
  [SMALL_STATE(965)] = 14591,
  [SMALL_STATE(966)] = 14605,
  [SMALL_STATE(967)] = 14619,
  [SMALL_STATE(968)] = 14633,
  [SMALL_STATE(969)] = 14647,
  [SMALL_STATE(970)] = 14661,
  [SMALL_STATE(971)] = 14675,
  [SMALL_STATE(972)] = 14689,
  [SMALL_STATE(973)] = 14703,
  [SMALL_STATE(974)] = 14717,
  [SMALL_STATE(975)] = 14731,
  [SMALL_STATE(976)] = 14745,
  [SMALL_STATE(977)] = 14759,
  [SMALL_STATE(978)] = 14773,
  [SMALL_STATE(979)] = 14787,
  [SMALL_STATE(980)] = 14801,
  [SMALL_STATE(981)] = 14815,
  [SMALL_STATE(982)] = 14829,
  [SMALL_STATE(983)] = 14843,
  [SMALL_STATE(984)] = 14857,
  [SMALL_STATE(985)] = 14871,
  [SMALL_STATE(986)] = 14885,
  [SMALL_STATE(987)] = 14899,
  [SMALL_STATE(988)] = 14913,
  [SMALL_STATE(989)] = 14927,
  [SMALL_STATE(990)] = 14941,
  [SMALL_STATE(991)] = 14955,
  [SMALL_STATE(992)] = 14969,
  [SMALL_STATE(993)] = 14983,
  [SMALL_STATE(994)] = 14997,
  [SMALL_STATE(995)] = 15011,
  [SMALL_STATE(996)] = 15025,
  [SMALL_STATE(997)] = 15039,
  [SMALL_STATE(998)] = 15053,
  [SMALL_STATE(999)] = 15067,
  [SMALL_STATE(1000)] = 15081,
  [SMALL_STATE(1001)] = 15094,
  [SMALL_STATE(1002)] = 15107,
  [SMALL_STATE(1003)] = 15120,
  [SMALL_STATE(1004)] = 15133,
  [SMALL_STATE(1005)] = 15146,
  [SMALL_STATE(1006)] = 15159,
  [SMALL_STATE(1007)] = 15172,
  [SMALL_STATE(1008)] = 15185,
  [SMALL_STATE(1009)] = 15198,
  [SMALL_STATE(1010)] = 15211,
  [SMALL_STATE(1011)] = 15224,
  [SMALL_STATE(1012)] = 15237,
  [SMALL_STATE(1013)] = 15250,
  [SMALL_STATE(1014)] = 15263,
  [SMALL_STATE(1015)] = 15274,
  [SMALL_STATE(1016)] = 15287,
  [SMALL_STATE(1017)] = 15300,
  [SMALL_STATE(1018)] = 15313,
  [SMALL_STATE(1019)] = 15326,
  [SMALL_STATE(1020)] = 15339,
  [SMALL_STATE(1021)] = 15352,
  [SMALL_STATE(1022)] = 15365,
  [SMALL_STATE(1023)] = 15378,
  [SMALL_STATE(1024)] = 15391,
  [SMALL_STATE(1025)] = 15404,
  [SMALL_STATE(1026)] = 15417,
  [SMALL_STATE(1027)] = 15430,
  [SMALL_STATE(1028)] = 15443,
  [SMALL_STATE(1029)] = 15456,
  [SMALL_STATE(1030)] = 15469,
  [SMALL_STATE(1031)] = 15482,
  [SMALL_STATE(1032)] = 15495,
  [SMALL_STATE(1033)] = 15508,
  [SMALL_STATE(1034)] = 15521,
  [SMALL_STATE(1035)] = 15534,
  [SMALL_STATE(1036)] = 15547,
  [SMALL_STATE(1037)] = 15560,
  [SMALL_STATE(1038)] = 15573,
  [SMALL_STATE(1039)] = 15586,
  [SMALL_STATE(1040)] = 15599,
  [SMALL_STATE(1041)] = 15612,
  [SMALL_STATE(1042)] = 15622,
  [SMALL_STATE(1043)] = 15632,
  [SMALL_STATE(1044)] = 15642,
  [SMALL_STATE(1045)] = 15652,
  [SMALL_STATE(1046)] = 15662,
  [SMALL_STATE(1047)] = 15672,
  [SMALL_STATE(1048)] = 15682,
  [SMALL_STATE(1049)] = 15692,
  [SMALL_STATE(1050)] = 15702,
  [SMALL_STATE(1051)] = 15712,
  [SMALL_STATE(1052)] = 15722,
  [SMALL_STATE(1053)] = 15732,
  [SMALL_STATE(1054)] = 15742,
  [SMALL_STATE(1055)] = 15750,
  [SMALL_STATE(1056)] = 15760,
  [SMALL_STATE(1057)] = 15770,
  [SMALL_STATE(1058)] = 15780,
  [SMALL_STATE(1059)] = 15790,
  [SMALL_STATE(1060)] = 15800,
  [SMALL_STATE(1061)] = 15810,
  [SMALL_STATE(1062)] = 15820,
  [SMALL_STATE(1063)] = 15827,
  [SMALL_STATE(1064)] = 15834,
  [SMALL_STATE(1065)] = 15841,
  [SMALL_STATE(1066)] = 15848,
  [SMALL_STATE(1067)] = 15855,
  [SMALL_STATE(1068)] = 15862,
  [SMALL_STATE(1069)] = 15869,
  [SMALL_STATE(1070)] = 15876,
  [SMALL_STATE(1071)] = 15883,
  [SMALL_STATE(1072)] = 15890,
  [SMALL_STATE(1073)] = 15897,
  [SMALL_STATE(1074)] = 15904,
  [SMALL_STATE(1075)] = 15911,
  [SMALL_STATE(1076)] = 15918,
  [SMALL_STATE(1077)] = 15925,
  [SMALL_STATE(1078)] = 15932,
  [SMALL_STATE(1079)] = 15939,
  [SMALL_STATE(1080)] = 15946,
  [SMALL_STATE(1081)] = 15953,
  [SMALL_STATE(1082)] = 15960,
  [SMALL_STATE(1083)] = 15967,
  [SMALL_STATE(1084)] = 15974,
  [SMALL_STATE(1085)] = 15981,
  [SMALL_STATE(1086)] = 15988,
  [SMALL_STATE(1087)] = 15995,
  [SMALL_STATE(1088)] = 16002,
  [SMALL_STATE(1089)] = 16009,
  [SMALL_STATE(1090)] = 16016,
  [SMALL_STATE(1091)] = 16023,
  [SMALL_STATE(1092)] = 16030,
  [SMALL_STATE(1093)] = 16037,
  [SMALL_STATE(1094)] = 16044,
  [SMALL_STATE(1095)] = 16051,
  [SMALL_STATE(1096)] = 16058,
  [SMALL_STATE(1097)] = 16065,
  [SMALL_STATE(1098)] = 16072,
  [SMALL_STATE(1099)] = 16079,
  [SMALL_STATE(1100)] = 16086,
  [SMALL_STATE(1101)] = 16093,
  [SMALL_STATE(1102)] = 16100,
  [SMALL_STATE(1103)] = 16107,
  [SMALL_STATE(1104)] = 16114,
  [SMALL_STATE(1105)] = 16121,
  [SMALL_STATE(1106)] = 16128,
  [SMALL_STATE(1107)] = 16135,
  [SMALL_STATE(1108)] = 16142,
  [SMALL_STATE(1109)] = 16149,
  [SMALL_STATE(1110)] = 16156,
  [SMALL_STATE(1111)] = 16163,
  [SMALL_STATE(1112)] = 16170,
  [SMALL_STATE(1113)] = 16177,
  [SMALL_STATE(1114)] = 16184,
  [SMALL_STATE(1115)] = 16191,
  [SMALL_STATE(1116)] = 16198,
  [SMALL_STATE(1117)] = 16205,
  [SMALL_STATE(1118)] = 16212,
  [SMALL_STATE(1119)] = 16219,
  [SMALL_STATE(1120)] = 16226,
  [SMALL_STATE(1121)] = 16233,
  [SMALL_STATE(1122)] = 16240,
  [SMALL_STATE(1123)] = 16247,
  [SMALL_STATE(1124)] = 16254,
  [SMALL_STATE(1125)] = 16261,
  [SMALL_STATE(1126)] = 16268,
  [SMALL_STATE(1127)] = 16275,
  [SMALL_STATE(1128)] = 16282,
  [SMALL_STATE(1129)] = 16289,
  [SMALL_STATE(1130)] = 16296,
  [SMALL_STATE(1131)] = 16303,
  [SMALL_STATE(1132)] = 16310,
  [SMALL_STATE(1133)] = 16317,
  [SMALL_STATE(1134)] = 16324,
  [SMALL_STATE(1135)] = 16331,
  [SMALL_STATE(1136)] = 16338,
  [SMALL_STATE(1137)] = 16345,
  [SMALL_STATE(1138)] = 16352,
  [SMALL_STATE(1139)] = 16359,
  [SMALL_STATE(1140)] = 16366,
  [SMALL_STATE(1141)] = 16373,
  [SMALL_STATE(1142)] = 16380,
  [SMALL_STATE(1143)] = 16387,
  [SMALL_STATE(1144)] = 16394,
  [SMALL_STATE(1145)] = 16401,
  [SMALL_STATE(1146)] = 16408,
  [SMALL_STATE(1147)] = 16415,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 1),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(465),
  [166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1061),
  [169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1043),
  [172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1104),
  [175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(75),
  [178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2),
  [180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1071),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(154),
  [186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1131),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1132),
  [192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(15),
  [195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(74),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(600),
  [201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(155),
  [204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(156),
  [207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(157),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(465),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(641),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(159),
  [219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(942),
  [222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(520),
  [225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(943),
  [228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(944),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(618),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1044),
  [267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1045),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1114),
  [273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(59),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1082),
  [279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(320),
  [282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1137),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(1136),
  [288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(34),
  [291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(58),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(739),
  [297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(321),
  [300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(322),
  [303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(323),
  [306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(618),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(748),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(541),
  [315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(945),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(730),
  [321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(978),
  [324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(985),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_argument, 2, .production_id = 8),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(654),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1053),
  [443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1059),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1069),
  [449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(47),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1065),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(137),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1063),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1122),
  [464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(76),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(654),
  [470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(147),
  [473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(182),
  [476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(229),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(740),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(561),
  [485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(941),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(579),
  [491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(992),
  [494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(988),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(785),
  [514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1061),
  [517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1043),
  [520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1104),
  [523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(75),
  [526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2),
  [528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1071),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(154),
  [534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1131),
  [537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1132),
  [540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(74),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(785),
  [546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(155),
  [549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(156),
  [552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(157),
  [555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(641),
  [558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(159),
  [561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(942),
  [564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(520),
  [567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(943),
  [570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(944),
  [573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(639),
  [576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1041),
  [579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1060),
  [582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1108),
  [585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(67),
  [588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1075),
  [591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(242),
  [594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1133),
  [597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1134),
  [600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(44),
  [603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(639),
  [606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(243),
  [609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(244),
  [612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(245),
  [615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(741),
  [618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(566),
  [621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(962),
  [624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(581),
  [627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(965),
  [630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(969),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1),
  [651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1),
  [653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 2),
  [655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 2),
  [657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 3),
  [659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 3),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, .production_id = 10),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, .production_id = 10),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [1359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for, 7, .production_id = 14),
  [1361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for, 7, .production_id = 14),
  [1363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 7, .production_id = 13),
  [1365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 7, .production_id = 13),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [1379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 5, .production_id = 11),
  [1381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 5, .production_id = 11),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [1407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 3, .production_id = 6),
  [1409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 3, .production_id = 6),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [1441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_right_assignment, 3, .production_id = 5),
  [1443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_right_assignment, 3, .production_id = 5),
  [1445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super_right_assignment, 3, .production_id = 5),
  [1447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_super_right_assignment, 3, .production_id = 5),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [1457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super_assignment, 3, .production_id = 4),
  [1459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_super_assignment, 3, .production_id = 4),
  [1461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_left_assignment2, 3, .production_id = 4),
  [1463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_left_assignment2, 3, .production_id = 4),
  [1465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_left_assignment, 3, .production_id = 4),
  [1467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_left_assignment, 3, .production_id = 4),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [1485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equals_assignment, 3, .production_id = 4),
  [1487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_equals_assignment, 3, .production_id = 4),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [1519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_function, 3),
  [1521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_function, 3),
  [1523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3),
  [1525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [1553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [1851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [2087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [2095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [2121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat, 2, .production_id = 1),
  [2123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat, 2, .production_id = 1),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [2129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary, 2, .production_id = 2),
  [2131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary, 2, .production_id = 2),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [2197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [2201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paren_list, 2),
  [2203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paren_list, 2),
  [2205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brace_list, 2),
  [2207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_brace_list, 2),
  [2209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex, 2),
  [2211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex, 2),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [2215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [2219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [2249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [2253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [2265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paren_list, 3),
  [2267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paren_list, 3),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brace_list, 3),
  [2271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_brace_list, 3),
  [2273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [2275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [2277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, .production_id = 3),
  [2279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 3, .production_id = 3),
  [2281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset, 3),
  [2283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset, 3),
  [2285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2, 3),
  [2287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2, 3),
  [2289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dollar, 3),
  [2291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dollar, 3),
  [2293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slot, 3),
  [2295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slot, 3),
  [2297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe, 3, .production_id = 6),
  [2299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipe, 3, .production_id = 6),
  [2301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_get, 3, .production_id = 7),
  [2303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_get, 3, .production_id = 7),
  [2305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_get_internal, 3, .production_id = 7),
  [2307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_get_internal, 3, .production_id = 7),
  [2309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument, 1),
  [2311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument, 1),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [2347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [2361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 4, .production_id = 9),
  [2363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 4, .production_id = 9),
  [2365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset, 4),
  [2367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset, 4),
  [2369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2, 4),
  [2371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2, 4),
  [2373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [2375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_na, 1),
  [2377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_na, 1),
  [2379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch, 6, .production_id = 12),
  [2381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch, 6, .production_id = 12),
  [2383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [2387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [2397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [2401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [2403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [2411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [2413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [2415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [2421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [2427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [2431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [2435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [2439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [2441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [2445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [2447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [2449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [2455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [2459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [2463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [2465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [2467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [2469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [2471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [2473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_argument, 3, .production_id = 4),
  [2475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_argument, 3, .production_id = 4),
  [2477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [2479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [2481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [2483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [2485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [2487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [2491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [2493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [2495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [2497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [2499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [2509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [2513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [2515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [2523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [2525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [2529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [2533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [2551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [2627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1), SHIFT_REPEAT(819),
  [2630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1),
  [2632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 1),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [2636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1), SHIFT_REPEAT(809),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 1),
  [2643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 1),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [2677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [2679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [2697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [2705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [2721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [2727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [2729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_parameters, 4),
  [2731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special, 2),
  [2733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special, 2),
  [2735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [2737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_parameters, 2),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [2741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, .production_id = 4),
  [2743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [2759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_parameters, 3),
  [2761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [2763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_parameters, 5),
  [2765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special, 3),
  [2767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special, 3),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [2885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [2887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [2889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [2891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [2893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [2897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [2899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [2901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [2905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [2907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [2909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [2915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [2917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [2919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [2923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [2925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [2927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [2929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [2931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [2933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(957),
  [2936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [2938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_identifier_repeat1, 2),
  [2940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_identifier_repeat1, 2), SHIFT_REPEAT(959),
  [2943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [2945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [2947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [2951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [2953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [2955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [2957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [2959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [2961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [2963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [2967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [2969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [2971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_special_repeat1, 2),
  [2973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_special_repeat1, 2), SHIFT_REPEAT(971),
  [2976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [2978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [2980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [2982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [2984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [2986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [2988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [2990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [2992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [2996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [2998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [3000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [3002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [3004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [3006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [3008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [3010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [3012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [3014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [3016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [3018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [3020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [3022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [3024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [3028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [3030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [3034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [3036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [3038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [3040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(999),
  [3043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter, 1),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [3053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [3055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(936),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [3070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [3082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [3148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [3168] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_r(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
