#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 268
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 84
#define ALIAS_COUNT 1
#define TOKEN_COUNT 40
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 3

enum {
  anon_sym_LT = 1,
  anon_sym_GT = 2,
  anon_sym_SLASH_GT = 3,
  anon_sym_LT_SLASH = 4,
  anon_sym_EQ = 5,
  aux_sym_attribute_name_token1 = 6,
  anon_sym_SQUOTE = 7,
  aux_sym_quoted_attribute_value_token1 = 8,
  anon_sym_DQUOTE = 9,
  aux_sym_quoted_attribute_value_token2 = 10,
  aux_sym__text_token1 = 11,
  anon_sym_LBRACE_RBRACE = 12,
  anon_sym_LBRACE = 13,
  anon_sym_RBRACE = 14,
  anon_sym_AT = 15,
  anon_sym_html = 16,
  anon_sym_const = 17,
  anon_sym_POUND = 18,
  anon_sym_if = 19,
  anon_sym_COLON = 20,
  anon_sym_else = 21,
  anon_sym_SLASH = 22,
  anon_sym_each = 23,
  anon_sym_as = 24,
  anon_sym_await = 25,
  anon_sym_then = 26,
  anon_sym_catch = 27,
  anon_sym_key = 28,
  sym__start_tag_name = 29,
  sym__script_start_tag_name = 30,
  sym__style_start_tag_name = 31,
  sym__end_tag_name = 32,
  sym_erroneous_end_tag_name = 33,
  sym__implicit_end_tag = 34,
  sym_raw_text = 35,
  sym_raw_text_expr = 36,
  sym_raw_text_await = 37,
  sym_raw_text_each = 38,
  sym_comment = 39,
  sym_document = 40,
  sym__node = 41,
  sym__statement = 42,
  sym_element = 43,
  sym_start_tag = 44,
  sym_self_closing_tag = 45,
  sym_end_tag = 46,
  sym_script_element = 47,
  sym_script_start_tag = 48,
  sym_style_element = 49,
  sym_style_start_tag = 50,
  sym_attribute = 51,
  sym_attribute_name = 52,
  sym_attribute_value = 53,
  sym_expr_attribute_value = 54,
  sym_quoted_attribute_value = 55,
  sym__text = 56,
  sym__expression = 57,
  sym_expression = 58,
  sym_html_expr = 59,
  sym_const_expr = 60,
  sym_if_statement = 61,
  sym_else_if_statement = 62,
  sym_else_statement = 63,
  sym_if_start_expr = 64,
  sym_else_expr = 65,
  sym_else_if_expr = 66,
  sym_if_end_expr = 67,
  sym_each_statement = 68,
  sym_each_start_expr = 69,
  sym_else_each_statement = 70,
  sym_each_end_expr = 71,
  sym_await_statement = 72,
  sym_then_statement = 73,
  sym_catch_statement = 74,
  sym_await_start_expr = 75,
  sym_then_expr = 76,
  sym_catch_expr = 77,
  sym_await_end_expr = 78,
  sym_key_statement = 79,
  sym_key_start_expr = 80,
  sym_key_end_expr = 81,
  aux_sym_document_repeat1 = 82,
  aux_sym_start_tag_repeat1 = 83,
  alias_sym_then = 84,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH_GT] = "/>",
  [anon_sym_LT_SLASH] = "</",
  [anon_sym_EQ] = "=",
  [aux_sym_attribute_name_token1] = "attribute_name_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_quoted_attribute_value_token1] = "attribute_value",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_quoted_attribute_value_token2] = "attribute_value",
  [aux_sym__text_token1] = "text",
  [anon_sym_LBRACE_RBRACE] = "expression",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_AT] = "@",
  [anon_sym_html] = "special_block_keyword",
  [anon_sym_const] = "special_block_keyword",
  [anon_sym_POUND] = "#",
  [anon_sym_if] = "special_block_keyword",
  [anon_sym_COLON] = ":",
  [anon_sym_else] = "special_block_keyword",
  [anon_sym_SLASH] = "/",
  [anon_sym_each] = "special_block_keyword",
  [anon_sym_as] = "as",
  [anon_sym_await] = "special_block_keyword",
  [anon_sym_then] = "special_block_keyword",
  [anon_sym_catch] = "special_block_keyword",
  [anon_sym_key] = "special_block_keyword",
  [sym__start_tag_name] = "tag_name",
  [sym__script_start_tag_name] = "tag_name",
  [sym__style_start_tag_name] = "tag_name",
  [sym__end_tag_name] = "tag_name",
  [sym_erroneous_end_tag_name] = "erroneous_end_tag_name",
  [sym__implicit_end_tag] = "_implicit_end_tag",
  [sym_raw_text] = "raw_text",
  [sym_raw_text_expr] = "raw_text_expr",
  [sym_raw_text_await] = "raw_text_await",
  [sym_raw_text_each] = "raw_text_each",
  [sym_comment] = "comment",
  [sym_document] = "document",
  [sym__node] = "_node",
  [sym__statement] = "_statement",
  [sym_element] = "element",
  [sym_start_tag] = "start_tag",
  [sym_self_closing_tag] = "self_closing_tag",
  [sym_end_tag] = "end_tag",
  [sym_script_element] = "script_element",
  [sym_script_start_tag] = "start_tag",
  [sym_style_element] = "style_element",
  [sym_style_start_tag] = "start_tag",
  [sym_attribute] = "attribute",
  [sym_attribute_name] = "attribute_name",
  [sym_attribute_value] = "attribute_value",
  [sym_expr_attribute_value] = "expr_attribute_value",
  [sym_quoted_attribute_value] = "quoted_attribute_value",
  [sym__text] = "_text",
  [sym__expression] = "_expression",
  [sym_expression] = "expression",
  [sym_html_expr] = "html_expr",
  [sym_const_expr] = "const_expr",
  [sym_if_statement] = "if_statement",
  [sym_else_if_statement] = "else_if_statement",
  [sym_else_statement] = "else_statement",
  [sym_if_start_expr] = "if_start_expr",
  [sym_else_expr] = "else_expr",
  [sym_else_if_expr] = "else_if_expr",
  [sym_if_end_expr] = "if_end_expr",
  [sym_each_statement] = "each_statement",
  [sym_each_start_expr] = "each_start_expr",
  [sym_else_each_statement] = "else_each_statement",
  [sym_each_end_expr] = "each_end_expr",
  [sym_await_statement] = "await_statement",
  [sym_then_statement] = "then_statement",
  [sym_catch_statement] = "catch_statement",
  [sym_await_start_expr] = "await_start_expr",
  [sym_then_expr] = "then_expr",
  [sym_catch_expr] = "catch_expr",
  [sym_await_end_expr] = "await_end_expr",
  [sym_key_statement] = "key_statement",
  [sym_key_start_expr] = "key_start_expr",
  [sym_key_end_expr] = "key_end_expr",
  [aux_sym_document_repeat1] = "document_repeat1",
  [aux_sym_start_tag_repeat1] = "start_tag_repeat1",
  [alias_sym_then] = "then",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH_GT] = anon_sym_SLASH_GT,
  [anon_sym_LT_SLASH] = anon_sym_LT_SLASH,
  [anon_sym_EQ] = anon_sym_EQ,
  [aux_sym_attribute_name_token1] = aux_sym_attribute_name_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_quoted_attribute_value_token1] = sym_attribute_value,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_quoted_attribute_value_token2] = sym_attribute_value,
  [aux_sym__text_token1] = aux_sym__text_token1,
  [anon_sym_LBRACE_RBRACE] = sym_expression,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_html] = anon_sym_html,
  [anon_sym_const] = anon_sym_html,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_if] = anon_sym_html,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_else] = anon_sym_html,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_each] = anon_sym_html,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_await] = anon_sym_html,
  [anon_sym_then] = anon_sym_html,
  [anon_sym_catch] = anon_sym_html,
  [anon_sym_key] = anon_sym_html,
  [sym__start_tag_name] = sym__start_tag_name,
  [sym__script_start_tag_name] = sym__start_tag_name,
  [sym__style_start_tag_name] = sym__start_tag_name,
  [sym__end_tag_name] = sym__start_tag_name,
  [sym_erroneous_end_tag_name] = sym_erroneous_end_tag_name,
  [sym__implicit_end_tag] = sym__implicit_end_tag,
  [sym_raw_text] = sym_raw_text,
  [sym_raw_text_expr] = sym_raw_text_expr,
  [sym_raw_text_await] = sym_raw_text_await,
  [sym_raw_text_each] = sym_raw_text_each,
  [sym_comment] = sym_comment,
  [sym_document] = sym_document,
  [sym__node] = sym__node,
  [sym__statement] = sym__statement,
  [sym_element] = sym_element,
  [sym_start_tag] = sym_start_tag,
  [sym_self_closing_tag] = sym_self_closing_tag,
  [sym_end_tag] = sym_end_tag,
  [sym_script_element] = sym_script_element,
  [sym_script_start_tag] = sym_start_tag,
  [sym_style_element] = sym_style_element,
  [sym_style_start_tag] = sym_start_tag,
  [sym_attribute] = sym_attribute,
  [sym_attribute_name] = sym_attribute_name,
  [sym_attribute_value] = sym_attribute_value,
  [sym_expr_attribute_value] = sym_expr_attribute_value,
  [sym_quoted_attribute_value] = sym_quoted_attribute_value,
  [sym__text] = sym__text,
  [sym__expression] = sym__expression,
  [sym_expression] = sym_expression,
  [sym_html_expr] = sym_html_expr,
  [sym_const_expr] = sym_const_expr,
  [sym_if_statement] = sym_if_statement,
  [sym_else_if_statement] = sym_else_if_statement,
  [sym_else_statement] = sym_else_statement,
  [sym_if_start_expr] = sym_if_start_expr,
  [sym_else_expr] = sym_else_expr,
  [sym_else_if_expr] = sym_else_if_expr,
  [sym_if_end_expr] = sym_if_end_expr,
  [sym_each_statement] = sym_each_statement,
  [sym_each_start_expr] = sym_each_start_expr,
  [sym_else_each_statement] = sym_else_each_statement,
  [sym_each_end_expr] = sym_each_end_expr,
  [sym_await_statement] = sym_await_statement,
  [sym_then_statement] = sym_then_statement,
  [sym_catch_statement] = sym_catch_statement,
  [sym_await_start_expr] = sym_await_start_expr,
  [sym_then_expr] = sym_then_expr,
  [sym_catch_expr] = sym_catch_expr,
  [sym_await_end_expr] = sym_await_end_expr,
  [sym_key_statement] = sym_key_statement,
  [sym_key_start_expr] = sym_key_start_expr,
  [sym_key_end_expr] = sym_key_end_expr,
  [aux_sym_document_repeat1] = aux_sym_document_repeat1,
  [aux_sym_start_tag_repeat1] = aux_sym_start_tag_repeat1,
  [alias_sym_then] = alias_sym_then,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_attribute_name_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_quoted_attribute_value_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_quoted_attribute_value_token2] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__text_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE_RBRACE] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_html] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_each] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_key] = {
    .visible = true,
    .named = true,
  },
  [sym__start_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__script_start_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__style_start_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__end_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym_erroneous_end_tag_name] = {
    .visible = true,
    .named = true,
  },
  [sym__implicit_end_tag] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_text] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_text_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_text_await] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_text_each] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_document] = {
    .visible = true,
    .named = true,
  },
  [sym__node] = {
    .visible = false,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_element] = {
    .visible = true,
    .named = true,
  },
  [sym_start_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_self_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_end_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_script_element] = {
    .visible = true,
    .named = true,
  },
  [sym_script_start_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_style_element] = {
    .visible = true,
    .named = true,
  },
  [sym_style_start_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_name] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym_expr_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym_quoted_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym__text] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_html_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_const_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_start_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_else_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_if_end_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_each_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_each_start_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_else_each_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_each_end_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_await_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_then_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_await_start_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_then_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_await_end_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_key_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_key_start_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_key_end_expr] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_document_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_start_tag_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_then] = {
    .visible = true,
    .named = true,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_attribute_name,
  },
  [2] = {
    [4] = alias_sym_then,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_expression, 2,
    sym_expression,
    sym_attribute_name,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 2,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 3,
  [10] = 8,
  [11] = 6,
  [12] = 7,
  [13] = 4,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 18,
  [21] = 16,
  [22] = 17,
  [23] = 15,
  [24] = 14,
  [25] = 19,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 32,
  [34] = 30,
  [35] = 35,
  [36] = 29,
  [37] = 35,
  [38] = 38,
  [39] = 28,
  [40] = 38,
  [41] = 27,
  [42] = 42,
  [43] = 42,
  [44] = 26,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 47,
  [50] = 46,
  [51] = 45,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 48,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 71,
  [97] = 64,
  [98] = 90,
  [99] = 83,
  [100] = 74,
  [101] = 82,
  [102] = 58,
  [103] = 94,
  [104] = 95,
  [105] = 55,
  [106] = 73,
  [107] = 92,
  [108] = 81,
  [109] = 52,
  [110] = 91,
  [111] = 77,
  [112] = 76,
  [113] = 70,
  [114] = 89,
  [115] = 75,
  [116] = 88,
  [117] = 72,
  [118] = 87,
  [119] = 65,
  [120] = 69,
  [121] = 68,
  [122] = 67,
  [123] = 63,
  [124] = 85,
  [125] = 62,
  [126] = 61,
  [127] = 60,
  [128] = 59,
  [129] = 84,
  [130] = 80,
  [131] = 79,
  [132] = 78,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 138,
  [143] = 143,
  [144] = 144,
  [145] = 139,
  [146] = 146,
  [147] = 144,
  [148] = 148,
  [149] = 140,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 156,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 159,
  [166] = 158,
  [167] = 167,
  [168] = 168,
  [169] = 137,
  [170] = 135,
  [171] = 163,
  [172] = 78,
  [173] = 173,
  [174] = 174,
  [175] = 167,
  [176] = 176,
  [177] = 177,
  [178] = 164,
  [179] = 168,
  [180] = 162,
  [181] = 177,
  [182] = 174,
  [183] = 161,
  [184] = 173,
  [185] = 78,
  [186] = 176,
  [187] = 187,
  [188] = 187,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 194,
  [200] = 195,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 192,
  [205] = 205,
  [206] = 191,
  [207] = 198,
  [208] = 208,
  [209] = 209,
  [210] = 197,
  [211] = 196,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 214,
  [233] = 233,
  [234] = 216,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 227,
  [240] = 229,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 241,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 216,
  [250] = 216,
  [251] = 242,
  [252] = 243,
  [253] = 253,
  [254] = 228,
  [255] = 220,
  [256] = 222,
  [257] = 257,
  [258] = 224,
  [259] = 259,
  [260] = 225,
  [261] = 261,
  [262] = 262,
  [263] = 226,
  [264] = 248,
  [265] = 247,
  [266] = 244,
  [267] = 267,
};

static inline bool aux_sym_attribute_name_token1_character_set_1(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '"')))
    : (c <= '\'' || (c < '{'
      ? (c < '<'
        ? c == '/'
        : c <= '>')
      : (c <= '{' || c == '}'))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(33);
      if (lookahead == '"') ADVANCE(43);
      if (lookahead == '#') ADVANCE(54);
      if (lookahead == '\'') ADVANCE(40);
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == ':') ADVANCE(56);
      if (lookahead == '<') ADVANCE(34);
      if (lookahead == '=') ADVANCE(38);
      if (lookahead == '>') ADVANCE(35);
      if (lookahead == '@') ADVANCE(51);
      if (lookahead == 'a') ADVANCE(23);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'e') ADVANCE(6);
      if (lookahead == 'h') ADVANCE(26);
      if (lookahead == 'i') ADVANCE(14);
      if (lookahead == 'k') ADVANCE(11);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == '{') ADVANCE(49);
      if (lookahead == '}') ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(43);
      if (lookahead == '\'') ADVANCE(40);
      if (lookahead == '/') ADVANCE(5);
      if (lookahead == '=') ADVANCE(38);
      if (lookahead == '>') ADVANCE(35);
      if (lookahead == '{') ADVANCE(48);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '}') ADVANCE(39);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(43);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(44);
      if (lookahead != 0) ADVANCE(45);
      END_STATE();
    case 3:
      if (lookahead == '#') ADVANCE(54);
      if (lookahead == '/') ADVANCE(58);
      if (lookahead == ':') ADVANCE(56);
      if (lookahead == '@') ADVANCE(51);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      END_STATE();
    case 4:
      if (lookahead == '\'') ADVANCE(40);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(41);
      if (lookahead != 0) ADVANCE(42);
      END_STATE();
    case 5:
      if (lookahead == '>') ADVANCE(36);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(24);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(18);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(22);
      END_STATE();
    case 9:
      if (lookahead == 'c') ADVANCE(15);
      END_STATE();
    case 10:
      if (lookahead == 'c') ADVANCE(16);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(30);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(57);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(21);
      END_STATE();
    case 14:
      if (lookahead == 'f') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 'h') ADVANCE(64);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(13);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(27);
      END_STATE();
    case 19:
      if (lookahead == 'l') ADVANCE(52);
      END_STATE();
    case 20:
      if (lookahead == 'm') ADVANCE(19);
      END_STATE();
    case 21:
      if (lookahead == 'n') ADVANCE(63);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(25);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(61);
      if (lookahead == 'w') ADVANCE(7);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(12);
      END_STATE();
    case 25:
      if (lookahead == 's') ADVANCE(28);
      END_STATE();
    case 26:
      if (lookahead == 't') ADVANCE(20);
      END_STATE();
    case 27:
      if (lookahead == 't') ADVANCE(62);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(53);
      END_STATE();
    case 29:
      if (lookahead == 't') ADVANCE(10);
      END_STATE();
    case 30:
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 31:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(31);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(46);
      END_STATE();
    case 32:
      if (eof) ADVANCE(33);
      if (lookahead == '<') ADVANCE(34);
      if (lookahead == '{') ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(32)
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(46);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '/') ADVANCE(37);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_SLASH_GT);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_LT_SLASH);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(aux_sym_attribute_name_token1);
      if (!aux_sym_attribute_name_token1_character_set_1(lookahead)) ADVANCE(39);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(41);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token1);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(42);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token2);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(44);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(45);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token2);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(45);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(31);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(46);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_LBRACE_RBRACE);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '}') ADVANCE(47);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_html);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '>') ADVANCE(36);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_each);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_key);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 32, .external_lex_state = 2},
  [2] = {.lex_state = 32, .external_lex_state = 2},
  [3] = {.lex_state = 32, .external_lex_state = 2},
  [4] = {.lex_state = 32, .external_lex_state = 2},
  [5] = {.lex_state = 32, .external_lex_state = 2},
  [6] = {.lex_state = 32, .external_lex_state = 2},
  [7] = {.lex_state = 32, .external_lex_state = 2},
  [8] = {.lex_state = 32, .external_lex_state = 2},
  [9] = {.lex_state = 32, .external_lex_state = 2},
  [10] = {.lex_state = 32, .external_lex_state = 2},
  [11] = {.lex_state = 32, .external_lex_state = 2},
  [12] = {.lex_state = 32, .external_lex_state = 2},
  [13] = {.lex_state = 32, .external_lex_state = 2},
  [14] = {.lex_state = 32, .external_lex_state = 2},
  [15] = {.lex_state = 32, .external_lex_state = 2},
  [16] = {.lex_state = 32, .external_lex_state = 3},
  [17] = {.lex_state = 32, .external_lex_state = 2},
  [18] = {.lex_state = 32, .external_lex_state = 3},
  [19] = {.lex_state = 32, .external_lex_state = 2},
  [20] = {.lex_state = 32, .external_lex_state = 3},
  [21] = {.lex_state = 32, .external_lex_state = 3},
  [22] = {.lex_state = 32, .external_lex_state = 2},
  [23] = {.lex_state = 32, .external_lex_state = 2},
  [24] = {.lex_state = 32, .external_lex_state = 2},
  [25] = {.lex_state = 32, .external_lex_state = 2},
  [26] = {.lex_state = 32, .external_lex_state = 3},
  [27] = {.lex_state = 32, .external_lex_state = 2},
  [28] = {.lex_state = 32, .external_lex_state = 2},
  [29] = {.lex_state = 32, .external_lex_state = 2},
  [30] = {.lex_state = 32, .external_lex_state = 2},
  [31] = {.lex_state = 32, .external_lex_state = 2},
  [32] = {.lex_state = 32, .external_lex_state = 2},
  [33] = {.lex_state = 32, .external_lex_state = 2},
  [34] = {.lex_state = 32, .external_lex_state = 2},
  [35] = {.lex_state = 32, .external_lex_state = 2},
  [36] = {.lex_state = 32, .external_lex_state = 2},
  [37] = {.lex_state = 32, .external_lex_state = 2},
  [38] = {.lex_state = 32, .external_lex_state = 2},
  [39] = {.lex_state = 32, .external_lex_state = 2},
  [40] = {.lex_state = 32, .external_lex_state = 2},
  [41] = {.lex_state = 32, .external_lex_state = 2},
  [42] = {.lex_state = 32, .external_lex_state = 2},
  [43] = {.lex_state = 32, .external_lex_state = 2},
  [44] = {.lex_state = 32, .external_lex_state = 2},
  [45] = {.lex_state = 1, .external_lex_state = 4},
  [46] = {.lex_state = 1},
  [47] = {.lex_state = 1, .external_lex_state = 4},
  [48] = {.lex_state = 1, .external_lex_state = 4},
  [49] = {.lex_state = 1, .external_lex_state = 4},
  [50] = {.lex_state = 1},
  [51] = {.lex_state = 1, .external_lex_state = 4},
  [52] = {.lex_state = 32, .external_lex_state = 3},
  [53] = {.lex_state = 1},
  [54] = {.lex_state = 32, .external_lex_state = 3},
  [55] = {.lex_state = 32, .external_lex_state = 3},
  [56] = {.lex_state = 1},
  [57] = {.lex_state = 1},
  [58] = {.lex_state = 32, .external_lex_state = 3},
  [59] = {.lex_state = 32, .external_lex_state = 3},
  [60] = {.lex_state = 32, .external_lex_state = 3},
  [61] = {.lex_state = 32, .external_lex_state = 3},
  [62] = {.lex_state = 32, .external_lex_state = 3},
  [63] = {.lex_state = 32, .external_lex_state = 3},
  [64] = {.lex_state = 32, .external_lex_state = 3},
  [65] = {.lex_state = 32, .external_lex_state = 3},
  [66] = {.lex_state = 1},
  [67] = {.lex_state = 32, .external_lex_state = 3},
  [68] = {.lex_state = 32, .external_lex_state = 3},
  [69] = {.lex_state = 32, .external_lex_state = 3},
  [70] = {.lex_state = 32, .external_lex_state = 3},
  [71] = {.lex_state = 32, .external_lex_state = 3},
  [72] = {.lex_state = 32, .external_lex_state = 3},
  [73] = {.lex_state = 32, .external_lex_state = 3},
  [74] = {.lex_state = 32, .external_lex_state = 3},
  [75] = {.lex_state = 32, .external_lex_state = 3},
  [76] = {.lex_state = 32, .external_lex_state = 3},
  [77] = {.lex_state = 32, .external_lex_state = 3},
  [78] = {.lex_state = 32, .external_lex_state = 3},
  [79] = {.lex_state = 32, .external_lex_state = 3},
  [80] = {.lex_state = 32, .external_lex_state = 3},
  [81] = {.lex_state = 32, .external_lex_state = 3},
  [82] = {.lex_state = 32, .external_lex_state = 3},
  [83] = {.lex_state = 32, .external_lex_state = 3},
  [84] = {.lex_state = 32, .external_lex_state = 3},
  [85] = {.lex_state = 32, .external_lex_state = 3},
  [86] = {.lex_state = 1},
  [87] = {.lex_state = 32, .external_lex_state = 3},
  [88] = {.lex_state = 32, .external_lex_state = 3},
  [89] = {.lex_state = 32, .external_lex_state = 3},
  [90] = {.lex_state = 32, .external_lex_state = 3},
  [91] = {.lex_state = 32, .external_lex_state = 3},
  [92] = {.lex_state = 32, .external_lex_state = 3},
  [93] = {.lex_state = 32, .external_lex_state = 3},
  [94] = {.lex_state = 32, .external_lex_state = 3},
  [95] = {.lex_state = 32, .external_lex_state = 3},
  [96] = {.lex_state = 32, .external_lex_state = 2},
  [97] = {.lex_state = 32, .external_lex_state = 2},
  [98] = {.lex_state = 32, .external_lex_state = 2},
  [99] = {.lex_state = 32, .external_lex_state = 2},
  [100] = {.lex_state = 32, .external_lex_state = 2},
  [101] = {.lex_state = 32, .external_lex_state = 2},
  [102] = {.lex_state = 32, .external_lex_state = 2},
  [103] = {.lex_state = 32, .external_lex_state = 2},
  [104] = {.lex_state = 32, .external_lex_state = 2},
  [105] = {.lex_state = 32, .external_lex_state = 2},
  [106] = {.lex_state = 32, .external_lex_state = 2},
  [107] = {.lex_state = 32, .external_lex_state = 2},
  [108] = {.lex_state = 32, .external_lex_state = 2},
  [109] = {.lex_state = 32, .external_lex_state = 2},
  [110] = {.lex_state = 32, .external_lex_state = 2},
  [111] = {.lex_state = 32, .external_lex_state = 2},
  [112] = {.lex_state = 32, .external_lex_state = 2},
  [113] = {.lex_state = 32, .external_lex_state = 2},
  [114] = {.lex_state = 32, .external_lex_state = 2},
  [115] = {.lex_state = 32, .external_lex_state = 2},
  [116] = {.lex_state = 32, .external_lex_state = 2},
  [117] = {.lex_state = 32, .external_lex_state = 2},
  [118] = {.lex_state = 32, .external_lex_state = 2},
  [119] = {.lex_state = 32, .external_lex_state = 2},
  [120] = {.lex_state = 32, .external_lex_state = 2},
  [121] = {.lex_state = 32, .external_lex_state = 2},
  [122] = {.lex_state = 32, .external_lex_state = 2},
  [123] = {.lex_state = 32, .external_lex_state = 2},
  [124] = {.lex_state = 32, .external_lex_state = 2},
  [125] = {.lex_state = 32, .external_lex_state = 2},
  [126] = {.lex_state = 32, .external_lex_state = 2},
  [127] = {.lex_state = 32, .external_lex_state = 2},
  [128] = {.lex_state = 32, .external_lex_state = 2},
  [129] = {.lex_state = 32, .external_lex_state = 2},
  [130] = {.lex_state = 32, .external_lex_state = 2},
  [131] = {.lex_state = 32, .external_lex_state = 2},
  [132] = {.lex_state = 32, .external_lex_state = 2},
  [133] = {.lex_state = 32, .external_lex_state = 2},
  [134] = {.lex_state = 32, .external_lex_state = 2},
  [135] = {.lex_state = 1, .external_lex_state = 4},
  [136] = {.lex_state = 32, .external_lex_state = 2},
  [137] = {.lex_state = 1, .external_lex_state = 4},
  [138] = {.lex_state = 3, .external_lex_state = 5},
  [139] = {.lex_state = 3, .external_lex_state = 5},
  [140] = {.lex_state = 3, .external_lex_state = 5},
  [141] = {.lex_state = 32, .external_lex_state = 2},
  [142] = {.lex_state = 3, .external_lex_state = 5},
  [143] = {.lex_state = 32, .external_lex_state = 2},
  [144] = {.lex_state = 3, .external_lex_state = 5},
  [145] = {.lex_state = 3, .external_lex_state = 5},
  [146] = {.lex_state = 32, .external_lex_state = 2},
  [147] = {.lex_state = 3, .external_lex_state = 5},
  [148] = {.lex_state = 32, .external_lex_state = 2},
  [149] = {.lex_state = 3, .external_lex_state = 5},
  [150] = {.lex_state = 32, .external_lex_state = 2},
  [151] = {.lex_state = 32, .external_lex_state = 2},
  [152] = {.lex_state = 32, .external_lex_state = 2},
  [153] = {.lex_state = 32, .external_lex_state = 2},
  [154] = {.lex_state = 32, .external_lex_state = 2},
  [155] = {.lex_state = 32, .external_lex_state = 2},
  [156] = {.lex_state = 3, .external_lex_state = 5},
  [157] = {.lex_state = 0},
  [158] = {.lex_state = 3, .external_lex_state = 5},
  [159] = {.lex_state = 3, .external_lex_state = 5},
  [160] = {.lex_state = 3, .external_lex_state = 5},
  [161] = {.lex_state = 1, .external_lex_state = 4},
  [162] = {.lex_state = 1, .external_lex_state = 4},
  [163] = {.lex_state = 3, .external_lex_state = 5},
  [164] = {.lex_state = 1, .external_lex_state = 4},
  [165] = {.lex_state = 3, .external_lex_state = 5},
  [166] = {.lex_state = 3, .external_lex_state = 5},
  [167] = {.lex_state = 1, .external_lex_state = 4},
  [168] = {.lex_state = 1, .external_lex_state = 4},
  [169] = {.lex_state = 1},
  [170] = {.lex_state = 1},
  [171] = {.lex_state = 3, .external_lex_state = 5},
  [172] = {.lex_state = 1, .external_lex_state = 4},
  [173] = {.lex_state = 1, .external_lex_state = 4},
  [174] = {.lex_state = 0, .external_lex_state = 5},
  [175] = {.lex_state = 1},
  [176] = {.lex_state = 0, .external_lex_state = 6},
  [177] = {.lex_state = 0, .external_lex_state = 6},
  [178] = {.lex_state = 1},
  [179] = {.lex_state = 1},
  [180] = {.lex_state = 1},
  [181] = {.lex_state = 0, .external_lex_state = 6},
  [182] = {.lex_state = 0, .external_lex_state = 5},
  [183] = {.lex_state = 1},
  [184] = {.lex_state = 1},
  [185] = {.lex_state = 1},
  [186] = {.lex_state = 0, .external_lex_state = 6},
  [187] = {.lex_state = 0, .external_lex_state = 7},
  [188] = {.lex_state = 0, .external_lex_state = 7},
  [189] = {.lex_state = 0, .external_lex_state = 6},
  [190] = {.lex_state = 0},
  [191] = {.lex_state = 4},
  [192] = {.lex_state = 0},
  [193] = {.lex_state = 0, .external_lex_state = 6},
  [194] = {.lex_state = 0},
  [195] = {.lex_state = 0},
  [196] = {.lex_state = 0, .external_lex_state = 5},
  [197] = {.lex_state = 0, .external_lex_state = 5},
  [198] = {.lex_state = 2},
  [199] = {.lex_state = 0},
  [200] = {.lex_state = 0},
  [201] = {.lex_state = 0, .external_lex_state = 5},
  [202] = {.lex_state = 0, .external_lex_state = 8},
  [203] = {.lex_state = 0, .external_lex_state = 9},
  [204] = {.lex_state = 0},
  [205] = {.lex_state = 0},
  [206] = {.lex_state = 4},
  [207] = {.lex_state = 2},
  [208] = {.lex_state = 0, .external_lex_state = 5},
  [209] = {.lex_state = 0, .external_lex_state = 5},
  [210] = {.lex_state = 0, .external_lex_state = 5},
  [211] = {.lex_state = 0, .external_lex_state = 5},
  [212] = {.lex_state = 0, .external_lex_state = 6},
  [213] = {.lex_state = 0, .external_lex_state = 6},
  [214] = {.lex_state = 0},
  [215] = {.lex_state = 0, .external_lex_state = 5},
  [216] = {.lex_state = 0},
  [217] = {.lex_state = 0},
  [218] = {.lex_state = 0, .external_lex_state = 5},
  [219] = {.lex_state = 0, .external_lex_state = 5},
  [220] = {.lex_state = 0, .external_lex_state = 5},
  [221] = {.lex_state = 0},
  [222] = {.lex_state = 0},
  [223] = {.lex_state = 0},
  [224] = {.lex_state = 0},
  [225] = {.lex_state = 0},
  [226] = {.lex_state = 0},
  [227] = {.lex_state = 0},
  [228] = {.lex_state = 0, .external_lex_state = 10},
  [229] = {.lex_state = 0},
  [230] = {.lex_state = 0},
  [231] = {.lex_state = 0},
  [232] = {.lex_state = 0},
  [233] = {.lex_state = 0},
  [234] = {.lex_state = 0},
  [235] = {.lex_state = 0},
  [236] = {.lex_state = 0},
  [237] = {.lex_state = 0},
  [238] = {.lex_state = 0},
  [239] = {.lex_state = 0},
  [240] = {.lex_state = 0},
  [241] = {.lex_state = 0},
  [242] = {.lex_state = 0},
  [243] = {.lex_state = 0},
  [244] = {.lex_state = 0},
  [245] = {.lex_state = 0},
  [246] = {.lex_state = 0},
  [247] = {.lex_state = 0},
  [248] = {.lex_state = 0},
  [249] = {.lex_state = 0},
  [250] = {.lex_state = 0},
  [251] = {.lex_state = 0},
  [252] = {.lex_state = 0},
  [253] = {.lex_state = 0},
  [254] = {.lex_state = 0, .external_lex_state = 10},
  [255] = {.lex_state = 0, .external_lex_state = 5},
  [256] = {.lex_state = 0},
  [257] = {.lex_state = 0, .external_lex_state = 5},
  [258] = {.lex_state = 0},
  [259] = {.lex_state = 0},
  [260] = {.lex_state = 0},
  [261] = {.lex_state = 0},
  [262] = {.lex_state = 0},
  [263] = {.lex_state = 0},
  [264] = {.lex_state = 0},
  [265] = {.lex_state = 0},
  [266] = {.lex_state = 0},
  [267] = {.lex_state = 0},
};

enum {
  ts_external_token__start_tag_name = 0,
  ts_external_token__script_start_tag_name = 1,
  ts_external_token__style_start_tag_name = 2,
  ts_external_token__end_tag_name = 3,
  ts_external_token_erroneous_end_tag_name = 4,
  ts_external_token_SLASH_GT = 5,
  ts_external_token__implicit_end_tag = 6,
  ts_external_token_raw_text = 7,
  ts_external_token_raw_text_expr = 8,
  ts_external_token_raw_text_await = 9,
  ts_external_token_raw_text_each = 10,
  ts_external_token_comment = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__start_tag_name] = sym__start_tag_name,
  [ts_external_token__script_start_tag_name] = sym__script_start_tag_name,
  [ts_external_token__style_start_tag_name] = sym__style_start_tag_name,
  [ts_external_token__end_tag_name] = sym__end_tag_name,
  [ts_external_token_erroneous_end_tag_name] = sym_erroneous_end_tag_name,
  [ts_external_token_SLASH_GT] = anon_sym_SLASH_GT,
  [ts_external_token__implicit_end_tag] = sym__implicit_end_tag,
  [ts_external_token_raw_text] = sym_raw_text,
  [ts_external_token_raw_text_expr] = sym_raw_text_expr,
  [ts_external_token_raw_text_await] = sym_raw_text_await,
  [ts_external_token_raw_text_each] = sym_raw_text_each,
  [ts_external_token_comment] = sym_comment,
};

static const bool ts_external_scanner_states[11][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__start_tag_name] = true,
    [ts_external_token__script_start_tag_name] = true,
    [ts_external_token__style_start_tag_name] = true,
    [ts_external_token__end_tag_name] = true,
    [ts_external_token_erroneous_end_tag_name] = true,
    [ts_external_token_SLASH_GT] = true,
    [ts_external_token__implicit_end_tag] = true,
    [ts_external_token_raw_text] = true,
    [ts_external_token_raw_text_expr] = true,
    [ts_external_token_raw_text_await] = true,
    [ts_external_token_raw_text_each] = true,
    [ts_external_token_comment] = true,
  },
  [2] = {
    [ts_external_token_comment] = true,
  },
  [3] = {
    [ts_external_token__implicit_end_tag] = true,
    [ts_external_token_comment] = true,
  },
  [4] = {
    [ts_external_token_SLASH_GT] = true,
  },
  [5] = {
    [ts_external_token_raw_text_expr] = true,
  },
  [6] = {
    [ts_external_token_raw_text] = true,
  },
  [7] = {
    [ts_external_token__start_tag_name] = true,
    [ts_external_token__script_start_tag_name] = true,
    [ts_external_token__style_start_tag_name] = true,
  },
  [8] = {
    [ts_external_token_raw_text_expr] = true,
    [ts_external_token_raw_text_await] = true,
  },
  [9] = {
    [ts_external_token_raw_text_expr] = true,
    [ts_external_token_raw_text_each] = true,
  },
  [10] = {
    [ts_external_token__end_tag_name] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH_GT] = ACTIONS(1),
    [anon_sym_LT_SLASH] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_LBRACE_RBRACE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_html] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_each] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_key] = ACTIONS(1),
    [sym__start_tag_name] = ACTIONS(1),
    [sym__script_start_tag_name] = ACTIONS(1),
    [sym__style_start_tag_name] = ACTIONS(1),
    [sym__end_tag_name] = ACTIONS(1),
    [sym_erroneous_end_tag_name] = ACTIONS(1),
    [sym__implicit_end_tag] = ACTIONS(1),
    [sym_raw_text] = ACTIONS(1),
    [sym_raw_text_expr] = ACTIONS(1),
    [sym_raw_text_await] = ACTIONS(1),
    [sym_raw_text_each] = ACTIONS(1),
    [sym_comment] = ACTIONS(1),
  },
  [1] = {
    [sym_document] = STATE(237),
    [sym__node] = STATE(31),
    [sym__statement] = STATE(31),
    [sym_element] = STATE(31),
    [sym_start_tag] = STATE(20),
    [sym_self_closing_tag] = STATE(119),
    [sym_script_element] = STATE(31),
    [sym_script_start_tag] = STATE(176),
    [sym_style_element] = STATE(31),
    [sym_style_start_tag] = STATE(177),
    [sym__text] = STATE(31),
    [sym__expression] = STATE(31),
    [sym_expression] = STATE(31),
    [sym_html_expr] = STATE(31),
    [sym_const_expr] = STATE(31),
    [sym_if_statement] = STATE(31),
    [sym_if_start_expr] = STATE(9),
    [sym_each_statement] = STATE(31),
    [sym_each_start_expr] = STATE(22),
    [sym_await_statement] = STATE(31),
    [sym_await_start_expr] = STATE(11),
    [sym_key_statement] = STATE(31),
    [sym_key_start_expr] = STATE(34),
    [aux_sym_document_repeat1] = STATE(31),
    [ts_builtin_sym_end] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(5),
    [aux_sym__text_token1] = ACTIONS(7),
    [anon_sym_LBRACE_RBRACE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [sym_comment] = ACTIONS(7),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(24), 1,
      sym_then_expr,
    STATE(28), 1,
      sym_catch_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(95), 3,
      sym_then_statement,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [64] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    STATE(4), 1,
      sym_else_if_expr,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(36), 1,
      sym_else_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(15), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(92), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(7), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [128] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    STATE(4), 1,
      sym_else_if_expr,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(36), 1,
      sym_else_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(19), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(87), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(8), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [192] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(14), 1,
      sym_then_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(39), 1,
      sym_catch_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(104), 3,
      sym_then_statement,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [256] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(24), 1,
      sym_then_expr,
    STATE(28), 1,
      sym_catch_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(23), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(71), 3,
      sym_then_statement,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(2), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [320] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    STATE(4), 1,
      sym_else_if_expr,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(36), 1,
      sym_else_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(88), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [384] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    STATE(4), 1,
      sym_else_if_expr,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(36), 1,
      sym_else_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(76), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [448] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(13), 1,
      sym_else_if_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(29), 1,
      sym_else_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(25), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(107), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(12), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [512] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(13), 1,
      sym_else_if_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(29), 1,
      sym_else_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(112), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [576] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(21), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(14), 1,
      sym_then_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(39), 1,
      sym_catch_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(29), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(96), 3,
      sym_then_statement,
      sym_catch_statement,
      sym_await_end_expr,
    STATE(5), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [640] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(13), 1,
      sym_else_if_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(29), 1,
      sym_else_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(116), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [704] = 15,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(13), 1,
      sym_else_if_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(29), 1,
      sym_else_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(31), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(118), 3,
      sym_else_if_statement,
      sym_else_statement,
      sym_if_end_expr,
    STATE(10), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [768] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(39), 1,
      sym_catch_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    STATE(109), 2,
      sym_catch_statement,
      sym_await_end_expr,
    ACTIONS(33), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(25), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [828] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(32), 1,
      sym_else_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    STATE(91), 2,
      sym_else_each_statement,
      sym_each_end_expr,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [888] = 15,
    ACTIONS(39), 1,
      anon_sym_LT,
    ACTIONS(41), 1,
      anon_sym_LT_SLASH,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(47), 1,
      sym__implicit_end_tag,
    STATE(3), 1,
      sym_if_start_expr,
    STATE(6), 1,
      sym_await_start_expr,
    STATE(17), 1,
      sym_each_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(30), 1,
      sym_key_start_expr,
    STATE(65), 1,
      sym_self_closing_tag,
    STATE(79), 1,
      sym_end_tag,
    STATE(181), 1,
      sym_style_start_tag,
    STATE(186), 1,
      sym_script_start_tag,
    ACTIONS(43), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(26), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [950] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(32), 1,
      sym_else_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    STATE(70), 2,
      sym_else_each_statement,
      sym_each_end_expr,
    ACTIONS(49), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(15), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1010] = 15,
    ACTIONS(39), 1,
      anon_sym_LT,
    ACTIONS(41), 1,
      anon_sym_LT_SLASH,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      sym__implicit_end_tag,
    STATE(3), 1,
      sym_if_start_expr,
    STATE(6), 1,
      sym_await_start_expr,
    STATE(17), 1,
      sym_each_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(30), 1,
      sym_key_start_expr,
    STATE(64), 1,
      sym_end_tag,
    STATE(65), 1,
      sym_self_closing_tag,
    STATE(181), 1,
      sym_style_start_tag,
    STATE(186), 1,
      sym_script_start_tag,
    ACTIONS(51), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(16), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1072] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(28), 1,
      sym_catch_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    STATE(69), 2,
      sym_catch_statement,
      sym_await_end_expr,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1132] = 15,
    ACTIONS(39), 1,
      anon_sym_LT,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_LT_SLASH,
    ACTIONS(61), 1,
      sym__implicit_end_tag,
    STATE(3), 1,
      sym_if_start_expr,
    STATE(6), 1,
      sym_await_start_expr,
    STATE(17), 1,
      sym_each_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(30), 1,
      sym_key_start_expr,
    STATE(65), 1,
      sym_self_closing_tag,
    STATE(97), 1,
      sym_end_tag,
    STATE(181), 1,
      sym_style_start_tag,
    STATE(186), 1,
      sym_script_start_tag,
    ACTIONS(59), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(21), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1194] = 15,
    ACTIONS(39), 1,
      anon_sym_LT,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_LT_SLASH,
    ACTIONS(63), 1,
      sym__implicit_end_tag,
    STATE(3), 1,
      sym_if_start_expr,
    STATE(6), 1,
      sym_await_start_expr,
    STATE(17), 1,
      sym_each_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(30), 1,
      sym_key_start_expr,
    STATE(65), 1,
      sym_self_closing_tag,
    STATE(131), 1,
      sym_end_tag,
    STATE(181), 1,
      sym_style_start_tag,
    STATE(186), 1,
      sym_script_start_tag,
    ACTIONS(43), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(26), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1256] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(33), 1,
      sym_else_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    STATE(113), 2,
      sym_else_each_statement,
      sym_each_end_expr,
    ACTIONS(65), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(23), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1316] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(33), 1,
      sym_else_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    STATE(110), 2,
      sym_else_each_statement,
      sym_each_end_expr,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1376] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(28), 1,
      sym_catch_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    STATE(52), 2,
      sym_catch_statement,
      sym_await_end_expr,
    ACTIONS(69), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(19), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1436] = 14,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(39), 1,
      sym_catch_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    STATE(120), 2,
      sym_catch_statement,
      sym_await_end_expr,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1496] = 13,
    ACTIONS(71), 1,
      anon_sym_LT,
    ACTIONS(79), 1,
      anon_sym_LBRACE,
    STATE(3), 1,
      sym_if_start_expr,
    STATE(6), 1,
      sym_await_start_expr,
    STATE(17), 1,
      sym_each_start_expr,
    STATE(18), 1,
      sym_start_tag,
    STATE(30), 1,
      sym_key_start_expr,
    STATE(65), 1,
      sym_self_closing_tag,
    STATE(181), 1,
      sym_style_start_tag,
    STATE(186), 1,
      sym_script_start_tag,
    ACTIONS(74), 2,
      sym__implicit_end_tag,
      anon_sym_LT_SLASH,
    ACTIONS(76), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(26), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1553] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(82), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(121), 1,
      sym_await_end_expr,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1609] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(86), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(73), 1,
      sym_await_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(84), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(41), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1665] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(90), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(124), 1,
      sym_if_end_expr,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(88), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(37), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1721] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(94), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(72), 1,
      sym_key_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(92), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(42), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1777] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(9), 1,
      anon_sym_LBRACE,
    ACTIONS(96), 1,
      ts_builtin_sym_end,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1833] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(100), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(89), 1,
      sym_each_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(98), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(38), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1889] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(104), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(114), 1,
      sym_each_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(102), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(40), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [1945] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(108), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(117), 1,
      sym_key_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(106), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(43), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2001] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(110), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(77), 1,
      sym_if_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2057] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(110), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(85), 1,
      sym_if_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(112), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(35), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2113] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(90), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(111), 1,
      sym_if_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2169] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(100), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(75), 1,
      sym_each_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2225] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(82), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(106), 1,
      sym_await_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(114), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(27), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2281] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(104), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(115), 1,
      sym_each_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2337] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(86), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(68), 1,
      sym_await_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2393] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(94), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(94), 1,
      sym_key_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2449] = 13,
    ACTIONS(5), 1,
      anon_sym_LT,
    ACTIONS(108), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(103), 1,
      sym_key_end_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(11), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2505] = 13,
    ACTIONS(74), 1,
      ts_builtin_sym_end,
    ACTIONS(116), 1,
      anon_sym_LT,
    ACTIONS(122), 1,
      anon_sym_LBRACE,
    STATE(9), 1,
      sym_if_start_expr,
    STATE(11), 1,
      sym_await_start_expr,
    STATE(20), 1,
      sym_start_tag,
    STATE(22), 1,
      sym_each_start_expr,
    STATE(34), 1,
      sym_key_start_expr,
    STATE(119), 1,
      sym_self_closing_tag,
    STATE(176), 1,
      sym_script_start_tag,
    STATE(177), 1,
      sym_style_start_tag,
    ACTIONS(119), 3,
      sym_comment,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
    STATE(44), 15,
      sym__node,
      sym__statement,
      sym_element,
      sym_script_element,
      sym_style_element,
      sym__text,
      sym__expression,
      sym_expression,
      sym_html_expr,
      sym_const_expr,
      sym_if_statement,
      sym_each_statement,
      sym_await_statement,
      sym_key_statement,
      aux_sym_document_repeat1,
  [2561] = 7,
    ACTIONS(125), 1,
      anon_sym_GT,
    ACTIONS(127), 1,
      anon_sym_SLASH_GT,
    ACTIONS(129), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    STATE(135), 1,
      sym_attribute_name,
    STATE(173), 1,
      sym_expression,
    STATE(48), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2584] = 6,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(133), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(135), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    STATE(164), 1,
      sym_expression,
    STATE(168), 3,
      sym_attribute_value,
      sym_expr_attribute_value,
      sym_quoted_attribute_value,
  [2605] = 7,
    ACTIONS(129), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(139), 1,
      anon_sym_GT,
    ACTIONS(141), 1,
      anon_sym_SLASH_GT,
    STATE(135), 1,
      sym_attribute_name,
    STATE(173), 1,
      sym_expression,
    STATE(51), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2628] = 6,
    ACTIONS(145), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(148), 1,
      anon_sym_LBRACE,
    STATE(135), 1,
      sym_attribute_name,
    STATE(173), 1,
      sym_expression,
    ACTIONS(143), 2,
      anon_sym_GT,
      anon_sym_SLASH_GT,
    STATE(48), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2649] = 7,
    ACTIONS(129), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(139), 1,
      anon_sym_GT,
    ACTIONS(151), 1,
      anon_sym_SLASH_GT,
    STATE(135), 1,
      sym_attribute_name,
    STATE(173), 1,
      sym_expression,
    STATE(45), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2672] = 6,
    ACTIONS(153), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(155), 1,
      anon_sym_SQUOTE,
    ACTIONS(157), 1,
      anon_sym_DQUOTE,
    ACTIONS(159), 1,
      anon_sym_LBRACE,
    STATE(178), 1,
      sym_expression,
    STATE(179), 3,
      sym_attribute_value,
      sym_expr_attribute_value,
      sym_quoted_attribute_value,
  [2693] = 7,
    ACTIONS(125), 1,
      anon_sym_GT,
    ACTIONS(129), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(161), 1,
      anon_sym_SLASH_GT,
    STATE(135), 1,
      sym_attribute_name,
    STATE(173), 1,
      sym_expression,
    STATE(48), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2716] = 2,
    ACTIONS(163), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(165), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2728] = 6,
    ACTIONS(159), 1,
      anon_sym_LBRACE,
    ACTIONS(167), 1,
      anon_sym_GT,
    ACTIONS(169), 1,
      aux_sym_attribute_name_token1,
    STATE(170), 1,
      sym_attribute_name,
    STATE(184), 1,
      sym_expression,
    STATE(57), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2748] = 2,
    ACTIONS(171), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(173), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2760] = 2,
    ACTIONS(175), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(177), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2772] = 6,
    ACTIONS(159), 1,
      anon_sym_LBRACE,
    ACTIONS(169), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(179), 1,
      anon_sym_GT,
    STATE(170), 1,
      sym_attribute_name,
    STATE(184), 1,
      sym_expression,
    STATE(86), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2792] = 6,
    ACTIONS(159), 1,
      anon_sym_LBRACE,
    ACTIONS(169), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(181), 1,
      anon_sym_GT,
    STATE(170), 1,
      sym_attribute_name,
    STATE(184), 1,
      sym_expression,
    STATE(86), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2812] = 2,
    ACTIONS(183), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(185), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2824] = 2,
    ACTIONS(187), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(189), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2836] = 2,
    ACTIONS(191), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(193), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2848] = 2,
    ACTIONS(195), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(197), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2860] = 2,
    ACTIONS(199), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(201), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2872] = 2,
    ACTIONS(203), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(205), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2884] = 2,
    ACTIONS(207), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(209), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2896] = 2,
    ACTIONS(211), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(213), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2908] = 6,
    ACTIONS(159), 1,
      anon_sym_LBRACE,
    ACTIONS(169), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(215), 1,
      anon_sym_GT,
    STATE(170), 1,
      sym_attribute_name,
    STATE(184), 1,
      sym_expression,
    STATE(56), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [2928] = 2,
    ACTIONS(217), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(219), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2940] = 2,
    ACTIONS(221), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(223), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2952] = 2,
    ACTIONS(225), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(227), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2964] = 2,
    ACTIONS(229), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(231), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2976] = 2,
    ACTIONS(233), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(235), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [2988] = 2,
    ACTIONS(237), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(239), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3000] = 2,
    ACTIONS(241), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(243), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3012] = 2,
    ACTIONS(245), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(247), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3024] = 2,
    ACTIONS(249), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(251), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3036] = 2,
    ACTIONS(253), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(255), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3048] = 2,
    ACTIONS(257), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(259), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3060] = 2,
    ACTIONS(261), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(263), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3072] = 2,
    ACTIONS(265), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(267), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3084] = 2,
    ACTIONS(269), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(271), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3096] = 2,
    ACTIONS(273), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(275), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3108] = 2,
    ACTIONS(277), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(279), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3120] = 2,
    ACTIONS(281), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(283), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3132] = 2,
    ACTIONS(285), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(287), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3144] = 2,
    ACTIONS(289), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(291), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3156] = 6,
    ACTIONS(143), 1,
      anon_sym_GT,
    ACTIONS(293), 1,
      aux_sym_attribute_name_token1,
    ACTIONS(296), 1,
      anon_sym_LBRACE,
    STATE(170), 1,
      sym_attribute_name,
    STATE(184), 1,
      sym_expression,
    STATE(86), 2,
      sym_attribute,
      aux_sym_start_tag_repeat1,
  [3176] = 2,
    ACTIONS(299), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(301), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3188] = 2,
    ACTIONS(303), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(305), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3200] = 2,
    ACTIONS(307), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(309), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3212] = 2,
    ACTIONS(311), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(313), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3224] = 2,
    ACTIONS(315), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(317), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3236] = 2,
    ACTIONS(319), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(321), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3248] = 2,
    ACTIONS(323), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(325), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3260] = 2,
    ACTIONS(327), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(329), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3272] = 2,
    ACTIONS(331), 2,
      anon_sym_LT,
      anon_sym_LBRACE,
    ACTIONS(333), 5,
      sym__implicit_end_tag,
      sym_comment,
      anon_sym_LT_SLASH,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3284] = 2,
    ACTIONS(233), 1,
      anon_sym_LBRACE,
    ACTIONS(235), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3295] = 2,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3306] = 2,
    ACTIONS(311), 1,
      anon_sym_LBRACE,
    ACTIONS(313), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3317] = 2,
    ACTIONS(281), 1,
      anon_sym_LBRACE,
    ACTIONS(283), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3328] = 2,
    ACTIONS(245), 1,
      anon_sym_LBRACE,
    ACTIONS(247), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3339] = 2,
    ACTIONS(277), 1,
      anon_sym_LBRACE,
    ACTIONS(279), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3350] = 2,
    ACTIONS(183), 1,
      anon_sym_LBRACE,
    ACTIONS(185), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3361] = 2,
    ACTIONS(327), 1,
      anon_sym_LBRACE,
    ACTIONS(329), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3372] = 2,
    ACTIONS(331), 1,
      anon_sym_LBRACE,
    ACTIONS(333), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3383] = 2,
    ACTIONS(175), 1,
      anon_sym_LBRACE,
    ACTIONS(177), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3394] = 2,
    ACTIONS(241), 1,
      anon_sym_LBRACE,
    ACTIONS(243), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3405] = 2,
    ACTIONS(319), 1,
      anon_sym_LBRACE,
    ACTIONS(321), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3416] = 2,
    ACTIONS(273), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3427] = 2,
    ACTIONS(163), 1,
      anon_sym_LBRACE,
    ACTIONS(165), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3438] = 2,
    ACTIONS(315), 1,
      anon_sym_LBRACE,
    ACTIONS(317), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3449] = 2,
    ACTIONS(257), 1,
      anon_sym_LBRACE,
    ACTIONS(259), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3460] = 2,
    ACTIONS(253), 1,
      anon_sym_LBRACE,
    ACTIONS(255), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3471] = 2,
    ACTIONS(229), 1,
      anon_sym_LBRACE,
    ACTIONS(231), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3482] = 2,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(309), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3493] = 2,
    ACTIONS(249), 1,
      anon_sym_LBRACE,
    ACTIONS(251), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3504] = 2,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(305), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3515] = 2,
    ACTIONS(237), 1,
      anon_sym_LBRACE,
    ACTIONS(239), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3526] = 2,
    ACTIONS(299), 1,
      anon_sym_LBRACE,
    ACTIONS(301), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3537] = 2,
    ACTIONS(211), 1,
      anon_sym_LBRACE,
    ACTIONS(213), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3548] = 2,
    ACTIONS(225), 1,
      anon_sym_LBRACE,
    ACTIONS(227), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3559] = 2,
    ACTIONS(221), 1,
      anon_sym_LBRACE,
    ACTIONS(223), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3570] = 2,
    ACTIONS(217), 1,
      anon_sym_LBRACE,
    ACTIONS(219), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3581] = 2,
    ACTIONS(203), 1,
      anon_sym_LBRACE,
    ACTIONS(205), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3592] = 2,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(291), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3603] = 2,
    ACTIONS(199), 1,
      anon_sym_LBRACE,
    ACTIONS(201), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3614] = 2,
    ACTIONS(195), 1,
      anon_sym_LBRACE,
    ACTIONS(197), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3625] = 2,
    ACTIONS(191), 1,
      anon_sym_LBRACE,
    ACTIONS(193), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3636] = 2,
    ACTIONS(187), 1,
      anon_sym_LBRACE,
    ACTIONS(189), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3647] = 2,
    ACTIONS(285), 1,
      anon_sym_LBRACE,
    ACTIONS(287), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3658] = 2,
    ACTIONS(269), 1,
      anon_sym_LBRACE,
    ACTIONS(271), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3669] = 2,
    ACTIONS(265), 1,
      anon_sym_LBRACE,
    ACTIONS(267), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3680] = 2,
    ACTIONS(261), 1,
      anon_sym_LBRACE,
    ACTIONS(263), 5,
      sym_comment,
      ts_builtin_sym_end,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3691] = 2,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(335), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3701] = 2,
    ACTIONS(341), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3711] = 2,
    ACTIONS(345), 1,
      anon_sym_EQ,
    ACTIONS(343), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3721] = 2,
    ACTIONS(349), 1,
      anon_sym_LBRACE,
    ACTIONS(347), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3731] = 1,
    ACTIONS(351), 5,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_EQ,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [3739] = 5,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(357), 1,
      anon_sym_COLON,
    ACTIONS(359), 1,
      anon_sym_SLASH,
    ACTIONS(361), 1,
      sym_raw_text_expr,
  [3755] = 5,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(363), 1,
      anon_sym_COLON,
    ACTIONS(365), 1,
      anon_sym_SLASH,
  [3771] = 5,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(359), 1,
      anon_sym_SLASH,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(367), 1,
      anon_sym_COLON,
  [3787] = 2,
    ACTIONS(371), 1,
      anon_sym_LBRACE,
    ACTIONS(369), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3797] = 5,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(357), 1,
      anon_sym_COLON,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(373), 1,
      anon_sym_SLASH,
  [3813] = 2,
    ACTIONS(377), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3823] = 5,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(379), 1,
      anon_sym_COLON,
    ACTIONS(381), 1,
      anon_sym_SLASH,
  [3839] = 5,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(363), 1,
      anon_sym_COLON,
    ACTIONS(383), 1,
      anon_sym_SLASH,
  [3855] = 2,
    ACTIONS(387), 1,
      anon_sym_LBRACE,
    ACTIONS(385), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3865] = 5,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(379), 1,
      anon_sym_COLON,
    ACTIONS(389), 1,
      anon_sym_SLASH,
  [3881] = 2,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(391), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3891] = 5,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(367), 1,
      anon_sym_COLON,
    ACTIONS(373), 1,
      anon_sym_SLASH,
  [3907] = 2,
    ACTIONS(397), 1,
      anon_sym_LBRACE,
    ACTIONS(395), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3917] = 2,
    ACTIONS(401), 1,
      anon_sym_LBRACE,
    ACTIONS(399), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3927] = 2,
    ACTIONS(405), 1,
      anon_sym_LBRACE,
    ACTIONS(403), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3937] = 2,
    ACTIONS(409), 1,
      anon_sym_LBRACE,
    ACTIONS(407), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3947] = 2,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(411), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3957] = 2,
    ACTIONS(417), 1,
      anon_sym_LBRACE,
    ACTIONS(415), 4,
      sym_comment,
      anon_sym_LT,
      aux_sym__text_token1,
      anon_sym_LBRACE_RBRACE,
  [3967] = 4,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(381), 1,
      anon_sym_SLASH,
  [3980] = 4,
    ACTIONS(419), 1,
      anon_sym_if,
    ACTIONS(421), 1,
      anon_sym_each,
    ACTIONS(423), 1,
      anon_sym_await,
    ACTIONS(425), 1,
      anon_sym_key,
  [3993] = 4,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(373), 1,
      anon_sym_SLASH,
  [4006] = 4,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(383), 1,
      anon_sym_SLASH,
  [4019] = 4,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(389), 1,
      anon_sym_SLASH,
  [4032] = 1,
    ACTIONS(427), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4039] = 1,
    ACTIONS(429), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4046] = 4,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(431), 1,
      anon_sym_SLASH,
  [4059] = 1,
    ACTIONS(433), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4066] = 4,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(365), 1,
      anon_sym_SLASH,
  [4079] = 4,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(359), 1,
      anon_sym_SLASH,
    ACTIONS(361), 1,
      sym_raw_text_expr,
  [4092] = 1,
    ACTIONS(435), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4099] = 1,
    ACTIONS(437), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4106] = 1,
    ACTIONS(351), 4,
      anon_sym_GT,
      anon_sym_EQ,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4113] = 2,
    ACTIONS(439), 1,
      anon_sym_EQ,
    ACTIONS(343), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4122] = 4,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
    ACTIONS(441), 1,
      anon_sym_SLASH,
  [4135] = 1,
    ACTIONS(263), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4142] = 1,
    ACTIONS(443), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4149] = 3,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(445), 1,
      anon_sym_AT,
    ACTIONS(447), 1,
      sym_raw_text_expr,
  [4159] = 1,
    ACTIONS(435), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4165] = 3,
    ACTIONS(57), 1,
      anon_sym_LT_SLASH,
    ACTIONS(449), 1,
      sym_raw_text,
    STATE(102), 1,
      sym_end_tag,
  [4175] = 3,
    ACTIONS(57), 1,
      anon_sym_LT_SLASH,
    ACTIONS(451), 1,
      sym_raw_text,
    STATE(105), 1,
      sym_end_tag,
  [4185] = 1,
    ACTIONS(433), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4191] = 1,
    ACTIONS(437), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4197] = 1,
    ACTIONS(429), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4203] = 3,
    ACTIONS(41), 1,
      anon_sym_LT_SLASH,
    ACTIONS(453), 1,
      sym_raw_text,
    STATE(55), 1,
      sym_end_tag,
  [4213] = 3,
    ACTIONS(353), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_POUND,
    ACTIONS(361), 1,
      sym_raw_text_expr,
  [4223] = 1,
    ACTIONS(427), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4229] = 1,
    ACTIONS(443), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4235] = 1,
    ACTIONS(263), 3,
      anon_sym_GT,
      aux_sym_attribute_name_token1,
      anon_sym_LBRACE,
  [4241] = 3,
    ACTIONS(41), 1,
      anon_sym_LT_SLASH,
    ACTIONS(455), 1,
      sym_raw_text,
    STATE(58), 1,
      sym_end_tag,
  [4251] = 3,
    ACTIONS(457), 1,
      sym__start_tag_name,
    ACTIONS(459), 1,
      sym__script_start_tag_name,
    ACTIONS(461), 1,
      sym__style_start_tag_name,
  [4261] = 3,
    ACTIONS(459), 1,
      sym__script_start_tag_name,
    ACTIONS(461), 1,
      sym__style_start_tag_name,
    ACTIONS(463), 1,
      sym__start_tag_name,
  [4271] = 1,
    ACTIONS(465), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [4276] = 2,
    ACTIONS(467), 1,
      anon_sym_then,
    ACTIONS(469), 1,
      anon_sym_catch,
  [4283] = 2,
    ACTIONS(471), 1,
      anon_sym_SQUOTE,
    ACTIONS(473), 1,
      aux_sym_quoted_attribute_value_token1,
  [4290] = 2,
    ACTIONS(475), 1,
      anon_sym_html,
    ACTIONS(477), 1,
      anon_sym_const,
  [4297] = 1,
    ACTIONS(479), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [4302] = 2,
    ACTIONS(57), 1,
      anon_sym_LT_SLASH,
    STATE(129), 1,
      sym_end_tag,
  [4309] = 2,
    ACTIONS(57), 1,
      anon_sym_LT_SLASH,
    STATE(130), 1,
      sym_end_tag,
  [4316] = 2,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(483), 1,
      sym_raw_text_expr,
  [4323] = 2,
    ACTIONS(485), 1,
      anon_sym_RBRACE,
    ACTIONS(487), 1,
      sym_raw_text_expr,
  [4330] = 2,
    ACTIONS(471), 1,
      anon_sym_DQUOTE,
    ACTIONS(489), 1,
      aux_sym_quoted_attribute_value_token2,
  [4337] = 2,
    ACTIONS(41), 1,
      anon_sym_LT_SLASH,
    STATE(84), 1,
      sym_end_tag,
  [4344] = 2,
    ACTIONS(41), 1,
      anon_sym_LT_SLASH,
    STATE(80), 1,
      sym_end_tag,
  [4351] = 2,
    ACTIONS(491), 1,
      anon_sym_RBRACE,
    ACTIONS(493), 1,
      sym_raw_text_expr,
  [4358] = 2,
    ACTIONS(495), 1,
      sym_raw_text_expr,
    ACTIONS(497), 1,
      sym_raw_text_await,
  [4365] = 2,
    ACTIONS(499), 1,
      sym_raw_text_expr,
    ACTIONS(501), 1,
      sym_raw_text_each,
  [4372] = 2,
    ACTIONS(503), 1,
      anon_sym_html,
    ACTIONS(505), 1,
      anon_sym_const,
  [4379] = 2,
    ACTIONS(507), 1,
      anon_sym_RBRACE,
    ACTIONS(509), 1,
      anon_sym_if,
  [4386] = 2,
    ACTIONS(511), 1,
      anon_sym_SQUOTE,
    ACTIONS(513), 1,
      aux_sym_quoted_attribute_value_token1,
  [4393] = 2,
    ACTIONS(511), 1,
      anon_sym_DQUOTE,
    ACTIONS(515), 1,
      aux_sym_quoted_attribute_value_token2,
  [4400] = 2,
    ACTIONS(517), 1,
      anon_sym_RBRACE,
    ACTIONS(519), 1,
      sym_raw_text_expr,
  [4407] = 2,
    ACTIONS(521), 1,
      anon_sym_RBRACE,
    ACTIONS(523), 1,
      sym_raw_text_expr,
  [4414] = 2,
    ACTIONS(525), 1,
      anon_sym_RBRACE,
    ACTIONS(527), 1,
      sym_raw_text_expr,
  [4421] = 2,
    ACTIONS(529), 1,
      anon_sym_RBRACE,
    ACTIONS(531), 1,
      sym_raw_text_expr,
  [4428] = 1,
    ACTIONS(533), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [4433] = 1,
    ACTIONS(535), 2,
      sym_raw_text,
      anon_sym_LT_SLASH,
  [4438] = 1,
    ACTIONS(537), 1,
      anon_sym_GT,
  [4442] = 1,
    ACTIONS(539), 1,
      sym_raw_text_expr,
  [4446] = 1,
    ACTIONS(541), 1,
      anon_sym_RBRACE,
  [4450] = 1,
    ACTIONS(543), 1,
      anon_sym_RBRACE,
  [4454] = 1,
    ACTIONS(545), 1,
      sym_raw_text_expr,
  [4458] = 1,
    ACTIONS(547), 1,
      sym_raw_text_expr,
  [4462] = 1,
    ACTIONS(549), 1,
      sym_raw_text_expr,
  [4466] = 1,
    ACTIONS(551), 1,
      anon_sym_else,
  [4470] = 1,
    ACTIONS(553), 1,
      anon_sym_if,
  [4474] = 1,
    ACTIONS(555), 1,
      anon_sym_else,
  [4478] = 1,
    ACTIONS(557), 1,
      anon_sym_each,
  [4482] = 1,
    ACTIONS(559), 1,
      anon_sym_await,
  [4486] = 1,
    ACTIONS(561), 1,
      anon_sym_key,
  [4490] = 1,
    ACTIONS(563), 1,
      anon_sym_RBRACE,
  [4494] = 1,
    ACTIONS(565), 1,
      sym__end_tag_name,
  [4498] = 1,
    ACTIONS(567), 1,
      anon_sym_RBRACE,
  [4502] = 1,
    ACTIONS(569), 1,
      anon_sym_RBRACE,
  [4506] = 1,
    ACTIONS(571), 1,
      anon_sym_RBRACE,
  [4510] = 1,
    ACTIONS(573), 1,
      anon_sym_GT,
  [4514] = 1,
    ACTIONS(575), 1,
      anon_sym_as,
  [4518] = 1,
    ACTIONS(577), 1,
      anon_sym_RBRACE,
  [4522] = 1,
    ACTIONS(579), 1,
      anon_sym_RBRACE,
  [4526] = 1,
    ACTIONS(581), 1,
      anon_sym_then,
  [4530] = 1,
    ACTIONS(583), 1,
      ts_builtin_sym_end,
  [4534] = 1,
    ACTIONS(585), 1,
      anon_sym_RBRACE,
  [4538] = 1,
    ACTIONS(587), 1,
      anon_sym_RBRACE,
  [4542] = 1,
    ACTIONS(589), 1,
      anon_sym_RBRACE,
  [4546] = 1,
    ACTIONS(591), 1,
      anon_sym_RBRACE,
  [4550] = 1,
    ACTIONS(593), 1,
      anon_sym_RBRACE,
  [4554] = 1,
    ACTIONS(595), 1,
      anon_sym_RBRACE,
  [4558] = 1,
    ACTIONS(597), 1,
      anon_sym_RBRACE,
  [4562] = 1,
    ACTIONS(599), 1,
      anon_sym_RBRACE,
  [4566] = 1,
    ACTIONS(507), 1,
      anon_sym_RBRACE,
  [4570] = 1,
    ACTIONS(601), 1,
      anon_sym_SQUOTE,
  [4574] = 1,
    ACTIONS(601), 1,
      anon_sym_DQUOTE,
  [4578] = 1,
    ACTIONS(603), 1,
      anon_sym_RBRACE,
  [4582] = 1,
    ACTIONS(605), 1,
      anon_sym_RBRACE,
  [4586] = 1,
    ACTIONS(607), 1,
      anon_sym_RBRACE,
  [4590] = 1,
    ACTIONS(609), 1,
      anon_sym_RBRACE,
  [4594] = 1,
    ACTIONS(469), 1,
      anon_sym_catch,
  [4598] = 1,
    ACTIONS(611), 1,
      sym__end_tag_name,
  [4602] = 1,
    ACTIONS(613), 1,
      sym_raw_text_expr,
  [4606] = 1,
    ACTIONS(615), 1,
      anon_sym_if,
  [4610] = 1,
    ACTIONS(617), 1,
      sym_raw_text_expr,
  [4614] = 1,
    ACTIONS(619), 1,
      anon_sym_each,
  [4618] = 1,
    ACTIONS(621), 1,
      anon_sym_RBRACE,
  [4622] = 1,
    ACTIONS(623), 1,
      anon_sym_await,
  [4626] = 1,
    ACTIONS(625), 1,
      anon_sym_RBRACE,
  [4630] = 1,
    ACTIONS(627), 1,
      anon_sym_RBRACE,
  [4634] = 1,
    ACTIONS(629), 1,
      anon_sym_key,
  [4638] = 1,
    ACTIONS(631), 1,
      anon_sym_DQUOTE,
  [4642] = 1,
    ACTIONS(631), 1,
      anon_sym_SQUOTE,
  [4646] = 1,
    ACTIONS(633), 1,
      anon_sym_RBRACE,
  [4650] = 1,
    ACTIONS(635), 1,
      anon_sym_RBRACE,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 64,
  [SMALL_STATE(4)] = 128,
  [SMALL_STATE(5)] = 192,
  [SMALL_STATE(6)] = 256,
  [SMALL_STATE(7)] = 320,
  [SMALL_STATE(8)] = 384,
  [SMALL_STATE(9)] = 448,
  [SMALL_STATE(10)] = 512,
  [SMALL_STATE(11)] = 576,
  [SMALL_STATE(12)] = 640,
  [SMALL_STATE(13)] = 704,
  [SMALL_STATE(14)] = 768,
  [SMALL_STATE(15)] = 828,
  [SMALL_STATE(16)] = 888,
  [SMALL_STATE(17)] = 950,
  [SMALL_STATE(18)] = 1010,
  [SMALL_STATE(19)] = 1072,
  [SMALL_STATE(20)] = 1132,
  [SMALL_STATE(21)] = 1194,
  [SMALL_STATE(22)] = 1256,
  [SMALL_STATE(23)] = 1316,
  [SMALL_STATE(24)] = 1376,
  [SMALL_STATE(25)] = 1436,
  [SMALL_STATE(26)] = 1496,
  [SMALL_STATE(27)] = 1553,
  [SMALL_STATE(28)] = 1609,
  [SMALL_STATE(29)] = 1665,
  [SMALL_STATE(30)] = 1721,
  [SMALL_STATE(31)] = 1777,
  [SMALL_STATE(32)] = 1833,
  [SMALL_STATE(33)] = 1889,
  [SMALL_STATE(34)] = 1945,
  [SMALL_STATE(35)] = 2001,
  [SMALL_STATE(36)] = 2057,
  [SMALL_STATE(37)] = 2113,
  [SMALL_STATE(38)] = 2169,
  [SMALL_STATE(39)] = 2225,
  [SMALL_STATE(40)] = 2281,
  [SMALL_STATE(41)] = 2337,
  [SMALL_STATE(42)] = 2393,
  [SMALL_STATE(43)] = 2449,
  [SMALL_STATE(44)] = 2505,
  [SMALL_STATE(45)] = 2561,
  [SMALL_STATE(46)] = 2584,
  [SMALL_STATE(47)] = 2605,
  [SMALL_STATE(48)] = 2628,
  [SMALL_STATE(49)] = 2649,
  [SMALL_STATE(50)] = 2672,
  [SMALL_STATE(51)] = 2693,
  [SMALL_STATE(52)] = 2716,
  [SMALL_STATE(53)] = 2728,
  [SMALL_STATE(54)] = 2748,
  [SMALL_STATE(55)] = 2760,
  [SMALL_STATE(56)] = 2772,
  [SMALL_STATE(57)] = 2792,
  [SMALL_STATE(58)] = 2812,
  [SMALL_STATE(59)] = 2824,
  [SMALL_STATE(60)] = 2836,
  [SMALL_STATE(61)] = 2848,
  [SMALL_STATE(62)] = 2860,
  [SMALL_STATE(63)] = 2872,
  [SMALL_STATE(64)] = 2884,
  [SMALL_STATE(65)] = 2896,
  [SMALL_STATE(66)] = 2908,
  [SMALL_STATE(67)] = 2928,
  [SMALL_STATE(68)] = 2940,
  [SMALL_STATE(69)] = 2952,
  [SMALL_STATE(70)] = 2964,
  [SMALL_STATE(71)] = 2976,
  [SMALL_STATE(72)] = 2988,
  [SMALL_STATE(73)] = 3000,
  [SMALL_STATE(74)] = 3012,
  [SMALL_STATE(75)] = 3024,
  [SMALL_STATE(76)] = 3036,
  [SMALL_STATE(77)] = 3048,
  [SMALL_STATE(78)] = 3060,
  [SMALL_STATE(79)] = 3072,
  [SMALL_STATE(80)] = 3084,
  [SMALL_STATE(81)] = 3096,
  [SMALL_STATE(82)] = 3108,
  [SMALL_STATE(83)] = 3120,
  [SMALL_STATE(84)] = 3132,
  [SMALL_STATE(85)] = 3144,
  [SMALL_STATE(86)] = 3156,
  [SMALL_STATE(87)] = 3176,
  [SMALL_STATE(88)] = 3188,
  [SMALL_STATE(89)] = 3200,
  [SMALL_STATE(90)] = 3212,
  [SMALL_STATE(91)] = 3224,
  [SMALL_STATE(92)] = 3236,
  [SMALL_STATE(93)] = 3248,
  [SMALL_STATE(94)] = 3260,
  [SMALL_STATE(95)] = 3272,
  [SMALL_STATE(96)] = 3284,
  [SMALL_STATE(97)] = 3295,
  [SMALL_STATE(98)] = 3306,
  [SMALL_STATE(99)] = 3317,
  [SMALL_STATE(100)] = 3328,
  [SMALL_STATE(101)] = 3339,
  [SMALL_STATE(102)] = 3350,
  [SMALL_STATE(103)] = 3361,
  [SMALL_STATE(104)] = 3372,
  [SMALL_STATE(105)] = 3383,
  [SMALL_STATE(106)] = 3394,
  [SMALL_STATE(107)] = 3405,
  [SMALL_STATE(108)] = 3416,
  [SMALL_STATE(109)] = 3427,
  [SMALL_STATE(110)] = 3438,
  [SMALL_STATE(111)] = 3449,
  [SMALL_STATE(112)] = 3460,
  [SMALL_STATE(113)] = 3471,
  [SMALL_STATE(114)] = 3482,
  [SMALL_STATE(115)] = 3493,
  [SMALL_STATE(116)] = 3504,
  [SMALL_STATE(117)] = 3515,
  [SMALL_STATE(118)] = 3526,
  [SMALL_STATE(119)] = 3537,
  [SMALL_STATE(120)] = 3548,
  [SMALL_STATE(121)] = 3559,
  [SMALL_STATE(122)] = 3570,
  [SMALL_STATE(123)] = 3581,
  [SMALL_STATE(124)] = 3592,
  [SMALL_STATE(125)] = 3603,
  [SMALL_STATE(126)] = 3614,
  [SMALL_STATE(127)] = 3625,
  [SMALL_STATE(128)] = 3636,
  [SMALL_STATE(129)] = 3647,
  [SMALL_STATE(130)] = 3658,
  [SMALL_STATE(131)] = 3669,
  [SMALL_STATE(132)] = 3680,
  [SMALL_STATE(133)] = 3691,
  [SMALL_STATE(134)] = 3701,
  [SMALL_STATE(135)] = 3711,
  [SMALL_STATE(136)] = 3721,
  [SMALL_STATE(137)] = 3731,
  [SMALL_STATE(138)] = 3739,
  [SMALL_STATE(139)] = 3755,
  [SMALL_STATE(140)] = 3771,
  [SMALL_STATE(141)] = 3787,
  [SMALL_STATE(142)] = 3797,
  [SMALL_STATE(143)] = 3813,
  [SMALL_STATE(144)] = 3823,
  [SMALL_STATE(145)] = 3839,
  [SMALL_STATE(146)] = 3855,
  [SMALL_STATE(147)] = 3865,
  [SMALL_STATE(148)] = 3881,
  [SMALL_STATE(149)] = 3891,
  [SMALL_STATE(150)] = 3907,
  [SMALL_STATE(151)] = 3917,
  [SMALL_STATE(152)] = 3927,
  [SMALL_STATE(153)] = 3937,
  [SMALL_STATE(154)] = 3947,
  [SMALL_STATE(155)] = 3957,
  [SMALL_STATE(156)] = 3967,
  [SMALL_STATE(157)] = 3980,
  [SMALL_STATE(158)] = 3993,
  [SMALL_STATE(159)] = 4006,
  [SMALL_STATE(160)] = 4019,
  [SMALL_STATE(161)] = 4032,
  [SMALL_STATE(162)] = 4039,
  [SMALL_STATE(163)] = 4046,
  [SMALL_STATE(164)] = 4059,
  [SMALL_STATE(165)] = 4066,
  [SMALL_STATE(166)] = 4079,
  [SMALL_STATE(167)] = 4092,
  [SMALL_STATE(168)] = 4099,
  [SMALL_STATE(169)] = 4106,
  [SMALL_STATE(170)] = 4113,
  [SMALL_STATE(171)] = 4122,
  [SMALL_STATE(172)] = 4135,
  [SMALL_STATE(173)] = 4142,
  [SMALL_STATE(174)] = 4149,
  [SMALL_STATE(175)] = 4159,
  [SMALL_STATE(176)] = 4165,
  [SMALL_STATE(177)] = 4175,
  [SMALL_STATE(178)] = 4185,
  [SMALL_STATE(179)] = 4191,
  [SMALL_STATE(180)] = 4197,
  [SMALL_STATE(181)] = 4203,
  [SMALL_STATE(182)] = 4213,
  [SMALL_STATE(183)] = 4223,
  [SMALL_STATE(184)] = 4229,
  [SMALL_STATE(185)] = 4235,
  [SMALL_STATE(186)] = 4241,
  [SMALL_STATE(187)] = 4251,
  [SMALL_STATE(188)] = 4261,
  [SMALL_STATE(189)] = 4271,
  [SMALL_STATE(190)] = 4276,
  [SMALL_STATE(191)] = 4283,
  [SMALL_STATE(192)] = 4290,
  [SMALL_STATE(193)] = 4297,
  [SMALL_STATE(194)] = 4302,
  [SMALL_STATE(195)] = 4309,
  [SMALL_STATE(196)] = 4316,
  [SMALL_STATE(197)] = 4323,
  [SMALL_STATE(198)] = 4330,
  [SMALL_STATE(199)] = 4337,
  [SMALL_STATE(200)] = 4344,
  [SMALL_STATE(201)] = 4351,
  [SMALL_STATE(202)] = 4358,
  [SMALL_STATE(203)] = 4365,
  [SMALL_STATE(204)] = 4372,
  [SMALL_STATE(205)] = 4379,
  [SMALL_STATE(206)] = 4386,
  [SMALL_STATE(207)] = 4393,
  [SMALL_STATE(208)] = 4400,
  [SMALL_STATE(209)] = 4407,
  [SMALL_STATE(210)] = 4414,
  [SMALL_STATE(211)] = 4421,
  [SMALL_STATE(212)] = 4428,
  [SMALL_STATE(213)] = 4433,
  [SMALL_STATE(214)] = 4438,
  [SMALL_STATE(215)] = 4442,
  [SMALL_STATE(216)] = 4446,
  [SMALL_STATE(217)] = 4450,
  [SMALL_STATE(218)] = 4454,
  [SMALL_STATE(219)] = 4458,
  [SMALL_STATE(220)] = 4462,
  [SMALL_STATE(221)] = 4466,
  [SMALL_STATE(222)] = 4470,
  [SMALL_STATE(223)] = 4474,
  [SMALL_STATE(224)] = 4478,
  [SMALL_STATE(225)] = 4482,
  [SMALL_STATE(226)] = 4486,
  [SMALL_STATE(227)] = 4490,
  [SMALL_STATE(228)] = 4494,
  [SMALL_STATE(229)] = 4498,
  [SMALL_STATE(230)] = 4502,
  [SMALL_STATE(231)] = 4506,
  [SMALL_STATE(232)] = 4510,
  [SMALL_STATE(233)] = 4514,
  [SMALL_STATE(234)] = 4518,
  [SMALL_STATE(235)] = 4522,
  [SMALL_STATE(236)] = 4526,
  [SMALL_STATE(237)] = 4530,
  [SMALL_STATE(238)] = 4534,
  [SMALL_STATE(239)] = 4538,
  [SMALL_STATE(240)] = 4542,
  [SMALL_STATE(241)] = 4546,
  [SMALL_STATE(242)] = 4550,
  [SMALL_STATE(243)] = 4554,
  [SMALL_STATE(244)] = 4558,
  [SMALL_STATE(245)] = 4562,
  [SMALL_STATE(246)] = 4566,
  [SMALL_STATE(247)] = 4570,
  [SMALL_STATE(248)] = 4574,
  [SMALL_STATE(249)] = 4578,
  [SMALL_STATE(250)] = 4582,
  [SMALL_STATE(251)] = 4586,
  [SMALL_STATE(252)] = 4590,
  [SMALL_STATE(253)] = 4594,
  [SMALL_STATE(254)] = 4598,
  [SMALL_STATE(255)] = 4602,
  [SMALL_STATE(256)] = 4606,
  [SMALL_STATE(257)] = 4610,
  [SMALL_STATE(258)] = 4614,
  [SMALL_STATE(259)] = 4618,
  [SMALL_STATE(260)] = 4622,
  [SMALL_STATE(261)] = 4626,
  [SMALL_STATE(262)] = 4630,
  [SMALL_STATE(263)] = 4634,
  [SMALL_STATE(264)] = 4638,
  [SMALL_STATE(265)] = 4642,
  [SMALL_STATE(266)] = 4646,
  [SMALL_STATE(267)] = 4650,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 0),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [71] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(187),
  [74] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2),
  [76] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(26),
  [79] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(174),
  [82] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [84] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [86] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [88] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [90] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [92] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [94] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [96] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 1),
  [98] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(188),
  [119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(44),
  [122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(182),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2),
  [145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2), SHIFT_REPEAT(137),
  [148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2), SHIFT_REPEAT(220),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then_statement, 2),
  [165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then_statement, 2),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_start_tag, 3),
  [173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_start_tag, 3),
  [175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 2),
  [177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 2),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 2),
  [185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 2),
  [187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_key_end_expr, 4),
  [189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_end_expr, 4),
  [191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_end_expr, 4),
  [193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_end_expr, 4),
  [195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each_end_expr, 4),
  [197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each_end_expr, 4),
  [199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_end_expr, 4),
  [201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_end_expr, 4),
  [203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_expr, 5),
  [205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_expr, 5),
  [207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 2),
  [209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 2),
  [211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 1),
  [213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 1),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_expr, 5),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_expr, 5),
  [221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_statement, 3),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_statement, 3),
  [225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then_statement, 3),
  [227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then_statement, 3),
  [229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each_statement, 2),
  [231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each_statement, 2),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_statement, 2),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_statement, 2),
  [237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_key_statement, 2),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_statement, 2),
  [241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_statement, 2),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_statement, 2),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_tag, 3),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_tag, 3),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_each_statement, 3),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_each_statement, 3),
  [253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_statement, 3),
  [255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_statement, 3),
  [257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_statement, 3),
  [259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_statement, 3),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 3),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 3),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 3),
  [267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 3),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 3),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 3),
  [273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_tag, 3),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_tag, 3),
  [277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_expr, 4),
  [279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_expr, 4),
  [281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_expr, 4),
  [283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_expr, 4),
  [285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 3),
  [287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 3),
  [289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_statement, 2),
  [291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_statement, 2),
  [293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2), SHIFT_REPEAT(169),
  [296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_start_tag_repeat1, 2), SHIFT_REPEAT(255),
  [299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_statement, 2),
  [301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_statement, 2),
  [303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3),
  [305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3),
  [307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_each_statement, 2),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_each_statement, 2),
  [311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_tag, 4),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_tag, 4),
  [315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each_statement, 3),
  [317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each_statement, 3),
  [319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 2),
  [321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 2),
  [323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_start_tag, 4),
  [325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_start_tag, 4),
  [327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_key_statement, 3),
  [329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_statement, 3),
  [331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_statement, 3),
  [333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_statement, 3),
  [335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_start_expr, 5),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_key_start_expr, 5),
  [339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each_start_expr, 7),
  [341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each_start_expr, 7),
  [343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_expr, 4),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_expr, 4),
  [351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_name, 1),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then_expr, 4),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then_expr, 4),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_expr, 4),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_expr, 4),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_start_expr, 7, .production_id = 2),
  [387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_start_expr, 7, .production_id = 2),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_expr, 6),
  [393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_expr, 6),
  [395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_start_expr, 5),
  [397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_start_expr, 5),
  [399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_start_expr, 5),
  [401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_start_expr, 5),
  [403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_expr, 5),
  [405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_expr, 5),
  [407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then_expr, 5),
  [409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then_expr, 5),
  [411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_expr, 5),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_expr, 5),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each_start_expr, 5),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_each_start_expr, 5),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_attribute_value, 3),
  [429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_value, 1),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr_attribute_value, 1),
  [435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_attribute_value, 2),
  [437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, .production_id = 1),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_start_tag, 4),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_start_tag, 4),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_start_tag, 3),
  [535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_start_tag, 3),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [583] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_svelte_external_scanner_create(void);
void tree_sitter_svelte_external_scanner_destroy(void *);
bool tree_sitter_svelte_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_svelte_external_scanner_serialize(void *, char *);
void tree_sitter_svelte_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_svelte(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_svelte_external_scanner_create,
      tree_sitter_svelte_external_scanner_destroy,
      tree_sitter_svelte_external_scanner_scan,
      tree_sitter_svelte_external_scanner_serialize,
      tree_sitter_svelte_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
