#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 4345
#define LARGE_STATE_COUNT 995
#define SYMBOL_COUNT 368
#define ALIAS_COUNT 6
#define TOKEN_COUNT 161
#define EXTERNAL_TOKEN_COUNT 5
#define FIELD_COUNT 43
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 284

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_type = 6,
  anon_sym_EQ = 7,
  anon_sym_as = 8,
  anon_sym_namespace = 9,
  anon_sym_LBRACE = 10,
  anon_sym_COMMA = 11,
  anon_sym_RBRACE = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_BANG = 19,
  anon_sym_else = 20,
  anon_sym_if = 21,
  anon_sym_switch = 22,
  anon_sym_for = 23,
  anon_sym_LPAREN = 24,
  anon_sym_RPAREN = 25,
  anon_sym_await = 26,
  anon_sym_in = 27,
  anon_sym_of = 28,
  anon_sym_while = 29,
  anon_sym_do = 30,
  anon_sym_try = 31,
  anon_sym_with = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  sym__glimmer_template_content = 46,
  anon_sym_LTtemplate_GT = 47,
  anon_sym_LT_SLASHtemplate_GT = 48,
  anon_sym_GT = 49,
  anon_sym_DOT = 50,
  anon_sym_class = 51,
  anon_sym_async = 52,
  anon_sym_function = 53,
  anon_sym_EQ_GT = 54,
  anon_sym_QMARK_DOT = 55,
  anon_sym_new = 56,
  anon_sym_PLUS_EQ = 57,
  anon_sym_DASH_EQ = 58,
  anon_sym_STAR_EQ = 59,
  anon_sym_SLASH_EQ = 60,
  anon_sym_PERCENT_EQ = 61,
  anon_sym_CARET_EQ = 62,
  anon_sym_AMP_EQ = 63,
  anon_sym_PIPE_EQ = 64,
  anon_sym_GT_GT_EQ = 65,
  anon_sym_GT_GT_GT_EQ = 66,
  anon_sym_LT_LT_EQ = 67,
  anon_sym_STAR_STAR_EQ = 68,
  anon_sym_AMP_AMP_EQ = 69,
  anon_sym_PIPE_PIPE_EQ = 70,
  anon_sym_QMARK_QMARK_EQ = 71,
  anon_sym_DOT_DOT_DOT = 72,
  anon_sym_AMP_AMP = 73,
  anon_sym_PIPE_PIPE = 74,
  anon_sym_GT_GT = 75,
  anon_sym_GT_GT_GT = 76,
  anon_sym_LT_LT = 77,
  anon_sym_AMP = 78,
  anon_sym_CARET = 79,
  anon_sym_PIPE = 80,
  anon_sym_PLUS = 81,
  anon_sym_DASH = 82,
  anon_sym_SLASH = 83,
  anon_sym_PERCENT = 84,
  anon_sym_STAR_STAR = 85,
  anon_sym_LT = 86,
  anon_sym_LT_EQ = 87,
  anon_sym_EQ_EQ = 88,
  anon_sym_EQ_EQ_EQ = 89,
  anon_sym_BANG_EQ = 90,
  anon_sym_BANG_EQ_EQ = 91,
  anon_sym_GT_EQ = 92,
  anon_sym_QMARK_QMARK = 93,
  anon_sym_instanceof = 94,
  anon_sym_TILDE = 95,
  anon_sym_void = 96,
  anon_sym_delete = 97,
  anon_sym_PLUS_PLUS = 98,
  anon_sym_DASH_DASH = 99,
  anon_sym_DQUOTE = 100,
  anon_sym_SQUOTE = 101,
  sym_unescaped_double_string_fragment = 102,
  sym_unescaped_single_string_fragment = 103,
  sym_escape_sequence = 104,
  sym_comment = 105,
  anon_sym_BQUOTE = 106,
  anon_sym_DOLLAR_LBRACE = 107,
  anon_sym_SLASH2 = 108,
  sym_regex_pattern = 109,
  sym_regex_flags = 110,
  sym_number = 111,
  sym_private_property_identifier = 112,
  anon_sym_target = 113,
  sym_this = 114,
  sym_super = 115,
  sym_true = 116,
  sym_false = 117,
  sym_null = 118,
  sym_undefined = 119,
  anon_sym_AT = 120,
  anon_sym_static = 121,
  anon_sym_readonly = 122,
  anon_sym_get = 123,
  anon_sym_set = 124,
  anon_sym_QMARK = 125,
  anon_sym_declare = 126,
  anon_sym_public = 127,
  anon_sym_private = 128,
  anon_sym_protected = 129,
  anon_sym_override = 130,
  anon_sym_module = 131,
  anon_sym_any = 132,
  anon_sym_number = 133,
  anon_sym_boolean = 134,
  anon_sym_string = 135,
  anon_sym_symbol = 136,
  anon_sym_abstract = 137,
  anon_sym_satisfies = 138,
  anon_sym_require = 139,
  anon_sym_extends = 140,
  anon_sym_implements = 141,
  anon_sym_global = 142,
  anon_sym_interface = 143,
  anon_sym_enum = 144,
  anon_sym_DASH_QMARK_COLON = 145,
  anon_sym_QMARK_COLON = 146,
  anon_sym_asserts = 147,
  anon_sym_infer = 148,
  anon_sym_is = 149,
  anon_sym_keyof = 150,
  anon_sym_unique = 151,
  anon_sym_unknown = 152,
  anon_sym_never = 153,
  anon_sym_object = 154,
  anon_sym_LBRACE_PIPE = 155,
  anon_sym_PIPE_RBRACE = 156,
  sym__automatic_semicolon = 157,
  sym__template_chars = 158,
  sym__ternary_qmark = 159,
  sym__function_signature_automatic_semicolon = 160,
  sym_program = 161,
  sym_export_statement = 162,
  sym_namespace_export = 163,
  sym_export_clause = 164,
  sym_export_specifier = 165,
  sym__module_export_name = 166,
  sym_declaration = 167,
  sym_import = 168,
  sym_import_statement = 169,
  sym_import_clause = 170,
  sym__from_clause = 171,
  sym_namespace_import = 172,
  sym_named_imports = 173,
  sym_import_specifier = 174,
  sym_expression_statement = 175,
  sym_variable_declaration = 176,
  sym_lexical_declaration = 177,
  sym_variable_declarator = 178,
  sym_statement_block = 179,
  sym_else_clause = 180,
  sym_if_statement = 181,
  sym_switch_statement = 182,
  sym_for_statement = 183,
  sym_for_in_statement = 184,
  sym__for_header = 185,
  sym_while_statement = 186,
  sym_do_statement = 187,
  sym_try_statement = 188,
  sym_with_statement = 189,
  sym_break_statement = 190,
  sym_continue_statement = 191,
  sym_debugger_statement = 192,
  sym_return_statement = 193,
  sym_throw_statement = 194,
  sym_empty_statement = 195,
  sym_labeled_statement = 196,
  sym_switch_body = 197,
  sym_switch_case = 198,
  sym_switch_default = 199,
  sym_catch_clause = 200,
  sym_finally_clause = 201,
  sym_parenthesized_expression = 202,
  sym_expression = 203,
  sym_primary_expression = 204,
  sym_yield_expression = 205,
  sym_object = 206,
  sym_object_pattern = 207,
  sym_assignment_pattern = 208,
  sym_object_assignment_pattern = 209,
  sym_array = 210,
  sym_array_pattern = 211,
  sym_glimmer_template = 212,
  sym_glimmer_opening_tag = 213,
  sym_glimmer_closing_tag = 214,
  sym_nested_identifier = 215,
  sym_class = 216,
  sym_class_declaration = 217,
  sym_class_heritage = 218,
  sym_function = 219,
  sym_function_declaration = 220,
  sym_generator_function = 221,
  sym_generator_function_declaration = 222,
  sym_arrow_function = 223,
  sym__call_signature = 224,
  sym__formal_parameter = 225,
  sym_optional_chain = 226,
  sym_call_expression = 227,
  sym_new_expression = 228,
  sym_await_expression = 229,
  sym_member_expression = 230,
  sym_subscript_expression = 231,
  sym_assignment_expression = 232,
  sym__augmented_assignment_lhs = 233,
  sym_augmented_assignment_expression = 234,
  sym__initializer = 235,
  sym__destructuring_pattern = 236,
  sym_spread_element = 237,
  sym_ternary_expression = 238,
  sym_binary_expression = 239,
  sym_unary_expression = 240,
  sym_update_expression = 241,
  sym_sequence_expression = 242,
  sym_string = 243,
  sym_template_string = 244,
  sym_template_substitution = 245,
  sym_regex = 246,
  sym_meta_property = 247,
  sym_arguments = 248,
  sym_decorator = 249,
  sym_decorator_member_expression = 250,
  sym_decorator_call_expression = 251,
  sym_class_body = 252,
  sym_formal_parameters = 253,
  sym_class_static_block = 254,
  sym_pattern = 255,
  sym_rest_pattern = 256,
  sym_method_definition = 257,
  sym_pair = 258,
  sym_pair_pattern = 259,
  sym__property_name = 260,
  sym_computed_property_name = 261,
  sym_public_field_definition = 262,
  sym__import_identifier = 263,
  sym_non_null_expression = 264,
  sym_method_signature = 265,
  sym_abstract_method_signature = 266,
  sym_function_signature = 267,
  sym_type_assertion = 268,
  sym_as_expression = 269,
  sym_satisfies_expression = 270,
  sym_instantiation_expression = 271,
  sym_import_require_clause = 272,
  sym_extends_clause = 273,
  sym__extends_clause_single = 274,
  sym_implements_clause = 275,
  sym_ambient_declaration = 276,
  sym_abstract_class_declaration = 277,
  sym_module = 278,
  sym_internal_module = 279,
  sym__module = 280,
  sym_import_alias = 281,
  sym_nested_type_identifier = 282,
  sym_interface_declaration = 283,
  sym_extends_type_clause = 284,
  sym_enum_declaration = 285,
  sym_enum_body = 286,
  sym_enum_assignment = 287,
  sym_type_alias_declaration = 288,
  sym_accessibility_modifier = 289,
  sym_override_modifier = 290,
  sym_required_parameter = 291,
  sym_optional_parameter = 292,
  sym__parameter_name = 293,
  sym_omitting_type_annotation = 294,
  sym_opting_type_annotation = 295,
  sym_type_annotation = 296,
  sym_asserts = 297,
  sym_asserts_annotation = 298,
  sym__type = 299,
  sym_tuple_parameter = 300,
  sym_optional_tuple_parameter = 301,
  sym_optional_type = 302,
  sym_rest_type = 303,
  sym__tuple_type_member = 304,
  sym_constructor_type = 305,
  sym__primary_type = 306,
  sym_template_type = 307,
  sym_template_literal_type = 308,
  sym_infer_type = 309,
  sym_conditional_type = 310,
  sym_generic_type = 311,
  sym_type_predicate = 312,
  sym_type_predicate_annotation = 313,
  sym__type_query_member_expression = 314,
  sym__type_query_subscript_expression = 315,
  sym__type_query_call_expression = 316,
  sym__type_query_instantiation_expression = 317,
  sym_type_query = 318,
  sym_index_type_query = 319,
  sym_lookup_type = 320,
  sym_mapped_type_clause = 321,
  sym_literal_type = 322,
  sym__number = 323,
  sym_existential_type = 324,
  sym_flow_maybe_type = 325,
  sym_parenthesized_type = 326,
  sym_predefined_type = 327,
  sym_type_arguments = 328,
  sym_object_type = 329,
  sym_call_signature = 330,
  sym_property_signature = 331,
  sym_type_parameters = 332,
  sym_type_parameter = 333,
  sym_default_type = 334,
  sym_constraint = 335,
  sym_construct_signature = 336,
  sym_index_signature = 337,
  sym_array_type = 338,
  sym_tuple_type = 339,
  sym_readonly_type = 340,
  sym_union_type = 341,
  sym_intersection_type = 342,
  sym_function_type = 343,
  aux_sym_program_repeat1 = 344,
  aux_sym_export_statement_repeat1 = 345,
  aux_sym_export_clause_repeat1 = 346,
  aux_sym_named_imports_repeat1 = 347,
  aux_sym_variable_declaration_repeat1 = 348,
  aux_sym_switch_body_repeat1 = 349,
  aux_sym_object_repeat1 = 350,
  aux_sym_object_pattern_repeat1 = 351,
  aux_sym_array_repeat1 = 352,
  aux_sym_array_pattern_repeat1 = 353,
  aux_sym_glimmer_template_repeat1 = 354,
  aux_sym_string_repeat1 = 355,
  aux_sym_string_repeat2 = 356,
  aux_sym_template_string_repeat1 = 357,
  aux_sym_class_body_repeat1 = 358,
  aux_sym_formal_parameters_repeat1 = 359,
  aux_sym_extends_clause_repeat1 = 360,
  aux_sym_implements_clause_repeat1 = 361,
  aux_sym_extends_type_clause_repeat1 = 362,
  aux_sym_enum_body_repeat1 = 363,
  aux_sym_template_literal_type_repeat1 = 364,
  aux_sym_object_type_repeat1 = 365,
  aux_sym_type_parameters_repeat1 = 366,
  aux_sym_tuple_type_repeat1 = 367,
  alias_sym_property_identifier = 368,
  alias_sym_shorthand_property_identifier = 369,
  alias_sym_shorthand_property_identifier_pattern = 370,
  alias_sym_statement_identifier = 371,
  alias_sym_this_type = 372,
  alias_sym_type_identifier = 373,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym__glimmer_template_content] = "_glimmer_template_content",
  [anon_sym_LTtemplate_GT] = "<template>",
  [anon_sym_LT_SLASHtemplate_GT] = "</template>",
  [anon_sym_GT] = ">",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_private_property_identifier] = "private_property_identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_override] = "override",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_abstract] = "abstract",
  [anon_sym_satisfies] = "satisfies",
  [anon_sym_require] = "require",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_unique] = "unique symbol",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_object] = "object",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym__ternary_qmark] = "\?",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_namespace_export] = "namespace_export",
  [sym_export_clause] = "export_clause",
  [sym_export_specifier] = "export_specifier",
  [sym__module_export_name] = "_module_export_name",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_import_specifier] = "import_specifier",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_glimmer_template] = "glimmer_template",
  [sym_glimmer_opening_tag] = "glimmer_opening_tag",
  [sym_glimmer_closing_tag] = "glimmer_closing_tag",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_optional_chain] = "optional_chain",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_formal_parameters] = "formal_parameters",
  [sym_class_static_block] = "class_static_block",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_public_field_definition] = "public_field_definition",
  [sym__import_identifier] = "_import_identifier",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_satisfies_expression] = "satisfies_expression",
  [sym_instantiation_expression] = "instantiation_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_extends_clause] = "extends_clause",
  [sym__extends_clause_single] = "_extends_clause_single",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_type_clause] = "extends_type_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_override_modifier] = "override_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_asserts] = "asserts",
  [sym_asserts_annotation] = "asserts_annotation",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_template_type] = "template_type",
  [sym_template_literal_type] = "template_literal_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym__type_query_member_expression] = "member_expression",
  [sym__type_query_subscript_expression] = "subscript_expression",
  [sym__type_query_call_expression] = "call_expression",
  [sym__type_query_instantiation_expression] = "instantiation_expression",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_glimmer_template_repeat1] = "glimmer_template_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_type_clause_repeat1] = "extends_type_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_template_literal_type_repeat1] = "template_literal_type_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_this_type] = "this_type",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym__glimmer_template_content] = sym__glimmer_template_content,
  [anon_sym_LTtemplate_GT] = anon_sym_LTtemplate_GT,
  [anon_sym_LT_SLASHtemplate_GT] = anon_sym_LT_SLASHtemplate_GT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_unescaped_double_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_unescaped_single_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [sym_private_property_identifier] = sym_private_property_identifier,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_satisfies] = anon_sym_satisfies,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_unique] = anon_sym_unique,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__ternary_qmark] = anon_sym_QMARK,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_namespace_export] = sym_namespace_export,
  [sym_export_clause] = sym_export_clause,
  [sym_export_specifier] = sym_export_specifier,
  [sym__module_export_name] = sym__module_export_name,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_import_specifier] = sym_import_specifier,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_glimmer_template] = sym_glimmer_template,
  [sym_glimmer_opening_tag] = sym_glimmer_opening_tag,
  [sym_glimmer_closing_tag] = sym_glimmer_closing_tag,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_optional_chain] = sym_optional_chain,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_class_static_block] = sym_class_static_block,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym__import_identifier] = sym__import_identifier,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_satisfies_expression] = sym_satisfies_expression,
  [sym_instantiation_expression] = sym_instantiation_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_extends_clause] = sym_extends_clause,
  [sym__extends_clause_single] = sym__extends_clause_single,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_type_clause] = sym_extends_type_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_override_modifier] = sym_override_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_asserts] = sym_asserts,
  [sym_asserts_annotation] = sym_asserts_annotation,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_template_type] = sym_template_type,
  [sym_template_literal_type] = sym_template_literal_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym__type_query_member_expression] = sym_member_expression,
  [sym__type_query_subscript_expression] = sym_subscript_expression,
  [sym__type_query_call_expression] = sym_call_expression,
  [sym__type_query_instantiation_expression] = sym_instantiation_expression,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_glimmer_template_repeat1] = aux_sym_glimmer_template_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_type_clause_repeat1] = aux_sym_extends_type_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_template_literal_type_repeat1] = aux_sym_template_literal_type_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_this_type] = alias_sym_this_type,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym__glimmer_template_content] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LTtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASHtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_private_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_satisfies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unique] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym__ternary_qmark] = {
    .visible = true,
    .named = false,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_export] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__module_export_name] = {
    .visible = false,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_template] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_opening_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_chain] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_class_static_block] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__import_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_satisfies_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_instantiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__extends_clause_single] = {
    .visible = false,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_override_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_instantiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_glimmer_template_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_type_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_close_tag = 6,
  field_condition = 7,
  field_consequence = 8,
  field_constraint = 9,
  field_constructor = 10,
  field_content = 11,
  field_declaration = 12,
  field_decorator = 13,
  field_finalizer = 14,
  field_flags = 15,
  field_function = 16,
  field_handler = 17,
  field_increment = 18,
  field_index = 19,
  field_index_type = 20,
  field_initializer = 21,
  field_key = 22,
  field_kind = 23,
  field_label = 24,
  field_left = 25,
  field_module = 26,
  field_name = 27,
  field_object = 28,
  field_open_tag = 29,
  field_operator = 30,
  field_optional_chain = 31,
  field_parameter = 32,
  field_parameters = 33,
  field_pattern = 34,
  field_property = 35,
  field_return_type = 36,
  field_right = 37,
  field_sign = 38,
  field_source = 39,
  field_type = 40,
  field_type_arguments = 41,
  field_type_parameters = 42,
  field_value = 43,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_content] = "content",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_index_type] = "index_type",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_optional_chain] = "optional_chain",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 1},
  [12] = {.index = 12, .length = 1},
  [14] = {.index = 3, .length = 1},
  [16] = {.index = 13, .length = 2},
  [17] = {.index = 15, .length = 2},
  [18] = {.index = 17, .length = 2},
  [19] = {.index = 19, .length = 1},
  [20] = {.index = 20, .length = 2},
  [21] = {.index = 22, .length = 2},
  [22] = {.index = 24, .length = 2},
  [23] = {.index = 26, .length = 2},
  [24] = {.index = 28, .length = 1},
  [25] = {.index = 29, .length = 2},
  [26] = {.index = 31, .length = 2},
  [27] = {.index = 33, .length = 2},
  [28] = {.index = 35, .length = 2},
  [32] = {.index = 37, .length = 1},
  [33] = {.index = 38, .length = 2},
  [34] = {.index = 40, .length = 2},
  [35] = {.index = 42, .length = 1},
  [36] = {.index = 43, .length = 2},
  [37] = {.index = 45, .length = 2},
  [38] = {.index = 47, .length = 6},
  [39] = {.index = 53, .length = 1},
  [40] = {.index = 54, .length = 3},
  [41] = {.index = 57, .length = 3},
  [42] = {.index = 60, .length = 2},
  [43] = {.index = 62, .length = 2},
  [44] = {.index = 64, .length = 2},
  [45] = {.index = 66, .length = 2},
  [46] = {.index = 68, .length = 2},
  [47] = {.index = 70, .length = 1},
  [48] = {.index = 71, .length = 2},
  [49] = {.index = 73, .length = 1},
  [50] = {.index = 74, .length = 2},
  [51] = {.index = 76, .length = 1},
  [52] = {.index = 77, .length = 2},
  [53] = {.index = 79, .length = 4},
  [54] = {.index = 83, .length = 2},
  [55] = {.index = 85, .length = 2},
  [56] = {.index = 87, .length = 3},
  [57] = {.index = 90, .length = 2},
  [58] = {.index = 92, .length = 2},
  [59] = {.index = 94, .length = 2},
  [60] = {.index = 96, .length = 2},
  [61] = {.index = 98, .length = 1},
  [62] = {.index = 99, .length = 2},
  [63] = {.index = 101, .length = 2},
  [64] = {.index = 103, .length = 2},
  [67] = {.index = 99, .length = 2},
  [68] = {.index = 29, .length = 2},
  [69] = {.index = 33, .length = 2},
  [70] = {.index = 71, .length = 2},
  [71] = {.index = 105, .length = 3},
  [72] = {.index = 108, .length = 2},
  [73] = {.index = 108, .length = 2},
  [74] = {.index = 110, .length = 3},
  [75] = {.index = 110, .length = 3},
  [76] = {.index = 113, .length = 3},
  [77] = {.index = 116, .length = 2},
  [78] = {.index = 118, .length = 3},
  [79] = {.index = 121, .length = 4},
  [80] = {.index = 125, .length = 3},
  [81] = {.index = 128, .length = 2},
  [82] = {.index = 130, .length = 2},
  [83] = {.index = 132, .length = 1},
  [84] = {.index = 133, .length = 1},
  [85] = {.index = 98, .length = 1},
  [88] = {.index = 29, .length = 2},
  [89] = {.index = 134, .length = 2},
  [90] = {.index = 136, .length = 5},
  [91] = {.index = 141, .length = 1},
  [92] = {.index = 142, .length = 1},
  [93] = {.index = 143, .length = 2},
  [94] = {.index = 145, .length = 3},
  [95] = {.index = 148, .length = 2},
  [96] = {.index = 150, .length = 3},
  [97] = {.index = 153, .length = 6},
  [98] = {.index = 159, .length = 1},
  [99] = {.index = 160, .length = 1},
  [100] = {.index = 161, .length = 3},
  [101] = {.index = 164, .length = 3},
  [102] = {.index = 167, .length = 4},
  [103] = {.index = 171, .length = 2},
  [104] = {.index = 173, .length = 3},
  [105] = {.index = 176, .length = 4},
  [106] = {.index = 180, .length = 2},
  [107] = {.index = 182, .length = 3},
  [108] = {.index = 185, .length = 2},
  [109] = {.index = 187, .length = 4},
  [110] = {.index = 191, .length = 2},
  [111] = {.index = 193, .length = 2},
  [112] = {.index = 195, .length = 4},
  [113] = {.index = 193, .length = 2},
  [114] = {.index = 199, .length = 4},
  [115] = {.index = 203, .length = 4},
  [116] = {.index = 207, .length = 5},
  [117] = {.index = 212, .length = 3},
  [118] = {.index = 215, .length = 2},
  [119] = {.index = 217, .length = 1},
  [120] = {.index = 218, .length = 2},
  [121] = {.index = 220, .length = 4},
  [122] = {.index = 224, .length = 4},
  [123] = {.index = 228, .length = 4},
  [124] = {.index = 232, .length = 4},
  [125] = {.index = 236, .length = 2},
  [126] = {.index = 238, .length = 2},
  [127] = {.index = 240, .length = 2},
  [128] = {.index = 242, .length = 3},
  [129] = {.index = 245, .length = 2},
  [130] = {.index = 148, .length = 2},
  [131] = {.index = 247, .length = 1},
  [132] = {.index = 247, .length = 1},
  [133] = {.index = 248, .length = 2},
  [134] = {.index = 250, .length = 3},
  [135] = {.index = 253, .length = 2},
  [136] = {.index = 255, .length = 3},
  [137] = {.index = 258, .length = 2},
  [138] = {.index = 260, .length = 3},
  [139] = {.index = 263, .length = 1},
  [140] = {.index = 264, .length = 2},
  [141] = {.index = 266, .length = 2},
  [142] = {.index = 268, .length = 5},
  [143] = {.index = 264, .length = 2},
  [144] = {.index = 273, .length = 1},
  [145] = {.index = 274, .length = 4},
  [146] = {.index = 278, .length = 2},
  [147] = {.index = 280, .length = 2},
  [148] = {.index = 282, .length = 1},
  [149] = {.index = 283, .length = 2},
  [150] = {.index = 285, .length = 2},
  [151] = {.index = 287, .length = 2},
  [152] = {.index = 289, .length = 4},
  [153] = {.index = 293, .length = 3},
  [154] = {.index = 296, .length = 4},
  [155] = {.index = 300, .length = 4},
  [156] = {.index = 304, .length = 4},
  [157] = {.index = 308, .length = 5},
  [158] = {.index = 313, .length = 2},
  [159] = {.index = 315, .length = 2},
  [160] = {.index = 317, .length = 1},
  [161] = {.index = 318, .length = 4},
  [162] = {.index = 318, .length = 4},
  [163] = {.index = 322, .length = 4},
  [164] = {.index = 322, .length = 4},
  [165] = {.index = 326, .length = 4},
  [166] = {.index = 326, .length = 4},
  [167] = {.index = 330, .length = 3},
  [168] = {.index = 333, .length = 2},
  [169] = {.index = 335, .length = 3},
  [170] = {.index = 338, .length = 2},
  [171] = {.index = 340, .length = 3},
  [172] = {.index = 343, .length = 2},
  [173] = {.index = 343, .length = 2},
  [174] = {.index = 345, .length = 3},
  [175] = {.index = 348, .length = 3},
  [176] = {.index = 143, .length = 2},
  [177] = {.index = 351, .length = 2},
  [178] = {.index = 353, .length = 3},
  [179] = {.index = 356, .length = 4},
  [180] = {.index = 360, .length = 3},
  [181] = {.index = 363, .length = 3},
  [182] = {.index = 366, .length = 2},
  [183] = {.index = 368, .length = 3},
  [184] = {.index = 371, .length = 5},
  [185] = {.index = 366, .length = 2},
  [186] = {.index = 376, .length = 3},
  [187] = {.index = 376, .length = 3},
  [188] = {.index = 379, .length = 3},
  [189] = {.index = 382, .length = 2},
  [190] = {.index = 384, .length = 4},
  [191] = {.index = 143, .length = 2},
  [192] = {.index = 388, .length = 1},
  [193] = {.index = 389, .length = 2},
  [194] = {.index = 391, .length = 2},
  [195] = {.index = 393, .length = 2},
  [196] = {.index = 395, .length = 2},
  [197] = {.index = 397, .length = 3},
  [198] = {.index = 400, .length = 1},
  [199] = {.index = 401, .length = 3},
  [200] = {.index = 404, .length = 5},
  [201] = {.index = 409, .length = 3},
  [202] = {.index = 412, .length = 2},
  [203] = {.index = 414, .length = 2},
  [204] = {.index = 416, .length = 4},
  [205] = {.index = 420, .length = 4},
  [206] = {.index = 424, .length = 4},
  [207] = {.index = 428, .length = 3},
  [208] = {.index = 431, .length = 2},
  [209] = {.index = 433, .length = 3},
  [210] = {.index = 436, .length = 2},
  [211] = {.index = 438, .length = 2},
  [212] = {.index = 440, .length = 2},
  [213] = {.index = 442, .length = 1},
  [214] = {.index = 443, .length = 4},
  [215] = {.index = 447, .length = 3},
  [216] = {.index = 450, .length = 4},
  [217] = {.index = 454, .length = 5},
  [218] = {.index = 459, .length = 1},
  [219] = {.index = 460, .length = 2},
  [220] = {.index = 462, .length = 4},
  [221] = {.index = 466, .length = 4},
  [222] = {.index = 470, .length = 2},
  [223] = {.index = 472, .length = 4},
  [224] = {.index = 476, .length = 4},
  [225] = {.index = 480, .length = 2},
  [226] = {.index = 482, .length = 2},
  [227] = {.index = 484, .length = 3},
  [228] = {.index = 487, .length = 3},
  [229] = {.index = 490, .length = 2},
  [230] = {.index = 492, .length = 2},
  [231] = {.index = 494, .length = 1},
  [232] = {.index = 495, .length = 1},
  [233] = {.index = 496, .length = 3},
  [234] = {.index = 499, .length = 2},
  [235] = {.index = 501, .length = 4},
  [236] = {.index = 505, .length = 4},
  [237] = {.index = 509, .length = 4},
  [238] = {.index = 513, .length = 3},
  [240] = {.index = 516, .length = 4},
  [241] = {.index = 520, .length = 5},
  [242] = {.index = 525, .length = 5},
  [243] = {.index = 530, .length = 5},
  [244] = {.index = 535, .length = 3},
  [245] = {.index = 538, .length = 3},
  [246] = {.index = 541, .length = 3},
  [247] = {.index = 538, .length = 3},
  [248] = {.index = 544, .length = 2},
  [249] = {.index = 546, .length = 4},
  [250] = {.index = 550, .length = 4},
  [251] = {.index = 554, .length = 3},
  [252] = {.index = 557, .length = 2},
  [253] = {.index = 559, .length = 2},
  [254] = {.index = 561, .length = 3},
  [255] = {.index = 564, .length = 2},
  [256] = {.index = 566, .length = 2},
  [257] = {.index = 568, .length = 1},
  [258] = {.index = 569, .length = 4},
  [259] = {.index = 573, .length = 5},
  [260] = {.index = 578, .length = 5},
  [261] = {.index = 583, .length = 4},
  [262] = {.index = 587, .length = 4},
  [263] = {.index = 591, .length = 3},
  [264] = {.index = 594, .length = 3},
  [265] = {.index = 594, .length = 3},
  [266] = {.index = 597, .length = 2},
  [267] = {.index = 599, .length = 2},
  [268] = {.index = 601, .length = 3},
  [269] = {.index = 604, .length = 2},
  [270] = {.index = 606, .length = 2},
  [271] = {.index = 608, .length = 5},
  [272] = {.index = 613, .length = 5},
  [273] = {.index = 618, .length = 4},
  [274] = {.index = 618, .length = 4},
  [275] = {.index = 622, .length = 4},
  [276] = {.index = 626, .length = 3},
  [277] = {.index = 629, .length = 2},
  [278] = {.index = 631, .length = 2},
  [279] = {.index = 633, .length = 3},
  [280] = {.index = 636, .length = 4},
  [281] = {.index = 640, .length = 5},
  [282] = {.index = 645, .length = 3},
  [283] = {.index = 648, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_pattern, 0},
  [9] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [11] =
    {field_body, 1},
  [12] =
    {field_constructor, 1},
  [13] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [15] =
    {field_argument, 0},
    {field_operator, 1},
  [17] =
    {field_arguments, 1},
    {field_function, 0},
  [19] =
    {field_type_arguments, 1},
  [20] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [22] =
    {field_parameters, 0},
    {field_return_type, 1},
  [24] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [26] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [28] =
    {field_declaration, 2},
  [29] =
    {field_left, 0},
    {field_right, 2},
  [31] =
    {field_body, 2},
    {field_label, 0},
  [33] =
    {field_body, 2},
    {field_parameter, 0},
  [35] =
    {field_body, 1},
    {field_name, 0},
  [37] =
    {field_source, 1},
  [38] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [40] =
    {field_name, 0},
    {field_type, 1},
  [42] =
    {field_kind, 0},
  [43] =
    {field_condition, 1},
    {field_consequence, 2},
  [45] =
    {field_body, 2},
    {field_value, 1},
  [47] =
    {field_body, 2},
    {field_kind, 1, .inherited = true},
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [53] =
    {field_pattern, 1},
  [54] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [57] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
  [60] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 1},
  [62] =
    {field_body, 2},
    {field_condition, 1},
  [64] =
    {field_body, 1},
    {field_handler, 2},
  [66] =
    {field_body, 1},
    {field_finalizer, 2},
  [68] =
    {field_body, 2},
    {field_object, 1},
  [70] =
    {field_label, 1},
  [71] =
    {field_body, 2},
    {field_name, 1},
  [73] =
    {field_value, 0},
  [74] =
    {field_type_arguments, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [76] =
    {field_body, 2},
  [77] =
    {field_body, 2},
    {field_type_parameters, 1},
  [79] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [83] =
    {field_arguments, 2},
    {field_constructor, 1},
  [85] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [87] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [90] =
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [92] =
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [94] =
    {field_arguments, 1, .inherited = true},
    {field_function, 1, .inherited = true},
  [96] =
    {field_function, 1, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
  [98] =
    {field_name, 1},
  [99] =
    {field_name, 0},
    {field_type_arguments, 1},
  [101] =
    {field_name, 0},
    {field_value, 1},
  [103] =
    {field_constraint, 1},
    {field_name, 0},
  [105] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [108] =
    {field_object, 0},
    {field_property, 2},
  [110] =
    {field_object, 0},
    {field_optional_chain, 1},
    {field_property, 2},
  [113] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [116] =
    {field_arguments, 2},
    {field_function, 0},
  [118] =
    {field_close_tag, 2},
    {field_content, 1},
    {field_open_tag, 0},
  [121] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [125] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [128] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [130] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [132] =
    {field_source, 2, .inherited = true},
  [133] =
    {field_value, 2},
  [134] =
    {field_key, 0},
    {field_value, 2},
  [136] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [141] =
    {field_source, 2},
  [142] =
    {field_value, 1},
  [143] =
    {field_name, 0},
    {field_type, 2},
  [145] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [148] =
    {field_body, 3},
    {field_name, 2},
  [150] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [153] =
    {field_body, 3},
    {field_kind, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [159] =
    {field_type, 2},
  [160] =
    {field_pattern, 2},
  [161] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [164] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
  [167] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [171] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 2},
  [173] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [176] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [180] =
    {field_body, 3},
    {field_name, 1},
  [182] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [185] =
    {field_type_arguments, 1},
    {field_value, 0},
  [187] =
    {field_type_arguments, 1, .inherited = true},
    {field_type_arguments, 2, .inherited = true},
    {field_value, 1, .inherited = true},
    {field_value, 2, .inherited = true},
  [191] =
    {field_body, 3},
    {field_type_parameters, 1},
  [193] =
    {field_body, 3},
    {field_parameter, 1},
  [195] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [199] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [203] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [207] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [212] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [215] =
    {field_flags, 3},
    {field_pattern, 1},
  [217] =
    {field_parameters, 1},
  [218] =
    {field_function, 0},
    {field_type_arguments, 1},
  [220] =
    {field_arguments, 1},
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [224] =
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_type_arguments, 1},
  [228] =
    {field_arguments, 1},
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [232] =
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
    {field_type_arguments, 1},
  [236] =
    {field_name, 1},
    {field_value, 2},
  [238] =
    {field_constraint, 2},
    {field_name, 1},
  [240] =
    {field_module, 0},
    {field_name, 2},
  [242] =
    {field_constraint, 1},
    {field_name, 0},
    {field_value, 2},
  [245] =
    {field_parameters, 0},
    {field_return_type, 2},
  [247] =
    {field_type, 1},
  [248] =
    {field_index, 2},
    {field_object, 0},
  [250] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [253] =
    {field_declaration, 3},
    {field_decorator, 0, .inherited = true},
  [255] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [258] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [260] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [263] =
    {field_source, 3, .inherited = true},
  [264] =
    {field_alias, 2},
    {field_name, 0},
  [266] =
    {field_name, 1},
    {field_value, 3},
  [268] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [273] =
    {field_pattern, 3},
  [274] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [278] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 3},
  [280] =
    {field_body, 1},
    {field_condition, 3},
  [282] =
    {field_name, 2},
  [283] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [285] =
    {field_name, 1},
    {field_type, 2},
  [287] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [289] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [293] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [296] =
    {field_type_arguments, 0, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [300] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [304] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [308] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [313] =
    {field_parameters, 1},
    {field_type, 2},
  [315] =
    {field_parameters, 2},
    {field_type_parameters, 1},
  [317] =
    {field_parameters, 2},
  [318] =
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 2},
  [322] =
    {field_index, 0, .inherited = true},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 2},
  [326] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_object, 0},
    {field_property, 2},
  [330] =
    {field_constraint, 2},
    {field_name, 1},
    {field_value, 3},
  [333] =
    {field_parameters, 1},
    {field_type, 3},
  [335] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_type_parameters, 0},
  [338] =
    {field_body, 4},
    {field_name, 2},
  [340] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [343] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [345] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [348] =
    {field_index, 3},
    {field_object, 0},
    {field_optional_chain, 1},
  [351] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [353] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [356] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [360] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [363] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [366] =
    {field_alias, 3},
    {field_name, 1},
  [368] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [371] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [376] =
    {field_left, 1},
    {field_operator, 2},
    {field_right, 3},
  [379] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [382] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 4},
  [384] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [388] =
    {field_type, 3},
  [389] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [391] =
    {field_name, 2},
    {field_type, 3},
  [393] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [395] =
    {field_name, 1},
    {field_type, 3},
  [397] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [400] =
    {field_name, 3},
  [401] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [404] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [409] =
    {field_parameters, 2},
    {field_type, 3},
    {field_type_parameters, 1},
  [412] =
    {field_parameters, 2},
    {field_type, 3},
  [414] =
    {field_parameters, 3},
    {field_type_parameters, 2},
  [416] =
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [420] =
    {field_index, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [424] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
  [428] =
    {field_parameters, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [431] =
    {field_parameters, 2},
    {field_type, 4},
  [433] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [436] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [438] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [440] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [442] =
    {field_name, 2, .inherited = true},
  [443] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [447] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [450] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [454] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [459] =
    {field_source, 4},
  [460] =
    {field_body, 3},
    {field_value, 1},
  [462] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [466] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [470] =
    {field_body, 4},
    {field_parameter, 2},
  [472] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [476] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [480] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [482] =
    {field_name, 2},
    {field_type, 4},
  [484] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [487] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [490] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [492] =
    {field_name, 3},
    {field_type, 4},
  [494] =
    {field_type, 4},
  [495] =
    {field_name, 4},
  [496] =
    {field_parameters, 3},
    {field_type, 4},
    {field_type_parameters, 2},
  [499] =
    {field_index, 3},
    {field_object, 0},
  [501] =
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [505] =
    {field_index, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [509] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
  [513] =
    {field_parameters, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [516] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [520] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [525] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [530] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 4},
    {field_right, 5},
    {field_value, 3, .inherited = true},
  [535] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [538] =
    {field_index_type, 3},
    {field_name, 1},
    {field_type, 5},
  [541] =
    {field_alias, 4},
    {field_name, 0},
    {field_type, 2},
  [544] =
    {field_sign, 0},
    {field_type, 5},
  [546] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [550] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [554] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [557] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [559] =
    {field_name, 3},
    {field_type, 5},
  [561] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [564] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [566] =
    {field_name, 4},
    {field_type, 5},
  [568] =
    {field_name, 5},
  [569] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [573] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [578] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [583] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [587] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [591] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [594] =
    {field_index_type, 4},
    {field_name, 2},
    {field_type, 6},
  [597] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [599] =
    {field_name, 4},
    {field_type, 6},
  [601] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [604] =
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [606] =
    {field_name, 5},
    {field_type, 6},
  [608] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [613] =
    {field_body, 8},
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [618] =
    {field_index_type, 5},
    {field_name, 3},
    {field_sign, 0},
    {field_type, 7},
  [622] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [626] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [629] =
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [631] =
    {field_name, 5},
    {field_type, 7},
  [633] =
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [636] =
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [640] =
    {field_body, 9},
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [645] =
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [648] =
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [13] = {
    [0] = alias_sym_type_identifier,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_this_type,
  },
  [25] = {
    [0] = sym_identifier,
  },
  [26] = {
    [0] = alias_sym_statement_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [29] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [30] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [31] = {
    [1] = sym_identifier,
  },
  [47] = {
    [1] = alias_sym_statement_identifier,
  },
  [48] = {
    [1] = alias_sym_type_identifier,
  },
  [61] = {
    [1] = alias_sym_type_identifier,
  },
  [62] = {
    [0] = alias_sym_type_identifier,
  },
  [63] = {
    [0] = alias_sym_type_identifier,
  },
  [64] = {
    [0] = alias_sym_type_identifier,
  },
  [65] = {
    [1] = alias_sym_type_identifier,
  },
  [66] = {
    [1] = anon_sym_unique,
  },
  [72] = {
    [2] = alias_sym_property_identifier,
  },
  [74] = {
    [2] = alias_sym_property_identifier,
  },
  [86] = {
    [2] = alias_sym_property_identifier,
  },
  [87] = {
    [0] = sym_member_expression,
    [2] = alias_sym_property_identifier,
  },
  [88] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [106] = {
    [1] = alias_sym_type_identifier,
  },
  [107] = {
    [1] = alias_sym_type_identifier,
  },
  [111] = {
    [1] = sym_identifier,
  },
  [125] = {
    [1] = alias_sym_type_identifier,
  },
  [126] = {
    [1] = alias_sym_type_identifier,
  },
  [127] = {
    [2] = alias_sym_type_identifier,
  },
  [128] = {
    [0] = alias_sym_type_identifier,
  },
  [130] = {
    [2] = alias_sym_type_identifier,
  },
  [131] = {
    [1] = alias_sym_type_identifier,
  },
  [136] = {
    [2] = alias_sym_type_identifier,
  },
  [141] = {
    [1] = alias_sym_type_identifier,
  },
  [143] = {
    [0] = sym_identifier,
  },
  [153] = {
    [1] = alias_sym_type_identifier,
  },
  [161] = {
    [2] = alias_sym_property_identifier,
  },
  [163] = {
    [2] = alias_sym_property_identifier,
  },
  [165] = {
    [2] = alias_sym_property_identifier,
  },
  [167] = {
    [1] = alias_sym_type_identifier,
  },
  [170] = {
    [2] = alias_sym_type_identifier,
  },
  [171] = {
    [2] = alias_sym_type_identifier,
  },
  [172] = {
    [1] = alias_sym_type_identifier,
  },
  [176] = {
    [0] = sym_identifier,
  },
  [178] = {
    [2] = alias_sym_type_identifier,
  },
  [179] = {
    [2] = alias_sym_type_identifier,
  },
  [181] = {
    [3] = alias_sym_type_identifier,
  },
  [183] = {
    [1] = alias_sym_type_identifier,
  },
  [185] = {
    [1] = sym_identifier,
  },
  [186] = {
    [1] = sym_identifier,
  },
  [191] = {
    [0] = alias_sym_type_identifier,
  },
  [209] = {
    [2] = alias_sym_type_identifier,
  },
  [214] = {
    [2] = alias_sym_type_identifier,
  },
  [215] = {
    [3] = alias_sym_type_identifier,
  },
  [216] = {
    [3] = alias_sym_type_identifier,
  },
  [239] = {
    [3] = alias_sym_property_identifier,
  },
  [240] = {
    [3] = alias_sym_type_identifier,
  },
  [245] = {
    [1] = sym_identifier,
  },
  [246] = {
    [0] = alias_sym_type_identifier,
  },
  [264] = {
    [2] = sym_identifier,
  },
  [273] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_nested_identifier, 2,
    sym_nested_identifier,
    sym_member_expression,
  sym_predefined_type, 2,
    sym_predefined_type,
    sym_identifier,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 4,
  [6] = 4,
  [7] = 4,
  [8] = 4,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 15,
  [17] = 14,
  [18] = 15,
  [19] = 19,
  [20] = 15,
  [21] = 21,
  [22] = 22,
  [23] = 15,
  [24] = 14,
  [25] = 14,
  [26] = 14,
  [27] = 14,
  [28] = 15,
  [29] = 15,
  [30] = 14,
  [31] = 31,
  [32] = 32,
  [33] = 31,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 37,
  [40] = 40,
  [41] = 36,
  [42] = 35,
  [43] = 38,
  [44] = 34,
  [45] = 45,
  [46] = 46,
  [47] = 32,
  [48] = 40,
  [49] = 45,
  [50] = 50,
  [51] = 50,
  [52] = 50,
  [53] = 50,
  [54] = 50,
  [55] = 50,
  [56] = 50,
  [57] = 50,
  [58] = 50,
  [59] = 50,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 65,
  [67] = 67,
  [68] = 68,
  [69] = 68,
  [70] = 68,
  [71] = 71,
  [72] = 71,
  [73] = 71,
  [74] = 71,
  [75] = 71,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 78,
  [80] = 78,
  [81] = 78,
  [82] = 78,
  [83] = 83,
  [84] = 84,
  [85] = 78,
  [86] = 78,
  [87] = 78,
  [88] = 88,
  [89] = 88,
  [90] = 88,
  [91] = 88,
  [92] = 88,
  [93] = 88,
  [94] = 88,
  [95] = 88,
  [96] = 96,
  [97] = 96,
  [98] = 96,
  [99] = 99,
  [100] = 99,
  [101] = 99,
  [102] = 102,
  [103] = 102,
  [104] = 102,
  [105] = 105,
  [106] = 106,
  [107] = 102,
  [108] = 105,
  [109] = 105,
  [110] = 102,
  [111] = 102,
  [112] = 102,
  [113] = 106,
  [114] = 102,
  [115] = 115,
  [116] = 115,
  [117] = 117,
  [118] = 117,
  [119] = 119,
  [120] = 120,
  [121] = 120,
  [122] = 119,
  [123] = 117,
  [124] = 119,
  [125] = 120,
  [126] = 126,
  [127] = 127,
  [128] = 126,
  [129] = 126,
  [130] = 130,
  [131] = 126,
  [132] = 132,
  [133] = 126,
  [134] = 126,
  [135] = 126,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 127,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 137,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 137,
  [172] = 172,
  [173] = 173,
  [174] = 172,
  [175] = 173,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 137,
  [180] = 180,
  [181] = 177,
  [182] = 137,
  [183] = 177,
  [184] = 137,
  [185] = 177,
  [186] = 177,
  [187] = 137,
  [188] = 177,
  [189] = 137,
  [190] = 137,
  [191] = 177,
  [192] = 192,
  [193] = 193,
  [194] = 193,
  [195] = 193,
  [196] = 196,
  [197] = 193,
  [198] = 193,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 196,
  [203] = 193,
  [204] = 193,
  [205] = 205,
  [206] = 193,
  [207] = 193,
  [208] = 199,
  [209] = 209,
  [210] = 193,
  [211] = 193,
  [212] = 205,
  [213] = 193,
  [214] = 193,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 221,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 228,
  [231] = 226,
  [232] = 225,
  [233] = 233,
  [234] = 223,
  [235] = 235,
  [236] = 223,
  [237] = 237,
  [238] = 227,
  [239] = 233,
  [240] = 229,
  [241] = 241,
  [242] = 224,
  [243] = 227,
  [244] = 223,
  [245] = 245,
  [246] = 223,
  [247] = 225,
  [248] = 226,
  [249] = 227,
  [250] = 228,
  [251] = 233,
  [252] = 252,
  [253] = 233,
  [254] = 227,
  [255] = 227,
  [256] = 224,
  [257] = 229,
  [258] = 252,
  [259] = 228,
  [260] = 226,
  [261] = 261,
  [262] = 225,
  [263] = 224,
  [264] = 229,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 223,
  [269] = 223,
  [270] = 225,
  [271] = 228,
  [272] = 226,
  [273] = 225,
  [274] = 226,
  [275] = 275,
  [276] = 228,
  [277] = 233,
  [278] = 223,
  [279] = 279,
  [280] = 224,
  [281] = 227,
  [282] = 252,
  [283] = 235,
  [284] = 224,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 229,
  [290] = 290,
  [291] = 229,
  [292] = 224,
  [293] = 227,
  [294] = 227,
  [295] = 295,
  [296] = 226,
  [297] = 228,
  [298] = 224,
  [299] = 279,
  [300] = 245,
  [301] = 301,
  [302] = 226,
  [303] = 228,
  [304] = 225,
  [305] = 229,
  [306] = 233,
  [307] = 307,
  [308] = 223,
  [309] = 233,
  [310] = 233,
  [311] = 225,
  [312] = 295,
  [313] = 229,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 314,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 323,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 326,
  [331] = 322,
  [332] = 328,
  [333] = 333,
  [334] = 314,
  [335] = 323,
  [336] = 318,
  [337] = 317,
  [338] = 316,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 329,
  [343] = 343,
  [344] = 344,
  [345] = 315,
  [346] = 346,
  [347] = 347,
  [348] = 321,
  [349] = 321,
  [350] = 350,
  [351] = 347,
  [352] = 327,
  [353] = 346,
  [354] = 354,
  [355] = 321,
  [356] = 314,
  [357] = 315,
  [358] = 344,
  [359] = 359,
  [360] = 343,
  [361] = 361,
  [362] = 362,
  [363] = 346,
  [364] = 364,
  [365] = 347,
  [366] = 333,
  [367] = 322,
  [368] = 333,
  [369] = 350,
  [370] = 329,
  [371] = 341,
  [372] = 340,
  [373] = 318,
  [374] = 362,
  [375] = 339,
  [376] = 376,
  [377] = 316,
  [378] = 333,
  [379] = 350,
  [380] = 346,
  [381] = 376,
  [382] = 339,
  [383] = 362,
  [384] = 362,
  [385] = 328,
  [386] = 317,
  [387] = 387,
  [388] = 322,
  [389] = 322,
  [390] = 315,
  [391] = 326,
  [392] = 392,
  [393] = 376,
  [394] = 318,
  [395] = 318,
  [396] = 396,
  [397] = 314,
  [398] = 317,
  [399] = 344,
  [400] = 343,
  [401] = 323,
  [402] = 314,
  [403] = 340,
  [404] = 350,
  [405] = 323,
  [406] = 326,
  [407] = 329,
  [408] = 341,
  [409] = 340,
  [410] = 376,
  [411] = 341,
  [412] = 318,
  [413] = 317,
  [414] = 316,
  [415] = 339,
  [416] = 316,
  [417] = 340,
  [418] = 328,
  [419] = 339,
  [420] = 340,
  [421] = 341,
  [422] = 327,
  [423] = 362,
  [424] = 329,
  [425] = 343,
  [426] = 343,
  [427] = 344,
  [428] = 333,
  [429] = 350,
  [430] = 376,
  [431] = 339,
  [432] = 344,
  [433] = 315,
  [434] = 315,
  [435] = 346,
  [436] = 362,
  [437] = 317,
  [438] = 326,
  [439] = 347,
  [440] = 346,
  [441] = 341,
  [442] = 362,
  [443] = 321,
  [444] = 319,
  [445] = 362,
  [446] = 347,
  [447] = 376,
  [448] = 316,
  [449] = 329,
  [450] = 343,
  [451] = 321,
  [452] = 362,
  [453] = 344,
  [454] = 362,
  [455] = 455,
  [456] = 347,
  [457] = 328,
  [458] = 322,
  [459] = 339,
  [460] = 316,
  [461] = 461,
  [462] = 327,
  [463] = 317,
  [464] = 328,
  [465] = 319,
  [466] = 318,
  [467] = 326,
  [468] = 350,
  [469] = 362,
  [470] = 323,
  [471] = 314,
  [472] = 323,
  [473] = 323,
  [474] = 322,
  [475] = 318,
  [476] = 317,
  [477] = 316,
  [478] = 339,
  [479] = 340,
  [480] = 341,
  [481] = 340,
  [482] = 326,
  [483] = 327,
  [484] = 314,
  [485] = 329,
  [486] = 343,
  [487] = 344,
  [488] = 488,
  [489] = 489,
  [490] = 315,
  [491] = 346,
  [492] = 319,
  [493] = 327,
  [494] = 347,
  [495] = 495,
  [496] = 327,
  [497] = 359,
  [498] = 326,
  [499] = 333,
  [500] = 328,
  [501] = 321,
  [502] = 350,
  [503] = 321,
  [504] = 504,
  [505] = 328,
  [506] = 333,
  [507] = 347,
  [508] = 362,
  [509] = 346,
  [510] = 315,
  [511] = 341,
  [512] = 329,
  [513] = 344,
  [514] = 362,
  [515] = 515,
  [516] = 376,
  [517] = 322,
  [518] = 327,
  [519] = 376,
  [520] = 333,
  [521] = 350,
  [522] = 343,
  [523] = 523,
  [524] = 523,
  [525] = 523,
  [526] = 526,
  [527] = 526,
  [528] = 528,
  [529] = 528,
  [530] = 528,
  [531] = 531,
  [532] = 531,
  [533] = 533,
  [534] = 533,
  [535] = 533,
  [536] = 536,
  [537] = 155,
  [538] = 536,
  [539] = 146,
  [540] = 540,
  [541] = 541,
  [542] = 541,
  [543] = 540,
  [544] = 540,
  [545] = 541,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 551,
  [554] = 552,
  [555] = 551,
  [556] = 552,
  [557] = 557,
  [558] = 558,
  [559] = 558,
  [560] = 560,
  [561] = 560,
  [562] = 560,
  [563] = 563,
  [564] = 557,
  [565] = 560,
  [566] = 560,
  [567] = 560,
  [568] = 568,
  [569] = 568,
  [570] = 570,
  [571] = 560,
  [572] = 154,
  [573] = 560,
  [574] = 574,
  [575] = 144,
  [576] = 151,
  [577] = 560,
  [578] = 558,
  [579] = 152,
  [580] = 161,
  [581] = 154,
  [582] = 560,
  [583] = 148,
  [584] = 584,
  [585] = 585,
  [586] = 560,
  [587] = 587,
  [588] = 560,
  [589] = 584,
  [590] = 148,
  [591] = 144,
  [592] = 584,
  [593] = 151,
  [594] = 557,
  [595] = 132,
  [596] = 141,
  [597] = 560,
  [598] = 560,
  [599] = 599,
  [600] = 563,
  [601] = 601,
  [602] = 602,
  [603] = 143,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 560,
  [613] = 613,
  [614] = 156,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 138,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 160,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 161,
  [666] = 666,
  [667] = 667,
  [668] = 152,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 150,
  [768] = 768,
  [769] = 769,
  [770] = 769,
  [771] = 769,
  [772] = 769,
  [773] = 769,
  [774] = 774,
  [775] = 775,
  [776] = 774,
  [777] = 774,
  [778] = 774,
  [779] = 774,
  [780] = 775,
  [781] = 775,
  [782] = 775,
  [783] = 775,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 799,
  [801] = 801,
  [802] = 799,
  [803] = 801,
  [804] = 801,
  [805] = 801,
  [806] = 798,
  [807] = 799,
  [808] = 808,
  [809] = 799,
  [810] = 798,
  [811] = 811,
  [812] = 812,
  [813] = 801,
  [814] = 801,
  [815] = 799,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 818,
  [820] = 817,
  [821] = 817,
  [822] = 818,
  [823] = 823,
  [824] = 823,
  [825] = 823,
  [826] = 826,
  [827] = 827,
  [828] = 827,
  [829] = 827,
  [830] = 826,
  [831] = 831,
  [832] = 826,
  [833] = 827,
  [834] = 826,
  [835] = 823,
  [836] = 826,
  [837] = 823,
  [838] = 831,
  [839] = 827,
  [840] = 827,
  [841] = 823,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 842,
  [848] = 848,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 851,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 858,
  [863] = 848,
  [864] = 857,
  [865] = 865,
  [866] = 861,
  [867] = 867,
  [868] = 868,
  [869] = 844,
  [870] = 870,
  [871] = 867,
  [872] = 851,
  [873] = 843,
  [874] = 859,
  [875] = 857,
  [876] = 858,
  [877] = 877,
  [878] = 867,
  [879] = 848,
  [880] = 880,
  [881] = 881,
  [882] = 844,
  [883] = 883,
  [884] = 849,
  [885] = 844,
  [886] = 886,
  [887] = 844,
  [888] = 851,
  [889] = 859,
  [890] = 848,
  [891] = 891,
  [892] = 851,
  [893] = 893,
  [894] = 858,
  [895] = 895,
  [896] = 859,
  [897] = 897,
  [898] = 897,
  [899] = 859,
  [900] = 900,
  [901] = 861,
  [902] = 895,
  [903] = 858,
  [904] = 850,
  [905] = 870,
  [906] = 857,
  [907] = 907,
  [908] = 860,
  [909] = 850,
  [910] = 846,
  [911] = 858,
  [912] = 849,
  [913] = 867,
  [914] = 858,
  [915] = 846,
  [916] = 891,
  [917] = 842,
  [918] = 849,
  [919] = 855,
  [920] = 920,
  [921] = 907,
  [922] = 860,
  [923] = 923,
  [924] = 846,
  [925] = 925,
  [926] = 849,
  [927] = 870,
  [928] = 860,
  [929] = 861,
  [930] = 891,
  [931] = 931,
  [932] = 870,
  [933] = 858,
  [934] = 870,
  [935] = 861,
  [936] = 861,
  [937] = 856,
  [938] = 848,
  [939] = 842,
  [940] = 940,
  [941] = 867,
  [942] = 850,
  [943] = 857,
  [944] = 944,
  [945] = 850,
  [946] = 944,
  [947] = 860,
  [948] = 849,
  [949] = 858,
  [950] = 895,
  [951] = 897,
  [952] = 842,
  [953] = 953,
  [954] = 843,
  [955] = 843,
  [956] = 855,
  [957] = 891,
  [958] = 860,
  [959] = 855,
  [960] = 897,
  [961] = 891,
  [962] = 931,
  [963] = 855,
  [964] = 858,
  [965] = 858,
  [966] = 858,
  [967] = 843,
  [968] = 859,
  [969] = 895,
  [970] = 857,
  [971] = 851,
  [972] = 844,
  [973] = 895,
  [974] = 974,
  [975] = 870,
  [976] = 846,
  [977] = 842,
  [978] = 897,
  [979] = 848,
  [980] = 850,
  [981] = 897,
  [982] = 891,
  [983] = 867,
  [984] = 920,
  [985] = 855,
  [986] = 843,
  [987] = 893,
  [988] = 846,
  [989] = 895,
  [990] = 990,
  [991] = 991,
  [992] = 991,
  [993] = 993,
  [994] = 994,
  [995] = 974,
  [996] = 996,
  [997] = 991,
  [998] = 991,
  [999] = 999,
  [1000] = 999,
  [1001] = 991,
  [1002] = 1002,
  [1003] = 991,
  [1004] = 996,
  [1005] = 991,
  [1006] = 1006,
  [1007] = 991,
  [1008] = 1008,
  [1009] = 1006,
  [1010] = 1006,
  [1011] = 1011,
  [1012] = 991,
  [1013] = 991,
  [1014] = 991,
  [1015] = 1015,
  [1016] = 1016,
  [1017] = 991,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 1011,
  [1023] = 1019,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1015,
  [1028] = 1011,
  [1029] = 944,
  [1030] = 1019,
  [1031] = 991,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 1024,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1036,
  [1038] = 1015,
  [1039] = 974,
  [1040] = 1015,
  [1041] = 791,
  [1042] = 1042,
  [1043] = 792,
  [1044] = 1015,
  [1045] = 991,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1002,
  [1049] = 1049,
  [1050] = 991,
  [1051] = 1046,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1052,
  [1058] = 1056,
  [1059] = 1059,
  [1060] = 1015,
  [1061] = 1015,
  [1062] = 1049,
  [1063] = 1015,
  [1064] = 1046,
  [1065] = 1049,
  [1066] = 991,
  [1067] = 1015,
  [1068] = 1054,
  [1069] = 1054,
  [1070] = 1015,
  [1071] = 1071,
  [1072] = 1059,
  [1073] = 1059,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1071,
  [1077] = 1074,
  [1078] = 1078,
  [1079] = 1015,
  [1080] = 1049,
  [1081] = 1049,
  [1082] = 1082,
  [1083] = 1078,
  [1084] = 1075,
  [1085] = 1085,
  [1086] = 1049,
  [1087] = 1085,
  [1088] = 1016,
  [1089] = 1075,
  [1090] = 1059,
  [1091] = 1074,
  [1092] = 1092,
  [1093] = 1075,
  [1094] = 1094,
  [1095] = 1059,
  [1096] = 1047,
  [1097] = 1097,
  [1098] = 1015,
  [1099] = 1032,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 1033,
  [1103] = 792,
  [1104] = 1092,
  [1105] = 1074,
  [1106] = 1074,
  [1107] = 1074,
  [1108] = 1021,
  [1109] = 1025,
  [1110] = 1049,
  [1111] = 1020,
  [1112] = 1059,
  [1113] = 1049,
  [1114] = 1035,
  [1115] = 1075,
  [1116] = 1075,
  [1117] = 1055,
  [1118] = 1101,
  [1119] = 1047,
  [1120] = 1054,
  [1121] = 791,
  [1122] = 1100,
  [1123] = 1015,
  [1124] = 1124,
  [1125] = 1053,
  [1126] = 1049,
  [1127] = 1124,
  [1128] = 1128,
  [1129] = 1075,
  [1130] = 1047,
  [1131] = 1074,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 1075,
  [1136] = 1082,
  [1137] = 1074,
  [1138] = 1138,
  [1139] = 1059,
  [1140] = 1047,
  [1141] = 1059,
  [1142] = 1074,
  [1143] = 1052,
  [1144] = 1047,
  [1145] = 1145,
  [1146] = 1075,
  [1147] = 1074,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1059,
  [1151] = 1074,
  [1152] = 1074,
  [1153] = 1075,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 1056,
  [1157] = 1075,
  [1158] = 1158,
  [1159] = 1075,
  [1160] = 1094,
  [1161] = 1075,
  [1162] = 1162,
  [1163] = 1097,
  [1164] = 1055,
  [1165] = 1047,
  [1166] = 1075,
  [1167] = 1047,
  [1168] = 1074,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1085,
  [1172] = 1074,
  [1173] = 1075,
  [1174] = 1074,
  [1175] = 1134,
  [1176] = 1047,
  [1177] = 1082,
  [1178] = 1178,
  [1179] = 1178,
  [1180] = 1178,
  [1181] = 1178,
  [1182] = 1178,
  [1183] = 1178,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1186,
  [1187] = 1187,
  [1188] = 1185,
  [1189] = 1187,
  [1190] = 1185,
  [1191] = 1187,
  [1192] = 1192,
  [1193] = 1192,
  [1194] = 1192,
  [1195] = 1192,
  [1196] = 1187,
  [1197] = 1185,
  [1198] = 1185,
  [1199] = 1186,
  [1200] = 1186,
  [1201] = 1187,
  [1202] = 1187,
  [1203] = 1186,
  [1204] = 1192,
  [1205] = 1192,
  [1206] = 1186,
  [1207] = 1186,
  [1208] = 1208,
  [1209] = 146,
  [1210] = 1210,
  [1211] = 1208,
  [1212] = 1208,
  [1213] = 1208,
  [1214] = 1208,
  [1215] = 1215,
  [1216] = 155,
  [1217] = 1208,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 146,
  [1226] = 155,
  [1227] = 1227,
  [1228] = 138,
  [1229] = 132,
  [1230] = 141,
  [1231] = 1231,
  [1232] = 1231,
  [1233] = 1233,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1231,
  [1237] = 1237,
  [1238] = 1231,
  [1239] = 1231,
  [1240] = 1231,
  [1241] = 1241,
  [1242] = 1231,
  [1243] = 1243,
  [1244] = 136,
  [1245] = 1245,
  [1246] = 811,
  [1247] = 1247,
  [1248] = 138,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 546,
  [1257] = 1257,
  [1258] = 548,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 994,
  [1272] = 1272,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 808,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 1283,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 156,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1294,
  [1295] = 1295,
  [1296] = 1296,
  [1297] = 1297,
  [1298] = 1298,
  [1299] = 1299,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1302,
  [1303] = 1303,
  [1304] = 1304,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 144,
  [1308] = 1308,
  [1309] = 143,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 132,
  [1318] = 141,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 550,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 154,
  [1337] = 1337,
  [1338] = 812,
  [1339] = 1339,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 990,
  [1345] = 1345,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 549,
  [1361] = 547,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 993,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1316,
  [1385] = 1262,
  [1386] = 1349,
  [1387] = 1387,
  [1388] = 1334,
  [1389] = 1389,
  [1390] = 150,
  [1391] = 143,
  [1392] = 1347,
  [1393] = 1381,
  [1394] = 1394,
  [1395] = 1219,
  [1396] = 151,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1324,
  [1400] = 1374,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1402,
  [1404] = 1381,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 151,
  [1412] = 160,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 144,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1334,
  [1420] = 1420,
  [1421] = 1296,
  [1422] = 1422,
  [1423] = 1423,
  [1424] = 1347,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1374,
  [1431] = 1291,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 1298,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 152,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1221,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1262,
  [1448] = 1448,
  [1449] = 148,
  [1450] = 1450,
  [1451] = 1330,
  [1452] = 1366,
  [1453] = 1453,
  [1454] = 1366,
  [1455] = 1455,
  [1456] = 1373,
  [1457] = 1457,
  [1458] = 1367,
  [1459] = 1459,
  [1460] = 148,
  [1461] = 1461,
  [1462] = 1448,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1298,
  [1467] = 154,
  [1468] = 1296,
  [1469] = 1291,
  [1470] = 1439,
  [1471] = 160,
  [1472] = 1346,
  [1473] = 1345,
  [1474] = 1312,
  [1475] = 1475,
  [1476] = 1349,
  [1477] = 1477,
  [1478] = 1322,
  [1479] = 1320,
  [1480] = 1319,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1247,
  [1484] = 1314,
  [1485] = 1313,
  [1486] = 1486,
  [1487] = 156,
  [1488] = 1330,
  [1489] = 152,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1306,
  [1493] = 1493,
  [1494] = 1312,
  [1495] = 1373,
  [1496] = 1367,
  [1497] = 1497,
  [1498] = 161,
  [1499] = 1346,
  [1500] = 1345,
  [1501] = 1402,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 161,
  [1506] = 1506,
  [1507] = 1507,
  [1508] = 1508,
  [1509] = 1281,
  [1510] = 1324,
  [1511] = 1288,
  [1512] = 1295,
  [1513] = 1513,
  [1514] = 1514,
  [1515] = 1295,
  [1516] = 1306,
  [1517] = 1313,
  [1518] = 1322,
  [1519] = 1314,
  [1520] = 1520,
  [1521] = 1247,
  [1522] = 1402,
  [1523] = 1523,
  [1524] = 1316,
  [1525] = 1223,
  [1526] = 1288,
  [1527] = 1527,
  [1528] = 1320,
  [1529] = 1222,
  [1530] = 150,
  [1531] = 1319,
  [1532] = 1281,
  [1533] = 1220,
  [1534] = 1401,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 1536,
  [1538] = 1538,
  [1539] = 1345,
  [1540] = 1540,
  [1541] = 1367,
  [1542] = 1535,
  [1543] = 1302,
  [1544] = 1373,
  [1545] = 1237,
  [1546] = 1224,
  [1547] = 1547,
  [1548] = 1262,
  [1549] = 1227,
  [1550] = 1312,
  [1551] = 1547,
  [1552] = 1547,
  [1553] = 1286,
  [1554] = 1346,
  [1555] = 1285,
  [1556] = 1241,
  [1557] = 1366,
  [1558] = 1334,
  [1559] = 1320,
  [1560] = 1560,
  [1561] = 1561,
  [1562] = 1547,
  [1563] = 1547,
  [1564] = 1564,
  [1565] = 1535,
  [1566] = 1547,
  [1567] = 1536,
  [1568] = 1324,
  [1569] = 1569,
  [1570] = 1298,
  [1571] = 1347,
  [1572] = 1381,
  [1573] = 1296,
  [1574] = 1574,
  [1575] = 1374,
  [1576] = 1291,
  [1577] = 1349,
  [1578] = 1330,
  [1579] = 1243,
  [1580] = 1439,
  [1581] = 1535,
  [1582] = 1582,
  [1583] = 1583,
  [1584] = 1281,
  [1585] = 1288,
  [1586] = 1450,
  [1587] = 1448,
  [1588] = 1295,
  [1589] = 1401,
  [1590] = 1245,
  [1591] = 1306,
  [1592] = 1592,
  [1593] = 1547,
  [1594] = 1536,
  [1595] = 1595,
  [1596] = 1595,
  [1597] = 1597,
  [1598] = 1322,
  [1599] = 1313,
  [1600] = 1569,
  [1601] = 1536,
  [1602] = 1285,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1314,
  [1606] = 1247,
  [1607] = 1319,
  [1608] = 1535,
  [1609] = 1316,
  [1610] = 1286,
  [1611] = 1450,
  [1612] = 1235,
  [1613] = 1234,
  [1614] = 1233,
  [1615] = 1305,
  [1616] = 1279,
  [1617] = 1617,
  [1618] = 1448,
  [1619] = 1366,
  [1620] = 1312,
  [1621] = 1262,
  [1622] = 1373,
  [1623] = 1367,
  [1624] = 1346,
  [1625] = 1339,
  [1626] = 1335,
  [1627] = 1345,
  [1628] = 1439,
  [1629] = 1331,
  [1630] = 1324,
  [1631] = 1322,
  [1632] = 1320,
  [1633] = 1319,
  [1634] = 1316,
  [1635] = 1247,
  [1636] = 1314,
  [1637] = 1313,
  [1638] = 1306,
  [1639] = 1295,
  [1640] = 1283,
  [1641] = 1285,
  [1642] = 1286,
  [1643] = 1288,
  [1644] = 1281,
  [1645] = 1330,
  [1646] = 1330,
  [1647] = 1315,
  [1648] = 1648,
  [1649] = 1583,
  [1650] = 1650,
  [1651] = 1297,
  [1652] = 811,
  [1653] = 1414,
  [1654] = 1582,
  [1655] = 1348,
  [1656] = 1286,
  [1657] = 1285,
  [1658] = 1658,
  [1659] = 1659,
  [1660] = 1349,
  [1661] = 1374,
  [1662] = 1347,
  [1663] = 1291,
  [1664] = 1296,
  [1665] = 1298,
  [1666] = 136,
  [1667] = 1401,
  [1668] = 1273,
  [1669] = 1334,
  [1670] = 1381,
  [1671] = 1266,
  [1672] = 1368,
  [1673] = 1372,
  [1674] = 1375,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 1677,
  [1678] = 1678,
  [1679] = 1276,
  [1680] = 1250,
  [1681] = 1252,
  [1682] = 1257,
  [1683] = 1382,
  [1684] = 1684,
  [1685] = 1263,
  [1686] = 1272,
  [1687] = 1342,
  [1688] = 547,
  [1689] = 1281,
  [1690] = 1288,
  [1691] = 1295,
  [1692] = 1306,
  [1693] = 1658,
  [1694] = 1259,
  [1695] = 1337,
  [1696] = 1333,
  [1697] = 1294,
  [1698] = 1280,
  [1699] = 1684,
  [1700] = 1269,
  [1701] = 1267,
  [1702] = 1264,
  [1703] = 1261,
  [1704] = 1254,
  [1705] = 1251,
  [1706] = 1379,
  [1707] = 548,
  [1708] = 1313,
  [1709] = 1314,
  [1710] = 1247,
  [1711] = 1316,
  [1712] = 1319,
  [1713] = 1320,
  [1714] = 1322,
  [1715] = 1324,
  [1716] = 1345,
  [1717] = 1346,
  [1718] = 1367,
  [1719] = 1373,
  [1720] = 1286,
  [1721] = 1285,
  [1722] = 1282,
  [1723] = 1270,
  [1724] = 1275,
  [1725] = 993,
  [1726] = 1277,
  [1727] = 1284,
  [1728] = 1290,
  [1729] = 1292,
  [1730] = 1293,
  [1731] = 1299,
  [1732] = 1300,
  [1733] = 1301,
  [1734] = 1304,
  [1735] = 1310,
  [1736] = 1311,
  [1737] = 1325,
  [1738] = 1326,
  [1739] = 1328,
  [1740] = 1332,
  [1741] = 1351,
  [1742] = 1359,
  [1743] = 549,
  [1744] = 1291,
  [1745] = 1296,
  [1746] = 1617,
  [1747] = 1262,
  [1748] = 1312,
  [1749] = 1366,
  [1750] = 1684,
  [1751] = 1363,
  [1752] = 1364,
  [1753] = 1369,
  [1754] = 994,
  [1755] = 1370,
  [1756] = 1378,
  [1757] = 1357,
  [1758] = 1383,
  [1759] = 1352,
  [1760] = 1329,
  [1761] = 1323,
  [1762] = 1465,
  [1763] = 1283,
  [1764] = 1684,
  [1765] = 1321,
  [1766] = 1308,
  [1767] = 1303,
  [1768] = 1249,
  [1769] = 1253,
  [1770] = 1255,
  [1771] = 546,
  [1772] = 1286,
  [1773] = 1684,
  [1774] = 1285,
  [1775] = 1775,
  [1776] = 1355,
  [1777] = 1418,
  [1778] = 1778,
  [1779] = 808,
  [1780] = 1775,
  [1781] = 1465,
  [1782] = 1778,
  [1783] = 1414,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 1786,
  [1787] = 1334,
  [1788] = 1788,
  [1789] = 990,
  [1790] = 1380,
  [1791] = 1791,
  [1792] = 136,
  [1793] = 1793,
  [1794] = 1376,
  [1795] = 1371,
  [1796] = 1365,
  [1797] = 1362,
  [1798] = 1358,
  [1799] = 1356,
  [1800] = 1354,
  [1801] = 1353,
  [1802] = 1350,
  [1803] = 1343,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1583,
  [1807] = 1648,
  [1808] = 1786,
  [1809] = 1418,
  [1810] = 1582,
  [1811] = 1341,
  [1812] = 1340,
  [1813] = 1355,
  [1814] = 1298,
  [1815] = 550,
  [1816] = 1816,
  [1817] = 1260,
  [1818] = 1818,
  [1819] = 812,
  [1820] = 1287,
  [1821] = 1265,
  [1822] = 1268,
  [1823] = 1374,
  [1824] = 1349,
  [1825] = 1347,
  [1826] = 1381,
  [1827] = 1274,
  [1828] = 1828,
  [1829] = 1397,
  [1830] = 1582,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1446,
  [1835] = 145,
  [1836] = 168,
  [1837] = 1349,
  [1838] = 1345,
  [1839] = 1334,
  [1840] = 1833,
  [1841] = 1366,
  [1842] = 162,
  [1843] = 158,
  [1844] = 1455,
  [1845] = 1486,
  [1846] = 1832,
  [1847] = 1346,
  [1848] = 1848,
  [1849] = 1387,
  [1850] = 1389,
  [1851] = 1355,
  [1852] = 1464,
  [1853] = 1853,
  [1854] = 1322,
  [1855] = 1463,
  [1856] = 1856,
  [1857] = 1320,
  [1858] = 1858,
  [1859] = 1355,
  [1860] = 159,
  [1861] = 1861,
  [1862] = 1848,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1312,
  [1866] = 1319,
  [1867] = 1833,
  [1868] = 1868,
  [1869] = 1869,
  [1870] = 1316,
  [1871] = 1465,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1262,
  [1875] = 164,
  [1876] = 165,
  [1877] = 1413,
  [1878] = 1828,
  [1879] = 1247,
  [1880] = 1314,
  [1881] = 142,
  [1882] = 1409,
  [1883] = 1883,
  [1884] = 1884,
  [1885] = 1490,
  [1886] = 1491,
  [1887] = 1503,
  [1888] = 1523,
  [1889] = 1514,
  [1890] = 1513,
  [1891] = 167,
  [1892] = 1832,
  [1893] = 1493,
  [1894] = 1848,
  [1895] = 149,
  [1896] = 1583,
  [1897] = 1313,
  [1898] = 1432,
  [1899] = 1833,
  [1900] = 1450,
  [1901] = 1901,
  [1902] = 1306,
  [1903] = 1497,
  [1904] = 1582,
  [1905] = 1295,
  [1906] = 1394,
  [1907] = 1373,
  [1908] = 1443,
  [1909] = 1442,
  [1910] = 1465,
  [1911] = 1848,
  [1912] = 1440,
  [1913] = 1502,
  [1914] = 1367,
  [1915] = 1444,
  [1916] = 149,
  [1917] = 1832,
  [1918] = 1414,
  [1919] = 1506,
  [1920] = 157,
  [1921] = 1504,
  [1922] = 1832,
  [1923] = 1833,
  [1924] = 1507,
  [1925] = 1508,
  [1926] = 1926,
  [1927] = 1520,
  [1928] = 1816,
  [1929] = 1929,
  [1930] = 1930,
  [1931] = 1848,
  [1932] = 1427,
  [1933] = 1288,
  [1934] = 1281,
  [1935] = 1330,
  [1936] = 1481,
  [1937] = 1937,
  [1938] = 1347,
  [1939] = 1283,
  [1940] = 1381,
  [1941] = 1465,
  [1942] = 1418,
  [1943] = 1291,
  [1944] = 1426,
  [1945] = 1873,
  [1946] = 1425,
  [1947] = 1405,
  [1948] = 166,
  [1949] = 1416,
  [1950] = 1410,
  [1951] = 1374,
  [1952] = 1816,
  [1953] = 153,
  [1954] = 153,
  [1955] = 1901,
  [1956] = 166,
  [1957] = 157,
  [1958] = 1296,
  [1959] = 1298,
  [1960] = 1833,
  [1961] = 1398,
  [1962] = 1324,
  [1963] = 1418,
  [1964] = 1406,
  [1965] = 1833,
  [1966] = 1434,
  [1967] = 1407,
  [1968] = 1436,
  [1969] = 1286,
  [1970] = 1420,
  [1971] = 1418,
  [1972] = 1437,
  [1973] = 1285,
  [1974] = 1445,
  [1975] = 1482,
  [1976] = 1477,
  [1977] = 1401,
  [1978] = 168,
  [1979] = 1833,
  [1980] = 1582,
  [1981] = 1408,
  [1982] = 145,
  [1983] = 162,
  [1984] = 158,
  [1985] = 1461,
  [1986] = 1433,
  [1987] = 1448,
  [1988] = 1285,
  [1989] = 1286,
  [1990] = 1439,
  [1991] = 159,
  [1992] = 167,
  [1993] = 142,
  [1994] = 1428,
  [1995] = 1459,
  [1996] = 1453,
  [1997] = 164,
  [1998] = 165,
  [1999] = 1381,
  [2000] = 1306,
  [2001] = 1367,
  [2002] = 1281,
  [2003] = 1355,
  [2004] = 2004,
  [2005] = 1418,
  [2006] = 1346,
  [2007] = 1448,
  [2008] = 1345,
  [2009] = 1324,
  [2010] = 1322,
  [2011] = 1288,
  [2012] = 1414,
  [2013] = 1366,
  [2014] = 1347,
  [2015] = 2015,
  [2016] = 1414,
  [2017] = 2017,
  [2018] = 1312,
  [2019] = 2019,
  [2020] = 1262,
  [2021] = 1373,
  [2022] = 2017,
  [2023] = 2017,
  [2024] = 1582,
  [2025] = 1295,
  [2026] = 1560,
  [2027] = 1816,
  [2028] = 1465,
  [2029] = 2017,
  [2030] = 2015,
  [2031] = 1286,
  [2032] = 1243,
  [2033] = 1283,
  [2034] = 1349,
  [2035] = 1320,
  [2036] = 1319,
  [2037] = 1316,
  [2038] = 1247,
  [2039] = 1285,
  [2040] = 1291,
  [2041] = 1314,
  [2042] = 1313,
  [2043] = 1374,
  [2044] = 1296,
  [2045] = 1330,
  [2046] = 1582,
  [2047] = 1298,
  [2048] = 2017,
  [2049] = 1334,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 2053,
  [2054] = 1355,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 2050,
  [2058] = 2058,
  [2059] = 2059,
  [2060] = 1582,
  [2061] = 2061,
  [2062] = 1355,
  [2063] = 2063,
  [2064] = 2050,
  [2065] = 1595,
  [2066] = 2066,
  [2067] = 2067,
  [2068] = 1414,
  [2069] = 2050,
  [2070] = 2070,
  [2071] = 2050,
  [2072] = 1401,
  [2073] = 1448,
  [2074] = 2074,
  [2075] = 2075,
  [2076] = 2076,
  [2077] = 1414,
  [2078] = 1465,
  [2079] = 2079,
  [2080] = 1439,
  [2081] = 2081,
  [2082] = 2053,
  [2083] = 2083,
  [2084] = 1418,
  [2085] = 2050,
  [2086] = 2050,
  [2087] = 2074,
  [2088] = 2088,
  [2089] = 2089,
  [2090] = 1355,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 1868,
  [2094] = 2094,
  [2095] = 2095,
  [2096] = 2096,
  [2097] = 1224,
  [2098] = 2098,
  [2099] = 2099,
  [2100] = 2091,
  [2101] = 2101,
  [2102] = 2102,
  [2103] = 2096,
  [2104] = 2096,
  [2105] = 2105,
  [2106] = 1439,
  [2107] = 2107,
  [2108] = 2108,
  [2109] = 1816,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2091,
  [2113] = 2113,
  [2114] = 2114,
  [2115] = 2096,
  [2116] = 2092,
  [2117] = 2094,
  [2118] = 2096,
  [2119] = 2094,
  [2120] = 2101,
  [2121] = 2091,
  [2122] = 2107,
  [2123] = 1448,
  [2124] = 2091,
  [2125] = 2092,
  [2126] = 2092,
  [2127] = 2094,
  [2128] = 2096,
  [2129] = 2108,
  [2130] = 2092,
  [2131] = 2131,
  [2132] = 1401,
  [2133] = 2113,
  [2134] = 2096,
  [2135] = 2135,
  [2136] = 2136,
  [2137] = 2137,
  [2138] = 2138,
  [2139] = 2094,
  [2140] = 2140,
  [2141] = 2091,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 2144,
  [2145] = 2091,
  [2146] = 2146,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 2149,
  [2150] = 2148,
  [2151] = 2151,
  [2152] = 2152,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 2153,
  [2156] = 2148,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2159,
  [2160] = 2148,
  [2161] = 2161,
  [2162] = 2162,
  [2163] = 2162,
  [2164] = 2148,
  [2165] = 2148,
  [2166] = 2146,
  [2167] = 2167,
  [2168] = 2168,
  [2169] = 2157,
  [2170] = 2170,
  [2171] = 2171,
  [2172] = 2172,
  [2173] = 2148,
  [2174] = 2174,
  [2175] = 2175,
  [2176] = 2176,
  [2177] = 2177,
  [2178] = 2178,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2092,
  [2184] = 2092,
  [2185] = 2094,
  [2186] = 2092,
  [2187] = 2094,
  [2188] = 2188,
  [2189] = 2092,
  [2190] = 2094,
  [2191] = 2191,
  [2192] = 2192,
  [2193] = 2094,
  [2194] = 2092,
  [2195] = 2195,
  [2196] = 2094,
  [2197] = 2197,
  [2198] = 2094,
  [2199] = 2092,
  [2200] = 2092,
  [2201] = 2094,
  [2202] = 2202,
  [2203] = 2203,
  [2204] = 2179,
  [2205] = 2205,
  [2206] = 2205,
  [2207] = 2203,
  [2208] = 1128,
  [2209] = 2205,
  [2210] = 2178,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 2214,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2222,
  [2223] = 154,
  [2224] = 148,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 1158,
  [2243] = 2243,
  [2244] = 151,
  [2245] = 2245,
  [2246] = 144,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2157,
  [2251] = 2146,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 144,
  [2256] = 2153,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2162,
  [2260] = 2157,
  [2261] = 2261,
  [2262] = 154,
  [2263] = 2149,
  [2264] = 2257,
  [2265] = 2153,
  [2266] = 2266,
  [2267] = 2171,
  [2268] = 2146,
  [2269] = 2269,
  [2270] = 2154,
  [2271] = 2147,
  [2272] = 2162,
  [2273] = 1169,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 1170,
  [2278] = 811,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2276,
  [2282] = 812,
  [2283] = 2283,
  [2284] = 808,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2283,
  [2289] = 2287,
  [2290] = 2290,
  [2291] = 148,
  [2292] = 2285,
  [2293] = 2275,
  [2294] = 2294,
  [2295] = 151,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2168,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2312,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2313,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2325,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2339,
  [2342] = 2323,
  [2343] = 2340,
  [2344] = 2344,
  [2345] = 1220,
  [2346] = 1222,
  [2347] = 1223,
  [2348] = 1328,
  [2349] = 1325,
  [2350] = 1267,
  [2351] = 1264,
  [2352] = 1372,
  [2353] = 1359,
  [2354] = 1272,
  [2355] = 1263,
  [2356] = 1269,
  [2357] = 1375,
  [2358] = 1261,
  [2359] = 1280,
  [2360] = 1342,
  [2361] = 1294,
  [2362] = 1250,
  [2363] = 1254,
  [2364] = 1351,
  [2365] = 1382,
  [2366] = 1251,
  [2367] = 1305,
  [2368] = 1332,
  [2369] = 1252,
  [2370] = 1292,
  [2371] = 1257,
  [2372] = 1326,
  [2373] = 1293,
  [2374] = 1299,
  [2375] = 1311,
  [2376] = 1310,
  [2377] = 1304,
  [2378] = 1368,
  [2379] = 1301,
  [2380] = 1379,
  [2381] = 1300,
  [2382] = 1219,
  [2383] = 1223,
  [2384] = 1308,
  [2385] = 1249,
  [2386] = 1383,
  [2387] = 1357,
  [2388] = 1237,
  [2389] = 1255,
  [2390] = 1340,
  [2391] = 1220,
  [2392] = 1222,
  [2393] = 1241,
  [2394] = 1245,
  [2395] = 155,
  [2396] = 146,
  [2397] = 1227,
  [2398] = 1253,
  [2399] = 1261,
  [2400] = 1235,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 1363,
  [2404] = 1270,
  [2405] = 1220,
  [2406] = 1275,
  [2407] = 2407,
  [2408] = 2407,
  [2409] = 1222,
  [2410] = 1223,
  [2411] = 2407,
  [2412] = 1321,
  [2413] = 1284,
  [2414] = 2407,
  [2415] = 1290,
  [2416] = 1369,
  [2417] = 1337,
  [2418] = 2418,
  [2419] = 2407,
  [2420] = 1378,
  [2421] = 1233,
  [2422] = 1331,
  [2423] = 1341,
  [2424] = 2424,
  [2425] = 2402,
  [2426] = 1352,
  [2427] = 1359,
  [2428] = 1351,
  [2429] = 1332,
  [2430] = 1328,
  [2431] = 1326,
  [2432] = 1325,
  [2433] = 1311,
  [2434] = 1310,
  [2435] = 1304,
  [2436] = 1301,
  [2437] = 1300,
  [2438] = 1299,
  [2439] = 1293,
  [2440] = 1292,
  [2441] = 2401,
  [2442] = 2401,
  [2443] = 1380,
  [2444] = 1329,
  [2445] = 1323,
  [2446] = 1234,
  [2447] = 1260,
  [2448] = 2424,
  [2449] = 2407,
  [2450] = 2418,
  [2451] = 2407,
  [2452] = 2402,
  [2453] = 2424,
  [2454] = 1259,
  [2455] = 2401,
  [2456] = 1265,
  [2457] = 1379,
  [2458] = 1305,
  [2459] = 1251,
  [2460] = 1254,
  [2461] = 1333,
  [2462] = 1264,
  [2463] = 1267,
  [2464] = 1269,
  [2465] = 1280,
  [2466] = 1294,
  [2467] = 2418,
  [2468] = 1268,
  [2469] = 2402,
  [2470] = 1287,
  [2471] = 2407,
  [2472] = 1219,
  [2473] = 1342,
  [2474] = 1272,
  [2475] = 1263,
  [2476] = 1382,
  [2477] = 1257,
  [2478] = 1252,
  [2479] = 1250,
  [2480] = 1375,
  [2481] = 1372,
  [2482] = 1368,
  [2483] = 1266,
  [2484] = 1303,
  [2485] = 1274,
  [2486] = 2402,
  [2487] = 1279,
  [2488] = 2401,
  [2489] = 2424,
  [2490] = 1343,
  [2491] = 2418,
  [2492] = 2424,
  [2493] = 1350,
  [2494] = 1354,
  [2495] = 2418,
  [2496] = 1376,
  [2497] = 1356,
  [2498] = 1365,
  [2499] = 1358,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 1353,
  [2504] = 1273,
  [2505] = 2505,
  [2506] = 2505,
  [2507] = 2505,
  [2508] = 2505,
  [2509] = 2509,
  [2510] = 2510,
  [2511] = 2505,
  [2512] = 1371,
  [2513] = 1237,
  [2514] = 1362,
  [2515] = 1370,
  [2516] = 2505,
  [2517] = 1277,
  [2518] = 1339,
  [2519] = 1335,
  [2520] = 2520,
  [2521] = 2521,
  [2522] = 2522,
  [2523] = 1282,
  [2524] = 1364,
  [2525] = 2525,
  [2526] = 1245,
  [2527] = 1304,
  [2528] = 2528,
  [2529] = 1328,
  [2530] = 1326,
  [2531] = 1351,
  [2532] = 1301,
  [2533] = 1325,
  [2534] = 1383,
  [2535] = 1357,
  [2536] = 1368,
  [2537] = 2537,
  [2538] = 2538,
  [2539] = 1300,
  [2540] = 1332,
  [2541] = 1299,
  [2542] = 1372,
  [2543] = 1311,
  [2544] = 1375,
  [2545] = 1250,
  [2546] = 1293,
  [2547] = 1340,
  [2548] = 2548,
  [2549] = 1252,
  [2550] = 811,
  [2551] = 1292,
  [2552] = 1219,
  [2553] = 1310,
  [2554] = 2554,
  [2555] = 1359,
  [2556] = 1308,
  [2557] = 1257,
  [2558] = 2558,
  [2559] = 1379,
  [2560] = 812,
  [2561] = 1305,
  [2562] = 1382,
  [2563] = 1263,
  [2564] = 1272,
  [2565] = 1249,
  [2566] = 1251,
  [2567] = 1342,
  [2568] = 1254,
  [2569] = 2569,
  [2570] = 2570,
  [2571] = 1294,
  [2572] = 1280,
  [2573] = 2573,
  [2574] = 1261,
  [2575] = 1264,
  [2576] = 808,
  [2577] = 2577,
  [2578] = 1267,
  [2579] = 1269,
  [2580] = 1255,
  [2581] = 1222,
  [2582] = 2582,
  [2583] = 2583,
  [2584] = 1220,
  [2585] = 2585,
  [2586] = 2586,
  [2587] = 1234,
  [2588] = 2588,
  [2589] = 2589,
  [2590] = 2590,
  [2591] = 1223,
  [2592] = 2592,
  [2593] = 2593,
  [2594] = 2589,
  [2595] = 2589,
  [2596] = 1235,
  [2597] = 2589,
  [2598] = 1241,
  [2599] = 1227,
  [2600] = 2600,
  [2601] = 2601,
  [2602] = 2602,
  [2603] = 2603,
  [2604] = 2604,
  [2605] = 2605,
  [2606] = 2606,
  [2607] = 2607,
  [2608] = 1233,
  [2609] = 2609,
  [2610] = 1237,
  [2611] = 155,
  [2612] = 2612,
  [2613] = 146,
  [2614] = 2589,
  [2615] = 2615,
  [2616] = 993,
  [2617] = 1356,
  [2618] = 1321,
  [2619] = 1383,
  [2620] = 1323,
  [2621] = 1308,
  [2622] = 994,
  [2623] = 2623,
  [2624] = 808,
  [2625] = 546,
  [2626] = 1249,
  [2627] = 1380,
  [2628] = 1255,
  [2629] = 2629,
  [2630] = 1357,
  [2631] = 1376,
  [2632] = 1253,
  [2633] = 1303,
  [2634] = 1371,
  [2635] = 2635,
  [2636] = 1365,
  [2637] = 1362,
  [2638] = 1352,
  [2639] = 1358,
  [2640] = 1340,
  [2641] = 1378,
  [2642] = 1370,
  [2643] = 1369,
  [2644] = 811,
  [2645] = 990,
  [2646] = 1329,
  [2647] = 1364,
  [2648] = 1260,
  [2649] = 1265,
  [2650] = 1268,
  [2651] = 1274,
  [2652] = 812,
  [2653] = 1273,
  [2654] = 1279,
  [2655] = 1266,
  [2656] = 547,
  [2657] = 1363,
  [2658] = 1287,
  [2659] = 1354,
  [2660] = 1259,
  [2661] = 1337,
  [2662] = 1333,
  [2663] = 1245,
  [2664] = 550,
  [2665] = 1341,
  [2666] = 1343,
  [2667] = 548,
  [2668] = 1339,
  [2669] = 1335,
  [2670] = 1282,
  [2671] = 1350,
  [2672] = 1270,
  [2673] = 1275,
  [2674] = 1277,
  [2675] = 1284,
  [2676] = 1290,
  [2677] = 549,
  [2678] = 1353,
  [2679] = 1331,
  [2680] = 2680,
  [2681] = 1241,
  [2682] = 2682,
  [2683] = 2683,
  [2684] = 2684,
  [2685] = 2685,
  [2686] = 2686,
  [2687] = 2687,
  [2688] = 2687,
  [2689] = 2689,
  [2690] = 1219,
  [2691] = 2685,
  [2692] = 1233,
  [2693] = 2693,
  [2694] = 1234,
  [2695] = 2695,
  [2696] = 1235,
  [2697] = 2697,
  [2698] = 2698,
  [2699] = 2685,
  [2700] = 1227,
  [2701] = 2701,
  [2702] = 2693,
  [2703] = 2703,
  [2704] = 2704,
  [2705] = 2703,
  [2706] = 2693,
  [2707] = 1371,
  [2708] = 993,
  [2709] = 1356,
  [2710] = 1358,
  [2711] = 1362,
  [2712] = 1365,
  [2713] = 2713,
  [2714] = 1376,
  [2715] = 1380,
  [2716] = 990,
  [2717] = 2695,
  [2718] = 2718,
  [2719] = 2719,
  [2720] = 2720,
  [2721] = 2720,
  [2722] = 2722,
  [2723] = 1354,
  [2724] = 1335,
  [2725] = 2720,
  [2726] = 2726,
  [2727] = 546,
  [2728] = 1253,
  [2729] = 1303,
  [2730] = 1321,
  [2731] = 1339,
  [2732] = 2732,
  [2733] = 2722,
  [2734] = 2734,
  [2735] = 2735,
  [2736] = 1323,
  [2737] = 1329,
  [2738] = 1352,
  [2739] = 1378,
  [2740] = 1370,
  [2741] = 994,
  [2742] = 1369,
  [2743] = 1364,
  [2744] = 1363,
  [2745] = 2719,
  [2746] = 2719,
  [2747] = 1353,
  [2748] = 549,
  [2749] = 1350,
  [2750] = 1343,
  [2751] = 1341,
  [2752] = 550,
  [2753] = 155,
  [2754] = 2686,
  [2755] = 2589,
  [2756] = 2756,
  [2757] = 1287,
  [2758] = 1279,
  [2759] = 990,
  [2760] = 2589,
  [2761] = 2761,
  [2762] = 1274,
  [2763] = 1290,
  [2764] = 1284,
  [2765] = 1268,
  [2766] = 1265,
  [2767] = 1277,
  [2768] = 994,
  [2769] = 1275,
  [2770] = 1270,
  [2771] = 1282,
  [2772] = 1260,
  [2773] = 2773,
  [2774] = 2761,
  [2775] = 548,
  [2776] = 2776,
  [2777] = 2777,
  [2778] = 2777,
  [2779] = 2779,
  [2780] = 2589,
  [2781] = 993,
  [2782] = 2782,
  [2783] = 2773,
  [2784] = 2784,
  [2785] = 1331,
  [2786] = 1333,
  [2787] = 1337,
  [2788] = 1259,
  [2789] = 2789,
  [2790] = 547,
  [2791] = 2791,
  [2792] = 2680,
  [2793] = 2793,
  [2794] = 2794,
  [2795] = 2589,
  [2796] = 2589,
  [2797] = 1237,
  [2798] = 2798,
  [2799] = 2589,
  [2800] = 2800,
  [2801] = 1266,
  [2802] = 2791,
  [2803] = 1273,
  [2804] = 2804,
  [2805] = 146,
  [2806] = 2589,
  [2807] = 2779,
  [2808] = 132,
  [2809] = 812,
  [2810] = 808,
  [2811] = 1245,
  [2812] = 811,
  [2813] = 2813,
  [2814] = 2814,
  [2815] = 2815,
  [2816] = 2816,
  [2817] = 141,
  [2818] = 2814,
  [2819] = 2814,
  [2820] = 2814,
  [2821] = 2814,
  [2822] = 2814,
  [2823] = 2695,
  [2824] = 2814,
  [2825] = 2814,
  [2826] = 2826,
  [2827] = 2827,
  [2828] = 2816,
  [2829] = 2829,
  [2830] = 2830,
  [2831] = 2831,
  [2832] = 2832,
  [2833] = 2833,
  [2834] = 2834,
  [2835] = 2835,
  [2836] = 2836,
  [2837] = 2837,
  [2838] = 2838,
  [2839] = 2839,
  [2840] = 2840,
  [2841] = 2841,
  [2842] = 2842,
  [2843] = 2843,
  [2844] = 2844,
  [2845] = 2845,
  [2846] = 2846,
  [2847] = 2847,
  [2848] = 2718,
  [2849] = 2849,
  [2850] = 2756,
  [2851] = 2735,
  [2852] = 1233,
  [2853] = 2849,
  [2854] = 2854,
  [2855] = 2841,
  [2856] = 2856,
  [2857] = 2857,
  [2858] = 2858,
  [2859] = 2859,
  [2860] = 2860,
  [2861] = 2861,
  [2862] = 2862,
  [2863] = 2863,
  [2864] = 2864,
  [2865] = 2865,
  [2866] = 2701,
  [2867] = 2867,
  [2868] = 2868,
  [2869] = 2857,
  [2870] = 2635,
  [2871] = 2871,
  [2872] = 2872,
  [2873] = 2858,
  [2874] = 2874,
  [2875] = 1234,
  [2876] = 1235,
  [2877] = 2877,
  [2878] = 2878,
  [2879] = 2879,
  [2880] = 2782,
  [2881] = 2881,
  [2882] = 2833,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2885,
  [2886] = 2804,
  [2887] = 2887,
  [2888] = 2888,
  [2889] = 2889,
  [2890] = 2890,
  [2891] = 2891,
  [2892] = 2892,
  [2893] = 2893,
  [2894] = 2894,
  [2895] = 2895,
  [2896] = 2872,
  [2897] = 2897,
  [2898] = 2898,
  [2899] = 2899,
  [2900] = 2900,
  [2901] = 2901,
  [2902] = 2902,
  [2903] = 2903,
  [2904] = 2903,
  [2905] = 2899,
  [2906] = 2906,
  [2907] = 138,
  [2908] = 2864,
  [2909] = 2909,
  [2910] = 2836,
  [2911] = 2895,
  [2912] = 2912,
  [2913] = 2913,
  [2914] = 2914,
  [2915] = 2915,
  [2916] = 2916,
  [2917] = 2846,
  [2918] = 2918,
  [2919] = 2919,
  [2920] = 2920,
  [2921] = 2921,
  [2922] = 2909,
  [2923] = 2894,
  [2924] = 2894,
  [2925] = 2887,
  [2926] = 2894,
  [2927] = 2898,
  [2928] = 2897,
  [2929] = 2929,
  [2930] = 2930,
  [2931] = 2898,
  [2932] = 2831,
  [2933] = 2832,
  [2934] = 2894,
  [2935] = 2841,
  [2936] = 2894,
  [2937] = 156,
  [2938] = 143,
  [2939] = 2846,
  [2940] = 2940,
  [2941] = 2941,
  [2942] = 2902,
  [2943] = 2909,
  [2944] = 2941,
  [2945] = 2945,
  [2946] = 2946,
  [2947] = 2947,
  [2948] = 2948,
  [2949] = 2686,
  [2950] = 2950,
  [2951] = 2951,
  [2952] = 2952,
  [2953] = 2953,
  [2954] = 2954,
  [2955] = 2865,
  [2956] = 2956,
  [2957] = 2954,
  [2958] = 2958,
  [2959] = 2959,
  [2960] = 2960,
  [2961] = 2961,
  [2962] = 2962,
  [2963] = 2680,
  [2964] = 2964,
  [2965] = 2965,
  [2966] = 2867,
  [2967] = 2863,
  [2968] = 2968,
  [2969] = 2629,
  [2970] = 2970,
  [2971] = 2861,
  [2972] = 2860,
  [2973] = 2960,
  [2974] = 2974,
  [2975] = 2975,
  [2976] = 2856,
  [2977] = 2962,
  [2978] = 2978,
  [2979] = 2952,
  [2980] = 2953,
  [2981] = 2981,
  [2982] = 2951,
  [2983] = 2854,
  [2984] = 2954,
  [2985] = 2985,
  [2986] = 2868,
  [2987] = 2987,
  [2988] = 2988,
  [2989] = 2989,
  [2990] = 2948,
  [2991] = 2952,
  [2992] = 2960,
  [2993] = 2993,
  [2994] = 547,
  [2995] = 2989,
  [2996] = 548,
  [2997] = 549,
  [2998] = 2989,
  [2999] = 2999,
  [3000] = 3000,
  [3001] = 2964,
  [3002] = 3002,
  [3003] = 2959,
  [3004] = 3004,
  [3005] = 2960,
  [3006] = 3006,
  [3007] = 550,
  [3008] = 546,
  [3009] = 2956,
  [3010] = 3010,
  [3011] = 2960,
  [3012] = 2989,
  [3013] = 3013,
  [3014] = 3014,
  [3015] = 2871,
  [3016] = 2879,
  [3017] = 3017,
  [3018] = 3018,
  [3019] = 3019,
  [3020] = 3020,
  [3021] = 2964,
  [3022] = 2884,
  [3023] = 3023,
  [3024] = 3024,
  [3025] = 3025,
  [3026] = 3026,
  [3027] = 3027,
  [3028] = 2959,
  [3029] = 3029,
  [3030] = 2989,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 3033,
  [3034] = 2956,
  [3035] = 2889,
  [3036] = 2960,
  [3037] = 2890,
  [3038] = 2989,
  [3039] = 2843,
  [3040] = 2891,
  [3041] = 2901,
  [3042] = 3042,
  [3043] = 3043,
  [3044] = 2847,
  [3045] = 3018,
  [3046] = 1273,
  [3047] = 2961,
  [3048] = 2975,
  [3049] = 2842,
  [3050] = 2915,
  [3051] = 2964,
  [3052] = 3052,
  [3053] = 2959,
  [3054] = 3054,
  [3055] = 2956,
  [3056] = 2964,
  [3057] = 2959,
  [3058] = 2835,
  [3059] = 2862,
  [3060] = 3060,
  [3061] = 3052,
  [3062] = 2950,
  [3063] = 3063,
  [3064] = 1339,
  [3065] = 1335,
  [3066] = 3066,
  [3067] = 1282,
  [3068] = 1277,
  [3069] = 3069,
  [3070] = 2956,
  [3071] = 2974,
  [3072] = 2837,
  [3073] = 2956,
  [3074] = 3074,
  [3075] = 3075,
  [3076] = 1353,
  [3077] = 1362,
  [3078] = 1371,
  [3079] = 3079,
  [3080] = 2839,
  [3081] = 3074,
  [3082] = 3082,
  [3083] = 2840,
  [3084] = 3084,
  [3085] = 2945,
  [3086] = 1364,
  [3087] = 1370,
  [3088] = 3088,
  [3089] = 3020,
  [3090] = 2959,
  [3091] = 2964,
  [3092] = 3063,
  [3093] = 2919,
  [3094] = 3094,
  [3095] = 3095,
  [3096] = 3096,
  [3097] = 655,
  [3098] = 3098,
  [3099] = 654,
  [3100] = 3100,
  [3101] = 653,
  [3102] = 3102,
  [3103] = 652,
  [3104] = 3104,
  [3105] = 3105,
  [3106] = 3106,
  [3107] = 634,
  [3108] = 3108,
  [3109] = 3105,
  [3110] = 625,
  [3111] = 3111,
  [3112] = 3112,
  [3113] = 609,
  [3114] = 604,
  [3115] = 3115,
  [3116] = 672,
  [3117] = 620,
  [3118] = 3118,
  [3119] = 3119,
  [3120] = 3120,
  [3121] = 673,
  [3122] = 3122,
  [3123] = 731,
  [3124] = 736,
  [3125] = 737,
  [3126] = 739,
  [3127] = 754,
  [3128] = 760,
  [3129] = 766,
  [3130] = 752,
  [3131] = 3131,
  [3132] = 3111,
  [3133] = 3031,
  [3134] = 684,
  [3135] = 656,
  [3136] = 3136,
  [3137] = 3137,
  [3138] = 657,
  [3139] = 685,
  [3140] = 690,
  [3141] = 659,
  [3142] = 3142,
  [3143] = 694,
  [3144] = 3144,
  [3145] = 3145,
  [3146] = 755,
  [3147] = 3147,
  [3148] = 3108,
  [3149] = 3149,
  [3150] = 695,
  [3151] = 757,
  [3152] = 730,
  [3153] = 761,
  [3154] = 2906,
  [3155] = 608,
  [3156] = 765,
  [3157] = 764,
  [3158] = 601,
  [3159] = 763,
  [3160] = 742,
  [3161] = 762,
  [3162] = 3162,
  [3163] = 3095,
  [3164] = 605,
  [3165] = 698,
  [3166] = 618,
  [3167] = 3100,
  [3168] = 3168,
  [3169] = 697,
  [3170] = 3170,
  [3171] = 3171,
  [3172] = 746,
  [3173] = 745,
  [3174] = 3149,
  [3175] = 662,
  [3176] = 3176,
  [3177] = 744,
  [3178] = 3178,
  [3179] = 658,
  [3180] = 3180,
  [3181] = 647,
  [3182] = 3182,
  [3183] = 3183,
  [3184] = 3184,
  [3185] = 3185,
  [3186] = 3186,
  [3187] = 3187,
  [3188] = 3188,
  [3189] = 3189,
  [3190] = 743,
  [3191] = 735,
  [3192] = 3029,
  [3193] = 3193,
  [3194] = 642,
  [3195] = 641,
  [3196] = 3196,
  [3197] = 3197,
  [3198] = 637,
  [3199] = 3033,
  [3200] = 3200,
  [3201] = 3201,
  [3202] = 622,
  [3203] = 3203,
  [3204] = 3189,
  [3205] = 3205,
  [3206] = 682,
  [3207] = 602,
  [3208] = 616,
  [3209] = 3209,
  [3210] = 613,
  [3211] = 3211,
  [3212] = 679,
  [3213] = 3213,
  [3214] = 3131,
  [3215] = 675,
  [3216] = 3216,
  [3217] = 3217,
  [3218] = 3218,
  [3219] = 3219,
  [3220] = 3220,
  [3221] = 3213,
  [3222] = 3222,
  [3223] = 759,
  [3224] = 756,
  [3225] = 768,
  [3226] = 646,
  [3227] = 677,
  [3228] = 3228,
  [3229] = 741,
  [3230] = 3112,
  [3231] = 3231,
  [3232] = 615,
  [3233] = 3233,
  [3234] = 3205,
  [3235] = 732,
  [3236] = 3236,
  [3237] = 3115,
  [3238] = 3238,
  [3239] = 3239,
  [3240] = 3240,
  [3241] = 3241,
  [3242] = 696,
  [3243] = 2900,
  [3244] = 2883,
  [3245] = 626,
  [3246] = 748,
  [3247] = 3024,
  [3248] = 3248,
  [3249] = 645,
  [3250] = 3250,
  [3251] = 3251,
  [3252] = 716,
  [3253] = 713,
  [3254] = 674,
  [3255] = 3255,
  [3256] = 3256,
  [3257] = 3257,
  [3258] = 3258,
  [3259] = 3259,
  [3260] = 3260,
  [3261] = 3261,
  [3262] = 3186,
  [3263] = 3241,
  [3264] = 3176,
  [3265] = 3265,
  [3266] = 3236,
  [3267] = 3267,
  [3268] = 3268,
  [3269] = 3269,
  [3270] = 3270,
  [3271] = 636,
  [3272] = 3170,
  [3273] = 3273,
  [3274] = 3274,
  [3275] = 3275,
  [3276] = 3115,
  [3277] = 3277,
  [3278] = 3278,
  [3279] = 3279,
  [3280] = 3280,
  [3281] = 3119,
  [3282] = 3120,
  [3283] = 3283,
  [3284] = 3284,
  [3285] = 3285,
  [3286] = 3286,
  [3287] = 160,
  [3288] = 3238,
  [3289] = 3289,
  [3290] = 3290,
  [3291] = 3291,
  [3292] = 3292,
  [3293] = 3293,
  [3294] = 3098,
  [3295] = 3239,
  [3296] = 150,
  [3297] = 3096,
  [3298] = 3298,
  [3299] = 3299,
  [3300] = 3300,
  [3301] = 3301,
  [3302] = 3302,
  [3303] = 3122,
  [3304] = 3304,
  [3305] = 3305,
  [3306] = 3306,
  [3307] = 3228,
  [3308] = 3308,
  [3309] = 3309,
  [3310] = 3310,
  [3311] = 3311,
  [3312] = 3305,
  [3313] = 3203,
  [3314] = 3314,
  [3315] = 3315,
  [3316] = 3316,
  [3317] = 3238,
  [3318] = 3251,
  [3319] = 1357,
  [3320] = 3320,
  [3321] = 3321,
  [3322] = 3322,
  [3323] = 3238,
  [3324] = 3324,
  [3325] = 3273,
  [3326] = 3326,
  [3327] = 3170,
  [3328] = 3176,
  [3329] = 3273,
  [3330] = 3330,
  [3331] = 3305,
  [3332] = 3332,
  [3333] = 3333,
  [3334] = 3334,
  [3335] = 3335,
  [3336] = 3311,
  [3337] = 3298,
  [3338] = 3104,
  [3339] = 3180,
  [3340] = 3340,
  [3341] = 3238,
  [3342] = 3342,
  [3343] = 2874,
  [3344] = 3344,
  [3345] = 3185,
  [3346] = 3346,
  [3347] = 3347,
  [3348] = 3348,
  [3349] = 3349,
  [3350] = 3350,
  [3351] = 3351,
  [3352] = 3305,
  [3353] = 3353,
  [3354] = 3354,
  [3355] = 3355,
  [3356] = 3112,
  [3357] = 3186,
  [3358] = 3358,
  [3359] = 1383,
  [3360] = 3305,
  [3361] = 3233,
  [3362] = 3362,
  [3363] = 3363,
  [3364] = 3364,
  [3365] = 3205,
  [3366] = 3366,
  [3367] = 3367,
  [3368] = 3368,
  [3369] = 3369,
  [3370] = 3333,
  [3371] = 3371,
  [3372] = 3372,
  [3373] = 3373,
  [3374] = 3374,
  [3375] = 3375,
  [3376] = 3376,
  [3377] = 3375,
  [3378] = 3375,
  [3379] = 3375,
  [3380] = 3380,
  [3381] = 3381,
  [3382] = 3382,
  [3383] = 3383,
  [3384] = 3384,
  [3385] = 3385,
  [3386] = 3384,
  [3387] = 3383,
  [3388] = 3388,
  [3389] = 3389,
  [3390] = 3390,
  [3391] = 3382,
  [3392] = 3392,
  [3393] = 3393,
  [3394] = 3394,
  [3395] = 3372,
  [3396] = 3396,
  [3397] = 3397,
  [3398] = 3388,
  [3399] = 3389,
  [3400] = 3400,
  [3401] = 3380,
  [3402] = 3375,
  [3403] = 3403,
  [3404] = 3404,
  [3405] = 3385,
  [3406] = 3406,
  [3407] = 3407,
  [3408] = 3376,
  [3409] = 3409,
  [3410] = 3410,
  [3411] = 3411,
  [3412] = 3412,
  [3413] = 3403,
  [3414] = 3374,
  [3415] = 3373,
  [3416] = 3385,
  [3417] = 3417,
  [3418] = 3418,
  [3419] = 3419,
  [3420] = 3420,
  [3421] = 3421,
  [3422] = 3403,
  [3423] = 3423,
  [3424] = 3424,
  [3425] = 3425,
  [3426] = 3426,
  [3427] = 3427,
  [3428] = 3403,
  [3429] = 3385,
  [3430] = 3406,
  [3431] = 3407,
  [3432] = 3432,
  [3433] = 3433,
  [3434] = 3434,
  [3435] = 3403,
  [3436] = 3419,
  [3437] = 3437,
  [3438] = 3393,
  [3439] = 3420,
  [3440] = 3440,
  [3441] = 3385,
  [3442] = 3373,
  [3443] = 3374,
  [3444] = 3424,
  [3445] = 3445,
  [3446] = 3446,
  [3447] = 3447,
  [3448] = 3448,
  [3449] = 3375,
  [3450] = 3450,
  [3451] = 3372,
  [3452] = 3420,
  [3453] = 3453,
  [3454] = 3454,
  [3455] = 3455,
  [3456] = 3423,
  [3457] = 3372,
  [3458] = 3458,
  [3459] = 3419,
  [3460] = 3388,
  [3461] = 3389,
  [3462] = 3453,
  [3463] = 3403,
  [3464] = 3464,
  [3465] = 3465,
  [3466] = 3385,
  [3467] = 3381,
  [3468] = 3419,
  [3469] = 3469,
  [3470] = 3470,
  [3471] = 3471,
  [3472] = 3472,
  [3473] = 3473,
  [3474] = 3420,
  [3475] = 3475,
  [3476] = 3389,
  [3477] = 3388,
  [3478] = 3374,
  [3479] = 3373,
  [3480] = 3423,
  [3481] = 3392,
  [3482] = 3419,
  [3483] = 3389,
  [3484] = 3388,
  [3485] = 3374,
  [3486] = 3373,
  [3487] = 3423,
  [3488] = 3372,
  [3489] = 3373,
  [3490] = 3374,
  [3491] = 3420,
  [3492] = 3389,
  [3493] = 3419,
  [3494] = 3389,
  [3495] = 3388,
  [3496] = 3374,
  [3497] = 3373,
  [3498] = 3423,
  [3499] = 3388,
  [3500] = 3423,
  [3501] = 3501,
  [3502] = 3502,
  [3503] = 3503,
  [3504] = 3504,
  [3505] = 3505,
  [3506] = 3506,
  [3507] = 3507,
  [3508] = 3508,
  [3509] = 3509,
  [3510] = 3510,
  [3511] = 3511,
  [3512] = 3512,
  [3513] = 3513,
  [3514] = 3514,
  [3515] = 3503,
  [3516] = 3516,
  [3517] = 3517,
  [3518] = 3518,
  [3519] = 3519,
  [3520] = 3520,
  [3521] = 3521,
  [3522] = 3522,
  [3523] = 3523,
  [3524] = 3524,
  [3525] = 3525,
  [3526] = 3526,
  [3527] = 3527,
  [3528] = 3528,
  [3529] = 3529,
  [3530] = 3530,
  [3531] = 3531,
  [3532] = 3532,
  [3533] = 2887,
  [3534] = 3534,
  [3535] = 3535,
  [3536] = 3536,
  [3537] = 3537,
  [3538] = 3538,
  [3539] = 3539,
  [3540] = 3540,
  [3541] = 3541,
  [3542] = 3542,
  [3543] = 3543,
  [3544] = 3544,
  [3545] = 3545,
  [3546] = 3546,
  [3547] = 2945,
  [3548] = 3548,
  [3549] = 3549,
  [3550] = 3550,
  [3551] = 3551,
  [3552] = 3552,
  [3553] = 3553,
  [3554] = 3554,
  [3555] = 3555,
  [3556] = 3556,
  [3557] = 3557,
  [3558] = 2901,
  [3559] = 3519,
  [3560] = 3560,
  [3561] = 3557,
  [3562] = 3511,
  [3563] = 3519,
  [3564] = 3564,
  [3565] = 3565,
  [3566] = 3566,
  [3567] = 3567,
  [3568] = 3545,
  [3569] = 3554,
  [3570] = 3570,
  [3571] = 3571,
  [3572] = 3521,
  [3573] = 3557,
  [3574] = 3529,
  [3575] = 3575,
  [3576] = 3511,
  [3577] = 3577,
  [3578] = 3518,
  [3579] = 3579,
  [3580] = 3518,
  [3581] = 3521,
  [3582] = 3552,
  [3583] = 3583,
  [3584] = 3512,
  [3585] = 3585,
  [3586] = 3586,
  [3587] = 3545,
  [3588] = 1358,
  [3589] = 3552,
  [3590] = 3590,
  [3591] = 3583,
  [3592] = 3554,
  [3593] = 3586,
  [3594] = 3594,
  [3595] = 3507,
  [3596] = 3596,
  [3597] = 3597,
  [3598] = 3598,
  [3599] = 3518,
  [3600] = 3508,
  [3601] = 3521,
  [3602] = 3507,
  [3603] = 3603,
  [3604] = 3604,
  [3605] = 3577,
  [3606] = 3606,
  [3607] = 3583,
  [3608] = 3118,
  [3609] = 3586,
  [3610] = 3590,
  [3611] = 3611,
  [3612] = 3612,
  [3613] = 3507,
  [3614] = 3614,
  [3615] = 3615,
  [3616] = 3616,
  [3617] = 1380,
  [3618] = 3618,
  [3619] = 3619,
  [3620] = 3620,
  [3621] = 3621,
  [3622] = 3622,
  [3623] = 3567,
  [3624] = 3544,
  [3625] = 3625,
  [3626] = 3626,
  [3627] = 3521,
  [3628] = 3628,
  [3629] = 3518,
  [3630] = 3543,
  [3631] = 3631,
  [3632] = 3632,
  [3633] = 3633,
  [3634] = 3634,
  [3635] = 3635,
  [3636] = 3508,
  [3637] = 3637,
  [3638] = 3638,
  [3639] = 3639,
  [3640] = 3511,
  [3641] = 3641,
  [3642] = 3508,
  [3643] = 3643,
  [3644] = 3644,
  [3645] = 3596,
  [3646] = 3646,
  [3647] = 3647,
  [3648] = 3648,
  [3649] = 3511,
  [3650] = 3650,
  [3651] = 3518,
  [3652] = 3521,
  [3653] = 3653,
  [3654] = 3654,
  [3655] = 3655,
  [3656] = 3656,
  [3657] = 3508,
  [3658] = 3209,
  [3659] = 3557,
  [3660] = 3660,
  [3661] = 3661,
  [3662] = 3557,
  [3663] = 3541,
  [3664] = 3531,
  [3665] = 3532,
  [3666] = 3510,
  [3667] = 3661,
  [3668] = 3554,
  [3669] = 3650,
  [3670] = 3611,
  [3671] = 3554,
  [3672] = 3672,
  [3673] = 3518,
  [3674] = 3521,
  [3675] = 3508,
  [3676] = 3676,
  [3677] = 3677,
  [3678] = 3678,
  [3679] = 3660,
  [3680] = 3680,
  [3681] = 3681,
  [3682] = 3682,
  [3683] = 3542,
  [3684] = 3684,
  [3685] = 2919,
  [3686] = 3632,
  [3687] = 3687,
  [3688] = 3637,
  [3689] = 3689,
  [3690] = 3509,
  [3691] = 3508,
  [3692] = 3557,
  [3693] = 3693,
  [3694] = 3694,
  [3695] = 3695,
  [3696] = 3696,
  [3697] = 3697,
  [3698] = 3698,
  [3699] = 3699,
  [3700] = 3700,
  [3701] = 3523,
  [3702] = 3702,
  [3703] = 3703,
  [3704] = 3704,
  [3705] = 610,
  [3706] = 3527,
  [3707] = 3528,
  [3708] = 3511,
  [3709] = 3709,
  [3710] = 3710,
  [3711] = 3711,
  [3712] = 3504,
  [3713] = 3626,
  [3714] = 3714,
  [3715] = 3715,
  [3716] = 3716,
  [3717] = 3520,
  [3718] = 3510,
  [3719] = 3719,
  [3720] = 2915,
  [3721] = 3316,
  [3722] = 3722,
  [3723] = 3723,
  [3724] = 3711,
  [3725] = 3597,
  [3726] = 3507,
  [3727] = 3727,
  [3728] = 3728,
  [3729] = 3621,
  [3730] = 3540,
  [3731] = 3653,
  [3732] = 3732,
  [3733] = 3733,
  [3734] = 3734,
  [3735] = 2226,
  [3736] = 3736,
  [3737] = 3737,
  [3738] = 3738,
  [3739] = 3739,
  [3740] = 3738,
  [3741] = 3741,
  [3742] = 3742,
  [3743] = 3743,
  [3744] = 3744,
  [3745] = 3745,
  [3746] = 3746,
  [3747] = 3747,
  [3748] = 3748,
  [3749] = 3749,
  [3750] = 3750,
  [3751] = 3751,
  [3752] = 3752,
  [3753] = 3753,
  [3754] = 3754,
  [3755] = 3754,
  [3756] = 3756,
  [3757] = 3757,
  [3758] = 3758,
  [3759] = 3759,
  [3760] = 3760,
  [3761] = 3761,
  [3762] = 3762,
  [3763] = 3763,
  [3764] = 3764,
  [3765] = 3765,
  [3766] = 3766,
  [3767] = 3767,
  [3768] = 3768,
  [3769] = 3769,
  [3770] = 3770,
  [3771] = 3771,
  [3772] = 3772,
  [3773] = 3773,
  [3774] = 3764,
  [3775] = 3748,
  [3776] = 3776,
  [3777] = 2237,
  [3778] = 3778,
  [3779] = 3779,
  [3780] = 3780,
  [3781] = 2236,
  [3782] = 3782,
  [3783] = 3783,
  [3784] = 3784,
  [3785] = 3785,
  [3786] = 3761,
  [3787] = 3787,
  [3788] = 3788,
  [3789] = 3789,
  [3790] = 3745,
  [3791] = 3791,
  [3792] = 3792,
  [3793] = 3734,
  [3794] = 3794,
  [3795] = 3767,
  [3796] = 3761,
  [3797] = 3785,
  [3798] = 3798,
  [3799] = 3799,
  [3800] = 3751,
  [3801] = 3801,
  [3802] = 3802,
  [3803] = 3803,
  [3804] = 3804,
  [3805] = 3805,
  [3806] = 3768,
  [3807] = 3807,
  [3808] = 3808,
  [3809] = 3738,
  [3810] = 3810,
  [3811] = 3811,
  [3812] = 3812,
  [3813] = 3813,
  [3814] = 3814,
  [3815] = 3784,
  [3816] = 3764,
  [3817] = 3817,
  [3818] = 3818,
  [3819] = 2241,
  [3820] = 3785,
  [3821] = 3821,
  [3822] = 3822,
  [3823] = 3823,
  [3824] = 3824,
  [3825] = 3825,
  [3826] = 3779,
  [3827] = 3827,
  [3828] = 3828,
  [3829] = 3829,
  [3830] = 3830,
  [3831] = 3776,
  [3832] = 3832,
  [3833] = 3833,
  [3834] = 3761,
  [3835] = 3767,
  [3836] = 3836,
  [3837] = 3794,
  [3838] = 3838,
  [3839] = 3839,
  [3840] = 3782,
  [3841] = 3841,
  [3842] = 3842,
  [3843] = 3787,
  [3844] = 2235,
  [3845] = 3845,
  [3846] = 3846,
  [3847] = 3847,
  [3848] = 2234,
  [3849] = 3814,
  [3850] = 3850,
  [3851] = 3851,
  [3852] = 3788,
  [3853] = 3773,
  [3854] = 3838,
  [3855] = 3855,
  [3856] = 3856,
  [3857] = 3857,
  [3858] = 3791,
  [3859] = 3859,
  [3860] = 3813,
  [3861] = 3861,
  [3862] = 3743,
  [3863] = 3863,
  [3864] = 2227,
  [3865] = 3769,
  [3866] = 3866,
  [3867] = 3867,
  [3868] = 3794,
  [3869] = 3869,
  [3870] = 3870,
  [3871] = 2238,
  [3872] = 3759,
  [3873] = 3801,
  [3874] = 3024,
  [3875] = 3875,
  [3876] = 3739,
  [3877] = 2229,
  [3878] = 3878,
  [3879] = 3879,
  [3880] = 3757,
  [3881] = 3766,
  [3882] = 3882,
  [3883] = 3883,
  [3884] = 3767,
  [3885] = 3738,
  [3886] = 3886,
  [3887] = 3887,
  [3888] = 3821,
  [3889] = 2245,
  [3890] = 3890,
  [3891] = 3767,
  [3892] = 3892,
  [3893] = 2239,
  [3894] = 3894,
  [3895] = 3895,
  [3896] = 3896,
  [3897] = 3897,
  [3898] = 2232,
  [3899] = 3821,
  [3900] = 3832,
  [3901] = 3822,
  [3902] = 3761,
  [3903] = 3823,
  [3904] = 3904,
  [3905] = 3829,
  [3906] = 3821,
  [3907] = 3907,
  [3908] = 3822,
  [3909] = 3465,
  [3910] = 3744,
  [3911] = 3822,
  [3912] = 3823,
  [3913] = 3913,
  [3914] = 3738,
  [3915] = 3915,
  [3916] = 3916,
  [3917] = 3829,
  [3918] = 2220,
  [3919] = 2222,
  [3920] = 3887,
  [3921] = 3921,
  [3922] = 3922,
  [3923] = 3923,
  [3924] = 2218,
  [3925] = 3033,
  [3926] = 3836,
  [3927] = 3927,
  [3928] = 3031,
  [3929] = 3839,
  [3930] = 3029,
  [3931] = 3883,
  [3932] = 3738,
  [3933] = 3823,
  [3934] = 3934,
  [3935] = 3753,
  [3936] = 3842,
  [3937] = 3937,
  [3938] = 3938,
  [3939] = 3879,
  [3940] = 3870,
  [3941] = 3822,
  [3942] = 3821,
  [3943] = 2219,
  [3944] = 3944,
  [3945] = 3823,
  [3946] = 3946,
  [3947] = 2212,
  [3948] = 3948,
  [3949] = 3949,
  [3950] = 3950,
  [3951] = 2240,
  [3952] = 3952,
  [3953] = 2243,
  [3954] = 2248,
  [3955] = 3798,
  [3956] = 1428,
  [3957] = 3957,
  [3958] = 3958,
  [3959] = 2213,
  [3960] = 3812,
  [3961] = 3761,
  [3962] = 3765,
  [3963] = 3810,
  [3964] = 3805,
  [3965] = 3767,
  [3966] = 3890,
  [3967] = 3967,
  [3968] = 3829,
  [3969] = 3829,
  [3970] = 3866,
  [3971] = 3747,
  [3972] = 3836,
  [3973] = 3897,
  [3974] = 3974,
  [3975] = 3744,
  [3976] = 3842,
  [3977] = 3977,
  [3978] = 3851,
  [3979] = 3745,
  [3980] = 792,
  [3981] = 3981,
  [3982] = 3855,
  [3983] = 2247,
  [3984] = 3984,
  [3985] = 3985,
  [3986] = 3986,
  [3987] = 3987,
  [3988] = 3783,
  [3989] = 3989,
  [3990] = 3990,
  [3991] = 791,
  [3992] = 3789,
  [3993] = 3742,
  [3994] = 3994,
  [3995] = 3863,
  [3996] = 3818,
  [3997] = 3997,
  [3998] = 3998,
  [3999] = 3999,
  [4000] = 4000,
  [4001] = 4001,
  [4002] = 4002,
  [4003] = 4003,
  [4004] = 4004,
  [4005] = 4005,
  [4006] = 4006,
  [4007] = 4007,
  [4008] = 4008,
  [4009] = 4009,
  [4010] = 4010,
  [4011] = 4011,
  [4012] = 4012,
  [4013] = 4013,
  [4014] = 4014,
  [4015] = 4015,
  [4016] = 4016,
  [4017] = 4017,
  [4018] = 4015,
  [4019] = 4019,
  [4020] = 4020,
  [4021] = 4021,
  [4022] = 4022,
  [4023] = 4023,
  [4024] = 4024,
  [4025] = 4012,
  [4026] = 4024,
  [4027] = 4016,
  [4028] = 4022,
  [4029] = 4007,
  [4030] = 4021,
  [4031] = 4020,
  [4032] = 4032,
  [4033] = 4017,
  [4034] = 4034,
  [4035] = 4035,
  [4036] = 4036,
  [4037] = 4037,
  [4038] = 4038,
  [4039] = 4039,
  [4040] = 4035,
  [4041] = 4041,
  [4042] = 4042,
  [4043] = 4009,
  [4044] = 4044,
  [4045] = 4034,
  [4046] = 4046,
  [4047] = 4047,
  [4048] = 4023,
  [4049] = 4037,
  [4050] = 4019,
  [4051] = 4051,
  [4052] = 4019,
  [4053] = 4053,
  [4054] = 4054,
  [4055] = 4015,
  [4056] = 4056,
  [4057] = 4051,
  [4058] = 4012,
  [4059] = 4038,
  [4060] = 4036,
  [4061] = 4061,
  [4062] = 4009,
  [4063] = 4014,
  [4064] = 4064,
  [4065] = 4065,
  [4066] = 4066,
  [4067] = 4067,
  [4068] = 4068,
  [4069] = 4069,
  [4070] = 4070,
  [4071] = 4071,
  [4072] = 4036,
  [4073] = 4017,
  [4074] = 4074,
  [4075] = 4020,
  [4076] = 4021,
  [4077] = 4022,
  [4078] = 4038,
  [4079] = 4024,
  [4080] = 4080,
  [4081] = 4038,
  [4082] = 4016,
  [4083] = 4083,
  [4084] = 4084,
  [4085] = 4085,
  [4086] = 4056,
  [4087] = 4087,
  [4088] = 4068,
  [4089] = 4089,
  [4090] = 4090,
  [4091] = 4051,
  [4092] = 4092,
  [4093] = 4023,
  [4094] = 4065,
  [4095] = 4012,
  [4096] = 4096,
  [4097] = 4097,
  [4098] = 4054,
  [4099] = 4016,
  [4100] = 4100,
  [4101] = 4101,
  [4102] = 4102,
  [4103] = 4103,
  [4104] = 4000,
  [4105] = 4105,
  [4106] = 4106,
  [4107] = 4023,
  [4108] = 4108,
  [4109] = 4109,
  [4110] = 4110,
  [4111] = 4111,
  [4112] = 4112,
  [4113] = 4109,
  [4114] = 4114,
  [4115] = 4000,
  [4116] = 4017,
  [4117] = 4112,
  [4118] = 4032,
  [4119] = 4119,
  [4120] = 4054,
  [4121] = 4100,
  [4122] = 4102,
  [4123] = 4103,
  [4124] = 4017,
  [4125] = 4105,
  [4126] = 4110,
  [4127] = 4106,
  [4128] = 4020,
  [4129] = 4108,
  [4130] = 4021,
  [4131] = 4022,
  [4132] = 4032,
  [4133] = 4106,
  [4134] = 4134,
  [4135] = 4047,
  [4136] = 4108,
  [4137] = 4110,
  [4138] = 4138,
  [4139] = 4139,
  [4140] = 4112,
  [4141] = 4109,
  [4142] = 4142,
  [4143] = 4143,
  [4144] = 4144,
  [4145] = 4145,
  [4146] = 4080,
  [4147] = 4105,
  [4148] = 4016,
  [4149] = 4054,
  [4150] = 4150,
  [4151] = 4151,
  [4152] = 4152,
  [4153] = 4153,
  [4154] = 4154,
  [4155] = 4103,
  [4156] = 4156,
  [4157] = 4036,
  [4158] = 4158,
  [4159] = 4159,
  [4160] = 4101,
  [4161] = 4102,
  [4162] = 4046,
  [4163] = 4101,
  [4164] = 4164,
  [4165] = 4165,
  [4166] = 4166,
  [4167] = 4024,
  [4168] = 4089,
  [4169] = 4169,
  [4170] = 4100,
  [4171] = 4171,
  [4172] = 4172,
  [4173] = 4085,
  [4174] = 4174,
  [4175] = 4084,
  [4176] = 4143,
  [4177] = 4009,
  [4178] = 4080,
  [4179] = 4008,
  [4180] = 4051,
  [4181] = 4012,
  [4182] = 4182,
  [4183] = 4071,
  [4184] = 3997,
  [4185] = 4067,
  [4186] = 4015,
  [4187] = 4066,
  [4188] = 4065,
  [4189] = 4068,
  [4190] = 4144,
  [4191] = 4090,
  [4192] = 4192,
  [4193] = 4064,
  [4194] = 4047,
  [4195] = 4195,
  [4196] = 4196,
  [4197] = 4142,
  [4198] = 4053,
  [4199] = 4019,
  [4200] = 4019,
  [4201] = 4201,
  [4202] = 4015,
  [4203] = 4111,
  [4204] = 4000,
  [4205] = 4089,
  [4206] = 4065,
  [4207] = 4053,
  [4208] = 4044,
  [4209] = 4139,
  [4210] = 4064,
  [4211] = 4066,
  [4212] = 4067,
  [4213] = 4071,
  [4214] = 4008,
  [4215] = 4084,
  [4216] = 4085,
  [4217] = 4038,
  [4218] = 4092,
  [4219] = 4138,
  [4220] = 4036,
  [4221] = 4054,
  [4222] = 4109,
  [4223] = 4112,
  [4224] = 4110,
  [4225] = 4108,
  [4226] = 4080,
  [4227] = 4016,
  [4228] = 3997,
  [4229] = 4047,
  [4230] = 4134,
  [4231] = 4106,
  [4232] = 4044,
  [4233] = 4017,
  [4234] = 4105,
  [4235] = 4032,
  [4236] = 4020,
  [4237] = 4021,
  [4238] = 4022,
  [4239] = 4239,
  [4240] = 4041,
  [4241] = 4241,
  [4242] = 4103,
  [4243] = 4041,
  [4244] = 4102,
  [4245] = 4022,
  [4246] = 4021,
  [4247] = 4020,
  [4248] = 4248,
  [4249] = 4101,
  [4250] = 4100,
  [4251] = 4051,
  [4252] = 4038,
  [4253] = 4036,
  [4254] = 4068,
  [4255] = 4023,
  [4256] = 4256,
  [4257] = 4019,
  [4258] = 4015,
  [4259] = 4012,
  [4260] = 4009,
  [4261] = 4261,
  [4262] = 4241,
  [4263] = 4034,
  [4264] = 4092,
  [4265] = 4092,
  [4266] = 4065,
  [4267] = 4068,
  [4268] = 4150,
  [4269] = 4089,
  [4270] = 4080,
  [4271] = 3997,
  [4272] = 4047,
  [4273] = 4041,
  [4274] = 4274,
  [4275] = 4044,
  [4276] = 4085,
  [4277] = 4277,
  [4278] = 4032,
  [4279] = 4084,
  [4280] = 4008,
  [4281] = 4041,
  [4282] = 4071,
  [4283] = 4283,
  [4284] = 4067,
  [4285] = 4066,
  [4286] = 4017,
  [4287] = 4064,
  [4288] = 4032,
  [4289] = 4053,
  [4290] = 4053,
  [4291] = 4020,
  [4292] = 4064,
  [4293] = 4021,
  [4294] = 4022,
  [4295] = 4022,
  [4296] = 4134,
  [4297] = 4021,
  [4298] = 4020,
  [4299] = 4066,
  [4300] = 4067,
  [4301] = 4301,
  [4302] = 4164,
  [4303] = 4303,
  [4304] = 4071,
  [4305] = 4119,
  [4306] = 4008,
  [4307] = 4084,
  [4308] = 4085,
  [4309] = 4089,
  [4310] = 4032,
  [4311] = 4134,
  [4312] = 4092,
  [4313] = 4034,
  [4314] = 4044,
  [4315] = 4032,
  [4316] = 4134,
  [4317] = 4054,
  [4318] = 4017,
  [4319] = 4047,
  [4320] = 4320,
  [4321] = 4165,
  [4322] = 4303,
  [4323] = 4301,
  [4324] = 4166,
  [4325] = 4134,
  [4326] = 4114,
  [4327] = 4109,
  [4328] = 4195,
  [4329] = 4112,
  [4330] = 4039,
  [4331] = 4003,
  [4332] = 4110,
  [4333] = 4108,
  [4334] = 4023,
  [4335] = 4024,
  [4336] = 4106,
  [4337] = 4105,
  [4338] = 4103,
  [4339] = 4102,
  [4340] = 4101,
  [4341] = 4100,
  [4342] = 3997,
  [4343] = 4080,
  [4344] = 4051,
};

static inline bool anon_sym_BANG_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? (c >= '\t' && c <= '\n')
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym__glimmer_template_content_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '{' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '|' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_private_property_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < '['
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '@')))
      : (c <= '^' || (c < '{'
        ? c == '`'
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(98);
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '$') ADVANCE(255);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(160);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(101);
      if (lookahead == '+') ADVANCE(172);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(175);
      if (lookahead == '.') ADVANCE(129);
      if (lookahead == '/') ADVANCE(236);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(185);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(261);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(166);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '~') ADVANCE(197);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(95)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(256);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(1)
      if (lookahead == '-') ADVANCE(122);
      if (lookahead == '/') ADVANCE(120);
      if (lookahead == '<') ADVANCE(119);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(121);
      if (lookahead != 0) ADVANCE(118);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(29)
      if (lookahead == '-') ADVANCE(239);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '<') ADVANCE(238);
      if (lookahead == '[') ADVANCE(40);
      if (lookahead == '\\') ADVANCE(94);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(237);
      if (lookahead != 0) ADVANCE(243);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '#') ADVANCE(39);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(160);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(101);
      if (lookahead == '+') ADVANCE(172);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(174);
      if (lookahead == '.') ADVANCE(130);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(184);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(261);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(166);
      if (lookahead == '}') ADVANCE(109);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(3)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '~') ADVANCE(256);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(160);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(101);
      if (lookahead == '+') ADVANCE(172);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(174);
      if (lookahead == '.') ADVANCE(129);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == '<') ADVANCE(185);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(261);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(165);
      if (lookahead == '~') ADVANCE(197);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(4)
      if (lookahead != 0 &&
          lookahead > '#' &&
          lookahead != ';' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(256);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(160);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(101);
      if (lookahead == '+') ADVANCE(172);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(174);
      if (lookahead == '.') ADVANCE(129);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == '<') ADVANCE(185);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(261);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(165);
      if (lookahead == '~') ADVANCE(197);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(5)
      if (lookahead != 0 &&
          lookahead > '#' &&
          lookahead != ';' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(256);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(160);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(101);
      if (lookahead == '+') ADVANCE(172);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(174);
      if (lookahead == '.') ADVANCE(128);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(184);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(261);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(165);
      if (lookahead == '}') ADVANCE(109);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(6)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != '~') ADVANCE(256);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '%') ADVANCE(179);
      if (lookahead == '&') ADVANCE(161);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(102);
      if (lookahead == '+') ADVANCE(171);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(128);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(186);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(262);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '^') ADVANCE(162);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(168);
      if (lookahead == '}') ADVANCE(109);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(7)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '0' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(256);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '%') ADVANCE(179);
      if (lookahead == '&') ADVANCE(161);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(102);
      if (lookahead == '+') ADVANCE(171);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(128);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(186);
      if (lookahead == '=') ADVANCE(35);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(31);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '^') ADVANCE(162);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(167);
      if (lookahead == '}') ADVANCE(109);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(9)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(244);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(256);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '%') ADVANCE(179);
      if (lookahead == '&') ADVANCE(161);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(102);
      if (lookahead == '+') ADVANCE(171);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(128);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(186);
      if (lookahead == '=') ADVANCE(35);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(31);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '^') ADVANCE(162);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(167);
      if (lookahead == '}') ADVANCE(109);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(9)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(256);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(99);
      if (lookahead == '\\') ADVANCE(57);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(257);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(26);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(110);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '#') ADVANCE(39);
      if (lookahead == '&') ADVANCE(159);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(100);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(176);
      if (lookahead == '.') ADVANCE(129);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(183);
      if (lookahead == '=') ADVANCE(105);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(259);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(169);
      if (lookahead == '}') ADVANCE(109);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(12)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || '+' < lookahead) &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(256);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(110);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '#') ADVANCE(39);
      if (lookahead == '&') ADVANCE(159);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(100);
      if (lookahead == '+') ADVANCE(170);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(176);
      if (lookahead == '.') ADVANCE(129);
      if (lookahead == '/') ADVANCE(236);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(183);
      if (lookahead == '=') ADVANCE(105);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(259);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(169);
      if (lookahead == '}') ADVANCE(109);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(14)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || ')' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(256);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(110);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '#') ADVANCE(39);
      if (lookahead == '&') ADVANCE(159);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(100);
      if (lookahead == '+') ADVANCE(170);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(176);
      if (lookahead == '.') ADVANCE(129);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(183);
      if (lookahead == '=') ADVANCE(105);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(259);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(169);
      if (lookahead == '}') ADVANCE(109);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(14)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || ')' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(256);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(110);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '&') ADVANCE(159);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(100);
      if (lookahead == '+') ADVANCE(171);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == '<') ADVANCE(188);
      if (lookahead == '?') ADVANCE(259);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(164);
      if (lookahead == '~') ADVANCE(197);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(15)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(256);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(110);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '&') ADVANCE(159);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '+') ADVANCE(171);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(129);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(188);
      if (lookahead == '=') ADVANCE(105);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(260);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(169);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '~') ADVANCE(197);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(16)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '*' < lookahead) &&
          lookahead != '^') ADVANCE(256);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '-') ADVANCE(208);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '<') ADVANCE(203);
      if (lookahead == '\\') ADVANCE(59);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(207);
      if (lookahead != 0) ADVANCE(212);
      END_STATE();
    case 18:
      if (lookahead == '$') ADVANCE(60);
      if (lookahead == '-') ADVANCE(28);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '?') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '`') ADVANCE(234);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(19)
      END_STATE();
    case 19:
      if (lookahead == '$') ADVANCE(60);
      if (lookahead == '-') ADVANCE(28);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '?') ADVANCE(34);
      if (lookahead == '`') ADVANCE(234);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(19)
      END_STATE();
    case 20:
      if (lookahead == '&') ADVANCE(159);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(27);
      if (lookahead == '.') ADVANCE(128);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(183);
      if (lookahead == '=') ADVANCE(105);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(260);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(169);
      if (lookahead == '}') ADVANCE(109);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(20)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(256);
      END_STATE();
    case 21:
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '-') ADVANCE(219);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '<') ADVANCE(214);
      if (lookahead == '\\') ADVANCE(59);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(218);
      if (lookahead != 0) ADVANCE(223);
      END_STATE();
    case 22:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(231);
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 25:
      if (lookahead == '-') ADVANCE(231);
      END_STATE();
    case 26:
      if (lookahead == '-') ADVANCE(25);
      END_STATE();
    case 27:
      if (lookahead == '-') ADVANCE(36);
      END_STATE();
    case 28:
      if (lookahead == '-') ADVANCE(36);
      if (lookahead == '?') ADVANCE(33);
      END_STATE();
    case 29:
      if (lookahead == '-') ADVANCE(27);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '<') ADVANCE(11);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(29)
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(253);
      END_STATE();
    case 31:
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '?') ADVANCE(195);
      END_STATE();
    case 32:
      if (lookahead == '.') ADVANCE(148);
      END_STATE();
    case 33:
      if (lookahead == ':') ADVANCE(263);
      END_STATE();
    case 34:
      if (lookahead == ':') ADVANCE(264);
      END_STATE();
    case 35:
      if (lookahead == '=') ADVANCE(190);
      END_STATE();
    case 36:
      if (lookahead == '>') ADVANCE(231);
      END_STATE();
    case 37:
      if (lookahead == '>') ADVANCE(123);
      END_STATE();
    case 38:
      if (lookahead == '>') ADVANCE(124);
      END_STATE();
    case 39:
      if (lookahead == '\\') ADVANCE(57);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(257);
      END_STATE();
    case 40:
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == ']') ADVANCE(243);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(54);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(49);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(37);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(38);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(50);
      END_STATE();
    case 47:
      if (lookahead == 'l') ADVANCE(41);
      END_STATE();
    case 48:
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 49:
      if (lookahead == 'm') ADVANCE(51);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(52);
      END_STATE();
    case 51:
      if (lookahead == 'p') ADVANCE(47);
      END_STATE();
    case 52:
      if (lookahead == 'p') ADVANCE(48);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(44);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(46);
      END_STATE();
    case 56:
      if (lookahead == 'u') ADVANCE(61);
      if (lookahead == 'x') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(227);
      if (lookahead != 0) ADVANCE(224);
      END_STATE();
    case 57:
      if (lookahead == 'u') ADVANCE(62);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(63);
      END_STATE();
    case 59:
      if (lookahead == 'u') ADVANCE(64);
      if (lookahead == 'x') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(227);
      if (lookahead != 0) ADVANCE(224);
      END_STATE();
    case 60:
      if (lookahead == '{') ADVANCE(235);
      END_STATE();
    case 61:
      if (lookahead == '{') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 62:
      if (lookahead == '{') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(91);
      END_STATE();
    case 63:
      if (lookahead == '{') ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(92);
      END_STATE();
    case 64:
      if (lookahead == '{') ADVANCE(86);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(82);
      END_STATE();
    case 65:
      if (lookahead == '}') ADVANCE(256);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 66:
      if (lookahead == '}') ADVANCE(257);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 67:
      if (lookahead == '}') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 68:
      if (lookahead == '}') ADVANCE(225);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 69:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(252);
      END_STATE();
    case 70:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(248);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(249);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(247);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(253);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(252);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(256);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(257);
      END_STATE();
    case 78:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(224);
      END_STATE();
    case 79:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(250);
      END_STATE();
    case 80:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 81:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(225);
      END_STATE();
    case 82:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(85);
      END_STATE();
    case 83:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 84:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 85:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 86:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 87:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(81);
      END_STATE();
    case 88:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      END_STATE();
    case 90:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      END_STATE();
    case 91:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    case 92:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(89);
      END_STATE();
    case 93:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(40);
      END_STATE();
    case 94:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(243);
      END_STATE();
    case 95:
      if (eof) ADVANCE(98);
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '$') ADVANCE(255);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(160);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(101);
      if (lookahead == '+') ADVANCE(172);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(175);
      if (lookahead == '.') ADVANCE(129);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(185);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(261);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(166);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '~') ADVANCE(197);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(95)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(256);
      END_STATE();
    case 96:
      if (eof) ADVANCE(98);
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '%') ADVANCE(179);
      if (lookahead == '&') ADVANCE(161);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(102);
      if (lookahead == '+') ADVANCE(171);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(130);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(187);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(31);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '^') ADVANCE(162);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(167);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '~') ADVANCE(197);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(96)
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(256);
      END_STATE();
    case 97:
      if (eof) ADVANCE(98);
      if (lookahead == '!') ADVANCE(110);
      if (lookahead == '"') ADVANCE(200);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '&') ADVANCE(159);
      if (lookahead == '\'') ADVANCE(201);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(100);
      if (lookahead == '+') ADVANCE(171);
      if (lookahead == ',') ADVANCE(108);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(129);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == '0') ADVANCE(246);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == ';') ADVANCE(114);
      if (lookahead == '<') ADVANCE(188);
      if (lookahead == '=') ADVANCE(105);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(259);
      if (lookahead == '@') ADVANCE(258);
      if (lookahead == '[') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(117);
      if (lookahead == '`') ADVANCE(234);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(169);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '~') ADVANCE(197);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(97)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(256);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(99);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(182);
      if (lookahead == '=') ADVANCE(135);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(181);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(190);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(190);
      if (lookahead == '>') ADVANCE(131);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(131);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(265);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(192);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '!') ADVANCE(26);
      if (lookahead == '/') ADVANCE(55);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(231);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '-') ADVANCE(122);
      if (lookahead == '/') ADVANCE(120);
      if (lookahead == '<') ADVANCE(119);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(121);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(118);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '-') ADVANCE(36);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LTtemplate_GT);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LT_SLASHtemplate_GT);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(194);
      if (lookahead == '>') ADVANCE(153);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(194);
      if (lookahead == '>') ADVANCE(154);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(253);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(253);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(156);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(150);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(149);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '|') ADVANCE(152);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '|') ADVANCE(152);
      if (lookahead == '}') ADVANCE(266);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(151);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '}') ADVANCE(266);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(266);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(198);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == '=') ADVANCE(133);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(199);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(199);
      if (lookahead == '=') ADVANCE(134);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(199);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '?') ADVANCE(33);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(36);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(231);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(231);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(144);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(26);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(26);
      if (lookahead == '<') ADVANCE(158);
      if (lookahead == '=') ADVANCE(189);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(26);
      if (lookahead == '<') ADVANCE(158);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(26);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(189);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(26);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(26);
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(193);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '>') ADVANCE(231);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '\n') ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(202);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '!') ADVANCE(210);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(212);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(206);
      if (lookahead == '/') ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(212);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(205);
      if (lookahead == '/') ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(206);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(205);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(206);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '-') ADVANCE(208);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '<') ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(207);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(212);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '-') ADVANCE(211);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(212);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '-') ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(212);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '-') ADVANCE(209);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(212);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '>') ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(212);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(212);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '\n') ADVANCE(223);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(213);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '!') ADVANCE(221);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(223);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(217);
      if (lookahead == '/') ADVANCE(213);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(223);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(216);
      if (lookahead == '/') ADVANCE(223);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(217);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(216);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(217);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '-') ADVANCE(219);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '<') ADVANCE(214);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(218);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(223);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '-') ADVANCE(222);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(223);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '-') ADVANCE(213);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(223);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(223);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(223);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(223);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(58);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(256);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(224);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(226);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(231);
      if (lookahead == '[') ADVANCE(230);
      if (lookahead == '\\') ADVANCE(232);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(229);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(233);
      if (lookahead == ']') ADVANCE(229);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(230);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(231);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(229);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(230);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(231);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(29)
      if (lookahead == '-') ADVANCE(239);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '<') ADVANCE(238);
      if (lookahead == '[') ADVANCE(40);
      if (lookahead == '\\') ADVANCE(94);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(237);
      if (lookahead != 0) ADVANCE(243);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '!') ADVANCE(241);
      if (lookahead == '[') ADVANCE(40);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(243);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '-') ADVANCE(242);
      if (lookahead == '[') ADVANCE(40);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(243);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '-') ADVANCE(229);
      if (lookahead == '[') ADVANCE(40);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(243);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '-') ADVANCE(240);
      if (lookahead == '[') ADVANCE(40);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(243);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '>') ADVANCE(229);
      if (lookahead == '[') ADVANCE(40);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(243);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(40);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(243);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(58);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(244);
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(256);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(254);
      if (lookahead == '0') ADVANCE(251);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(70);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(69);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(71);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(79);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'n') ADVANCE(245);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(247);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(254);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(69);
      if (lookahead == '_') ADVANCE(72);
      if (lookahead == 'n') ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(247);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(70);
      if (lookahead == 'n') ADVANCE(245);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(248);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(71);
      if (lookahead == 'n') ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(249);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(79);
      if (lookahead == 'n') ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(250);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'n') ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(252);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(69);
      if (lookahead == '_') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(253);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(253);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == '{') ADVANCE(235);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(256);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(58);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(256);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_private_property_identifier);
      if (lookahead == '\\') ADVANCE(57);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(257);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(132);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '?') ADVANCE(196);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '?') ADVANCE(195);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8203) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 8288 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'b') ADVANCE(53);
      if (lookahead == 'f') ADVANCE(54);
      if (lookahead == 'v') ADVANCE(55);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(59);
      if (lookahead == 'e') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      if (lookahead == 'u') ADVANCE(62);
      if (lookahead == 'w') ADVANCE(63);
      if (lookahead == 'y') ADVANCE(64);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(65);
      if (lookahead == 'h') ADVANCE(66);
      if (lookahead == 'r') ADVANCE(67);
      if (lookahead == 'y') ADVANCE(68);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(69);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(70);
      if (lookahead == 'o') ADVANCE(71);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(73);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(74);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(75);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(76);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(77);
      if (lookahead == 'y') ADVANCE(78);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(79);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(80);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(81);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(82);
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(84);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(85);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(86);
      if (lookahead == 'c') ADVANCE(87);
      if (lookahead == 'f') ADVANCE(88);
      if (lookahead == 'l') ADVANCE(89);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(90);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(91);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(92);
      if (lookahead == 't') ADVANCE(93);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(94);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(98);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(100);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(101);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(102);
      if (lookahead == 's') ADVANCE(103);
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(105);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(107);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(108);
      END_STATE();
    case 51:
      if (lookahead == 'v') ADVANCE(109);
      if (lookahead == 'w') ADVANCE(110);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(111);
      if (lookahead == 'm') ADVANCE(112);
      END_STATE();
    case 53:
      if (lookahead == 'j') ADVANCE(113);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(114);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(115);
      if (lookahead == 'o') ADVANCE(116);
      END_STATE();
    case 57:
      if (lookahead == 'b') ADVANCE(117);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(118);
      if (lookahead == 'q') ADVANCE(119);
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 60:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 61:
      if (lookahead == 'a') ADVANCE(123);
      if (lookahead == 'r') ADVANCE(124);
      END_STATE();
    case 62:
      if (lookahead == 'p') ADVANCE(125);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(126);
      END_STATE();
    case 64:
      if (lookahead == 'm') ADVANCE(127);
      END_STATE();
    case 65:
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(129);
      if (lookahead == 'r') ADVANCE(130);
      END_STATE();
    case 67:
      if (lookahead == 'u') ADVANCE(131);
      if (lookahead == 'y') ADVANCE(132);
      END_STATE();
    case 68:
      if (lookahead == 'p') ADVANCE(133);
      END_STATE();
    case 69:
      if (lookahead == 'd') ADVANCE(134);
      if (lookahead == 'i') ADVANCE(135);
      if (lookahead == 'k') ADVANCE(136);
      END_STATE();
    case 70:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(138);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(141);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 78:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 79:
      if (lookahead == 'i') ADVANCE(145);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(146);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(147);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 83:
      if (lookahead == 'c') ADVANCE(149);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(150);
      END_STATE();
    case 85:
      if (lookahead == 's') ADVANCE(151);
      if (lookahead == 't') ADVANCE(152);
      END_STATE();
    case 86:
      if (lookahead == 'u') ADVANCE(153);
      END_STATE();
    case 87:
      if (lookahead == 'l') ADVANCE(154);
      END_STATE();
    case 88:
      if (lookahead == 'a') ADVANCE(155);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 91:
      if (lookahead == 'm') ADVANCE(158);
      END_STATE();
    case 92:
      if (lookahead == 'o') ADVANCE(159);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 94:
      if (lookahead == 's') ADVANCE(161);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(162);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 97:
      if (lookahead == 'm') ADVANCE(163);
      END_STATE();
    case 98:
      if (lookahead == 'c') ADVANCE(164);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 100:
      if (lookahead == 'b') ADVANCE(165);
      END_STATE();
    case 101:
      if (lookahead == 'l') ADVANCE(166);
      if (lookahead == 'o') ADVANCE(167);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(168);
      END_STATE();
    case 103:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 105:
      if (lookahead == 'o') ADVANCE(171);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 107:
      if (lookahead == 'u') ADVANCE(172);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(173);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(175);
      END_STATE();
    case 112:
      if (lookahead == 'b') ADVANCE(176);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 114:
      if (lookahead == 'r') ADVANCE(178);
      END_STATE();
    case 115:
      if (lookahead == 'v') ADVANCE(179);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(180);
      END_STATE();
    case 117:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 118:
      if (lookahead == 'd') ADVANCE(182);
      END_STATE();
    case 119:
      if (lookahead == 'u') ADVANCE(183);
      END_STATE();
    case 120:
      if (lookahead == 'u') ADVANCE(184);
      END_STATE();
    case 121:
      if (lookahead == 'i') ADVANCE(185);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 124:
      if (lookahead == 'i') ADVANCE(187);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 126:
      if (lookahead == 't') ADVANCE(189);
      END_STATE();
    case 127:
      if (lookahead == 'b') ADVANCE(190);
      END_STATE();
    case 128:
      if (lookahead == 'g') ADVANCE(191);
      END_STATE();
    case 129:
      if (lookahead == 's') ADVANCE(192);
      END_STATE();
    case 130:
      if (lookahead == 'o') ADVANCE(193);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(194);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(195);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 135:
      if (lookahead == 'q') ADVANCE(197);
      END_STATE();
    case 136:
      if (lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 138:
      if (lookahead == 'd') ADVANCE(199);
      END_STATE();
    case 139:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 140:
      if (lookahead == 'h') ADVANCE(201);
      END_STATE();
    case 141:
      if (lookahead == 'l') ADVANCE(202);
      END_STATE();
    case 142:
      if (lookahead == 'r') ADVANCE(203);
      END_STATE();
    case 143:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 144:
      if (lookahead == 'c') ADVANCE(205);
      END_STATE();
    case 145:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(207);
      END_STATE();
    case 147:
      if (lookahead == 'k') ADVANCE(208);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 149:
      if (lookahead == 'h') ADVANCE(209);
      END_STATE();
    case 150:
      if (lookahead == 's') ADVANCE(210);
      END_STATE();
    case 151:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 152:
      if (lookahead == 'i') ADVANCE(212);
      END_STATE();
    case 153:
      if (lookahead == 'g') ADVANCE(213);
      END_STATE();
    case 154:
      if (lookahead == 'a') ADVANCE(214);
      END_STATE();
    case 155:
      if (lookahead == 'u') ADVANCE(215);
      END_STATE();
    case 156:
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 159:
      if (lookahead == 'r') ADVANCE(217);
      END_STATE();
    case 160:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 161:
      if (lookahead == 'e') ADVANCE(219);
      END_STATE();
    case 162:
      if (lookahead == 'l') ADVANCE(220);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 164:
      if (lookahead == 't') ADVANCE(221);
      END_STATE();
    case 165:
      if (lookahead == 'a') ADVANCE(222);
      END_STATE();
    case 166:
      if (lookahead == 'e') ADVANCE(223);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(224);
      END_STATE();
    case 168:
      if (lookahead == 'r') ADVANCE(225);
      END_STATE();
    case 169:
      if (lookahead == 'a') ADVANCE(226);
      END_STATE();
    case 170:
      if (lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 171:
      if (lookahead == 'f') ADVANCE(228);
      END_STATE();
    case 172:
      if (lookahead == 'l') ADVANCE(229);
      END_STATE();
    case 173:
      if (lookahead == 's') ADVANCE(230);
      END_STATE();
    case 174:
      if (lookahead == 'r') ADVANCE(231);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 177:
      if (lookahead == 'c') ADVANCE(233);
      END_STATE();
    case 178:
      if (lookahead == 'r') ADVANCE(234);
      END_STATE();
    case 179:
      if (lookahead == 'a') ADVANCE(235);
      END_STATE();
    case 180:
      if (lookahead == 'e') ADVANCE(236);
      END_STATE();
    case 181:
      if (lookahead == 'i') ADVANCE(237);
      END_STATE();
    case 182:
      if (lookahead == 'o') ADVANCE(238);
      END_STATE();
    case 183:
      if (lookahead == 'i') ADVANCE(239);
      END_STATE();
    case 184:
      if (lookahead == 'r') ADVANCE(240);
      END_STATE();
    case 185:
      if (lookahead == 's') ADVANCE(241);
      END_STATE();
    case 186:
      if (lookahead == 'i') ADVANCE(242);
      END_STATE();
    case 187:
      if (lookahead == 'n') ADVANCE(243);
      END_STATE();
    case 188:
      if (lookahead == 'r') ADVANCE(244);
      END_STATE();
    case 189:
      if (lookahead == 'c') ADVANCE(245);
      END_STATE();
    case 190:
      if (lookahead == 'o') ADVANCE(246);
      END_STATE();
    case 191:
      if (lookahead == 'e') ADVANCE(247);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 193:
      if (lookahead == 'w') ADVANCE(248);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(249);
      END_STATE();
    case 196:
      if (lookahead == 'f') ADVANCE(250);
      END_STATE();
    case 197:
      if (lookahead == 'u') ADVANCE(251);
      END_STATE();
    case 198:
      if (lookahead == 'o') ADVANCE(252);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 200:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 202:
      if (lookahead == 'd') ADVANCE(254);
      END_STATE();
    case 203:
      if (lookahead == 'a') ADVANCE(255);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 207:
      if (lookahead == 'a') ADVANCE(257);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 212:
      if (lookahead == 'n') ADVANCE(258);
      END_STATE();
    case 213:
      if (lookahead == 'g') ADVANCE(259);
      END_STATE();
    case 214:
      if (lookahead == 'r') ADVANCE(260);
      END_STATE();
    case 215:
      if (lookahead == 'l') ADVANCE(261);
      END_STATE();
    case 216:
      if (lookahead == 'e') ADVANCE(262);
      END_STATE();
    case 217:
      if (lookahead == 't') ADVANCE(263);
      END_STATE();
    case 218:
      if (lookahead == 'd') ADVANCE(264);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 220:
      if (lookahead == 'l') ADVANCE(265);
      END_STATE();
    case 221:
      if (lookahead == 'i') ADVANCE(266);
      END_STATE();
    case 222:
      if (lookahead == 'l') ADVANCE(267);
      END_STATE();
    case 223:
      if (lookahead == 'm') ADVANCE(268);
      END_STATE();
    case 224:
      if (lookahead == 't') ADVANCE(269);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 226:
      if (lookahead == 'n') ADVANCE(270);
      END_STATE();
    case 227:
      if (lookahead == 'f') ADVANCE(271);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 229:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 230:
      if (lookahead == 'p') ADVANCE(273);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 232:
      if (lookahead == 'r') ADVANCE(274);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(275);
      END_STATE();
    case 234:
      if (lookahead == 'i') ADVANCE(276);
      END_STATE();
    case 235:
      if (lookahead == 't') ADVANCE(277);
      END_STATE();
    case 236:
      if (lookahead == 'c') ADVANCE(278);
      END_STATE();
    case 237:
      if (lookahead == 'c') ADVANCE(279);
      END_STATE();
    case 238:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 239:
      if (lookahead == 'r') ADVANCE(281);
      END_STATE();
    case 240:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 241:
      if (lookahead == 'f') ADVANCE(283);
      END_STATE();
    case 242:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 243:
      if (lookahead == 'g') ADVANCE(285);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 245:
      if (lookahead == 'h') ADVANCE(286);
      END_STATE();
    case 246:
      if (lookahead == 'l') ADVANCE(287);
      END_STATE();
    case 247:
      if (lookahead == 't') ADVANCE(288);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 249:
      if (lookahead == 'f') ADVANCE(289);
      END_STATE();
    case 250:
      if (lookahead == 'i') ADVANCE(290);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 252:
      if (lookahead == 'w') ADVANCE(292);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 255:
      if (lookahead == 'c') ADVANCE(293);
      END_STATE();
    case 256:
      if (lookahead == 's') ADVANCE(294);
      END_STATE();
    case 257:
      if (lookahead == 'n') ADVANCE(295);
      END_STATE();
    case 258:
      if (lookahead == 'u') ADVANCE(296);
      END_STATE();
    case 259:
      if (lookahead == 'e') ADVANCE(297);
      END_STATE();
    case 260:
      if (lookahead == 'e') ADVANCE(298);
      END_STATE();
    case 261:
      if (lookahead == 't') ADVANCE(299);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 264:
      if (lookahead == 's') ADVANCE(300);
      END_STATE();
    case 265:
      if (lookahead == 'y') ADVANCE(301);
      END_STATE();
    case 266:
      if (lookahead == 'o') ADVANCE(302);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 268:
      if (lookahead == 'e') ADVANCE(303);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 270:
      if (lookahead == 'c') ADVANCE(304);
      END_STATE();
    case 271:
      if (lookahead == 'a') ADVANCE(305);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 273:
      if (lookahead == 'a') ADVANCE(306);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 276:
      if (lookahead == 'd') ADVANCE(307);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(308);
      END_STATE();
    case 278:
      if (lookahead == 't') ADVANCE(309);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 280:
      if (lookahead == 'l') ADVANCE(310);
      END_STATE();
    case 281:
      if (lookahead == 'e') ADVANCE(311);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 283:
      if (lookahead == 'i') ADVANCE(312);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 290:
      if (lookahead == 'n') ADVANCE(313);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_unique);
      END_STATE();
    case 292:
      if (lookahead == 'n') ADVANCE(314);
      END_STATE();
    case 293:
      if (lookahead == 't') ADVANCE(315);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 296:
      if (lookahead == 'e') ADVANCE(316);
      END_STATE();
    case 297:
      if (lookahead == 'r') ADVANCE(317);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 302:
      if (lookahead == 'n') ADVANCE(318);
      END_STATE();
    case 303:
      if (lookahead == 'n') ADVANCE(319);
      END_STATE();
    case 304:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 305:
      if (lookahead == 'c') ADVANCE(321);
      END_STATE();
    case 306:
      if (lookahead == 'c') ADVANCE(322);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(323);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 309:
      if (lookahead == 'e') ADVANCE(324);
      END_STATE();
    case 310:
      if (lookahead == 'y') ADVANCE(325);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 312:
      if (lookahead == 'e') ADVANCE(326);
      END_STATE();
    case 313:
      if (lookahead == 'e') ADVANCE(327);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 319:
      if (lookahead == 't') ADVANCE(328);
      END_STATE();
    case 320:
      if (lookahead == 'o') ADVANCE(329);
      END_STATE();
    case 321:
      if (lookahead == 'e') ADVANCE(330);
      END_STATE();
    case 322:
      if (lookahead == 'e') ADVANCE(331);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 324:
      if (lookahead == 'd') ADVANCE(332);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 326:
      if (lookahead == 's') ADVANCE(333);
      END_STATE();
    case 327:
      if (lookahead == 'd') ADVANCE(334);
      END_STATE();
    case 328:
      if (lookahead == 's') ADVANCE(335);
      END_STATE();
    case 329:
      if (lookahead == 'f') ADVANCE(336);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_satisfies);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 97},
  [2] = {.lex_state = 4, .external_lex_state = 2},
  [3] = {.lex_state = 4, .external_lex_state = 2},
  [4] = {.lex_state = 97},
  [5] = {.lex_state = 97},
  [6] = {.lex_state = 97},
  [7] = {.lex_state = 97},
  [8] = {.lex_state = 97},
  [9] = {.lex_state = 97},
  [10] = {.lex_state = 97},
  [11] = {.lex_state = 97},
  [12] = {.lex_state = 97},
  [13] = {.lex_state = 97},
  [14] = {.lex_state = 97},
  [15] = {.lex_state = 97},
  [16] = {.lex_state = 97},
  [17] = {.lex_state = 97},
  [18] = {.lex_state = 97},
  [19] = {.lex_state = 97},
  [20] = {.lex_state = 97},
  [21] = {.lex_state = 97},
  [22] = {.lex_state = 97},
  [23] = {.lex_state = 97},
  [24] = {.lex_state = 97},
  [25] = {.lex_state = 97},
  [26] = {.lex_state = 97},
  [27] = {.lex_state = 97},
  [28] = {.lex_state = 97},
  [29] = {.lex_state = 97},
  [30] = {.lex_state = 97},
  [31] = {.lex_state = 97},
  [32] = {.lex_state = 97},
  [33] = {.lex_state = 97},
  [34] = {.lex_state = 97},
  [35] = {.lex_state = 97},
  [36] = {.lex_state = 97},
  [37] = {.lex_state = 97},
  [38] = {.lex_state = 97},
  [39] = {.lex_state = 97},
  [40] = {.lex_state = 97},
  [41] = {.lex_state = 97},
  [42] = {.lex_state = 97},
  [43] = {.lex_state = 97},
  [44] = {.lex_state = 97},
  [45] = {.lex_state = 97},
  [46] = {.lex_state = 97},
  [47] = {.lex_state = 97},
  [48] = {.lex_state = 97},
  [49] = {.lex_state = 97},
  [50] = {.lex_state = 15},
  [51] = {.lex_state = 15},
  [52] = {.lex_state = 15},
  [53] = {.lex_state = 15},
  [54] = {.lex_state = 15},
  [55] = {.lex_state = 15},
  [56] = {.lex_state = 15},
  [57] = {.lex_state = 15},
  [58] = {.lex_state = 15},
  [59] = {.lex_state = 15},
  [60] = {.lex_state = 5, .external_lex_state = 2},
  [61] = {.lex_state = 5, .external_lex_state = 2},
  [62] = {.lex_state = 5, .external_lex_state = 2},
  [63] = {.lex_state = 5, .external_lex_state = 2},
  [64] = {.lex_state = 5, .external_lex_state = 2},
  [65] = {.lex_state = 5, .external_lex_state = 2},
  [66] = {.lex_state = 5, .external_lex_state = 2},
  [67] = {.lex_state = 5, .external_lex_state = 2},
  [68] = {.lex_state = 15},
  [69] = {.lex_state = 15},
  [70] = {.lex_state = 15},
  [71] = {.lex_state = 15},
  [72] = {.lex_state = 15},
  [73] = {.lex_state = 15},
  [74] = {.lex_state = 15},
  [75] = {.lex_state = 15},
  [76] = {.lex_state = 15},
  [77] = {.lex_state = 15},
  [78] = {.lex_state = 15},
  [79] = {.lex_state = 15},
  [80] = {.lex_state = 15},
  [81] = {.lex_state = 15},
  [82] = {.lex_state = 15},
  [83] = {.lex_state = 15},
  [84] = {.lex_state = 15},
  [85] = {.lex_state = 15},
  [86] = {.lex_state = 15},
  [87] = {.lex_state = 15},
  [88] = {.lex_state = 96, .external_lex_state = 2},
  [89] = {.lex_state = 96, .external_lex_state = 3},
  [90] = {.lex_state = 96, .external_lex_state = 3},
  [91] = {.lex_state = 96, .external_lex_state = 2},
  [92] = {.lex_state = 96, .external_lex_state = 2},
  [93] = {.lex_state = 96, .external_lex_state = 3},
  [94] = {.lex_state = 96, .external_lex_state = 2},
  [95] = {.lex_state = 96, .external_lex_state = 2},
  [96] = {.lex_state = 97},
  [97] = {.lex_state = 97},
  [98] = {.lex_state = 97},
  [99] = {.lex_state = 97},
  [100] = {.lex_state = 97},
  [101] = {.lex_state = 97},
  [102] = {.lex_state = 3, .external_lex_state = 2},
  [103] = {.lex_state = 3, .external_lex_state = 3},
  [104] = {.lex_state = 3, .external_lex_state = 3},
  [105] = {.lex_state = 3, .external_lex_state = 2},
  [106] = {.lex_state = 3, .external_lex_state = 2},
  [107] = {.lex_state = 3, .external_lex_state = 2},
  [108] = {.lex_state = 3, .external_lex_state = 2},
  [109] = {.lex_state = 3, .external_lex_state = 2},
  [110] = {.lex_state = 3, .external_lex_state = 2},
  [111] = {.lex_state = 3, .external_lex_state = 3},
  [112] = {.lex_state = 3, .external_lex_state = 2},
  [113] = {.lex_state = 3, .external_lex_state = 2},
  [114] = {.lex_state = 3, .external_lex_state = 2},
  [115] = {.lex_state = 97},
  [116] = {.lex_state = 97},
  [117] = {.lex_state = 97},
  [118] = {.lex_state = 97},
  [119] = {.lex_state = 97},
  [120] = {.lex_state = 97},
  [121] = {.lex_state = 97},
  [122] = {.lex_state = 97},
  [123] = {.lex_state = 97},
  [124] = {.lex_state = 97},
  [125] = {.lex_state = 97},
  [126] = {.lex_state = 97},
  [127] = {.lex_state = 97},
  [128] = {.lex_state = 97},
  [129] = {.lex_state = 97},
  [130] = {.lex_state = 97},
  [131] = {.lex_state = 97},
  [132] = {.lex_state = 96, .external_lex_state = 3},
  [133] = {.lex_state = 97},
  [134] = {.lex_state = 97},
  [135] = {.lex_state = 97},
  [136] = {.lex_state = 96, .external_lex_state = 3},
  [137] = {.lex_state = 97},
  [138] = {.lex_state = 96, .external_lex_state = 3},
  [139] = {.lex_state = 97},
  [140] = {.lex_state = 97},
  [141] = {.lex_state = 96, .external_lex_state = 3},
  [142] = {.lex_state = 96, .external_lex_state = 3},
  [143] = {.lex_state = 96, .external_lex_state = 3},
  [144] = {.lex_state = 96, .external_lex_state = 3},
  [145] = {.lex_state = 96, .external_lex_state = 3},
  [146] = {.lex_state = 96, .external_lex_state = 3},
  [147] = {.lex_state = 97},
  [148] = {.lex_state = 96, .external_lex_state = 3},
  [149] = {.lex_state = 96, .external_lex_state = 3},
  [150] = {.lex_state = 96, .external_lex_state = 3},
  [151] = {.lex_state = 96, .external_lex_state = 3},
  [152] = {.lex_state = 96, .external_lex_state = 3},
  [153] = {.lex_state = 96, .external_lex_state = 3},
  [154] = {.lex_state = 96, .external_lex_state = 3},
  [155] = {.lex_state = 96, .external_lex_state = 3},
  [156] = {.lex_state = 96, .external_lex_state = 3},
  [157] = {.lex_state = 96, .external_lex_state = 3},
  [158] = {.lex_state = 96, .external_lex_state = 3},
  [159] = {.lex_state = 96, .external_lex_state = 3},
  [160] = {.lex_state = 96, .external_lex_state = 3},
  [161] = {.lex_state = 96, .external_lex_state = 3},
  [162] = {.lex_state = 96, .external_lex_state = 3},
  [163] = {.lex_state = 97, .external_lex_state = 4},
  [164] = {.lex_state = 96, .external_lex_state = 3},
  [165] = {.lex_state = 96, .external_lex_state = 3},
  [166] = {.lex_state = 96, .external_lex_state = 3},
  [167] = {.lex_state = 96, .external_lex_state = 3},
  [168] = {.lex_state = 96, .external_lex_state = 3},
  [169] = {.lex_state = 97},
  [170] = {.lex_state = 97},
  [171] = {.lex_state = 97},
  [172] = {.lex_state = 97},
  [173] = {.lex_state = 97},
  [174] = {.lex_state = 97},
  [175] = {.lex_state = 97},
  [176] = {.lex_state = 97},
  [177] = {.lex_state = 97},
  [178] = {.lex_state = 97},
  [179] = {.lex_state = 97},
  [180] = {.lex_state = 97},
  [181] = {.lex_state = 97},
  [182] = {.lex_state = 97},
  [183] = {.lex_state = 97},
  [184] = {.lex_state = 97},
  [185] = {.lex_state = 97},
  [186] = {.lex_state = 97},
  [187] = {.lex_state = 97},
  [188] = {.lex_state = 97},
  [189] = {.lex_state = 97},
  [190] = {.lex_state = 97},
  [191] = {.lex_state = 97},
  [192] = {.lex_state = 97},
  [193] = {.lex_state = 97},
  [194] = {.lex_state = 97},
  [195] = {.lex_state = 97},
  [196] = {.lex_state = 97},
  [197] = {.lex_state = 97},
  [198] = {.lex_state = 97},
  [199] = {.lex_state = 5, .external_lex_state = 2},
  [200] = {.lex_state = 97},
  [201] = {.lex_state = 97},
  [202] = {.lex_state = 97},
  [203] = {.lex_state = 97},
  [204] = {.lex_state = 97},
  [205] = {.lex_state = 5, .external_lex_state = 2},
  [206] = {.lex_state = 97},
  [207] = {.lex_state = 97},
  [208] = {.lex_state = 5, .external_lex_state = 2},
  [209] = {.lex_state = 97},
  [210] = {.lex_state = 97},
  [211] = {.lex_state = 97},
  [212] = {.lex_state = 5, .external_lex_state = 2},
  [213] = {.lex_state = 97},
  [214] = {.lex_state = 97},
  [215] = {.lex_state = 97},
  [216] = {.lex_state = 97},
  [217] = {.lex_state = 97},
  [218] = {.lex_state = 97},
  [219] = {.lex_state = 97},
  [220] = {.lex_state = 97, .external_lex_state = 4},
  [221] = {.lex_state = 97},
  [222] = {.lex_state = 97},
  [223] = {.lex_state = 97},
  [224] = {.lex_state = 97},
  [225] = {.lex_state = 97},
  [226] = {.lex_state = 97},
  [227] = {.lex_state = 97},
  [228] = {.lex_state = 97},
  [229] = {.lex_state = 97},
  [230] = {.lex_state = 97},
  [231] = {.lex_state = 97},
  [232] = {.lex_state = 97},
  [233] = {.lex_state = 97},
  [234] = {.lex_state = 97},
  [235] = {.lex_state = 97},
  [236] = {.lex_state = 97},
  [237] = {.lex_state = 97},
  [238] = {.lex_state = 97},
  [239] = {.lex_state = 97},
  [240] = {.lex_state = 97},
  [241] = {.lex_state = 97},
  [242] = {.lex_state = 97},
  [243] = {.lex_state = 97},
  [244] = {.lex_state = 97},
  [245] = {.lex_state = 97},
  [246] = {.lex_state = 97},
  [247] = {.lex_state = 97},
  [248] = {.lex_state = 97},
  [249] = {.lex_state = 97},
  [250] = {.lex_state = 97},
  [251] = {.lex_state = 97},
  [252] = {.lex_state = 6, .external_lex_state = 3},
  [253] = {.lex_state = 97},
  [254] = {.lex_state = 97},
  [255] = {.lex_state = 97},
  [256] = {.lex_state = 97},
  [257] = {.lex_state = 97},
  [258] = {.lex_state = 6, .external_lex_state = 3},
  [259] = {.lex_state = 97},
  [260] = {.lex_state = 97},
  [261] = {.lex_state = 97},
  [262] = {.lex_state = 97},
  [263] = {.lex_state = 97},
  [264] = {.lex_state = 97},
  [265] = {.lex_state = 97},
  [266] = {.lex_state = 97},
  [267] = {.lex_state = 97},
  [268] = {.lex_state = 97},
  [269] = {.lex_state = 97},
  [270] = {.lex_state = 97},
  [271] = {.lex_state = 97},
  [272] = {.lex_state = 97},
  [273] = {.lex_state = 97},
  [274] = {.lex_state = 97},
  [275] = {.lex_state = 97},
  [276] = {.lex_state = 97},
  [277] = {.lex_state = 97},
  [278] = {.lex_state = 97},
  [279] = {.lex_state = 97},
  [280] = {.lex_state = 97},
  [281] = {.lex_state = 97},
  [282] = {.lex_state = 6, .external_lex_state = 3},
  [283] = {.lex_state = 97},
  [284] = {.lex_state = 97},
  [285] = {.lex_state = 97},
  [286] = {.lex_state = 97},
  [287] = {.lex_state = 97},
  [288] = {.lex_state = 97},
  [289] = {.lex_state = 97},
  [290] = {.lex_state = 97},
  [291] = {.lex_state = 97},
  [292] = {.lex_state = 97},
  [293] = {.lex_state = 97},
  [294] = {.lex_state = 97},
  [295] = {.lex_state = 97},
  [296] = {.lex_state = 97},
  [297] = {.lex_state = 97},
  [298] = {.lex_state = 97},
  [299] = {.lex_state = 97},
  [300] = {.lex_state = 97},
  [301] = {.lex_state = 97},
  [302] = {.lex_state = 97},
  [303] = {.lex_state = 97},
  [304] = {.lex_state = 97},
  [305] = {.lex_state = 97},
  [306] = {.lex_state = 97},
  [307] = {.lex_state = 97},
  [308] = {.lex_state = 97},
  [309] = {.lex_state = 97},
  [310] = {.lex_state = 97},
  [311] = {.lex_state = 97},
  [312] = {.lex_state = 97},
  [313] = {.lex_state = 97},
  [314] = {.lex_state = 97},
  [315] = {.lex_state = 97},
  [316] = {.lex_state = 97},
  [317] = {.lex_state = 97},
  [318] = {.lex_state = 97},
  [319] = {.lex_state = 97},
  [320] = {.lex_state = 97},
  [321] = {.lex_state = 97},
  [322] = {.lex_state = 97},
  [323] = {.lex_state = 97},
  [324] = {.lex_state = 97},
  [325] = {.lex_state = 97},
  [326] = {.lex_state = 97},
  [327] = {.lex_state = 97},
  [328] = {.lex_state = 97},
  [329] = {.lex_state = 97},
  [330] = {.lex_state = 97},
  [331] = {.lex_state = 97},
  [332] = {.lex_state = 97},
  [333] = {.lex_state = 97},
  [334] = {.lex_state = 97},
  [335] = {.lex_state = 97},
  [336] = {.lex_state = 97},
  [337] = {.lex_state = 97},
  [338] = {.lex_state = 97},
  [339] = {.lex_state = 97},
  [340] = {.lex_state = 97},
  [341] = {.lex_state = 97},
  [342] = {.lex_state = 97},
  [343] = {.lex_state = 97},
  [344] = {.lex_state = 97},
  [345] = {.lex_state = 97},
  [346] = {.lex_state = 97},
  [347] = {.lex_state = 97},
  [348] = {.lex_state = 97},
  [349] = {.lex_state = 97},
  [350] = {.lex_state = 97},
  [351] = {.lex_state = 97},
  [352] = {.lex_state = 97},
  [353] = {.lex_state = 97},
  [354] = {.lex_state = 97},
  [355] = {.lex_state = 97},
  [356] = {.lex_state = 97},
  [357] = {.lex_state = 97},
  [358] = {.lex_state = 97},
  [359] = {.lex_state = 97},
  [360] = {.lex_state = 97},
  [361] = {.lex_state = 97},
  [362] = {.lex_state = 97},
  [363] = {.lex_state = 97},
  [364] = {.lex_state = 97},
  [365] = {.lex_state = 97},
  [366] = {.lex_state = 97},
  [367] = {.lex_state = 97},
  [368] = {.lex_state = 97},
  [369] = {.lex_state = 97},
  [370] = {.lex_state = 97},
  [371] = {.lex_state = 97},
  [372] = {.lex_state = 97},
  [373] = {.lex_state = 97},
  [374] = {.lex_state = 97},
  [375] = {.lex_state = 97},
  [376] = {.lex_state = 97},
  [377] = {.lex_state = 97},
  [378] = {.lex_state = 97},
  [379] = {.lex_state = 97},
  [380] = {.lex_state = 97},
  [381] = {.lex_state = 97},
  [382] = {.lex_state = 97},
  [383] = {.lex_state = 97},
  [384] = {.lex_state = 97},
  [385] = {.lex_state = 97},
  [386] = {.lex_state = 97},
  [387] = {.lex_state = 97},
  [388] = {.lex_state = 97},
  [389] = {.lex_state = 97},
  [390] = {.lex_state = 97},
  [391] = {.lex_state = 97},
  [392] = {.lex_state = 97},
  [393] = {.lex_state = 97},
  [394] = {.lex_state = 97},
  [395] = {.lex_state = 97},
  [396] = {.lex_state = 97},
  [397] = {.lex_state = 97},
  [398] = {.lex_state = 97},
  [399] = {.lex_state = 97},
  [400] = {.lex_state = 97},
  [401] = {.lex_state = 97},
  [402] = {.lex_state = 97},
  [403] = {.lex_state = 97},
  [404] = {.lex_state = 97},
  [405] = {.lex_state = 97},
  [406] = {.lex_state = 97},
  [407] = {.lex_state = 97},
  [408] = {.lex_state = 97},
  [409] = {.lex_state = 97},
  [410] = {.lex_state = 97},
  [411] = {.lex_state = 97},
  [412] = {.lex_state = 97},
  [413] = {.lex_state = 97},
  [414] = {.lex_state = 97},
  [415] = {.lex_state = 97},
  [416] = {.lex_state = 97},
  [417] = {.lex_state = 97},
  [418] = {.lex_state = 97},
  [419] = {.lex_state = 97},
  [420] = {.lex_state = 97},
  [421] = {.lex_state = 97},
  [422] = {.lex_state = 97},
  [423] = {.lex_state = 97},
  [424] = {.lex_state = 97},
  [425] = {.lex_state = 97},
  [426] = {.lex_state = 97},
  [427] = {.lex_state = 97},
  [428] = {.lex_state = 97},
  [429] = {.lex_state = 97},
  [430] = {.lex_state = 97},
  [431] = {.lex_state = 97},
  [432] = {.lex_state = 97},
  [433] = {.lex_state = 97},
  [434] = {.lex_state = 97},
  [435] = {.lex_state = 97},
  [436] = {.lex_state = 97},
  [437] = {.lex_state = 97},
  [438] = {.lex_state = 97},
  [439] = {.lex_state = 97},
  [440] = {.lex_state = 97},
  [441] = {.lex_state = 97},
  [442] = {.lex_state = 97},
  [443] = {.lex_state = 97},
  [444] = {.lex_state = 97},
  [445] = {.lex_state = 97},
  [446] = {.lex_state = 97},
  [447] = {.lex_state = 97},
  [448] = {.lex_state = 97},
  [449] = {.lex_state = 97},
  [450] = {.lex_state = 97},
  [451] = {.lex_state = 97},
  [452] = {.lex_state = 97},
  [453] = {.lex_state = 97},
  [454] = {.lex_state = 97},
  [455] = {.lex_state = 97},
  [456] = {.lex_state = 97},
  [457] = {.lex_state = 97},
  [458] = {.lex_state = 97},
  [459] = {.lex_state = 97},
  [460] = {.lex_state = 97},
  [461] = {.lex_state = 97},
  [462] = {.lex_state = 97},
  [463] = {.lex_state = 97},
  [464] = {.lex_state = 97},
  [465] = {.lex_state = 97},
  [466] = {.lex_state = 97},
  [467] = {.lex_state = 97},
  [468] = {.lex_state = 97},
  [469] = {.lex_state = 97},
  [470] = {.lex_state = 97},
  [471] = {.lex_state = 97},
  [472] = {.lex_state = 97},
  [473] = {.lex_state = 97},
  [474] = {.lex_state = 97},
  [475] = {.lex_state = 97},
  [476] = {.lex_state = 97},
  [477] = {.lex_state = 97},
  [478] = {.lex_state = 97},
  [479] = {.lex_state = 97},
  [480] = {.lex_state = 97},
  [481] = {.lex_state = 97},
  [482] = {.lex_state = 97},
  [483] = {.lex_state = 97},
  [484] = {.lex_state = 97},
  [485] = {.lex_state = 97},
  [486] = {.lex_state = 97},
  [487] = {.lex_state = 97},
  [488] = {.lex_state = 97},
  [489] = {.lex_state = 97},
  [490] = {.lex_state = 97},
  [491] = {.lex_state = 97},
  [492] = {.lex_state = 97},
  [493] = {.lex_state = 97},
  [494] = {.lex_state = 97},
  [495] = {.lex_state = 97},
  [496] = {.lex_state = 97},
  [497] = {.lex_state = 97},
  [498] = {.lex_state = 97},
  [499] = {.lex_state = 97},
  [500] = {.lex_state = 97},
  [501] = {.lex_state = 97},
  [502] = {.lex_state = 97},
  [503] = {.lex_state = 97},
  [504] = {.lex_state = 97},
  [505] = {.lex_state = 97},
  [506] = {.lex_state = 97},
  [507] = {.lex_state = 97},
  [508] = {.lex_state = 97},
  [509] = {.lex_state = 97},
  [510] = {.lex_state = 97},
  [511] = {.lex_state = 97},
  [512] = {.lex_state = 97},
  [513] = {.lex_state = 97},
  [514] = {.lex_state = 97},
  [515] = {.lex_state = 97},
  [516] = {.lex_state = 97},
  [517] = {.lex_state = 97},
  [518] = {.lex_state = 97},
  [519] = {.lex_state = 97},
  [520] = {.lex_state = 97},
  [521] = {.lex_state = 97},
  [522] = {.lex_state = 97},
  [523] = {.lex_state = 3, .external_lex_state = 3},
  [524] = {.lex_state = 3, .external_lex_state = 3},
  [525] = {.lex_state = 3, .external_lex_state = 3},
  [526] = {.lex_state = 6, .external_lex_state = 3},
  [527] = {.lex_state = 6, .external_lex_state = 3},
  [528] = {.lex_state = 3, .external_lex_state = 3},
  [529] = {.lex_state = 3, .external_lex_state = 3},
  [530] = {.lex_state = 3, .external_lex_state = 3},
  [531] = {.lex_state = 3, .external_lex_state = 3},
  [532] = {.lex_state = 3, .external_lex_state = 3},
  [533] = {.lex_state = 3, .external_lex_state = 3},
  [534] = {.lex_state = 3, .external_lex_state = 3},
  [535] = {.lex_state = 3, .external_lex_state = 3},
  [536] = {.lex_state = 3, .external_lex_state = 3},
  [537] = {.lex_state = 97},
  [538] = {.lex_state = 3, .external_lex_state = 3},
  [539] = {.lex_state = 97},
  [540] = {.lex_state = 3, .external_lex_state = 3},
  [541] = {.lex_state = 3, .external_lex_state = 3},
  [542] = {.lex_state = 3, .external_lex_state = 3},
  [543] = {.lex_state = 3, .external_lex_state = 3},
  [544] = {.lex_state = 3, .external_lex_state = 3},
  [545] = {.lex_state = 3, .external_lex_state = 3},
  [546] = {.lex_state = 97},
  [547] = {.lex_state = 97},
  [548] = {.lex_state = 97},
  [549] = {.lex_state = 97},
  [550] = {.lex_state = 97},
  [551] = {.lex_state = 3, .external_lex_state = 3},
  [552] = {.lex_state = 3, .external_lex_state = 3},
  [553] = {.lex_state = 3, .external_lex_state = 3},
  [554] = {.lex_state = 3, .external_lex_state = 3},
  [555] = {.lex_state = 3, .external_lex_state = 3},
  [556] = {.lex_state = 3, .external_lex_state = 3},
  [557] = {.lex_state = 3, .external_lex_state = 2},
  [558] = {.lex_state = 3, .external_lex_state = 2},
  [559] = {.lex_state = 3, .external_lex_state = 2},
  [560] = {.lex_state = 3, .external_lex_state = 2},
  [561] = {.lex_state = 3, .external_lex_state = 2},
  [562] = {.lex_state = 3, .external_lex_state = 3},
  [563] = {.lex_state = 3, .external_lex_state = 3},
  [564] = {.lex_state = 3, .external_lex_state = 2},
  [565] = {.lex_state = 3, .external_lex_state = 3},
  [566] = {.lex_state = 3, .external_lex_state = 3},
  [567] = {.lex_state = 3, .external_lex_state = 3},
  [568] = {.lex_state = 3, .external_lex_state = 3},
  [569] = {.lex_state = 3, .external_lex_state = 3},
  [570] = {.lex_state = 3, .external_lex_state = 2},
  [571] = {.lex_state = 6, .external_lex_state = 2},
  [572] = {.lex_state = 97, .external_lex_state = 4},
  [573] = {.lex_state = 6, .external_lex_state = 2},
  [574] = {.lex_state = 97},
  [575] = {.lex_state = 97, .external_lex_state = 4},
  [576] = {.lex_state = 97},
  [577] = {.lex_state = 3, .external_lex_state = 3},
  [578] = {.lex_state = 3, .external_lex_state = 2},
  [579] = {.lex_state = 97, .external_lex_state = 4},
  [580] = {.lex_state = 97, .external_lex_state = 4},
  [581] = {.lex_state = 97, .external_lex_state = 4},
  [582] = {.lex_state = 3, .external_lex_state = 3},
  [583] = {.lex_state = 97},
  [584] = {.lex_state = 3, .external_lex_state = 3},
  [585] = {.lex_state = 3, .external_lex_state = 2},
  [586] = {.lex_state = 3, .external_lex_state = 2},
  [587] = {.lex_state = 3, .external_lex_state = 2},
  [588] = {.lex_state = 3, .external_lex_state = 2},
  [589] = {.lex_state = 3, .external_lex_state = 3},
  [590] = {.lex_state = 97, .external_lex_state = 4},
  [591] = {.lex_state = 97, .external_lex_state = 4},
  [592] = {.lex_state = 3, .external_lex_state = 3},
  [593] = {.lex_state = 97, .external_lex_state = 4},
  [594] = {.lex_state = 3, .external_lex_state = 2},
  [595] = {.lex_state = 97},
  [596] = {.lex_state = 97},
  [597] = {.lex_state = 3, .external_lex_state = 2},
  [598] = {.lex_state = 3, .external_lex_state = 2},
  [599] = {.lex_state = 97},
  [600] = {.lex_state = 3, .external_lex_state = 2},
  [601] = {.lex_state = 97, .external_lex_state = 4},
  [602] = {.lex_state = 97, .external_lex_state = 4},
  [603] = {.lex_state = 97},
  [604] = {.lex_state = 97, .external_lex_state = 4},
  [605] = {.lex_state = 97, .external_lex_state = 4},
  [606] = {.lex_state = 97},
  [607] = {.lex_state = 97},
  [608] = {.lex_state = 97, .external_lex_state = 4},
  [609] = {.lex_state = 97, .external_lex_state = 4},
  [610] = {.lex_state = 97},
  [611] = {.lex_state = 97},
  [612] = {.lex_state = 3, .external_lex_state = 2},
  [613] = {.lex_state = 97, .external_lex_state = 4},
  [614] = {.lex_state = 97},
  [615] = {.lex_state = 97, .external_lex_state = 4},
  [616] = {.lex_state = 97, .external_lex_state = 4},
  [617] = {.lex_state = 97},
  [618] = {.lex_state = 97, .external_lex_state = 4},
  [619] = {.lex_state = 97},
  [620] = {.lex_state = 97, .external_lex_state = 4},
  [621] = {.lex_state = 97},
  [622] = {.lex_state = 97, .external_lex_state = 4},
  [623] = {.lex_state = 97},
  [624] = {.lex_state = 97},
  [625] = {.lex_state = 97},
  [626] = {.lex_state = 97},
  [627] = {.lex_state = 97},
  [628] = {.lex_state = 97},
  [629] = {.lex_state = 97},
  [630] = {.lex_state = 97},
  [631] = {.lex_state = 97},
  [632] = {.lex_state = 97},
  [633] = {.lex_state = 97},
  [634] = {.lex_state = 97},
  [635] = {.lex_state = 97},
  [636] = {.lex_state = 97},
  [637] = {.lex_state = 97},
  [638] = {.lex_state = 97},
  [639] = {.lex_state = 97},
  [640] = {.lex_state = 97},
  [641] = {.lex_state = 97},
  [642] = {.lex_state = 97},
  [643] = {.lex_state = 97},
  [644] = {.lex_state = 97},
  [645] = {.lex_state = 97},
  [646] = {.lex_state = 97},
  [647] = {.lex_state = 97},
  [648] = {.lex_state = 97},
  [649] = {.lex_state = 97},
  [650] = {.lex_state = 97},
  [651] = {.lex_state = 97},
  [652] = {.lex_state = 97},
  [653] = {.lex_state = 97},
  [654] = {.lex_state = 97},
  [655] = {.lex_state = 97},
  [656] = {.lex_state = 97},
  [657] = {.lex_state = 97},
  [658] = {.lex_state = 97},
  [659] = {.lex_state = 97},
  [660] = {.lex_state = 97},
  [661] = {.lex_state = 97},
  [662] = {.lex_state = 97},
  [663] = {.lex_state = 97},
  [664] = {.lex_state = 97},
  [665] = {.lex_state = 97},
  [666] = {.lex_state = 97},
  [667] = {.lex_state = 97},
  [668] = {.lex_state = 97},
  [669] = {.lex_state = 97},
  [670] = {.lex_state = 97},
  [671] = {.lex_state = 97},
  [672] = {.lex_state = 97},
  [673] = {.lex_state = 97},
  [674] = {.lex_state = 97},
  [675] = {.lex_state = 97},
  [676] = {.lex_state = 97},
  [677] = {.lex_state = 97},
  [678] = {.lex_state = 97},
  [679] = {.lex_state = 97},
  [680] = {.lex_state = 97},
  [681] = {.lex_state = 97},
  [682] = {.lex_state = 97},
  [683] = {.lex_state = 97},
  [684] = {.lex_state = 97},
  [685] = {.lex_state = 97},
  [686] = {.lex_state = 97},
  [687] = {.lex_state = 97},
  [688] = {.lex_state = 97},
  [689] = {.lex_state = 97},
  [690] = {.lex_state = 97},
  [691] = {.lex_state = 97},
  [692] = {.lex_state = 97},
  [693] = {.lex_state = 97},
  [694] = {.lex_state = 97},
  [695] = {.lex_state = 97},
  [696] = {.lex_state = 97},
  [697] = {.lex_state = 97},
  [698] = {.lex_state = 97},
  [699] = {.lex_state = 97},
  [700] = {.lex_state = 97},
  [701] = {.lex_state = 97},
  [702] = {.lex_state = 97},
  [703] = {.lex_state = 97},
  [704] = {.lex_state = 97},
  [705] = {.lex_state = 97},
  [706] = {.lex_state = 97},
  [707] = {.lex_state = 97},
  [708] = {.lex_state = 97},
  [709] = {.lex_state = 97},
  [710] = {.lex_state = 97},
  [711] = {.lex_state = 97},
  [712] = {.lex_state = 97},
  [713] = {.lex_state = 97},
  [714] = {.lex_state = 97},
  [715] = {.lex_state = 97},
  [716] = {.lex_state = 97},
  [717] = {.lex_state = 97},
  [718] = {.lex_state = 97},
  [719] = {.lex_state = 97},
  [720] = {.lex_state = 97},
  [721] = {.lex_state = 97},
  [722] = {.lex_state = 97},
  [723] = {.lex_state = 97},
  [724] = {.lex_state = 97},
  [725] = {.lex_state = 97},
  [726] = {.lex_state = 97},
  [727] = {.lex_state = 97},
  [728] = {.lex_state = 97},
  [729] = {.lex_state = 97},
  [730] = {.lex_state = 97},
  [731] = {.lex_state = 97},
  [732] = {.lex_state = 97},
  [733] = {.lex_state = 97},
  [734] = {.lex_state = 97},
  [735] = {.lex_state = 97},
  [736] = {.lex_state = 97},
  [737] = {.lex_state = 97},
  [738] = {.lex_state = 97},
  [739] = {.lex_state = 97},
  [740] = {.lex_state = 97},
  [741] = {.lex_state = 97},
  [742] = {.lex_state = 97},
  [743] = {.lex_state = 97},
  [744] = {.lex_state = 97},
  [745] = {.lex_state = 97},
  [746] = {.lex_state = 97},
  [747] = {.lex_state = 97},
  [748] = {.lex_state = 97},
  [749] = {.lex_state = 97},
  [750] = {.lex_state = 97},
  [751] = {.lex_state = 97},
  [752] = {.lex_state = 97},
  [753] = {.lex_state = 97},
  [754] = {.lex_state = 97},
  [755] = {.lex_state = 97},
  [756] = {.lex_state = 97},
  [757] = {.lex_state = 97},
  [758] = {.lex_state = 97},
  [759] = {.lex_state = 97},
  [760] = {.lex_state = 97},
  [761] = {.lex_state = 97},
  [762] = {.lex_state = 97},
  [763] = {.lex_state = 97},
  [764] = {.lex_state = 97},
  [765] = {.lex_state = 97},
  [766] = {.lex_state = 97},
  [767] = {.lex_state = 97},
  [768] = {.lex_state = 97},
  [769] = {.lex_state = 13},
  [770] = {.lex_state = 13},
  [771] = {.lex_state = 13},
  [772] = {.lex_state = 13},
  [773] = {.lex_state = 13},
  [774] = {.lex_state = 13},
  [775] = {.lex_state = 13},
  [776] = {.lex_state = 13},
  [777] = {.lex_state = 13},
  [778] = {.lex_state = 13},
  [779] = {.lex_state = 13},
  [780] = {.lex_state = 13},
  [781] = {.lex_state = 13},
  [782] = {.lex_state = 13},
  [783] = {.lex_state = 13},
  [784] = {.lex_state = 13},
  [785] = {.lex_state = 97},
  [786] = {.lex_state = 97},
  [787] = {.lex_state = 97},
  [788] = {.lex_state = 97},
  [789] = {.lex_state = 97},
  [790] = {.lex_state = 97},
  [791] = {.lex_state = 97},
  [792] = {.lex_state = 97},
  [793] = {.lex_state = 97},
  [794] = {.lex_state = 97},
  [795] = {.lex_state = 97},
  [796] = {.lex_state = 97},
  [797] = {.lex_state = 97},
  [798] = {.lex_state = 13},
  [799] = {.lex_state = 13},
  [800] = {.lex_state = 13},
  [801] = {.lex_state = 13},
  [802] = {.lex_state = 13},
  [803] = {.lex_state = 13},
  [804] = {.lex_state = 13},
  [805] = {.lex_state = 13},
  [806] = {.lex_state = 13},
  [807] = {.lex_state = 13},
  [808] = {.lex_state = 16},
  [809] = {.lex_state = 13},
  [810] = {.lex_state = 13},
  [811] = {.lex_state = 16},
  [812] = {.lex_state = 16},
  [813] = {.lex_state = 13},
  [814] = {.lex_state = 13},
  [815] = {.lex_state = 13},
  [816] = {.lex_state = 13},
  [817] = {.lex_state = 3, .external_lex_state = 3},
  [818] = {.lex_state = 3, .external_lex_state = 3},
  [819] = {.lex_state = 3, .external_lex_state = 3},
  [820] = {.lex_state = 3, .external_lex_state = 3},
  [821] = {.lex_state = 3, .external_lex_state = 3},
  [822] = {.lex_state = 3, .external_lex_state = 3},
  [823] = {.lex_state = 13},
  [824] = {.lex_state = 13},
  [825] = {.lex_state = 13},
  [826] = {.lex_state = 13},
  [827] = {.lex_state = 13},
  [828] = {.lex_state = 13},
  [829] = {.lex_state = 13},
  [830] = {.lex_state = 13},
  [831] = {.lex_state = 13},
  [832] = {.lex_state = 13},
  [833] = {.lex_state = 13},
  [834] = {.lex_state = 13},
  [835] = {.lex_state = 13},
  [836] = {.lex_state = 13},
  [837] = {.lex_state = 13},
  [838] = {.lex_state = 13},
  [839] = {.lex_state = 13},
  [840] = {.lex_state = 13},
  [841] = {.lex_state = 13},
  [842] = {.lex_state = 13},
  [843] = {.lex_state = 13},
  [844] = {.lex_state = 13},
  [845] = {.lex_state = 13},
  [846] = {.lex_state = 13},
  [847] = {.lex_state = 13},
  [848] = {.lex_state = 13},
  [849] = {.lex_state = 13},
  [850] = {.lex_state = 13},
  [851] = {.lex_state = 13},
  [852] = {.lex_state = 13},
  [853] = {.lex_state = 13},
  [854] = {.lex_state = 13},
  [855] = {.lex_state = 13},
  [856] = {.lex_state = 13},
  [857] = {.lex_state = 13},
  [858] = {.lex_state = 12},
  [859] = {.lex_state = 13},
  [860] = {.lex_state = 13},
  [861] = {.lex_state = 13},
  [862] = {.lex_state = 12},
  [863] = {.lex_state = 13},
  [864] = {.lex_state = 13},
  [865] = {.lex_state = 13},
  [866] = {.lex_state = 13},
  [867] = {.lex_state = 13},
  [868] = {.lex_state = 13},
  [869] = {.lex_state = 13},
  [870] = {.lex_state = 13},
  [871] = {.lex_state = 13},
  [872] = {.lex_state = 13},
  [873] = {.lex_state = 13},
  [874] = {.lex_state = 13},
  [875] = {.lex_state = 13},
  [876] = {.lex_state = 12},
  [877] = {.lex_state = 13},
  [878] = {.lex_state = 13},
  [879] = {.lex_state = 13},
  [880] = {.lex_state = 13},
  [881] = {.lex_state = 13},
  [882] = {.lex_state = 13},
  [883] = {.lex_state = 13},
  [884] = {.lex_state = 13},
  [885] = {.lex_state = 13},
  [886] = {.lex_state = 13},
  [887] = {.lex_state = 13},
  [888] = {.lex_state = 13},
  [889] = {.lex_state = 13},
  [890] = {.lex_state = 13},
  [891] = {.lex_state = 13},
  [892] = {.lex_state = 13},
  [893] = {.lex_state = 13},
  [894] = {.lex_state = 12},
  [895] = {.lex_state = 13},
  [896] = {.lex_state = 13},
  [897] = {.lex_state = 13},
  [898] = {.lex_state = 13},
  [899] = {.lex_state = 13},
  [900] = {.lex_state = 13},
  [901] = {.lex_state = 13},
  [902] = {.lex_state = 13},
  [903] = {.lex_state = 12},
  [904] = {.lex_state = 13},
  [905] = {.lex_state = 13},
  [906] = {.lex_state = 13},
  [907] = {.lex_state = 13},
  [908] = {.lex_state = 13},
  [909] = {.lex_state = 13},
  [910] = {.lex_state = 13},
  [911] = {.lex_state = 12},
  [912] = {.lex_state = 13},
  [913] = {.lex_state = 13},
  [914] = {.lex_state = 12},
  [915] = {.lex_state = 13},
  [916] = {.lex_state = 13},
  [917] = {.lex_state = 13},
  [918] = {.lex_state = 13},
  [919] = {.lex_state = 13},
  [920] = {.lex_state = 13},
  [921] = {.lex_state = 13},
  [922] = {.lex_state = 13},
  [923] = {.lex_state = 13},
  [924] = {.lex_state = 13},
  [925] = {.lex_state = 13},
  [926] = {.lex_state = 13},
  [927] = {.lex_state = 13},
  [928] = {.lex_state = 13},
  [929] = {.lex_state = 13},
  [930] = {.lex_state = 13},
  [931] = {.lex_state = 13},
  [932] = {.lex_state = 13},
  [933] = {.lex_state = 12},
  [934] = {.lex_state = 13},
  [935] = {.lex_state = 13},
  [936] = {.lex_state = 13},
  [937] = {.lex_state = 13},
  [938] = {.lex_state = 13},
  [939] = {.lex_state = 13},
  [940] = {.lex_state = 13},
  [941] = {.lex_state = 13},
  [942] = {.lex_state = 13},
  [943] = {.lex_state = 13},
  [944] = {.lex_state = 3, .external_lex_state = 2},
  [945] = {.lex_state = 13},
  [946] = {.lex_state = 3, .external_lex_state = 2},
  [947] = {.lex_state = 13},
  [948] = {.lex_state = 13},
  [949] = {.lex_state = 12},
  [950] = {.lex_state = 13},
  [951] = {.lex_state = 13},
  [952] = {.lex_state = 13},
  [953] = {.lex_state = 13},
  [954] = {.lex_state = 13},
  [955] = {.lex_state = 13},
  [956] = {.lex_state = 13},
  [957] = {.lex_state = 13},
  [958] = {.lex_state = 13},
  [959] = {.lex_state = 13},
  [960] = {.lex_state = 13},
  [961] = {.lex_state = 13},
  [962] = {.lex_state = 13},
  [963] = {.lex_state = 13},
  [964] = {.lex_state = 12},
  [965] = {.lex_state = 12},
  [966] = {.lex_state = 12},
  [967] = {.lex_state = 13},
  [968] = {.lex_state = 13},
  [969] = {.lex_state = 13},
  [970] = {.lex_state = 13},
  [971] = {.lex_state = 13},
  [972] = {.lex_state = 13},
  [973] = {.lex_state = 13},
  [974] = {.lex_state = 3, .external_lex_state = 2},
  [975] = {.lex_state = 13},
  [976] = {.lex_state = 13},
  [977] = {.lex_state = 13},
  [978] = {.lex_state = 13},
  [979] = {.lex_state = 13},
  [980] = {.lex_state = 13},
  [981] = {.lex_state = 13},
  [982] = {.lex_state = 13},
  [983] = {.lex_state = 13},
  [984] = {.lex_state = 13},
  [985] = {.lex_state = 13},
  [986] = {.lex_state = 13},
  [987] = {.lex_state = 13},
  [988] = {.lex_state = 13},
  [989] = {.lex_state = 13},
  [990] = {.lex_state = 97},
  [991] = {.lex_state = 3, .external_lex_state = 2},
  [992] = {.lex_state = 3, .external_lex_state = 2},
  [993] = {.lex_state = 97},
  [994] = {.lex_state = 97},
  [995] = {.lex_state = 3, .external_lex_state = 2},
  [996] = {.lex_state = 3, .external_lex_state = 3},
  [997] = {.lex_state = 3, .external_lex_state = 3},
  [998] = {.lex_state = 3, .external_lex_state = 3},
  [999] = {.lex_state = 3, .external_lex_state = 3},
  [1000] = {.lex_state = 3, .external_lex_state = 3},
  [1001] = {.lex_state = 3, .external_lex_state = 3},
  [1002] = {.lex_state = 3, .external_lex_state = 3},
  [1003] = {.lex_state = 3, .external_lex_state = 3},
  [1004] = {.lex_state = 3, .external_lex_state = 3},
  [1005] = {.lex_state = 6, .external_lex_state = 2},
  [1006] = {.lex_state = 3, .external_lex_state = 3},
  [1007] = {.lex_state = 6, .external_lex_state = 2},
  [1008] = {.lex_state = 3, .external_lex_state = 2},
  [1009] = {.lex_state = 3, .external_lex_state = 3},
  [1010] = {.lex_state = 3, .external_lex_state = 3},
  [1011] = {.lex_state = 3, .external_lex_state = 3},
  [1012] = {.lex_state = 3, .external_lex_state = 2},
  [1013] = {.lex_state = 3, .external_lex_state = 3},
  [1014] = {.lex_state = 3, .external_lex_state = 3},
  [1015] = {.lex_state = 3, .external_lex_state = 3},
  [1016] = {.lex_state = 6, .external_lex_state = 2},
  [1017] = {.lex_state = 3, .external_lex_state = 2},
  [1018] = {.lex_state = 3, .external_lex_state = 2},
  [1019] = {.lex_state = 3, .external_lex_state = 3},
  [1020] = {.lex_state = 6, .external_lex_state = 2},
  [1021] = {.lex_state = 6, .external_lex_state = 2},
  [1022] = {.lex_state = 3, .external_lex_state = 3},
  [1023] = {.lex_state = 3, .external_lex_state = 3},
  [1024] = {.lex_state = 12},
  [1025] = {.lex_state = 6, .external_lex_state = 2},
  [1026] = {.lex_state = 3, .external_lex_state = 2},
  [1027] = {.lex_state = 3, .external_lex_state = 2},
  [1028] = {.lex_state = 3, .external_lex_state = 3},
  [1029] = {.lex_state = 3, .external_lex_state = 2},
  [1030] = {.lex_state = 3, .external_lex_state = 3},
  [1031] = {.lex_state = 3, .external_lex_state = 3},
  [1032] = {.lex_state = 6, .external_lex_state = 2},
  [1033] = {.lex_state = 6, .external_lex_state = 2},
  [1034] = {.lex_state = 12},
  [1035] = {.lex_state = 6, .external_lex_state = 2},
  [1036] = {.lex_state = 3, .external_lex_state = 3},
  [1037] = {.lex_state = 3, .external_lex_state = 3},
  [1038] = {.lex_state = 3, .external_lex_state = 2},
  [1039] = {.lex_state = 3, .external_lex_state = 2},
  [1040] = {.lex_state = 3, .external_lex_state = 3},
  [1041] = {.lex_state = 6, .external_lex_state = 2},
  [1042] = {.lex_state = 3, .external_lex_state = 2},
  [1043] = {.lex_state = 6, .external_lex_state = 2},
  [1044] = {.lex_state = 3, .external_lex_state = 3},
  [1045] = {.lex_state = 3, .external_lex_state = 2},
  [1046] = {.lex_state = 3, .external_lex_state = 3},
  [1047] = {.lex_state = 6, .external_lex_state = 2},
  [1048] = {.lex_state = 3, .external_lex_state = 2},
  [1049] = {.lex_state = 3, .external_lex_state = 2},
  [1050] = {.lex_state = 3, .external_lex_state = 2},
  [1051] = {.lex_state = 3, .external_lex_state = 2},
  [1052] = {.lex_state = 3, .external_lex_state = 2},
  [1053] = {.lex_state = 3, .external_lex_state = 2},
  [1054] = {.lex_state = 3, .external_lex_state = 3},
  [1055] = {.lex_state = 3, .external_lex_state = 2},
  [1056] = {.lex_state = 3, .external_lex_state = 2},
  [1057] = {.lex_state = 3, .external_lex_state = 2},
  [1058] = {.lex_state = 3, .external_lex_state = 2},
  [1059] = {.lex_state = 3, .external_lex_state = 2},
  [1060] = {.lex_state = 6, .external_lex_state = 2},
  [1061] = {.lex_state = 3, .external_lex_state = 2},
  [1062] = {.lex_state = 3, .external_lex_state = 3},
  [1063] = {.lex_state = 3, .external_lex_state = 2},
  [1064] = {.lex_state = 3, .external_lex_state = 2},
  [1065] = {.lex_state = 3, .external_lex_state = 3},
  [1066] = {.lex_state = 3, .external_lex_state = 2},
  [1067] = {.lex_state = 3, .external_lex_state = 3},
  [1068] = {.lex_state = 3, .external_lex_state = 2},
  [1069] = {.lex_state = 3, .external_lex_state = 2},
  [1070] = {.lex_state = 3, .external_lex_state = 2},
  [1071] = {.lex_state = 3, .external_lex_state = 3},
  [1072] = {.lex_state = 3, .external_lex_state = 3},
  [1073] = {.lex_state = 3, .external_lex_state = 3},
  [1074] = {.lex_state = 3, .external_lex_state = 2},
  [1075] = {.lex_state = 3, .external_lex_state = 2},
  [1076] = {.lex_state = 3, .external_lex_state = 3},
  [1077] = {.lex_state = 3, .external_lex_state = 2},
  [1078] = {.lex_state = 3, .external_lex_state = 2},
  [1079] = {.lex_state = 3, .external_lex_state = 2},
  [1080] = {.lex_state = 3, .external_lex_state = 2},
  [1081] = {.lex_state = 6, .external_lex_state = 2},
  [1082] = {.lex_state = 3, .external_lex_state = 2},
  [1083] = {.lex_state = 3, .external_lex_state = 2},
  [1084] = {.lex_state = 3, .external_lex_state = 2},
  [1085] = {.lex_state = 3, .external_lex_state = 2},
  [1086] = {.lex_state = 3, .external_lex_state = 3},
  [1087] = {.lex_state = 3, .external_lex_state = 2},
  [1088] = {.lex_state = 3, .external_lex_state = 3},
  [1089] = {.lex_state = 3, .external_lex_state = 3},
  [1090] = {.lex_state = 3, .external_lex_state = 3},
  [1091] = {.lex_state = 3, .external_lex_state = 3},
  [1092] = {.lex_state = 3, .external_lex_state = 2},
  [1093] = {.lex_state = 3, .external_lex_state = 3},
  [1094] = {.lex_state = 3, .external_lex_state = 3},
  [1095] = {.lex_state = 3, .external_lex_state = 2},
  [1096] = {.lex_state = 3, .external_lex_state = 2},
  [1097] = {.lex_state = 3, .external_lex_state = 3},
  [1098] = {.lex_state = 3, .external_lex_state = 2},
  [1099] = {.lex_state = 3, .external_lex_state = 3},
  [1100] = {.lex_state = 3, .external_lex_state = 3},
  [1101] = {.lex_state = 3, .external_lex_state = 3},
  [1102] = {.lex_state = 3, .external_lex_state = 3},
  [1103] = {.lex_state = 3, .external_lex_state = 3},
  [1104] = {.lex_state = 3, .external_lex_state = 2},
  [1105] = {.lex_state = 3, .external_lex_state = 3},
  [1106] = {.lex_state = 3, .external_lex_state = 3},
  [1107] = {.lex_state = 3, .external_lex_state = 3},
  [1108] = {.lex_state = 3, .external_lex_state = 3},
  [1109] = {.lex_state = 3, .external_lex_state = 3},
  [1110] = {.lex_state = 3, .external_lex_state = 2},
  [1111] = {.lex_state = 3, .external_lex_state = 3},
  [1112] = {.lex_state = 6, .external_lex_state = 2},
  [1113] = {.lex_state = 3, .external_lex_state = 2},
  [1114] = {.lex_state = 3, .external_lex_state = 3},
  [1115] = {.lex_state = 3, .external_lex_state = 3},
  [1116] = {.lex_state = 3, .external_lex_state = 3},
  [1117] = {.lex_state = 3, .external_lex_state = 2},
  [1118] = {.lex_state = 3, .external_lex_state = 3},
  [1119] = {.lex_state = 3, .external_lex_state = 3},
  [1120] = {.lex_state = 3, .external_lex_state = 2},
  [1121] = {.lex_state = 3, .external_lex_state = 3},
  [1122] = {.lex_state = 3, .external_lex_state = 3},
  [1123] = {.lex_state = 3, .external_lex_state = 2},
  [1124] = {.lex_state = 3, .external_lex_state = 3},
  [1125] = {.lex_state = 3, .external_lex_state = 2},
  [1126] = {.lex_state = 3, .external_lex_state = 2},
  [1127] = {.lex_state = 3, .external_lex_state = 3},
  [1128] = {.lex_state = 97},
  [1129] = {.lex_state = 6, .external_lex_state = 2},
  [1130] = {.lex_state = 3, .external_lex_state = 3},
  [1131] = {.lex_state = 6, .external_lex_state = 2},
  [1132] = {.lex_state = 3, .external_lex_state = 2},
  [1133] = {.lex_state = 3, .external_lex_state = 2},
  [1134] = {.lex_state = 3, .external_lex_state = 3},
  [1135] = {.lex_state = 6, .external_lex_state = 2},
  [1136] = {.lex_state = 3, .external_lex_state = 2},
  [1137] = {.lex_state = 6, .external_lex_state = 2},
  [1138] = {.lex_state = 97},
  [1139] = {.lex_state = 3, .external_lex_state = 2},
  [1140] = {.lex_state = 3, .external_lex_state = 3},
  [1141] = {.lex_state = 3, .external_lex_state = 2},
  [1142] = {.lex_state = 3, .external_lex_state = 3},
  [1143] = {.lex_state = 3, .external_lex_state = 2},
  [1144] = {.lex_state = 6, .external_lex_state = 2},
  [1145] = {.lex_state = 3, .external_lex_state = 2},
  [1146] = {.lex_state = 3, .external_lex_state = 3},
  [1147] = {.lex_state = 3, .external_lex_state = 3},
  [1148] = {.lex_state = 3, .external_lex_state = 2},
  [1149] = {.lex_state = 97},
  [1150] = {.lex_state = 3, .external_lex_state = 2},
  [1151] = {.lex_state = 3, .external_lex_state = 2},
  [1152] = {.lex_state = 3, .external_lex_state = 2},
  [1153] = {.lex_state = 3, .external_lex_state = 2},
  [1154] = {.lex_state = 3, .external_lex_state = 2},
  [1155] = {.lex_state = 3, .external_lex_state = 2},
  [1156] = {.lex_state = 3, .external_lex_state = 2},
  [1157] = {.lex_state = 3, .external_lex_state = 2},
  [1158] = {.lex_state = 97},
  [1159] = {.lex_state = 3, .external_lex_state = 3},
  [1160] = {.lex_state = 3, .external_lex_state = 2},
  [1161] = {.lex_state = 3, .external_lex_state = 2},
  [1162] = {.lex_state = 97},
  [1163] = {.lex_state = 3, .external_lex_state = 2},
  [1164] = {.lex_state = 3, .external_lex_state = 2},
  [1165] = {.lex_state = 3, .external_lex_state = 3},
  [1166] = {.lex_state = 3, .external_lex_state = 2},
  [1167] = {.lex_state = 3, .external_lex_state = 2},
  [1168] = {.lex_state = 3, .external_lex_state = 2},
  [1169] = {.lex_state = 97},
  [1170] = {.lex_state = 97},
  [1171] = {.lex_state = 3, .external_lex_state = 2},
  [1172] = {.lex_state = 3, .external_lex_state = 2},
  [1173] = {.lex_state = 3, .external_lex_state = 2},
  [1174] = {.lex_state = 3, .external_lex_state = 2},
  [1175] = {.lex_state = 3, .external_lex_state = 2},
  [1176] = {.lex_state = 3, .external_lex_state = 2},
  [1177] = {.lex_state = 3, .external_lex_state = 2},
  [1178] = {.lex_state = 13},
  [1179] = {.lex_state = 13},
  [1180] = {.lex_state = 13},
  [1181] = {.lex_state = 13},
  [1182] = {.lex_state = 13},
  [1183] = {.lex_state = 13},
  [1184] = {.lex_state = 7, .external_lex_state = 3},
  [1185] = {.lex_state = 12, .external_lex_state = 4},
  [1186] = {.lex_state = 13},
  [1187] = {.lex_state = 13},
  [1188] = {.lex_state = 12, .external_lex_state = 4},
  [1189] = {.lex_state = 13},
  [1190] = {.lex_state = 12, .external_lex_state = 4},
  [1191] = {.lex_state = 13},
  [1192] = {.lex_state = 13},
  [1193] = {.lex_state = 13},
  [1194] = {.lex_state = 13},
  [1195] = {.lex_state = 13},
  [1196] = {.lex_state = 13},
  [1197] = {.lex_state = 12, .external_lex_state = 4},
  [1198] = {.lex_state = 12, .external_lex_state = 4},
  [1199] = {.lex_state = 13},
  [1200] = {.lex_state = 13},
  [1201] = {.lex_state = 13},
  [1202] = {.lex_state = 13},
  [1203] = {.lex_state = 13},
  [1204] = {.lex_state = 13},
  [1205] = {.lex_state = 13},
  [1206] = {.lex_state = 13},
  [1207] = {.lex_state = 13},
  [1208] = {.lex_state = 13},
  [1209] = {.lex_state = 7, .external_lex_state = 3},
  [1210] = {.lex_state = 12, .external_lex_state = 4},
  [1211] = {.lex_state = 13},
  [1212] = {.lex_state = 13},
  [1213] = {.lex_state = 13},
  [1214] = {.lex_state = 13},
  [1215] = {.lex_state = 13},
  [1216] = {.lex_state = 7, .external_lex_state = 3},
  [1217] = {.lex_state = 13},
  [1218] = {.lex_state = 12, .external_lex_state = 4},
  [1219] = {.lex_state = 7, .external_lex_state = 2},
  [1220] = {.lex_state = 7, .external_lex_state = 2},
  [1221] = {.lex_state = 7, .external_lex_state = 2},
  [1222] = {.lex_state = 7, .external_lex_state = 2},
  [1223] = {.lex_state = 7, .external_lex_state = 2},
  [1224] = {.lex_state = 7, .external_lex_state = 2},
  [1225] = {.lex_state = 7, .external_lex_state = 2},
  [1226] = {.lex_state = 7, .external_lex_state = 2},
  [1227] = {.lex_state = 7, .external_lex_state = 2},
  [1228] = {.lex_state = 7, .external_lex_state = 3},
  [1229] = {.lex_state = 7, .external_lex_state = 3},
  [1230] = {.lex_state = 7, .external_lex_state = 3},
  [1231] = {.lex_state = 97},
  [1232] = {.lex_state = 97},
  [1233] = {.lex_state = 7, .external_lex_state = 2},
  [1234] = {.lex_state = 7, .external_lex_state = 2},
  [1235] = {.lex_state = 7, .external_lex_state = 2},
  [1236] = {.lex_state = 97},
  [1237] = {.lex_state = 7, .external_lex_state = 2},
  [1238] = {.lex_state = 97},
  [1239] = {.lex_state = 97},
  [1240] = {.lex_state = 97},
  [1241] = {.lex_state = 7, .external_lex_state = 2},
  [1242] = {.lex_state = 97},
  [1243] = {.lex_state = 7, .external_lex_state = 2},
  [1244] = {.lex_state = 7, .external_lex_state = 3},
  [1245] = {.lex_state = 7, .external_lex_state = 2},
  [1246] = {.lex_state = 7, .external_lex_state = 2},
  [1247] = {.lex_state = 7, .external_lex_state = 2},
  [1248] = {.lex_state = 7, .external_lex_state = 2},
  [1249] = {.lex_state = 7, .external_lex_state = 2},
  [1250] = {.lex_state = 7, .external_lex_state = 2},
  [1251] = {.lex_state = 7, .external_lex_state = 2},
  [1252] = {.lex_state = 7, .external_lex_state = 2},
  [1253] = {.lex_state = 7, .external_lex_state = 2},
  [1254] = {.lex_state = 7, .external_lex_state = 2},
  [1255] = {.lex_state = 7, .external_lex_state = 2},
  [1256] = {.lex_state = 7, .external_lex_state = 2},
  [1257] = {.lex_state = 7, .external_lex_state = 2},
  [1258] = {.lex_state = 7, .external_lex_state = 2},
  [1259] = {.lex_state = 7, .external_lex_state = 2},
  [1260] = {.lex_state = 7, .external_lex_state = 2},
  [1261] = {.lex_state = 7, .external_lex_state = 2},
  [1262] = {.lex_state = 7, .external_lex_state = 2},
  [1263] = {.lex_state = 7, .external_lex_state = 2},
  [1264] = {.lex_state = 7, .external_lex_state = 2},
  [1265] = {.lex_state = 7, .external_lex_state = 2},
  [1266] = {.lex_state = 7, .external_lex_state = 2},
  [1267] = {.lex_state = 7, .external_lex_state = 2},
  [1268] = {.lex_state = 7, .external_lex_state = 2},
  [1269] = {.lex_state = 7, .external_lex_state = 2},
  [1270] = {.lex_state = 7, .external_lex_state = 2},
  [1271] = {.lex_state = 7, .external_lex_state = 2},
  [1272] = {.lex_state = 7, .external_lex_state = 2},
  [1273] = {.lex_state = 7, .external_lex_state = 2},
  [1274] = {.lex_state = 7, .external_lex_state = 2},
  [1275] = {.lex_state = 7, .external_lex_state = 2},
  [1276] = {.lex_state = 7, .external_lex_state = 2},
  [1277] = {.lex_state = 7, .external_lex_state = 2},
  [1278] = {.lex_state = 7, .external_lex_state = 2},
  [1279] = {.lex_state = 7, .external_lex_state = 2},
  [1280] = {.lex_state = 7, .external_lex_state = 2},
  [1281] = {.lex_state = 7, .external_lex_state = 2},
  [1282] = {.lex_state = 7, .external_lex_state = 2},
  [1283] = {.lex_state = 7, .external_lex_state = 2},
  [1284] = {.lex_state = 7, .external_lex_state = 2},
  [1285] = {.lex_state = 7, .external_lex_state = 2},
  [1286] = {.lex_state = 7, .external_lex_state = 2},
  [1287] = {.lex_state = 7, .external_lex_state = 2},
  [1288] = {.lex_state = 7, .external_lex_state = 2},
  [1289] = {.lex_state = 7, .external_lex_state = 3},
  [1290] = {.lex_state = 7, .external_lex_state = 2},
  [1291] = {.lex_state = 7, .external_lex_state = 2},
  [1292] = {.lex_state = 7, .external_lex_state = 2},
  [1293] = {.lex_state = 7, .external_lex_state = 2},
  [1294] = {.lex_state = 7, .external_lex_state = 2},
  [1295] = {.lex_state = 7, .external_lex_state = 2},
  [1296] = {.lex_state = 7, .external_lex_state = 2},
  [1297] = {.lex_state = 7, .external_lex_state = 2},
  [1298] = {.lex_state = 7, .external_lex_state = 2},
  [1299] = {.lex_state = 7, .external_lex_state = 2},
  [1300] = {.lex_state = 7, .external_lex_state = 2},
  [1301] = {.lex_state = 7, .external_lex_state = 2},
  [1302] = {.lex_state = 7, .external_lex_state = 2},
  [1303] = {.lex_state = 7, .external_lex_state = 2},
  [1304] = {.lex_state = 7, .external_lex_state = 2},
  [1305] = {.lex_state = 7, .external_lex_state = 2},
  [1306] = {.lex_state = 7, .external_lex_state = 2},
  [1307] = {.lex_state = 7, .external_lex_state = 3},
  [1308] = {.lex_state = 7, .external_lex_state = 2},
  [1309] = {.lex_state = 7, .external_lex_state = 3},
  [1310] = {.lex_state = 7, .external_lex_state = 2},
  [1311] = {.lex_state = 7, .external_lex_state = 2},
  [1312] = {.lex_state = 7, .external_lex_state = 2},
  [1313] = {.lex_state = 7, .external_lex_state = 2},
  [1314] = {.lex_state = 7, .external_lex_state = 2},
  [1315] = {.lex_state = 7, .external_lex_state = 2},
  [1316] = {.lex_state = 7, .external_lex_state = 2},
  [1317] = {.lex_state = 7, .external_lex_state = 2},
  [1318] = {.lex_state = 7, .external_lex_state = 2},
  [1319] = {.lex_state = 7, .external_lex_state = 2},
  [1320] = {.lex_state = 7, .external_lex_state = 2},
  [1321] = {.lex_state = 7, .external_lex_state = 2},
  [1322] = {.lex_state = 7, .external_lex_state = 2},
  [1323] = {.lex_state = 7, .external_lex_state = 2},
  [1324] = {.lex_state = 7, .external_lex_state = 2},
  [1325] = {.lex_state = 7, .external_lex_state = 2},
  [1326] = {.lex_state = 7, .external_lex_state = 2},
  [1327] = {.lex_state = 7, .external_lex_state = 2},
  [1328] = {.lex_state = 7, .external_lex_state = 2},
  [1329] = {.lex_state = 7, .external_lex_state = 2},
  [1330] = {.lex_state = 7, .external_lex_state = 2},
  [1331] = {.lex_state = 7, .external_lex_state = 2},
  [1332] = {.lex_state = 7, .external_lex_state = 2},
  [1333] = {.lex_state = 7, .external_lex_state = 2},
  [1334] = {.lex_state = 7, .external_lex_state = 2},
  [1335] = {.lex_state = 7, .external_lex_state = 2},
  [1336] = {.lex_state = 7, .external_lex_state = 3},
  [1337] = {.lex_state = 7, .external_lex_state = 2},
  [1338] = {.lex_state = 7, .external_lex_state = 2},
  [1339] = {.lex_state = 7, .external_lex_state = 2},
  [1340] = {.lex_state = 7, .external_lex_state = 2},
  [1341] = {.lex_state = 7, .external_lex_state = 2},
  [1342] = {.lex_state = 7, .external_lex_state = 2},
  [1343] = {.lex_state = 7, .external_lex_state = 2},
  [1344] = {.lex_state = 7, .external_lex_state = 2},
  [1345] = {.lex_state = 7, .external_lex_state = 2},
  [1346] = {.lex_state = 7, .external_lex_state = 2},
  [1347] = {.lex_state = 7, .external_lex_state = 2},
  [1348] = {.lex_state = 7, .external_lex_state = 2},
  [1349] = {.lex_state = 7, .external_lex_state = 2},
  [1350] = {.lex_state = 7, .external_lex_state = 2},
  [1351] = {.lex_state = 7, .external_lex_state = 2},
  [1352] = {.lex_state = 7, .external_lex_state = 2},
  [1353] = {.lex_state = 7, .external_lex_state = 2},
  [1354] = {.lex_state = 7, .external_lex_state = 2},
  [1355] = {.lex_state = 7, .external_lex_state = 2},
  [1356] = {.lex_state = 7, .external_lex_state = 2},
  [1357] = {.lex_state = 7, .external_lex_state = 2},
  [1358] = {.lex_state = 7, .external_lex_state = 2},
  [1359] = {.lex_state = 7, .external_lex_state = 2},
  [1360] = {.lex_state = 7, .external_lex_state = 2},
  [1361] = {.lex_state = 7, .external_lex_state = 2},
  [1362] = {.lex_state = 7, .external_lex_state = 2},
  [1363] = {.lex_state = 7, .external_lex_state = 2},
  [1364] = {.lex_state = 7, .external_lex_state = 2},
  [1365] = {.lex_state = 7, .external_lex_state = 2},
  [1366] = {.lex_state = 7, .external_lex_state = 2},
  [1367] = {.lex_state = 7, .external_lex_state = 2},
  [1368] = {.lex_state = 7, .external_lex_state = 2},
  [1369] = {.lex_state = 7, .external_lex_state = 2},
  [1370] = {.lex_state = 7, .external_lex_state = 2},
  [1371] = {.lex_state = 7, .external_lex_state = 2},
  [1372] = {.lex_state = 7, .external_lex_state = 2},
  [1373] = {.lex_state = 7, .external_lex_state = 2},
  [1374] = {.lex_state = 7, .external_lex_state = 2},
  [1375] = {.lex_state = 7, .external_lex_state = 2},
  [1376] = {.lex_state = 7, .external_lex_state = 2},
  [1377] = {.lex_state = 7, .external_lex_state = 2},
  [1378] = {.lex_state = 7, .external_lex_state = 2},
  [1379] = {.lex_state = 7, .external_lex_state = 2},
  [1380] = {.lex_state = 7, .external_lex_state = 2},
  [1381] = {.lex_state = 7, .external_lex_state = 2},
  [1382] = {.lex_state = 7, .external_lex_state = 2},
  [1383] = {.lex_state = 7, .external_lex_state = 2},
  [1384] = {.lex_state = 7, .external_lex_state = 3},
  [1385] = {.lex_state = 7, .external_lex_state = 3},
  [1386] = {.lex_state = 7, .external_lex_state = 3},
  [1387] = {.lex_state = 7, .external_lex_state = 2},
  [1388] = {.lex_state = 7, .external_lex_state = 3},
  [1389] = {.lex_state = 7, .external_lex_state = 2},
  [1390] = {.lex_state = 7, .external_lex_state = 3},
  [1391] = {.lex_state = 7, .external_lex_state = 2},
  [1392] = {.lex_state = 7, .external_lex_state = 3},
  [1393] = {.lex_state = 7, .external_lex_state = 3},
  [1394] = {.lex_state = 7, .external_lex_state = 2},
  [1395] = {.lex_state = 7, .external_lex_state = 3},
  [1396] = {.lex_state = 7, .external_lex_state = 2},
  [1397] = {.lex_state = 7, .external_lex_state = 2},
  [1398] = {.lex_state = 7, .external_lex_state = 2},
  [1399] = {.lex_state = 7, .external_lex_state = 3},
  [1400] = {.lex_state = 7, .external_lex_state = 3},
  [1401] = {.lex_state = 7, .external_lex_state = 2},
  [1402] = {.lex_state = 7, .external_lex_state = 2},
  [1403] = {.lex_state = 7, .external_lex_state = 2},
  [1404] = {.lex_state = 7, .external_lex_state = 3},
  [1405] = {.lex_state = 7, .external_lex_state = 2},
  [1406] = {.lex_state = 7, .external_lex_state = 2},
  [1407] = {.lex_state = 7, .external_lex_state = 2},
  [1408] = {.lex_state = 7, .external_lex_state = 2},
  [1409] = {.lex_state = 7, .external_lex_state = 2},
  [1410] = {.lex_state = 7, .external_lex_state = 2},
  [1411] = {.lex_state = 7, .external_lex_state = 3},
  [1412] = {.lex_state = 7, .external_lex_state = 3},
  [1413] = {.lex_state = 7, .external_lex_state = 2},
  [1414] = {.lex_state = 7, .external_lex_state = 2},
  [1415] = {.lex_state = 7, .external_lex_state = 3},
  [1416] = {.lex_state = 7, .external_lex_state = 2},
  [1417] = {.lex_state = 7, .external_lex_state = 3},
  [1418] = {.lex_state = 7, .external_lex_state = 2},
  [1419] = {.lex_state = 7, .external_lex_state = 3},
  [1420] = {.lex_state = 7, .external_lex_state = 2},
  [1421] = {.lex_state = 7, .external_lex_state = 3},
  [1422] = {.lex_state = 7, .external_lex_state = 3},
  [1423] = {.lex_state = 7, .external_lex_state = 3},
  [1424] = {.lex_state = 7, .external_lex_state = 3},
  [1425] = {.lex_state = 7, .external_lex_state = 2},
  [1426] = {.lex_state = 7, .external_lex_state = 2},
  [1427] = {.lex_state = 7, .external_lex_state = 2},
  [1428] = {.lex_state = 7, .external_lex_state = 2},
  [1429] = {.lex_state = 7, .external_lex_state = 3},
  [1430] = {.lex_state = 7, .external_lex_state = 3},
  [1431] = {.lex_state = 7, .external_lex_state = 3},
  [1432] = {.lex_state = 7, .external_lex_state = 2},
  [1433] = {.lex_state = 7, .external_lex_state = 2},
  [1434] = {.lex_state = 7, .external_lex_state = 2},
  [1435] = {.lex_state = 7, .external_lex_state = 3},
  [1436] = {.lex_state = 7, .external_lex_state = 2},
  [1437] = {.lex_state = 7, .external_lex_state = 2},
  [1438] = {.lex_state = 7, .external_lex_state = 3},
  [1439] = {.lex_state = 7, .external_lex_state = 2},
  [1440] = {.lex_state = 7, .external_lex_state = 2},
  [1441] = {.lex_state = 7, .external_lex_state = 3},
  [1442] = {.lex_state = 7, .external_lex_state = 2},
  [1443] = {.lex_state = 7, .external_lex_state = 2},
  [1444] = {.lex_state = 7, .external_lex_state = 2},
  [1445] = {.lex_state = 7, .external_lex_state = 2},
  [1446] = {.lex_state = 7, .external_lex_state = 2},
  [1447] = {.lex_state = 7, .external_lex_state = 3},
  [1448] = {.lex_state = 7, .external_lex_state = 2},
  [1449] = {.lex_state = 7, .external_lex_state = 2},
  [1450] = {.lex_state = 7, .external_lex_state = 3},
  [1451] = {.lex_state = 7, .external_lex_state = 3},
  [1452] = {.lex_state = 7, .external_lex_state = 3},
  [1453] = {.lex_state = 7, .external_lex_state = 2},
  [1454] = {.lex_state = 7, .external_lex_state = 3},
  [1455] = {.lex_state = 7, .external_lex_state = 2},
  [1456] = {.lex_state = 7, .external_lex_state = 3},
  [1457] = {.lex_state = 97},
  [1458] = {.lex_state = 7, .external_lex_state = 3},
  [1459] = {.lex_state = 7, .external_lex_state = 2},
  [1460] = {.lex_state = 7, .external_lex_state = 3},
  [1461] = {.lex_state = 7, .external_lex_state = 2},
  [1462] = {.lex_state = 7, .external_lex_state = 2},
  [1463] = {.lex_state = 7, .external_lex_state = 2},
  [1464] = {.lex_state = 7, .external_lex_state = 2},
  [1465] = {.lex_state = 7, .external_lex_state = 2},
  [1466] = {.lex_state = 7, .external_lex_state = 3},
  [1467] = {.lex_state = 7, .external_lex_state = 3},
  [1468] = {.lex_state = 7, .external_lex_state = 3},
  [1469] = {.lex_state = 7, .external_lex_state = 3},
  [1470] = {.lex_state = 7, .external_lex_state = 2},
  [1471] = {.lex_state = 7, .external_lex_state = 2},
  [1472] = {.lex_state = 7, .external_lex_state = 3},
  [1473] = {.lex_state = 7, .external_lex_state = 3},
  [1474] = {.lex_state = 7, .external_lex_state = 3},
  [1475] = {.lex_state = 7, .external_lex_state = 2},
  [1476] = {.lex_state = 7, .external_lex_state = 3},
  [1477] = {.lex_state = 7, .external_lex_state = 2},
  [1478] = {.lex_state = 7, .external_lex_state = 3},
  [1479] = {.lex_state = 7, .external_lex_state = 3},
  [1480] = {.lex_state = 7, .external_lex_state = 3},
  [1481] = {.lex_state = 7, .external_lex_state = 2},
  [1482] = {.lex_state = 7, .external_lex_state = 2},
  [1483] = {.lex_state = 7, .external_lex_state = 3},
  [1484] = {.lex_state = 7, .external_lex_state = 3},
  [1485] = {.lex_state = 7, .external_lex_state = 3},
  [1486] = {.lex_state = 7, .external_lex_state = 2},
  [1487] = {.lex_state = 7, .external_lex_state = 2},
  [1488] = {.lex_state = 7, .external_lex_state = 3},
  [1489] = {.lex_state = 7, .external_lex_state = 2},
  [1490] = {.lex_state = 7, .external_lex_state = 2},
  [1491] = {.lex_state = 7, .external_lex_state = 2},
  [1492] = {.lex_state = 7, .external_lex_state = 3},
  [1493] = {.lex_state = 7, .external_lex_state = 2},
  [1494] = {.lex_state = 7, .external_lex_state = 3},
  [1495] = {.lex_state = 7, .external_lex_state = 3},
  [1496] = {.lex_state = 7, .external_lex_state = 3},
  [1497] = {.lex_state = 7, .external_lex_state = 2},
  [1498] = {.lex_state = 7, .external_lex_state = 2},
  [1499] = {.lex_state = 7, .external_lex_state = 3},
  [1500] = {.lex_state = 7, .external_lex_state = 3},
  [1501] = {.lex_state = 7, .external_lex_state = 2},
  [1502] = {.lex_state = 7, .external_lex_state = 2},
  [1503] = {.lex_state = 7, .external_lex_state = 2},
  [1504] = {.lex_state = 7, .external_lex_state = 2},
  [1505] = {.lex_state = 7, .external_lex_state = 3},
  [1506] = {.lex_state = 7, .external_lex_state = 2},
  [1507] = {.lex_state = 7, .external_lex_state = 2},
  [1508] = {.lex_state = 7, .external_lex_state = 2},
  [1509] = {.lex_state = 7, .external_lex_state = 3},
  [1510] = {.lex_state = 7, .external_lex_state = 3},
  [1511] = {.lex_state = 7, .external_lex_state = 3},
  [1512] = {.lex_state = 7, .external_lex_state = 3},
  [1513] = {.lex_state = 7, .external_lex_state = 2},
  [1514] = {.lex_state = 7, .external_lex_state = 2},
  [1515] = {.lex_state = 7, .external_lex_state = 3},
  [1516] = {.lex_state = 7, .external_lex_state = 3},
  [1517] = {.lex_state = 7, .external_lex_state = 3},
  [1518] = {.lex_state = 7, .external_lex_state = 3},
  [1519] = {.lex_state = 7, .external_lex_state = 3},
  [1520] = {.lex_state = 7, .external_lex_state = 2},
  [1521] = {.lex_state = 7, .external_lex_state = 3},
  [1522] = {.lex_state = 7, .external_lex_state = 2},
  [1523] = {.lex_state = 7, .external_lex_state = 2},
  [1524] = {.lex_state = 7, .external_lex_state = 3},
  [1525] = {.lex_state = 7, .external_lex_state = 3},
  [1526] = {.lex_state = 7, .external_lex_state = 3},
  [1527] = {.lex_state = 7, .external_lex_state = 3},
  [1528] = {.lex_state = 7, .external_lex_state = 3},
  [1529] = {.lex_state = 7, .external_lex_state = 3},
  [1530] = {.lex_state = 7, .external_lex_state = 2},
  [1531] = {.lex_state = 7, .external_lex_state = 3},
  [1532] = {.lex_state = 7, .external_lex_state = 3},
  [1533] = {.lex_state = 7, .external_lex_state = 3},
  [1534] = {.lex_state = 7, .external_lex_state = 2},
  [1535] = {.lex_state = 13},
  [1536] = {.lex_state = 13},
  [1537] = {.lex_state = 13},
  [1538] = {.lex_state = 7, .external_lex_state = 3},
  [1539] = {.lex_state = 7, .external_lex_state = 2},
  [1540] = {.lex_state = 7, .external_lex_state = 2},
  [1541] = {.lex_state = 7, .external_lex_state = 2},
  [1542] = {.lex_state = 13},
  [1543] = {.lex_state = 7, .external_lex_state = 3},
  [1544] = {.lex_state = 7, .external_lex_state = 2},
  [1545] = {.lex_state = 7, .external_lex_state = 3},
  [1546] = {.lex_state = 7, .external_lex_state = 3},
  [1547] = {.lex_state = 7, .external_lex_state = 2},
  [1548] = {.lex_state = 7, .external_lex_state = 2},
  [1549] = {.lex_state = 7, .external_lex_state = 3},
  [1550] = {.lex_state = 7, .external_lex_state = 2},
  [1551] = {.lex_state = 7, .external_lex_state = 2},
  [1552] = {.lex_state = 7, .external_lex_state = 2},
  [1553] = {.lex_state = 7, .external_lex_state = 3},
  [1554] = {.lex_state = 7, .external_lex_state = 2},
  [1555] = {.lex_state = 7, .external_lex_state = 3},
  [1556] = {.lex_state = 7, .external_lex_state = 3},
  [1557] = {.lex_state = 7, .external_lex_state = 2},
  [1558] = {.lex_state = 7, .external_lex_state = 2},
  [1559] = {.lex_state = 7, .external_lex_state = 2},
  [1560] = {.lex_state = 7, .external_lex_state = 2},
  [1561] = {.lex_state = 7, .external_lex_state = 2},
  [1562] = {.lex_state = 7, .external_lex_state = 2},
  [1563] = {.lex_state = 7, .external_lex_state = 2},
  [1564] = {.lex_state = 13},
  [1565] = {.lex_state = 13},
  [1566] = {.lex_state = 7, .external_lex_state = 2},
  [1567] = {.lex_state = 13},
  [1568] = {.lex_state = 7, .external_lex_state = 2},
  [1569] = {.lex_state = 7, .external_lex_state = 2},
  [1570] = {.lex_state = 7, .external_lex_state = 2},
  [1571] = {.lex_state = 7, .external_lex_state = 2},
  [1572] = {.lex_state = 7, .external_lex_state = 2},
  [1573] = {.lex_state = 7, .external_lex_state = 2},
  [1574] = {.lex_state = 7, .external_lex_state = 3},
  [1575] = {.lex_state = 7, .external_lex_state = 2},
  [1576] = {.lex_state = 7, .external_lex_state = 2},
  [1577] = {.lex_state = 7, .external_lex_state = 2},
  [1578] = {.lex_state = 7, .external_lex_state = 2},
  [1579] = {.lex_state = 7, .external_lex_state = 3},
  [1580] = {.lex_state = 7, .external_lex_state = 2},
  [1581] = {.lex_state = 13},
  [1582] = {.lex_state = 7, .external_lex_state = 2},
  [1583] = {.lex_state = 7, .external_lex_state = 3},
  [1584] = {.lex_state = 7, .external_lex_state = 2},
  [1585] = {.lex_state = 7, .external_lex_state = 2},
  [1586] = {.lex_state = 7, .external_lex_state = 2},
  [1587] = {.lex_state = 7, .external_lex_state = 2},
  [1588] = {.lex_state = 7, .external_lex_state = 2},
  [1589] = {.lex_state = 7, .external_lex_state = 2},
  [1590] = {.lex_state = 7, .external_lex_state = 3},
  [1591] = {.lex_state = 7, .external_lex_state = 2},
  [1592] = {.lex_state = 7, .external_lex_state = 3},
  [1593] = {.lex_state = 7, .external_lex_state = 2},
  [1594] = {.lex_state = 13},
  [1595] = {.lex_state = 7, .external_lex_state = 2},
  [1596] = {.lex_state = 7, .external_lex_state = 2},
  [1597] = {.lex_state = 7, .external_lex_state = 2},
  [1598] = {.lex_state = 7, .external_lex_state = 2},
  [1599] = {.lex_state = 7, .external_lex_state = 2},
  [1600] = {.lex_state = 7, .external_lex_state = 2},
  [1601] = {.lex_state = 13},
  [1602] = {.lex_state = 7, .external_lex_state = 3},
  [1603] = {.lex_state = 7, .external_lex_state = 3},
  [1604] = {.lex_state = 7, .external_lex_state = 2},
  [1605] = {.lex_state = 7, .external_lex_state = 2},
  [1606] = {.lex_state = 7, .external_lex_state = 2},
  [1607] = {.lex_state = 7, .external_lex_state = 2},
  [1608] = {.lex_state = 13},
  [1609] = {.lex_state = 7, .external_lex_state = 2},
  [1610] = {.lex_state = 7, .external_lex_state = 3},
  [1611] = {.lex_state = 7, .external_lex_state = 3},
  [1612] = {.lex_state = 7, .external_lex_state = 3},
  [1613] = {.lex_state = 7, .external_lex_state = 3},
  [1614] = {.lex_state = 7, .external_lex_state = 3},
  [1615] = {.lex_state = 7, .external_lex_state = 3},
  [1616] = {.lex_state = 7, .external_lex_state = 3},
  [1617] = {.lex_state = 7, .external_lex_state = 3},
  [1618] = {.lex_state = 7, .external_lex_state = 3},
  [1619] = {.lex_state = 7, .external_lex_state = 2},
  [1620] = {.lex_state = 7, .external_lex_state = 2},
  [1621] = {.lex_state = 7, .external_lex_state = 2},
  [1622] = {.lex_state = 7, .external_lex_state = 2},
  [1623] = {.lex_state = 7, .external_lex_state = 2},
  [1624] = {.lex_state = 7, .external_lex_state = 2},
  [1625] = {.lex_state = 7, .external_lex_state = 3},
  [1626] = {.lex_state = 7, .external_lex_state = 3},
  [1627] = {.lex_state = 7, .external_lex_state = 2},
  [1628] = {.lex_state = 7, .external_lex_state = 3},
  [1629] = {.lex_state = 7, .external_lex_state = 3},
  [1630] = {.lex_state = 7, .external_lex_state = 2},
  [1631] = {.lex_state = 7, .external_lex_state = 2},
  [1632] = {.lex_state = 7, .external_lex_state = 2},
  [1633] = {.lex_state = 7, .external_lex_state = 2},
  [1634] = {.lex_state = 7, .external_lex_state = 2},
  [1635] = {.lex_state = 7, .external_lex_state = 2},
  [1636] = {.lex_state = 7, .external_lex_state = 2},
  [1637] = {.lex_state = 7, .external_lex_state = 2},
  [1638] = {.lex_state = 7, .external_lex_state = 2},
  [1639] = {.lex_state = 7, .external_lex_state = 2},
  [1640] = {.lex_state = 7, .external_lex_state = 3},
  [1641] = {.lex_state = 7, .external_lex_state = 2},
  [1642] = {.lex_state = 7, .external_lex_state = 2},
  [1643] = {.lex_state = 7, .external_lex_state = 2},
  [1644] = {.lex_state = 7, .external_lex_state = 2},
  [1645] = {.lex_state = 7, .external_lex_state = 2},
  [1646] = {.lex_state = 7, .external_lex_state = 3},
  [1647] = {.lex_state = 7, .external_lex_state = 3},
  [1648] = {.lex_state = 7, .external_lex_state = 2},
  [1649] = {.lex_state = 7, .external_lex_state = 2},
  [1650] = {.lex_state = 7, .external_lex_state = 2},
  [1651] = {.lex_state = 7, .external_lex_state = 3},
  [1652] = {.lex_state = 7, .external_lex_state = 3},
  [1653] = {.lex_state = 7, .external_lex_state = 3},
  [1654] = {.lex_state = 7, .external_lex_state = 3},
  [1655] = {.lex_state = 7, .external_lex_state = 3},
  [1656] = {.lex_state = 7, .external_lex_state = 2},
  [1657] = {.lex_state = 7, .external_lex_state = 2},
  [1658] = {.lex_state = 7, .external_lex_state = 2},
  [1659] = {.lex_state = 7, .external_lex_state = 2},
  [1660] = {.lex_state = 7, .external_lex_state = 2},
  [1661] = {.lex_state = 7, .external_lex_state = 2},
  [1662] = {.lex_state = 7, .external_lex_state = 2},
  [1663] = {.lex_state = 7, .external_lex_state = 2},
  [1664] = {.lex_state = 7, .external_lex_state = 2},
  [1665] = {.lex_state = 7, .external_lex_state = 2},
  [1666] = {.lex_state = 7, .external_lex_state = 3},
  [1667] = {.lex_state = 7, .external_lex_state = 3},
  [1668] = {.lex_state = 7, .external_lex_state = 3},
  [1669] = {.lex_state = 7, .external_lex_state = 2},
  [1670] = {.lex_state = 7, .external_lex_state = 2},
  [1671] = {.lex_state = 7, .external_lex_state = 3},
  [1672] = {.lex_state = 7, .external_lex_state = 3},
  [1673] = {.lex_state = 7, .external_lex_state = 3},
  [1674] = {.lex_state = 7, .external_lex_state = 3},
  [1675] = {.lex_state = 7, .external_lex_state = 2},
  [1676] = {.lex_state = 7, .external_lex_state = 2},
  [1677] = {.lex_state = 7, .external_lex_state = 2},
  [1678] = {.lex_state = 7, .external_lex_state = 2},
  [1679] = {.lex_state = 7, .external_lex_state = 3},
  [1680] = {.lex_state = 7, .external_lex_state = 3},
  [1681] = {.lex_state = 7, .external_lex_state = 3},
  [1682] = {.lex_state = 7, .external_lex_state = 3},
  [1683] = {.lex_state = 7, .external_lex_state = 3},
  [1684] = {.lex_state = 13, .external_lex_state = 4},
  [1685] = {.lex_state = 7, .external_lex_state = 3},
  [1686] = {.lex_state = 7, .external_lex_state = 3},
  [1687] = {.lex_state = 7, .external_lex_state = 3},
  [1688] = {.lex_state = 7, .external_lex_state = 3},
  [1689] = {.lex_state = 7, .external_lex_state = 3},
  [1690] = {.lex_state = 7, .external_lex_state = 3},
  [1691] = {.lex_state = 7, .external_lex_state = 3},
  [1692] = {.lex_state = 7, .external_lex_state = 3},
  [1693] = {.lex_state = 7, .external_lex_state = 2},
  [1694] = {.lex_state = 7, .external_lex_state = 3},
  [1695] = {.lex_state = 7, .external_lex_state = 3},
  [1696] = {.lex_state = 7, .external_lex_state = 3},
  [1697] = {.lex_state = 7, .external_lex_state = 3},
  [1698] = {.lex_state = 7, .external_lex_state = 3},
  [1699] = {.lex_state = 13, .external_lex_state = 4},
  [1700] = {.lex_state = 7, .external_lex_state = 3},
  [1701] = {.lex_state = 7, .external_lex_state = 3},
  [1702] = {.lex_state = 7, .external_lex_state = 3},
  [1703] = {.lex_state = 7, .external_lex_state = 3},
  [1704] = {.lex_state = 7, .external_lex_state = 3},
  [1705] = {.lex_state = 7, .external_lex_state = 3},
  [1706] = {.lex_state = 7, .external_lex_state = 3},
  [1707] = {.lex_state = 7, .external_lex_state = 3},
  [1708] = {.lex_state = 7, .external_lex_state = 3},
  [1709] = {.lex_state = 7, .external_lex_state = 3},
  [1710] = {.lex_state = 7, .external_lex_state = 3},
  [1711] = {.lex_state = 7, .external_lex_state = 3},
  [1712] = {.lex_state = 7, .external_lex_state = 3},
  [1713] = {.lex_state = 7, .external_lex_state = 3},
  [1714] = {.lex_state = 7, .external_lex_state = 3},
  [1715] = {.lex_state = 7, .external_lex_state = 3},
  [1716] = {.lex_state = 7, .external_lex_state = 3},
  [1717] = {.lex_state = 7, .external_lex_state = 3},
  [1718] = {.lex_state = 7, .external_lex_state = 3},
  [1719] = {.lex_state = 7, .external_lex_state = 3},
  [1720] = {.lex_state = 7, .external_lex_state = 2},
  [1721] = {.lex_state = 7, .external_lex_state = 2},
  [1722] = {.lex_state = 7, .external_lex_state = 3},
  [1723] = {.lex_state = 7, .external_lex_state = 3},
  [1724] = {.lex_state = 7, .external_lex_state = 3},
  [1725] = {.lex_state = 7, .external_lex_state = 3},
  [1726] = {.lex_state = 7, .external_lex_state = 3},
  [1727] = {.lex_state = 7, .external_lex_state = 3},
  [1728] = {.lex_state = 7, .external_lex_state = 3},
  [1729] = {.lex_state = 7, .external_lex_state = 3},
  [1730] = {.lex_state = 7, .external_lex_state = 3},
  [1731] = {.lex_state = 7, .external_lex_state = 3},
  [1732] = {.lex_state = 7, .external_lex_state = 3},
  [1733] = {.lex_state = 7, .external_lex_state = 3},
  [1734] = {.lex_state = 7, .external_lex_state = 3},
  [1735] = {.lex_state = 7, .external_lex_state = 3},
  [1736] = {.lex_state = 7, .external_lex_state = 3},
  [1737] = {.lex_state = 7, .external_lex_state = 3},
  [1738] = {.lex_state = 7, .external_lex_state = 3},
  [1739] = {.lex_state = 7, .external_lex_state = 3},
  [1740] = {.lex_state = 7, .external_lex_state = 3},
  [1741] = {.lex_state = 7, .external_lex_state = 3},
  [1742] = {.lex_state = 7, .external_lex_state = 3},
  [1743] = {.lex_state = 7, .external_lex_state = 3},
  [1744] = {.lex_state = 7, .external_lex_state = 3},
  [1745] = {.lex_state = 7, .external_lex_state = 3},
  [1746] = {.lex_state = 7, .external_lex_state = 3},
  [1747] = {.lex_state = 7, .external_lex_state = 3},
  [1748] = {.lex_state = 7, .external_lex_state = 3},
  [1749] = {.lex_state = 7, .external_lex_state = 3},
  [1750] = {.lex_state = 13, .external_lex_state = 4},
  [1751] = {.lex_state = 7, .external_lex_state = 3},
  [1752] = {.lex_state = 7, .external_lex_state = 3},
  [1753] = {.lex_state = 7, .external_lex_state = 3},
  [1754] = {.lex_state = 7, .external_lex_state = 3},
  [1755] = {.lex_state = 7, .external_lex_state = 3},
  [1756] = {.lex_state = 7, .external_lex_state = 3},
  [1757] = {.lex_state = 7, .external_lex_state = 3},
  [1758] = {.lex_state = 7, .external_lex_state = 3},
  [1759] = {.lex_state = 7, .external_lex_state = 3},
  [1760] = {.lex_state = 7, .external_lex_state = 3},
  [1761] = {.lex_state = 7, .external_lex_state = 3},
  [1762] = {.lex_state = 7, .external_lex_state = 3},
  [1763] = {.lex_state = 7, .external_lex_state = 3},
  [1764] = {.lex_state = 13, .external_lex_state = 4},
  [1765] = {.lex_state = 7, .external_lex_state = 3},
  [1766] = {.lex_state = 7, .external_lex_state = 3},
  [1767] = {.lex_state = 7, .external_lex_state = 3},
  [1768] = {.lex_state = 7, .external_lex_state = 3},
  [1769] = {.lex_state = 7, .external_lex_state = 3},
  [1770] = {.lex_state = 7, .external_lex_state = 3},
  [1771] = {.lex_state = 7, .external_lex_state = 3},
  [1772] = {.lex_state = 7, .external_lex_state = 2},
  [1773] = {.lex_state = 13, .external_lex_state = 4},
  [1774] = {.lex_state = 7, .external_lex_state = 2},
  [1775] = {.lex_state = 7, .external_lex_state = 2},
  [1776] = {.lex_state = 7, .external_lex_state = 2},
  [1777] = {.lex_state = 7, .external_lex_state = 3},
  [1778] = {.lex_state = 7, .external_lex_state = 3},
  [1779] = {.lex_state = 7, .external_lex_state = 3},
  [1780] = {.lex_state = 7, .external_lex_state = 2},
  [1781] = {.lex_state = 7, .external_lex_state = 3},
  [1782] = {.lex_state = 7, .external_lex_state = 3},
  [1783] = {.lex_state = 7, .external_lex_state = 3},
  [1784] = {.lex_state = 7, .external_lex_state = 2},
  [1785] = {.lex_state = 7, .external_lex_state = 2},
  [1786] = {.lex_state = 7, .external_lex_state = 2},
  [1787] = {.lex_state = 7, .external_lex_state = 3},
  [1788] = {.lex_state = 7, .external_lex_state = 2},
  [1789] = {.lex_state = 7, .external_lex_state = 3},
  [1790] = {.lex_state = 7, .external_lex_state = 3},
  [1791] = {.lex_state = 7, .external_lex_state = 2},
  [1792] = {.lex_state = 7, .external_lex_state = 3},
  [1793] = {.lex_state = 7, .external_lex_state = 2},
  [1794] = {.lex_state = 7, .external_lex_state = 3},
  [1795] = {.lex_state = 7, .external_lex_state = 3},
  [1796] = {.lex_state = 7, .external_lex_state = 3},
  [1797] = {.lex_state = 7, .external_lex_state = 3},
  [1798] = {.lex_state = 7, .external_lex_state = 3},
  [1799] = {.lex_state = 7, .external_lex_state = 3},
  [1800] = {.lex_state = 7, .external_lex_state = 3},
  [1801] = {.lex_state = 7, .external_lex_state = 3},
  [1802] = {.lex_state = 7, .external_lex_state = 3},
  [1803] = {.lex_state = 7, .external_lex_state = 3},
  [1804] = {.lex_state = 7, .external_lex_state = 2},
  [1805] = {.lex_state = 7, .external_lex_state = 2},
  [1806] = {.lex_state = 7, .external_lex_state = 2},
  [1807] = {.lex_state = 7, .external_lex_state = 2},
  [1808] = {.lex_state = 7, .external_lex_state = 2},
  [1809] = {.lex_state = 7, .external_lex_state = 3},
  [1810] = {.lex_state = 7, .external_lex_state = 3},
  [1811] = {.lex_state = 7, .external_lex_state = 3},
  [1812] = {.lex_state = 7, .external_lex_state = 3},
  [1813] = {.lex_state = 7, .external_lex_state = 3},
  [1814] = {.lex_state = 7, .external_lex_state = 3},
  [1815] = {.lex_state = 7, .external_lex_state = 3},
  [1816] = {.lex_state = 8, .external_lex_state = 2},
  [1817] = {.lex_state = 7, .external_lex_state = 3},
  [1818] = {.lex_state = 7, .external_lex_state = 3},
  [1819] = {.lex_state = 7, .external_lex_state = 3},
  [1820] = {.lex_state = 7, .external_lex_state = 3},
  [1821] = {.lex_state = 7, .external_lex_state = 3},
  [1822] = {.lex_state = 7, .external_lex_state = 3},
  [1823] = {.lex_state = 7, .external_lex_state = 3},
  [1824] = {.lex_state = 7, .external_lex_state = 3},
  [1825] = {.lex_state = 7, .external_lex_state = 3},
  [1826] = {.lex_state = 7, .external_lex_state = 3},
  [1827] = {.lex_state = 7, .external_lex_state = 3},
  [1828] = {.lex_state = 7, .external_lex_state = 2},
  [1829] = {.lex_state = 7, .external_lex_state = 3},
  [1830] = {.lex_state = 7, .external_lex_state = 2},
  [1831] = {.lex_state = 7, .external_lex_state = 2},
  [1832] = {.lex_state = 13, .external_lex_state = 4},
  [1833] = {.lex_state = 7, .external_lex_state = 2},
  [1834] = {.lex_state = 7, .external_lex_state = 3},
  [1835] = {.lex_state = 7, .external_lex_state = 3},
  [1836] = {.lex_state = 7, .external_lex_state = 3},
  [1837] = {.lex_state = 7, .external_lex_state = 2},
  [1838] = {.lex_state = 7, .external_lex_state = 2},
  [1839] = {.lex_state = 7, .external_lex_state = 2},
  [1840] = {.lex_state = 7, .external_lex_state = 2},
  [1841] = {.lex_state = 7, .external_lex_state = 2},
  [1842] = {.lex_state = 7, .external_lex_state = 3},
  [1843] = {.lex_state = 7, .external_lex_state = 3},
  [1844] = {.lex_state = 7, .external_lex_state = 3},
  [1845] = {.lex_state = 7, .external_lex_state = 3},
  [1846] = {.lex_state = 13, .external_lex_state = 4},
  [1847] = {.lex_state = 7, .external_lex_state = 2},
  [1848] = {.lex_state = 13, .external_lex_state = 4},
  [1849] = {.lex_state = 7, .external_lex_state = 3},
  [1850] = {.lex_state = 7, .external_lex_state = 3},
  [1851] = {.lex_state = 7, .external_lex_state = 3},
  [1852] = {.lex_state = 7, .external_lex_state = 3},
  [1853] = {.lex_state = 7, .external_lex_state = 2},
  [1854] = {.lex_state = 7, .external_lex_state = 2},
  [1855] = {.lex_state = 7, .external_lex_state = 3},
  [1856] = {.lex_state = 7, .external_lex_state = 2},
  [1857] = {.lex_state = 7, .external_lex_state = 2},
  [1858] = {.lex_state = 7, .external_lex_state = 2},
  [1859] = {.lex_state = 7, .external_lex_state = 3},
  [1860] = {.lex_state = 7, .external_lex_state = 3},
  [1861] = {.lex_state = 7, .external_lex_state = 2},
  [1862] = {.lex_state = 13, .external_lex_state = 4},
  [1863] = {.lex_state = 7, .external_lex_state = 3},
  [1864] = {.lex_state = 7, .external_lex_state = 3},
  [1865] = {.lex_state = 7, .external_lex_state = 2},
  [1866] = {.lex_state = 7, .external_lex_state = 2},
  [1867] = {.lex_state = 7, .external_lex_state = 2},
  [1868] = {.lex_state = 7, .external_lex_state = 3},
  [1869] = {.lex_state = 7, .external_lex_state = 2},
  [1870] = {.lex_state = 7, .external_lex_state = 2},
  [1871] = {.lex_state = 7, .external_lex_state = 2},
  [1872] = {.lex_state = 7, .external_lex_state = 2},
  [1873] = {.lex_state = 7, .external_lex_state = 2},
  [1874] = {.lex_state = 7, .external_lex_state = 2},
  [1875] = {.lex_state = 7, .external_lex_state = 3},
  [1876] = {.lex_state = 7, .external_lex_state = 3},
  [1877] = {.lex_state = 7, .external_lex_state = 3},
  [1878] = {.lex_state = 7, .external_lex_state = 2},
  [1879] = {.lex_state = 7, .external_lex_state = 2},
  [1880] = {.lex_state = 7, .external_lex_state = 2},
  [1881] = {.lex_state = 7, .external_lex_state = 3},
  [1882] = {.lex_state = 7, .external_lex_state = 3},
  [1883] = {.lex_state = 12, .external_lex_state = 4},
  [1884] = {.lex_state = 7, .external_lex_state = 2},
  [1885] = {.lex_state = 7, .external_lex_state = 3},
  [1886] = {.lex_state = 7, .external_lex_state = 3},
  [1887] = {.lex_state = 7, .external_lex_state = 3},
  [1888] = {.lex_state = 7, .external_lex_state = 3},
  [1889] = {.lex_state = 7, .external_lex_state = 3},
  [1890] = {.lex_state = 7, .external_lex_state = 3},
  [1891] = {.lex_state = 7, .external_lex_state = 3},
  [1892] = {.lex_state = 13, .external_lex_state = 4},
  [1893] = {.lex_state = 7, .external_lex_state = 3},
  [1894] = {.lex_state = 13, .external_lex_state = 4},
  [1895] = {.lex_state = 7, .external_lex_state = 3},
  [1896] = {.lex_state = 7, .external_lex_state = 2},
  [1897] = {.lex_state = 7, .external_lex_state = 2},
  [1898] = {.lex_state = 7, .external_lex_state = 3},
  [1899] = {.lex_state = 7, .external_lex_state = 2},
  [1900] = {.lex_state = 7, .external_lex_state = 2},
  [1901] = {.lex_state = 7, .external_lex_state = 2},
  [1902] = {.lex_state = 7, .external_lex_state = 2},
  [1903] = {.lex_state = 7, .external_lex_state = 3},
  [1904] = {.lex_state = 7, .external_lex_state = 3},
  [1905] = {.lex_state = 7, .external_lex_state = 2},
  [1906] = {.lex_state = 7, .external_lex_state = 3},
  [1907] = {.lex_state = 7, .external_lex_state = 2},
  [1908] = {.lex_state = 7, .external_lex_state = 3},
  [1909] = {.lex_state = 7, .external_lex_state = 3},
  [1910] = {.lex_state = 7, .external_lex_state = 2},
  [1911] = {.lex_state = 13, .external_lex_state = 4},
  [1912] = {.lex_state = 7, .external_lex_state = 3},
  [1913] = {.lex_state = 7, .external_lex_state = 3},
  [1914] = {.lex_state = 7, .external_lex_state = 2},
  [1915] = {.lex_state = 7, .external_lex_state = 3},
  [1916] = {.lex_state = 7, .external_lex_state = 3},
  [1917] = {.lex_state = 13, .external_lex_state = 4},
  [1918] = {.lex_state = 7, .external_lex_state = 2},
  [1919] = {.lex_state = 7, .external_lex_state = 3},
  [1920] = {.lex_state = 7, .external_lex_state = 3},
  [1921] = {.lex_state = 7, .external_lex_state = 3},
  [1922] = {.lex_state = 13, .external_lex_state = 4},
  [1923] = {.lex_state = 7, .external_lex_state = 2},
  [1924] = {.lex_state = 7, .external_lex_state = 3},
  [1925] = {.lex_state = 7, .external_lex_state = 3},
  [1926] = {.lex_state = 7, .external_lex_state = 2},
  [1927] = {.lex_state = 7, .external_lex_state = 3},
  [1928] = {.lex_state = 8, .external_lex_state = 3},
  [1929] = {.lex_state = 7, .external_lex_state = 2},
  [1930] = {.lex_state = 7, .external_lex_state = 2},
  [1931] = {.lex_state = 13, .external_lex_state = 4},
  [1932] = {.lex_state = 7, .external_lex_state = 3},
  [1933] = {.lex_state = 7, .external_lex_state = 2},
  [1934] = {.lex_state = 7, .external_lex_state = 2},
  [1935] = {.lex_state = 7, .external_lex_state = 2},
  [1936] = {.lex_state = 7, .external_lex_state = 3},
  [1937] = {.lex_state = 7, .external_lex_state = 2},
  [1938] = {.lex_state = 7, .external_lex_state = 2},
  [1939] = {.lex_state = 7, .external_lex_state = 2},
  [1940] = {.lex_state = 7, .external_lex_state = 2},
  [1941] = {.lex_state = 7, .external_lex_state = 2},
  [1942] = {.lex_state = 7, .external_lex_state = 2},
  [1943] = {.lex_state = 7, .external_lex_state = 2},
  [1944] = {.lex_state = 7, .external_lex_state = 3},
  [1945] = {.lex_state = 7, .external_lex_state = 2},
  [1946] = {.lex_state = 7, .external_lex_state = 3},
  [1947] = {.lex_state = 7, .external_lex_state = 3},
  [1948] = {.lex_state = 7, .external_lex_state = 3},
  [1949] = {.lex_state = 7, .external_lex_state = 3},
  [1950] = {.lex_state = 7, .external_lex_state = 3},
  [1951] = {.lex_state = 7, .external_lex_state = 2},
  [1952] = {.lex_state = 8, .external_lex_state = 3},
  [1953] = {.lex_state = 7, .external_lex_state = 3},
  [1954] = {.lex_state = 7, .external_lex_state = 3},
  [1955] = {.lex_state = 7, .external_lex_state = 2},
  [1956] = {.lex_state = 7, .external_lex_state = 3},
  [1957] = {.lex_state = 7, .external_lex_state = 3},
  [1958] = {.lex_state = 7, .external_lex_state = 2},
  [1959] = {.lex_state = 7, .external_lex_state = 2},
  [1960] = {.lex_state = 7, .external_lex_state = 2},
  [1961] = {.lex_state = 7, .external_lex_state = 3},
  [1962] = {.lex_state = 7, .external_lex_state = 2},
  [1963] = {.lex_state = 7, .external_lex_state = 2},
  [1964] = {.lex_state = 7, .external_lex_state = 3},
  [1965] = {.lex_state = 7, .external_lex_state = 2},
  [1966] = {.lex_state = 7, .external_lex_state = 3},
  [1967] = {.lex_state = 7, .external_lex_state = 3},
  [1968] = {.lex_state = 7, .external_lex_state = 3},
  [1969] = {.lex_state = 7, .external_lex_state = 2},
  [1970] = {.lex_state = 7, .external_lex_state = 3},
  [1971] = {.lex_state = 7, .external_lex_state = 2},
  [1972] = {.lex_state = 7, .external_lex_state = 3},
  [1973] = {.lex_state = 7, .external_lex_state = 2},
  [1974] = {.lex_state = 7, .external_lex_state = 3},
  [1975] = {.lex_state = 7, .external_lex_state = 3},
  [1976] = {.lex_state = 7, .external_lex_state = 3},
  [1977] = {.lex_state = 7, .external_lex_state = 3},
  [1978] = {.lex_state = 7, .external_lex_state = 3},
  [1979] = {.lex_state = 7, .external_lex_state = 2},
  [1980] = {.lex_state = 7, .external_lex_state = 2},
  [1981] = {.lex_state = 7, .external_lex_state = 3},
  [1982] = {.lex_state = 7, .external_lex_state = 3},
  [1983] = {.lex_state = 7, .external_lex_state = 3},
  [1984] = {.lex_state = 7, .external_lex_state = 3},
  [1985] = {.lex_state = 7, .external_lex_state = 3},
  [1986] = {.lex_state = 7, .external_lex_state = 3},
  [1987] = {.lex_state = 7, .external_lex_state = 3},
  [1988] = {.lex_state = 7, .external_lex_state = 3},
  [1989] = {.lex_state = 7, .external_lex_state = 3},
  [1990] = {.lex_state = 7, .external_lex_state = 3},
  [1991] = {.lex_state = 7, .external_lex_state = 3},
  [1992] = {.lex_state = 7, .external_lex_state = 3},
  [1993] = {.lex_state = 7, .external_lex_state = 3},
  [1994] = {.lex_state = 7, .external_lex_state = 3},
  [1995] = {.lex_state = 7, .external_lex_state = 3},
  [1996] = {.lex_state = 7, .external_lex_state = 3},
  [1997] = {.lex_state = 7, .external_lex_state = 3},
  [1998] = {.lex_state = 7, .external_lex_state = 3},
  [1999] = {.lex_state = 7, .external_lex_state = 2},
  [2000] = {.lex_state = 7, .external_lex_state = 2},
  [2001] = {.lex_state = 7, .external_lex_state = 2},
  [2002] = {.lex_state = 7, .external_lex_state = 2},
  [2003] = {.lex_state = 7, .external_lex_state = 2},
  [2004] = {.lex_state = 13, .external_lex_state = 4},
  [2005] = {.lex_state = 7, .external_lex_state = 3},
  [2006] = {.lex_state = 7, .external_lex_state = 2},
  [2007] = {.lex_state = 7, .external_lex_state = 2},
  [2008] = {.lex_state = 7, .external_lex_state = 2},
  [2009] = {.lex_state = 7, .external_lex_state = 2},
  [2010] = {.lex_state = 7, .external_lex_state = 2},
  [2011] = {.lex_state = 7, .external_lex_state = 2},
  [2012] = {.lex_state = 7, .external_lex_state = 3},
  [2013] = {.lex_state = 7, .external_lex_state = 2},
  [2014] = {.lex_state = 7, .external_lex_state = 2},
  [2015] = {.lex_state = 7, .external_lex_state = 2},
  [2016] = {.lex_state = 7, .external_lex_state = 2},
  [2017] = {.lex_state = 13, .external_lex_state = 4},
  [2018] = {.lex_state = 7, .external_lex_state = 2},
  [2019] = {.lex_state = 13, .external_lex_state = 4},
  [2020] = {.lex_state = 7, .external_lex_state = 2},
  [2021] = {.lex_state = 7, .external_lex_state = 2},
  [2022] = {.lex_state = 13, .external_lex_state = 4},
  [2023] = {.lex_state = 13, .external_lex_state = 4},
  [2024] = {.lex_state = 7, .external_lex_state = 2},
  [2025] = {.lex_state = 7, .external_lex_state = 2},
  [2026] = {.lex_state = 7, .external_lex_state = 2},
  [2027] = {.lex_state = 8, .external_lex_state = 2},
  [2028] = {.lex_state = 7, .external_lex_state = 3},
  [2029] = {.lex_state = 13, .external_lex_state = 4},
  [2030] = {.lex_state = 7, .external_lex_state = 2},
  [2031] = {.lex_state = 7, .external_lex_state = 2},
  [2032] = {.lex_state = 7, .external_lex_state = 2},
  [2033] = {.lex_state = 7, .external_lex_state = 2},
  [2034] = {.lex_state = 7, .external_lex_state = 2},
  [2035] = {.lex_state = 7, .external_lex_state = 2},
  [2036] = {.lex_state = 7, .external_lex_state = 2},
  [2037] = {.lex_state = 7, .external_lex_state = 2},
  [2038] = {.lex_state = 7, .external_lex_state = 2},
  [2039] = {.lex_state = 7, .external_lex_state = 2},
  [2040] = {.lex_state = 7, .external_lex_state = 2},
  [2041] = {.lex_state = 7, .external_lex_state = 2},
  [2042] = {.lex_state = 7, .external_lex_state = 2},
  [2043] = {.lex_state = 7, .external_lex_state = 2},
  [2044] = {.lex_state = 7, .external_lex_state = 2},
  [2045] = {.lex_state = 7, .external_lex_state = 2},
  [2046] = {.lex_state = 7, .external_lex_state = 2},
  [2047] = {.lex_state = 7, .external_lex_state = 2},
  [2048] = {.lex_state = 13, .external_lex_state = 4},
  [2049] = {.lex_state = 7, .external_lex_state = 2},
  [2050] = {.lex_state = 13},
  [2051] = {.lex_state = 13, .external_lex_state = 4},
  [2052] = {.lex_state = 7, .external_lex_state = 2},
  [2053] = {.lex_state = 97},
  [2054] = {.lex_state = 7, .external_lex_state = 3},
  [2055] = {.lex_state = 7, .external_lex_state = 2},
  [2056] = {.lex_state = 13, .external_lex_state = 4},
  [2057] = {.lex_state = 13},
  [2058] = {.lex_state = 13, .external_lex_state = 4},
  [2059] = {.lex_state = 13, .external_lex_state = 4},
  [2060] = {.lex_state = 7, .external_lex_state = 2},
  [2061] = {.lex_state = 7, .external_lex_state = 2},
  [2062] = {.lex_state = 7, .external_lex_state = 2},
  [2063] = {.lex_state = 7, .external_lex_state = 2},
  [2064] = {.lex_state = 13},
  [2065] = {.lex_state = 7, .external_lex_state = 2},
  [2066] = {.lex_state = 7, .external_lex_state = 2},
  [2067] = {.lex_state = 7, .external_lex_state = 2},
  [2068] = {.lex_state = 7, .external_lex_state = 2},
  [2069] = {.lex_state = 13},
  [2070] = {.lex_state = 7, .external_lex_state = 2},
  [2071] = {.lex_state = 13},
  [2072] = {.lex_state = 7, .external_lex_state = 2},
  [2073] = {.lex_state = 7, .external_lex_state = 2},
  [2074] = {.lex_state = 7, .external_lex_state = 3},
  [2075] = {.lex_state = 7, .external_lex_state = 2},
  [2076] = {.lex_state = 13, .external_lex_state = 4},
  [2077] = {.lex_state = 7, .external_lex_state = 2},
  [2078] = {.lex_state = 7, .external_lex_state = 2},
  [2079] = {.lex_state = 13, .external_lex_state = 4},
  [2080] = {.lex_state = 7, .external_lex_state = 2},
  [2081] = {.lex_state = 13, .external_lex_state = 4},
  [2082] = {.lex_state = 97},
  [2083] = {.lex_state = 13, .external_lex_state = 4},
  [2084] = {.lex_state = 7, .external_lex_state = 2},
  [2085] = {.lex_state = 13},
  [2086] = {.lex_state = 13},
  [2087] = {.lex_state = 7, .external_lex_state = 3},
  [2088] = {.lex_state = 13, .external_lex_state = 4},
  [2089] = {.lex_state = 13, .external_lex_state = 4},
  [2090] = {.lex_state = 7, .external_lex_state = 2},
  [2091] = {.lex_state = 13},
  [2092] = {.lex_state = 13, .external_lex_state = 4},
  [2093] = {.lex_state = 7, .external_lex_state = 2},
  [2094] = {.lex_state = 13, .external_lex_state = 4},
  [2095] = {.lex_state = 13, .external_lex_state = 4},
  [2096] = {.lex_state = 13},
  [2097] = {.lex_state = 7, .external_lex_state = 2},
  [2098] = {.lex_state = 13, .external_lex_state = 4},
  [2099] = {.lex_state = 13, .external_lex_state = 4},
  [2100] = {.lex_state = 13},
  [2101] = {.lex_state = 13, .external_lex_state = 4},
  [2102] = {.lex_state = 13, .external_lex_state = 4},
  [2103] = {.lex_state = 13},
  [2104] = {.lex_state = 13},
  [2105] = {.lex_state = 13, .external_lex_state = 4},
  [2106] = {.lex_state = 7, .external_lex_state = 2},
  [2107] = {.lex_state = 13, .external_lex_state = 4},
  [2108] = {.lex_state = 13, .external_lex_state = 4},
  [2109] = {.lex_state = 8, .external_lex_state = 2},
  [2110] = {.lex_state = 13, .external_lex_state = 4},
  [2111] = {.lex_state = 13, .external_lex_state = 4},
  [2112] = {.lex_state = 13},
  [2113] = {.lex_state = 13, .external_lex_state = 4},
  [2114] = {.lex_state = 13, .external_lex_state = 4},
  [2115] = {.lex_state = 13},
  [2116] = {.lex_state = 13, .external_lex_state = 4},
  [2117] = {.lex_state = 13, .external_lex_state = 4},
  [2118] = {.lex_state = 13},
  [2119] = {.lex_state = 13, .external_lex_state = 4},
  [2120] = {.lex_state = 13, .external_lex_state = 4},
  [2121] = {.lex_state = 13},
  [2122] = {.lex_state = 13, .external_lex_state = 4},
  [2123] = {.lex_state = 7, .external_lex_state = 2},
  [2124] = {.lex_state = 13},
  [2125] = {.lex_state = 13, .external_lex_state = 4},
  [2126] = {.lex_state = 13, .external_lex_state = 4},
  [2127] = {.lex_state = 13, .external_lex_state = 4},
  [2128] = {.lex_state = 13},
  [2129] = {.lex_state = 13, .external_lex_state = 4},
  [2130] = {.lex_state = 13, .external_lex_state = 4},
  [2131] = {.lex_state = 13, .external_lex_state = 4},
  [2132] = {.lex_state = 7, .external_lex_state = 2},
  [2133] = {.lex_state = 13, .external_lex_state = 4},
  [2134] = {.lex_state = 13},
  [2135] = {.lex_state = 13, .external_lex_state = 4},
  [2136] = {.lex_state = 13, .external_lex_state = 4},
  [2137] = {.lex_state = 97},
  [2138] = {.lex_state = 13, .external_lex_state = 4},
  [2139] = {.lex_state = 13, .external_lex_state = 4},
  [2140] = {.lex_state = 13, .external_lex_state = 4},
  [2141] = {.lex_state = 13},
  [2142] = {.lex_state = 13, .external_lex_state = 4},
  [2143] = {.lex_state = 13, .external_lex_state = 4},
  [2144] = {.lex_state = 13, .external_lex_state = 4},
  [2145] = {.lex_state = 13},
  [2146] = {.lex_state = 13, .external_lex_state = 4},
  [2147] = {.lex_state = 13, .external_lex_state = 4},
  [2148] = {.lex_state = 13},
  [2149] = {.lex_state = 13, .external_lex_state = 4},
  [2150] = {.lex_state = 13},
  [2151] = {.lex_state = 13, .external_lex_state = 4},
  [2152] = {.lex_state = 13, .external_lex_state = 4},
  [2153] = {.lex_state = 13, .external_lex_state = 4},
  [2154] = {.lex_state = 13, .external_lex_state = 4},
  [2155] = {.lex_state = 13, .external_lex_state = 4},
  [2156] = {.lex_state = 13},
  [2157] = {.lex_state = 13, .external_lex_state = 4},
  [2158] = {.lex_state = 13},
  [2159] = {.lex_state = 13, .external_lex_state = 4},
  [2160] = {.lex_state = 13},
  [2161] = {.lex_state = 97},
  [2162] = {.lex_state = 13, .external_lex_state = 4},
  [2163] = {.lex_state = 13, .external_lex_state = 4},
  [2164] = {.lex_state = 13},
  [2165] = {.lex_state = 13},
  [2166] = {.lex_state = 13, .external_lex_state = 4},
  [2167] = {.lex_state = 13, .external_lex_state = 4},
  [2168] = {.lex_state = 13, .external_lex_state = 4},
  [2169] = {.lex_state = 13, .external_lex_state = 4},
  [2170] = {.lex_state = 13, .external_lex_state = 4},
  [2171] = {.lex_state = 13, .external_lex_state = 4},
  [2172] = {.lex_state = 13, .external_lex_state = 4},
  [2173] = {.lex_state = 13},
  [2174] = {.lex_state = 97, .external_lex_state = 4},
  [2175] = {.lex_state = 13},
  [2176] = {.lex_state = 97, .external_lex_state = 4},
  [2177] = {.lex_state = 97, .external_lex_state = 4},
  [2178] = {.lex_state = 13, .external_lex_state = 4},
  [2179] = {.lex_state = 13, .external_lex_state = 4},
  [2180] = {.lex_state = 13},
  [2181] = {.lex_state = 97, .external_lex_state = 4},
  [2182] = {.lex_state = 13},
  [2183] = {.lex_state = 13},
  [2184] = {.lex_state = 13},
  [2185] = {.lex_state = 13},
  [2186] = {.lex_state = 13},
  [2187] = {.lex_state = 13},
  [2188] = {.lex_state = 13},
  [2189] = {.lex_state = 13},
  [2190] = {.lex_state = 13},
  [2191] = {.lex_state = 13},
  [2192] = {.lex_state = 97, .external_lex_state = 4},
  [2193] = {.lex_state = 13},
  [2194] = {.lex_state = 13},
  [2195] = {.lex_state = 97, .external_lex_state = 4},
  [2196] = {.lex_state = 13},
  [2197] = {.lex_state = 13},
  [2198] = {.lex_state = 13},
  [2199] = {.lex_state = 13},
  [2200] = {.lex_state = 13},
  [2201] = {.lex_state = 13},
  [2202] = {.lex_state = 13},
  [2203] = {.lex_state = 97},
  [2204] = {.lex_state = 13},
  [2205] = {.lex_state = 97},
  [2206] = {.lex_state = 97},
  [2207] = {.lex_state = 97},
  [2208] = {.lex_state = 13},
  [2209] = {.lex_state = 97},
  [2210] = {.lex_state = 13},
  [2211] = {.lex_state = 13},
  [2212] = {.lex_state = 13, .external_lex_state = 4},
  [2213] = {.lex_state = 13, .external_lex_state = 4},
  [2214] = {.lex_state = 13},
  [2215] = {.lex_state = 13},
  [2216] = {.lex_state = 13},
  [2217] = {.lex_state = 13},
  [2218] = {.lex_state = 13, .external_lex_state = 4},
  [2219] = {.lex_state = 13, .external_lex_state = 4},
  [2220] = {.lex_state = 13, .external_lex_state = 4},
  [2221] = {.lex_state = 13, .external_lex_state = 4},
  [2222] = {.lex_state = 13, .external_lex_state = 4},
  [2223] = {.lex_state = 13, .external_lex_state = 4},
  [2224] = {.lex_state = 13, .external_lex_state = 4},
  [2225] = {.lex_state = 13},
  [2226] = {.lex_state = 13, .external_lex_state = 4},
  [2227] = {.lex_state = 13, .external_lex_state = 4},
  [2228] = {.lex_state = 13},
  [2229] = {.lex_state = 13, .external_lex_state = 4},
  [2230] = {.lex_state = 13},
  [2231] = {.lex_state = 13},
  [2232] = {.lex_state = 13, .external_lex_state = 4},
  [2233] = {.lex_state = 13},
  [2234] = {.lex_state = 13, .external_lex_state = 4},
  [2235] = {.lex_state = 13, .external_lex_state = 4},
  [2236] = {.lex_state = 13, .external_lex_state = 4},
  [2237] = {.lex_state = 13, .external_lex_state = 4},
  [2238] = {.lex_state = 13, .external_lex_state = 4},
  [2239] = {.lex_state = 13, .external_lex_state = 4},
  [2240] = {.lex_state = 13, .external_lex_state = 4},
  [2241] = {.lex_state = 13, .external_lex_state = 4},
  [2242] = {.lex_state = 13},
  [2243] = {.lex_state = 13, .external_lex_state = 4},
  [2244] = {.lex_state = 13, .external_lex_state = 4},
  [2245] = {.lex_state = 13, .external_lex_state = 4},
  [2246] = {.lex_state = 13, .external_lex_state = 4},
  [2247] = {.lex_state = 13, .external_lex_state = 4},
  [2248] = {.lex_state = 13, .external_lex_state = 4},
  [2249] = {.lex_state = 13},
  [2250] = {.lex_state = 13},
  [2251] = {.lex_state = 13},
  [2252] = {.lex_state = 13},
  [2253] = {.lex_state = 13},
  [2254] = {.lex_state = 13},
  [2255] = {.lex_state = 13, .external_lex_state = 4},
  [2256] = {.lex_state = 13},
  [2257] = {.lex_state = 13},
  [2258] = {.lex_state = 13},
  [2259] = {.lex_state = 13},
  [2260] = {.lex_state = 13},
  [2261] = {.lex_state = 13},
  [2262] = {.lex_state = 13, .external_lex_state = 4},
  [2263] = {.lex_state = 13},
  [2264] = {.lex_state = 13},
  [2265] = {.lex_state = 13},
  [2266] = {.lex_state = 13},
  [2267] = {.lex_state = 13},
  [2268] = {.lex_state = 13},
  [2269] = {.lex_state = 97},
  [2270] = {.lex_state = 13},
  [2271] = {.lex_state = 13},
  [2272] = {.lex_state = 13},
  [2273] = {.lex_state = 13},
  [2274] = {.lex_state = 13},
  [2275] = {.lex_state = 97},
  [2276] = {.lex_state = 97},
  [2277] = {.lex_state = 13},
  [2278] = {.lex_state = 13},
  [2279] = {.lex_state = 97},
  [2280] = {.lex_state = 13},
  [2281] = {.lex_state = 97},
  [2282] = {.lex_state = 13},
  [2283] = {.lex_state = 97},
  [2284] = {.lex_state = 13},
  [2285] = {.lex_state = 97},
  [2286] = {.lex_state = 97},
  [2287] = {.lex_state = 97},
  [2288] = {.lex_state = 97},
  [2289] = {.lex_state = 97},
  [2290] = {.lex_state = 97},
  [2291] = {.lex_state = 13},
  [2292] = {.lex_state = 97},
  [2293] = {.lex_state = 97},
  [2294] = {.lex_state = 97},
  [2295] = {.lex_state = 13},
  [2296] = {.lex_state = 97},
  [2297] = {.lex_state = 97},
  [2298] = {.lex_state = 13},
  [2299] = {.lex_state = 97},
  [2300] = {.lex_state = 97},
  [2301] = {.lex_state = 97},
  [2302] = {.lex_state = 97},
  [2303] = {.lex_state = 97},
  [2304] = {.lex_state = 97},
  [2305] = {.lex_state = 97},
  [2306] = {.lex_state = 97},
  [2307] = {.lex_state = 97},
  [2308] = {.lex_state = 97},
  [2309] = {.lex_state = 97},
  [2310] = {.lex_state = 97},
  [2311] = {.lex_state = 97},
  [2312] = {.lex_state = 97},
  [2313] = {.lex_state = 97},
  [2314] = {.lex_state = 97},
  [2315] = {.lex_state = 97},
  [2316] = {.lex_state = 97},
  [2317] = {.lex_state = 97},
  [2318] = {.lex_state = 97},
  [2319] = {.lex_state = 97},
  [2320] = {.lex_state = 97},
  [2321] = {.lex_state = 97},
  [2322] = {.lex_state = 97},
  [2323] = {.lex_state = 97},
  [2324] = {.lex_state = 97},
  [2325] = {.lex_state = 97},
  [2326] = {.lex_state = 97},
  [2327] = {.lex_state = 97},
  [2328] = {.lex_state = 97},
  [2329] = {.lex_state = 97},
  [2330] = {.lex_state = 97},
  [2331] = {.lex_state = 97},
  [2332] = {.lex_state = 97},
  [2333] = {.lex_state = 97},
  [2334] = {.lex_state = 97},
  [2335] = {.lex_state = 97},
  [2336] = {.lex_state = 97},
  [2337] = {.lex_state = 97},
  [2338] = {.lex_state = 97},
  [2339] = {.lex_state = 97},
  [2340] = {.lex_state = 97},
  [2341] = {.lex_state = 97},
  [2342] = {.lex_state = 97},
  [2343] = {.lex_state = 97},
  [2344] = {.lex_state = 97},
  [2345] = {.lex_state = 20},
  [2346] = {.lex_state = 20},
  [2347] = {.lex_state = 20},
  [2348] = {.lex_state = 20},
  [2349] = {.lex_state = 20},
  [2350] = {.lex_state = 20},
  [2351] = {.lex_state = 20},
  [2352] = {.lex_state = 20},
  [2353] = {.lex_state = 20},
  [2354] = {.lex_state = 20},
  [2355] = {.lex_state = 20},
  [2356] = {.lex_state = 20},
  [2357] = {.lex_state = 20},
  [2358] = {.lex_state = 20},
  [2359] = {.lex_state = 20},
  [2360] = {.lex_state = 20},
  [2361] = {.lex_state = 20},
  [2362] = {.lex_state = 20},
  [2363] = {.lex_state = 20},
  [2364] = {.lex_state = 20},
  [2365] = {.lex_state = 20},
  [2366] = {.lex_state = 20},
  [2367] = {.lex_state = 20},
  [2368] = {.lex_state = 20},
  [2369] = {.lex_state = 20},
  [2370] = {.lex_state = 20},
  [2371] = {.lex_state = 20},
  [2372] = {.lex_state = 20},
  [2373] = {.lex_state = 20},
  [2374] = {.lex_state = 20},
  [2375] = {.lex_state = 20},
  [2376] = {.lex_state = 20},
  [2377] = {.lex_state = 20},
  [2378] = {.lex_state = 20},
  [2379] = {.lex_state = 20},
  [2380] = {.lex_state = 20},
  [2381] = {.lex_state = 20},
  [2382] = {.lex_state = 12},
  [2383] = {.lex_state = 20, .external_lex_state = 4},
  [2384] = {.lex_state = 16},
  [2385] = {.lex_state = 16},
  [2386] = {.lex_state = 12},
  [2387] = {.lex_state = 12},
  [2388] = {.lex_state = 12},
  [2389] = {.lex_state = 16},
  [2390] = {.lex_state = 16},
  [2391] = {.lex_state = 20, .external_lex_state = 4},
  [2392] = {.lex_state = 20, .external_lex_state = 4},
  [2393] = {.lex_state = 97},
  [2394] = {.lex_state = 12},
  [2395] = {.lex_state = 12, .external_lex_state = 4},
  [2396] = {.lex_state = 12, .external_lex_state = 4},
  [2397] = {.lex_state = 97},
  [2398] = {.lex_state = 97},
  [2399] = {.lex_state = 20, .external_lex_state = 4},
  [2400] = {.lex_state = 97},
  [2401] = {.lex_state = 97},
  [2402] = {.lex_state = 97},
  [2403] = {.lex_state = 97},
  [2404] = {.lex_state = 97},
  [2405] = {.lex_state = 20, .external_lex_state = 5},
  [2406] = {.lex_state = 97},
  [2407] = {.lex_state = 4},
  [2408] = {.lex_state = 4},
  [2409] = {.lex_state = 20, .external_lex_state = 5},
  [2410] = {.lex_state = 20, .external_lex_state = 5},
  [2411] = {.lex_state = 4},
  [2412] = {.lex_state = 97},
  [2413] = {.lex_state = 97},
  [2414] = {.lex_state = 4},
  [2415] = {.lex_state = 97},
  [2416] = {.lex_state = 97},
  [2417] = {.lex_state = 97},
  [2418] = {.lex_state = 97},
  [2419] = {.lex_state = 4},
  [2420] = {.lex_state = 97},
  [2421] = {.lex_state = 97},
  [2422] = {.lex_state = 97},
  [2423] = {.lex_state = 97},
  [2424] = {.lex_state = 97},
  [2425] = {.lex_state = 97},
  [2426] = {.lex_state = 97},
  [2427] = {.lex_state = 20, .external_lex_state = 4},
  [2428] = {.lex_state = 20, .external_lex_state = 4},
  [2429] = {.lex_state = 20, .external_lex_state = 4},
  [2430] = {.lex_state = 20, .external_lex_state = 4},
  [2431] = {.lex_state = 20, .external_lex_state = 4},
  [2432] = {.lex_state = 20, .external_lex_state = 4},
  [2433] = {.lex_state = 20, .external_lex_state = 4},
  [2434] = {.lex_state = 20, .external_lex_state = 4},
  [2435] = {.lex_state = 20, .external_lex_state = 4},
  [2436] = {.lex_state = 20, .external_lex_state = 4},
  [2437] = {.lex_state = 20, .external_lex_state = 4},
  [2438] = {.lex_state = 20, .external_lex_state = 4},
  [2439] = {.lex_state = 20, .external_lex_state = 4},
  [2440] = {.lex_state = 20, .external_lex_state = 4},
  [2441] = {.lex_state = 97},
  [2442] = {.lex_state = 97},
  [2443] = {.lex_state = 97},
  [2444] = {.lex_state = 97},
  [2445] = {.lex_state = 97},
  [2446] = {.lex_state = 97},
  [2447] = {.lex_state = 97},
  [2448] = {.lex_state = 97},
  [2449] = {.lex_state = 4},
  [2450] = {.lex_state = 97},
  [2451] = {.lex_state = 4},
  [2452] = {.lex_state = 97},
  [2453] = {.lex_state = 97},
  [2454] = {.lex_state = 97},
  [2455] = {.lex_state = 97},
  [2456] = {.lex_state = 97},
  [2457] = {.lex_state = 20, .external_lex_state = 4},
  [2458] = {.lex_state = 20, .external_lex_state = 4},
  [2459] = {.lex_state = 20, .external_lex_state = 4},
  [2460] = {.lex_state = 20, .external_lex_state = 4},
  [2461] = {.lex_state = 97},
  [2462] = {.lex_state = 20, .external_lex_state = 4},
  [2463] = {.lex_state = 20, .external_lex_state = 4},
  [2464] = {.lex_state = 20, .external_lex_state = 4},
  [2465] = {.lex_state = 20, .external_lex_state = 4},
  [2466] = {.lex_state = 20, .external_lex_state = 4},
  [2467] = {.lex_state = 97},
  [2468] = {.lex_state = 97},
  [2469] = {.lex_state = 97},
  [2470] = {.lex_state = 97},
  [2471] = {.lex_state = 4},
  [2472] = {.lex_state = 12, .external_lex_state = 4},
  [2473] = {.lex_state = 20, .external_lex_state = 4},
  [2474] = {.lex_state = 20, .external_lex_state = 4},
  [2475] = {.lex_state = 20, .external_lex_state = 4},
  [2476] = {.lex_state = 20, .external_lex_state = 4},
  [2477] = {.lex_state = 20, .external_lex_state = 4},
  [2478] = {.lex_state = 20, .external_lex_state = 4},
  [2479] = {.lex_state = 20, .external_lex_state = 4},
  [2480] = {.lex_state = 20, .external_lex_state = 4},
  [2481] = {.lex_state = 20, .external_lex_state = 4},
  [2482] = {.lex_state = 20, .external_lex_state = 4},
  [2483] = {.lex_state = 97},
  [2484] = {.lex_state = 97},
  [2485] = {.lex_state = 97},
  [2486] = {.lex_state = 97},
  [2487] = {.lex_state = 97},
  [2488] = {.lex_state = 97},
  [2489] = {.lex_state = 97},
  [2490] = {.lex_state = 97},
  [2491] = {.lex_state = 97},
  [2492] = {.lex_state = 97},
  [2493] = {.lex_state = 97},
  [2494] = {.lex_state = 97},
  [2495] = {.lex_state = 97},
  [2496] = {.lex_state = 97},
  [2497] = {.lex_state = 97},
  [2498] = {.lex_state = 97},
  [2499] = {.lex_state = 97},
  [2500] = {.lex_state = 13, .external_lex_state = 4},
  [2501] = {.lex_state = 13, .external_lex_state = 4},
  [2502] = {.lex_state = 13, .external_lex_state = 4},
  [2503] = {.lex_state = 97},
  [2504] = {.lex_state = 97},
  [2505] = {.lex_state = 97},
  [2506] = {.lex_state = 97},
  [2507] = {.lex_state = 97},
  [2508] = {.lex_state = 97},
  [2509] = {.lex_state = 13, .external_lex_state = 4},
  [2510] = {.lex_state = 97},
  [2511] = {.lex_state = 97},
  [2512] = {.lex_state = 97},
  [2513] = {.lex_state = 12, .external_lex_state = 4},
  [2514] = {.lex_state = 97},
  [2515] = {.lex_state = 97},
  [2516] = {.lex_state = 97},
  [2517] = {.lex_state = 97},
  [2518] = {.lex_state = 97},
  [2519] = {.lex_state = 97},
  [2520] = {.lex_state = 13, .external_lex_state = 4},
  [2521] = {.lex_state = 13, .external_lex_state = 4},
  [2522] = {.lex_state = 13, .external_lex_state = 4},
  [2523] = {.lex_state = 97},
  [2524] = {.lex_state = 97},
  [2525] = {.lex_state = 13, .external_lex_state = 4},
  [2526] = {.lex_state = 12, .external_lex_state = 4},
  [2527] = {.lex_state = 20, .external_lex_state = 5},
  [2528] = {.lex_state = 13, .external_lex_state = 4},
  [2529] = {.lex_state = 20, .external_lex_state = 5},
  [2530] = {.lex_state = 20, .external_lex_state = 5},
  [2531] = {.lex_state = 20, .external_lex_state = 5},
  [2532] = {.lex_state = 20, .external_lex_state = 5},
  [2533] = {.lex_state = 20, .external_lex_state = 5},
  [2534] = {.lex_state = 12, .external_lex_state = 4},
  [2535] = {.lex_state = 12, .external_lex_state = 4},
  [2536] = {.lex_state = 20, .external_lex_state = 5},
  [2537] = {.lex_state = 13, .external_lex_state = 4},
  [2538] = {.lex_state = 13, .external_lex_state = 4},
  [2539] = {.lex_state = 20, .external_lex_state = 5},
  [2540] = {.lex_state = 20, .external_lex_state = 5},
  [2541] = {.lex_state = 20, .external_lex_state = 5},
  [2542] = {.lex_state = 20, .external_lex_state = 5},
  [2543] = {.lex_state = 20, .external_lex_state = 5},
  [2544] = {.lex_state = 20, .external_lex_state = 5},
  [2545] = {.lex_state = 20, .external_lex_state = 5},
  [2546] = {.lex_state = 20, .external_lex_state = 5},
  [2547] = {.lex_state = 16, .external_lex_state = 4},
  [2548] = {.lex_state = 13, .external_lex_state = 4},
  [2549] = {.lex_state = 20, .external_lex_state = 5},
  [2550] = {.lex_state = 16, .external_lex_state = 4},
  [2551] = {.lex_state = 20, .external_lex_state = 5},
  [2552] = {.lex_state = 12, .external_lex_state = 5},
  [2553] = {.lex_state = 20, .external_lex_state = 5},
  [2554] = {.lex_state = 13, .external_lex_state = 4},
  [2555] = {.lex_state = 20, .external_lex_state = 5},
  [2556] = {.lex_state = 16, .external_lex_state = 4},
  [2557] = {.lex_state = 20, .external_lex_state = 5},
  [2558] = {.lex_state = 13, .external_lex_state = 4},
  [2559] = {.lex_state = 20, .external_lex_state = 5},
  [2560] = {.lex_state = 16, .external_lex_state = 4},
  [2561] = {.lex_state = 20, .external_lex_state = 5},
  [2562] = {.lex_state = 20, .external_lex_state = 5},
  [2563] = {.lex_state = 20, .external_lex_state = 5},
  [2564] = {.lex_state = 20, .external_lex_state = 5},
  [2565] = {.lex_state = 16, .external_lex_state = 4},
  [2566] = {.lex_state = 20, .external_lex_state = 5},
  [2567] = {.lex_state = 20, .external_lex_state = 5},
  [2568] = {.lex_state = 20, .external_lex_state = 5},
  [2569] = {.lex_state = 13, .external_lex_state = 4},
  [2570] = {.lex_state = 13, .external_lex_state = 4},
  [2571] = {.lex_state = 20, .external_lex_state = 5},
  [2572] = {.lex_state = 20, .external_lex_state = 5},
  [2573] = {.lex_state = 13},
  [2574] = {.lex_state = 20, .external_lex_state = 5},
  [2575] = {.lex_state = 20, .external_lex_state = 5},
  [2576] = {.lex_state = 16, .external_lex_state = 4},
  [2577] = {.lex_state = 13, .external_lex_state = 4},
  [2578] = {.lex_state = 20, .external_lex_state = 5},
  [2579] = {.lex_state = 20, .external_lex_state = 5},
  [2580] = {.lex_state = 16, .external_lex_state = 4},
  [2581] = {.lex_state = 20},
  [2582] = {.lex_state = 13, .external_lex_state = 4},
  [2583] = {.lex_state = 13, .external_lex_state = 4},
  [2584] = {.lex_state = 20},
  [2585] = {.lex_state = 13, .external_lex_state = 4},
  [2586] = {.lex_state = 13, .external_lex_state = 4},
  [2587] = {.lex_state = 97, .external_lex_state = 4},
  [2588] = {.lex_state = 13, .external_lex_state = 4},
  [2589] = {.lex_state = 13, .external_lex_state = 4},
  [2590] = {.lex_state = 13, .external_lex_state = 4},
  [2591] = {.lex_state = 20},
  [2592] = {.lex_state = 13, .external_lex_state = 4},
  [2593] = {.lex_state = 13, .external_lex_state = 4},
  [2594] = {.lex_state = 13, .external_lex_state = 4},
  [2595] = {.lex_state = 13, .external_lex_state = 4},
  [2596] = {.lex_state = 97, .external_lex_state = 4},
  [2597] = {.lex_state = 13, .external_lex_state = 4},
  [2598] = {.lex_state = 97, .external_lex_state = 4},
  [2599] = {.lex_state = 97, .external_lex_state = 4},
  [2600] = {.lex_state = 13, .external_lex_state = 4},
  [2601] = {.lex_state = 13},
  [2602] = {.lex_state = 13, .external_lex_state = 4},
  [2603] = {.lex_state = 97},
  [2604] = {.lex_state = 13, .external_lex_state = 4},
  [2605] = {.lex_state = 13, .external_lex_state = 4},
  [2606] = {.lex_state = 13, .external_lex_state = 4},
  [2607] = {.lex_state = 13, .external_lex_state = 4},
  [2608] = {.lex_state = 97, .external_lex_state = 4},
  [2609] = {.lex_state = 13, .external_lex_state = 4},
  [2610] = {.lex_state = 12, .external_lex_state = 5},
  [2611] = {.lex_state = 13},
  [2612] = {.lex_state = 13, .external_lex_state = 4},
  [2613] = {.lex_state = 13},
  [2614] = {.lex_state = 13, .external_lex_state = 4},
  [2615] = {.lex_state = 13, .external_lex_state = 4},
  [2616] = {.lex_state = 97, .external_lex_state = 4},
  [2617] = {.lex_state = 97, .external_lex_state = 4},
  [2618] = {.lex_state = 97, .external_lex_state = 4},
  [2619] = {.lex_state = 12, .external_lex_state = 5},
  [2620] = {.lex_state = 97, .external_lex_state = 4},
  [2621] = {.lex_state = 16, .external_lex_state = 5},
  [2622] = {.lex_state = 97, .external_lex_state = 4},
  [2623] = {.lex_state = 97},
  [2624] = {.lex_state = 16, .external_lex_state = 5},
  [2625] = {.lex_state = 97, .external_lex_state = 4},
  [2626] = {.lex_state = 16, .external_lex_state = 5},
  [2627] = {.lex_state = 97, .external_lex_state = 4},
  [2628] = {.lex_state = 16, .external_lex_state = 5},
  [2629] = {.lex_state = 13, .external_lex_state = 4},
  [2630] = {.lex_state = 12, .external_lex_state = 5},
  [2631] = {.lex_state = 97, .external_lex_state = 4},
  [2632] = {.lex_state = 97, .external_lex_state = 4},
  [2633] = {.lex_state = 97, .external_lex_state = 4},
  [2634] = {.lex_state = 97, .external_lex_state = 4},
  [2635] = {.lex_state = 13, .external_lex_state = 4},
  [2636] = {.lex_state = 97, .external_lex_state = 4},
  [2637] = {.lex_state = 97, .external_lex_state = 4},
  [2638] = {.lex_state = 97, .external_lex_state = 4},
  [2639] = {.lex_state = 97, .external_lex_state = 4},
  [2640] = {.lex_state = 16, .external_lex_state = 5},
  [2641] = {.lex_state = 97, .external_lex_state = 4},
  [2642] = {.lex_state = 97, .external_lex_state = 4},
  [2643] = {.lex_state = 97, .external_lex_state = 4},
  [2644] = {.lex_state = 16, .external_lex_state = 5},
  [2645] = {.lex_state = 97, .external_lex_state = 4},
  [2646] = {.lex_state = 97, .external_lex_state = 4},
  [2647] = {.lex_state = 97, .external_lex_state = 4},
  [2648] = {.lex_state = 97, .external_lex_state = 4},
  [2649] = {.lex_state = 97, .external_lex_state = 4},
  [2650] = {.lex_state = 97, .external_lex_state = 4},
  [2651] = {.lex_state = 97, .external_lex_state = 4},
  [2652] = {.lex_state = 16, .external_lex_state = 5},
  [2653] = {.lex_state = 97, .external_lex_state = 4},
  [2654] = {.lex_state = 97, .external_lex_state = 4},
  [2655] = {.lex_state = 97, .external_lex_state = 4},
  [2656] = {.lex_state = 97, .external_lex_state = 4},
  [2657] = {.lex_state = 97, .external_lex_state = 4},
  [2658] = {.lex_state = 97, .external_lex_state = 4},
  [2659] = {.lex_state = 97, .external_lex_state = 4},
  [2660] = {.lex_state = 97, .external_lex_state = 4},
  [2661] = {.lex_state = 97, .external_lex_state = 4},
  [2662] = {.lex_state = 97, .external_lex_state = 4},
  [2663] = {.lex_state = 12, .external_lex_state = 5},
  [2664] = {.lex_state = 97, .external_lex_state = 4},
  [2665] = {.lex_state = 97, .external_lex_state = 4},
  [2666] = {.lex_state = 97, .external_lex_state = 4},
  [2667] = {.lex_state = 97, .external_lex_state = 4},
  [2668] = {.lex_state = 97, .external_lex_state = 4},
  [2669] = {.lex_state = 97, .external_lex_state = 4},
  [2670] = {.lex_state = 97, .external_lex_state = 4},
  [2671] = {.lex_state = 97, .external_lex_state = 4},
  [2672] = {.lex_state = 97, .external_lex_state = 4},
  [2673] = {.lex_state = 97, .external_lex_state = 4},
  [2674] = {.lex_state = 97, .external_lex_state = 4},
  [2675] = {.lex_state = 97, .external_lex_state = 4},
  [2676] = {.lex_state = 97, .external_lex_state = 4},
  [2677] = {.lex_state = 97, .external_lex_state = 4},
  [2678] = {.lex_state = 97, .external_lex_state = 4},
  [2679] = {.lex_state = 97, .external_lex_state = 4},
  [2680] = {.lex_state = 97, .external_lex_state = 4},
  [2681] = {.lex_state = 97, .external_lex_state = 5},
  [2682] = {.lex_state = 97},
  [2683] = {.lex_state = 97, .external_lex_state = 4},
  [2684] = {.lex_state = 97, .external_lex_state = 4},
  [2685] = {.lex_state = 12},
  [2686] = {.lex_state = 97, .external_lex_state = 4},
  [2687] = {.lex_state = 12},
  [2688] = {.lex_state = 12},
  [2689] = {.lex_state = 97},
  [2690] = {.lex_state = 13},
  [2691] = {.lex_state = 12},
  [2692] = {.lex_state = 97, .external_lex_state = 5},
  [2693] = {.lex_state = 12},
  [2694] = {.lex_state = 97, .external_lex_state = 5},
  [2695] = {.lex_state = 97, .external_lex_state = 4},
  [2696] = {.lex_state = 97, .external_lex_state = 5},
  [2697] = {.lex_state = 12},
  [2698] = {.lex_state = 97},
  [2699] = {.lex_state = 12},
  [2700] = {.lex_state = 97, .external_lex_state = 5},
  [2701] = {.lex_state = 13, .external_lex_state = 4},
  [2702] = {.lex_state = 12},
  [2703] = {.lex_state = 12},
  [2704] = {.lex_state = 97},
  [2705] = {.lex_state = 12},
  [2706] = {.lex_state = 12},
  [2707] = {.lex_state = 97, .external_lex_state = 5},
  [2708] = {.lex_state = 15},
  [2709] = {.lex_state = 97, .external_lex_state = 5},
  [2710] = {.lex_state = 97, .external_lex_state = 5},
  [2711] = {.lex_state = 97, .external_lex_state = 5},
  [2712] = {.lex_state = 97, .external_lex_state = 5},
  [2713] = {.lex_state = 97, .external_lex_state = 4},
  [2714] = {.lex_state = 97, .external_lex_state = 5},
  [2715] = {.lex_state = 97, .external_lex_state = 5},
  [2716] = {.lex_state = 15},
  [2717] = {.lex_state = 97},
  [2718] = {.lex_state = 97},
  [2719] = {.lex_state = 12},
  [2720] = {.lex_state = 12},
  [2721] = {.lex_state = 12},
  [2722] = {.lex_state = 12},
  [2723] = {.lex_state = 97, .external_lex_state = 5},
  [2724] = {.lex_state = 97, .external_lex_state = 5},
  [2725] = {.lex_state = 12},
  [2726] = {.lex_state = 97},
  [2727] = {.lex_state = 97, .external_lex_state = 5},
  [2728] = {.lex_state = 97, .external_lex_state = 5},
  [2729] = {.lex_state = 97, .external_lex_state = 5},
  [2730] = {.lex_state = 97, .external_lex_state = 5},
  [2731] = {.lex_state = 97, .external_lex_state = 5},
  [2732] = {.lex_state = 97, .external_lex_state = 4},
  [2733] = {.lex_state = 12},
  [2734] = {.lex_state = 97, .external_lex_state = 4},
  [2735] = {.lex_state = 97},
  [2736] = {.lex_state = 97, .external_lex_state = 5},
  [2737] = {.lex_state = 97, .external_lex_state = 5},
  [2738] = {.lex_state = 97, .external_lex_state = 5},
  [2739] = {.lex_state = 97, .external_lex_state = 5},
  [2740] = {.lex_state = 97, .external_lex_state = 5},
  [2741] = {.lex_state = 15},
  [2742] = {.lex_state = 97, .external_lex_state = 5},
  [2743] = {.lex_state = 97, .external_lex_state = 5},
  [2744] = {.lex_state = 97, .external_lex_state = 5},
  [2745] = {.lex_state = 12},
  [2746] = {.lex_state = 12},
  [2747] = {.lex_state = 97, .external_lex_state = 5},
  [2748] = {.lex_state = 97, .external_lex_state = 5},
  [2749] = {.lex_state = 97, .external_lex_state = 5},
  [2750] = {.lex_state = 97, .external_lex_state = 5},
  [2751] = {.lex_state = 97, .external_lex_state = 5},
  [2752] = {.lex_state = 97, .external_lex_state = 5},
  [2753] = {.lex_state = 97, .external_lex_state = 5},
  [2754] = {.lex_state = 97, .external_lex_state = 5},
  [2755] = {.lex_state = 13},
  [2756] = {.lex_state = 97},
  [2757] = {.lex_state = 97, .external_lex_state = 5},
  [2758] = {.lex_state = 97, .external_lex_state = 5},
  [2759] = {.lex_state = 97, .external_lex_state = 5},
  [2760] = {.lex_state = 13},
  [2761] = {.lex_state = 12},
  [2762] = {.lex_state = 97, .external_lex_state = 5},
  [2763] = {.lex_state = 97, .external_lex_state = 5},
  [2764] = {.lex_state = 97, .external_lex_state = 5},
  [2765] = {.lex_state = 97, .external_lex_state = 5},
  [2766] = {.lex_state = 97, .external_lex_state = 5},
  [2767] = {.lex_state = 97, .external_lex_state = 5},
  [2768] = {.lex_state = 97, .external_lex_state = 5},
  [2769] = {.lex_state = 97, .external_lex_state = 5},
  [2770] = {.lex_state = 97, .external_lex_state = 5},
  [2771] = {.lex_state = 97, .external_lex_state = 5},
  [2772] = {.lex_state = 97, .external_lex_state = 5},
  [2773] = {.lex_state = 12},
  [2774] = {.lex_state = 12},
  [2775] = {.lex_state = 97, .external_lex_state = 5},
  [2776] = {.lex_state = 97},
  [2777] = {.lex_state = 12},
  [2778] = {.lex_state = 12},
  [2779] = {.lex_state = 12},
  [2780] = {.lex_state = 13},
  [2781] = {.lex_state = 97, .external_lex_state = 5},
  [2782] = {.lex_state = 97},
  [2783] = {.lex_state = 12},
  [2784] = {.lex_state = 97, .external_lex_state = 4},
  [2785] = {.lex_state = 97, .external_lex_state = 5},
  [2786] = {.lex_state = 97, .external_lex_state = 5},
  [2787] = {.lex_state = 97, .external_lex_state = 5},
  [2788] = {.lex_state = 97, .external_lex_state = 5},
  [2789] = {.lex_state = 97, .external_lex_state = 4},
  [2790] = {.lex_state = 97, .external_lex_state = 5},
  [2791] = {.lex_state = 12},
  [2792] = {.lex_state = 97, .external_lex_state = 5},
  [2793] = {.lex_state = 97, .external_lex_state = 4},
  [2794] = {.lex_state = 12},
  [2795] = {.lex_state = 13},
  [2796] = {.lex_state = 13},
  [2797] = {.lex_state = 13},
  [2798] = {.lex_state = 97, .external_lex_state = 4},
  [2799] = {.lex_state = 13},
  [2800] = {.lex_state = 97},
  [2801] = {.lex_state = 97, .external_lex_state = 5},
  [2802] = {.lex_state = 12},
  [2803] = {.lex_state = 97, .external_lex_state = 5},
  [2804] = {.lex_state = 97},
  [2805] = {.lex_state = 97, .external_lex_state = 5},
  [2806] = {.lex_state = 13},
  [2807] = {.lex_state = 12},
  [2808] = {.lex_state = 97, .external_lex_state = 4},
  [2809] = {.lex_state = 16},
  [2810] = {.lex_state = 16},
  [2811] = {.lex_state = 13},
  [2812] = {.lex_state = 16},
  [2813] = {.lex_state = 97, .external_lex_state = 4},
  [2814] = {.lex_state = 18, .external_lex_state = 6},
  [2815] = {.lex_state = 97},
  [2816] = {.lex_state = 97},
  [2817] = {.lex_state = 97, .external_lex_state = 4},
  [2818] = {.lex_state = 18, .external_lex_state = 6},
  [2819] = {.lex_state = 18, .external_lex_state = 6},
  [2820] = {.lex_state = 18, .external_lex_state = 6},
  [2821] = {.lex_state = 18, .external_lex_state = 6},
  [2822] = {.lex_state = 18, .external_lex_state = 6},
  [2823] = {.lex_state = 97, .external_lex_state = 5},
  [2824] = {.lex_state = 18, .external_lex_state = 6},
  [2825] = {.lex_state = 18, .external_lex_state = 6},
  [2826] = {.lex_state = 97, .external_lex_state = 4},
  [2827] = {.lex_state = 97, .external_lex_state = 4},
  [2828] = {.lex_state = 97},
  [2829] = {.lex_state = 97},
  [2830] = {.lex_state = 0, .external_lex_state = 4},
  [2831] = {.lex_state = 97},
  [2832] = {.lex_state = 97},
  [2833] = {.lex_state = 13},
  [2834] = {.lex_state = 97},
  [2835] = {.lex_state = 97, .external_lex_state = 4},
  [2836] = {.lex_state = 97},
  [2837] = {.lex_state = 97, .external_lex_state = 4},
  [2838] = {.lex_state = 97},
  [2839] = {.lex_state = 97, .external_lex_state = 4},
  [2840] = {.lex_state = 97, .external_lex_state = 4},
  [2841] = {.lex_state = 97},
  [2842] = {.lex_state = 97, .external_lex_state = 4},
  [2843] = {.lex_state = 97, .external_lex_state = 4},
  [2844] = {.lex_state = 97},
  [2845] = {.lex_state = 0, .external_lex_state = 4},
  [2846] = {.lex_state = 13},
  [2847] = {.lex_state = 97, .external_lex_state = 4},
  [2848] = {.lex_state = 97, .external_lex_state = 4},
  [2849] = {.lex_state = 97},
  [2850] = {.lex_state = 97, .external_lex_state = 4},
  [2851] = {.lex_state = 97, .external_lex_state = 4},
  [2852] = {.lex_state = 97},
  [2853] = {.lex_state = 97},
  [2854] = {.lex_state = 97, .external_lex_state = 4},
  [2855] = {.lex_state = 97},
  [2856] = {.lex_state = 97, .external_lex_state = 4},
  [2857] = {.lex_state = 97},
  [2858] = {.lex_state = 97},
  [2859] = {.lex_state = 13},
  [2860] = {.lex_state = 97, .external_lex_state = 4},
  [2861] = {.lex_state = 97, .external_lex_state = 4},
  [2862] = {.lex_state = 97, .external_lex_state = 4},
  [2863] = {.lex_state = 97, .external_lex_state = 4},
  [2864] = {.lex_state = 97},
  [2865] = {.lex_state = 97, .external_lex_state = 4},
  [2866] = {.lex_state = 13},
  [2867] = {.lex_state = 97, .external_lex_state = 4},
  [2868] = {.lex_state = 97, .external_lex_state = 4},
  [2869] = {.lex_state = 97},
  [2870] = {.lex_state = 13},
  [2871] = {.lex_state = 97, .external_lex_state = 4},
  [2872] = {.lex_state = 97},
  [2873] = {.lex_state = 97},
  [2874] = {.lex_state = 97},
  [2875] = {.lex_state = 97},
  [2876] = {.lex_state = 97},
  [2877] = {.lex_state = 97},
  [2878] = {.lex_state = 0, .external_lex_state = 4},
  [2879] = {.lex_state = 97, .external_lex_state = 4},
  [2880] = {.lex_state = 97, .external_lex_state = 4},
  [2881] = {.lex_state = 97},
  [2882] = {.lex_state = 13},
  [2883] = {.lex_state = 97, .external_lex_state = 4},
  [2884] = {.lex_state = 97, .external_lex_state = 4},
  [2885] = {.lex_state = 0, .external_lex_state = 4},
  [2886] = {.lex_state = 97, .external_lex_state = 4},
  [2887] = {.lex_state = 97},
  [2888] = {.lex_state = 0, .external_lex_state = 4},
  [2889] = {.lex_state = 97, .external_lex_state = 4},
  [2890] = {.lex_state = 97, .external_lex_state = 4},
  [2891] = {.lex_state = 97, .external_lex_state = 4},
  [2892] = {.lex_state = 97},
  [2893] = {.lex_state = 0, .external_lex_state = 4},
  [2894] = {.lex_state = 97},
  [2895] = {.lex_state = 13},
  [2896] = {.lex_state = 97},
  [2897] = {.lex_state = 13},
  [2898] = {.lex_state = 97},
  [2899] = {.lex_state = 13},
  [2900] = {.lex_state = 97, .external_lex_state = 4},
  [2901] = {.lex_state = 97, .external_lex_state = 4},
  [2902] = {.lex_state = 97},
  [2903] = {.lex_state = 97},
  [2904] = {.lex_state = 97},
  [2905] = {.lex_state = 13},
  [2906] = {.lex_state = 97, .external_lex_state = 4},
  [2907] = {.lex_state = 97, .external_lex_state = 4},
  [2908] = {.lex_state = 97},
  [2909] = {.lex_state = 13},
  [2910] = {.lex_state = 97},
  [2911] = {.lex_state = 13},
  [2912] = {.lex_state = 97},
  [2913] = {.lex_state = 0, .external_lex_state = 4},
  [2914] = {.lex_state = 13},
  [2915] = {.lex_state = 97, .external_lex_state = 4},
  [2916] = {.lex_state = 13},
  [2917] = {.lex_state = 13},
  [2918] = {.lex_state = 0, .external_lex_state = 4},
  [2919] = {.lex_state = 97, .external_lex_state = 4},
  [2920] = {.lex_state = 0, .external_lex_state = 4},
  [2921] = {.lex_state = 0, .external_lex_state = 4},
  [2922] = {.lex_state = 13},
  [2923] = {.lex_state = 97},
  [2924] = {.lex_state = 97},
  [2925] = {.lex_state = 97},
  [2926] = {.lex_state = 97},
  [2927] = {.lex_state = 97},
  [2928] = {.lex_state = 13},
  [2929] = {.lex_state = 97},
  [2930] = {.lex_state = 0, .external_lex_state = 4},
  [2931] = {.lex_state = 97},
  [2932] = {.lex_state = 97},
  [2933] = {.lex_state = 97},
  [2934] = {.lex_state = 97},
  [2935] = {.lex_state = 97},
  [2936] = {.lex_state = 97},
  [2937] = {.lex_state = 97, .external_lex_state = 4},
  [2938] = {.lex_state = 97, .external_lex_state = 4},
  [2939] = {.lex_state = 13},
  [2940] = {.lex_state = 97},
  [2941] = {.lex_state = 97},
  [2942] = {.lex_state = 97},
  [2943] = {.lex_state = 13},
  [2944] = {.lex_state = 97},
  [2945] = {.lex_state = 97, .external_lex_state = 4},
  [2946] = {.lex_state = 13},
  [2947] = {.lex_state = 18},
  [2948] = {.lex_state = 18, .external_lex_state = 6},
  [2949] = {.lex_state = 97},
  [2950] = {.lex_state = 97},
  [2951] = {.lex_state = 97},
  [2952] = {.lex_state = 13},
  [2953] = {.lex_state = 97},
  [2954] = {.lex_state = 13},
  [2955] = {.lex_state = 97, .external_lex_state = 5},
  [2956] = {.lex_state = 0, .external_lex_state = 4},
  [2957] = {.lex_state = 13},
  [2958] = {.lex_state = 13},
  [2959] = {.lex_state = 0, .external_lex_state = 4},
  [2960] = {.lex_state = 97},
  [2961] = {.lex_state = 13},
  [2962] = {.lex_state = 18, .external_lex_state = 6},
  [2963] = {.lex_state = 97},
  [2964] = {.lex_state = 0, .external_lex_state = 4},
  [2965] = {.lex_state = 13},
  [2966] = {.lex_state = 97, .external_lex_state = 5},
  [2967] = {.lex_state = 97, .external_lex_state = 5},
  [2968] = {.lex_state = 18},
  [2969] = {.lex_state = 13},
  [2970] = {.lex_state = 13},
  [2971] = {.lex_state = 97, .external_lex_state = 5},
  [2972] = {.lex_state = 97, .external_lex_state = 5},
  [2973] = {.lex_state = 97},
  [2974] = {.lex_state = 13},
  [2975] = {.lex_state = 13},
  [2976] = {.lex_state = 97, .external_lex_state = 5},
  [2977] = {.lex_state = 18, .external_lex_state = 6},
  [2978] = {.lex_state = 18},
  [2979] = {.lex_state = 13},
  [2980] = {.lex_state = 97},
  [2981] = {.lex_state = 18},
  [2982] = {.lex_state = 97},
  [2983] = {.lex_state = 97, .external_lex_state = 5},
  [2984] = {.lex_state = 13},
  [2985] = {.lex_state = 97},
  [2986] = {.lex_state = 97, .external_lex_state = 5},
  [2987] = {.lex_state = 18},
  [2988] = {.lex_state = 0},
  [2989] = {.lex_state = 0, .external_lex_state = 4},
  [2990] = {.lex_state = 18, .external_lex_state = 6},
  [2991] = {.lex_state = 13},
  [2992] = {.lex_state = 97},
  [2993] = {.lex_state = 18},
  [2994] = {.lex_state = 97},
  [2995] = {.lex_state = 0, .external_lex_state = 4},
  [2996] = {.lex_state = 97},
  [2997] = {.lex_state = 97},
  [2998] = {.lex_state = 0, .external_lex_state = 4},
  [2999] = {.lex_state = 13},
  [3000] = {.lex_state = 13},
  [3001] = {.lex_state = 0, .external_lex_state = 4},
  [3002] = {.lex_state = 97},
  [3003] = {.lex_state = 0, .external_lex_state = 4},
  [3004] = {.lex_state = 97},
  [3005] = {.lex_state = 97},
  [3006] = {.lex_state = 18, .external_lex_state = 6},
  [3007] = {.lex_state = 97},
  [3008] = {.lex_state = 97},
  [3009] = {.lex_state = 0, .external_lex_state = 4},
  [3010] = {.lex_state = 13},
  [3011] = {.lex_state = 97},
  [3012] = {.lex_state = 0, .external_lex_state = 4},
  [3013] = {.lex_state = 18},
  [3014] = {.lex_state = 18},
  [3015] = {.lex_state = 97, .external_lex_state = 5},
  [3016] = {.lex_state = 97, .external_lex_state = 5},
  [3017] = {.lex_state = 13},
  [3018] = {.lex_state = 13},
  [3019] = {.lex_state = 13},
  [3020] = {.lex_state = 13},
  [3021] = {.lex_state = 0, .external_lex_state = 4},
  [3022] = {.lex_state = 97, .external_lex_state = 5},
  [3023] = {.lex_state = 13},
  [3024] = {.lex_state = 97, .external_lex_state = 4},
  [3025] = {.lex_state = 13},
  [3026] = {.lex_state = 97},
  [3027] = {.lex_state = 97},
  [3028] = {.lex_state = 0, .external_lex_state = 4},
  [3029] = {.lex_state = 97, .external_lex_state = 4},
  [3030] = {.lex_state = 0, .external_lex_state = 4},
  [3031] = {.lex_state = 97, .external_lex_state = 4},
  [3032] = {.lex_state = 13},
  [3033] = {.lex_state = 97, .external_lex_state = 4},
  [3034] = {.lex_state = 0, .external_lex_state = 4},
  [3035] = {.lex_state = 97, .external_lex_state = 5},
  [3036] = {.lex_state = 97},
  [3037] = {.lex_state = 97, .external_lex_state = 5},
  [3038] = {.lex_state = 0, .external_lex_state = 4},
  [3039] = {.lex_state = 97, .external_lex_state = 5},
  [3040] = {.lex_state = 97, .external_lex_state = 5},
  [3041] = {.lex_state = 97, .external_lex_state = 5},
  [3042] = {.lex_state = 97},
  [3043] = {.lex_state = 97},
  [3044] = {.lex_state = 97, .external_lex_state = 5},
  [3045] = {.lex_state = 13},
  [3046] = {.lex_state = 97},
  [3047] = {.lex_state = 13},
  [3048] = {.lex_state = 13},
  [3049] = {.lex_state = 97, .external_lex_state = 5},
  [3050] = {.lex_state = 97, .external_lex_state = 5},
  [3051] = {.lex_state = 0, .external_lex_state = 4},
  [3052] = {.lex_state = 13},
  [3053] = {.lex_state = 0, .external_lex_state = 4},
  [3054] = {.lex_state = 13},
  [3055] = {.lex_state = 0, .external_lex_state = 4},
  [3056] = {.lex_state = 0, .external_lex_state = 4},
  [3057] = {.lex_state = 0, .external_lex_state = 4},
  [3058] = {.lex_state = 97, .external_lex_state = 5},
  [3059] = {.lex_state = 97, .external_lex_state = 5},
  [3060] = {.lex_state = 13},
  [3061] = {.lex_state = 13},
  [3062] = {.lex_state = 97},
  [3063] = {.lex_state = 13},
  [3064] = {.lex_state = 97},
  [3065] = {.lex_state = 97},
  [3066] = {.lex_state = 0, .external_lex_state = 4},
  [3067] = {.lex_state = 97},
  [3068] = {.lex_state = 97},
  [3069] = {.lex_state = 13},
  [3070] = {.lex_state = 0, .external_lex_state = 4},
  [3071] = {.lex_state = 13},
  [3072] = {.lex_state = 97, .external_lex_state = 5},
  [3073] = {.lex_state = 0, .external_lex_state = 4},
  [3074] = {.lex_state = 13},
  [3075] = {.lex_state = 13},
  [3076] = {.lex_state = 97},
  [3077] = {.lex_state = 97},
  [3078] = {.lex_state = 97},
  [3079] = {.lex_state = 97},
  [3080] = {.lex_state = 97, .external_lex_state = 5},
  [3081] = {.lex_state = 13},
  [3082] = {.lex_state = 18},
  [3083] = {.lex_state = 97, .external_lex_state = 5},
  [3084] = {.lex_state = 97},
  [3085] = {.lex_state = 97, .external_lex_state = 5},
  [3086] = {.lex_state = 97},
  [3087] = {.lex_state = 97},
  [3088] = {.lex_state = 97},
  [3089] = {.lex_state = 13},
  [3090] = {.lex_state = 0, .external_lex_state = 4},
  [3091] = {.lex_state = 0, .external_lex_state = 4},
  [3092] = {.lex_state = 13},
  [3093] = {.lex_state = 97, .external_lex_state = 5},
  [3094] = {.lex_state = 13},
  [3095] = {.lex_state = 97, .external_lex_state = 5},
  [3096] = {.lex_state = 97, .external_lex_state = 5},
  [3097] = {.lex_state = 0, .external_lex_state = 4},
  [3098] = {.lex_state = 97, .external_lex_state = 4},
  [3099] = {.lex_state = 0, .external_lex_state = 4},
  [3100] = {.lex_state = 97, .external_lex_state = 4},
  [3101] = {.lex_state = 0, .external_lex_state = 4},
  [3102] = {.lex_state = 13},
  [3103] = {.lex_state = 0, .external_lex_state = 4},
  [3104] = {.lex_state = 13},
  [3105] = {.lex_state = 13},
  [3106] = {.lex_state = 97},
  [3107] = {.lex_state = 0, .external_lex_state = 4},
  [3108] = {.lex_state = 0},
  [3109] = {.lex_state = 13},
  [3110] = {.lex_state = 0, .external_lex_state = 4},
  [3111] = {.lex_state = 0},
  [3112] = {.lex_state = 97, .external_lex_state = 5},
  [3113] = {.lex_state = 0, .external_lex_state = 4},
  [3114] = {.lex_state = 0, .external_lex_state = 4},
  [3115] = {.lex_state = 13},
  [3116] = {.lex_state = 0, .external_lex_state = 4},
  [3117] = {.lex_state = 0, .external_lex_state = 4},
  [3118] = {.lex_state = 97},
  [3119] = {.lex_state = 13},
  [3120] = {.lex_state = 13},
  [3121] = {.lex_state = 0, .external_lex_state = 4},
  [3122] = {.lex_state = 13},
  [3123] = {.lex_state = 0, .external_lex_state = 4},
  [3124] = {.lex_state = 0, .external_lex_state = 4},
  [3125] = {.lex_state = 0, .external_lex_state = 4},
  [3126] = {.lex_state = 0, .external_lex_state = 4},
  [3127] = {.lex_state = 0, .external_lex_state = 4},
  [3128] = {.lex_state = 0, .external_lex_state = 4},
  [3129] = {.lex_state = 0, .external_lex_state = 4},
  [3130] = {.lex_state = 0, .external_lex_state = 4},
  [3131] = {.lex_state = 0},
  [3132] = {.lex_state = 0},
  [3133] = {.lex_state = 97, .external_lex_state = 5},
  [3134] = {.lex_state = 0, .external_lex_state = 4},
  [3135] = {.lex_state = 0, .external_lex_state = 4},
  [3136] = {.lex_state = 97, .external_lex_state = 4},
  [3137] = {.lex_state = 97, .external_lex_state = 4},
  [3138] = {.lex_state = 0, .external_lex_state = 4},
  [3139] = {.lex_state = 0, .external_lex_state = 4},
  [3140] = {.lex_state = 0, .external_lex_state = 4},
  [3141] = {.lex_state = 0, .external_lex_state = 4},
  [3142] = {.lex_state = 97},
  [3143] = {.lex_state = 0, .external_lex_state = 4},
  [3144] = {.lex_state = 97},
  [3145] = {.lex_state = 97},
  [3146] = {.lex_state = 0, .external_lex_state = 4},
  [3147] = {.lex_state = 97},
  [3148] = {.lex_state = 0},
  [3149] = {.lex_state = 13},
  [3150] = {.lex_state = 0, .external_lex_state = 4},
  [3151] = {.lex_state = 0, .external_lex_state = 4},
  [3152] = {.lex_state = 0, .external_lex_state = 4},
  [3153] = {.lex_state = 0, .external_lex_state = 4},
  [3154] = {.lex_state = 97},
  [3155] = {.lex_state = 0, .external_lex_state = 4},
  [3156] = {.lex_state = 0, .external_lex_state = 4},
  [3157] = {.lex_state = 0, .external_lex_state = 4},
  [3158] = {.lex_state = 0, .external_lex_state = 4},
  [3159] = {.lex_state = 0, .external_lex_state = 4},
  [3160] = {.lex_state = 0, .external_lex_state = 4},
  [3161] = {.lex_state = 0, .external_lex_state = 4},
  [3162] = {.lex_state = 97},
  [3163] = {.lex_state = 97, .external_lex_state = 5},
  [3164] = {.lex_state = 0, .external_lex_state = 4},
  [3165] = {.lex_state = 0, .external_lex_state = 4},
  [3166] = {.lex_state = 0, .external_lex_state = 4},
  [3167] = {.lex_state = 97, .external_lex_state = 4},
  [3168] = {.lex_state = 0, .external_lex_state = 4},
  [3169] = {.lex_state = 0, .external_lex_state = 4},
  [3170] = {.lex_state = 13},
  [3171] = {.lex_state = 0, .external_lex_state = 4},
  [3172] = {.lex_state = 0, .external_lex_state = 4},
  [3173] = {.lex_state = 0, .external_lex_state = 4},
  [3174] = {.lex_state = 13},
  [3175] = {.lex_state = 0, .external_lex_state = 4},
  [3176] = {.lex_state = 13},
  [3177] = {.lex_state = 0, .external_lex_state = 4},
  [3178] = {.lex_state = 18, .external_lex_state = 6},
  [3179] = {.lex_state = 0, .external_lex_state = 4},
  [3180] = {.lex_state = 13},
  [3181] = {.lex_state = 0, .external_lex_state = 4},
  [3182] = {.lex_state = 13},
  [3183] = {.lex_state = 0, .external_lex_state = 4},
  [3184] = {.lex_state = 97},
  [3185] = {.lex_state = 13},
  [3186] = {.lex_state = 97},
  [3187] = {.lex_state = 97},
  [3188] = {.lex_state = 0, .external_lex_state = 4},
  [3189] = {.lex_state = 0},
  [3190] = {.lex_state = 0, .external_lex_state = 4},
  [3191] = {.lex_state = 0, .external_lex_state = 4},
  [3192] = {.lex_state = 97, .external_lex_state = 5},
  [3193] = {.lex_state = 0, .external_lex_state = 4},
  [3194] = {.lex_state = 0, .external_lex_state = 4},
  [3195] = {.lex_state = 0, .external_lex_state = 4},
  [3196] = {.lex_state = 0, .external_lex_state = 4},
  [3197] = {.lex_state = 0, .external_lex_state = 4},
  [3198] = {.lex_state = 0, .external_lex_state = 4},
  [3199] = {.lex_state = 97, .external_lex_state = 5},
  [3200] = {.lex_state = 0, .external_lex_state = 4},
  [3201] = {.lex_state = 0, .external_lex_state = 4},
  [3202] = {.lex_state = 0, .external_lex_state = 4},
  [3203] = {.lex_state = 4},
  [3204] = {.lex_state = 0},
  [3205] = {.lex_state = 13},
  [3206] = {.lex_state = 0, .external_lex_state = 4},
  [3207] = {.lex_state = 0, .external_lex_state = 4},
  [3208] = {.lex_state = 0, .external_lex_state = 4},
  [3209] = {.lex_state = 97},
  [3210] = {.lex_state = 0, .external_lex_state = 4},
  [3211] = {.lex_state = 13},
  [3212] = {.lex_state = 0, .external_lex_state = 4},
  [3213] = {.lex_state = 13},
  [3214] = {.lex_state = 0},
  [3215] = {.lex_state = 0, .external_lex_state = 4},
  [3216] = {.lex_state = 0},
  [3217] = {.lex_state = 97},
  [3218] = {.lex_state = 0, .external_lex_state = 4},
  [3219] = {.lex_state = 97},
  [3220] = {.lex_state = 0, .external_lex_state = 4},
  [3221] = {.lex_state = 13},
  [3222] = {.lex_state = 0, .external_lex_state = 4},
  [3223] = {.lex_state = 0, .external_lex_state = 4},
  [3224] = {.lex_state = 0, .external_lex_state = 4},
  [3225] = {.lex_state = 0, .external_lex_state = 4},
  [3226] = {.lex_state = 0, .external_lex_state = 4},
  [3227] = {.lex_state = 0, .external_lex_state = 4},
  [3228] = {.lex_state = 97, .external_lex_state = 4},
  [3229] = {.lex_state = 0, .external_lex_state = 4},
  [3230] = {.lex_state = 97, .external_lex_state = 5},
  [3231] = {.lex_state = 0, .external_lex_state = 4},
  [3232] = {.lex_state = 0, .external_lex_state = 4},
  [3233] = {.lex_state = 13},
  [3234] = {.lex_state = 13},
  [3235] = {.lex_state = 0, .external_lex_state = 4},
  [3236] = {.lex_state = 13},
  [3237] = {.lex_state = 13},
  [3238] = {.lex_state = 18, .external_lex_state = 6},
  [3239] = {.lex_state = 13},
  [3240] = {.lex_state = 0, .external_lex_state = 4},
  [3241] = {.lex_state = 13},
  [3242] = {.lex_state = 0, .external_lex_state = 4},
  [3243] = {.lex_state = 97},
  [3244] = {.lex_state = 97},
  [3245] = {.lex_state = 0, .external_lex_state = 4},
  [3246] = {.lex_state = 0, .external_lex_state = 4},
  [3247] = {.lex_state = 97, .external_lex_state = 5},
  [3248] = {.lex_state = 0, .external_lex_state = 4},
  [3249] = {.lex_state = 0, .external_lex_state = 4},
  [3250] = {.lex_state = 13},
  [3251] = {.lex_state = 0},
  [3252] = {.lex_state = 0, .external_lex_state = 4},
  [3253] = {.lex_state = 0, .external_lex_state = 4},
  [3254] = {.lex_state = 0, .external_lex_state = 4},
  [3255] = {.lex_state = 0, .external_lex_state = 4},
  [3256] = {.lex_state = 97},
  [3257] = {.lex_state = 97},
  [3258] = {.lex_state = 97},
  [3259] = {.lex_state = 0, .external_lex_state = 4},
  [3260] = {.lex_state = 13},
  [3261] = {.lex_state = 0, .external_lex_state = 4},
  [3262] = {.lex_state = 97},
  [3263] = {.lex_state = 13},
  [3264] = {.lex_state = 13},
  [3265] = {.lex_state = 0, .external_lex_state = 4},
  [3266] = {.lex_state = 13},
  [3267] = {.lex_state = 13},
  [3268] = {.lex_state = 97},
  [3269] = {.lex_state = 0, .external_lex_state = 4},
  [3270] = {.lex_state = 0, .external_lex_state = 4},
  [3271] = {.lex_state = 0, .external_lex_state = 4},
  [3272] = {.lex_state = 13},
  [3273] = {.lex_state = 97, .external_lex_state = 5},
  [3274] = {.lex_state = 0, .external_lex_state = 4},
  [3275] = {.lex_state = 0, .external_lex_state = 4},
  [3276] = {.lex_state = 13},
  [3277] = {.lex_state = 0, .external_lex_state = 4},
  [3278] = {.lex_state = 13},
  [3279] = {.lex_state = 0, .external_lex_state = 4},
  [3280] = {.lex_state = 0, .external_lex_state = 4},
  [3281] = {.lex_state = 13},
  [3282] = {.lex_state = 13},
  [3283] = {.lex_state = 13},
  [3284] = {.lex_state = 0, .external_lex_state = 4},
  [3285] = {.lex_state = 13},
  [3286] = {.lex_state = 0, .external_lex_state = 4},
  [3287] = {.lex_state = 0, .external_lex_state = 4},
  [3288] = {.lex_state = 18, .external_lex_state = 6},
  [3289] = {.lex_state = 0, .external_lex_state = 4},
  [3290] = {.lex_state = 0, .external_lex_state = 4},
  [3291] = {.lex_state = 0, .external_lex_state = 4},
  [3292] = {.lex_state = 0, .external_lex_state = 4},
  [3293] = {.lex_state = 0, .external_lex_state = 4},
  [3294] = {.lex_state = 97, .external_lex_state = 4},
  [3295] = {.lex_state = 13},
  [3296] = {.lex_state = 0, .external_lex_state = 4},
  [3297] = {.lex_state = 97, .external_lex_state = 5},
  [3298] = {.lex_state = 13},
  [3299] = {.lex_state = 0, .external_lex_state = 4},
  [3300] = {.lex_state = 13},
  [3301] = {.lex_state = 0, .external_lex_state = 4},
  [3302] = {.lex_state = 0, .external_lex_state = 4},
  [3303] = {.lex_state = 13},
  [3304] = {.lex_state = 97},
  [3305] = {.lex_state = 18, .external_lex_state = 6},
  [3306] = {.lex_state = 0, .external_lex_state = 4},
  [3307] = {.lex_state = 97, .external_lex_state = 4},
  [3308] = {.lex_state = 0, .external_lex_state = 4},
  [3309] = {.lex_state = 0, .external_lex_state = 4},
  [3310] = {.lex_state = 0, .external_lex_state = 4},
  [3311] = {.lex_state = 0},
  [3312] = {.lex_state = 18, .external_lex_state = 6},
  [3313] = {.lex_state = 4},
  [3314] = {.lex_state = 13},
  [3315] = {.lex_state = 0, .external_lex_state = 4},
  [3316] = {.lex_state = 97},
  [3317] = {.lex_state = 18, .external_lex_state = 6},
  [3318] = {.lex_state = 0},
  [3319] = {.lex_state = 13},
  [3320] = {.lex_state = 0, .external_lex_state = 4},
  [3321] = {.lex_state = 13},
  [3322] = {.lex_state = 0, .external_lex_state = 4},
  [3323] = {.lex_state = 18, .external_lex_state = 6},
  [3324] = {.lex_state = 0, .external_lex_state = 4},
  [3325] = {.lex_state = 97, .external_lex_state = 5},
  [3326] = {.lex_state = 0, .external_lex_state = 4},
  [3327] = {.lex_state = 13},
  [3328] = {.lex_state = 13},
  [3329] = {.lex_state = 97, .external_lex_state = 5},
  [3330] = {.lex_state = 97},
  [3331] = {.lex_state = 18, .external_lex_state = 6},
  [3332] = {.lex_state = 97},
  [3333] = {.lex_state = 97},
  [3334] = {.lex_state = 0, .external_lex_state = 4},
  [3335] = {.lex_state = 0, .external_lex_state = 4},
  [3336] = {.lex_state = 0},
  [3337] = {.lex_state = 13},
  [3338] = {.lex_state = 13},
  [3339] = {.lex_state = 13},
  [3340] = {.lex_state = 0, .external_lex_state = 4},
  [3341] = {.lex_state = 18, .external_lex_state = 6},
  [3342] = {.lex_state = 13},
  [3343] = {.lex_state = 0},
  [3344] = {.lex_state = 0, .external_lex_state = 4},
  [3345] = {.lex_state = 13},
  [3346] = {.lex_state = 97},
  [3347] = {.lex_state = 0, .external_lex_state = 4},
  [3348] = {.lex_state = 13},
  [3349] = {.lex_state = 0, .external_lex_state = 4},
  [3350] = {.lex_state = 0, .external_lex_state = 4},
  [3351] = {.lex_state = 0, .external_lex_state = 4},
  [3352] = {.lex_state = 18, .external_lex_state = 6},
  [3353] = {.lex_state = 0, .external_lex_state = 4},
  [3354] = {.lex_state = 0, .external_lex_state = 4},
  [3355] = {.lex_state = 0, .external_lex_state = 4},
  [3356] = {.lex_state = 97, .external_lex_state = 5},
  [3357] = {.lex_state = 97},
  [3358] = {.lex_state = 97},
  [3359] = {.lex_state = 13},
  [3360] = {.lex_state = 18, .external_lex_state = 6},
  [3361] = {.lex_state = 13},
  [3362] = {.lex_state = 0, .external_lex_state = 4},
  [3363] = {.lex_state = 0, .external_lex_state = 4},
  [3364] = {.lex_state = 13},
  [3365] = {.lex_state = 13},
  [3366] = {.lex_state = 97},
  [3367] = {.lex_state = 13},
  [3368] = {.lex_state = 0, .external_lex_state = 4},
  [3369] = {.lex_state = 0, .external_lex_state = 4},
  [3370] = {.lex_state = 97},
  [3371] = {.lex_state = 0},
  [3372] = {.lex_state = 97},
  [3373] = {.lex_state = 17},
  [3374] = {.lex_state = 21},
  [3375] = {.lex_state = 97},
  [3376] = {.lex_state = 1},
  [3377] = {.lex_state = 97},
  [3378] = {.lex_state = 97},
  [3379] = {.lex_state = 97},
  [3380] = {.lex_state = 97, .external_lex_state = 4},
  [3381] = {.lex_state = 97},
  [3382] = {.lex_state = 0, .external_lex_state = 4},
  [3383] = {.lex_state = 0, .external_lex_state = 4},
  [3384] = {.lex_state = 0},
  [3385] = {.lex_state = 13},
  [3386] = {.lex_state = 0},
  [3387] = {.lex_state = 0, .external_lex_state = 4},
  [3388] = {.lex_state = 17},
  [3389] = {.lex_state = 21},
  [3390] = {.lex_state = 97},
  [3391] = {.lex_state = 0, .external_lex_state = 4},
  [3392] = {.lex_state = 1},
  [3393] = {.lex_state = 97, .external_lex_state = 4},
  [3394] = {.lex_state = 97},
  [3395] = {.lex_state = 97},
  [3396] = {.lex_state = 13},
  [3397] = {.lex_state = 13},
  [3398] = {.lex_state = 17},
  [3399] = {.lex_state = 21},
  [3400] = {.lex_state = 97},
  [3401] = {.lex_state = 97, .external_lex_state = 4},
  [3402] = {.lex_state = 97},
  [3403] = {.lex_state = 13},
  [3404] = {.lex_state = 97},
  [3405] = {.lex_state = 13},
  [3406] = {.lex_state = 0, .external_lex_state = 4},
  [3407] = {.lex_state = 0, .external_lex_state = 4},
  [3408] = {.lex_state = 1},
  [3409] = {.lex_state = 0},
  [3410] = {.lex_state = 0},
  [3411] = {.lex_state = 0, .external_lex_state = 5},
  [3412] = {.lex_state = 97},
  [3413] = {.lex_state = 13},
  [3414] = {.lex_state = 21},
  [3415] = {.lex_state = 17},
  [3416] = {.lex_state = 13},
  [3417] = {.lex_state = 13},
  [3418] = {.lex_state = 97},
  [3419] = {.lex_state = 13},
  [3420] = {.lex_state = 97},
  [3421] = {.lex_state = 97},
  [3422] = {.lex_state = 13},
  [3423] = {.lex_state = 97},
  [3424] = {.lex_state = 97},
  [3425] = {.lex_state = 17},
  [3426] = {.lex_state = 21},
  [3427] = {.lex_state = 97},
  [3428] = {.lex_state = 13},
  [3429] = {.lex_state = 13},
  [3430] = {.lex_state = 0, .external_lex_state = 4},
  [3431] = {.lex_state = 0, .external_lex_state = 4},
  [3432] = {.lex_state = 0, .external_lex_state = 4},
  [3433] = {.lex_state = 97},
  [3434] = {.lex_state = 97},
  [3435] = {.lex_state = 13},
  [3436] = {.lex_state = 13},
  [3437] = {.lex_state = 0},
  [3438] = {.lex_state = 97, .external_lex_state = 4},
  [3439] = {.lex_state = 97},
  [3440] = {.lex_state = 97},
  [3441] = {.lex_state = 13},
  [3442] = {.lex_state = 17},
  [3443] = {.lex_state = 21},
  [3444] = {.lex_state = 97},
  [3445] = {.lex_state = 13},
  [3446] = {.lex_state = 97},
  [3447] = {.lex_state = 18, .external_lex_state = 6},
  [3448] = {.lex_state = 97},
  [3449] = {.lex_state = 97},
  [3450] = {.lex_state = 97},
  [3451] = {.lex_state = 97},
  [3452] = {.lex_state = 97},
  [3453] = {.lex_state = 97},
  [3454] = {.lex_state = 18, .external_lex_state = 6},
  [3455] = {.lex_state = 0},
  [3456] = {.lex_state = 97},
  [3457] = {.lex_state = 97},
  [3458] = {.lex_state = 97},
  [3459] = {.lex_state = 13},
  [3460] = {.lex_state = 17},
  [3461] = {.lex_state = 21},
  [3462] = {.lex_state = 97},
  [3463] = {.lex_state = 13},
  [3464] = {.lex_state = 97},
  [3465] = {.lex_state = 0},
  [3466] = {.lex_state = 13},
  [3467] = {.lex_state = 97},
  [3468] = {.lex_state = 13},
  [3469] = {.lex_state = 97},
  [3470] = {.lex_state = 0},
  [3471] = {.lex_state = 0},
  [3472] = {.lex_state = 0},
  [3473] = {.lex_state = 97},
  [3474] = {.lex_state = 97},
  [3475] = {.lex_state = 97},
  [3476] = {.lex_state = 21},
  [3477] = {.lex_state = 17},
  [3478] = {.lex_state = 21},
  [3479] = {.lex_state = 17},
  [3480] = {.lex_state = 97},
  [3481] = {.lex_state = 1},
  [3482] = {.lex_state = 13},
  [3483] = {.lex_state = 21},
  [3484] = {.lex_state = 17},
  [3485] = {.lex_state = 21},
  [3486] = {.lex_state = 17},
  [3487] = {.lex_state = 97},
  [3488] = {.lex_state = 97},
  [3489] = {.lex_state = 17},
  [3490] = {.lex_state = 21},
  [3491] = {.lex_state = 97},
  [3492] = {.lex_state = 21},
  [3493] = {.lex_state = 13},
  [3494] = {.lex_state = 21},
  [3495] = {.lex_state = 17},
  [3496] = {.lex_state = 21},
  [3497] = {.lex_state = 17},
  [3498] = {.lex_state = 97},
  [3499] = {.lex_state = 17},
  [3500] = {.lex_state = 97},
  [3501] = {.lex_state = 0},
  [3502] = {.lex_state = 0},
  [3503] = {.lex_state = 0},
  [3504] = {.lex_state = 0},
  [3505] = {.lex_state = 0, .external_lex_state = 4},
  [3506] = {.lex_state = 0},
  [3507] = {.lex_state = 0},
  [3508] = {.lex_state = 0},
  [3509] = {.lex_state = 97},
  [3510] = {.lex_state = 0},
  [3511] = {.lex_state = 97},
  [3512] = {.lex_state = 0},
  [3513] = {.lex_state = 97, .external_lex_state = 4},
  [3514] = {.lex_state = 97, .external_lex_state = 4},
  [3515] = {.lex_state = 0},
  [3516] = {.lex_state = 0},
  [3517] = {.lex_state = 0, .external_lex_state = 4},
  [3518] = {.lex_state = 0},
  [3519] = {.lex_state = 0},
  [3520] = {.lex_state = 97},
  [3521] = {.lex_state = 0},
  [3522] = {.lex_state = 0, .external_lex_state = 4},
  [3523] = {.lex_state = 0},
  [3524] = {.lex_state = 97},
  [3525] = {.lex_state = 97},
  [3526] = {.lex_state = 97},
  [3527] = {.lex_state = 97},
  [3528] = {.lex_state = 97},
  [3529] = {.lex_state = 0},
  [3530] = {.lex_state = 0},
  [3531] = {.lex_state = 0, .external_lex_state = 4},
  [3532] = {.lex_state = 0, .external_lex_state = 4},
  [3533] = {.lex_state = 0},
  [3534] = {.lex_state = 0, .external_lex_state = 4},
  [3535] = {.lex_state = 0, .external_lex_state = 4},
  [3536] = {.lex_state = 0, .external_lex_state = 4},
  [3537] = {.lex_state = 0, .external_lex_state = 4},
  [3538] = {.lex_state = 0, .external_lex_state = 4},
  [3539] = {.lex_state = 0},
  [3540] = {.lex_state = 13},
  [3541] = {.lex_state = 0},
  [3542] = {.lex_state = 0},
  [3543] = {.lex_state = 0},
  [3544] = {.lex_state = 0},
  [3545] = {.lex_state = 97},
  [3546] = {.lex_state = 97},
  [3547] = {.lex_state = 97},
  [3548] = {.lex_state = 0},
  [3549] = {.lex_state = 0, .external_lex_state = 4},
  [3550] = {.lex_state = 0, .external_lex_state = 4},
  [3551] = {.lex_state = 0, .external_lex_state = 4},
  [3552] = {.lex_state = 97},
  [3553] = {.lex_state = 97, .external_lex_state = 4},
  [3554] = {.lex_state = 0},
  [3555] = {.lex_state = 97},
  [3556] = {.lex_state = 0, .external_lex_state = 4},
  [3557] = {.lex_state = 97},
  [3558] = {.lex_state = 97},
  [3559] = {.lex_state = 0},
  [3560] = {.lex_state = 97},
  [3561] = {.lex_state = 97},
  [3562] = {.lex_state = 97},
  [3563] = {.lex_state = 0},
  [3564] = {.lex_state = 0, .external_lex_state = 4},
  [3565] = {.lex_state = 1},
  [3566] = {.lex_state = 0, .external_lex_state = 4},
  [3567] = {.lex_state = 97},
  [3568] = {.lex_state = 97},
  [3569] = {.lex_state = 0},
  [3570] = {.lex_state = 0, .external_lex_state = 4},
  [3571] = {.lex_state = 0, .external_lex_state = 4},
  [3572] = {.lex_state = 0},
  [3573] = {.lex_state = 97},
  [3574] = {.lex_state = 0},
  [3575] = {.lex_state = 0, .external_lex_state = 4},
  [3576] = {.lex_state = 97},
  [3577] = {.lex_state = 0},
  [3578] = {.lex_state = 0},
  [3579] = {.lex_state = 0, .external_lex_state = 4},
  [3580] = {.lex_state = 0},
  [3581] = {.lex_state = 0},
  [3582] = {.lex_state = 97},
  [3583] = {.lex_state = 97},
  [3584] = {.lex_state = 0},
  [3585] = {.lex_state = 0, .external_lex_state = 4},
  [3586] = {.lex_state = 97},
  [3587] = {.lex_state = 97},
  [3588] = {.lex_state = 0},
  [3589] = {.lex_state = 97},
  [3590] = {.lex_state = 0},
  [3591] = {.lex_state = 97},
  [3592] = {.lex_state = 0},
  [3593] = {.lex_state = 97},
  [3594] = {.lex_state = 0, .external_lex_state = 4},
  [3595] = {.lex_state = 0},
  [3596] = {.lex_state = 0},
  [3597] = {.lex_state = 97},
  [3598] = {.lex_state = 0, .external_lex_state = 4},
  [3599] = {.lex_state = 0},
  [3600] = {.lex_state = 0},
  [3601] = {.lex_state = 0},
  [3602] = {.lex_state = 0},
  [3603] = {.lex_state = 0, .external_lex_state = 4},
  [3604] = {.lex_state = 97},
  [3605] = {.lex_state = 0},
  [3606] = {.lex_state = 0},
  [3607] = {.lex_state = 97},
  [3608] = {.lex_state = 4},
  [3609] = {.lex_state = 97},
  [3610] = {.lex_state = 0},
  [3611] = {.lex_state = 97},
  [3612] = {.lex_state = 0, .external_lex_state = 4},
  [3613] = {.lex_state = 0},
  [3614] = {.lex_state = 0, .external_lex_state = 4},
  [3615] = {.lex_state = 0, .external_lex_state = 4},
  [3616] = {.lex_state = 0, .external_lex_state = 4},
  [3617] = {.lex_state = 0},
  [3618] = {.lex_state = 0, .external_lex_state = 4},
  [3619] = {.lex_state = 97},
  [3620] = {.lex_state = 97},
  [3621] = {.lex_state = 97},
  [3622] = {.lex_state = 0, .external_lex_state = 4},
  [3623] = {.lex_state = 97},
  [3624] = {.lex_state = 0},
  [3625] = {.lex_state = 0},
  [3626] = {.lex_state = 0},
  [3627] = {.lex_state = 0},
  [3628] = {.lex_state = 0, .external_lex_state = 4},
  [3629] = {.lex_state = 0},
  [3630] = {.lex_state = 0},
  [3631] = {.lex_state = 0, .external_lex_state = 4},
  [3632] = {.lex_state = 0},
  [3633] = {.lex_state = 0, .external_lex_state = 4},
  [3634] = {.lex_state = 0, .external_lex_state = 4},
  [3635] = {.lex_state = 0, .external_lex_state = 4},
  [3636] = {.lex_state = 0},
  [3637] = {.lex_state = 0},
  [3638] = {.lex_state = 0, .external_lex_state = 4},
  [3639] = {.lex_state = 0, .external_lex_state = 4},
  [3640] = {.lex_state = 97},
  [3641] = {.lex_state = 0, .external_lex_state = 4},
  [3642] = {.lex_state = 0},
  [3643] = {.lex_state = 0, .external_lex_state = 4},
  [3644] = {.lex_state = 0, .external_lex_state = 4},
  [3645] = {.lex_state = 0},
  [3646] = {.lex_state = 97, .external_lex_state = 4},
  [3647] = {.lex_state = 0},
  [3648] = {.lex_state = 0, .external_lex_state = 4},
  [3649] = {.lex_state = 97},
  [3650] = {.lex_state = 0},
  [3651] = {.lex_state = 0},
  [3652] = {.lex_state = 0},
  [3653] = {.lex_state = 97},
  [3654] = {.lex_state = 97},
  [3655] = {.lex_state = 97, .external_lex_state = 4},
  [3656] = {.lex_state = 0},
  [3657] = {.lex_state = 0},
  [3658] = {.lex_state = 4},
  [3659] = {.lex_state = 97},
  [3660] = {.lex_state = 0},
  [3661] = {.lex_state = 0},
  [3662] = {.lex_state = 97},
  [3663] = {.lex_state = 0},
  [3664] = {.lex_state = 0, .external_lex_state = 4},
  [3665] = {.lex_state = 0, .external_lex_state = 4},
  [3666] = {.lex_state = 0},
  [3667] = {.lex_state = 0},
  [3668] = {.lex_state = 0},
  [3669] = {.lex_state = 0},
  [3670] = {.lex_state = 97},
  [3671] = {.lex_state = 0},
  [3672] = {.lex_state = 0},
  [3673] = {.lex_state = 0},
  [3674] = {.lex_state = 0},
  [3675] = {.lex_state = 0},
  [3676] = {.lex_state = 97},
  [3677] = {.lex_state = 0},
  [3678] = {.lex_state = 97},
  [3679] = {.lex_state = 0},
  [3680] = {.lex_state = 0},
  [3681] = {.lex_state = 0},
  [3682] = {.lex_state = 97},
  [3683] = {.lex_state = 0},
  [3684] = {.lex_state = 0, .external_lex_state = 4},
  [3685] = {.lex_state = 97},
  [3686] = {.lex_state = 0},
  [3687] = {.lex_state = 97},
  [3688] = {.lex_state = 0},
  [3689] = {.lex_state = 0},
  [3690] = {.lex_state = 97},
  [3691] = {.lex_state = 0},
  [3692] = {.lex_state = 97},
  [3693] = {.lex_state = 0, .external_lex_state = 4},
  [3694] = {.lex_state = 0, .external_lex_state = 4},
  [3695] = {.lex_state = 0, .external_lex_state = 4},
  [3696] = {.lex_state = 0, .external_lex_state = 4},
  [3697] = {.lex_state = 0, .external_lex_state = 4},
  [3698] = {.lex_state = 0, .external_lex_state = 4},
  [3699] = {.lex_state = 0},
  [3700] = {.lex_state = 97, .external_lex_state = 4},
  [3701] = {.lex_state = 0},
  [3702] = {.lex_state = 0, .external_lex_state = 4},
  [3703] = {.lex_state = 0, .external_lex_state = 4},
  [3704] = {.lex_state = 97},
  [3705] = {.lex_state = 97},
  [3706] = {.lex_state = 97},
  [3707] = {.lex_state = 97},
  [3708] = {.lex_state = 97},
  [3709] = {.lex_state = 0},
  [3710] = {.lex_state = 0},
  [3711] = {.lex_state = 0},
  [3712] = {.lex_state = 0},
  [3713] = {.lex_state = 0},
  [3714] = {.lex_state = 97},
  [3715] = {.lex_state = 97},
  [3716] = {.lex_state = 0},
  [3717] = {.lex_state = 97},
  [3718] = {.lex_state = 0},
  [3719] = {.lex_state = 97},
  [3720] = {.lex_state = 97},
  [3721] = {.lex_state = 4},
  [3722] = {.lex_state = 97},
  [3723] = {.lex_state = 0, .external_lex_state = 4},
  [3724] = {.lex_state = 0},
  [3725] = {.lex_state = 97},
  [3726] = {.lex_state = 0},
  [3727] = {.lex_state = 18, .external_lex_state = 6},
  [3728] = {.lex_state = 0},
  [3729] = {.lex_state = 97},
  [3730] = {.lex_state = 13},
  [3731] = {.lex_state = 97},
  [3732] = {.lex_state = 0, .external_lex_state = 4},
  [3733] = {.lex_state = 0, .external_lex_state = 4},
  [3734] = {.lex_state = 97},
  [3735] = {.lex_state = 0},
  [3736] = {.lex_state = 97},
  [3737] = {.lex_state = 0},
  [3738] = {.lex_state = 0},
  [3739] = {.lex_state = 97},
  [3740] = {.lex_state = 0},
  [3741] = {.lex_state = 0},
  [3742] = {.lex_state = 97},
  [3743] = {.lex_state = 97},
  [3744] = {.lex_state = 0},
  [3745] = {.lex_state = 97},
  [3746] = {.lex_state = 0},
  [3747] = {.lex_state = 97},
  [3748] = {.lex_state = 97},
  [3749] = {.lex_state = 97},
  [3750] = {.lex_state = 0, .external_lex_state = 4},
  [3751] = {.lex_state = 97},
  [3752] = {.lex_state = 0},
  [3753] = {.lex_state = 0},
  [3754] = {.lex_state = 97},
  [3755] = {.lex_state = 97},
  [3756] = {.lex_state = 0},
  [3757] = {.lex_state = 97},
  [3758] = {.lex_state = 0},
  [3759] = {.lex_state = 0, .external_lex_state = 4},
  [3760] = {.lex_state = 0},
  [3761] = {.lex_state = 0},
  [3762] = {.lex_state = 97},
  [3763] = {.lex_state = 0},
  [3764] = {.lex_state = 97},
  [3765] = {.lex_state = 97},
  [3766] = {.lex_state = 97},
  [3767] = {.lex_state = 0},
  [3768] = {.lex_state = 97},
  [3769] = {.lex_state = 97},
  [3770] = {.lex_state = 0, .external_lex_state = 4},
  [3771] = {.lex_state = 0, .external_lex_state = 4},
  [3772] = {.lex_state = 0},
  [3773] = {.lex_state = 97},
  [3774] = {.lex_state = 97},
  [3775] = {.lex_state = 97},
  [3776] = {.lex_state = 97},
  [3777] = {.lex_state = 0},
  [3778] = {.lex_state = 97},
  [3779] = {.lex_state = 97},
  [3780] = {.lex_state = 97},
  [3781] = {.lex_state = 0},
  [3782] = {.lex_state = 97},
  [3783] = {.lex_state = 0},
  [3784] = {.lex_state = 0},
  [3785] = {.lex_state = 97},
  [3786] = {.lex_state = 0},
  [3787] = {.lex_state = 97},
  [3788] = {.lex_state = 97},
  [3789] = {.lex_state = 0},
  [3790] = {.lex_state = 97},
  [3791] = {.lex_state = 97},
  [3792] = {.lex_state = 0},
  [3793] = {.lex_state = 97},
  [3794] = {.lex_state = 97},
  [3795] = {.lex_state = 0},
  [3796] = {.lex_state = 0},
  [3797] = {.lex_state = 97},
  [3798] = {.lex_state = 0},
  [3799] = {.lex_state = 97},
  [3800] = {.lex_state = 97},
  [3801] = {.lex_state = 97},
  [3802] = {.lex_state = 97},
  [3803] = {.lex_state = 97},
  [3804] = {.lex_state = 0},
  [3805] = {.lex_state = 97},
  [3806] = {.lex_state = 97},
  [3807] = {.lex_state = 97},
  [3808] = {.lex_state = 0},
  [3809] = {.lex_state = 0},
  [3810] = {.lex_state = 97},
  [3811] = {.lex_state = 0},
  [3812] = {.lex_state = 97},
  [3813] = {.lex_state = 0, .external_lex_state = 4},
  [3814] = {.lex_state = 0, .external_lex_state = 4},
  [3815] = {.lex_state = 0},
  [3816] = {.lex_state = 97},
  [3817] = {.lex_state = 0},
  [3818] = {.lex_state = 97},
  [3819] = {.lex_state = 0},
  [3820] = {.lex_state = 97},
  [3821] = {.lex_state = 97},
  [3822] = {.lex_state = 97},
  [3823] = {.lex_state = 97},
  [3824] = {.lex_state = 0},
  [3825] = {.lex_state = 97},
  [3826] = {.lex_state = 97},
  [3827] = {.lex_state = 97},
  [3828] = {.lex_state = 0},
  [3829] = {.lex_state = 97},
  [3830] = {.lex_state = 97},
  [3831] = {.lex_state = 97},
  [3832] = {.lex_state = 0},
  [3833] = {.lex_state = 97},
  [3834] = {.lex_state = 0},
  [3835] = {.lex_state = 0},
  [3836] = {.lex_state = 97},
  [3837] = {.lex_state = 97},
  [3838] = {.lex_state = 97},
  [3839] = {.lex_state = 97},
  [3840] = {.lex_state = 97},
  [3841] = {.lex_state = 97},
  [3842] = {.lex_state = 97},
  [3843] = {.lex_state = 97},
  [3844] = {.lex_state = 0},
  [3845] = {.lex_state = 0},
  [3846] = {.lex_state = 97},
  [3847] = {.lex_state = 0},
  [3848] = {.lex_state = 0},
  [3849] = {.lex_state = 0, .external_lex_state = 4},
  [3850] = {.lex_state = 97},
  [3851] = {.lex_state = 97},
  [3852] = {.lex_state = 97},
  [3853] = {.lex_state = 97},
  [3854] = {.lex_state = 97},
  [3855] = {.lex_state = 97},
  [3856] = {.lex_state = 97},
  [3857] = {.lex_state = 97},
  [3858] = {.lex_state = 97},
  [3859] = {.lex_state = 0},
  [3860] = {.lex_state = 0, .external_lex_state = 4},
  [3861] = {.lex_state = 0},
  [3862] = {.lex_state = 97},
  [3863] = {.lex_state = 97},
  [3864] = {.lex_state = 0},
  [3865] = {.lex_state = 97},
  [3866] = {.lex_state = 97},
  [3867] = {.lex_state = 0},
  [3868] = {.lex_state = 97},
  [3869] = {.lex_state = 97},
  [3870] = {.lex_state = 0, .external_lex_state = 4},
  [3871] = {.lex_state = 0},
  [3872] = {.lex_state = 0, .external_lex_state = 4},
  [3873] = {.lex_state = 97},
  [3874] = {.lex_state = 97},
  [3875] = {.lex_state = 97},
  [3876] = {.lex_state = 97},
  [3877] = {.lex_state = 0},
  [3878] = {.lex_state = 97},
  [3879] = {.lex_state = 0, .external_lex_state = 4},
  [3880] = {.lex_state = 97},
  [3881] = {.lex_state = 97},
  [3882] = {.lex_state = 0, .external_lex_state = 4},
  [3883] = {.lex_state = 97},
  [3884] = {.lex_state = 0},
  [3885] = {.lex_state = 0},
  [3886] = {.lex_state = 97},
  [3887] = {.lex_state = 0},
  [3888] = {.lex_state = 97},
  [3889] = {.lex_state = 0},
  [3890] = {.lex_state = 97},
  [3891] = {.lex_state = 0},
  [3892] = {.lex_state = 97},
  [3893] = {.lex_state = 0},
  [3894] = {.lex_state = 0},
  [3895] = {.lex_state = 0},
  [3896] = {.lex_state = 0},
  [3897] = {.lex_state = 97},
  [3898] = {.lex_state = 0},
  [3899] = {.lex_state = 97},
  [3900] = {.lex_state = 0},
  [3901] = {.lex_state = 97},
  [3902] = {.lex_state = 0},
  [3903] = {.lex_state = 97},
  [3904] = {.lex_state = 97},
  [3905] = {.lex_state = 97},
  [3906] = {.lex_state = 97},
  [3907] = {.lex_state = 97},
  [3908] = {.lex_state = 97},
  [3909] = {.lex_state = 0, .external_lex_state = 4},
  [3910] = {.lex_state = 0},
  [3911] = {.lex_state = 97},
  [3912] = {.lex_state = 97},
  [3913] = {.lex_state = 0, .external_lex_state = 4},
  [3914] = {.lex_state = 0},
  [3915] = {.lex_state = 0, .external_lex_state = 4},
  [3916] = {.lex_state = 0, .external_lex_state = 4},
  [3917] = {.lex_state = 97},
  [3918] = {.lex_state = 0},
  [3919] = {.lex_state = 0},
  [3920] = {.lex_state = 0},
  [3921] = {.lex_state = 0, .external_lex_state = 4},
  [3922] = {.lex_state = 97},
  [3923] = {.lex_state = 0},
  [3924] = {.lex_state = 0},
  [3925] = {.lex_state = 97},
  [3926] = {.lex_state = 97},
  [3927] = {.lex_state = 0, .external_lex_state = 4},
  [3928] = {.lex_state = 97},
  [3929] = {.lex_state = 97},
  [3930] = {.lex_state = 97},
  [3931] = {.lex_state = 97},
  [3932] = {.lex_state = 0},
  [3933] = {.lex_state = 97},
  [3934] = {.lex_state = 97},
  [3935] = {.lex_state = 0},
  [3936] = {.lex_state = 97},
  [3937] = {.lex_state = 0, .external_lex_state = 4},
  [3938] = {.lex_state = 97},
  [3939] = {.lex_state = 0, .external_lex_state = 4},
  [3940] = {.lex_state = 0, .external_lex_state = 4},
  [3941] = {.lex_state = 97},
  [3942] = {.lex_state = 97},
  [3943] = {.lex_state = 0},
  [3944] = {.lex_state = 0, .external_lex_state = 4},
  [3945] = {.lex_state = 97},
  [3946] = {.lex_state = 0, .external_lex_state = 4},
  [3947] = {.lex_state = 0},
  [3948] = {.lex_state = 97},
  [3949] = {.lex_state = 0},
  [3950] = {.lex_state = 97},
  [3951] = {.lex_state = 0},
  [3952] = {.lex_state = 0},
  [3953] = {.lex_state = 0},
  [3954] = {.lex_state = 0},
  [3955] = {.lex_state = 0},
  [3956] = {.lex_state = 13},
  [3957] = {.lex_state = 0},
  [3958] = {.lex_state = 97},
  [3959] = {.lex_state = 0},
  [3960] = {.lex_state = 97},
  [3961] = {.lex_state = 0},
  [3962] = {.lex_state = 97},
  [3963] = {.lex_state = 97},
  [3964] = {.lex_state = 97},
  [3965] = {.lex_state = 0},
  [3966] = {.lex_state = 97},
  [3967] = {.lex_state = 0},
  [3968] = {.lex_state = 97},
  [3969] = {.lex_state = 97},
  [3970] = {.lex_state = 97},
  [3971] = {.lex_state = 97},
  [3972] = {.lex_state = 97},
  [3973] = {.lex_state = 97},
  [3974] = {.lex_state = 0},
  [3975] = {.lex_state = 0},
  [3976] = {.lex_state = 97},
  [3977] = {.lex_state = 0, .external_lex_state = 4},
  [3978] = {.lex_state = 97},
  [3979] = {.lex_state = 97},
  [3980] = {.lex_state = 0, .external_lex_state = 4},
  [3981] = {.lex_state = 0, .external_lex_state = 4},
  [3982] = {.lex_state = 97},
  [3983] = {.lex_state = 0},
  [3984] = {.lex_state = 97},
  [3985] = {.lex_state = 1},
  [3986] = {.lex_state = 0},
  [3987] = {.lex_state = 0, .external_lex_state = 4},
  [3988] = {.lex_state = 0},
  [3989] = {.lex_state = 97},
  [3990] = {.lex_state = 97},
  [3991] = {.lex_state = 0, .external_lex_state = 4},
  [3992] = {.lex_state = 0},
  [3993] = {.lex_state = 97},
  [3994] = {.lex_state = 0},
  [3995] = {.lex_state = 97},
  [3996] = {.lex_state = 97},
  [3997] = {.lex_state = 97},
  [3998] = {.lex_state = 97},
  [3999] = {.lex_state = 97},
  [4000] = {.lex_state = 0},
  [4001] = {.lex_state = 97},
  [4002] = {.lex_state = 0},
  [4003] = {.lex_state = 97},
  [4004] = {.lex_state = 0},
  [4005] = {.lex_state = 97},
  [4006] = {.lex_state = 97},
  [4007] = {.lex_state = 0},
  [4008] = {.lex_state = 0},
  [4009] = {.lex_state = 0},
  [4010] = {.lex_state = 0},
  [4011] = {.lex_state = 0},
  [4012] = {.lex_state = 0},
  [4013] = {.lex_state = 97},
  [4014] = {.lex_state = 97},
  [4015] = {.lex_state = 97},
  [4016] = {.lex_state = 0},
  [4017] = {.lex_state = 0},
  [4018] = {.lex_state = 97},
  [4019] = {.lex_state = 97},
  [4020] = {.lex_state = 0},
  [4021] = {.lex_state = 0},
  [4022] = {.lex_state = 0},
  [4023] = {.lex_state = 0},
  [4024] = {.lex_state = 2},
  [4025] = {.lex_state = 0},
  [4026] = {.lex_state = 2},
  [4027] = {.lex_state = 0},
  [4028] = {.lex_state = 0},
  [4029] = {.lex_state = 0},
  [4030] = {.lex_state = 0},
  [4031] = {.lex_state = 0},
  [4032] = {.lex_state = 0},
  [4033] = {.lex_state = 0},
  [4034] = {.lex_state = 0},
  [4035] = {.lex_state = 97},
  [4036] = {.lex_state = 0},
  [4037] = {.lex_state = 0},
  [4038] = {.lex_state = 0},
  [4039] = {.lex_state = 97},
  [4040] = {.lex_state = 97},
  [4041] = {.lex_state = 13},
  [4042] = {.lex_state = 0},
  [4043] = {.lex_state = 0},
  [4044] = {.lex_state = 0},
  [4045] = {.lex_state = 0},
  [4046] = {.lex_state = 0},
  [4047] = {.lex_state = 97},
  [4048] = {.lex_state = 0},
  [4049] = {.lex_state = 0},
  [4050] = {.lex_state = 97},
  [4051] = {.lex_state = 97},
  [4052] = {.lex_state = 97},
  [4053] = {.lex_state = 0},
  [4054] = {.lex_state = 0},
  [4055] = {.lex_state = 97},
  [4056] = {.lex_state = 0},
  [4057] = {.lex_state = 97},
  [4058] = {.lex_state = 0},
  [4059] = {.lex_state = 0},
  [4060] = {.lex_state = 0},
  [4061] = {.lex_state = 97},
  [4062] = {.lex_state = 0},
  [4063] = {.lex_state = 97},
  [4064] = {.lex_state = 0},
  [4065] = {.lex_state = 97},
  [4066] = {.lex_state = 0},
  [4067] = {.lex_state = 0},
  [4068] = {.lex_state = 97},
  [4069] = {.lex_state = 0},
  [4070] = {.lex_state = 97},
  [4071] = {.lex_state = 0},
  [4072] = {.lex_state = 0},
  [4073] = {.lex_state = 0},
  [4074] = {.lex_state = 0},
  [4075] = {.lex_state = 0},
  [4076] = {.lex_state = 0},
  [4077] = {.lex_state = 0},
  [4078] = {.lex_state = 0},
  [4079] = {.lex_state = 2},
  [4080] = {.lex_state = 0},
  [4081] = {.lex_state = 0},
  [4082] = {.lex_state = 0},
  [4083] = {.lex_state = 0},
  [4084] = {.lex_state = 0},
  [4085] = {.lex_state = 0},
  [4086] = {.lex_state = 0},
  [4087] = {.lex_state = 97},
  [4088] = {.lex_state = 97},
  [4089] = {.lex_state = 0},
  [4090] = {.lex_state = 97},
  [4091] = {.lex_state = 97},
  [4092] = {.lex_state = 0},
  [4093] = {.lex_state = 0},
  [4094] = {.lex_state = 97},
  [4095] = {.lex_state = 0},
  [4096] = {.lex_state = 97},
  [4097] = {.lex_state = 0},
  [4098] = {.lex_state = 0},
  [4099] = {.lex_state = 0},
  [4100] = {.lex_state = 0},
  [4101] = {.lex_state = 0},
  [4102] = {.lex_state = 0},
  [4103] = {.lex_state = 0},
  [4104] = {.lex_state = 0},
  [4105] = {.lex_state = 0},
  [4106] = {.lex_state = 0},
  [4107] = {.lex_state = 0},
  [4108] = {.lex_state = 0},
  [4109] = {.lex_state = 0},
  [4110] = {.lex_state = 0},
  [4111] = {.lex_state = 97},
  [4112] = {.lex_state = 0},
  [4113] = {.lex_state = 0},
  [4114] = {.lex_state = 97},
  [4115] = {.lex_state = 0},
  [4116] = {.lex_state = 0},
  [4117] = {.lex_state = 0},
  [4118] = {.lex_state = 0},
  [4119] = {.lex_state = 97},
  [4120] = {.lex_state = 0},
  [4121] = {.lex_state = 0},
  [4122] = {.lex_state = 0},
  [4123] = {.lex_state = 0},
  [4124] = {.lex_state = 0},
  [4125] = {.lex_state = 0},
  [4126] = {.lex_state = 0},
  [4127] = {.lex_state = 0},
  [4128] = {.lex_state = 0},
  [4129] = {.lex_state = 0},
  [4130] = {.lex_state = 0},
  [4131] = {.lex_state = 0},
  [4132] = {.lex_state = 0},
  [4133] = {.lex_state = 0},
  [4134] = {.lex_state = 97},
  [4135] = {.lex_state = 97},
  [4136] = {.lex_state = 0},
  [4137] = {.lex_state = 0},
  [4138] = {.lex_state = 97},
  [4139] = {.lex_state = 97},
  [4140] = {.lex_state = 0},
  [4141] = {.lex_state = 0},
  [4142] = {.lex_state = 0},
  [4143] = {.lex_state = 97},
  [4144] = {.lex_state = 0},
  [4145] = {.lex_state = 0},
  [4146] = {.lex_state = 0},
  [4147] = {.lex_state = 0},
  [4148] = {.lex_state = 0},
  [4149] = {.lex_state = 0},
  [4150] = {.lex_state = 97},
  [4151] = {.lex_state = 0},
  [4152] = {.lex_state = 0},
  [4153] = {.lex_state = 97},
  [4154] = {.lex_state = 0},
  [4155] = {.lex_state = 0},
  [4156] = {.lex_state = 0},
  [4157] = {.lex_state = 0},
  [4158] = {.lex_state = 97},
  [4159] = {.lex_state = 0},
  [4160] = {.lex_state = 0},
  [4161] = {.lex_state = 0},
  [4162] = {.lex_state = 0},
  [4163] = {.lex_state = 0},
  [4164] = {.lex_state = 97},
  [4165] = {.lex_state = 97},
  [4166] = {.lex_state = 97},
  [4167] = {.lex_state = 2},
  [4168] = {.lex_state = 0},
  [4169] = {.lex_state = 97},
  [4170] = {.lex_state = 0},
  [4171] = {.lex_state = 97},
  [4172] = {.lex_state = 0},
  [4173] = {.lex_state = 0},
  [4174] = {.lex_state = 0},
  [4175] = {.lex_state = 0},
  [4176] = {.lex_state = 97},
  [4177] = {.lex_state = 0},
  [4178] = {.lex_state = 0},
  [4179] = {.lex_state = 0},
  [4180] = {.lex_state = 97},
  [4181] = {.lex_state = 0},
  [4182] = {.lex_state = 0},
  [4183] = {.lex_state = 0},
  [4184] = {.lex_state = 97},
  [4185] = {.lex_state = 0},
  [4186] = {.lex_state = 97},
  [4187] = {.lex_state = 0},
  [4188] = {.lex_state = 97},
  [4189] = {.lex_state = 97},
  [4190] = {.lex_state = 0},
  [4191] = {.lex_state = 97},
  [4192] = {.lex_state = 0},
  [4193] = {.lex_state = 0},
  [4194] = {.lex_state = 97},
  [4195] = {.lex_state = 97},
  [4196] = {.lex_state = 0},
  [4197] = {.lex_state = 0},
  [4198] = {.lex_state = 0},
  [4199] = {.lex_state = 97},
  [4200] = {.lex_state = 97},
  [4201] = {.lex_state = 0},
  [4202] = {.lex_state = 97},
  [4203] = {.lex_state = 97},
  [4204] = {.lex_state = 0},
  [4205] = {.lex_state = 0},
  [4206] = {.lex_state = 97},
  [4207] = {.lex_state = 0},
  [4208] = {.lex_state = 0},
  [4209] = {.lex_state = 97},
  [4210] = {.lex_state = 0},
  [4211] = {.lex_state = 0},
  [4212] = {.lex_state = 0},
  [4213] = {.lex_state = 0},
  [4214] = {.lex_state = 0},
  [4215] = {.lex_state = 0},
  [4216] = {.lex_state = 0},
  [4217] = {.lex_state = 0},
  [4218] = {.lex_state = 0},
  [4219] = {.lex_state = 97},
  [4220] = {.lex_state = 0},
  [4221] = {.lex_state = 0},
  [4222] = {.lex_state = 0},
  [4223] = {.lex_state = 0},
  [4224] = {.lex_state = 0},
  [4225] = {.lex_state = 0},
  [4226] = {.lex_state = 0},
  [4227] = {.lex_state = 0},
  [4228] = {.lex_state = 97},
  [4229] = {.lex_state = 97},
  [4230] = {.lex_state = 97},
  [4231] = {.lex_state = 0},
  [4232] = {.lex_state = 0},
  [4233] = {.lex_state = 0},
  [4234] = {.lex_state = 0},
  [4235] = {.lex_state = 0},
  [4236] = {.lex_state = 0},
  [4237] = {.lex_state = 0},
  [4238] = {.lex_state = 0},
  [4239] = {.lex_state = 97},
  [4240] = {.lex_state = 13},
  [4241] = {.lex_state = 97},
  [4242] = {.lex_state = 0},
  [4243] = {.lex_state = 13},
  [4244] = {.lex_state = 0},
  [4245] = {.lex_state = 0},
  [4246] = {.lex_state = 0},
  [4247] = {.lex_state = 0},
  [4248] = {.lex_state = 97},
  [4249] = {.lex_state = 0},
  [4250] = {.lex_state = 0},
  [4251] = {.lex_state = 97},
  [4252] = {.lex_state = 0},
  [4253] = {.lex_state = 0},
  [4254] = {.lex_state = 97},
  [4255] = {.lex_state = 0},
  [4256] = {.lex_state = 0},
  [4257] = {.lex_state = 97},
  [4258] = {.lex_state = 97},
  [4259] = {.lex_state = 0},
  [4260] = {.lex_state = 0},
  [4261] = {.lex_state = 97},
  [4262] = {.lex_state = 97},
  [4263] = {.lex_state = 0},
  [4264] = {.lex_state = 0},
  [4265] = {.lex_state = 0},
  [4266] = {.lex_state = 97},
  [4267] = {.lex_state = 97},
  [4268] = {.lex_state = 97},
  [4269] = {.lex_state = 0},
  [4270] = {.lex_state = 0},
  [4271] = {.lex_state = 97},
  [4272] = {.lex_state = 97},
  [4273] = {.lex_state = 13},
  [4274] = {.lex_state = 97},
  [4275] = {.lex_state = 0},
  [4276] = {.lex_state = 0},
  [4277] = {.lex_state = 97},
  [4278] = {.lex_state = 0},
  [4279] = {.lex_state = 0},
  [4280] = {.lex_state = 0},
  [4281] = {.lex_state = 13},
  [4282] = {.lex_state = 0},
  [4283] = {.lex_state = 0},
  [4284] = {.lex_state = 0},
  [4285] = {.lex_state = 0},
  [4286] = {.lex_state = 0},
  [4287] = {.lex_state = 0},
  [4288] = {.lex_state = 0},
  [4289] = {.lex_state = 0},
  [4290] = {.lex_state = 0},
  [4291] = {.lex_state = 0},
  [4292] = {.lex_state = 0},
  [4293] = {.lex_state = 0},
  [4294] = {.lex_state = 0},
  [4295] = {.lex_state = 0},
  [4296] = {.lex_state = 97},
  [4297] = {.lex_state = 0},
  [4298] = {.lex_state = 0},
  [4299] = {.lex_state = 0},
  [4300] = {.lex_state = 0},
  [4301] = {.lex_state = 97},
  [4302] = {.lex_state = 97},
  [4303] = {.lex_state = 97},
  [4304] = {.lex_state = 0},
  [4305] = {.lex_state = 97},
  [4306] = {.lex_state = 0},
  [4307] = {.lex_state = 0},
  [4308] = {.lex_state = 0},
  [4309] = {.lex_state = 0},
  [4310] = {.lex_state = 0},
  [4311] = {.lex_state = 97},
  [4312] = {.lex_state = 0},
  [4313] = {.lex_state = 0},
  [4314] = {.lex_state = 0},
  [4315] = {.lex_state = 0},
  [4316] = {.lex_state = 97},
  [4317] = {.lex_state = 0},
  [4318] = {.lex_state = 0},
  [4319] = {.lex_state = 97},
  [4320] = {.lex_state = 0},
  [4321] = {.lex_state = 97},
  [4322] = {.lex_state = 97},
  [4323] = {.lex_state = 97},
  [4324] = {.lex_state = 97},
  [4325] = {.lex_state = 97},
  [4326] = {.lex_state = 97},
  [4327] = {.lex_state = 0},
  [4328] = {.lex_state = 97},
  [4329] = {.lex_state = 0},
  [4330] = {.lex_state = 97},
  [4331] = {.lex_state = 97},
  [4332] = {.lex_state = 0},
  [4333] = {.lex_state = 0},
  [4334] = {.lex_state = 0},
  [4335] = {.lex_state = 2},
  [4336] = {.lex_state = 0},
  [4337] = {.lex_state = 0},
  [4338] = {.lex_state = 0},
  [4339] = {.lex_state = 0},
  [4340] = {.lex_state = 0},
  [4341] = {.lex_state = 0},
  [4342] = {.lex_state = 97},
  [4343] = {.lex_state = 0},
  [4344] = {.lex_state = 97},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token__ternary_qmark = 2,
  ts_external_token_PIPE_PIPE = 3,
  ts_external_token__function_signature_automatic_semicolon = 4,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token__ternary_qmark] = sym__ternary_qmark,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
};

static const bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [2] = {
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [6] = {
    [ts_external_token__template_chars] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LTtemplate_GT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_private_property_identifier] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_satisfies] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_unique] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__ternary_qmark] = ACTIONS(1),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(4320),
    [sym_export_statement] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [2] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3332),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(328),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(139),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(161),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(186),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(192),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(194),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(198),
    [anon_sym_number] = ACTIONS(198),
    [anon_sym_boolean] = ACTIONS(198),
    [anon_sym_string] = ACTIONS(198),
    [anon_sym_symbol] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [3] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3332),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(328),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(139),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(161),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(186),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(192),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(194),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(198),
    [anon_sym_number] = ACTIONS(198),
    [anon_sym_boolean] = ACTIONS(198),
    [anon_sym_string] = ACTIONS(198),
    [anon_sym_symbol] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [4] = {
    [sym_export_statement] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4283),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4283),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4283),
    [sym_spread_element] = STATE(3542),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1864),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3542),
    [sym_pair] = STATE(3542),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2916),
    [sym_computed_property_name] = STATE(2916),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_accessibility_modifier] = STATE(2286),
    [sym_override_modifier] = STATE(2301),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [aux_sym_object_repeat1] = STATE(3543),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(220),
    [anon_sym_export] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_type] = ACTIONS(226),
    [anon_sym_namespace] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(230),
    [anon_sym_RBRACE] = ACTIONS(232),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(240),
    [sym_private_property_identifier] = ACTIONS(242),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_get] = ACTIONS(248),
    [anon_sym_set] = ACTIONS(248),
    [anon_sym_declare] = ACTIONS(250),
    [anon_sym_public] = ACTIONS(252),
    [anon_sym_private] = ACTIONS(252),
    [anon_sym_protected] = ACTIONS(252),
    [anon_sym_override] = ACTIONS(254),
    [anon_sym_module] = ACTIONS(256),
    [anon_sym_any] = ACTIONS(258),
    [anon_sym_number] = ACTIONS(258),
    [anon_sym_boolean] = ACTIONS(258),
    [anon_sym_string] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(258),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [5] = {
    [sym_export_statement] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4283),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4283),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4283),
    [sym_spread_element] = STATE(3683),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1864),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2916),
    [sym_computed_property_name] = STATE(2916),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_accessibility_modifier] = STATE(2286),
    [sym_override_modifier] = STATE(2301),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(262),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_type] = ACTIONS(264),
    [anon_sym_namespace] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(230),
    [anon_sym_RBRACE] = ACTIONS(268),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(240),
    [sym_private_property_identifier] = ACTIONS(242),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(272),
    [anon_sym_readonly] = ACTIONS(274),
    [anon_sym_get] = ACTIONS(276),
    [anon_sym_set] = ACTIONS(276),
    [anon_sym_declare] = ACTIONS(278),
    [anon_sym_public] = ACTIONS(280),
    [anon_sym_private] = ACTIONS(280),
    [anon_sym_protected] = ACTIONS(280),
    [anon_sym_override] = ACTIONS(282),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_any] = ACTIONS(286),
    [anon_sym_number] = ACTIONS(286),
    [anon_sym_boolean] = ACTIONS(286),
    [anon_sym_string] = ACTIONS(286),
    [anon_sym_symbol] = ACTIONS(286),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [6] = {
    [sym_export_statement] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4283),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4283),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4283),
    [sym_spread_element] = STATE(3542),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1864),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3542),
    [sym_pair] = STATE(3542),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2916),
    [sym_computed_property_name] = STATE(2916),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_accessibility_modifier] = STATE(2286),
    [sym_override_modifier] = STATE(2301),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [aux_sym_object_repeat1] = STATE(3543),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(220),
    [anon_sym_export] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_type] = ACTIONS(226),
    [anon_sym_namespace] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(230),
    [anon_sym_RBRACE] = ACTIONS(288),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(240),
    [sym_private_property_identifier] = ACTIONS(242),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_get] = ACTIONS(248),
    [anon_sym_set] = ACTIONS(248),
    [anon_sym_declare] = ACTIONS(250),
    [anon_sym_public] = ACTIONS(252),
    [anon_sym_private] = ACTIONS(252),
    [anon_sym_protected] = ACTIONS(252),
    [anon_sym_override] = ACTIONS(254),
    [anon_sym_module] = ACTIONS(256),
    [anon_sym_any] = ACTIONS(258),
    [anon_sym_number] = ACTIONS(258),
    [anon_sym_boolean] = ACTIONS(258),
    [anon_sym_string] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(258),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [7] = {
    [sym_export_statement] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4283),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4283),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4283),
    [sym_spread_element] = STATE(3683),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1864),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2916),
    [sym_computed_property_name] = STATE(2916),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_accessibility_modifier] = STATE(2286),
    [sym_override_modifier] = STATE(2301),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(290),
    [anon_sym_export] = ACTIONS(292),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_type] = ACTIONS(294),
    [anon_sym_namespace] = ACTIONS(296),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(230),
    [anon_sym_RBRACE] = ACTIONS(268),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(298),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(240),
    [sym_private_property_identifier] = ACTIONS(242),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(302),
    [anon_sym_get] = ACTIONS(304),
    [anon_sym_set] = ACTIONS(304),
    [anon_sym_declare] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(308),
    [anon_sym_private] = ACTIONS(308),
    [anon_sym_protected] = ACTIONS(308),
    [anon_sym_override] = ACTIONS(310),
    [anon_sym_module] = ACTIONS(312),
    [anon_sym_any] = ACTIONS(314),
    [anon_sym_number] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(314),
    [anon_sym_string] = ACTIONS(314),
    [anon_sym_symbol] = ACTIONS(314),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [8] = {
    [sym_export_statement] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4283),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4283),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4283),
    [sym_spread_element] = STATE(3542),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1864),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3542),
    [sym_pair] = STATE(3542),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2916),
    [sym_computed_property_name] = STATE(2916),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_accessibility_modifier] = STATE(2286),
    [sym_override_modifier] = STATE(2301),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [aux_sym_object_repeat1] = STATE(3543),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(220),
    [anon_sym_export] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_type] = ACTIONS(226),
    [anon_sym_namespace] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(230),
    [anon_sym_RBRACE] = ACTIONS(316),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(236),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(240),
    [sym_private_property_identifier] = ACTIONS(242),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_get] = ACTIONS(248),
    [anon_sym_set] = ACTIONS(248),
    [anon_sym_declare] = ACTIONS(250),
    [anon_sym_public] = ACTIONS(252),
    [anon_sym_private] = ACTIONS(252),
    [anon_sym_protected] = ACTIONS(252),
    [anon_sym_override] = ACTIONS(254),
    [anon_sym_module] = ACTIONS(256),
    [anon_sym_any] = ACTIONS(258),
    [anon_sym_number] = ACTIONS(258),
    [anon_sym_boolean] = ACTIONS(258),
    [anon_sym_string] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(258),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [9] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [ts_builtin_sym_end] = ACTIONS(318),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_default] = ACTIONS(326),
    [anon_sym_type] = ACTIONS(328),
    [anon_sym_namespace] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(334),
    [anon_sym_RBRACE] = ACTIONS(318),
    [anon_sym_typeof] = ACTIONS(337),
    [anon_sym_import] = ACTIONS(340),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_let] = ACTIONS(346),
    [anon_sym_const] = ACTIONS(349),
    [anon_sym_BANG] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(355),
    [anon_sym_switch] = ACTIONS(358),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(364),
    [anon_sym_await] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(370),
    [anon_sym_do] = ACTIONS(373),
    [anon_sym_try] = ACTIONS(376),
    [anon_sym_with] = ACTIONS(379),
    [anon_sym_break] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(385),
    [anon_sym_debugger] = ACTIONS(388),
    [anon_sym_return] = ACTIONS(391),
    [anon_sym_throw] = ACTIONS(394),
    [anon_sym_SEMI] = ACTIONS(397),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_yield] = ACTIONS(400),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LTtemplate_GT] = ACTIONS(406),
    [anon_sym_class] = ACTIONS(409),
    [anon_sym_async] = ACTIONS(412),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(418),
    [anon_sym_PLUS] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_TILDE] = ACTIONS(352),
    [anon_sym_void] = ACTIONS(337),
    [anon_sym_delete] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(430),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(439),
    [sym_number] = ACTIONS(442),
    [sym_this] = ACTIONS(445),
    [sym_super] = ACTIONS(445),
    [sym_true] = ACTIONS(445),
    [sym_false] = ACTIONS(445),
    [sym_null] = ACTIONS(445),
    [sym_undefined] = ACTIONS(448),
    [anon_sym_AT] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(454),
    [anon_sym_readonly] = ACTIONS(454),
    [anon_sym_get] = ACTIONS(454),
    [anon_sym_set] = ACTIONS(454),
    [anon_sym_declare] = ACTIONS(457),
    [anon_sym_public] = ACTIONS(454),
    [anon_sym_private] = ACTIONS(454),
    [anon_sym_protected] = ACTIONS(454),
    [anon_sym_override] = ACTIONS(454),
    [anon_sym_module] = ACTIONS(460),
    [anon_sym_any] = ACTIONS(454),
    [anon_sym_number] = ACTIONS(454),
    [anon_sym_boolean] = ACTIONS(454),
    [anon_sym_string] = ACTIONS(454),
    [anon_sym_symbol] = ACTIONS(454),
    [anon_sym_abstract] = ACTIONS(463),
    [anon_sym_interface] = ACTIONS(466),
    [anon_sym_enum] = ACTIONS(469),
  },
  [10] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(472),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(472),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [11] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(478),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(476),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [12] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(480),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(482),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(480),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [13] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(484),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(486),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(484),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [14] = {
    [sym_export_statement] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(488),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [15] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(490),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [16] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(492),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [17] = {
    [sym_export_statement] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [18] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(496),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [19] = {
    [sym_export_statement] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [ts_builtin_sym_end] = ACTIONS(498),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [20] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(500),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [21] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [ts_builtin_sym_end] = ACTIONS(502),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [22] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [ts_builtin_sym_end] = ACTIONS(498),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [23] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(504),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [24] = {
    [sym_export_statement] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [25] = {
    [sym_export_statement] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(508),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [26] = {
    [sym_export_statement] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(510),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [27] = {
    [sym_export_statement] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(512),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [28] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [29] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [30] = {
    [sym_export_statement] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_for_in_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_debugger_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_throw_statement] = STATE(29),
    [sym_empty_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(518),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [31] = {
    [sym_export_statement] = STATE(678),
    [sym_declaration] = STATE(678),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(678),
    [sym_expression_statement] = STATE(678),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(678),
    [sym_if_statement] = STATE(678),
    [sym_switch_statement] = STATE(678),
    [sym_for_statement] = STATE(678),
    [sym_for_in_statement] = STATE(678),
    [sym_while_statement] = STATE(678),
    [sym_do_statement] = STATE(678),
    [sym_try_statement] = STATE(678),
    [sym_with_statement] = STATE(678),
    [sym_break_statement] = STATE(678),
    [sym_continue_statement] = STATE(678),
    [sym_debugger_statement] = STATE(678),
    [sym_return_statement] = STATE(678),
    [sym_throw_statement] = STATE(678),
    [sym_empty_statement] = STATE(678),
    [sym_labeled_statement] = STATE(678),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [32] = {
    [sym_export_statement] = STATE(3705),
    [sym_declaration] = STATE(3705),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(3705),
    [sym_expression_statement] = STATE(3705),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(3705),
    [sym_if_statement] = STATE(3705),
    [sym_switch_statement] = STATE(3705),
    [sym_for_statement] = STATE(3705),
    [sym_for_in_statement] = STATE(3705),
    [sym_while_statement] = STATE(3705),
    [sym_do_statement] = STATE(3705),
    [sym_try_statement] = STATE(3705),
    [sym_with_statement] = STATE(3705),
    [sym_break_statement] = STATE(3705),
    [sym_continue_statement] = STATE(3705),
    [sym_debugger_statement] = STATE(3705),
    [sym_return_statement] = STATE(3705),
    [sym_throw_statement] = STATE(3705),
    [sym_empty_statement] = STATE(3705),
    [sym_labeled_statement] = STATE(3705),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [sym_identifier] = ACTIONS(520),
    [anon_sym_export] = ACTIONS(522),
    [anon_sym_type] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_readonly] = ACTIONS(544),
    [anon_sym_get] = ACTIONS(544),
    [anon_sym_set] = ACTIONS(544),
    [anon_sym_declare] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_override] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_any] = ACTIONS(544),
    [anon_sym_number] = ACTIONS(544),
    [anon_sym_boolean] = ACTIONS(544),
    [anon_sym_string] = ACTIONS(544),
    [anon_sym_symbol] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [33] = {
    [sym_export_statement] = STATE(678),
    [sym_declaration] = STATE(678),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(678),
    [sym_expression_statement] = STATE(678),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(678),
    [sym_if_statement] = STATE(678),
    [sym_switch_statement] = STATE(678),
    [sym_for_statement] = STATE(678),
    [sym_for_in_statement] = STATE(678),
    [sym_while_statement] = STATE(678),
    [sym_do_statement] = STATE(678),
    [sym_try_statement] = STATE(678),
    [sym_with_statement] = STATE(678),
    [sym_break_statement] = STATE(678),
    [sym_continue_statement] = STATE(678),
    [sym_debugger_statement] = STATE(678),
    [sym_return_statement] = STATE(678),
    [sym_throw_statement] = STATE(678),
    [sym_empty_statement] = STATE(678),
    [sym_labeled_statement] = STATE(678),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [sym_identifier] = ACTIONS(520),
    [anon_sym_export] = ACTIONS(522),
    [anon_sym_type] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_readonly] = ACTIONS(544),
    [anon_sym_get] = ACTIONS(544),
    [anon_sym_set] = ACTIONS(544),
    [anon_sym_declare] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_override] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_any] = ACTIONS(544),
    [anon_sym_number] = ACTIONS(544),
    [anon_sym_boolean] = ACTIONS(544),
    [anon_sym_string] = ACTIONS(544),
    [anon_sym_symbol] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [34] = {
    [sym_export_statement] = STATE(749),
    [sym_declaration] = STATE(749),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(749),
    [sym_expression_statement] = STATE(749),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(749),
    [sym_if_statement] = STATE(749),
    [sym_switch_statement] = STATE(749),
    [sym_for_statement] = STATE(749),
    [sym_for_in_statement] = STATE(749),
    [sym_while_statement] = STATE(749),
    [sym_do_statement] = STATE(749),
    [sym_try_statement] = STATE(749),
    [sym_with_statement] = STATE(749),
    [sym_break_statement] = STATE(749),
    [sym_continue_statement] = STATE(749),
    [sym_debugger_statement] = STATE(749),
    [sym_return_statement] = STATE(749),
    [sym_throw_statement] = STATE(749),
    [sym_empty_statement] = STATE(749),
    [sym_labeled_statement] = STATE(749),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [35] = {
    [sym_export_statement] = STATE(635),
    [sym_declaration] = STATE(635),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(635),
    [sym_expression_statement] = STATE(635),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(635),
    [sym_if_statement] = STATE(635),
    [sym_switch_statement] = STATE(635),
    [sym_for_statement] = STATE(635),
    [sym_for_in_statement] = STATE(635),
    [sym_while_statement] = STATE(635),
    [sym_do_statement] = STATE(635),
    [sym_try_statement] = STATE(635),
    [sym_with_statement] = STATE(635),
    [sym_break_statement] = STATE(635),
    [sym_continue_statement] = STATE(635),
    [sym_debugger_statement] = STATE(635),
    [sym_return_statement] = STATE(635),
    [sym_throw_statement] = STATE(635),
    [sym_empty_statement] = STATE(635),
    [sym_labeled_statement] = STATE(635),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [36] = {
    [sym_export_statement] = STATE(740),
    [sym_declaration] = STATE(740),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(740),
    [sym_expression_statement] = STATE(740),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(740),
    [sym_if_statement] = STATE(740),
    [sym_switch_statement] = STATE(740),
    [sym_for_statement] = STATE(740),
    [sym_for_in_statement] = STATE(740),
    [sym_while_statement] = STATE(740),
    [sym_do_statement] = STATE(740),
    [sym_try_statement] = STATE(740),
    [sym_with_statement] = STATE(740),
    [sym_break_statement] = STATE(740),
    [sym_continue_statement] = STATE(740),
    [sym_debugger_statement] = STATE(740),
    [sym_return_statement] = STATE(740),
    [sym_throw_statement] = STATE(740),
    [sym_empty_statement] = STATE(740),
    [sym_labeled_statement] = STATE(740),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [37] = {
    [sym_export_statement] = STATE(758),
    [sym_declaration] = STATE(758),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(758),
    [sym_expression_statement] = STATE(758),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(758),
    [sym_if_statement] = STATE(758),
    [sym_switch_statement] = STATE(758),
    [sym_for_statement] = STATE(758),
    [sym_for_in_statement] = STATE(758),
    [sym_while_statement] = STATE(758),
    [sym_do_statement] = STATE(758),
    [sym_try_statement] = STATE(758),
    [sym_with_statement] = STATE(758),
    [sym_break_statement] = STATE(758),
    [sym_continue_statement] = STATE(758),
    [sym_debugger_statement] = STATE(758),
    [sym_return_statement] = STATE(758),
    [sym_throw_statement] = STATE(758),
    [sym_empty_statement] = STATE(758),
    [sym_labeled_statement] = STATE(758),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [38] = {
    [sym_export_statement] = STATE(728),
    [sym_declaration] = STATE(727),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(725),
    [sym_expression_statement] = STATE(724),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(723),
    [sym_if_statement] = STATE(722),
    [sym_switch_statement] = STATE(721),
    [sym_for_statement] = STATE(720),
    [sym_for_in_statement] = STATE(719),
    [sym_while_statement] = STATE(718),
    [sym_do_statement] = STATE(717),
    [sym_try_statement] = STATE(714),
    [sym_with_statement] = STATE(712),
    [sym_break_statement] = STATE(711),
    [sym_continue_statement] = STATE(624),
    [sym_debugger_statement] = STATE(709),
    [sym_return_statement] = STATE(708),
    [sym_throw_statement] = STATE(707),
    [sym_empty_statement] = STATE(706),
    [sym_labeled_statement] = STATE(704),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [sym_identifier] = ACTIONS(520),
    [anon_sym_export] = ACTIONS(522),
    [anon_sym_type] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_readonly] = ACTIONS(544),
    [anon_sym_get] = ACTIONS(544),
    [anon_sym_set] = ACTIONS(544),
    [anon_sym_declare] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_override] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_any] = ACTIONS(544),
    [anon_sym_number] = ACTIONS(544),
    [anon_sym_boolean] = ACTIONS(544),
    [anon_sym_string] = ACTIONS(544),
    [anon_sym_symbol] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [39] = {
    [sym_export_statement] = STATE(758),
    [sym_declaration] = STATE(758),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(758),
    [sym_expression_statement] = STATE(758),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(758),
    [sym_if_statement] = STATE(758),
    [sym_switch_statement] = STATE(758),
    [sym_for_statement] = STATE(758),
    [sym_for_in_statement] = STATE(758),
    [sym_while_statement] = STATE(758),
    [sym_do_statement] = STATE(758),
    [sym_try_statement] = STATE(758),
    [sym_with_statement] = STATE(758),
    [sym_break_statement] = STATE(758),
    [sym_continue_statement] = STATE(758),
    [sym_debugger_statement] = STATE(758),
    [sym_return_statement] = STATE(758),
    [sym_throw_statement] = STATE(758),
    [sym_empty_statement] = STATE(758),
    [sym_labeled_statement] = STATE(758),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [sym_identifier] = ACTIONS(520),
    [anon_sym_export] = ACTIONS(522),
    [anon_sym_type] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_readonly] = ACTIONS(544),
    [anon_sym_get] = ACTIONS(544),
    [anon_sym_set] = ACTIONS(544),
    [anon_sym_declare] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_override] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_any] = ACTIONS(544),
    [anon_sym_number] = ACTIONS(544),
    [anon_sym_boolean] = ACTIONS(544),
    [anon_sym_string] = ACTIONS(544),
    [anon_sym_symbol] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [40] = {
    [sym_export_statement] = STATE(699),
    [sym_declaration] = STATE(699),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(699),
    [sym_expression_statement] = STATE(699),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(699),
    [sym_if_statement] = STATE(699),
    [sym_switch_statement] = STATE(699),
    [sym_for_statement] = STATE(699),
    [sym_for_in_statement] = STATE(699),
    [sym_while_statement] = STATE(699),
    [sym_do_statement] = STATE(699),
    [sym_try_statement] = STATE(699),
    [sym_with_statement] = STATE(699),
    [sym_break_statement] = STATE(699),
    [sym_continue_statement] = STATE(699),
    [sym_debugger_statement] = STATE(699),
    [sym_return_statement] = STATE(699),
    [sym_throw_statement] = STATE(699),
    [sym_empty_statement] = STATE(699),
    [sym_labeled_statement] = STATE(699),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [sym_identifier] = ACTIONS(520),
    [anon_sym_export] = ACTIONS(522),
    [anon_sym_type] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_readonly] = ACTIONS(544),
    [anon_sym_get] = ACTIONS(544),
    [anon_sym_set] = ACTIONS(544),
    [anon_sym_declare] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_override] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_any] = ACTIONS(544),
    [anon_sym_number] = ACTIONS(544),
    [anon_sym_boolean] = ACTIONS(544),
    [anon_sym_string] = ACTIONS(544),
    [anon_sym_symbol] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [41] = {
    [sym_export_statement] = STATE(740),
    [sym_declaration] = STATE(740),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(740),
    [sym_expression_statement] = STATE(740),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(740),
    [sym_if_statement] = STATE(740),
    [sym_switch_statement] = STATE(740),
    [sym_for_statement] = STATE(740),
    [sym_for_in_statement] = STATE(740),
    [sym_while_statement] = STATE(740),
    [sym_do_statement] = STATE(740),
    [sym_try_statement] = STATE(740),
    [sym_with_statement] = STATE(740),
    [sym_break_statement] = STATE(740),
    [sym_continue_statement] = STATE(740),
    [sym_debugger_statement] = STATE(740),
    [sym_return_statement] = STATE(740),
    [sym_throw_statement] = STATE(740),
    [sym_empty_statement] = STATE(740),
    [sym_labeled_statement] = STATE(740),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [sym_identifier] = ACTIONS(520),
    [anon_sym_export] = ACTIONS(522),
    [anon_sym_type] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_readonly] = ACTIONS(544),
    [anon_sym_get] = ACTIONS(544),
    [anon_sym_set] = ACTIONS(544),
    [anon_sym_declare] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_override] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_any] = ACTIONS(544),
    [anon_sym_number] = ACTIONS(544),
    [anon_sym_boolean] = ACTIONS(544),
    [anon_sym_string] = ACTIONS(544),
    [anon_sym_symbol] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [42] = {
    [sym_export_statement] = STATE(635),
    [sym_declaration] = STATE(635),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(635),
    [sym_expression_statement] = STATE(635),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(635),
    [sym_if_statement] = STATE(635),
    [sym_switch_statement] = STATE(635),
    [sym_for_statement] = STATE(635),
    [sym_for_in_statement] = STATE(635),
    [sym_while_statement] = STATE(635),
    [sym_do_statement] = STATE(635),
    [sym_try_statement] = STATE(635),
    [sym_with_statement] = STATE(635),
    [sym_break_statement] = STATE(635),
    [sym_continue_statement] = STATE(635),
    [sym_debugger_statement] = STATE(635),
    [sym_return_statement] = STATE(635),
    [sym_throw_statement] = STATE(635),
    [sym_empty_statement] = STATE(635),
    [sym_labeled_statement] = STATE(635),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [sym_identifier] = ACTIONS(520),
    [anon_sym_export] = ACTIONS(522),
    [anon_sym_type] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_readonly] = ACTIONS(544),
    [anon_sym_get] = ACTIONS(544),
    [anon_sym_set] = ACTIONS(544),
    [anon_sym_declare] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_override] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_any] = ACTIONS(544),
    [anon_sym_number] = ACTIONS(544),
    [anon_sym_boolean] = ACTIONS(544),
    [anon_sym_string] = ACTIONS(544),
    [anon_sym_symbol] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [43] = {
    [sym_export_statement] = STATE(728),
    [sym_declaration] = STATE(727),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(725),
    [sym_expression_statement] = STATE(724),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(723),
    [sym_if_statement] = STATE(722),
    [sym_switch_statement] = STATE(721),
    [sym_for_statement] = STATE(720),
    [sym_for_in_statement] = STATE(719),
    [sym_while_statement] = STATE(718),
    [sym_do_statement] = STATE(717),
    [sym_try_statement] = STATE(714),
    [sym_with_statement] = STATE(712),
    [sym_break_statement] = STATE(711),
    [sym_continue_statement] = STATE(624),
    [sym_debugger_statement] = STATE(709),
    [sym_return_statement] = STATE(708),
    [sym_throw_statement] = STATE(707),
    [sym_empty_statement] = STATE(706),
    [sym_labeled_statement] = STATE(704),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [44] = {
    [sym_export_statement] = STATE(749),
    [sym_declaration] = STATE(749),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(749),
    [sym_expression_statement] = STATE(749),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(749),
    [sym_if_statement] = STATE(749),
    [sym_switch_statement] = STATE(749),
    [sym_for_statement] = STATE(749),
    [sym_for_in_statement] = STATE(749),
    [sym_while_statement] = STATE(749),
    [sym_do_statement] = STATE(749),
    [sym_try_statement] = STATE(749),
    [sym_with_statement] = STATE(749),
    [sym_break_statement] = STATE(749),
    [sym_continue_statement] = STATE(749),
    [sym_debugger_statement] = STATE(749),
    [sym_return_statement] = STATE(749),
    [sym_throw_statement] = STATE(749),
    [sym_empty_statement] = STATE(749),
    [sym_labeled_statement] = STATE(749),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [sym_identifier] = ACTIONS(520),
    [anon_sym_export] = ACTIONS(522),
    [anon_sym_type] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_readonly] = ACTIONS(544),
    [anon_sym_get] = ACTIONS(544),
    [anon_sym_set] = ACTIONS(544),
    [anon_sym_declare] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_override] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_any] = ACTIONS(544),
    [anon_sym_number] = ACTIONS(544),
    [anon_sym_boolean] = ACTIONS(544),
    [anon_sym_string] = ACTIONS(544),
    [anon_sym_symbol] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [45] = {
    [sym_export_statement] = STATE(629),
    [sym_declaration] = STATE(715),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(639),
    [sym_expression_statement] = STATE(631),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(663),
    [sym_if_statement] = STATE(664),
    [sym_switch_statement] = STATE(671),
    [sym_for_statement] = STATE(701),
    [sym_for_in_statement] = STATE(702),
    [sym_while_statement] = STATE(705),
    [sym_do_statement] = STATE(710),
    [sym_try_statement] = STATE(627),
    [sym_with_statement] = STATE(628),
    [sym_break_statement] = STATE(644),
    [sym_continue_statement] = STATE(648),
    [sym_debugger_statement] = STATE(660),
    [sym_return_statement] = STATE(666),
    [sym_throw_statement] = STATE(683),
    [sym_empty_statement] = STATE(691),
    [sym_labeled_statement] = STATE(692),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [sym_identifier] = ACTIONS(520),
    [anon_sym_export] = ACTIONS(522),
    [anon_sym_type] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_readonly] = ACTIONS(544),
    [anon_sym_get] = ACTIONS(544),
    [anon_sym_set] = ACTIONS(544),
    [anon_sym_declare] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_override] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_any] = ACTIONS(544),
    [anon_sym_number] = ACTIONS(544),
    [anon_sym_boolean] = ACTIONS(544),
    [anon_sym_string] = ACTIONS(544),
    [anon_sym_symbol] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [46] = {
    [sym_export_statement] = STATE(4261),
    [sym_declaration] = STATE(4261),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(4261),
    [sym_expression_statement] = STATE(4261),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(4261),
    [sym_if_statement] = STATE(4261),
    [sym_switch_statement] = STATE(4261),
    [sym_for_statement] = STATE(4261),
    [sym_for_in_statement] = STATE(4261),
    [sym_while_statement] = STATE(4261),
    [sym_do_statement] = STATE(4261),
    [sym_try_statement] = STATE(4261),
    [sym_with_statement] = STATE(4261),
    [sym_break_statement] = STATE(4261),
    [sym_continue_statement] = STATE(4261),
    [sym_debugger_statement] = STATE(4261),
    [sym_return_statement] = STATE(4261),
    [sym_throw_statement] = STATE(4261),
    [sym_empty_statement] = STATE(4261),
    [sym_labeled_statement] = STATE(4261),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [sym_identifier] = ACTIONS(520),
    [anon_sym_export] = ACTIONS(522),
    [anon_sym_type] = ACTIONS(524),
    [anon_sym_namespace] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_readonly] = ACTIONS(544),
    [anon_sym_get] = ACTIONS(544),
    [anon_sym_set] = ACTIONS(544),
    [anon_sym_declare] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_override] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_any] = ACTIONS(544),
    [anon_sym_number] = ACTIONS(544),
    [anon_sym_boolean] = ACTIONS(544),
    [anon_sym_string] = ACTIONS(544),
    [anon_sym_symbol] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [47] = {
    [sym_export_statement] = STATE(610),
    [sym_declaration] = STATE(610),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(610),
    [sym_expression_statement] = STATE(610),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(610),
    [sym_if_statement] = STATE(610),
    [sym_switch_statement] = STATE(610),
    [sym_for_statement] = STATE(610),
    [sym_for_in_statement] = STATE(610),
    [sym_while_statement] = STATE(610),
    [sym_do_statement] = STATE(610),
    [sym_try_statement] = STATE(610),
    [sym_with_statement] = STATE(610),
    [sym_break_statement] = STATE(610),
    [sym_continue_statement] = STATE(610),
    [sym_debugger_statement] = STATE(610),
    [sym_return_statement] = STATE(610),
    [sym_throw_statement] = STATE(610),
    [sym_empty_statement] = STATE(610),
    [sym_labeled_statement] = STATE(610),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [48] = {
    [sym_export_statement] = STATE(699),
    [sym_declaration] = STATE(699),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(699),
    [sym_expression_statement] = STATE(699),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(699),
    [sym_if_statement] = STATE(699),
    [sym_switch_statement] = STATE(699),
    [sym_for_statement] = STATE(699),
    [sym_for_in_statement] = STATE(699),
    [sym_while_statement] = STATE(699),
    [sym_do_statement] = STATE(699),
    [sym_try_statement] = STATE(699),
    [sym_with_statement] = STATE(699),
    [sym_break_statement] = STATE(699),
    [sym_continue_statement] = STATE(699),
    [sym_debugger_statement] = STATE(699),
    [sym_return_statement] = STATE(699),
    [sym_throw_statement] = STATE(699),
    [sym_empty_statement] = STATE(699),
    [sym_labeled_statement] = STATE(699),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [49] = {
    [sym_export_statement] = STATE(629),
    [sym_declaration] = STATE(715),
    [sym_import] = STATE(1852),
    [sym_import_statement] = STATE(639),
    [sym_expression_statement] = STATE(631),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_statement_block] = STATE(663),
    [sym_if_statement] = STATE(664),
    [sym_switch_statement] = STATE(671),
    [sym_for_statement] = STATE(701),
    [sym_for_in_statement] = STATE(702),
    [sym_while_statement] = STATE(705),
    [sym_do_statement] = STATE(710),
    [sym_try_statement] = STATE(627),
    [sym_with_statement] = STATE(628),
    [sym_break_statement] = STATE(644),
    [sym_continue_statement] = STATE(648),
    [sym_debugger_statement] = STATE(660),
    [sym_return_statement] = STATE(666),
    [sym_throw_statement] = STATE(683),
    [sym_empty_statement] = STATE(691),
    [sym_labeled_statement] = STATE(692),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [50] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(3216),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3592),
    [sym_optional_tuple_parameter] = STATE(3592),
    [sym_optional_type] = STATE(3592),
    [sym_rest_type] = STATE(3592),
    [sym__tuple_type_member] = STATE(3592),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(572),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(600),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(604),
    [anon_sym_number] = ACTIONS(604),
    [anon_sym_boolean] = ACTIONS(604),
    [anon_sym_string] = ACTIONS(604),
    [anon_sym_symbol] = ACTIONS(604),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [51] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1569),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3577),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(3216),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3671),
    [sym_optional_tuple_parameter] = STATE(3671),
    [sym_optional_type] = STATE(3671),
    [sym_rest_type] = STATE(3671),
    [sym__tuple_type_member] = STATE(3671),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3584),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(608),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(600),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(604),
    [anon_sym_number] = ACTIONS(604),
    [anon_sym_boolean] = ACTIONS(604),
    [anon_sym_string] = ACTIONS(604),
    [anon_sym_symbol] = ACTIONS(604),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [52] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(3216),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3671),
    [sym_optional_tuple_parameter] = STATE(3671),
    [sym_optional_type] = STATE(3671),
    [sym_rest_type] = STATE(3671),
    [sym__tuple_type_member] = STATE(3671),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(610),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(600),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(604),
    [anon_sym_number] = ACTIONS(604),
    [anon_sym_boolean] = ACTIONS(604),
    [anon_sym_string] = ACTIONS(604),
    [anon_sym_symbol] = ACTIONS(604),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [53] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(3216),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3671),
    [sym_optional_tuple_parameter] = STATE(3671),
    [sym_optional_type] = STATE(3671),
    [sym_rest_type] = STATE(3671),
    [sym__tuple_type_member] = STATE(3671),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(612),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(600),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(604),
    [anon_sym_number] = ACTIONS(604),
    [anon_sym_boolean] = ACTIONS(604),
    [anon_sym_string] = ACTIONS(604),
    [anon_sym_symbol] = ACTIONS(604),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [54] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(3216),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3671),
    [sym_optional_tuple_parameter] = STATE(3671),
    [sym_optional_type] = STATE(3671),
    [sym_rest_type] = STATE(3671),
    [sym__tuple_type_member] = STATE(3671),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(614),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(600),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(604),
    [anon_sym_number] = ACTIONS(604),
    [anon_sym_boolean] = ACTIONS(604),
    [anon_sym_string] = ACTIONS(604),
    [anon_sym_symbol] = ACTIONS(604),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [55] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(3216),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3671),
    [sym_optional_tuple_parameter] = STATE(3671),
    [sym_optional_type] = STATE(3671),
    [sym_rest_type] = STATE(3671),
    [sym__tuple_type_member] = STATE(3671),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(616),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(600),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(604),
    [anon_sym_number] = ACTIONS(604),
    [anon_sym_boolean] = ACTIONS(604),
    [anon_sym_string] = ACTIONS(604),
    [anon_sym_symbol] = ACTIONS(604),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [56] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(3216),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3671),
    [sym_optional_tuple_parameter] = STATE(3671),
    [sym_optional_type] = STATE(3671),
    [sym_rest_type] = STATE(3671),
    [sym__tuple_type_member] = STATE(3671),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(618),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(600),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(604),
    [anon_sym_number] = ACTIONS(604),
    [anon_sym_boolean] = ACTIONS(604),
    [anon_sym_string] = ACTIONS(604),
    [anon_sym_symbol] = ACTIONS(604),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [57] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(3216),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3671),
    [sym_optional_tuple_parameter] = STATE(3671),
    [sym_optional_type] = STATE(3671),
    [sym_rest_type] = STATE(3671),
    [sym__tuple_type_member] = STATE(3671),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(620),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(600),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(604),
    [anon_sym_number] = ACTIONS(604),
    [anon_sym_boolean] = ACTIONS(604),
    [anon_sym_string] = ACTIONS(604),
    [anon_sym_symbol] = ACTIONS(604),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [58] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(3216),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3671),
    [sym_optional_tuple_parameter] = STATE(3671),
    [sym_optional_type] = STATE(3671),
    [sym_rest_type] = STATE(3671),
    [sym__tuple_type_member] = STATE(3671),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(622),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(600),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(604),
    [anon_sym_number] = ACTIONS(604),
    [anon_sym_boolean] = ACTIONS(604),
    [anon_sym_string] = ACTIONS(604),
    [anon_sym_symbol] = ACTIONS(604),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [59] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1569),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3577),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(3216),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3671),
    [sym_optional_tuple_parameter] = STATE(3671),
    [sym_optional_type] = STATE(3671),
    [sym_rest_type] = STATE(3671),
    [sym__tuple_type_member] = STATE(3671),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3584),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(624),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(600),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(604),
    [anon_sym_number] = ACTIONS(604),
    [anon_sym_boolean] = ACTIONS(604),
    [anon_sym_string] = ACTIONS(604),
    [anon_sym_symbol] = ACTIONS(604),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [60] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3217),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(130),
    [anon_sym_DASH] = ACTIONS(130),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(646),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [61] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3258),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(130),
    [anon_sym_DASH] = ACTIONS(130),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(652),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [62] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3144),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(130),
    [anon_sym_DASH] = ACTIONS(130),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(654),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [63] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3142),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(130),
    [anon_sym_DASH] = ACTIONS(130),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(656),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [64] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3268),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(130),
    [anon_sym_DASH] = ACTIONS(130),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(658),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [65] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3332),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(130),
    [anon_sym_DASH] = ACTIONS(130),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(660),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [66] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3332),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(130),
    [anon_sym_DASH] = ACTIONS(130),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(660),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [67] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3147),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(130),
    [anon_sym_DASH] = ACTIONS(130),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(662),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [68] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1522),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4045),
    [sym_string] = STATE(1963),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2829),
    [sym__type] = STATE(3420),
    [sym_constructor_type] = STATE(3420),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3420),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3420),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3420),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(664),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_typeof] = ACTIONS(668),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(672),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [sym_number] = ACTIONS(678),
    [sym_this] = ACTIONS(680),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(682),
    [sym_false] = ACTIONS(682),
    [sym_null] = ACTIONS(682),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(688),
    [anon_sym_private] = ACTIONS(688),
    [anon_sym_protected] = ACTIONS(688),
    [anon_sym_override] = ACTIONS(690),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(692),
    [anon_sym_number] = ACTIONS(692),
    [anon_sym_boolean] = ACTIONS(692),
    [anon_sym_string] = ACTIONS(692),
    [anon_sym_symbol] = ACTIONS(692),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [69] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1522),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4045),
    [sym_string] = STATE(1963),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2829),
    [sym__type] = STATE(3452),
    [sym_constructor_type] = STATE(3452),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3452),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3452),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3452),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(664),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_typeof] = ACTIONS(668),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(672),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [sym_number] = ACTIONS(678),
    [sym_this] = ACTIONS(680),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(682),
    [sym_false] = ACTIONS(682),
    [sym_null] = ACTIONS(682),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(688),
    [anon_sym_private] = ACTIONS(688),
    [anon_sym_protected] = ACTIONS(688),
    [anon_sym_override] = ACTIONS(690),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(692),
    [anon_sym_number] = ACTIONS(692),
    [anon_sym_boolean] = ACTIONS(692),
    [anon_sym_string] = ACTIONS(692),
    [anon_sym_symbol] = ACTIONS(692),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [70] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1402),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4263),
    [sym_string] = STATE(1963),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2829),
    [sym__type] = STATE(3420),
    [sym_constructor_type] = STATE(3420),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3420),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3420),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3420),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(664),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_typeof] = ACTIONS(668),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(672),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [sym_number] = ACTIONS(678),
    [sym_this] = ACTIONS(680),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(682),
    [sym_false] = ACTIONS(682),
    [sym_null] = ACTIONS(682),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(688),
    [anon_sym_private] = ACTIONS(688),
    [anon_sym_protected] = ACTIONS(688),
    [anon_sym_override] = ACTIONS(690),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(692),
    [anon_sym_number] = ACTIONS(692),
    [anon_sym_boolean] = ACTIONS(692),
    [anon_sym_string] = ACTIONS(692),
    [anon_sym_symbol] = ACTIONS(692),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [71] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2829),
    [sym__type] = STATE(3439),
    [sym_constructor_type] = STATE(3439),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3439),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(328),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3439),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3439),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(139),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(161),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(698),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(192),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(700),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(198),
    [anon_sym_number] = ACTIONS(198),
    [anon_sym_boolean] = ACTIONS(198),
    [anon_sym_string] = ACTIONS(198),
    [anon_sym_symbol] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [72] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2829),
    [sym__type] = STATE(3474),
    [sym_constructor_type] = STATE(3474),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3474),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(328),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3474),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3474),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(139),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(161),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(698),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(192),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(700),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(198),
    [anon_sym_number] = ACTIONS(198),
    [anon_sym_boolean] = ACTIONS(198),
    [anon_sym_string] = ACTIONS(198),
    [anon_sym_symbol] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [73] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2829),
    [sym__type] = STATE(3452),
    [sym_constructor_type] = STATE(3452),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3452),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(328),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3452),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3452),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(139),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(161),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(698),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(192),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(700),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(198),
    [anon_sym_number] = ACTIONS(198),
    [anon_sym_boolean] = ACTIONS(198),
    [anon_sym_string] = ACTIONS(198),
    [anon_sym_symbol] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [74] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2829),
    [sym__type] = STATE(3491),
    [sym_constructor_type] = STATE(3491),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3491),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(328),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3491),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3491),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(139),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(161),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(698),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(192),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(700),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(198),
    [anon_sym_number] = ACTIONS(198),
    [anon_sym_boolean] = ACTIONS(198),
    [anon_sym_string] = ACTIONS(198),
    [anon_sym_symbol] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [75] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2829),
    [sym__type] = STATE(3420),
    [sym_constructor_type] = STATE(3420),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3420),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(328),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3420),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3420),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(139),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(161),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(698),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(192),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(700),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(198),
    [anon_sym_number] = ACTIONS(198),
    [anon_sym_boolean] = ACTIONS(198),
    [anon_sym_string] = ACTIONS(198),
    [anon_sym_symbol] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [76] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1659),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3986),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4016),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1777),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3251),
    [sym_pattern] = STATE(3516),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2695),
    [sym_constructor_type] = STATE(2695),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2695),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3784),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2695),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2695),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(706),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(710),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(726),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(728),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(732),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(734),
    [sym_false] = ACTIONS(734),
    [sym_null] = ACTIONS(734),
    [sym_undefined] = ACTIONS(736),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(738),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(742),
    [anon_sym_number] = ACTIONS(742),
    [anon_sym_boolean] = ACTIONS(742),
    [anon_sym_string] = ACTIONS(742),
    [anon_sym_symbol] = ACTIONS(742),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [77] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1650),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4042),
    [sym_string] = STATE(1963),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3659),
    [sym_constructor_type] = STATE(3659),
    [sym__primary_type] = STATE(3184),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3448),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3659),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3659),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(756),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(762),
    [anon_sym_typeof] = ACTIONS(668),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(764),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [sym_number] = ACTIONS(678),
    [sym_this] = ACTIONS(768),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(682),
    [sym_false] = ACTIONS(682),
    [sym_null] = ACTIONS(682),
    [sym_undefined] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(772),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(774),
    [anon_sym_number] = ACTIONS(774),
    [anon_sym_boolean] = ACTIONS(774),
    [anon_sym_string] = ACTIONS(774),
    [anon_sym_symbol] = ACTIONS(774),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [78] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1902),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1942),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3005),
    [sym_constructor_type] = STATE(3005),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3005),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(500),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3005),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3005),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(776),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(782),
    [anon_sym_typeof] = ACTIONS(784),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(792),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(812),
    [sym_this] = ACTIONS(814),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [sym_undefined] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(820),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(822),
    [anon_sym_number] = ACTIONS(822),
    [anon_sym_boolean] = ACTIONS(822),
    [anon_sym_string] = ACTIONS(822),
    [anon_sym_symbol] = ACTIONS(822),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [79] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1492),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1809),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2973),
    [sym_constructor_type] = STATE(2973),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2973),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(505),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2973),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2973),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(830),
    [anon_sym_typeof] = ACTIONS(832),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(838),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(846),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(850),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(852),
    [sym_number] = ACTIONS(854),
    [sym_this] = ACTIONS(856),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(858),
    [sym_false] = ACTIONS(858),
    [sym_null] = ACTIONS(858),
    [sym_undefined] = ACTIONS(860),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(862),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [80] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2000),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1942),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3005),
    [sym_constructor_type] = STATE(3005),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3005),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(328),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3005),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3005),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(866),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(782),
    [anon_sym_typeof] = ACTIONS(872),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(792),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(151),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(812),
    [sym_this] = ACTIONS(814),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [sym_undefined] = ACTIONS(878),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [81] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1306),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1418),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3005),
    [sym_constructor_type] = STATE(3005),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3005),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3005),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3005),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(884),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(886),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(890),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(892),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(894),
    [sym_number] = ACTIONS(896),
    [sym_this] = ACTIONS(898),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(900),
    [sym_false] = ACTIONS(900),
    [sym_null] = ACTIONS(900),
    [sym_undefined] = ACTIONS(902),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(772),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(904),
    [anon_sym_number] = ACTIONS(904),
    [anon_sym_boolean] = ACTIONS(904),
    [anon_sym_string] = ACTIONS(904),
    [anon_sym_symbol] = ACTIONS(904),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [82] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1516),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1809),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2973),
    [sym_constructor_type] = STATE(2973),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2973),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(385),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2973),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2973),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(830),
    [anon_sym_typeof] = ACTIONS(912),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(838),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(922),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(928),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(852),
    [sym_number] = ACTIONS(854),
    [sym_this] = ACTIONS(856),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(858),
    [sym_false] = ACTIONS(858),
    [sym_null] = ACTIONS(858),
    [sym_undefined] = ACTIONS(936),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(938),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(940),
    [anon_sym_number] = ACTIONS(940),
    [anon_sym_boolean] = ACTIONS(940),
    [anon_sym_string] = ACTIONS(940),
    [anon_sym_symbol] = ACTIONS(940),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [83] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2874),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2874),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1177),
    [sym_subscript_expression] = STATE(1177),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2874),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(2084),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_non_null_expression] = STATE(1177),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3187),
    [sym_constructor_type] = STATE(3187),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3187),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(328),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3187),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3187),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_typeof] = ACTIONS(950),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(954),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(151),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(958),
    [sym_number] = ACTIONS(960),
    [sym_this] = ACTIONS(962),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_undefined] = ACTIONS(966),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(968),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(970),
    [anon_sym_number] = ACTIONS(970),
    [anon_sym_boolean] = ACTIONS(970),
    [anon_sym_string] = ACTIONS(970),
    [anon_sym_symbol] = ACTIONS(970),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [84] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1475),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(3343),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(3343),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(3343),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3187),
    [sym_constructor_type] = STATE(3187),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3187),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(457),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3187),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3187),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(972),
    [anon_sym_export] = ACTIONS(974),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(974),
    [anon_sym_namespace] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(980),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(588),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(182),
    [sym_number] = ACTIONS(184),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(190),
    [sym_false] = ACTIONS(190),
    [sym_null] = ACTIONS(190),
    [sym_undefined] = ACTIONS(982),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(974),
    [anon_sym_readonly] = ACTIONS(984),
    [anon_sym_get] = ACTIONS(974),
    [anon_sym_set] = ACTIONS(974),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(974),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_override] = ACTIONS(974),
    [anon_sym_module] = ACTIONS(974),
    [anon_sym_any] = ACTIONS(986),
    [anon_sym_number] = ACTIONS(986),
    [anon_sym_boolean] = ACTIONS(986),
    [anon_sym_string] = ACTIONS(986),
    [anon_sym_symbol] = ACTIONS(986),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [85] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1591),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1418),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3005),
    [sym_constructor_type] = STATE(3005),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3005),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(418),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3005),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3005),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(988),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(886),
    [anon_sym_typeof] = ACTIONS(994),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(890),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1004),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1006),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1010),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(894),
    [sym_number] = ACTIONS(896),
    [sym_this] = ACTIONS(898),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(900),
    [sym_false] = ACTIONS(900),
    [sym_null] = ACTIONS(900),
    [sym_undefined] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(1020),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(1022),
    [anon_sym_number] = ACTIONS(1022),
    [anon_sym_boolean] = ACTIONS(1022),
    [anon_sym_string] = ACTIONS(1022),
    [anon_sym_symbol] = ACTIONS(1022),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [86] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1692),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(2005),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2973),
    [sym_constructor_type] = STATE(2973),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2973),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(332),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2973),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2973),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_typeof] = ACTIONS(1032),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1044),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1046),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1048),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1056),
    [sym_number] = ACTIONS(1058),
    [sym_this] = ACTIONS(1060),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(1062),
    [sym_false] = ACTIONS(1062),
    [sym_null] = ACTIONS(1062),
    [sym_undefined] = ACTIONS(1064),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1066),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1068),
    [anon_sym_number] = ACTIONS(1068),
    [anon_sym_boolean] = ACTIONS(1068),
    [anon_sym_string] = ACTIONS(1068),
    [anon_sym_symbol] = ACTIONS(1068),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [87] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1638),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_nested_identifier] = STATE(4227),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1942),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3318),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3005),
    [sym_constructor_type] = STATE(3005),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3005),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_type_arguments] = STATE(464),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3005),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3005),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1070),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1076),
    [anon_sym_typeof] = ACTIONS(1078),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(792),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1088),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1090),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1092),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(812),
    [sym_this] = ACTIONS(814),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [sym_undefined] = ACTIONS(1100),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1102),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1104),
    [anon_sym_number] = ACTIONS(1104),
    [anon_sym_boolean] = ACTIONS(1104),
    [anon_sym_string] = ACTIONS(1104),
    [anon_sym_symbol] = ACTIONS(1104),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [88] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1374),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(590),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1114),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_COLON] = ACTIONS(1114),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_RBRACK] = ACTIONS(1114),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [89] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1400),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_STAR] = ACTIONS(1128),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(930),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__automatic_semicolon] = ACTIONS(1114),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [90] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1430),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_STAR] = ACTIONS(1138),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__automatic_semicolon] = ACTIONS(1114),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [91] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1575),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_STAR] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
    [anon_sym_satisfies] = ACTIONS(1110),
    [anon_sym_implements] = ACTIONS(1110),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [92] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1661),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1094),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_COLON] = ACTIONS(1114),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_RBRACK] = ACTIONS(1114),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [93] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1823),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__automatic_semicolon] = ACTIONS(1114),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [94] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1951),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_STAR] = ACTIONS(1166),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(804),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [95] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2043),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_STAR] = ACTIONS(1178),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [96] = {
    [sym_declaration] = STATE(3126),
    [sym_import] = STATE(1852),
    [sym_variable_declaration] = STATE(3254),
    [sym_lexical_declaration] = STATE(3254),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1778),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(3254),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(3254),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(3254),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_function_signature] = STATE(3254),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(3254),
    [sym_abstract_class_declaration] = STATE(3254),
    [sym_module] = STATE(3254),
    [sym_internal_module] = STATE(1860),
    [sym_import_alias] = STATE(3254),
    [sym_interface_declaration] = STATE(3254),
    [sym_enum_declaration] = STATE(3254),
    [sym_type_alias_declaration] = STATE(3254),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3262),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(1184),
    [anon_sym_var] = ACTIONS(1186),
    [anon_sym_let] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1190),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(1192),
    [anon_sym_async] = ACTIONS(1194),
    [anon_sym_function] = ACTIONS(1196),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1200),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_abstract] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_enum] = ACTIONS(1206),
  },
  [97] = {
    [sym_declaration] = STATE(739),
    [sym_import] = STATE(1852),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1782),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3357),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1208),
    [anon_sym_namespace] = ACTIONS(1210),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(1212),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1218),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [98] = {
    [sym_declaration] = STATE(739),
    [sym_import] = STATE(1852),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1782),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3186),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1208),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(1212),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1218),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [99] = {
    [sym_declaration] = STATE(748),
    [sym_import] = STATE(1852),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1617),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(159),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3357),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1208),
    [anon_sym_namespace] = ACTIONS(1210),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(1212),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1218),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [100] = {
    [sym_declaration] = STATE(3246),
    [sym_import] = STATE(1852),
    [sym_variable_declaration] = STATE(3254),
    [sym_lexical_declaration] = STATE(3254),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1746),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(3254),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(3254),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(3254),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_function_signature] = STATE(3254),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(3254),
    [sym_abstract_class_declaration] = STATE(3254),
    [sym_module] = STATE(3254),
    [sym_internal_module] = STATE(1860),
    [sym_import_alias] = STATE(3254),
    [sym_interface_declaration] = STATE(3254),
    [sym_enum_declaration] = STATE(3254),
    [sym_type_alias_declaration] = STATE(3254),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3262),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(1184),
    [anon_sym_var] = ACTIONS(1186),
    [anon_sym_let] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1190),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(1192),
    [anon_sym_async] = ACTIONS(1194),
    [anon_sym_function] = ACTIONS(1196),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1200),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_abstract] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_enum] = ACTIONS(1206),
  },
  [101] = {
    [sym_declaration] = STATE(748),
    [sym_import] = STATE(1852),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1617),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_class_declaration] = STATE(674),
    [sym_function] = STATE(1852),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function] = STATE(1852),
    [sym_generator_function_declaration] = STATE(674),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_function_signature] = STATE(674),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(1991),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3186),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1208),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(1212),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1218),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
  },
  [102] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1224),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_RPAREN] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [103] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [104] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(1260),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [105] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [106] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1224),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(1262),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(1262),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [107] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(1269),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [108] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2637),
    [sym_constructor_type] = STATE(2637),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2637),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2637),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2637),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(1273),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_RBRACE] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(1287),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [109] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [110] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(1309),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [111] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(1313),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [112] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1315),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(1317),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [113] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [114] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [115] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1402),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4263),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1323),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(688),
    [anon_sym_private] = ACTIONS(688),
    [anon_sym_protected] = ACTIONS(688),
    [anon_sym_override] = ACTIONS(690),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [116] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1522),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4045),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1323),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(688),
    [anon_sym_private] = ACTIONS(688),
    [anon_sym_protected] = ACTIONS(688),
    [anon_sym_override] = ACTIONS(690),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [117] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3957),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3957),
    [sym_optional_parameter] = STATE(3957),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1329),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1333),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1335),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [118] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3957),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3957),
    [sym_optional_parameter] = STATE(3957),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1337),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1333),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1335),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [119] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3563),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3563),
    [sym_optional_parameter] = STATE(3563),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1333),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1335),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [120] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3957),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3957),
    [sym_optional_parameter] = STATE(3957),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1333),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1335),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [121] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3957),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3957),
    [sym_optional_parameter] = STATE(3957),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1343),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1333),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1335),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [122] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3519),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3519),
    [sym_optional_parameter] = STATE(3519),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1345),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1333),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1335),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [123] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3957),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3957),
    [sym_optional_parameter] = STATE(3957),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1347),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1333),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1335),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [124] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1333),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1335),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [125] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3957),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3957),
    [sym_optional_parameter] = STATE(3957),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1349),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1333),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1335),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [126] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1353),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [127] = {
    [sym_import] = STATE(1852),
    [sym_expression_statement] = STATE(202),
    [sym_variable_declaration] = STATE(202),
    [sym_lexical_declaration] = STATE(202),
    [sym_empty_statement] = STATE(202),
    [sym_parenthesized_expression] = STATE(1134),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(3731),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(3731),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1134),
    [sym_subscript_expression] = STATE(1134),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(3731),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1134),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1355),
    [anon_sym_export] = ACTIONS(1357),
    [anon_sym_type] = ACTIONS(1357),
    [anon_sym_namespace] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(1361),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_var] = ACTIONS(1363),
    [anon_sym_let] = ACTIONS(1365),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1367),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1371),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_readonly] = ACTIONS(1357),
    [anon_sym_get] = ACTIONS(1357),
    [anon_sym_set] = ACTIONS(1357),
    [anon_sym_declare] = ACTIONS(1357),
    [anon_sym_public] = ACTIONS(1357),
    [anon_sym_private] = ACTIONS(1357),
    [anon_sym_protected] = ACTIONS(1357),
    [anon_sym_override] = ACTIONS(1357),
    [anon_sym_module] = ACTIONS(1357),
    [anon_sym_any] = ACTIONS(1357),
    [anon_sym_number] = ACTIONS(1357),
    [anon_sym_boolean] = ACTIONS(1357),
    [anon_sym_string] = ACTIONS(1357),
    [anon_sym_symbol] = ACTIONS(1357),
  },
  [128] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1373),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [129] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1375),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [130] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym__formal_parameter] = STATE(3957),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3366),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(192),
    [sym_override_modifier] = STATE(217),
    [sym_required_parameter] = STATE(3957),
    [sym_optional_parameter] = STATE(3957),
    [sym__parameter_name] = STATE(2829),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1333),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1335),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [131] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1569),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3577),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3584),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1377),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [132] = {
    [sym_statement_block] = STATE(160),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1381),
    [anon_sym_default] = ACTIONS(1381),
    [anon_sym_type] = ACTIONS(1381),
    [anon_sym_as] = ACTIONS(1381),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1383),
    [anon_sym_COMMA] = ACTIONS(1379),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_typeof] = ACTIONS(1381),
    [anon_sym_import] = ACTIONS(1381),
    [anon_sym_var] = ACTIONS(1381),
    [anon_sym_let] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(1379),
    [anon_sym_await] = ACTIONS(1381),
    [anon_sym_in] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_try] = ACTIONS(1381),
    [anon_sym_with] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_debugger] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_throw] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_case] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_LTtemplate_GT] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_DOT] = ACTIONS(1385),
    [anon_sym_class] = ACTIONS(1381),
    [anon_sym_async] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_QMARK_DOT] = ACTIONS(1379),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_AMP_AMP] = ACTIONS(1379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1379),
    [anon_sym_GT_GT] = ACTIONS(1381),
    [anon_sym_GT_GT_GT] = ACTIONS(1379),
    [anon_sym_LT_LT] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1379),
    [anon_sym_STAR_STAR] = ACTIONS(1379),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_LT_EQ] = ACTIONS(1379),
    [anon_sym_EQ_EQ] = ACTIONS(1381),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1381),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1379),
    [anon_sym_QMARK_QMARK] = ACTIONS(1379),
    [anon_sym_instanceof] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_void] = ACTIONS(1381),
    [anon_sym_delete] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_number] = ACTIONS(1379),
    [sym_this] = ACTIONS(1381),
    [sym_super] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_undefined] = ACTIONS(1381),
    [anon_sym_AT] = ACTIONS(1379),
    [anon_sym_static] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(1381),
    [anon_sym_get] = ACTIONS(1381),
    [anon_sym_set] = ACTIONS(1381),
    [anon_sym_declare] = ACTIONS(1381),
    [anon_sym_public] = ACTIONS(1381),
    [anon_sym_private] = ACTIONS(1381),
    [anon_sym_protected] = ACTIONS(1381),
    [anon_sym_override] = ACTIONS(1381),
    [anon_sym_module] = ACTIONS(1381),
    [anon_sym_any] = ACTIONS(1381),
    [anon_sym_number] = ACTIONS(1381),
    [anon_sym_boolean] = ACTIONS(1381),
    [anon_sym_string] = ACTIONS(1381),
    [anon_sym_symbol] = ACTIONS(1381),
    [anon_sym_abstract] = ACTIONS(1381),
    [anon_sym_satisfies] = ACTIONS(1381),
    [anon_sym_interface] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
    [sym__automatic_semicolon] = ACTIONS(1379),
    [sym__ternary_qmark] = ACTIONS(1379),
  },
  [133] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1387),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [134] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3512),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1389),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [135] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1569),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3577),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3584),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1391),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_export] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(1397),
    [anon_sym_default] = ACTIONS(1395),
    [anon_sym_type] = ACTIONS(1395),
    [anon_sym_EQ] = ACTIONS(1399),
    [anon_sym_as] = ACTIONS(1397),
    [anon_sym_namespace] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_COMMA] = ACTIONS(1401),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_typeof] = ACTIONS(1395),
    [anon_sym_import] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1395),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_const] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_else] = ACTIONS(1395),
    [anon_sym_if] = ACTIONS(1395),
    [anon_sym_switch] = ACTIONS(1395),
    [anon_sym_for] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_in] = ACTIONS(1397),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_do] = ACTIONS(1395),
    [anon_sym_try] = ACTIONS(1395),
    [anon_sym_with] = ACTIONS(1395),
    [anon_sym_break] = ACTIONS(1395),
    [anon_sym_continue] = ACTIONS(1395),
    [anon_sym_debugger] = ACTIONS(1395),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_throw] = ACTIONS(1395),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1395),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_LTtemplate_GT] = ACTIONS(1393),
    [anon_sym_GT] = ACTIONS(1397),
    [anon_sym_DOT] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1395),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_function] = ACTIONS(1395),
    [anon_sym_QMARK_DOT] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1395),
    [anon_sym_AMP_AMP] = ACTIONS(1401),
    [anon_sym_PIPE_PIPE] = ACTIONS(1401),
    [anon_sym_GT_GT] = ACTIONS(1397),
    [anon_sym_GT_GT_GT] = ACTIONS(1401),
    [anon_sym_LT_LT] = ACTIONS(1401),
    [anon_sym_AMP] = ACTIONS(1397),
    [anon_sym_CARET] = ACTIONS(1401),
    [anon_sym_PIPE] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(1401),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_LT_EQ] = ACTIONS(1401),
    [anon_sym_EQ_EQ] = ACTIONS(1397),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1401),
    [anon_sym_BANG_EQ] = ACTIONS(1397),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1401),
    [anon_sym_GT_EQ] = ACTIONS(1401),
    [anon_sym_QMARK_QMARK] = ACTIONS(1401),
    [anon_sym_instanceof] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1393),
    [anon_sym_void] = ACTIONS(1395),
    [anon_sym_delete] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1395),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1393),
    [sym_number] = ACTIONS(1393),
    [sym_this] = ACTIONS(1395),
    [sym_super] = ACTIONS(1395),
    [sym_true] = ACTIONS(1395),
    [sym_false] = ACTIONS(1395),
    [sym_null] = ACTIONS(1395),
    [sym_undefined] = ACTIONS(1395),
    [anon_sym_AT] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1395),
    [anon_sym_readonly] = ACTIONS(1395),
    [anon_sym_get] = ACTIONS(1395),
    [anon_sym_set] = ACTIONS(1395),
    [anon_sym_declare] = ACTIONS(1395),
    [anon_sym_public] = ACTIONS(1395),
    [anon_sym_private] = ACTIONS(1395),
    [anon_sym_protected] = ACTIONS(1395),
    [anon_sym_override] = ACTIONS(1395),
    [anon_sym_module] = ACTIONS(1395),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1395),
    [anon_sym_satisfies] = ACTIONS(1397),
    [anon_sym_interface] = ACTIONS(1395),
    [anon_sym_enum] = ACTIONS(1395),
    [sym__automatic_semicolon] = ACTIONS(1403),
    [sym__ternary_qmark] = ACTIONS(1401),
  },
  [137] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1405),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_RBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1405),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(1405),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
    [anon_sym_extends] = ACTIONS(1407),
  },
  [138] = {
    [sym_statement_block] = STATE(160),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1381),
    [anon_sym_default] = ACTIONS(1381),
    [anon_sym_type] = ACTIONS(1381),
    [anon_sym_as] = ACTIONS(1381),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1383),
    [anon_sym_COMMA] = ACTIONS(1379),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_typeof] = ACTIONS(1381),
    [anon_sym_import] = ACTIONS(1381),
    [anon_sym_var] = ACTIONS(1381),
    [anon_sym_let] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(1379),
    [anon_sym_await] = ACTIONS(1381),
    [anon_sym_in] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_try] = ACTIONS(1381),
    [anon_sym_with] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_debugger] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_throw] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_case] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_LTtemplate_GT] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_DOT] = ACTIONS(1381),
    [anon_sym_class] = ACTIONS(1381),
    [anon_sym_async] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_QMARK_DOT] = ACTIONS(1379),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_AMP_AMP] = ACTIONS(1379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1379),
    [anon_sym_GT_GT] = ACTIONS(1381),
    [anon_sym_GT_GT_GT] = ACTIONS(1379),
    [anon_sym_LT_LT] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1379),
    [anon_sym_STAR_STAR] = ACTIONS(1379),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_LT_EQ] = ACTIONS(1379),
    [anon_sym_EQ_EQ] = ACTIONS(1381),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1381),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1379),
    [anon_sym_QMARK_QMARK] = ACTIONS(1379),
    [anon_sym_instanceof] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_void] = ACTIONS(1381),
    [anon_sym_delete] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_number] = ACTIONS(1379),
    [sym_this] = ACTIONS(1381),
    [sym_super] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_undefined] = ACTIONS(1381),
    [anon_sym_AT] = ACTIONS(1379),
    [anon_sym_static] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(1381),
    [anon_sym_get] = ACTIONS(1381),
    [anon_sym_set] = ACTIONS(1381),
    [anon_sym_declare] = ACTIONS(1381),
    [anon_sym_public] = ACTIONS(1381),
    [anon_sym_private] = ACTIONS(1381),
    [anon_sym_protected] = ACTIONS(1381),
    [anon_sym_override] = ACTIONS(1381),
    [anon_sym_module] = ACTIONS(1381),
    [anon_sym_any] = ACTIONS(1381),
    [anon_sym_number] = ACTIONS(1381),
    [anon_sym_boolean] = ACTIONS(1381),
    [anon_sym_string] = ACTIONS(1381),
    [anon_sym_symbol] = ACTIONS(1381),
    [anon_sym_abstract] = ACTIONS(1381),
    [anon_sym_satisfies] = ACTIONS(1381),
    [anon_sym_interface] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
    [sym__automatic_semicolon] = ACTIONS(1379),
    [sym__ternary_qmark] = ACTIONS(1379),
  },
  [139] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1540),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3577),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3584),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1377),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [140] = {
    [sym_import] = STATE(1852),
    [sym_expression_statement] = STATE(196),
    [sym_variable_declaration] = STATE(196),
    [sym_lexical_declaration] = STATE(196),
    [sym_empty_statement] = STATE(196),
    [sym_parenthesized_expression] = STATE(1134),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(3731),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(3731),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1134),
    [sym_subscript_expression] = STATE(1134),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(3731),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1134),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1355),
    [anon_sym_export] = ACTIONS(1357),
    [anon_sym_type] = ACTIONS(1357),
    [anon_sym_namespace] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(1361),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_var] = ACTIONS(1363),
    [anon_sym_let] = ACTIONS(1365),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1367),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1371),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_readonly] = ACTIONS(1357),
    [anon_sym_get] = ACTIONS(1357),
    [anon_sym_set] = ACTIONS(1357),
    [anon_sym_declare] = ACTIONS(1357),
    [anon_sym_public] = ACTIONS(1357),
    [anon_sym_private] = ACTIONS(1357),
    [anon_sym_protected] = ACTIONS(1357),
    [anon_sym_override] = ACTIONS(1357),
    [anon_sym_module] = ACTIONS(1357),
    [anon_sym_any] = ACTIONS(1357),
    [anon_sym_number] = ACTIONS(1357),
    [anon_sym_boolean] = ACTIONS(1357),
    [anon_sym_string] = ACTIONS(1357),
    [anon_sym_symbol] = ACTIONS(1357),
  },
  [141] = {
    [sym_statement_block] = STATE(160),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1381),
    [anon_sym_default] = ACTIONS(1381),
    [anon_sym_type] = ACTIONS(1381),
    [anon_sym_as] = ACTIONS(1381),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1383),
    [anon_sym_COMMA] = ACTIONS(1379),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_typeof] = ACTIONS(1381),
    [anon_sym_import] = ACTIONS(1381),
    [anon_sym_var] = ACTIONS(1381),
    [anon_sym_let] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(1379),
    [anon_sym_await] = ACTIONS(1381),
    [anon_sym_in] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_try] = ACTIONS(1381),
    [anon_sym_with] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_debugger] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_throw] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_case] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_LTtemplate_GT] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_DOT] = ACTIONS(1409),
    [anon_sym_class] = ACTIONS(1381),
    [anon_sym_async] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_QMARK_DOT] = ACTIONS(1379),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_AMP_AMP] = ACTIONS(1379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1379),
    [anon_sym_GT_GT] = ACTIONS(1381),
    [anon_sym_GT_GT_GT] = ACTIONS(1379),
    [anon_sym_LT_LT] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1379),
    [anon_sym_STAR_STAR] = ACTIONS(1379),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_LT_EQ] = ACTIONS(1379),
    [anon_sym_EQ_EQ] = ACTIONS(1381),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1381),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1379),
    [anon_sym_QMARK_QMARK] = ACTIONS(1379),
    [anon_sym_instanceof] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_void] = ACTIONS(1381),
    [anon_sym_delete] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_number] = ACTIONS(1379),
    [sym_this] = ACTIONS(1381),
    [sym_super] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_undefined] = ACTIONS(1381),
    [anon_sym_AT] = ACTIONS(1379),
    [anon_sym_static] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(1381),
    [anon_sym_get] = ACTIONS(1381),
    [anon_sym_set] = ACTIONS(1381),
    [anon_sym_declare] = ACTIONS(1381),
    [anon_sym_public] = ACTIONS(1381),
    [anon_sym_private] = ACTIONS(1381),
    [anon_sym_protected] = ACTIONS(1381),
    [anon_sym_override] = ACTIONS(1381),
    [anon_sym_module] = ACTIONS(1381),
    [anon_sym_any] = ACTIONS(1381),
    [anon_sym_number] = ACTIONS(1381),
    [anon_sym_boolean] = ACTIONS(1381),
    [anon_sym_string] = ACTIONS(1381),
    [anon_sym_symbol] = ACTIONS(1381),
    [anon_sym_abstract] = ACTIONS(1381),
    [anon_sym_satisfies] = ACTIONS(1381),
    [anon_sym_interface] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
    [sym__automatic_semicolon] = ACTIONS(1379),
    [sym__ternary_qmark] = ACTIONS(1379),
  },
  [142] = {
    [ts_builtin_sym_end] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1413),
    [anon_sym_export] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_default] = ACTIONS(1413),
    [anon_sym_type] = ACTIONS(1413),
    [anon_sym_as] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_COMMA] = ACTIONS(1417),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_typeof] = ACTIONS(1413),
    [anon_sym_import] = ACTIONS(1413),
    [anon_sym_var] = ACTIONS(1413),
    [anon_sym_let] = ACTIONS(1413),
    [anon_sym_const] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_else] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_await] = ACTIONS(1413),
    [anon_sym_in] = ACTIONS(1415),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_try] = ACTIONS(1413),
    [anon_sym_with] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_continue] = ACTIONS(1413),
    [anon_sym_debugger] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_throw] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_LTtemplate_GT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_DOT] = ACTIONS(1415),
    [anon_sym_class] = ACTIONS(1413),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_function] = ACTIONS(1413),
    [anon_sym_QMARK_DOT] = ACTIONS(1417),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_AMP_AMP] = ACTIONS(1417),
    [anon_sym_PIPE_PIPE] = ACTIONS(1417),
    [anon_sym_GT_GT] = ACTIONS(1415),
    [anon_sym_GT_GT_GT] = ACTIONS(1417),
    [anon_sym_LT_LT] = ACTIONS(1417),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1417),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1413),
    [anon_sym_PERCENT] = ACTIONS(1417),
    [anon_sym_STAR_STAR] = ACTIONS(1417),
    [anon_sym_LT] = ACTIONS(1413),
    [anon_sym_LT_EQ] = ACTIONS(1417),
    [anon_sym_EQ_EQ] = ACTIONS(1415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1417),
    [anon_sym_BANG_EQ] = ACTIONS(1415),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1417),
    [anon_sym_GT_EQ] = ACTIONS(1417),
    [anon_sym_QMARK_QMARK] = ACTIONS(1417),
    [anon_sym_instanceof] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_void] = ACTIONS(1413),
    [anon_sym_delete] = ACTIONS(1413),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1411),
    [sym_number] = ACTIONS(1411),
    [sym_this] = ACTIONS(1413),
    [sym_super] = ACTIONS(1413),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_undefined] = ACTIONS(1413),
    [anon_sym_AT] = ACTIONS(1411),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(1413),
    [anon_sym_get] = ACTIONS(1413),
    [anon_sym_set] = ACTIONS(1413),
    [anon_sym_declare] = ACTIONS(1413),
    [anon_sym_public] = ACTIONS(1413),
    [anon_sym_private] = ACTIONS(1413),
    [anon_sym_protected] = ACTIONS(1413),
    [anon_sym_override] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_any] = ACTIONS(1413),
    [anon_sym_number] = ACTIONS(1413),
    [anon_sym_boolean] = ACTIONS(1413),
    [anon_sym_string] = ACTIONS(1413),
    [anon_sym_symbol] = ACTIONS(1413),
    [anon_sym_abstract] = ACTIONS(1413),
    [anon_sym_satisfies] = ACTIONS(1415),
    [anon_sym_interface] = ACTIONS(1413),
    [anon_sym_enum] = ACTIONS(1413),
    [sym__automatic_semicolon] = ACTIONS(1419),
    [sym__ternary_qmark] = ACTIONS(1417),
  },
  [143] = {
    [ts_builtin_sym_end] = ACTIONS(1421),
    [sym_identifier] = ACTIONS(1423),
    [anon_sym_export] = ACTIONS(1423),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_default] = ACTIONS(1423),
    [anon_sym_type] = ACTIONS(1423),
    [anon_sym_as] = ACTIONS(1423),
    [anon_sym_namespace] = ACTIONS(1423),
    [anon_sym_LBRACE] = ACTIONS(1421),
    [anon_sym_COMMA] = ACTIONS(1421),
    [anon_sym_RBRACE] = ACTIONS(1421),
    [anon_sym_typeof] = ACTIONS(1423),
    [anon_sym_import] = ACTIONS(1423),
    [anon_sym_var] = ACTIONS(1423),
    [anon_sym_let] = ACTIONS(1423),
    [anon_sym_const] = ACTIONS(1423),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_else] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(1423),
    [anon_sym_switch] = ACTIONS(1423),
    [anon_sym_for] = ACTIONS(1423),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_in] = ACTIONS(1423),
    [anon_sym_while] = ACTIONS(1423),
    [anon_sym_do] = ACTIONS(1423),
    [anon_sym_try] = ACTIONS(1423),
    [anon_sym_with] = ACTIONS(1423),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_continue] = ACTIONS(1423),
    [anon_sym_debugger] = ACTIONS(1423),
    [anon_sym_return] = ACTIONS(1423),
    [anon_sym_throw] = ACTIONS(1423),
    [anon_sym_SEMI] = ACTIONS(1421),
    [anon_sym_case] = ACTIONS(1423),
    [anon_sym_yield] = ACTIONS(1423),
    [anon_sym_LBRACK] = ACTIONS(1421),
    [anon_sym_LTtemplate_GT] = ACTIONS(1421),
    [anon_sym_GT] = ACTIONS(1423),
    [anon_sym_DOT] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1423),
    [anon_sym_async] = ACTIONS(1423),
    [anon_sym_function] = ACTIONS(1423),
    [anon_sym_QMARK_DOT] = ACTIONS(1421),
    [anon_sym_new] = ACTIONS(1423),
    [anon_sym_AMP_AMP] = ACTIONS(1421),
    [anon_sym_PIPE_PIPE] = ACTIONS(1421),
    [anon_sym_GT_GT] = ACTIONS(1423),
    [anon_sym_GT_GT_GT] = ACTIONS(1421),
    [anon_sym_LT_LT] = ACTIONS(1421),
    [anon_sym_AMP] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(1423),
    [anon_sym_PLUS] = ACTIONS(1423),
    [anon_sym_DASH] = ACTIONS(1423),
    [anon_sym_SLASH] = ACTIONS(1423),
    [anon_sym_PERCENT] = ACTIONS(1421),
    [anon_sym_STAR_STAR] = ACTIONS(1421),
    [anon_sym_LT] = ACTIONS(1423),
    [anon_sym_LT_EQ] = ACTIONS(1421),
    [anon_sym_EQ_EQ] = ACTIONS(1423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1421),
    [anon_sym_BANG_EQ] = ACTIONS(1423),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1421),
    [anon_sym_GT_EQ] = ACTIONS(1421),
    [anon_sym_QMARK_QMARK] = ACTIONS(1421),
    [anon_sym_instanceof] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1423),
    [anon_sym_delete] = ACTIONS(1423),
    [anon_sym_PLUS_PLUS] = ACTIONS(1421),
    [anon_sym_DASH_DASH] = ACTIONS(1423),
    [anon_sym_DQUOTE] = ACTIONS(1421),
    [anon_sym_SQUOTE] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1421),
    [sym_number] = ACTIONS(1421),
    [sym_this] = ACTIONS(1423),
    [sym_super] = ACTIONS(1423),
    [sym_true] = ACTIONS(1423),
    [sym_false] = ACTIONS(1423),
    [sym_null] = ACTIONS(1423),
    [sym_undefined] = ACTIONS(1423),
    [anon_sym_AT] = ACTIONS(1421),
    [anon_sym_static] = ACTIONS(1423),
    [anon_sym_readonly] = ACTIONS(1423),
    [anon_sym_get] = ACTIONS(1423),
    [anon_sym_set] = ACTIONS(1423),
    [anon_sym_declare] = ACTIONS(1423),
    [anon_sym_public] = ACTIONS(1423),
    [anon_sym_private] = ACTIONS(1423),
    [anon_sym_protected] = ACTIONS(1423),
    [anon_sym_override] = ACTIONS(1423),
    [anon_sym_module] = ACTIONS(1423),
    [anon_sym_any] = ACTIONS(1423),
    [anon_sym_number] = ACTIONS(1423),
    [anon_sym_boolean] = ACTIONS(1423),
    [anon_sym_string] = ACTIONS(1423),
    [anon_sym_symbol] = ACTIONS(1423),
    [anon_sym_abstract] = ACTIONS(1423),
    [anon_sym_satisfies] = ACTIONS(1423),
    [anon_sym_interface] = ACTIONS(1423),
    [anon_sym_enum] = ACTIONS(1423),
    [sym__automatic_semicolon] = ACTIONS(1421),
    [sym__ternary_qmark] = ACTIONS(1421),
  },
  [144] = {
    [ts_builtin_sym_end] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_export] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_default] = ACTIONS(1395),
    [anon_sym_type] = ACTIONS(1395),
    [anon_sym_as] = ACTIONS(1395),
    [anon_sym_namespace] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_COMMA] = ACTIONS(1393),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_typeof] = ACTIONS(1395),
    [anon_sym_import] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1395),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_const] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_else] = ACTIONS(1395),
    [anon_sym_if] = ACTIONS(1395),
    [anon_sym_switch] = ACTIONS(1395),
    [anon_sym_for] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_in] = ACTIONS(1395),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_do] = ACTIONS(1395),
    [anon_sym_try] = ACTIONS(1395),
    [anon_sym_with] = ACTIONS(1395),
    [anon_sym_break] = ACTIONS(1395),
    [anon_sym_continue] = ACTIONS(1395),
    [anon_sym_debugger] = ACTIONS(1395),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_throw] = ACTIONS(1395),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1395),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_LTtemplate_GT] = ACTIONS(1393),
    [anon_sym_GT] = ACTIONS(1395),
    [anon_sym_DOT] = ACTIONS(1395),
    [anon_sym_class] = ACTIONS(1395),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_function] = ACTIONS(1395),
    [anon_sym_QMARK_DOT] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1395),
    [anon_sym_AMP_AMP] = ACTIONS(1393),
    [anon_sym_PIPE_PIPE] = ACTIONS(1393),
    [anon_sym_GT_GT] = ACTIONS(1395),
    [anon_sym_GT_GT_GT] = ACTIONS(1393),
    [anon_sym_LT_LT] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_CARET] = ACTIONS(1393),
    [anon_sym_PIPE] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1393),
    [anon_sym_STAR_STAR] = ACTIONS(1393),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_LT_EQ] = ACTIONS(1393),
    [anon_sym_EQ_EQ] = ACTIONS(1395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1393),
    [anon_sym_BANG_EQ] = ACTIONS(1395),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1393),
    [anon_sym_GT_EQ] = ACTIONS(1393),
    [anon_sym_QMARK_QMARK] = ACTIONS(1393),
    [anon_sym_instanceof] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1393),
    [anon_sym_void] = ACTIONS(1395),
    [anon_sym_delete] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1395),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1393),
    [sym_number] = ACTIONS(1393),
    [sym_this] = ACTIONS(1395),
    [sym_super] = ACTIONS(1395),
    [sym_true] = ACTIONS(1395),
    [sym_false] = ACTIONS(1395),
    [sym_null] = ACTIONS(1395),
    [sym_undefined] = ACTIONS(1395),
    [anon_sym_AT] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1395),
    [anon_sym_readonly] = ACTIONS(1395),
    [anon_sym_get] = ACTIONS(1395),
    [anon_sym_set] = ACTIONS(1395),
    [anon_sym_declare] = ACTIONS(1395),
    [anon_sym_public] = ACTIONS(1395),
    [anon_sym_private] = ACTIONS(1395),
    [anon_sym_protected] = ACTIONS(1395),
    [anon_sym_override] = ACTIONS(1395),
    [anon_sym_module] = ACTIONS(1395),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1395),
    [anon_sym_satisfies] = ACTIONS(1395),
    [anon_sym_interface] = ACTIONS(1395),
    [anon_sym_enum] = ACTIONS(1395),
    [sym__automatic_semicolon] = ACTIONS(1425),
    [sym__ternary_qmark] = ACTIONS(1393),
  },
  [145] = {
    [ts_builtin_sym_end] = ACTIONS(1427),
    [sym_identifier] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1429),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_type] = ACTIONS(1429),
    [anon_sym_as] = ACTIONS(1431),
    [anon_sym_namespace] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_RBRACE] = ACTIONS(1427),
    [anon_sym_typeof] = ACTIONS(1429),
    [anon_sym_import] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1429),
    [anon_sym_let] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_else] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_await] = ACTIONS(1429),
    [anon_sym_in] = ACTIONS(1431),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_try] = ACTIONS(1429),
    [anon_sym_with] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_continue] = ACTIONS(1429),
    [anon_sym_debugger] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LTtemplate_GT] = ACTIONS(1427),
    [anon_sym_GT] = ACTIONS(1431),
    [anon_sym_DOT] = ACTIONS(1431),
    [anon_sym_class] = ACTIONS(1429),
    [anon_sym_async] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1429),
    [anon_sym_QMARK_DOT] = ACTIONS(1433),
    [anon_sym_new] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1433),
    [anon_sym_GT_GT] = ACTIONS(1431),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1431),
    [anon_sym_CARET] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_DASH] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1433),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_LT_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ] = ACTIONS(1431),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1433),
    [anon_sym_BANG_EQ] = ACTIONS(1431),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1433),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_QMARK_QMARK] = ACTIONS(1433),
    [anon_sym_instanceof] = ACTIONS(1431),
    [anon_sym_TILDE] = ACTIONS(1427),
    [anon_sym_void] = ACTIONS(1429),
    [anon_sym_delete] = ACTIONS(1429),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1429),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1427),
    [sym_number] = ACTIONS(1427),
    [sym_this] = ACTIONS(1429),
    [sym_super] = ACTIONS(1429),
    [sym_true] = ACTIONS(1429),
    [sym_false] = ACTIONS(1429),
    [sym_null] = ACTIONS(1429),
    [sym_undefined] = ACTIONS(1429),
    [anon_sym_AT] = ACTIONS(1427),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_readonly] = ACTIONS(1429),
    [anon_sym_get] = ACTIONS(1429),
    [anon_sym_set] = ACTIONS(1429),
    [anon_sym_declare] = ACTIONS(1429),
    [anon_sym_public] = ACTIONS(1429),
    [anon_sym_private] = ACTIONS(1429),
    [anon_sym_protected] = ACTIONS(1429),
    [anon_sym_override] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1429),
    [anon_sym_any] = ACTIONS(1429),
    [anon_sym_number] = ACTIONS(1429),
    [anon_sym_boolean] = ACTIONS(1429),
    [anon_sym_string] = ACTIONS(1429),
    [anon_sym_symbol] = ACTIONS(1429),
    [anon_sym_abstract] = ACTIONS(1429),
    [anon_sym_satisfies] = ACTIONS(1431),
    [anon_sym_interface] = ACTIONS(1429),
    [anon_sym_enum] = ACTIONS(1429),
    [sym__automatic_semicolon] = ACTIONS(1435),
    [sym__ternary_qmark] = ACTIONS(1433),
  },
  [146] = {
    [ts_builtin_sym_end] = ACTIONS(1437),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_export] = ACTIONS(1439),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_default] = ACTIONS(1439),
    [anon_sym_type] = ACTIONS(1439),
    [anon_sym_as] = ACTIONS(1439),
    [anon_sym_namespace] = ACTIONS(1439),
    [anon_sym_LBRACE] = ACTIONS(1437),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_typeof] = ACTIONS(1439),
    [anon_sym_import] = ACTIONS(1439),
    [anon_sym_var] = ACTIONS(1439),
    [anon_sym_let] = ACTIONS(1439),
    [anon_sym_const] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_else] = ACTIONS(1439),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_switch] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1439),
    [anon_sym_LPAREN] = ACTIONS(1437),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_in] = ACTIONS(1439),
    [anon_sym_while] = ACTIONS(1439),
    [anon_sym_do] = ACTIONS(1439),
    [anon_sym_try] = ACTIONS(1439),
    [anon_sym_with] = ACTIONS(1439),
    [anon_sym_break] = ACTIONS(1439),
    [anon_sym_continue] = ACTIONS(1439),
    [anon_sym_debugger] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1439),
    [anon_sym_throw] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_case] = ACTIONS(1439),
    [anon_sym_yield] = ACTIONS(1439),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_LTtemplate_GT] = ACTIONS(1437),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_class] = ACTIONS(1439),
    [anon_sym_async] = ACTIONS(1439),
    [anon_sym_function] = ACTIONS(1439),
    [anon_sym_QMARK_DOT] = ACTIONS(1437),
    [anon_sym_new] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_GT_GT_GT] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1439),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1437),
    [anon_sym_STAR_STAR] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1437),
    [anon_sym_BANG_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1437),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_QMARK_QMARK] = ACTIONS(1437),
    [anon_sym_instanceof] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(1437),
    [anon_sym_void] = ACTIONS(1439),
    [anon_sym_delete] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1437),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_SQUOTE] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [sym_number] = ACTIONS(1437),
    [sym_this] = ACTIONS(1439),
    [sym_super] = ACTIONS(1439),
    [sym_true] = ACTIONS(1439),
    [sym_false] = ACTIONS(1439),
    [sym_null] = ACTIONS(1439),
    [sym_undefined] = ACTIONS(1439),
    [anon_sym_AT] = ACTIONS(1437),
    [anon_sym_static] = ACTIONS(1439),
    [anon_sym_readonly] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(1439),
    [anon_sym_set] = ACTIONS(1439),
    [anon_sym_declare] = ACTIONS(1439),
    [anon_sym_public] = ACTIONS(1439),
    [anon_sym_private] = ACTIONS(1439),
    [anon_sym_protected] = ACTIONS(1439),
    [anon_sym_override] = ACTIONS(1439),
    [anon_sym_module] = ACTIONS(1439),
    [anon_sym_any] = ACTIONS(1439),
    [anon_sym_number] = ACTIONS(1439),
    [anon_sym_boolean] = ACTIONS(1439),
    [anon_sym_string] = ACTIONS(1439),
    [anon_sym_symbol] = ACTIONS(1439),
    [anon_sym_abstract] = ACTIONS(1439),
    [anon_sym_satisfies] = ACTIONS(1439),
    [anon_sym_interface] = ACTIONS(1439),
    [anon_sym_enum] = ACTIONS(1439),
    [sym__automatic_semicolon] = ACTIONS(1437),
    [sym__ternary_qmark] = ACTIONS(1437),
  },
  [147] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1878),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(3533),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(3533),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1171),
    [sym_subscript_expression] = STATE(1171),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(3533),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1171),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_mapped_type_clause] = STATE(4010),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(1441),
    [anon_sym_export] = ACTIONS(1443),
    [anon_sym_type] = ACTIONS(1443),
    [anon_sym_namespace] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_RBRACK] = ACTIONS(1453),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1457),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1443),
    [anon_sym_readonly] = ACTIONS(1443),
    [anon_sym_get] = ACTIONS(1443),
    [anon_sym_set] = ACTIONS(1443),
    [anon_sym_declare] = ACTIONS(1443),
    [anon_sym_public] = ACTIONS(1443),
    [anon_sym_private] = ACTIONS(1443),
    [anon_sym_protected] = ACTIONS(1443),
    [anon_sym_override] = ACTIONS(1443),
    [anon_sym_module] = ACTIONS(1443),
    [anon_sym_any] = ACTIONS(1443),
    [anon_sym_number] = ACTIONS(1443),
    [anon_sym_boolean] = ACTIONS(1443),
    [anon_sym_string] = ACTIONS(1443),
    [anon_sym_symbol] = ACTIONS(1443),
  },
  [148] = {
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1461),
    [anon_sym_export] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_as] = ACTIONS(1461),
    [anon_sym_namespace] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_typeof] = ACTIONS(1461),
    [anon_sym_import] = ACTIONS(1461),
    [anon_sym_var] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_BANG] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_await] = ACTIONS(1461),
    [anon_sym_in] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_try] = ACTIONS(1461),
    [anon_sym_with] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_debugger] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_throw] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_yield] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LTtemplate_GT] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1461),
    [anon_sym_class] = ACTIONS(1461),
    [anon_sym_async] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1461),
    [anon_sym_QMARK_DOT] = ACTIONS(1459),
    [anon_sym_new] = ACTIONS(1461),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1461),
    [anon_sym_GT_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1461),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_SLASH] = ACTIONS(1461),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_STAR_STAR] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1461),
    [anon_sym_LT_EQ] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1459),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1459),
    [anon_sym_GT_EQ] = ACTIONS(1459),
    [anon_sym_QMARK_QMARK] = ACTIONS(1459),
    [anon_sym_instanceof] = ACTIONS(1461),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_void] = ACTIONS(1461),
    [anon_sym_delete] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1461),
    [sym_super] = ACTIONS(1461),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_undefined] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_get] = ACTIONS(1461),
    [anon_sym_set] = ACTIONS(1461),
    [anon_sym_declare] = ACTIONS(1461),
    [anon_sym_public] = ACTIONS(1461),
    [anon_sym_private] = ACTIONS(1461),
    [anon_sym_protected] = ACTIONS(1461),
    [anon_sym_override] = ACTIONS(1461),
    [anon_sym_module] = ACTIONS(1461),
    [anon_sym_any] = ACTIONS(1461),
    [anon_sym_number] = ACTIONS(1461),
    [anon_sym_boolean] = ACTIONS(1461),
    [anon_sym_string] = ACTIONS(1461),
    [anon_sym_symbol] = ACTIONS(1461),
    [anon_sym_abstract] = ACTIONS(1461),
    [anon_sym_satisfies] = ACTIONS(1461),
    [anon_sym_interface] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
    [sym__automatic_semicolon] = ACTIONS(1459),
    [sym__ternary_qmark] = ACTIONS(1459),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1465),
    [anon_sym_export] = ACTIONS(1465),
    [anon_sym_STAR] = ACTIONS(1467),
    [anon_sym_default] = ACTIONS(1465),
    [anon_sym_type] = ACTIONS(1465),
    [anon_sym_as] = ACTIONS(1467),
    [anon_sym_namespace] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1469),
    [anon_sym_RBRACE] = ACTIONS(1463),
    [anon_sym_typeof] = ACTIONS(1465),
    [anon_sym_import] = ACTIONS(1465),
    [anon_sym_var] = ACTIONS(1465),
    [anon_sym_let] = ACTIONS(1465),
    [anon_sym_const] = ACTIONS(1465),
    [anon_sym_BANG] = ACTIONS(1465),
    [anon_sym_else] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_switch] = ACTIONS(1465),
    [anon_sym_for] = ACTIONS(1465),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_in] = ACTIONS(1467),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_try] = ACTIONS(1465),
    [anon_sym_with] = ACTIONS(1465),
    [anon_sym_break] = ACTIONS(1465),
    [anon_sym_continue] = ACTIONS(1465),
    [anon_sym_debugger] = ACTIONS(1465),
    [anon_sym_return] = ACTIONS(1465),
    [anon_sym_throw] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_case] = ACTIONS(1465),
    [anon_sym_yield] = ACTIONS(1465),
    [anon_sym_LBRACK] = ACTIONS(1463),
    [anon_sym_LTtemplate_GT] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1467),
    [anon_sym_DOT] = ACTIONS(1467),
    [anon_sym_class] = ACTIONS(1465),
    [anon_sym_async] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(1465),
    [anon_sym_QMARK_DOT] = ACTIONS(1469),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_AMP_AMP] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE] = ACTIONS(1469),
    [anon_sym_GT_GT] = ACTIONS(1467),
    [anon_sym_GT_GT_GT] = ACTIONS(1469),
    [anon_sym_LT_LT] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1467),
    [anon_sym_CARET] = ACTIONS(1469),
    [anon_sym_PIPE] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1465),
    [anon_sym_DASH] = ACTIONS(1465),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1469),
    [anon_sym_STAR_STAR] = ACTIONS(1469),
    [anon_sym_LT] = ACTIONS(1465),
    [anon_sym_LT_EQ] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1469),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1469),
    [anon_sym_GT_EQ] = ACTIONS(1469),
    [anon_sym_QMARK_QMARK] = ACTIONS(1469),
    [anon_sym_instanceof] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(1463),
    [anon_sym_void] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(1465),
    [anon_sym_PLUS_PLUS] = ACTIONS(1463),
    [anon_sym_DASH_DASH] = ACTIONS(1465),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [sym_number] = ACTIONS(1463),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(1465),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_undefined] = ACTIONS(1465),
    [anon_sym_AT] = ACTIONS(1463),
    [anon_sym_static] = ACTIONS(1465),
    [anon_sym_readonly] = ACTIONS(1465),
    [anon_sym_get] = ACTIONS(1465),
    [anon_sym_set] = ACTIONS(1465),
    [anon_sym_declare] = ACTIONS(1465),
    [anon_sym_public] = ACTIONS(1465),
    [anon_sym_private] = ACTIONS(1465),
    [anon_sym_protected] = ACTIONS(1465),
    [anon_sym_override] = ACTIONS(1465),
    [anon_sym_module] = ACTIONS(1465),
    [anon_sym_any] = ACTIONS(1465),
    [anon_sym_number] = ACTIONS(1465),
    [anon_sym_boolean] = ACTIONS(1465),
    [anon_sym_string] = ACTIONS(1465),
    [anon_sym_symbol] = ACTIONS(1465),
    [anon_sym_abstract] = ACTIONS(1465),
    [anon_sym_satisfies] = ACTIONS(1467),
    [anon_sym_interface] = ACTIONS(1465),
    [anon_sym_enum] = ACTIONS(1465),
    [sym__automatic_semicolon] = ACTIONS(1471),
    [sym__ternary_qmark] = ACTIONS(1469),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(1473),
    [sym_identifier] = ACTIONS(1475),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_default] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1473),
    [anon_sym_COMMA] = ACTIONS(1473),
    [anon_sym_RBRACE] = ACTIONS(1473),
    [anon_sym_typeof] = ACTIONS(1475),
    [anon_sym_import] = ACTIONS(1475),
    [anon_sym_var] = ACTIONS(1475),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_const] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_else] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(1475),
    [anon_sym_switch] = ACTIONS(1475),
    [anon_sym_for] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_await] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(1475),
    [anon_sym_while] = ACTIONS(1475),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1475),
    [anon_sym_with] = ACTIONS(1475),
    [anon_sym_break] = ACTIONS(1475),
    [anon_sym_continue] = ACTIONS(1475),
    [anon_sym_debugger] = ACTIONS(1475),
    [anon_sym_return] = ACTIONS(1475),
    [anon_sym_throw] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(1475),
    [anon_sym_yield] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(1473),
    [anon_sym_LTtemplate_GT] = ACTIONS(1473),
    [anon_sym_GT] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(1475),
    [anon_sym_class] = ACTIONS(1475),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_function] = ACTIONS(1475),
    [anon_sym_QMARK_DOT] = ACTIONS(1473),
    [anon_sym_new] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1475),
    [anon_sym_GT_GT_GT] = ACTIONS(1473),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_CARET] = ACTIONS(1473),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(1475),
    [anon_sym_PERCENT] = ACTIONS(1473),
    [anon_sym_STAR_STAR] = ACTIONS(1473),
    [anon_sym_LT] = ACTIONS(1475),
    [anon_sym_LT_EQ] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1473),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1473),
    [anon_sym_GT_EQ] = ACTIONS(1473),
    [anon_sym_QMARK_QMARK] = ACTIONS(1473),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1473),
    [anon_sym_void] = ACTIONS(1475),
    [anon_sym_delete] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1473),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1473),
    [sym_number] = ACTIONS(1473),
    [sym_this] = ACTIONS(1475),
    [sym_super] = ACTIONS(1475),
    [sym_true] = ACTIONS(1475),
    [sym_false] = ACTIONS(1475),
    [sym_null] = ACTIONS(1475),
    [sym_undefined] = ACTIONS(1475),
    [anon_sym_AT] = ACTIONS(1473),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_abstract] = ACTIONS(1475),
    [anon_sym_satisfies] = ACTIONS(1475),
    [anon_sym_interface] = ACTIONS(1475),
    [anon_sym_enum] = ACTIONS(1475),
    [sym__automatic_semicolon] = ACTIONS(1473),
    [sym__ternary_qmark] = ACTIONS(1473),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(1479),
    [anon_sym_export] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_default] = ACTIONS(1479),
    [anon_sym_type] = ACTIONS(1479),
    [anon_sym_as] = ACTIONS(1479),
    [anon_sym_namespace] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_typeof] = ACTIONS(1479),
    [anon_sym_import] = ACTIONS(1479),
    [anon_sym_var] = ACTIONS(1479),
    [anon_sym_let] = ACTIONS(1479),
    [anon_sym_const] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_switch] = ACTIONS(1479),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_await] = ACTIONS(1479),
    [anon_sym_in] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1479),
    [anon_sym_do] = ACTIONS(1479),
    [anon_sym_try] = ACTIONS(1479),
    [anon_sym_with] = ACTIONS(1479),
    [anon_sym_break] = ACTIONS(1479),
    [anon_sym_continue] = ACTIONS(1479),
    [anon_sym_debugger] = ACTIONS(1479),
    [anon_sym_return] = ACTIONS(1479),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_case] = ACTIONS(1479),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_LTtemplate_GT] = ACTIONS(1477),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(1479),
    [anon_sym_function] = ACTIONS(1479),
    [anon_sym_QMARK_DOT] = ACTIONS(1477),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE] = ACTIONS(1477),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_GT_GT_GT] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1477),
    [anon_sym_STAR_STAR] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_EQ_EQ] = ACTIONS(1479),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1477),
    [anon_sym_BANG_EQ] = ACTIONS(1479),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1477),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK_QMARK] = ACTIONS(1477),
    [anon_sym_instanceof] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1477),
    [anon_sym_void] = ACTIONS(1479),
    [anon_sym_delete] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_SQUOTE] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1477),
    [sym_number] = ACTIONS(1477),
    [sym_this] = ACTIONS(1479),
    [sym_super] = ACTIONS(1479),
    [sym_true] = ACTIONS(1479),
    [sym_false] = ACTIONS(1479),
    [sym_null] = ACTIONS(1479),
    [sym_undefined] = ACTIONS(1479),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_static] = ACTIONS(1479),
    [anon_sym_readonly] = ACTIONS(1479),
    [anon_sym_get] = ACTIONS(1479),
    [anon_sym_set] = ACTIONS(1479),
    [anon_sym_declare] = ACTIONS(1479),
    [anon_sym_public] = ACTIONS(1479),
    [anon_sym_private] = ACTIONS(1479),
    [anon_sym_protected] = ACTIONS(1479),
    [anon_sym_override] = ACTIONS(1479),
    [anon_sym_module] = ACTIONS(1479),
    [anon_sym_any] = ACTIONS(1479),
    [anon_sym_number] = ACTIONS(1479),
    [anon_sym_boolean] = ACTIONS(1479),
    [anon_sym_string] = ACTIONS(1479),
    [anon_sym_symbol] = ACTIONS(1479),
    [anon_sym_abstract] = ACTIONS(1479),
    [anon_sym_satisfies] = ACTIONS(1479),
    [anon_sym_interface] = ACTIONS(1479),
    [anon_sym_enum] = ACTIONS(1479),
    [sym__automatic_semicolon] = ACTIONS(1477),
    [sym__ternary_qmark] = ACTIONS(1477),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(1481),
    [sym_identifier] = ACTIONS(1483),
    [anon_sym_export] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1483),
    [anon_sym_default] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(1483),
    [anon_sym_as] = ACTIONS(1483),
    [anon_sym_namespace] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(1481),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym_RBRACE] = ACTIONS(1481),
    [anon_sym_typeof] = ACTIONS(1483),
    [anon_sym_import] = ACTIONS(1483),
    [anon_sym_var] = ACTIONS(1483),
    [anon_sym_let] = ACTIONS(1483),
    [anon_sym_const] = ACTIONS(1483),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_else] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(1483),
    [anon_sym_switch] = ACTIONS(1483),
    [anon_sym_for] = ACTIONS(1483),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_in] = ACTIONS(1483),
    [anon_sym_while] = ACTIONS(1483),
    [anon_sym_do] = ACTIONS(1483),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1483),
    [anon_sym_break] = ACTIONS(1483),
    [anon_sym_continue] = ACTIONS(1483),
    [anon_sym_debugger] = ACTIONS(1483),
    [anon_sym_return] = ACTIONS(1483),
    [anon_sym_throw] = ACTIONS(1483),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_case] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1483),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_LTtemplate_GT] = ACTIONS(1481),
    [anon_sym_GT] = ACTIONS(1483),
    [anon_sym_DOT] = ACTIONS(1483),
    [anon_sym_class] = ACTIONS(1483),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_QMARK_DOT] = ACTIONS(1481),
    [anon_sym_new] = ACTIONS(1483),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [anon_sym_GT_GT] = ACTIONS(1483),
    [anon_sym_GT_GT_GT] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_PIPE] = ACTIONS(1483),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(1483),
    [anon_sym_PERCENT] = ACTIONS(1481),
    [anon_sym_STAR_STAR] = ACTIONS(1481),
    [anon_sym_LT] = ACTIONS(1483),
    [anon_sym_LT_EQ] = ACTIONS(1481),
    [anon_sym_EQ_EQ] = ACTIONS(1483),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(1483),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1481),
    [anon_sym_GT_EQ] = ACTIONS(1481),
    [anon_sym_QMARK_QMARK] = ACTIONS(1481),
    [anon_sym_instanceof] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1483),
    [anon_sym_delete] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_DQUOTE] = ACTIONS(1481),
    [anon_sym_SQUOTE] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1481),
    [sym_number] = ACTIONS(1481),
    [sym_this] = ACTIONS(1483),
    [sym_super] = ACTIONS(1483),
    [sym_true] = ACTIONS(1483),
    [sym_false] = ACTIONS(1483),
    [sym_null] = ACTIONS(1483),
    [sym_undefined] = ACTIONS(1483),
    [anon_sym_AT] = ACTIONS(1481),
    [anon_sym_static] = ACTIONS(1483),
    [anon_sym_readonly] = ACTIONS(1483),
    [anon_sym_get] = ACTIONS(1483),
    [anon_sym_set] = ACTIONS(1483),
    [anon_sym_declare] = ACTIONS(1483),
    [anon_sym_public] = ACTIONS(1483),
    [anon_sym_private] = ACTIONS(1483),
    [anon_sym_protected] = ACTIONS(1483),
    [anon_sym_override] = ACTIONS(1483),
    [anon_sym_module] = ACTIONS(1483),
    [anon_sym_any] = ACTIONS(1483),
    [anon_sym_number] = ACTIONS(1483),
    [anon_sym_boolean] = ACTIONS(1483),
    [anon_sym_string] = ACTIONS(1483),
    [anon_sym_symbol] = ACTIONS(1483),
    [anon_sym_abstract] = ACTIONS(1483),
    [anon_sym_satisfies] = ACTIONS(1483),
    [anon_sym_interface] = ACTIONS(1483),
    [anon_sym_enum] = ACTIONS(1483),
    [sym__automatic_semicolon] = ACTIONS(1481),
    [sym__ternary_qmark] = ACTIONS(1481),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(1485),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_STAR] = ACTIONS(1489),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_as] = ACTIONS(1489),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1485),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_import] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_let] = ACTIONS(1487),
    [anon_sym_const] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_await] = ACTIONS(1487),
    [anon_sym_in] = ACTIONS(1489),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_try] = ACTIONS(1487),
    [anon_sym_with] = ACTIONS(1487),
    [anon_sym_break] = ACTIONS(1487),
    [anon_sym_continue] = ACTIONS(1487),
    [anon_sym_debugger] = ACTIONS(1487),
    [anon_sym_return] = ACTIONS(1487),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_case] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [anon_sym_LTtemplate_GT] = ACTIONS(1485),
    [anon_sym_GT] = ACTIONS(1489),
    [anon_sym_DOT] = ACTIONS(1489),
    [anon_sym_class] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_QMARK_DOT] = ACTIONS(1491),
    [anon_sym_new] = ACTIONS(1487),
    [anon_sym_AMP_AMP] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE] = ACTIONS(1491),
    [anon_sym_GT_GT] = ACTIONS(1489),
    [anon_sym_GT_GT_GT] = ACTIONS(1491),
    [anon_sym_LT_LT] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1489),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1489),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(1491),
    [anon_sym_STAR_STAR] = ACTIONS(1491),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_LT_EQ] = ACTIONS(1491),
    [anon_sym_EQ_EQ] = ACTIONS(1489),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1491),
    [anon_sym_BANG_EQ] = ACTIONS(1489),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1491),
    [anon_sym_GT_EQ] = ACTIONS(1491),
    [anon_sym_QMARK_QMARK] = ACTIONS(1491),
    [anon_sym_instanceof] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1485),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_DASH_DASH] = ACTIONS(1487),
    [anon_sym_DQUOTE] = ACTIONS(1485),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1485),
    [sym_number] = ACTIONS(1485),
    [sym_this] = ACTIONS(1487),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_readonly] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_override] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_satisfies] = ACTIONS(1489),
    [anon_sym_interface] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
    [sym__automatic_semicolon] = ACTIONS(1493),
    [sym__ternary_qmark] = ACTIONS(1491),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1461),
    [anon_sym_export] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_as] = ACTIONS(1461),
    [anon_sym_namespace] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_typeof] = ACTIONS(1461),
    [anon_sym_import] = ACTIONS(1461),
    [anon_sym_var] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_BANG] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_await] = ACTIONS(1461),
    [anon_sym_in] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_try] = ACTIONS(1461),
    [anon_sym_with] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_debugger] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_throw] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_yield] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LTtemplate_GT] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1461),
    [anon_sym_class] = ACTIONS(1461),
    [anon_sym_async] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1461),
    [anon_sym_QMARK_DOT] = ACTIONS(1459),
    [anon_sym_new] = ACTIONS(1461),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1461),
    [anon_sym_GT_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1461),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_SLASH] = ACTIONS(1461),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_STAR_STAR] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1461),
    [anon_sym_LT_EQ] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1459),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1459),
    [anon_sym_GT_EQ] = ACTIONS(1459),
    [anon_sym_QMARK_QMARK] = ACTIONS(1459),
    [anon_sym_instanceof] = ACTIONS(1461),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_void] = ACTIONS(1461),
    [anon_sym_delete] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1461),
    [sym_super] = ACTIONS(1461),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_undefined] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_get] = ACTIONS(1461),
    [anon_sym_set] = ACTIONS(1461),
    [anon_sym_declare] = ACTIONS(1461),
    [anon_sym_public] = ACTIONS(1461),
    [anon_sym_private] = ACTIONS(1461),
    [anon_sym_protected] = ACTIONS(1461),
    [anon_sym_override] = ACTIONS(1461),
    [anon_sym_module] = ACTIONS(1461),
    [anon_sym_any] = ACTIONS(1461),
    [anon_sym_number] = ACTIONS(1461),
    [anon_sym_boolean] = ACTIONS(1461),
    [anon_sym_string] = ACTIONS(1461),
    [anon_sym_symbol] = ACTIONS(1461),
    [anon_sym_abstract] = ACTIONS(1461),
    [anon_sym_satisfies] = ACTIONS(1461),
    [anon_sym_interface] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
    [sym__automatic_semicolon] = ACTIONS(1495),
    [sym__ternary_qmark] = ACTIONS(1459),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(1497),
    [sym_identifier] = ACTIONS(1499),
    [anon_sym_export] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1499),
    [anon_sym_type] = ACTIONS(1499),
    [anon_sym_as] = ACTIONS(1499),
    [anon_sym_namespace] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(1497),
    [anon_sym_COMMA] = ACTIONS(1497),
    [anon_sym_RBRACE] = ACTIONS(1497),
    [anon_sym_typeof] = ACTIONS(1499),
    [anon_sym_import] = ACTIONS(1499),
    [anon_sym_var] = ACTIONS(1499),
    [anon_sym_let] = ACTIONS(1499),
    [anon_sym_const] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_else] = ACTIONS(1499),
    [anon_sym_if] = ACTIONS(1499),
    [anon_sym_switch] = ACTIONS(1499),
    [anon_sym_for] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1497),
    [anon_sym_await] = ACTIONS(1499),
    [anon_sym_in] = ACTIONS(1499),
    [anon_sym_while] = ACTIONS(1499),
    [anon_sym_do] = ACTIONS(1499),
    [anon_sym_try] = ACTIONS(1499),
    [anon_sym_with] = ACTIONS(1499),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_continue] = ACTIONS(1499),
    [anon_sym_debugger] = ACTIONS(1499),
    [anon_sym_return] = ACTIONS(1499),
    [anon_sym_throw] = ACTIONS(1499),
    [anon_sym_SEMI] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_yield] = ACTIONS(1499),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_LTtemplate_GT] = ACTIONS(1497),
    [anon_sym_GT] = ACTIONS(1499),
    [anon_sym_DOT] = ACTIONS(1499),
    [anon_sym_class] = ACTIONS(1499),
    [anon_sym_async] = ACTIONS(1499),
    [anon_sym_function] = ACTIONS(1499),
    [anon_sym_QMARK_DOT] = ACTIONS(1497),
    [anon_sym_new] = ACTIONS(1499),
    [anon_sym_AMP_AMP] = ACTIONS(1497),
    [anon_sym_PIPE_PIPE] = ACTIONS(1497),
    [anon_sym_GT_GT] = ACTIONS(1499),
    [anon_sym_GT_GT_GT] = ACTIONS(1497),
    [anon_sym_LT_LT] = ACTIONS(1497),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1497),
    [anon_sym_PIPE] = ACTIONS(1499),
    [anon_sym_PLUS] = ACTIONS(1499),
    [anon_sym_DASH] = ACTIONS(1499),
    [anon_sym_SLASH] = ACTIONS(1499),
    [anon_sym_PERCENT] = ACTIONS(1497),
    [anon_sym_STAR_STAR] = ACTIONS(1497),
    [anon_sym_LT] = ACTIONS(1499),
    [anon_sym_LT_EQ] = ACTIONS(1497),
    [anon_sym_EQ_EQ] = ACTIONS(1499),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1497),
    [anon_sym_BANG_EQ] = ACTIONS(1499),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1497),
    [anon_sym_GT_EQ] = ACTIONS(1497),
    [anon_sym_QMARK_QMARK] = ACTIONS(1497),
    [anon_sym_instanceof] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1497),
    [anon_sym_void] = ACTIONS(1499),
    [anon_sym_delete] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1497),
    [sym_number] = ACTIONS(1497),
    [sym_this] = ACTIONS(1499),
    [sym_super] = ACTIONS(1499),
    [sym_true] = ACTIONS(1499),
    [sym_false] = ACTIONS(1499),
    [sym_null] = ACTIONS(1499),
    [sym_undefined] = ACTIONS(1499),
    [anon_sym_AT] = ACTIONS(1497),
    [anon_sym_static] = ACTIONS(1499),
    [anon_sym_readonly] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
    [anon_sym_declare] = ACTIONS(1499),
    [anon_sym_public] = ACTIONS(1499),
    [anon_sym_private] = ACTIONS(1499),
    [anon_sym_protected] = ACTIONS(1499),
    [anon_sym_override] = ACTIONS(1499),
    [anon_sym_module] = ACTIONS(1499),
    [anon_sym_any] = ACTIONS(1499),
    [anon_sym_number] = ACTIONS(1499),
    [anon_sym_boolean] = ACTIONS(1499),
    [anon_sym_string] = ACTIONS(1499),
    [anon_sym_symbol] = ACTIONS(1499),
    [anon_sym_abstract] = ACTIONS(1499),
    [anon_sym_satisfies] = ACTIONS(1499),
    [anon_sym_interface] = ACTIONS(1499),
    [anon_sym_enum] = ACTIONS(1499),
    [sym__automatic_semicolon] = ACTIONS(1497),
    [sym__ternary_qmark] = ACTIONS(1497),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(1501),
    [sym_identifier] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_STAR] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(1503),
    [anon_sym_type] = ACTIONS(1503),
    [anon_sym_as] = ACTIONS(1503),
    [anon_sym_namespace] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1501),
    [anon_sym_RBRACE] = ACTIONS(1501),
    [anon_sym_typeof] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_var] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_BANG] = ACTIONS(1503),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_switch] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_with] = ACTIONS(1503),
    [anon_sym_break] = ACTIONS(1503),
    [anon_sym_continue] = ACTIONS(1503),
    [anon_sym_debugger] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1501),
    [anon_sym_case] = ACTIONS(1503),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LTtemplate_GT] = ACTIONS(1501),
    [anon_sym_GT] = ACTIONS(1503),
    [anon_sym_DOT] = ACTIONS(1503),
    [anon_sym_class] = ACTIONS(1503),
    [anon_sym_async] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_QMARK_DOT] = ACTIONS(1501),
    [anon_sym_new] = ACTIONS(1503),
    [anon_sym_AMP_AMP] = ACTIONS(1501),
    [anon_sym_PIPE_PIPE] = ACTIONS(1501),
    [anon_sym_GT_GT] = ACTIONS(1503),
    [anon_sym_GT_GT_GT] = ACTIONS(1501),
    [anon_sym_LT_LT] = ACTIONS(1501),
    [anon_sym_AMP] = ACTIONS(1503),
    [anon_sym_CARET] = ACTIONS(1501),
    [anon_sym_PIPE] = ACTIONS(1503),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_DASH] = ACTIONS(1503),
    [anon_sym_SLASH] = ACTIONS(1503),
    [anon_sym_PERCENT] = ACTIONS(1501),
    [anon_sym_STAR_STAR] = ACTIONS(1501),
    [anon_sym_LT] = ACTIONS(1503),
    [anon_sym_LT_EQ] = ACTIONS(1501),
    [anon_sym_EQ_EQ] = ACTIONS(1503),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1501),
    [anon_sym_BANG_EQ] = ACTIONS(1503),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1501),
    [anon_sym_GT_EQ] = ACTIONS(1501),
    [anon_sym_QMARK_QMARK] = ACTIONS(1501),
    [anon_sym_instanceof] = ACTIONS(1503),
    [anon_sym_TILDE] = ACTIONS(1501),
    [anon_sym_void] = ACTIONS(1503),
    [anon_sym_delete] = ACTIONS(1503),
    [anon_sym_PLUS_PLUS] = ACTIONS(1501),
    [anon_sym_DASH_DASH] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1501),
    [anon_sym_SQUOTE] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1501),
    [sym_number] = ACTIONS(1501),
    [sym_this] = ACTIONS(1503),
    [sym_super] = ACTIONS(1503),
    [sym_true] = ACTIONS(1503),
    [sym_false] = ACTIONS(1503),
    [sym_null] = ACTIONS(1503),
    [sym_undefined] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1501),
    [anon_sym_static] = ACTIONS(1503),
    [anon_sym_readonly] = ACTIONS(1503),
    [anon_sym_get] = ACTIONS(1503),
    [anon_sym_set] = ACTIONS(1503),
    [anon_sym_declare] = ACTIONS(1503),
    [anon_sym_public] = ACTIONS(1503),
    [anon_sym_private] = ACTIONS(1503),
    [anon_sym_protected] = ACTIONS(1503),
    [anon_sym_override] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_any] = ACTIONS(1503),
    [anon_sym_number] = ACTIONS(1503),
    [anon_sym_boolean] = ACTIONS(1503),
    [anon_sym_string] = ACTIONS(1503),
    [anon_sym_symbol] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_satisfies] = ACTIONS(1503),
    [anon_sym_interface] = ACTIONS(1503),
    [anon_sym_enum] = ACTIONS(1503),
    [sym__automatic_semicolon] = ACTIONS(1501),
    [sym__ternary_qmark] = ACTIONS(1501),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(1505),
    [sym_identifier] = ACTIONS(1507),
    [anon_sym_export] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1509),
    [anon_sym_default] = ACTIONS(1507),
    [anon_sym_type] = ACTIONS(1507),
    [anon_sym_as] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_RBRACE] = ACTIONS(1505),
    [anon_sym_typeof] = ACTIONS(1507),
    [anon_sym_import] = ACTIONS(1507),
    [anon_sym_var] = ACTIONS(1507),
    [anon_sym_let] = ACTIONS(1507),
    [anon_sym_const] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_else] = ACTIONS(1507),
    [anon_sym_if] = ACTIONS(1507),
    [anon_sym_switch] = ACTIONS(1507),
    [anon_sym_for] = ACTIONS(1507),
    [anon_sym_LPAREN] = ACTIONS(1505),
    [anon_sym_await] = ACTIONS(1507),
    [anon_sym_in] = ACTIONS(1509),
    [anon_sym_while] = ACTIONS(1507),
    [anon_sym_do] = ACTIONS(1507),
    [anon_sym_try] = ACTIONS(1507),
    [anon_sym_with] = ACTIONS(1507),
    [anon_sym_break] = ACTIONS(1507),
    [anon_sym_continue] = ACTIONS(1507),
    [anon_sym_debugger] = ACTIONS(1507),
    [anon_sym_return] = ACTIONS(1507),
    [anon_sym_throw] = ACTIONS(1507),
    [anon_sym_SEMI] = ACTIONS(1505),
    [anon_sym_case] = ACTIONS(1507),
    [anon_sym_yield] = ACTIONS(1507),
    [anon_sym_LBRACK] = ACTIONS(1505),
    [anon_sym_LTtemplate_GT] = ACTIONS(1505),
    [anon_sym_GT] = ACTIONS(1509),
    [anon_sym_DOT] = ACTIONS(1509),
    [anon_sym_class] = ACTIONS(1507),
    [anon_sym_async] = ACTIONS(1507),
    [anon_sym_function] = ACTIONS(1507),
    [anon_sym_QMARK_DOT] = ACTIONS(1511),
    [anon_sym_new] = ACTIONS(1507),
    [anon_sym_AMP_AMP] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(1509),
    [anon_sym_GT_GT_GT] = ACTIONS(1511),
    [anon_sym_LT_LT] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_PIPE] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1507),
    [anon_sym_PERCENT] = ACTIONS(1511),
    [anon_sym_STAR_STAR] = ACTIONS(1511),
    [anon_sym_LT] = ACTIONS(1507),
    [anon_sym_LT_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(1509),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(1509),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(1511),
    [anon_sym_QMARK_QMARK] = ACTIONS(1511),
    [anon_sym_instanceof] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1505),
    [anon_sym_void] = ACTIONS(1507),
    [anon_sym_delete] = ACTIONS(1507),
    [anon_sym_PLUS_PLUS] = ACTIONS(1505),
    [anon_sym_DASH_DASH] = ACTIONS(1507),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_SQUOTE] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1505),
    [sym_number] = ACTIONS(1505),
    [sym_this] = ACTIONS(1507),
    [sym_super] = ACTIONS(1507),
    [sym_true] = ACTIONS(1507),
    [sym_false] = ACTIONS(1507),
    [sym_null] = ACTIONS(1507),
    [sym_undefined] = ACTIONS(1507),
    [anon_sym_AT] = ACTIONS(1505),
    [anon_sym_static] = ACTIONS(1507),
    [anon_sym_readonly] = ACTIONS(1507),
    [anon_sym_get] = ACTIONS(1507),
    [anon_sym_set] = ACTIONS(1507),
    [anon_sym_declare] = ACTIONS(1507),
    [anon_sym_public] = ACTIONS(1507),
    [anon_sym_private] = ACTIONS(1507),
    [anon_sym_protected] = ACTIONS(1507),
    [anon_sym_override] = ACTIONS(1507),
    [anon_sym_module] = ACTIONS(1507),
    [anon_sym_any] = ACTIONS(1507),
    [anon_sym_number] = ACTIONS(1507),
    [anon_sym_boolean] = ACTIONS(1507),
    [anon_sym_string] = ACTIONS(1507),
    [anon_sym_symbol] = ACTIONS(1507),
    [anon_sym_abstract] = ACTIONS(1507),
    [anon_sym_satisfies] = ACTIONS(1509),
    [anon_sym_interface] = ACTIONS(1507),
    [anon_sym_enum] = ACTIONS(1507),
    [sym__automatic_semicolon] = ACTIONS(1513),
    [sym__ternary_qmark] = ACTIONS(1511),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_default] = ACTIONS(1517),
    [anon_sym_type] = ACTIONS(1517),
    [anon_sym_as] = ACTIONS(1519),
    [anon_sym_namespace] = ACTIONS(1517),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_COMMA] = ACTIONS(1521),
    [anon_sym_RBRACE] = ACTIONS(1515),
    [anon_sym_typeof] = ACTIONS(1517),
    [anon_sym_import] = ACTIONS(1517),
    [anon_sym_var] = ACTIONS(1517),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_else] = ACTIONS(1517),
    [anon_sym_if] = ACTIONS(1517),
    [anon_sym_switch] = ACTIONS(1517),
    [anon_sym_for] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1515),
    [anon_sym_await] = ACTIONS(1517),
    [anon_sym_in] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1517),
    [anon_sym_do] = ACTIONS(1517),
    [anon_sym_try] = ACTIONS(1517),
    [anon_sym_with] = ACTIONS(1517),
    [anon_sym_break] = ACTIONS(1517),
    [anon_sym_continue] = ACTIONS(1517),
    [anon_sym_debugger] = ACTIONS(1517),
    [anon_sym_return] = ACTIONS(1517),
    [anon_sym_throw] = ACTIONS(1517),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_case] = ACTIONS(1517),
    [anon_sym_yield] = ACTIONS(1517),
    [anon_sym_LBRACK] = ACTIONS(1515),
    [anon_sym_LTtemplate_GT] = ACTIONS(1515),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_DOT] = ACTIONS(1519),
    [anon_sym_class] = ACTIONS(1517),
    [anon_sym_async] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1517),
    [anon_sym_QMARK_DOT] = ACTIONS(1521),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_GT_GT] = ACTIONS(1519),
    [anon_sym_GT_GT_GT] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_CARET] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1517),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_PERCENT] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1519),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1521),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_QMARK_QMARK] = ACTIONS(1521),
    [anon_sym_instanceof] = ACTIONS(1519),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_void] = ACTIONS(1517),
    [anon_sym_delete] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1515),
    [sym_number] = ACTIONS(1515),
    [sym_this] = ACTIONS(1517),
    [sym_super] = ACTIONS(1517),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [sym_null] = ACTIONS(1517),
    [sym_undefined] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1515),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_readonly] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(1517),
    [anon_sym_set] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_public] = ACTIONS(1517),
    [anon_sym_private] = ACTIONS(1517),
    [anon_sym_protected] = ACTIONS(1517),
    [anon_sym_override] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_any] = ACTIONS(1517),
    [anon_sym_number] = ACTIONS(1517),
    [anon_sym_boolean] = ACTIONS(1517),
    [anon_sym_string] = ACTIONS(1517),
    [anon_sym_symbol] = ACTIONS(1517),
    [anon_sym_abstract] = ACTIONS(1517),
    [anon_sym_satisfies] = ACTIONS(1519),
    [anon_sym_interface] = ACTIONS(1517),
    [anon_sym_enum] = ACTIONS(1517),
    [sym__automatic_semicolon] = ACTIONS(1523),
    [sym__ternary_qmark] = ACTIONS(1521),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(1525),
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_export] = ACTIONS(1527),
    [anon_sym_STAR] = ACTIONS(1529),
    [anon_sym_default] = ACTIONS(1527),
    [anon_sym_type] = ACTIONS(1527),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_namespace] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_RBRACE] = ACTIONS(1525),
    [anon_sym_typeof] = ACTIONS(1527),
    [anon_sym_import] = ACTIONS(1527),
    [anon_sym_var] = ACTIONS(1527),
    [anon_sym_let] = ACTIONS(1527),
    [anon_sym_const] = ACTIONS(1527),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_else] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_switch] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_LPAREN] = ACTIONS(1525),
    [anon_sym_await] = ACTIONS(1527),
    [anon_sym_in] = ACTIONS(1529),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(1527),
    [anon_sym_try] = ACTIONS(1527),
    [anon_sym_with] = ACTIONS(1527),
    [anon_sym_break] = ACTIONS(1527),
    [anon_sym_continue] = ACTIONS(1527),
    [anon_sym_debugger] = ACTIONS(1527),
    [anon_sym_return] = ACTIONS(1527),
    [anon_sym_throw] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_case] = ACTIONS(1527),
    [anon_sym_yield] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(1525),
    [anon_sym_LTtemplate_GT] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1529),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_class] = ACTIONS(1527),
    [anon_sym_async] = ACTIONS(1527),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_QMARK_DOT] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_GT_GT] = ACTIONS(1529),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1527),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_EQ_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1531),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_QMARK_QMARK] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_void] = ACTIONS(1527),
    [anon_sym_delete] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1525),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [sym_number] = ACTIONS(1525),
    [sym_this] = ACTIONS(1527),
    [sym_super] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_undefined] = ACTIONS(1527),
    [anon_sym_AT] = ACTIONS(1525),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_readonly] = ACTIONS(1527),
    [anon_sym_get] = ACTIONS(1527),
    [anon_sym_set] = ACTIONS(1527),
    [anon_sym_declare] = ACTIONS(1527),
    [anon_sym_public] = ACTIONS(1527),
    [anon_sym_private] = ACTIONS(1527),
    [anon_sym_protected] = ACTIONS(1527),
    [anon_sym_override] = ACTIONS(1527),
    [anon_sym_module] = ACTIONS(1527),
    [anon_sym_any] = ACTIONS(1527),
    [anon_sym_number] = ACTIONS(1527),
    [anon_sym_boolean] = ACTIONS(1527),
    [anon_sym_string] = ACTIONS(1527),
    [anon_sym_symbol] = ACTIONS(1527),
    [anon_sym_abstract] = ACTIONS(1527),
    [anon_sym_satisfies] = ACTIONS(1529),
    [anon_sym_interface] = ACTIONS(1527),
    [anon_sym_enum] = ACTIONS(1527),
    [sym__automatic_semicolon] = ACTIONS(1531),
    [sym__ternary_qmark] = ACTIONS(1531),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(1533),
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_export] = ACTIONS(1535),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_default] = ACTIONS(1535),
    [anon_sym_type] = ACTIONS(1535),
    [anon_sym_as] = ACTIONS(1535),
    [anon_sym_namespace] = ACTIONS(1535),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_COMMA] = ACTIONS(1533),
    [anon_sym_RBRACE] = ACTIONS(1533),
    [anon_sym_typeof] = ACTIONS(1535),
    [anon_sym_import] = ACTIONS(1535),
    [anon_sym_var] = ACTIONS(1535),
    [anon_sym_let] = ACTIONS(1535),
    [anon_sym_const] = ACTIONS(1535),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_else] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_LPAREN] = ACTIONS(1533),
    [anon_sym_await] = ACTIONS(1535),
    [anon_sym_in] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_do] = ACTIONS(1535),
    [anon_sym_try] = ACTIONS(1535),
    [anon_sym_with] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1535),
    [anon_sym_continue] = ACTIONS(1535),
    [anon_sym_debugger] = ACTIONS(1535),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_throw] = ACTIONS(1535),
    [anon_sym_SEMI] = ACTIONS(1533),
    [anon_sym_case] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1533),
    [anon_sym_LTtemplate_GT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_DOT] = ACTIONS(1535),
    [anon_sym_class] = ACTIONS(1535),
    [anon_sym_async] = ACTIONS(1535),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_QMARK_DOT] = ACTIONS(1533),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_AMP_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1535),
    [anon_sym_GT_GT_GT] = ACTIONS(1533),
    [anon_sym_LT_LT] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1535),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1535),
    [anon_sym_PERCENT] = ACTIONS(1533),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1533),
    [anon_sym_EQ_EQ] = ACTIONS(1535),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1533),
    [anon_sym_BANG_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1533),
    [anon_sym_GT_EQ] = ACTIONS(1533),
    [anon_sym_QMARK_QMARK] = ACTIONS(1533),
    [anon_sym_instanceof] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1533),
    [anon_sym_void] = ACTIONS(1535),
    [anon_sym_delete] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1533),
    [sym_number] = ACTIONS(1533),
    [sym_this] = ACTIONS(1535),
    [sym_super] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_undefined] = ACTIONS(1535),
    [anon_sym_AT] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(1535),
    [anon_sym_readonly] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(1535),
    [anon_sym_set] = ACTIONS(1535),
    [anon_sym_declare] = ACTIONS(1535),
    [anon_sym_public] = ACTIONS(1535),
    [anon_sym_private] = ACTIONS(1535),
    [anon_sym_protected] = ACTIONS(1535),
    [anon_sym_override] = ACTIONS(1535),
    [anon_sym_module] = ACTIONS(1535),
    [anon_sym_any] = ACTIONS(1535),
    [anon_sym_number] = ACTIONS(1535),
    [anon_sym_boolean] = ACTIONS(1535),
    [anon_sym_string] = ACTIONS(1535),
    [anon_sym_symbol] = ACTIONS(1535),
    [anon_sym_abstract] = ACTIONS(1535),
    [anon_sym_satisfies] = ACTIONS(1535),
    [anon_sym_interface] = ACTIONS(1535),
    [anon_sym_enum] = ACTIONS(1535),
    [sym__automatic_semicolon] = ACTIONS(1533),
    [sym__ternary_qmark] = ACTIONS(1533),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(1537),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1539),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(1539),
    [anon_sym_type] = ACTIONS(1539),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_namespace] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1537),
    [anon_sym_RBRACE] = ACTIONS(1537),
    [anon_sym_typeof] = ACTIONS(1539),
    [anon_sym_import] = ACTIONS(1539),
    [anon_sym_var] = ACTIONS(1539),
    [anon_sym_let] = ACTIONS(1539),
    [anon_sym_const] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_else] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_switch] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_do] = ACTIONS(1539),
    [anon_sym_try] = ACTIONS(1539),
    [anon_sym_with] = ACTIONS(1539),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_continue] = ACTIONS(1539),
    [anon_sym_debugger] = ACTIONS(1539),
    [anon_sym_return] = ACTIONS(1539),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1537),
    [anon_sym_case] = ACTIONS(1539),
    [anon_sym_yield] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1537),
    [anon_sym_LTtemplate_GT] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_DOT] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1539),
    [anon_sym_async] = ACTIONS(1539),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_QMARK_DOT] = ACTIONS(1537),
    [anon_sym_new] = ACTIONS(1539),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_GT_GT] = ACTIONS(1539),
    [anon_sym_GT_GT_GT] = ACTIONS(1537),
    [anon_sym_LT_LT] = ACTIONS(1537),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_CARET] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_PERCENT] = ACTIONS(1537),
    [anon_sym_STAR_STAR] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_EQ_EQ] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1537),
    [anon_sym_BANG_EQ] = ACTIONS(1539),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1537),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_QMARK_QMARK] = ACTIONS(1537),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_void] = ACTIONS(1539),
    [anon_sym_delete] = ACTIONS(1539),
    [anon_sym_PLUS_PLUS] = ACTIONS(1537),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1537),
    [sym_number] = ACTIONS(1537),
    [sym_this] = ACTIONS(1539),
    [sym_super] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_undefined] = ACTIONS(1539),
    [anon_sym_AT] = ACTIONS(1537),
    [anon_sym_static] = ACTIONS(1539),
    [anon_sym_readonly] = ACTIONS(1539),
    [anon_sym_get] = ACTIONS(1539),
    [anon_sym_set] = ACTIONS(1539),
    [anon_sym_declare] = ACTIONS(1539),
    [anon_sym_public] = ACTIONS(1539),
    [anon_sym_private] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1539),
    [anon_sym_override] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1539),
    [anon_sym_any] = ACTIONS(1539),
    [anon_sym_number] = ACTIONS(1539),
    [anon_sym_boolean] = ACTIONS(1539),
    [anon_sym_string] = ACTIONS(1539),
    [anon_sym_symbol] = ACTIONS(1539),
    [anon_sym_abstract] = ACTIONS(1539),
    [anon_sym_satisfies] = ACTIONS(1539),
    [anon_sym_interface] = ACTIONS(1539),
    [anon_sym_enum] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1537),
    [sym__ternary_qmark] = ACTIONS(1537),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(1541),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1545),
    [anon_sym_default] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_as] = ACTIONS(1545),
    [anon_sym_namespace] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1547),
    [anon_sym_RBRACE] = ACTIONS(1541),
    [anon_sym_typeof] = ACTIONS(1543),
    [anon_sym_import] = ACTIONS(1543),
    [anon_sym_var] = ACTIONS(1543),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_const] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_else] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_switch] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_LPAREN] = ACTIONS(1541),
    [anon_sym_await] = ACTIONS(1543),
    [anon_sym_in] = ACTIONS(1545),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_do] = ACTIONS(1543),
    [anon_sym_try] = ACTIONS(1543),
    [anon_sym_with] = ACTIONS(1543),
    [anon_sym_break] = ACTIONS(1543),
    [anon_sym_continue] = ACTIONS(1543),
    [anon_sym_debugger] = ACTIONS(1543),
    [anon_sym_return] = ACTIONS(1543),
    [anon_sym_throw] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1541),
    [anon_sym_case] = ACTIONS(1543),
    [anon_sym_yield] = ACTIONS(1543),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [anon_sym_LTtemplate_GT] = ACTIONS(1541),
    [anon_sym_GT] = ACTIONS(1545),
    [anon_sym_DOT] = ACTIONS(1545),
    [anon_sym_class] = ACTIONS(1543),
    [anon_sym_async] = ACTIONS(1543),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_QMARK_DOT] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_AMP_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1545),
    [anon_sym_GT_GT_GT] = ACTIONS(1547),
    [anon_sym_LT_LT] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_CARET] = ACTIONS(1547),
    [anon_sym_PIPE] = ACTIONS(1545),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1543),
    [anon_sym_PERCENT] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1547),
    [anon_sym_EQ_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1547),
    [anon_sym_BANG_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1547),
    [anon_sym_GT_EQ] = ACTIONS(1547),
    [anon_sym_QMARK_QMARK] = ACTIONS(1547),
    [anon_sym_instanceof] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_void] = ACTIONS(1543),
    [anon_sym_delete] = ACTIONS(1543),
    [anon_sym_PLUS_PLUS] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1541),
    [sym_number] = ACTIONS(1541),
    [sym_this] = ACTIONS(1543),
    [sym_super] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_undefined] = ACTIONS(1543),
    [anon_sym_AT] = ACTIONS(1541),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_abstract] = ACTIONS(1543),
    [anon_sym_satisfies] = ACTIONS(1545),
    [anon_sym_interface] = ACTIONS(1543),
    [anon_sym_enum] = ACTIONS(1543),
    [sym__automatic_semicolon] = ACTIONS(1549),
    [sym__ternary_qmark] = ACTIONS(1547),
  },
  [163] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_SEMI] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
    [anon_sym_extends] = ACTIONS(1407),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1405),
    [sym__automatic_semicolon] = ACTIONS(1405),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1553),
    [anon_sym_export] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1555),
    [anon_sym_default] = ACTIONS(1553),
    [anon_sym_type] = ACTIONS(1553),
    [anon_sym_as] = ACTIONS(1555),
    [anon_sym_namespace] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_COMMA] = ACTIONS(1557),
    [anon_sym_RBRACE] = ACTIONS(1551),
    [anon_sym_typeof] = ACTIONS(1553),
    [anon_sym_import] = ACTIONS(1553),
    [anon_sym_var] = ACTIONS(1553),
    [anon_sym_let] = ACTIONS(1553),
    [anon_sym_const] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_else] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_switch] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_await] = ACTIONS(1553),
    [anon_sym_in] = ACTIONS(1555),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_do] = ACTIONS(1553),
    [anon_sym_try] = ACTIONS(1553),
    [anon_sym_with] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_continue] = ACTIONS(1553),
    [anon_sym_debugger] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_throw] = ACTIONS(1553),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(1551),
    [anon_sym_LTtemplate_GT] = ACTIONS(1551),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_DOT] = ACTIONS(1555),
    [anon_sym_class] = ACTIONS(1553),
    [anon_sym_async] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1553),
    [anon_sym_QMARK_DOT] = ACTIONS(1557),
    [anon_sym_new] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1557),
    [anon_sym_PIPE_PIPE] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1555),
    [anon_sym_GT_GT_GT] = ACTIONS(1557),
    [anon_sym_LT_LT] = ACTIONS(1557),
    [anon_sym_AMP] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1557),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_PERCENT] = ACTIONS(1557),
    [anon_sym_STAR_STAR] = ACTIONS(1557),
    [anon_sym_LT] = ACTIONS(1553),
    [anon_sym_LT_EQ] = ACTIONS(1557),
    [anon_sym_EQ_EQ] = ACTIONS(1555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1557),
    [anon_sym_BANG_EQ] = ACTIONS(1555),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1557),
    [anon_sym_GT_EQ] = ACTIONS(1557),
    [anon_sym_QMARK_QMARK] = ACTIONS(1557),
    [anon_sym_instanceof] = ACTIONS(1555),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_void] = ACTIONS(1553),
    [anon_sym_delete] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1551),
    [sym_number] = ACTIONS(1551),
    [sym_this] = ACTIONS(1553),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [sym_null] = ACTIONS(1553),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1551),
    [anon_sym_static] = ACTIONS(1553),
    [anon_sym_readonly] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(1553),
    [anon_sym_set] = ACTIONS(1553),
    [anon_sym_declare] = ACTIONS(1553),
    [anon_sym_public] = ACTIONS(1553),
    [anon_sym_private] = ACTIONS(1553),
    [anon_sym_protected] = ACTIONS(1553),
    [anon_sym_override] = ACTIONS(1553),
    [anon_sym_module] = ACTIONS(1553),
    [anon_sym_any] = ACTIONS(1553),
    [anon_sym_number] = ACTIONS(1553),
    [anon_sym_boolean] = ACTIONS(1553),
    [anon_sym_string] = ACTIONS(1553),
    [anon_sym_symbol] = ACTIONS(1553),
    [anon_sym_abstract] = ACTIONS(1553),
    [anon_sym_satisfies] = ACTIONS(1555),
    [anon_sym_interface] = ACTIONS(1553),
    [anon_sym_enum] = ACTIONS(1553),
    [sym__automatic_semicolon] = ACTIONS(1559),
    [sym__ternary_qmark] = ACTIONS(1557),
  },
  [165] = {
    [ts_builtin_sym_end] = ACTIONS(1561),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(1565),
    [anon_sym_default] = ACTIONS(1563),
    [anon_sym_type] = ACTIONS(1563),
    [anon_sym_as] = ACTIONS(1565),
    [anon_sym_namespace] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1561),
    [anon_sym_COMMA] = ACTIONS(1567),
    [anon_sym_RBRACE] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(1563),
    [anon_sym_import] = ACTIONS(1563),
    [anon_sym_var] = ACTIONS(1563),
    [anon_sym_let] = ACTIONS(1563),
    [anon_sym_const] = ACTIONS(1563),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_else] = ACTIONS(1563),
    [anon_sym_if] = ACTIONS(1563),
    [anon_sym_switch] = ACTIONS(1563),
    [anon_sym_for] = ACTIONS(1563),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_await] = ACTIONS(1563),
    [anon_sym_in] = ACTIONS(1565),
    [anon_sym_while] = ACTIONS(1563),
    [anon_sym_do] = ACTIONS(1563),
    [anon_sym_try] = ACTIONS(1563),
    [anon_sym_with] = ACTIONS(1563),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_continue] = ACTIONS(1563),
    [anon_sym_debugger] = ACTIONS(1563),
    [anon_sym_return] = ACTIONS(1563),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1561),
    [anon_sym_case] = ACTIONS(1563),
    [anon_sym_yield] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(1561),
    [anon_sym_LTtemplate_GT] = ACTIONS(1561),
    [anon_sym_GT] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(1565),
    [anon_sym_class] = ACTIONS(1563),
    [anon_sym_async] = ACTIONS(1563),
    [anon_sym_function] = ACTIONS(1563),
    [anon_sym_QMARK_DOT] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(1563),
    [anon_sym_AMP_AMP] = ACTIONS(1567),
    [anon_sym_PIPE_PIPE] = ACTIONS(1567),
    [anon_sym_GT_GT] = ACTIONS(1565),
    [anon_sym_GT_GT_GT] = ACTIONS(1567),
    [anon_sym_LT_LT] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1565),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_PIPE] = ACTIONS(1565),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_DASH] = ACTIONS(1563),
    [anon_sym_SLASH] = ACTIONS(1563),
    [anon_sym_PERCENT] = ACTIONS(1567),
    [anon_sym_STAR_STAR] = ACTIONS(1567),
    [anon_sym_LT] = ACTIONS(1563),
    [anon_sym_LT_EQ] = ACTIONS(1567),
    [anon_sym_EQ_EQ] = ACTIONS(1565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1567),
    [anon_sym_BANG_EQ] = ACTIONS(1565),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1567),
    [anon_sym_GT_EQ] = ACTIONS(1567),
    [anon_sym_QMARK_QMARK] = ACTIONS(1567),
    [anon_sym_instanceof] = ACTIONS(1565),
    [anon_sym_TILDE] = ACTIONS(1561),
    [anon_sym_void] = ACTIONS(1563),
    [anon_sym_delete] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1561),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_DQUOTE] = ACTIONS(1561),
    [anon_sym_SQUOTE] = ACTIONS(1561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1561),
    [sym_number] = ACTIONS(1561),
    [sym_this] = ACTIONS(1563),
    [sym_super] = ACTIONS(1563),
    [sym_true] = ACTIONS(1563),
    [sym_false] = ACTIONS(1563),
    [sym_null] = ACTIONS(1563),
    [sym_undefined] = ACTIONS(1563),
    [anon_sym_AT] = ACTIONS(1561),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_readonly] = ACTIONS(1563),
    [anon_sym_get] = ACTIONS(1563),
    [anon_sym_set] = ACTIONS(1563),
    [anon_sym_declare] = ACTIONS(1563),
    [anon_sym_public] = ACTIONS(1563),
    [anon_sym_private] = ACTIONS(1563),
    [anon_sym_protected] = ACTIONS(1563),
    [anon_sym_override] = ACTIONS(1563),
    [anon_sym_module] = ACTIONS(1563),
    [anon_sym_any] = ACTIONS(1563),
    [anon_sym_number] = ACTIONS(1563),
    [anon_sym_boolean] = ACTIONS(1563),
    [anon_sym_string] = ACTIONS(1563),
    [anon_sym_symbol] = ACTIONS(1563),
    [anon_sym_abstract] = ACTIONS(1563),
    [anon_sym_satisfies] = ACTIONS(1565),
    [anon_sym_interface] = ACTIONS(1563),
    [anon_sym_enum] = ACTIONS(1563),
    [sym__automatic_semicolon] = ACTIONS(1569),
    [sym__ternary_qmark] = ACTIONS(1567),
  },
  [166] = {
    [ts_builtin_sym_end] = ACTIONS(1571),
    [sym_identifier] = ACTIONS(1573),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(1573),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_as] = ACTIONS(1575),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_RBRACE] = ACTIONS(1571),
    [anon_sym_typeof] = ACTIONS(1573),
    [anon_sym_import] = ACTIONS(1573),
    [anon_sym_var] = ACTIONS(1573),
    [anon_sym_let] = ACTIONS(1573),
    [anon_sym_const] = ACTIONS(1573),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_else] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1573),
    [anon_sym_for] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_while] = ACTIONS(1573),
    [anon_sym_do] = ACTIONS(1573),
    [anon_sym_try] = ACTIONS(1573),
    [anon_sym_with] = ACTIONS(1573),
    [anon_sym_break] = ACTIONS(1573),
    [anon_sym_continue] = ACTIONS(1573),
    [anon_sym_debugger] = ACTIONS(1573),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_case] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1573),
    [anon_sym_LBRACK] = ACTIONS(1571),
    [anon_sym_LTtemplate_GT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1575),
    [anon_sym_class] = ACTIONS(1573),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_function] = ACTIONS(1573),
    [anon_sym_QMARK_DOT] = ACTIONS(1577),
    [anon_sym_new] = ACTIONS(1573),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_GT_GT] = ACTIONS(1575),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1575),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_SLASH] = ACTIONS(1573),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1573),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_QMARK_QMARK] = ACTIONS(1577),
    [anon_sym_instanceof] = ACTIONS(1575),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_void] = ACTIONS(1573),
    [anon_sym_delete] = ACTIONS(1573),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1573),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1571),
    [sym_number] = ACTIONS(1571),
    [sym_this] = ACTIONS(1573),
    [sym_super] = ACTIONS(1573),
    [sym_true] = ACTIONS(1573),
    [sym_false] = ACTIONS(1573),
    [sym_null] = ACTIONS(1573),
    [sym_undefined] = ACTIONS(1573),
    [anon_sym_AT] = ACTIONS(1571),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(1573),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_override] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1573),
    [anon_sym_number] = ACTIONS(1573),
    [anon_sym_boolean] = ACTIONS(1573),
    [anon_sym_string] = ACTIONS(1573),
    [anon_sym_symbol] = ACTIONS(1573),
    [anon_sym_abstract] = ACTIONS(1573),
    [anon_sym_satisfies] = ACTIONS(1575),
    [anon_sym_interface] = ACTIONS(1573),
    [anon_sym_enum] = ACTIONS(1573),
    [sym__automatic_semicolon] = ACTIONS(1579),
    [sym__ternary_qmark] = ACTIONS(1577),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(1581),
    [sym_identifier] = ACTIONS(1583),
    [anon_sym_export] = ACTIONS(1583),
    [anon_sym_STAR] = ACTIONS(1585),
    [anon_sym_default] = ACTIONS(1583),
    [anon_sym_type] = ACTIONS(1583),
    [anon_sym_as] = ACTIONS(1585),
    [anon_sym_namespace] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1581),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_RBRACE] = ACTIONS(1581),
    [anon_sym_typeof] = ACTIONS(1583),
    [anon_sym_import] = ACTIONS(1583),
    [anon_sym_var] = ACTIONS(1583),
    [anon_sym_let] = ACTIONS(1583),
    [anon_sym_const] = ACTIONS(1583),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_else] = ACTIONS(1583),
    [anon_sym_if] = ACTIONS(1583),
    [anon_sym_switch] = ACTIONS(1583),
    [anon_sym_for] = ACTIONS(1583),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_await] = ACTIONS(1583),
    [anon_sym_in] = ACTIONS(1585),
    [anon_sym_while] = ACTIONS(1583),
    [anon_sym_do] = ACTIONS(1583),
    [anon_sym_try] = ACTIONS(1583),
    [anon_sym_with] = ACTIONS(1583),
    [anon_sym_break] = ACTIONS(1583),
    [anon_sym_continue] = ACTIONS(1583),
    [anon_sym_debugger] = ACTIONS(1583),
    [anon_sym_return] = ACTIONS(1583),
    [anon_sym_throw] = ACTIONS(1583),
    [anon_sym_SEMI] = ACTIONS(1581),
    [anon_sym_case] = ACTIONS(1583),
    [anon_sym_yield] = ACTIONS(1583),
    [anon_sym_LBRACK] = ACTIONS(1581),
    [anon_sym_LTtemplate_GT] = ACTIONS(1581),
    [anon_sym_GT] = ACTIONS(1585),
    [anon_sym_DOT] = ACTIONS(1585),
    [anon_sym_class] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(1583),
    [anon_sym_QMARK_DOT] = ACTIONS(1587),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1585),
    [anon_sym_GT_GT_GT] = ACTIONS(1587),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_DASH] = ACTIONS(1583),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_STAR_STAR] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(1583),
    [anon_sym_LT_EQ] = ACTIONS(1587),
    [anon_sym_EQ_EQ] = ACTIONS(1585),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1587),
    [anon_sym_BANG_EQ] = ACTIONS(1585),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1587),
    [anon_sym_QMARK_QMARK] = ACTIONS(1587),
    [anon_sym_instanceof] = ACTIONS(1585),
    [anon_sym_TILDE] = ACTIONS(1581),
    [anon_sym_void] = ACTIONS(1583),
    [anon_sym_delete] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1581),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_DQUOTE] = ACTIONS(1581),
    [anon_sym_SQUOTE] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1581),
    [sym_number] = ACTIONS(1581),
    [sym_this] = ACTIONS(1583),
    [sym_super] = ACTIONS(1583),
    [sym_true] = ACTIONS(1583),
    [sym_false] = ACTIONS(1583),
    [sym_null] = ACTIONS(1583),
    [sym_undefined] = ACTIONS(1583),
    [anon_sym_AT] = ACTIONS(1581),
    [anon_sym_static] = ACTIONS(1583),
    [anon_sym_readonly] = ACTIONS(1583),
    [anon_sym_get] = ACTIONS(1583),
    [anon_sym_set] = ACTIONS(1583),
    [anon_sym_declare] = ACTIONS(1583),
    [anon_sym_public] = ACTIONS(1583),
    [anon_sym_private] = ACTIONS(1583),
    [anon_sym_protected] = ACTIONS(1583),
    [anon_sym_override] = ACTIONS(1583),
    [anon_sym_module] = ACTIONS(1583),
    [anon_sym_any] = ACTIONS(1583),
    [anon_sym_number] = ACTIONS(1583),
    [anon_sym_boolean] = ACTIONS(1583),
    [anon_sym_string] = ACTIONS(1583),
    [anon_sym_symbol] = ACTIONS(1583),
    [anon_sym_abstract] = ACTIONS(1583),
    [anon_sym_satisfies] = ACTIONS(1585),
    [anon_sym_interface] = ACTIONS(1583),
    [anon_sym_enum] = ACTIONS(1583),
    [sym__automatic_semicolon] = ACTIONS(1589),
    [sym__ternary_qmark] = ACTIONS(1587),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(1591),
    [sym_identifier] = ACTIONS(1593),
    [anon_sym_export] = ACTIONS(1593),
    [anon_sym_STAR] = ACTIONS(1595),
    [anon_sym_default] = ACTIONS(1593),
    [anon_sym_type] = ACTIONS(1593),
    [anon_sym_as] = ACTIONS(1595),
    [anon_sym_namespace] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1591),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1591),
    [anon_sym_typeof] = ACTIONS(1593),
    [anon_sym_import] = ACTIONS(1593),
    [anon_sym_var] = ACTIONS(1593),
    [anon_sym_let] = ACTIONS(1593),
    [anon_sym_const] = ACTIONS(1593),
    [anon_sym_BANG] = ACTIONS(1593),
    [anon_sym_else] = ACTIONS(1593),
    [anon_sym_if] = ACTIONS(1593),
    [anon_sym_switch] = ACTIONS(1593),
    [anon_sym_for] = ACTIONS(1593),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_in] = ACTIONS(1595),
    [anon_sym_while] = ACTIONS(1593),
    [anon_sym_do] = ACTIONS(1593),
    [anon_sym_try] = ACTIONS(1593),
    [anon_sym_with] = ACTIONS(1593),
    [anon_sym_break] = ACTIONS(1593),
    [anon_sym_continue] = ACTIONS(1593),
    [anon_sym_debugger] = ACTIONS(1593),
    [anon_sym_return] = ACTIONS(1593),
    [anon_sym_throw] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1591),
    [anon_sym_case] = ACTIONS(1593),
    [anon_sym_yield] = ACTIONS(1593),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_LTtemplate_GT] = ACTIONS(1591),
    [anon_sym_GT] = ACTIONS(1595),
    [anon_sym_DOT] = ACTIONS(1595),
    [anon_sym_class] = ACTIONS(1593),
    [anon_sym_async] = ACTIONS(1593),
    [anon_sym_function] = ACTIONS(1593),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1593),
    [anon_sym_AMP_AMP] = ACTIONS(1597),
    [anon_sym_PIPE_PIPE] = ACTIONS(1597),
    [anon_sym_GT_GT] = ACTIONS(1595),
    [anon_sym_GT_GT_GT] = ACTIONS(1597),
    [anon_sym_LT_LT] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_PIPE] = ACTIONS(1595),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_DASH] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(1593),
    [anon_sym_PERCENT] = ACTIONS(1597),
    [anon_sym_STAR_STAR] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1595),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1595),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1595),
    [anon_sym_TILDE] = ACTIONS(1591),
    [anon_sym_void] = ACTIONS(1593),
    [anon_sym_delete] = ACTIONS(1593),
    [anon_sym_PLUS_PLUS] = ACTIONS(1591),
    [anon_sym_DASH_DASH] = ACTIONS(1593),
    [anon_sym_DQUOTE] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(1591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1591),
    [sym_number] = ACTIONS(1591),
    [sym_this] = ACTIONS(1593),
    [sym_super] = ACTIONS(1593),
    [sym_true] = ACTIONS(1593),
    [sym_false] = ACTIONS(1593),
    [sym_null] = ACTIONS(1593),
    [sym_undefined] = ACTIONS(1593),
    [anon_sym_AT] = ACTIONS(1591),
    [anon_sym_static] = ACTIONS(1593),
    [anon_sym_readonly] = ACTIONS(1593),
    [anon_sym_get] = ACTIONS(1593),
    [anon_sym_set] = ACTIONS(1593),
    [anon_sym_declare] = ACTIONS(1593),
    [anon_sym_public] = ACTIONS(1593),
    [anon_sym_private] = ACTIONS(1593),
    [anon_sym_protected] = ACTIONS(1593),
    [anon_sym_override] = ACTIONS(1593),
    [anon_sym_module] = ACTIONS(1593),
    [anon_sym_any] = ACTIONS(1593),
    [anon_sym_number] = ACTIONS(1593),
    [anon_sym_boolean] = ACTIONS(1593),
    [anon_sym_string] = ACTIONS(1593),
    [anon_sym_symbol] = ACTIONS(1593),
    [anon_sym_abstract] = ACTIONS(1593),
    [anon_sym_satisfies] = ACTIONS(1595),
    [anon_sym_interface] = ACTIONS(1593),
    [anon_sym_enum] = ACTIONS(1593),
    [sym__automatic_semicolon] = ACTIONS(1599),
    [sym__ternary_qmark] = ACTIONS(1597),
  },
  [169] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1561),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3792),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3710),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3709),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1601),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1601),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [170] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1828),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(3533),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(3533),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1171),
    [sym_subscript_expression] = STATE(1171),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(3533),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1171),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_export] = ACTIONS(1606),
    [anon_sym_type] = ACTIONS(1606),
    [anon_sym_namespace] = ACTIONS(1608),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_RBRACK] = ACTIONS(1453),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1610),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1457),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1606),
    [anon_sym_readonly] = ACTIONS(1606),
    [anon_sym_get] = ACTIONS(1606),
    [anon_sym_set] = ACTIONS(1606),
    [anon_sym_declare] = ACTIONS(1606),
    [anon_sym_public] = ACTIONS(1606),
    [anon_sym_private] = ACTIONS(1606),
    [anon_sym_protected] = ACTIONS(1606),
    [anon_sym_override] = ACTIONS(1606),
    [anon_sym_module] = ACTIONS(1606),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_symbol] = ACTIONS(1606),
  },
  [171] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2014),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1405),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_RBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1405),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
    [anon_sym_extends] = ACTIONS(1407),
  },
  [172] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_assignment_pattern] = STATE(3574),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3384),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_pattern_repeat1] = STATE(3596),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_RBRACK] = ACTIONS(1453),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [173] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1561),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3792),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3710),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3709),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1601),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1612),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [174] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_assignment_pattern] = STATE(3529),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3386),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_pattern_repeat1] = STATE(3645),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_RBRACK] = ACTIONS(1616),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [175] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1561),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3792),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_spread_element] = STATE(3710),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3709),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1601),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1618),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [176] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_assignment_pattern] = STATE(3792),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3709),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_RBRACK] = ACTIONS(1622),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [177] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1552),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_spread_element] = STATE(3580),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3581),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1626),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [178] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3330),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_accessibility_modifier] = STATE(209),
    [sym_override_modifier] = STATE(215),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(1149),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(1630),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1632),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1634),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [179] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1662),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1405),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
    [anon_sym_extends] = ACTIONS(1407),
  },
  [180] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1561),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_spread_element] = STATE(3710),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1636),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_RBRACK] = ACTIONS(1636),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [181] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1551),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_spread_element] = STATE(3518),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3521),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [182] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1392),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1405),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
    [anon_sym_extends] = ACTIONS(1407),
  },
  [183] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1562),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_spread_element] = STATE(3651),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3652),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1640),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [184] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1405),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_extends] = ACTIONS(1407),
  },
  [185] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1547),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_spread_element] = STATE(3578),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3572),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [186] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1566),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_spread_element] = STATE(3673),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3674),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [187] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1424),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1405),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
    [anon_sym_extends] = ACTIONS(1407),
  },
  [188] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1593),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_spread_element] = STATE(3599),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3601),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1646),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [189] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1571),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1405),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
    [anon_sym_extends] = ACTIONS(1407),
  },
  [190] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1938),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1405),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
    [anon_sym_extends] = ACTIONS(1407),
  },
  [191] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1563),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_spread_element] = STATE(3629),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [aux_sym_array_repeat1] = STATE(3627),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [192] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3332),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_override_modifier] = STATE(216),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(660),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1650),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [193] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1662),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [194] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1938),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1654),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [195] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1656),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [196] = {
    [sym_import] = STATE(1852),
    [sym_expression_statement] = STATE(222),
    [sym_empty_statement] = STATE(222),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [197] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [198] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2014),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [199] = {
    [sym_identifier] = ACTIONS(1662),
    [anon_sym_export] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1662),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(1662),
    [anon_sym_import] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(1662),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(1662),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(1662),
    [anon_sym_LBRACK] = ACTIONS(1664),
    [anon_sym_LTtemplate_GT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(1662),
    [anon_sym_async] = ACTIONS(1662),
    [anon_sym_function] = ACTIONS(1662),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1662),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(1662),
    [anon_sym_DASH] = ACTIONS(1662),
    [anon_sym_SLASH] = ACTIONS(1662),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(1664),
    [anon_sym_void] = ACTIONS(1662),
    [anon_sym_delete] = ACTIONS(1662),
    [anon_sym_PLUS_PLUS] = ACTIONS(1664),
    [anon_sym_DASH_DASH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_SQUOTE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [sym_number] = ACTIONS(1664),
    [sym_this] = ACTIONS(1662),
    [sym_super] = ACTIONS(1662),
    [sym_true] = ACTIONS(1662),
    [sym_false] = ACTIONS(1662),
    [sym_null] = ACTIONS(1662),
    [sym_undefined] = ACTIONS(1662),
    [anon_sym_AT] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1662),
    [anon_sym_readonly] = ACTIONS(1662),
    [anon_sym_get] = ACTIONS(1662),
    [anon_sym_set] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(1662),
    [anon_sym_public] = ACTIONS(1662),
    [anon_sym_private] = ACTIONS(1662),
    [anon_sym_protected] = ACTIONS(1662),
    [anon_sym_override] = ACTIONS(1662),
    [anon_sym_module] = ACTIONS(1662),
    [anon_sym_any] = ACTIONS(1662),
    [anon_sym_number] = ACTIONS(1662),
    [anon_sym_boolean] = ACTIONS(1662),
    [anon_sym_string] = ACTIONS(1662),
    [anon_sym_symbol] = ACTIONS(1662),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [200] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1659),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2887),
    [sym_assignment_pattern] = STATE(3986),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2887),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1087),
    [sym_subscript_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2887),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3516),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_readonly] = ACTIONS(552),
    [anon_sym_get] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(552),
    [anon_sym_declare] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_override] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_any] = ACTIONS(552),
    [anon_sym_number] = ACTIONS(552),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
  },
  [201] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_assignment_pattern] = STATE(3986),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3516),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [202] = {
    [sym_import] = STATE(1852),
    [sym_expression_statement] = STATE(221),
    [sym_empty_statement] = STATE(221),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3981),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [203] = {
    [sym_import] = STATE(2032),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym__type_query_member_expression] = STATE(2392),
    [sym__type_query_subscript_expression] = STATE(2391),
    [sym__type_query_call_expression] = STATE(2547),
    [sym__type_query_instantiation_expression] = STATE(2665),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1666),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [204] = {
    [sym_import] = STATE(1579),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1668),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [205] = {
    [sym_identifier] = ACTIONS(1670),
    [anon_sym_export] = ACTIONS(1670),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1670),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(1670),
    [anon_sym_import] = ACTIONS(1670),
    [anon_sym_BANG] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1672),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(1670),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_LTtemplate_GT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(1670),
    [anon_sym_async] = ACTIONS(1670),
    [anon_sym_function] = ACTIONS(1670),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1670),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1672),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(1670),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_SLASH] = ACTIONS(1670),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1670),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_void] = ACTIONS(1670),
    [anon_sym_delete] = ACTIONS(1670),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_DASH_DASH] = ACTIONS(1670),
    [anon_sym_DQUOTE] = ACTIONS(1672),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1672),
    [sym_number] = ACTIONS(1672),
    [sym_this] = ACTIONS(1670),
    [sym_super] = ACTIONS(1670),
    [sym_true] = ACTIONS(1670),
    [sym_false] = ACTIONS(1670),
    [sym_null] = ACTIONS(1670),
    [sym_undefined] = ACTIONS(1670),
    [anon_sym_AT] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1670),
    [anon_sym_readonly] = ACTIONS(1670),
    [anon_sym_get] = ACTIONS(1670),
    [anon_sym_set] = ACTIONS(1670),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(1670),
    [anon_sym_public] = ACTIONS(1670),
    [anon_sym_private] = ACTIONS(1670),
    [anon_sym_protected] = ACTIONS(1670),
    [anon_sym_override] = ACTIONS(1670),
    [anon_sym_module] = ACTIONS(1670),
    [anon_sym_any] = ACTIONS(1670),
    [anon_sym_number] = ACTIONS(1670),
    [anon_sym_boolean] = ACTIONS(1670),
    [anon_sym_string] = ACTIONS(1670),
    [anon_sym_symbol] = ACTIONS(1670),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [206] = {
    [sym_import] = STATE(1579),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1424),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1674),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [207] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2014),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1676),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [208] = {
    [sym_identifier] = ACTIONS(1662),
    [anon_sym_export] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1662),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(1662),
    [anon_sym_import] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(1662),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(1662),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(1662),
    [anon_sym_LBRACK] = ACTIONS(1664),
    [anon_sym_LTtemplate_GT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(1662),
    [anon_sym_async] = ACTIONS(1662),
    [anon_sym_function] = ACTIONS(1662),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1662),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1664),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(1662),
    [anon_sym_DASH] = ACTIONS(1662),
    [anon_sym_SLASH] = ACTIONS(1662),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(1664),
    [anon_sym_void] = ACTIONS(1662),
    [anon_sym_delete] = ACTIONS(1662),
    [anon_sym_PLUS_PLUS] = ACTIONS(1664),
    [anon_sym_DASH_DASH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_SQUOTE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [sym_number] = ACTIONS(1664),
    [sym_this] = ACTIONS(1662),
    [sym_super] = ACTIONS(1662),
    [sym_true] = ACTIONS(1662),
    [sym_false] = ACTIONS(1662),
    [sym_null] = ACTIONS(1662),
    [sym_undefined] = ACTIONS(1662),
    [anon_sym_AT] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1662),
    [anon_sym_readonly] = ACTIONS(1662),
    [anon_sym_get] = ACTIONS(1662),
    [anon_sym_set] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(1662),
    [anon_sym_public] = ACTIONS(1662),
    [anon_sym_private] = ACTIONS(1662),
    [anon_sym_protected] = ACTIONS(1662),
    [anon_sym_override] = ACTIONS(1662),
    [anon_sym_module] = ACTIONS(1662),
    [anon_sym_any] = ACTIONS(1662),
    [anon_sym_number] = ACTIONS(1662),
    [anon_sym_boolean] = ACTIONS(1662),
    [anon_sym_string] = ACTIONS(1662),
    [anon_sym_symbol] = ACTIONS(1662),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [209] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3257),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_override_modifier] = STATE(219),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1678),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1680),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [210] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2014),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1682),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [211] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1684),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [212] = {
    [sym_identifier] = ACTIONS(1670),
    [anon_sym_export] = ACTIONS(1670),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1670),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(1670),
    [anon_sym_import] = ACTIONS(1670),
    [anon_sym_BANG] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1672),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(1670),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_LTtemplate_GT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_class] = ACTIONS(1670),
    [anon_sym_async] = ACTIONS(1670),
    [anon_sym_function] = ACTIONS(1670),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(1670),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1672),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(1670),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_SLASH] = ACTIONS(1670),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1670),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_void] = ACTIONS(1670),
    [anon_sym_delete] = ACTIONS(1670),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_DASH_DASH] = ACTIONS(1670),
    [anon_sym_DQUOTE] = ACTIONS(1672),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1672),
    [sym_number] = ACTIONS(1672),
    [sym_this] = ACTIONS(1670),
    [sym_super] = ACTIONS(1670),
    [sym_true] = ACTIONS(1670),
    [sym_false] = ACTIONS(1670),
    [sym_null] = ACTIONS(1670),
    [sym_undefined] = ACTIONS(1670),
    [anon_sym_AT] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1670),
    [anon_sym_readonly] = ACTIONS(1670),
    [anon_sym_get] = ACTIONS(1670),
    [anon_sym_set] = ACTIONS(1670),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(1670),
    [anon_sym_public] = ACTIONS(1670),
    [anon_sym_private] = ACTIONS(1670),
    [anon_sym_protected] = ACTIONS(1670),
    [anon_sym_override] = ACTIONS(1670),
    [anon_sym_module] = ACTIONS(1670),
    [anon_sym_any] = ACTIONS(1670),
    [anon_sym_number] = ACTIONS(1670),
    [anon_sym_boolean] = ACTIONS(1670),
    [anon_sym_string] = ACTIONS(1670),
    [anon_sym_symbol] = ACTIONS(1670),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [213] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1571),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [214] = {
    [sym_import] = STATE(1579),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1392),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym__type_query_member_expression] = STATE(2346),
    [sym__type_query_subscript_expression] = STATE(2345),
    [sym__type_query_call_expression] = STATE(2390),
    [sym__type_query_instantiation_expression] = STATE(2423),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1688),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [215] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3256),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1690),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1692),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [216] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3268),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(658),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1694),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [217] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3332),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(660),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1650),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [218] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(3653),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(3653),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(3653),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1696),
    [anon_sym_export] = ACTIONS(1698),
    [anon_sym_type] = ACTIONS(1698),
    [anon_sym_namespace] = ACTIONS(1700),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_var] = ACTIONS(1704),
    [anon_sym_let] = ACTIONS(1706),
    [anon_sym_const] = ACTIONS(1706),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1708),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1710),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1712),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1698),
    [anon_sym_readonly] = ACTIONS(1698),
    [anon_sym_get] = ACTIONS(1698),
    [anon_sym_set] = ACTIONS(1698),
    [anon_sym_declare] = ACTIONS(1698),
    [anon_sym_public] = ACTIONS(1698),
    [anon_sym_private] = ACTIONS(1698),
    [anon_sym_protected] = ACTIONS(1698),
    [anon_sym_override] = ACTIONS(1698),
    [anon_sym_module] = ACTIONS(1698),
    [anon_sym_any] = ACTIONS(1698),
    [anon_sym_number] = ACTIONS(1698),
    [anon_sym_boolean] = ACTIONS(1698),
    [anon_sym_string] = ACTIONS(1698),
    [anon_sym_symbol] = ACTIONS(1698),
  },
  [219] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2925),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2925),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1085),
    [sym_subscript_expression] = STATE(1085),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2925),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_pattern] = STATE(3145),
    [sym_rest_pattern] = STATE(2838),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(143),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(1714),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1716),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
  },
  [220] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1592),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3915),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(1718),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
    [sym__automatic_semicolon] = ACTIONS(1718),
  },
  [221] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1808),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4086),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1720),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [222] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1786),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4056),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1722),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [223] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3214),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3900),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1726),
    [anon_sym_type] = ACTIONS(1726),
    [anon_sym_namespace] = ACTIONS(1728),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1732),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1726),
    [anon_sym_readonly] = ACTIONS(1726),
    [anon_sym_get] = ACTIONS(1726),
    [anon_sym_set] = ACTIONS(1726),
    [anon_sym_declare] = ACTIONS(1726),
    [anon_sym_public] = ACTIONS(1726),
    [anon_sym_private] = ACTIONS(1726),
    [anon_sym_protected] = ACTIONS(1726),
    [anon_sym_override] = ACTIONS(1726),
    [anon_sym_module] = ACTIONS(1726),
    [anon_sym_any] = ACTIONS(1726),
    [anon_sym_number] = ACTIONS(1726),
    [anon_sym_boolean] = ACTIONS(1726),
    [anon_sym_string] = ACTIONS(1726),
    [anon_sym_symbol] = ACTIONS(1726),
  },
  [224] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1745),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [225] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1889),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1454),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [226] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1888),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1494),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [227] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [228] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1886),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1447),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [229] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1976),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1690),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [230] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1491),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1874),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [231] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1523),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1865),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [232] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1514),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1841),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [233] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1367),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [234] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3131),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3832),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1740),
    [anon_sym_export] = ACTIONS(1742),
    [anon_sym_type] = ACTIONS(1742),
    [anon_sym_namespace] = ACTIONS(1744),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1746),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1742),
    [anon_sym_readonly] = ACTIONS(1742),
    [anon_sym_get] = ACTIONS(1742),
    [anon_sym_set] = ACTIONS(1742),
    [anon_sym_declare] = ACTIONS(1742),
    [anon_sym_public] = ACTIONS(1742),
    [anon_sym_private] = ACTIONS(1742),
    [anon_sym_protected] = ACTIONS(1742),
    [anon_sym_override] = ACTIONS(1742),
    [anon_sym_module] = ACTIONS(1742),
    [anon_sym_any] = ACTIONS(1742),
    [anon_sym_number] = ACTIONS(1742),
    [anon_sym_boolean] = ACTIONS(1742),
    [anon_sym_string] = ACTIONS(1742),
    [anon_sym_symbol] = ACTIONS(1742),
  },
  [235] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1693),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4007),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [236] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3214),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3900),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [237] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1574),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3913),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [238] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1748),
    [anon_sym_export] = ACTIONS(1750),
    [anon_sym_type] = ACTIONS(1750),
    [anon_sym_namespace] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1754),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1750),
    [anon_sym_readonly] = ACTIONS(1750),
    [anon_sym_get] = ACTIONS(1750),
    [anon_sym_set] = ACTIONS(1750),
    [anon_sym_declare] = ACTIONS(1750),
    [anon_sym_public] = ACTIONS(1750),
    [anon_sym_private] = ACTIONS(1750),
    [anon_sym_protected] = ACTIONS(1750),
    [anon_sym_override] = ACTIONS(1750),
    [anon_sym_module] = ACTIONS(1750),
    [anon_sym_any] = ACTIONS(1750),
    [anon_sym_number] = ACTIONS(1750),
    [anon_sym_boolean] = ACTIONS(1750),
    [anon_sym_string] = ACTIONS(1750),
    [anon_sym_symbol] = ACTIONS(1750),
  },
  [239] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1914),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [240] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1933),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [241] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1878),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_mapped_type_clause] = STATE(4010),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1756),
    [anon_sym_export] = ACTIONS(1758),
    [anon_sym_type] = ACTIONS(1758),
    [anon_sym_namespace] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1762),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1758),
    [anon_sym_readonly] = ACTIONS(1758),
    [anon_sym_get] = ACTIONS(1758),
    [anon_sym_set] = ACTIONS(1758),
    [anon_sym_declare] = ACTIONS(1758),
    [anon_sym_public] = ACTIONS(1758),
    [anon_sym_private] = ACTIONS(1758),
    [anon_sym_protected] = ACTIONS(1758),
    [anon_sym_override] = ACTIONS(1758),
    [anon_sym_module] = ACTIONS(1758),
    [anon_sym_any] = ACTIONS(1758),
    [anon_sym_number] = ACTIONS(1758),
    [anon_sym_boolean] = ACTIONS(1758),
    [anon_sym_string] = ACTIONS(1758),
    [anon_sym_symbol] = ACTIONS(1758),
  },
  [242] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1446),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1958),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [243] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1119),
    [sym_expression] = STATE(2030),
    [sym_primary_expression] = STATE(1441),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1119),
    [sym_subscript_expression] = STATE(1119),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1119),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1764),
    [anon_sym_export] = ACTIONS(1766),
    [anon_sym_type] = ACTIONS(1766),
    [anon_sym_namespace] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1770),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1772),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1766),
    [anon_sym_readonly] = ACTIONS(1766),
    [anon_sym_get] = ACTIONS(1766),
    [anon_sym_set] = ACTIONS(1766),
    [anon_sym_declare] = ACTIONS(1766),
    [anon_sym_public] = ACTIONS(1766),
    [anon_sym_private] = ACTIONS(1766),
    [anon_sym_protected] = ACTIONS(1766),
    [anon_sym_override] = ACTIONS(1766),
    [anon_sym_module] = ACTIONS(1766),
    [anon_sym_any] = ACTIONS(1766),
    [anon_sym_number] = ACTIONS(1766),
    [anon_sym_boolean] = ACTIONS(1766),
    [anon_sym_string] = ACTIONS(1766),
    [anon_sym_symbol] = ACTIONS(1766),
  },
  [244] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3214),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3900),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1778),
    [anon_sym_export] = ACTIONS(1780),
    [anon_sym_type] = ACTIONS(1780),
    [anon_sym_namespace] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1784),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1780),
    [anon_sym_readonly] = ACTIONS(1780),
    [anon_sym_get] = ACTIONS(1780),
    [anon_sym_set] = ACTIONS(1780),
    [anon_sym_declare] = ACTIONS(1780),
    [anon_sym_public] = ACTIONS(1780),
    [anon_sym_private] = ACTIONS(1780),
    [anon_sym_protected] = ACTIONS(1780),
    [anon_sym_override] = ACTIONS(1780),
    [anon_sym_module] = ACTIONS(1780),
    [anon_sym_any] = ACTIONS(1780),
    [anon_sym_number] = ACTIONS(1780),
    [anon_sym_boolean] = ACTIONS(1780),
    [anon_sym_string] = ACTIONS(1780),
    [anon_sym_symbol] = ACTIONS(1780),
  },
  [245] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1780),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4049),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [246] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1119),
    [sym_expression] = STATE(2030),
    [sym_primary_expression] = STATE(1441),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1119),
    [sym_subscript_expression] = STATE(1119),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3214),
    [sym_non_null_expression] = STATE(1119),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3900),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1770),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_readonly] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_override] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
  },
  [247] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1514),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1619),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [248] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1523),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1620),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [249] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1778),
    [anon_sym_export] = ACTIONS(1780),
    [anon_sym_type] = ACTIONS(1780),
    [anon_sym_namespace] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1784),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1780),
    [anon_sym_readonly] = ACTIONS(1780),
    [anon_sym_get] = ACTIONS(1780),
    [anon_sym_set] = ACTIONS(1780),
    [anon_sym_declare] = ACTIONS(1780),
    [anon_sym_public] = ACTIONS(1780),
    [anon_sym_private] = ACTIONS(1780),
    [anon_sym_protected] = ACTIONS(1780),
    [anon_sym_override] = ACTIONS(1780),
    [anon_sym_module] = ACTIONS(1780),
    [anon_sym_any] = ACTIONS(1780),
    [anon_sym_number] = ACTIONS(1780),
    [anon_sym_boolean] = ACTIONS(1780),
    [anon_sym_string] = ACTIONS(1780),
    [anon_sym_symbol] = ACTIONS(1780),
  },
  [250] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1491),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1621),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [251] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1961),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1718),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [252] = {
    [sym_namespace_export] = STATE(3970),
    [sym_export_clause] = STATE(3380),
    [sym_declaration] = STATE(713),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_class_declaration] = STATE(674),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function_declaration] = STATE(674),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(674),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(716),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [aux_sym_export_statement_repeat1] = STATE(3370),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [anon_sym_STAR] = ACTIONS(1794),
    [anon_sym_default] = ACTIONS(1796),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1800),
    [anon_sym_as] = ACTIONS(1802),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_LBRACE] = ACTIONS(1806),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1808),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1837),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [253] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1623),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [254] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1770),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [255] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1119),
    [sym_expression] = STATE(2030),
    [sym_primary_expression] = STATE(1441),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1119),
    [sym_subscript_expression] = STATE(1119),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1119),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1847),
    [anon_sym_type] = ACTIONS(1847),
    [anon_sym_namespace] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1770),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1851),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1847),
    [anon_sym_readonly] = ACTIONS(1847),
    [anon_sym_get] = ACTIONS(1847),
    [anon_sym_set] = ACTIONS(1847),
    [anon_sym_declare] = ACTIONS(1847),
    [anon_sym_public] = ACTIONS(1847),
    [anon_sym_private] = ACTIONS(1847),
    [anon_sym_protected] = ACTIONS(1847),
    [anon_sym_override] = ACTIONS(1847),
    [anon_sym_module] = ACTIONS(1847),
    [anon_sym_any] = ACTIONS(1847),
    [anon_sym_number] = ACTIONS(1847),
    [anon_sym_boolean] = ACTIONS(1847),
    [anon_sym_string] = ACTIONS(1847),
    [anon_sym_symbol] = ACTIONS(1847),
  },
  [256] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [257] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1643),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [258] = {
    [sym_namespace_export] = STATE(3970),
    [sym_export_clause] = STATE(3380),
    [sym_declaration] = STATE(713),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_class_declaration] = STATE(674),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function_declaration] = STATE(674),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(674),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(716),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [aux_sym_export_statement_repeat1] = STATE(3370),
    [aux_sym_object_repeat1] = STATE(3660),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [anon_sym_STAR] = ACTIONS(1794),
    [anon_sym_default] = ACTIONS(1796),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1800),
    [anon_sym_as] = ACTIONS(1802),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_LBRACE] = ACTIONS(1806),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1837),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [259] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1886),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1747),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [260] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1888),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1748),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [261] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1650),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4042),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [262] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1889),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1749),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [263] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1446),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1664),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [264] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1976),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1526),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [265] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1793),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4069),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [266] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1804),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4074),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [267] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1805),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4083),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [268] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3214),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3900),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1740),
    [anon_sym_export] = ACTIONS(1742),
    [anon_sym_type] = ACTIONS(1742),
    [anon_sym_namespace] = ACTIONS(1744),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1746),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1742),
    [anon_sym_readonly] = ACTIONS(1742),
    [anon_sym_get] = ACTIONS(1742),
    [anon_sym_set] = ACTIONS(1742),
    [anon_sym_declare] = ACTIONS(1742),
    [anon_sym_public] = ACTIONS(1742),
    [anon_sym_private] = ACTIONS(1742),
    [anon_sym_protected] = ACTIONS(1742),
    [anon_sym_override] = ACTIONS(1742),
    [anon_sym_module] = ACTIONS(1742),
    [anon_sym_any] = ACTIONS(1742),
    [anon_sym_number] = ACTIONS(1742),
    [anon_sym_boolean] = ACTIONS(1742),
    [anon_sym_string] = ACTIONS(1742),
    [anon_sym_symbol] = ACTIONS(1742),
  },
  [269] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3214),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3900),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1748),
    [anon_sym_export] = ACTIONS(1750),
    [anon_sym_type] = ACTIONS(1750),
    [anon_sym_namespace] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1754),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1750),
    [anon_sym_readonly] = ACTIONS(1750),
    [anon_sym_get] = ACTIONS(1750),
    [anon_sym_set] = ACTIONS(1750),
    [anon_sym_declare] = ACTIONS(1750),
    [anon_sym_public] = ACTIONS(1750),
    [anon_sym_private] = ACTIONS(1750),
    [anon_sym_protected] = ACTIONS(1750),
    [anon_sym_override] = ACTIONS(1750),
    [anon_sym_module] = ACTIONS(1750),
    [anon_sym_any] = ACTIONS(1750),
    [anon_sym_number] = ACTIONS(1750),
    [anon_sym_boolean] = ACTIONS(1750),
    [anon_sym_string] = ACTIONS(1750),
    [anon_sym_symbol] = ACTIONS(1750),
  },
  [270] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1889),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1452),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [271] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1491),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1262),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [272] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1523),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1312),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [273] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1514),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1366),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [274] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1888),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1474),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [275] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1604),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym__extends_clause_single] = STATE(3412),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [276] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1886),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1385),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [277] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1961),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1496),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [278] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1119),
    [sym_expression] = STATE(2030),
    [sym_primary_expression] = STATE(1441),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1119),
    [sym_subscript_expression] = STATE(1119),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3214),
    [sym_non_null_expression] = STATE(1119),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3900),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1764),
    [anon_sym_export] = ACTIONS(1766),
    [anon_sym_type] = ACTIONS(1766),
    [anon_sym_namespace] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1770),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1772),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1766),
    [anon_sym_readonly] = ACTIONS(1766),
    [anon_sym_get] = ACTIONS(1766),
    [anon_sym_set] = ACTIONS(1766),
    [anon_sym_declare] = ACTIONS(1766),
    [anon_sym_public] = ACTIONS(1766),
    [anon_sym_private] = ACTIONS(1766),
    [anon_sym_protected] = ACTIONS(1766),
    [anon_sym_override] = ACTIONS(1766),
    [anon_sym_module] = ACTIONS(1766),
    [anon_sym_any] = ACTIONS(1766),
    [anon_sym_number] = ACTIONS(1766),
    [anon_sym_boolean] = ACTIONS(1766),
    [anon_sym_string] = ACTIONS(1766),
    [anon_sym_symbol] = ACTIONS(1766),
  },
  [279] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1543),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_sequence_expression] = STATE(3909),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [280] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1446),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1296),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [281] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1119),
    [sym_expression] = STATE(2030),
    [sym_primary_expression] = STATE(1441),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1119),
    [sym_subscript_expression] = STATE(1119),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1119),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1770),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_readonly] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_override] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
  },
  [282] = {
    [sym_namespace_export] = STATE(3970),
    [sym_export_clause] = STATE(3380),
    [sym_declaration] = STATE(713),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_class_declaration] = STATE(674),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function_declaration] = STATE(674),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(674),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(716),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [aux_sym_export_statement_repeat1] = STATE(3370),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [anon_sym_STAR] = ACTIONS(1794),
    [anon_sym_default] = ACTIONS(1796),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1800),
    [anon_sym_as] = ACTIONS(1802),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_LBRACE] = ACTIONS(1806),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1837),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [283] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1658),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4029),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [284] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1446),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1573),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [285] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1878),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_mapped_type_clause] = STATE(4097),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1857),
    [anon_sym_export] = ACTIONS(1859),
    [anon_sym_type] = ACTIONS(1859),
    [anon_sym_namespace] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1863),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1859),
    [anon_sym_readonly] = ACTIONS(1859),
    [anon_sym_get] = ACTIONS(1859),
    [anon_sym_set] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1859),
    [anon_sym_public] = ACTIONS(1859),
    [anon_sym_private] = ACTIONS(1859),
    [anon_sym_protected] = ACTIONS(1859),
    [anon_sym_override] = ACTIONS(1859),
    [anon_sym_module] = ACTIONS(1859),
    [anon_sym_any] = ACTIONS(1859),
    [anon_sym_number] = ACTIONS(1859),
    [anon_sym_boolean] = ACTIONS(1859),
    [anon_sym_string] = ACTIONS(1859),
    [anon_sym_symbol] = ACTIONS(1859),
  },
  [286] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1675),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4151),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [287] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1677),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4154),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [288] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1604),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym__extends_clause_single] = STATE(3704),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [289] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1976),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1511),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [290] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1678),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4156),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [291] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1585),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [292] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1834),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1468),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [293] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1726),
    [anon_sym_type] = ACTIONS(1726),
    [anon_sym_namespace] = ACTIONS(1728),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1732),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1726),
    [anon_sym_readonly] = ACTIONS(1726),
    [anon_sym_get] = ACTIONS(1726),
    [anon_sym_set] = ACTIONS(1726),
    [anon_sym_declare] = ACTIONS(1726),
    [anon_sym_public] = ACTIONS(1726),
    [anon_sym_private] = ACTIONS(1726),
    [anon_sym_protected] = ACTIONS(1726),
    [anon_sym_override] = ACTIONS(1726),
    [anon_sym_module] = ACTIONS(1726),
    [anon_sym_any] = ACTIONS(1726),
    [anon_sym_number] = ACTIONS(1726),
    [anon_sym_boolean] = ACTIONS(1726),
    [anon_sym_string] = ACTIONS(1726),
    [anon_sym_symbol] = ACTIONS(1726),
  },
  [294] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1221),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1740),
    [anon_sym_export] = ACTIONS(1742),
    [anon_sym_type] = ACTIONS(1742),
    [anon_sym_namespace] = ACTIONS(1744),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1746),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1742),
    [anon_sym_readonly] = ACTIONS(1742),
    [anon_sym_get] = ACTIONS(1742),
    [anon_sym_set] = ACTIONS(1742),
    [anon_sym_declare] = ACTIONS(1742),
    [anon_sym_public] = ACTIONS(1742),
    [anon_sym_private] = ACTIONS(1742),
    [anon_sym_protected] = ACTIONS(1742),
    [anon_sym_override] = ACTIONS(1742),
    [anon_sym_module] = ACTIONS(1742),
    [anon_sym_any] = ACTIONS(1742),
    [anon_sym_number] = ACTIONS(1742),
    [anon_sym_boolean] = ACTIONS(1742),
    [anon_sym_string] = ACTIONS(1742),
    [anon_sym_symbol] = ACTIONS(1742),
  },
  [295] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1501),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4313),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [296] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1523),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1550),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [297] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1491),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2020),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [298] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1446),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2044),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [299] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1302),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(3465),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [300] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1775),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4037),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [301] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4256),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [302] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1523),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2018),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [303] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1491),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1548),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [304] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1514),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2013),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [305] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1288),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [306] = {
    [sym_import] = STATE(1852),
    [sym_statement_block] = STATE(1961),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1458),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [307] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1676),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4152),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [308] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1119),
    [sym_expression] = STATE(2030),
    [sym_primary_expression] = STATE(1441),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1119),
    [sym_subscript_expression] = STATE(1119),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(3214),
    [sym_non_null_expression] = STATE(1119),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3900),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1847),
    [anon_sym_type] = ACTIONS(1847),
    [anon_sym_namespace] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1770),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1851),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1847),
    [anon_sym_readonly] = ACTIONS(1847),
    [anon_sym_get] = ACTIONS(1847),
    [anon_sym_set] = ACTIONS(1847),
    [anon_sym_declare] = ACTIONS(1847),
    [anon_sym_public] = ACTIONS(1847),
    [anon_sym_private] = ACTIONS(1847),
    [anon_sym_protected] = ACTIONS(1847),
    [anon_sym_override] = ACTIONS(1847),
    [anon_sym_module] = ACTIONS(1847),
    [anon_sym_any] = ACTIONS(1847),
    [anon_sym_number] = ACTIONS(1847),
    [anon_sym_boolean] = ACTIONS(1847),
    [anon_sym_string] = ACTIONS(1847),
    [anon_sym_symbol] = ACTIONS(1847),
  },
  [309] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2001),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [310] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1541),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [311] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1514),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1557),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [312] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1403),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_sequence_expression] = STATE(4034),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [313] = {
    [sym_import] = STATE(1464),
    [sym_statement_block] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2011),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [314] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1646),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [315] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1324),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [316] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1313),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [317] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1306),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [318] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1295),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [319] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1900),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [320] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1451),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [321] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1456),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [322] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1787),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [323] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1281),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [324] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1659),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [325] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1689),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [326] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1744),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [327] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2034),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [328] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2047),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [329] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1866),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [330] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [331] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1388),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [332] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1814),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [333] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1938),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [334] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2045),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [335] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2002),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [336] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2025),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [337] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2000),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [338] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [339] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2041),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [340] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [341] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2037),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [342] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2036),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [343] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2035),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [344] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2010),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [345] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2009),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [346] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2008),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [347] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2006),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [348] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [349] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1544),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [350] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1940),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [351] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1554),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [352] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1386),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [353] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1539),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [354] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1429),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [355] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1907),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [356] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1330),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [357] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1568),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [358] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1598),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [359] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1828),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [360] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1559),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [361] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1423),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [362] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1865),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [363] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1345),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [364] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(2874),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(2874),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1082),
    [sym_subscript_expression] = STATE(1082),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(2874),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1082),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1867),
    [anon_sym_export] = ACTIONS(1869),
    [anon_sym_type] = ACTIONS(1869),
    [anon_sym_namespace] = ACTIONS(1871),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1331),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1873),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1875),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1869),
    [anon_sym_readonly] = ACTIONS(1869),
    [anon_sym_get] = ACTIONS(1869),
    [anon_sym_set] = ACTIONS(1869),
    [anon_sym_declare] = ACTIONS(1869),
    [anon_sym_public] = ACTIONS(1869),
    [anon_sym_private] = ACTIONS(1869),
    [anon_sym_protected] = ACTIONS(1869),
    [anon_sym_override] = ACTIONS(1869),
    [anon_sym_module] = ACTIONS(1869),
    [anon_sym_any] = ACTIONS(1869),
    [anon_sym_number] = ACTIONS(1869),
    [anon_sym_boolean] = ACTIONS(1869),
    [anon_sym_string] = ACTIONS(1869),
    [anon_sym_symbol] = ACTIONS(1869),
  },
  [365] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1346),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [366] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [367] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2049),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [368] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1424),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [369] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1381),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [370] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1607),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [371] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1609),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [372] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1606),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [373] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1512),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [374] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1938),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1877),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [375] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1605),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [376] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1923),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [377] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1599),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [378] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2014),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [379] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(1999),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [380] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1473),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [381] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1833),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [382] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1314),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [383] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1662),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1877),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [384] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1571),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1877),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [385] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1466),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [386] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1591),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [387] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1422),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [388] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1839),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [389] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1334),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [390] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1399),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [391] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1469),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [392] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1818),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [393] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1960),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [394] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1691),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [395] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1588),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [396] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1417),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [397] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1488),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [398] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1692),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [399] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1478),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [400] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1479),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [401] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1584),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [402] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1578),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [403] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1879),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [404] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1393),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [405] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1509),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [406] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1576),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [407] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1480),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [408] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1384),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [409] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1483),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [410] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1899),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [411] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1870),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [412] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1515),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [413] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1516),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [414] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1517),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [415] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1484),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [416] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1485),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [417] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1247),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [418] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [419] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1519),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [420] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1521),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [421] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1524),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [422] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1577),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [423] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1424),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1865),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [424] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1531),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [425] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1857),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [426] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1528),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [427] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1518),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [428] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1392),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [429] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1404),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [430] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1840),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [431] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1880),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [432] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1854),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [433] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1510),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [434] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1962),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [435] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1500),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [436] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1877),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [437] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1492),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [438] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1291),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [439] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1499),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [440] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1838),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [441] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1316),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [442] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1879),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [443] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1495),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [444] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1611),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [445] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2014),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1881),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [446] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1472),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [447] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1979),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [448] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1708),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [449] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1319),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [450] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1320),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [451] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1373),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [452] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1881),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [453] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1322),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [454] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2014),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1877),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [455] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1527),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [456] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1847),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [457] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1298),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [458] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1419),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [459] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1709),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [460] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1897),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [461] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1475),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(3343),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(3343),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(3343),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(974),
    [anon_sym_type] = ACTIONS(974),
    [anon_sym_namespace] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(980),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(974),
    [anon_sym_readonly] = ACTIONS(974),
    [anon_sym_get] = ACTIONS(974),
    [anon_sym_set] = ACTIONS(974),
    [anon_sym_declare] = ACTIONS(974),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_override] = ACTIONS(974),
    [anon_sym_module] = ACTIONS(974),
    [anon_sym_any] = ACTIONS(974),
    [anon_sym_number] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(974),
    [anon_sym_symbol] = ACTIONS(974),
  },
  [462] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1837),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [463] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1902),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [464] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1665),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [465] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1450),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [466] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1905),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [467] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1663),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [468] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1572),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [469] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1887),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [470] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1934),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [471] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1645),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [472] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1532),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [473] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1644),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [474] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1558),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [475] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [476] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1638),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [477] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1637),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [478] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1636),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [479] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1635),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [480] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1634),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [481] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1710),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [482] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1431),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [483] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1349),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [484] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1935),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [485] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1633),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [486] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1632),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [487] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [488] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1785),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [489] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1784),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [490] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1630),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [491] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1627),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [492] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1586),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [493] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [494] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1624),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [495] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1603),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [496] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1824),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [497] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1878),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [498] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1943),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [499] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1571),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4278),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4278),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4233),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2451),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4278),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(418),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(990),
    [anon_sym_readonly] = ACTIONS(990),
    [anon_sym_get] = ACTIONS(990),
    [anon_sym_set] = ACTIONS(990),
    [anon_sym_declare] = ACTIONS(990),
    [anon_sym_public] = ACTIONS(990),
    [anon_sym_private] = ACTIONS(990),
    [anon_sym_protected] = ACTIONS(990),
    [anon_sym_override] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [anon_sym_any] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_boolean] = ACTIONS(990),
    [anon_sym_string] = ACTIONS(990),
    [anon_sym_symbol] = ACTIONS(990),
  },
  [500] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1959),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4310),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4310),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4073),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2407),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4310),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(500),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(804),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(794),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(800),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_void] = ACTIONS(804),
    [anon_sym_delete] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_readonly] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
  },
  [501] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1719),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [502] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1826),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [503] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1622),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [504] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1597),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [505] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1435),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [506] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [507] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1717),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [508] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_expression] = STATE(2014),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4132),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4132),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4033),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2471),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4132),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(328),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_type] = ACTIONS(868),
    [anon_sym_namespace] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1879),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_get] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(868),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_public] = ACTIONS(868),
    [anon_sym_private] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(868),
    [anon_sym_override] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
  },
  [509] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1716),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [510] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1715),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [511] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1711),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [512] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1712),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [513] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1714),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [514] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_expression] = STATE(1392),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4286),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2411),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4288),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(385),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_type] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1865),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_declare] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_module] = ACTIONS(908),
    [anon_sym_any] = ACTIONS(908),
    [anon_sym_number] = ACTIONS(908),
    [anon_sym_boolean] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_symbol] = ACTIONS(908),
  },
  [515] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_expression] = STATE(1475),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4032),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4032),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4124),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1096),
    [sym_subscript_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4032),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(457),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(590),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(766),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_readonly] = ACTIONS(758),
    [anon_sym_get] = ACTIONS(758),
    [anon_sym_set] = ACTIONS(758),
    [anon_sym_declare] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_override] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_any] = ACTIONS(758),
    [anon_sym_number] = ACTIONS(758),
    [anon_sym_boolean] = ACTIONS(758),
    [anon_sym_string] = ACTIONS(758),
    [anon_sym_symbol] = ACTIONS(758),
  },
  [516] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1965),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [517] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1669),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [518] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_expression] = STATE(1476),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4315),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4315),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4318),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1140),
    [sym_subscript_expression] = STATE(1140),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4315),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(505),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_readonly] = ACTIONS(826),
    [anon_sym_get] = ACTIONS(826),
    [anon_sym_set] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_override] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(826),
    [anon_sym_number] = ACTIONS(826),
    [anon_sym_boolean] = ACTIONS(826),
    [anon_sym_string] = ACTIONS(826),
    [anon_sym_symbol] = ACTIONS(826),
  },
  [519] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1867),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [520] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1662),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [521] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1670),
    [sym_primary_expression] = STATE(1276),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1464),
    [sym_object_pattern] = STATE(4235),
    [sym_array] = STATE(1464),
    [sym_array_pattern] = STATE(4235),
    [sym_glimmer_template] = STATE(1455),
    [sym_glimmer_opening_tag] = STATE(3408),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1464),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(4017),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1455),
    [sym__augmented_assignment_lhs] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym__destructuring_pattern] = STATE(4235),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_satisfies_expression] = STATE(1455),
    [sym_instantiation_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(464),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3467),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1094),
    [anon_sym_delete] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(644),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_readonly] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_override] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
  },
  [522] = {
    [sym_import] = STATE(1852),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1713),
    [sym_primary_expression] = STATE(1679),
    [sym_yield_expression] = STATE(1844),
    [sym_object] = STATE(1852),
    [sym_object_pattern] = STATE(4118),
    [sym_array] = STATE(1852),
    [sym_array_pattern] = STATE(4118),
    [sym_glimmer_template] = STATE(1844),
    [sym_glimmer_opening_tag] = STATE(3376),
    [sym_class] = STATE(1852),
    [sym_function] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_arrow_function] = STATE(1852),
    [sym__call_signature] = STATE(4116),
    [sym_call_expression] = STATE(1852),
    [sym_new_expression] = STATE(1844),
    [sym_await_expression] = STATE(1844),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1844),
    [sym__augmented_assignment_lhs] = STATE(2449),
    [sym_augmented_assignment_expression] = STATE(1844),
    [sym__destructuring_pattern] = STATE(4118),
    [sym_ternary_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_update_expression] = STATE(1844),
    [sym_string] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_meta_property] = STATE(1852),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2949),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1844),
    [sym_as_expression] = STATE(1844),
    [sym_satisfies_expression] = STATE(1844),
    [sym_instantiation_expression] = STATE(1844),
    [sym_internal_module] = STATE(1844),
    [sym_type_arguments] = STATE(332),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_export_statement_repeat1] = STATE(3381),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(91),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
  },
  [523] = {
    [sym_declaration] = STATE(646),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_class_declaration] = STATE(674),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function_declaration] = STATE(674),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(674),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(716),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [aux_sym_export_statement_repeat1] = STATE(3370),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1889),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_global] = ACTIONS(1895),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [524] = {
    [sym_declaration] = STATE(646),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_class_declaration] = STATE(674),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function_declaration] = STATE(674),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(674),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(716),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [aux_sym_export_statement_repeat1] = STATE(3370),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1889),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1808),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_global] = ACTIONS(1895),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [525] = {
    [sym_declaration] = STATE(646),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_class_declaration] = STATE(674),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function_declaration] = STATE(674),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(674),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(716),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [aux_sym_export_statement_repeat1] = STATE(3370),
    [aux_sym_object_repeat1] = STATE(3660),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1889),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_global] = ACTIONS(1895),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [526] = {
    [sym_namespace_export] = STATE(3970),
    [sym_export_clause] = STATE(3380),
    [sym_declaration] = STATE(713),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_class_declaration] = STATE(674),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function_declaration] = STATE(674),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(674),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(716),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [aux_sym_export_statement_repeat1] = STATE(3370),
    [anon_sym_STAR] = ACTIONS(1794),
    [anon_sym_default] = ACTIONS(1796),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(1802),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_LBRACE] = ACTIONS(1806),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1837),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [527] = {
    [sym_namespace_export] = STATE(3970),
    [sym_export_clause] = STATE(3380),
    [sym_declaration] = STATE(713),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_class_declaration] = STATE(674),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function_declaration] = STATE(674),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(674),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(716),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [aux_sym_export_statement_repeat1] = STATE(3370),
    [anon_sym_STAR] = ACTIONS(1794),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(1802),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_LBRACE] = ACTIONS(1806),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1837),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [528] = {
    [sym__call_signature] = STATE(4245),
    [sym_string] = STATE(2970),
    [sym_formal_parameters] = STATE(2949),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1905),
    [anon_sym_export] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_type] = ACTIONS(1907),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1907),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1912),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1907),
    [anon_sym_function] = ACTIONS(1919),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1921),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1907),
    [anon_sym_readonly] = ACTIONS(1907),
    [anon_sym_get] = ACTIONS(1931),
    [anon_sym_set] = ACTIONS(1931),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1907),
    [anon_sym_public] = ACTIONS(1907),
    [anon_sym_private] = ACTIONS(1907),
    [anon_sym_protected] = ACTIONS(1907),
    [anon_sym_override] = ACTIONS(1907),
    [anon_sym_module] = ACTIONS(1907),
    [anon_sym_any] = ACTIONS(1907),
    [anon_sym_number] = ACTIONS(1907),
    [anon_sym_boolean] = ACTIONS(1907),
    [anon_sym_string] = ACTIONS(1907),
    [anon_sym_symbol] = ACTIONS(1907),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [529] = {
    [sym__call_signature] = STATE(4245),
    [sym_string] = STATE(2970),
    [sym_formal_parameters] = STATE(2949),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1905),
    [anon_sym_export] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_type] = ACTIONS(1907),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1907),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1912),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1907),
    [anon_sym_function] = ACTIONS(1919),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1921),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1907),
    [anon_sym_readonly] = ACTIONS(1907),
    [anon_sym_get] = ACTIONS(1931),
    [anon_sym_set] = ACTIONS(1931),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1907),
    [anon_sym_public] = ACTIONS(1907),
    [anon_sym_private] = ACTIONS(1907),
    [anon_sym_protected] = ACTIONS(1907),
    [anon_sym_override] = ACTIONS(1907),
    [anon_sym_module] = ACTIONS(1907),
    [anon_sym_any] = ACTIONS(1907),
    [anon_sym_number] = ACTIONS(1907),
    [anon_sym_boolean] = ACTIONS(1907),
    [anon_sym_string] = ACTIONS(1907),
    [anon_sym_symbol] = ACTIONS(1907),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [530] = {
    [sym__call_signature] = STATE(4245),
    [sym_string] = STATE(2970),
    [sym_formal_parameters] = STATE(2949),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [sym_type_parameters] = STATE(3975),
    [aux_sym_object_repeat1] = STATE(3660),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1905),
    [anon_sym_export] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_type] = ACTIONS(1907),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1907),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1912),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1907),
    [anon_sym_function] = ACTIONS(1919),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1921),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1907),
    [anon_sym_readonly] = ACTIONS(1907),
    [anon_sym_get] = ACTIONS(1931),
    [anon_sym_set] = ACTIONS(1931),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1907),
    [anon_sym_public] = ACTIONS(1907),
    [anon_sym_private] = ACTIONS(1907),
    [anon_sym_protected] = ACTIONS(1907),
    [anon_sym_override] = ACTIONS(1907),
    [anon_sym_module] = ACTIONS(1907),
    [anon_sym_any] = ACTIONS(1907),
    [anon_sym_number] = ACTIONS(1907),
    [anon_sym_boolean] = ACTIONS(1907),
    [anon_sym_string] = ACTIONS(1907),
    [anon_sym_symbol] = ACTIONS(1907),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [531] = {
    [sym_declaration] = STATE(646),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_class_declaration] = STATE(674),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function_declaration] = STATE(674),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(674),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(716),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [aux_sym_export_statement_repeat1] = STATE(3370),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1889),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_global] = ACTIONS(1895),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [532] = {
    [sym_declaration] = STATE(646),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_class_declaration] = STATE(674),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function_declaration] = STATE(674),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(674),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(716),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [aux_sym_export_statement_repeat1] = STATE(3370),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1889),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_global] = ACTIONS(1895),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [533] = {
    [sym_string] = STATE(2970),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [sym_override_modifier] = STATE(2299),
    [aux_sym_object_repeat1] = STATE(3660),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1937),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1941),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [534] = {
    [sym_string] = STATE(2970),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [sym_override_modifier] = STATE(2299),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1937),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1941),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [535] = {
    [sym_string] = STATE(2970),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [sym_override_modifier] = STATE(2299),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1937),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1941),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [536] = {
    [sym_declaration] = STATE(646),
    [sym_variable_declaration] = STATE(674),
    [sym_lexical_declaration] = STATE(674),
    [sym_class_declaration] = STATE(674),
    [sym_function_declaration] = STATE(674),
    [sym_generator_function_declaration] = STATE(674),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(674),
    [sym_ambient_declaration] = STATE(674),
    [sym_abstract_class_declaration] = STATE(674),
    [sym_module] = STATE(674),
    [sym_internal_module] = STATE(716),
    [sym_import_alias] = STATE(674),
    [sym_interface_declaration] = STATE(674),
    [sym_enum_declaration] = STATE(674),
    [sym_type_alias_declaration] = STATE(674),
    [aux_sym_export_statement_repeat1] = STATE(3370),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1889),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_EQ_GT] = ACTIONS(1313),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_global] = ACTIONS(1895),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(1497),
    [sym_identifier] = ACTIONS(1499),
    [anon_sym_export] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1499),
    [anon_sym_type] = ACTIONS(1499),
    [anon_sym_EQ] = ACTIONS(1499),
    [anon_sym_namespace] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(1497),
    [anon_sym_COMMA] = ACTIONS(1497),
    [anon_sym_RBRACE] = ACTIONS(1497),
    [anon_sym_typeof] = ACTIONS(1499),
    [anon_sym_import] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(1499),
    [anon_sym_var] = ACTIONS(1499),
    [anon_sym_let] = ACTIONS(1499),
    [anon_sym_const] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(1497),
    [anon_sym_else] = ACTIONS(1499),
    [anon_sym_if] = ACTIONS(1499),
    [anon_sym_switch] = ACTIONS(1499),
    [anon_sym_for] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1497),
    [anon_sym_RPAREN] = ACTIONS(1497),
    [anon_sym_await] = ACTIONS(1499),
    [anon_sym_while] = ACTIONS(1499),
    [anon_sym_do] = ACTIONS(1499),
    [anon_sym_try] = ACTIONS(1499),
    [anon_sym_with] = ACTIONS(1499),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_continue] = ACTIONS(1499),
    [anon_sym_debugger] = ACTIONS(1499),
    [anon_sym_return] = ACTIONS(1499),
    [anon_sym_throw] = ACTIONS(1499),
    [anon_sym_SEMI] = ACTIONS(1497),
    [anon_sym_COLON] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_yield] = ACTIONS(1499),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_RBRACK] = ACTIONS(1497),
    [anon_sym_LTtemplate_GT] = ACTIONS(1497),
    [anon_sym_GT] = ACTIONS(1497),
    [anon_sym_class] = ACTIONS(1499),
    [anon_sym_async] = ACTIONS(1499),
    [anon_sym_function] = ACTIONS(1499),
    [anon_sym_EQ_GT] = ACTIONS(1497),
    [anon_sym_new] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1497),
    [anon_sym_PIPE] = ACTIONS(1497),
    [anon_sym_PLUS] = ACTIONS(1499),
    [anon_sym_DASH] = ACTIONS(1499),
    [anon_sym_SLASH] = ACTIONS(1499),
    [anon_sym_LT] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1497),
    [anon_sym_void] = ACTIONS(1499),
    [anon_sym_delete] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1497),
    [sym_number] = ACTIONS(1497),
    [sym_this] = ACTIONS(1499),
    [sym_super] = ACTIONS(1499),
    [sym_true] = ACTIONS(1499),
    [sym_false] = ACTIONS(1499),
    [sym_null] = ACTIONS(1499),
    [sym_undefined] = ACTIONS(1499),
    [anon_sym_AT] = ACTIONS(1497),
    [anon_sym_static] = ACTIONS(1499),
    [anon_sym_readonly] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
    [anon_sym_QMARK] = ACTIONS(1497),
    [anon_sym_declare] = ACTIONS(1499),
    [anon_sym_public] = ACTIONS(1499),
    [anon_sym_private] = ACTIONS(1499),
    [anon_sym_protected] = ACTIONS(1499),
    [anon_sym_override] = ACTIONS(1499),
    [anon_sym_module] = ACTIONS(1499),
    [anon_sym_any] = ACTIONS(1499),
    [anon_sym_number] = ACTIONS(1499),
    [anon_sym_boolean] = ACTIONS(1499),
    [anon_sym_string] = ACTIONS(1499),
    [anon_sym_symbol] = ACTIONS(1499),
    [anon_sym_abstract] = ACTIONS(1499),
    [anon_sym_extends] = ACTIONS(1499),
    [anon_sym_interface] = ACTIONS(1499),
    [anon_sym_enum] = ACTIONS(1499),
  },
  [538] = {
    [sym_declaration] = STATE(3226),
    [sym_variable_declaration] = STATE(3254),
    [sym_lexical_declaration] = STATE(3254),
    [sym_class_declaration] = STATE(3254),
    [sym_function_declaration] = STATE(3254),
    [sym_generator_function_declaration] = STATE(3254),
    [sym_decorator] = STATE(1162),
    [sym_function_signature] = STATE(3254),
    [sym_ambient_declaration] = STATE(3254),
    [sym_abstract_class_declaration] = STATE(3254),
    [sym_module] = STATE(3254),
    [sym_internal_module] = STATE(3252),
    [sym_import_alias] = STATE(3254),
    [sym_interface_declaration] = STATE(3254),
    [sym_enum_declaration] = STATE(3254),
    [sym_type_alias_declaration] = STATE(3254),
    [aux_sym_export_statement_repeat1] = STATE(3333),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1943),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1945),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_var] = ACTIONS(1949),
    [anon_sym_let] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(1955),
    [anon_sym_async] = ACTIONS(1957),
    [anon_sym_function] = ACTIONS(1959),
    [anon_sym_EQ_GT] = ACTIONS(1313),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(1961),
    [anon_sym_module] = ACTIONS(1963),
    [anon_sym_abstract] = ACTIONS(1965),
    [anon_sym_satisfies] = ACTIONS(149),
    [anon_sym_global] = ACTIONS(1967),
    [anon_sym_interface] = ACTIONS(1969),
    [anon_sym_enum] = ACTIONS(1971),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(1437),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_export] = ACTIONS(1439),
    [anon_sym_default] = ACTIONS(1439),
    [anon_sym_type] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(1439),
    [anon_sym_namespace] = ACTIONS(1439),
    [anon_sym_LBRACE] = ACTIONS(1437),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_typeof] = ACTIONS(1439),
    [anon_sym_import] = ACTIONS(1439),
    [anon_sym_from] = ACTIONS(1439),
    [anon_sym_var] = ACTIONS(1439),
    [anon_sym_let] = ACTIONS(1439),
    [anon_sym_const] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(1437),
    [anon_sym_else] = ACTIONS(1439),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_switch] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1439),
    [anon_sym_LPAREN] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_while] = ACTIONS(1439),
    [anon_sym_do] = ACTIONS(1439),
    [anon_sym_try] = ACTIONS(1439),
    [anon_sym_with] = ACTIONS(1439),
    [anon_sym_break] = ACTIONS(1439),
    [anon_sym_continue] = ACTIONS(1439),
    [anon_sym_debugger] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1439),
    [anon_sym_throw] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_COLON] = ACTIONS(1437),
    [anon_sym_case] = ACTIONS(1439),
    [anon_sym_yield] = ACTIONS(1439),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_RBRACK] = ACTIONS(1437),
    [anon_sym_LTtemplate_GT] = ACTIONS(1437),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_class] = ACTIONS(1439),
    [anon_sym_async] = ACTIONS(1439),
    [anon_sym_function] = ACTIONS(1439),
    [anon_sym_EQ_GT] = ACTIONS(1437),
    [anon_sym_new] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1439),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(1437),
    [anon_sym_void] = ACTIONS(1439),
    [anon_sym_delete] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1437),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_SQUOTE] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [sym_number] = ACTIONS(1437),
    [sym_this] = ACTIONS(1439),
    [sym_super] = ACTIONS(1439),
    [sym_true] = ACTIONS(1439),
    [sym_false] = ACTIONS(1439),
    [sym_null] = ACTIONS(1439),
    [sym_undefined] = ACTIONS(1439),
    [anon_sym_AT] = ACTIONS(1437),
    [anon_sym_static] = ACTIONS(1439),
    [anon_sym_readonly] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(1439),
    [anon_sym_set] = ACTIONS(1439),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_declare] = ACTIONS(1439),
    [anon_sym_public] = ACTIONS(1439),
    [anon_sym_private] = ACTIONS(1439),
    [anon_sym_protected] = ACTIONS(1439),
    [anon_sym_override] = ACTIONS(1439),
    [anon_sym_module] = ACTIONS(1439),
    [anon_sym_any] = ACTIONS(1439),
    [anon_sym_number] = ACTIONS(1439),
    [anon_sym_boolean] = ACTIONS(1439),
    [anon_sym_string] = ACTIONS(1439),
    [anon_sym_symbol] = ACTIONS(1439),
    [anon_sym_abstract] = ACTIONS(1439),
    [anon_sym_extends] = ACTIONS(1439),
    [anon_sym_interface] = ACTIONS(1439),
    [anon_sym_enum] = ACTIONS(1439),
  },
  [540] = {
    [sym_string] = STATE(2970),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1933),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1933),
    [anon_sym_set] = ACTIONS(1933),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [541] = {
    [sym_string] = STATE(2970),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [542] = {
    [sym_string] = STATE(2970),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [aux_sym_object_repeat1] = STATE(3660),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [543] = {
    [sym_string] = STATE(2970),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [aux_sym_object_repeat1] = STATE(3660),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1933),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1933),
    [anon_sym_set] = ACTIONS(1933),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [544] = {
    [sym_string] = STATE(2970),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1933),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1933),
    [anon_sym_set] = ACTIONS(1933),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [545] = {
    [sym_string] = STATE(2970),
    [sym__property_name] = STATE(2970),
    [sym_computed_property_name] = STATE(2970),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1929),
    [sym_private_property_identifier] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(1973),
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_export] = ACTIONS(1975),
    [anon_sym_default] = ACTIONS(1975),
    [anon_sym_type] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1975),
    [anon_sym_namespace] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_typeof] = ACTIONS(1975),
    [anon_sym_import] = ACTIONS(1975),
    [anon_sym_var] = ACTIONS(1975),
    [anon_sym_let] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_else] = ACTIONS(1975),
    [anon_sym_if] = ACTIONS(1975),
    [anon_sym_switch] = ACTIONS(1975),
    [anon_sym_for] = ACTIONS(1975),
    [anon_sym_LPAREN] = ACTIONS(1973),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_await] = ACTIONS(1975),
    [anon_sym_while] = ACTIONS(1975),
    [anon_sym_do] = ACTIONS(1975),
    [anon_sym_try] = ACTIONS(1975),
    [anon_sym_with] = ACTIONS(1975),
    [anon_sym_break] = ACTIONS(1975),
    [anon_sym_continue] = ACTIONS(1975),
    [anon_sym_debugger] = ACTIONS(1975),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_throw] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym_COLON] = ACTIONS(1973),
    [anon_sym_case] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1973),
    [anon_sym_RBRACK] = ACTIONS(1973),
    [anon_sym_LTtemplate_GT] = ACTIONS(1973),
    [anon_sym_GT] = ACTIONS(1973),
    [anon_sym_class] = ACTIONS(1975),
    [anon_sym_async] = ACTIONS(1975),
    [anon_sym_function] = ACTIONS(1975),
    [anon_sym_EQ_GT] = ACTIONS(1973),
    [anon_sym_new] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1973),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1975),
    [anon_sym_delete] = ACTIONS(1975),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_DASH_DASH] = ACTIONS(1975),
    [anon_sym_DQUOTE] = ACTIONS(1973),
    [anon_sym_SQUOTE] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1973),
    [sym_number] = ACTIONS(1973),
    [sym_this] = ACTIONS(1975),
    [sym_super] = ACTIONS(1975),
    [sym_true] = ACTIONS(1975),
    [sym_false] = ACTIONS(1975),
    [sym_null] = ACTIONS(1975),
    [sym_undefined] = ACTIONS(1975),
    [anon_sym_AT] = ACTIONS(1973),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_readonly] = ACTIONS(1975),
    [anon_sym_get] = ACTIONS(1975),
    [anon_sym_set] = ACTIONS(1975),
    [anon_sym_QMARK] = ACTIONS(1973),
    [anon_sym_declare] = ACTIONS(1975),
    [anon_sym_public] = ACTIONS(1975),
    [anon_sym_private] = ACTIONS(1975),
    [anon_sym_protected] = ACTIONS(1975),
    [anon_sym_override] = ACTIONS(1975),
    [anon_sym_module] = ACTIONS(1975),
    [anon_sym_any] = ACTIONS(1975),
    [anon_sym_number] = ACTIONS(1975),
    [anon_sym_boolean] = ACTIONS(1975),
    [anon_sym_string] = ACTIONS(1975),
    [anon_sym_symbol] = ACTIONS(1975),
    [anon_sym_abstract] = ACTIONS(1975),
    [anon_sym_extends] = ACTIONS(1975),
    [anon_sym_interface] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(1977),
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_export] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_type] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_typeof] = ACTIONS(1979),
    [anon_sym_import] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_await] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_with] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_debugger] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_COLON] = ACTIONS(1977),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_RBRACK] = ACTIONS(1977),
    [anon_sym_LTtemplate_GT] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1977),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_function] = ACTIONS(1979),
    [anon_sym_EQ_GT] = ACTIONS(1977),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1977),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_void] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1979),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1977),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_super] = ACTIONS(1979),
    [sym_true] = ACTIONS(1979),
    [sym_false] = ACTIONS(1979),
    [sym_null] = ACTIONS(1979),
    [sym_undefined] = ACTIONS(1979),
    [anon_sym_AT] = ACTIONS(1977),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_readonly] = ACTIONS(1979),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_QMARK] = ACTIONS(1977),
    [anon_sym_declare] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_module] = ACTIONS(1979),
    [anon_sym_any] = ACTIONS(1979),
    [anon_sym_number] = ACTIONS(1979),
    [anon_sym_boolean] = ACTIONS(1979),
    [anon_sym_string] = ACTIONS(1979),
    [anon_sym_symbol] = ACTIONS(1979),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_extends] = ACTIONS(1979),
    [anon_sym_interface] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1981),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_export] = ACTIONS(1983),
    [anon_sym_default] = ACTIONS(1983),
    [anon_sym_type] = ACTIONS(1983),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_namespace] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_typeof] = ACTIONS(1983),
    [anon_sym_import] = ACTIONS(1983),
    [anon_sym_var] = ACTIONS(1983),
    [anon_sym_let] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_BANG] = ACTIONS(1981),
    [anon_sym_else] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1983),
    [anon_sym_switch] = ACTIONS(1983),
    [anon_sym_for] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_await] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_do] = ACTIONS(1983),
    [anon_sym_try] = ACTIONS(1983),
    [anon_sym_with] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1983),
    [anon_sym_continue] = ACTIONS(1983),
    [anon_sym_debugger] = ACTIONS(1983),
    [anon_sym_return] = ACTIONS(1983),
    [anon_sym_throw] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_COLON] = ACTIONS(1981),
    [anon_sym_case] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_RBRACK] = ACTIONS(1981),
    [anon_sym_LTtemplate_GT] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1981),
    [anon_sym_class] = ACTIONS(1983),
    [anon_sym_async] = ACTIONS(1983),
    [anon_sym_function] = ACTIONS(1983),
    [anon_sym_EQ_GT] = ACTIONS(1981),
    [anon_sym_new] = ACTIONS(1983),
    [anon_sym_AMP] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1981),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_void] = ACTIONS(1983),
    [anon_sym_delete] = ACTIONS(1983),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DASH_DASH] = ACTIONS(1983),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_SQUOTE] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1981),
    [sym_number] = ACTIONS(1981),
    [sym_this] = ACTIONS(1983),
    [sym_super] = ACTIONS(1983),
    [sym_true] = ACTIONS(1983),
    [sym_false] = ACTIONS(1983),
    [sym_null] = ACTIONS(1983),
    [sym_undefined] = ACTIONS(1983),
    [anon_sym_AT] = ACTIONS(1981),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_readonly] = ACTIONS(1983),
    [anon_sym_get] = ACTIONS(1983),
    [anon_sym_set] = ACTIONS(1983),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_declare] = ACTIONS(1983),
    [anon_sym_public] = ACTIONS(1983),
    [anon_sym_private] = ACTIONS(1983),
    [anon_sym_protected] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
    [anon_sym_module] = ACTIONS(1983),
    [anon_sym_any] = ACTIONS(1983),
    [anon_sym_number] = ACTIONS(1983),
    [anon_sym_boolean] = ACTIONS(1983),
    [anon_sym_string] = ACTIONS(1983),
    [anon_sym_symbol] = ACTIONS(1983),
    [anon_sym_abstract] = ACTIONS(1983),
    [anon_sym_extends] = ACTIONS(1983),
    [anon_sym_interface] = ACTIONS(1983),
    [anon_sym_enum] = ACTIONS(1983),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_export] = ACTIONS(1987),
    [anon_sym_default] = ACTIONS(1987),
    [anon_sym_type] = ACTIONS(1987),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_namespace] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_typeof] = ACTIONS(1987),
    [anon_sym_import] = ACTIONS(1987),
    [anon_sym_var] = ACTIONS(1987),
    [anon_sym_let] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_else] = ACTIONS(1987),
    [anon_sym_if] = ACTIONS(1987),
    [anon_sym_switch] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1987),
    [anon_sym_LPAREN] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_await] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_do] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1987),
    [anon_sym_with] = ACTIONS(1987),
    [anon_sym_break] = ACTIONS(1987),
    [anon_sym_continue] = ACTIONS(1987),
    [anon_sym_debugger] = ACTIONS(1987),
    [anon_sym_return] = ACTIONS(1987),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_COLON] = ACTIONS(1985),
    [anon_sym_case] = ACTIONS(1987),
    [anon_sym_yield] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1985),
    [anon_sym_LTtemplate_GT] = ACTIONS(1985),
    [anon_sym_GT] = ACTIONS(1985),
    [anon_sym_class] = ACTIONS(1987),
    [anon_sym_async] = ACTIONS(1987),
    [anon_sym_function] = ACTIONS(1987),
    [anon_sym_EQ_GT] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_void] = ACTIONS(1987),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1985),
    [sym_number] = ACTIONS(1985),
    [sym_this] = ACTIONS(1987),
    [sym_super] = ACTIONS(1987),
    [sym_true] = ACTIONS(1987),
    [sym_false] = ACTIONS(1987),
    [sym_null] = ACTIONS(1987),
    [sym_undefined] = ACTIONS(1987),
    [anon_sym_AT] = ACTIONS(1985),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_readonly] = ACTIONS(1987),
    [anon_sym_get] = ACTIONS(1987),
    [anon_sym_set] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_declare] = ACTIONS(1987),
    [anon_sym_public] = ACTIONS(1987),
    [anon_sym_private] = ACTIONS(1987),
    [anon_sym_protected] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_module] = ACTIONS(1987),
    [anon_sym_any] = ACTIONS(1987),
    [anon_sym_number] = ACTIONS(1987),
    [anon_sym_boolean] = ACTIONS(1987),
    [anon_sym_string] = ACTIONS(1987),
    [anon_sym_symbol] = ACTIONS(1987),
    [anon_sym_abstract] = ACTIONS(1987),
    [anon_sym_extends] = ACTIONS(1987),
    [anon_sym_interface] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1987),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(1989),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1991),
    [anon_sym_default] = ACTIONS(1991),
    [anon_sym_type] = ACTIONS(1991),
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_namespace] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_typeof] = ACTIONS(1991),
    [anon_sym_import] = ACTIONS(1991),
    [anon_sym_var] = ACTIONS(1991),
    [anon_sym_let] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_else] = ACTIONS(1991),
    [anon_sym_if] = ACTIONS(1991),
    [anon_sym_switch] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_do] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1991),
    [anon_sym_with] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1991),
    [anon_sym_continue] = ACTIONS(1991),
    [anon_sym_debugger] = ACTIONS(1991),
    [anon_sym_return] = ACTIONS(1991),
    [anon_sym_throw] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_COLON] = ACTIONS(1989),
    [anon_sym_case] = ACTIONS(1991),
    [anon_sym_yield] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_RBRACK] = ACTIONS(1989),
    [anon_sym_LTtemplate_GT] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_class] = ACTIONS(1991),
    [anon_sym_async] = ACTIONS(1991),
    [anon_sym_function] = ACTIONS(1991),
    [anon_sym_EQ_GT] = ACTIONS(1989),
    [anon_sym_new] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_void] = ACTIONS(1991),
    [anon_sym_delete] = ACTIONS(1991),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DASH_DASH] = ACTIONS(1991),
    [anon_sym_DQUOTE] = ACTIONS(1989),
    [anon_sym_SQUOTE] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1989),
    [sym_number] = ACTIONS(1989),
    [sym_this] = ACTIONS(1991),
    [sym_super] = ACTIONS(1991),
    [sym_true] = ACTIONS(1991),
    [sym_false] = ACTIONS(1991),
    [sym_null] = ACTIONS(1991),
    [sym_undefined] = ACTIONS(1991),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_readonly] = ACTIONS(1991),
    [anon_sym_get] = ACTIONS(1991),
    [anon_sym_set] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1989),
    [anon_sym_declare] = ACTIONS(1991),
    [anon_sym_public] = ACTIONS(1991),
    [anon_sym_private] = ACTIONS(1991),
    [anon_sym_protected] = ACTIONS(1991),
    [anon_sym_override] = ACTIONS(1991),
    [anon_sym_module] = ACTIONS(1991),
    [anon_sym_any] = ACTIONS(1991),
    [anon_sym_number] = ACTIONS(1991),
    [anon_sym_boolean] = ACTIONS(1991),
    [anon_sym_string] = ACTIONS(1991),
    [anon_sym_symbol] = ACTIONS(1991),
    [anon_sym_abstract] = ACTIONS(1991),
    [anon_sym_extends] = ACTIONS(1991),
    [anon_sym_interface] = ACTIONS(1991),
    [anon_sym_enum] = ACTIONS(1991),
  },
  [551] = {
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1670),
    [anon_sym_export] = ACTIONS(1670),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_type] = ACTIONS(1670),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1670),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1670),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1672),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1672),
    [sym_private_property_identifier] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1670),
    [anon_sym_readonly] = ACTIONS(1670),
    [anon_sym_get] = ACTIONS(1670),
    [anon_sym_set] = ACTIONS(1670),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1670),
    [anon_sym_public] = ACTIONS(1670),
    [anon_sym_private] = ACTIONS(1670),
    [anon_sym_protected] = ACTIONS(1670),
    [anon_sym_override] = ACTIONS(1670),
    [anon_sym_module] = ACTIONS(1670),
    [anon_sym_any] = ACTIONS(1670),
    [anon_sym_number] = ACTIONS(1670),
    [anon_sym_boolean] = ACTIONS(1670),
    [anon_sym_string] = ACTIONS(1670),
    [anon_sym_symbol] = ACTIONS(1670),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [552] = {
    [aux_sym_object_repeat1] = STATE(3660),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1662),
    [anon_sym_export] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_type] = ACTIONS(1662),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1662),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_SQUOTE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1664),
    [sym_private_property_identifier] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1662),
    [anon_sym_readonly] = ACTIONS(1662),
    [anon_sym_get] = ACTIONS(1662),
    [anon_sym_set] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1662),
    [anon_sym_public] = ACTIONS(1662),
    [anon_sym_private] = ACTIONS(1662),
    [anon_sym_protected] = ACTIONS(1662),
    [anon_sym_override] = ACTIONS(1662),
    [anon_sym_module] = ACTIONS(1662),
    [anon_sym_any] = ACTIONS(1662),
    [anon_sym_number] = ACTIONS(1662),
    [anon_sym_boolean] = ACTIONS(1662),
    [anon_sym_string] = ACTIONS(1662),
    [anon_sym_symbol] = ACTIONS(1662),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [553] = {
    [aux_sym_object_repeat1] = STATE(3660),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1670),
    [anon_sym_export] = ACTIONS(1670),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_type] = ACTIONS(1670),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1670),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1670),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1672),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1672),
    [sym_private_property_identifier] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1670),
    [anon_sym_readonly] = ACTIONS(1670),
    [anon_sym_get] = ACTIONS(1670),
    [anon_sym_set] = ACTIONS(1670),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1670),
    [anon_sym_public] = ACTIONS(1670),
    [anon_sym_private] = ACTIONS(1670),
    [anon_sym_protected] = ACTIONS(1670),
    [anon_sym_override] = ACTIONS(1670),
    [anon_sym_module] = ACTIONS(1670),
    [anon_sym_any] = ACTIONS(1670),
    [anon_sym_number] = ACTIONS(1670),
    [anon_sym_boolean] = ACTIONS(1670),
    [anon_sym_string] = ACTIONS(1670),
    [anon_sym_symbol] = ACTIONS(1670),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [554] = {
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1662),
    [anon_sym_export] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_type] = ACTIONS(1662),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1662),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_SQUOTE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1664),
    [sym_private_property_identifier] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1662),
    [anon_sym_readonly] = ACTIONS(1662),
    [anon_sym_get] = ACTIONS(1662),
    [anon_sym_set] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1662),
    [anon_sym_public] = ACTIONS(1662),
    [anon_sym_private] = ACTIONS(1662),
    [anon_sym_protected] = ACTIONS(1662),
    [anon_sym_override] = ACTIONS(1662),
    [anon_sym_module] = ACTIONS(1662),
    [anon_sym_any] = ACTIONS(1662),
    [anon_sym_number] = ACTIONS(1662),
    [anon_sym_boolean] = ACTIONS(1662),
    [anon_sym_string] = ACTIONS(1662),
    [anon_sym_symbol] = ACTIONS(1662),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [555] = {
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1670),
    [anon_sym_export] = ACTIONS(1670),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_type] = ACTIONS(1670),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1670),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1670),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1672),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1672),
    [sym_private_property_identifier] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1670),
    [anon_sym_readonly] = ACTIONS(1670),
    [anon_sym_get] = ACTIONS(1670),
    [anon_sym_set] = ACTIONS(1670),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1670),
    [anon_sym_public] = ACTIONS(1670),
    [anon_sym_private] = ACTIONS(1670),
    [anon_sym_protected] = ACTIONS(1670),
    [anon_sym_override] = ACTIONS(1670),
    [anon_sym_module] = ACTIONS(1670),
    [anon_sym_any] = ACTIONS(1670),
    [anon_sym_number] = ACTIONS(1670),
    [anon_sym_boolean] = ACTIONS(1670),
    [anon_sym_string] = ACTIONS(1670),
    [anon_sym_symbol] = ACTIONS(1670),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [556] = {
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(1662),
    [anon_sym_export] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_type] = ACTIONS(1662),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(1662),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_SQUOTE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [sym_number] = ACTIONS(1664),
    [sym_private_property_identifier] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1662),
    [anon_sym_readonly] = ACTIONS(1662),
    [anon_sym_get] = ACTIONS(1662),
    [anon_sym_set] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1662),
    [anon_sym_public] = ACTIONS(1662),
    [anon_sym_private] = ACTIONS(1662),
    [anon_sym_protected] = ACTIONS(1662),
    [anon_sym_override] = ACTIONS(1662),
    [anon_sym_module] = ACTIONS(1662),
    [anon_sym_any] = ACTIONS(1662),
    [anon_sym_number] = ACTIONS(1662),
    [anon_sym_boolean] = ACTIONS(1662),
    [anon_sym_string] = ACTIONS(1662),
    [anon_sym_symbol] = ACTIONS(1662),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [557] = {
    [sym__call_signature] = STATE(4028),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_export] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(1995),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_get] = ACTIONS(1995),
    [anon_sym_set] = ACTIONS(1995),
    [anon_sym_QMARK] = ACTIONS(2005),
    [anon_sym_declare] = ACTIONS(1995),
    [anon_sym_public] = ACTIONS(1995),
    [anon_sym_private] = ACTIONS(1995),
    [anon_sym_protected] = ACTIONS(1995),
    [anon_sym_override] = ACTIONS(1995),
    [anon_sym_module] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1995),
    [anon_sym_number] = ACTIONS(1995),
    [anon_sym_boolean] = ACTIONS(1995),
    [anon_sym_string] = ACTIONS(1995),
    [anon_sym_symbol] = ACTIONS(1995),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [558] = {
    [sym__call_signature] = STATE(4028),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_export] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(1995),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_get] = ACTIONS(1995),
    [anon_sym_set] = ACTIONS(1995),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(1995),
    [anon_sym_public] = ACTIONS(1995),
    [anon_sym_private] = ACTIONS(1995),
    [anon_sym_protected] = ACTIONS(1995),
    [anon_sym_override] = ACTIONS(1995),
    [anon_sym_module] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1995),
    [anon_sym_number] = ACTIONS(1995),
    [anon_sym_boolean] = ACTIONS(1995),
    [anon_sym_string] = ACTIONS(1995),
    [anon_sym_symbol] = ACTIONS(1995),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [559] = {
    [sym__call_signature] = STATE(4295),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2007),
    [anon_sym_export] = ACTIONS(2009),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2009),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2009),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_RBRACE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2009),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2009),
    [anon_sym_readonly] = ACTIONS(2009),
    [anon_sym_get] = ACTIONS(2009),
    [anon_sym_set] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_declare] = ACTIONS(2009),
    [anon_sym_public] = ACTIONS(2009),
    [anon_sym_private] = ACTIONS(2009),
    [anon_sym_protected] = ACTIONS(2009),
    [anon_sym_override] = ACTIONS(2009),
    [anon_sym_module] = ACTIONS(2009),
    [anon_sym_any] = ACTIONS(2009),
    [anon_sym_number] = ACTIONS(2009),
    [anon_sym_boolean] = ACTIONS(2009),
    [anon_sym_string] = ACTIONS(2009),
    [anon_sym_symbol] = ACTIONS(2009),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [560] = {
    [sym__call_signature] = STATE(4295),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2007),
    [anon_sym_export] = ACTIONS(2009),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2009),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2009),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_RPAREN] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2009),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2009),
    [anon_sym_readonly] = ACTIONS(2009),
    [anon_sym_get] = ACTIONS(2009),
    [anon_sym_set] = ACTIONS(2009),
    [anon_sym_declare] = ACTIONS(2009),
    [anon_sym_public] = ACTIONS(2009),
    [anon_sym_private] = ACTIONS(2009),
    [anon_sym_protected] = ACTIONS(2009),
    [anon_sym_override] = ACTIONS(2009),
    [anon_sym_module] = ACTIONS(2009),
    [anon_sym_any] = ACTIONS(2009),
    [anon_sym_number] = ACTIONS(2009),
    [anon_sym_boolean] = ACTIONS(2009),
    [anon_sym_string] = ACTIONS(2009),
    [anon_sym_symbol] = ACTIONS(2009),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [561] = {
    [sym__call_signature] = STATE(4295),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2007),
    [anon_sym_export] = ACTIONS(2009),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2009),
    [anon_sym_EQ] = ACTIONS(1224),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2009),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_RPAREN] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2009),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2009),
    [anon_sym_readonly] = ACTIONS(2009),
    [anon_sym_get] = ACTIONS(2009),
    [anon_sym_set] = ACTIONS(2009),
    [anon_sym_declare] = ACTIONS(2009),
    [anon_sym_public] = ACTIONS(2009),
    [anon_sym_private] = ACTIONS(2009),
    [anon_sym_protected] = ACTIONS(2009),
    [anon_sym_override] = ACTIONS(2009),
    [anon_sym_module] = ACTIONS(2009),
    [anon_sym_any] = ACTIONS(2009),
    [anon_sym_number] = ACTIONS(2009),
    [anon_sym_boolean] = ACTIONS(2009),
    [anon_sym_string] = ACTIONS(2009),
    [anon_sym_symbol] = ACTIONS(2009),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [562] = {
    [sym__call_signature] = STATE(4294),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_export] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2013),
    [anon_sym_function] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(1260),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2013),
    [anon_sym_readonly] = ACTIONS(2013),
    [anon_sym_get] = ACTIONS(2013),
    [anon_sym_set] = ACTIONS(2013),
    [anon_sym_declare] = ACTIONS(2013),
    [anon_sym_public] = ACTIONS(2013),
    [anon_sym_private] = ACTIONS(2013),
    [anon_sym_protected] = ACTIONS(2013),
    [anon_sym_override] = ACTIONS(2013),
    [anon_sym_module] = ACTIONS(2013),
    [anon_sym_any] = ACTIONS(2013),
    [anon_sym_number] = ACTIONS(2013),
    [anon_sym_boolean] = ACTIONS(2013),
    [anon_sym_string] = ACTIONS(2013),
    [anon_sym_symbol] = ACTIONS(2013),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [563] = {
    [sym__call_signature] = STATE(4245),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_export] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_of] = ACTIONS(2024),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_readonly] = ACTIONS(2019),
    [anon_sym_get] = ACTIONS(2019),
    [anon_sym_set] = ACTIONS(2019),
    [anon_sym_declare] = ACTIONS(2019),
    [anon_sym_public] = ACTIONS(2019),
    [anon_sym_private] = ACTIONS(2019),
    [anon_sym_protected] = ACTIONS(2019),
    [anon_sym_override] = ACTIONS(2019),
    [anon_sym_module] = ACTIONS(2019),
    [anon_sym_any] = ACTIONS(2019),
    [anon_sym_number] = ACTIONS(2019),
    [anon_sym_boolean] = ACTIONS(2019),
    [anon_sym_string] = ACTIONS(2019),
    [anon_sym_symbol] = ACTIONS(2019),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [564] = {
    [sym__call_signature] = STATE(4295),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2007),
    [anon_sym_export] = ACTIONS(2009),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2009),
    [anon_sym_EQ] = ACTIONS(1224),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2009),
    [anon_sym_COMMA] = ACTIONS(1262),
    [anon_sym_RBRACE] = ACTIONS(1262),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(1262),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2009),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2009),
    [anon_sym_readonly] = ACTIONS(2009),
    [anon_sym_get] = ACTIONS(2009),
    [anon_sym_set] = ACTIONS(2009),
    [anon_sym_declare] = ACTIONS(2009),
    [anon_sym_public] = ACTIONS(2009),
    [anon_sym_private] = ACTIONS(2009),
    [anon_sym_protected] = ACTIONS(2009),
    [anon_sym_override] = ACTIONS(2009),
    [anon_sym_module] = ACTIONS(2009),
    [anon_sym_any] = ACTIONS(2009),
    [anon_sym_number] = ACTIONS(2009),
    [anon_sym_boolean] = ACTIONS(2009),
    [anon_sym_string] = ACTIONS(2009),
    [anon_sym_symbol] = ACTIONS(2009),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [565] = {
    [sym__call_signature] = STATE(4245),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_export] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_readonly] = ACTIONS(2019),
    [anon_sym_get] = ACTIONS(2019),
    [anon_sym_set] = ACTIONS(2019),
    [anon_sym_declare] = ACTIONS(2019),
    [anon_sym_public] = ACTIONS(2019),
    [anon_sym_private] = ACTIONS(2019),
    [anon_sym_protected] = ACTIONS(2019),
    [anon_sym_override] = ACTIONS(2019),
    [anon_sym_module] = ACTIONS(2019),
    [anon_sym_any] = ACTIONS(2019),
    [anon_sym_number] = ACTIONS(2019),
    [anon_sym_boolean] = ACTIONS(2019),
    [anon_sym_string] = ACTIONS(2019),
    [anon_sym_symbol] = ACTIONS(2019),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [566] = {
    [sym__call_signature] = STATE(4294),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_export] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2013),
    [anon_sym_function] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(1260),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2013),
    [anon_sym_readonly] = ACTIONS(2013),
    [anon_sym_get] = ACTIONS(2013),
    [anon_sym_set] = ACTIONS(2013),
    [anon_sym_declare] = ACTIONS(2013),
    [anon_sym_public] = ACTIONS(2013),
    [anon_sym_private] = ACTIONS(2013),
    [anon_sym_protected] = ACTIONS(2013),
    [anon_sym_override] = ACTIONS(2013),
    [anon_sym_module] = ACTIONS(2013),
    [anon_sym_any] = ACTIONS(2013),
    [anon_sym_number] = ACTIONS(2013),
    [anon_sym_boolean] = ACTIONS(2013),
    [anon_sym_string] = ACTIONS(2013),
    [anon_sym_symbol] = ACTIONS(2013),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [567] = {
    [sym__call_signature] = STATE(4245),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_export] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_readonly] = ACTIONS(2019),
    [anon_sym_get] = ACTIONS(2019),
    [anon_sym_set] = ACTIONS(2019),
    [anon_sym_declare] = ACTIONS(2019),
    [anon_sym_public] = ACTIONS(2019),
    [anon_sym_private] = ACTIONS(2019),
    [anon_sym_protected] = ACTIONS(2019),
    [anon_sym_override] = ACTIONS(2019),
    [anon_sym_module] = ACTIONS(2019),
    [anon_sym_any] = ACTIONS(2019),
    [anon_sym_number] = ACTIONS(2019),
    [anon_sym_boolean] = ACTIONS(2019),
    [anon_sym_string] = ACTIONS(2019),
    [anon_sym_symbol] = ACTIONS(2019),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [568] = {
    [sym__call_signature] = STATE(4245),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_export] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(2026),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_readonly] = ACTIONS(2019),
    [anon_sym_get] = ACTIONS(2019),
    [anon_sym_set] = ACTIONS(2019),
    [anon_sym_declare] = ACTIONS(2019),
    [anon_sym_public] = ACTIONS(2019),
    [anon_sym_private] = ACTIONS(2019),
    [anon_sym_protected] = ACTIONS(2019),
    [anon_sym_override] = ACTIONS(2019),
    [anon_sym_module] = ACTIONS(2019),
    [anon_sym_any] = ACTIONS(2019),
    [anon_sym_number] = ACTIONS(2019),
    [anon_sym_boolean] = ACTIONS(2019),
    [anon_sym_string] = ACTIONS(2019),
    [anon_sym_symbol] = ACTIONS(2019),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [569] = {
    [sym__call_signature] = STATE(4245),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_export] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(1919),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_readonly] = ACTIONS(2019),
    [anon_sym_get] = ACTIONS(2019),
    [anon_sym_set] = ACTIONS(2019),
    [anon_sym_declare] = ACTIONS(2019),
    [anon_sym_public] = ACTIONS(2019),
    [anon_sym_private] = ACTIONS(2019),
    [anon_sym_protected] = ACTIONS(2019),
    [anon_sym_override] = ACTIONS(2019),
    [anon_sym_module] = ACTIONS(2019),
    [anon_sym_any] = ACTIONS(2019),
    [anon_sym_number] = ACTIONS(2019),
    [anon_sym_boolean] = ACTIONS(2019),
    [anon_sym_string] = ACTIONS(2019),
    [anon_sym_symbol] = ACTIONS(2019),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [570] = {
    [sym__call_signature] = STATE(4022),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_export] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2030),
    [anon_sym_EQ] = ACTIONS(2032),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2030),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(2035),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2030),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(1309),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2030),
    [anon_sym_readonly] = ACTIONS(2030),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2030),
    [anon_sym_declare] = ACTIONS(2030),
    [anon_sym_public] = ACTIONS(2030),
    [anon_sym_private] = ACTIONS(2030),
    [anon_sym_protected] = ACTIONS(2030),
    [anon_sym_override] = ACTIONS(2030),
    [anon_sym_module] = ACTIONS(2030),
    [anon_sym_any] = ACTIONS(2030),
    [anon_sym_number] = ACTIONS(2030),
    [anon_sym_boolean] = ACTIONS(2030),
    [anon_sym_string] = ACTIONS(2030),
    [anon_sym_symbol] = ACTIONS(2030),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [571] = {
    [sym__call_signature] = STATE(4238),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_export] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2039),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2039),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(1269),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2039),
    [anon_sym_readonly] = ACTIONS(2039),
    [anon_sym_get] = ACTIONS(2039),
    [anon_sym_set] = ACTIONS(2039),
    [anon_sym_declare] = ACTIONS(2039),
    [anon_sym_public] = ACTIONS(2039),
    [anon_sym_private] = ACTIONS(2039),
    [anon_sym_protected] = ACTIONS(2039),
    [anon_sym_override] = ACTIONS(2039),
    [anon_sym_module] = ACTIONS(2039),
    [anon_sym_any] = ACTIONS(2039),
    [anon_sym_number] = ACTIONS(2039),
    [anon_sym_boolean] = ACTIONS(2039),
    [anon_sym_string] = ACTIONS(2039),
    [anon_sym_symbol] = ACTIONS(2039),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1461),
    [anon_sym_export] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_namespace] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_typeof] = ACTIONS(1461),
    [anon_sym_import] = ACTIONS(1461),
    [anon_sym_var] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_await] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_try] = ACTIONS(1461),
    [anon_sym_with] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_debugger] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_throw] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_catch] = ACTIONS(1461),
    [anon_sym_finally] = ACTIONS(1461),
    [anon_sym_yield] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LTtemplate_GT] = ACTIONS(1459),
    [anon_sym_class] = ACTIONS(1461),
    [anon_sym_async] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1461),
    [anon_sym_new] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_SLASH] = ACTIONS(1461),
    [anon_sym_LT] = ACTIONS(1461),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_void] = ACTIONS(1461),
    [anon_sym_delete] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1461),
    [sym_super] = ACTIONS(1461),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_undefined] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_get] = ACTIONS(1461),
    [anon_sym_set] = ACTIONS(1461),
    [anon_sym_declare] = ACTIONS(1461),
    [anon_sym_public] = ACTIONS(1461),
    [anon_sym_private] = ACTIONS(1461),
    [anon_sym_protected] = ACTIONS(1461),
    [anon_sym_override] = ACTIONS(1461),
    [anon_sym_module] = ACTIONS(1461),
    [anon_sym_any] = ACTIONS(1461),
    [anon_sym_number] = ACTIONS(1461),
    [anon_sym_boolean] = ACTIONS(1461),
    [anon_sym_string] = ACTIONS(1461),
    [anon_sym_symbol] = ACTIONS(1461),
    [anon_sym_abstract] = ACTIONS(1461),
    [anon_sym_interface] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
    [sym__automatic_semicolon] = ACTIONS(2041),
  },
  [573] = {
    [sym__call_signature] = STATE(4238),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_export] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2039),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2039),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(1269),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2039),
    [anon_sym_readonly] = ACTIONS(2039),
    [anon_sym_get] = ACTIONS(2039),
    [anon_sym_set] = ACTIONS(2039),
    [anon_sym_declare] = ACTIONS(2039),
    [anon_sym_public] = ACTIONS(2039),
    [anon_sym_private] = ACTIONS(2039),
    [anon_sym_protected] = ACTIONS(2039),
    [anon_sym_override] = ACTIONS(2039),
    [anon_sym_module] = ACTIONS(2039),
    [anon_sym_any] = ACTIONS(2039),
    [anon_sym_number] = ACTIONS(2039),
    [anon_sym_boolean] = ACTIONS(2039),
    [anon_sym_string] = ACTIONS(2039),
    [anon_sym_symbol] = ACTIONS(2039),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [574] = {
    [sym_catch_clause] = STATE(599),
    [sym_finally_clause] = STATE(726),
    [ts_builtin_sym_end] = ACTIONS(2043),
    [sym_identifier] = ACTIONS(2045),
    [anon_sym_export] = ACTIONS(2045),
    [anon_sym_default] = ACTIONS(2045),
    [anon_sym_type] = ACTIONS(2045),
    [anon_sym_namespace] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2043),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_typeof] = ACTIONS(2045),
    [anon_sym_import] = ACTIONS(2045),
    [anon_sym_var] = ACTIONS(2045),
    [anon_sym_let] = ACTIONS(2045),
    [anon_sym_const] = ACTIONS(2045),
    [anon_sym_BANG] = ACTIONS(2043),
    [anon_sym_else] = ACTIONS(2045),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_switch] = ACTIONS(2045),
    [anon_sym_for] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(2043),
    [anon_sym_await] = ACTIONS(2045),
    [anon_sym_while] = ACTIONS(2045),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_try] = ACTIONS(2045),
    [anon_sym_with] = ACTIONS(2045),
    [anon_sym_break] = ACTIONS(2045),
    [anon_sym_continue] = ACTIONS(2045),
    [anon_sym_debugger] = ACTIONS(2045),
    [anon_sym_return] = ACTIONS(2045),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_SEMI] = ACTIONS(2043),
    [anon_sym_case] = ACTIONS(2045),
    [anon_sym_catch] = ACTIONS(2047),
    [anon_sym_finally] = ACTIONS(2049),
    [anon_sym_yield] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2043),
    [anon_sym_LTtemplate_GT] = ACTIONS(2043),
    [anon_sym_class] = ACTIONS(2045),
    [anon_sym_async] = ACTIONS(2045),
    [anon_sym_function] = ACTIONS(2045),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2045),
    [anon_sym_SLASH] = ACTIONS(2045),
    [anon_sym_LT] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2043),
    [anon_sym_void] = ACTIONS(2045),
    [anon_sym_delete] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2043),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_DQUOTE] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2043),
    [sym_number] = ACTIONS(2043),
    [sym_this] = ACTIONS(2045),
    [sym_super] = ACTIONS(2045),
    [sym_true] = ACTIONS(2045),
    [sym_false] = ACTIONS(2045),
    [sym_null] = ACTIONS(2045),
    [sym_undefined] = ACTIONS(2045),
    [anon_sym_AT] = ACTIONS(2043),
    [anon_sym_static] = ACTIONS(2045),
    [anon_sym_readonly] = ACTIONS(2045),
    [anon_sym_get] = ACTIONS(2045),
    [anon_sym_set] = ACTIONS(2045),
    [anon_sym_declare] = ACTIONS(2045),
    [anon_sym_public] = ACTIONS(2045),
    [anon_sym_private] = ACTIONS(2045),
    [anon_sym_protected] = ACTIONS(2045),
    [anon_sym_override] = ACTIONS(2045),
    [anon_sym_module] = ACTIONS(2045),
    [anon_sym_any] = ACTIONS(2045),
    [anon_sym_number] = ACTIONS(2045),
    [anon_sym_boolean] = ACTIONS(2045),
    [anon_sym_string] = ACTIONS(2045),
    [anon_sym_symbol] = ACTIONS(2045),
    [anon_sym_abstract] = ACTIONS(2045),
    [anon_sym_interface] = ACTIONS(2045),
    [anon_sym_enum] = ACTIONS(2045),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_export] = ACTIONS(1395),
    [anon_sym_default] = ACTIONS(1395),
    [anon_sym_type] = ACTIONS(1395),
    [anon_sym_namespace] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_COMMA] = ACTIONS(1393),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_typeof] = ACTIONS(1395),
    [anon_sym_import] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1395),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_const] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_else] = ACTIONS(1395),
    [anon_sym_if] = ACTIONS(1395),
    [anon_sym_switch] = ACTIONS(1395),
    [anon_sym_for] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_do] = ACTIONS(1395),
    [anon_sym_try] = ACTIONS(1395),
    [anon_sym_with] = ACTIONS(1395),
    [anon_sym_break] = ACTIONS(1395),
    [anon_sym_continue] = ACTIONS(1395),
    [anon_sym_debugger] = ACTIONS(1395),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_throw] = ACTIONS(1395),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1395),
    [anon_sym_catch] = ACTIONS(1395),
    [anon_sym_finally] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1395),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_LTtemplate_GT] = ACTIONS(1393),
    [anon_sym_class] = ACTIONS(1395),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_function] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1393),
    [anon_sym_void] = ACTIONS(1395),
    [anon_sym_delete] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1395),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1393),
    [sym_number] = ACTIONS(1393),
    [sym_this] = ACTIONS(1395),
    [sym_super] = ACTIONS(1395),
    [sym_true] = ACTIONS(1395),
    [sym_false] = ACTIONS(1395),
    [sym_null] = ACTIONS(1395),
    [sym_undefined] = ACTIONS(1395),
    [anon_sym_AT] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1395),
    [anon_sym_readonly] = ACTIONS(1395),
    [anon_sym_get] = ACTIONS(1395),
    [anon_sym_set] = ACTIONS(1395),
    [anon_sym_declare] = ACTIONS(1395),
    [anon_sym_public] = ACTIONS(1395),
    [anon_sym_private] = ACTIONS(1395),
    [anon_sym_protected] = ACTIONS(1395),
    [anon_sym_override] = ACTIONS(1395),
    [anon_sym_module] = ACTIONS(1395),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1395),
    [anon_sym_interface] = ACTIONS(1395),
    [anon_sym_enum] = ACTIONS(1395),
    [sym__automatic_semicolon] = ACTIONS(1403),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(1479),
    [anon_sym_export] = ACTIONS(1479),
    [anon_sym_default] = ACTIONS(1479),
    [anon_sym_type] = ACTIONS(1479),
    [anon_sym_namespace] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_typeof] = ACTIONS(1479),
    [anon_sym_import] = ACTIONS(1479),
    [anon_sym_var] = ACTIONS(1479),
    [anon_sym_let] = ACTIONS(1479),
    [anon_sym_const] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_switch] = ACTIONS(1479),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_await] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1479),
    [anon_sym_do] = ACTIONS(1479),
    [anon_sym_try] = ACTIONS(1479),
    [anon_sym_with] = ACTIONS(1479),
    [anon_sym_break] = ACTIONS(1479),
    [anon_sym_continue] = ACTIONS(1479),
    [anon_sym_debugger] = ACTIONS(1479),
    [anon_sym_return] = ACTIONS(1479),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_case] = ACTIONS(1479),
    [anon_sym_catch] = ACTIONS(1479),
    [anon_sym_finally] = ACTIONS(1479),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_LTtemplate_GT] = ACTIONS(1477),
    [anon_sym_class] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(1479),
    [anon_sym_function] = ACTIONS(1479),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1477),
    [anon_sym_void] = ACTIONS(1479),
    [anon_sym_delete] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_SQUOTE] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1477),
    [sym_number] = ACTIONS(1477),
    [sym_this] = ACTIONS(1479),
    [sym_super] = ACTIONS(1479),
    [sym_true] = ACTIONS(1479),
    [sym_false] = ACTIONS(1479),
    [sym_null] = ACTIONS(1479),
    [sym_undefined] = ACTIONS(1479),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_static] = ACTIONS(1479),
    [anon_sym_readonly] = ACTIONS(1479),
    [anon_sym_get] = ACTIONS(1479),
    [anon_sym_set] = ACTIONS(1479),
    [anon_sym_declare] = ACTIONS(1479),
    [anon_sym_public] = ACTIONS(1479),
    [anon_sym_private] = ACTIONS(1479),
    [anon_sym_protected] = ACTIONS(1479),
    [anon_sym_override] = ACTIONS(1479),
    [anon_sym_module] = ACTIONS(1479),
    [anon_sym_any] = ACTIONS(1479),
    [anon_sym_number] = ACTIONS(1479),
    [anon_sym_boolean] = ACTIONS(1479),
    [anon_sym_string] = ACTIONS(1479),
    [anon_sym_symbol] = ACTIONS(1479),
    [anon_sym_abstract] = ACTIONS(1479),
    [anon_sym_interface] = ACTIONS(1479),
    [anon_sym_enum] = ACTIONS(1479),
  },
  [577] = {
    [sym__call_signature] = STATE(4131),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2051),
    [anon_sym_export] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2053),
    [anon_sym_function] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(1313),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2053),
    [anon_sym_readonly] = ACTIONS(2053),
    [anon_sym_get] = ACTIONS(2053),
    [anon_sym_set] = ACTIONS(2053),
    [anon_sym_declare] = ACTIONS(2053),
    [anon_sym_public] = ACTIONS(2053),
    [anon_sym_private] = ACTIONS(2053),
    [anon_sym_protected] = ACTIONS(2053),
    [anon_sym_override] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_any] = ACTIONS(2053),
    [anon_sym_number] = ACTIONS(2053),
    [anon_sym_boolean] = ACTIONS(2053),
    [anon_sym_string] = ACTIONS(2053),
    [anon_sym_symbol] = ACTIONS(2053),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [578] = {
    [sym__call_signature] = STATE(4022),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_export] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2030),
    [anon_sym_EQ] = ACTIONS(2032),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2030),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2030),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(1309),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2030),
    [anon_sym_readonly] = ACTIONS(2030),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2030),
    [anon_sym_declare] = ACTIONS(2030),
    [anon_sym_public] = ACTIONS(2030),
    [anon_sym_private] = ACTIONS(2030),
    [anon_sym_protected] = ACTIONS(2030),
    [anon_sym_override] = ACTIONS(2030),
    [anon_sym_module] = ACTIONS(2030),
    [anon_sym_any] = ACTIONS(2030),
    [anon_sym_number] = ACTIONS(2030),
    [anon_sym_boolean] = ACTIONS(2030),
    [anon_sym_string] = ACTIONS(2030),
    [anon_sym_symbol] = ACTIONS(2030),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(1481),
    [sym_identifier] = ACTIONS(1483),
    [anon_sym_export] = ACTIONS(1483),
    [anon_sym_default] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(1483),
    [anon_sym_namespace] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(1481),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym_RBRACE] = ACTIONS(1481),
    [anon_sym_typeof] = ACTIONS(1483),
    [anon_sym_import] = ACTIONS(1483),
    [anon_sym_var] = ACTIONS(1483),
    [anon_sym_let] = ACTIONS(1483),
    [anon_sym_const] = ACTIONS(1483),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_else] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(1483),
    [anon_sym_switch] = ACTIONS(1483),
    [anon_sym_for] = ACTIONS(1483),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_while] = ACTIONS(1483),
    [anon_sym_do] = ACTIONS(1483),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1483),
    [anon_sym_break] = ACTIONS(1483),
    [anon_sym_continue] = ACTIONS(1483),
    [anon_sym_debugger] = ACTIONS(1483),
    [anon_sym_return] = ACTIONS(1483),
    [anon_sym_throw] = ACTIONS(1483),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_case] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1483),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_LTtemplate_GT] = ACTIONS(1481),
    [anon_sym_class] = ACTIONS(1483),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1483),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1483),
    [anon_sym_delete] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_DQUOTE] = ACTIONS(1481),
    [anon_sym_SQUOTE] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1481),
    [sym_number] = ACTIONS(1481),
    [sym_this] = ACTIONS(1483),
    [sym_super] = ACTIONS(1483),
    [sym_true] = ACTIONS(1483),
    [sym_false] = ACTIONS(1483),
    [sym_null] = ACTIONS(1483),
    [sym_undefined] = ACTIONS(1483),
    [anon_sym_AT] = ACTIONS(1481),
    [anon_sym_static] = ACTIONS(1483),
    [anon_sym_readonly] = ACTIONS(1483),
    [anon_sym_get] = ACTIONS(1483),
    [anon_sym_set] = ACTIONS(1483),
    [anon_sym_declare] = ACTIONS(1483),
    [anon_sym_public] = ACTIONS(1483),
    [anon_sym_private] = ACTIONS(1483),
    [anon_sym_protected] = ACTIONS(1483),
    [anon_sym_override] = ACTIONS(1483),
    [anon_sym_module] = ACTIONS(1483),
    [anon_sym_any] = ACTIONS(1483),
    [anon_sym_number] = ACTIONS(1483),
    [anon_sym_boolean] = ACTIONS(1483),
    [anon_sym_string] = ACTIONS(1483),
    [anon_sym_symbol] = ACTIONS(1483),
    [anon_sym_abstract] = ACTIONS(1483),
    [anon_sym_interface] = ACTIONS(1483),
    [anon_sym_enum] = ACTIONS(1483),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1481),
    [sym__automatic_semicolon] = ACTIONS(1481),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(1537),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(1539),
    [anon_sym_type] = ACTIONS(1539),
    [anon_sym_namespace] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1537),
    [anon_sym_RBRACE] = ACTIONS(1537),
    [anon_sym_typeof] = ACTIONS(1539),
    [anon_sym_import] = ACTIONS(1539),
    [anon_sym_var] = ACTIONS(1539),
    [anon_sym_let] = ACTIONS(1539),
    [anon_sym_const] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1537),
    [anon_sym_else] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_switch] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_do] = ACTIONS(1539),
    [anon_sym_try] = ACTIONS(1539),
    [anon_sym_with] = ACTIONS(1539),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_continue] = ACTIONS(1539),
    [anon_sym_debugger] = ACTIONS(1539),
    [anon_sym_return] = ACTIONS(1539),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1537),
    [anon_sym_case] = ACTIONS(1539),
    [anon_sym_yield] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1537),
    [anon_sym_LTtemplate_GT] = ACTIONS(1537),
    [anon_sym_class] = ACTIONS(1539),
    [anon_sym_async] = ACTIONS(1539),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_new] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_void] = ACTIONS(1539),
    [anon_sym_delete] = ACTIONS(1539),
    [anon_sym_PLUS_PLUS] = ACTIONS(1537),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1537),
    [sym_number] = ACTIONS(1537),
    [sym_this] = ACTIONS(1539),
    [sym_super] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_undefined] = ACTIONS(1539),
    [anon_sym_AT] = ACTIONS(1537),
    [anon_sym_static] = ACTIONS(1539),
    [anon_sym_readonly] = ACTIONS(1539),
    [anon_sym_get] = ACTIONS(1539),
    [anon_sym_set] = ACTIONS(1539),
    [anon_sym_declare] = ACTIONS(1539),
    [anon_sym_public] = ACTIONS(1539),
    [anon_sym_private] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1539),
    [anon_sym_override] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1539),
    [anon_sym_any] = ACTIONS(1539),
    [anon_sym_number] = ACTIONS(1539),
    [anon_sym_boolean] = ACTIONS(1539),
    [anon_sym_string] = ACTIONS(1539),
    [anon_sym_symbol] = ACTIONS(1539),
    [anon_sym_abstract] = ACTIONS(1539),
    [anon_sym_interface] = ACTIONS(1539),
    [anon_sym_enum] = ACTIONS(1539),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1537),
    [sym__automatic_semicolon] = ACTIONS(1537),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1461),
    [anon_sym_export] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_namespace] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_typeof] = ACTIONS(1461),
    [anon_sym_import] = ACTIONS(1461),
    [anon_sym_var] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_await] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_try] = ACTIONS(1461),
    [anon_sym_with] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_debugger] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_throw] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_yield] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LTtemplate_GT] = ACTIONS(1459),
    [anon_sym_class] = ACTIONS(1461),
    [anon_sym_async] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1461),
    [anon_sym_new] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_SLASH] = ACTIONS(1461),
    [anon_sym_LT] = ACTIONS(1461),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_void] = ACTIONS(1461),
    [anon_sym_delete] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1461),
    [sym_super] = ACTIONS(1461),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_undefined] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_get] = ACTIONS(1461),
    [anon_sym_set] = ACTIONS(1461),
    [anon_sym_declare] = ACTIONS(1461),
    [anon_sym_public] = ACTIONS(1461),
    [anon_sym_private] = ACTIONS(1461),
    [anon_sym_protected] = ACTIONS(1461),
    [anon_sym_override] = ACTIONS(1461),
    [anon_sym_module] = ACTIONS(1461),
    [anon_sym_any] = ACTIONS(1461),
    [anon_sym_number] = ACTIONS(1461),
    [anon_sym_boolean] = ACTIONS(1461),
    [anon_sym_string] = ACTIONS(1461),
    [anon_sym_symbol] = ACTIONS(1461),
    [anon_sym_abstract] = ACTIONS(1461),
    [anon_sym_interface] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1459),
    [sym__automatic_semicolon] = ACTIONS(2055),
  },
  [582] = {
    [sym__call_signature] = STATE(4131),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2051),
    [anon_sym_export] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2053),
    [anon_sym_function] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(1313),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2053),
    [anon_sym_readonly] = ACTIONS(2053),
    [anon_sym_get] = ACTIONS(2053),
    [anon_sym_set] = ACTIONS(2053),
    [anon_sym_declare] = ACTIONS(2053),
    [anon_sym_public] = ACTIONS(2053),
    [anon_sym_private] = ACTIONS(2053),
    [anon_sym_protected] = ACTIONS(2053),
    [anon_sym_override] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_any] = ACTIONS(2053),
    [anon_sym_number] = ACTIONS(2053),
    [anon_sym_boolean] = ACTIONS(2053),
    [anon_sym_string] = ACTIONS(2053),
    [anon_sym_symbol] = ACTIONS(2053),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1461),
    [anon_sym_export] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_namespace] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_typeof] = ACTIONS(1461),
    [anon_sym_import] = ACTIONS(1461),
    [anon_sym_var] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_await] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_try] = ACTIONS(1461),
    [anon_sym_with] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_debugger] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_throw] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_catch] = ACTIONS(1461),
    [anon_sym_finally] = ACTIONS(1461),
    [anon_sym_yield] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LTtemplate_GT] = ACTIONS(1459),
    [anon_sym_class] = ACTIONS(1461),
    [anon_sym_async] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1461),
    [anon_sym_new] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_SLASH] = ACTIONS(1461),
    [anon_sym_LT] = ACTIONS(1461),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_void] = ACTIONS(1461),
    [anon_sym_delete] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1461),
    [sym_super] = ACTIONS(1461),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_undefined] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_get] = ACTIONS(1461),
    [anon_sym_set] = ACTIONS(1461),
    [anon_sym_declare] = ACTIONS(1461),
    [anon_sym_public] = ACTIONS(1461),
    [anon_sym_private] = ACTIONS(1461),
    [anon_sym_protected] = ACTIONS(1461),
    [anon_sym_override] = ACTIONS(1461),
    [anon_sym_module] = ACTIONS(1461),
    [anon_sym_any] = ACTIONS(1461),
    [anon_sym_number] = ACTIONS(1461),
    [anon_sym_boolean] = ACTIONS(1461),
    [anon_sym_string] = ACTIONS(1461),
    [anon_sym_symbol] = ACTIONS(1461),
    [anon_sym_abstract] = ACTIONS(1461),
    [anon_sym_interface] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
  },
  [584] = {
    [sym__call_signature] = STATE(4131),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2051),
    [anon_sym_export] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2053),
    [anon_sym_function] = ACTIONS(1919),
    [anon_sym_EQ_GT] = ACTIONS(1313),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2053),
    [anon_sym_readonly] = ACTIONS(2053),
    [anon_sym_get] = ACTIONS(2053),
    [anon_sym_set] = ACTIONS(2053),
    [anon_sym_declare] = ACTIONS(2053),
    [anon_sym_public] = ACTIONS(2053),
    [anon_sym_private] = ACTIONS(2053),
    [anon_sym_protected] = ACTIONS(2053),
    [anon_sym_override] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_any] = ACTIONS(2053),
    [anon_sym_number] = ACTIONS(2053),
    [anon_sym_boolean] = ACTIONS(2053),
    [anon_sym_string] = ACTIONS(2053),
    [anon_sym_symbol] = ACTIONS(2053),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [585] = {
    [sym__call_signature] = STATE(4022),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_export] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2030),
    [anon_sym_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2030),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(1309),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2030),
    [anon_sym_readonly] = ACTIONS(2030),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2030),
    [anon_sym_declare] = ACTIONS(2030),
    [anon_sym_public] = ACTIONS(2030),
    [anon_sym_private] = ACTIONS(2030),
    [anon_sym_protected] = ACTIONS(2030),
    [anon_sym_override] = ACTIONS(2030),
    [anon_sym_module] = ACTIONS(2030),
    [anon_sym_any] = ACTIONS(2030),
    [anon_sym_number] = ACTIONS(2030),
    [anon_sym_boolean] = ACTIONS(2030),
    [anon_sym_string] = ACTIONS(2030),
    [anon_sym_symbol] = ACTIONS(2030),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [586] = {
    [sym__call_signature] = STATE(4022),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_export] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2030),
    [anon_sym_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2030),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(1309),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2030),
    [anon_sym_readonly] = ACTIONS(2030),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2030),
    [anon_sym_declare] = ACTIONS(2030),
    [anon_sym_public] = ACTIONS(2030),
    [anon_sym_private] = ACTIONS(2030),
    [anon_sym_protected] = ACTIONS(2030),
    [anon_sym_override] = ACTIONS(2030),
    [anon_sym_module] = ACTIONS(2030),
    [anon_sym_any] = ACTIONS(2030),
    [anon_sym_number] = ACTIONS(2030),
    [anon_sym_boolean] = ACTIONS(2030),
    [anon_sym_string] = ACTIONS(2030),
    [anon_sym_symbol] = ACTIONS(2030),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [587] = {
    [sym__call_signature] = STATE(4022),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_export] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2030),
    [anon_sym_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(2035),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2030),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(1309),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2030),
    [anon_sym_readonly] = ACTIONS(2030),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2030),
    [anon_sym_declare] = ACTIONS(2030),
    [anon_sym_public] = ACTIONS(2030),
    [anon_sym_private] = ACTIONS(2030),
    [anon_sym_protected] = ACTIONS(2030),
    [anon_sym_override] = ACTIONS(2030),
    [anon_sym_module] = ACTIONS(2030),
    [anon_sym_any] = ACTIONS(2030),
    [anon_sym_number] = ACTIONS(2030),
    [anon_sym_boolean] = ACTIONS(2030),
    [anon_sym_string] = ACTIONS(2030),
    [anon_sym_symbol] = ACTIONS(2030),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [588] = {
    [sym__call_signature] = STATE(4022),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_export] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2030),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2030),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(1309),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2030),
    [anon_sym_readonly] = ACTIONS(2030),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2030),
    [anon_sym_declare] = ACTIONS(2030),
    [anon_sym_public] = ACTIONS(2030),
    [anon_sym_private] = ACTIONS(2030),
    [anon_sym_protected] = ACTIONS(2030),
    [anon_sym_override] = ACTIONS(2030),
    [anon_sym_module] = ACTIONS(2030),
    [anon_sym_any] = ACTIONS(2030),
    [anon_sym_number] = ACTIONS(2030),
    [anon_sym_boolean] = ACTIONS(2030),
    [anon_sym_string] = ACTIONS(2030),
    [anon_sym_symbol] = ACTIONS(2030),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [589] = {
    [sym__call_signature] = STATE(4131),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2051),
    [anon_sym_export] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2053),
    [anon_sym_function] = ACTIONS(2026),
    [anon_sym_EQ_GT] = ACTIONS(1313),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2053),
    [anon_sym_readonly] = ACTIONS(2053),
    [anon_sym_get] = ACTIONS(2053),
    [anon_sym_set] = ACTIONS(2053),
    [anon_sym_declare] = ACTIONS(2053),
    [anon_sym_public] = ACTIONS(2053),
    [anon_sym_private] = ACTIONS(2053),
    [anon_sym_protected] = ACTIONS(2053),
    [anon_sym_override] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_any] = ACTIONS(2053),
    [anon_sym_number] = ACTIONS(2053),
    [anon_sym_boolean] = ACTIONS(2053),
    [anon_sym_string] = ACTIONS(2053),
    [anon_sym_symbol] = ACTIONS(2053),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1461),
    [anon_sym_export] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_namespace] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_typeof] = ACTIONS(1461),
    [anon_sym_import] = ACTIONS(1461),
    [anon_sym_var] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_await] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_try] = ACTIONS(1461),
    [anon_sym_with] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_debugger] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_throw] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_yield] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LTtemplate_GT] = ACTIONS(1459),
    [anon_sym_class] = ACTIONS(1461),
    [anon_sym_async] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1461),
    [anon_sym_new] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_SLASH] = ACTIONS(1461),
    [anon_sym_LT] = ACTIONS(1461),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_void] = ACTIONS(1461),
    [anon_sym_delete] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1461),
    [sym_super] = ACTIONS(1461),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_undefined] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_get] = ACTIONS(1461),
    [anon_sym_set] = ACTIONS(1461),
    [anon_sym_declare] = ACTIONS(1461),
    [anon_sym_public] = ACTIONS(1461),
    [anon_sym_private] = ACTIONS(1461),
    [anon_sym_protected] = ACTIONS(1461),
    [anon_sym_override] = ACTIONS(1461),
    [anon_sym_module] = ACTIONS(1461),
    [anon_sym_any] = ACTIONS(1461),
    [anon_sym_number] = ACTIONS(1461),
    [anon_sym_boolean] = ACTIONS(1461),
    [anon_sym_string] = ACTIONS(1461),
    [anon_sym_symbol] = ACTIONS(1461),
    [anon_sym_abstract] = ACTIONS(1461),
    [anon_sym_interface] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1459),
    [sym__automatic_semicolon] = ACTIONS(1459),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_export] = ACTIONS(1395),
    [anon_sym_default] = ACTIONS(1395),
    [anon_sym_type] = ACTIONS(1395),
    [anon_sym_namespace] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_COMMA] = ACTIONS(1393),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_typeof] = ACTIONS(1395),
    [anon_sym_import] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1395),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_const] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_else] = ACTIONS(1395),
    [anon_sym_if] = ACTIONS(1395),
    [anon_sym_switch] = ACTIONS(1395),
    [anon_sym_for] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_do] = ACTIONS(1395),
    [anon_sym_try] = ACTIONS(1395),
    [anon_sym_with] = ACTIONS(1395),
    [anon_sym_break] = ACTIONS(1395),
    [anon_sym_continue] = ACTIONS(1395),
    [anon_sym_debugger] = ACTIONS(1395),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_throw] = ACTIONS(1395),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1395),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_LTtemplate_GT] = ACTIONS(1393),
    [anon_sym_class] = ACTIONS(1395),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_function] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1393),
    [anon_sym_void] = ACTIONS(1395),
    [anon_sym_delete] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1395),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1393),
    [sym_number] = ACTIONS(1393),
    [sym_this] = ACTIONS(1395),
    [sym_super] = ACTIONS(1395),
    [sym_true] = ACTIONS(1395),
    [sym_false] = ACTIONS(1395),
    [sym_null] = ACTIONS(1395),
    [sym_undefined] = ACTIONS(1395),
    [anon_sym_AT] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1395),
    [anon_sym_readonly] = ACTIONS(1395),
    [anon_sym_get] = ACTIONS(1395),
    [anon_sym_set] = ACTIONS(1395),
    [anon_sym_declare] = ACTIONS(1395),
    [anon_sym_public] = ACTIONS(1395),
    [anon_sym_private] = ACTIONS(1395),
    [anon_sym_protected] = ACTIONS(1395),
    [anon_sym_override] = ACTIONS(1395),
    [anon_sym_module] = ACTIONS(1395),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1395),
    [anon_sym_interface] = ACTIONS(1395),
    [anon_sym_enum] = ACTIONS(1395),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1393),
    [sym__automatic_semicolon] = ACTIONS(2059),
  },
  [592] = {
    [sym__call_signature] = STATE(4131),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2051),
    [anon_sym_export] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2053),
    [anon_sym_function] = ACTIONS(2061),
    [anon_sym_EQ_GT] = ACTIONS(1313),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2053),
    [anon_sym_readonly] = ACTIONS(2053),
    [anon_sym_get] = ACTIONS(2053),
    [anon_sym_set] = ACTIONS(2053),
    [anon_sym_declare] = ACTIONS(2053),
    [anon_sym_public] = ACTIONS(2053),
    [anon_sym_private] = ACTIONS(2053),
    [anon_sym_protected] = ACTIONS(2053),
    [anon_sym_override] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_any] = ACTIONS(2053),
    [anon_sym_number] = ACTIONS(2053),
    [anon_sym_boolean] = ACTIONS(2053),
    [anon_sym_string] = ACTIONS(2053),
    [anon_sym_symbol] = ACTIONS(2053),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(1479),
    [anon_sym_export] = ACTIONS(1479),
    [anon_sym_default] = ACTIONS(1479),
    [anon_sym_type] = ACTIONS(1479),
    [anon_sym_namespace] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_typeof] = ACTIONS(1479),
    [anon_sym_import] = ACTIONS(1479),
    [anon_sym_var] = ACTIONS(1479),
    [anon_sym_let] = ACTIONS(1479),
    [anon_sym_const] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_switch] = ACTIONS(1479),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_LPAREN] = ACTIONS(1477),
    [anon_sym_await] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1479),
    [anon_sym_do] = ACTIONS(1479),
    [anon_sym_try] = ACTIONS(1479),
    [anon_sym_with] = ACTIONS(1479),
    [anon_sym_break] = ACTIONS(1479),
    [anon_sym_continue] = ACTIONS(1479),
    [anon_sym_debugger] = ACTIONS(1479),
    [anon_sym_return] = ACTIONS(1479),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_case] = ACTIONS(1479),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_LTtemplate_GT] = ACTIONS(1477),
    [anon_sym_class] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(1479),
    [anon_sym_function] = ACTIONS(1479),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1477),
    [anon_sym_void] = ACTIONS(1479),
    [anon_sym_delete] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1477),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_SQUOTE] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1477),
    [sym_number] = ACTIONS(1477),
    [sym_this] = ACTIONS(1479),
    [sym_super] = ACTIONS(1479),
    [sym_true] = ACTIONS(1479),
    [sym_false] = ACTIONS(1479),
    [sym_null] = ACTIONS(1479),
    [sym_undefined] = ACTIONS(1479),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_static] = ACTIONS(1479),
    [anon_sym_readonly] = ACTIONS(1479),
    [anon_sym_get] = ACTIONS(1479),
    [anon_sym_set] = ACTIONS(1479),
    [anon_sym_declare] = ACTIONS(1479),
    [anon_sym_public] = ACTIONS(1479),
    [anon_sym_private] = ACTIONS(1479),
    [anon_sym_protected] = ACTIONS(1479),
    [anon_sym_override] = ACTIONS(1479),
    [anon_sym_module] = ACTIONS(1479),
    [anon_sym_any] = ACTIONS(1479),
    [anon_sym_number] = ACTIONS(1479),
    [anon_sym_boolean] = ACTIONS(1479),
    [anon_sym_string] = ACTIONS(1479),
    [anon_sym_symbol] = ACTIONS(1479),
    [anon_sym_abstract] = ACTIONS(1479),
    [anon_sym_interface] = ACTIONS(1479),
    [anon_sym_enum] = ACTIONS(1479),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1477),
    [sym__automatic_semicolon] = ACTIONS(1477),
  },
  [594] = {
    [sym__call_signature] = STATE(4028),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_export] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(1995),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_get] = ACTIONS(1995),
    [anon_sym_set] = ACTIONS(1995),
    [anon_sym_declare] = ACTIONS(1995),
    [anon_sym_public] = ACTIONS(1995),
    [anon_sym_private] = ACTIONS(1995),
    [anon_sym_protected] = ACTIONS(1995),
    [anon_sym_override] = ACTIONS(1995),
    [anon_sym_module] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1995),
    [anon_sym_number] = ACTIONS(1995),
    [anon_sym_boolean] = ACTIONS(1995),
    [anon_sym_string] = ACTIONS(1995),
    [anon_sym_symbol] = ACTIONS(1995),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [595] = {
    [sym_statement_block] = STATE(661),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(1381),
    [anon_sym_default] = ACTIONS(1381),
    [anon_sym_type] = ACTIONS(1381),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(2063),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_typeof] = ACTIONS(1381),
    [anon_sym_import] = ACTIONS(1381),
    [anon_sym_var] = ACTIONS(1381),
    [anon_sym_let] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(1379),
    [anon_sym_await] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_try] = ACTIONS(1381),
    [anon_sym_with] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_debugger] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_throw] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_case] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_LTtemplate_GT] = ACTIONS(1379),
    [anon_sym_DOT] = ACTIONS(2065),
    [anon_sym_class] = ACTIONS(1381),
    [anon_sym_async] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_void] = ACTIONS(1381),
    [anon_sym_delete] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_number] = ACTIONS(1379),
    [sym_this] = ACTIONS(1381),
    [sym_super] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_undefined] = ACTIONS(1381),
    [anon_sym_AT] = ACTIONS(1379),
    [anon_sym_static] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(1381),
    [anon_sym_get] = ACTIONS(1381),
    [anon_sym_set] = ACTIONS(1381),
    [anon_sym_declare] = ACTIONS(1381),
    [anon_sym_public] = ACTIONS(1381),
    [anon_sym_private] = ACTIONS(1381),
    [anon_sym_protected] = ACTIONS(1381),
    [anon_sym_override] = ACTIONS(1381),
    [anon_sym_module] = ACTIONS(1381),
    [anon_sym_any] = ACTIONS(1381),
    [anon_sym_number] = ACTIONS(1381),
    [anon_sym_boolean] = ACTIONS(1381),
    [anon_sym_string] = ACTIONS(1381),
    [anon_sym_symbol] = ACTIONS(1381),
    [anon_sym_abstract] = ACTIONS(1381),
    [anon_sym_interface] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
  },
  [596] = {
    [sym_statement_block] = STATE(661),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(1381),
    [anon_sym_default] = ACTIONS(1381),
    [anon_sym_type] = ACTIONS(1381),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(2063),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_typeof] = ACTIONS(1381),
    [anon_sym_import] = ACTIONS(1381),
    [anon_sym_var] = ACTIONS(1381),
    [anon_sym_let] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(1379),
    [anon_sym_await] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_try] = ACTIONS(1381),
    [anon_sym_with] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_debugger] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_throw] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_case] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_LTtemplate_GT] = ACTIONS(1379),
    [anon_sym_DOT] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(1381),
    [anon_sym_async] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_void] = ACTIONS(1381),
    [anon_sym_delete] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_number] = ACTIONS(1379),
    [sym_this] = ACTIONS(1381),
    [sym_super] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_undefined] = ACTIONS(1381),
    [anon_sym_AT] = ACTIONS(1379),
    [anon_sym_static] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(1381),
    [anon_sym_get] = ACTIONS(1381),
    [anon_sym_set] = ACTIONS(1381),
    [anon_sym_declare] = ACTIONS(1381),
    [anon_sym_public] = ACTIONS(1381),
    [anon_sym_private] = ACTIONS(1381),
    [anon_sym_protected] = ACTIONS(1381),
    [anon_sym_override] = ACTIONS(1381),
    [anon_sym_module] = ACTIONS(1381),
    [anon_sym_any] = ACTIONS(1381),
    [anon_sym_number] = ACTIONS(1381),
    [anon_sym_boolean] = ACTIONS(1381),
    [anon_sym_string] = ACTIONS(1381),
    [anon_sym_symbol] = ACTIONS(1381),
    [anon_sym_abstract] = ACTIONS(1381),
    [anon_sym_interface] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
  },
  [597] = {
    [sym__call_signature] = STATE(4077),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_export] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_EQ] = ACTIONS(1315),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(1317),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_readonly] = ACTIONS(2071),
    [anon_sym_get] = ACTIONS(2071),
    [anon_sym_set] = ACTIONS(2071),
    [anon_sym_declare] = ACTIONS(2071),
    [anon_sym_public] = ACTIONS(2071),
    [anon_sym_private] = ACTIONS(2071),
    [anon_sym_protected] = ACTIONS(2071),
    [anon_sym_override] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(2071),
    [anon_sym_any] = ACTIONS(2071),
    [anon_sym_number] = ACTIONS(2071),
    [anon_sym_boolean] = ACTIONS(2071),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_symbol] = ACTIONS(2071),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [598] = {
    [sym__call_signature] = STATE(4077),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_export] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(1317),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_readonly] = ACTIONS(2071),
    [anon_sym_get] = ACTIONS(2071),
    [anon_sym_set] = ACTIONS(2071),
    [anon_sym_declare] = ACTIONS(2071),
    [anon_sym_public] = ACTIONS(2071),
    [anon_sym_private] = ACTIONS(2071),
    [anon_sym_protected] = ACTIONS(2071),
    [anon_sym_override] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(2071),
    [anon_sym_any] = ACTIONS(2071),
    [anon_sym_number] = ACTIONS(2071),
    [anon_sym_boolean] = ACTIONS(2071),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_symbol] = ACTIONS(2071),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [599] = {
    [sym_finally_clause] = STATE(680),
    [ts_builtin_sym_end] = ACTIONS(2073),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_export] = ACTIONS(2075),
    [anon_sym_default] = ACTIONS(2075),
    [anon_sym_type] = ACTIONS(2075),
    [anon_sym_namespace] = ACTIONS(2075),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_RBRACE] = ACTIONS(2073),
    [anon_sym_typeof] = ACTIONS(2075),
    [anon_sym_import] = ACTIONS(2075),
    [anon_sym_var] = ACTIONS(2075),
    [anon_sym_let] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2075),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_else] = ACTIONS(2075),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_switch] = ACTIONS(2075),
    [anon_sym_for] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(2073),
    [anon_sym_await] = ACTIONS(2075),
    [anon_sym_while] = ACTIONS(2075),
    [anon_sym_do] = ACTIONS(2075),
    [anon_sym_try] = ACTIONS(2075),
    [anon_sym_with] = ACTIONS(2075),
    [anon_sym_break] = ACTIONS(2075),
    [anon_sym_continue] = ACTIONS(2075),
    [anon_sym_debugger] = ACTIONS(2075),
    [anon_sym_return] = ACTIONS(2075),
    [anon_sym_throw] = ACTIONS(2075),
    [anon_sym_SEMI] = ACTIONS(2073),
    [anon_sym_case] = ACTIONS(2075),
    [anon_sym_finally] = ACTIONS(2049),
    [anon_sym_yield] = ACTIONS(2075),
    [anon_sym_LBRACK] = ACTIONS(2073),
    [anon_sym_LTtemplate_GT] = ACTIONS(2073),
    [anon_sym_class] = ACTIONS(2075),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2075),
    [anon_sym_new] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(2075),
    [anon_sym_DASH] = ACTIONS(2075),
    [anon_sym_SLASH] = ACTIONS(2075),
    [anon_sym_LT] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_void] = ACTIONS(2075),
    [anon_sym_delete] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(2073),
    [anon_sym_SQUOTE] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2073),
    [sym_number] = ACTIONS(2073),
    [sym_this] = ACTIONS(2075),
    [sym_super] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_null] = ACTIONS(2075),
    [sym_undefined] = ACTIONS(2075),
    [anon_sym_AT] = ACTIONS(2073),
    [anon_sym_static] = ACTIONS(2075),
    [anon_sym_readonly] = ACTIONS(2075),
    [anon_sym_get] = ACTIONS(2075),
    [anon_sym_set] = ACTIONS(2075),
    [anon_sym_declare] = ACTIONS(2075),
    [anon_sym_public] = ACTIONS(2075),
    [anon_sym_private] = ACTIONS(2075),
    [anon_sym_protected] = ACTIONS(2075),
    [anon_sym_override] = ACTIONS(2075),
    [anon_sym_module] = ACTIONS(2075),
    [anon_sym_any] = ACTIONS(2075),
    [anon_sym_number] = ACTIONS(2075),
    [anon_sym_boolean] = ACTIONS(2075),
    [anon_sym_string] = ACTIONS(2075),
    [anon_sym_symbol] = ACTIONS(2075),
    [anon_sym_abstract] = ACTIONS(2075),
    [anon_sym_interface] = ACTIONS(2075),
    [anon_sym_enum] = ACTIONS(2075),
  },
  [600] = {
    [sym__call_signature] = STATE(4028),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_export] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_of] = ACTIONS(2024),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(1995),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_get] = ACTIONS(1995),
    [anon_sym_set] = ACTIONS(1995),
    [anon_sym_declare] = ACTIONS(1995),
    [anon_sym_public] = ACTIONS(1995),
    [anon_sym_private] = ACTIONS(1995),
    [anon_sym_protected] = ACTIONS(1995),
    [anon_sym_override] = ACTIONS(1995),
    [anon_sym_module] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1995),
    [anon_sym_number] = ACTIONS(1995),
    [anon_sym_boolean] = ACTIONS(1995),
    [anon_sym_string] = ACTIONS(1995),
    [anon_sym_symbol] = ACTIONS(1995),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1517),
    [anon_sym_default] = ACTIONS(1517),
    [anon_sym_type] = ACTIONS(1517),
    [anon_sym_namespace] = ACTIONS(1517),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1515),
    [anon_sym_typeof] = ACTIONS(1517),
    [anon_sym_import] = ACTIONS(1517),
    [anon_sym_var] = ACTIONS(1517),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_else] = ACTIONS(1517),
    [anon_sym_if] = ACTIONS(1517),
    [anon_sym_switch] = ACTIONS(1517),
    [anon_sym_for] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1515),
    [anon_sym_await] = ACTIONS(1517),
    [anon_sym_while] = ACTIONS(1517),
    [anon_sym_do] = ACTIONS(1517),
    [anon_sym_try] = ACTIONS(1517),
    [anon_sym_with] = ACTIONS(1517),
    [anon_sym_break] = ACTIONS(1517),
    [anon_sym_continue] = ACTIONS(1517),
    [anon_sym_debugger] = ACTIONS(1517),
    [anon_sym_return] = ACTIONS(1517),
    [anon_sym_throw] = ACTIONS(1517),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_case] = ACTIONS(1517),
    [anon_sym_yield] = ACTIONS(1517),
    [anon_sym_LBRACK] = ACTIONS(1515),
    [anon_sym_LTtemplate_GT] = ACTIONS(1515),
    [anon_sym_class] = ACTIONS(1517),
    [anon_sym_async] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1517),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1517),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_void] = ACTIONS(1517),
    [anon_sym_delete] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1515),
    [sym_number] = ACTIONS(1515),
    [sym_this] = ACTIONS(1517),
    [sym_super] = ACTIONS(1517),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [sym_null] = ACTIONS(1517),
    [sym_undefined] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1515),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_readonly] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(1517),
    [anon_sym_set] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_public] = ACTIONS(1517),
    [anon_sym_private] = ACTIONS(1517),
    [anon_sym_protected] = ACTIONS(1517),
    [anon_sym_override] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_any] = ACTIONS(1517),
    [anon_sym_number] = ACTIONS(1517),
    [anon_sym_boolean] = ACTIONS(1517),
    [anon_sym_string] = ACTIONS(1517),
    [anon_sym_symbol] = ACTIONS(1517),
    [anon_sym_abstract] = ACTIONS(1517),
    [anon_sym_interface] = ACTIONS(1517),
    [anon_sym_enum] = ACTIONS(1517),
    [sym__automatic_semicolon] = ACTIONS(1523),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(1561),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(1563),
    [anon_sym_default] = ACTIONS(1563),
    [anon_sym_type] = ACTIONS(1563),
    [anon_sym_namespace] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1561),
    [anon_sym_RBRACE] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(1563),
    [anon_sym_import] = ACTIONS(1563),
    [anon_sym_var] = ACTIONS(1563),
    [anon_sym_let] = ACTIONS(1563),
    [anon_sym_const] = ACTIONS(1563),
    [anon_sym_BANG] = ACTIONS(1561),
    [anon_sym_else] = ACTIONS(1563),
    [anon_sym_if] = ACTIONS(1563),
    [anon_sym_switch] = ACTIONS(1563),
    [anon_sym_for] = ACTIONS(1563),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_await] = ACTIONS(1563),
    [anon_sym_while] = ACTIONS(1563),
    [anon_sym_do] = ACTIONS(1563),
    [anon_sym_try] = ACTIONS(1563),
    [anon_sym_with] = ACTIONS(1563),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_continue] = ACTIONS(1563),
    [anon_sym_debugger] = ACTIONS(1563),
    [anon_sym_return] = ACTIONS(1563),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1561),
    [anon_sym_case] = ACTIONS(1563),
    [anon_sym_yield] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(1561),
    [anon_sym_LTtemplate_GT] = ACTIONS(1561),
    [anon_sym_class] = ACTIONS(1563),
    [anon_sym_async] = ACTIONS(1563),
    [anon_sym_function] = ACTIONS(1563),
    [anon_sym_new] = ACTIONS(1563),
    [anon_sym_PLUS] = ACTIONS(1563),
    [anon_sym_DASH] = ACTIONS(1563),
    [anon_sym_SLASH] = ACTIONS(1563),
    [anon_sym_LT] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1561),
    [anon_sym_void] = ACTIONS(1563),
    [anon_sym_delete] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1561),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_DQUOTE] = ACTIONS(1561),
    [anon_sym_SQUOTE] = ACTIONS(1561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1561),
    [sym_number] = ACTIONS(1561),
    [sym_this] = ACTIONS(1563),
    [sym_super] = ACTIONS(1563),
    [sym_true] = ACTIONS(1563),
    [sym_false] = ACTIONS(1563),
    [sym_null] = ACTIONS(1563),
    [sym_undefined] = ACTIONS(1563),
    [anon_sym_AT] = ACTIONS(1561),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_readonly] = ACTIONS(1563),
    [anon_sym_get] = ACTIONS(1563),
    [anon_sym_set] = ACTIONS(1563),
    [anon_sym_declare] = ACTIONS(1563),
    [anon_sym_public] = ACTIONS(1563),
    [anon_sym_private] = ACTIONS(1563),
    [anon_sym_protected] = ACTIONS(1563),
    [anon_sym_override] = ACTIONS(1563),
    [anon_sym_module] = ACTIONS(1563),
    [anon_sym_any] = ACTIONS(1563),
    [anon_sym_number] = ACTIONS(1563),
    [anon_sym_boolean] = ACTIONS(1563),
    [anon_sym_string] = ACTIONS(1563),
    [anon_sym_symbol] = ACTIONS(1563),
    [anon_sym_abstract] = ACTIONS(1563),
    [anon_sym_interface] = ACTIONS(1563),
    [anon_sym_enum] = ACTIONS(1563),
    [sym__automatic_semicolon] = ACTIONS(1569),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(1421),
    [sym_identifier] = ACTIONS(1423),
    [anon_sym_export] = ACTIONS(1423),
    [anon_sym_default] = ACTIONS(1423),
    [anon_sym_type] = ACTIONS(1423),
    [anon_sym_namespace] = ACTIONS(1423),
    [anon_sym_LBRACE] = ACTIONS(1421),
    [anon_sym_RBRACE] = ACTIONS(1421),
    [anon_sym_typeof] = ACTIONS(1423),
    [anon_sym_import] = ACTIONS(1423),
    [anon_sym_var] = ACTIONS(1423),
    [anon_sym_let] = ACTIONS(1423),
    [anon_sym_const] = ACTIONS(1423),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_else] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(1423),
    [anon_sym_switch] = ACTIONS(1423),
    [anon_sym_for] = ACTIONS(1423),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_while] = ACTIONS(1423),
    [anon_sym_do] = ACTIONS(1423),
    [anon_sym_try] = ACTIONS(1423),
    [anon_sym_with] = ACTIONS(1423),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_continue] = ACTIONS(1423),
    [anon_sym_debugger] = ACTIONS(1423),
    [anon_sym_return] = ACTIONS(1423),
    [anon_sym_throw] = ACTIONS(1423),
    [anon_sym_SEMI] = ACTIONS(1421),
    [anon_sym_case] = ACTIONS(1423),
    [anon_sym_yield] = ACTIONS(1423),
    [anon_sym_LBRACK] = ACTIONS(1421),
    [anon_sym_LTtemplate_GT] = ACTIONS(1421),
    [anon_sym_DOT] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1423),
    [anon_sym_async] = ACTIONS(1423),
    [anon_sym_function] = ACTIONS(1423),
    [anon_sym_new] = ACTIONS(1423),
    [anon_sym_PLUS] = ACTIONS(1423),
    [anon_sym_DASH] = ACTIONS(1423),
    [anon_sym_SLASH] = ACTIONS(1423),
    [anon_sym_LT] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1423),
    [anon_sym_delete] = ACTIONS(1423),
    [anon_sym_PLUS_PLUS] = ACTIONS(1421),
    [anon_sym_DASH_DASH] = ACTIONS(1423),
    [anon_sym_DQUOTE] = ACTIONS(1421),
    [anon_sym_SQUOTE] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1421),
    [sym_number] = ACTIONS(1421),
    [sym_this] = ACTIONS(1423),
    [sym_super] = ACTIONS(1423),
    [sym_true] = ACTIONS(1423),
    [sym_false] = ACTIONS(1423),
    [sym_null] = ACTIONS(1423),
    [sym_undefined] = ACTIONS(1423),
    [anon_sym_AT] = ACTIONS(1421),
    [anon_sym_static] = ACTIONS(1423),
    [anon_sym_readonly] = ACTIONS(1423),
    [anon_sym_get] = ACTIONS(1423),
    [anon_sym_set] = ACTIONS(1423),
    [anon_sym_declare] = ACTIONS(1423),
    [anon_sym_public] = ACTIONS(1423),
    [anon_sym_private] = ACTIONS(1423),
    [anon_sym_protected] = ACTIONS(1423),
    [anon_sym_override] = ACTIONS(1423),
    [anon_sym_module] = ACTIONS(1423),
    [anon_sym_any] = ACTIONS(1423),
    [anon_sym_number] = ACTIONS(1423),
    [anon_sym_boolean] = ACTIONS(1423),
    [anon_sym_string] = ACTIONS(1423),
    [anon_sym_symbol] = ACTIONS(1423),
    [anon_sym_abstract] = ACTIONS(1423),
    [anon_sym_interface] = ACTIONS(1423),
    [anon_sym_enum] = ACTIONS(1423),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(1571),
    [sym_identifier] = ACTIONS(1573),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_default] = ACTIONS(1573),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_RBRACE] = ACTIONS(1571),
    [anon_sym_typeof] = ACTIONS(1573),
    [anon_sym_import] = ACTIONS(1573),
    [anon_sym_var] = ACTIONS(1573),
    [anon_sym_let] = ACTIONS(1573),
    [anon_sym_const] = ACTIONS(1573),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_else] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1573),
    [anon_sym_for] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_while] = ACTIONS(1573),
    [anon_sym_do] = ACTIONS(1573),
    [anon_sym_try] = ACTIONS(1573),
    [anon_sym_with] = ACTIONS(1573),
    [anon_sym_break] = ACTIONS(1573),
    [anon_sym_continue] = ACTIONS(1573),
    [anon_sym_debugger] = ACTIONS(1573),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_case] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1573),
    [anon_sym_LBRACK] = ACTIONS(1571),
    [anon_sym_LTtemplate_GT] = ACTIONS(1571),
    [anon_sym_class] = ACTIONS(1573),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_function] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1573),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_SLASH] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_void] = ACTIONS(1573),
    [anon_sym_delete] = ACTIONS(1573),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1573),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1571),
    [sym_number] = ACTIONS(1571),
    [sym_this] = ACTIONS(1573),
    [sym_super] = ACTIONS(1573),
    [sym_true] = ACTIONS(1573),
    [sym_false] = ACTIONS(1573),
    [sym_null] = ACTIONS(1573),
    [sym_undefined] = ACTIONS(1573),
    [anon_sym_AT] = ACTIONS(1571),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(1573),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_override] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1573),
    [anon_sym_number] = ACTIONS(1573),
    [anon_sym_boolean] = ACTIONS(1573),
    [anon_sym_string] = ACTIONS(1573),
    [anon_sym_symbol] = ACTIONS(1573),
    [anon_sym_abstract] = ACTIONS(1573),
    [anon_sym_interface] = ACTIONS(1573),
    [anon_sym_enum] = ACTIONS(1573),
    [sym__automatic_semicolon] = ACTIONS(1579),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(1505),
    [sym_identifier] = ACTIONS(1507),
    [anon_sym_export] = ACTIONS(1507),
    [anon_sym_default] = ACTIONS(1507),
    [anon_sym_type] = ACTIONS(1507),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_RBRACE] = ACTIONS(1505),
    [anon_sym_typeof] = ACTIONS(1507),
    [anon_sym_import] = ACTIONS(1507),
    [anon_sym_var] = ACTIONS(1507),
    [anon_sym_let] = ACTIONS(1507),
    [anon_sym_const] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1505),
    [anon_sym_else] = ACTIONS(1507),
    [anon_sym_if] = ACTIONS(1507),
    [anon_sym_switch] = ACTIONS(1507),
    [anon_sym_for] = ACTIONS(1507),
    [anon_sym_LPAREN] = ACTIONS(1505),
    [anon_sym_await] = ACTIONS(1507),
    [anon_sym_while] = ACTIONS(1507),
    [anon_sym_do] = ACTIONS(1507),
    [anon_sym_try] = ACTIONS(1507),
    [anon_sym_with] = ACTIONS(1507),
    [anon_sym_break] = ACTIONS(1507),
    [anon_sym_continue] = ACTIONS(1507),
    [anon_sym_debugger] = ACTIONS(1507),
    [anon_sym_return] = ACTIONS(1507),
    [anon_sym_throw] = ACTIONS(1507),
    [anon_sym_SEMI] = ACTIONS(1505),
    [anon_sym_case] = ACTIONS(1507),
    [anon_sym_yield] = ACTIONS(1507),
    [anon_sym_LBRACK] = ACTIONS(1505),
    [anon_sym_LTtemplate_GT] = ACTIONS(1505),
    [anon_sym_class] = ACTIONS(1507),
    [anon_sym_async] = ACTIONS(1507),
    [anon_sym_function] = ACTIONS(1507),
    [anon_sym_new] = ACTIONS(1507),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1507),
    [anon_sym_LT] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1505),
    [anon_sym_void] = ACTIONS(1507),
    [anon_sym_delete] = ACTIONS(1507),
    [anon_sym_PLUS_PLUS] = ACTIONS(1505),
    [anon_sym_DASH_DASH] = ACTIONS(1507),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_SQUOTE] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1505),
    [sym_number] = ACTIONS(1505),
    [sym_this] = ACTIONS(1507),
    [sym_super] = ACTIONS(1507),
    [sym_true] = ACTIONS(1507),
    [sym_false] = ACTIONS(1507),
    [sym_null] = ACTIONS(1507),
    [sym_undefined] = ACTIONS(1507),
    [anon_sym_AT] = ACTIONS(1505),
    [anon_sym_static] = ACTIONS(1507),
    [anon_sym_readonly] = ACTIONS(1507),
    [anon_sym_get] = ACTIONS(1507),
    [anon_sym_set] = ACTIONS(1507),
    [anon_sym_declare] = ACTIONS(1507),
    [anon_sym_public] = ACTIONS(1507),
    [anon_sym_private] = ACTIONS(1507),
    [anon_sym_protected] = ACTIONS(1507),
    [anon_sym_override] = ACTIONS(1507),
    [anon_sym_module] = ACTIONS(1507),
    [anon_sym_any] = ACTIONS(1507),
    [anon_sym_number] = ACTIONS(1507),
    [anon_sym_boolean] = ACTIONS(1507),
    [anon_sym_string] = ACTIONS(1507),
    [anon_sym_symbol] = ACTIONS(1507),
    [anon_sym_abstract] = ACTIONS(1507),
    [anon_sym_interface] = ACTIONS(1507),
    [anon_sym_enum] = ACTIONS(1507),
    [sym__automatic_semicolon] = ACTIONS(1513),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(2077),
    [sym_identifier] = ACTIONS(2079),
    [anon_sym_export] = ACTIONS(2079),
    [anon_sym_default] = ACTIONS(2079),
    [anon_sym_type] = ACTIONS(2079),
    [anon_sym_namespace] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(2077),
    [anon_sym_RBRACE] = ACTIONS(2077),
    [anon_sym_typeof] = ACTIONS(2079),
    [anon_sym_import] = ACTIONS(2079),
    [anon_sym_var] = ACTIONS(2079),
    [anon_sym_let] = ACTIONS(2079),
    [anon_sym_const] = ACTIONS(2079),
    [anon_sym_BANG] = ACTIONS(2077),
    [anon_sym_else] = ACTIONS(2079),
    [anon_sym_if] = ACTIONS(2079),
    [anon_sym_switch] = ACTIONS(2079),
    [anon_sym_for] = ACTIONS(2079),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(2079),
    [anon_sym_do] = ACTIONS(2079),
    [anon_sym_try] = ACTIONS(2079),
    [anon_sym_with] = ACTIONS(2079),
    [anon_sym_break] = ACTIONS(2079),
    [anon_sym_continue] = ACTIONS(2079),
    [anon_sym_debugger] = ACTIONS(2079),
    [anon_sym_return] = ACTIONS(2079),
    [anon_sym_throw] = ACTIONS(2079),
    [anon_sym_SEMI] = ACTIONS(2077),
    [anon_sym_case] = ACTIONS(2079),
    [anon_sym_finally] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(2079),
    [anon_sym_LBRACK] = ACTIONS(2077),
    [anon_sym_LTtemplate_GT] = ACTIONS(2077),
    [anon_sym_class] = ACTIONS(2079),
    [anon_sym_async] = ACTIONS(2079),
    [anon_sym_function] = ACTIONS(2079),
    [anon_sym_new] = ACTIONS(2079),
    [anon_sym_PLUS] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2079),
    [anon_sym_SLASH] = ACTIONS(2079),
    [anon_sym_LT] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2077),
    [anon_sym_void] = ACTIONS(2079),
    [anon_sym_delete] = ACTIONS(2079),
    [anon_sym_PLUS_PLUS] = ACTIONS(2077),
    [anon_sym_DASH_DASH] = ACTIONS(2079),
    [anon_sym_DQUOTE] = ACTIONS(2077),
    [anon_sym_SQUOTE] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2077),
    [sym_number] = ACTIONS(2077),
    [sym_this] = ACTIONS(2079),
    [sym_super] = ACTIONS(2079),
    [sym_true] = ACTIONS(2079),
    [sym_false] = ACTIONS(2079),
    [sym_null] = ACTIONS(2079),
    [sym_undefined] = ACTIONS(2079),
    [anon_sym_AT] = ACTIONS(2077),
    [anon_sym_static] = ACTIONS(2079),
    [anon_sym_readonly] = ACTIONS(2079),
    [anon_sym_get] = ACTIONS(2079),
    [anon_sym_set] = ACTIONS(2079),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_public] = ACTIONS(2079),
    [anon_sym_private] = ACTIONS(2079),
    [anon_sym_protected] = ACTIONS(2079),
    [anon_sym_override] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2079),
    [anon_sym_any] = ACTIONS(2079),
    [anon_sym_number] = ACTIONS(2079),
    [anon_sym_boolean] = ACTIONS(2079),
    [anon_sym_string] = ACTIONS(2079),
    [anon_sym_symbol] = ACTIONS(2079),
    [anon_sym_abstract] = ACTIONS(2079),
    [anon_sym_interface] = ACTIONS(2079),
    [anon_sym_enum] = ACTIONS(2079),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(2081),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_default] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2081),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2081),
    [anon_sym_else] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2081),
    [anon_sym_case] = ACTIONS(2083),
    [anon_sym_finally] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_LTtemplate_GT] = ACTIONS(2081),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2083),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2081),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2081),
    [anon_sym_SQUOTE] = ACTIONS(2081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2081),
    [sym_number] = ACTIONS(2081),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2081),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_readonly] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_override] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1413),
    [anon_sym_export] = ACTIONS(1413),
    [anon_sym_default] = ACTIONS(1413),
    [anon_sym_type] = ACTIONS(1413),
    [anon_sym_namespace] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_typeof] = ACTIONS(1413),
    [anon_sym_import] = ACTIONS(1413),
    [anon_sym_var] = ACTIONS(1413),
    [anon_sym_let] = ACTIONS(1413),
    [anon_sym_const] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_else] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_await] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_try] = ACTIONS(1413),
    [anon_sym_with] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_continue] = ACTIONS(1413),
    [anon_sym_debugger] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_throw] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_LTtemplate_GT] = ACTIONS(1411),
    [anon_sym_class] = ACTIONS(1413),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_function] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1413),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_void] = ACTIONS(1413),
    [anon_sym_delete] = ACTIONS(1413),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1411),
    [sym_number] = ACTIONS(1411),
    [sym_this] = ACTIONS(1413),
    [sym_super] = ACTIONS(1413),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [sym_null] = ACTIONS(1413),
    [sym_undefined] = ACTIONS(1413),
    [anon_sym_AT] = ACTIONS(1411),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(1413),
    [anon_sym_get] = ACTIONS(1413),
    [anon_sym_set] = ACTIONS(1413),
    [anon_sym_declare] = ACTIONS(1413),
    [anon_sym_public] = ACTIONS(1413),
    [anon_sym_private] = ACTIONS(1413),
    [anon_sym_protected] = ACTIONS(1413),
    [anon_sym_override] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_any] = ACTIONS(1413),
    [anon_sym_number] = ACTIONS(1413),
    [anon_sym_boolean] = ACTIONS(1413),
    [anon_sym_string] = ACTIONS(1413),
    [anon_sym_symbol] = ACTIONS(1413),
    [anon_sym_abstract] = ACTIONS(1413),
    [anon_sym_interface] = ACTIONS(1413),
    [anon_sym_enum] = ACTIONS(1413),
    [sym__automatic_semicolon] = ACTIONS(1419),
  },
  [609] = {
    [ts_builtin_sym_end] = ACTIONS(1581),
    [sym_identifier] = ACTIONS(1583),
    [anon_sym_export] = ACTIONS(1583),
    [anon_sym_default] = ACTIONS(1583),
    [anon_sym_type] = ACTIONS(1583),
    [anon_sym_namespace] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1581),
    [anon_sym_RBRACE] = ACTIONS(1581),
    [anon_sym_typeof] = ACTIONS(1583),
    [anon_sym_import] = ACTIONS(1583),
    [anon_sym_var] = ACTIONS(1583),
    [anon_sym_let] = ACTIONS(1583),
    [anon_sym_const] = ACTIONS(1583),
    [anon_sym_BANG] = ACTIONS(1581),
    [anon_sym_else] = ACTIONS(1583),
    [anon_sym_if] = ACTIONS(1583),
    [anon_sym_switch] = ACTIONS(1583),
    [anon_sym_for] = ACTIONS(1583),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_await] = ACTIONS(1583),
    [anon_sym_while] = ACTIONS(1583),
    [anon_sym_do] = ACTIONS(1583),
    [anon_sym_try] = ACTIONS(1583),
    [anon_sym_with] = ACTIONS(1583),
    [anon_sym_break] = ACTIONS(1583),
    [anon_sym_continue] = ACTIONS(1583),
    [anon_sym_debugger] = ACTIONS(1583),
    [anon_sym_return] = ACTIONS(1583),
    [anon_sym_throw] = ACTIONS(1583),
    [anon_sym_SEMI] = ACTIONS(1581),
    [anon_sym_case] = ACTIONS(1583),
    [anon_sym_yield] = ACTIONS(1583),
    [anon_sym_LBRACK] = ACTIONS(1581),
    [anon_sym_LTtemplate_GT] = ACTIONS(1581),
    [anon_sym_class] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(1583),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_DASH] = ACTIONS(1583),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_LT] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1581),
    [anon_sym_void] = ACTIONS(1583),
    [anon_sym_delete] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1581),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_DQUOTE] = ACTIONS(1581),
    [anon_sym_SQUOTE] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1581),
    [sym_number] = ACTIONS(1581),
    [sym_this] = ACTIONS(1583),
    [sym_super] = ACTIONS(1583),
    [sym_true] = ACTIONS(1583),
    [sym_false] = ACTIONS(1583),
    [sym_null] = ACTIONS(1583),
    [sym_undefined] = ACTIONS(1583),
    [anon_sym_AT] = ACTIONS(1581),
    [anon_sym_static] = ACTIONS(1583),
    [anon_sym_readonly] = ACTIONS(1583),
    [anon_sym_get] = ACTIONS(1583),
    [anon_sym_set] = ACTIONS(1583),
    [anon_sym_declare] = ACTIONS(1583),
    [anon_sym_public] = ACTIONS(1583),
    [anon_sym_private] = ACTIONS(1583),
    [anon_sym_protected] = ACTIONS(1583),
    [anon_sym_override] = ACTIONS(1583),
    [anon_sym_module] = ACTIONS(1583),
    [anon_sym_any] = ACTIONS(1583),
    [anon_sym_number] = ACTIONS(1583),
    [anon_sym_boolean] = ACTIONS(1583),
    [anon_sym_string] = ACTIONS(1583),
    [anon_sym_symbol] = ACTIONS(1583),
    [anon_sym_abstract] = ACTIONS(1583),
    [anon_sym_interface] = ACTIONS(1583),
    [anon_sym_enum] = ACTIONS(1583),
    [sym__automatic_semicolon] = ACTIONS(1589),
  },
  [610] = {
    [sym_else_clause] = STATE(751),
    [ts_builtin_sym_end] = ACTIONS(2085),
    [sym_identifier] = ACTIONS(2087),
    [anon_sym_export] = ACTIONS(2087),
    [anon_sym_default] = ACTIONS(2087),
    [anon_sym_type] = ACTIONS(2087),
    [anon_sym_namespace] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(2085),
    [anon_sym_RBRACE] = ACTIONS(2085),
    [anon_sym_typeof] = ACTIONS(2087),
    [anon_sym_import] = ACTIONS(2087),
    [anon_sym_var] = ACTIONS(2087),
    [anon_sym_let] = ACTIONS(2087),
    [anon_sym_const] = ACTIONS(2087),
    [anon_sym_BANG] = ACTIONS(2085),
    [anon_sym_else] = ACTIONS(2089),
    [anon_sym_if] = ACTIONS(2087),
    [anon_sym_switch] = ACTIONS(2087),
    [anon_sym_for] = ACTIONS(2087),
    [anon_sym_LPAREN] = ACTIONS(2085),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_while] = ACTIONS(2087),
    [anon_sym_do] = ACTIONS(2087),
    [anon_sym_try] = ACTIONS(2087),
    [anon_sym_with] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_continue] = ACTIONS(2087),
    [anon_sym_debugger] = ACTIONS(2087),
    [anon_sym_return] = ACTIONS(2087),
    [anon_sym_throw] = ACTIONS(2087),
    [anon_sym_SEMI] = ACTIONS(2085),
    [anon_sym_case] = ACTIONS(2087),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_LBRACK] = ACTIONS(2085),
    [anon_sym_LTtemplate_GT] = ACTIONS(2085),
    [anon_sym_class] = ACTIONS(2087),
    [anon_sym_async] = ACTIONS(2087),
    [anon_sym_function] = ACTIONS(2087),
    [anon_sym_new] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2087),
    [anon_sym_DASH] = ACTIONS(2087),
    [anon_sym_SLASH] = ACTIONS(2087),
    [anon_sym_LT] = ACTIONS(2087),
    [anon_sym_TILDE] = ACTIONS(2085),
    [anon_sym_void] = ACTIONS(2087),
    [anon_sym_delete] = ACTIONS(2087),
    [anon_sym_PLUS_PLUS] = ACTIONS(2085),
    [anon_sym_DASH_DASH] = ACTIONS(2087),
    [anon_sym_DQUOTE] = ACTIONS(2085),
    [anon_sym_SQUOTE] = ACTIONS(2085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2085),
    [sym_number] = ACTIONS(2085),
    [sym_this] = ACTIONS(2087),
    [sym_super] = ACTIONS(2087),
    [sym_true] = ACTIONS(2087),
    [sym_false] = ACTIONS(2087),
    [sym_null] = ACTIONS(2087),
    [sym_undefined] = ACTIONS(2087),
    [anon_sym_AT] = ACTIONS(2085),
    [anon_sym_static] = ACTIONS(2087),
    [anon_sym_readonly] = ACTIONS(2087),
    [anon_sym_get] = ACTIONS(2087),
    [anon_sym_set] = ACTIONS(2087),
    [anon_sym_declare] = ACTIONS(2087),
    [anon_sym_public] = ACTIONS(2087),
    [anon_sym_private] = ACTIONS(2087),
    [anon_sym_protected] = ACTIONS(2087),
    [anon_sym_override] = ACTIONS(2087),
    [anon_sym_module] = ACTIONS(2087),
    [anon_sym_any] = ACTIONS(2087),
    [anon_sym_number] = ACTIONS(2087),
    [anon_sym_boolean] = ACTIONS(2087),
    [anon_sym_string] = ACTIONS(2087),
    [anon_sym_symbol] = ACTIONS(2087),
    [anon_sym_abstract] = ACTIONS(2087),
    [anon_sym_interface] = ACTIONS(2087),
    [anon_sym_enum] = ACTIONS(2087),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(2091),
    [sym_identifier] = ACTIONS(2093),
    [anon_sym_export] = ACTIONS(2093),
    [anon_sym_default] = ACTIONS(2093),
    [anon_sym_type] = ACTIONS(2093),
    [anon_sym_namespace] = ACTIONS(2093),
    [anon_sym_LBRACE] = ACTIONS(2091),
    [anon_sym_RBRACE] = ACTIONS(2091),
    [anon_sym_typeof] = ACTIONS(2093),
    [anon_sym_import] = ACTIONS(2093),
    [anon_sym_var] = ACTIONS(2093),
    [anon_sym_let] = ACTIONS(2093),
    [anon_sym_const] = ACTIONS(2093),
    [anon_sym_BANG] = ACTIONS(2091),
    [anon_sym_else] = ACTIONS(2093),
    [anon_sym_if] = ACTIONS(2093),
    [anon_sym_switch] = ACTIONS(2093),
    [anon_sym_for] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(2091),
    [anon_sym_RPAREN] = ACTIONS(2091),
    [anon_sym_await] = ACTIONS(2093),
    [anon_sym_while] = ACTIONS(2093),
    [anon_sym_do] = ACTIONS(2093),
    [anon_sym_try] = ACTIONS(2093),
    [anon_sym_with] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2093),
    [anon_sym_continue] = ACTIONS(2093),
    [anon_sym_debugger] = ACTIONS(2093),
    [anon_sym_return] = ACTIONS(2093),
    [anon_sym_throw] = ACTIONS(2093),
    [anon_sym_SEMI] = ACTIONS(2091),
    [anon_sym_case] = ACTIONS(2093),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2091),
    [anon_sym_LTtemplate_GT] = ACTIONS(2091),
    [anon_sym_class] = ACTIONS(2093),
    [anon_sym_async] = ACTIONS(2093),
    [anon_sym_function] = ACTIONS(2093),
    [anon_sym_new] = ACTIONS(2093),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_SLASH] = ACTIONS(2093),
    [anon_sym_LT] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(2091),
    [anon_sym_void] = ACTIONS(2093),
    [anon_sym_delete] = ACTIONS(2093),
    [anon_sym_PLUS_PLUS] = ACTIONS(2091),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2091),
    [anon_sym_SQUOTE] = ACTIONS(2091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2091),
    [sym_number] = ACTIONS(2091),
    [sym_this] = ACTIONS(2093),
    [sym_super] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_null] = ACTIONS(2093),
    [sym_undefined] = ACTIONS(2093),
    [anon_sym_AT] = ACTIONS(2091),
    [anon_sym_static] = ACTIONS(2093),
    [anon_sym_readonly] = ACTIONS(2093),
    [anon_sym_get] = ACTIONS(2093),
    [anon_sym_set] = ACTIONS(2093),
    [anon_sym_declare] = ACTIONS(2093),
    [anon_sym_public] = ACTIONS(2093),
    [anon_sym_private] = ACTIONS(2093),
    [anon_sym_protected] = ACTIONS(2093),
    [anon_sym_override] = ACTIONS(2093),
    [anon_sym_module] = ACTIONS(2093),
    [anon_sym_any] = ACTIONS(2093),
    [anon_sym_number] = ACTIONS(2093),
    [anon_sym_boolean] = ACTIONS(2093),
    [anon_sym_string] = ACTIONS(2093),
    [anon_sym_symbol] = ACTIONS(2093),
    [anon_sym_abstract] = ACTIONS(2093),
    [anon_sym_interface] = ACTIONS(2093),
    [anon_sym_enum] = ACTIONS(2093),
  },
  [612] = {
    [sym__call_signature] = STATE(4028),
    [sym_formal_parameters] = STATE(2949),
    [sym_type_parameters] = STATE(3975),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_export] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(1995),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_get] = ACTIONS(1995),
    [anon_sym_set] = ACTIONS(1995),
    [anon_sym_declare] = ACTIONS(1995),
    [anon_sym_public] = ACTIONS(1995),
    [anon_sym_private] = ACTIONS(1995),
    [anon_sym_protected] = ACTIONS(1995),
    [anon_sym_override] = ACTIONS(1995),
    [anon_sym_module] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1995),
    [anon_sym_number] = ACTIONS(1995),
    [anon_sym_boolean] = ACTIONS(1995),
    [anon_sym_string] = ACTIONS(1995),
    [anon_sym_symbol] = ACTIONS(1995),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(1591),
    [sym_identifier] = ACTIONS(1593),
    [anon_sym_export] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(1593),
    [anon_sym_type] = ACTIONS(1593),
    [anon_sym_namespace] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1591),
    [anon_sym_RBRACE] = ACTIONS(1591),
    [anon_sym_typeof] = ACTIONS(1593),
    [anon_sym_import] = ACTIONS(1593),
    [anon_sym_var] = ACTIONS(1593),
    [anon_sym_let] = ACTIONS(1593),
    [anon_sym_const] = ACTIONS(1593),
    [anon_sym_BANG] = ACTIONS(1591),
    [anon_sym_else] = ACTIONS(1593),
    [anon_sym_if] = ACTIONS(1593),
    [anon_sym_switch] = ACTIONS(1593),
    [anon_sym_for] = ACTIONS(1593),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_while] = ACTIONS(1593),
    [anon_sym_do] = ACTIONS(1593),
    [anon_sym_try] = ACTIONS(1593),
    [anon_sym_with] = ACTIONS(1593),
    [anon_sym_break] = ACTIONS(1593),
    [anon_sym_continue] = ACTIONS(1593),
    [anon_sym_debugger] = ACTIONS(1593),
    [anon_sym_return] = ACTIONS(1593),
    [anon_sym_throw] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1591),
    [anon_sym_case] = ACTIONS(1593),
    [anon_sym_yield] = ACTIONS(1593),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_LTtemplate_GT] = ACTIONS(1591),
    [anon_sym_class] = ACTIONS(1593),
    [anon_sym_async] = ACTIONS(1593),
    [anon_sym_function] = ACTIONS(1593),
    [anon_sym_new] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_DASH] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(1593),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1591),
    [anon_sym_void] = ACTIONS(1593),
    [anon_sym_delete] = ACTIONS(1593),
    [anon_sym_PLUS_PLUS] = ACTIONS(1591),
    [anon_sym_DASH_DASH] = ACTIONS(1593),
    [anon_sym_DQUOTE] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(1591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1591),
    [sym_number] = ACTIONS(1591),
    [sym_this] = ACTIONS(1593),
    [sym_super] = ACTIONS(1593),
    [sym_true] = ACTIONS(1593),
    [sym_false] = ACTIONS(1593),
    [sym_null] = ACTIONS(1593),
    [sym_undefined] = ACTIONS(1593),
    [anon_sym_AT] = ACTIONS(1591),
    [anon_sym_static] = ACTIONS(1593),
    [anon_sym_readonly] = ACTIONS(1593),
    [anon_sym_get] = ACTIONS(1593),
    [anon_sym_set] = ACTIONS(1593),
    [anon_sym_declare] = ACTIONS(1593),
    [anon_sym_public] = ACTIONS(1593),
    [anon_sym_private] = ACTIONS(1593),
    [anon_sym_protected] = ACTIONS(1593),
    [anon_sym_override] = ACTIONS(1593),
    [anon_sym_module] = ACTIONS(1593),
    [anon_sym_any] = ACTIONS(1593),
    [anon_sym_number] = ACTIONS(1593),
    [anon_sym_boolean] = ACTIONS(1593),
    [anon_sym_string] = ACTIONS(1593),
    [anon_sym_symbol] = ACTIONS(1593),
    [anon_sym_abstract] = ACTIONS(1593),
    [anon_sym_interface] = ACTIONS(1593),
    [anon_sym_enum] = ACTIONS(1593),
    [sym__automatic_semicolon] = ACTIONS(1599),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(1501),
    [sym_identifier] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(1503),
    [anon_sym_type] = ACTIONS(1503),
    [anon_sym_namespace] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1501),
    [anon_sym_RBRACE] = ACTIONS(1501),
    [anon_sym_typeof] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_var] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_BANG] = ACTIONS(1501),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_switch] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_with] = ACTIONS(1503),
    [anon_sym_break] = ACTIONS(1503),
    [anon_sym_continue] = ACTIONS(1503),
    [anon_sym_debugger] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1501),
    [anon_sym_case] = ACTIONS(1503),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LTtemplate_GT] = ACTIONS(1501),
    [anon_sym_DOT] = ACTIONS(1503),
    [anon_sym_class] = ACTIONS(1503),
    [anon_sym_async] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_new] = ACTIONS(1503),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_DASH] = ACTIONS(1503),
    [anon_sym_SLASH] = ACTIONS(1503),
    [anon_sym_LT] = ACTIONS(1503),
    [anon_sym_TILDE] = ACTIONS(1501),
    [anon_sym_void] = ACTIONS(1503),
    [anon_sym_delete] = ACTIONS(1503),
    [anon_sym_PLUS_PLUS] = ACTIONS(1501),
    [anon_sym_DASH_DASH] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1501),
    [anon_sym_SQUOTE] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1501),
    [sym_number] = ACTIONS(1501),
    [sym_this] = ACTIONS(1503),
    [sym_super] = ACTIONS(1503),
    [sym_true] = ACTIONS(1503),
    [sym_false] = ACTIONS(1503),
    [sym_null] = ACTIONS(1503),
    [sym_undefined] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1501),
    [anon_sym_static] = ACTIONS(1503),
    [anon_sym_readonly] = ACTIONS(1503),
    [anon_sym_get] = ACTIONS(1503),
    [anon_sym_set] = ACTIONS(1503),
    [anon_sym_declare] = ACTIONS(1503),
    [anon_sym_public] = ACTIONS(1503),
    [anon_sym_private] = ACTIONS(1503),
    [anon_sym_protected] = ACTIONS(1503),
    [anon_sym_override] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_any] = ACTIONS(1503),
    [anon_sym_number] = ACTIONS(1503),
    [anon_sym_boolean] = ACTIONS(1503),
    [anon_sym_string] = ACTIONS(1503),
    [anon_sym_symbol] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_interface] = ACTIONS(1503),
    [anon_sym_enum] = ACTIONS(1503),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(1427),
    [sym_identifier] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1429),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_type] = ACTIONS(1429),
    [anon_sym_namespace] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_RBRACE] = ACTIONS(1427),
    [anon_sym_typeof] = ACTIONS(1429),
    [anon_sym_import] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1429),
    [anon_sym_let] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_else] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_await] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_try] = ACTIONS(1429),
    [anon_sym_with] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_continue] = ACTIONS(1429),
    [anon_sym_debugger] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LTtemplate_GT] = ACTIONS(1427),
    [anon_sym_class] = ACTIONS(1429),
    [anon_sym_async] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1429),
    [anon_sym_new] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_DASH] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1427),
    [anon_sym_void] = ACTIONS(1429),
    [anon_sym_delete] = ACTIONS(1429),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1429),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1427),
    [sym_number] = ACTIONS(1427),
    [sym_this] = ACTIONS(1429),
    [sym_super] = ACTIONS(1429),
    [sym_true] = ACTIONS(1429),
    [sym_false] = ACTIONS(1429),
    [sym_null] = ACTIONS(1429),
    [sym_undefined] = ACTIONS(1429),
    [anon_sym_AT] = ACTIONS(1427),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_readonly] = ACTIONS(1429),
    [anon_sym_get] = ACTIONS(1429),
    [anon_sym_set] = ACTIONS(1429),
    [anon_sym_declare] = ACTIONS(1429),
    [anon_sym_public] = ACTIONS(1429),
    [anon_sym_private] = ACTIONS(1429),
    [anon_sym_protected] = ACTIONS(1429),
    [anon_sym_override] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1429),
    [anon_sym_any] = ACTIONS(1429),
    [anon_sym_number] = ACTIONS(1429),
    [anon_sym_boolean] = ACTIONS(1429),
    [anon_sym_string] = ACTIONS(1429),
    [anon_sym_symbol] = ACTIONS(1429),
    [anon_sym_abstract] = ACTIONS(1429),
    [anon_sym_interface] = ACTIONS(1429),
    [anon_sym_enum] = ACTIONS(1429),
    [sym__automatic_semicolon] = ACTIONS(1435),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1553),
    [anon_sym_export] = ACTIONS(1553),
    [anon_sym_default] = ACTIONS(1553),
    [anon_sym_type] = ACTIONS(1553),
    [anon_sym_namespace] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_RBRACE] = ACTIONS(1551),
    [anon_sym_typeof] = ACTIONS(1553),
    [anon_sym_import] = ACTIONS(1553),
    [anon_sym_var] = ACTIONS(1553),
    [anon_sym_let] = ACTIONS(1553),
    [anon_sym_const] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_else] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_switch] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_await] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_do] = ACTIONS(1553),
    [anon_sym_try] = ACTIONS(1553),
    [anon_sym_with] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_continue] = ACTIONS(1553),
    [anon_sym_debugger] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_throw] = ACTIONS(1553),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(1551),
    [anon_sym_LTtemplate_GT] = ACTIONS(1551),
    [anon_sym_class] = ACTIONS(1553),
    [anon_sym_async] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1553),
    [anon_sym_new] = ACTIONS(1553),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_void] = ACTIONS(1553),
    [anon_sym_delete] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1551),
    [sym_number] = ACTIONS(1551),
    [sym_this] = ACTIONS(1553),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [sym_null] = ACTIONS(1553),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1551),
    [anon_sym_static] = ACTIONS(1553),
    [anon_sym_readonly] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(1553),
    [anon_sym_set] = ACTIONS(1553),
    [anon_sym_declare] = ACTIONS(1553),
    [anon_sym_public] = ACTIONS(1553),
    [anon_sym_private] = ACTIONS(1553),
    [anon_sym_protected] = ACTIONS(1553),
    [anon_sym_override] = ACTIONS(1553),
    [anon_sym_module] = ACTIONS(1553),
    [anon_sym_any] = ACTIONS(1553),
    [anon_sym_number] = ACTIONS(1553),
    [anon_sym_boolean] = ACTIONS(1553),
    [anon_sym_string] = ACTIONS(1553),
    [anon_sym_symbol] = ACTIONS(1553),
    [anon_sym_abstract] = ACTIONS(1553),
    [anon_sym_interface] = ACTIONS(1553),
    [anon_sym_enum] = ACTIONS(1553),
    [sym__automatic_semicolon] = ACTIONS(1559),
  },
  [617] = {
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_export] = ACTIONS(2097),
    [anon_sym_default] = ACTIONS(2097),
    [anon_sym_type] = ACTIONS(2097),
    [anon_sym_namespace] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(2095),
    [anon_sym_RBRACE] = ACTIONS(2095),
    [anon_sym_typeof] = ACTIONS(2097),
    [anon_sym_import] = ACTIONS(2097),
    [anon_sym_var] = ACTIONS(2097),
    [anon_sym_let] = ACTIONS(2097),
    [anon_sym_const] = ACTIONS(2097),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_else] = ACTIONS(2097),
    [anon_sym_if] = ACTIONS(2097),
    [anon_sym_switch] = ACTIONS(2097),
    [anon_sym_for] = ACTIONS(2097),
    [anon_sym_LPAREN] = ACTIONS(2095),
    [anon_sym_await] = ACTIONS(2097),
    [anon_sym_while] = ACTIONS(2097),
    [anon_sym_do] = ACTIONS(2097),
    [anon_sym_try] = ACTIONS(2097),
    [anon_sym_with] = ACTIONS(2097),
    [anon_sym_break] = ACTIONS(2097),
    [anon_sym_continue] = ACTIONS(2097),
    [anon_sym_debugger] = ACTIONS(2097),
    [anon_sym_return] = ACTIONS(2097),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(2095),
    [anon_sym_case] = ACTIONS(2097),
    [anon_sym_finally] = ACTIONS(2097),
    [anon_sym_yield] = ACTIONS(2097),
    [anon_sym_LBRACK] = ACTIONS(2095),
    [anon_sym_LTtemplate_GT] = ACTIONS(2095),
    [anon_sym_class] = ACTIONS(2097),
    [anon_sym_async] = ACTIONS(2097),
    [anon_sym_function] = ACTIONS(2097),
    [anon_sym_new] = ACTIONS(2097),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(2097),
    [anon_sym_SLASH] = ACTIONS(2097),
    [anon_sym_LT] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_void] = ACTIONS(2097),
    [anon_sym_delete] = ACTIONS(2097),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2097),
    [anon_sym_DQUOTE] = ACTIONS(2095),
    [anon_sym_SQUOTE] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2095),
    [sym_number] = ACTIONS(2095),
    [sym_this] = ACTIONS(2097),
    [sym_super] = ACTIONS(2097),
    [sym_true] = ACTIONS(2097),
    [sym_false] = ACTIONS(2097),
    [sym_null] = ACTIONS(2097),
    [sym_undefined] = ACTIONS(2097),
    [anon_sym_AT] = ACTIONS(2095),
    [anon_sym_static] = ACTIONS(2097),
    [anon_sym_readonly] = ACTIONS(2097),
    [anon_sym_get] = ACTIONS(2097),
    [anon_sym_set] = ACTIONS(2097),
    [anon_sym_declare] = ACTIONS(2097),
    [anon_sym_public] = ACTIONS(2097),
    [anon_sym_private] = ACTIONS(2097),
    [anon_sym_protected] = ACTIONS(2097),
    [anon_sym_override] = ACTIONS(2097),
    [anon_sym_module] = ACTIONS(2097),
    [anon_sym_any] = ACTIONS(2097),
    [anon_sym_number] = ACTIONS(2097),
    [anon_sym_boolean] = ACTIONS(2097),
    [anon_sym_string] = ACTIONS(2097),
    [anon_sym_symbol] = ACTIONS(2097),
    [anon_sym_abstract] = ACTIONS(2097),
    [anon_sym_interface] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2097),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1465),
    [anon_sym_export] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(1465),
    [anon_sym_type] = ACTIONS(1465),
    [anon_sym_namespace] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1463),
    [anon_sym_typeof] = ACTIONS(1465),
    [anon_sym_import] = ACTIONS(1465),
    [anon_sym_var] = ACTIONS(1465),
    [anon_sym_let] = ACTIONS(1465),
    [anon_sym_const] = ACTIONS(1465),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_else] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_switch] = ACTIONS(1465),
    [anon_sym_for] = ACTIONS(1465),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_try] = ACTIONS(1465),
    [anon_sym_with] = ACTIONS(1465),
    [anon_sym_break] = ACTIONS(1465),
    [anon_sym_continue] = ACTIONS(1465),
    [anon_sym_debugger] = ACTIONS(1465),
    [anon_sym_return] = ACTIONS(1465),
    [anon_sym_throw] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_case] = ACTIONS(1465),
    [anon_sym_yield] = ACTIONS(1465),
    [anon_sym_LBRACK] = ACTIONS(1463),
    [anon_sym_LTtemplate_GT] = ACTIONS(1463),
    [anon_sym_class] = ACTIONS(1465),
    [anon_sym_async] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_PLUS] = ACTIONS(1465),
    [anon_sym_DASH] = ACTIONS(1465),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1465),
    [anon_sym_TILDE] = ACTIONS(1463),
    [anon_sym_void] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(1465),
    [anon_sym_PLUS_PLUS] = ACTIONS(1463),
    [anon_sym_DASH_DASH] = ACTIONS(1465),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [sym_number] = ACTIONS(1463),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(1465),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_undefined] = ACTIONS(1465),
    [anon_sym_AT] = ACTIONS(1463),
    [anon_sym_static] = ACTIONS(1465),
    [anon_sym_readonly] = ACTIONS(1465),
    [anon_sym_get] = ACTIONS(1465),
    [anon_sym_set] = ACTIONS(1465),
    [anon_sym_declare] = ACTIONS(1465),
    [anon_sym_public] = ACTIONS(1465),
    [anon_sym_private] = ACTIONS(1465),
    [anon_sym_protected] = ACTIONS(1465),
    [anon_sym_override] = ACTIONS(1465),
    [anon_sym_module] = ACTIONS(1465),
    [anon_sym_any] = ACTIONS(1465),
    [anon_sym_number] = ACTIONS(1465),
    [anon_sym_boolean] = ACTIONS(1465),
    [anon_sym_string] = ACTIONS(1465),
    [anon_sym_symbol] = ACTIONS(1465),
    [anon_sym_abstract] = ACTIONS(1465),
    [anon_sym_interface] = ACTIONS(1465),
    [anon_sym_enum] = ACTIONS(1465),
    [sym__automatic_semicolon] = ACTIONS(1471),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(2099),
    [sym_identifier] = ACTIONS(2101),
    [anon_sym_export] = ACTIONS(2101),
    [anon_sym_default] = ACTIONS(2101),
    [anon_sym_type] = ACTIONS(2101),
    [anon_sym_namespace] = ACTIONS(2101),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_RBRACE] = ACTIONS(2099),
    [anon_sym_typeof] = ACTIONS(2101),
    [anon_sym_import] = ACTIONS(2101),
    [anon_sym_var] = ACTIONS(2101),
    [anon_sym_let] = ACTIONS(2101),
    [anon_sym_const] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2099),
    [anon_sym_else] = ACTIONS(2101),
    [anon_sym_if] = ACTIONS(2101),
    [anon_sym_switch] = ACTIONS(2101),
    [anon_sym_for] = ACTIONS(2101),
    [anon_sym_LPAREN] = ACTIONS(2099),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [anon_sym_await] = ACTIONS(2101),
    [anon_sym_while] = ACTIONS(2101),
    [anon_sym_do] = ACTIONS(2101),
    [anon_sym_try] = ACTIONS(2101),
    [anon_sym_with] = ACTIONS(2101),
    [anon_sym_break] = ACTIONS(2101),
    [anon_sym_continue] = ACTIONS(2101),
    [anon_sym_debugger] = ACTIONS(2101),
    [anon_sym_return] = ACTIONS(2101),
    [anon_sym_throw] = ACTIONS(2101),
    [anon_sym_SEMI] = ACTIONS(2099),
    [anon_sym_case] = ACTIONS(2101),
    [anon_sym_yield] = ACTIONS(2101),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_LTtemplate_GT] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_async] = ACTIONS(2101),
    [anon_sym_function] = ACTIONS(2101),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2099),
    [anon_sym_void] = ACTIONS(2101),
    [anon_sym_delete] = ACTIONS(2101),
    [anon_sym_PLUS_PLUS] = ACTIONS(2099),
    [anon_sym_DASH_DASH] = ACTIONS(2101),
    [anon_sym_DQUOTE] = ACTIONS(2099),
    [anon_sym_SQUOTE] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2099),
    [sym_number] = ACTIONS(2099),
    [sym_this] = ACTIONS(2101),
    [sym_super] = ACTIONS(2101),
    [sym_true] = ACTIONS(2101),
    [sym_false] = ACTIONS(2101),
    [sym_null] = ACTIONS(2101),
    [sym_undefined] = ACTIONS(2101),
    [anon_sym_AT] = ACTIONS(2099),
    [anon_sym_static] = ACTIONS(2101),
    [anon_sym_readonly] = ACTIONS(2101),
    [anon_sym_get] = ACTIONS(2101),
    [anon_sym_set] = ACTIONS(2101),
    [anon_sym_declare] = ACTIONS(2101),
    [anon_sym_public] = ACTIONS(2101),
    [anon_sym_private] = ACTIONS(2101),
    [anon_sym_protected] = ACTIONS(2101),
    [anon_sym_override] = ACTIONS(2101),
    [anon_sym_module] = ACTIONS(2101),
    [anon_sym_any] = ACTIONS(2101),
    [anon_sym_number] = ACTIONS(2101),
    [anon_sym_boolean] = ACTIONS(2101),
    [anon_sym_string] = ACTIONS(2101),
    [anon_sym_symbol] = ACTIONS(2101),
    [anon_sym_abstract] = ACTIONS(2101),
    [anon_sym_interface] = ACTIONS(2101),
    [anon_sym_enum] = ACTIONS(2101),
  },
  [620] = {
    [ts_builtin_sym_end] = ACTIONS(1485),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_RBRACE] = ACTIONS(1485),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_import] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_let] = ACTIONS(1487),
    [anon_sym_const] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1485),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_await] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_try] = ACTIONS(1487),
    [anon_sym_with] = ACTIONS(1487),
    [anon_sym_break] = ACTIONS(1487),
    [anon_sym_continue] = ACTIONS(1487),
    [anon_sym_debugger] = ACTIONS(1487),
    [anon_sym_return] = ACTIONS(1487),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_case] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [anon_sym_LTtemplate_GT] = ACTIONS(1485),
    [anon_sym_class] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_new] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1485),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_DASH_DASH] = ACTIONS(1487),
    [anon_sym_DQUOTE] = ACTIONS(1485),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1485),
    [sym_number] = ACTIONS(1485),
    [sym_this] = ACTIONS(1487),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_readonly] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_override] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_interface] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
    [sym__automatic_semicolon] = ACTIONS(1493),
  },
  [621] = {
    [sym_statement_block] = STATE(661),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(1381),
    [anon_sym_default] = ACTIONS(1381),
    [anon_sym_type] = ACTIONS(1381),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(2063),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_typeof] = ACTIONS(1381),
    [anon_sym_import] = ACTIONS(1381),
    [anon_sym_var] = ACTIONS(1381),
    [anon_sym_let] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(1379),
    [anon_sym_await] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_try] = ACTIONS(1381),
    [anon_sym_with] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_debugger] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_throw] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_case] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_LTtemplate_GT] = ACTIONS(1379),
    [anon_sym_class] = ACTIONS(1381),
    [anon_sym_async] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_void] = ACTIONS(1381),
    [anon_sym_delete] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_number] = ACTIONS(1379),
    [sym_this] = ACTIONS(1381),
    [sym_super] = ACTIONS(1381),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [sym_null] = ACTIONS(1381),
    [sym_undefined] = ACTIONS(1381),
    [anon_sym_AT] = ACTIONS(1379),
    [anon_sym_static] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(1381),
    [anon_sym_get] = ACTIONS(1381),
    [anon_sym_set] = ACTIONS(1381),
    [anon_sym_declare] = ACTIONS(1381),
    [anon_sym_public] = ACTIONS(1381),
    [anon_sym_private] = ACTIONS(1381),
    [anon_sym_protected] = ACTIONS(1381),
    [anon_sym_override] = ACTIONS(1381),
    [anon_sym_module] = ACTIONS(1381),
    [anon_sym_any] = ACTIONS(1381),
    [anon_sym_number] = ACTIONS(1381),
    [anon_sym_boolean] = ACTIONS(1381),
    [anon_sym_string] = ACTIONS(1381),
    [anon_sym_symbol] = ACTIONS(1381),
    [anon_sym_abstract] = ACTIONS(1381),
    [anon_sym_interface] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
  },
  [622] = {
    [ts_builtin_sym_end] = ACTIONS(1541),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_default] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1541),
    [anon_sym_RBRACE] = ACTIONS(1541),
    [anon_sym_typeof] = ACTIONS(1543),
    [anon_sym_import] = ACTIONS(1543),
    [anon_sym_var] = ACTIONS(1543),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_const] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_else] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_switch] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_LPAREN] = ACTIONS(1541),
    [anon_sym_await] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_do] = ACTIONS(1543),
    [anon_sym_try] = ACTIONS(1543),
    [anon_sym_with] = ACTIONS(1543),
    [anon_sym_break] = ACTIONS(1543),
    [anon_sym_continue] = ACTIONS(1543),
    [anon_sym_debugger] = ACTIONS(1543),
    [anon_sym_return] = ACTIONS(1543),
    [anon_sym_throw] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1541),
    [anon_sym_case] = ACTIONS(1543),
    [anon_sym_yield] = ACTIONS(1543),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [anon_sym_LTtemplate_GT] = ACTIONS(1541),
    [anon_sym_class] = ACTIONS(1543),
    [anon_sym_async] = ACTIONS(1543),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1543),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_void] = ACTIONS(1543),
    [anon_sym_delete] = ACTIONS(1543),
    [anon_sym_PLUS_PLUS] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1541),
    [sym_number] = ACTIONS(1541),
    [sym_this] = ACTIONS(1543),
    [sym_super] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_undefined] = ACTIONS(1543),
    [anon_sym_AT] = ACTIONS(1541),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_abstract] = ACTIONS(1543),
    [anon_sym_interface] = ACTIONS(1543),
    [anon_sym_enum] = ACTIONS(1543),
    [sym__automatic_semicolon] = ACTIONS(1549),
  },
  [623] = {
    [ts_builtin_sym_end] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2105),
    [anon_sym_export] = ACTIONS(2105),
    [anon_sym_default] = ACTIONS(2105),
    [anon_sym_type] = ACTIONS(2105),
    [anon_sym_namespace] = ACTIONS(2105),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_typeof] = ACTIONS(2105),
    [anon_sym_import] = ACTIONS(2105),
    [anon_sym_var] = ACTIONS(2105),
    [anon_sym_let] = ACTIONS(2105),
    [anon_sym_const] = ACTIONS(2105),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_else] = ACTIONS(2105),
    [anon_sym_if] = ACTIONS(2105),
    [anon_sym_switch] = ACTIONS(2105),
    [anon_sym_for] = ACTIONS(2105),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_await] = ACTIONS(2105),
    [anon_sym_while] = ACTIONS(2105),
    [anon_sym_do] = ACTIONS(2105),
    [anon_sym_try] = ACTIONS(2105),
    [anon_sym_with] = ACTIONS(2105),
    [anon_sym_break] = ACTIONS(2105),
    [anon_sym_continue] = ACTIONS(2105),
    [anon_sym_debugger] = ACTIONS(2105),
    [anon_sym_return] = ACTIONS(2105),
    [anon_sym_throw] = ACTIONS(2105),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_case] = ACTIONS(2105),
    [anon_sym_yield] = ACTIONS(2105),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LTtemplate_GT] = ACTIONS(2103),
    [anon_sym_class] = ACTIONS(2105),
    [anon_sym_async] = ACTIONS(2105),
    [anon_sym_function] = ACTIONS(2105),
    [anon_sym_new] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2105),
    [anon_sym_DASH] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2103),
    [anon_sym_void] = ACTIONS(2105),
    [anon_sym_delete] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2103),
    [anon_sym_SQUOTE] = ACTIONS(2103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2103),
    [sym_number] = ACTIONS(2103),
    [sym_this] = ACTIONS(2105),
    [sym_super] = ACTIONS(2105),
    [sym_true] = ACTIONS(2105),
    [sym_false] = ACTIONS(2105),
    [sym_null] = ACTIONS(2105),
    [sym_undefined] = ACTIONS(2105),
    [anon_sym_AT] = ACTIONS(2103),
    [anon_sym_static] = ACTIONS(2105),
    [anon_sym_readonly] = ACTIONS(2105),
    [anon_sym_get] = ACTIONS(2105),
    [anon_sym_set] = ACTIONS(2105),
    [anon_sym_declare] = ACTIONS(2105),
    [anon_sym_public] = ACTIONS(2105),
    [anon_sym_private] = ACTIONS(2105),
    [anon_sym_protected] = ACTIONS(2105),
    [anon_sym_override] = ACTIONS(2105),
    [anon_sym_module] = ACTIONS(2105),
    [anon_sym_any] = ACTIONS(2105),
    [anon_sym_number] = ACTIONS(2105),
    [anon_sym_boolean] = ACTIONS(2105),
    [anon_sym_string] = ACTIONS(2105),
    [anon_sym_symbol] = ACTIONS(2105),
    [anon_sym_abstract] = ACTIONS(2105),
    [anon_sym_interface] = ACTIONS(2105),
    [anon_sym_enum] = ACTIONS(2105),
  },
  [624] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [625] = {
    [ts_builtin_sym_end] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_export] = ACTIONS(2113),
    [anon_sym_default] = ACTIONS(2113),
    [anon_sym_type] = ACTIONS(2113),
    [anon_sym_namespace] = ACTIONS(2113),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2113),
    [anon_sym_import] = ACTIONS(2113),
    [anon_sym_var] = ACTIONS(2113),
    [anon_sym_let] = ACTIONS(2113),
    [anon_sym_const] = ACTIONS(2113),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2113),
    [anon_sym_if] = ACTIONS(2113),
    [anon_sym_switch] = ACTIONS(2113),
    [anon_sym_for] = ACTIONS(2113),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2113),
    [anon_sym_while] = ACTIONS(2113),
    [anon_sym_do] = ACTIONS(2113),
    [anon_sym_try] = ACTIONS(2113),
    [anon_sym_with] = ACTIONS(2113),
    [anon_sym_break] = ACTIONS(2113),
    [anon_sym_continue] = ACTIONS(2113),
    [anon_sym_debugger] = ACTIONS(2113),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_throw] = ACTIONS(2113),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2113),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2113),
    [anon_sym_async] = ACTIONS(2113),
    [anon_sym_function] = ACTIONS(2113),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_PLUS] = ACTIONS(2113),
    [anon_sym_DASH] = ACTIONS(2113),
    [anon_sym_SLASH] = ACTIONS(2113),
    [anon_sym_LT] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2113),
    [anon_sym_delete] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_this] = ACTIONS(2113),
    [sym_super] = ACTIONS(2113),
    [sym_true] = ACTIONS(2113),
    [sym_false] = ACTIONS(2113),
    [sym_null] = ACTIONS(2113),
    [sym_undefined] = ACTIONS(2113),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2113),
    [anon_sym_readonly] = ACTIONS(2113),
    [anon_sym_get] = ACTIONS(2113),
    [anon_sym_set] = ACTIONS(2113),
    [anon_sym_declare] = ACTIONS(2113),
    [anon_sym_public] = ACTIONS(2113),
    [anon_sym_private] = ACTIONS(2113),
    [anon_sym_protected] = ACTIONS(2113),
    [anon_sym_override] = ACTIONS(2113),
    [anon_sym_module] = ACTIONS(2113),
    [anon_sym_any] = ACTIONS(2113),
    [anon_sym_number] = ACTIONS(2113),
    [anon_sym_boolean] = ACTIONS(2113),
    [anon_sym_string] = ACTIONS(2113),
    [anon_sym_symbol] = ACTIONS(2113),
    [anon_sym_abstract] = ACTIONS(2113),
    [anon_sym_interface] = ACTIONS(2113),
    [anon_sym_enum] = ACTIONS(2113),
  },
  [626] = {
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2117),
    [anon_sym_export] = ACTIONS(2117),
    [anon_sym_default] = ACTIONS(2117),
    [anon_sym_type] = ACTIONS(2117),
    [anon_sym_namespace] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(2115),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [anon_sym_typeof] = ACTIONS(2117),
    [anon_sym_import] = ACTIONS(2117),
    [anon_sym_var] = ACTIONS(2117),
    [anon_sym_let] = ACTIONS(2117),
    [anon_sym_const] = ACTIONS(2117),
    [anon_sym_BANG] = ACTIONS(2115),
    [anon_sym_else] = ACTIONS(2117),
    [anon_sym_if] = ACTIONS(2117),
    [anon_sym_switch] = ACTIONS(2117),
    [anon_sym_for] = ACTIONS(2117),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_while] = ACTIONS(2117),
    [anon_sym_do] = ACTIONS(2117),
    [anon_sym_try] = ACTIONS(2117),
    [anon_sym_with] = ACTIONS(2117),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_continue] = ACTIONS(2117),
    [anon_sym_debugger] = ACTIONS(2117),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_throw] = ACTIONS(2117),
    [anon_sym_SEMI] = ACTIONS(2115),
    [anon_sym_case] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_LTtemplate_GT] = ACTIONS(2115),
    [anon_sym_class] = ACTIONS(2117),
    [anon_sym_async] = ACTIONS(2117),
    [anon_sym_function] = ACTIONS(2117),
    [anon_sym_new] = ACTIONS(2117),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_SLASH] = ACTIONS(2117),
    [anon_sym_LT] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2115),
    [anon_sym_void] = ACTIONS(2117),
    [anon_sym_delete] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2115),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_DQUOTE] = ACTIONS(2115),
    [anon_sym_SQUOTE] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2115),
    [sym_number] = ACTIONS(2115),
    [sym_this] = ACTIONS(2117),
    [sym_super] = ACTIONS(2117),
    [sym_true] = ACTIONS(2117),
    [sym_false] = ACTIONS(2117),
    [sym_null] = ACTIONS(2117),
    [sym_undefined] = ACTIONS(2117),
    [anon_sym_AT] = ACTIONS(2115),
    [anon_sym_static] = ACTIONS(2117),
    [anon_sym_readonly] = ACTIONS(2117),
    [anon_sym_get] = ACTIONS(2117),
    [anon_sym_set] = ACTIONS(2117),
    [anon_sym_declare] = ACTIONS(2117),
    [anon_sym_public] = ACTIONS(2117),
    [anon_sym_private] = ACTIONS(2117),
    [anon_sym_protected] = ACTIONS(2117),
    [anon_sym_override] = ACTIONS(2117),
    [anon_sym_module] = ACTIONS(2117),
    [anon_sym_any] = ACTIONS(2117),
    [anon_sym_number] = ACTIONS(2117),
    [anon_sym_boolean] = ACTIONS(2117),
    [anon_sym_string] = ACTIONS(2117),
    [anon_sym_symbol] = ACTIONS(2117),
    [anon_sym_abstract] = ACTIONS(2117),
    [anon_sym_interface] = ACTIONS(2117),
    [anon_sym_enum] = ACTIONS(2117),
  },
  [627] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [628] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [629] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [630] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [631] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [632] = {
    [ts_builtin_sym_end] = ACTIONS(2127),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_default] = ACTIONS(2129),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2127),
    [anon_sym_RBRACE] = ACTIONS(2127),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_else] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2127),
    [anon_sym_case] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2127),
    [anon_sym_LTtemplate_GT] = ACTIONS(2127),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2127),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2127),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_DQUOTE] = ACTIONS(2127),
    [anon_sym_SQUOTE] = ACTIONS(2127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2127),
    [sym_number] = ACTIONS(2127),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2127),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
  },
  [633] = {
    [ts_builtin_sym_end] = ACTIONS(2127),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_default] = ACTIONS(2129),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2127),
    [anon_sym_RBRACE] = ACTIONS(2127),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_else] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2127),
    [anon_sym_case] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2127),
    [anon_sym_LTtemplate_GT] = ACTIONS(2127),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2127),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2127),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_DQUOTE] = ACTIONS(2127),
    [anon_sym_SQUOTE] = ACTIONS(2127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2127),
    [sym_number] = ACTIONS(2127),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2127),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(2131),
    [sym_identifier] = ACTIONS(2133),
    [anon_sym_export] = ACTIONS(2133),
    [anon_sym_default] = ACTIONS(2133),
    [anon_sym_type] = ACTIONS(2133),
    [anon_sym_namespace] = ACTIONS(2133),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_typeof] = ACTIONS(2133),
    [anon_sym_import] = ACTIONS(2133),
    [anon_sym_var] = ACTIONS(2133),
    [anon_sym_let] = ACTIONS(2133),
    [anon_sym_const] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_else] = ACTIONS(2133),
    [anon_sym_if] = ACTIONS(2133),
    [anon_sym_switch] = ACTIONS(2133),
    [anon_sym_for] = ACTIONS(2133),
    [anon_sym_LPAREN] = ACTIONS(2131),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_while] = ACTIONS(2133),
    [anon_sym_do] = ACTIONS(2133),
    [anon_sym_try] = ACTIONS(2133),
    [anon_sym_with] = ACTIONS(2133),
    [anon_sym_break] = ACTIONS(2133),
    [anon_sym_continue] = ACTIONS(2133),
    [anon_sym_debugger] = ACTIONS(2133),
    [anon_sym_return] = ACTIONS(2133),
    [anon_sym_throw] = ACTIONS(2133),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_case] = ACTIONS(2133),
    [anon_sym_yield] = ACTIONS(2133),
    [anon_sym_LBRACK] = ACTIONS(2131),
    [anon_sym_LTtemplate_GT] = ACTIONS(2131),
    [anon_sym_class] = ACTIONS(2133),
    [anon_sym_async] = ACTIONS(2133),
    [anon_sym_function] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2133),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_SLASH] = ACTIONS(2133),
    [anon_sym_LT] = ACTIONS(2133),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_void] = ACTIONS(2133),
    [anon_sym_delete] = ACTIONS(2133),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_number] = ACTIONS(2131),
    [sym_this] = ACTIONS(2133),
    [sym_super] = ACTIONS(2133),
    [sym_true] = ACTIONS(2133),
    [sym_false] = ACTIONS(2133),
    [sym_null] = ACTIONS(2133),
    [sym_undefined] = ACTIONS(2133),
    [anon_sym_AT] = ACTIONS(2131),
    [anon_sym_static] = ACTIONS(2133),
    [anon_sym_readonly] = ACTIONS(2133),
    [anon_sym_get] = ACTIONS(2133),
    [anon_sym_set] = ACTIONS(2133),
    [anon_sym_declare] = ACTIONS(2133),
    [anon_sym_public] = ACTIONS(2133),
    [anon_sym_private] = ACTIONS(2133),
    [anon_sym_protected] = ACTIONS(2133),
    [anon_sym_override] = ACTIONS(2133),
    [anon_sym_module] = ACTIONS(2133),
    [anon_sym_any] = ACTIONS(2133),
    [anon_sym_number] = ACTIONS(2133),
    [anon_sym_boolean] = ACTIONS(2133),
    [anon_sym_string] = ACTIONS(2133),
    [anon_sym_symbol] = ACTIONS(2133),
    [anon_sym_abstract] = ACTIONS(2133),
    [anon_sym_interface] = ACTIONS(2133),
    [anon_sym_enum] = ACTIONS(2133),
  },
  [635] = {
    [ts_builtin_sym_end] = ACTIONS(2135),
    [sym_identifier] = ACTIONS(2137),
    [anon_sym_export] = ACTIONS(2137),
    [anon_sym_default] = ACTIONS(2137),
    [anon_sym_type] = ACTIONS(2137),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_LBRACE] = ACTIONS(2135),
    [anon_sym_RBRACE] = ACTIONS(2135),
    [anon_sym_typeof] = ACTIONS(2137),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2137),
    [anon_sym_let] = ACTIONS(2137),
    [anon_sym_const] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_else] = ACTIONS(2137),
    [anon_sym_if] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2137),
    [anon_sym_for] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2135),
    [anon_sym_await] = ACTIONS(2137),
    [anon_sym_while] = ACTIONS(2137),
    [anon_sym_do] = ACTIONS(2137),
    [anon_sym_try] = ACTIONS(2137),
    [anon_sym_with] = ACTIONS(2137),
    [anon_sym_break] = ACTIONS(2137),
    [anon_sym_continue] = ACTIONS(2137),
    [anon_sym_debugger] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2137),
    [anon_sym_throw] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym_case] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2135),
    [anon_sym_LTtemplate_GT] = ACTIONS(2135),
    [anon_sym_class] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(2137),
    [anon_sym_new] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(2137),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_void] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2135),
    [sym_number] = ACTIONS(2135),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(2137),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(2135),
    [anon_sym_static] = ACTIONS(2137),
    [anon_sym_readonly] = ACTIONS(2137),
    [anon_sym_get] = ACTIONS(2137),
    [anon_sym_set] = ACTIONS(2137),
    [anon_sym_declare] = ACTIONS(2137),
    [anon_sym_public] = ACTIONS(2137),
    [anon_sym_private] = ACTIONS(2137),
    [anon_sym_protected] = ACTIONS(2137),
    [anon_sym_override] = ACTIONS(2137),
    [anon_sym_module] = ACTIONS(2137),
    [anon_sym_any] = ACTIONS(2137),
    [anon_sym_number] = ACTIONS(2137),
    [anon_sym_boolean] = ACTIONS(2137),
    [anon_sym_string] = ACTIONS(2137),
    [anon_sym_symbol] = ACTIONS(2137),
    [anon_sym_abstract] = ACTIONS(2137),
    [anon_sym_interface] = ACTIONS(2137),
    [anon_sym_enum] = ACTIONS(2137),
  },
  [636] = {
    [ts_builtin_sym_end] = ACTIONS(2139),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_export] = ACTIONS(2141),
    [anon_sym_default] = ACTIONS(2141),
    [anon_sym_type] = ACTIONS(2141),
    [anon_sym_namespace] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(2139),
    [anon_sym_RBRACE] = ACTIONS(2139),
    [anon_sym_typeof] = ACTIONS(2141),
    [anon_sym_import] = ACTIONS(2141),
    [anon_sym_var] = ACTIONS(2141),
    [anon_sym_let] = ACTIONS(2141),
    [anon_sym_const] = ACTIONS(2141),
    [anon_sym_BANG] = ACTIONS(2139),
    [anon_sym_else] = ACTIONS(2141),
    [anon_sym_if] = ACTIONS(2141),
    [anon_sym_switch] = ACTIONS(2141),
    [anon_sym_for] = ACTIONS(2141),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_while] = ACTIONS(2141),
    [anon_sym_do] = ACTIONS(2141),
    [anon_sym_try] = ACTIONS(2141),
    [anon_sym_with] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2141),
    [anon_sym_continue] = ACTIONS(2141),
    [anon_sym_debugger] = ACTIONS(2141),
    [anon_sym_return] = ACTIONS(2141),
    [anon_sym_throw] = ACTIONS(2141),
    [anon_sym_SEMI] = ACTIONS(2139),
    [anon_sym_case] = ACTIONS(2141),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2139),
    [anon_sym_LTtemplate_GT] = ACTIONS(2139),
    [anon_sym_class] = ACTIONS(2141),
    [anon_sym_async] = ACTIONS(2141),
    [anon_sym_function] = ACTIONS(2141),
    [anon_sym_new] = ACTIONS(2141),
    [anon_sym_PLUS] = ACTIONS(2141),
    [anon_sym_DASH] = ACTIONS(2141),
    [anon_sym_SLASH] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2141),
    [anon_sym_TILDE] = ACTIONS(2139),
    [anon_sym_void] = ACTIONS(2141),
    [anon_sym_delete] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2139),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2139),
    [anon_sym_SQUOTE] = ACTIONS(2139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2139),
    [sym_number] = ACTIONS(2139),
    [sym_this] = ACTIONS(2141),
    [sym_super] = ACTIONS(2141),
    [sym_true] = ACTIONS(2141),
    [sym_false] = ACTIONS(2141),
    [sym_null] = ACTIONS(2141),
    [sym_undefined] = ACTIONS(2141),
    [anon_sym_AT] = ACTIONS(2139),
    [anon_sym_static] = ACTIONS(2141),
    [anon_sym_readonly] = ACTIONS(2141),
    [anon_sym_get] = ACTIONS(2141),
    [anon_sym_set] = ACTIONS(2141),
    [anon_sym_declare] = ACTIONS(2141),
    [anon_sym_public] = ACTIONS(2141),
    [anon_sym_private] = ACTIONS(2141),
    [anon_sym_protected] = ACTIONS(2141),
    [anon_sym_override] = ACTIONS(2141),
    [anon_sym_module] = ACTIONS(2141),
    [anon_sym_any] = ACTIONS(2141),
    [anon_sym_number] = ACTIONS(2141),
    [anon_sym_boolean] = ACTIONS(2141),
    [anon_sym_string] = ACTIONS(2141),
    [anon_sym_symbol] = ACTIONS(2141),
    [anon_sym_abstract] = ACTIONS(2141),
    [anon_sym_interface] = ACTIONS(2141),
    [anon_sym_enum] = ACTIONS(2141),
  },
  [637] = {
    [ts_builtin_sym_end] = ACTIONS(2143),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2143),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2143),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2143),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_LTtemplate_GT] = ACTIONS(2143),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2143),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2143),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2143),
    [anon_sym_SQUOTE] = ACTIONS(2143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2143),
    [sym_number] = ACTIONS(2143),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2143),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
  },
  [638] = {
    [ts_builtin_sym_end] = ACTIONS(2147),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_default] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_else] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_case] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_LTtemplate_GT] = ACTIONS(2147),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2147),
    [sym_number] = ACTIONS(2147),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
  },
  [639] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [640] = {
    [ts_builtin_sym_end] = ACTIONS(2151),
    [sym_identifier] = ACTIONS(2153),
    [anon_sym_export] = ACTIONS(2153),
    [anon_sym_default] = ACTIONS(2153),
    [anon_sym_type] = ACTIONS(2153),
    [anon_sym_namespace] = ACTIONS(2153),
    [anon_sym_LBRACE] = ACTIONS(2151),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_typeof] = ACTIONS(2153),
    [anon_sym_import] = ACTIONS(2153),
    [anon_sym_var] = ACTIONS(2153),
    [anon_sym_let] = ACTIONS(2153),
    [anon_sym_const] = ACTIONS(2153),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_else] = ACTIONS(2153),
    [anon_sym_if] = ACTIONS(2153),
    [anon_sym_switch] = ACTIONS(2153),
    [anon_sym_for] = ACTIONS(2153),
    [anon_sym_LPAREN] = ACTIONS(2151),
    [anon_sym_await] = ACTIONS(2153),
    [anon_sym_while] = ACTIONS(2153),
    [anon_sym_do] = ACTIONS(2153),
    [anon_sym_try] = ACTIONS(2153),
    [anon_sym_with] = ACTIONS(2153),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_continue] = ACTIONS(2153),
    [anon_sym_debugger] = ACTIONS(2153),
    [anon_sym_return] = ACTIONS(2153),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_case] = ACTIONS(2153),
    [anon_sym_yield] = ACTIONS(2153),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_LTtemplate_GT] = ACTIONS(2151),
    [anon_sym_class] = ACTIONS(2153),
    [anon_sym_async] = ACTIONS(2153),
    [anon_sym_function] = ACTIONS(2153),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_SLASH] = ACTIONS(2153),
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_void] = ACTIONS(2153),
    [anon_sym_delete] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2153),
    [anon_sym_DQUOTE] = ACTIONS(2151),
    [anon_sym_SQUOTE] = ACTIONS(2151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2151),
    [sym_number] = ACTIONS(2151),
    [sym_this] = ACTIONS(2153),
    [sym_super] = ACTIONS(2153),
    [sym_true] = ACTIONS(2153),
    [sym_false] = ACTIONS(2153),
    [sym_null] = ACTIONS(2153),
    [sym_undefined] = ACTIONS(2153),
    [anon_sym_AT] = ACTIONS(2151),
    [anon_sym_static] = ACTIONS(2153),
    [anon_sym_readonly] = ACTIONS(2153),
    [anon_sym_get] = ACTIONS(2153),
    [anon_sym_set] = ACTIONS(2153),
    [anon_sym_declare] = ACTIONS(2153),
    [anon_sym_public] = ACTIONS(2153),
    [anon_sym_private] = ACTIONS(2153),
    [anon_sym_protected] = ACTIONS(2153),
    [anon_sym_override] = ACTIONS(2153),
    [anon_sym_module] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2153),
    [anon_sym_number] = ACTIONS(2153),
    [anon_sym_boolean] = ACTIONS(2153),
    [anon_sym_string] = ACTIONS(2153),
    [anon_sym_symbol] = ACTIONS(2153),
    [anon_sym_abstract] = ACTIONS(2153),
    [anon_sym_interface] = ACTIONS(2153),
    [anon_sym_enum] = ACTIONS(2153),
  },
  [641] = {
    [ts_builtin_sym_end] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2157),
    [anon_sym_export] = ACTIONS(2157),
    [anon_sym_default] = ACTIONS(2157),
    [anon_sym_type] = ACTIONS(2157),
    [anon_sym_namespace] = ACTIONS(2157),
    [anon_sym_LBRACE] = ACTIONS(2155),
    [anon_sym_RBRACE] = ACTIONS(2155),
    [anon_sym_typeof] = ACTIONS(2157),
    [anon_sym_import] = ACTIONS(2157),
    [anon_sym_var] = ACTIONS(2157),
    [anon_sym_let] = ACTIONS(2157),
    [anon_sym_const] = ACTIONS(2157),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_else] = ACTIONS(2157),
    [anon_sym_if] = ACTIONS(2157),
    [anon_sym_switch] = ACTIONS(2157),
    [anon_sym_for] = ACTIONS(2157),
    [anon_sym_LPAREN] = ACTIONS(2155),
    [anon_sym_await] = ACTIONS(2157),
    [anon_sym_while] = ACTIONS(2157),
    [anon_sym_do] = ACTIONS(2157),
    [anon_sym_try] = ACTIONS(2157),
    [anon_sym_with] = ACTIONS(2157),
    [anon_sym_break] = ACTIONS(2157),
    [anon_sym_continue] = ACTIONS(2157),
    [anon_sym_debugger] = ACTIONS(2157),
    [anon_sym_return] = ACTIONS(2157),
    [anon_sym_throw] = ACTIONS(2157),
    [anon_sym_SEMI] = ACTIONS(2155),
    [anon_sym_case] = ACTIONS(2157),
    [anon_sym_yield] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2155),
    [anon_sym_LTtemplate_GT] = ACTIONS(2155),
    [anon_sym_class] = ACTIONS(2157),
    [anon_sym_async] = ACTIONS(2157),
    [anon_sym_function] = ACTIONS(2157),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_SLASH] = ACTIONS(2157),
    [anon_sym_LT] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_void] = ACTIONS(2157),
    [anon_sym_delete] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2155),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_DQUOTE] = ACTIONS(2155),
    [anon_sym_SQUOTE] = ACTIONS(2155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [sym_number] = ACTIONS(2155),
    [sym_this] = ACTIONS(2157),
    [sym_super] = ACTIONS(2157),
    [sym_true] = ACTIONS(2157),
    [sym_false] = ACTIONS(2157),
    [sym_null] = ACTIONS(2157),
    [sym_undefined] = ACTIONS(2157),
    [anon_sym_AT] = ACTIONS(2155),
    [anon_sym_static] = ACTIONS(2157),
    [anon_sym_readonly] = ACTIONS(2157),
    [anon_sym_get] = ACTIONS(2157),
    [anon_sym_set] = ACTIONS(2157),
    [anon_sym_declare] = ACTIONS(2157),
    [anon_sym_public] = ACTIONS(2157),
    [anon_sym_private] = ACTIONS(2157),
    [anon_sym_protected] = ACTIONS(2157),
    [anon_sym_override] = ACTIONS(2157),
    [anon_sym_module] = ACTIONS(2157),
    [anon_sym_any] = ACTIONS(2157),
    [anon_sym_number] = ACTIONS(2157),
    [anon_sym_boolean] = ACTIONS(2157),
    [anon_sym_string] = ACTIONS(2157),
    [anon_sym_symbol] = ACTIONS(2157),
    [anon_sym_abstract] = ACTIONS(2157),
    [anon_sym_interface] = ACTIONS(2157),
    [anon_sym_enum] = ACTIONS(2157),
  },
  [642] = {
    [ts_builtin_sym_end] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2161),
    [anon_sym_export] = ACTIONS(2161),
    [anon_sym_default] = ACTIONS(2161),
    [anon_sym_type] = ACTIONS(2161),
    [anon_sym_namespace] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(2159),
    [anon_sym_typeof] = ACTIONS(2161),
    [anon_sym_import] = ACTIONS(2161),
    [anon_sym_var] = ACTIONS(2161),
    [anon_sym_let] = ACTIONS(2161),
    [anon_sym_const] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2161),
    [anon_sym_if] = ACTIONS(2161),
    [anon_sym_switch] = ACTIONS(2161),
    [anon_sym_for] = ACTIONS(2161),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_await] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(2161),
    [anon_sym_do] = ACTIONS(2161),
    [anon_sym_try] = ACTIONS(2161),
    [anon_sym_with] = ACTIONS(2161),
    [anon_sym_break] = ACTIONS(2161),
    [anon_sym_continue] = ACTIONS(2161),
    [anon_sym_debugger] = ACTIONS(2161),
    [anon_sym_return] = ACTIONS(2161),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_SEMI] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2161),
    [anon_sym_yield] = ACTIONS(2161),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_LTtemplate_GT] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2161),
    [anon_sym_async] = ACTIONS(2161),
    [anon_sym_function] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2161),
    [anon_sym_PLUS] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2161),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_LT] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2159),
    [anon_sym_void] = ACTIONS(2161),
    [anon_sym_delete] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2159),
    [anon_sym_SQUOTE] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2159),
    [sym_number] = ACTIONS(2159),
    [sym_this] = ACTIONS(2161),
    [sym_super] = ACTIONS(2161),
    [sym_true] = ACTIONS(2161),
    [sym_false] = ACTIONS(2161),
    [sym_null] = ACTIONS(2161),
    [sym_undefined] = ACTIONS(2161),
    [anon_sym_AT] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2161),
    [anon_sym_readonly] = ACTIONS(2161),
    [anon_sym_get] = ACTIONS(2161),
    [anon_sym_set] = ACTIONS(2161),
    [anon_sym_declare] = ACTIONS(2161),
    [anon_sym_public] = ACTIONS(2161),
    [anon_sym_private] = ACTIONS(2161),
    [anon_sym_protected] = ACTIONS(2161),
    [anon_sym_override] = ACTIONS(2161),
    [anon_sym_module] = ACTIONS(2161),
    [anon_sym_any] = ACTIONS(2161),
    [anon_sym_number] = ACTIONS(2161),
    [anon_sym_boolean] = ACTIONS(2161),
    [anon_sym_string] = ACTIONS(2161),
    [anon_sym_symbol] = ACTIONS(2161),
    [anon_sym_abstract] = ACTIONS(2161),
    [anon_sym_interface] = ACTIONS(2161),
    [anon_sym_enum] = ACTIONS(2161),
  },
  [643] = {
    [ts_builtin_sym_end] = ACTIONS(2163),
    [sym_identifier] = ACTIONS(2165),
    [anon_sym_export] = ACTIONS(2165),
    [anon_sym_default] = ACTIONS(2165),
    [anon_sym_type] = ACTIONS(2165),
    [anon_sym_namespace] = ACTIONS(2165),
    [anon_sym_LBRACE] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2165),
    [anon_sym_import] = ACTIONS(2165),
    [anon_sym_var] = ACTIONS(2165),
    [anon_sym_let] = ACTIONS(2165),
    [anon_sym_const] = ACTIONS(2165),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2165),
    [anon_sym_if] = ACTIONS(2165),
    [anon_sym_switch] = ACTIONS(2165),
    [anon_sym_for] = ACTIONS(2165),
    [anon_sym_LPAREN] = ACTIONS(2163),
    [anon_sym_await] = ACTIONS(2165),
    [anon_sym_while] = ACTIONS(2165),
    [anon_sym_do] = ACTIONS(2165),
    [anon_sym_try] = ACTIONS(2165),
    [anon_sym_with] = ACTIONS(2165),
    [anon_sym_break] = ACTIONS(2165),
    [anon_sym_continue] = ACTIONS(2165),
    [anon_sym_debugger] = ACTIONS(2165),
    [anon_sym_return] = ACTIONS(2165),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_case] = ACTIONS(2165),
    [anon_sym_yield] = ACTIONS(2165),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_LTtemplate_GT] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2165),
    [anon_sym_async] = ACTIONS(2165),
    [anon_sym_function] = ACTIONS(2165),
    [anon_sym_new] = ACTIONS(2165),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_SLASH] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2163),
    [anon_sym_void] = ACTIONS(2165),
    [anon_sym_delete] = ACTIONS(2165),
    [anon_sym_PLUS_PLUS] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2165),
    [anon_sym_DQUOTE] = ACTIONS(2163),
    [anon_sym_SQUOTE] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2163),
    [sym_number] = ACTIONS(2163),
    [sym_this] = ACTIONS(2165),
    [sym_super] = ACTIONS(2165),
    [sym_true] = ACTIONS(2165),
    [sym_false] = ACTIONS(2165),
    [sym_null] = ACTIONS(2165),
    [sym_undefined] = ACTIONS(2165),
    [anon_sym_AT] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2165),
    [anon_sym_readonly] = ACTIONS(2165),
    [anon_sym_get] = ACTIONS(2165),
    [anon_sym_set] = ACTIONS(2165),
    [anon_sym_declare] = ACTIONS(2165),
    [anon_sym_public] = ACTIONS(2165),
    [anon_sym_private] = ACTIONS(2165),
    [anon_sym_protected] = ACTIONS(2165),
    [anon_sym_override] = ACTIONS(2165),
    [anon_sym_module] = ACTIONS(2165),
    [anon_sym_any] = ACTIONS(2165),
    [anon_sym_number] = ACTIONS(2165),
    [anon_sym_boolean] = ACTIONS(2165),
    [anon_sym_string] = ACTIONS(2165),
    [anon_sym_symbol] = ACTIONS(2165),
    [anon_sym_abstract] = ACTIONS(2165),
    [anon_sym_interface] = ACTIONS(2165),
    [anon_sym_enum] = ACTIONS(2165),
  },
  [644] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [645] = {
    [ts_builtin_sym_end] = ACTIONS(2167),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_export] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2169),
    [anon_sym_type] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2169),
    [anon_sym_import] = ACTIONS(2169),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_switch] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_await] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2169),
    [anon_sym_do] = ACTIONS(2169),
    [anon_sym_try] = ACTIONS(2169),
    [anon_sym_with] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_debugger] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_throw] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_case] = ACTIONS(2169),
    [anon_sym_yield] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LTtemplate_GT] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2169),
    [anon_sym_async] = ACTIONS(2169),
    [anon_sym_function] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_void] = ACTIONS(2169),
    [anon_sym_delete] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [sym_number] = ACTIONS(2167),
    [sym_this] = ACTIONS(2169),
    [sym_super] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_null] = ACTIONS(2169),
    [sym_undefined] = ACTIONS(2169),
    [anon_sym_AT] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_readonly] = ACTIONS(2169),
    [anon_sym_get] = ACTIONS(2169),
    [anon_sym_set] = ACTIONS(2169),
    [anon_sym_declare] = ACTIONS(2169),
    [anon_sym_public] = ACTIONS(2169),
    [anon_sym_private] = ACTIONS(2169),
    [anon_sym_protected] = ACTIONS(2169),
    [anon_sym_override] = ACTIONS(2169),
    [anon_sym_module] = ACTIONS(2169),
    [anon_sym_any] = ACTIONS(2169),
    [anon_sym_number] = ACTIONS(2169),
    [anon_sym_boolean] = ACTIONS(2169),
    [anon_sym_string] = ACTIONS(2169),
    [anon_sym_symbol] = ACTIONS(2169),
    [anon_sym_abstract] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
  },
  [646] = {
    [ts_builtin_sym_end] = ACTIONS(2171),
    [sym_identifier] = ACTIONS(2173),
    [anon_sym_export] = ACTIONS(2173),
    [anon_sym_default] = ACTIONS(2173),
    [anon_sym_type] = ACTIONS(2173),
    [anon_sym_namespace] = ACTIONS(2173),
    [anon_sym_LBRACE] = ACTIONS(2171),
    [anon_sym_RBRACE] = ACTIONS(2171),
    [anon_sym_typeof] = ACTIONS(2173),
    [anon_sym_import] = ACTIONS(2173),
    [anon_sym_var] = ACTIONS(2173),
    [anon_sym_let] = ACTIONS(2173),
    [anon_sym_const] = ACTIONS(2173),
    [anon_sym_BANG] = ACTIONS(2171),
    [anon_sym_else] = ACTIONS(2173),
    [anon_sym_if] = ACTIONS(2173),
    [anon_sym_switch] = ACTIONS(2173),
    [anon_sym_for] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(2171),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_while] = ACTIONS(2173),
    [anon_sym_do] = ACTIONS(2173),
    [anon_sym_try] = ACTIONS(2173),
    [anon_sym_with] = ACTIONS(2173),
    [anon_sym_break] = ACTIONS(2173),
    [anon_sym_continue] = ACTIONS(2173),
    [anon_sym_debugger] = ACTIONS(2173),
    [anon_sym_return] = ACTIONS(2173),
    [anon_sym_throw] = ACTIONS(2173),
    [anon_sym_SEMI] = ACTIONS(2171),
    [anon_sym_case] = ACTIONS(2173),
    [anon_sym_yield] = ACTIONS(2173),
    [anon_sym_LBRACK] = ACTIONS(2171),
    [anon_sym_LTtemplate_GT] = ACTIONS(2171),
    [anon_sym_class] = ACTIONS(2173),
    [anon_sym_async] = ACTIONS(2173),
    [anon_sym_function] = ACTIONS(2173),
    [anon_sym_new] = ACTIONS(2173),
    [anon_sym_PLUS] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2173),
    [anon_sym_SLASH] = ACTIONS(2173),
    [anon_sym_LT] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2171),
    [anon_sym_void] = ACTIONS(2173),
    [anon_sym_delete] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2171),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_DQUOTE] = ACTIONS(2171),
    [anon_sym_SQUOTE] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2171),
    [sym_number] = ACTIONS(2171),
    [sym_this] = ACTIONS(2173),
    [sym_super] = ACTIONS(2173),
    [sym_true] = ACTIONS(2173),
    [sym_false] = ACTIONS(2173),
    [sym_null] = ACTIONS(2173),
    [sym_undefined] = ACTIONS(2173),
    [anon_sym_AT] = ACTIONS(2171),
    [anon_sym_static] = ACTIONS(2173),
    [anon_sym_readonly] = ACTIONS(2173),
    [anon_sym_get] = ACTIONS(2173),
    [anon_sym_set] = ACTIONS(2173),
    [anon_sym_declare] = ACTIONS(2173),
    [anon_sym_public] = ACTIONS(2173),
    [anon_sym_private] = ACTIONS(2173),
    [anon_sym_protected] = ACTIONS(2173),
    [anon_sym_override] = ACTIONS(2173),
    [anon_sym_module] = ACTIONS(2173),
    [anon_sym_any] = ACTIONS(2173),
    [anon_sym_number] = ACTIONS(2173),
    [anon_sym_boolean] = ACTIONS(2173),
    [anon_sym_string] = ACTIONS(2173),
    [anon_sym_symbol] = ACTIONS(2173),
    [anon_sym_abstract] = ACTIONS(2173),
    [anon_sym_interface] = ACTIONS(2173),
    [anon_sym_enum] = ACTIONS(2173),
  },
  [647] = {
    [ts_builtin_sym_end] = ACTIONS(2175),
    [sym_identifier] = ACTIONS(2177),
    [anon_sym_export] = ACTIONS(2177),
    [anon_sym_default] = ACTIONS(2177),
    [anon_sym_type] = ACTIONS(2177),
    [anon_sym_namespace] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2177),
    [anon_sym_import] = ACTIONS(2177),
    [anon_sym_var] = ACTIONS(2177),
    [anon_sym_let] = ACTIONS(2177),
    [anon_sym_const] = ACTIONS(2177),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_else] = ACTIONS(2177),
    [anon_sym_if] = ACTIONS(2177),
    [anon_sym_switch] = ACTIONS(2177),
    [anon_sym_for] = ACTIONS(2177),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_while] = ACTIONS(2177),
    [anon_sym_do] = ACTIONS(2177),
    [anon_sym_try] = ACTIONS(2177),
    [anon_sym_with] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2177),
    [anon_sym_continue] = ACTIONS(2177),
    [anon_sym_debugger] = ACTIONS(2177),
    [anon_sym_return] = ACTIONS(2177),
    [anon_sym_throw] = ACTIONS(2177),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_case] = ACTIONS(2177),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [anon_sym_LTtemplate_GT] = ACTIONS(2175),
    [anon_sym_class] = ACTIONS(2177),
    [anon_sym_async] = ACTIONS(2177),
    [anon_sym_function] = ACTIONS(2177),
    [anon_sym_new] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2177),
    [anon_sym_DASH] = ACTIONS(2177),
    [anon_sym_SLASH] = ACTIONS(2177),
    [anon_sym_LT] = ACTIONS(2177),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_void] = ACTIONS(2177),
    [anon_sym_delete] = ACTIONS(2177),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_number] = ACTIONS(2175),
    [sym_this] = ACTIONS(2177),
    [sym_super] = ACTIONS(2177),
    [sym_true] = ACTIONS(2177),
    [sym_false] = ACTIONS(2177),
    [sym_null] = ACTIONS(2177),
    [sym_undefined] = ACTIONS(2177),
    [anon_sym_AT] = ACTIONS(2175),
    [anon_sym_static] = ACTIONS(2177),
    [anon_sym_readonly] = ACTIONS(2177),
    [anon_sym_get] = ACTIONS(2177),
    [anon_sym_set] = ACTIONS(2177),
    [anon_sym_declare] = ACTIONS(2177),
    [anon_sym_public] = ACTIONS(2177),
    [anon_sym_private] = ACTIONS(2177),
    [anon_sym_protected] = ACTIONS(2177),
    [anon_sym_override] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(2177),
    [anon_sym_any] = ACTIONS(2177),
    [anon_sym_number] = ACTIONS(2177),
    [anon_sym_boolean] = ACTIONS(2177),
    [anon_sym_string] = ACTIONS(2177),
    [anon_sym_symbol] = ACTIONS(2177),
    [anon_sym_abstract] = ACTIONS(2177),
    [anon_sym_interface] = ACTIONS(2177),
    [anon_sym_enum] = ACTIONS(2177),
  },
  [648] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [649] = {
    [ts_builtin_sym_end] = ACTIONS(2179),
    [sym_identifier] = ACTIONS(2181),
    [anon_sym_export] = ACTIONS(2181),
    [anon_sym_default] = ACTIONS(2181),
    [anon_sym_type] = ACTIONS(2181),
    [anon_sym_namespace] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2179),
    [anon_sym_RBRACE] = ACTIONS(2179),
    [anon_sym_typeof] = ACTIONS(2181),
    [anon_sym_import] = ACTIONS(2181),
    [anon_sym_var] = ACTIONS(2181),
    [anon_sym_let] = ACTIONS(2181),
    [anon_sym_const] = ACTIONS(2181),
    [anon_sym_BANG] = ACTIONS(2179),
    [anon_sym_else] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_switch] = ACTIONS(2181),
    [anon_sym_for] = ACTIONS(2181),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_await] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_try] = ACTIONS(2181),
    [anon_sym_with] = ACTIONS(2181),
    [anon_sym_break] = ACTIONS(2181),
    [anon_sym_continue] = ACTIONS(2181),
    [anon_sym_debugger] = ACTIONS(2181),
    [anon_sym_return] = ACTIONS(2181),
    [anon_sym_throw] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2179),
    [anon_sym_case] = ACTIONS(2181),
    [anon_sym_yield] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_LTtemplate_GT] = ACTIONS(2179),
    [anon_sym_class] = ACTIONS(2181),
    [anon_sym_async] = ACTIONS(2181),
    [anon_sym_function] = ACTIONS(2181),
    [anon_sym_new] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(2181),
    [anon_sym_TILDE] = ACTIONS(2179),
    [anon_sym_void] = ACTIONS(2181),
    [anon_sym_delete] = ACTIONS(2181),
    [anon_sym_PLUS_PLUS] = ACTIONS(2179),
    [anon_sym_DASH_DASH] = ACTIONS(2181),
    [anon_sym_DQUOTE] = ACTIONS(2179),
    [anon_sym_SQUOTE] = ACTIONS(2179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2179),
    [sym_number] = ACTIONS(2179),
    [sym_this] = ACTIONS(2181),
    [sym_super] = ACTIONS(2181),
    [sym_true] = ACTIONS(2181),
    [sym_false] = ACTIONS(2181),
    [sym_null] = ACTIONS(2181),
    [sym_undefined] = ACTIONS(2181),
    [anon_sym_AT] = ACTIONS(2179),
    [anon_sym_static] = ACTIONS(2181),
    [anon_sym_readonly] = ACTIONS(2181),
    [anon_sym_get] = ACTIONS(2181),
    [anon_sym_set] = ACTIONS(2181),
    [anon_sym_declare] = ACTIONS(2181),
    [anon_sym_public] = ACTIONS(2181),
    [anon_sym_private] = ACTIONS(2181),
    [anon_sym_protected] = ACTIONS(2181),
    [anon_sym_override] = ACTIONS(2181),
    [anon_sym_module] = ACTIONS(2181),
    [anon_sym_any] = ACTIONS(2181),
    [anon_sym_number] = ACTIONS(2181),
    [anon_sym_boolean] = ACTIONS(2181),
    [anon_sym_string] = ACTIONS(2181),
    [anon_sym_symbol] = ACTIONS(2181),
    [anon_sym_abstract] = ACTIONS(2181),
    [anon_sym_interface] = ACTIONS(2181),
    [anon_sym_enum] = ACTIONS(2181),
  },
  [650] = {
    [ts_builtin_sym_end] = ACTIONS(2183),
    [sym_identifier] = ACTIONS(2185),
    [anon_sym_export] = ACTIONS(2185),
    [anon_sym_default] = ACTIONS(2185),
    [anon_sym_type] = ACTIONS(2185),
    [anon_sym_namespace] = ACTIONS(2185),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_typeof] = ACTIONS(2185),
    [anon_sym_import] = ACTIONS(2185),
    [anon_sym_var] = ACTIONS(2185),
    [anon_sym_let] = ACTIONS(2185),
    [anon_sym_const] = ACTIONS(2185),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_else] = ACTIONS(2185),
    [anon_sym_if] = ACTIONS(2185),
    [anon_sym_switch] = ACTIONS(2185),
    [anon_sym_for] = ACTIONS(2185),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2185),
    [anon_sym_while] = ACTIONS(2185),
    [anon_sym_do] = ACTIONS(2185),
    [anon_sym_try] = ACTIONS(2185),
    [anon_sym_with] = ACTIONS(2185),
    [anon_sym_break] = ACTIONS(2185),
    [anon_sym_continue] = ACTIONS(2185),
    [anon_sym_debugger] = ACTIONS(2185),
    [anon_sym_return] = ACTIONS(2185),
    [anon_sym_throw] = ACTIONS(2185),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_case] = ACTIONS(2185),
    [anon_sym_yield] = ACTIONS(2185),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_class] = ACTIONS(2185),
    [anon_sym_async] = ACTIONS(2185),
    [anon_sym_function] = ACTIONS(2185),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2185),
    [anon_sym_LT] = ACTIONS(2185),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2185),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2185),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2183),
    [sym_this] = ACTIONS(2185),
    [sym_super] = ACTIONS(2185),
    [sym_true] = ACTIONS(2185),
    [sym_false] = ACTIONS(2185),
    [sym_null] = ACTIONS(2185),
    [sym_undefined] = ACTIONS(2185),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2185),
    [anon_sym_readonly] = ACTIONS(2185),
    [anon_sym_get] = ACTIONS(2185),
    [anon_sym_set] = ACTIONS(2185),
    [anon_sym_declare] = ACTIONS(2185),
    [anon_sym_public] = ACTIONS(2185),
    [anon_sym_private] = ACTIONS(2185),
    [anon_sym_protected] = ACTIONS(2185),
    [anon_sym_override] = ACTIONS(2185),
    [anon_sym_module] = ACTIONS(2185),
    [anon_sym_any] = ACTIONS(2185),
    [anon_sym_number] = ACTIONS(2185),
    [anon_sym_boolean] = ACTIONS(2185),
    [anon_sym_string] = ACTIONS(2185),
    [anon_sym_symbol] = ACTIONS(2185),
    [anon_sym_abstract] = ACTIONS(2185),
    [anon_sym_interface] = ACTIONS(2185),
    [anon_sym_enum] = ACTIONS(2185),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(2187),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_export] = ACTIONS(2189),
    [anon_sym_default] = ACTIONS(2189),
    [anon_sym_type] = ACTIONS(2189),
    [anon_sym_namespace] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_import] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_else] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_with] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_debugger] = ACTIONS(2189),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_case] = ACTIONS(2189),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_LTtemplate_GT] = ACTIONS(2187),
    [anon_sym_class] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_function] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2189),
    [anon_sym_delete] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2187),
    [sym_number] = ACTIONS(2187),
    [sym_this] = ACTIONS(2189),
    [sym_super] = ACTIONS(2189),
    [sym_true] = ACTIONS(2189),
    [sym_false] = ACTIONS(2189),
    [sym_null] = ACTIONS(2189),
    [sym_undefined] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(2187),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_declare] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_module] = ACTIONS(2189),
    [anon_sym_any] = ACTIONS(2189),
    [anon_sym_number] = ACTIONS(2189),
    [anon_sym_boolean] = ACTIONS(2189),
    [anon_sym_string] = ACTIONS(2189),
    [anon_sym_symbol] = ACTIONS(2189),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_interface] = ACTIONS(2189),
    [anon_sym_enum] = ACTIONS(2189),
  },
  [652] = {
    [ts_builtin_sym_end] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2193),
    [anon_sym_export] = ACTIONS(2193),
    [anon_sym_default] = ACTIONS(2193),
    [anon_sym_type] = ACTIONS(2193),
    [anon_sym_namespace] = ACTIONS(2193),
    [anon_sym_LBRACE] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2191),
    [anon_sym_typeof] = ACTIONS(2193),
    [anon_sym_import] = ACTIONS(2193),
    [anon_sym_var] = ACTIONS(2193),
    [anon_sym_let] = ACTIONS(2193),
    [anon_sym_const] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(2191),
    [anon_sym_else] = ACTIONS(2193),
    [anon_sym_if] = ACTIONS(2193),
    [anon_sym_switch] = ACTIONS(2193),
    [anon_sym_for] = ACTIONS(2193),
    [anon_sym_LPAREN] = ACTIONS(2191),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_while] = ACTIONS(2193),
    [anon_sym_do] = ACTIONS(2193),
    [anon_sym_try] = ACTIONS(2193),
    [anon_sym_with] = ACTIONS(2193),
    [anon_sym_break] = ACTIONS(2193),
    [anon_sym_continue] = ACTIONS(2193),
    [anon_sym_debugger] = ACTIONS(2193),
    [anon_sym_return] = ACTIONS(2193),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_SEMI] = ACTIONS(2191),
    [anon_sym_case] = ACTIONS(2193),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_LTtemplate_GT] = ACTIONS(2191),
    [anon_sym_class] = ACTIONS(2193),
    [anon_sym_async] = ACTIONS(2193),
    [anon_sym_function] = ACTIONS(2193),
    [anon_sym_new] = ACTIONS(2193),
    [anon_sym_PLUS] = ACTIONS(2193),
    [anon_sym_DASH] = ACTIONS(2193),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2191),
    [anon_sym_void] = ACTIONS(2193),
    [anon_sym_delete] = ACTIONS(2193),
    [anon_sym_PLUS_PLUS] = ACTIONS(2191),
    [anon_sym_DASH_DASH] = ACTIONS(2193),
    [anon_sym_DQUOTE] = ACTIONS(2191),
    [anon_sym_SQUOTE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2191),
    [sym_number] = ACTIONS(2191),
    [sym_this] = ACTIONS(2193),
    [sym_super] = ACTIONS(2193),
    [sym_true] = ACTIONS(2193),
    [sym_false] = ACTIONS(2193),
    [sym_null] = ACTIONS(2193),
    [sym_undefined] = ACTIONS(2193),
    [anon_sym_AT] = ACTIONS(2191),
    [anon_sym_static] = ACTIONS(2193),
    [anon_sym_readonly] = ACTIONS(2193),
    [anon_sym_get] = ACTIONS(2193),
    [anon_sym_set] = ACTIONS(2193),
    [anon_sym_declare] = ACTIONS(2193),
    [anon_sym_public] = ACTIONS(2193),
    [anon_sym_private] = ACTIONS(2193),
    [anon_sym_protected] = ACTIONS(2193),
    [anon_sym_override] = ACTIONS(2193),
    [anon_sym_module] = ACTIONS(2193),
    [anon_sym_any] = ACTIONS(2193),
    [anon_sym_number] = ACTIONS(2193),
    [anon_sym_boolean] = ACTIONS(2193),
    [anon_sym_string] = ACTIONS(2193),
    [anon_sym_symbol] = ACTIONS(2193),
    [anon_sym_abstract] = ACTIONS(2193),
    [anon_sym_interface] = ACTIONS(2193),
    [anon_sym_enum] = ACTIONS(2193),
  },
  [653] = {
    [ts_builtin_sym_end] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2193),
    [anon_sym_export] = ACTIONS(2193),
    [anon_sym_default] = ACTIONS(2193),
    [anon_sym_type] = ACTIONS(2193),
    [anon_sym_namespace] = ACTIONS(2193),
    [anon_sym_LBRACE] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2191),
    [anon_sym_typeof] = ACTIONS(2193),
    [anon_sym_import] = ACTIONS(2193),
    [anon_sym_var] = ACTIONS(2193),
    [anon_sym_let] = ACTIONS(2193),
    [anon_sym_const] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(2191),
    [anon_sym_else] = ACTIONS(2193),
    [anon_sym_if] = ACTIONS(2193),
    [anon_sym_switch] = ACTIONS(2193),
    [anon_sym_for] = ACTIONS(2193),
    [anon_sym_LPAREN] = ACTIONS(2191),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_while] = ACTIONS(2193),
    [anon_sym_do] = ACTIONS(2193),
    [anon_sym_try] = ACTIONS(2193),
    [anon_sym_with] = ACTIONS(2193),
    [anon_sym_break] = ACTIONS(2193),
    [anon_sym_continue] = ACTIONS(2193),
    [anon_sym_debugger] = ACTIONS(2193),
    [anon_sym_return] = ACTIONS(2193),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_SEMI] = ACTIONS(2191),
    [anon_sym_case] = ACTIONS(2193),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_LTtemplate_GT] = ACTIONS(2191),
    [anon_sym_class] = ACTIONS(2193),
    [anon_sym_async] = ACTIONS(2193),
    [anon_sym_function] = ACTIONS(2193),
    [anon_sym_new] = ACTIONS(2193),
    [anon_sym_PLUS] = ACTIONS(2193),
    [anon_sym_DASH] = ACTIONS(2193),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2191),
    [anon_sym_void] = ACTIONS(2193),
    [anon_sym_delete] = ACTIONS(2193),
    [anon_sym_PLUS_PLUS] = ACTIONS(2191),
    [anon_sym_DASH_DASH] = ACTIONS(2193),
    [anon_sym_DQUOTE] = ACTIONS(2191),
    [anon_sym_SQUOTE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2191),
    [sym_number] = ACTIONS(2191),
    [sym_this] = ACTIONS(2193),
    [sym_super] = ACTIONS(2193),
    [sym_true] = ACTIONS(2193),
    [sym_false] = ACTIONS(2193),
    [sym_null] = ACTIONS(2193),
    [sym_undefined] = ACTIONS(2193),
    [anon_sym_AT] = ACTIONS(2191),
    [anon_sym_static] = ACTIONS(2193),
    [anon_sym_readonly] = ACTIONS(2193),
    [anon_sym_get] = ACTIONS(2193),
    [anon_sym_set] = ACTIONS(2193),
    [anon_sym_declare] = ACTIONS(2193),
    [anon_sym_public] = ACTIONS(2193),
    [anon_sym_private] = ACTIONS(2193),
    [anon_sym_protected] = ACTIONS(2193),
    [anon_sym_override] = ACTIONS(2193),
    [anon_sym_module] = ACTIONS(2193),
    [anon_sym_any] = ACTIONS(2193),
    [anon_sym_number] = ACTIONS(2193),
    [anon_sym_boolean] = ACTIONS(2193),
    [anon_sym_string] = ACTIONS(2193),
    [anon_sym_symbol] = ACTIONS(2193),
    [anon_sym_abstract] = ACTIONS(2193),
    [anon_sym_interface] = ACTIONS(2193),
    [anon_sym_enum] = ACTIONS(2193),
  },
  [654] = {
    [ts_builtin_sym_end] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2193),
    [anon_sym_export] = ACTIONS(2193),
    [anon_sym_default] = ACTIONS(2193),
    [anon_sym_type] = ACTIONS(2193),
    [anon_sym_namespace] = ACTIONS(2193),
    [anon_sym_LBRACE] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2191),
    [anon_sym_typeof] = ACTIONS(2193),
    [anon_sym_import] = ACTIONS(2193),
    [anon_sym_var] = ACTIONS(2193),
    [anon_sym_let] = ACTIONS(2193),
    [anon_sym_const] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(2191),
    [anon_sym_else] = ACTIONS(2193),
    [anon_sym_if] = ACTIONS(2193),
    [anon_sym_switch] = ACTIONS(2193),
    [anon_sym_for] = ACTIONS(2193),
    [anon_sym_LPAREN] = ACTIONS(2191),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_while] = ACTIONS(2193),
    [anon_sym_do] = ACTIONS(2193),
    [anon_sym_try] = ACTIONS(2193),
    [anon_sym_with] = ACTIONS(2193),
    [anon_sym_break] = ACTIONS(2193),
    [anon_sym_continue] = ACTIONS(2193),
    [anon_sym_debugger] = ACTIONS(2193),
    [anon_sym_return] = ACTIONS(2193),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_SEMI] = ACTIONS(2191),
    [anon_sym_case] = ACTIONS(2193),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_LTtemplate_GT] = ACTIONS(2191),
    [anon_sym_class] = ACTIONS(2193),
    [anon_sym_async] = ACTIONS(2193),
    [anon_sym_function] = ACTIONS(2193),
    [anon_sym_new] = ACTIONS(2193),
    [anon_sym_PLUS] = ACTIONS(2193),
    [anon_sym_DASH] = ACTIONS(2193),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2191),
    [anon_sym_void] = ACTIONS(2193),
    [anon_sym_delete] = ACTIONS(2193),
    [anon_sym_PLUS_PLUS] = ACTIONS(2191),
    [anon_sym_DASH_DASH] = ACTIONS(2193),
    [anon_sym_DQUOTE] = ACTIONS(2191),
    [anon_sym_SQUOTE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2191),
    [sym_number] = ACTIONS(2191),
    [sym_this] = ACTIONS(2193),
    [sym_super] = ACTIONS(2193),
    [sym_true] = ACTIONS(2193),
    [sym_false] = ACTIONS(2193),
    [sym_null] = ACTIONS(2193),
    [sym_undefined] = ACTIONS(2193),
    [anon_sym_AT] = ACTIONS(2191),
    [anon_sym_static] = ACTIONS(2193),
    [anon_sym_readonly] = ACTIONS(2193),
    [anon_sym_get] = ACTIONS(2193),
    [anon_sym_set] = ACTIONS(2193),
    [anon_sym_declare] = ACTIONS(2193),
    [anon_sym_public] = ACTIONS(2193),
    [anon_sym_private] = ACTIONS(2193),
    [anon_sym_protected] = ACTIONS(2193),
    [anon_sym_override] = ACTIONS(2193),
    [anon_sym_module] = ACTIONS(2193),
    [anon_sym_any] = ACTIONS(2193),
    [anon_sym_number] = ACTIONS(2193),
    [anon_sym_boolean] = ACTIONS(2193),
    [anon_sym_string] = ACTIONS(2193),
    [anon_sym_symbol] = ACTIONS(2193),
    [anon_sym_abstract] = ACTIONS(2193),
    [anon_sym_interface] = ACTIONS(2193),
    [anon_sym_enum] = ACTIONS(2193),
  },
  [655] = {
    [ts_builtin_sym_end] = ACTIONS(2195),
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_export] = ACTIONS(2197),
    [anon_sym_default] = ACTIONS(2197),
    [anon_sym_type] = ACTIONS(2197),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2195),
    [anon_sym_RBRACE] = ACTIONS(2195),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_import] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2195),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_with] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_debugger] = ACTIONS(2197),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2195),
    [anon_sym_case] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [anon_sym_LTtemplate_GT] = ACTIONS(2195),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_function] = ACTIONS(2197),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_TILDE] = ACTIONS(2195),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(2195),
    [anon_sym_SQUOTE] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2195),
    [sym_number] = ACTIONS(2195),
    [sym_this] = ACTIONS(2197),
    [sym_super] = ACTIONS(2197),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [sym_null] = ACTIONS(2197),
    [sym_undefined] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(2195),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_declare] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_module] = ACTIONS(2197),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_boolean] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
  },
  [656] = {
    [ts_builtin_sym_end] = ACTIONS(2199),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_import] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2201),
    [anon_sym_switch] = ACTIONS(2201),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_await] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_with] = ACTIONS(2201),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_debugger] = ACTIONS(2201),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_case] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_LTtemplate_GT] = ACTIONS(2199),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_SLASH] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_delete] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [sym_number] = ACTIONS(2199),
    [sym_this] = ACTIONS(2201),
    [sym_super] = ACTIONS(2201),
    [sym_true] = ACTIONS(2201),
    [sym_false] = ACTIONS(2201),
    [sym_null] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_readonly] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_override] = ACTIONS(2201),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
  },
  [657] = {
    [ts_builtin_sym_end] = ACTIONS(2199),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_import] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2201),
    [anon_sym_switch] = ACTIONS(2201),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_await] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_with] = ACTIONS(2201),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_debugger] = ACTIONS(2201),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_case] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_LTtemplate_GT] = ACTIONS(2199),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_SLASH] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_delete] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [sym_number] = ACTIONS(2199),
    [sym_this] = ACTIONS(2201),
    [sym_super] = ACTIONS(2201),
    [sym_true] = ACTIONS(2201),
    [sym_false] = ACTIONS(2201),
    [sym_null] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_readonly] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_override] = ACTIONS(2201),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
  },
  [658] = {
    [ts_builtin_sym_end] = ACTIONS(2203),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2205),
    [anon_sym_default] = ACTIONS(2205),
    [anon_sym_type] = ACTIONS(2205),
    [anon_sym_namespace] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2203),
    [anon_sym_RBRACE] = ACTIONS(2203),
    [anon_sym_typeof] = ACTIONS(2205),
    [anon_sym_import] = ACTIONS(2205),
    [anon_sym_var] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_else] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_await] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(2205),
    [anon_sym_do] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2205),
    [anon_sym_break] = ACTIONS(2205),
    [anon_sym_continue] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2205),
    [anon_sym_return] = ACTIONS(2205),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2203),
    [anon_sym_case] = ACTIONS(2205),
    [anon_sym_yield] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LTtemplate_GT] = ACTIONS(2203),
    [anon_sym_class] = ACTIONS(2205),
    [anon_sym_async] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2205),
    [anon_sym_new] = ACTIONS(2205),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_void] = ACTIONS(2205),
    [anon_sym_delete] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2203),
    [anon_sym_SQUOTE] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2203),
    [sym_number] = ACTIONS(2203),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(2205),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2203),
    [anon_sym_static] = ACTIONS(2205),
    [anon_sym_readonly] = ACTIONS(2205),
    [anon_sym_get] = ACTIONS(2205),
    [anon_sym_set] = ACTIONS(2205),
    [anon_sym_declare] = ACTIONS(2205),
    [anon_sym_public] = ACTIONS(2205),
    [anon_sym_private] = ACTIONS(2205),
    [anon_sym_protected] = ACTIONS(2205),
    [anon_sym_override] = ACTIONS(2205),
    [anon_sym_module] = ACTIONS(2205),
    [anon_sym_any] = ACTIONS(2205),
    [anon_sym_number] = ACTIONS(2205),
    [anon_sym_boolean] = ACTIONS(2205),
    [anon_sym_string] = ACTIONS(2205),
    [anon_sym_symbol] = ACTIONS(2205),
    [anon_sym_abstract] = ACTIONS(2205),
    [anon_sym_interface] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2205),
  },
  [659] = {
    [ts_builtin_sym_end] = ACTIONS(2199),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_import] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2201),
    [anon_sym_switch] = ACTIONS(2201),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_await] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_with] = ACTIONS(2201),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_debugger] = ACTIONS(2201),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_case] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_LTtemplate_GT] = ACTIONS(2199),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_SLASH] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_delete] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [sym_number] = ACTIONS(2199),
    [sym_this] = ACTIONS(2201),
    [sym_super] = ACTIONS(2201),
    [sym_true] = ACTIONS(2201),
    [sym_false] = ACTIONS(2201),
    [sym_null] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_readonly] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_override] = ACTIONS(2201),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
  },
  [660] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [661] = {
    [ts_builtin_sym_end] = ACTIONS(1533),
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_export] = ACTIONS(1535),
    [anon_sym_default] = ACTIONS(1535),
    [anon_sym_type] = ACTIONS(1535),
    [anon_sym_namespace] = ACTIONS(1535),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_RBRACE] = ACTIONS(1533),
    [anon_sym_typeof] = ACTIONS(1535),
    [anon_sym_import] = ACTIONS(1535),
    [anon_sym_var] = ACTIONS(1535),
    [anon_sym_let] = ACTIONS(1535),
    [anon_sym_const] = ACTIONS(1535),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_else] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_LPAREN] = ACTIONS(1533),
    [anon_sym_await] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_do] = ACTIONS(1535),
    [anon_sym_try] = ACTIONS(1535),
    [anon_sym_with] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1535),
    [anon_sym_continue] = ACTIONS(1535),
    [anon_sym_debugger] = ACTIONS(1535),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_throw] = ACTIONS(1535),
    [anon_sym_SEMI] = ACTIONS(1533),
    [anon_sym_case] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1533),
    [anon_sym_LTtemplate_GT] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(1535),
    [anon_sym_async] = ACTIONS(1535),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1535),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1533),
    [anon_sym_void] = ACTIONS(1535),
    [anon_sym_delete] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1533),
    [sym_number] = ACTIONS(1533),
    [sym_this] = ACTIONS(1535),
    [sym_super] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_undefined] = ACTIONS(1535),
    [anon_sym_AT] = ACTIONS(1533),
    [anon_sym_static] = ACTIONS(1535),
    [anon_sym_readonly] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(1535),
    [anon_sym_set] = ACTIONS(1535),
    [anon_sym_declare] = ACTIONS(1535),
    [anon_sym_public] = ACTIONS(1535),
    [anon_sym_private] = ACTIONS(1535),
    [anon_sym_protected] = ACTIONS(1535),
    [anon_sym_override] = ACTIONS(1535),
    [anon_sym_module] = ACTIONS(1535),
    [anon_sym_any] = ACTIONS(1535),
    [anon_sym_number] = ACTIONS(1535),
    [anon_sym_boolean] = ACTIONS(1535),
    [anon_sym_string] = ACTIONS(1535),
    [anon_sym_symbol] = ACTIONS(1535),
    [anon_sym_abstract] = ACTIONS(1535),
    [anon_sym_interface] = ACTIONS(1535),
    [anon_sym_enum] = ACTIONS(1535),
  },
  [662] = {
    [ts_builtin_sym_end] = ACTIONS(2207),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2209),
    [anon_sym_default] = ACTIONS(2209),
    [anon_sym_type] = ACTIONS(2209),
    [anon_sym_namespace] = ACTIONS(2209),
    [anon_sym_LBRACE] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2207),
    [anon_sym_typeof] = ACTIONS(2209),
    [anon_sym_import] = ACTIONS(2209),
    [anon_sym_var] = ACTIONS(2209),
    [anon_sym_let] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2209),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_else] = ACTIONS(2209),
    [anon_sym_if] = ACTIONS(2209),
    [anon_sym_switch] = ACTIONS(2209),
    [anon_sym_for] = ACTIONS(2209),
    [anon_sym_LPAREN] = ACTIONS(2207),
    [anon_sym_await] = ACTIONS(2209),
    [anon_sym_while] = ACTIONS(2209),
    [anon_sym_do] = ACTIONS(2209),
    [anon_sym_try] = ACTIONS(2209),
    [anon_sym_with] = ACTIONS(2209),
    [anon_sym_break] = ACTIONS(2209),
    [anon_sym_continue] = ACTIONS(2209),
    [anon_sym_debugger] = ACTIONS(2209),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_throw] = ACTIONS(2209),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_case] = ACTIONS(2209),
    [anon_sym_yield] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(2207),
    [anon_sym_LTtemplate_GT] = ACTIONS(2207),
    [anon_sym_class] = ACTIONS(2209),
    [anon_sym_async] = ACTIONS(2209),
    [anon_sym_function] = ACTIONS(2209),
    [anon_sym_new] = ACTIONS(2209),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_SLASH] = ACTIONS(2209),
    [anon_sym_LT] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2207),
    [anon_sym_void] = ACTIONS(2209),
    [anon_sym_delete] = ACTIONS(2209),
    [anon_sym_PLUS_PLUS] = ACTIONS(2207),
    [anon_sym_DASH_DASH] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [anon_sym_SQUOTE] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_number] = ACTIONS(2207),
    [sym_this] = ACTIONS(2209),
    [sym_super] = ACTIONS(2209),
    [sym_true] = ACTIONS(2209),
    [sym_false] = ACTIONS(2209),
    [sym_null] = ACTIONS(2209),
    [sym_undefined] = ACTIONS(2209),
    [anon_sym_AT] = ACTIONS(2207),
    [anon_sym_static] = ACTIONS(2209),
    [anon_sym_readonly] = ACTIONS(2209),
    [anon_sym_get] = ACTIONS(2209),
    [anon_sym_set] = ACTIONS(2209),
    [anon_sym_declare] = ACTIONS(2209),
    [anon_sym_public] = ACTIONS(2209),
    [anon_sym_private] = ACTIONS(2209),
    [anon_sym_protected] = ACTIONS(2209),
    [anon_sym_override] = ACTIONS(2209),
    [anon_sym_module] = ACTIONS(2209),
    [anon_sym_any] = ACTIONS(2209),
    [anon_sym_number] = ACTIONS(2209),
    [anon_sym_boolean] = ACTIONS(2209),
    [anon_sym_string] = ACTIONS(2209),
    [anon_sym_symbol] = ACTIONS(2209),
    [anon_sym_abstract] = ACTIONS(2209),
    [anon_sym_interface] = ACTIONS(2209),
    [anon_sym_enum] = ACTIONS(2209),
  },
  [663] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [664] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [665] = {
    [ts_builtin_sym_end] = ACTIONS(1537),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(1539),
    [anon_sym_type] = ACTIONS(1539),
    [anon_sym_namespace] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_RBRACE] = ACTIONS(1537),
    [anon_sym_typeof] = ACTIONS(1539),
    [anon_sym_import] = ACTIONS(1539),
    [anon_sym_var] = ACTIONS(1539),
    [anon_sym_let] = ACTIONS(1539),
    [anon_sym_const] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1537),
    [anon_sym_else] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_switch] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_do] = ACTIONS(1539),
    [anon_sym_try] = ACTIONS(1539),
    [anon_sym_with] = ACTIONS(1539),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_continue] = ACTIONS(1539),
    [anon_sym_debugger] = ACTIONS(1539),
    [anon_sym_return] = ACTIONS(1539),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1537),
    [anon_sym_case] = ACTIONS(1539),
    [anon_sym_yield] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1537),
    [anon_sym_LTtemplate_GT] = ACTIONS(1537),
    [anon_sym_class] = ACTIONS(1539),
    [anon_sym_async] = ACTIONS(1539),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_new] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_void] = ACTIONS(1539),
    [anon_sym_delete] = ACTIONS(1539),
    [anon_sym_PLUS_PLUS] = ACTIONS(1537),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1537),
    [sym_number] = ACTIONS(1537),
    [sym_this] = ACTIONS(1539),
    [sym_super] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_undefined] = ACTIONS(1539),
    [anon_sym_AT] = ACTIONS(1537),
    [anon_sym_static] = ACTIONS(1539),
    [anon_sym_readonly] = ACTIONS(1539),
    [anon_sym_get] = ACTIONS(1539),
    [anon_sym_set] = ACTIONS(1539),
    [anon_sym_declare] = ACTIONS(1539),
    [anon_sym_public] = ACTIONS(1539),
    [anon_sym_private] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1539),
    [anon_sym_override] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1539),
    [anon_sym_any] = ACTIONS(1539),
    [anon_sym_number] = ACTIONS(1539),
    [anon_sym_boolean] = ACTIONS(1539),
    [anon_sym_string] = ACTIONS(1539),
    [anon_sym_symbol] = ACTIONS(1539),
    [anon_sym_abstract] = ACTIONS(1539),
    [anon_sym_interface] = ACTIONS(1539),
    [anon_sym_enum] = ACTIONS(1539),
  },
  [666] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [667] = {
    [ts_builtin_sym_end] = ACTIONS(2211),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_export] = ACTIONS(2213),
    [anon_sym_default] = ACTIONS(2213),
    [anon_sym_type] = ACTIONS(2213),
    [anon_sym_namespace] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_RBRACE] = ACTIONS(2211),
    [anon_sym_typeof] = ACTIONS(2213),
    [anon_sym_import] = ACTIONS(2213),
    [anon_sym_var] = ACTIONS(2213),
    [anon_sym_let] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_else] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_for] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2211),
    [anon_sym_await] = ACTIONS(2213),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_do] = ACTIONS(2213),
    [anon_sym_try] = ACTIONS(2213),
    [anon_sym_with] = ACTIONS(2213),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_debugger] = ACTIONS(2213),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_throw] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_case] = ACTIONS(2213),
    [anon_sym_yield] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_LTtemplate_GT] = ACTIONS(2211),
    [anon_sym_class] = ACTIONS(2213),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2213),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_void] = ACTIONS(2213),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [anon_sym_SQUOTE] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [sym_number] = ACTIONS(2211),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(2213),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2211),
    [anon_sym_static] = ACTIONS(2213),
    [anon_sym_readonly] = ACTIONS(2213),
    [anon_sym_get] = ACTIONS(2213),
    [anon_sym_set] = ACTIONS(2213),
    [anon_sym_declare] = ACTIONS(2213),
    [anon_sym_public] = ACTIONS(2213),
    [anon_sym_private] = ACTIONS(2213),
    [anon_sym_protected] = ACTIONS(2213),
    [anon_sym_override] = ACTIONS(2213),
    [anon_sym_module] = ACTIONS(2213),
    [anon_sym_any] = ACTIONS(2213),
    [anon_sym_number] = ACTIONS(2213),
    [anon_sym_boolean] = ACTIONS(2213),
    [anon_sym_string] = ACTIONS(2213),
    [anon_sym_symbol] = ACTIONS(2213),
    [anon_sym_abstract] = ACTIONS(2213),
    [anon_sym_interface] = ACTIONS(2213),
    [anon_sym_enum] = ACTIONS(2213),
  },
  [668] = {
    [ts_builtin_sym_end] = ACTIONS(1481),
    [sym_identifier] = ACTIONS(1483),
    [anon_sym_export] = ACTIONS(1483),
    [anon_sym_default] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(1483),
    [anon_sym_namespace] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(1481),
    [anon_sym_RBRACE] = ACTIONS(1481),
    [anon_sym_typeof] = ACTIONS(1483),
    [anon_sym_import] = ACTIONS(1483),
    [anon_sym_var] = ACTIONS(1483),
    [anon_sym_let] = ACTIONS(1483),
    [anon_sym_const] = ACTIONS(1483),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_else] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(1483),
    [anon_sym_switch] = ACTIONS(1483),
    [anon_sym_for] = ACTIONS(1483),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_while] = ACTIONS(1483),
    [anon_sym_do] = ACTIONS(1483),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1483),
    [anon_sym_break] = ACTIONS(1483),
    [anon_sym_continue] = ACTIONS(1483),
    [anon_sym_debugger] = ACTIONS(1483),
    [anon_sym_return] = ACTIONS(1483),
    [anon_sym_throw] = ACTIONS(1483),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_case] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1483),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_LTtemplate_GT] = ACTIONS(1481),
    [anon_sym_class] = ACTIONS(1483),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1483),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1483),
    [anon_sym_delete] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_DQUOTE] = ACTIONS(1481),
    [anon_sym_SQUOTE] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1481),
    [sym_number] = ACTIONS(1481),
    [sym_this] = ACTIONS(1483),
    [sym_super] = ACTIONS(1483),
    [sym_true] = ACTIONS(1483),
    [sym_false] = ACTIONS(1483),
    [sym_null] = ACTIONS(1483),
    [sym_undefined] = ACTIONS(1483),
    [anon_sym_AT] = ACTIONS(1481),
    [anon_sym_static] = ACTIONS(1483),
    [anon_sym_readonly] = ACTIONS(1483),
    [anon_sym_get] = ACTIONS(1483),
    [anon_sym_set] = ACTIONS(1483),
    [anon_sym_declare] = ACTIONS(1483),
    [anon_sym_public] = ACTIONS(1483),
    [anon_sym_private] = ACTIONS(1483),
    [anon_sym_protected] = ACTIONS(1483),
    [anon_sym_override] = ACTIONS(1483),
    [anon_sym_module] = ACTIONS(1483),
    [anon_sym_any] = ACTIONS(1483),
    [anon_sym_number] = ACTIONS(1483),
    [anon_sym_boolean] = ACTIONS(1483),
    [anon_sym_string] = ACTIONS(1483),
    [anon_sym_symbol] = ACTIONS(1483),
    [anon_sym_abstract] = ACTIONS(1483),
    [anon_sym_interface] = ACTIONS(1483),
    [anon_sym_enum] = ACTIONS(1483),
  },
  [669] = {
    [ts_builtin_sym_end] = ACTIONS(2215),
    [sym_identifier] = ACTIONS(2217),
    [anon_sym_export] = ACTIONS(2217),
    [anon_sym_default] = ACTIONS(2217),
    [anon_sym_type] = ACTIONS(2217),
    [anon_sym_namespace] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_typeof] = ACTIONS(2217),
    [anon_sym_import] = ACTIONS(2217),
    [anon_sym_var] = ACTIONS(2217),
    [anon_sym_let] = ACTIONS(2217),
    [anon_sym_const] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2215),
    [anon_sym_else] = ACTIONS(2217),
    [anon_sym_if] = ACTIONS(2217),
    [anon_sym_switch] = ACTIONS(2217),
    [anon_sym_for] = ACTIONS(2217),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_while] = ACTIONS(2217),
    [anon_sym_do] = ACTIONS(2217),
    [anon_sym_try] = ACTIONS(2217),
    [anon_sym_with] = ACTIONS(2217),
    [anon_sym_break] = ACTIONS(2217),
    [anon_sym_continue] = ACTIONS(2217),
    [anon_sym_debugger] = ACTIONS(2217),
    [anon_sym_return] = ACTIONS(2217),
    [anon_sym_throw] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_case] = ACTIONS(2217),
    [anon_sym_yield] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_LTtemplate_GT] = ACTIONS(2215),
    [anon_sym_class] = ACTIONS(2217),
    [anon_sym_async] = ACTIONS(2217),
    [anon_sym_function] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2217),
    [anon_sym_SLASH] = ACTIONS(2217),
    [anon_sym_LT] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2215),
    [anon_sym_void] = ACTIONS(2217),
    [anon_sym_delete] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2215),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2215),
    [anon_sym_SQUOTE] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2215),
    [sym_number] = ACTIONS(2215),
    [sym_this] = ACTIONS(2217),
    [sym_super] = ACTIONS(2217),
    [sym_true] = ACTIONS(2217),
    [sym_false] = ACTIONS(2217),
    [sym_null] = ACTIONS(2217),
    [sym_undefined] = ACTIONS(2217),
    [anon_sym_AT] = ACTIONS(2215),
    [anon_sym_static] = ACTIONS(2217),
    [anon_sym_readonly] = ACTIONS(2217),
    [anon_sym_get] = ACTIONS(2217),
    [anon_sym_set] = ACTIONS(2217),
    [anon_sym_declare] = ACTIONS(2217),
    [anon_sym_public] = ACTIONS(2217),
    [anon_sym_private] = ACTIONS(2217),
    [anon_sym_protected] = ACTIONS(2217),
    [anon_sym_override] = ACTIONS(2217),
    [anon_sym_module] = ACTIONS(2217),
    [anon_sym_any] = ACTIONS(2217),
    [anon_sym_number] = ACTIONS(2217),
    [anon_sym_boolean] = ACTIONS(2217),
    [anon_sym_string] = ACTIONS(2217),
    [anon_sym_symbol] = ACTIONS(2217),
    [anon_sym_abstract] = ACTIONS(2217),
    [anon_sym_interface] = ACTIONS(2217),
    [anon_sym_enum] = ACTIONS(2217),
  },
  [670] = {
    [ts_builtin_sym_end] = ACTIONS(2219),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2219),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2219),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LTtemplate_GT] = ACTIONS(2219),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2219),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2219),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [anon_sym_SQUOTE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [sym_number] = ACTIONS(2219),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
  },
  [671] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [672] = {
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_default] = ACTIONS(2225),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_else] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2223),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_case] = ACTIONS(2225),
    [anon_sym_yield] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_LTtemplate_GT] = ACTIONS(2223),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_function] = ACTIONS(2225),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2225),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [anon_sym_SQUOTE] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [sym_number] = ACTIONS(2223),
    [sym_this] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [sym_false] = ACTIONS(2225),
    [sym_null] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2225),
    [anon_sym_readonly] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_override] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
  },
  [673] = {
    [ts_builtin_sym_end] = ACTIONS(2227),
    [sym_identifier] = ACTIONS(2229),
    [anon_sym_export] = ACTIONS(2229),
    [anon_sym_default] = ACTIONS(2229),
    [anon_sym_type] = ACTIONS(2229),
    [anon_sym_namespace] = ACTIONS(2229),
    [anon_sym_LBRACE] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2227),
    [anon_sym_typeof] = ACTIONS(2229),
    [anon_sym_import] = ACTIONS(2229),
    [anon_sym_var] = ACTIONS(2229),
    [anon_sym_let] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_else] = ACTIONS(2229),
    [anon_sym_if] = ACTIONS(2229),
    [anon_sym_switch] = ACTIONS(2229),
    [anon_sym_for] = ACTIONS(2229),
    [anon_sym_LPAREN] = ACTIONS(2227),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_while] = ACTIONS(2229),
    [anon_sym_do] = ACTIONS(2229),
    [anon_sym_try] = ACTIONS(2229),
    [anon_sym_with] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2229),
    [anon_sym_continue] = ACTIONS(2229),
    [anon_sym_debugger] = ACTIONS(2229),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_throw] = ACTIONS(2229),
    [anon_sym_SEMI] = ACTIONS(2227),
    [anon_sym_case] = ACTIONS(2229),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2227),
    [anon_sym_LTtemplate_GT] = ACTIONS(2227),
    [anon_sym_class] = ACTIONS(2229),
    [anon_sym_async] = ACTIONS(2229),
    [anon_sym_function] = ACTIONS(2229),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_LT] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_void] = ACTIONS(2229),
    [anon_sym_delete] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2227),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2227),
    [anon_sym_SQUOTE] = ACTIONS(2227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2227),
    [sym_number] = ACTIONS(2227),
    [sym_this] = ACTIONS(2229),
    [sym_super] = ACTIONS(2229),
    [sym_true] = ACTIONS(2229),
    [sym_false] = ACTIONS(2229),
    [sym_null] = ACTIONS(2229),
    [sym_undefined] = ACTIONS(2229),
    [anon_sym_AT] = ACTIONS(2227),
    [anon_sym_static] = ACTIONS(2229),
    [anon_sym_readonly] = ACTIONS(2229),
    [anon_sym_get] = ACTIONS(2229),
    [anon_sym_set] = ACTIONS(2229),
    [anon_sym_declare] = ACTIONS(2229),
    [anon_sym_public] = ACTIONS(2229),
    [anon_sym_private] = ACTIONS(2229),
    [anon_sym_protected] = ACTIONS(2229),
    [anon_sym_override] = ACTIONS(2229),
    [anon_sym_module] = ACTIONS(2229),
    [anon_sym_any] = ACTIONS(2229),
    [anon_sym_number] = ACTIONS(2229),
    [anon_sym_boolean] = ACTIONS(2229),
    [anon_sym_string] = ACTIONS(2229),
    [anon_sym_symbol] = ACTIONS(2229),
    [anon_sym_abstract] = ACTIONS(2229),
    [anon_sym_interface] = ACTIONS(2229),
    [anon_sym_enum] = ACTIONS(2229),
  },
  [674] = {
    [ts_builtin_sym_end] = ACTIONS(1525),
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_export] = ACTIONS(1527),
    [anon_sym_default] = ACTIONS(1527),
    [anon_sym_type] = ACTIONS(1527),
    [anon_sym_namespace] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_RBRACE] = ACTIONS(1525),
    [anon_sym_typeof] = ACTIONS(1527),
    [anon_sym_import] = ACTIONS(1527),
    [anon_sym_var] = ACTIONS(1527),
    [anon_sym_let] = ACTIONS(1527),
    [anon_sym_const] = ACTIONS(1527),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_else] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_switch] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_LPAREN] = ACTIONS(1525),
    [anon_sym_await] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(1527),
    [anon_sym_try] = ACTIONS(1527),
    [anon_sym_with] = ACTIONS(1527),
    [anon_sym_break] = ACTIONS(1527),
    [anon_sym_continue] = ACTIONS(1527),
    [anon_sym_debugger] = ACTIONS(1527),
    [anon_sym_return] = ACTIONS(1527),
    [anon_sym_throw] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_case] = ACTIONS(1527),
    [anon_sym_yield] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(1525),
    [anon_sym_LTtemplate_GT] = ACTIONS(1525),
    [anon_sym_class] = ACTIONS(1527),
    [anon_sym_async] = ACTIONS(1527),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1527),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_void] = ACTIONS(1527),
    [anon_sym_delete] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1525),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [sym_number] = ACTIONS(1525),
    [sym_this] = ACTIONS(1527),
    [sym_super] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_undefined] = ACTIONS(1527),
    [anon_sym_AT] = ACTIONS(1525),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_readonly] = ACTIONS(1527),
    [anon_sym_get] = ACTIONS(1527),
    [anon_sym_set] = ACTIONS(1527),
    [anon_sym_declare] = ACTIONS(1527),
    [anon_sym_public] = ACTIONS(1527),
    [anon_sym_private] = ACTIONS(1527),
    [anon_sym_protected] = ACTIONS(1527),
    [anon_sym_override] = ACTIONS(1527),
    [anon_sym_module] = ACTIONS(1527),
    [anon_sym_any] = ACTIONS(1527),
    [anon_sym_number] = ACTIONS(1527),
    [anon_sym_boolean] = ACTIONS(1527),
    [anon_sym_string] = ACTIONS(1527),
    [anon_sym_symbol] = ACTIONS(1527),
    [anon_sym_abstract] = ACTIONS(1527),
    [anon_sym_interface] = ACTIONS(1527),
    [anon_sym_enum] = ACTIONS(1527),
  },
  [675] = {
    [ts_builtin_sym_end] = ACTIONS(2231),
    [sym_identifier] = ACTIONS(2233),
    [anon_sym_export] = ACTIONS(2233),
    [anon_sym_default] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(2233),
    [anon_sym_namespace] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2231),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_typeof] = ACTIONS(2233),
    [anon_sym_import] = ACTIONS(2233),
    [anon_sym_var] = ACTIONS(2233),
    [anon_sym_let] = ACTIONS(2233),
    [anon_sym_const] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2231),
    [anon_sym_else] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_for] = ACTIONS(2233),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_await] = ACTIONS(2233),
    [anon_sym_while] = ACTIONS(2233),
    [anon_sym_do] = ACTIONS(2233),
    [anon_sym_try] = ACTIONS(2233),
    [anon_sym_with] = ACTIONS(2233),
    [anon_sym_break] = ACTIONS(2233),
    [anon_sym_continue] = ACTIONS(2233),
    [anon_sym_debugger] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2233),
    [anon_sym_throw] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2231),
    [anon_sym_case] = ACTIONS(2233),
    [anon_sym_yield] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_LTtemplate_GT] = ACTIONS(2231),
    [anon_sym_class] = ACTIONS(2233),
    [anon_sym_async] = ACTIONS(2233),
    [anon_sym_function] = ACTIONS(2233),
    [anon_sym_new] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2231),
    [anon_sym_void] = ACTIONS(2233),
    [anon_sym_delete] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2231),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2231),
    [anon_sym_SQUOTE] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2231),
    [sym_number] = ACTIONS(2231),
    [sym_this] = ACTIONS(2233),
    [sym_super] = ACTIONS(2233),
    [sym_true] = ACTIONS(2233),
    [sym_false] = ACTIONS(2233),
    [sym_null] = ACTIONS(2233),
    [sym_undefined] = ACTIONS(2233),
    [anon_sym_AT] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2233),
    [anon_sym_readonly] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2233),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_declare] = ACTIONS(2233),
    [anon_sym_public] = ACTIONS(2233),
    [anon_sym_private] = ACTIONS(2233),
    [anon_sym_protected] = ACTIONS(2233),
    [anon_sym_override] = ACTIONS(2233),
    [anon_sym_module] = ACTIONS(2233),
    [anon_sym_any] = ACTIONS(2233),
    [anon_sym_number] = ACTIONS(2233),
    [anon_sym_boolean] = ACTIONS(2233),
    [anon_sym_string] = ACTIONS(2233),
    [anon_sym_symbol] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2233),
    [anon_sym_interface] = ACTIONS(2233),
    [anon_sym_enum] = ACTIONS(2233),
  },
  [676] = {
    [ts_builtin_sym_end] = ACTIONS(2235),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_export] = ACTIONS(2237),
    [anon_sym_default] = ACTIONS(2237),
    [anon_sym_type] = ACTIONS(2237),
    [anon_sym_namespace] = ACTIONS(2237),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_typeof] = ACTIONS(2237),
    [anon_sym_import] = ACTIONS(2237),
    [anon_sym_var] = ACTIONS(2237),
    [anon_sym_let] = ACTIONS(2237),
    [anon_sym_const] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2237),
    [anon_sym_if] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_for] = ACTIONS(2237),
    [anon_sym_LPAREN] = ACTIONS(2235),
    [anon_sym_await] = ACTIONS(2237),
    [anon_sym_while] = ACTIONS(2237),
    [anon_sym_do] = ACTIONS(2237),
    [anon_sym_try] = ACTIONS(2237),
    [anon_sym_with] = ACTIONS(2237),
    [anon_sym_break] = ACTIONS(2237),
    [anon_sym_continue] = ACTIONS(2237),
    [anon_sym_debugger] = ACTIONS(2237),
    [anon_sym_return] = ACTIONS(2237),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_case] = ACTIONS(2237),
    [anon_sym_yield] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_LTtemplate_GT] = ACTIONS(2235),
    [anon_sym_class] = ACTIONS(2237),
    [anon_sym_async] = ACTIONS(2237),
    [anon_sym_function] = ACTIONS(2237),
    [anon_sym_new] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_SLASH] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2235),
    [anon_sym_void] = ACTIONS(2237),
    [anon_sym_delete] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2235),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2235),
    [anon_sym_SQUOTE] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2235),
    [sym_number] = ACTIONS(2235),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2235),
    [anon_sym_static] = ACTIONS(2237),
    [anon_sym_readonly] = ACTIONS(2237),
    [anon_sym_get] = ACTIONS(2237),
    [anon_sym_set] = ACTIONS(2237),
    [anon_sym_declare] = ACTIONS(2237),
    [anon_sym_public] = ACTIONS(2237),
    [anon_sym_private] = ACTIONS(2237),
    [anon_sym_protected] = ACTIONS(2237),
    [anon_sym_override] = ACTIONS(2237),
    [anon_sym_module] = ACTIONS(2237),
    [anon_sym_any] = ACTIONS(2237),
    [anon_sym_number] = ACTIONS(2237),
    [anon_sym_boolean] = ACTIONS(2237),
    [anon_sym_string] = ACTIONS(2237),
    [anon_sym_symbol] = ACTIONS(2237),
    [anon_sym_abstract] = ACTIONS(2237),
    [anon_sym_interface] = ACTIONS(2237),
    [anon_sym_enum] = ACTIONS(2237),
  },
  [677] = {
    [ts_builtin_sym_end] = ACTIONS(2239),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_export] = ACTIONS(2241),
    [anon_sym_default] = ACTIONS(2241),
    [anon_sym_type] = ACTIONS(2241),
    [anon_sym_namespace] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2239),
    [anon_sym_RBRACE] = ACTIONS(2239),
    [anon_sym_typeof] = ACTIONS(2241),
    [anon_sym_import] = ACTIONS(2241),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_const] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_else] = ACTIONS(2241),
    [anon_sym_if] = ACTIONS(2241),
    [anon_sym_switch] = ACTIONS(2241),
    [anon_sym_for] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2239),
    [anon_sym_await] = ACTIONS(2241),
    [anon_sym_while] = ACTIONS(2241),
    [anon_sym_do] = ACTIONS(2241),
    [anon_sym_try] = ACTIONS(2241),
    [anon_sym_with] = ACTIONS(2241),
    [anon_sym_break] = ACTIONS(2241),
    [anon_sym_continue] = ACTIONS(2241),
    [anon_sym_debugger] = ACTIONS(2241),
    [anon_sym_return] = ACTIONS(2241),
    [anon_sym_throw] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2241),
    [anon_sym_yield] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_LTtemplate_GT] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2241),
    [anon_sym_async] = ACTIONS(2241),
    [anon_sym_function] = ACTIONS(2241),
    [anon_sym_new] = ACTIONS(2241),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_void] = ACTIONS(2241),
    [anon_sym_delete] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2239),
    [anon_sym_SQUOTE] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2239),
    [sym_number] = ACTIONS(2239),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(2241),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2241),
    [anon_sym_readonly] = ACTIONS(2241),
    [anon_sym_get] = ACTIONS(2241),
    [anon_sym_set] = ACTIONS(2241),
    [anon_sym_declare] = ACTIONS(2241),
    [anon_sym_public] = ACTIONS(2241),
    [anon_sym_private] = ACTIONS(2241),
    [anon_sym_protected] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_module] = ACTIONS(2241),
    [anon_sym_any] = ACTIONS(2241),
    [anon_sym_number] = ACTIONS(2241),
    [anon_sym_boolean] = ACTIONS(2241),
    [anon_sym_string] = ACTIONS(2241),
    [anon_sym_symbol] = ACTIONS(2241),
    [anon_sym_abstract] = ACTIONS(2241),
    [anon_sym_interface] = ACTIONS(2241),
    [anon_sym_enum] = ACTIONS(2241),
  },
  [678] = {
    [ts_builtin_sym_end] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(2245),
    [anon_sym_export] = ACTIONS(2245),
    [anon_sym_default] = ACTIONS(2245),
    [anon_sym_type] = ACTIONS(2245),
    [anon_sym_namespace] = ACTIONS(2245),
    [anon_sym_LBRACE] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(2243),
    [anon_sym_typeof] = ACTIONS(2245),
    [anon_sym_import] = ACTIONS(2245),
    [anon_sym_var] = ACTIONS(2245),
    [anon_sym_let] = ACTIONS(2245),
    [anon_sym_const] = ACTIONS(2245),
    [anon_sym_BANG] = ACTIONS(2243),
    [anon_sym_else] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(2245),
    [anon_sym_switch] = ACTIONS(2245),
    [anon_sym_for] = ACTIONS(2245),
    [anon_sym_LPAREN] = ACTIONS(2243),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_while] = ACTIONS(2245),
    [anon_sym_do] = ACTIONS(2245),
    [anon_sym_try] = ACTIONS(2245),
    [anon_sym_with] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(2245),
    [anon_sym_continue] = ACTIONS(2245),
    [anon_sym_debugger] = ACTIONS(2245),
    [anon_sym_return] = ACTIONS(2245),
    [anon_sym_throw] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2245),
    [anon_sym_yield] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_LTtemplate_GT] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2245),
    [anon_sym_async] = ACTIONS(2245),
    [anon_sym_function] = ACTIONS(2245),
    [anon_sym_new] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2245),
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_TILDE] = ACTIONS(2243),
    [anon_sym_void] = ACTIONS(2245),
    [anon_sym_delete] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_DQUOTE] = ACTIONS(2243),
    [anon_sym_SQUOTE] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2243),
    [sym_number] = ACTIONS(2243),
    [sym_this] = ACTIONS(2245),
    [sym_super] = ACTIONS(2245),
    [sym_true] = ACTIONS(2245),
    [sym_false] = ACTIONS(2245),
    [sym_null] = ACTIONS(2245),
    [sym_undefined] = ACTIONS(2245),
    [anon_sym_AT] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2245),
    [anon_sym_readonly] = ACTIONS(2245),
    [anon_sym_get] = ACTIONS(2245),
    [anon_sym_set] = ACTIONS(2245),
    [anon_sym_declare] = ACTIONS(2245),
    [anon_sym_public] = ACTIONS(2245),
    [anon_sym_private] = ACTIONS(2245),
    [anon_sym_protected] = ACTIONS(2245),
    [anon_sym_override] = ACTIONS(2245),
    [anon_sym_module] = ACTIONS(2245),
    [anon_sym_any] = ACTIONS(2245),
    [anon_sym_number] = ACTIONS(2245),
    [anon_sym_boolean] = ACTIONS(2245),
    [anon_sym_string] = ACTIONS(2245),
    [anon_sym_symbol] = ACTIONS(2245),
    [anon_sym_abstract] = ACTIONS(2245),
    [anon_sym_interface] = ACTIONS(2245),
    [anon_sym_enum] = ACTIONS(2245),
  },
  [679] = {
    [ts_builtin_sym_end] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2249),
    [anon_sym_export] = ACTIONS(2249),
    [anon_sym_default] = ACTIONS(2249),
    [anon_sym_type] = ACTIONS(2249),
    [anon_sym_namespace] = ACTIONS(2249),
    [anon_sym_LBRACE] = ACTIONS(2247),
    [anon_sym_RBRACE] = ACTIONS(2247),
    [anon_sym_typeof] = ACTIONS(2249),
    [anon_sym_import] = ACTIONS(2249),
    [anon_sym_var] = ACTIONS(2249),
    [anon_sym_let] = ACTIONS(2249),
    [anon_sym_const] = ACTIONS(2249),
    [anon_sym_BANG] = ACTIONS(2247),
    [anon_sym_else] = ACTIONS(2249),
    [anon_sym_if] = ACTIONS(2249),
    [anon_sym_switch] = ACTIONS(2249),
    [anon_sym_for] = ACTIONS(2249),
    [anon_sym_LPAREN] = ACTIONS(2247),
    [anon_sym_await] = ACTIONS(2249),
    [anon_sym_while] = ACTIONS(2249),
    [anon_sym_do] = ACTIONS(2249),
    [anon_sym_try] = ACTIONS(2249),
    [anon_sym_with] = ACTIONS(2249),
    [anon_sym_break] = ACTIONS(2249),
    [anon_sym_continue] = ACTIONS(2249),
    [anon_sym_debugger] = ACTIONS(2249),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_throw] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym_case] = ACTIONS(2249),
    [anon_sym_yield] = ACTIONS(2249),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_LTtemplate_GT] = ACTIONS(2247),
    [anon_sym_class] = ACTIONS(2249),
    [anon_sym_async] = ACTIONS(2249),
    [anon_sym_function] = ACTIONS(2249),
    [anon_sym_new] = ACTIONS(2249),
    [anon_sym_PLUS] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2249),
    [anon_sym_SLASH] = ACTIONS(2249),
    [anon_sym_LT] = ACTIONS(2249),
    [anon_sym_TILDE] = ACTIONS(2247),
    [anon_sym_void] = ACTIONS(2249),
    [anon_sym_delete] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2247),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [sym_number] = ACTIONS(2247),
    [sym_this] = ACTIONS(2249),
    [sym_super] = ACTIONS(2249),
    [sym_true] = ACTIONS(2249),
    [sym_false] = ACTIONS(2249),
    [sym_null] = ACTIONS(2249),
    [sym_undefined] = ACTIONS(2249),
    [anon_sym_AT] = ACTIONS(2247),
    [anon_sym_static] = ACTIONS(2249),
    [anon_sym_readonly] = ACTIONS(2249),
    [anon_sym_get] = ACTIONS(2249),
    [anon_sym_set] = ACTIONS(2249),
    [anon_sym_declare] = ACTIONS(2249),
    [anon_sym_public] = ACTIONS(2249),
    [anon_sym_private] = ACTIONS(2249),
    [anon_sym_protected] = ACTIONS(2249),
    [anon_sym_override] = ACTIONS(2249),
    [anon_sym_module] = ACTIONS(2249),
    [anon_sym_any] = ACTIONS(2249),
    [anon_sym_number] = ACTIONS(2249),
    [anon_sym_boolean] = ACTIONS(2249),
    [anon_sym_string] = ACTIONS(2249),
    [anon_sym_symbol] = ACTIONS(2249),
    [anon_sym_abstract] = ACTIONS(2249),
    [anon_sym_interface] = ACTIONS(2249),
    [anon_sym_enum] = ACTIONS(2249),
  },
  [680] = {
    [ts_builtin_sym_end] = ACTIONS(2251),
    [sym_identifier] = ACTIONS(2253),
    [anon_sym_export] = ACTIONS(2253),
    [anon_sym_default] = ACTIONS(2253),
    [anon_sym_type] = ACTIONS(2253),
    [anon_sym_namespace] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2253),
    [anon_sym_import] = ACTIONS(2253),
    [anon_sym_var] = ACTIONS(2253),
    [anon_sym_let] = ACTIONS(2253),
    [anon_sym_const] = ACTIONS(2253),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2253),
    [anon_sym_if] = ACTIONS(2253),
    [anon_sym_switch] = ACTIONS(2253),
    [anon_sym_for] = ACTIONS(2253),
    [anon_sym_LPAREN] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2253),
    [anon_sym_while] = ACTIONS(2253),
    [anon_sym_do] = ACTIONS(2253),
    [anon_sym_try] = ACTIONS(2253),
    [anon_sym_with] = ACTIONS(2253),
    [anon_sym_break] = ACTIONS(2253),
    [anon_sym_continue] = ACTIONS(2253),
    [anon_sym_debugger] = ACTIONS(2253),
    [anon_sym_return] = ACTIONS(2253),
    [anon_sym_throw] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2253),
    [anon_sym_yield] = ACTIONS(2253),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_LTtemplate_GT] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2253),
    [anon_sym_async] = ACTIONS(2253),
    [anon_sym_function] = ACTIONS(2253),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_DASH] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2253),
    [anon_sym_LT] = ACTIONS(2253),
    [anon_sym_TILDE] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2253),
    [anon_sym_delete] = ACTIONS(2253),
    [anon_sym_PLUS_PLUS] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2253),
    [anon_sym_DQUOTE] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_number] = ACTIONS(2251),
    [sym_this] = ACTIONS(2253),
    [sym_super] = ACTIONS(2253),
    [sym_true] = ACTIONS(2253),
    [sym_false] = ACTIONS(2253),
    [sym_null] = ACTIONS(2253),
    [sym_undefined] = ACTIONS(2253),
    [anon_sym_AT] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2253),
    [anon_sym_readonly] = ACTIONS(2253),
    [anon_sym_get] = ACTIONS(2253),
    [anon_sym_set] = ACTIONS(2253),
    [anon_sym_declare] = ACTIONS(2253),
    [anon_sym_public] = ACTIONS(2253),
    [anon_sym_private] = ACTIONS(2253),
    [anon_sym_protected] = ACTIONS(2253),
    [anon_sym_override] = ACTIONS(2253),
    [anon_sym_module] = ACTIONS(2253),
    [anon_sym_any] = ACTIONS(2253),
    [anon_sym_number] = ACTIONS(2253),
    [anon_sym_boolean] = ACTIONS(2253),
    [anon_sym_string] = ACTIONS(2253),
    [anon_sym_symbol] = ACTIONS(2253),
    [anon_sym_abstract] = ACTIONS(2253),
    [anon_sym_interface] = ACTIONS(2253),
    [anon_sym_enum] = ACTIONS(2253),
  },
  [681] = {
    [ts_builtin_sym_end] = ACTIONS(2255),
    [sym_identifier] = ACTIONS(2257),
    [anon_sym_export] = ACTIONS(2257),
    [anon_sym_default] = ACTIONS(2257),
    [anon_sym_type] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(2255),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_typeof] = ACTIONS(2257),
    [anon_sym_import] = ACTIONS(2257),
    [anon_sym_var] = ACTIONS(2257),
    [anon_sym_let] = ACTIONS(2257),
    [anon_sym_const] = ACTIONS(2257),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_else] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_switch] = ACTIONS(2257),
    [anon_sym_for] = ACTIONS(2257),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_await] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_do] = ACTIONS(2257),
    [anon_sym_try] = ACTIONS(2257),
    [anon_sym_with] = ACTIONS(2257),
    [anon_sym_break] = ACTIONS(2257),
    [anon_sym_continue] = ACTIONS(2257),
    [anon_sym_debugger] = ACTIONS(2257),
    [anon_sym_return] = ACTIONS(2257),
    [anon_sym_throw] = ACTIONS(2257),
    [anon_sym_SEMI] = ACTIONS(2255),
    [anon_sym_case] = ACTIONS(2257),
    [anon_sym_yield] = ACTIONS(2257),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_LTtemplate_GT] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2257),
    [anon_sym_async] = ACTIONS(2257),
    [anon_sym_function] = ACTIONS(2257),
    [anon_sym_new] = ACTIONS(2257),
    [anon_sym_PLUS] = ACTIONS(2257),
    [anon_sym_DASH] = ACTIONS(2257),
    [anon_sym_SLASH] = ACTIONS(2257),
    [anon_sym_LT] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2255),
    [anon_sym_void] = ACTIONS(2257),
    [anon_sym_delete] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(2255),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [sym_number] = ACTIONS(2255),
    [sym_this] = ACTIONS(2257),
    [sym_super] = ACTIONS(2257),
    [sym_true] = ACTIONS(2257),
    [sym_false] = ACTIONS(2257),
    [sym_null] = ACTIONS(2257),
    [sym_undefined] = ACTIONS(2257),
    [anon_sym_AT] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2257),
    [anon_sym_readonly] = ACTIONS(2257),
    [anon_sym_get] = ACTIONS(2257),
    [anon_sym_set] = ACTIONS(2257),
    [anon_sym_declare] = ACTIONS(2257),
    [anon_sym_public] = ACTIONS(2257),
    [anon_sym_private] = ACTIONS(2257),
    [anon_sym_protected] = ACTIONS(2257),
    [anon_sym_override] = ACTIONS(2257),
    [anon_sym_module] = ACTIONS(2257),
    [anon_sym_any] = ACTIONS(2257),
    [anon_sym_number] = ACTIONS(2257),
    [anon_sym_boolean] = ACTIONS(2257),
    [anon_sym_string] = ACTIONS(2257),
    [anon_sym_symbol] = ACTIONS(2257),
    [anon_sym_abstract] = ACTIONS(2257),
    [anon_sym_interface] = ACTIONS(2257),
    [anon_sym_enum] = ACTIONS(2257),
  },
  [682] = {
    [ts_builtin_sym_end] = ACTIONS(2259),
    [sym_identifier] = ACTIONS(2261),
    [anon_sym_export] = ACTIONS(2261),
    [anon_sym_default] = ACTIONS(2261),
    [anon_sym_type] = ACTIONS(2261),
    [anon_sym_namespace] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_RBRACE] = ACTIONS(2259),
    [anon_sym_typeof] = ACTIONS(2261),
    [anon_sym_import] = ACTIONS(2261),
    [anon_sym_var] = ACTIONS(2261),
    [anon_sym_let] = ACTIONS(2261),
    [anon_sym_const] = ACTIONS(2261),
    [anon_sym_BANG] = ACTIONS(2259),
    [anon_sym_else] = ACTIONS(2261),
    [anon_sym_if] = ACTIONS(2261),
    [anon_sym_switch] = ACTIONS(2261),
    [anon_sym_for] = ACTIONS(2261),
    [anon_sym_LPAREN] = ACTIONS(2259),
    [anon_sym_await] = ACTIONS(2261),
    [anon_sym_while] = ACTIONS(2261),
    [anon_sym_do] = ACTIONS(2261),
    [anon_sym_try] = ACTIONS(2261),
    [anon_sym_with] = ACTIONS(2261),
    [anon_sym_break] = ACTIONS(2261),
    [anon_sym_continue] = ACTIONS(2261),
    [anon_sym_debugger] = ACTIONS(2261),
    [anon_sym_return] = ACTIONS(2261),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_SEMI] = ACTIONS(2259),
    [anon_sym_case] = ACTIONS(2261),
    [anon_sym_yield] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_LTtemplate_GT] = ACTIONS(2259),
    [anon_sym_class] = ACTIONS(2261),
    [anon_sym_async] = ACTIONS(2261),
    [anon_sym_function] = ACTIONS(2261),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_PLUS] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(2261),
    [anon_sym_SLASH] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_TILDE] = ACTIONS(2259),
    [anon_sym_void] = ACTIONS(2261),
    [anon_sym_delete] = ACTIONS(2261),
    [anon_sym_PLUS_PLUS] = ACTIONS(2259),
    [anon_sym_DASH_DASH] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2259),
    [sym_number] = ACTIONS(2259),
    [sym_this] = ACTIONS(2261),
    [sym_super] = ACTIONS(2261),
    [sym_true] = ACTIONS(2261),
    [sym_false] = ACTIONS(2261),
    [sym_null] = ACTIONS(2261),
    [sym_undefined] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2259),
    [anon_sym_static] = ACTIONS(2261),
    [anon_sym_readonly] = ACTIONS(2261),
    [anon_sym_get] = ACTIONS(2261),
    [anon_sym_set] = ACTIONS(2261),
    [anon_sym_declare] = ACTIONS(2261),
    [anon_sym_public] = ACTIONS(2261),
    [anon_sym_private] = ACTIONS(2261),
    [anon_sym_protected] = ACTIONS(2261),
    [anon_sym_override] = ACTIONS(2261),
    [anon_sym_module] = ACTIONS(2261),
    [anon_sym_any] = ACTIONS(2261),
    [anon_sym_number] = ACTIONS(2261),
    [anon_sym_boolean] = ACTIONS(2261),
    [anon_sym_string] = ACTIONS(2261),
    [anon_sym_symbol] = ACTIONS(2261),
    [anon_sym_abstract] = ACTIONS(2261),
    [anon_sym_interface] = ACTIONS(2261),
    [anon_sym_enum] = ACTIONS(2261),
  },
  [683] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [684] = {
    [ts_builtin_sym_end] = ACTIONS(2263),
    [sym_identifier] = ACTIONS(2265),
    [anon_sym_export] = ACTIONS(2265),
    [anon_sym_default] = ACTIONS(2265),
    [anon_sym_type] = ACTIONS(2265),
    [anon_sym_namespace] = ACTIONS(2265),
    [anon_sym_LBRACE] = ACTIONS(2263),
    [anon_sym_RBRACE] = ACTIONS(2263),
    [anon_sym_typeof] = ACTIONS(2265),
    [anon_sym_import] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(2265),
    [anon_sym_let] = ACTIONS(2265),
    [anon_sym_const] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2263),
    [anon_sym_else] = ACTIONS(2265),
    [anon_sym_if] = ACTIONS(2265),
    [anon_sym_switch] = ACTIONS(2265),
    [anon_sym_for] = ACTIONS(2265),
    [anon_sym_LPAREN] = ACTIONS(2263),
    [anon_sym_await] = ACTIONS(2265),
    [anon_sym_while] = ACTIONS(2265),
    [anon_sym_do] = ACTIONS(2265),
    [anon_sym_try] = ACTIONS(2265),
    [anon_sym_with] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2265),
    [anon_sym_continue] = ACTIONS(2265),
    [anon_sym_debugger] = ACTIONS(2265),
    [anon_sym_return] = ACTIONS(2265),
    [anon_sym_throw] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2263),
    [anon_sym_case] = ACTIONS(2265),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(2263),
    [anon_sym_LTtemplate_GT] = ACTIONS(2263),
    [anon_sym_class] = ACTIONS(2265),
    [anon_sym_async] = ACTIONS(2265),
    [anon_sym_function] = ACTIONS(2265),
    [anon_sym_new] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_SLASH] = ACTIONS(2265),
    [anon_sym_LT] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2263),
    [anon_sym_void] = ACTIONS(2265),
    [anon_sym_delete] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2263),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2263),
    [anon_sym_SQUOTE] = ACTIONS(2263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2263),
    [sym_number] = ACTIONS(2263),
    [sym_this] = ACTIONS(2265),
    [sym_super] = ACTIONS(2265),
    [sym_true] = ACTIONS(2265),
    [sym_false] = ACTIONS(2265),
    [sym_null] = ACTIONS(2265),
    [sym_undefined] = ACTIONS(2265),
    [anon_sym_AT] = ACTIONS(2263),
    [anon_sym_static] = ACTIONS(2265),
    [anon_sym_readonly] = ACTIONS(2265),
    [anon_sym_get] = ACTIONS(2265),
    [anon_sym_set] = ACTIONS(2265),
    [anon_sym_declare] = ACTIONS(2265),
    [anon_sym_public] = ACTIONS(2265),
    [anon_sym_private] = ACTIONS(2265),
    [anon_sym_protected] = ACTIONS(2265),
    [anon_sym_override] = ACTIONS(2265),
    [anon_sym_module] = ACTIONS(2265),
    [anon_sym_any] = ACTIONS(2265),
    [anon_sym_number] = ACTIONS(2265),
    [anon_sym_boolean] = ACTIONS(2265),
    [anon_sym_string] = ACTIONS(2265),
    [anon_sym_symbol] = ACTIONS(2265),
    [anon_sym_abstract] = ACTIONS(2265),
    [anon_sym_interface] = ACTIONS(2265),
    [anon_sym_enum] = ACTIONS(2265),
  },
  [685] = {
    [ts_builtin_sym_end] = ACTIONS(2267),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_export] = ACTIONS(2269),
    [anon_sym_default] = ACTIONS(2269),
    [anon_sym_type] = ACTIONS(2269),
    [anon_sym_namespace] = ACTIONS(2269),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_typeof] = ACTIONS(2269),
    [anon_sym_import] = ACTIONS(2269),
    [anon_sym_var] = ACTIONS(2269),
    [anon_sym_let] = ACTIONS(2269),
    [anon_sym_const] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2269),
    [anon_sym_if] = ACTIONS(2269),
    [anon_sym_switch] = ACTIONS(2269),
    [anon_sym_for] = ACTIONS(2269),
    [anon_sym_LPAREN] = ACTIONS(2267),
    [anon_sym_await] = ACTIONS(2269),
    [anon_sym_while] = ACTIONS(2269),
    [anon_sym_do] = ACTIONS(2269),
    [anon_sym_try] = ACTIONS(2269),
    [anon_sym_with] = ACTIONS(2269),
    [anon_sym_break] = ACTIONS(2269),
    [anon_sym_continue] = ACTIONS(2269),
    [anon_sym_debugger] = ACTIONS(2269),
    [anon_sym_return] = ACTIONS(2269),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2269),
    [anon_sym_yield] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_LTtemplate_GT] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2269),
    [anon_sym_function] = ACTIONS(2269),
    [anon_sym_new] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_void] = ACTIONS(2269),
    [anon_sym_delete] = ACTIONS(2269),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2269),
    [anon_sym_DQUOTE] = ACTIONS(2267),
    [anon_sym_SQUOTE] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2267),
    [sym_number] = ACTIONS(2267),
    [sym_this] = ACTIONS(2269),
    [sym_super] = ACTIONS(2269),
    [sym_true] = ACTIONS(2269),
    [sym_false] = ACTIONS(2269),
    [sym_null] = ACTIONS(2269),
    [sym_undefined] = ACTIONS(2269),
    [anon_sym_AT] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2269),
    [anon_sym_readonly] = ACTIONS(2269),
    [anon_sym_get] = ACTIONS(2269),
    [anon_sym_set] = ACTIONS(2269),
    [anon_sym_declare] = ACTIONS(2269),
    [anon_sym_public] = ACTIONS(2269),
    [anon_sym_private] = ACTIONS(2269),
    [anon_sym_protected] = ACTIONS(2269),
    [anon_sym_override] = ACTIONS(2269),
    [anon_sym_module] = ACTIONS(2269),
    [anon_sym_any] = ACTIONS(2269),
    [anon_sym_number] = ACTIONS(2269),
    [anon_sym_boolean] = ACTIONS(2269),
    [anon_sym_string] = ACTIONS(2269),
    [anon_sym_symbol] = ACTIONS(2269),
    [anon_sym_abstract] = ACTIONS(2269),
    [anon_sym_interface] = ACTIONS(2269),
    [anon_sym_enum] = ACTIONS(2269),
  },
  [686] = {
    [ts_builtin_sym_end] = ACTIONS(2271),
    [sym_identifier] = ACTIONS(2273),
    [anon_sym_export] = ACTIONS(2273),
    [anon_sym_default] = ACTIONS(2273),
    [anon_sym_type] = ACTIONS(2273),
    [anon_sym_namespace] = ACTIONS(2273),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_RBRACE] = ACTIONS(2271),
    [anon_sym_typeof] = ACTIONS(2273),
    [anon_sym_import] = ACTIONS(2273),
    [anon_sym_var] = ACTIONS(2273),
    [anon_sym_let] = ACTIONS(2273),
    [anon_sym_const] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2271),
    [anon_sym_else] = ACTIONS(2273),
    [anon_sym_if] = ACTIONS(2273),
    [anon_sym_switch] = ACTIONS(2273),
    [anon_sym_for] = ACTIONS(2273),
    [anon_sym_LPAREN] = ACTIONS(2271),
    [anon_sym_await] = ACTIONS(2273),
    [anon_sym_while] = ACTIONS(2273),
    [anon_sym_do] = ACTIONS(2273),
    [anon_sym_try] = ACTIONS(2273),
    [anon_sym_with] = ACTIONS(2273),
    [anon_sym_break] = ACTIONS(2273),
    [anon_sym_continue] = ACTIONS(2273),
    [anon_sym_debugger] = ACTIONS(2273),
    [anon_sym_return] = ACTIONS(2273),
    [anon_sym_throw] = ACTIONS(2273),
    [anon_sym_SEMI] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_yield] = ACTIONS(2273),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_LTtemplate_GT] = ACTIONS(2271),
    [anon_sym_class] = ACTIONS(2273),
    [anon_sym_async] = ACTIONS(2273),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_new] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_LT] = ACTIONS(2273),
    [anon_sym_TILDE] = ACTIONS(2271),
    [anon_sym_void] = ACTIONS(2273),
    [anon_sym_delete] = ACTIONS(2273),
    [anon_sym_PLUS_PLUS] = ACTIONS(2271),
    [anon_sym_DASH_DASH] = ACTIONS(2273),
    [anon_sym_DQUOTE] = ACTIONS(2271),
    [anon_sym_SQUOTE] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2271),
    [sym_number] = ACTIONS(2271),
    [sym_this] = ACTIONS(2273),
    [sym_super] = ACTIONS(2273),
    [sym_true] = ACTIONS(2273),
    [sym_false] = ACTIONS(2273),
    [sym_null] = ACTIONS(2273),
    [sym_undefined] = ACTIONS(2273),
    [anon_sym_AT] = ACTIONS(2271),
    [anon_sym_static] = ACTIONS(2273),
    [anon_sym_readonly] = ACTIONS(2273),
    [anon_sym_get] = ACTIONS(2273),
    [anon_sym_set] = ACTIONS(2273),
    [anon_sym_declare] = ACTIONS(2273),
    [anon_sym_public] = ACTIONS(2273),
    [anon_sym_private] = ACTIONS(2273),
    [anon_sym_protected] = ACTIONS(2273),
    [anon_sym_override] = ACTIONS(2273),
    [anon_sym_module] = ACTIONS(2273),
    [anon_sym_any] = ACTIONS(2273),
    [anon_sym_number] = ACTIONS(2273),
    [anon_sym_boolean] = ACTIONS(2273),
    [anon_sym_string] = ACTIONS(2273),
    [anon_sym_symbol] = ACTIONS(2273),
    [anon_sym_abstract] = ACTIONS(2273),
    [anon_sym_interface] = ACTIONS(2273),
    [anon_sym_enum] = ACTIONS(2273),
  },
  [687] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [688] = {
    [ts_builtin_sym_end] = ACTIONS(2275),
    [sym_identifier] = ACTIONS(2277),
    [anon_sym_export] = ACTIONS(2277),
    [anon_sym_default] = ACTIONS(2277),
    [anon_sym_type] = ACTIONS(2277),
    [anon_sym_namespace] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2275),
    [anon_sym_RBRACE] = ACTIONS(2275),
    [anon_sym_typeof] = ACTIONS(2277),
    [anon_sym_import] = ACTIONS(2277),
    [anon_sym_var] = ACTIONS(2277),
    [anon_sym_let] = ACTIONS(2277),
    [anon_sym_const] = ACTIONS(2277),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_else] = ACTIONS(2277),
    [anon_sym_if] = ACTIONS(2277),
    [anon_sym_switch] = ACTIONS(2277),
    [anon_sym_for] = ACTIONS(2277),
    [anon_sym_LPAREN] = ACTIONS(2275),
    [anon_sym_await] = ACTIONS(2277),
    [anon_sym_while] = ACTIONS(2277),
    [anon_sym_do] = ACTIONS(2277),
    [anon_sym_try] = ACTIONS(2277),
    [anon_sym_with] = ACTIONS(2277),
    [anon_sym_break] = ACTIONS(2277),
    [anon_sym_continue] = ACTIONS(2277),
    [anon_sym_debugger] = ACTIONS(2277),
    [anon_sym_return] = ACTIONS(2277),
    [anon_sym_throw] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_case] = ACTIONS(2277),
    [anon_sym_yield] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_LTtemplate_GT] = ACTIONS(2275),
    [anon_sym_class] = ACTIONS(2277),
    [anon_sym_async] = ACTIONS(2277),
    [anon_sym_function] = ACTIONS(2277),
    [anon_sym_new] = ACTIONS(2277),
    [anon_sym_PLUS] = ACTIONS(2277),
    [anon_sym_DASH] = ACTIONS(2277),
    [anon_sym_SLASH] = ACTIONS(2277),
    [anon_sym_LT] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_void] = ACTIONS(2277),
    [anon_sym_delete] = ACTIONS(2277),
    [anon_sym_PLUS_PLUS] = ACTIONS(2275),
    [anon_sym_DASH_DASH] = ACTIONS(2277),
    [anon_sym_DQUOTE] = ACTIONS(2275),
    [anon_sym_SQUOTE] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2275),
    [sym_number] = ACTIONS(2275),
    [sym_this] = ACTIONS(2277),
    [sym_super] = ACTIONS(2277),
    [sym_true] = ACTIONS(2277),
    [sym_false] = ACTIONS(2277),
    [sym_null] = ACTIONS(2277),
    [sym_undefined] = ACTIONS(2277),
    [anon_sym_AT] = ACTIONS(2275),
    [anon_sym_static] = ACTIONS(2277),
    [anon_sym_readonly] = ACTIONS(2277),
    [anon_sym_get] = ACTIONS(2277),
    [anon_sym_set] = ACTIONS(2277),
    [anon_sym_declare] = ACTIONS(2277),
    [anon_sym_public] = ACTIONS(2277),
    [anon_sym_private] = ACTIONS(2277),
    [anon_sym_protected] = ACTIONS(2277),
    [anon_sym_override] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2277),
    [anon_sym_any] = ACTIONS(2277),
    [anon_sym_number] = ACTIONS(2277),
    [anon_sym_boolean] = ACTIONS(2277),
    [anon_sym_string] = ACTIONS(2277),
    [anon_sym_symbol] = ACTIONS(2277),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_interface] = ACTIONS(2277),
    [anon_sym_enum] = ACTIONS(2277),
  },
  [689] = {
    [ts_builtin_sym_end] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(2281),
    [anon_sym_export] = ACTIONS(2281),
    [anon_sym_default] = ACTIONS(2281),
    [anon_sym_type] = ACTIONS(2281),
    [anon_sym_namespace] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(2279),
    [anon_sym_RBRACE] = ACTIONS(2279),
    [anon_sym_typeof] = ACTIONS(2281),
    [anon_sym_import] = ACTIONS(2281),
    [anon_sym_var] = ACTIONS(2281),
    [anon_sym_let] = ACTIONS(2281),
    [anon_sym_const] = ACTIONS(2281),
    [anon_sym_BANG] = ACTIONS(2279),
    [anon_sym_else] = ACTIONS(2281),
    [anon_sym_if] = ACTIONS(2281),
    [anon_sym_switch] = ACTIONS(2281),
    [anon_sym_for] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_await] = ACTIONS(2281),
    [anon_sym_while] = ACTIONS(2281),
    [anon_sym_do] = ACTIONS(2281),
    [anon_sym_try] = ACTIONS(2281),
    [anon_sym_with] = ACTIONS(2281),
    [anon_sym_break] = ACTIONS(2281),
    [anon_sym_continue] = ACTIONS(2281),
    [anon_sym_debugger] = ACTIONS(2281),
    [anon_sym_return] = ACTIONS(2281),
    [anon_sym_throw] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_case] = ACTIONS(2281),
    [anon_sym_yield] = ACTIONS(2281),
    [anon_sym_LBRACK] = ACTIONS(2279),
    [anon_sym_LTtemplate_GT] = ACTIONS(2279),
    [anon_sym_class] = ACTIONS(2281),
    [anon_sym_async] = ACTIONS(2281),
    [anon_sym_function] = ACTIONS(2281),
    [anon_sym_new] = ACTIONS(2281),
    [anon_sym_PLUS] = ACTIONS(2281),
    [anon_sym_DASH] = ACTIONS(2281),
    [anon_sym_SLASH] = ACTIONS(2281),
    [anon_sym_LT] = ACTIONS(2281),
    [anon_sym_TILDE] = ACTIONS(2279),
    [anon_sym_void] = ACTIONS(2281),
    [anon_sym_delete] = ACTIONS(2281),
    [anon_sym_PLUS_PLUS] = ACTIONS(2279),
    [anon_sym_DASH_DASH] = ACTIONS(2281),
    [anon_sym_DQUOTE] = ACTIONS(2279),
    [anon_sym_SQUOTE] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2279),
    [sym_number] = ACTIONS(2279),
    [sym_this] = ACTIONS(2281),
    [sym_super] = ACTIONS(2281),
    [sym_true] = ACTIONS(2281),
    [sym_false] = ACTIONS(2281),
    [sym_null] = ACTIONS(2281),
    [sym_undefined] = ACTIONS(2281),
    [anon_sym_AT] = ACTIONS(2279),
    [anon_sym_static] = ACTIONS(2281),
    [anon_sym_readonly] = ACTIONS(2281),
    [anon_sym_get] = ACTIONS(2281),
    [anon_sym_set] = ACTIONS(2281),
    [anon_sym_declare] = ACTIONS(2281),
    [anon_sym_public] = ACTIONS(2281),
    [anon_sym_private] = ACTIONS(2281),
    [anon_sym_protected] = ACTIONS(2281),
    [anon_sym_override] = ACTIONS(2281),
    [anon_sym_module] = ACTIONS(2281),
    [anon_sym_any] = ACTIONS(2281),
    [anon_sym_number] = ACTIONS(2281),
    [anon_sym_boolean] = ACTIONS(2281),
    [anon_sym_string] = ACTIONS(2281),
    [anon_sym_symbol] = ACTIONS(2281),
    [anon_sym_abstract] = ACTIONS(2281),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2281),
  },
  [690] = {
    [ts_builtin_sym_end] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2285),
    [anon_sym_export] = ACTIONS(2285),
    [anon_sym_default] = ACTIONS(2285),
    [anon_sym_type] = ACTIONS(2285),
    [anon_sym_namespace] = ACTIONS(2285),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_RBRACE] = ACTIONS(2283),
    [anon_sym_typeof] = ACTIONS(2285),
    [anon_sym_import] = ACTIONS(2285),
    [anon_sym_var] = ACTIONS(2285),
    [anon_sym_let] = ACTIONS(2285),
    [anon_sym_const] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2283),
    [anon_sym_else] = ACTIONS(2285),
    [anon_sym_if] = ACTIONS(2285),
    [anon_sym_switch] = ACTIONS(2285),
    [anon_sym_for] = ACTIONS(2285),
    [anon_sym_LPAREN] = ACTIONS(2283),
    [anon_sym_await] = ACTIONS(2285),
    [anon_sym_while] = ACTIONS(2285),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_try] = ACTIONS(2285),
    [anon_sym_with] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2285),
    [anon_sym_continue] = ACTIONS(2285),
    [anon_sym_debugger] = ACTIONS(2285),
    [anon_sym_return] = ACTIONS(2285),
    [anon_sym_throw] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_case] = ACTIONS(2285),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LTtemplate_GT] = ACTIONS(2283),
    [anon_sym_class] = ACTIONS(2285),
    [anon_sym_async] = ACTIONS(2285),
    [anon_sym_function] = ACTIONS(2285),
    [anon_sym_new] = ACTIONS(2285),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_SLASH] = ACTIONS(2285),
    [anon_sym_LT] = ACTIONS(2285),
    [anon_sym_TILDE] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2285),
    [anon_sym_delete] = ACTIONS(2285),
    [anon_sym_PLUS_PLUS] = ACTIONS(2283),
    [anon_sym_DASH_DASH] = ACTIONS(2285),
    [anon_sym_DQUOTE] = ACTIONS(2283),
    [anon_sym_SQUOTE] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2283),
    [sym_number] = ACTIONS(2283),
    [sym_this] = ACTIONS(2285),
    [sym_super] = ACTIONS(2285),
    [sym_true] = ACTIONS(2285),
    [sym_false] = ACTIONS(2285),
    [sym_null] = ACTIONS(2285),
    [sym_undefined] = ACTIONS(2285),
    [anon_sym_AT] = ACTIONS(2283),
    [anon_sym_static] = ACTIONS(2285),
    [anon_sym_readonly] = ACTIONS(2285),
    [anon_sym_get] = ACTIONS(2285),
    [anon_sym_set] = ACTIONS(2285),
    [anon_sym_declare] = ACTIONS(2285),
    [anon_sym_public] = ACTIONS(2285),
    [anon_sym_private] = ACTIONS(2285),
    [anon_sym_protected] = ACTIONS(2285),
    [anon_sym_override] = ACTIONS(2285),
    [anon_sym_module] = ACTIONS(2285),
    [anon_sym_any] = ACTIONS(2285),
    [anon_sym_number] = ACTIONS(2285),
    [anon_sym_boolean] = ACTIONS(2285),
    [anon_sym_string] = ACTIONS(2285),
    [anon_sym_symbol] = ACTIONS(2285),
    [anon_sym_abstract] = ACTIONS(2285),
    [anon_sym_interface] = ACTIONS(2285),
    [anon_sym_enum] = ACTIONS(2285),
  },
  [691] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [692] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [693] = {
    [ts_builtin_sym_end] = ACTIONS(2287),
    [sym_identifier] = ACTIONS(2289),
    [anon_sym_export] = ACTIONS(2289),
    [anon_sym_default] = ACTIONS(2289),
    [anon_sym_type] = ACTIONS(2289),
    [anon_sym_namespace] = ACTIONS(2289),
    [anon_sym_LBRACE] = ACTIONS(2287),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_typeof] = ACTIONS(2289),
    [anon_sym_import] = ACTIONS(2289),
    [anon_sym_var] = ACTIONS(2289),
    [anon_sym_let] = ACTIONS(2289),
    [anon_sym_const] = ACTIONS(2289),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_else] = ACTIONS(2289),
    [anon_sym_if] = ACTIONS(2289),
    [anon_sym_switch] = ACTIONS(2289),
    [anon_sym_for] = ACTIONS(2289),
    [anon_sym_LPAREN] = ACTIONS(2287),
    [anon_sym_await] = ACTIONS(2289),
    [anon_sym_while] = ACTIONS(2289),
    [anon_sym_do] = ACTIONS(2289),
    [anon_sym_try] = ACTIONS(2289),
    [anon_sym_with] = ACTIONS(2289),
    [anon_sym_break] = ACTIONS(2289),
    [anon_sym_continue] = ACTIONS(2289),
    [anon_sym_debugger] = ACTIONS(2289),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_throw] = ACTIONS(2289),
    [anon_sym_SEMI] = ACTIONS(2287),
    [anon_sym_case] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2289),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_LTtemplate_GT] = ACTIONS(2287),
    [anon_sym_class] = ACTIONS(2289),
    [anon_sym_async] = ACTIONS(2289),
    [anon_sym_function] = ACTIONS(2289),
    [anon_sym_new] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_SLASH] = ACTIONS(2289),
    [anon_sym_LT] = ACTIONS(2289),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_void] = ACTIONS(2289),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2289),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [anon_sym_SQUOTE] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [sym_number] = ACTIONS(2287),
    [sym_this] = ACTIONS(2289),
    [sym_super] = ACTIONS(2289),
    [sym_true] = ACTIONS(2289),
    [sym_false] = ACTIONS(2289),
    [sym_null] = ACTIONS(2289),
    [sym_undefined] = ACTIONS(2289),
    [anon_sym_AT] = ACTIONS(2287),
    [anon_sym_static] = ACTIONS(2289),
    [anon_sym_readonly] = ACTIONS(2289),
    [anon_sym_get] = ACTIONS(2289),
    [anon_sym_set] = ACTIONS(2289),
    [anon_sym_declare] = ACTIONS(2289),
    [anon_sym_public] = ACTIONS(2289),
    [anon_sym_private] = ACTIONS(2289),
    [anon_sym_protected] = ACTIONS(2289),
    [anon_sym_override] = ACTIONS(2289),
    [anon_sym_module] = ACTIONS(2289),
    [anon_sym_any] = ACTIONS(2289),
    [anon_sym_number] = ACTIONS(2289),
    [anon_sym_boolean] = ACTIONS(2289),
    [anon_sym_string] = ACTIONS(2289),
    [anon_sym_symbol] = ACTIONS(2289),
    [anon_sym_abstract] = ACTIONS(2289),
    [anon_sym_interface] = ACTIONS(2289),
    [anon_sym_enum] = ACTIONS(2289),
  },
  [694] = {
    [ts_builtin_sym_end] = ACTIONS(2291),
    [sym_identifier] = ACTIONS(2293),
    [anon_sym_export] = ACTIONS(2293),
    [anon_sym_default] = ACTIONS(2293),
    [anon_sym_type] = ACTIONS(2293),
    [anon_sym_namespace] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_typeof] = ACTIONS(2293),
    [anon_sym_import] = ACTIONS(2293),
    [anon_sym_var] = ACTIONS(2293),
    [anon_sym_let] = ACTIONS(2293),
    [anon_sym_const] = ACTIONS(2293),
    [anon_sym_BANG] = ACTIONS(2291),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_switch] = ACTIONS(2293),
    [anon_sym_for] = ACTIONS(2293),
    [anon_sym_LPAREN] = ACTIONS(2291),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_try] = ACTIONS(2293),
    [anon_sym_with] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_continue] = ACTIONS(2293),
    [anon_sym_debugger] = ACTIONS(2293),
    [anon_sym_return] = ACTIONS(2293),
    [anon_sym_throw] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2291),
    [anon_sym_case] = ACTIONS(2293),
    [anon_sym_yield] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2291),
    [anon_sym_LTtemplate_GT] = ACTIONS(2291),
    [anon_sym_class] = ACTIONS(2293),
    [anon_sym_async] = ACTIONS(2293),
    [anon_sym_function] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_LT] = ACTIONS(2293),
    [anon_sym_TILDE] = ACTIONS(2291),
    [anon_sym_void] = ACTIONS(2293),
    [anon_sym_delete] = ACTIONS(2293),
    [anon_sym_PLUS_PLUS] = ACTIONS(2291),
    [anon_sym_DASH_DASH] = ACTIONS(2293),
    [anon_sym_DQUOTE] = ACTIONS(2291),
    [anon_sym_SQUOTE] = ACTIONS(2291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2291),
    [sym_number] = ACTIONS(2291),
    [sym_this] = ACTIONS(2293),
    [sym_super] = ACTIONS(2293),
    [sym_true] = ACTIONS(2293),
    [sym_false] = ACTIONS(2293),
    [sym_null] = ACTIONS(2293),
    [sym_undefined] = ACTIONS(2293),
    [anon_sym_AT] = ACTIONS(2291),
    [anon_sym_static] = ACTIONS(2293),
    [anon_sym_readonly] = ACTIONS(2293),
    [anon_sym_get] = ACTIONS(2293),
    [anon_sym_set] = ACTIONS(2293),
    [anon_sym_declare] = ACTIONS(2293),
    [anon_sym_public] = ACTIONS(2293),
    [anon_sym_private] = ACTIONS(2293),
    [anon_sym_protected] = ACTIONS(2293),
    [anon_sym_override] = ACTIONS(2293),
    [anon_sym_module] = ACTIONS(2293),
    [anon_sym_any] = ACTIONS(2293),
    [anon_sym_number] = ACTIONS(2293),
    [anon_sym_boolean] = ACTIONS(2293),
    [anon_sym_string] = ACTIONS(2293),
    [anon_sym_symbol] = ACTIONS(2293),
    [anon_sym_abstract] = ACTIONS(2293),
    [anon_sym_interface] = ACTIONS(2293),
    [anon_sym_enum] = ACTIONS(2293),
  },
  [695] = {
    [ts_builtin_sym_end] = ACTIONS(2291),
    [sym_identifier] = ACTIONS(2293),
    [anon_sym_export] = ACTIONS(2293),
    [anon_sym_default] = ACTIONS(2293),
    [anon_sym_type] = ACTIONS(2293),
    [anon_sym_namespace] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_typeof] = ACTIONS(2293),
    [anon_sym_import] = ACTIONS(2293),
    [anon_sym_var] = ACTIONS(2293),
    [anon_sym_let] = ACTIONS(2293),
    [anon_sym_const] = ACTIONS(2293),
    [anon_sym_BANG] = ACTIONS(2291),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_switch] = ACTIONS(2293),
    [anon_sym_for] = ACTIONS(2293),
    [anon_sym_LPAREN] = ACTIONS(2291),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_try] = ACTIONS(2293),
    [anon_sym_with] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_continue] = ACTIONS(2293),
    [anon_sym_debugger] = ACTIONS(2293),
    [anon_sym_return] = ACTIONS(2293),
    [anon_sym_throw] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2291),
    [anon_sym_case] = ACTIONS(2293),
    [anon_sym_yield] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2291),
    [anon_sym_LTtemplate_GT] = ACTIONS(2291),
    [anon_sym_class] = ACTIONS(2293),
    [anon_sym_async] = ACTIONS(2293),
    [anon_sym_function] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_LT] = ACTIONS(2293),
    [anon_sym_TILDE] = ACTIONS(2291),
    [anon_sym_void] = ACTIONS(2293),
    [anon_sym_delete] = ACTIONS(2293),
    [anon_sym_PLUS_PLUS] = ACTIONS(2291),
    [anon_sym_DASH_DASH] = ACTIONS(2293),
    [anon_sym_DQUOTE] = ACTIONS(2291),
    [anon_sym_SQUOTE] = ACTIONS(2291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2291),
    [sym_number] = ACTIONS(2291),
    [sym_this] = ACTIONS(2293),
    [sym_super] = ACTIONS(2293),
    [sym_true] = ACTIONS(2293),
    [sym_false] = ACTIONS(2293),
    [sym_null] = ACTIONS(2293),
    [sym_undefined] = ACTIONS(2293),
    [anon_sym_AT] = ACTIONS(2291),
    [anon_sym_static] = ACTIONS(2293),
    [anon_sym_readonly] = ACTIONS(2293),
    [anon_sym_get] = ACTIONS(2293),
    [anon_sym_set] = ACTIONS(2293),
    [anon_sym_declare] = ACTIONS(2293),
    [anon_sym_public] = ACTIONS(2293),
    [anon_sym_private] = ACTIONS(2293),
    [anon_sym_protected] = ACTIONS(2293),
    [anon_sym_override] = ACTIONS(2293),
    [anon_sym_module] = ACTIONS(2293),
    [anon_sym_any] = ACTIONS(2293),
    [anon_sym_number] = ACTIONS(2293),
    [anon_sym_boolean] = ACTIONS(2293),
    [anon_sym_string] = ACTIONS(2293),
    [anon_sym_symbol] = ACTIONS(2293),
    [anon_sym_abstract] = ACTIONS(2293),
    [anon_sym_interface] = ACTIONS(2293),
    [anon_sym_enum] = ACTIONS(2293),
  },
  [696] = {
    [ts_builtin_sym_end] = ACTIONS(2295),
    [sym_identifier] = ACTIONS(2297),
    [anon_sym_export] = ACTIONS(2297),
    [anon_sym_default] = ACTIONS(2297),
    [anon_sym_type] = ACTIONS(2297),
    [anon_sym_namespace] = ACTIONS(2297),
    [anon_sym_LBRACE] = ACTIONS(2295),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_typeof] = ACTIONS(2297),
    [anon_sym_import] = ACTIONS(2297),
    [anon_sym_var] = ACTIONS(2297),
    [anon_sym_let] = ACTIONS(2297),
    [anon_sym_const] = ACTIONS(2297),
    [anon_sym_BANG] = ACTIONS(2295),
    [anon_sym_else] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_switch] = ACTIONS(2297),
    [anon_sym_for] = ACTIONS(2297),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [anon_sym_await] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_do] = ACTIONS(2297),
    [anon_sym_try] = ACTIONS(2297),
    [anon_sym_with] = ACTIONS(2297),
    [anon_sym_break] = ACTIONS(2297),
    [anon_sym_continue] = ACTIONS(2297),
    [anon_sym_debugger] = ACTIONS(2297),
    [anon_sym_return] = ACTIONS(2297),
    [anon_sym_throw] = ACTIONS(2297),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_case] = ACTIONS(2297),
    [anon_sym_yield] = ACTIONS(2297),
    [anon_sym_LBRACK] = ACTIONS(2295),
    [anon_sym_LTtemplate_GT] = ACTIONS(2295),
    [anon_sym_class] = ACTIONS(2297),
    [anon_sym_async] = ACTIONS(2297),
    [anon_sym_function] = ACTIONS(2297),
    [anon_sym_new] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_DASH] = ACTIONS(2297),
    [anon_sym_SLASH] = ACTIONS(2297),
    [anon_sym_LT] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2295),
    [anon_sym_void] = ACTIONS(2297),
    [anon_sym_delete] = ACTIONS(2297),
    [anon_sym_PLUS_PLUS] = ACTIONS(2295),
    [anon_sym_DASH_DASH] = ACTIONS(2297),
    [anon_sym_DQUOTE] = ACTIONS(2295),
    [anon_sym_SQUOTE] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2295),
    [sym_number] = ACTIONS(2295),
    [sym_this] = ACTIONS(2297),
    [sym_super] = ACTIONS(2297),
    [sym_true] = ACTIONS(2297),
    [sym_false] = ACTIONS(2297),
    [sym_null] = ACTIONS(2297),
    [sym_undefined] = ACTIONS(2297),
    [anon_sym_AT] = ACTIONS(2295),
    [anon_sym_static] = ACTIONS(2297),
    [anon_sym_readonly] = ACTIONS(2297),
    [anon_sym_get] = ACTIONS(2297),
    [anon_sym_set] = ACTIONS(2297),
    [anon_sym_declare] = ACTIONS(2297),
    [anon_sym_public] = ACTIONS(2297),
    [anon_sym_private] = ACTIONS(2297),
    [anon_sym_protected] = ACTIONS(2297),
    [anon_sym_override] = ACTIONS(2297),
    [anon_sym_module] = ACTIONS(2297),
    [anon_sym_any] = ACTIONS(2297),
    [anon_sym_number] = ACTIONS(2297),
    [anon_sym_boolean] = ACTIONS(2297),
    [anon_sym_string] = ACTIONS(2297),
    [anon_sym_symbol] = ACTIONS(2297),
    [anon_sym_abstract] = ACTIONS(2297),
    [anon_sym_interface] = ACTIONS(2297),
    [anon_sym_enum] = ACTIONS(2297),
  },
  [697] = {
    [ts_builtin_sym_end] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2301),
    [anon_sym_export] = ACTIONS(2301),
    [anon_sym_default] = ACTIONS(2301),
    [anon_sym_type] = ACTIONS(2301),
    [anon_sym_namespace] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2299),
    [anon_sym_RBRACE] = ACTIONS(2299),
    [anon_sym_typeof] = ACTIONS(2301),
    [anon_sym_import] = ACTIONS(2301),
    [anon_sym_var] = ACTIONS(2301),
    [anon_sym_let] = ACTIONS(2301),
    [anon_sym_const] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2299),
    [anon_sym_else] = ACTIONS(2301),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(2301),
    [anon_sym_for] = ACTIONS(2301),
    [anon_sym_LPAREN] = ACTIONS(2299),
    [anon_sym_await] = ACTIONS(2301),
    [anon_sym_while] = ACTIONS(2301),
    [anon_sym_do] = ACTIONS(2301),
    [anon_sym_try] = ACTIONS(2301),
    [anon_sym_with] = ACTIONS(2301),
    [anon_sym_break] = ACTIONS(2301),
    [anon_sym_continue] = ACTIONS(2301),
    [anon_sym_debugger] = ACTIONS(2301),
    [anon_sym_return] = ACTIONS(2301),
    [anon_sym_throw] = ACTIONS(2301),
    [anon_sym_SEMI] = ACTIONS(2299),
    [anon_sym_case] = ACTIONS(2301),
    [anon_sym_yield] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2299),
    [anon_sym_LTtemplate_GT] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_async] = ACTIONS(2301),
    [anon_sym_function] = ACTIONS(2301),
    [anon_sym_new] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2301),
    [anon_sym_SLASH] = ACTIONS(2301),
    [anon_sym_LT] = ACTIONS(2301),
    [anon_sym_TILDE] = ACTIONS(2299),
    [anon_sym_void] = ACTIONS(2301),
    [anon_sym_delete] = ACTIONS(2301),
    [anon_sym_PLUS_PLUS] = ACTIONS(2299),
    [anon_sym_DASH_DASH] = ACTIONS(2301),
    [anon_sym_DQUOTE] = ACTIONS(2299),
    [anon_sym_SQUOTE] = ACTIONS(2299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2299),
    [sym_number] = ACTIONS(2299),
    [sym_this] = ACTIONS(2301),
    [sym_super] = ACTIONS(2301),
    [sym_true] = ACTIONS(2301),
    [sym_false] = ACTIONS(2301),
    [sym_null] = ACTIONS(2301),
    [sym_undefined] = ACTIONS(2301),
    [anon_sym_AT] = ACTIONS(2299),
    [anon_sym_static] = ACTIONS(2301),
    [anon_sym_readonly] = ACTIONS(2301),
    [anon_sym_get] = ACTIONS(2301),
    [anon_sym_set] = ACTIONS(2301),
    [anon_sym_declare] = ACTIONS(2301),
    [anon_sym_public] = ACTIONS(2301),
    [anon_sym_private] = ACTIONS(2301),
    [anon_sym_protected] = ACTIONS(2301),
    [anon_sym_override] = ACTIONS(2301),
    [anon_sym_module] = ACTIONS(2301),
    [anon_sym_any] = ACTIONS(2301),
    [anon_sym_number] = ACTIONS(2301),
    [anon_sym_boolean] = ACTIONS(2301),
    [anon_sym_string] = ACTIONS(2301),
    [anon_sym_symbol] = ACTIONS(2301),
    [anon_sym_abstract] = ACTIONS(2301),
    [anon_sym_interface] = ACTIONS(2301),
    [anon_sym_enum] = ACTIONS(2301),
  },
  [698] = {
    [ts_builtin_sym_end] = ACTIONS(2303),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_export] = ACTIONS(2305),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_type] = ACTIONS(2305),
    [anon_sym_namespace] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2303),
    [anon_sym_RBRACE] = ACTIONS(2303),
    [anon_sym_typeof] = ACTIONS(2305),
    [anon_sym_import] = ACTIONS(2305),
    [anon_sym_var] = ACTIONS(2305),
    [anon_sym_let] = ACTIONS(2305),
    [anon_sym_const] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_else] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2305),
    [anon_sym_switch] = ACTIONS(2305),
    [anon_sym_for] = ACTIONS(2305),
    [anon_sym_LPAREN] = ACTIONS(2303),
    [anon_sym_await] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2305),
    [anon_sym_do] = ACTIONS(2305),
    [anon_sym_try] = ACTIONS(2305),
    [anon_sym_with] = ACTIONS(2305),
    [anon_sym_break] = ACTIONS(2305),
    [anon_sym_continue] = ACTIONS(2305),
    [anon_sym_debugger] = ACTIONS(2305),
    [anon_sym_return] = ACTIONS(2305),
    [anon_sym_throw] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2303),
    [anon_sym_case] = ACTIONS(2305),
    [anon_sym_yield] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2303),
    [anon_sym_LTtemplate_GT] = ACTIONS(2303),
    [anon_sym_class] = ACTIONS(2305),
    [anon_sym_async] = ACTIONS(2305),
    [anon_sym_function] = ACTIONS(2305),
    [anon_sym_new] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(2305),
    [anon_sym_SLASH] = ACTIONS(2305),
    [anon_sym_LT] = ACTIONS(2305),
    [anon_sym_TILDE] = ACTIONS(2303),
    [anon_sym_void] = ACTIONS(2305),
    [anon_sym_delete] = ACTIONS(2305),
    [anon_sym_PLUS_PLUS] = ACTIONS(2303),
    [anon_sym_DASH_DASH] = ACTIONS(2305),
    [anon_sym_DQUOTE] = ACTIONS(2303),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2303),
    [sym_number] = ACTIONS(2303),
    [sym_this] = ACTIONS(2305),
    [sym_super] = ACTIONS(2305),
    [sym_true] = ACTIONS(2305),
    [sym_false] = ACTIONS(2305),
    [sym_null] = ACTIONS(2305),
    [sym_undefined] = ACTIONS(2305),
    [anon_sym_AT] = ACTIONS(2303),
    [anon_sym_static] = ACTIONS(2305),
    [anon_sym_readonly] = ACTIONS(2305),
    [anon_sym_get] = ACTIONS(2305),
    [anon_sym_set] = ACTIONS(2305),
    [anon_sym_declare] = ACTIONS(2305),
    [anon_sym_public] = ACTIONS(2305),
    [anon_sym_private] = ACTIONS(2305),
    [anon_sym_protected] = ACTIONS(2305),
    [anon_sym_override] = ACTIONS(2305),
    [anon_sym_module] = ACTIONS(2305),
    [anon_sym_any] = ACTIONS(2305),
    [anon_sym_number] = ACTIONS(2305),
    [anon_sym_boolean] = ACTIONS(2305),
    [anon_sym_string] = ACTIONS(2305),
    [anon_sym_symbol] = ACTIONS(2305),
    [anon_sym_abstract] = ACTIONS(2305),
    [anon_sym_interface] = ACTIONS(2305),
    [anon_sym_enum] = ACTIONS(2305),
  },
  [699] = {
    [ts_builtin_sym_end] = ACTIONS(2307),
    [sym_identifier] = ACTIONS(2309),
    [anon_sym_export] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2309),
    [anon_sym_type] = ACTIONS(2309),
    [anon_sym_namespace] = ACTIONS(2309),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_typeof] = ACTIONS(2309),
    [anon_sym_import] = ACTIONS(2309),
    [anon_sym_var] = ACTIONS(2309),
    [anon_sym_let] = ACTIONS(2309),
    [anon_sym_const] = ACTIONS(2309),
    [anon_sym_BANG] = ACTIONS(2307),
    [anon_sym_else] = ACTIONS(2309),
    [anon_sym_if] = ACTIONS(2309),
    [anon_sym_switch] = ACTIONS(2309),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_LPAREN] = ACTIONS(2307),
    [anon_sym_await] = ACTIONS(2309),
    [anon_sym_while] = ACTIONS(2309),
    [anon_sym_do] = ACTIONS(2309),
    [anon_sym_try] = ACTIONS(2309),
    [anon_sym_with] = ACTIONS(2309),
    [anon_sym_break] = ACTIONS(2309),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_debugger] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(2309),
    [anon_sym_throw] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [anon_sym_case] = ACTIONS(2309),
    [anon_sym_yield] = ACTIONS(2309),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_LTtemplate_GT] = ACTIONS(2307),
    [anon_sym_class] = ACTIONS(2309),
    [anon_sym_async] = ACTIONS(2309),
    [anon_sym_function] = ACTIONS(2309),
    [anon_sym_new] = ACTIONS(2309),
    [anon_sym_PLUS] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2309),
    [anon_sym_SLASH] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2307),
    [anon_sym_void] = ACTIONS(2309),
    [anon_sym_delete] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(2309),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [sym_number] = ACTIONS(2307),
    [sym_this] = ACTIONS(2309),
    [sym_super] = ACTIONS(2309),
    [sym_true] = ACTIONS(2309),
    [sym_false] = ACTIONS(2309),
    [sym_null] = ACTIONS(2309),
    [sym_undefined] = ACTIONS(2309),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_static] = ACTIONS(2309),
    [anon_sym_readonly] = ACTIONS(2309),
    [anon_sym_get] = ACTIONS(2309),
    [anon_sym_set] = ACTIONS(2309),
    [anon_sym_declare] = ACTIONS(2309),
    [anon_sym_public] = ACTIONS(2309),
    [anon_sym_private] = ACTIONS(2309),
    [anon_sym_protected] = ACTIONS(2309),
    [anon_sym_override] = ACTIONS(2309),
    [anon_sym_module] = ACTIONS(2309),
    [anon_sym_any] = ACTIONS(2309),
    [anon_sym_number] = ACTIONS(2309),
    [anon_sym_boolean] = ACTIONS(2309),
    [anon_sym_string] = ACTIONS(2309),
    [anon_sym_symbol] = ACTIONS(2309),
    [anon_sym_abstract] = ACTIONS(2309),
    [anon_sym_interface] = ACTIONS(2309),
    [anon_sym_enum] = ACTIONS(2309),
  },
  [700] = {
    [ts_builtin_sym_end] = ACTIONS(2311),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2313),
    [anon_sym_default] = ACTIONS(2313),
    [anon_sym_type] = ACTIONS(2313),
    [anon_sym_namespace] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_RBRACE] = ACTIONS(2311),
    [anon_sym_typeof] = ACTIONS(2313),
    [anon_sym_import] = ACTIONS(2313),
    [anon_sym_var] = ACTIONS(2313),
    [anon_sym_let] = ACTIONS(2313),
    [anon_sym_const] = ACTIONS(2313),
    [anon_sym_BANG] = ACTIONS(2311),
    [anon_sym_else] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_switch] = ACTIONS(2313),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_LPAREN] = ACTIONS(2311),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_while] = ACTIONS(2313),
    [anon_sym_do] = ACTIONS(2313),
    [anon_sym_try] = ACTIONS(2313),
    [anon_sym_with] = ACTIONS(2313),
    [anon_sym_break] = ACTIONS(2313),
    [anon_sym_continue] = ACTIONS(2313),
    [anon_sym_debugger] = ACTIONS(2313),
    [anon_sym_return] = ACTIONS(2313),
    [anon_sym_throw] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2311),
    [anon_sym_case] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_LTtemplate_GT] = ACTIONS(2311),
    [anon_sym_class] = ACTIONS(2313),
    [anon_sym_async] = ACTIONS(2313),
    [anon_sym_function] = ACTIONS(2313),
    [anon_sym_new] = ACTIONS(2313),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_SLASH] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2313),
    [anon_sym_TILDE] = ACTIONS(2311),
    [anon_sym_void] = ACTIONS(2313),
    [anon_sym_delete] = ACTIONS(2313),
    [anon_sym_PLUS_PLUS] = ACTIONS(2311),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2311),
    [anon_sym_SQUOTE] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [sym_number] = ACTIONS(2311),
    [sym_this] = ACTIONS(2313),
    [sym_super] = ACTIONS(2313),
    [sym_true] = ACTIONS(2313),
    [sym_false] = ACTIONS(2313),
    [sym_null] = ACTIONS(2313),
    [sym_undefined] = ACTIONS(2313),
    [anon_sym_AT] = ACTIONS(2311),
    [anon_sym_static] = ACTIONS(2313),
    [anon_sym_readonly] = ACTIONS(2313),
    [anon_sym_get] = ACTIONS(2313),
    [anon_sym_set] = ACTIONS(2313),
    [anon_sym_declare] = ACTIONS(2313),
    [anon_sym_public] = ACTIONS(2313),
    [anon_sym_private] = ACTIONS(2313),
    [anon_sym_protected] = ACTIONS(2313),
    [anon_sym_override] = ACTIONS(2313),
    [anon_sym_module] = ACTIONS(2313),
    [anon_sym_any] = ACTIONS(2313),
    [anon_sym_number] = ACTIONS(2313),
    [anon_sym_boolean] = ACTIONS(2313),
    [anon_sym_string] = ACTIONS(2313),
    [anon_sym_symbol] = ACTIONS(2313),
    [anon_sym_abstract] = ACTIONS(2313),
    [anon_sym_interface] = ACTIONS(2313),
    [anon_sym_enum] = ACTIONS(2313),
  },
  [701] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [702] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [703] = {
    [ts_builtin_sym_end] = ACTIONS(2315),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_export] = ACTIONS(2317),
    [anon_sym_default] = ACTIONS(2317),
    [anon_sym_type] = ACTIONS(2317),
    [anon_sym_namespace] = ACTIONS(2317),
    [anon_sym_LBRACE] = ACTIONS(2315),
    [anon_sym_RBRACE] = ACTIONS(2315),
    [anon_sym_typeof] = ACTIONS(2317),
    [anon_sym_import] = ACTIONS(2317),
    [anon_sym_var] = ACTIONS(2317),
    [anon_sym_let] = ACTIONS(2317),
    [anon_sym_const] = ACTIONS(2317),
    [anon_sym_BANG] = ACTIONS(2315),
    [anon_sym_else] = ACTIONS(2317),
    [anon_sym_if] = ACTIONS(2317),
    [anon_sym_switch] = ACTIONS(2317),
    [anon_sym_for] = ACTIONS(2317),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_await] = ACTIONS(2317),
    [anon_sym_while] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_try] = ACTIONS(2317),
    [anon_sym_with] = ACTIONS(2317),
    [anon_sym_break] = ACTIONS(2317),
    [anon_sym_continue] = ACTIONS(2317),
    [anon_sym_debugger] = ACTIONS(2317),
    [anon_sym_return] = ACTIONS(2317),
    [anon_sym_throw] = ACTIONS(2317),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_case] = ACTIONS(2317),
    [anon_sym_yield] = ACTIONS(2317),
    [anon_sym_LBRACK] = ACTIONS(2315),
    [anon_sym_LTtemplate_GT] = ACTIONS(2315),
    [anon_sym_class] = ACTIONS(2317),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_new] = ACTIONS(2317),
    [anon_sym_PLUS] = ACTIONS(2317),
    [anon_sym_DASH] = ACTIONS(2317),
    [anon_sym_SLASH] = ACTIONS(2317),
    [anon_sym_LT] = ACTIONS(2317),
    [anon_sym_TILDE] = ACTIONS(2315),
    [anon_sym_void] = ACTIONS(2317),
    [anon_sym_delete] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(2315),
    [anon_sym_DASH_DASH] = ACTIONS(2317),
    [anon_sym_DQUOTE] = ACTIONS(2315),
    [anon_sym_SQUOTE] = ACTIONS(2315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2315),
    [sym_number] = ACTIONS(2315),
    [sym_this] = ACTIONS(2317),
    [sym_super] = ACTIONS(2317),
    [sym_true] = ACTIONS(2317),
    [sym_false] = ACTIONS(2317),
    [sym_null] = ACTIONS(2317),
    [sym_undefined] = ACTIONS(2317),
    [anon_sym_AT] = ACTIONS(2315),
    [anon_sym_static] = ACTIONS(2317),
    [anon_sym_readonly] = ACTIONS(2317),
    [anon_sym_get] = ACTIONS(2317),
    [anon_sym_set] = ACTIONS(2317),
    [anon_sym_declare] = ACTIONS(2317),
    [anon_sym_public] = ACTIONS(2317),
    [anon_sym_private] = ACTIONS(2317),
    [anon_sym_protected] = ACTIONS(2317),
    [anon_sym_override] = ACTIONS(2317),
    [anon_sym_module] = ACTIONS(2317),
    [anon_sym_any] = ACTIONS(2317),
    [anon_sym_number] = ACTIONS(2317),
    [anon_sym_boolean] = ACTIONS(2317),
    [anon_sym_string] = ACTIONS(2317),
    [anon_sym_symbol] = ACTIONS(2317),
    [anon_sym_abstract] = ACTIONS(2317),
    [anon_sym_interface] = ACTIONS(2317),
    [anon_sym_enum] = ACTIONS(2317),
  },
  [704] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [705] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [706] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [707] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [708] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [709] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [710] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [711] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [712] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [713] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2321),
    [anon_sym_default] = ACTIONS(2321),
    [anon_sym_type] = ACTIONS(2321),
    [anon_sym_namespace] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [anon_sym_RBRACE] = ACTIONS(2319),
    [anon_sym_typeof] = ACTIONS(2321),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_var] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_const] = ACTIONS(2321),
    [anon_sym_BANG] = ACTIONS(2319),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_switch] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_await] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_break] = ACTIONS(2321),
    [anon_sym_continue] = ACTIONS(2321),
    [anon_sym_debugger] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_throw] = ACTIONS(2321),
    [anon_sym_SEMI] = ACTIONS(2319),
    [anon_sym_case] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [anon_sym_LTtemplate_GT] = ACTIONS(2319),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_SLASH] = ACTIONS(2321),
    [anon_sym_LT] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_void] = ACTIONS(2321),
    [anon_sym_delete] = ACTIONS(2321),
    [anon_sym_PLUS_PLUS] = ACTIONS(2319),
    [anon_sym_DASH_DASH] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [sym_number] = ACTIONS(2319),
    [sym_this] = ACTIONS(2321),
    [sym_super] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_null] = ACTIONS(2321),
    [sym_undefined] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_static] = ACTIONS(2321),
    [anon_sym_readonly] = ACTIONS(2321),
    [anon_sym_get] = ACTIONS(2321),
    [anon_sym_set] = ACTIONS(2321),
    [anon_sym_declare] = ACTIONS(2321),
    [anon_sym_public] = ACTIONS(2321),
    [anon_sym_private] = ACTIONS(2321),
    [anon_sym_protected] = ACTIONS(2321),
    [anon_sym_override] = ACTIONS(2321),
    [anon_sym_module] = ACTIONS(2321),
    [anon_sym_any] = ACTIONS(2321),
    [anon_sym_number] = ACTIONS(2321),
    [anon_sym_boolean] = ACTIONS(2321),
    [anon_sym_string] = ACTIONS(2321),
    [anon_sym_symbol] = ACTIONS(2321),
    [anon_sym_abstract] = ACTIONS(2321),
    [anon_sym_interface] = ACTIONS(2321),
    [anon_sym_enum] = ACTIONS(2321),
  },
  [714] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [715] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [716] = {
    [ts_builtin_sym_end] = ACTIONS(1525),
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_export] = ACTIONS(1527),
    [anon_sym_default] = ACTIONS(1527),
    [anon_sym_type] = ACTIONS(1527),
    [anon_sym_namespace] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_RBRACE] = ACTIONS(1525),
    [anon_sym_typeof] = ACTIONS(1527),
    [anon_sym_import] = ACTIONS(1527),
    [anon_sym_var] = ACTIONS(1527),
    [anon_sym_let] = ACTIONS(1527),
    [anon_sym_const] = ACTIONS(1527),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_else] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_switch] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_LPAREN] = ACTIONS(1525),
    [anon_sym_await] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(1527),
    [anon_sym_try] = ACTIONS(1527),
    [anon_sym_with] = ACTIONS(1527),
    [anon_sym_break] = ACTIONS(1527),
    [anon_sym_continue] = ACTIONS(1527),
    [anon_sym_debugger] = ACTIONS(1527),
    [anon_sym_return] = ACTIONS(1527),
    [anon_sym_throw] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_case] = ACTIONS(1527),
    [anon_sym_yield] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(1525),
    [anon_sym_LTtemplate_GT] = ACTIONS(1525),
    [anon_sym_class] = ACTIONS(1527),
    [anon_sym_async] = ACTIONS(1527),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1527),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_void] = ACTIONS(1527),
    [anon_sym_delete] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1525),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [sym_number] = ACTIONS(1525),
    [sym_this] = ACTIONS(1527),
    [sym_super] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_undefined] = ACTIONS(1527),
    [anon_sym_AT] = ACTIONS(1525),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_readonly] = ACTIONS(1527),
    [anon_sym_get] = ACTIONS(1527),
    [anon_sym_set] = ACTIONS(1527),
    [anon_sym_declare] = ACTIONS(1527),
    [anon_sym_public] = ACTIONS(1527),
    [anon_sym_private] = ACTIONS(1527),
    [anon_sym_protected] = ACTIONS(1527),
    [anon_sym_override] = ACTIONS(1527),
    [anon_sym_module] = ACTIONS(1527),
    [anon_sym_any] = ACTIONS(1527),
    [anon_sym_number] = ACTIONS(1527),
    [anon_sym_boolean] = ACTIONS(1527),
    [anon_sym_string] = ACTIONS(1527),
    [anon_sym_symbol] = ACTIONS(1527),
    [anon_sym_abstract] = ACTIONS(1527),
    [anon_sym_interface] = ACTIONS(1527),
    [anon_sym_enum] = ACTIONS(1527),
  },
  [717] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [718] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [719] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [720] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [721] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [722] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [723] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [724] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [725] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [726] = {
    [ts_builtin_sym_end] = ACTIONS(2323),
    [sym_identifier] = ACTIONS(2325),
    [anon_sym_export] = ACTIONS(2325),
    [anon_sym_default] = ACTIONS(2325),
    [anon_sym_type] = ACTIONS(2325),
    [anon_sym_namespace] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(2323),
    [anon_sym_RBRACE] = ACTIONS(2323),
    [anon_sym_typeof] = ACTIONS(2325),
    [anon_sym_import] = ACTIONS(2325),
    [anon_sym_var] = ACTIONS(2325),
    [anon_sym_let] = ACTIONS(2325),
    [anon_sym_const] = ACTIONS(2325),
    [anon_sym_BANG] = ACTIONS(2323),
    [anon_sym_else] = ACTIONS(2325),
    [anon_sym_if] = ACTIONS(2325),
    [anon_sym_switch] = ACTIONS(2325),
    [anon_sym_for] = ACTIONS(2325),
    [anon_sym_LPAREN] = ACTIONS(2323),
    [anon_sym_await] = ACTIONS(2325),
    [anon_sym_while] = ACTIONS(2325),
    [anon_sym_do] = ACTIONS(2325),
    [anon_sym_try] = ACTIONS(2325),
    [anon_sym_with] = ACTIONS(2325),
    [anon_sym_break] = ACTIONS(2325),
    [anon_sym_continue] = ACTIONS(2325),
    [anon_sym_debugger] = ACTIONS(2325),
    [anon_sym_return] = ACTIONS(2325),
    [anon_sym_throw] = ACTIONS(2325),
    [anon_sym_SEMI] = ACTIONS(2323),
    [anon_sym_case] = ACTIONS(2325),
    [anon_sym_yield] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LTtemplate_GT] = ACTIONS(2323),
    [anon_sym_class] = ACTIONS(2325),
    [anon_sym_async] = ACTIONS(2325),
    [anon_sym_function] = ACTIONS(2325),
    [anon_sym_new] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2325),
    [anon_sym_SLASH] = ACTIONS(2325),
    [anon_sym_LT] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2325),
    [anon_sym_delete] = ACTIONS(2325),
    [anon_sym_PLUS_PLUS] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(2325),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [anon_sym_SQUOTE] = ACTIONS(2323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2323),
    [sym_number] = ACTIONS(2323),
    [sym_this] = ACTIONS(2325),
    [sym_super] = ACTIONS(2325),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [sym_null] = ACTIONS(2325),
    [sym_undefined] = ACTIONS(2325),
    [anon_sym_AT] = ACTIONS(2323),
    [anon_sym_static] = ACTIONS(2325),
    [anon_sym_readonly] = ACTIONS(2325),
    [anon_sym_get] = ACTIONS(2325),
    [anon_sym_set] = ACTIONS(2325),
    [anon_sym_declare] = ACTIONS(2325),
    [anon_sym_public] = ACTIONS(2325),
    [anon_sym_private] = ACTIONS(2325),
    [anon_sym_protected] = ACTIONS(2325),
    [anon_sym_override] = ACTIONS(2325),
    [anon_sym_module] = ACTIONS(2325),
    [anon_sym_any] = ACTIONS(2325),
    [anon_sym_number] = ACTIONS(2325),
    [anon_sym_boolean] = ACTIONS(2325),
    [anon_sym_string] = ACTIONS(2325),
    [anon_sym_symbol] = ACTIONS(2325),
    [anon_sym_abstract] = ACTIONS(2325),
    [anon_sym_interface] = ACTIONS(2325),
    [anon_sym_enum] = ACTIONS(2325),
  },
  [727] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [728] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [729] = {
    [ts_builtin_sym_end] = ACTIONS(2327),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_export] = ACTIONS(2329),
    [anon_sym_default] = ACTIONS(2329),
    [anon_sym_type] = ACTIONS(2329),
    [anon_sym_namespace] = ACTIONS(2329),
    [anon_sym_LBRACE] = ACTIONS(2327),
    [anon_sym_RBRACE] = ACTIONS(2327),
    [anon_sym_typeof] = ACTIONS(2329),
    [anon_sym_import] = ACTIONS(2329),
    [anon_sym_var] = ACTIONS(2329),
    [anon_sym_let] = ACTIONS(2329),
    [anon_sym_const] = ACTIONS(2329),
    [anon_sym_BANG] = ACTIONS(2327),
    [anon_sym_else] = ACTIONS(2329),
    [anon_sym_if] = ACTIONS(2329),
    [anon_sym_switch] = ACTIONS(2329),
    [anon_sym_for] = ACTIONS(2329),
    [anon_sym_LPAREN] = ACTIONS(2327),
    [anon_sym_await] = ACTIONS(2329),
    [anon_sym_while] = ACTIONS(2329),
    [anon_sym_do] = ACTIONS(2329),
    [anon_sym_try] = ACTIONS(2329),
    [anon_sym_with] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2329),
    [anon_sym_continue] = ACTIONS(2329),
    [anon_sym_debugger] = ACTIONS(2329),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_throw] = ACTIONS(2329),
    [anon_sym_SEMI] = ACTIONS(2327),
    [anon_sym_case] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2329),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_LTtemplate_GT] = ACTIONS(2327),
    [anon_sym_class] = ACTIONS(2329),
    [anon_sym_async] = ACTIONS(2329),
    [anon_sym_function] = ACTIONS(2329),
    [anon_sym_new] = ACTIONS(2329),
    [anon_sym_PLUS] = ACTIONS(2329),
    [anon_sym_DASH] = ACTIONS(2329),
    [anon_sym_SLASH] = ACTIONS(2329),
    [anon_sym_LT] = ACTIONS(2329),
    [anon_sym_TILDE] = ACTIONS(2327),
    [anon_sym_void] = ACTIONS(2329),
    [anon_sym_delete] = ACTIONS(2329),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2329),
    [anon_sym_DQUOTE] = ACTIONS(2327),
    [anon_sym_SQUOTE] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2327),
    [sym_number] = ACTIONS(2327),
    [sym_this] = ACTIONS(2329),
    [sym_super] = ACTIONS(2329),
    [sym_true] = ACTIONS(2329),
    [sym_false] = ACTIONS(2329),
    [sym_null] = ACTIONS(2329),
    [sym_undefined] = ACTIONS(2329),
    [anon_sym_AT] = ACTIONS(2327),
    [anon_sym_static] = ACTIONS(2329),
    [anon_sym_readonly] = ACTIONS(2329),
    [anon_sym_get] = ACTIONS(2329),
    [anon_sym_set] = ACTIONS(2329),
    [anon_sym_declare] = ACTIONS(2329),
    [anon_sym_public] = ACTIONS(2329),
    [anon_sym_private] = ACTIONS(2329),
    [anon_sym_protected] = ACTIONS(2329),
    [anon_sym_override] = ACTIONS(2329),
    [anon_sym_module] = ACTIONS(2329),
    [anon_sym_any] = ACTIONS(2329),
    [anon_sym_number] = ACTIONS(2329),
    [anon_sym_boolean] = ACTIONS(2329),
    [anon_sym_string] = ACTIONS(2329),
    [anon_sym_symbol] = ACTIONS(2329),
    [anon_sym_abstract] = ACTIONS(2329),
    [anon_sym_interface] = ACTIONS(2329),
    [anon_sym_enum] = ACTIONS(2329),
  },
  [730] = {
    [ts_builtin_sym_end] = ACTIONS(2331),
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_export] = ACTIONS(2333),
    [anon_sym_default] = ACTIONS(2333),
    [anon_sym_type] = ACTIONS(2333),
    [anon_sym_namespace] = ACTIONS(2333),
    [anon_sym_LBRACE] = ACTIONS(2331),
    [anon_sym_RBRACE] = ACTIONS(2331),
    [anon_sym_typeof] = ACTIONS(2333),
    [anon_sym_import] = ACTIONS(2333),
    [anon_sym_var] = ACTIONS(2333),
    [anon_sym_let] = ACTIONS(2333),
    [anon_sym_const] = ACTIONS(2333),
    [anon_sym_BANG] = ACTIONS(2331),
    [anon_sym_else] = ACTIONS(2333),
    [anon_sym_if] = ACTIONS(2333),
    [anon_sym_switch] = ACTIONS(2333),
    [anon_sym_for] = ACTIONS(2333),
    [anon_sym_LPAREN] = ACTIONS(2331),
    [anon_sym_await] = ACTIONS(2333),
    [anon_sym_while] = ACTIONS(2333),
    [anon_sym_do] = ACTIONS(2333),
    [anon_sym_try] = ACTIONS(2333),
    [anon_sym_with] = ACTIONS(2333),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_continue] = ACTIONS(2333),
    [anon_sym_debugger] = ACTIONS(2333),
    [anon_sym_return] = ACTIONS(2333),
    [anon_sym_throw] = ACTIONS(2333),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_case] = ACTIONS(2333),
    [anon_sym_yield] = ACTIONS(2333),
    [anon_sym_LBRACK] = ACTIONS(2331),
    [anon_sym_LTtemplate_GT] = ACTIONS(2331),
    [anon_sym_class] = ACTIONS(2333),
    [anon_sym_async] = ACTIONS(2333),
    [anon_sym_function] = ACTIONS(2333),
    [anon_sym_new] = ACTIONS(2333),
    [anon_sym_PLUS] = ACTIONS(2333),
    [anon_sym_DASH] = ACTIONS(2333),
    [anon_sym_SLASH] = ACTIONS(2333),
    [anon_sym_LT] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2331),
    [anon_sym_void] = ACTIONS(2333),
    [anon_sym_delete] = ACTIONS(2333),
    [anon_sym_PLUS_PLUS] = ACTIONS(2331),
    [anon_sym_DASH_DASH] = ACTIONS(2333),
    [anon_sym_DQUOTE] = ACTIONS(2331),
    [anon_sym_SQUOTE] = ACTIONS(2331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2331),
    [sym_number] = ACTIONS(2331),
    [sym_this] = ACTIONS(2333),
    [sym_super] = ACTIONS(2333),
    [sym_true] = ACTIONS(2333),
    [sym_false] = ACTIONS(2333),
    [sym_null] = ACTIONS(2333),
    [sym_undefined] = ACTIONS(2333),
    [anon_sym_AT] = ACTIONS(2331),
    [anon_sym_static] = ACTIONS(2333),
    [anon_sym_readonly] = ACTIONS(2333),
    [anon_sym_get] = ACTIONS(2333),
    [anon_sym_set] = ACTIONS(2333),
    [anon_sym_declare] = ACTIONS(2333),
    [anon_sym_public] = ACTIONS(2333),
    [anon_sym_private] = ACTIONS(2333),
    [anon_sym_protected] = ACTIONS(2333),
    [anon_sym_override] = ACTIONS(2333),
    [anon_sym_module] = ACTIONS(2333),
    [anon_sym_any] = ACTIONS(2333),
    [anon_sym_number] = ACTIONS(2333),
    [anon_sym_boolean] = ACTIONS(2333),
    [anon_sym_string] = ACTIONS(2333),
    [anon_sym_symbol] = ACTIONS(2333),
    [anon_sym_abstract] = ACTIONS(2333),
    [anon_sym_interface] = ACTIONS(2333),
    [anon_sym_enum] = ACTIONS(2333),
  },
  [731] = {
    [ts_builtin_sym_end] = ACTIONS(2335),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_export] = ACTIONS(2337),
    [anon_sym_default] = ACTIONS(2337),
    [anon_sym_type] = ACTIONS(2337),
    [anon_sym_namespace] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_RBRACE] = ACTIONS(2335),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_import] = ACTIONS(2337),
    [anon_sym_var] = ACTIONS(2337),
    [anon_sym_let] = ACTIONS(2337),
    [anon_sym_const] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_else] = ACTIONS(2337),
    [anon_sym_if] = ACTIONS(2337),
    [anon_sym_switch] = ACTIONS(2337),
    [anon_sym_for] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2335),
    [anon_sym_await] = ACTIONS(2337),
    [anon_sym_while] = ACTIONS(2337),
    [anon_sym_do] = ACTIONS(2337),
    [anon_sym_try] = ACTIONS(2337),
    [anon_sym_with] = ACTIONS(2337),
    [anon_sym_break] = ACTIONS(2337),
    [anon_sym_continue] = ACTIONS(2337),
    [anon_sym_debugger] = ACTIONS(2337),
    [anon_sym_return] = ACTIONS(2337),
    [anon_sym_throw] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2335),
    [anon_sym_case] = ACTIONS(2337),
    [anon_sym_yield] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(2335),
    [anon_sym_LTtemplate_GT] = ACTIONS(2335),
    [anon_sym_class] = ACTIONS(2337),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_function] = ACTIONS(2337),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(2337),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_TILDE] = ACTIONS(2335),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_delete] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2335),
    [anon_sym_DASH_DASH] = ACTIONS(2337),
    [anon_sym_DQUOTE] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2335),
    [sym_number] = ACTIONS(2335),
    [sym_this] = ACTIONS(2337),
    [sym_super] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_AT] = ACTIONS(2335),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_declare] = ACTIONS(2337),
    [anon_sym_public] = ACTIONS(2337),
    [anon_sym_private] = ACTIONS(2337),
    [anon_sym_protected] = ACTIONS(2337),
    [anon_sym_override] = ACTIONS(2337),
    [anon_sym_module] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_interface] = ACTIONS(2337),
    [anon_sym_enum] = ACTIONS(2337),
  },
  [732] = {
    [ts_builtin_sym_end] = ACTIONS(2339),
    [sym_identifier] = ACTIONS(2341),
    [anon_sym_export] = ACTIONS(2341),
    [anon_sym_default] = ACTIONS(2341),
    [anon_sym_type] = ACTIONS(2341),
    [anon_sym_namespace] = ACTIONS(2341),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2341),
    [anon_sym_import] = ACTIONS(2341),
    [anon_sym_var] = ACTIONS(2341),
    [anon_sym_let] = ACTIONS(2341),
    [anon_sym_const] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2339),
    [anon_sym_else] = ACTIONS(2341),
    [anon_sym_if] = ACTIONS(2341),
    [anon_sym_switch] = ACTIONS(2341),
    [anon_sym_for] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2339),
    [anon_sym_await] = ACTIONS(2341),
    [anon_sym_while] = ACTIONS(2341),
    [anon_sym_do] = ACTIONS(2341),
    [anon_sym_try] = ACTIONS(2341),
    [anon_sym_with] = ACTIONS(2341),
    [anon_sym_break] = ACTIONS(2341),
    [anon_sym_continue] = ACTIONS(2341),
    [anon_sym_debugger] = ACTIONS(2341),
    [anon_sym_return] = ACTIONS(2341),
    [anon_sym_throw] = ACTIONS(2341),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_case] = ACTIONS(2341),
    [anon_sym_yield] = ACTIONS(2341),
    [anon_sym_LBRACK] = ACTIONS(2339),
    [anon_sym_LTtemplate_GT] = ACTIONS(2339),
    [anon_sym_class] = ACTIONS(2341),
    [anon_sym_async] = ACTIONS(2341),
    [anon_sym_function] = ACTIONS(2341),
    [anon_sym_new] = ACTIONS(2341),
    [anon_sym_PLUS] = ACTIONS(2341),
    [anon_sym_DASH] = ACTIONS(2341),
    [anon_sym_SLASH] = ACTIONS(2341),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2339),
    [anon_sym_void] = ACTIONS(2341),
    [anon_sym_delete] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2339),
    [anon_sym_DASH_DASH] = ACTIONS(2341),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2341),
    [sym_super] = ACTIONS(2341),
    [sym_true] = ACTIONS(2341),
    [sym_false] = ACTIONS(2341),
    [sym_null] = ACTIONS(2341),
    [sym_undefined] = ACTIONS(2341),
    [anon_sym_AT] = ACTIONS(2339),
    [anon_sym_static] = ACTIONS(2341),
    [anon_sym_readonly] = ACTIONS(2341),
    [anon_sym_get] = ACTIONS(2341),
    [anon_sym_set] = ACTIONS(2341),
    [anon_sym_declare] = ACTIONS(2341),
    [anon_sym_public] = ACTIONS(2341),
    [anon_sym_private] = ACTIONS(2341),
    [anon_sym_protected] = ACTIONS(2341),
    [anon_sym_override] = ACTIONS(2341),
    [anon_sym_module] = ACTIONS(2341),
    [anon_sym_any] = ACTIONS(2341),
    [anon_sym_number] = ACTIONS(2341),
    [anon_sym_boolean] = ACTIONS(2341),
    [anon_sym_string] = ACTIONS(2341),
    [anon_sym_symbol] = ACTIONS(2341),
    [anon_sym_abstract] = ACTIONS(2341),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_enum] = ACTIONS(2341),
  },
  [733] = {
    [ts_builtin_sym_end] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2345),
    [anon_sym_export] = ACTIONS(2345),
    [anon_sym_default] = ACTIONS(2345),
    [anon_sym_type] = ACTIONS(2345),
    [anon_sym_namespace] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(2343),
    [anon_sym_typeof] = ACTIONS(2345),
    [anon_sym_import] = ACTIONS(2345),
    [anon_sym_var] = ACTIONS(2345),
    [anon_sym_let] = ACTIONS(2345),
    [anon_sym_const] = ACTIONS(2345),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_else] = ACTIONS(2345),
    [anon_sym_if] = ACTIONS(2345),
    [anon_sym_switch] = ACTIONS(2345),
    [anon_sym_for] = ACTIONS(2345),
    [anon_sym_LPAREN] = ACTIONS(2343),
    [anon_sym_await] = ACTIONS(2345),
    [anon_sym_while] = ACTIONS(2345),
    [anon_sym_do] = ACTIONS(2345),
    [anon_sym_try] = ACTIONS(2345),
    [anon_sym_with] = ACTIONS(2345),
    [anon_sym_break] = ACTIONS(2345),
    [anon_sym_continue] = ACTIONS(2345),
    [anon_sym_debugger] = ACTIONS(2345),
    [anon_sym_return] = ACTIONS(2345),
    [anon_sym_throw] = ACTIONS(2345),
    [anon_sym_SEMI] = ACTIONS(2343),
    [anon_sym_case] = ACTIONS(2345),
    [anon_sym_yield] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2343),
    [anon_sym_LTtemplate_GT] = ACTIONS(2343),
    [anon_sym_class] = ACTIONS(2345),
    [anon_sym_async] = ACTIONS(2345),
    [anon_sym_function] = ACTIONS(2345),
    [anon_sym_new] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(2345),
    [anon_sym_DASH] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_void] = ACTIONS(2345),
    [anon_sym_delete] = ACTIONS(2345),
    [anon_sym_PLUS_PLUS] = ACTIONS(2343),
    [anon_sym_DASH_DASH] = ACTIONS(2345),
    [anon_sym_DQUOTE] = ACTIONS(2343),
    [anon_sym_SQUOTE] = ACTIONS(2343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2343),
    [sym_number] = ACTIONS(2343),
    [sym_this] = ACTIONS(2345),
    [sym_super] = ACTIONS(2345),
    [sym_true] = ACTIONS(2345),
    [sym_false] = ACTIONS(2345),
    [sym_null] = ACTIONS(2345),
    [sym_undefined] = ACTIONS(2345),
    [anon_sym_AT] = ACTIONS(2343),
    [anon_sym_static] = ACTIONS(2345),
    [anon_sym_readonly] = ACTIONS(2345),
    [anon_sym_get] = ACTIONS(2345),
    [anon_sym_set] = ACTIONS(2345),
    [anon_sym_declare] = ACTIONS(2345),
    [anon_sym_public] = ACTIONS(2345),
    [anon_sym_private] = ACTIONS(2345),
    [anon_sym_protected] = ACTIONS(2345),
    [anon_sym_override] = ACTIONS(2345),
    [anon_sym_module] = ACTIONS(2345),
    [anon_sym_any] = ACTIONS(2345),
    [anon_sym_number] = ACTIONS(2345),
    [anon_sym_boolean] = ACTIONS(2345),
    [anon_sym_string] = ACTIONS(2345),
    [anon_sym_symbol] = ACTIONS(2345),
    [anon_sym_abstract] = ACTIONS(2345),
    [anon_sym_interface] = ACTIONS(2345),
    [anon_sym_enum] = ACTIONS(2345),
  },
  [734] = {
    [ts_builtin_sym_end] = ACTIONS(2347),
    [sym_identifier] = ACTIONS(2349),
    [anon_sym_export] = ACTIONS(2349),
    [anon_sym_default] = ACTIONS(2349),
    [anon_sym_type] = ACTIONS(2349),
    [anon_sym_namespace] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_import] = ACTIONS(2349),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_const] = ACTIONS(2349),
    [anon_sym_BANG] = ACTIONS(2347),
    [anon_sym_else] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2349),
    [anon_sym_switch] = ACTIONS(2349),
    [anon_sym_for] = ACTIONS(2349),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_await] = ACTIONS(2349),
    [anon_sym_while] = ACTIONS(2349),
    [anon_sym_do] = ACTIONS(2349),
    [anon_sym_try] = ACTIONS(2349),
    [anon_sym_with] = ACTIONS(2349),
    [anon_sym_break] = ACTIONS(2349),
    [anon_sym_continue] = ACTIONS(2349),
    [anon_sym_debugger] = ACTIONS(2349),
    [anon_sym_return] = ACTIONS(2349),
    [anon_sym_throw] = ACTIONS(2349),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_case] = ACTIONS(2349),
    [anon_sym_yield] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_LTtemplate_GT] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(2349),
    [anon_sym_async] = ACTIONS(2349),
    [anon_sym_function] = ACTIONS(2349),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_SLASH] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(2349),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_void] = ACTIONS(2349),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2349),
    [anon_sym_DQUOTE] = ACTIONS(2347),
    [anon_sym_SQUOTE] = ACTIONS(2347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2347),
    [sym_number] = ACTIONS(2347),
    [sym_this] = ACTIONS(2349),
    [sym_super] = ACTIONS(2349),
    [sym_true] = ACTIONS(2349),
    [sym_false] = ACTIONS(2349),
    [sym_null] = ACTIONS(2349),
    [sym_undefined] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_static] = ACTIONS(2349),
    [anon_sym_readonly] = ACTIONS(2349),
    [anon_sym_get] = ACTIONS(2349),
    [anon_sym_set] = ACTIONS(2349),
    [anon_sym_declare] = ACTIONS(2349),
    [anon_sym_public] = ACTIONS(2349),
    [anon_sym_private] = ACTIONS(2349),
    [anon_sym_protected] = ACTIONS(2349),
    [anon_sym_override] = ACTIONS(2349),
    [anon_sym_module] = ACTIONS(2349),
    [anon_sym_any] = ACTIONS(2349),
    [anon_sym_number] = ACTIONS(2349),
    [anon_sym_boolean] = ACTIONS(2349),
    [anon_sym_string] = ACTIONS(2349),
    [anon_sym_symbol] = ACTIONS(2349),
    [anon_sym_abstract] = ACTIONS(2349),
    [anon_sym_interface] = ACTIONS(2349),
    [anon_sym_enum] = ACTIONS(2349),
  },
  [735] = {
    [ts_builtin_sym_end] = ACTIONS(2351),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_export] = ACTIONS(2353),
    [anon_sym_default] = ACTIONS(2353),
    [anon_sym_type] = ACTIONS(2353),
    [anon_sym_namespace] = ACTIONS(2353),
    [anon_sym_LBRACE] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_typeof] = ACTIONS(2353),
    [anon_sym_import] = ACTIONS(2353),
    [anon_sym_var] = ACTIONS(2353),
    [anon_sym_let] = ACTIONS(2353),
    [anon_sym_const] = ACTIONS(2353),
    [anon_sym_BANG] = ACTIONS(2351),
    [anon_sym_else] = ACTIONS(2353),
    [anon_sym_if] = ACTIONS(2353),
    [anon_sym_switch] = ACTIONS(2353),
    [anon_sym_for] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2353),
    [anon_sym_while] = ACTIONS(2353),
    [anon_sym_do] = ACTIONS(2353),
    [anon_sym_try] = ACTIONS(2353),
    [anon_sym_with] = ACTIONS(2353),
    [anon_sym_break] = ACTIONS(2353),
    [anon_sym_continue] = ACTIONS(2353),
    [anon_sym_debugger] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(2353),
    [anon_sym_throw] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2351),
    [anon_sym_case] = ACTIONS(2353),
    [anon_sym_yield] = ACTIONS(2353),
    [anon_sym_LBRACK] = ACTIONS(2351),
    [anon_sym_LTtemplate_GT] = ACTIONS(2351),
    [anon_sym_class] = ACTIONS(2353),
    [anon_sym_async] = ACTIONS(2353),
    [anon_sym_function] = ACTIONS(2353),
    [anon_sym_new] = ACTIONS(2353),
    [anon_sym_PLUS] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2353),
    [anon_sym_SLASH] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2351),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_delete] = ACTIONS(2353),
    [anon_sym_PLUS_PLUS] = ACTIONS(2351),
    [anon_sym_DASH_DASH] = ACTIONS(2353),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_SQUOTE] = ACTIONS(2351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [sym_number] = ACTIONS(2351),
    [sym_this] = ACTIONS(2353),
    [sym_super] = ACTIONS(2353),
    [sym_true] = ACTIONS(2353),
    [sym_false] = ACTIONS(2353),
    [sym_null] = ACTIONS(2353),
    [sym_undefined] = ACTIONS(2353),
    [anon_sym_AT] = ACTIONS(2351),
    [anon_sym_static] = ACTIONS(2353),
    [anon_sym_readonly] = ACTIONS(2353),
    [anon_sym_get] = ACTIONS(2353),
    [anon_sym_set] = ACTIONS(2353),
    [anon_sym_declare] = ACTIONS(2353),
    [anon_sym_public] = ACTIONS(2353),
    [anon_sym_private] = ACTIONS(2353),
    [anon_sym_protected] = ACTIONS(2353),
    [anon_sym_override] = ACTIONS(2353),
    [anon_sym_module] = ACTIONS(2353),
    [anon_sym_any] = ACTIONS(2353),
    [anon_sym_number] = ACTIONS(2353),
    [anon_sym_boolean] = ACTIONS(2353),
    [anon_sym_string] = ACTIONS(2353),
    [anon_sym_symbol] = ACTIONS(2353),
    [anon_sym_abstract] = ACTIONS(2353),
    [anon_sym_interface] = ACTIONS(2353),
    [anon_sym_enum] = ACTIONS(2353),
  },
  [736] = {
    [ts_builtin_sym_end] = ACTIONS(2355),
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_export] = ACTIONS(2357),
    [anon_sym_default] = ACTIONS(2357),
    [anon_sym_type] = ACTIONS(2357),
    [anon_sym_namespace] = ACTIONS(2357),
    [anon_sym_LBRACE] = ACTIONS(2355),
    [anon_sym_RBRACE] = ACTIONS(2355),
    [anon_sym_typeof] = ACTIONS(2357),
    [anon_sym_import] = ACTIONS(2357),
    [anon_sym_var] = ACTIONS(2357),
    [anon_sym_let] = ACTIONS(2357),
    [anon_sym_const] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2355),
    [anon_sym_else] = ACTIONS(2357),
    [anon_sym_if] = ACTIONS(2357),
    [anon_sym_switch] = ACTIONS(2357),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [anon_sym_await] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(2357),
    [anon_sym_do] = ACTIONS(2357),
    [anon_sym_try] = ACTIONS(2357),
    [anon_sym_with] = ACTIONS(2357),
    [anon_sym_break] = ACTIONS(2357),
    [anon_sym_continue] = ACTIONS(2357),
    [anon_sym_debugger] = ACTIONS(2357),
    [anon_sym_return] = ACTIONS(2357),
    [anon_sym_throw] = ACTIONS(2357),
    [anon_sym_SEMI] = ACTIONS(2355),
    [anon_sym_case] = ACTIONS(2357),
    [anon_sym_yield] = ACTIONS(2357),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_LTtemplate_GT] = ACTIONS(2355),
    [anon_sym_class] = ACTIONS(2357),
    [anon_sym_async] = ACTIONS(2357),
    [anon_sym_function] = ACTIONS(2357),
    [anon_sym_new] = ACTIONS(2357),
    [anon_sym_PLUS] = ACTIONS(2357),
    [anon_sym_DASH] = ACTIONS(2357),
    [anon_sym_SLASH] = ACTIONS(2357),
    [anon_sym_LT] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2355),
    [anon_sym_void] = ACTIONS(2357),
    [anon_sym_delete] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2355),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_DQUOTE] = ACTIONS(2355),
    [anon_sym_SQUOTE] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2355),
    [sym_number] = ACTIONS(2355),
    [sym_this] = ACTIONS(2357),
    [sym_super] = ACTIONS(2357),
    [sym_true] = ACTIONS(2357),
    [sym_false] = ACTIONS(2357),
    [sym_null] = ACTIONS(2357),
    [sym_undefined] = ACTIONS(2357),
    [anon_sym_AT] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2357),
    [anon_sym_readonly] = ACTIONS(2357),
    [anon_sym_get] = ACTIONS(2357),
    [anon_sym_set] = ACTIONS(2357),
    [anon_sym_declare] = ACTIONS(2357),
    [anon_sym_public] = ACTIONS(2357),
    [anon_sym_private] = ACTIONS(2357),
    [anon_sym_protected] = ACTIONS(2357),
    [anon_sym_override] = ACTIONS(2357),
    [anon_sym_module] = ACTIONS(2357),
    [anon_sym_any] = ACTIONS(2357),
    [anon_sym_number] = ACTIONS(2357),
    [anon_sym_boolean] = ACTIONS(2357),
    [anon_sym_string] = ACTIONS(2357),
    [anon_sym_symbol] = ACTIONS(2357),
    [anon_sym_abstract] = ACTIONS(2357),
    [anon_sym_interface] = ACTIONS(2357),
    [anon_sym_enum] = ACTIONS(2357),
  },
  [737] = {
    [ts_builtin_sym_end] = ACTIONS(2355),
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_export] = ACTIONS(2357),
    [anon_sym_default] = ACTIONS(2357),
    [anon_sym_type] = ACTIONS(2357),
    [anon_sym_namespace] = ACTIONS(2357),
    [anon_sym_LBRACE] = ACTIONS(2355),
    [anon_sym_RBRACE] = ACTIONS(2355),
    [anon_sym_typeof] = ACTIONS(2357),
    [anon_sym_import] = ACTIONS(2357),
    [anon_sym_var] = ACTIONS(2357),
    [anon_sym_let] = ACTIONS(2357),
    [anon_sym_const] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2355),
    [anon_sym_else] = ACTIONS(2357),
    [anon_sym_if] = ACTIONS(2357),
    [anon_sym_switch] = ACTIONS(2357),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [anon_sym_await] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(2357),
    [anon_sym_do] = ACTIONS(2357),
    [anon_sym_try] = ACTIONS(2357),
    [anon_sym_with] = ACTIONS(2357),
    [anon_sym_break] = ACTIONS(2357),
    [anon_sym_continue] = ACTIONS(2357),
    [anon_sym_debugger] = ACTIONS(2357),
    [anon_sym_return] = ACTIONS(2357),
    [anon_sym_throw] = ACTIONS(2357),
    [anon_sym_SEMI] = ACTIONS(2355),
    [anon_sym_case] = ACTIONS(2357),
    [anon_sym_yield] = ACTIONS(2357),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_LTtemplate_GT] = ACTIONS(2355),
    [anon_sym_class] = ACTIONS(2357),
    [anon_sym_async] = ACTIONS(2357),
    [anon_sym_function] = ACTIONS(2357),
    [anon_sym_new] = ACTIONS(2357),
    [anon_sym_PLUS] = ACTIONS(2357),
    [anon_sym_DASH] = ACTIONS(2357),
    [anon_sym_SLASH] = ACTIONS(2357),
    [anon_sym_LT] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2355),
    [anon_sym_void] = ACTIONS(2357),
    [anon_sym_delete] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2355),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_DQUOTE] = ACTIONS(2355),
    [anon_sym_SQUOTE] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2355),
    [sym_number] = ACTIONS(2355),
    [sym_this] = ACTIONS(2357),
    [sym_super] = ACTIONS(2357),
    [sym_true] = ACTIONS(2357),
    [sym_false] = ACTIONS(2357),
    [sym_null] = ACTIONS(2357),
    [sym_undefined] = ACTIONS(2357),
    [anon_sym_AT] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2357),
    [anon_sym_readonly] = ACTIONS(2357),
    [anon_sym_get] = ACTIONS(2357),
    [anon_sym_set] = ACTIONS(2357),
    [anon_sym_declare] = ACTIONS(2357),
    [anon_sym_public] = ACTIONS(2357),
    [anon_sym_private] = ACTIONS(2357),
    [anon_sym_protected] = ACTIONS(2357),
    [anon_sym_override] = ACTIONS(2357),
    [anon_sym_module] = ACTIONS(2357),
    [anon_sym_any] = ACTIONS(2357),
    [anon_sym_number] = ACTIONS(2357),
    [anon_sym_boolean] = ACTIONS(2357),
    [anon_sym_string] = ACTIONS(2357),
    [anon_sym_symbol] = ACTIONS(2357),
    [anon_sym_abstract] = ACTIONS(2357),
    [anon_sym_interface] = ACTIONS(2357),
    [anon_sym_enum] = ACTIONS(2357),
  },
  [738] = {
    [ts_builtin_sym_end] = ACTIONS(2359),
    [sym_identifier] = ACTIONS(2361),
    [anon_sym_export] = ACTIONS(2361),
    [anon_sym_default] = ACTIONS(2361),
    [anon_sym_type] = ACTIONS(2361),
    [anon_sym_namespace] = ACTIONS(2361),
    [anon_sym_LBRACE] = ACTIONS(2359),
    [anon_sym_RBRACE] = ACTIONS(2359),
    [anon_sym_typeof] = ACTIONS(2361),
    [anon_sym_import] = ACTIONS(2361),
    [anon_sym_var] = ACTIONS(2361),
    [anon_sym_let] = ACTIONS(2361),
    [anon_sym_const] = ACTIONS(2361),
    [anon_sym_BANG] = ACTIONS(2359),
    [anon_sym_else] = ACTIONS(2361),
    [anon_sym_if] = ACTIONS(2361),
    [anon_sym_switch] = ACTIONS(2361),
    [anon_sym_for] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2359),
    [anon_sym_await] = ACTIONS(2361),
    [anon_sym_while] = ACTIONS(2361),
    [anon_sym_do] = ACTIONS(2361),
    [anon_sym_try] = ACTIONS(2361),
    [anon_sym_with] = ACTIONS(2361),
    [anon_sym_break] = ACTIONS(2361),
    [anon_sym_continue] = ACTIONS(2361),
    [anon_sym_debugger] = ACTIONS(2361),
    [anon_sym_return] = ACTIONS(2361),
    [anon_sym_throw] = ACTIONS(2361),
    [anon_sym_SEMI] = ACTIONS(2359),
    [anon_sym_case] = ACTIONS(2361),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_LTtemplate_GT] = ACTIONS(2359),
    [anon_sym_class] = ACTIONS(2361),
    [anon_sym_async] = ACTIONS(2361),
    [anon_sym_function] = ACTIONS(2361),
    [anon_sym_new] = ACTIONS(2361),
    [anon_sym_PLUS] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2359),
    [anon_sym_void] = ACTIONS(2361),
    [anon_sym_delete] = ACTIONS(2361),
    [anon_sym_PLUS_PLUS] = ACTIONS(2359),
    [anon_sym_DASH_DASH] = ACTIONS(2361),
    [anon_sym_DQUOTE] = ACTIONS(2359),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2359),
    [sym_number] = ACTIONS(2359),
    [sym_this] = ACTIONS(2361),
    [sym_super] = ACTIONS(2361),
    [sym_true] = ACTIONS(2361),
    [sym_false] = ACTIONS(2361),
    [sym_null] = ACTIONS(2361),
    [sym_undefined] = ACTIONS(2361),
    [anon_sym_AT] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2361),
    [anon_sym_readonly] = ACTIONS(2361),
    [anon_sym_get] = ACTIONS(2361),
    [anon_sym_set] = ACTIONS(2361),
    [anon_sym_declare] = ACTIONS(2361),
    [anon_sym_public] = ACTIONS(2361),
    [anon_sym_private] = ACTIONS(2361),
    [anon_sym_protected] = ACTIONS(2361),
    [anon_sym_override] = ACTIONS(2361),
    [anon_sym_module] = ACTIONS(2361),
    [anon_sym_any] = ACTIONS(2361),
    [anon_sym_number] = ACTIONS(2361),
    [anon_sym_boolean] = ACTIONS(2361),
    [anon_sym_string] = ACTIONS(2361),
    [anon_sym_symbol] = ACTIONS(2361),
    [anon_sym_abstract] = ACTIONS(2361),
    [anon_sym_interface] = ACTIONS(2361),
    [anon_sym_enum] = ACTIONS(2361),
  },
  [739] = {
    [ts_builtin_sym_end] = ACTIONS(2363),
    [sym_identifier] = ACTIONS(2365),
    [anon_sym_export] = ACTIONS(2365),
    [anon_sym_default] = ACTIONS(2365),
    [anon_sym_type] = ACTIONS(2365),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2363),
    [anon_sym_RBRACE] = ACTIONS(2363),
    [anon_sym_typeof] = ACTIONS(2365),
    [anon_sym_import] = ACTIONS(2365),
    [anon_sym_var] = ACTIONS(2365),
    [anon_sym_let] = ACTIONS(2365),
    [anon_sym_const] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2363),
    [anon_sym_else] = ACTIONS(2365),
    [anon_sym_if] = ACTIONS(2365),
    [anon_sym_switch] = ACTIONS(2365),
    [anon_sym_for] = ACTIONS(2365),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_await] = ACTIONS(2365),
    [anon_sym_while] = ACTIONS(2365),
    [anon_sym_do] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(2365),
    [anon_sym_with] = ACTIONS(2365),
    [anon_sym_break] = ACTIONS(2365),
    [anon_sym_continue] = ACTIONS(2365),
    [anon_sym_debugger] = ACTIONS(2365),
    [anon_sym_return] = ACTIONS(2365),
    [anon_sym_throw] = ACTIONS(2365),
    [anon_sym_SEMI] = ACTIONS(2363),
    [anon_sym_case] = ACTIONS(2365),
    [anon_sym_yield] = ACTIONS(2365),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LTtemplate_GT] = ACTIONS(2363),
    [anon_sym_class] = ACTIONS(2365),
    [anon_sym_async] = ACTIONS(2365),
    [anon_sym_function] = ACTIONS(2365),
    [anon_sym_new] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2363),
    [anon_sym_void] = ACTIONS(2365),
    [anon_sym_delete] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2363),
    [anon_sym_DASH_DASH] = ACTIONS(2365),
    [anon_sym_DQUOTE] = ACTIONS(2363),
    [anon_sym_SQUOTE] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2363),
    [sym_number] = ACTIONS(2363),
    [sym_this] = ACTIONS(2365),
    [sym_super] = ACTIONS(2365),
    [sym_true] = ACTIONS(2365),
    [sym_false] = ACTIONS(2365),
    [sym_null] = ACTIONS(2365),
    [sym_undefined] = ACTIONS(2365),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_static] = ACTIONS(2365),
    [anon_sym_readonly] = ACTIONS(2365),
    [anon_sym_get] = ACTIONS(2365),
    [anon_sym_set] = ACTIONS(2365),
    [anon_sym_declare] = ACTIONS(2365),
    [anon_sym_public] = ACTIONS(2365),
    [anon_sym_private] = ACTIONS(2365),
    [anon_sym_protected] = ACTIONS(2365),
    [anon_sym_override] = ACTIONS(2365),
    [anon_sym_module] = ACTIONS(2365),
    [anon_sym_any] = ACTIONS(2365),
    [anon_sym_number] = ACTIONS(2365),
    [anon_sym_boolean] = ACTIONS(2365),
    [anon_sym_string] = ACTIONS(2365),
    [anon_sym_symbol] = ACTIONS(2365),
    [anon_sym_abstract] = ACTIONS(2365),
    [anon_sym_interface] = ACTIONS(2365),
    [anon_sym_enum] = ACTIONS(2365),
  },
  [740] = {
    [ts_builtin_sym_end] = ACTIONS(2367),
    [sym_identifier] = ACTIONS(2369),
    [anon_sym_export] = ACTIONS(2369),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_type] = ACTIONS(2369),
    [anon_sym_namespace] = ACTIONS(2369),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_RBRACE] = ACTIONS(2367),
    [anon_sym_typeof] = ACTIONS(2369),
    [anon_sym_import] = ACTIONS(2369),
    [anon_sym_var] = ACTIONS(2369),
    [anon_sym_let] = ACTIONS(2369),
    [anon_sym_const] = ACTIONS(2369),
    [anon_sym_BANG] = ACTIONS(2367),
    [anon_sym_else] = ACTIONS(2369),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_switch] = ACTIONS(2369),
    [anon_sym_for] = ACTIONS(2369),
    [anon_sym_LPAREN] = ACTIONS(2367),
    [anon_sym_await] = ACTIONS(2369),
    [anon_sym_while] = ACTIONS(2369),
    [anon_sym_do] = ACTIONS(2369),
    [anon_sym_try] = ACTIONS(2369),
    [anon_sym_with] = ACTIONS(2369),
    [anon_sym_break] = ACTIONS(2369),
    [anon_sym_continue] = ACTIONS(2369),
    [anon_sym_debugger] = ACTIONS(2369),
    [anon_sym_return] = ACTIONS(2369),
    [anon_sym_throw] = ACTIONS(2369),
    [anon_sym_SEMI] = ACTIONS(2367),
    [anon_sym_case] = ACTIONS(2369),
    [anon_sym_yield] = ACTIONS(2369),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_LTtemplate_GT] = ACTIONS(2367),
    [anon_sym_class] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(2369),
    [anon_sym_function] = ACTIONS(2369),
    [anon_sym_new] = ACTIONS(2369),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_SLASH] = ACTIONS(2369),
    [anon_sym_LT] = ACTIONS(2369),
    [anon_sym_TILDE] = ACTIONS(2367),
    [anon_sym_void] = ACTIONS(2369),
    [anon_sym_delete] = ACTIONS(2369),
    [anon_sym_PLUS_PLUS] = ACTIONS(2367),
    [anon_sym_DASH_DASH] = ACTIONS(2369),
    [anon_sym_DQUOTE] = ACTIONS(2367),
    [anon_sym_SQUOTE] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2367),
    [sym_number] = ACTIONS(2367),
    [sym_this] = ACTIONS(2369),
    [sym_super] = ACTIONS(2369),
    [sym_true] = ACTIONS(2369),
    [sym_false] = ACTIONS(2369),
    [sym_null] = ACTIONS(2369),
    [sym_undefined] = ACTIONS(2369),
    [anon_sym_AT] = ACTIONS(2367),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_readonly] = ACTIONS(2369),
    [anon_sym_get] = ACTIONS(2369),
    [anon_sym_set] = ACTIONS(2369),
    [anon_sym_declare] = ACTIONS(2369),
    [anon_sym_public] = ACTIONS(2369),
    [anon_sym_private] = ACTIONS(2369),
    [anon_sym_protected] = ACTIONS(2369),
    [anon_sym_override] = ACTIONS(2369),
    [anon_sym_module] = ACTIONS(2369),
    [anon_sym_any] = ACTIONS(2369),
    [anon_sym_number] = ACTIONS(2369),
    [anon_sym_boolean] = ACTIONS(2369),
    [anon_sym_string] = ACTIONS(2369),
    [anon_sym_symbol] = ACTIONS(2369),
    [anon_sym_abstract] = ACTIONS(2369),
    [anon_sym_interface] = ACTIONS(2369),
    [anon_sym_enum] = ACTIONS(2369),
  },
  [741] = {
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_export] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_typeof] = ACTIONS(2373),
    [anon_sym_import] = ACTIONS(2373),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_await] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_with] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_debugger] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_yield] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LTtemplate_GT] = ACTIONS(2371),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_async] = ACTIONS(2373),
    [anon_sym_function] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_void] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [sym_number] = ACTIONS(2371),
    [sym_this] = ACTIONS(2373),
    [sym_super] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_null] = ACTIONS(2373),
    [sym_undefined] = ACTIONS(2373),
    [anon_sym_AT] = ACTIONS(2371),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_readonly] = ACTIONS(2373),
    [anon_sym_get] = ACTIONS(2373),
    [anon_sym_set] = ACTIONS(2373),
    [anon_sym_declare] = ACTIONS(2373),
    [anon_sym_public] = ACTIONS(2373),
    [anon_sym_private] = ACTIONS(2373),
    [anon_sym_protected] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [anon_sym_module] = ACTIONS(2373),
    [anon_sym_any] = ACTIONS(2373),
    [anon_sym_number] = ACTIONS(2373),
    [anon_sym_boolean] = ACTIONS(2373),
    [anon_sym_string] = ACTIONS(2373),
    [anon_sym_symbol] = ACTIONS(2373),
    [anon_sym_abstract] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
  },
  [742] = {
    [ts_builtin_sym_end] = ACTIONS(2375),
    [sym_identifier] = ACTIONS(2377),
    [anon_sym_export] = ACTIONS(2377),
    [anon_sym_default] = ACTIONS(2377),
    [anon_sym_type] = ACTIONS(2377),
    [anon_sym_namespace] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2375),
    [anon_sym_RBRACE] = ACTIONS(2375),
    [anon_sym_typeof] = ACTIONS(2377),
    [anon_sym_import] = ACTIONS(2377),
    [anon_sym_var] = ACTIONS(2377),
    [anon_sym_let] = ACTIONS(2377),
    [anon_sym_const] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2375),
    [anon_sym_else] = ACTIONS(2377),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_switch] = ACTIONS(2377),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2375),
    [anon_sym_await] = ACTIONS(2377),
    [anon_sym_while] = ACTIONS(2377),
    [anon_sym_do] = ACTIONS(2377),
    [anon_sym_try] = ACTIONS(2377),
    [anon_sym_with] = ACTIONS(2377),
    [anon_sym_break] = ACTIONS(2377),
    [anon_sym_continue] = ACTIONS(2377),
    [anon_sym_debugger] = ACTIONS(2377),
    [anon_sym_return] = ACTIONS(2377),
    [anon_sym_throw] = ACTIONS(2377),
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_case] = ACTIONS(2377),
    [anon_sym_yield] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2375),
    [anon_sym_LTtemplate_GT] = ACTIONS(2375),
    [anon_sym_class] = ACTIONS(2377),
    [anon_sym_async] = ACTIONS(2377),
    [anon_sym_function] = ACTIONS(2377),
    [anon_sym_new] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2377),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_SLASH] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2375),
    [anon_sym_void] = ACTIONS(2377),
    [anon_sym_delete] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2375),
    [anon_sym_DASH_DASH] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(2375),
    [anon_sym_SQUOTE] = ACTIONS(2375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2375),
    [sym_number] = ACTIONS(2375),
    [sym_this] = ACTIONS(2377),
    [sym_super] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_null] = ACTIONS(2377),
    [sym_undefined] = ACTIONS(2377),
    [anon_sym_AT] = ACTIONS(2375),
    [anon_sym_static] = ACTIONS(2377),
    [anon_sym_readonly] = ACTIONS(2377),
    [anon_sym_get] = ACTIONS(2377),
    [anon_sym_set] = ACTIONS(2377),
    [anon_sym_declare] = ACTIONS(2377),
    [anon_sym_public] = ACTIONS(2377),
    [anon_sym_private] = ACTIONS(2377),
    [anon_sym_protected] = ACTIONS(2377),
    [anon_sym_override] = ACTIONS(2377),
    [anon_sym_module] = ACTIONS(2377),
    [anon_sym_any] = ACTIONS(2377),
    [anon_sym_number] = ACTIONS(2377),
    [anon_sym_boolean] = ACTIONS(2377),
    [anon_sym_string] = ACTIONS(2377),
    [anon_sym_symbol] = ACTIONS(2377),
    [anon_sym_abstract] = ACTIONS(2377),
    [anon_sym_interface] = ACTIONS(2377),
    [anon_sym_enum] = ACTIONS(2377),
  },
  [743] = {
    [ts_builtin_sym_end] = ACTIONS(2379),
    [sym_identifier] = ACTIONS(2381),
    [anon_sym_export] = ACTIONS(2381),
    [anon_sym_default] = ACTIONS(2381),
    [anon_sym_type] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_RBRACE] = ACTIONS(2379),
    [anon_sym_typeof] = ACTIONS(2381),
    [anon_sym_import] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2381),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_const] = ACTIONS(2381),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2379),
    [anon_sym_await] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_do] = ACTIONS(2381),
    [anon_sym_try] = ACTIONS(2381),
    [anon_sym_with] = ACTIONS(2381),
    [anon_sym_break] = ACTIONS(2381),
    [anon_sym_continue] = ACTIONS(2381),
    [anon_sym_debugger] = ACTIONS(2381),
    [anon_sym_return] = ACTIONS(2381),
    [anon_sym_throw] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_case] = ACTIONS(2381),
    [anon_sym_yield] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2379),
    [anon_sym_LTtemplate_GT] = ACTIONS(2379),
    [anon_sym_class] = ACTIONS(2381),
    [anon_sym_async] = ACTIONS(2381),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2381),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_SLASH] = ACTIONS(2381),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2379),
    [anon_sym_void] = ACTIONS(2381),
    [anon_sym_delete] = ACTIONS(2381),
    [anon_sym_PLUS_PLUS] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(2381),
    [anon_sym_DQUOTE] = ACTIONS(2379),
    [anon_sym_SQUOTE] = ACTIONS(2379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2379),
    [sym_number] = ACTIONS(2379),
    [sym_this] = ACTIONS(2381),
    [sym_super] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_undefined] = ACTIONS(2381),
    [anon_sym_AT] = ACTIONS(2379),
    [anon_sym_static] = ACTIONS(2381),
    [anon_sym_readonly] = ACTIONS(2381),
    [anon_sym_get] = ACTIONS(2381),
    [anon_sym_set] = ACTIONS(2381),
    [anon_sym_declare] = ACTIONS(2381),
    [anon_sym_public] = ACTIONS(2381),
    [anon_sym_private] = ACTIONS(2381),
    [anon_sym_protected] = ACTIONS(2381),
    [anon_sym_override] = ACTIONS(2381),
    [anon_sym_module] = ACTIONS(2381),
    [anon_sym_any] = ACTIONS(2381),
    [anon_sym_number] = ACTIONS(2381),
    [anon_sym_boolean] = ACTIONS(2381),
    [anon_sym_string] = ACTIONS(2381),
    [anon_sym_symbol] = ACTIONS(2381),
    [anon_sym_abstract] = ACTIONS(2381),
    [anon_sym_interface] = ACTIONS(2381),
    [anon_sym_enum] = ACTIONS(2381),
  },
  [744] = {
    [ts_builtin_sym_end] = ACTIONS(2379),
    [sym_identifier] = ACTIONS(2381),
    [anon_sym_export] = ACTIONS(2381),
    [anon_sym_default] = ACTIONS(2381),
    [anon_sym_type] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_RBRACE] = ACTIONS(2379),
    [anon_sym_typeof] = ACTIONS(2381),
    [anon_sym_import] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2381),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_const] = ACTIONS(2381),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2379),
    [anon_sym_await] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_do] = ACTIONS(2381),
    [anon_sym_try] = ACTIONS(2381),
    [anon_sym_with] = ACTIONS(2381),
    [anon_sym_break] = ACTIONS(2381),
    [anon_sym_continue] = ACTIONS(2381),
    [anon_sym_debugger] = ACTIONS(2381),
    [anon_sym_return] = ACTIONS(2381),
    [anon_sym_throw] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_case] = ACTIONS(2381),
    [anon_sym_yield] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2379),
    [anon_sym_LTtemplate_GT] = ACTIONS(2379),
    [anon_sym_class] = ACTIONS(2381),
    [anon_sym_async] = ACTIONS(2381),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2381),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_SLASH] = ACTIONS(2381),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2379),
    [anon_sym_void] = ACTIONS(2381),
    [anon_sym_delete] = ACTIONS(2381),
    [anon_sym_PLUS_PLUS] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(2381),
    [anon_sym_DQUOTE] = ACTIONS(2379),
    [anon_sym_SQUOTE] = ACTIONS(2379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2379),
    [sym_number] = ACTIONS(2379),
    [sym_this] = ACTIONS(2381),
    [sym_super] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_undefined] = ACTIONS(2381),
    [anon_sym_AT] = ACTIONS(2379),
    [anon_sym_static] = ACTIONS(2381),
    [anon_sym_readonly] = ACTIONS(2381),
    [anon_sym_get] = ACTIONS(2381),
    [anon_sym_set] = ACTIONS(2381),
    [anon_sym_declare] = ACTIONS(2381),
    [anon_sym_public] = ACTIONS(2381),
    [anon_sym_private] = ACTIONS(2381),
    [anon_sym_protected] = ACTIONS(2381),
    [anon_sym_override] = ACTIONS(2381),
    [anon_sym_module] = ACTIONS(2381),
    [anon_sym_any] = ACTIONS(2381),
    [anon_sym_number] = ACTIONS(2381),
    [anon_sym_boolean] = ACTIONS(2381),
    [anon_sym_string] = ACTIONS(2381),
    [anon_sym_symbol] = ACTIONS(2381),
    [anon_sym_abstract] = ACTIONS(2381),
    [anon_sym_interface] = ACTIONS(2381),
    [anon_sym_enum] = ACTIONS(2381),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(2383),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_export] = ACTIONS(2385),
    [anon_sym_default] = ACTIONS(2385),
    [anon_sym_type] = ACTIONS(2385),
    [anon_sym_namespace] = ACTIONS(2385),
    [anon_sym_LBRACE] = ACTIONS(2383),
    [anon_sym_RBRACE] = ACTIONS(2383),
    [anon_sym_typeof] = ACTIONS(2385),
    [anon_sym_import] = ACTIONS(2385),
    [anon_sym_var] = ACTIONS(2385),
    [anon_sym_let] = ACTIONS(2385),
    [anon_sym_const] = ACTIONS(2385),
    [anon_sym_BANG] = ACTIONS(2383),
    [anon_sym_else] = ACTIONS(2385),
    [anon_sym_if] = ACTIONS(2385),
    [anon_sym_switch] = ACTIONS(2385),
    [anon_sym_for] = ACTIONS(2385),
    [anon_sym_LPAREN] = ACTIONS(2383),
    [anon_sym_await] = ACTIONS(2385),
    [anon_sym_while] = ACTIONS(2385),
    [anon_sym_do] = ACTIONS(2385),
    [anon_sym_try] = ACTIONS(2385),
    [anon_sym_with] = ACTIONS(2385),
    [anon_sym_break] = ACTIONS(2385),
    [anon_sym_continue] = ACTIONS(2385),
    [anon_sym_debugger] = ACTIONS(2385),
    [anon_sym_return] = ACTIONS(2385),
    [anon_sym_throw] = ACTIONS(2385),
    [anon_sym_SEMI] = ACTIONS(2383),
    [anon_sym_case] = ACTIONS(2385),
    [anon_sym_yield] = ACTIONS(2385),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LTtemplate_GT] = ACTIONS(2383),
    [anon_sym_class] = ACTIONS(2385),
    [anon_sym_async] = ACTIONS(2385),
    [anon_sym_function] = ACTIONS(2385),
    [anon_sym_new] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2385),
    [anon_sym_DASH] = ACTIONS(2385),
    [anon_sym_SLASH] = ACTIONS(2385),
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_TILDE] = ACTIONS(2383),
    [anon_sym_void] = ACTIONS(2385),
    [anon_sym_delete] = ACTIONS(2385),
    [anon_sym_PLUS_PLUS] = ACTIONS(2383),
    [anon_sym_DASH_DASH] = ACTIONS(2385),
    [anon_sym_DQUOTE] = ACTIONS(2383),
    [anon_sym_SQUOTE] = ACTIONS(2383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2383),
    [sym_number] = ACTIONS(2383),
    [sym_this] = ACTIONS(2385),
    [sym_super] = ACTIONS(2385),
    [sym_true] = ACTIONS(2385),
    [sym_false] = ACTIONS(2385),
    [sym_null] = ACTIONS(2385),
    [sym_undefined] = ACTIONS(2385),
    [anon_sym_AT] = ACTIONS(2383),
    [anon_sym_static] = ACTIONS(2385),
    [anon_sym_readonly] = ACTIONS(2385),
    [anon_sym_get] = ACTIONS(2385),
    [anon_sym_set] = ACTIONS(2385),
    [anon_sym_declare] = ACTIONS(2385),
    [anon_sym_public] = ACTIONS(2385),
    [anon_sym_private] = ACTIONS(2385),
    [anon_sym_protected] = ACTIONS(2385),
    [anon_sym_override] = ACTIONS(2385),
    [anon_sym_module] = ACTIONS(2385),
    [anon_sym_any] = ACTIONS(2385),
    [anon_sym_number] = ACTIONS(2385),
    [anon_sym_boolean] = ACTIONS(2385),
    [anon_sym_string] = ACTIONS(2385),
    [anon_sym_symbol] = ACTIONS(2385),
    [anon_sym_abstract] = ACTIONS(2385),
    [anon_sym_interface] = ACTIONS(2385),
    [anon_sym_enum] = ACTIONS(2385),
  },
  [746] = {
    [ts_builtin_sym_end] = ACTIONS(2387),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_export] = ACTIONS(2389),
    [anon_sym_default] = ACTIONS(2389),
    [anon_sym_type] = ACTIONS(2389),
    [anon_sym_namespace] = ACTIONS(2389),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_typeof] = ACTIONS(2389),
    [anon_sym_import] = ACTIONS(2389),
    [anon_sym_var] = ACTIONS(2389),
    [anon_sym_let] = ACTIONS(2389),
    [anon_sym_const] = ACTIONS(2389),
    [anon_sym_BANG] = ACTIONS(2387),
    [anon_sym_else] = ACTIONS(2389),
    [anon_sym_if] = ACTIONS(2389),
    [anon_sym_switch] = ACTIONS(2389),
    [anon_sym_for] = ACTIONS(2389),
    [anon_sym_LPAREN] = ACTIONS(2387),
    [anon_sym_await] = ACTIONS(2389),
    [anon_sym_while] = ACTIONS(2389),
    [anon_sym_do] = ACTIONS(2389),
    [anon_sym_try] = ACTIONS(2389),
    [anon_sym_with] = ACTIONS(2389),
    [anon_sym_break] = ACTIONS(2389),
    [anon_sym_continue] = ACTIONS(2389),
    [anon_sym_debugger] = ACTIONS(2389),
    [anon_sym_return] = ACTIONS(2389),
    [anon_sym_throw] = ACTIONS(2389),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_case] = ACTIONS(2389),
    [anon_sym_yield] = ACTIONS(2389),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [anon_sym_LTtemplate_GT] = ACTIONS(2387),
    [anon_sym_class] = ACTIONS(2389),
    [anon_sym_async] = ACTIONS(2389),
    [anon_sym_function] = ACTIONS(2389),
    [anon_sym_new] = ACTIONS(2389),
    [anon_sym_PLUS] = ACTIONS(2389),
    [anon_sym_DASH] = ACTIONS(2389),
    [anon_sym_SLASH] = ACTIONS(2389),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_TILDE] = ACTIONS(2387),
    [anon_sym_void] = ACTIONS(2389),
    [anon_sym_delete] = ACTIONS(2389),
    [anon_sym_PLUS_PLUS] = ACTIONS(2387),
    [anon_sym_DASH_DASH] = ACTIONS(2389),
    [anon_sym_DQUOTE] = ACTIONS(2387),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2387),
    [sym_number] = ACTIONS(2387),
    [sym_this] = ACTIONS(2389),
    [sym_super] = ACTIONS(2389),
    [sym_true] = ACTIONS(2389),
    [sym_false] = ACTIONS(2389),
    [sym_null] = ACTIONS(2389),
    [sym_undefined] = ACTIONS(2389),
    [anon_sym_AT] = ACTIONS(2387),
    [anon_sym_static] = ACTIONS(2389),
    [anon_sym_readonly] = ACTIONS(2389),
    [anon_sym_get] = ACTIONS(2389),
    [anon_sym_set] = ACTIONS(2389),
    [anon_sym_declare] = ACTIONS(2389),
    [anon_sym_public] = ACTIONS(2389),
    [anon_sym_private] = ACTIONS(2389),
    [anon_sym_protected] = ACTIONS(2389),
    [anon_sym_override] = ACTIONS(2389),
    [anon_sym_module] = ACTIONS(2389),
    [anon_sym_any] = ACTIONS(2389),
    [anon_sym_number] = ACTIONS(2389),
    [anon_sym_boolean] = ACTIONS(2389),
    [anon_sym_string] = ACTIONS(2389),
    [anon_sym_symbol] = ACTIONS(2389),
    [anon_sym_abstract] = ACTIONS(2389),
    [anon_sym_interface] = ACTIONS(2389),
    [anon_sym_enum] = ACTIONS(2389),
  },
  [747] = {
    [ts_builtin_sym_end] = ACTIONS(2391),
    [sym_identifier] = ACTIONS(2393),
    [anon_sym_export] = ACTIONS(2393),
    [anon_sym_default] = ACTIONS(2393),
    [anon_sym_type] = ACTIONS(2393),
    [anon_sym_namespace] = ACTIONS(2393),
    [anon_sym_LBRACE] = ACTIONS(2391),
    [anon_sym_RBRACE] = ACTIONS(2391),
    [anon_sym_typeof] = ACTIONS(2393),
    [anon_sym_import] = ACTIONS(2393),
    [anon_sym_var] = ACTIONS(2393),
    [anon_sym_let] = ACTIONS(2393),
    [anon_sym_const] = ACTIONS(2393),
    [anon_sym_BANG] = ACTIONS(2391),
    [anon_sym_else] = ACTIONS(2393),
    [anon_sym_if] = ACTIONS(2393),
    [anon_sym_switch] = ACTIONS(2393),
    [anon_sym_for] = ACTIONS(2393),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_await] = ACTIONS(2393),
    [anon_sym_while] = ACTIONS(2393),
    [anon_sym_do] = ACTIONS(2393),
    [anon_sym_try] = ACTIONS(2393),
    [anon_sym_with] = ACTIONS(2393),
    [anon_sym_break] = ACTIONS(2393),
    [anon_sym_continue] = ACTIONS(2393),
    [anon_sym_debugger] = ACTIONS(2393),
    [anon_sym_return] = ACTIONS(2393),
    [anon_sym_throw] = ACTIONS(2393),
    [anon_sym_SEMI] = ACTIONS(2391),
    [anon_sym_case] = ACTIONS(2393),
    [anon_sym_yield] = ACTIONS(2393),
    [anon_sym_LBRACK] = ACTIONS(2391),
    [anon_sym_LTtemplate_GT] = ACTIONS(2391),
    [anon_sym_class] = ACTIONS(2393),
    [anon_sym_async] = ACTIONS(2393),
    [anon_sym_function] = ACTIONS(2393),
    [anon_sym_new] = ACTIONS(2393),
    [anon_sym_PLUS] = ACTIONS(2393),
    [anon_sym_DASH] = ACTIONS(2393),
    [anon_sym_SLASH] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2391),
    [anon_sym_void] = ACTIONS(2393),
    [anon_sym_delete] = ACTIONS(2393),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_DASH_DASH] = ACTIONS(2393),
    [anon_sym_DQUOTE] = ACTIONS(2391),
    [anon_sym_SQUOTE] = ACTIONS(2391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2391),
    [sym_number] = ACTIONS(2391),
    [sym_this] = ACTIONS(2393),
    [sym_super] = ACTIONS(2393),
    [sym_true] = ACTIONS(2393),
    [sym_false] = ACTIONS(2393),
    [sym_null] = ACTIONS(2393),
    [sym_undefined] = ACTIONS(2393),
    [anon_sym_AT] = ACTIONS(2391),
    [anon_sym_static] = ACTIONS(2393),
    [anon_sym_readonly] = ACTIONS(2393),
    [anon_sym_get] = ACTIONS(2393),
    [anon_sym_set] = ACTIONS(2393),
    [anon_sym_declare] = ACTIONS(2393),
    [anon_sym_public] = ACTIONS(2393),
    [anon_sym_private] = ACTIONS(2393),
    [anon_sym_protected] = ACTIONS(2393),
    [anon_sym_override] = ACTIONS(2393),
    [anon_sym_module] = ACTIONS(2393),
    [anon_sym_any] = ACTIONS(2393),
    [anon_sym_number] = ACTIONS(2393),
    [anon_sym_boolean] = ACTIONS(2393),
    [anon_sym_string] = ACTIONS(2393),
    [anon_sym_symbol] = ACTIONS(2393),
    [anon_sym_abstract] = ACTIONS(2393),
    [anon_sym_interface] = ACTIONS(2393),
    [anon_sym_enum] = ACTIONS(2393),
  },
  [748] = {
    [ts_builtin_sym_end] = ACTIONS(2395),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_export] = ACTIONS(2397),
    [anon_sym_default] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2397),
    [anon_sym_namespace] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(2395),
    [anon_sym_RBRACE] = ACTIONS(2395),
    [anon_sym_typeof] = ACTIONS(2397),
    [anon_sym_import] = ACTIONS(2397),
    [anon_sym_var] = ACTIONS(2397),
    [anon_sym_let] = ACTIONS(2397),
    [anon_sym_const] = ACTIONS(2397),
    [anon_sym_BANG] = ACTIONS(2395),
    [anon_sym_else] = ACTIONS(2397),
    [anon_sym_if] = ACTIONS(2397),
    [anon_sym_switch] = ACTIONS(2397),
    [anon_sym_for] = ACTIONS(2397),
    [anon_sym_LPAREN] = ACTIONS(2395),
    [anon_sym_await] = ACTIONS(2397),
    [anon_sym_while] = ACTIONS(2397),
    [anon_sym_do] = ACTIONS(2397),
    [anon_sym_try] = ACTIONS(2397),
    [anon_sym_with] = ACTIONS(2397),
    [anon_sym_break] = ACTIONS(2397),
    [anon_sym_continue] = ACTIONS(2397),
    [anon_sym_debugger] = ACTIONS(2397),
    [anon_sym_return] = ACTIONS(2397),
    [anon_sym_throw] = ACTIONS(2397),
    [anon_sym_SEMI] = ACTIONS(2395),
    [anon_sym_case] = ACTIONS(2397),
    [anon_sym_yield] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_LTtemplate_GT] = ACTIONS(2395),
    [anon_sym_class] = ACTIONS(2397),
    [anon_sym_async] = ACTIONS(2397),
    [anon_sym_function] = ACTIONS(2397),
    [anon_sym_new] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(2397),
    [anon_sym_DASH] = ACTIONS(2397),
    [anon_sym_SLASH] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(2397),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_void] = ACTIONS(2397),
    [anon_sym_delete] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2395),
    [anon_sym_DASH_DASH] = ACTIONS(2397),
    [anon_sym_DQUOTE] = ACTIONS(2395),
    [anon_sym_SQUOTE] = ACTIONS(2395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2395),
    [sym_number] = ACTIONS(2395),
    [sym_this] = ACTIONS(2397),
    [sym_super] = ACTIONS(2397),
    [sym_true] = ACTIONS(2397),
    [sym_false] = ACTIONS(2397),
    [sym_null] = ACTIONS(2397),
    [sym_undefined] = ACTIONS(2397),
    [anon_sym_AT] = ACTIONS(2395),
    [anon_sym_static] = ACTIONS(2397),
    [anon_sym_readonly] = ACTIONS(2397),
    [anon_sym_get] = ACTIONS(2397),
    [anon_sym_set] = ACTIONS(2397),
    [anon_sym_declare] = ACTIONS(2397),
    [anon_sym_public] = ACTIONS(2397),
    [anon_sym_private] = ACTIONS(2397),
    [anon_sym_protected] = ACTIONS(2397),
    [anon_sym_override] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(2397),
    [anon_sym_any] = ACTIONS(2397),
    [anon_sym_number] = ACTIONS(2397),
    [anon_sym_boolean] = ACTIONS(2397),
    [anon_sym_string] = ACTIONS(2397),
    [anon_sym_symbol] = ACTIONS(2397),
    [anon_sym_abstract] = ACTIONS(2397),
    [anon_sym_interface] = ACTIONS(2397),
    [anon_sym_enum] = ACTIONS(2397),
  },
  [749] = {
    [ts_builtin_sym_end] = ACTIONS(2399),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_export] = ACTIONS(2401),
    [anon_sym_default] = ACTIONS(2401),
    [anon_sym_type] = ACTIONS(2401),
    [anon_sym_namespace] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2399),
    [anon_sym_RBRACE] = ACTIONS(2399),
    [anon_sym_typeof] = ACTIONS(2401),
    [anon_sym_import] = ACTIONS(2401),
    [anon_sym_var] = ACTIONS(2401),
    [anon_sym_let] = ACTIONS(2401),
    [anon_sym_const] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_else] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_switch] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2399),
    [anon_sym_await] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(2401),
    [anon_sym_do] = ACTIONS(2401),
    [anon_sym_try] = ACTIONS(2401),
    [anon_sym_with] = ACTIONS(2401),
    [anon_sym_break] = ACTIONS(2401),
    [anon_sym_continue] = ACTIONS(2401),
    [anon_sym_debugger] = ACTIONS(2401),
    [anon_sym_return] = ACTIONS(2401),
    [anon_sym_throw] = ACTIONS(2401),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_case] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2401),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LTtemplate_GT] = ACTIONS(2399),
    [anon_sym_class] = ACTIONS(2401),
    [anon_sym_async] = ACTIONS(2401),
    [anon_sym_function] = ACTIONS(2401),
    [anon_sym_new] = ACTIONS(2401),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2401),
    [anon_sym_LT] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_void] = ACTIONS(2401),
    [anon_sym_delete] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2399),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [anon_sym_SQUOTE] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [sym_number] = ACTIONS(2399),
    [sym_this] = ACTIONS(2401),
    [sym_super] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_null] = ACTIONS(2401),
    [sym_undefined] = ACTIONS(2401),
    [anon_sym_AT] = ACTIONS(2399),
    [anon_sym_static] = ACTIONS(2401),
    [anon_sym_readonly] = ACTIONS(2401),
    [anon_sym_get] = ACTIONS(2401),
    [anon_sym_set] = ACTIONS(2401),
    [anon_sym_declare] = ACTIONS(2401),
    [anon_sym_public] = ACTIONS(2401),
    [anon_sym_private] = ACTIONS(2401),
    [anon_sym_protected] = ACTIONS(2401),
    [anon_sym_override] = ACTIONS(2401),
    [anon_sym_module] = ACTIONS(2401),
    [anon_sym_any] = ACTIONS(2401),
    [anon_sym_number] = ACTIONS(2401),
    [anon_sym_boolean] = ACTIONS(2401),
    [anon_sym_string] = ACTIONS(2401),
    [anon_sym_symbol] = ACTIONS(2401),
    [anon_sym_abstract] = ACTIONS(2401),
    [anon_sym_interface] = ACTIONS(2401),
    [anon_sym_enum] = ACTIONS(2401),
  },
  [750] = {
    [ts_builtin_sym_end] = ACTIONS(2403),
    [sym_identifier] = ACTIONS(2405),
    [anon_sym_export] = ACTIONS(2405),
    [anon_sym_default] = ACTIONS(2405),
    [anon_sym_type] = ACTIONS(2405),
    [anon_sym_namespace] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_RBRACE] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_import] = ACTIONS(2405),
    [anon_sym_var] = ACTIONS(2405),
    [anon_sym_let] = ACTIONS(2405),
    [anon_sym_const] = ACTIONS(2405),
    [anon_sym_BANG] = ACTIONS(2403),
    [anon_sym_else] = ACTIONS(2405),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_switch] = ACTIONS(2405),
    [anon_sym_for] = ACTIONS(2405),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_await] = ACTIONS(2405),
    [anon_sym_while] = ACTIONS(2405),
    [anon_sym_do] = ACTIONS(2405),
    [anon_sym_try] = ACTIONS(2405),
    [anon_sym_with] = ACTIONS(2405),
    [anon_sym_break] = ACTIONS(2405),
    [anon_sym_continue] = ACTIONS(2405),
    [anon_sym_debugger] = ACTIONS(2405),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_throw] = ACTIONS(2405),
    [anon_sym_SEMI] = ACTIONS(2403),
    [anon_sym_case] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2405),
    [anon_sym_LBRACK] = ACTIONS(2403),
    [anon_sym_LTtemplate_GT] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(2405),
    [anon_sym_async] = ACTIONS(2405),
    [anon_sym_function] = ACTIONS(2405),
    [anon_sym_new] = ACTIONS(2405),
    [anon_sym_PLUS] = ACTIONS(2405),
    [anon_sym_DASH] = ACTIONS(2405),
    [anon_sym_SLASH] = ACTIONS(2405),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_TILDE] = ACTIONS(2403),
    [anon_sym_void] = ACTIONS(2405),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_PLUS_PLUS] = ACTIONS(2403),
    [anon_sym_DASH_DASH] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [anon_sym_SQUOTE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [sym_number] = ACTIONS(2403),
    [sym_this] = ACTIONS(2405),
    [sym_super] = ACTIONS(2405),
    [sym_true] = ACTIONS(2405),
    [sym_false] = ACTIONS(2405),
    [sym_null] = ACTIONS(2405),
    [sym_undefined] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(2403),
    [anon_sym_static] = ACTIONS(2405),
    [anon_sym_readonly] = ACTIONS(2405),
    [anon_sym_get] = ACTIONS(2405),
    [anon_sym_set] = ACTIONS(2405),
    [anon_sym_declare] = ACTIONS(2405),
    [anon_sym_public] = ACTIONS(2405),
    [anon_sym_private] = ACTIONS(2405),
    [anon_sym_protected] = ACTIONS(2405),
    [anon_sym_override] = ACTIONS(2405),
    [anon_sym_module] = ACTIONS(2405),
    [anon_sym_any] = ACTIONS(2405),
    [anon_sym_number] = ACTIONS(2405),
    [anon_sym_boolean] = ACTIONS(2405),
    [anon_sym_string] = ACTIONS(2405),
    [anon_sym_symbol] = ACTIONS(2405),
    [anon_sym_abstract] = ACTIONS(2405),
    [anon_sym_interface] = ACTIONS(2405),
    [anon_sym_enum] = ACTIONS(2405),
  },
  [751] = {
    [ts_builtin_sym_end] = ACTIONS(2407),
    [sym_identifier] = ACTIONS(2409),
    [anon_sym_export] = ACTIONS(2409),
    [anon_sym_default] = ACTIONS(2409),
    [anon_sym_type] = ACTIONS(2409),
    [anon_sym_namespace] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_RBRACE] = ACTIONS(2407),
    [anon_sym_typeof] = ACTIONS(2409),
    [anon_sym_import] = ACTIONS(2409),
    [anon_sym_var] = ACTIONS(2409),
    [anon_sym_let] = ACTIONS(2409),
    [anon_sym_const] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(2407),
    [anon_sym_else] = ACTIONS(2409),
    [anon_sym_if] = ACTIONS(2409),
    [anon_sym_switch] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2409),
    [anon_sym_while] = ACTIONS(2409),
    [anon_sym_do] = ACTIONS(2409),
    [anon_sym_try] = ACTIONS(2409),
    [anon_sym_with] = ACTIONS(2409),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_continue] = ACTIONS(2409),
    [anon_sym_debugger] = ACTIONS(2409),
    [anon_sym_return] = ACTIONS(2409),
    [anon_sym_throw] = ACTIONS(2409),
    [anon_sym_SEMI] = ACTIONS(2407),
    [anon_sym_case] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LTtemplate_GT] = ACTIONS(2407),
    [anon_sym_class] = ACTIONS(2409),
    [anon_sym_async] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_SLASH] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_TILDE] = ACTIONS(2407),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_delete] = ACTIONS(2409),
    [anon_sym_PLUS_PLUS] = ACTIONS(2407),
    [anon_sym_DASH_DASH] = ACTIONS(2409),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_SQUOTE] = ACTIONS(2407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2407),
    [sym_number] = ACTIONS(2407),
    [sym_this] = ACTIONS(2409),
    [sym_super] = ACTIONS(2409),
    [sym_true] = ACTIONS(2409),
    [sym_false] = ACTIONS(2409),
    [sym_null] = ACTIONS(2409),
    [sym_undefined] = ACTIONS(2409),
    [anon_sym_AT] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(2409),
    [anon_sym_readonly] = ACTIONS(2409),
    [anon_sym_get] = ACTIONS(2409),
    [anon_sym_set] = ACTIONS(2409),
    [anon_sym_declare] = ACTIONS(2409),
    [anon_sym_public] = ACTIONS(2409),
    [anon_sym_private] = ACTIONS(2409),
    [anon_sym_protected] = ACTIONS(2409),
    [anon_sym_override] = ACTIONS(2409),
    [anon_sym_module] = ACTIONS(2409),
    [anon_sym_any] = ACTIONS(2409),
    [anon_sym_number] = ACTIONS(2409),
    [anon_sym_boolean] = ACTIONS(2409),
    [anon_sym_string] = ACTIONS(2409),
    [anon_sym_symbol] = ACTIONS(2409),
    [anon_sym_abstract] = ACTIONS(2409),
    [anon_sym_interface] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2409),
  },
  [752] = {
    [ts_builtin_sym_end] = ACTIONS(2411),
    [sym_identifier] = ACTIONS(2413),
    [anon_sym_export] = ACTIONS(2413),
    [anon_sym_default] = ACTIONS(2413),
    [anon_sym_type] = ACTIONS(2413),
    [anon_sym_namespace] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_RBRACE] = ACTIONS(2411),
    [anon_sym_typeof] = ACTIONS(2413),
    [anon_sym_import] = ACTIONS(2413),
    [anon_sym_var] = ACTIONS(2413),
    [anon_sym_let] = ACTIONS(2413),
    [anon_sym_const] = ACTIONS(2413),
    [anon_sym_BANG] = ACTIONS(2411),
    [anon_sym_else] = ACTIONS(2413),
    [anon_sym_if] = ACTIONS(2413),
    [anon_sym_switch] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_await] = ACTIONS(2413),
    [anon_sym_while] = ACTIONS(2413),
    [anon_sym_do] = ACTIONS(2413),
    [anon_sym_try] = ACTIONS(2413),
    [anon_sym_with] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2413),
    [anon_sym_continue] = ACTIONS(2413),
    [anon_sym_debugger] = ACTIONS(2413),
    [anon_sym_return] = ACTIONS(2413),
    [anon_sym_throw] = ACTIONS(2413),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_case] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LTtemplate_GT] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_async] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2413),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_void] = ACTIONS(2413),
    [anon_sym_delete] = ACTIONS(2413),
    [anon_sym_PLUS_PLUS] = ACTIONS(2411),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_SQUOTE] = ACTIONS(2411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [sym_number] = ACTIONS(2411),
    [sym_this] = ACTIONS(2413),
    [sym_super] = ACTIONS(2413),
    [sym_true] = ACTIONS(2413),
    [sym_false] = ACTIONS(2413),
    [sym_null] = ACTIONS(2413),
    [sym_undefined] = ACTIONS(2413),
    [anon_sym_AT] = ACTIONS(2411),
    [anon_sym_static] = ACTIONS(2413),
    [anon_sym_readonly] = ACTIONS(2413),
    [anon_sym_get] = ACTIONS(2413),
    [anon_sym_set] = ACTIONS(2413),
    [anon_sym_declare] = ACTIONS(2413),
    [anon_sym_public] = ACTIONS(2413),
    [anon_sym_private] = ACTIONS(2413),
    [anon_sym_protected] = ACTIONS(2413),
    [anon_sym_override] = ACTIONS(2413),
    [anon_sym_module] = ACTIONS(2413),
    [anon_sym_any] = ACTIONS(2413),
    [anon_sym_number] = ACTIONS(2413),
    [anon_sym_boolean] = ACTIONS(2413),
    [anon_sym_string] = ACTIONS(2413),
    [anon_sym_symbol] = ACTIONS(2413),
    [anon_sym_abstract] = ACTIONS(2413),
    [anon_sym_interface] = ACTIONS(2413),
    [anon_sym_enum] = ACTIONS(2413),
  },
  [753] = {
    [ts_builtin_sym_end] = ACTIONS(2415),
    [sym_identifier] = ACTIONS(2417),
    [anon_sym_export] = ACTIONS(2417),
    [anon_sym_default] = ACTIONS(2417),
    [anon_sym_type] = ACTIONS(2417),
    [anon_sym_namespace] = ACTIONS(2417),
    [anon_sym_LBRACE] = ACTIONS(2415),
    [anon_sym_RBRACE] = ACTIONS(2415),
    [anon_sym_typeof] = ACTIONS(2417),
    [anon_sym_import] = ACTIONS(2417),
    [anon_sym_var] = ACTIONS(2417),
    [anon_sym_let] = ACTIONS(2417),
    [anon_sym_const] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2415),
    [anon_sym_else] = ACTIONS(2417),
    [anon_sym_if] = ACTIONS(2417),
    [anon_sym_switch] = ACTIONS(2417),
    [anon_sym_for] = ACTIONS(2417),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_await] = ACTIONS(2417),
    [anon_sym_while] = ACTIONS(2417),
    [anon_sym_do] = ACTIONS(2417),
    [anon_sym_try] = ACTIONS(2417),
    [anon_sym_with] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2417),
    [anon_sym_continue] = ACTIONS(2417),
    [anon_sym_debugger] = ACTIONS(2417),
    [anon_sym_return] = ACTIONS(2417),
    [anon_sym_throw] = ACTIONS(2417),
    [anon_sym_SEMI] = ACTIONS(2415),
    [anon_sym_case] = ACTIONS(2417),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_LBRACK] = ACTIONS(2415),
    [anon_sym_LTtemplate_GT] = ACTIONS(2415),
    [anon_sym_class] = ACTIONS(2417),
    [anon_sym_async] = ACTIONS(2417),
    [anon_sym_function] = ACTIONS(2417),
    [anon_sym_new] = ACTIONS(2417),
    [anon_sym_PLUS] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(2417),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_TILDE] = ACTIONS(2415),
    [anon_sym_void] = ACTIONS(2417),
    [anon_sym_delete] = ACTIONS(2417),
    [anon_sym_PLUS_PLUS] = ACTIONS(2415),
    [anon_sym_DASH_DASH] = ACTIONS(2417),
    [anon_sym_DQUOTE] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(2415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2415),
    [sym_number] = ACTIONS(2415),
    [sym_this] = ACTIONS(2417),
    [sym_super] = ACTIONS(2417),
    [sym_true] = ACTIONS(2417),
    [sym_false] = ACTIONS(2417),
    [sym_null] = ACTIONS(2417),
    [sym_undefined] = ACTIONS(2417),
    [anon_sym_AT] = ACTIONS(2415),
    [anon_sym_static] = ACTIONS(2417),
    [anon_sym_readonly] = ACTIONS(2417),
    [anon_sym_get] = ACTIONS(2417),
    [anon_sym_set] = ACTIONS(2417),
    [anon_sym_declare] = ACTIONS(2417),
    [anon_sym_public] = ACTIONS(2417),
    [anon_sym_private] = ACTIONS(2417),
    [anon_sym_protected] = ACTIONS(2417),
    [anon_sym_override] = ACTIONS(2417),
    [anon_sym_module] = ACTIONS(2417),
    [anon_sym_any] = ACTIONS(2417),
    [anon_sym_number] = ACTIONS(2417),
    [anon_sym_boolean] = ACTIONS(2417),
    [anon_sym_string] = ACTIONS(2417),
    [anon_sym_symbol] = ACTIONS(2417),
    [anon_sym_abstract] = ACTIONS(2417),
    [anon_sym_interface] = ACTIONS(2417),
    [anon_sym_enum] = ACTIONS(2417),
  },
  [754] = {
    [ts_builtin_sym_end] = ACTIONS(2419),
    [sym_identifier] = ACTIONS(2421),
    [anon_sym_export] = ACTIONS(2421),
    [anon_sym_default] = ACTIONS(2421),
    [anon_sym_type] = ACTIONS(2421),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_LBRACE] = ACTIONS(2419),
    [anon_sym_RBRACE] = ACTIONS(2419),
    [anon_sym_typeof] = ACTIONS(2421),
    [anon_sym_import] = ACTIONS(2421),
    [anon_sym_var] = ACTIONS(2421),
    [anon_sym_let] = ACTIONS(2421),
    [anon_sym_const] = ACTIONS(2421),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_else] = ACTIONS(2421),
    [anon_sym_if] = ACTIONS(2421),
    [anon_sym_switch] = ACTIONS(2421),
    [anon_sym_for] = ACTIONS(2421),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [anon_sym_await] = ACTIONS(2421),
    [anon_sym_while] = ACTIONS(2421),
    [anon_sym_do] = ACTIONS(2421),
    [anon_sym_try] = ACTIONS(2421),
    [anon_sym_with] = ACTIONS(2421),
    [anon_sym_break] = ACTIONS(2421),
    [anon_sym_continue] = ACTIONS(2421),
    [anon_sym_debugger] = ACTIONS(2421),
    [anon_sym_return] = ACTIONS(2421),
    [anon_sym_throw] = ACTIONS(2421),
    [anon_sym_SEMI] = ACTIONS(2419),
    [anon_sym_case] = ACTIONS(2421),
    [anon_sym_yield] = ACTIONS(2421),
    [anon_sym_LBRACK] = ACTIONS(2419),
    [anon_sym_LTtemplate_GT] = ACTIONS(2419),
    [anon_sym_class] = ACTIONS(2421),
    [anon_sym_async] = ACTIONS(2421),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_new] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2421),
    [anon_sym_DASH] = ACTIONS(2421),
    [anon_sym_SLASH] = ACTIONS(2421),
    [anon_sym_LT] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2419),
    [anon_sym_void] = ACTIONS(2421),
    [anon_sym_delete] = ACTIONS(2421),
    [anon_sym_PLUS_PLUS] = ACTIONS(2419),
    [anon_sym_DASH_DASH] = ACTIONS(2421),
    [anon_sym_DQUOTE] = ACTIONS(2419),
    [anon_sym_SQUOTE] = ACTIONS(2419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2419),
    [sym_number] = ACTIONS(2419),
    [sym_this] = ACTIONS(2421),
    [sym_super] = ACTIONS(2421),
    [sym_true] = ACTIONS(2421),
    [sym_false] = ACTIONS(2421),
    [sym_null] = ACTIONS(2421),
    [sym_undefined] = ACTIONS(2421),
    [anon_sym_AT] = ACTIONS(2419),
    [anon_sym_static] = ACTIONS(2421),
    [anon_sym_readonly] = ACTIONS(2421),
    [anon_sym_get] = ACTIONS(2421),
    [anon_sym_set] = ACTIONS(2421),
    [anon_sym_declare] = ACTIONS(2421),
    [anon_sym_public] = ACTIONS(2421),
    [anon_sym_private] = ACTIONS(2421),
    [anon_sym_protected] = ACTIONS(2421),
    [anon_sym_override] = ACTIONS(2421),
    [anon_sym_module] = ACTIONS(2421),
    [anon_sym_any] = ACTIONS(2421),
    [anon_sym_number] = ACTIONS(2421),
    [anon_sym_boolean] = ACTIONS(2421),
    [anon_sym_string] = ACTIONS(2421),
    [anon_sym_symbol] = ACTIONS(2421),
    [anon_sym_abstract] = ACTIONS(2421),
    [anon_sym_interface] = ACTIONS(2421),
    [anon_sym_enum] = ACTIONS(2421),
  },
  [755] = {
    [ts_builtin_sym_end] = ACTIONS(2423),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_export] = ACTIONS(2425),
    [anon_sym_default] = ACTIONS(2425),
    [anon_sym_type] = ACTIONS(2425),
    [anon_sym_namespace] = ACTIONS(2425),
    [anon_sym_LBRACE] = ACTIONS(2423),
    [anon_sym_RBRACE] = ACTIONS(2423),
    [anon_sym_typeof] = ACTIONS(2425),
    [anon_sym_import] = ACTIONS(2425),
    [anon_sym_var] = ACTIONS(2425),
    [anon_sym_let] = ACTIONS(2425),
    [anon_sym_const] = ACTIONS(2425),
    [anon_sym_BANG] = ACTIONS(2423),
    [anon_sym_else] = ACTIONS(2425),
    [anon_sym_if] = ACTIONS(2425),
    [anon_sym_switch] = ACTIONS(2425),
    [anon_sym_for] = ACTIONS(2425),
    [anon_sym_LPAREN] = ACTIONS(2423),
    [anon_sym_await] = ACTIONS(2425),
    [anon_sym_while] = ACTIONS(2425),
    [anon_sym_do] = ACTIONS(2425),
    [anon_sym_try] = ACTIONS(2425),
    [anon_sym_with] = ACTIONS(2425),
    [anon_sym_break] = ACTIONS(2425),
    [anon_sym_continue] = ACTIONS(2425),
    [anon_sym_debugger] = ACTIONS(2425),
    [anon_sym_return] = ACTIONS(2425),
    [anon_sym_throw] = ACTIONS(2425),
    [anon_sym_SEMI] = ACTIONS(2423),
    [anon_sym_case] = ACTIONS(2425),
    [anon_sym_yield] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(2423),
    [anon_sym_LTtemplate_GT] = ACTIONS(2423),
    [anon_sym_class] = ACTIONS(2425),
    [anon_sym_async] = ACTIONS(2425),
    [anon_sym_function] = ACTIONS(2425),
    [anon_sym_new] = ACTIONS(2425),
    [anon_sym_PLUS] = ACTIONS(2425),
    [anon_sym_DASH] = ACTIONS(2425),
    [anon_sym_SLASH] = ACTIONS(2425),
    [anon_sym_LT] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2423),
    [anon_sym_void] = ACTIONS(2425),
    [anon_sym_delete] = ACTIONS(2425),
    [anon_sym_PLUS_PLUS] = ACTIONS(2423),
    [anon_sym_DASH_DASH] = ACTIONS(2425),
    [anon_sym_DQUOTE] = ACTIONS(2423),
    [anon_sym_SQUOTE] = ACTIONS(2423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2423),
    [sym_number] = ACTIONS(2423),
    [sym_this] = ACTIONS(2425),
    [sym_super] = ACTIONS(2425),
    [sym_true] = ACTIONS(2425),
    [sym_false] = ACTIONS(2425),
    [sym_null] = ACTIONS(2425),
    [sym_undefined] = ACTIONS(2425),
    [anon_sym_AT] = ACTIONS(2423),
    [anon_sym_static] = ACTIONS(2425),
    [anon_sym_readonly] = ACTIONS(2425),
    [anon_sym_get] = ACTIONS(2425),
    [anon_sym_set] = ACTIONS(2425),
    [anon_sym_declare] = ACTIONS(2425),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_override] = ACTIONS(2425),
    [anon_sym_module] = ACTIONS(2425),
    [anon_sym_any] = ACTIONS(2425),
    [anon_sym_number] = ACTIONS(2425),
    [anon_sym_boolean] = ACTIONS(2425),
    [anon_sym_string] = ACTIONS(2425),
    [anon_sym_symbol] = ACTIONS(2425),
    [anon_sym_abstract] = ACTIONS(2425),
    [anon_sym_interface] = ACTIONS(2425),
    [anon_sym_enum] = ACTIONS(2425),
  },
  [756] = {
    [ts_builtin_sym_end] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2429),
    [anon_sym_export] = ACTIONS(2429),
    [anon_sym_default] = ACTIONS(2429),
    [anon_sym_type] = ACTIONS(2429),
    [anon_sym_namespace] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2427),
    [anon_sym_RBRACE] = ACTIONS(2427),
    [anon_sym_typeof] = ACTIONS(2429),
    [anon_sym_import] = ACTIONS(2429),
    [anon_sym_var] = ACTIONS(2429),
    [anon_sym_let] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(2429),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_switch] = ACTIONS(2429),
    [anon_sym_for] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_await] = ACTIONS(2429),
    [anon_sym_while] = ACTIONS(2429),
    [anon_sym_do] = ACTIONS(2429),
    [anon_sym_try] = ACTIONS(2429),
    [anon_sym_with] = ACTIONS(2429),
    [anon_sym_break] = ACTIONS(2429),
    [anon_sym_continue] = ACTIONS(2429),
    [anon_sym_debugger] = ACTIONS(2429),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_throw] = ACTIONS(2429),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym_case] = ACTIONS(2429),
    [anon_sym_yield] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2427),
    [anon_sym_LTtemplate_GT] = ACTIONS(2427),
    [anon_sym_class] = ACTIONS(2429),
    [anon_sym_async] = ACTIONS(2429),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_SLASH] = ACTIONS(2429),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_void] = ACTIONS(2429),
    [anon_sym_delete] = ACTIONS(2429),
    [anon_sym_PLUS_PLUS] = ACTIONS(2427),
    [anon_sym_DASH_DASH] = ACTIONS(2429),
    [anon_sym_DQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2427),
    [sym_number] = ACTIONS(2427),
    [sym_this] = ACTIONS(2429),
    [sym_super] = ACTIONS(2429),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [sym_null] = ACTIONS(2429),
    [sym_undefined] = ACTIONS(2429),
    [anon_sym_AT] = ACTIONS(2427),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_readonly] = ACTIONS(2429),
    [anon_sym_get] = ACTIONS(2429),
    [anon_sym_set] = ACTIONS(2429),
    [anon_sym_declare] = ACTIONS(2429),
    [anon_sym_public] = ACTIONS(2429),
    [anon_sym_private] = ACTIONS(2429),
    [anon_sym_protected] = ACTIONS(2429),
    [anon_sym_override] = ACTIONS(2429),
    [anon_sym_module] = ACTIONS(2429),
    [anon_sym_any] = ACTIONS(2429),
    [anon_sym_number] = ACTIONS(2429),
    [anon_sym_boolean] = ACTIONS(2429),
    [anon_sym_string] = ACTIONS(2429),
    [anon_sym_symbol] = ACTIONS(2429),
    [anon_sym_abstract] = ACTIONS(2429),
    [anon_sym_interface] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
  },
  [757] = {
    [ts_builtin_sym_end] = ACTIONS(2431),
    [sym_identifier] = ACTIONS(2433),
    [anon_sym_export] = ACTIONS(2433),
    [anon_sym_default] = ACTIONS(2433),
    [anon_sym_type] = ACTIONS(2433),
    [anon_sym_namespace] = ACTIONS(2433),
    [anon_sym_LBRACE] = ACTIONS(2431),
    [anon_sym_RBRACE] = ACTIONS(2431),
    [anon_sym_typeof] = ACTIONS(2433),
    [anon_sym_import] = ACTIONS(2433),
    [anon_sym_var] = ACTIONS(2433),
    [anon_sym_let] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [anon_sym_BANG] = ACTIONS(2431),
    [anon_sym_else] = ACTIONS(2433),
    [anon_sym_if] = ACTIONS(2433),
    [anon_sym_switch] = ACTIONS(2433),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_await] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2433),
    [anon_sym_do] = ACTIONS(2433),
    [anon_sym_try] = ACTIONS(2433),
    [anon_sym_with] = ACTIONS(2433),
    [anon_sym_break] = ACTIONS(2433),
    [anon_sym_continue] = ACTIONS(2433),
    [anon_sym_debugger] = ACTIONS(2433),
    [anon_sym_return] = ACTIONS(2433),
    [anon_sym_throw] = ACTIONS(2433),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym_case] = ACTIONS(2433),
    [anon_sym_yield] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2431),
    [anon_sym_LTtemplate_GT] = ACTIONS(2431),
    [anon_sym_class] = ACTIONS(2433),
    [anon_sym_async] = ACTIONS(2433),
    [anon_sym_function] = ACTIONS(2433),
    [anon_sym_new] = ACTIONS(2433),
    [anon_sym_PLUS] = ACTIONS(2433),
    [anon_sym_DASH] = ACTIONS(2433),
    [anon_sym_SLASH] = ACTIONS(2433),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_void] = ACTIONS(2433),
    [anon_sym_delete] = ACTIONS(2433),
    [anon_sym_PLUS_PLUS] = ACTIONS(2431),
    [anon_sym_DASH_DASH] = ACTIONS(2433),
    [anon_sym_DQUOTE] = ACTIONS(2431),
    [anon_sym_SQUOTE] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2431),
    [sym_number] = ACTIONS(2431),
    [sym_this] = ACTIONS(2433),
    [sym_super] = ACTIONS(2433),
    [sym_true] = ACTIONS(2433),
    [sym_false] = ACTIONS(2433),
    [sym_null] = ACTIONS(2433),
    [sym_undefined] = ACTIONS(2433),
    [anon_sym_AT] = ACTIONS(2431),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_readonly] = ACTIONS(2433),
    [anon_sym_get] = ACTIONS(2433),
    [anon_sym_set] = ACTIONS(2433),
    [anon_sym_declare] = ACTIONS(2433),
    [anon_sym_public] = ACTIONS(2433),
    [anon_sym_private] = ACTIONS(2433),
    [anon_sym_protected] = ACTIONS(2433),
    [anon_sym_override] = ACTIONS(2433),
    [anon_sym_module] = ACTIONS(2433),
    [anon_sym_any] = ACTIONS(2433),
    [anon_sym_number] = ACTIONS(2433),
    [anon_sym_boolean] = ACTIONS(2433),
    [anon_sym_string] = ACTIONS(2433),
    [anon_sym_symbol] = ACTIONS(2433),
    [anon_sym_abstract] = ACTIONS(2433),
    [anon_sym_interface] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
  },
  [758] = {
    [ts_builtin_sym_end] = ACTIONS(2435),
    [sym_identifier] = ACTIONS(2437),
    [anon_sym_export] = ACTIONS(2437),
    [anon_sym_default] = ACTIONS(2437),
    [anon_sym_type] = ACTIONS(2437),
    [anon_sym_namespace] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_RBRACE] = ACTIONS(2435),
    [anon_sym_typeof] = ACTIONS(2437),
    [anon_sym_import] = ACTIONS(2437),
    [anon_sym_var] = ACTIONS(2437),
    [anon_sym_let] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2437),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_else] = ACTIONS(2437),
    [anon_sym_if] = ACTIONS(2437),
    [anon_sym_switch] = ACTIONS(2437),
    [anon_sym_for] = ACTIONS(2437),
    [anon_sym_LPAREN] = ACTIONS(2435),
    [anon_sym_await] = ACTIONS(2437),
    [anon_sym_while] = ACTIONS(2437),
    [anon_sym_do] = ACTIONS(2437),
    [anon_sym_try] = ACTIONS(2437),
    [anon_sym_with] = ACTIONS(2437),
    [anon_sym_break] = ACTIONS(2437),
    [anon_sym_continue] = ACTIONS(2437),
    [anon_sym_debugger] = ACTIONS(2437),
    [anon_sym_return] = ACTIONS(2437),
    [anon_sym_throw] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym_case] = ACTIONS(2437),
    [anon_sym_yield] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2435),
    [anon_sym_LTtemplate_GT] = ACTIONS(2435),
    [anon_sym_class] = ACTIONS(2437),
    [anon_sym_async] = ACTIONS(2437),
    [anon_sym_function] = ACTIONS(2437),
    [anon_sym_new] = ACTIONS(2437),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2437),
    [anon_sym_LT] = ACTIONS(2437),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_void] = ACTIONS(2437),
    [anon_sym_delete] = ACTIONS(2437),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_DASH_DASH] = ACTIONS(2437),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2435),
    [sym_number] = ACTIONS(2435),
    [sym_this] = ACTIONS(2437),
    [sym_super] = ACTIONS(2437),
    [sym_true] = ACTIONS(2437),
    [sym_false] = ACTIONS(2437),
    [sym_null] = ACTIONS(2437),
    [sym_undefined] = ACTIONS(2437),
    [anon_sym_AT] = ACTIONS(2435),
    [anon_sym_static] = ACTIONS(2437),
    [anon_sym_readonly] = ACTIONS(2437),
    [anon_sym_get] = ACTIONS(2437),
    [anon_sym_set] = ACTIONS(2437),
    [anon_sym_declare] = ACTIONS(2437),
    [anon_sym_public] = ACTIONS(2437),
    [anon_sym_private] = ACTIONS(2437),
    [anon_sym_protected] = ACTIONS(2437),
    [anon_sym_override] = ACTIONS(2437),
    [anon_sym_module] = ACTIONS(2437),
    [anon_sym_any] = ACTIONS(2437),
    [anon_sym_number] = ACTIONS(2437),
    [anon_sym_boolean] = ACTIONS(2437),
    [anon_sym_string] = ACTIONS(2437),
    [anon_sym_symbol] = ACTIONS(2437),
    [anon_sym_abstract] = ACTIONS(2437),
    [anon_sym_interface] = ACTIONS(2437),
    [anon_sym_enum] = ACTIONS(2437),
  },
  [759] = {
    [ts_builtin_sym_end] = ACTIONS(2439),
    [sym_identifier] = ACTIONS(2441),
    [anon_sym_export] = ACTIONS(2441),
    [anon_sym_default] = ACTIONS(2441),
    [anon_sym_type] = ACTIONS(2441),
    [anon_sym_namespace] = ACTIONS(2441),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_typeof] = ACTIONS(2441),
    [anon_sym_import] = ACTIONS(2441),
    [anon_sym_var] = ACTIONS(2441),
    [anon_sym_let] = ACTIONS(2441),
    [anon_sym_const] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2439),
    [anon_sym_else] = ACTIONS(2441),
    [anon_sym_if] = ACTIONS(2441),
    [anon_sym_switch] = ACTIONS(2441),
    [anon_sym_for] = ACTIONS(2441),
    [anon_sym_LPAREN] = ACTIONS(2439),
    [anon_sym_await] = ACTIONS(2441),
    [anon_sym_while] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_try] = ACTIONS(2441),
    [anon_sym_with] = ACTIONS(2441),
    [anon_sym_break] = ACTIONS(2441),
    [anon_sym_continue] = ACTIONS(2441),
    [anon_sym_debugger] = ACTIONS(2441),
    [anon_sym_return] = ACTIONS(2441),
    [anon_sym_throw] = ACTIONS(2441),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym_case] = ACTIONS(2441),
    [anon_sym_yield] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LTtemplate_GT] = ACTIONS(2439),
    [anon_sym_class] = ACTIONS(2441),
    [anon_sym_async] = ACTIONS(2441),
    [anon_sym_function] = ACTIONS(2441),
    [anon_sym_new] = ACTIONS(2441),
    [anon_sym_PLUS] = ACTIONS(2441),
    [anon_sym_DASH] = ACTIONS(2441),
    [anon_sym_SLASH] = ACTIONS(2441),
    [anon_sym_LT] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_void] = ACTIONS(2441),
    [anon_sym_delete] = ACTIONS(2441),
    [anon_sym_PLUS_PLUS] = ACTIONS(2439),
    [anon_sym_DASH_DASH] = ACTIONS(2441),
    [anon_sym_DQUOTE] = ACTIONS(2439),
    [anon_sym_SQUOTE] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2439),
    [sym_number] = ACTIONS(2439),
    [sym_this] = ACTIONS(2441),
    [sym_super] = ACTIONS(2441),
    [sym_true] = ACTIONS(2441),
    [sym_false] = ACTIONS(2441),
    [sym_null] = ACTIONS(2441),
    [sym_undefined] = ACTIONS(2441),
    [anon_sym_AT] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2441),
    [anon_sym_readonly] = ACTIONS(2441),
    [anon_sym_get] = ACTIONS(2441),
    [anon_sym_set] = ACTIONS(2441),
    [anon_sym_declare] = ACTIONS(2441),
    [anon_sym_public] = ACTIONS(2441),
    [anon_sym_private] = ACTIONS(2441),
    [anon_sym_protected] = ACTIONS(2441),
    [anon_sym_override] = ACTIONS(2441),
    [anon_sym_module] = ACTIONS(2441),
    [anon_sym_any] = ACTIONS(2441),
    [anon_sym_number] = ACTIONS(2441),
    [anon_sym_boolean] = ACTIONS(2441),
    [anon_sym_string] = ACTIONS(2441),
    [anon_sym_symbol] = ACTIONS(2441),
    [anon_sym_abstract] = ACTIONS(2441),
    [anon_sym_interface] = ACTIONS(2441),
    [anon_sym_enum] = ACTIONS(2441),
  },
  [760] = {
    [ts_builtin_sym_end] = ACTIONS(2443),
    [sym_identifier] = ACTIONS(2445),
    [anon_sym_export] = ACTIONS(2445),
    [anon_sym_default] = ACTIONS(2445),
    [anon_sym_type] = ACTIONS(2445),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_RBRACE] = ACTIONS(2443),
    [anon_sym_typeof] = ACTIONS(2445),
    [anon_sym_import] = ACTIONS(2445),
    [anon_sym_var] = ACTIONS(2445),
    [anon_sym_let] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_else] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2445),
    [anon_sym_switch] = ACTIONS(2445),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2443),
    [anon_sym_await] = ACTIONS(2445),
    [anon_sym_while] = ACTIONS(2445),
    [anon_sym_do] = ACTIONS(2445),
    [anon_sym_try] = ACTIONS(2445),
    [anon_sym_with] = ACTIONS(2445),
    [anon_sym_break] = ACTIONS(2445),
    [anon_sym_continue] = ACTIONS(2445),
    [anon_sym_debugger] = ACTIONS(2445),
    [anon_sym_return] = ACTIONS(2445),
    [anon_sym_throw] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(2443),
    [anon_sym_case] = ACTIONS(2445),
    [anon_sym_yield] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LTtemplate_GT] = ACTIONS(2443),
    [anon_sym_class] = ACTIONS(2445),
    [anon_sym_async] = ACTIONS(2445),
    [anon_sym_function] = ACTIONS(2445),
    [anon_sym_new] = ACTIONS(2445),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_void] = ACTIONS(2445),
    [anon_sym_delete] = ACTIONS(2445),
    [anon_sym_PLUS_PLUS] = ACTIONS(2443),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2443),
    [sym_number] = ACTIONS(2443),
    [sym_this] = ACTIONS(2445),
    [sym_super] = ACTIONS(2445),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [sym_null] = ACTIONS(2445),
    [sym_undefined] = ACTIONS(2445),
    [anon_sym_AT] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2445),
    [anon_sym_readonly] = ACTIONS(2445),
    [anon_sym_get] = ACTIONS(2445),
    [anon_sym_set] = ACTIONS(2445),
    [anon_sym_declare] = ACTIONS(2445),
    [anon_sym_public] = ACTIONS(2445),
    [anon_sym_private] = ACTIONS(2445),
    [anon_sym_protected] = ACTIONS(2445),
    [anon_sym_override] = ACTIONS(2445),
    [anon_sym_module] = ACTIONS(2445),
    [anon_sym_any] = ACTIONS(2445),
    [anon_sym_number] = ACTIONS(2445),
    [anon_sym_boolean] = ACTIONS(2445),
    [anon_sym_string] = ACTIONS(2445),
    [anon_sym_symbol] = ACTIONS(2445),
    [anon_sym_abstract] = ACTIONS(2445),
    [anon_sym_interface] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
  },
  [761] = {
    [ts_builtin_sym_end] = ACTIONS(2447),
    [sym_identifier] = ACTIONS(2449),
    [anon_sym_export] = ACTIONS(2449),
    [anon_sym_default] = ACTIONS(2449),
    [anon_sym_type] = ACTIONS(2449),
    [anon_sym_namespace] = ACTIONS(2449),
    [anon_sym_LBRACE] = ACTIONS(2447),
    [anon_sym_RBRACE] = ACTIONS(2447),
    [anon_sym_typeof] = ACTIONS(2449),
    [anon_sym_import] = ACTIONS(2449),
    [anon_sym_var] = ACTIONS(2449),
    [anon_sym_let] = ACTIONS(2449),
    [anon_sym_const] = ACTIONS(2449),
    [anon_sym_BANG] = ACTIONS(2447),
    [anon_sym_else] = ACTIONS(2449),
    [anon_sym_if] = ACTIONS(2449),
    [anon_sym_switch] = ACTIONS(2449),
    [anon_sym_for] = ACTIONS(2449),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_await] = ACTIONS(2449),
    [anon_sym_while] = ACTIONS(2449),
    [anon_sym_do] = ACTIONS(2449),
    [anon_sym_try] = ACTIONS(2449),
    [anon_sym_with] = ACTIONS(2449),
    [anon_sym_break] = ACTIONS(2449),
    [anon_sym_continue] = ACTIONS(2449),
    [anon_sym_debugger] = ACTIONS(2449),
    [anon_sym_return] = ACTIONS(2449),
    [anon_sym_throw] = ACTIONS(2449),
    [anon_sym_SEMI] = ACTIONS(2447),
    [anon_sym_case] = ACTIONS(2449),
    [anon_sym_yield] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LTtemplate_GT] = ACTIONS(2447),
    [anon_sym_class] = ACTIONS(2449),
    [anon_sym_async] = ACTIONS(2449),
    [anon_sym_function] = ACTIONS(2449),
    [anon_sym_new] = ACTIONS(2449),
    [anon_sym_PLUS] = ACTIONS(2449),
    [anon_sym_DASH] = ACTIONS(2449),
    [anon_sym_SLASH] = ACTIONS(2449),
    [anon_sym_LT] = ACTIONS(2449),
    [anon_sym_TILDE] = ACTIONS(2447),
    [anon_sym_void] = ACTIONS(2449),
    [anon_sym_delete] = ACTIONS(2449),
    [anon_sym_PLUS_PLUS] = ACTIONS(2447),
    [anon_sym_DASH_DASH] = ACTIONS(2449),
    [anon_sym_DQUOTE] = ACTIONS(2447),
    [anon_sym_SQUOTE] = ACTIONS(2447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2447),
    [sym_number] = ACTIONS(2447),
    [sym_this] = ACTIONS(2449),
    [sym_super] = ACTIONS(2449),
    [sym_true] = ACTIONS(2449),
    [sym_false] = ACTIONS(2449),
    [sym_null] = ACTIONS(2449),
    [sym_undefined] = ACTIONS(2449),
    [anon_sym_AT] = ACTIONS(2447),
    [anon_sym_static] = ACTIONS(2449),
    [anon_sym_readonly] = ACTIONS(2449),
    [anon_sym_get] = ACTIONS(2449),
    [anon_sym_set] = ACTIONS(2449),
    [anon_sym_declare] = ACTIONS(2449),
    [anon_sym_public] = ACTIONS(2449),
    [anon_sym_private] = ACTIONS(2449),
    [anon_sym_protected] = ACTIONS(2449),
    [anon_sym_override] = ACTIONS(2449),
    [anon_sym_module] = ACTIONS(2449),
    [anon_sym_any] = ACTIONS(2449),
    [anon_sym_number] = ACTIONS(2449),
    [anon_sym_boolean] = ACTIONS(2449),
    [anon_sym_string] = ACTIONS(2449),
    [anon_sym_symbol] = ACTIONS(2449),
    [anon_sym_abstract] = ACTIONS(2449),
    [anon_sym_interface] = ACTIONS(2449),
    [anon_sym_enum] = ACTIONS(2449),
  },
  [762] = {
    [ts_builtin_sym_end] = ACTIONS(2379),
    [sym_identifier] = ACTIONS(2381),
    [anon_sym_export] = ACTIONS(2381),
    [anon_sym_default] = ACTIONS(2381),
    [anon_sym_type] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_RBRACE] = ACTIONS(2379),
    [anon_sym_typeof] = ACTIONS(2381),
    [anon_sym_import] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2381),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_const] = ACTIONS(2381),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2379),
    [anon_sym_await] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_do] = ACTIONS(2381),
    [anon_sym_try] = ACTIONS(2381),
    [anon_sym_with] = ACTIONS(2381),
    [anon_sym_break] = ACTIONS(2381),
    [anon_sym_continue] = ACTIONS(2381),
    [anon_sym_debugger] = ACTIONS(2381),
    [anon_sym_return] = ACTIONS(2381),
    [anon_sym_throw] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_case] = ACTIONS(2381),
    [anon_sym_yield] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2379),
    [anon_sym_LTtemplate_GT] = ACTIONS(2379),
    [anon_sym_class] = ACTIONS(2381),
    [anon_sym_async] = ACTIONS(2381),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2381),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_SLASH] = ACTIONS(2381),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2379),
    [anon_sym_void] = ACTIONS(2381),
    [anon_sym_delete] = ACTIONS(2381),
    [anon_sym_PLUS_PLUS] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(2381),
    [anon_sym_DQUOTE] = ACTIONS(2379),
    [anon_sym_SQUOTE] = ACTIONS(2379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2379),
    [sym_number] = ACTIONS(2379),
    [sym_this] = ACTIONS(2381),
    [sym_super] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_undefined] = ACTIONS(2381),
    [anon_sym_AT] = ACTIONS(2379),
    [anon_sym_static] = ACTIONS(2381),
    [anon_sym_readonly] = ACTIONS(2381),
    [anon_sym_get] = ACTIONS(2381),
    [anon_sym_set] = ACTIONS(2381),
    [anon_sym_declare] = ACTIONS(2381),
    [anon_sym_public] = ACTIONS(2381),
    [anon_sym_private] = ACTIONS(2381),
    [anon_sym_protected] = ACTIONS(2381),
    [anon_sym_override] = ACTIONS(2381),
    [anon_sym_module] = ACTIONS(2381),
    [anon_sym_any] = ACTIONS(2381),
    [anon_sym_number] = ACTIONS(2381),
    [anon_sym_boolean] = ACTIONS(2381),
    [anon_sym_string] = ACTIONS(2381),
    [anon_sym_symbol] = ACTIONS(2381),
    [anon_sym_abstract] = ACTIONS(2381),
    [anon_sym_interface] = ACTIONS(2381),
    [anon_sym_enum] = ACTIONS(2381),
  },
  [763] = {
    [ts_builtin_sym_end] = ACTIONS(2379),
    [sym_identifier] = ACTIONS(2381),
    [anon_sym_export] = ACTIONS(2381),
    [anon_sym_default] = ACTIONS(2381),
    [anon_sym_type] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_RBRACE] = ACTIONS(2379),
    [anon_sym_typeof] = ACTIONS(2381),
    [anon_sym_import] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2381),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_const] = ACTIONS(2381),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2379),
    [anon_sym_await] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_do] = ACTIONS(2381),
    [anon_sym_try] = ACTIONS(2381),
    [anon_sym_with] = ACTIONS(2381),
    [anon_sym_break] = ACTIONS(2381),
    [anon_sym_continue] = ACTIONS(2381),
    [anon_sym_debugger] = ACTIONS(2381),
    [anon_sym_return] = ACTIONS(2381),
    [anon_sym_throw] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_case] = ACTIONS(2381),
    [anon_sym_yield] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2379),
    [anon_sym_LTtemplate_GT] = ACTIONS(2379),
    [anon_sym_class] = ACTIONS(2381),
    [anon_sym_async] = ACTIONS(2381),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2381),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_SLASH] = ACTIONS(2381),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2379),
    [anon_sym_void] = ACTIONS(2381),
    [anon_sym_delete] = ACTIONS(2381),
    [anon_sym_PLUS_PLUS] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(2381),
    [anon_sym_DQUOTE] = ACTIONS(2379),
    [anon_sym_SQUOTE] = ACTIONS(2379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2379),
    [sym_number] = ACTIONS(2379),
    [sym_this] = ACTIONS(2381),
    [sym_super] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_undefined] = ACTIONS(2381),
    [anon_sym_AT] = ACTIONS(2379),
    [anon_sym_static] = ACTIONS(2381),
    [anon_sym_readonly] = ACTIONS(2381),
    [anon_sym_get] = ACTIONS(2381),
    [anon_sym_set] = ACTIONS(2381),
    [anon_sym_declare] = ACTIONS(2381),
    [anon_sym_public] = ACTIONS(2381),
    [anon_sym_private] = ACTIONS(2381),
    [anon_sym_protected] = ACTIONS(2381),
    [anon_sym_override] = ACTIONS(2381),
    [anon_sym_module] = ACTIONS(2381),
    [anon_sym_any] = ACTIONS(2381),
    [anon_sym_number] = ACTIONS(2381),
    [anon_sym_boolean] = ACTIONS(2381),
    [anon_sym_string] = ACTIONS(2381),
    [anon_sym_symbol] = ACTIONS(2381),
    [anon_sym_abstract] = ACTIONS(2381),
    [anon_sym_interface] = ACTIONS(2381),
    [anon_sym_enum] = ACTIONS(2381),
  },
  [764] = {
    [ts_builtin_sym_end] = ACTIONS(2379),
    [sym_identifier] = ACTIONS(2381),
    [anon_sym_export] = ACTIONS(2381),
    [anon_sym_default] = ACTIONS(2381),
    [anon_sym_type] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_RBRACE] = ACTIONS(2379),
    [anon_sym_typeof] = ACTIONS(2381),
    [anon_sym_import] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2381),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_const] = ACTIONS(2381),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2379),
    [anon_sym_await] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_do] = ACTIONS(2381),
    [anon_sym_try] = ACTIONS(2381),
    [anon_sym_with] = ACTIONS(2381),
    [anon_sym_break] = ACTIONS(2381),
    [anon_sym_continue] = ACTIONS(2381),
    [anon_sym_debugger] = ACTIONS(2381),
    [anon_sym_return] = ACTIONS(2381),
    [anon_sym_throw] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_case] = ACTIONS(2381),
    [anon_sym_yield] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2379),
    [anon_sym_LTtemplate_GT] = ACTIONS(2379),
    [anon_sym_class] = ACTIONS(2381),
    [anon_sym_async] = ACTIONS(2381),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2381),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_SLASH] = ACTIONS(2381),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2379),
    [anon_sym_void] = ACTIONS(2381),
    [anon_sym_delete] = ACTIONS(2381),
    [anon_sym_PLUS_PLUS] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(2381),
    [anon_sym_DQUOTE] = ACTIONS(2379),
    [anon_sym_SQUOTE] = ACTIONS(2379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2379),
    [sym_number] = ACTIONS(2379),
    [sym_this] = ACTIONS(2381),
    [sym_super] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_undefined] = ACTIONS(2381),
    [anon_sym_AT] = ACTIONS(2379),
    [anon_sym_static] = ACTIONS(2381),
    [anon_sym_readonly] = ACTIONS(2381),
    [anon_sym_get] = ACTIONS(2381),
    [anon_sym_set] = ACTIONS(2381),
    [anon_sym_declare] = ACTIONS(2381),
    [anon_sym_public] = ACTIONS(2381),
    [anon_sym_private] = ACTIONS(2381),
    [anon_sym_protected] = ACTIONS(2381),
    [anon_sym_override] = ACTIONS(2381),
    [anon_sym_module] = ACTIONS(2381),
    [anon_sym_any] = ACTIONS(2381),
    [anon_sym_number] = ACTIONS(2381),
    [anon_sym_boolean] = ACTIONS(2381),
    [anon_sym_string] = ACTIONS(2381),
    [anon_sym_symbol] = ACTIONS(2381),
    [anon_sym_abstract] = ACTIONS(2381),
    [anon_sym_interface] = ACTIONS(2381),
    [anon_sym_enum] = ACTIONS(2381),
  },
  [765] = {
    [ts_builtin_sym_end] = ACTIONS(2379),
    [sym_identifier] = ACTIONS(2381),
    [anon_sym_export] = ACTIONS(2381),
    [anon_sym_default] = ACTIONS(2381),
    [anon_sym_type] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_RBRACE] = ACTIONS(2379),
    [anon_sym_typeof] = ACTIONS(2381),
    [anon_sym_import] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2381),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_const] = ACTIONS(2381),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2379),
    [anon_sym_await] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_do] = ACTIONS(2381),
    [anon_sym_try] = ACTIONS(2381),
    [anon_sym_with] = ACTIONS(2381),
    [anon_sym_break] = ACTIONS(2381),
    [anon_sym_continue] = ACTIONS(2381),
    [anon_sym_debugger] = ACTIONS(2381),
    [anon_sym_return] = ACTIONS(2381),
    [anon_sym_throw] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_case] = ACTIONS(2381),
    [anon_sym_yield] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2379),
    [anon_sym_LTtemplate_GT] = ACTIONS(2379),
    [anon_sym_class] = ACTIONS(2381),
    [anon_sym_async] = ACTIONS(2381),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2381),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_SLASH] = ACTIONS(2381),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2379),
    [anon_sym_void] = ACTIONS(2381),
    [anon_sym_delete] = ACTIONS(2381),
    [anon_sym_PLUS_PLUS] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(2381),
    [anon_sym_DQUOTE] = ACTIONS(2379),
    [anon_sym_SQUOTE] = ACTIONS(2379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2379),
    [sym_number] = ACTIONS(2379),
    [sym_this] = ACTIONS(2381),
    [sym_super] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_undefined] = ACTIONS(2381),
    [anon_sym_AT] = ACTIONS(2379),
    [anon_sym_static] = ACTIONS(2381),
    [anon_sym_readonly] = ACTIONS(2381),
    [anon_sym_get] = ACTIONS(2381),
    [anon_sym_set] = ACTIONS(2381),
    [anon_sym_declare] = ACTIONS(2381),
    [anon_sym_public] = ACTIONS(2381),
    [anon_sym_private] = ACTIONS(2381),
    [anon_sym_protected] = ACTIONS(2381),
    [anon_sym_override] = ACTIONS(2381),
    [anon_sym_module] = ACTIONS(2381),
    [anon_sym_any] = ACTIONS(2381),
    [anon_sym_number] = ACTIONS(2381),
    [anon_sym_boolean] = ACTIONS(2381),
    [anon_sym_string] = ACTIONS(2381),
    [anon_sym_symbol] = ACTIONS(2381),
    [anon_sym_abstract] = ACTIONS(2381),
    [anon_sym_interface] = ACTIONS(2381),
    [anon_sym_enum] = ACTIONS(2381),
  },
  [766] = {
    [ts_builtin_sym_end] = ACTIONS(2451),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_type] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2451),
    [anon_sym_RBRACE] = ACTIONS(2451),
    [anon_sym_typeof] = ACTIONS(2453),
    [anon_sym_import] = ACTIONS(2453),
    [anon_sym_var] = ACTIONS(2453),
    [anon_sym_let] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2451),
    [anon_sym_else] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(2451),
    [anon_sym_await] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_with] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_debugger] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_yield] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2451),
    [anon_sym_LTtemplate_GT] = ACTIONS(2451),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_async] = ACTIONS(2453),
    [anon_sym_function] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_SLASH] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_void] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_PLUS_PLUS] = ACTIONS(2451),
    [anon_sym_DASH_DASH] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2451),
    [sym_number] = ACTIONS(2451),
    [sym_this] = ACTIONS(2453),
    [sym_super] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_null] = ACTIONS(2453),
    [sym_undefined] = ACTIONS(2453),
    [anon_sym_AT] = ACTIONS(2451),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_readonly] = ACTIONS(2453),
    [anon_sym_get] = ACTIONS(2453),
    [anon_sym_set] = ACTIONS(2453),
    [anon_sym_declare] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_override] = ACTIONS(2453),
    [anon_sym_module] = ACTIONS(2453),
    [anon_sym_any] = ACTIONS(2453),
    [anon_sym_number] = ACTIONS(2453),
    [anon_sym_boolean] = ACTIONS(2453),
    [anon_sym_string] = ACTIONS(2453),
    [anon_sym_symbol] = ACTIONS(2453),
    [anon_sym_abstract] = ACTIONS(2453),
    [anon_sym_interface] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
  },
  [767] = {
    [ts_builtin_sym_end] = ACTIONS(1473),
    [sym_identifier] = ACTIONS(1475),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_default] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1473),
    [anon_sym_RBRACE] = ACTIONS(1473),
    [anon_sym_typeof] = ACTIONS(1475),
    [anon_sym_import] = ACTIONS(1475),
    [anon_sym_var] = ACTIONS(1475),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_const] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1473),
    [anon_sym_else] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(1475),
    [anon_sym_switch] = ACTIONS(1475),
    [anon_sym_for] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_await] = ACTIONS(1475),
    [anon_sym_while] = ACTIONS(1475),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1475),
    [anon_sym_with] = ACTIONS(1475),
    [anon_sym_break] = ACTIONS(1475),
    [anon_sym_continue] = ACTIONS(1475),
    [anon_sym_debugger] = ACTIONS(1475),
    [anon_sym_return] = ACTIONS(1475),
    [anon_sym_throw] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(1475),
    [anon_sym_yield] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(1473),
    [anon_sym_LTtemplate_GT] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(1475),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_function] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1473),
    [anon_sym_void] = ACTIONS(1475),
    [anon_sym_delete] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1473),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1473),
    [sym_number] = ACTIONS(1473),
    [sym_this] = ACTIONS(1475),
    [sym_super] = ACTIONS(1475),
    [sym_true] = ACTIONS(1475),
    [sym_false] = ACTIONS(1475),
    [sym_null] = ACTIONS(1475),
    [sym_undefined] = ACTIONS(1475),
    [anon_sym_AT] = ACTIONS(1473),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_abstract] = ACTIONS(1475),
    [anon_sym_interface] = ACTIONS(1475),
    [anon_sym_enum] = ACTIONS(1475),
  },
  [768] = {
    [ts_builtin_sym_end] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_export] = ACTIONS(2457),
    [anon_sym_default] = ACTIONS(2457),
    [anon_sym_type] = ACTIONS(2457),
    [anon_sym_namespace] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_typeof] = ACTIONS(2457),
    [anon_sym_import] = ACTIONS(2457),
    [anon_sym_var] = ACTIONS(2457),
    [anon_sym_let] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_else] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2455),
    [anon_sym_await] = ACTIONS(2457),
    [anon_sym_while] = ACTIONS(2457),
    [anon_sym_do] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2457),
    [anon_sym_with] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_debugger] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_throw] = ACTIONS(2457),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym_case] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_LTtemplate_GT] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2457),
    [anon_sym_async] = ACTIONS(2457),
    [anon_sym_function] = ACTIONS(2457),
    [anon_sym_new] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_void] = ACTIONS(2457),
    [anon_sym_delete] = ACTIONS(2457),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2455),
    [sym_number] = ACTIONS(2455),
    [sym_this] = ACTIONS(2457),
    [sym_super] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_null] = ACTIONS(2457),
    [sym_undefined] = ACTIONS(2457),
    [anon_sym_AT] = ACTIONS(2455),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_readonly] = ACTIONS(2457),
    [anon_sym_get] = ACTIONS(2457),
    [anon_sym_set] = ACTIONS(2457),
    [anon_sym_declare] = ACTIONS(2457),
    [anon_sym_public] = ACTIONS(2457),
    [anon_sym_private] = ACTIONS(2457),
    [anon_sym_protected] = ACTIONS(2457),
    [anon_sym_override] = ACTIONS(2457),
    [anon_sym_module] = ACTIONS(2457),
    [anon_sym_any] = ACTIONS(2457),
    [anon_sym_number] = ACTIONS(2457),
    [anon_sym_boolean] = ACTIONS(2457),
    [anon_sym_string] = ACTIONS(2457),
    [anon_sym_symbol] = ACTIONS(2457),
    [anon_sym_abstract] = ACTIONS(2457),
    [anon_sym_interface] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
  },
  [769] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3668),
    [sym_optional_tuple_parameter] = STATE(3668),
    [sym_optional_type] = STATE(3668),
    [sym_rest_type] = STATE(3668),
    [sym__tuple_type_member] = STATE(3668),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2463),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [770] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3671),
    [sym_optional_tuple_parameter] = STATE(3671),
    [sym_optional_type] = STATE(3671),
    [sym_rest_type] = STATE(3671),
    [sym__tuple_type_member] = STATE(3671),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2471),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [771] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3592),
    [sym_optional_tuple_parameter] = STATE(3592),
    [sym_optional_type] = STATE(3592),
    [sym_rest_type] = STATE(3592),
    [sym__tuple_type_member] = STATE(3592),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(2473),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2475),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [772] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3554),
    [sym_optional_tuple_parameter] = STATE(3554),
    [sym_optional_type] = STATE(3554),
    [sym_rest_type] = STATE(3554),
    [sym__tuple_type_member] = STATE(3554),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(2477),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2479),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [773] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3569),
    [sym_optional_tuple_parameter] = STATE(3569),
    [sym_optional_type] = STATE(3569),
    [sym_rest_type] = STATE(3569),
    [sym__tuple_type_member] = STATE(3569),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_COMMA] = ACTIONS(2481),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [774] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3741),
    [sym_optional_tuple_parameter] = STATE(3741),
    [sym_optional_type] = STATE(3741),
    [sym_rest_type] = STATE(3741),
    [sym__tuple_type_member] = STATE(3741),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2485),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [775] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3741),
    [sym_optional_tuple_parameter] = STATE(3741),
    [sym_optional_type] = STATE(3741),
    [sym_rest_type] = STATE(3741),
    [sym__tuple_type_member] = STATE(3741),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2487),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [776] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3741),
    [sym_optional_tuple_parameter] = STATE(3741),
    [sym_optional_type] = STATE(3741),
    [sym_rest_type] = STATE(3741),
    [sym__tuple_type_member] = STATE(3741),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2489),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [777] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3741),
    [sym_optional_tuple_parameter] = STATE(3741),
    [sym_optional_type] = STATE(3741),
    [sym_rest_type] = STATE(3741),
    [sym__tuple_type_member] = STATE(3741),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2491),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [778] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3741),
    [sym_optional_tuple_parameter] = STATE(3741),
    [sym_optional_type] = STATE(3741),
    [sym_rest_type] = STATE(3741),
    [sym__tuple_type_member] = STATE(3741),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2493),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [779] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3741),
    [sym_optional_tuple_parameter] = STATE(3741),
    [sym_optional_type] = STATE(3741),
    [sym_rest_type] = STATE(3741),
    [sym__tuple_type_member] = STATE(3741),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2495),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [780] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3741),
    [sym_optional_tuple_parameter] = STATE(3741),
    [sym_optional_type] = STATE(3741),
    [sym_rest_type] = STATE(3741),
    [sym__tuple_type_member] = STATE(3741),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2497),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [781] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3741),
    [sym_optional_tuple_parameter] = STATE(3741),
    [sym_optional_type] = STATE(3741),
    [sym_rest_type] = STATE(3741),
    [sym__tuple_type_member] = STATE(3741),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2499),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [782] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3741),
    [sym_optional_tuple_parameter] = STATE(3741),
    [sym_optional_type] = STATE(3741),
    [sym_rest_type] = STATE(3741),
    [sym__tuple_type_member] = STATE(3741),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2501),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [783] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3741),
    [sym_optional_tuple_parameter] = STATE(3741),
    [sym_optional_type] = STATE(3741),
    [sym_rest_type] = STATE(3741),
    [sym__tuple_type_member] = STATE(3741),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2503),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [784] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_rest_pattern] = STATE(3817),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3002),
    [sym_tuple_parameter] = STATE(3741),
    [sym_optional_tuple_parameter] = STATE(3741),
    [sym_optional_type] = STATE(3741),
    [sym_rest_type] = STATE(3741),
    [sym__tuple_type_member] = STATE(3741),
    [sym_constructor_type] = STATE(3002),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3002),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3002),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3002),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [785] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2505),
    [anon_sym_namespace] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2505),
    [anon_sym_import] = ACTIONS(2505),
    [anon_sym_var] = ACTIONS(2505),
    [anon_sym_let] = ACTIONS(2505),
    [anon_sym_const] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2505),
    [anon_sym_switch] = ACTIONS(2505),
    [anon_sym_for] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [anon_sym_await] = ACTIONS(2505),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2505),
    [anon_sym_try] = ACTIONS(2505),
    [anon_sym_with] = ACTIONS(2505),
    [anon_sym_break] = ACTIONS(2505),
    [anon_sym_continue] = ACTIONS(2505),
    [anon_sym_debugger] = ACTIONS(2505),
    [anon_sym_return] = ACTIONS(2505),
    [anon_sym_throw] = ACTIONS(2505),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_LTtemplate_GT] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2505),
    [anon_sym_async] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(2505),
    [anon_sym_new] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_SLASH] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_void] = ACTIONS(2505),
    [anon_sym_delete] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2507),
    [anon_sym_SQUOTE] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [sym_number] = ACTIONS(2507),
    [sym_this] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_undefined] = ACTIONS(2505),
    [anon_sym_AT] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2505),
    [anon_sym_readonly] = ACTIONS(2505),
    [anon_sym_get] = ACTIONS(2505),
    [anon_sym_set] = ACTIONS(2505),
    [anon_sym_declare] = ACTIONS(2505),
    [anon_sym_public] = ACTIONS(2505),
    [anon_sym_private] = ACTIONS(2505),
    [anon_sym_protected] = ACTIONS(2505),
    [anon_sym_override] = ACTIONS(2505),
    [anon_sym_module] = ACTIONS(2505),
    [anon_sym_any] = ACTIONS(2505),
    [anon_sym_number] = ACTIONS(2505),
    [anon_sym_boolean] = ACTIONS(2505),
    [anon_sym_string] = ACTIONS(2505),
    [anon_sym_symbol] = ACTIONS(2505),
    [anon_sym_abstract] = ACTIONS(2505),
    [anon_sym_interface] = ACTIONS(2505),
    [anon_sym_enum] = ACTIONS(2505),
  },
  [786] = {
    [sym_identifier] = ACTIONS(2509),
    [anon_sym_export] = ACTIONS(2509),
    [anon_sym_type] = ACTIONS(2509),
    [anon_sym_namespace] = ACTIONS(2509),
    [anon_sym_LBRACE] = ACTIONS(2511),
    [anon_sym_typeof] = ACTIONS(2509),
    [anon_sym_import] = ACTIONS(2509),
    [anon_sym_var] = ACTIONS(2509),
    [anon_sym_let] = ACTIONS(2509),
    [anon_sym_const] = ACTIONS(2509),
    [anon_sym_BANG] = ACTIONS(2511),
    [anon_sym_if] = ACTIONS(2509),
    [anon_sym_switch] = ACTIONS(2509),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_LPAREN] = ACTIONS(2511),
    [anon_sym_await] = ACTIONS(2509),
    [anon_sym_while] = ACTIONS(2509),
    [anon_sym_do] = ACTIONS(2509),
    [anon_sym_try] = ACTIONS(2509),
    [anon_sym_with] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2509),
    [anon_sym_continue] = ACTIONS(2509),
    [anon_sym_debugger] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2509),
    [anon_sym_throw] = ACTIONS(2509),
    [anon_sym_SEMI] = ACTIONS(2511),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_LBRACK] = ACTIONS(2511),
    [anon_sym_LTtemplate_GT] = ACTIONS(2511),
    [anon_sym_class] = ACTIONS(2509),
    [anon_sym_async] = ACTIONS(2509),
    [anon_sym_function] = ACTIONS(2509),
    [anon_sym_new] = ACTIONS(2509),
    [anon_sym_PLUS] = ACTIONS(2509),
    [anon_sym_DASH] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [anon_sym_LT] = ACTIONS(2509),
    [anon_sym_TILDE] = ACTIONS(2511),
    [anon_sym_void] = ACTIONS(2509),
    [anon_sym_delete] = ACTIONS(2509),
    [anon_sym_PLUS_PLUS] = ACTIONS(2511),
    [anon_sym_DASH_DASH] = ACTIONS(2509),
    [anon_sym_DQUOTE] = ACTIONS(2511),
    [anon_sym_SQUOTE] = ACTIONS(2511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2511),
    [sym_number] = ACTIONS(2511),
    [sym_this] = ACTIONS(2509),
    [sym_super] = ACTIONS(2509),
    [sym_true] = ACTIONS(2509),
    [sym_false] = ACTIONS(2509),
    [sym_null] = ACTIONS(2509),
    [sym_undefined] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(2511),
    [anon_sym_static] = ACTIONS(2509),
    [anon_sym_readonly] = ACTIONS(2509),
    [anon_sym_get] = ACTIONS(2509),
    [anon_sym_set] = ACTIONS(2509),
    [anon_sym_declare] = ACTIONS(2509),
    [anon_sym_public] = ACTIONS(2509),
    [anon_sym_private] = ACTIONS(2509),
    [anon_sym_protected] = ACTIONS(2509),
    [anon_sym_override] = ACTIONS(2509),
    [anon_sym_module] = ACTIONS(2509),
    [anon_sym_any] = ACTIONS(2509),
    [anon_sym_number] = ACTIONS(2509),
    [anon_sym_boolean] = ACTIONS(2509),
    [anon_sym_string] = ACTIONS(2509),
    [anon_sym_symbol] = ACTIONS(2509),
    [anon_sym_abstract] = ACTIONS(2509),
    [anon_sym_interface] = ACTIONS(2509),
    [anon_sym_enum] = ACTIONS(2509),
  },
  [787] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2505),
    [anon_sym_namespace] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2505),
    [anon_sym_import] = ACTIONS(2505),
    [anon_sym_var] = ACTIONS(2505),
    [anon_sym_let] = ACTIONS(2505),
    [anon_sym_const] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2505),
    [anon_sym_switch] = ACTIONS(2505),
    [anon_sym_for] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [anon_sym_await] = ACTIONS(2505),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2505),
    [anon_sym_try] = ACTIONS(2505),
    [anon_sym_with] = ACTIONS(2505),
    [anon_sym_break] = ACTIONS(2505),
    [anon_sym_continue] = ACTIONS(2505),
    [anon_sym_debugger] = ACTIONS(2505),
    [anon_sym_return] = ACTIONS(2505),
    [anon_sym_throw] = ACTIONS(2505),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_LTtemplate_GT] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2505),
    [anon_sym_async] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(2505),
    [anon_sym_new] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_SLASH] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_void] = ACTIONS(2505),
    [anon_sym_delete] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2507),
    [anon_sym_SQUOTE] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [sym_number] = ACTIONS(2507),
    [sym_this] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_undefined] = ACTIONS(2505),
    [anon_sym_AT] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2505),
    [anon_sym_readonly] = ACTIONS(2505),
    [anon_sym_get] = ACTIONS(2505),
    [anon_sym_set] = ACTIONS(2505),
    [anon_sym_declare] = ACTIONS(2505),
    [anon_sym_public] = ACTIONS(2505),
    [anon_sym_private] = ACTIONS(2505),
    [anon_sym_protected] = ACTIONS(2505),
    [anon_sym_override] = ACTIONS(2505),
    [anon_sym_module] = ACTIONS(2505),
    [anon_sym_any] = ACTIONS(2505),
    [anon_sym_number] = ACTIONS(2505),
    [anon_sym_boolean] = ACTIONS(2505),
    [anon_sym_string] = ACTIONS(2505),
    [anon_sym_symbol] = ACTIONS(2505),
    [anon_sym_abstract] = ACTIONS(2505),
    [anon_sym_interface] = ACTIONS(2505),
    [anon_sym_enum] = ACTIONS(2505),
  },
  [788] = {
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_namespace] = ACTIONS(2513),
    [anon_sym_LBRACE] = ACTIONS(2515),
    [anon_sym_typeof] = ACTIONS(2513),
    [anon_sym_import] = ACTIONS(2513),
    [anon_sym_var] = ACTIONS(2513),
    [anon_sym_let] = ACTIONS(2513),
    [anon_sym_const] = ACTIONS(2513),
    [anon_sym_BANG] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(2513),
    [anon_sym_switch] = ACTIONS(2513),
    [anon_sym_for] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(2515),
    [anon_sym_await] = ACTIONS(2513),
    [anon_sym_while] = ACTIONS(2513),
    [anon_sym_do] = ACTIONS(2513),
    [anon_sym_try] = ACTIONS(2513),
    [anon_sym_with] = ACTIONS(2513),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2513),
    [anon_sym_debugger] = ACTIONS(2513),
    [anon_sym_return] = ACTIONS(2513),
    [anon_sym_throw] = ACTIONS(2513),
    [anon_sym_SEMI] = ACTIONS(2515),
    [anon_sym_yield] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(2515),
    [anon_sym_LTtemplate_GT] = ACTIONS(2515),
    [anon_sym_class] = ACTIONS(2513),
    [anon_sym_async] = ACTIONS(2513),
    [anon_sym_function] = ACTIONS(2513),
    [anon_sym_new] = ACTIONS(2513),
    [anon_sym_PLUS] = ACTIONS(2513),
    [anon_sym_DASH] = ACTIONS(2513),
    [anon_sym_SLASH] = ACTIONS(2513),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2515),
    [anon_sym_void] = ACTIONS(2513),
    [anon_sym_delete] = ACTIONS(2513),
    [anon_sym_PLUS_PLUS] = ACTIONS(2515),
    [anon_sym_DASH_DASH] = ACTIONS(2513),
    [anon_sym_DQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2515),
    [sym_number] = ACTIONS(2515),
    [sym_this] = ACTIONS(2513),
    [sym_super] = ACTIONS(2513),
    [sym_true] = ACTIONS(2513),
    [sym_false] = ACTIONS(2513),
    [sym_null] = ACTIONS(2513),
    [sym_undefined] = ACTIONS(2513),
    [anon_sym_AT] = ACTIONS(2515),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_readonly] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2513),
    [anon_sym_set] = ACTIONS(2513),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_override] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
    [anon_sym_abstract] = ACTIONS(2513),
    [anon_sym_interface] = ACTIONS(2513),
    [anon_sym_enum] = ACTIONS(2513),
  },
  [789] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2505),
    [anon_sym_namespace] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2505),
    [anon_sym_import] = ACTIONS(2505),
    [anon_sym_var] = ACTIONS(2505),
    [anon_sym_let] = ACTIONS(2505),
    [anon_sym_const] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2505),
    [anon_sym_switch] = ACTIONS(2505),
    [anon_sym_for] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [anon_sym_await] = ACTIONS(2505),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2505),
    [anon_sym_try] = ACTIONS(2505),
    [anon_sym_with] = ACTIONS(2505),
    [anon_sym_break] = ACTIONS(2505),
    [anon_sym_continue] = ACTIONS(2505),
    [anon_sym_debugger] = ACTIONS(2505),
    [anon_sym_return] = ACTIONS(2505),
    [anon_sym_throw] = ACTIONS(2505),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_LTtemplate_GT] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2505),
    [anon_sym_async] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(2505),
    [anon_sym_new] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_SLASH] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_void] = ACTIONS(2505),
    [anon_sym_delete] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2507),
    [anon_sym_SQUOTE] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [sym_number] = ACTIONS(2507),
    [sym_this] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_undefined] = ACTIONS(2505),
    [anon_sym_AT] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2505),
    [anon_sym_readonly] = ACTIONS(2505),
    [anon_sym_get] = ACTIONS(2505),
    [anon_sym_set] = ACTIONS(2505),
    [anon_sym_declare] = ACTIONS(2505),
    [anon_sym_public] = ACTIONS(2505),
    [anon_sym_private] = ACTIONS(2505),
    [anon_sym_protected] = ACTIONS(2505),
    [anon_sym_override] = ACTIONS(2505),
    [anon_sym_module] = ACTIONS(2505),
    [anon_sym_any] = ACTIONS(2505),
    [anon_sym_number] = ACTIONS(2505),
    [anon_sym_boolean] = ACTIONS(2505),
    [anon_sym_string] = ACTIONS(2505),
    [anon_sym_symbol] = ACTIONS(2505),
    [anon_sym_abstract] = ACTIONS(2505),
    [anon_sym_interface] = ACTIONS(2505),
    [anon_sym_enum] = ACTIONS(2505),
  },
  [790] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2505),
    [anon_sym_namespace] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2505),
    [anon_sym_import] = ACTIONS(2505),
    [anon_sym_var] = ACTIONS(2505),
    [anon_sym_let] = ACTIONS(2505),
    [anon_sym_const] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2505),
    [anon_sym_switch] = ACTIONS(2505),
    [anon_sym_for] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [anon_sym_await] = ACTIONS(2505),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2505),
    [anon_sym_try] = ACTIONS(2505),
    [anon_sym_with] = ACTIONS(2505),
    [anon_sym_break] = ACTIONS(2505),
    [anon_sym_continue] = ACTIONS(2505),
    [anon_sym_debugger] = ACTIONS(2505),
    [anon_sym_return] = ACTIONS(2505),
    [anon_sym_throw] = ACTIONS(2505),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_LTtemplate_GT] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2505),
    [anon_sym_async] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(2505),
    [anon_sym_new] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_SLASH] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_void] = ACTIONS(2505),
    [anon_sym_delete] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2507),
    [anon_sym_SQUOTE] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [sym_number] = ACTIONS(2507),
    [sym_this] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_undefined] = ACTIONS(2505),
    [anon_sym_AT] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2505),
    [anon_sym_readonly] = ACTIONS(2505),
    [anon_sym_get] = ACTIONS(2505),
    [anon_sym_set] = ACTIONS(2505),
    [anon_sym_declare] = ACTIONS(2505),
    [anon_sym_public] = ACTIONS(2505),
    [anon_sym_private] = ACTIONS(2505),
    [anon_sym_protected] = ACTIONS(2505),
    [anon_sym_override] = ACTIONS(2505),
    [anon_sym_module] = ACTIONS(2505),
    [anon_sym_any] = ACTIONS(2505),
    [anon_sym_number] = ACTIONS(2505),
    [anon_sym_boolean] = ACTIONS(2505),
    [anon_sym_string] = ACTIONS(2505),
    [anon_sym_symbol] = ACTIONS(2505),
    [anon_sym_abstract] = ACTIONS(2505),
    [anon_sym_interface] = ACTIONS(2505),
    [anon_sym_enum] = ACTIONS(2505),
  },
  [791] = {
    [sym_identifier] = ACTIONS(2517),
    [anon_sym_export] = ACTIONS(2517),
    [anon_sym_type] = ACTIONS(2517),
    [anon_sym_namespace] = ACTIONS(2517),
    [anon_sym_LBRACE] = ACTIONS(2519),
    [anon_sym_typeof] = ACTIONS(2517),
    [anon_sym_import] = ACTIONS(2517),
    [anon_sym_var] = ACTIONS(2517),
    [anon_sym_let] = ACTIONS(2517),
    [anon_sym_const] = ACTIONS(2517),
    [anon_sym_BANG] = ACTIONS(2519),
    [anon_sym_if] = ACTIONS(2517),
    [anon_sym_switch] = ACTIONS(2517),
    [anon_sym_for] = ACTIONS(2517),
    [anon_sym_LPAREN] = ACTIONS(2519),
    [anon_sym_await] = ACTIONS(2517),
    [anon_sym_while] = ACTIONS(2517),
    [anon_sym_do] = ACTIONS(2517),
    [anon_sym_try] = ACTIONS(2517),
    [anon_sym_with] = ACTIONS(2517),
    [anon_sym_break] = ACTIONS(2517),
    [anon_sym_continue] = ACTIONS(2517),
    [anon_sym_debugger] = ACTIONS(2517),
    [anon_sym_return] = ACTIONS(2517),
    [anon_sym_throw] = ACTIONS(2517),
    [anon_sym_SEMI] = ACTIONS(2519),
    [anon_sym_yield] = ACTIONS(2517),
    [anon_sym_LBRACK] = ACTIONS(2519),
    [anon_sym_LTtemplate_GT] = ACTIONS(2519),
    [anon_sym_class] = ACTIONS(2517),
    [anon_sym_async] = ACTIONS(2517),
    [anon_sym_function] = ACTIONS(2517),
    [anon_sym_new] = ACTIONS(2517),
    [anon_sym_PLUS] = ACTIONS(2517),
    [anon_sym_DASH] = ACTIONS(2517),
    [anon_sym_SLASH] = ACTIONS(2517),
    [anon_sym_LT] = ACTIONS(2517),
    [anon_sym_TILDE] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(2517),
    [anon_sym_delete] = ACTIONS(2517),
    [anon_sym_PLUS_PLUS] = ACTIONS(2519),
    [anon_sym_DASH_DASH] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2519),
    [anon_sym_SQUOTE] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2519),
    [sym_number] = ACTIONS(2519),
    [sym_this] = ACTIONS(2517),
    [sym_super] = ACTIONS(2517),
    [sym_true] = ACTIONS(2517),
    [sym_false] = ACTIONS(2517),
    [sym_null] = ACTIONS(2517),
    [sym_undefined] = ACTIONS(2517),
    [anon_sym_AT] = ACTIONS(2519),
    [anon_sym_static] = ACTIONS(2517),
    [anon_sym_readonly] = ACTIONS(2517),
    [anon_sym_get] = ACTIONS(2517),
    [anon_sym_set] = ACTIONS(2517),
    [anon_sym_declare] = ACTIONS(2517),
    [anon_sym_public] = ACTIONS(2517),
    [anon_sym_private] = ACTIONS(2517),
    [anon_sym_protected] = ACTIONS(2517),
    [anon_sym_override] = ACTIONS(2517),
    [anon_sym_module] = ACTIONS(2517),
    [anon_sym_any] = ACTIONS(2517),
    [anon_sym_number] = ACTIONS(2517),
    [anon_sym_boolean] = ACTIONS(2517),
    [anon_sym_string] = ACTIONS(2517),
    [anon_sym_symbol] = ACTIONS(2517),
    [anon_sym_abstract] = ACTIONS(2517),
    [anon_sym_interface] = ACTIONS(2517),
    [anon_sym_enum] = ACTIONS(2517),
  },
  [792] = {
    [sym_identifier] = ACTIONS(2521),
    [anon_sym_export] = ACTIONS(2521),
    [anon_sym_type] = ACTIONS(2521),
    [anon_sym_namespace] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(2523),
    [anon_sym_typeof] = ACTIONS(2521),
    [anon_sym_import] = ACTIONS(2521),
    [anon_sym_var] = ACTIONS(2521),
    [anon_sym_let] = ACTIONS(2521),
    [anon_sym_const] = ACTIONS(2521),
    [anon_sym_BANG] = ACTIONS(2523),
    [anon_sym_if] = ACTIONS(2521),
    [anon_sym_switch] = ACTIONS(2521),
    [anon_sym_for] = ACTIONS(2521),
    [anon_sym_LPAREN] = ACTIONS(2523),
    [anon_sym_await] = ACTIONS(2521),
    [anon_sym_while] = ACTIONS(2521),
    [anon_sym_do] = ACTIONS(2521),
    [anon_sym_try] = ACTIONS(2521),
    [anon_sym_with] = ACTIONS(2521),
    [anon_sym_break] = ACTIONS(2521),
    [anon_sym_continue] = ACTIONS(2521),
    [anon_sym_debugger] = ACTIONS(2521),
    [anon_sym_return] = ACTIONS(2521),
    [anon_sym_throw] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2523),
    [anon_sym_yield] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_LTtemplate_GT] = ACTIONS(2523),
    [anon_sym_class] = ACTIONS(2521),
    [anon_sym_async] = ACTIONS(2521),
    [anon_sym_function] = ACTIONS(2521),
    [anon_sym_new] = ACTIONS(2521),
    [anon_sym_PLUS] = ACTIONS(2521),
    [anon_sym_DASH] = ACTIONS(2521),
    [anon_sym_SLASH] = ACTIONS(2521),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2523),
    [anon_sym_void] = ACTIONS(2521),
    [anon_sym_delete] = ACTIONS(2521),
    [anon_sym_PLUS_PLUS] = ACTIONS(2523),
    [anon_sym_DASH_DASH] = ACTIONS(2521),
    [anon_sym_DQUOTE] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(2523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2523),
    [sym_number] = ACTIONS(2523),
    [sym_this] = ACTIONS(2521),
    [sym_super] = ACTIONS(2521),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_undefined] = ACTIONS(2521),
    [anon_sym_AT] = ACTIONS(2523),
    [anon_sym_static] = ACTIONS(2521),
    [anon_sym_readonly] = ACTIONS(2521),
    [anon_sym_get] = ACTIONS(2521),
    [anon_sym_set] = ACTIONS(2521),
    [anon_sym_declare] = ACTIONS(2521),
    [anon_sym_public] = ACTIONS(2521),
    [anon_sym_private] = ACTIONS(2521),
    [anon_sym_protected] = ACTIONS(2521),
    [anon_sym_override] = ACTIONS(2521),
    [anon_sym_module] = ACTIONS(2521),
    [anon_sym_any] = ACTIONS(2521),
    [anon_sym_number] = ACTIONS(2521),
    [anon_sym_boolean] = ACTIONS(2521),
    [anon_sym_string] = ACTIONS(2521),
    [anon_sym_symbol] = ACTIONS(2521),
    [anon_sym_abstract] = ACTIONS(2521),
    [anon_sym_interface] = ACTIONS(2521),
    [anon_sym_enum] = ACTIONS(2521),
  },
  [793] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2505),
    [anon_sym_namespace] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2505),
    [anon_sym_import] = ACTIONS(2505),
    [anon_sym_var] = ACTIONS(2505),
    [anon_sym_let] = ACTIONS(2505),
    [anon_sym_const] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2505),
    [anon_sym_switch] = ACTIONS(2505),
    [anon_sym_for] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [anon_sym_await] = ACTIONS(2505),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2505),
    [anon_sym_try] = ACTIONS(2505),
    [anon_sym_with] = ACTIONS(2505),
    [anon_sym_break] = ACTIONS(2505),
    [anon_sym_continue] = ACTIONS(2505),
    [anon_sym_debugger] = ACTIONS(2505),
    [anon_sym_return] = ACTIONS(2505),
    [anon_sym_throw] = ACTIONS(2505),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_LTtemplate_GT] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2505),
    [anon_sym_async] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(2505),
    [anon_sym_new] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_SLASH] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_void] = ACTIONS(2505),
    [anon_sym_delete] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2507),
    [anon_sym_SQUOTE] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [sym_number] = ACTIONS(2507),
    [sym_this] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_undefined] = ACTIONS(2505),
    [anon_sym_AT] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2505),
    [anon_sym_readonly] = ACTIONS(2505),
    [anon_sym_get] = ACTIONS(2505),
    [anon_sym_set] = ACTIONS(2505),
    [anon_sym_declare] = ACTIONS(2505),
    [anon_sym_public] = ACTIONS(2505),
    [anon_sym_private] = ACTIONS(2505),
    [anon_sym_protected] = ACTIONS(2505),
    [anon_sym_override] = ACTIONS(2505),
    [anon_sym_module] = ACTIONS(2505),
    [anon_sym_any] = ACTIONS(2505),
    [anon_sym_number] = ACTIONS(2505),
    [anon_sym_boolean] = ACTIONS(2505),
    [anon_sym_string] = ACTIONS(2505),
    [anon_sym_symbol] = ACTIONS(2505),
    [anon_sym_abstract] = ACTIONS(2505),
    [anon_sym_interface] = ACTIONS(2505),
    [anon_sym_enum] = ACTIONS(2505),
  },
  [794] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2505),
    [anon_sym_namespace] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2505),
    [anon_sym_import] = ACTIONS(2505),
    [anon_sym_var] = ACTIONS(2505),
    [anon_sym_let] = ACTIONS(2505),
    [anon_sym_const] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2505),
    [anon_sym_switch] = ACTIONS(2505),
    [anon_sym_for] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [anon_sym_await] = ACTIONS(2505),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2505),
    [anon_sym_try] = ACTIONS(2505),
    [anon_sym_with] = ACTIONS(2505),
    [anon_sym_break] = ACTIONS(2505),
    [anon_sym_continue] = ACTIONS(2505),
    [anon_sym_debugger] = ACTIONS(2505),
    [anon_sym_return] = ACTIONS(2505),
    [anon_sym_throw] = ACTIONS(2505),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_LTtemplate_GT] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2505),
    [anon_sym_async] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(2505),
    [anon_sym_new] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_SLASH] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_void] = ACTIONS(2505),
    [anon_sym_delete] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2507),
    [anon_sym_SQUOTE] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [sym_number] = ACTIONS(2507),
    [sym_this] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_undefined] = ACTIONS(2505),
    [anon_sym_AT] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2505),
    [anon_sym_readonly] = ACTIONS(2505),
    [anon_sym_get] = ACTIONS(2505),
    [anon_sym_set] = ACTIONS(2505),
    [anon_sym_declare] = ACTIONS(2505),
    [anon_sym_public] = ACTIONS(2505),
    [anon_sym_private] = ACTIONS(2505),
    [anon_sym_protected] = ACTIONS(2505),
    [anon_sym_override] = ACTIONS(2505),
    [anon_sym_module] = ACTIONS(2505),
    [anon_sym_any] = ACTIONS(2505),
    [anon_sym_number] = ACTIONS(2505),
    [anon_sym_boolean] = ACTIONS(2505),
    [anon_sym_string] = ACTIONS(2505),
    [anon_sym_symbol] = ACTIONS(2505),
    [anon_sym_abstract] = ACTIONS(2505),
    [anon_sym_interface] = ACTIONS(2505),
    [anon_sym_enum] = ACTIONS(2505),
  },
  [795] = {
    [sym_identifier] = ACTIONS(2525),
    [anon_sym_export] = ACTIONS(2525),
    [anon_sym_type] = ACTIONS(2525),
    [anon_sym_namespace] = ACTIONS(2525),
    [anon_sym_LBRACE] = ACTIONS(2527),
    [anon_sym_typeof] = ACTIONS(2525),
    [anon_sym_import] = ACTIONS(2525),
    [anon_sym_var] = ACTIONS(2525),
    [anon_sym_let] = ACTIONS(2525),
    [anon_sym_const] = ACTIONS(2525),
    [anon_sym_BANG] = ACTIONS(2527),
    [anon_sym_if] = ACTIONS(2525),
    [anon_sym_switch] = ACTIONS(2525),
    [anon_sym_for] = ACTIONS(2525),
    [anon_sym_LPAREN] = ACTIONS(2527),
    [anon_sym_await] = ACTIONS(2525),
    [anon_sym_while] = ACTIONS(2525),
    [anon_sym_do] = ACTIONS(2525),
    [anon_sym_try] = ACTIONS(2525),
    [anon_sym_with] = ACTIONS(2525),
    [anon_sym_break] = ACTIONS(2525),
    [anon_sym_continue] = ACTIONS(2525),
    [anon_sym_debugger] = ACTIONS(2525),
    [anon_sym_return] = ACTIONS(2525),
    [anon_sym_throw] = ACTIONS(2525),
    [anon_sym_SEMI] = ACTIONS(2527),
    [anon_sym_yield] = ACTIONS(2525),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_LTtemplate_GT] = ACTIONS(2527),
    [anon_sym_class] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(2525),
    [anon_sym_function] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2525),
    [anon_sym_PLUS] = ACTIONS(2525),
    [anon_sym_DASH] = ACTIONS(2525),
    [anon_sym_SLASH] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_TILDE] = ACTIONS(2527),
    [anon_sym_void] = ACTIONS(2525),
    [anon_sym_delete] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2527),
    [anon_sym_DASH_DASH] = ACTIONS(2525),
    [anon_sym_DQUOTE] = ACTIONS(2527),
    [anon_sym_SQUOTE] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2527),
    [sym_number] = ACTIONS(2527),
    [sym_this] = ACTIONS(2525),
    [sym_super] = ACTIONS(2525),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_undefined] = ACTIONS(2525),
    [anon_sym_AT] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2525),
    [anon_sym_readonly] = ACTIONS(2525),
    [anon_sym_get] = ACTIONS(2525),
    [anon_sym_set] = ACTIONS(2525),
    [anon_sym_declare] = ACTIONS(2525),
    [anon_sym_public] = ACTIONS(2525),
    [anon_sym_private] = ACTIONS(2525),
    [anon_sym_protected] = ACTIONS(2525),
    [anon_sym_override] = ACTIONS(2525),
    [anon_sym_module] = ACTIONS(2525),
    [anon_sym_any] = ACTIONS(2525),
    [anon_sym_number] = ACTIONS(2525),
    [anon_sym_boolean] = ACTIONS(2525),
    [anon_sym_string] = ACTIONS(2525),
    [anon_sym_symbol] = ACTIONS(2525),
    [anon_sym_abstract] = ACTIONS(2525),
    [anon_sym_interface] = ACTIONS(2525),
    [anon_sym_enum] = ACTIONS(2525),
  },
  [796] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2505),
    [anon_sym_namespace] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2505),
    [anon_sym_import] = ACTIONS(2505),
    [anon_sym_var] = ACTIONS(2505),
    [anon_sym_let] = ACTIONS(2505),
    [anon_sym_const] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2505),
    [anon_sym_switch] = ACTIONS(2505),
    [anon_sym_for] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [anon_sym_await] = ACTIONS(2505),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2505),
    [anon_sym_try] = ACTIONS(2505),
    [anon_sym_with] = ACTIONS(2505),
    [anon_sym_break] = ACTIONS(2505),
    [anon_sym_continue] = ACTIONS(2505),
    [anon_sym_debugger] = ACTIONS(2505),
    [anon_sym_return] = ACTIONS(2505),
    [anon_sym_throw] = ACTIONS(2505),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_LTtemplate_GT] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2505),
    [anon_sym_async] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(2505),
    [anon_sym_new] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_SLASH] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_void] = ACTIONS(2505),
    [anon_sym_delete] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2507),
    [anon_sym_SQUOTE] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [sym_number] = ACTIONS(2507),
    [sym_this] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_undefined] = ACTIONS(2505),
    [anon_sym_AT] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2505),
    [anon_sym_readonly] = ACTIONS(2505),
    [anon_sym_get] = ACTIONS(2505),
    [anon_sym_set] = ACTIONS(2505),
    [anon_sym_declare] = ACTIONS(2505),
    [anon_sym_public] = ACTIONS(2505),
    [anon_sym_private] = ACTIONS(2505),
    [anon_sym_protected] = ACTIONS(2505),
    [anon_sym_override] = ACTIONS(2505),
    [anon_sym_module] = ACTIONS(2505),
    [anon_sym_any] = ACTIONS(2505),
    [anon_sym_number] = ACTIONS(2505),
    [anon_sym_boolean] = ACTIONS(2505),
    [anon_sym_string] = ACTIONS(2505),
    [anon_sym_symbol] = ACTIONS(2505),
    [anon_sym_abstract] = ACTIONS(2505),
    [anon_sym_interface] = ACTIONS(2505),
    [anon_sym_enum] = ACTIONS(2505),
  },
  [797] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2505),
    [anon_sym_namespace] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2505),
    [anon_sym_import] = ACTIONS(2505),
    [anon_sym_var] = ACTIONS(2505),
    [anon_sym_let] = ACTIONS(2505),
    [anon_sym_const] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2505),
    [anon_sym_switch] = ACTIONS(2505),
    [anon_sym_for] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [anon_sym_await] = ACTIONS(2505),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2505),
    [anon_sym_try] = ACTIONS(2505),
    [anon_sym_with] = ACTIONS(2505),
    [anon_sym_break] = ACTIONS(2505),
    [anon_sym_continue] = ACTIONS(2505),
    [anon_sym_debugger] = ACTIONS(2505),
    [anon_sym_return] = ACTIONS(2505),
    [anon_sym_throw] = ACTIONS(2505),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_LTtemplate_GT] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2505),
    [anon_sym_async] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(2505),
    [anon_sym_new] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_SLASH] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_void] = ACTIONS(2505),
    [anon_sym_delete] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2507),
    [anon_sym_SQUOTE] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [sym_number] = ACTIONS(2507),
    [sym_this] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_undefined] = ACTIONS(2505),
    [anon_sym_AT] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2505),
    [anon_sym_readonly] = ACTIONS(2505),
    [anon_sym_get] = ACTIONS(2505),
    [anon_sym_set] = ACTIONS(2505),
    [anon_sym_declare] = ACTIONS(2505),
    [anon_sym_public] = ACTIONS(2505),
    [anon_sym_private] = ACTIONS(2505),
    [anon_sym_protected] = ACTIONS(2505),
    [anon_sym_override] = ACTIONS(2505),
    [anon_sym_module] = ACTIONS(2505),
    [anon_sym_any] = ACTIONS(2505),
    [anon_sym_number] = ACTIONS(2505),
    [anon_sym_boolean] = ACTIONS(2505),
    [anon_sym_string] = ACTIONS(2505),
    [anon_sym_symbol] = ACTIONS(2505),
    [anon_sym_abstract] = ACTIONS(2505),
    [anon_sym_interface] = ACTIONS(2505),
    [anon_sym_enum] = ACTIONS(2505),
  },
  [798] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym_asserts] = STATE(3033),
    [sym__type] = STATE(2695),
    [sym_constructor_type] = STATE(2695),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2695),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_predicate] = STATE(3031),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2587),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2695),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2695),
    [sym_identifier] = ACTIONS(2529),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(2533),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_asserts] = ACTIONS(2535),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [799] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym_asserts] = STATE(1756),
    [sym__type] = STATE(1755),
    [sym_constructor_type] = STATE(1755),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1755),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_predicate] = STATE(1756),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1613),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1755),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1755),
    [sym_identifier] = ACTIONS(2537),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2565),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_asserts] = ACTIONS(2575),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [800] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym_asserts] = STATE(1378),
    [sym__type] = STATE(1370),
    [sym_constructor_type] = STATE(1370),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1370),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_predicate] = STATE(1378),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1234),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1370),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1370),
    [sym_identifier] = ACTIONS(2585),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2613),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_asserts] = ACTIONS(2623),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [801] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym_asserts] = STATE(2404),
    [sym__type] = STATE(2523),
    [sym_constructor_type] = STATE(2523),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2523),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_predicate] = STATE(2404),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2446),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2523),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2523),
    [sym_identifier] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(2635),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_asserts] = ACTIONS(2637),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [802] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym_asserts] = STATE(2739),
    [sym__type] = STATE(2740),
    [sym_constructor_type] = STATE(2740),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2740),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_predicate] = STATE(2739),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2694),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2740),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2740),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2671),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_asserts] = ACTIONS(2681),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [803] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym_asserts] = STATE(2404),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3067),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_predicate] = STATE(2404),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2875),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3067),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3067),
    [sym_identifier] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(2703),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_asserts] = ACTIONS(2711),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [804] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym_asserts] = STATE(1270),
    [sym__type] = STATE(1282),
    [sym_constructor_type] = STATE(1282),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1282),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_predicate] = STATE(1270),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1234),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1282),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1282),
    [sym_identifier] = ACTIONS(2585),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2613),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_asserts] = ACTIONS(2623),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [805] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym_asserts] = STATE(2672),
    [sym__type] = STATE(2670),
    [sym_constructor_type] = STATE(2670),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2670),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_predicate] = STATE(2672),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2587),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2670),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2670),
    [sym_identifier] = ACTIONS(2529),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(2533),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_asserts] = ACTIONS(2535),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [806] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym_asserts] = STATE(3199),
    [sym__type] = STATE(2823),
    [sym_constructor_type] = STATE(2823),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2823),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_predicate] = STATE(3133),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2694),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2823),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2823),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2671),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_asserts] = ACTIONS(2681),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [807] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym_asserts] = STATE(2641),
    [sym__type] = STATE(2642),
    [sym_constructor_type] = STATE(2642),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2642),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_predicate] = STATE(2641),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2587),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2642),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2642),
    [sym_identifier] = ACTIONS(2529),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(2533),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_asserts] = ACTIONS(2535),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [808] = {
    [sym_identifier] = ACTIONS(2719),
    [anon_sym_export] = ACTIONS(2719),
    [anon_sym_type] = ACTIONS(2719),
    [anon_sym_EQ] = ACTIONS(2719),
    [anon_sym_namespace] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2721),
    [anon_sym_RBRACE] = ACTIONS(2721),
    [anon_sym_typeof] = ACTIONS(2719),
    [anon_sym_import] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2721),
    [anon_sym_RPAREN] = ACTIONS(2721),
    [anon_sym_await] = ACTIONS(2719),
    [anon_sym_COLON] = ACTIONS(2721),
    [anon_sym_yield] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [anon_sym_RBRACK] = ACTIONS(2721),
    [anon_sym_LTtemplate_GT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_DOT] = ACTIONS(2719),
    [anon_sym_class] = ACTIONS(2719),
    [anon_sym_async] = ACTIONS(2719),
    [anon_sym_function] = ACTIONS(2719),
    [anon_sym_EQ_GT] = ACTIONS(2721),
    [anon_sym_QMARK_DOT] = ACTIONS(2721),
    [anon_sym_new] = ACTIONS(2719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2719),
    [anon_sym_SLASH] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2719),
    [anon_sym_TILDE] = ACTIONS(2721),
    [anon_sym_void] = ACTIONS(2719),
    [anon_sym_delete] = ACTIONS(2719),
    [anon_sym_PLUS_PLUS] = ACTIONS(2721),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2721),
    [anon_sym_SQUOTE] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2721),
    [sym_number] = ACTIONS(2721),
    [sym_this] = ACTIONS(2719),
    [sym_super] = ACTIONS(2719),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [sym_null] = ACTIONS(2719),
    [sym_undefined] = ACTIONS(2719),
    [anon_sym_AT] = ACTIONS(2721),
    [anon_sym_static] = ACTIONS(2719),
    [anon_sym_readonly] = ACTIONS(2719),
    [anon_sym_get] = ACTIONS(2719),
    [anon_sym_set] = ACTIONS(2719),
    [anon_sym_QMARK] = ACTIONS(2719),
    [anon_sym_declare] = ACTIONS(2719),
    [anon_sym_public] = ACTIONS(2719),
    [anon_sym_private] = ACTIONS(2719),
    [anon_sym_protected] = ACTIONS(2719),
    [anon_sym_override] = ACTIONS(2719),
    [anon_sym_module] = ACTIONS(2719),
    [anon_sym_any] = ACTIONS(2719),
    [anon_sym_number] = ACTIONS(2719),
    [anon_sym_boolean] = ACTIONS(2719),
    [anon_sym_string] = ACTIONS(2719),
    [anon_sym_symbol] = ACTIONS(2719),
    [anon_sym_abstract] = ACTIONS(2719),
    [anon_sym_extends] = ACTIONS(2719),
  },
  [809] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym_asserts] = STATE(2420),
    [sym__type] = STATE(3087),
    [sym_constructor_type] = STATE(3087),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3087),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_predicate] = STATE(2420),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2875),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3087),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3087),
    [sym_identifier] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(2703),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_asserts] = ACTIONS(2711),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [810] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym_asserts] = STATE(3925),
    [sym__type] = STATE(2717),
    [sym_constructor_type] = STATE(2717),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2717),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_predicate] = STATE(3928),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2446),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2717),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2717),
    [sym_identifier] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(2635),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_asserts] = ACTIONS(2637),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [811] = {
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_export] = ACTIONS(2723),
    [anon_sym_type] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_typeof] = ACTIONS(2723),
    [anon_sym_import] = ACTIONS(2723),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_await] = ACTIONS(2723),
    [anon_sym_COLON] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_RBRACK] = ACTIONS(2725),
    [anon_sym_LTtemplate_GT] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_async] = ACTIONS(2723),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_EQ_GT] = ACTIONS(2725),
    [anon_sym_QMARK_DOT] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2725),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_SLASH] = ACTIONS(2723),
    [anon_sym_LT] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_void] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_DASH_DASH] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2725),
    [sym_number] = ACTIONS(2725),
    [sym_this] = ACTIONS(2723),
    [sym_super] = ACTIONS(2723),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [sym_null] = ACTIONS(2723),
    [sym_undefined] = ACTIONS(2723),
    [anon_sym_AT] = ACTIONS(2725),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_readonly] = ACTIONS(2723),
    [anon_sym_get] = ACTIONS(2723),
    [anon_sym_set] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_declare] = ACTIONS(2723),
    [anon_sym_public] = ACTIONS(2723),
    [anon_sym_private] = ACTIONS(2723),
    [anon_sym_protected] = ACTIONS(2723),
    [anon_sym_override] = ACTIONS(2723),
    [anon_sym_module] = ACTIONS(2723),
    [anon_sym_any] = ACTIONS(2723),
    [anon_sym_number] = ACTIONS(2723),
    [anon_sym_boolean] = ACTIONS(2723),
    [anon_sym_string] = ACTIONS(2723),
    [anon_sym_symbol] = ACTIONS(2723),
    [anon_sym_abstract] = ACTIONS(2723),
    [anon_sym_extends] = ACTIONS(2723),
  },
  [812] = {
    [sym_identifier] = ACTIONS(2727),
    [anon_sym_export] = ACTIONS(2727),
    [anon_sym_type] = ACTIONS(2727),
    [anon_sym_EQ] = ACTIONS(2727),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_typeof] = ACTIONS(2727),
    [anon_sym_import] = ACTIONS(2727),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_await] = ACTIONS(2727),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_yield] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_RBRACK] = ACTIONS(2729),
    [anon_sym_LTtemplate_GT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_async] = ACTIONS(2727),
    [anon_sym_function] = ACTIONS(2727),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_QMARK_DOT] = ACTIONS(2729),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_SLASH] = ACTIONS(2727),
    [anon_sym_LT] = ACTIONS(2727),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_void] = ACTIONS(2727),
    [anon_sym_delete] = ACTIONS(2727),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2727),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2729),
    [sym_number] = ACTIONS(2729),
    [sym_this] = ACTIONS(2727),
    [sym_super] = ACTIONS(2727),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [sym_null] = ACTIONS(2727),
    [sym_undefined] = ACTIONS(2727),
    [anon_sym_AT] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_readonly] = ACTIONS(2727),
    [anon_sym_get] = ACTIONS(2727),
    [anon_sym_set] = ACTIONS(2727),
    [anon_sym_QMARK] = ACTIONS(2727),
    [anon_sym_declare] = ACTIONS(2727),
    [anon_sym_public] = ACTIONS(2727),
    [anon_sym_private] = ACTIONS(2727),
    [anon_sym_protected] = ACTIONS(2727),
    [anon_sym_override] = ACTIONS(2727),
    [anon_sym_module] = ACTIONS(2727),
    [anon_sym_any] = ACTIONS(2727),
    [anon_sym_number] = ACTIONS(2727),
    [anon_sym_boolean] = ACTIONS(2727),
    [anon_sym_string] = ACTIONS(2727),
    [anon_sym_symbol] = ACTIONS(2727),
    [anon_sym_abstract] = ACTIONS(2727),
    [anon_sym_extends] = ACTIONS(2727),
  },
  [813] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym_asserts] = STATE(2770),
    [sym__type] = STATE(2771),
    [sym_constructor_type] = STATE(2771),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2771),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_predicate] = STATE(2770),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2694),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2771),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2771),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2671),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_asserts] = ACTIONS(2681),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [814] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym_asserts] = STATE(1723),
    [sym__type] = STATE(1722),
    [sym_constructor_type] = STATE(1722),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1722),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_predicate] = STATE(1723),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1613),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1722),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1722),
    [sym_identifier] = ACTIONS(2537),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2565),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_asserts] = ACTIONS(2575),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [815] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym_asserts] = STATE(2420),
    [sym__type] = STATE(2515),
    [sym_constructor_type] = STATE(2515),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2515),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_predicate] = STATE(2420),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2446),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2515),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2515),
    [sym_identifier] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(2635),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_asserts] = ACTIONS(2637),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [816] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2960),
    [sym_constructor_type] = STATE(2960),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2960),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_type_parameter] = STATE(3611),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2960),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2960),
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_const] = ACTIONS(2733),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [817] = {
    [sym_nested_identifier] = STATE(132),
    [sym_string] = STATE(138),
    [sym__module] = STATE(150),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [818] = {
    [sym_nested_identifier] = STATE(595),
    [sym_string] = STATE(621),
    [sym__module] = STATE(645),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(2741),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [819] = {
    [sym_nested_identifier] = STATE(595),
    [sym_string] = STATE(621),
    [sym__module] = STATE(645),
    [aux_sym_object_repeat1] = STATE(3660),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(2741),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [820] = {
    [sym_nested_identifier] = STATE(132),
    [sym_string] = STATE(138),
    [sym__module] = STATE(150),
    [aux_sym_object_repeat1] = STATE(3660),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [821] = {
    [sym_nested_identifier] = STATE(132),
    [sym_string] = STATE(138),
    [sym__module] = STATE(150),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [822] = {
    [sym_nested_identifier] = STATE(595),
    [sym_string] = STATE(621),
    [sym__module] = STATE(645),
    [aux_sym_object_repeat1] = STATE(3679),
    [aux_sym_object_pattern_repeat1] = STATE(3661),
    [sym_identifier] = ACTIONS(2741),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(149),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [823] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2743),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [824] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2745),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [825] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [826] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3451),
    [sym_constructor_type] = STATE(3451),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3451),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3451),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3451),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2749),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [827] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [828] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [829] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [830] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3395),
    [sym_constructor_type] = STATE(3395),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3395),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3395),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3395),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2757),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [831] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1651),
    [sym_constructor_type] = STATE(1651),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1651),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1651),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1651),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_const] = ACTIONS(2761),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [832] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3488),
    [sym_constructor_type] = STATE(3488),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3488),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3488),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3488),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2765),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [833] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [834] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3457),
    [sym_constructor_type] = STATE(3457),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3457),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3457),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3457),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [835] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2771),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [836] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3372),
    [sym_constructor_type] = STATE(3372),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3372),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3372),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3372),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(2773),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [837] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2775),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [838] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1297),
    [sym_constructor_type] = STATE(1297),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1297),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1297),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1297),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [839] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [840] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [841] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(2787),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [842] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2743),
    [sym_constructor_type] = STATE(2743),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2743),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2743),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2743),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [843] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(3561),
    [sym_constructor_type] = STATE(3561),
    [sym__primary_type] = STATE(1794),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(3561),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(3561),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(3561),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [844] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1335),
    [sym_constructor_type] = STATE(1335),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1335),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1335),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1335),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [845] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3162),
    [sym_constructor_type] = STATE(3162),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3162),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3162),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3162),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [846] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2504),
    [sym_constructor_type] = STATE(2504),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2504),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2504),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2504),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [847] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1364),
    [sym_constructor_type] = STATE(1364),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1364),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1364),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1364),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [848] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1277),
    [sym_constructor_type] = STATE(1277),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1277),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1277),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1277),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [849] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3423),
    [sym_constructor_type] = STATE(3423),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3423),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3423),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3423),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [850] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1369),
    [sym_constructor_type] = STATE(1369),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1369),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1369),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1369),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [851] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(3064),
    [sym_constructor_type] = STATE(3064),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3064),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3064),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3064),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [852] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3473),
    [sym_constructor_type] = STATE(3473),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3473),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3473),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3473),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [853] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1339),
    [sym_constructor_type] = STATE(1339),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1339),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1339),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1339),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [854] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(3219),
    [sym_constructor_type] = STATE(3219),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3219),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3219),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3219),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [855] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(3692),
    [sym_constructor_type] = STATE(3692),
    [sym__primary_type] = STATE(2498),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3692),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3692),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3692),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [856] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(3100),
    [sym_constructor_type] = STATE(3100),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(3100),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(3100),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(3100),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [857] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3375),
    [sym_constructor_type] = STATE(3375),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3375),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3375),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3375),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [858] = {
    [sym_export_statement] = STATE(2998),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3542),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3542),
    [sym_pair] = STATE(3542),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2998),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2998),
    [sym_property_signature] = STATE(2998),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2998),
    [sym_index_signature] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3543),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2795),
    [anon_sym_export] = ACTIONS(2797),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2795),
    [anon_sym_namespace] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2805),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_readonly] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2825),
    [anon_sym_set] = ACTIONS(2825),
    [anon_sym_declare] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(2827),
    [anon_sym_private] = ACTIONS(2827),
    [anon_sym_protected] = ACTIONS(2827),
    [anon_sym_override] = ACTIONS(2829),
    [anon_sym_module] = ACTIONS(2795),
    [anon_sym_any] = ACTIONS(2795),
    [anon_sym_number] = ACTIONS(2795),
    [anon_sym_boolean] = ACTIONS(2795),
    [anon_sym_string] = ACTIONS(2795),
    [anon_sym_symbol] = ACTIONS(2795),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2833),
  },
  [859] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2960),
    [sym_constructor_type] = STATE(2960),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2960),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2960),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2960),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [860] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1266),
    [sym_constructor_type] = STATE(1266),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1266),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1266),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1266),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [861] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1337),
    [sym_constructor_type] = STATE(1337),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1337),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1337),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1337),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [862] = {
    [sym_export_statement] = STATE(2998),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3683),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2998),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2998),
    [sym_property_signature] = STATE(2998),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2998),
    [sym_index_signature] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2835),
    [anon_sym_namespace] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2839),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_readonly] = ACTIONS(2845),
    [anon_sym_get] = ACTIONS(2847),
    [anon_sym_set] = ACTIONS(2847),
    [anon_sym_declare] = ACTIONS(2835),
    [anon_sym_public] = ACTIONS(2849),
    [anon_sym_private] = ACTIONS(2849),
    [anon_sym_protected] = ACTIONS(2849),
    [anon_sym_override] = ACTIONS(2851),
    [anon_sym_module] = ACTIONS(2835),
    [anon_sym_any] = ACTIONS(2835),
    [anon_sym_number] = ACTIONS(2835),
    [anon_sym_boolean] = ACTIONS(2835),
    [anon_sym_string] = ACTIONS(2835),
    [anon_sym_symbol] = ACTIONS(2835),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2833),
  },
  [863] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3068),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3068),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3068),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [864] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3377),
    [sym_constructor_type] = STATE(3377),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3377),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3377),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3377),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [865] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2826),
    [sym_constructor_type] = STATE(2826),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2826),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2826),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2826),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [866] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(2417),
    [sym_constructor_type] = STATE(2417),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2417),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2417),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [867] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1284),
    [sym_constructor_type] = STATE(1284),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1284),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1284),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1284),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [868] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2827),
    [sym_constructor_type] = STATE(2827),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2827),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2827),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2827),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [869] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2519),
    [sym_constructor_type] = STATE(2519),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2519),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2519),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2519),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [870] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(2454),
    [sym_constructor_type] = STATE(2454),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2454),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2454),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2454),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [871] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(2413),
    [sym_constructor_type] = STATE(2413),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2413),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2413),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2413),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [872] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2518),
    [sym_constructor_type] = STATE(2518),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2518),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2518),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2518),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [873] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(3692),
    [sym_constructor_type] = STATE(3692),
    [sym__primary_type] = STATE(2496),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3692),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3692),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3692),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [874] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3036),
    [sym_constructor_type] = STATE(3036),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3036),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3036),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3036),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [875] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3378),
    [sym_constructor_type] = STATE(3378),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3378),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3378),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3378),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [876] = {
    [sym_export_statement] = STATE(2998),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3683),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2998),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2998),
    [sym_property_signature] = STATE(2998),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2998),
    [sym_index_signature] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2853),
    [anon_sym_export] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2853),
    [anon_sym_namespace] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2859),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_readonly] = ACTIONS(2863),
    [anon_sym_get] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(2865),
    [anon_sym_declare] = ACTIONS(2853),
    [anon_sym_public] = ACTIONS(2867),
    [anon_sym_private] = ACTIONS(2867),
    [anon_sym_protected] = ACTIONS(2867),
    [anon_sym_override] = ACTIONS(2869),
    [anon_sym_module] = ACTIONS(2853),
    [anon_sym_any] = ACTIONS(2853),
    [anon_sym_number] = ACTIONS(2853),
    [anon_sym_boolean] = ACTIONS(2853),
    [anon_sym_string] = ACTIONS(2853),
    [anon_sym_symbol] = ACTIONS(2853),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2833),
  },
  [877] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3390),
    [sym_constructor_type] = STATE(3390),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3390),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3390),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3390),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [878] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2675),
    [sym_constructor_type] = STATE(2675),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2675),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2675),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2675),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [879] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2674),
    [sym_constructor_type] = STATE(2674),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2674),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2674),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2674),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [880] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3434),
    [sym_constructor_type] = STATE(3434),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3434),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3434),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3434),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [881] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3433),
    [sym_constructor_type] = STATE(3433),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3433),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3433),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3433),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [882] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2669),
    [sym_constructor_type] = STATE(2669),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2669),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2669),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2669),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [883] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3394),
    [sym_constructor_type] = STATE(3394),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3394),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3394),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3394),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [884] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3487),
    [sym_constructor_type] = STATE(3487),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3487),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3487),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3487),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [885] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1626),
    [sym_constructor_type] = STATE(1626),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1626),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1626),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1626),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [886] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3475),
    [sym_constructor_type] = STATE(3475),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3475),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3475),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3475),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [887] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(3065),
    [sym_constructor_type] = STATE(3065),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3065),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3065),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3065),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [888] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2668),
    [sym_constructor_type] = STATE(2668),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2668),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2668),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2668),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [889] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2992),
    [sym_constructor_type] = STATE(2992),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2992),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2992),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2992),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [890] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2517),
    [sym_constructor_type] = STATE(2517),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2517),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2517),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2517),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [891] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(3077),
    [sym_constructor_type] = STATE(3077),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3077),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3077),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3077),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [892] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1625),
    [sym_constructor_type] = STATE(1625),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1625),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1625),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1625),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [893] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2695),
    [sym_constructor_type] = STATE(2695),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2695),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2695),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2695),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [894] = {
    [sym_export_statement] = STATE(2998),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3542),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3542),
    [sym_pair] = STATE(3542),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2998),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2998),
    [sym_property_signature] = STATE(2998),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2998),
    [sym_index_signature] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3543),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2795),
    [anon_sym_export] = ACTIONS(2797),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2795),
    [anon_sym_namespace] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_readonly] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2825),
    [anon_sym_set] = ACTIONS(2825),
    [anon_sym_declare] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(2827),
    [anon_sym_private] = ACTIONS(2827),
    [anon_sym_protected] = ACTIONS(2827),
    [anon_sym_override] = ACTIONS(2829),
    [anon_sym_module] = ACTIONS(2795),
    [anon_sym_any] = ACTIONS(2795),
    [anon_sym_number] = ACTIONS(2795),
    [anon_sym_boolean] = ACTIONS(2795),
    [anon_sym_string] = ACTIONS(2795),
    [anon_sym_symbol] = ACTIONS(2795),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2833),
  },
  [895] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1802),
    [sym_constructor_type] = STATE(1802),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1802),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1802),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1802),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [896] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [897] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(3076),
    [sym_constructor_type] = STATE(3076),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3076),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3076),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3076),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [898] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1801),
    [sym_constructor_type] = STATE(1801),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1801),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1801),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1801),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [899] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2973),
    [sym_constructor_type] = STATE(2973),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2973),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2973),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2973),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [900] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3400),
    [sym_constructor_type] = STATE(3400),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3400),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3400),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3400),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [901] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2661),
    [sym_constructor_type] = STATE(2661),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2661),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2661),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2661),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [902] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(2493),
    [sym_constructor_type] = STATE(2493),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2493),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2493),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2493),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [903] = {
    [sym_export_statement] = STATE(2998),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3683),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2998),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2998),
    [sym_property_signature] = STATE(2998),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2998),
    [sym_index_signature] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2853),
    [anon_sym_export] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2853),
    [anon_sym_namespace] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2859),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_readonly] = ACTIONS(2863),
    [anon_sym_get] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(2865),
    [anon_sym_declare] = ACTIONS(2853),
    [anon_sym_public] = ACTIONS(2867),
    [anon_sym_private] = ACTIONS(2867),
    [anon_sym_protected] = ACTIONS(2867),
    [anon_sym_override] = ACTIONS(2869),
    [anon_sym_module] = ACTIONS(2853),
    [anon_sym_any] = ACTIONS(2853),
    [anon_sym_number] = ACTIONS(2853),
    [anon_sym_boolean] = ACTIONS(2853),
    [anon_sym_string] = ACTIONS(2853),
    [anon_sym_symbol] = ACTIONS(2853),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2833),
  },
  [904] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2643),
    [sym_constructor_type] = STATE(2643),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2643),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2643),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2643),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [905] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2660),
    [sym_constructor_type] = STATE(2660),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2660),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2660),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2660),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [906] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3379),
    [sym_constructor_type] = STATE(3379),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3379),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3379),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3379),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [907] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(3228),
    [sym_constructor_type] = STATE(3228),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(3228),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(3228),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(3228),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [908] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2655),
    [sym_constructor_type] = STATE(2655),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2655),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2655),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2655),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [909] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(2416),
    [sym_constructor_type] = STATE(2416),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2416),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2416),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2416),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [910] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1668),
    [sym_constructor_type] = STATE(1668),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1668),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1668),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1668),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [911] = {
    [sym_export_statement] = STATE(2998),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3683),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2998),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2998),
    [sym_property_signature] = STATE(2998),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2998),
    [sym_index_signature] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2853),
    [anon_sym_export] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2853),
    [anon_sym_namespace] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2859),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_readonly] = ACTIONS(2863),
    [anon_sym_get] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(2865),
    [anon_sym_declare] = ACTIONS(2853),
    [anon_sym_public] = ACTIONS(2867),
    [anon_sym_private] = ACTIONS(2867),
    [anon_sym_protected] = ACTIONS(2867),
    [anon_sym_override] = ACTIONS(2869),
    [anon_sym_module] = ACTIONS(2853),
    [anon_sym_any] = ACTIONS(2853),
    [anon_sym_number] = ACTIONS(2853),
    [anon_sym_boolean] = ACTIONS(2853),
    [anon_sym_string] = ACTIONS(2853),
    [anon_sym_symbol] = ACTIONS(2853),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2833),
  },
  [912] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3456),
    [sym_constructor_type] = STATE(3456),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3456),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3456),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3456),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [913] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2413),
    [sym_constructor_type] = STATE(2413),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2413),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2413),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2413),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [914] = {
    [sym_export_statement] = STATE(2998),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3683),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2998),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2998),
    [sym_property_signature] = STATE(2998),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2998),
    [sym_index_signature] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_export] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2877),
    [anon_sym_namespace] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_readonly] = ACTIONS(2885),
    [anon_sym_get] = ACTIONS(2887),
    [anon_sym_set] = ACTIONS(2887),
    [anon_sym_declare] = ACTIONS(2877),
    [anon_sym_public] = ACTIONS(2889),
    [anon_sym_private] = ACTIONS(2889),
    [anon_sym_protected] = ACTIONS(2889),
    [anon_sym_override] = ACTIONS(2891),
    [anon_sym_module] = ACTIONS(2877),
    [anon_sym_any] = ACTIONS(2877),
    [anon_sym_number] = ACTIONS(2877),
    [anon_sym_boolean] = ACTIONS(2877),
    [anon_sym_string] = ACTIONS(2877),
    [anon_sym_symbol] = ACTIONS(2877),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2833),
  },
  [915] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2653),
    [sym_constructor_type] = STATE(2653),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2653),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2653),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2653),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [916] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1797),
    [sym_constructor_type] = STATE(1797),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1797),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1797),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1797),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [917] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(3086),
    [sym_constructor_type] = STATE(3086),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3086),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3086),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3086),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [918] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3480),
    [sym_constructor_type] = STATE(3480),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3480),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3480),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3480),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [919] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(3561),
    [sym_constructor_type] = STATE(3561),
    [sym__primary_type] = STATE(1796),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(3561),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(3561),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(3561),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [920] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3294),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(3294),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(3294),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(3294),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [921] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(3307),
    [sym_constructor_type] = STATE(3307),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(3307),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(3307),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(3307),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [922] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1671),
    [sym_constructor_type] = STATE(1671),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1671),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1671),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1671),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [923] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3659),
    [sym_constructor_type] = STATE(3659),
    [sym__primary_type] = STATE(3184),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3448),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3659),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3659),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [924] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2803),
    [sym_constructor_type] = STATE(2803),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2803),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2803),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2803),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [925] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3079),
    [sym_constructor_type] = STATE(3079),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3079),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3079),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3079),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [926] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3498),
    [sym_constructor_type] = STATE(3498),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3498),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3498),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3498),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [927] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2454),
    [sym_constructor_type] = STATE(2454),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2454),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2454),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2454),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [928] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2801),
    [sym_constructor_type] = STATE(2801),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2801),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2801),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2801),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [929] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2417),
    [sym_constructor_type] = STATE(2417),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2417),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2417),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2417),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [930] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1362),
    [sym_constructor_type] = STATE(1362),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1362),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1362),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1362),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [931] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1348),
    [sym_constructor_type] = STATE(1348),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1348),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1348),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1348),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [932] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2788),
    [sym_constructor_type] = STATE(2788),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2788),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2788),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2788),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [933] = {
    [sym_export_statement] = STATE(2998),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3683),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2998),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2998),
    [sym_property_signature] = STATE(2998),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2998),
    [sym_index_signature] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2835),
    [anon_sym_namespace] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_readonly] = ACTIONS(2845),
    [anon_sym_get] = ACTIONS(2847),
    [anon_sym_set] = ACTIONS(2847),
    [anon_sym_declare] = ACTIONS(2835),
    [anon_sym_public] = ACTIONS(2849),
    [anon_sym_private] = ACTIONS(2849),
    [anon_sym_protected] = ACTIONS(2849),
    [anon_sym_override] = ACTIONS(2851),
    [anon_sym_module] = ACTIONS(2835),
    [anon_sym_any] = ACTIONS(2835),
    [anon_sym_number] = ACTIONS(2835),
    [anon_sym_boolean] = ACTIONS(2835),
    [anon_sym_string] = ACTIONS(2835),
    [anon_sym_symbol] = ACTIONS(2835),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2833),
  },
  [934] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1694),
    [sym_constructor_type] = STATE(1694),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1694),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1694),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1694),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [935] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1695),
    [sym_constructor_type] = STATE(1695),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1695),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1695),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1695),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [936] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2787),
    [sym_constructor_type] = STATE(2787),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2787),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2787),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2787),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [937] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(3167),
    [sym_constructor_type] = STATE(3167),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(3167),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(3167),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(3167),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [938] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2767),
    [sym_constructor_type] = STATE(2767),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2767),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2767),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2767),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [939] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1752),
    [sym_constructor_type] = STATE(1752),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1752),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1752),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1752),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [940] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3004),
    [sym_constructor_type] = STATE(3004),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3004),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3004),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3004),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [941] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2764),
    [sym_constructor_type] = STATE(2764),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2764),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2764),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2764),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [942] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1753),
    [sym_constructor_type] = STATE(1753),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1753),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1753),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1753),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [943] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3402),
    [sym_constructor_type] = STATE(3402),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3402),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3402),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3402),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [944] = {
    [sym_nested_identifier] = STATE(1317),
    [sym_string] = STATE(1248),
    [sym__module] = STATE(1530),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [945] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2742),
    [sym_constructor_type] = STATE(2742),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2742),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2742),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2742),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [946] = {
    [sym_nested_identifier] = STATE(1317),
    [sym_string] = STATE(1248),
    [sym__module] = STATE(1530),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_RBRACE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [947] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(2483),
    [sym_constructor_type] = STATE(2483),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2483),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2483),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2483),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [948] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3500),
    [sym_constructor_type] = STATE(3500),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3500),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3500),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3500),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [949] = {
    [sym_export_statement] = STATE(2998),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3683),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2998),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2998),
    [sym_property_signature] = STATE(2998),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2998),
    [sym_index_signature] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_export] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2897),
    [anon_sym_namespace] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2903),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_readonly] = ACTIONS(2907),
    [anon_sym_get] = ACTIONS(2909),
    [anon_sym_set] = ACTIONS(2909),
    [anon_sym_declare] = ACTIONS(2897),
    [anon_sym_public] = ACTIONS(2911),
    [anon_sym_private] = ACTIONS(2911),
    [anon_sym_protected] = ACTIONS(2911),
    [anon_sym_override] = ACTIONS(2913),
    [anon_sym_module] = ACTIONS(2897),
    [anon_sym_any] = ACTIONS(2897),
    [anon_sym_number] = ACTIONS(2897),
    [anon_sym_boolean] = ACTIONS(2897),
    [anon_sym_string] = ACTIONS(2897),
    [anon_sym_symbol] = ACTIONS(2897),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2833),
  },
  [950] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2493),
    [sym_constructor_type] = STATE(2493),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2493),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2493),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2493),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [951] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2503),
    [sym_constructor_type] = STATE(2503),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2503),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2503),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2503),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [952] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2647),
    [sym_constructor_type] = STATE(2647),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2647),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2647),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2647),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [953] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [954] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(3573),
    [sym_constructor_type] = STATE(3573),
    [sym__primary_type] = STATE(2714),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(3573),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(3573),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(3573),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [955] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(3662),
    [sym_constructor_type] = STATE(3662),
    [sym__primary_type] = STATE(1376),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(3662),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(3662),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(3662),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [956] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(3573),
    [sym_constructor_type] = STATE(3573),
    [sym__primary_type] = STATE(2712),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(3573),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(3573),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(3573),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [957] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2711),
    [sym_constructor_type] = STATE(2711),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2711),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2711),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2711),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [958] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2483),
    [sym_constructor_type] = STATE(2483),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2483),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2483),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2483),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [959] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(3662),
    [sym_constructor_type] = STATE(3662),
    [sym__primary_type] = STATE(1365),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(3662),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(3662),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(3662),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [960] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2747),
    [sym_constructor_type] = STATE(2747),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2747),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2747),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2747),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [961] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2514),
    [sym_constructor_type] = STATE(2514),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2514),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2514),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2514),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [962] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1655),
    [sym_constructor_type] = STATE(1655),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1655),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1655),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1655),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [963] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3659),
    [sym_constructor_type] = STATE(3659),
    [sym__primary_type] = STATE(2498),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3659),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3659),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3659),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [964] = {
    [sym_export_statement] = STATE(2998),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3683),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2998),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2998),
    [sym_property_signature] = STATE(2998),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2998),
    [sym_index_signature] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_export] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2897),
    [anon_sym_namespace] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2903),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_readonly] = ACTIONS(2907),
    [anon_sym_get] = ACTIONS(2909),
    [anon_sym_set] = ACTIONS(2909),
    [anon_sym_declare] = ACTIONS(2897),
    [anon_sym_public] = ACTIONS(2911),
    [anon_sym_private] = ACTIONS(2911),
    [anon_sym_protected] = ACTIONS(2911),
    [anon_sym_override] = ACTIONS(2913),
    [anon_sym_module] = ACTIONS(2897),
    [anon_sym_any] = ACTIONS(2897),
    [anon_sym_number] = ACTIONS(2897),
    [anon_sym_boolean] = ACTIONS(2897),
    [anon_sym_string] = ACTIONS(2897),
    [anon_sym_symbol] = ACTIONS(2897),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2833),
  },
  [965] = {
    [sym_export_statement] = STATE(2989),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3683),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2989),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2989),
    [sym_property_signature] = STATE(2989),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2989),
    [sym_index_signature] = STATE(2989),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2853),
    [anon_sym_export] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2853),
    [anon_sym_namespace] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2859),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_readonly] = ACTIONS(2863),
    [anon_sym_get] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(2865),
    [anon_sym_declare] = ACTIONS(2853),
    [anon_sym_public] = ACTIONS(2867),
    [anon_sym_private] = ACTIONS(2867),
    [anon_sym_protected] = ACTIONS(2867),
    [anon_sym_override] = ACTIONS(2869),
    [anon_sym_module] = ACTIONS(2853),
    [anon_sym_any] = ACTIONS(2853),
    [anon_sym_number] = ACTIONS(2853),
    [anon_sym_boolean] = ACTIONS(2853),
    [anon_sym_string] = ACTIONS(2853),
    [anon_sym_symbol] = ACTIONS(2853),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2923),
  },
  [966] = {
    [sym_export_statement] = STATE(2998),
    [sym_object_pattern] = STATE(4182),
    [sym_object_assignment_pattern] = STATE(3541),
    [sym_array_pattern] = STATE(4182),
    [sym__call_signature] = STATE(3322),
    [sym__destructuring_pattern] = STATE(4182),
    [sym_spread_element] = STATE(3683),
    [sym_string] = STATE(2577),
    [sym_decorator] = STATE(1162),
    [sym_formal_parameters] = STATE(2686),
    [sym_rest_pattern] = STATE(3541),
    [sym_method_definition] = STATE(3683),
    [sym_pair] = STATE(3683),
    [sym_pair_pattern] = STATE(3541),
    [sym__property_name] = STATE(2577),
    [sym_computed_property_name] = STATE(2577),
    [sym_method_signature] = STATE(2998),
    [sym_accessibility_modifier] = STATE(2290),
    [sym_override_modifier] = STATE(2307),
    [sym_call_signature] = STATE(2998),
    [sym_property_signature] = STATE(2998),
    [sym_type_parameters] = STATE(3910),
    [sym_construct_signature] = STATE(2998),
    [sym_index_signature] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [aux_sym_object_repeat1] = STATE(3630),
    [aux_sym_object_pattern_repeat1] = STATE(3544),
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_export] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2897),
    [anon_sym_namespace] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2903),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_readonly] = ACTIONS(2907),
    [anon_sym_get] = ACTIONS(2909),
    [anon_sym_set] = ACTIONS(2909),
    [anon_sym_declare] = ACTIONS(2897),
    [anon_sym_public] = ACTIONS(2911),
    [anon_sym_private] = ACTIONS(2911),
    [anon_sym_protected] = ACTIONS(2911),
    [anon_sym_override] = ACTIONS(2913),
    [anon_sym_module] = ACTIONS(2897),
    [anon_sym_any] = ACTIONS(2897),
    [anon_sym_number] = ACTIONS(2897),
    [anon_sym_boolean] = ACTIONS(2897),
    [anon_sym_string] = ACTIONS(2897),
    [anon_sym_symbol] = ACTIONS(2897),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2833),
  },
  [967] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3659),
    [sym_constructor_type] = STATE(3659),
    [sym__primary_type] = STATE(2496),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3659),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3659),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3659),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [968] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3005),
    [sym_constructor_type] = STATE(3005),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3005),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3005),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3005),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [969] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2671),
    [sym_constructor_type] = STATE(2671),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2671),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2671),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2671),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [970] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(3449),
    [sym_constructor_type] = STATE(3449),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3449),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3449),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3449),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [971] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2731),
    [sym_constructor_type] = STATE(2731),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2731),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2731),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2731),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [972] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2724),
    [sym_constructor_type] = STATE(2724),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2724),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2724),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2724),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [973] = {
    [sym_nested_identifier] = STATE(4099),
    [sym_string] = STATE(2766),
    [sym_formal_parameters] = STATE(4270),
    [sym_nested_type_identifier] = STATE(2663),
    [sym__type] = STATE(2749),
    [sym_constructor_type] = STATE(2749),
    [sym__primary_type] = STATE(2762),
    [sym_template_literal_type] = STATE(2758),
    [sym_infer_type] = STATE(2749),
    [sym_conditional_type] = STATE(2758),
    [sym_generic_type] = STATE(2758),
    [sym_type_query] = STATE(2758),
    [sym_index_type_query] = STATE(2758),
    [sym_lookup_type] = STATE(2758),
    [sym_literal_type] = STATE(2758),
    [sym__number] = STATE(2757),
    [sym_existential_type] = STATE(2758),
    [sym_flow_maybe_type] = STATE(2758),
    [sym_parenthesized_type] = STATE(2758),
    [sym_predefined_type] = STATE(2758),
    [sym_object_type] = STATE(2758),
    [sym_type_parameters] = STATE(3809),
    [sym_array_type] = STATE(2758),
    [sym_tuple_type] = STATE(2758),
    [sym_readonly_type] = STATE(2749),
    [sym_union_type] = STATE(2758),
    [sym_intersection_type] = STATE(2758),
    [sym_function_type] = STATE(2749),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2669),
    [sym_this] = ACTIONS(2791),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_QMARK] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2679),
    [anon_sym_infer] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(2685),
    [anon_sym_unique] = ACTIONS(2687),
    [anon_sym_unknown] = ACTIONS(2661),
    [anon_sym_never] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2689),
  },
  [974] = {
    [sym_nested_identifier] = STATE(1317),
    [sym_string] = STATE(1248),
    [sym__module] = STATE(1530),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(2005),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [975] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1259),
    [sym_constructor_type] = STATE(1259),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1259),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1259),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1259),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [976] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1273),
    [sym_constructor_type] = STATE(1273),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1273),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1273),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1273),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [977] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2524),
    [sym_constructor_type] = STATE(2524),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2524),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2524),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2524),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [978] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2678),
    [sym_constructor_type] = STATE(2678),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2678),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2678),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2678),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [979] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1726),
    [sym_constructor_type] = STATE(1726),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1726),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1726),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1726),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [980] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2416),
    [sym_constructor_type] = STATE(2416),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2416),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2416),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2416),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [981] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1353),
    [sym_constructor_type] = STATE(1353),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1353),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1353),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1353),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [982] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(2637),
    [sym_constructor_type] = STATE(2637),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(2637),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(2637),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2637),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [983] = {
    [sym_nested_identifier] = STATE(4148),
    [sym_string] = STATE(1821),
    [sym_formal_parameters] = STATE(4178),
    [sym_nested_type_identifier] = STATE(1590),
    [sym__type] = STATE(1727),
    [sym_constructor_type] = STATE(1727),
    [sym__primary_type] = STATE(1827),
    [sym_template_literal_type] = STATE(1616),
    [sym_infer_type] = STATE(1727),
    [sym_conditional_type] = STATE(1616),
    [sym_generic_type] = STATE(1616),
    [sym_type_query] = STATE(1616),
    [sym_index_type_query] = STATE(1616),
    [sym_lookup_type] = STATE(1616),
    [sym_literal_type] = STATE(1616),
    [sym__number] = STATE(1820),
    [sym_existential_type] = STATE(1616),
    [sym_flow_maybe_type] = STATE(1616),
    [sym_parenthesized_type] = STATE(1616),
    [sym_predefined_type] = STATE(1616),
    [sym_object_type] = STATE(1616),
    [sym_type_parameters] = STATE(3738),
    [sym_array_type] = STATE(1616),
    [sym_tuple_type] = STATE(1616),
    [sym_readonly_type] = STATE(1727),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1727),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2561),
    [sym_number] = ACTIONS(2563),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(2577),
    [anon_sym_keyof] = ACTIONS(2579),
    [anon_sym_unique] = ACTIONS(2581),
    [anon_sym_unknown] = ACTIONS(2559),
    [anon_sym_never] = ACTIONS(2559),
    [anon_sym_object] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2583),
  },
  [984] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4343),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(3098),
    [sym_constructor_type] = STATE(3098),
    [sym__primary_type] = STATE(2651),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(3098),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3932),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(3098),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(3098),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_infer] = ACTIONS(746),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [985] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(3557),
    [sym_constructor_type] = STATE(3557),
    [sym__primary_type] = STATE(2636),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(3557),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(3557),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(3557),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [986] = {
    [sym_nested_identifier] = STATE(4016),
    [sym_string] = STATE(2649),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2526),
    [sym__type] = STATE(3557),
    [sym_constructor_type] = STATE(3557),
    [sym__primary_type] = STATE(2631),
    [sym_template_literal_type] = STATE(2654),
    [sym_infer_type] = STATE(3557),
    [sym_conditional_type] = STATE(2654),
    [sym_generic_type] = STATE(2654),
    [sym_type_query] = STATE(2654),
    [sym_index_type_query] = STATE(2654),
    [sym_lookup_type] = STATE(2654),
    [sym_literal_type] = STATE(2654),
    [sym__number] = STATE(2658),
    [sym_existential_type] = STATE(2654),
    [sym_flow_maybe_type] = STATE(2654),
    [sym_parenthesized_type] = STATE(2654),
    [sym_predefined_type] = STATE(2654),
    [sym_object_type] = STATE(2654),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2654),
    [sym_tuple_type] = STATE(2654),
    [sym_readonly_type] = STATE(3557),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(3557),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1299),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_any] = ACTIONS(752),
    [anon_sym_number] = ACTIONS(752),
    [anon_sym_boolean] = ACTIONS(752),
    [anon_sym_string] = ACTIONS(752),
    [anon_sym_symbol] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(748),
    [anon_sym_unique] = ACTIONS(750),
    [anon_sym_unknown] = ACTIONS(752),
    [anon_sym_never] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(754),
  },
  [987] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4226),
    [sym_nested_type_identifier] = STATE(2394),
    [sym__type] = STATE(2717),
    [sym_constructor_type] = STATE(2717),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(2717),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3885),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(2717),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(2717),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(602),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_infer] = ACTIONS(202),
    [anon_sym_keyof] = ACTIONS(204),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(210),
  },
  [988] = {
    [sym_nested_identifier] = STATE(4227),
    [sym_string] = STATE(2456),
    [sym_formal_parameters] = STATE(4146),
    [sym_nested_type_identifier] = STATE(2811),
    [sym__type] = STATE(3046),
    [sym_constructor_type] = STATE(3046),
    [sym__primary_type] = STATE(2485),
    [sym_template_literal_type] = STATE(2487),
    [sym_infer_type] = STATE(3046),
    [sym_conditional_type] = STATE(2487),
    [sym_generic_type] = STATE(2487),
    [sym_type_query] = STATE(2487),
    [sym_index_type_query] = STATE(2487),
    [sym_lookup_type] = STATE(2487),
    [sym_literal_type] = STATE(2487),
    [sym__number] = STATE(2470),
    [sym_existential_type] = STATE(2487),
    [sym_flow_maybe_type] = STATE(2487),
    [sym_parenthesized_type] = STATE(2487),
    [sym_predefined_type] = STATE(2487),
    [sym_object_type] = STATE(2487),
    [sym_type_parameters] = STATE(3740),
    [sym_array_type] = STATE(2487),
    [sym_tuple_type] = STATE(2487),
    [sym_readonly_type] = STATE(3046),
    [sym_union_type] = STATE(2487),
    [sym_intersection_type] = STATE(2487),
    [sym_function_type] = STATE(3046),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_typeof] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_this] = ACTIONS(1248),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_any] = ACTIONS(208),
    [anon_sym_number] = ACTIONS(208),
    [anon_sym_boolean] = ACTIONS(208),
    [anon_sym_string] = ACTIONS(208),
    [anon_sym_symbol] = ACTIONS(208),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_infer] = ACTIONS(2713),
    [anon_sym_keyof] = ACTIONS(2715),
    [anon_sym_unique] = ACTIONS(206),
    [anon_sym_unknown] = ACTIONS(208),
    [anon_sym_never] = ACTIONS(208),
    [anon_sym_object] = ACTIONS(208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
  },
  [989] = {
    [sym_nested_identifier] = STATE(4027),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4080),
    [sym_nested_type_identifier] = STATE(1245),
    [sym__type] = STATE(1350),
    [sym_constructor_type] = STATE(1350),
    [sym__primary_type] = STATE(1274),
    [sym_template_literal_type] = STATE(1279),
    [sym_infer_type] = STATE(1350),
    [sym_conditional_type] = STATE(1279),
    [sym_generic_type] = STATE(1279),
    [sym_type_query] = STATE(1279),
    [sym_index_type_query] = STATE(1279),
    [sym_lookup_type] = STATE(1279),
    [sym_literal_type] = STATE(1279),
    [sym__number] = STATE(1287),
    [sym_existential_type] = STATE(1279),
    [sym_flow_maybe_type] = STATE(1279),
    [sym_parenthesized_type] = STATE(1279),
    [sym_predefined_type] = STATE(1279),
    [sym_object_type] = STATE(1279),
    [sym_type_parameters] = STATE(3914),
    [sym_array_type] = STATE(1279),
    [sym_tuple_type] = STATE(1279),
    [sym_readonly_type] = STATE(1350),
    [sym_union_type] = STATE(1279),
    [sym_intersection_type] = STATE(1279),
    [sym_function_type] = STATE(1350),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_QMARK] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2621),
    [anon_sym_infer] = ACTIONS(2625),
    [anon_sym_keyof] = ACTIONS(2627),
    [anon_sym_unique] = ACTIONS(2629),
    [anon_sym_unknown] = ACTIONS(2607),
    [anon_sym_never] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2631),
  },
  [990] = {
    [sym_identifier] = ACTIONS(2925),
    [anon_sym_export] = ACTIONS(2925),
    [anon_sym_type] = ACTIONS(2925),
    [anon_sym_EQ] = ACTIONS(2925),
    [anon_sym_namespace] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_typeof] = ACTIONS(2925),
    [anon_sym_import] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_RPAREN] = ACTIONS(2927),
    [anon_sym_await] = ACTIONS(2925),
    [anon_sym_COLON] = ACTIONS(2927),
    [anon_sym_yield] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_RBRACK] = ACTIONS(2927),
    [anon_sym_LTtemplate_GT] = ACTIONS(2927),
    [anon_sym_GT] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2925),
    [anon_sym_async] = ACTIONS(2925),
    [anon_sym_function] = ACTIONS(2925),
    [anon_sym_EQ_GT] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_PIPE] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_void] = ACTIONS(2925),
    [anon_sym_delete] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym_this] = ACTIONS(2925),
    [sym_super] = ACTIONS(2925),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [sym_null] = ACTIONS(2925),
    [sym_undefined] = ACTIONS(2925),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2925),
    [anon_sym_readonly] = ACTIONS(2925),
    [anon_sym_get] = ACTIONS(2925),
    [anon_sym_set] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2927),
    [anon_sym_declare] = ACTIONS(2925),
    [anon_sym_public] = ACTIONS(2925),
    [anon_sym_private] = ACTIONS(2925),
    [anon_sym_protected] = ACTIONS(2925),
    [anon_sym_override] = ACTIONS(2925),
    [anon_sym_module] = ACTIONS(2925),
    [anon_sym_any] = ACTIONS(2925),
    [anon_sym_number] = ACTIONS(2925),
    [anon_sym_boolean] = ACTIONS(2925),
    [anon_sym_string] = ACTIONS(2925),
    [anon_sym_symbol] = ACTIONS(2925),
    [anon_sym_extends] = ACTIONS(2925),
  },
  [991] = {
    [sym_nested_identifier] = STATE(1317),
    [sym_string] = STATE(1248),
    [sym__module] = STATE(1530),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1224),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_RPAREN] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [992] = {
    [sym_nested_identifier] = STATE(1317),
    [sym_string] = STATE(1248),
    [sym__module] = STATE(1530),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_RPAREN] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(218),
    [anon_sym_QMARK_DOT] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(153),
    [anon_sym_DASH_EQ] = ACTIONS(153),
    [anon_sym_STAR_EQ] = ACTIONS(153),
    [anon_sym_SLASH_EQ] = ACTIONS(153),
    [anon_sym_PERCENT_EQ] = ACTIONS(153),
    [anon_sym_CARET_EQ] = ACTIONS(153),
    [anon_sym_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(153),
    [anon_sym_LT_LT_EQ] = ACTIONS(153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(153),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(153),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(178),
    [anon_sym_SQUOTE] = ACTIONS(180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(149),
  },
  [993] = {
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_export] = ACTIONS(2929),
    [anon_sym_type] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_namespace] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_typeof] = ACTIONS(2929),
    [anon_sym_import] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_LPAREN] = ACTIONS(2931),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_await] = ACTIONS(2929),
    [anon_sym_COLON] = ACTIONS(2931),
    [anon_sym_yield] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_RBRACK] = ACTIONS(2931),
    [anon_sym_LTtemplate_GT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2929),
    [anon_sym_async] = ACTIONS(2929),
    [anon_sym_function] = ACTIONS(2929),
    [anon_sym_EQ_GT] = ACTIONS(2931),
    [anon_sym_new] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2931),
    [anon_sym_void] = ACTIONS(2929),
    [anon_sym_delete] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2931),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2931),
    [sym_number] = ACTIONS(2931),
    [sym_this] = ACTIONS(2929),
    [sym_super] = ACTIONS(2929),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [sym_null] = ACTIONS(2929),
    [sym_undefined] = ACTIONS(2929),
    [anon_sym_AT] = ACTIONS(2931),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_readonly] = ACTIONS(2929),
    [anon_sym_get] = ACTIONS(2929),
    [anon_sym_set] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2931),
    [anon_sym_declare] = ACTIONS(2929),
    [anon_sym_public] = ACTIONS(2929),
    [anon_sym_private] = ACTIONS(2929),
    [anon_sym_protected] = ACTIONS(2929),
    [anon_sym_override] = ACTIONS(2929),
    [anon_sym_module] = ACTIONS(2929),
    [anon_sym_any] = ACTIONS(2929),
    [anon_sym_number] = ACTIONS(2929),
    [anon_sym_boolean] = ACTIONS(2929),
    [anon_sym_string] = ACTIONS(2929),
    [anon_sym_symbol] = ACTIONS(2929),
    [anon_sym_extends] = ACTIONS(2929),
  },
  [994] = {
    [sym_identifier] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(2935),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_typeof] = ACTIONS(2933),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_await] = ACTIONS(2933),
    [anon_sym_COLON] = ACTIONS(2935),
    [anon_sym_yield] = ACTIONS(2933),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_RBRACK] = ACTIONS(2935),
    [anon_sym_LTtemplate_GT] = ACTIONS(2935),
    [anon_sym_GT] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(2933),
    [anon_sym_EQ_GT] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_PIPE] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2935),
    [anon_sym_void] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(2935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2935),
    [sym_number] = ACTIONS(2935),
    [sym_this] = ACTIONS(2933),
    [sym_super] = ACTIONS(2933),
    [sym_true] = ACTIONS(2933),
    [sym_false] = ACTIONS(2933),
    [sym_null] = ACTIONS(2933),
    [sym_undefined] = ACTIONS(2933),
    [anon_sym_AT] = ACTIONS(2935),
    [anon_sym_static] = ACTIONS(2933),
    [anon_sym_readonly] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_QMARK] = ACTIONS(2935),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_override] = ACTIONS(2933),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_extends] = ACTIONS(2933),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(218), 1,
      anon_sym_EQ_GT,
    ACTIONS(1224), 1,
      anon_sym_EQ,
    ACTIONS(1265), 1,
      anon_sym_COLON,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(1262), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(149), 11,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [93] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1899), 1,
      anon_sym_COLON,
    ACTIONS(2735), 1,
      sym_identifier,
    ACTIONS(2737), 1,
      anon_sym_DQUOTE,
    ACTIONS(2739), 1,
      anon_sym_SQUOTE,
    STATE(132), 1,
      sym_nested_identifier,
    STATE(138), 1,
      sym_string,
    STATE(150), 1,
      sym__module,
    ACTIONS(149), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [184] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(1258), 1,
      anon_sym_EQ,
    ACTIONS(1260), 1,
      anon_sym_EQ_GT,
    ACTIONS(2937), 1,
      sym_identifier,
    STATE(1228), 1,
      sym_string,
    STATE(1229), 1,
      sym_nested_identifier,
    STATE(1390), 1,
      sym__module,
    ACTIONS(149), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [273] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1260), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [362] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1899), 1,
      anon_sym_COLON,
    ACTIONS(2741), 1,
      sym_identifier,
    STATE(595), 1,
      sym_nested_identifier,
    STATE(621), 1,
      sym_string,
    STATE(645), 1,
      sym__module,
    ACTIONS(149), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [453] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1903), 1,
      anon_sym_COLON,
    ACTIONS(2741), 1,
      sym_identifier,
    STATE(595), 1,
      sym_nested_identifier,
    STATE(621), 1,
      sym_string,
    STATE(645), 1,
      sym__module,
    ACTIONS(149), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [544] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(2937), 1,
      sym_identifier,
    STATE(1228), 1,
      sym_string,
    STATE(1229), 1,
      sym_nested_identifier,
    STATE(1390), 1,
      sym__module,
    ACTIONS(149), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [633] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(2021), 1,
      anon_sym_in,
    ACTIONS(2024), 1,
      anon_sym_of,
    ACTIONS(2937), 1,
      sym_identifier,
    STATE(1228), 1,
      sym_string,
    STATE(1229), 1,
      sym_nested_identifier,
    STATE(1390), 1,
      sym__module,
    ACTIONS(149), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [726] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [815] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1903), 1,
      anon_sym_COLON,
    ACTIONS(2937), 1,
      sym_identifier,
    STATE(1228), 1,
      sym_string,
    STATE(1229), 1,
      sym_nested_identifier,
    STATE(1390), 1,
      sym__module,
    ACTIONS(149), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [906] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1267), 1,
      anon_sym_EQ,
    ACTIONS(1269), 1,
      anon_sym_EQ_GT,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 13,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [994] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1818), 1,
      anon_sym_LPAREN,
    ACTIONS(1821), 1,
      anon_sym_COLON,
    ACTIONS(1830), 1,
      anon_sym_LT,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1855), 1,
      anon_sym_RBRACE,
    ACTIONS(1891), 1,
      anon_sym_EQ,
    ACTIONS(2939), 1,
      sym_identifier,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(149), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [1086] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1269), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 13,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [1174] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(124), 1,
      anon_sym_COMMA,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_RBRACK,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(2032), 1,
      anon_sym_EQ,
    ACTIONS(2035), 1,
      anon_sym_COLON,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 11,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [1268] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    ACTIONS(1818), 1,
      anon_sym_LPAREN,
    ACTIONS(1821), 1,
      anon_sym_COLON,
    ACTIONS(1830), 1,
      anon_sym_LT,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1891), 1,
      anon_sym_EQ,
    ACTIONS(2939), 1,
      sym_identifier,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(149), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [1360] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1818), 1,
      anon_sym_LPAREN,
    ACTIONS(1821), 1,
      anon_sym_COLON,
    ACTIONS(1830), 1,
      anon_sym_LT,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1853), 1,
      anon_sym_RBRACE,
    ACTIONS(1891), 1,
      anon_sym_EQ,
    ACTIONS(2939), 1,
      sym_identifier,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(149), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [1452] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    ACTIONS(1821), 1,
      anon_sym_COLON,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(2947), 1,
      anon_sym_LPAREN,
    ACTIONS(2950), 1,
      anon_sym_EQ_GT,
    ACTIONS(2954), 1,
      anon_sym_LT,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [1541] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1307), 1,
      anon_sym_EQ,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [1628] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1311), 1,
      anon_sym_EQ,
    ACTIONS(1313), 1,
      anon_sym_EQ_GT,
    ACTIONS(2735), 1,
      sym_identifier,
    ACTIONS(2737), 1,
      anon_sym_DQUOTE,
    ACTIONS(2739), 1,
      anon_sym_SQUOTE,
    STATE(132), 1,
      sym_nested_identifier,
    STATE(138), 1,
      sym_string,
    STATE(150), 1,
      sym__module,
    ACTIONS(149), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [1715] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1313), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [1802] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2961), 1,
      anon_sym_LPAREN,
    ACTIONS(2963), 1,
      anon_sym_DOT,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(2967), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2971), 1,
      anon_sym_LT,
    STATE(2580), 1,
      sym_arguments,
    STATE(2632), 1,
      sym_type_arguments,
    ACTIONS(2969), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2959), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2945), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [1893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
    ACTIONS(2975), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [1962] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [2049] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1307), 1,
      anon_sym_EQ,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(2035), 1,
      anon_sym_COLON,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [2138] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    ACTIONS(1818), 1,
      anon_sym_LPAREN,
    ACTIONS(1821), 1,
      anon_sym_COLON,
    ACTIONS(1830), 1,
      anon_sym_LT,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1891), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [2227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
    ACTIONS(2979), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [2296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
    ACTIONS(2983), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [2365] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 1,
      anon_sym_COLON,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1855), 1,
      anon_sym_RBRACE,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(2947), 1,
      anon_sym_LPAREN,
    ACTIONS(2950), 1,
      anon_sym_EQ_GT,
    ACTIONS(2954), 1,
      anon_sym_LT,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [2454] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1818), 1,
      anon_sym_LPAREN,
    ACTIONS(1821), 1,
      anon_sym_COLON,
    ACTIONS(1830), 1,
      anon_sym_LT,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1853), 1,
      anon_sym_RBRACE,
    ACTIONS(1891), 1,
      anon_sym_EQ,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [2543] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(238), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2799), 1,
      anon_sym_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2811), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(2987), 1,
      anon_sym_export,
    ACTIONS(2992), 1,
      anon_sym_async,
    ACTIONS(2994), 1,
      anon_sym_static,
    ACTIONS(2996), 1,
      anon_sym_readonly,
    ACTIONS(3002), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2290), 1,
      sym_accessibility_modifier,
    STATE(2307), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(2819), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2989), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2998), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3000), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2577), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3845), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3847), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(2964), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2985), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3004), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
    ACTIONS(3006), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [2745] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1307), 1,
      anon_sym_EQ,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(2057), 1,
      anon_sym_COLON,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [2834] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2959), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2969), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [2925] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 1,
      anon_sym_COLON,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1853), 1,
      anon_sym_RBRACE,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(2947), 1,
      anon_sym_LPAREN,
    ACTIONS(2950), 1,
      anon_sym_EQ_GT,
    ACTIONS(2954), 1,
      anon_sym_LT,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [3014] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(124), 1,
      anon_sym_COMMA,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_RBRACK,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(2032), 1,
      anon_sym_EQ,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 11,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [3105] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1818), 1,
      anon_sym_LPAREN,
    ACTIONS(1821), 1,
      anon_sym_COLON,
    ACTIONS(1830), 1,
      anon_sym_LT,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1855), 1,
      anon_sym_RBRACE,
    ACTIONS(1891), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [3194] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(1311), 1,
      anon_sym_EQ,
    ACTIONS(1313), 1,
      anon_sym_EQ_GT,
    ACTIONS(2937), 1,
      sym_identifier,
    STATE(1228), 1,
      sym_string,
    STATE(1229), 1,
      sym_nested_identifier,
    STATE(1390), 1,
      sym__module,
    ACTIONS(149), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [3281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3016), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
    ACTIONS(3018), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [3350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3020), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
    ACTIONS(3022), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [3419] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(238), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2799), 1,
      anon_sym_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2811), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(2987), 1,
      anon_sym_export,
    ACTIONS(2992), 1,
      anon_sym_async,
    ACTIONS(2994), 1,
      anon_sym_static,
    ACTIONS(2996), 1,
      anon_sym_readonly,
    ACTIONS(3002), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2290), 1,
      sym_accessibility_modifier,
    STATE(2307), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(2819), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2989), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2998), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3000), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2577), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3845), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3847), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3056), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2985), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [3552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
    ACTIONS(3026), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [3621] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1311), 1,
      anon_sym_EQ,
    ACTIONS(1313), 1,
      anon_sym_EQ_GT,
    ACTIONS(3028), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_nested_identifier,
    STATE(2907), 1,
      sym_string,
    STATE(3249), 1,
      sym__module,
    ACTIONS(149), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [3708] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(1311), 1,
      anon_sym_EQ,
    ACTIONS(1313), 1,
      anon_sym_EQ_GT,
    ACTIONS(2741), 1,
      sym_identifier,
    STATE(595), 1,
      sym_nested_identifier,
    STATE(621), 1,
      sym_string,
    STATE(645), 1,
      sym__module,
    ACTIONS(149), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [3795] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2969), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2959), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2945), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [3885] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_EQ_GT,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1265), 1,
      anon_sym_COLON,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 11,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [3973] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_EQ_GT,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2959), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2969), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [4063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2517), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(2519), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [4131] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3053), 1,
      anon_sym_QMARK,
    ACTIONS(3056), 1,
      anon_sym_extends,
    STATE(2499), 1,
      sym_type_arguments,
    STATE(3895), 1,
      sym_type_annotation,
    ACTIONS(3035), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3047), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [4225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2521), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(2523), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [4293] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3058), 1,
      anon_sym_EQ,
    ACTIONS(3060), 1,
      anon_sym_EQ_GT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2959), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2969), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [4383] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1317), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 11,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [4469] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3062), 1,
      anon_sym_DOT,
    ACTIONS(3065), 1,
      anon_sym_LT,
    STATE(2639), 1,
      sym_type_arguments,
    ACTIONS(3035), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3047), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3056), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2945), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [4557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [4629] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_EQ_GT,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2021), 1,
      anon_sym_in,
    ACTIONS(2024), 1,
      anon_sym_of,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 11,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [4719] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3056), 1,
      anon_sym_extends,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3041), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3047), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [4805] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1315), 1,
      anon_sym_EQ,
    ACTIONS(1317), 1,
      anon_sym_EQ_GT,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 11,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [4891] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3035), 1,
      anon_sym_RPAREN,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3056), 1,
      anon_sym_extends,
    ACTIONS(3073), 1,
      anon_sym_QMARK,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3047), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3070), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2945), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [4982] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3073), 1,
      anon_sym_QMARK,
    ACTIONS(3070), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5059] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3077), 1,
      anon_sym_EQ_GT,
    ACTIONS(3079), 1,
      anon_sym_QMARK,
    ACTIONS(3075), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5136] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(212), 1,
      anon_sym_EQ,
    ACTIONS(218), 1,
      anon_sym_EQ_GT,
    ACTIONS(3081), 1,
      anon_sym_LBRACK,
    ACTIONS(3084), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1405), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(149), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5215] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2005), 1,
      anon_sym_QMARK,
    ACTIONS(1265), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(149), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5292] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(212), 1,
      anon_sym_EQ,
    ACTIONS(218), 1,
      anon_sym_EQ_GT,
    ACTIONS(650), 1,
      anon_sym_QMARK,
    ACTIONS(215), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(149), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5369] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3073), 1,
      anon_sym_QMARK,
    ACTIONS(3077), 1,
      anon_sym_EQ_GT,
    ACTIONS(3087), 1,
      anon_sym_EQ,
    ACTIONS(3090), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5446] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_EQ,
    ACTIONS(147), 1,
      anon_sym_EQ_GT,
    ACTIONS(650), 1,
      anon_sym_QMARK,
    ACTIONS(124), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(149), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5523] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(218), 1,
      anon_sym_EQ_GT,
    ACTIONS(1224), 1,
      anon_sym_EQ,
    ACTIONS(1405), 1,
      anon_sym_extends,
    ACTIONS(3081), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3084), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5602] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3092), 1,
      anon_sym_EQ,
    ACTIONS(3094), 1,
      anon_sym_EQ_GT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2959), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2969), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5691] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2969), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(2959), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2945), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5780] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3056), 1,
      anon_sym_extends,
    ACTIONS(3058), 1,
      anon_sym_EQ,
    ACTIONS(3060), 1,
      anon_sym_EQ_GT,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3041), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3047), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5865] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3096), 1,
      anon_sym_EQ,
    ACTIONS(3098), 1,
      anon_sym_EQ_GT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2959), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2969), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [5954] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3056), 1,
      anon_sym_extends,
    ACTIONS(3073), 1,
      anon_sym_QMARK,
    ACTIONS(3077), 1,
      anon_sym_EQ_GT,
    ACTIONS(3087), 1,
      anon_sym_EQ,
    ACTIONS(3100), 1,
      anon_sym_RPAREN,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3047), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3090), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2945), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [6045] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_EQ_GT,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3056), 1,
      anon_sym_extends,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3041), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3047), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [6130] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_EQ_GT,
    ACTIONS(178), 1,
      anon_sym_DQUOTE,
    ACTIONS(180), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_string,
    STATE(1317), 1,
      sym_nested_identifier,
    STATE(1530), 1,
      sym__module,
    ACTIONS(149), 11,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [6215] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3103), 1,
      anon_sym_EQ,
    ACTIONS(3105), 1,
      anon_sym_EQ_GT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2959), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2969), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [6304] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(212), 1,
      anon_sym_EQ,
    ACTIONS(218), 1,
      anon_sym_EQ_GT,
    ACTIONS(650), 1,
      anon_sym_QMARK,
    ACTIONS(3081), 1,
      anon_sym_LBRACK,
    ACTIONS(215), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1405), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3084), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(149), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [6386] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_EQ,
    ACTIONS(147), 1,
      anon_sym_EQ_GT,
    ACTIONS(650), 1,
      anon_sym_QMARK,
    ACTIONS(3081), 1,
      anon_sym_LBRACK,
    ACTIONS(124), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1405), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3084), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(149), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [6468] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3107), 1,
      anon_sym_EQ,
    ACTIONS(3109), 1,
      anon_sym_EQ_GT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2959), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2969), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [6556] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1903), 1,
      anon_sym_COLON,
    ACTIONS(2939), 1,
      sym_identifier,
    ACTIONS(149), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [6632] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_EQ,
    ACTIONS(1260), 1,
      anon_sym_EQ_GT,
    ACTIONS(1405), 1,
      anon_sym_extends,
    ACTIONS(3081), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3084), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [6710] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1405), 1,
      anon_sym_extends,
    ACTIONS(3081), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3084), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [6788] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [6860] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(218), 1,
      anon_sym_EQ_GT,
    ACTIONS(1224), 1,
      anon_sym_EQ,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [6932] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1899), 1,
      anon_sym_COLON,
    ACTIONS(2939), 1,
      sym_identifier,
    ACTIONS(149), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [7008] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [7080] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(3077), 1,
      anon_sym_EQ_GT,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3047), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3056), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2945), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [7166] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3077), 1,
      anon_sym_EQ_GT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2969), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2959), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2945), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [7254] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3096), 1,
      anon_sym_EQ,
    ACTIONS(3098), 1,
      anon_sym_EQ_GT,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3056), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3047), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [7338] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3056), 1,
      anon_sym_extends,
    ACTIONS(3092), 1,
      anon_sym_EQ,
    ACTIONS(3094), 1,
      anon_sym_EQ_GT,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3041), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3047), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [7422] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3079), 1,
      anon_sym_QMARK,
    ACTIONS(3075), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [7496] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3056), 1,
      anon_sym_extends,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3047), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3111), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2945), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [7584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(218), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [7656] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3073), 1,
      anon_sym_QMARK,
    ACTIONS(3087), 1,
      anon_sym_EQ,
    ACTIONS(3090), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [7730] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3103), 1,
      anon_sym_EQ,
    ACTIONS(3105), 1,
      anon_sym_EQ_GT,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3056), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3047), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [7814] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3073), 1,
      anon_sym_QMARK,
    ACTIONS(3070), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [7888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(2975), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [7953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8024] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1311), 1,
      anon_sym_EQ,
    ACTIONS(1313), 1,
      anon_sym_EQ_GT,
    ACTIONS(3081), 1,
      anon_sym_LBRACK,
    ACTIONS(1405), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3084), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(149), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8101] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3060), 1,
      anon_sym_EQ_GT,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8172] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_EQ_GT,
    ACTIONS(1265), 1,
      anon_sym_COLON,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(3081), 1,
      anon_sym_LBRACK,
    ACTIONS(3084), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1405), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(149), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8251] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_EQ,
    ACTIONS(1260), 1,
      anon_sym_EQ_GT,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8322] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_EQ_GT,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    ACTIONS(3115), 1,
      anon_sym_in,
    ACTIONS(3118), 1,
      anon_sym_of,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8397] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 1,
      anon_sym_EQ,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(3081), 1,
      anon_sym_LBRACK,
    ACTIONS(1405), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3084), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(149), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8474] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8543] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(2021), 1,
      anon_sym_in,
    ACTIONS(3120), 1,
      anon_sym_of,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8618] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3077), 1,
      anon_sym_EQ_GT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2959), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2969), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3016), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(3018), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [8770] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1903), 1,
      anon_sym_COLON,
    ACTIONS(2950), 1,
      anon_sym_EQ_GT,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8843] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1903), 1,
      anon_sym_COLON,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [8916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3020), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(3022), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [8981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2521), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(2523), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9046] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(218), 1,
      anon_sym_EQ_GT,
    ACTIONS(1224), 1,
      anon_sym_EQ,
    ACTIONS(1265), 1,
      anon_sym_COLON,
    ACTIONS(1405), 1,
      anon_sym_extends,
    ACTIONS(3081), 1,
      anon_sym_LBRACK,
    ACTIONS(3084), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3122), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(149), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [9127] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_EQ_GT,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [9198] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_EQ_GT,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [9269] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_EQ,
    ACTIONS(3060), 1,
      anon_sym_EQ_GT,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [9340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(2983), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3004), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(3006), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9470] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3056), 1,
      anon_sym_extends,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3041), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3047), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [9553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(2979), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9618] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1267), 1,
      anon_sym_EQ,
    ACTIONS(1269), 1,
      anon_sym_EQ_GT,
    ACTIONS(1405), 1,
      anon_sym_extends,
    ACTIONS(3081), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3084), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(149), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [9695] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3107), 1,
      anon_sym_EQ,
    ACTIONS(3109), 1,
      anon_sym_EQ_GT,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3056), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3047), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [9778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(3026), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9843] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [9914] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [9985] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(218), 1,
      anon_sym_EQ_GT,
    ACTIONS(1224), 1,
      anon_sym_EQ,
    ACTIONS(1265), 1,
      anon_sym_COLON,
    ACTIONS(1262), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(149), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [10060] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 1,
      anon_sym_EQ,
    ACTIONS(1256), 1,
      anon_sym_EQ_GT,
    ACTIONS(1899), 1,
      anon_sym_COLON,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [10133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [10202] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(212), 1,
      anon_sym_EQ,
    ACTIONS(218), 1,
      anon_sym_EQ_GT,
    ACTIONS(1407), 1,
      anon_sym_QMARK,
    ACTIONS(3081), 1,
      anon_sym_LBRACK,
    ACTIONS(3084), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1405), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(149), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [10281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2517), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
    ACTIONS(2519), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [10346] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_COLON,
    ACTIONS(2950), 1,
      anon_sym_EQ_GT,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [10419] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3077), 1,
      anon_sym_EQ_GT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2969), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2959), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2945), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [10506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1311), 1,
      anon_sym_EQ,
    ACTIONS(1313), 1,
      anon_sym_EQ_GT,
    ACTIONS(3126), 1,
      sym_identifier,
    ACTIONS(149), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [10578] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
    ACTIONS(3128), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [10650] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3044), 1,
      anon_sym_DOT,
    ACTIONS(3050), 1,
      anon_sym_LT,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3077), 1,
      anon_sym_EQ_GT,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3056), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3047), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [10732] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1311), 1,
      anon_sym_EQ,
    ACTIONS(1313), 1,
      anon_sym_EQ_GT,
    ACTIONS(2939), 1,
      sym_identifier,
    ACTIONS(149), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [10804] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3135), 1,
      anon_sym_DOT,
    STATE(1169), 1,
      sym_arguments,
    ACTIONS(3133), 12,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3131), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_DASH_DASH,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [10874] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1269), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [10944] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11012] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3094), 1,
      anon_sym_EQ_GT,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11082] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_RBRACK,
    ACTIONS(3090), 1,
      anon_sym_COMMA,
    ACTIONS(3098), 1,
      anon_sym_EQ_GT,
    ACTIONS(3137), 1,
      anon_sym_EQ,
    ACTIONS(3140), 1,
      anon_sym_in,
    ACTIONS(3142), 1,
      anon_sym_COLON,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11160] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(124), 1,
      anon_sym_COMMA,
    ACTIONS(215), 1,
      anon_sym_RBRACK,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(2032), 1,
      anon_sym_EQ,
    ACTIONS(2035), 1,
      anon_sym_COLON,
    ACTIONS(149), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11236] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    ACTIONS(3115), 1,
      anon_sym_in,
    ACTIONS(3118), 1,
      anon_sym_of,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11308] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1267), 1,
      anon_sym_EQ,
    ACTIONS(1269), 1,
      anon_sym_EQ_GT,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11378] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(3128), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11450] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_EQ,
    ACTIONS(3094), 1,
      anon_sym_EQ_GT,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11520] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 1,
      anon_sym_AT,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
    ACTIONS(3146), 12,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3144), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_DASH_DASH,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [11590] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(218), 1,
      anon_sym_EQ_GT,
    ACTIONS(1224), 1,
      anon_sym_EQ,
    ACTIONS(1405), 1,
      anon_sym_extends,
    ACTIONS(3081), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3084), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(149), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11734] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1315), 1,
      anon_sym_EQ,
    ACTIONS(1317), 1,
      anon_sym_EQ_GT,
    ACTIONS(3081), 1,
      anon_sym_LBRACK,
    ACTIONS(1405), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3084), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(149), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11810] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3103), 1,
      anon_sym_EQ,
    ACTIONS(3105), 1,
      anon_sym_EQ_GT,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11879] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_RBRACK,
    ACTIONS(3090), 1,
      anon_sym_COMMA,
    ACTIONS(3098), 1,
      anon_sym_EQ_GT,
    ACTIONS(3137), 1,
      anon_sym_EQ,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [11952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12019] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 1,
      anon_sym_EQ,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(2057), 1,
      anon_sym_COLON,
    ACTIONS(149), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12090] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1311), 1,
      anon_sym_EQ,
    ACTIONS(1313), 1,
      anon_sym_EQ_GT,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12159] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3105), 1,
      anon_sym_EQ_GT,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12228] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_EQ,
    ACTIONS(3098), 1,
      anon_sym_EQ_GT,
    ACTIONS(3140), 1,
      anon_sym_in,
    ACTIONS(3142), 1,
      anon_sym_COLON,
    ACTIONS(2945), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12301] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 1,
      anon_sym_AT,
    ACTIONS(3151), 1,
      anon_sym_class,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
    ACTIONS(3146), 12,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3144), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_DASH_DASH,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [12372] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(3081), 1,
      anon_sym_LBRACK,
    ACTIONS(1405), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3084), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(149), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12447] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3098), 1,
      anon_sym_EQ_GT,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12516] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_EQ,
    ACTIONS(3098), 1,
      anon_sym_EQ_GT,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12585] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12654] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 1,
      anon_sym_EQ,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(2035), 1,
      anon_sym_COLON,
    ACTIONS(149), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12725] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_EQ,
    ACTIONS(3098), 1,
      anon_sym_EQ_GT,
    ACTIONS(3140), 1,
      anon_sym_in,
    ACTIONS(3154), 1,
      anon_sym_COLON,
    ACTIONS(2945), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12798] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(124), 1,
      anon_sym_COMMA,
    ACTIONS(215), 1,
      anon_sym_RBRACK,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(2032), 1,
      anon_sym_EQ,
    ACTIONS(149), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12871] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 1,
      anon_sym_EQ,
    ACTIONS(1309), 1,
      anon_sym_EQ_GT,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [12940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3158), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3156), 42,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_DASH_DASH,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [13003] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1313), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(149), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [13072] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3077), 1,
      anon_sym_EQ_GT,
    ACTIONS(3115), 1,
      anon_sym_in,
    ACTIONS(3118), 1,
      anon_sym_of,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [13144] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1315), 1,
      anon_sym_EQ,
    ACTIONS(1317), 1,
      anon_sym_EQ_GT,
    ACTIONS(149), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [13212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3162), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3160), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_DASH_DASH,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [13274] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2021), 1,
      anon_sym_in,
    ACTIONS(3120), 1,
      anon_sym_of,
    ACTIONS(149), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [13346] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_EQ_GT,
    ACTIONS(1265), 1,
      anon_sym_COLON,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(149), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [13416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3103), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [13482] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(149), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [13550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_EQ,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2945), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [13616] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3109), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [13684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3166), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3164), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_DASH_DASH,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [13746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3133), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3131), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_DASH_DASH,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [13808] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_RBRACK,
    ACTIONS(3090), 1,
      anon_sym_COMMA,
    ACTIONS(3137), 1,
      anon_sym_EQ,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [13878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3107), 1,
      anon_sym_EQ,
    ACTIONS(3109), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [13946] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(149), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(153), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [14013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3077), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [14080] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3115), 1,
      anon_sym_in,
    ACTIONS(3118), 1,
      anon_sym_of,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [14149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3107), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [14214] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(2945), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2952), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2941), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_DASH_DASH,
  [14281] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3174), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3176), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3038), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14397] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(2809), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2833), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2998), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14513] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3194), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3196), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3030), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14629] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3198), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3200), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3012), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14745] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3202), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3204), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2995), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14861] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2923), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2989), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14977] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(3206), 1,
      sym_identifier,
    ACTIONS(3208), 1,
      anon_sym_STAR,
    ACTIONS(3210), 1,
      anon_sym_type,
    ACTIONS(3214), 1,
      anon_sym_LBRACE,
    ACTIONS(3218), 1,
      anon_sym_typeof,
    STATE(3882), 1,
      sym_string,
    STATE(3946), 1,
      sym_import_require_clause,
    STATE(3950), 1,
      sym__import_identifier,
    STATE(3958), 1,
      sym_import_clause,
    STATE(4274), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(3212), 16,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(3216), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
  [15060] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1806), 1,
      anon_sym_LBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1945), 1,
      anon_sym_namespace,
    ACTIONS(1947), 1,
      anon_sym_import,
    ACTIONS(1949), 1,
      anon_sym_var,
    ACTIONS(1951), 1,
      anon_sym_let,
    ACTIONS(1953), 1,
      anon_sym_const,
    ACTIONS(1955), 1,
      anon_sym_class,
    ACTIONS(1957), 1,
      anon_sym_async,
    ACTIONS(1959), 1,
      anon_sym_function,
    ACTIONS(1961), 1,
      anon_sym_declare,
    ACTIONS(1965), 1,
      anon_sym_abstract,
    ACTIONS(1969), 1,
      anon_sym_interface,
    ACTIONS(1971), 1,
      anon_sym_enum,
    ACTIONS(3220), 1,
      anon_sym_STAR,
    ACTIONS(3222), 1,
      anon_sym_default,
    ACTIONS(3224), 1,
      anon_sym_type,
    ACTIONS(3226), 1,
      anon_sym_EQ,
    ACTIONS(3228), 1,
      anon_sym_as,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3233), 1,
      anon_sym_RBRACE,
    ACTIONS(3238), 1,
      anon_sym_module,
    STATE(1162), 1,
      sym_decorator,
    STATE(3252), 1,
      sym_internal_module,
    STATE(3253), 1,
      sym_declaration,
    STATE(3333), 1,
      aux_sym_export_statement_repeat1,
    STATE(3401), 1,
      sym_export_clause,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    STATE(3866), 1,
      sym_namespace_export,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3254), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [15180] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3240), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15292] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3242), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15404] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1806), 1,
      anon_sym_LBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1945), 1,
      anon_sym_namespace,
    ACTIONS(1947), 1,
      anon_sym_import,
    ACTIONS(1949), 1,
      anon_sym_var,
    ACTIONS(1951), 1,
      anon_sym_let,
    ACTIONS(1953), 1,
      anon_sym_const,
    ACTIONS(1955), 1,
      anon_sym_class,
    ACTIONS(1957), 1,
      anon_sym_async,
    ACTIONS(1959), 1,
      anon_sym_function,
    ACTIONS(1961), 1,
      anon_sym_declare,
    ACTIONS(1965), 1,
      anon_sym_abstract,
    ACTIONS(1969), 1,
      anon_sym_interface,
    ACTIONS(1971), 1,
      anon_sym_enum,
    ACTIONS(3220), 1,
      anon_sym_STAR,
    ACTIONS(3222), 1,
      anon_sym_default,
    ACTIONS(3224), 1,
      anon_sym_type,
    ACTIONS(3226), 1,
      anon_sym_EQ,
    ACTIONS(3228), 1,
      anon_sym_as,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3238), 1,
      anon_sym_module,
    ACTIONS(3244), 1,
      anon_sym_RBRACE,
    STATE(1162), 1,
      sym_decorator,
    STATE(3252), 1,
      sym_internal_module,
    STATE(3253), 1,
      sym_declaration,
    STATE(3333), 1,
      aux_sym_export_statement_repeat1,
    STATE(3401), 1,
      sym_export_clause,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    STATE(3866), 1,
      sym_namespace_export,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3254), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [15524] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3247), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15636] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1806), 1,
      anon_sym_LBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1945), 1,
      anon_sym_namespace,
    ACTIONS(1947), 1,
      anon_sym_import,
    ACTIONS(1949), 1,
      anon_sym_var,
    ACTIONS(1951), 1,
      anon_sym_let,
    ACTIONS(1953), 1,
      anon_sym_const,
    ACTIONS(1955), 1,
      anon_sym_class,
    ACTIONS(1957), 1,
      anon_sym_async,
    ACTIONS(1959), 1,
      anon_sym_function,
    ACTIONS(1961), 1,
      anon_sym_declare,
    ACTIONS(1965), 1,
      anon_sym_abstract,
    ACTIONS(1969), 1,
      anon_sym_interface,
    ACTIONS(1971), 1,
      anon_sym_enum,
    ACTIONS(3220), 1,
      anon_sym_STAR,
    ACTIONS(3222), 1,
      anon_sym_default,
    ACTIONS(3224), 1,
      anon_sym_type,
    ACTIONS(3226), 1,
      anon_sym_EQ,
    ACTIONS(3228), 1,
      anon_sym_as,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3238), 1,
      anon_sym_module,
    ACTIONS(3249), 1,
      anon_sym_RBRACE,
    STATE(1162), 1,
      sym_decorator,
    STATE(3252), 1,
      sym_internal_module,
    STATE(3253), 1,
      sym_declaration,
    STATE(3333), 1,
      aux_sym_export_statement_repeat1,
    STATE(3401), 1,
      sym_export_clause,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3866), 1,
      sym_namespace_export,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3254), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [15756] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3252), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15868] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3254), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15980] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3256), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16092] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3258), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16204] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3260), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16316] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3262), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16428] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1806), 1,
      anon_sym_LBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1945), 1,
      anon_sym_namespace,
    ACTIONS(1947), 1,
      anon_sym_import,
    ACTIONS(1949), 1,
      anon_sym_var,
    ACTIONS(1951), 1,
      anon_sym_let,
    ACTIONS(1953), 1,
      anon_sym_const,
    ACTIONS(1955), 1,
      anon_sym_class,
    ACTIONS(1957), 1,
      anon_sym_async,
    ACTIONS(1959), 1,
      anon_sym_function,
    ACTIONS(1961), 1,
      anon_sym_declare,
    ACTIONS(1965), 1,
      anon_sym_abstract,
    ACTIONS(1969), 1,
      anon_sym_interface,
    ACTIONS(1971), 1,
      anon_sym_enum,
    ACTIONS(3220), 1,
      anon_sym_STAR,
    ACTIONS(3222), 1,
      anon_sym_default,
    ACTIONS(3224), 1,
      anon_sym_type,
    ACTIONS(3226), 1,
      anon_sym_EQ,
    ACTIONS(3228), 1,
      anon_sym_as,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3238), 1,
      anon_sym_module,
    ACTIONS(3264), 1,
      anon_sym_RBRACE,
    STATE(1162), 1,
      sym_decorator,
    STATE(3252), 1,
      sym_internal_module,
    STATE(3253), 1,
      sym_declaration,
    STATE(3333), 1,
      aux_sym_export_statement_repeat1,
    STATE(3401), 1,
      sym_export_clause,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    STATE(3866), 1,
      sym_namespace_export,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3254), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [16548] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1806), 1,
      anon_sym_LBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1945), 1,
      anon_sym_namespace,
    ACTIONS(1947), 1,
      anon_sym_import,
    ACTIONS(1949), 1,
      anon_sym_var,
    ACTIONS(1951), 1,
      anon_sym_let,
    ACTIONS(1953), 1,
      anon_sym_const,
    ACTIONS(1955), 1,
      anon_sym_class,
    ACTIONS(1957), 1,
      anon_sym_async,
    ACTIONS(1959), 1,
      anon_sym_function,
    ACTIONS(1961), 1,
      anon_sym_declare,
    ACTIONS(1965), 1,
      anon_sym_abstract,
    ACTIONS(1969), 1,
      anon_sym_interface,
    ACTIONS(1971), 1,
      anon_sym_enum,
    ACTIONS(3220), 1,
      anon_sym_STAR,
    ACTIONS(3222), 1,
      anon_sym_default,
    ACTIONS(3224), 1,
      anon_sym_type,
    ACTIONS(3226), 1,
      anon_sym_EQ,
    ACTIONS(3228), 1,
      anon_sym_as,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3238), 1,
      anon_sym_module,
    ACTIONS(3267), 1,
      anon_sym_RBRACE,
    STATE(1162), 1,
      sym_decorator,
    STATE(3252), 1,
      sym_internal_module,
    STATE(3253), 1,
      sym_declaration,
    STATE(3333), 1,
      aux_sym_export_statement_repeat1,
    STATE(3401), 1,
      sym_export_clause,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    STATE(3866), 1,
      sym_namespace_export,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3254), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [16668] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3270), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16780] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3272), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16892] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3274), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17004] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3276), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17116] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3278), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17228] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3280), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17340] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3282), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17452] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3284), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17564] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3286), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17676] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3091), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 15,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
    ACTIONS(1437), 33,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [17840] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1806), 1,
      anon_sym_LBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1945), 1,
      anon_sym_namespace,
    ACTIONS(1947), 1,
      anon_sym_import,
    ACTIONS(1949), 1,
      anon_sym_var,
    ACTIONS(1951), 1,
      anon_sym_let,
    ACTIONS(1953), 1,
      anon_sym_const,
    ACTIONS(1955), 1,
      anon_sym_class,
    ACTIONS(1957), 1,
      anon_sym_async,
    ACTIONS(1959), 1,
      anon_sym_function,
    ACTIONS(1961), 1,
      anon_sym_declare,
    ACTIONS(1965), 1,
      anon_sym_abstract,
    ACTIONS(1969), 1,
      anon_sym_interface,
    ACTIONS(1971), 1,
      anon_sym_enum,
    ACTIONS(3220), 1,
      anon_sym_STAR,
    ACTIONS(3222), 1,
      anon_sym_default,
    ACTIONS(3224), 1,
      anon_sym_type,
    ACTIONS(3228), 1,
      anon_sym_as,
    ACTIONS(3238), 1,
      anon_sym_module,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    STATE(1162), 1,
      sym_decorator,
    STATE(3252), 1,
      sym_internal_module,
    STATE(3253), 1,
      sym_declaration,
    STATE(3333), 1,
      aux_sym_export_statement_repeat1,
    STATE(3401), 1,
      sym_export_clause,
    STATE(3866), 1,
      sym_namespace_export,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3254), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [17950] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3051), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18058] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3056), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18166] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3021), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18274] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2964), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18382] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3197), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 15,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
    ACTIONS(1497), 33,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [18546] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(2815), 1,
      anon_sym_new,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(2831), 1,
      anon_sym_abstract,
    ACTIONS(3170), 1,
      anon_sym_export,
    ACTIONS(3172), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3180), 1,
      anon_sym_async,
    ACTIONS(3184), 1,
      anon_sym_static,
    ACTIONS(3186), 1,
      anon_sym_readonly,
    ACTIONS(3192), 1,
      anon_sym_override,
    STATE(1162), 1,
      sym_decorator,
    STATE(2279), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(3418), 1,
      aux_sym_export_statement_repeat1,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(3182), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3188), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3001), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18654] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1806), 1,
      anon_sym_LBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1945), 1,
      anon_sym_namespace,
    ACTIONS(1947), 1,
      anon_sym_import,
    ACTIONS(1949), 1,
      anon_sym_var,
    ACTIONS(1951), 1,
      anon_sym_let,
    ACTIONS(1953), 1,
      anon_sym_const,
    ACTIONS(1955), 1,
      anon_sym_class,
    ACTIONS(1957), 1,
      anon_sym_async,
    ACTIONS(1959), 1,
      anon_sym_function,
    ACTIONS(1961), 1,
      anon_sym_declare,
    ACTIONS(1965), 1,
      anon_sym_abstract,
    ACTIONS(1969), 1,
      anon_sym_interface,
    ACTIONS(1971), 1,
      anon_sym_enum,
    ACTIONS(3220), 1,
      anon_sym_STAR,
    ACTIONS(3222), 1,
      anon_sym_default,
    ACTIONS(3224), 1,
      anon_sym_type,
    ACTIONS(3226), 1,
      anon_sym_EQ,
    ACTIONS(3228), 1,
      anon_sym_as,
    ACTIONS(3238), 1,
      anon_sym_module,
    STATE(1162), 1,
      sym_decorator,
    STATE(3252), 1,
      sym_internal_module,
    STATE(3253), 1,
      sym_declaration,
    STATE(3333), 1,
      aux_sym_export_statement_repeat1,
    STATE(3401), 1,
      sym_export_clause,
    STATE(3866), 1,
      sym_namespace_export,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3254), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [18766] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3296), 1,
      anon_sym_DOT,
    ACTIONS(3298), 1,
      anon_sym_LT,
    ACTIONS(3300), 1,
      anon_sym_is,
    STATE(1358), 1,
      sym_type_arguments,
    ACTIONS(3294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3056), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18829] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_LT,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3308), 1,
      anon_sym_DOT,
    STATE(1308), 1,
      sym_arguments,
    STATE(1321), 1,
      sym_type_arguments,
    ACTIONS(3302), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3304), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18894] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_LT,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_QMARK_DOT,
    STATE(1315), 1,
      sym_type_arguments,
    STATE(1520), 1,
      sym_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3310), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3312), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [18965] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_LT,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3324), 1,
      anon_sym_DOT,
    STATE(1249), 1,
      sym_arguments,
    STATE(1303), 1,
      sym_type_arguments,
    ACTIONS(3320), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3322), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19030] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_LT,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_DOT,
    STATE(1253), 1,
      sym_type_arguments,
    STATE(1255), 1,
      sym_arguments,
    ACTIONS(2969), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2959), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    STATE(1408), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3328), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3330), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
      anon_sym_implements,
  [19155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 15,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
    ACTIONS(1437), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 15,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
      anon_sym_QMARK,
    ACTIONS(1497), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3334), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [19317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1412), 1,
      sym_statement_block,
    ACTIONS(1381), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1379), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [19375] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      anon_sym_DOT,
    STATE(1412), 1,
      sym_statement_block,
    ACTIONS(1381), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1379), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [19435] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3340), 1,
      anon_sym_DOT,
    STATE(1412), 1,
      sym_statement_block,
    ACTIONS(1381), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1379), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [19495] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(224), 1,
      anon_sym_STAR,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(238), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(3344), 1,
      anon_sym_RBRACE,
    ACTIONS(3346), 1,
      anon_sym_LBRACK,
    ACTIONS(3348), 1,
      anon_sym_async,
    ACTIONS(3350), 1,
      anon_sym_static,
    ACTIONS(3352), 1,
      anon_sym_readonly,
    ACTIONS(3358), 1,
      anon_sym_override,
    STATE(2286), 1,
      sym_accessibility_modifier,
    STATE(2301), 1,
      sym_override_modifier,
    STATE(3544), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3630), 1,
      aux_sym_object_repeat1,
    ACTIONS(242), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3354), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3356), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2916), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3541), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3683), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3342), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [19593] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(224), 1,
      anon_sym_STAR,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(238), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(3346), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      anon_sym_RBRACE,
    ACTIONS(3364), 1,
      anon_sym_async,
    ACTIONS(3366), 1,
      anon_sym_static,
    ACTIONS(3368), 1,
      anon_sym_readonly,
    ACTIONS(3374), 1,
      anon_sym_override,
    STATE(2286), 1,
      sym_accessibility_modifier,
    STATE(2301), 1,
      sym_override_modifier,
    STATE(3544), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3630), 1,
      aux_sym_object_repeat1,
    ACTIONS(242), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3370), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3372), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2916), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3541), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3683), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3360), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [19691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_is,
    ACTIONS(3376), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3378), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_is,
    ACTIONS(3380), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3382), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_is,
    ACTIONS(3386), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3388), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19859] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(224), 1,
      anon_sym_STAR,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(238), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(3346), 1,
      anon_sym_LBRACK,
    ACTIONS(3392), 1,
      anon_sym_RBRACE,
    ACTIONS(3394), 1,
      anon_sym_async,
    ACTIONS(3396), 1,
      anon_sym_static,
    ACTIONS(3398), 1,
      anon_sym_readonly,
    ACTIONS(3404), 1,
      anon_sym_override,
    STATE(2286), 1,
      sym_accessibility_modifier,
    STATE(2301), 1,
      sym_override_modifier,
    STATE(3543), 1,
      aux_sym_object_repeat1,
    STATE(3544), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(242), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3400), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3402), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2916), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3541), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3542), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3390), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [19957] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3296), 1,
      anon_sym_DOT,
    ACTIONS(3298), 1,
      anon_sym_LT,
    STATE(1358), 1,
      sym_type_arguments,
    ACTIONS(3294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3056), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20017] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(224), 1,
      anon_sym_STAR,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(238), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(3346), 1,
      anon_sym_LBRACK,
    ACTIONS(3408), 1,
      anon_sym_RBRACE,
    ACTIONS(3410), 1,
      anon_sym_async,
    ACTIONS(3412), 1,
      anon_sym_static,
    ACTIONS(3414), 1,
      anon_sym_readonly,
    ACTIONS(3420), 1,
      anon_sym_override,
    STATE(2286), 1,
      sym_accessibility_modifier,
    STATE(2301), 1,
      sym_override_modifier,
    STATE(3544), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3630), 1,
      aux_sym_object_repeat1,
    ACTIONS(242), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3416), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3418), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2916), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3541), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3683), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3406), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [20115] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(224), 1,
      anon_sym_STAR,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(238), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(3346), 1,
      anon_sym_LBRACK,
    ACTIONS(3424), 1,
      anon_sym_RBRACE,
    ACTIONS(3426), 1,
      anon_sym_async,
    ACTIONS(3428), 1,
      anon_sym_static,
    ACTIONS(3430), 1,
      anon_sym_readonly,
    ACTIONS(3436), 1,
      anon_sym_override,
    STATE(2286), 1,
      sym_accessibility_modifier,
    STATE(2301), 1,
      sym_override_modifier,
    STATE(3543), 1,
      aux_sym_object_repeat1,
    STATE(3544), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(242), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3432), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3434), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2916), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3541), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3542), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3422), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [20213] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(224), 1,
      anon_sym_STAR,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(238), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(3346), 1,
      anon_sym_LBRACK,
    ACTIONS(3440), 1,
      anon_sym_RBRACE,
    ACTIONS(3442), 1,
      anon_sym_async,
    ACTIONS(3444), 1,
      anon_sym_static,
    ACTIONS(3446), 1,
      anon_sym_readonly,
    ACTIONS(3452), 1,
      anon_sym_override,
    STATE(2286), 1,
      sym_accessibility_modifier,
    STATE(2301), 1,
      sym_override_modifier,
    STATE(3544), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3630), 1,
      aux_sym_object_repeat1,
    ACTIONS(242), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3448), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3450), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2916), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3541), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3683), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3438), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [20311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1407), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1405), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [20365] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(224), 1,
      anon_sym_STAR,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(238), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(3346), 1,
      anon_sym_LBRACK,
    ACTIONS(3456), 1,
      anon_sym_RBRACE,
    ACTIONS(3458), 1,
      anon_sym_async,
    ACTIONS(3460), 1,
      anon_sym_static,
    ACTIONS(3462), 1,
      anon_sym_readonly,
    ACTIONS(3468), 1,
      anon_sym_override,
    STATE(2286), 1,
      sym_accessibility_modifier,
    STATE(2301), 1,
      sym_override_modifier,
    STATE(3544), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3630), 1,
      aux_sym_object_repeat1,
    ACTIONS(242), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3464), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3466), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2916), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3541), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3683), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3454), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [20463] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3014), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [20525] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(3470), 1,
      sym__automatic_semicolon,
    ACTIONS(1395), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1393), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [20583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_LT,
    STATE(1380), 1,
      sym_type_arguments,
    ACTIONS(3380), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3382), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2723), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2725), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20694] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3486), 1,
      anon_sym_LT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [20777] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_LBRACE,
    STATE(1471), 1,
      sym_statement_block,
    ACTIONS(1381), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1379), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [20834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3497), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3501), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3505), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3501), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3509), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3505), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3513), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1973), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3501), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1981), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3517), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3521), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3525), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21523] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3529), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [21636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3525), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3567), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3569), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3573), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3525), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3388), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3577), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3581), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2935), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22166] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_AMP,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 1,
      anon_sym_extends,
    ACTIONS(3583), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3585), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [22225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    ACTIONS(3593), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3595), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3599), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3601), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22333] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_QMARK_DOT,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(1529), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1531), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [22394] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_AMP,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 1,
      anon_sym_extends,
    ACTIONS(3603), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3605), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [22453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2721), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3380), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3382), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3577), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22612] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3607), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [22725] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_AMP,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 1,
      anon_sym_extends,
    ACTIONS(3579), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3581), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [22784] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3609), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3611), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [22841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3613), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3615), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22894] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3629), 1,
      anon_sym_extends,
    ACTIONS(3623), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3626), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [22955] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(1989), 1,
      anon_sym_extends,
    ACTIONS(3631), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3634), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1397), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [23016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3637), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3639), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23069] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3641), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [23182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1501), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [23235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3645), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23288] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3647), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [23401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3651), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3655), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3577), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23560] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3486), 1,
      anon_sym_LT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [23637] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3657), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [23750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_AMP,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 1,
      anon_sym_extends,
    ACTIONS(3659), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3661), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [23809] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3549), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3663), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3665), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [23874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3651), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3655), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3669), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24033] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3673), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [24148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3675), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3681), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3505), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24307] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3549), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [24394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3470), 1,
      sym__automatic_semicolon,
    ACTIONS(1395), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1393), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [24449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3685), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1423), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1421), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [24555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3669), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3681), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24661] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3687), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [24774] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [24875] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [24978] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    STATE(1397), 1,
      sym_arguments,
    ACTIONS(3689), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3691), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [25035] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3549), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [25130] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_LBRACE,
    ACTIONS(3693), 1,
      anon_sym_DOT,
    STATE(1471), 1,
      sym_statement_block,
    ACTIONS(1381), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1379), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [25189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_LBRACE,
    ACTIONS(3695), 1,
      anon_sym_DOT,
    STATE(1471), 1,
      sym_statement_block,
    ACTIONS(1381), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1379), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [25248] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3549), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [25345] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3549), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [25444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3697), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3699), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25497] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3486), 1,
      anon_sym_LT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [25578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25631] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3486), 1,
      anon_sym_LT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 18,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [25714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3707), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3711), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1989), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3707), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3713), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3715), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25979] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3717), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [26092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3376), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3378), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3711), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3719), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3721), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26251] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3723), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [26364] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_AMP,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 1,
      anon_sym_extends,
    ACTIONS(3725), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3727), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [26423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      sym__automatic_semicolon,
    ACTIONS(1461), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1459), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [26478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3731), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3733), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2727), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2729), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_AMP,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 1,
      anon_sym_extends,
    ACTIONS(3735), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3737), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [26643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3743), 1,
      anon_sym_DOT,
    ACTIONS(3739), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3741), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3745), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3747), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3751), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3753), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3629), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2927), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26910] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3549), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3476), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [27001] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [27106] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3759), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3755), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3757), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [27181] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_AMP,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 1,
      anon_sym_extends,
    ACTIONS(3762), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3764), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [27240] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3770), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3766), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3768), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [27311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3773), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3775), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3779), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3783), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_AMP,
    ACTIONS(3785), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3609), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [27633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3791), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_DOT,
    ACTIONS(3793), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3795), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3802), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3804), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3806), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1985), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1977), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_AMP,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 1,
      anon_sym_extends,
    ACTIONS(3808), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3810), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [28012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3812), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3814), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [28065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_AMP,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3818), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [28120] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3595), 1,
      anon_sym_extends,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    ACTIONS(3593), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3820), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3822), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [28179] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3824), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [28292] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3826), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [28405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3830), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [28458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3834), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [28511] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_AMP,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 1,
      anon_sym_extends,
    ACTIONS(3836), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3838), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [28570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 1,
      anon_sym_extends,
    ACTIONS(3840), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3842), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [28625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3830), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [28678] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3846), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [28791] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3848), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [28904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3830), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [28957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    ACTIONS(3850), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3852), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [29012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2931), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [29065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3838), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [29118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3854), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3856), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [29171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3858), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3860), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [29224] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3866), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3862), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3864), 19,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [29305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [29358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3869), 1,
      anon_sym_DOT,
    ACTIONS(3793), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3795), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [29413] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [29507] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3529), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [29619] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3946), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3766), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3768), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [29689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1431), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1433), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [29741] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3723), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [29853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [29905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1473), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [29957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1423), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1421), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [30009] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3963), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3755), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3757), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [30083] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3966), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3862), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3864), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [30163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3969), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3971), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [30215] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_DOT,
    ACTIONS(3975), 1,
      anon_sym_LT,
    ACTIONS(3977), 1,
      anon_sym_is,
    STATE(1798), 1,
      sym_type_arguments,
    ACTIONS(3294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3056), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [30275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1477), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [30327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3981), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [30379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3826), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [30431] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3985), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [30513] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3848), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [30625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3988), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3617), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [30681] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(3991), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(4115), 1,
      sym_type_annotation,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [30799] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(3993), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(4104), 1,
      sym_type_annotation,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [30917] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3995), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3862), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3864), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [30997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1557), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4000), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4002), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4004), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4006), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4008), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4010), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4012), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1547), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1477), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [31361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1533), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [31413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1467), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1469), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31465] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 1,
      anon_sym_extends,
    ACTIONS(4014), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4020), 1,
      sym__automatic_semicolon,
    ACTIONS(1395), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1393), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [31577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1521), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31629] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    ACTIONS(4022), 1,
      anon_sym_COMMA,
    ACTIONS(4025), 1,
      anon_sym_RBRACE,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3607), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [31745] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_extends,
    ACTIONS(4027), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31803] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3723), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [31915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4033), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31967] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3657), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [32079] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    ACTIONS(4037), 1,
      anon_sym_COMMA,
    ACTIONS(4040), 1,
      anon_sym_RBRACE,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3607), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [32195] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    ACTIONS(4040), 1,
      anon_sym_RBRACE,
    ACTIONS(4042), 1,
      anon_sym_COMMA,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3647), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [32311] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3755), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3757), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [32385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1567), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [32437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1417), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [32489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4048), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4050), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [32541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3216), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [32593] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    ACTIONS(4040), 1,
      anon_sym_RBRACE,
    ACTIONS(4042), 1,
      anon_sym_COMMA,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4052), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [32709] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3848), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [32821] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3647), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [32933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4056), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [32985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3659), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3661), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1587), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33089] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3892), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3663), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3665), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [33153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1509), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1511), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1575), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1577), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1483), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1481), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [33309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(1397), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4058), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4060), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33415] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3975), 1,
      anon_sym_LT,
    ACTIONS(4062), 1,
      anon_sym_QMARK_DOT,
    STATE(1647), 1,
      sym_type_arguments,
    STATE(1927), 1,
      sym_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3310), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3312), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [33483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4064), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4066), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4070), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4072), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1489), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1491), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4076), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3657), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33743] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3529), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [33855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4080), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4084), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4078), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4082), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [33911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1459), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33963] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_GT,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    ACTIONS(4089), 1,
      anon_sym_in,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4087), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [34077] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3717), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [34189] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3824), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [34301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4092), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4094), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34353] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3824), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [34465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1529), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1531), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34517] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3846), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [34629] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(224), 1,
      anon_sym_STAR,
    ACTIONS(238), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(3346), 1,
      anon_sym_LBRACK,
    ACTIONS(4098), 1,
      anon_sym_async,
    ACTIONS(4100), 1,
      anon_sym_static,
    ACTIONS(4102), 1,
      anon_sym_readonly,
    ACTIONS(4108), 1,
      anon_sym_override,
    STATE(2286), 1,
      sym_accessibility_modifier,
    STATE(2301), 1,
      sym_override_modifier,
    ACTIONS(242), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2989), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4104), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4106), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2916), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3845), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3847), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4096), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34719] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3826), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [34831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4110), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4112), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1459), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [34935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4114), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4116), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4080), 1,
      anon_sym_EQ,
    ACTIONS(4078), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4082), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4118), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4120), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35145] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_extends,
    ACTIONS(4122), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4125), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4033), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35203] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3932), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3663), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3665), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [35267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4128), 1,
      sym__automatic_semicolon,
    ACTIONS(1461), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1459), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [35321] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3657), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [35433] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3647), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [35545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4130), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1397), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [35601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1533), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35653] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [35757] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3476), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [35847] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3687), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [35959] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4133), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [36071] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(4135), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3766), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3768), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [36141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4138), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3641), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36193] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3985), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [36273] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [36371] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [36467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4140), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4142), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4144), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4146), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36571] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3985), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [36653] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [36755] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [36855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4148), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4150), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1501), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36959] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3717), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [37071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1483), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1481), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4152), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4154), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4156), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3529), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37227] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [37313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4158), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4160), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37365] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3687), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [37477] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3846), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [37589] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3826), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [37701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4162), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4164), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1539), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1537), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37805] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [37909] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3476), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [37999] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4166), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(4000), 1,
      sym_type_annotation,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4168), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4170), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4172), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4174), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4178), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1539), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1537), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [38325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4182), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4184), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4186), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4188), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4190), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38481] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3607), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [38593] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4192), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [38675] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3914), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    ACTIONS(3940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3944), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3641), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [38787] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3985), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [38863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4197), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3824), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38967] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4192), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [39043] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [39129] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39229] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4192), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [39309] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3912), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3924), 1,
      anon_sym_PIPE,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4201), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4203), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39463] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4192), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [39545] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4205), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(4204), 1,
      sym_type_annotation,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4207), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3687), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39715] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39809] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3975), 1,
      anon_sym_LT,
    ACTIONS(4209), 1,
      anon_sym_DOT,
    STATE(1769), 1,
      sym_type_arguments,
    STATE(1770), 1,
      sym_arguments,
    ACTIONS(2969), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2959), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [39871] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3641), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [39983] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4040), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4211), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40097] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3922), 1,
      anon_sym_CARET,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [40195] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3975), 1,
      anon_sym_LT,
    ACTIONS(4213), 1,
      anon_sym_DOT,
    STATE(1767), 1,
      sym_type_arguments,
    STATE(1768), 1,
      sym_arguments,
    ACTIONS(3320), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3322), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [40257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1473), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [40309] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3916), 1,
      anon_sym_GT_GT,
    ACTIONS(3920), 1,
      anon_sym_AMP,
    ACTIONS(3928), 1,
      anon_sym_PERCENT,
    ACTIONS(3930), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3932), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3904), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3910), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3918), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3926), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3936), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3938), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3934), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [40405] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3607), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [40517] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3975), 1,
      anon_sym_LT,
    ACTIONS(4215), 1,
      anon_sym_DOT,
    STATE(1765), 1,
      sym_type_arguments,
    STATE(1766), 1,
      sym_arguments,
    ACTIONS(3302), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3304), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [40579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3617), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [40633] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4217), 1,
      anon_sym_STAR,
    ACTIONS(4219), 1,
      anon_sym_RBRACE,
    ACTIONS(4221), 1,
      anon_sym_async,
    ACTIONS(4225), 1,
      anon_sym_AT,
    ACTIONS(4227), 1,
      anon_sym_static,
    ACTIONS(4229), 1,
      anon_sym_readonly,
    ACTIONS(4233), 1,
      anon_sym_declare,
    ACTIONS(4235), 1,
      anon_sym_abstract,
    STATE(2221), 1,
      sym_method_definition,
    STATE(2269), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(3411), 1,
      sym_method_signature,
    ACTIONS(4223), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4231), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1564), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2502), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3694), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [40728] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4217), 1,
      anon_sym_STAR,
    ACTIONS(4221), 1,
      anon_sym_async,
    ACTIONS(4225), 1,
      anon_sym_AT,
    ACTIONS(4227), 1,
      anon_sym_static,
    ACTIONS(4229), 1,
      anon_sym_readonly,
    ACTIONS(4233), 1,
      anon_sym_declare,
    ACTIONS(4235), 1,
      anon_sym_abstract,
    ACTIONS(4237), 1,
      anon_sym_RBRACE,
    STATE(2221), 1,
      sym_method_definition,
    STATE(2269), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(3411), 1,
      sym_method_signature,
    ACTIONS(4223), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4231), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1535), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2502), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3694), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [40823] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4217), 1,
      anon_sym_STAR,
    ACTIONS(4221), 1,
      anon_sym_async,
    ACTIONS(4225), 1,
      anon_sym_AT,
    ACTIONS(4227), 1,
      anon_sym_static,
    ACTIONS(4229), 1,
      anon_sym_readonly,
    ACTIONS(4233), 1,
      anon_sym_declare,
    ACTIONS(4235), 1,
      anon_sym_abstract,
    ACTIONS(4239), 1,
      anon_sym_RBRACE,
    STATE(2221), 1,
      sym_method_definition,
    STATE(2269), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(3411), 1,
      sym_method_signature,
    ACTIONS(4223), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4231), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1542), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2502), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3694), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [40918] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    ACTIONS(4241), 1,
      anon_sym_COMMA,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4243), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41031] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3476), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [41120] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(4263), 1,
      anon_sym_RBRACK,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3503), 1,
      aux_sym_array_repeat1,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41235] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3826), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41346] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4217), 1,
      anon_sym_STAR,
    ACTIONS(4221), 1,
      anon_sym_async,
    ACTIONS(4225), 1,
      anon_sym_AT,
    ACTIONS(4227), 1,
      anon_sym_static,
    ACTIONS(4229), 1,
      anon_sym_readonly,
    ACTIONS(4233), 1,
      anon_sym_declare,
    ACTIONS(4235), 1,
      anon_sym_abstract,
    ACTIONS(4283), 1,
      anon_sym_RBRACE,
    STATE(2221), 1,
      sym_method_definition,
    STATE(2269), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(3411), 1,
      sym_method_signature,
    ACTIONS(4223), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4231), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1564), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2502), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3694), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41441] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    ACTIONS(4241), 1,
      anon_sym_COMMA,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3673), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41554] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3846), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41665] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_DOT,
    ACTIONS(3975), 1,
      anon_sym_LT,
    STATE(1798), 1,
      sym_type_arguments,
    ACTIONS(3294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3056), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [41722] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    STATE(1981), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3328), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3330), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [41779] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(4285), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3642), 1,
      aux_sym_array_repeat1,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41894] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3529), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3334), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_is,
  [42056] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3687), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42167] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(4287), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3636), 1,
      aux_sym_array_repeat1,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42282] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(4289), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3600), 1,
      aux_sym_array_repeat1,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42397] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(1989), 1,
      anon_sym_extends,
    ACTIONS(3631), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3634), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1397), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [42456] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [42559] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3629), 1,
      anon_sym_extends,
    ACTIONS(3623), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3626), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [42618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1407), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1405), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_is,
  [42669] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3824), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42780] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3723), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42891] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [42988] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3079), 1,
      anon_sym_QMARK,
    ACTIONS(3075), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [43045] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4291), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [43156] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(4293), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3657), 1,
      aux_sym_array_repeat1,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43271] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(4295), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3508), 1,
      aux_sym_array_repeat1,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43386] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4300), 1,
      anon_sym_STAR,
    ACTIONS(4303), 1,
      anon_sym_RBRACE,
    ACTIONS(4305), 1,
      anon_sym_LBRACK,
    ACTIONS(4308), 1,
      anon_sym_async,
    ACTIONS(4311), 1,
      anon_sym_DASH,
    ACTIONS(4314), 1,
      anon_sym_DQUOTE,
    ACTIONS(4317), 1,
      anon_sym_SQUOTE,
    ACTIONS(4323), 1,
      anon_sym_AT,
    ACTIONS(4326), 1,
      anon_sym_static,
    ACTIONS(4329), 1,
      anon_sym_readonly,
    ACTIONS(4335), 1,
      anon_sym_declare,
    ACTIONS(4341), 1,
      anon_sym_override,
    ACTIONS(4344), 1,
      anon_sym_abstract,
    STATE(2221), 1,
      sym_method_definition,
    STATE(2269), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(3411), 1,
      sym_method_signature,
    ACTIONS(4320), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4332), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4338), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1564), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2502), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3694), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4297), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [43481] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4217), 1,
      anon_sym_STAR,
    ACTIONS(4221), 1,
      anon_sym_async,
    ACTIONS(4225), 1,
      anon_sym_AT,
    ACTIONS(4227), 1,
      anon_sym_static,
    ACTIONS(4229), 1,
      anon_sym_readonly,
    ACTIONS(4233), 1,
      anon_sym_declare,
    ACTIONS(4235), 1,
      anon_sym_abstract,
    ACTIONS(4347), 1,
      anon_sym_RBRACE,
    STATE(2221), 1,
      sym_method_definition,
    STATE(2269), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(3411), 1,
      sym_method_signature,
    ACTIONS(4223), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4231), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1564), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2502), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3694), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [43576] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(4349), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3675), 1,
      aux_sym_array_repeat1,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43691] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4217), 1,
      anon_sym_STAR,
    ACTIONS(4221), 1,
      anon_sym_async,
    ACTIONS(4225), 1,
      anon_sym_AT,
    ACTIONS(4227), 1,
      anon_sym_static,
    ACTIONS(4229), 1,
      anon_sym_readonly,
    ACTIONS(4233), 1,
      anon_sym_declare,
    ACTIONS(4235), 1,
      anon_sym_abstract,
    ACTIONS(4351), 1,
      anon_sym_RBRACE,
    STATE(2221), 1,
      sym_method_definition,
    STATE(2269), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(3411), 1,
      sym_method_signature,
    ACTIONS(4223), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4231), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1608), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2502), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3694), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [43786] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 16,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [43867] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(4356), 1,
      anon_sym_RBRACK,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3503), 1,
      aux_sym_array_repeat1,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43982] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(4259), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3663), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3665), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
      anon_sym_implements,
  [44045] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4358), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3755), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3757), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [44118] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4361), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3862), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3864), 17,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [44197] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3657), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44308] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    ACTIONS(4241), 1,
      anon_sym_COMMA,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4364), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44421] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3848), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44532] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3647), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44643] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4366), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3766), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3768), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
      anon_sym_implements,
  [44712] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3717), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44823] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3014), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [44882] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4369), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1397), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [44937] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4217), 1,
      anon_sym_STAR,
    ACTIONS(4221), 1,
      anon_sym_async,
    ACTIONS(4225), 1,
      anon_sym_AT,
    ACTIONS(4227), 1,
      anon_sym_static,
    ACTIONS(4229), 1,
      anon_sym_readonly,
    ACTIONS(4233), 1,
      anon_sym_declare,
    ACTIONS(4235), 1,
      anon_sym_abstract,
    ACTIONS(4371), 1,
      anon_sym_RBRACE,
    STATE(2221), 1,
      sym_method_definition,
    STATE(2269), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(3411), 1,
      sym_method_signature,
    ACTIONS(4223), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4231), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1564), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2502), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3694), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [45032] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      anon_sym_extends,
    ACTIONS(4027), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [45091] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(4030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3569), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [45150] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3607), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45261] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3641), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45372] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4087), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [45483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4080), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4373), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4078), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4082), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [45538] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [45613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4375), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3617), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [45668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3975), 1,
      anon_sym_LT,
    STATE(1790), 1,
      sym_type_arguments,
    ACTIONS(3380), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3382), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [45723] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [45808] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    ACTIONS(4241), 1,
      anon_sym_COMMA,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4377), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45921] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(4379), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3691), 1,
      aux_sym_array_repeat1,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46036] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4217), 1,
      anon_sym_STAR,
    ACTIONS(4221), 1,
      anon_sym_async,
    ACTIONS(4225), 1,
      anon_sym_AT,
    ACTIONS(4227), 1,
      anon_sym_static,
    ACTIONS(4229), 1,
      anon_sym_readonly,
    ACTIONS(4233), 1,
      anon_sym_declare,
    ACTIONS(4235), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      anon_sym_RBRACE,
    STATE(2221), 1,
      sym_method_definition,
    STATE(2269), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(3411), 1,
      sym_method_signature,
    ACTIONS(4223), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4231), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1581), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2502), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3694), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46131] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3073), 1,
      anon_sym_QMARK,
    ACTIONS(3070), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [46188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3073), 1,
      anon_sym_QMARK,
    ACTIONS(3087), 1,
      anon_sym_EQ,
    ACTIONS(3090), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [46245] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4383), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [46356] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [46435] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [46534] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(4385), 1,
      anon_sym_RBRACK,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3515), 1,
      aux_sym_array_repeat1,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46649] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4217), 1,
      anon_sym_STAR,
    ACTIONS(4221), 1,
      anon_sym_async,
    ACTIONS(4225), 1,
      anon_sym_AT,
    ACTIONS(4227), 1,
      anon_sym_static,
    ACTIONS(4229), 1,
      anon_sym_readonly,
    ACTIONS(4233), 1,
      anon_sym_declare,
    ACTIONS(4235), 1,
      anon_sym_abstract,
    ACTIONS(4387), 1,
      anon_sym_RBRACE,
    STATE(2221), 1,
      sym_method_definition,
    STATE(2269), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(3411), 1,
      sym_method_signature,
    ACTIONS(4223), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4231), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1565), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2502), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3694), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46744] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3623), 1,
      anon_sym_LBRACK,
    ACTIONS(3626), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4389), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3629), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3617), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [46805] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3647), 1,
      anon_sym_COMMA,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4052), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46918] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4281), 1,
      sym__ternary_qmark,
    STATE(1884), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4393), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [47029] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    ACTIONS(4271), 1,
      anon_sym_CARET,
    ACTIONS(4273), 1,
      anon_sym_PIPE,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [47130] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [47211] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    ACTIONS(4269), 1,
      anon_sym_AMP,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [47306] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(2817), 1,
      anon_sym_DASH,
    ACTIONS(3178), 1,
      anon_sym_LBRACK,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4217), 1,
      anon_sym_STAR,
    ACTIONS(4221), 1,
      anon_sym_async,
    ACTIONS(4225), 1,
      anon_sym_AT,
    ACTIONS(4227), 1,
      anon_sym_static,
    ACTIONS(4229), 1,
      anon_sym_readonly,
    ACTIONS(4233), 1,
      anon_sym_declare,
    ACTIONS(4235), 1,
      anon_sym_abstract,
    ACTIONS(4395), 1,
      anon_sym_RBRACE,
    STATE(2221), 1,
      sym_method_definition,
    STATE(2269), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(3411), 1,
      sym_method_signature,
    ACTIONS(4223), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4231), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1564), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2502), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3694), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3168), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47401] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4249), 1,
      anon_sym_GT_GT,
    ACTIONS(4255), 1,
      anon_sym_PERCENT,
    ACTIONS(4257), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4245), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4247), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4251), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4253), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4275), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4261), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [47494] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(3631), 1,
      anon_sym_LBRACK,
    ACTIONS(3634), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4397), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1989), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1397), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [47555] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3882), 1,
      anon_sym_GT_GT,
    ACTIONS(3888), 1,
      anon_sym_PERCENT,
    ACTIONS(3890), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3892), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(3949), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3951), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3953), 1,
      anon_sym_AMP,
    ACTIONS(3955), 1,
      anon_sym_CARET,
    ACTIONS(3957), 1,
      anon_sym_PIPE,
    ACTIONS(3959), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3961), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3872), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3884), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3886), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3898), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3894), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4087), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [47666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3977), 1,
      anon_sym_is,
    ACTIONS(3386), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3388), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [47719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_is,
    ACTIONS(3380), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3382), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [47772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3977), 1,
      anon_sym_is,
    ACTIONS(3376), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3378), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [47825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3505), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [47875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3380), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3382), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [47925] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4407), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4080), 1,
      anon_sym_EQ,
    ACTIONS(4078), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4082), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [48087] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3824), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48197] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3687), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48307] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3529), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48417] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3846), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48527] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3826), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48637] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [48739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4479), 1,
      anon_sym_PIPE,
    ACTIONS(4481), 1,
      anon_sym_extends,
    ACTIONS(3735), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3737), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [48795] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4479), 1,
      anon_sym_PIPE,
    ACTIONS(4481), 1,
      anon_sym_extends,
    ACTIONS(3725), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3727), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [48851] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3476), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [48939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(1397), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [48991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3376), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3378), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [49041] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4483), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 15,
      sym__ternary_qmark,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49121] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4483), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [49199] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [49295] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [49389] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [49481] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4483), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [49561] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [49661] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [49759] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [49843] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4483), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [49917] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3609), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [49971] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3623), 1,
      anon_sym_LBRACK,
    ACTIONS(3629), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3626), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [50029] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(3631), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3634), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1397), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [50087] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3641), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50197] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3607), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50307] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3717), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50417] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3717), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    STATE(1829), 1,
      sym_arguments,
    ACTIONS(3689), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3691), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [50581] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 1,
      anon_sym_extends,
    ACTIONS(4014), 1,
      anon_sym_LBRACK,
    ACTIONS(4490), 1,
      anon_sym_RPAREN,
    ACTIONS(4017), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4486), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4488), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [50643] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3073), 1,
      anon_sym_QMARK,
    ACTIONS(3087), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(3090), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3569), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [50705] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4493), 1,
      anon_sym_RBRACE,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50817] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4479), 1,
      anon_sym_PIPE,
    ACTIONS(4481), 1,
      anon_sym_extends,
    ACTIONS(3659), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3661), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [50873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2723), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2725), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [50923] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 1,
      anon_sym_extends,
    ACTIONS(4014), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [50979] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      anon_sym_extends,
    ACTIONS(4027), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [51037] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4479), 1,
      anon_sym_PIPE,
    ACTIONS(4481), 1,
      anon_sym_extends,
    ACTIONS(3762), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3764), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [51093] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 1,
      anon_sym_extends,
    ACTIONS(3631), 1,
      anon_sym_LBRACK,
    ACTIONS(4397), 1,
      anon_sym_RPAREN,
    ACTIONS(1399), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3634), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4130), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1397), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [51155] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3623), 1,
      anon_sym_LBRACK,
    ACTIONS(3629), 1,
      anon_sym_extends,
    ACTIONS(4389), 1,
      anon_sym_RPAREN,
    ACTIONS(3619), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3626), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3988), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3617), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [51217] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4495), 1,
      anon_sym_RBRACK,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51329] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4497), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51439] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4499), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3766), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3768), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [51507] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3848), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51617] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4502), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3755), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3757), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [51689] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3647), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51799] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3657), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51909] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3663), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3665), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [51971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(4020), 1,
      sym__automatic_semicolon,
    ACTIONS(1395), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1393), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [52025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3617), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [52077] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4479), 1,
      anon_sym_PIPE,
    ACTIONS(4481), 1,
      anon_sym_extends,
    ACTIONS(3583), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3585), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [52133] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3723), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52243] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4505), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3862), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3864), 16,
      sym__ternary_qmark,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3573), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3830), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3830), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3830), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52521] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4508), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52633] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4510), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52745] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4512), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52857] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4514), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52969] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(4062), 1,
      anon_sym_QMARK_DOT,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(1529), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1531), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [53027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3501), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3501), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3501), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53227] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3233), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4526), 1,
      anon_sym_readonly,
    STATE(2304), 1,
      sym_override_modifier,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3751), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1977), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53511] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3607), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53621] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3641), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53731] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4530), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [53805] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [53889] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4533), 1,
      anon_sym_RBRACK,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3517), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3731), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3733), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3719), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3721), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3577), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3577), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54251] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3267), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4526), 1,
      anon_sym_readonly,
    STATE(2304), 1,
      sym_override_modifier,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3577), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3525), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3525), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3525), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3505), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3505), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3854), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3856), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1981), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54735] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [54833] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [54933] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4530), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [55013] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [55105] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [55199] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [55295] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4530), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [55373] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4530), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [55453] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3476), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [55541] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 6,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [55643] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3826), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55753] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3846), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55863] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(1989), 1,
      anon_sym_extends,
    ACTIONS(1991), 1,
      anon_sym_QMARK,
    ACTIONS(3631), 1,
      anon_sym_LBRACK,
    ACTIONS(4369), 1,
      anon_sym_COLON,
    ACTIONS(3634), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4397), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1397), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [55927] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3623), 1,
      anon_sym_LBRACK,
    ACTIONS(3629), 1,
      anon_sym_extends,
    ACTIONS(3753), 1,
      anon_sym_QMARK,
    ACTIONS(4375), 1,
      anon_sym_COLON,
    ACTIONS(3626), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4389), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3617), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [55991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4479), 1,
      anon_sym_PIPE,
    ACTIONS(4481), 1,
      anon_sym_extends,
    ACTIONS(3579), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3581), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [56047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3581), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3599), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3601), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2931), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4479), 1,
      anon_sym_PIPE,
    ACTIONS(4481), 1,
      anon_sym_extends,
    ACTIONS(3603), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3605), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [56253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3613), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3615), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3645), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3651), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3655), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3651), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3655), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3669), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3681), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3669), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3681), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3707), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3711), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3707), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3711), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3779), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [57003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3804), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3806), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [57053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1985), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [57103] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3647), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57213] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3657), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57323] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4535), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57433] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3529), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57543] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3687), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57653] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3824), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57763] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3264), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4526), 1,
      anon_sym_readonly,
    STATE(2304), 1,
      sym_override_modifier,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3812), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3814), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [57897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3818), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [57949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3834), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [57999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2935), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4479), 1,
      anon_sym_PIPE,
    ACTIONS(4481), 1,
      anon_sym_extends,
    ACTIONS(3836), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3838), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [58105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3838), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_DOT,
    ACTIONS(3793), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3795), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3869), 1,
      anon_sym_DOT,
    ACTIONS(3793), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3795), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3783), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3713), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3715), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_extends,
    ACTIONS(4122), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4125), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4033), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [58465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3609), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3611), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [58519] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3249), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4526), 1,
      anon_sym_readonly,
    STATE(2304), 1,
      sym_override_modifier,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3697), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3699), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3685), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3675), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3497), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3509), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3513), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1973), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58953] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 1,
      anon_sym_extends,
    ACTIONS(3631), 1,
      anon_sym_LBRACK,
    ACTIONS(4537), 1,
      anon_sym_RPAREN,
    ACTIONS(1399), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3634), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4369), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1397), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [59015] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3244), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4526), 1,
      anon_sym_readonly,
    STATE(2304), 1,
      sym_override_modifier,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59099] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3623), 1,
      anon_sym_LBRACK,
    ACTIONS(3629), 1,
      anon_sym_extends,
    ACTIONS(4540), 1,
      anon_sym_RPAREN,
    ACTIONS(3619), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3626), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4375), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3617), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [59161] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4543), 1,
      anon_sym_RBRACK,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [59325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4027), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3569), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [59381] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    ACTIONS(4545), 1,
      anon_sym_SEMI,
    ACTIONS(4547), 1,
      sym__automatic_semicolon,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2721), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [59543] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4549), 1,
      anon_sym_RBRACK,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59655] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4125), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4122), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3791), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4033), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [59711] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    ACTIONS(4551), 1,
      anon_sym_SEMI,
    ACTIONS(4553), 1,
      sym__automatic_semicolon,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59823] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4014), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3388), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [59879] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4040), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59989] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60099] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4555), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60211] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3723), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60321] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 1,
      anon_sym_extends,
    ACTIONS(4014), 1,
      anon_sym_LBRACK,
    ACTIONS(4561), 1,
      anon_sym_RPAREN,
    ACTIONS(4017), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4557), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4559), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [60383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2927), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [60433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3858), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3860), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [60483] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60595] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(1403), 1,
      sym__automatic_semicolon,
    ACTIONS(1393), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1397), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [60651] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4566), 1,
      anon_sym_COLON,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LBRACK,
    ACTIONS(3850), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3852), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [60815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4570), 1,
      anon_sym_extends,
    ACTIONS(3840), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3842), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [60867] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3595), 1,
      anon_sym_extends,
    ACTIONS(4568), 1,
      anon_sym_LBRACK,
    ACTIONS(3593), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3820), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3822), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [60923] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4479), 1,
      anon_sym_PIPE,
    ACTIONS(4481), 1,
      anon_sym_extends,
    ACTIONS(3808), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3810), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [60979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3802), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3791), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3609), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(3785), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3773), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3775), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3753), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3629), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61281] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4572), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61393] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4574), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61505] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3073), 1,
      anon_sym_QMARK,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(3070), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3569), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61567] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 1,
      anon_sym_extends,
    ACTIONS(4014), 1,
      anon_sym_LBRACK,
    ACTIONS(4579), 1,
      anon_sym_RPAREN,
    ACTIONS(4017), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4486), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4576), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61629] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3482), 1,
      anon_sym_PERCENT,
    ACTIONS(3484), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3537), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3539), 1,
      anon_sym_GT_GT,
    ACTIONS(3543), 1,
      anon_sym_AMP,
    ACTIONS(3545), 1,
      anon_sym_CARET,
    ACTIONS(3547), 1,
      anon_sym_PIPE,
    ACTIONS(3549), 1,
      anon_sym_LT,
    ACTIONS(3557), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3561), 1,
      sym__ternary_qmark,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(4583), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3472), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3533), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3541), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3553), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3551), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61741] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_extends,
    ACTIONS(4027), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61797] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      anon_sym_extends,
    ACTIONS(4027), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3745), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3747), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4585), 1,
      anon_sym_DOT,
    ACTIONS(3739), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3741), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [62009] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3663), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3665), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [62071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1989), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      sym_regex_flags,
    ACTIONS(4587), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(4589), 24,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
  [62173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3521), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62223] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4211), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2727), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2729), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3637), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3639), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3567), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3569), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3388), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62533] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4413), 1,
      anon_sym_GT_GT,
    ACTIONS(4417), 1,
      anon_sym_AMP,
    ACTIONS(4419), 1,
      anon_sym_CARET,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4425), 1,
      anon_sym_PERCENT,
    ACTIONS(4427), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4437), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4439), 1,
      sym__ternary_qmark,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(3848), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4403), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4405), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4415), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4433), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4431), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62643] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(4593), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3766), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3768), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [62711] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4596), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3755), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3757), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [62783] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3902), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3906), 1,
      anon_sym_as,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(3942), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3862), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3864), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [62861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LBRACK,
    ACTIONS(3593), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3595), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62913] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    ACTIONS(4602), 1,
      anon_sym_RBRACK,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3981), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63071] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      anon_sym_extends,
    ACTIONS(4027), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [63128] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4604), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4606), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63181] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3267), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4612), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63256] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    ACTIONS(4614), 1,
      anon_sym_COLON,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4076), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3657), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63414] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1435), 1,
      sym__automatic_semicolon,
    ACTIONS(1427), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1431), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1433), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 1,
      sym__automatic_semicolon,
    ACTIONS(1591), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1595), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63520] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4616), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3766), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3768), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [63587] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3476), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [63674] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3723), 1,
      anon_sym_of,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63783] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    ACTIONS(4655), 1,
      anon_sym_COLON,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63892] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3824), 1,
      anon_sym_of,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64001] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 1,
      sym__automatic_semicolon,
    ACTIONS(1541), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1545), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1547), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 1,
      sym__automatic_semicolon,
    ACTIONS(1515), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1519), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1521), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1529), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1531), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4148), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4150), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64205] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3233), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4612), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64280] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [64381] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3233), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4657), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1431), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1433), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64656] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4659), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4661), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64709] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4663), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [64786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4118), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4120), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64835] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4659), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4661), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64888] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [64983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4659), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4661), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_EQ,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1529), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1531), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4666), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4668), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65191] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3267), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4657), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65268] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4670), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_COLON,
    ACTIONS(4675), 1,
      anon_sym_LT,
    ACTIONS(4678), 1,
      anon_sym_QMARK,
    ACTIONS(4162), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4164), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65325] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4680), 1,
      anon_sym_LPAREN,
    ACTIONS(4683), 1,
      anon_sym_COLON,
    ACTIONS(4685), 1,
      anon_sym_LT,
    ACTIONS(4688), 1,
      anon_sym_QMARK,
    ACTIONS(2941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65382] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3687), 1,
      anon_sym_of,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65491] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [65584] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    ACTIONS(4690), 1,
      anon_sym_COLON,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    ACTIONS(3115), 1,
      anon_sym_in,
    ACTIONS(3118), 1,
      anon_sym_of,
    ACTIONS(2941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4557), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4559), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65801] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [65892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4122), 1,
      anon_sym_LBRACK,
    ACTIONS(3791), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4125), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4033), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4694), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4486), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4576), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66053] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3529), 1,
      anon_sym_of,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66162] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1559), 1,
      sym__automatic_semicolon,
    ACTIONS(1551), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1555), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1557), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 1,
      sym__automatic_semicolon,
    ACTIONS(1561), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1565), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1567), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1467), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1469), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66317] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    ACTIONS(4696), 1,
      anon_sym_RBRACK,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66426] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4663), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [66505] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [66604] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      sym__automatic_semicolon,
    ACTIONS(1411), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1415), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1417), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4010), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4012), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66706] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4698), 1,
      anon_sym_STAR,
    ACTIONS(4700), 1,
      anon_sym_LBRACE,
    ACTIONS(4702), 1,
      anon_sym_async,
    ACTIONS(4706), 1,
      anon_sym_readonly,
    STATE(2274), 1,
      sym_statement_block,
    STATE(2311), 1,
      sym_override_modifier,
    ACTIONS(4704), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4708), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66783] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    STATE(1408), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4710), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3328), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3330), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [66840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4152), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4154), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4156), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3529), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4172), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4174), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4207), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3687), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3824), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4197), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67134] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1589), 1,
      sym__automatic_semicolon,
    ACTIONS(1581), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1585), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1587), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67187] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3264), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4612), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4158), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4160), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67311] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3264), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4657), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1467), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1469), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67439] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3567), 1,
      anon_sym_QMARK,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(4030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3569), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67498] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [67595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4056), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67644] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    ACTIONS(4712), 1,
      anon_sym_COLON,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67753] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4087), 1,
      anon_sym_of,
    ACTIONS(4621), 1,
      anon_sym_GT,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    ACTIONS(4714), 1,
      anon_sym_in,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67864] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(3569), 1,
      anon_sym_extends,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(4030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4717), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67925] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [68008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4162), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4164), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68057] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3103), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(3569), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68114] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4663), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [68187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3969), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3971), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68236] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3846), 1,
      anon_sym_of,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4070), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4064), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4066), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68443] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_extends,
    ACTIONS(4125), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4122), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(4033), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68498] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3249), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4657), 1,
      anon_sym_LBRACK,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4058), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4060), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4168), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4170), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68673] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3826), 1,
      anon_sym_of,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4072), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68831] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym__automatic_semicolon,
    ACTIONS(1463), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1467), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1469), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68884] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3249), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4612), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4014), 1,
      anon_sym_LBRACK,
    ACTIONS(3388), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4182), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69063] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1513), 1,
      sym__automatic_semicolon,
    ACTIONS(1505), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1509), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1511), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4178), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69165] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3244), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4612), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69240] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    ACTIONS(4721), 1,
      anon_sym_COLON,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4184), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4186), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4188), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4190), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4725), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4201), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4203), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 1,
      sym_regex_flags,
    ACTIONS(4587), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(4589), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
  [69600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4725), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4725), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69706] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3244), 1,
      anon_sym_RBRACE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4657), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4048), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4050), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69832] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3641), 1,
      anon_sym_of,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69941] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3607), 1,
      anon_sym_of,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70050] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3717), 1,
      anon_sym_of,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4140), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4142), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4729), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4731), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70261] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4733), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3755), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3757), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [70332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3609), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70385] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4736), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3862), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3864), 15,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70462] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4125), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4122), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(4033), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70519] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(3569), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70574] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3647), 1,
      anon_sym_of,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1417), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70732] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4486), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4488), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1567), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1557), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 1,
      sym__automatic_semicolon,
    ACTIONS(1571), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1575), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1577), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1521), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1547), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71034] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3848), 1,
      anon_sym_of,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 1,
      sym_regex_flags,
    ACTIONS(4587), 18,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(4589), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
  [71194] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1493), 1,
      sym__automatic_semicolon,
    ACTIONS(1485), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1489), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1491), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1485), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1489), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1491), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71298] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(4030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3569), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1575), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1577), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 1,
      sym__automatic_semicolon,
    ACTIONS(1505), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1509), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1511), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71461] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3657), 1,
      anon_sym_of,
    ACTIONS(4623), 1,
      anon_sym_GT_GT,
    ACTIONS(4629), 1,
      anon_sym_PERCENT,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4639), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4641), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_CARET,
    ACTIONS(4645), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4653), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4619), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4621), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4625), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4647), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4649), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4635), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71570] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(4633), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3663), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3665), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [71631] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    ACTIONS(4741), 1,
      anon_sym_COLON,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3826), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71789] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4631), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4663), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 14,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [71868] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_extends,
    ACTIONS(4030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4027), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4000), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71972] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    ACTIONS(4743), 1,
      anon_sym_COLON,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1587), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4002), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4004), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1509), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1511), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72228] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(3631), 1,
      anon_sym_LBRACK,
    ACTIONS(4369), 1,
      anon_sym_COLON,
    ACTIONS(3634), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1989), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1397), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4033), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72336] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3567), 1,
      anon_sym_QMARK,
    ACTIONS(3569), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4027), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1575), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1577), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72442] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3623), 1,
      anon_sym_LBRACK,
    ACTIONS(4375), 1,
      anon_sym_COLON,
    ACTIONS(3626), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3629), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3617), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1489), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1491), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4144), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4146), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4138), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3641), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72648] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(4375), 1,
      anon_sym_of,
    ACTIONS(4745), 1,
      anon_sym_in,
    ACTIONS(3617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1595), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72754] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4449), 1,
      anon_sym_GT_GT,
    ACTIONS(4453), 1,
      anon_sym_AMP,
    ACTIONS(4455), 1,
      anon_sym_CARET,
    ACTIONS(4457), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 1,
      anon_sym_PERCENT,
    ACTIONS(4463), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4465), 1,
      anon_sym_LT,
    ACTIONS(4473), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4475), 1,
      sym__ternary_qmark,
    ACTIONS(4748), 1,
      anon_sym_COLON,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4443), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4451), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4459), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4469), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4471), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4467), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(3569), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4006), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4008), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72969] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4750), 1,
      sym__automatic_semicolon,
    ACTIONS(1427), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1431), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1433), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1545), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1547), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1519), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1521), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4114), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4116), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3659), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3661), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73222] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4080), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_of,
    ACTIONS(4752), 1,
      anon_sym_in,
    ACTIONS(4078), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4082), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73277] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3623), 1,
      anon_sym_LBRACK,
    ACTIONS(3629), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3626), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73334] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(3631), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3634), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1397), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(4369), 1,
      anon_sym_of,
    ACTIONS(4755), 1,
      anon_sym_in,
    ACTIONS(1397), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1529), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1531), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1581), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1585), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1587), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1411), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1415), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1417), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3216), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4110), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4112), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4092), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4094), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 1,
      sym__automatic_semicolon,
    ACTIONS(1551), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1555), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1557), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4760), 1,
      sym__automatic_semicolon,
    ACTIONS(1561), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1565), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1567), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73852] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4762), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3862), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3864), 14,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [73928] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [74010] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74116] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_EQ,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [74272] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_static,
    ACTIONS(4805), 1,
      anon_sym_readonly,
    ACTIONS(4807), 1,
      anon_sym_abstract,
    STATE(2294), 1,
      sym_accessibility_modifier,
    STATE(2320), 1,
      sym_override_modifier,
    ACTIONS(4801), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3190), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74346] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(3569), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74400] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [74500] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4080), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_COLON,
    ACTIONS(4084), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4078), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4082), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74554] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3476), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [74640] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4809), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 13,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [74718] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4809), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [74794] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74900] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4014), 1,
      anon_sym_LBRACK,
    ACTIONS(3388), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74954] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75060] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3755), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3757), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [75130] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75236] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_extends,
    ACTIONS(4017), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4014), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75292] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3233), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75362] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75468] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4526), 1,
      anon_sym_readonly,
    STATE(2304), 1,
      sym_override_modifier,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75544] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75650] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75756] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3249), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75826] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3267), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75896] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3107), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(3569), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75952] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4809), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [76024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(3128), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [76076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      sym_regex_flags,
    ACTIONS(4587), 18,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4589), 21,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
  [76126] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4122), 1,
      anon_sym_LBRACK,
    ACTIONS(3791), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4125), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4033), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [76180] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3264), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76250] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(3908), 1,
      anon_sym_BANG,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(2097), 1,
      sym_type_arguments,
    STATE(3621), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1909), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76356] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(1989), 1,
      anon_sym_extends,
    ACTIONS(3631), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3634), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1397), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [76412] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_LPAREN,
    ACTIONS(2971), 1,
      anon_sym_LT,
    STATE(2580), 1,
      sym_arguments,
    STATE(2632), 1,
      sym_type_arguments,
    ACTIONS(2941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [76468] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(3609), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [76520] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4815), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3766), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3768), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [76586] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [76680] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(3476), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [76772] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [76862] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4809), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3474), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [76940] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3629), 1,
      anon_sym_extends,
    ACTIONS(3623), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3626), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3617), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [76996] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77102] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [77200] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3474), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [77296] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77402] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77508] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77614] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      anon_sym_extends,
    ACTIONS(4027), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [77670] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(4777), 1,
      anon_sym_LT,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3663), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3665), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [77730] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3244), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77800] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3314), 1,
      anon_sym_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3478), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3489), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(3491), 1,
      anon_sym_DASH_DASH,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3531), 1,
      anon_sym_BANG,
    ACTIONS(3559), 1,
      anon_sym_satisfies,
    ACTIONS(4767), 1,
      anon_sym_GT_GT,
    ACTIONS(4773), 1,
      anon_sym_PERCENT,
    ACTIONS(4775), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4777), 1,
      anon_sym_LT,
    ACTIONS(4781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4785), 1,
      anon_sym_AMP,
    ACTIONS(4787), 1,
      anon_sym_CARET,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    ACTIONS(4797), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4799), 1,
      sym__ternary_qmark,
    STATE(1224), 1,
      sym_type_arguments,
    STATE(3729), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4779), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4793), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4795), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1442), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4791), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77906] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1855), 1,
      anon_sym_RBRACE,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    STATE(2299), 1,
      sym_override_modifier,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77987] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4820), 1,
      anon_sym_STAR,
    ACTIONS(4822), 1,
      anon_sym_async,
    ACTIONS(4826), 1,
      anon_sym_readonly,
    STATE(2297), 1,
      sym_override_modifier,
    ACTIONS(4824), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4828), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2522), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4112), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4830), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4833), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78107] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(155), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(3346), 1,
      anon_sym_LBRACK,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(4840), 1,
      anon_sym_RBRACE,
    STATE(3624), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4842), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3663), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4145), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4836), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3103), 1,
      anon_sym_EQ,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4094), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4844), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4847), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78274] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4820), 1,
      anon_sym_STAR,
    ACTIONS(4822), 1,
      anon_sym_async,
    ACTIONS(4850), 1,
      anon_sym_abstract,
    ACTIONS(4824), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4828), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2522), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78341] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4852), 1,
      anon_sym_RBRACE,
    STATE(2299), 1,
      sym_override_modifier,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78422] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4657), 1,
      anon_sym_LBRACK,
    ACTIONS(4698), 1,
      anon_sym_STAR,
    ACTIONS(4702), 1,
      anon_sym_async,
    ACTIONS(4854), 1,
      anon_sym_abstract,
    ACTIONS(4704), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4708), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78489] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4856), 1,
      anon_sym_STAR,
    ACTIONS(4858), 1,
      anon_sym_async,
    ACTIONS(4862), 1,
      anon_sym_readonly,
    STATE(2302), 1,
      sym_override_modifier,
    ACTIONS(4860), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4864), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2548), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78560] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(3569), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4866), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4869), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_EQ,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1521), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4872), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4875), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78762] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4878), 1,
      anon_sym_RBRACE,
    STATE(2299), 1,
      sym_override_modifier,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78843] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_RBRACK,
    ACTIONS(3090), 1,
      anon_sym_COMMA,
    ACTIONS(3137), 1,
      anon_sym_EQ,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4880), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4883), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4050), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4886), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4889), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4014), 1,
      anon_sym_LBRACK,
    ACTIONS(4017), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3388), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79047] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    STATE(2299), 1,
      sym_override_modifier,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4142), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4892), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4895), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79177] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1853), 1,
      anon_sym_RBRACE,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    STATE(2299), 1,
      sym_override_modifier,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79258] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3988), 1,
      anon_sym_RBRACK,
    ACTIONS(4375), 1,
      anon_sym_COMMA,
    ACTIONS(3617), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79311] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4080), 1,
      anon_sym_EQ,
    ACTIONS(4084), 1,
      anon_sym_RBRACK,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4078), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4082), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4898), 1,
      sym_identifier,
    ACTIONS(3212), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(3216), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
  [79413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4900), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4903), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79462] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4612), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79529] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 1,
      anon_sym_extends,
    ACTIONS(4014), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4017), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79582] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4122), 1,
      anon_sym_LBRACK,
    ACTIONS(4125), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3791), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4033), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79635] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4657), 1,
      anon_sym_LBRACK,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79704] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(4130), 1,
      anon_sym_RBRACK,
    ACTIONS(4369), 1,
      anon_sym_COMMA,
    ACTIONS(1397), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79757] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4906), 1,
      anon_sym_STAR,
    ACTIONS(4908), 1,
      anon_sym_async,
    ACTIONS(4912), 1,
      anon_sym_readonly,
    STATE(2300), 1,
      sym_override_modifier,
    ACTIONS(4910), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4914), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2558), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79828] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(155), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(3346), 1,
      anon_sym_LBRACK,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(4918), 1,
      anon_sym_RBRACE,
    STATE(3544), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4842), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3541), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4145), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4916), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79897] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4920), 1,
      anon_sym_STAR,
    ACTIONS(4922), 1,
      anon_sym_async,
    ACTIONS(4926), 1,
      anon_sym_readonly,
    STATE(2308), 1,
      sym_override_modifier,
    ACTIONS(4924), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4928), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2569), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79968] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    ACTIONS(4030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3569), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2941), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [80021] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4930), 1,
      anon_sym_RBRACE,
    STATE(2299), 1,
      sym_override_modifier,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80102] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4932), 1,
      anon_sym_RBRACE,
    STATE(2299), 1,
      sym_override_modifier,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4934), 1,
      sym_identifier,
    ACTIONS(3212), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(3216), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
  [80232] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4920), 1,
      anon_sym_STAR,
    ACTIONS(4936), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4938), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3069), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80294] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4940), 1,
      anon_sym_STAR,
    ACTIONS(4942), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2965), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3107), 1,
      anon_sym_EQ,
    ACTIONS(2941), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [80404] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4932), 1,
      anon_sym_RBRACE,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80478] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3244), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80538] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_EQ,
    ACTIONS(3115), 1,
      anon_sym_in,
    ACTIONS(3118), 1,
      anon_sym_of,
    ACTIONS(2941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(2945), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [80590] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3244), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1662), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [80700] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4878), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    STATE(1981), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3328), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3330), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_satisfies,
  [80824] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4820), 1,
      anon_sym_STAR,
    ACTIONS(4822), 1,
      anon_sym_async,
    ACTIONS(4824), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4828), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2522), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80888] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4946), 1,
      anon_sym_STAR,
    ACTIONS(4948), 1,
      anon_sym_async,
    ACTIONS(4950), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4952), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2521), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80952] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4930), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81026] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4954), 1,
      anon_sym_STAR,
    ACTIONS(4956), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4958), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3048), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81088] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4960), 1,
      anon_sym_STAR,
    ACTIONS(4962), 1,
      anon_sym_async,
    ACTIONS(4964), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4966), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2538), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81152] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4930), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81224] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4932), 1,
      anon_sym_RBRACE,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81296] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4920), 1,
      anon_sym_STAR,
    ACTIONS(4922), 1,
      anon_sym_async,
    ACTIONS(4924), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4928), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2569), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81360] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    ACTIONS(4369), 1,
      anon_sym_of,
    ACTIONS(4755), 1,
      anon_sym_in,
    ACTIONS(1397), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(1401), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81412] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4820), 1,
      anon_sym_STAR,
    ACTIONS(4968), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4970), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3081), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81474] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4960), 1,
      anon_sym_STAR,
    ACTIONS(4972), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4974), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      sym_regex_flags,
    ACTIONS(4587), 18,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(4589), 19,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
  [81584] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4906), 1,
      anon_sym_STAR,
    ACTIONS(4908), 1,
      anon_sym_async,
    ACTIONS(4910), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4914), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2558), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81648] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81710] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81784] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4976), 1,
      anon_sym_STAR,
    ACTIONS(4978), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4980), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3047), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81846] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4982), 1,
      anon_sym_STAR,
    ACTIONS(4984), 1,
      anon_sym_async,
    ACTIONS(4986), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4988), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2520), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81910] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81982] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3233), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82042] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3233), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82102] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1855), 1,
      anon_sym_RBRACE,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82174] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3264), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82234] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4946), 1,
      anon_sym_STAR,
    ACTIONS(4990), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2975), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82296] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1855), 1,
      anon_sym_RBRACE,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82370] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4906), 1,
      anon_sym_STAR,
    ACTIONS(4994), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4996), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3074), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82432] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4080), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_of,
    ACTIONS(4752), 1,
      anon_sym_in,
    ACTIONS(4078), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(4082), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [82484] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4852), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82558] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3264), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82618] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3267), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82678] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3249), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82738] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4852), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82810] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4982), 1,
      anon_sym_STAR,
    ACTIONS(4998), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5000), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3052), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82872] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3249), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82932] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5002), 1,
      anon_sym_STAR,
    ACTIONS(5004), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5006), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3017), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(4375), 1,
      anon_sym_of,
    ACTIONS(4745), 1,
      anon_sym_in,
    ACTIONS(3617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH_DASH,
    ACTIONS(3621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83046] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5008), 1,
      anon_sym_STAR,
    ACTIONS(5010), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5012), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83108] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1853), 1,
      anon_sym_RBRACE,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83180] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4954), 1,
      anon_sym_STAR,
    ACTIONS(5014), 1,
      anon_sym_async,
    ACTIONS(5016), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5018), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2554), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83244] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4698), 1,
      anon_sym_STAR,
    ACTIONS(5020), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5022), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3063), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83306] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(155), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(3346), 1,
      anon_sym_LBRACK,
    ACTIONS(4842), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5026), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3847), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4145), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4182), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5024), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83370] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5002), 1,
      anon_sym_STAR,
    ACTIONS(5028), 1,
      anon_sym_async,
    ACTIONS(5030), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5032), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2570), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83434] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3267), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83494] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5034), 1,
      anon_sym_STAR,
    ACTIONS(5036), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5038), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3000), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83556] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(4878), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83630] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4940), 1,
      anon_sym_STAR,
    ACTIONS(5040), 1,
      anon_sym_async,
    ACTIONS(5042), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5044), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2525), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83694] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4856), 1,
      anon_sym_STAR,
    ACTIONS(5046), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5048), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3054), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83756] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4657), 1,
      anon_sym_LBRACK,
    ACTIONS(4856), 1,
      anon_sym_STAR,
    ACTIONS(4858), 1,
      anon_sym_async,
    ACTIONS(4860), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4864), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2548), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83820] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1853), 1,
      anon_sym_RBRACE,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83894] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4972), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83951] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5036), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3000), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84008] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4932), 1,
      anon_sym_RBRACE,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84075] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4942), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2965), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84132] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1853), 1,
      anon_sym_RBRACE,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84199] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5050), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2793), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84256] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5052), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3032), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84313] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4968), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3081), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84370] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5004), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3017), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84427] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4994), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3074), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84484] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4878), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84551] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4990), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2975), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84608] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    STATE(2299), 1,
      sym_override_modifier,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5054), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84681] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3054), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84738] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4930), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84805] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(224), 1,
      anon_sym_STAR,
    ACTIONS(1628), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5061), 1,
      anon_sym_async,
    ACTIONS(5065), 1,
      anon_sym_static,
    ACTIONS(5067), 1,
      anon_sym_readonly,
    ACTIONS(5073), 1,
      anon_sym_override,
    STATE(2286), 1,
      sym_accessibility_modifier,
    STATE(2301), 1,
      sym_override_modifier,
    ACTIONS(5059), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5063), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5069), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5071), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2914), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3845), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(5057), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84882] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5010), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84939] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4978), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3047), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84996] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1855), 1,
      anon_sym_RBRACE,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85063] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4852), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85130] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4998), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3052), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85187] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3075), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85293] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4956), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3048), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85350] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5077), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2798), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85407] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4936), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3069), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85464] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5020), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3063), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85521] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85588] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4850), 1,
      anon_sym_abstract,
    ACTIONS(5077), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2798), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85644] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5054), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85710] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5079), 1,
      anon_sym_readonly,
    STATE(2331), 1,
      sym_override_modifier,
    ACTIONS(5050), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2793), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85770] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5081), 1,
      anon_sym_abstract,
    ACTIONS(5050), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2793), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85826] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85878] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85930] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5054), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85994] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5083), 1,
      anon_sym_readonly,
    STATE(2326), 1,
      sym_override_modifier,
    ACTIONS(5077), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2798), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86054] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    STATE(2299), 1,
      sym_override_modifier,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5085), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86124] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4932), 1,
      anon_sym_RBRACE,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86181] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4930), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86238] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4932), 1,
      anon_sym_RBRACE,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86295] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1853), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86352] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4852), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86409] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5085), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86472] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86529] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86586] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5085), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86647] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2732), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86700] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4878), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86757] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1855), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86814] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2713), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3236), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86867] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1855), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86924] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5054), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86983] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4930), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87040] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4852), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87097] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4878), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87154] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1853), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87211] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5085), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87267] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1804), 1,
      anon_sym_namespace,
    ACTIONS(1810), 1,
      anon_sym_import,
    ACTIONS(1812), 1,
      anon_sym_var,
    ACTIONS(1814), 1,
      anon_sym_let,
    ACTIONS(1816), 1,
      anon_sym_const,
    ACTIONS(1824), 1,
      anon_sym_class,
    ACTIONS(1826), 1,
      anon_sym_async,
    ACTIONS(1828), 1,
      anon_sym_function,
    ACTIONS(1835), 1,
      anon_sym_declare,
    ACTIONS(1839), 1,
      anon_sym_abstract,
    ACTIONS(1841), 1,
      anon_sym_interface,
    ACTIONS(1843), 1,
      anon_sym_enum,
    ACTIONS(1889), 1,
      anon_sym_type,
    ACTIONS(1893), 1,
      anon_sym_module,
    ACTIONS(1895), 1,
      anon_sym_global,
    STATE(646), 1,
      sym_declaration,
    STATE(716), 1,
      sym_internal_module,
    STATE(1162), 1,
      sym_decorator,
    STATE(3370), 1,
      aux_sym_export_statement_repeat1,
    STATE(674), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [87346] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(5054), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87395] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1943), 1,
      anon_sym_type,
    ACTIONS(1945), 1,
      anon_sym_namespace,
    ACTIONS(1947), 1,
      anon_sym_import,
    ACTIONS(1949), 1,
      anon_sym_var,
    ACTIONS(1951), 1,
      anon_sym_let,
    ACTIONS(1953), 1,
      anon_sym_const,
    ACTIONS(1955), 1,
      anon_sym_class,
    ACTIONS(1957), 1,
      anon_sym_async,
    ACTIONS(1959), 1,
      anon_sym_function,
    ACTIONS(1961), 1,
      anon_sym_declare,
    ACTIONS(1965), 1,
      anon_sym_abstract,
    ACTIONS(1969), 1,
      anon_sym_interface,
    ACTIONS(1971), 1,
      anon_sym_enum,
    ACTIONS(3238), 1,
      anon_sym_module,
    ACTIONS(5091), 1,
      anon_sym_default,
    STATE(1162), 1,
      sym_decorator,
    STATE(3191), 1,
      sym_declaration,
    STATE(3252), 1,
      sym_internal_module,
    STATE(3333), 1,
      aux_sym_export_statement_repeat1,
    STATE(3254), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [87474] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1804), 1,
      anon_sym_namespace,
    ACTIONS(1810), 1,
      anon_sym_import,
    ACTIONS(1812), 1,
      anon_sym_var,
    ACTIONS(1814), 1,
      anon_sym_let,
    ACTIONS(1816), 1,
      anon_sym_const,
    ACTIONS(1824), 1,
      anon_sym_class,
    ACTIONS(1826), 1,
      anon_sym_async,
    ACTIONS(1828), 1,
      anon_sym_function,
    ACTIONS(1835), 1,
      anon_sym_declare,
    ACTIONS(1837), 1,
      anon_sym_module,
    ACTIONS(1839), 1,
      anon_sym_abstract,
    ACTIONS(1841), 1,
      anon_sym_interface,
    ACTIONS(1843), 1,
      anon_sym_enum,
    ACTIONS(1889), 1,
      anon_sym_type,
    ACTIONS(5093), 1,
      anon_sym_default,
    STATE(716), 1,
      sym_internal_module,
    STATE(735), 1,
      sym_declaration,
    STATE(1162), 1,
      sym_decorator,
    STATE(3370), 1,
      aux_sym_export_statement_repeat1,
    STATE(674), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [87553] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1943), 1,
      anon_sym_type,
    ACTIONS(1945), 1,
      anon_sym_namespace,
    ACTIONS(1947), 1,
      anon_sym_import,
    ACTIONS(1949), 1,
      anon_sym_var,
    ACTIONS(1951), 1,
      anon_sym_let,
    ACTIONS(1953), 1,
      anon_sym_const,
    ACTIONS(1955), 1,
      anon_sym_class,
    ACTIONS(1957), 1,
      anon_sym_async,
    ACTIONS(1959), 1,
      anon_sym_function,
    ACTIONS(1961), 1,
      anon_sym_declare,
    ACTIONS(1963), 1,
      anon_sym_module,
    ACTIONS(1965), 1,
      anon_sym_abstract,
    ACTIONS(1967), 1,
      anon_sym_global,
    ACTIONS(1969), 1,
      anon_sym_interface,
    ACTIONS(1971), 1,
      anon_sym_enum,
    STATE(1162), 1,
      sym_decorator,
    STATE(3226), 1,
      sym_declaration,
    STATE(3252), 1,
      sym_internal_module,
    STATE(3333), 1,
      aux_sym_export_statement_repeat1,
    STATE(3254), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [87632] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5095), 1,
      anon_sym_LPAREN,
    ACTIONS(5097), 1,
      anon_sym_DOT,
    STATE(2273), 1,
      sym_arguments,
    ACTIONS(3133), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3131), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [87679] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1804), 1,
      anon_sym_namespace,
    ACTIONS(1810), 1,
      anon_sym_import,
    ACTIONS(1812), 1,
      anon_sym_var,
    ACTIONS(1814), 1,
      anon_sym_let,
    ACTIONS(1816), 1,
      anon_sym_const,
    ACTIONS(1824), 1,
      anon_sym_class,
    ACTIONS(1826), 1,
      anon_sym_async,
    ACTIONS(1828), 1,
      anon_sym_function,
    ACTIONS(1835), 1,
      anon_sym_declare,
    ACTIONS(1837), 1,
      anon_sym_module,
    ACTIONS(1839), 1,
      anon_sym_abstract,
    ACTIONS(1841), 1,
      anon_sym_interface,
    ACTIONS(1843), 1,
      anon_sym_enum,
    ACTIONS(1889), 1,
      anon_sym_type,
    ACTIONS(5099), 1,
      anon_sym_default,
    STATE(716), 1,
      sym_internal_module,
    STATE(735), 1,
      sym_declaration,
    STATE(1162), 1,
      sym_decorator,
    STATE(3370), 1,
      aux_sym_export_statement_repeat1,
    STATE(674), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [87758] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(5054), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87807] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5101), 1,
      anon_sym_STAR,
    ACTIONS(5103), 1,
      anon_sym_async,
    ACTIONS(5107), 1,
      anon_sym_readonly,
    STATE(2296), 1,
      sym_override_modifier,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5105), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5109), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5111), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [87912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5115), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [87952] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5119), 1,
      anon_sym_EQ_GT,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5105), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88006] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5101), 1,
      anon_sym_STAR,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5105), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5109), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88062] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5101), 1,
      anon_sym_STAR,
    ACTIONS(5103), 1,
      anon_sym_async,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5105), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5109), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88120] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(5085), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1664), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1662), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5121), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5125), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5131), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5129), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5137), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5135), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5133), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5139), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5143), 1,
      sym__automatic_semicolon,
    ACTIONS(1459), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1461), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1461), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88450] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5145), 1,
      anon_sym_STAR,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5147), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5149), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2999), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5153), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5151), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5157), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5155), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88586] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(5085), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5161), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5159), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88672] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5163), 1,
      anon_sym_STAR,
    ACTIONS(5165), 1,
      anon_sym_async,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5167), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5169), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88730] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5171), 1,
      anon_sym_STAR,
    ACTIONS(5173), 1,
      anon_sym_async,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5175), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5177), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3094), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5111), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88828] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5163), 1,
      anon_sym_STAR,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5167), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5169), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5181), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5179), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5185), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5183), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5131), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5129), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5139), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5189), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5187), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5193), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5191), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5161), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5159), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5181), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5179), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3158), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3156), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_DOT,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5157), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5155), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1479), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5115), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      sym__automatic_semicolon,
    ACTIONS(1393), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1395), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5199), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5197), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5125), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89486] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5171), 1,
      anon_sym_STAR,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5175), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5177), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3094), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89542] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(4990), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2975), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89593] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(4972), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89644] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5201), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2958), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89695] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5175), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3094), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89746] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5105), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5203), 1,
      sym__automatic_semicolon,
    ACTIONS(1393), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1395), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89838] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(4968), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3081), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89889] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5205), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3045), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89940] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5207), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3023), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89991] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(4978), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3047), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90042] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(4956), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3048), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90093] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5167), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      sym__automatic_semicolon,
    ACTIONS(1459), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1461), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90185] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(4942), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2965), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90236] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5211), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3018), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90287] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(4994), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3074), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90338] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5147), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2999), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90389] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(4936), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3069), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90440] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(4998), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3052), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90491] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4698), 1,
      anon_sym_STAR,
    ACTIONS(4702), 1,
      anon_sym_async,
    ACTIONS(5213), 1,
      anon_sym_static,
    ACTIONS(5215), 1,
      anon_sym_readonly,
    ACTIONS(5217), 1,
      anon_sym_abstract,
    STATE(2311), 1,
      sym_override_modifier,
    ACTIONS(4704), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4708), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90554] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5004), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3017), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90605] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5036), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3000), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90656] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(5010), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3166), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3164), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5221), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5219), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90783] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5223), 1,
      anon_sym_RBRACE,
    STATE(3688), 1,
      sym_enum_assignment,
    ACTIONS(5225), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3148), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90833] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5227), 1,
      anon_sym_RBRACE,
    STATE(3967), 1,
      sym_enum_assignment,
    ACTIONS(5229), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3133), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3131), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2725), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2723), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90959] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4856), 1,
      anon_sym_STAR,
    ACTIONS(4858), 1,
      anon_sym_async,
    ACTIONS(4862), 1,
      anon_sym_readonly,
    ACTIONS(5231), 1,
      anon_sym_static,
    STATE(2302), 1,
      sym_override_modifier,
    ACTIONS(4860), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4864), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2548), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4303), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5233), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [91057] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5235), 1,
      anon_sym_RBRACE,
    STATE(3967), 1,
      sym_enum_assignment,
    ACTIONS(5229), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2727), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [91145] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5237), 1,
      anon_sym_RBRACE,
    STATE(3967), 1,
      sym_enum_assignment,
    ACTIONS(5229), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2719), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [91233] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_RBRACE,
    STATE(3967), 1,
      sym_enum_assignment,
    ACTIONS(5229), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91283] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(5241), 1,
      anon_sym_static,
    STATE(2299), 1,
      sym_override_modifier,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91343] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5243), 1,
      anon_sym_RBRACE,
    STATE(3967), 1,
      sym_enum_assignment,
    ACTIONS(5229), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91393] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5245), 1,
      anon_sym_RBRACE,
    STATE(3967), 1,
      sym_enum_assignment,
    ACTIONS(5229), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91443] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5247), 1,
      anon_sym_RBRACE,
    STATE(3967), 1,
      sym_enum_assignment,
    ACTIONS(5229), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91493] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4526), 1,
      anon_sym_readonly,
    ACTIONS(5249), 1,
      anon_sym_static,
    STATE(2304), 1,
      sym_override_modifier,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1461), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [91591] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5251), 1,
      anon_sym_RBRACE,
    STATE(3967), 1,
      sym_enum_assignment,
    ACTIONS(5229), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91641] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5253), 1,
      anon_sym_RBRACE,
    STATE(3637), 1,
      sym_enum_assignment,
    ACTIONS(5255), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3108), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91691] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(3192), 1,
      anon_sym_override,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5257), 1,
      anon_sym_static,
    ACTIONS(5259), 1,
      anon_sym_readonly,
    ACTIONS(5261), 1,
      anon_sym_abstract,
    STATE(2326), 1,
      sym_override_modifier,
    ACTIONS(5077), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2798), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1479), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [91785] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5171), 1,
      anon_sym_STAR,
    ACTIONS(5173), 1,
      anon_sym_async,
    ACTIONS(5263), 1,
      anon_sym_readonly,
    ACTIONS(5175), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5177), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3094), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91838] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4982), 1,
      anon_sym_STAR,
    ACTIONS(4984), 1,
      anon_sym_async,
    ACTIONS(5265), 1,
      anon_sym_readonly,
    ACTIONS(4986), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4988), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2520), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(1672), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91932] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5101), 1,
      anon_sym_STAR,
    ACTIONS(5103), 1,
      anon_sym_async,
    ACTIONS(5107), 1,
      anon_sym_readonly,
    ACTIONS(5105), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5109), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91985] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4960), 1,
      anon_sym_STAR,
    ACTIONS(4962), 1,
      anon_sym_async,
    ACTIONS(5267), 1,
      anon_sym_readonly,
    ACTIONS(4964), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4966), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2538), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92038] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4818), 1,
      anon_sym_STAR,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92091] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4920), 1,
      anon_sym_STAR,
    ACTIONS(4922), 1,
      anon_sym_async,
    ACTIONS(4926), 1,
      anon_sym_readonly,
    ACTIONS(4924), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4928), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2569), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92144] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4856), 1,
      anon_sym_STAR,
    ACTIONS(4858), 1,
      anon_sym_async,
    ACTIONS(4862), 1,
      anon_sym_readonly,
    ACTIONS(4860), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4864), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2548), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92197] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4906), 1,
      anon_sym_STAR,
    ACTIONS(4908), 1,
      anon_sym_async,
    ACTIONS(4912), 1,
      anon_sym_readonly,
    ACTIONS(4910), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4914), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2558), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92250] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5083), 1,
      anon_sym_readonly,
    ACTIONS(5269), 1,
      anon_sym_STAR,
    ACTIONS(5271), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5273), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2509), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92301] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5275), 1,
      anon_sym_STAR,
    ACTIONS(5279), 1,
      anon_sym_readonly,
    ACTIONS(5277), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5281), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2500), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92352] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4522), 1,
      anon_sym_async,
    ACTIONS(4526), 1,
      anon_sym_readonly,
    ACTIONS(4524), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92405] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5002), 1,
      anon_sym_STAR,
    ACTIONS(5028), 1,
      anon_sym_async,
    ACTIONS(5283), 1,
      anon_sym_readonly,
    ACTIONS(5030), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5032), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2570), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92458] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    STATE(3967), 1,
      sym_enum_assignment,
    ACTIONS(5229), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92505] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4698), 1,
      anon_sym_STAR,
    ACTIONS(4702), 1,
      anon_sym_async,
    ACTIONS(4706), 1,
      anon_sym_readonly,
    ACTIONS(4704), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4708), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2501), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92558] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(4820), 1,
      anon_sym_STAR,
    ACTIONS(4822), 1,
      anon_sym_async,
    ACTIONS(4826), 1,
      anon_sym_readonly,
    ACTIONS(4824), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4828), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2522), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92611] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4610), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92655] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4998), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3052), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92699] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5020), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3063), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92743] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(1929), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2970), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92787] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5004), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3017), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92831] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5201), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2958), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92875] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5052), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3032), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92919] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4942), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2965), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92963] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5083), 1,
      anon_sym_readonly,
    ACTIONS(5077), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2798), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93009] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5077), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2798), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93053] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5105), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93097] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4978), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3047), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93141] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5050), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2793), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93185] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5205), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3045), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93229] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5079), 1,
      anon_sym_readonly,
    ACTIONS(5050), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2793), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93275] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5207), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3023), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93319] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4972), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93363] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5175), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3094), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93407] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3075), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93451] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5285), 1,
      anon_sym_readonly,
    ACTIONS(5089), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2713), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93497] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2713), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93541] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3054), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93585] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5036), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3000), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93629] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5147), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2999), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93673] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4936), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3069), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93717] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5211), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3018), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93761] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5167), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93805] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4968), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3081), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93849] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4990), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2975), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93893] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4994), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3074), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93937] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(5010), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93981] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      anon_sym_LBRACK,
    ACTIONS(4956), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3048), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5287), 1,
      sym_identifier,
    STATE(4196), 1,
      sym_mapped_type_clause,
    ACTIONS(5289), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94056] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(5291), 1,
      anon_sym_DOT,
    ACTIONS(5293), 1,
      anon_sym_QMARK_DOT,
    STATE(2384), 1,
      sym_arguments,
    STATE(2412), 1,
      sym_type_arguments,
    ACTIONS(3302), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3304), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94096] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(5295), 1,
      anon_sym_DOT,
    ACTIONS(5297), 1,
      anon_sym_QMARK_DOT,
    STATE(2385), 1,
      sym_arguments,
    STATE(2484), 1,
      sym_type_arguments,
    ACTIONS(3320), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3322), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94136] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2969), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2959), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3707), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3707), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3525), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3525), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3830), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3804), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3806), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3565), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3565), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3830), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3525), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3751), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3501), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3505), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3779), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3565), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3505), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3505), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3711), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3501), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3651), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3501), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3711), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3655), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3651), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3681), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3669), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3681), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3830), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3669), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3854), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3856), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3655), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95094] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3294), 1,
      anon_sym_EQ,
    ACTIONS(5299), 1,
      anon_sym_DOT,
    ACTIONS(5301), 1,
      anon_sym_is,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3056), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95128] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_LPAREN,
    ACTIONS(2963), 1,
      anon_sym_DOT,
    ACTIONS(2967), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2969), 1,
      anon_sym_PIPE,
    ACTIONS(2971), 1,
      anon_sym_LT,
    STATE(2580), 1,
      sym_arguments,
    STATE(2632), 1,
      sym_type_arguments,
    ACTIONS(2959), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3685), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3497), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 1,
      anon_sym_DOT,
    ACTIONS(3793), 2,
      anon_sym_EQ,
      anon_sym_LT,
    ACTIONS(3795), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(3793), 2,
      anon_sym_EQ,
      anon_sym_LT,
    ACTIONS(3795), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95269] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3294), 1,
      anon_sym_EQ,
    ACTIONS(5299), 1,
      anon_sym_DOT,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3056), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3513), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95325] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5303), 1,
      anon_sym_DOT,
    ACTIONS(5305), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3739), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3741), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95354] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_LPAREN,
    ACTIONS(2971), 1,
      anon_sym_LT,
    ACTIONS(3302), 1,
      anon_sym_PIPE,
    ACTIONS(5307), 1,
      anon_sym_DOT,
    ACTIONS(5309), 1,
      anon_sym_QMARK_DOT,
    STATE(2556), 1,
      sym_arguments,
    STATE(2618), 1,
      sym_type_arguments,
    ACTIONS(3304), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95391] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_LPAREN,
    ACTIONS(2971), 1,
      anon_sym_LT,
    ACTIONS(3320), 1,
      anon_sym_PIPE,
    ACTIONS(5311), 1,
      anon_sym_DOT,
    ACTIONS(5313), 1,
      anon_sym_QMARK_DOT,
    STATE(2565), 1,
      sym_arguments,
    STATE(2633), 1,
      sym_type_arguments,
    ACTIONS(3322), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1407), 1,
      anon_sym_EQ,
    ACTIONS(1405), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_is,
  [95452] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3380), 1,
      anon_sym_EQ,
    STATE(2443), 1,
      sym_type_arguments,
    ACTIONS(3382), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(1497), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(1437), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 1,
      anon_sym_EQ,
    ACTIONS(3334), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_is,
  [95552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 1,
      anon_sym_EQ,
    ACTIONS(3509), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3525), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 1,
      anon_sym_EQ,
    ACTIONS(5301), 1,
      anon_sym_is,
    ACTIONS(3388), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95623] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5317), 1,
      sym_number,
    ACTIONS(5319), 1,
      anon_sym_unique,
    STATE(4215), 1,
      sym_predefined_type,
    STATE(4216), 1,
      sym_string,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [95656] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5321), 1,
      sym_number,
    STATE(4218), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [95687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3812), 1,
      anon_sym_EQ,
    ACTIONS(3814), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_EQ,
    ACTIONS(3581), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95733] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LPAREN,
    ACTIONS(5325), 1,
      anon_sym_DOT,
    ACTIONS(5327), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5329), 1,
      anon_sym_LT,
    STATE(2621), 1,
      sym_arguments,
    STATE(2730), 1,
      sym_type_arguments,
    ACTIONS(3304), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_EQ,
    ACTIONS(3601), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5331), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5333), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95831] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LPAREN,
    ACTIONS(5329), 1,
      anon_sym_LT,
    ACTIONS(5335), 1,
      anon_sym_DOT,
    ACTIONS(5337), 1,
      anon_sym_QMARK_DOT,
    STATE(2626), 1,
      sym_arguments,
    STATE(2729), 1,
      sym_type_arguments,
    ACTIONS(3322), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95864] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LPAREN,
    ACTIONS(5329), 1,
      anon_sym_LT,
    ACTIONS(5339), 1,
      anon_sym_DOT,
    ACTIONS(5341), 1,
      anon_sym_QMARK_DOT,
    STATE(2628), 1,
      sym_arguments,
    STATE(2728), 1,
      sym_type_arguments,
    ACTIONS(2959), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5343), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3697), 1,
      anon_sym_EQ,
    ACTIONS(3699), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3613), 1,
      anon_sym_EQ,
    ACTIONS(3615), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5345), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3645), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      anon_sym_EQ,
    ACTIONS(3834), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3731), 1,
      anon_sym_EQ,
    ACTIONS(3733), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96054] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5347), 1,
      sym_number,
    STATE(4287), 1,
      sym_string,
    STATE(4289), 1,
      sym_predefined_type,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 1,
      anon_sym_EQ,
    ACTIONS(3838), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3376), 1,
      anon_sym_EQ,
    ACTIONS(5301), 1,
      anon_sym_is,
    ACTIONS(3378), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3376), 1,
      anon_sym_EQ,
    ACTIONS(3378), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3745), 1,
      anon_sym_EQ,
    ACTIONS(3747), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96202] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5351), 1,
      sym_number,
    STATE(4282), 1,
      sym_string,
    STATE(4284), 1,
      sym_predefined_type,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96235] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5353), 1,
      sym_number,
    STATE(4092), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 1,
      anon_sym_EQ,
    ACTIONS(3783), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3804), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3806), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3779), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3711), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3707), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3711), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3707), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3681), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3669), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3681), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3669), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3655), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3651), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3655), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3651), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96611] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5355), 1,
      sym_number,
    STATE(4276), 1,
      sym_string,
    STATE(4279), 1,
      sym_predefined_type,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96644] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5357), 1,
      sym_number,
    STATE(4084), 1,
      sym_predefined_type,
    STATE(4085), 1,
      sym_string,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3858), 1,
      anon_sym_EQ,
    ACTIONS(3860), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3713), 1,
      anon_sym_EQ,
    ACTIONS(3715), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 1,
      anon_sym_EQ,
    ACTIONS(3703), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3380), 1,
      anon_sym_EQ,
    ACTIONS(5359), 1,
      anon_sym_is,
    ACTIONS(3382), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 1,
      anon_sym_EQ,
    ACTIONS(3521), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96794] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5361), 1,
      sym_number,
    STATE(4067), 1,
      sym_predefined_type,
    STATE(4071), 1,
      sym_string,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5363), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96848] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5365), 1,
      sym_number,
    STATE(4193), 1,
      sym_string,
    STATE(4198), 1,
      sym_predefined_type,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5367), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96902] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5369), 1,
      sym_number,
    STATE(4265), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96933] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5371), 1,
      sym_number,
    STATE(4183), 1,
      sym_string,
    STATE(4185), 1,
      sym_predefined_type,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_EQ,
    ACTIONS(3517), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96989] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5373), 1,
      sym_number,
    STATE(4173), 1,
      sym_string,
    STATE(4175), 1,
      sym_predefined_type,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3567), 1,
      anon_sym_EQ,
    ACTIONS(3569), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3854), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3856), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3505), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3505), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3505), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3525), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3525), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3577), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3577), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3577), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97275] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5375), 1,
      sym_number,
    STATE(4053), 1,
      sym_predefined_type,
    STATE(4064), 1,
      sym_string,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 1,
      anon_sym_EQ,
    ACTIONS(3388), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97331] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5377), 1,
      sym_number,
    STATE(4264), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3637), 1,
      anon_sym_EQ,
    ACTIONS(3639), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5379), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [97406] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_LT,
    ACTIONS(3294), 1,
      anon_sym_PIPE,
    ACTIONS(5381), 1,
      anon_sym_DOT,
    ACTIONS(5383), 1,
      anon_sym_is,
    STATE(2639), 1,
      sym_type_arguments,
    ACTIONS(3056), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3751), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3565), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3565), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3565), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3501), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3501), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3501), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3830), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3830), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3830), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 1,
      anon_sym_EQ,
    ACTIONS(3573), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3675), 1,
      anon_sym_EQ,
    ACTIONS(3677), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 1,
      anon_sym_EQ,
    ACTIONS(5385), 1,
      anon_sym_LBRACK,
    ACTIONS(3595), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97738] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5387), 1,
      sym_number,
    STATE(4312), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3380), 1,
      anon_sym_EQ,
    ACTIONS(3382), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97792] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5389), 1,
      sym_number,
    STATE(4307), 1,
      sym_predefined_type,
    STATE(4308), 1,
      sym_string,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97825] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5391), 1,
      sym_number,
    STATE(4300), 1,
      sym_predefined_type,
    STATE(4304), 1,
      sym_string,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3753), 1,
      anon_sym_EQ,
    ACTIONS(3629), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97881] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5393), 1,
      sym_number,
    STATE(4290), 1,
      sym_predefined_type,
    STATE(4292), 1,
      sym_string,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97914] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5395), 1,
      sym_number,
    STATE(4212), 1,
      sym_predefined_type,
    STATE(4213), 1,
      sym_string,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3773), 1,
      anon_sym_EQ,
    ACTIONS(3775), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 1,
      anon_sym_EQ,
    ACTIONS(3609), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97993] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      anon_sym_unique,
    ACTIONS(5397), 1,
      sym_number,
    STATE(4207), 1,
      sym_predefined_type,
    STATE(4210), 1,
      sym_string,
    ACTIONS(5315), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [98026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3850), 1,
      anon_sym_EQ,
    ACTIONS(5385), 1,
      anon_sym_LBRACK,
    ACTIONS(3852), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [98051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 1,
      anon_sym_EQ,
    ACTIONS(3791), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [98074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3820), 1,
      anon_sym_EQ,
    ACTIONS(5385), 1,
      anon_sym_LBRACK,
    ACTIONS(3595), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3822), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [98101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 1,
      anon_sym_EQ,
    ACTIONS(3802), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [98124] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5403), 1,
      anon_sym_BANG,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5407), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3168), 1,
      sym_type_annotation,
    STATE(3696), 1,
      sym__call_signature,
    STATE(3697), 1,
      sym__initializer,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5401), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98166] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5403), 1,
      anon_sym_BANG,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    ACTIONS(5411), 1,
      anon_sym_QMARK,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3080), 1,
      sym__call_signature,
    STATE(3168), 1,
      sym_type_annotation,
    STATE(3693), 1,
      sym__initializer,
    STATE(3744), 1,
      sym_type_parameters,
    ACTIONS(5401), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98208] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(5417), 1,
      anon_sym_QMARK,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3044), 1,
      sym__call_signature,
    STATE(3240), 1,
      sym_type_annotation,
    STATE(3556), 1,
      sym__initializer,
    STATE(3744), 1,
      sym_type_parameters,
    ACTIONS(5413), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3785), 1,
      anon_sym_EQ,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(3787), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [98274] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3583), 1,
      anon_sym_EQ,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(3585), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [98302] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(206), 1,
      anon_sym_unique,
    STATE(2785), 1,
      sym_type_predicate,
    STATE(4091), 1,
      sym_predefined_type,
    ACTIONS(5425), 2,
      sym_identifier,
      sym_this,
    ACTIONS(208), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [98330] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(206), 1,
      anon_sym_unique,
    STATE(2422), 1,
      sym_type_predicate,
    STATE(4057), 1,
      sym_predefined_type,
    ACTIONS(5427), 2,
      sym_identifier,
      sym_this,
    ACTIONS(208), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [98358] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(206), 1,
      anon_sym_unique,
    STATE(2422), 1,
      sym_type_predicate,
    STATE(4051), 1,
      sym_predefined_type,
    ACTIONS(5429), 2,
      sym_identifier,
      sym_this,
    ACTIONS(208), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [98386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(206), 1,
      anon_sym_unique,
    STATE(1331), 1,
      sym_type_predicate,
    STATE(4251), 1,
      sym_predefined_type,
    ACTIONS(5431), 2,
      sym_identifier,
      sym_this,
    ACTIONS(208), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [98414] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5435), 1,
      anon_sym_BANG,
    ACTIONS(5437), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3231), 1,
      sym_type_annotation,
    STATE(3594), 1,
      sym__initializer,
    STATE(3598), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5433), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98456] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(3214), 1,
      anon_sym_LBRACE,
    ACTIONS(5439), 1,
      sym_identifier,
    ACTIONS(5441), 1,
      anon_sym_STAR,
    ACTIONS(5443), 1,
      anon_sym_type,
    ACTIONS(5445), 1,
      anon_sym_COMMA,
    ACTIONS(5447), 1,
      anon_sym_from,
    STATE(3770), 1,
      sym_import_require_clause,
    STATE(3771), 1,
      sym_string,
    STATE(3778), 1,
      sym_import_clause,
    STATE(3950), 1,
      sym__import_identifier,
    STATE(4274), 2,
      sym_namespace_import,
      sym_named_imports,
  [98500] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(206), 1,
      anon_sym_unique,
    STATE(2679), 1,
      sym_type_predicate,
    STATE(4180), 1,
      sym_predefined_type,
    ACTIONS(5449), 2,
      sym_identifier,
      sym_this,
    ACTIONS(208), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [98528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3840), 1,
      anon_sym_EQ,
    ACTIONS(5451), 1,
      anon_sym_extends,
    ACTIONS(3842), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [98552] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_LT,
    ACTIONS(3294), 1,
      anon_sym_PIPE,
    ACTIONS(5381), 1,
      anon_sym_DOT,
    STATE(2639), 1,
      sym_type_arguments,
    ACTIONS(3056), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98580] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3808), 1,
      anon_sym_EQ,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(3810), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [98608] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 1,
      anon_sym_EQ,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(3838), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [98636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(206), 1,
      anon_sym_unique,
    STATE(1629), 1,
      sym_type_predicate,
    STATE(4344), 1,
      sym_predefined_type,
    ACTIONS(5453), 2,
      sym_identifier,
      sym_this,
    ACTIONS(208), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [98664] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 1,
      anon_sym_EQ,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(3605), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [98692] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3735), 1,
      anon_sym_EQ,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(3737), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [98720] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 1,
      anon_sym_EQ,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(3727), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [98748] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym_BANG,
    ACTIONS(5459), 1,
      anon_sym_QMARK,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(2971), 1,
      sym__call_signature,
    STATE(3344), 1,
      sym_type_annotation,
    STATE(3538), 1,
      sym__initializer,
    STATE(3744), 1,
      sym_type_parameters,
    ACTIONS(5455), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98790] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    ACTIONS(5463), 1,
      anon_sym_BANG,
    ACTIONS(5465), 1,
      anon_sym_QMARK,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(2986), 1,
      sym__call_signature,
    STATE(3334), 1,
      sym_type_annotation,
    STATE(3537), 1,
      sym__initializer,
    STATE(3744), 1,
      sym_type_parameters,
    ACTIONS(5461), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98832] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    ACTIONS(5435), 1,
      anon_sym_BANG,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3049), 1,
      sym__call_signature,
    STATE(3231), 1,
      sym_type_annotation,
    STATE(3648), 1,
      sym__initializer,
    STATE(3744), 1,
      sym_type_parameters,
    ACTIONS(5433), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98874] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_EQ,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(3581), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [98902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3816), 1,
      anon_sym_EQ,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(3818), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [98926] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5471), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3306), 1,
      sym_type_annotation,
    STATE(3308), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5469), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_LT,
    ACTIONS(3380), 1,
      anon_sym_PIPE,
    STATE(2627), 1,
      sym_type_arguments,
    ACTIONS(3382), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 1,
      anon_sym_LT,
    ACTIONS(3681), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99007] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5475), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3218), 1,
      sym_type_annotation,
    STATE(3222), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5473), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 1,
      anon_sym_LT,
    ACTIONS(3707), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 1,
      anon_sym_LT,
    ACTIONS(3711), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_LT,
    ACTIONS(3779), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LT,
    ACTIONS(3669), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 1,
      anon_sym_LT,
    ACTIONS(3707), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 1,
      anon_sym_DOT,
    ACTIONS(3793), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3795), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(3793), 2,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(3795), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 1,
      anon_sym_LT,
    ACTIONS(3830), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99214] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5479), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2839), 1,
      sym__call_signature,
    STATE(3196), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5477), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99249] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5483), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2861), 1,
      sym__call_signature,
    STATE(3350), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5481), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_LT,
    ACTIONS(3655), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 1,
      anon_sym_LT,
    ACTIONS(3711), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 1,
      anon_sym_LT,
    ACTIONS(3651), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 1,
      anon_sym_LT,
    ACTIONS(3830), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 1,
      anon_sym_LT,
    ACTIONS(3681), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 1,
      anon_sym_LT,
    ACTIONS(3830), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 1,
      anon_sym_LT,
    ACTIONS(3501), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_LT,
    ACTIONS(3655), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99452] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3739), 1,
      anon_sym_PIPE,
    ACTIONS(5485), 1,
      anon_sym_DOT,
    ACTIONS(5487), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3741), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99477] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5489), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3193), 1,
      sym__call_signature,
    STATE(3196), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5477), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 1,
      anon_sym_LT,
    ACTIONS(3501), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2723), 1,
      anon_sym_PIPE,
    ACTIONS(2725), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 1,
      anon_sym_LT,
    ACTIONS(3651), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99575] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5329), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_DOT,
    ACTIONS(5493), 1,
      anon_sym_is,
    STATE(2710), 1,
      sym_type_arguments,
    ACTIONS(3056), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LT,
    ACTIONS(3669), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99623] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5495), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2868), 1,
      sym__call_signature,
    STATE(3306), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5469), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3804), 1,
      anon_sym_LT,
    ACTIONS(3806), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 1,
      anon_sym_PIPE,
    ACTIONS(3685), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 1,
      anon_sym_LT,
    ACTIONS(3501), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99721] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5499), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2842), 1,
      sym__call_signature,
    STATE(3293), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5497), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3854), 1,
      anon_sym_LT,
    ACTIONS(3856), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_PIPE,
    ACTIONS(2729), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_LT,
    ACTIONS(3505), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 1,
      anon_sym_LT,
    ACTIONS(3565), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 1,
      anon_sym_LT,
    ACTIONS(3565), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 1,
      anon_sym_LT,
    ACTIONS(3565), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 1,
      anon_sym_PIPE,
    ACTIONS(3497), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_LT,
    ACTIONS(3505), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 1,
      anon_sym_LT,
    ACTIONS(3751), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_LT,
    ACTIONS(3505), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99966] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5501), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3290), 1,
      sym__call_signature,
    STATE(3293), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5497), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100001] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3350), 1,
      sym_type_annotation,
    STATE(3351), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5481), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_LT,
    ACTIONS(3577), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_LT,
    ACTIONS(3577), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100078] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(5299), 1,
      anon_sym_DOT,
    ACTIONS(5505), 1,
      anon_sym_EQ,
    ACTIONS(5510), 1,
      anon_sym_COLON,
    ACTIONS(5512), 1,
      anon_sym_extends,
    STATE(2499), 1,
      sym_type_arguments,
    STATE(3421), 1,
      sym_constraint,
    STATE(3841), 1,
      sym_default_type,
    ACTIONS(5507), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(3056), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [100115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_LT,
    ACTIONS(3525), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_LT,
    ACTIONS(3525), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 1,
      anon_sym_PIPE,
    ACTIONS(2721), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100178] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5515), 1,
      anon_sym_COLON,
    ACTIONS(5517), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2847), 1,
      sym__call_signature,
    STATE(3218), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5473), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_LT,
    ACTIONS(3525), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_LT,
    ACTIONS(3577), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 1,
      anon_sym_PIPE,
    ACTIONS(3513), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100276] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5295), 1,
      anon_sym_DOT,
    ACTIONS(5297), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5519), 1,
      anon_sym_LPAREN,
    ACTIONS(5521), 1,
      anon_sym_LT,
    STATE(2385), 1,
      sym_arguments,
    STATE(2484), 1,
      sym_type_arguments,
    ACTIONS(3322), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100306] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3274), 1,
      sym_type_annotation,
    STATE(3275), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5523), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100338] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym__call_signature,
    STATE(3340), 1,
      sym_type_annotation,
    STATE(3551), 1,
      sym__initializer,
    STATE(3744), 1,
      sym_type_parameters,
    ACTIONS(5525), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100374] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5291), 1,
      anon_sym_DOT,
    ACTIONS(5293), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5519), 1,
      anon_sym_LPAREN,
    ACTIONS(5521), 1,
      anon_sym_LT,
    STATE(2384), 1,
      sym_arguments,
    STATE(2412), 1,
      sym_type_arguments,
    ACTIONS(3304), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100404] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3039), 1,
      sym__call_signature,
    STATE(3248), 1,
      sym_type_annotation,
    STATE(3641), 1,
      sym__initializer,
    STATE(3744), 1,
      sym_type_parameters,
    ACTIONS(5527), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100440] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3340), 1,
      sym_type_annotation,
    STATE(3603), 1,
      sym__call_signature,
    STATE(3615), 1,
      sym__initializer,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5525), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3380), 1,
      anon_sym_PIPE,
    ACTIONS(5529), 1,
      anon_sym_is,
    ACTIONS(3382), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100498] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2860), 1,
      sym__call_signature,
    STATE(3354), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5531), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100530] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3249), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [100560] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3309), 1,
      sym_type_annotation,
    STATE(3310), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5533), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100592] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 1,
      anon_sym_DOT,
    ACTIONS(3012), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5519), 1,
      anon_sym_LPAREN,
    ACTIONS(5521), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
    ACTIONS(2959), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100622] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3299), 1,
      sym__call_signature,
    STATE(3301), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5535), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100654] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3354), 1,
      sym_type_annotation,
    STATE(3355), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5531), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100686] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3267), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [100716] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3233), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [100746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 1,
      anon_sym_PIPE,
    ACTIONS(5383), 1,
      anon_sym_is,
    ACTIONS(3388), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100768] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3244), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [100798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1407), 1,
      anon_sym_PIPE,
    ACTIONS(1405), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [100818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 1,
      anon_sym_PIPE,
    ACTIONS(3334), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [100838] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3022), 1,
      sym__call_signature,
    STATE(3289), 1,
      sym_type_annotation,
    STATE(3585), 1,
      sym__initializer,
    STATE(3744), 1,
      sym_type_parameters,
    ACTIONS(5537), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100874] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    ACTIONS(5299), 1,
      anon_sym_DOT,
    ACTIONS(5539), 1,
      anon_sym_QMARK,
    STATE(2499), 1,
      sym_type_arguments,
    STATE(3895), 1,
      sym_type_annotation,
    ACTIONS(3056), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100904] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3248), 1,
      sym_type_annotation,
    STATE(3616), 1,
      sym__initializer,
    STATE(3628), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5527), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100940] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(3214), 1,
      anon_sym_LBRACE,
    ACTIONS(5439), 1,
      sym_identifier,
    ACTIONS(5441), 1,
      anon_sym_STAR,
    ACTIONS(5443), 1,
      anon_sym_type,
    STATE(3770), 1,
      sym_import_require_clause,
    STATE(3771), 1,
      sym_string,
    STATE(3778), 1,
      sym_import_clause,
    STATE(3950), 1,
      sym__import_identifier,
    STATE(4274), 2,
      sym_namespace_import,
      sym_named_imports,
  [100978] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym__call_signature,
    STATE(3171), 1,
      sym_type_annotation,
    STATE(3702), 1,
      sym__initializer,
    STATE(3744), 1,
      sym_type_parameters,
    ACTIONS(5542), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101014] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2884), 1,
      sym__call_signature,
    STATE(3274), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5523), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101046] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3200), 1,
      sym__call_signature,
    STATE(3201), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5544), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101078] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym__call_signature,
    STATE(3201), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5544), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3376), 1,
      anon_sym_PIPE,
    ACTIONS(5383), 1,
      anon_sym_is,
    ACTIONS(3378), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101132] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2843), 1,
      sym__call_signature,
    STATE(3301), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5535), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5329), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_DOT,
    STATE(2710), 1,
      sym_type_arguments,
    ACTIONS(3056), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 1,
      anon_sym_LT,
    ACTIONS(1497), 11,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [101208] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(2966), 1,
      sym__call_signature,
    STATE(3353), 1,
      sym_type_annotation,
    STATE(3517), 1,
      sym__initializer,
    STATE(3744), 1,
      sym_type_parameters,
    ACTIONS(5546), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 1,
      anon_sym_LT,
    ACTIONS(1437), 11,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [101264] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3230), 1,
      anon_sym_COMMA,
    ACTIONS(3264), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [101294] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2867), 1,
      sym__call_signature,
    STATE(3309), 1,
      sym_type_annotation,
    STATE(3910), 1,
      sym_type_parameters,
    ACTIONS(5533), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 1,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 1,
      anon_sym_PIPE,
    ACTIONS(3791), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3697), 1,
      anon_sym_PIPE,
    ACTIONS(3699), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 1,
      anon_sym_DOT,
    ACTIONS(3793), 1,
      anon_sym_LT,
    ACTIONS(3795), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 1,
      anon_sym_PIPE,
    ACTIONS(3703), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3685), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 1,
      anon_sym_PIPE,
    ACTIONS(2935), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101459] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(5548), 1,
      sym_identifier,
    ACTIONS(5550), 1,
      anon_sym_type,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    ACTIONS(5554), 1,
      anon_sym_RBRACE,
    ACTIONS(5556), 1,
      anon_sym_typeof,
    STATE(3716), 1,
      sym_import_specifier,
    STATE(3756), 1,
      sym__import_identifier,
    STATE(4153), 2,
      sym__module_export_name,
      sym_string,
  [101494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 1,
      anon_sym_PIPE,
    ACTIONS(1973), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3497), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3858), 1,
      anon_sym_PIPE,
    ACTIONS(3860), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3513), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3236), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [101602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(3793), 1,
      anon_sym_LT,
    ACTIONS(3795), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3850), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_LBRACK,
    ACTIONS(3852), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 1,
      anon_sym_PIPE,
    ACTIONS(3509), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3675), 1,
      anon_sym_PIPE,
    ACTIONS(3677), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3840), 1,
      anon_sym_PIPE,
    ACTIONS(5560), 1,
      anon_sym_extends,
    ACTIONS(3842), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [101703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_LT,
    ACTIONS(4673), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [101722] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_LBRACK,
    ACTIONS(3595), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(3822), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101745] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_PIPE,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(3810), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [101768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 1,
      anon_sym_PIPE,
    ACTIONS(3783), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 1,
      anon_sym_PIPE,
    ACTIONS(3802), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 1,
      anon_sym_DOT,
    ACTIONS(5570), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3741), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 1,
      anon_sym_PIPE,
    ACTIONS(3838), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_PIPE,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(3838), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [101869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      anon_sym_PIPE,
    ACTIONS(3834), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2725), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_PIPE,
    ACTIONS(2927), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3713), 1,
      anon_sym_PIPE,
    ACTIONS(3715), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3816), 1,
      anon_sym_PIPE,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(3818), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 1,
      anon_sym_PIPE,
    ACTIONS(3521), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3567), 1,
      anon_sym_PIPE,
    ACTIONS(3569), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 1,
      anon_sym_PIPE,
    ACTIONS(3388), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_LBRACK,
    ACTIONS(3595), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_PIPE,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(3585), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [102082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3380), 1,
      anon_sym_PIPE,
    ACTIONS(3382), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3573), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 1,
      anon_sym_PIPE,
    ACTIONS(1977), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3812), 1,
      anon_sym_PIPE,
    ACTIONS(3814), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(3639), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 1,
      anon_sym_PIPE,
    ACTIONS(3609), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_PIPE,
    ACTIONS(3517), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3731), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_PIPE,
    ACTIONS(3721), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5329), 1,
      anon_sym_LT,
    STATE(2715), 1,
      sym_type_arguments,
    ACTIONS(3382), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 1,
      anon_sym_PIPE,
    ACTIONS(1989), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3745), 1,
      anon_sym_PIPE,
    ACTIONS(3747), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3753), 1,
      anon_sym_PIPE,
    ACTIONS(3629), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 1,
      anon_sym_PIPE,
    ACTIONS(1981), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_PIPE,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(3737), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [102373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_PIPE,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(3727), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [102396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_PIPE,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(3581), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [102419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3773), 1,
      anon_sym_PIPE,
    ACTIONS(3775), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_PIPE,
    ACTIONS(3581), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_PIPE,
    ACTIONS(3601), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102476] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_PIPE,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(3605), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [102499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3613), 1,
      anon_sym_PIPE,
    ACTIONS(3615), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_PIPE,
    ACTIONS(3645), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_PIPE,
    ACTIONS(1985), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3785), 1,
      anon_sym_PIPE,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(3787), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3376), 1,
      anon_sym_PIPE,
    ACTIONS(3378), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5574), 1,
      anon_sym_COLON,
    STATE(3029), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(5572), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1405), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [102632] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(5548), 1,
      sym_identifier,
    ACTIONS(5550), 1,
      anon_sym_type,
    ACTIONS(5556), 1,
      anon_sym_typeof,
    ACTIONS(5576), 1,
      anon_sym_RBRACE,
    STATE(3756), 1,
      sym__import_identifier,
    STATE(3824), 1,
      sym_import_specifier,
    STATE(4153), 2,
      sym__module_export_name,
      sym_string,
  [102664] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5578), 1,
      anon_sym_EQ,
    ACTIONS(5582), 1,
      anon_sym_BANG,
    STATE(3136), 1,
      sym__initializer,
    STATE(3335), 1,
      sym_type_annotation,
    ACTIONS(5584), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102692] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5582), 1,
      anon_sym_BANG,
    STATE(3335), 1,
      sym_type_annotation,
    STATE(3733), 1,
      sym__initializer,
    ACTIONS(5584), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102720] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5586), 1,
      sym_identifier,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5590), 1,
      anon_sym_extends,
    ACTIONS(5592), 1,
      anon_sym_implements,
    STATE(1936), 1,
      sym_class_body,
    STATE(2933), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3931), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [102754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5574), 1,
      anon_sym_COLON,
    STATE(3024), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(5594), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102774] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5590), 1,
      anon_sym_extends,
    ACTIONS(5592), 1,
      anon_sym_implements,
    ACTIONS(5596), 1,
      sym_identifier,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(1481), 1,
      sym_class_body,
    STATE(2832), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3883), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [102808] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5590), 1,
      anon_sym_extends,
    ACTIONS(5592), 1,
      anon_sym_implements,
    ACTIONS(5600), 1,
      sym_identifier,
    STATE(1936), 1,
      sym_class_body,
    STATE(2933), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3931), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [102842] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(5548), 1,
      sym_identifier,
    ACTIONS(5602), 1,
      anon_sym_type,
    ACTIONS(5604), 1,
      anon_sym_as,
    STATE(3974), 1,
      sym__import_identifier,
    ACTIONS(5445), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4001), 2,
      sym__module_export_name,
      sym_string,
  [102872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_DOT,
    ACTIONS(5521), 1,
      anon_sym_LT,
    ACTIONS(5606), 1,
      anon_sym_is,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3056), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102896] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5590), 1,
      anon_sym_extends,
    ACTIONS(5592), 1,
      anon_sym_implements,
    ACTIONS(5608), 1,
      sym_identifier,
    STATE(1936), 1,
      sym_class_body,
    STATE(2933), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3931), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [102930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5493), 1,
      anon_sym_is,
    ACTIONS(3378), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102948] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5590), 1,
      anon_sym_extends,
    ACTIONS(5592), 1,
      anon_sym_implements,
    ACTIONS(5610), 1,
      sym_identifier,
    STATE(1906), 1,
      sym_class_body,
    STATE(2941), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3897), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [102982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5612), 1,
      anon_sym_is,
    ACTIONS(3382), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_PIPE,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(5614), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5493), 1,
      anon_sym_is,
    ACTIONS(3388), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103040] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5590), 1,
      anon_sym_extends,
    ACTIONS(5592), 1,
      anon_sym_implements,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    ACTIONS(5616), 1,
      sym_identifier,
    STATE(2070), 1,
      sym_class_body,
    STATE(2881), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3948), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103074] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(5548), 1,
      sym_identifier,
    ACTIONS(5550), 1,
      anon_sym_type,
    ACTIONS(5556), 1,
      anon_sym_typeof,
    ACTIONS(5618), 1,
      anon_sym_RBRACE,
    STATE(3756), 1,
      sym__import_identifier,
    STATE(3824), 1,
      sym_import_specifier,
    STATE(4153), 2,
      sym__module_export_name,
      sym_string,
  [103106] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5590), 1,
      anon_sym_extends,
    ACTIONS(5592), 1,
      anon_sym_implements,
    ACTIONS(5620), 1,
      sym_identifier,
    STATE(1936), 1,
      sym_class_body,
    STATE(2933), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3931), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3334), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [103156] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 6,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [103178] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5590), 1,
      anon_sym_extends,
    ACTIONS(5592), 1,
      anon_sym_implements,
    ACTIONS(5622), 1,
      sym_identifier,
    STATE(1906), 1,
      sym_class_body,
    STATE(2941), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3897), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103212] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5590), 1,
      anon_sym_extends,
    ACTIONS(5592), 1,
      anon_sym_implements,
    ACTIONS(5624), 1,
      sym_identifier,
    STATE(1906), 1,
      sym_class_body,
    STATE(2941), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3897), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103246] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(5626), 1,
      sym_identifier,
    ACTIONS(5630), 1,
      anon_sym_COMMA,
    ACTIONS(5632), 1,
      anon_sym_RBRACE,
    STATE(3647), 1,
      sym_export_specifier,
    ACTIONS(5628), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(3654), 2,
      sym__module_export_name,
      sym_string,
  [103276] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5590), 1,
      anon_sym_extends,
    ACTIONS(5592), 1,
      anon_sym_implements,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    ACTIONS(5634), 1,
      sym_identifier,
    STATE(1394), 1,
      sym_class_body,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3973), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103310] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5590), 1,
      anon_sym_extends,
    ACTIONS(5592), 1,
      anon_sym_implements,
    ACTIONS(5636), 1,
      sym_identifier,
    STATE(1906), 1,
      sym_class_body,
    STATE(2941), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3897), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_extends,
    ACTIONS(3842), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [103361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 1,
      anon_sym_LBRACE,
    ACTIONS(2931), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [103378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3791), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3802), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_PIPE,
    ACTIONS(5644), 1,
      anon_sym_extends,
    ACTIONS(3810), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [103429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_LBRACK,
    ACTIONS(3595), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3822), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103448] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3334), 1,
      sym_type_annotation,
    STATE(3618), 1,
      sym__initializer,
    ACTIONS(5463), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5461), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_LBRACK,
    ACTIONS(3852), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3860), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_LBRACE,
    ACTIONS(2927), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [103522] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(5648), 1,
      anon_sym_EQ,
    ACTIONS(5614), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [103545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5650), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [103560] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1916), 1,
      sym_class_body,
    STATE(2931), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3979), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103591] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1891), 1,
      sym_class_body,
    STATE(2855), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3794), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103622] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5656), 1,
      anon_sym_LBRACE,
    STATE(167), 1,
      sym_class_body,
    STATE(2841), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3868), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103653] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(2857), 1,
      sym_type_parameters,
    STATE(3113), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3788), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3609), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_PIPE,
    ACTIONS(5644), 1,
      anon_sym_extends,
    ACTIONS(3727), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [103720] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1992), 1,
      sym_class_body,
    STATE(2935), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3837), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103751] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(5626), 1,
      sym_identifier,
    ACTIONS(5660), 1,
      anon_sym_RBRACE,
    STATE(3861), 1,
      sym_export_specifier,
    ACTIONS(5628), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(3654), 2,
      sym__module_export_name,
      sym_string,
  [103778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1973), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3509), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3677), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3699), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103838] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_PIPE,
    ACTIONS(5644), 1,
      anon_sym_extends,
    ACTIONS(3737), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [103859] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3286), 1,
      sym_type_annotation,
    STATE(3579), 1,
      sym__initializer,
    ACTIONS(5664), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5662), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103884] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(609), 1,
      sym_class_body,
    STATE(2869), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3852), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [103915] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3168), 1,
      sym_type_annotation,
    STATE(3695), 1,
      sym__initializer,
    ACTIONS(5403), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5401), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5666), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [103955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3703), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3715), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3783), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3838), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104015] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_PIPE,
    ACTIONS(5644), 1,
      anon_sym_extends,
    ACTIONS(3838), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [104036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 1,
      anon_sym_LBRACE,
    ACTIONS(2935), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [104053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3834), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_AMP,
    ACTIONS(3818), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [104085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3814), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104100] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5656), 1,
      anon_sym_LBRACE,
    STATE(149), 1,
      sym_class_body,
    STATE(2898), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3790), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [104131] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1895), 1,
      sym_class_body,
    STATE(2927), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3745), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [104162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_AMP,
    ACTIONS(3787), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [104179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1985), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3629), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3747), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1497), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5668), 1,
      anon_sym_COLON,
    STATE(3247), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(5594), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104288] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4932), 1,
      anon_sym_RBRACE,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [104315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [104330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3639), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3382), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104375] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4852), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [104402] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1413), 1,
      sym_class_body,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3855), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [104433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_LBRACK,
    ACTIONS(3595), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3645), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104510] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_PIPE,
    ACTIONS(5644), 1,
      anon_sym_extends,
    ACTIONS(3605), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [104531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3601), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_PIPE,
    ACTIONS(5644), 1,
      anon_sym_extends,
    ACTIONS(3581), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [104597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104612] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5672), 1,
      anon_sym_LBRACE,
    STATE(752), 1,
      sym_class_body,
    STATE(2853), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3873), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [104643] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1877), 1,
      sym_class_body,
    STATE(2910), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3982), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [104674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1981), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104689] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(5548), 1,
      sym_identifier,
    ACTIONS(5550), 1,
      anon_sym_type,
    ACTIONS(5556), 1,
      anon_sym_typeof,
    STATE(3756), 1,
      sym__import_identifier,
    STATE(3824), 1,
      sym_import_specifier,
    STATE(4153), 2,
      sym__module_export_name,
      sym_string,
  [104718] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1434), 1,
      sym_class_body,
    STATE(2858), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3776), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [104749] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1966), 1,
      sym_class_body,
    STATE(2873), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3831), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [104780] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(2831), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3863), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [104811] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1855), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [104838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5674), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [104868] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(2849), 1,
      sym_type_parameters,
    STATE(3130), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3801), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [104899] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5578), 1,
      anon_sym_EQ,
    STATE(3137), 1,
      sym__initializer,
    STATE(3335), 1,
      sym_type_annotation,
    ACTIONS(5584), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3378), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3721), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3733), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104984] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3335), 1,
      sym_type_annotation,
    STATE(3732), 1,
      sym__initializer,
    ACTIONS(5584), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1977), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105024] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(2872), 1,
      sym_type_parameters,
    STATE(3152), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3865), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [105055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5668), 1,
      anon_sym_COLON,
    STATE(3192), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(5572), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105074] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3344), 1,
      sym_type_annotation,
    STATE(3505), 1,
      sym__initializer,
    ACTIONS(5457), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5455), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105099] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(2061), 1,
      sym_class_body,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3803), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [105130] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(1853), 1,
      anon_sym_RBRACE,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3660), 1,
      aux_sym_object_repeat1,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105157] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_DOT,
    ACTIONS(5521), 1,
      anon_sym_LT,
    STATE(2499), 1,
      sym_type_arguments,
    ACTIONS(3056), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105205] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3231), 1,
      sym_type_annotation,
    STATE(3633), 1,
      sym__initializer,
    ACTIONS(5435), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5433), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105230] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4878), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105257] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(5626), 1,
      sym_identifier,
    ACTIONS(5676), 1,
      anon_sym_RBRACE,
    STATE(3861), 1,
      sym_export_specifier,
    ACTIONS(5628), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(3654), 2,
      sym__module_export_name,
      sym_string,
  [105284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105299] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5672), 1,
      anon_sym_LBRACE,
    STATE(730), 1,
      sym_class_body,
    STATE(2896), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3769), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [105330] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_PIPE,
    ACTIONS(5644), 1,
      anon_sym_extends,
    ACTIONS(3585), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [105351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5678), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [105366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1437), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105381] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 1,
      anon_sym_COMMA,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4930), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3679), 1,
      aux_sym_object_repeat1,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105408] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(618), 1,
      sym_class_body,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3995), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [105439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    ACTIONS(5682), 1,
      anon_sym_DOT,
    STATE(3287), 1,
      sym_statement_block,
    ACTIONS(1379), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym_LT,
    STATE(2443), 1,
      sym_type_arguments,
    ACTIONS(3382), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2725), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105519] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5582), 1,
      anon_sym_BANG,
    STATE(3335), 1,
      sym_type_annotation,
    STATE(3733), 1,
      sym__initializer,
    ACTIONS(5580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105543] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      sym_escape_sequence,
    ACTIONS(5686), 1,
      anon_sym_BQUOTE,
    ACTIONS(5688), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5690), 1,
      sym__template_chars,
    STATE(2977), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3317), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105567] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(5626), 1,
      sym_identifier,
    STATE(3861), 1,
      sym_export_specifier,
    ACTIONS(5628), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(3654), 2,
      sym__module_export_name,
      sym_string,
  [105591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      sym_identifier,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      anon_sym_LBRACK,
    ACTIONS(5698), 1,
      anon_sym_enum,
    STATE(3387), 1,
      sym_variable_declarator,
    STATE(2893), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [105615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    ACTIONS(5700), 1,
      anon_sym_DOT,
    STATE(3287), 1,
      sym_statement_block,
    ACTIONS(1379), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105635] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5690), 1,
      sym__template_chars,
    ACTIONS(5702), 1,
      sym_escape_sequence,
    ACTIONS(5704), 1,
      anon_sym_BQUOTE,
    STATE(2962), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3317), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105659] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      sym_escape_sequence,
    ACTIONS(5688), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5690), 1,
      sym__template_chars,
    ACTIONS(5706), 1,
      anon_sym_BQUOTE,
    STATE(2977), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3341), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105683] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5690), 1,
      sym__template_chars,
    ACTIONS(5702), 1,
      sym_escape_sequence,
    ACTIONS(5708), 1,
      anon_sym_BQUOTE,
    STATE(2962), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3317), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105707] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      sym_escape_sequence,
    ACTIONS(5688), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5690), 1,
      sym__template_chars,
    ACTIONS(5710), 1,
      anon_sym_BQUOTE,
    STATE(2977), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3317), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105731] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      sym_escape_sequence,
    ACTIONS(5688), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5690), 1,
      sym__template_chars,
    ACTIONS(5712), 1,
      anon_sym_BQUOTE,
    STATE(2977), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3317), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_PIPE,
    ACTIONS(5644), 1,
      anon_sym_extends,
    ACTIONS(5614), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105775] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      sym_escape_sequence,
    ACTIONS(5688), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5690), 1,
      sym__template_chars,
    ACTIONS(5714), 1,
      anon_sym_BQUOTE,
    STATE(2977), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3317), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105799] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      sym_escape_sequence,
    ACTIONS(5688), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5690), 1,
      sym__template_chars,
    ACTIONS(5716), 1,
      anon_sym_BQUOTE,
    STATE(2977), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3317), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105823] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_PIPE,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(5718), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_PIPE,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(5720), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      sym_identifier,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      anon_sym_LBRACK,
    ACTIONS(5722), 1,
      anon_sym_enum,
    STATE(3383), 1,
      sym_variable_declarator,
    STATE(2893), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [105887] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    ACTIONS(5724), 1,
      anon_sym_EQ,
    ACTIONS(5728), 1,
      anon_sym_QMARK,
    STATE(3409), 1,
      sym_type_annotation,
    STATE(3758), 1,
      sym__initializer,
    ACTIONS(5726), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [105910] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3171), 1,
      sym_type_annotation,
    STATE(3698), 1,
      sym__initializer,
    ACTIONS(5542), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105931] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3114), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3791), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [105956] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1453), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3793), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [105981] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5730), 1,
      sym_identifier,
    ACTIONS(5732), 1,
      anon_sym_STAR,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3810), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [106006] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5505), 1,
      anon_sym_EQ,
    STATE(3446), 1,
      sym_constraint,
    STATE(3904), 1,
      sym_default_type,
    ACTIONS(5510), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5736), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [106027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3781), 1,
      sym_statement_block,
    ACTIONS(5738), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106044] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1437), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3787), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3844), 1,
      sym_statement_block,
    ACTIONS(5740), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [106099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3819), 1,
      sym_statement_block,
    ACTIONS(5742), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3848), 1,
      sym_statement_block,
    ACTIONS(5742), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106133] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5656), 1,
      anon_sym_LBRACE,
    STATE(162), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3820), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3918), 1,
      sym_statement_block,
    ACTIONS(5738), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3919), 1,
      sym_statement_block,
    ACTIONS(5744), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106192] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(5548), 1,
      sym_identifier,
    ACTIONS(5602), 1,
      anon_sym_type,
    STATE(3974), 1,
      sym__import_identifier,
    STATE(4001), 2,
      sym__module_export_name,
      sym_string,
  [106215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3188), 1,
      sym_type_annotation,
    ACTIONS(5746), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106232] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5748), 1,
      sym_identifier,
    ACTIONS(5750), 1,
      anon_sym_STAR,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3890), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [106257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3983), 1,
      sym_statement_block,
    ACTIONS(5752), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5650), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [106287] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3121), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3754), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [106325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5666), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [106338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 1,
      anon_sym_is,
    ACTIONS(3378), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106353] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5672), 1,
      anon_sym_LBRACE,
    STATE(673), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3755), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3959), 1,
      sym_statement_block,
    ACTIONS(5754), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106395] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1842), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3797), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3898), 1,
      sym_statement_block,
    ACTIONS(5756), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106437] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3202), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3748), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106462] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1410), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3768), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106487] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym_LT,
    ACTIONS(5758), 1,
      anon_sym_LBRACE,
    ACTIONS(5760), 1,
      anon_sym_COMMA,
    ACTIONS(5762), 1,
      anon_sym_DOT,
    ACTIONS(5764), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3470), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3588), 1,
      sym_type_arguments,
  [106512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3889), 1,
      sym_statement_block,
    ACTIONS(5754), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3947), 1,
      sym_statement_block,
    ACTIONS(5756), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3777), 1,
      sym_statement_block,
    ACTIONS(5744), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3877), 1,
      sym_statement_block,
    ACTIONS(5766), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106580] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5770), 1,
      anon_sym_DOT,
    STATE(595), 1,
      sym_nested_identifier,
    STATE(621), 1,
      sym_string,
    STATE(645), 1,
      sym__module,
  [106605] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3864), 1,
      sym_statement_block,
    ACTIONS(5772), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(5054), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3951), 1,
      sym_statement_block,
    ACTIONS(5766), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3953), 1,
      sym_statement_block,
    ACTIONS(5772), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106675] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(622), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3775), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_LT,
    ACTIONS(4673), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3943), 1,
      sym_statement_block,
    ACTIONS(5774), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106732] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3271), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3765), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106757] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1950), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3806), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5776), 1,
      anon_sym_EQ,
    ACTIONS(3075), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [106797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 1,
      anon_sym_is,
    ACTIONS(3382), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 1,
      anon_sym_is,
    ACTIONS(3388), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106827] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(2066), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3827), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106852] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3248), 1,
      sym_type_annotation,
    STATE(3644), 1,
      sym__initializer,
    ACTIONS(5527), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3924), 1,
      sym_statement_block,
    ACTIONS(5780), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5674), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [106903] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(2055), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3802), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [106928] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5782), 1,
      sym_identifier,
    ACTIONS(5784), 1,
      anon_sym_STAR,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3963), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [106953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4369), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [106966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3954), 1,
      sym_statement_block,
    ACTIONS(5774), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3315), 1,
      sym_type_annotation,
    ACTIONS(5786), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5678), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_EQ,
    ACTIONS(3090), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [107028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3302), 1,
      sym_type_annotation,
    ACTIONS(5791), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3893), 1,
      sym_statement_block,
    ACTIONS(5793), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3871), 1,
      sym_statement_block,
    ACTIONS(5795), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3735), 1,
      sym_statement_block,
    ACTIONS(5797), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107096] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5505), 1,
      anon_sym_EQ,
    STATE(3421), 1,
      sym_constraint,
    STATE(3841), 1,
      sym_default_type,
    ACTIONS(5510), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5799), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [107117] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3335), 1,
      sym_type_annotation,
    STATE(3732), 1,
      sym__initializer,
    ACTIONS(5580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107138] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      sym_identifier,
    ACTIONS(5803), 1,
      anon_sym_import,
    STATE(2390), 1,
      sym__type_query_call_expression,
    STATE(2423), 1,
      sym__type_query_instantiation_expression,
    STATE(2581), 1,
      sym__type_query_member_expression,
    STATE(2584), 1,
      sym__type_query_subscript_expression,
    STATE(3482), 1,
      sym_import,
  [107163] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5805), 1,
      sym_identifier,
    ACTIONS(5807), 1,
      anon_sym_STAR,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3966), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [107188] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5672), 1,
      anon_sym_LBRACE,
    STATE(636), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3962), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [107213] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    STATE(1407), 1,
      sym_arguments,
    STATE(3887), 1,
      sym_type_arguments,
    ACTIONS(5809), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [107234] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5656), 1,
      anon_sym_LBRACE,
    STATE(166), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3936), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [107259] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(210), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1226), 1,
      anon_sym_LBRACE,
    ACTIONS(5811), 1,
      anon_sym_LT,
    ACTIONS(5813), 1,
      anon_sym_extends,
    STATE(679), 1,
      sym_object_type,
    STATE(3313), 1,
      sym_type_parameters,
    STATE(3610), 1,
      sym_extends_type_clause,
  [107284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4375), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [107310] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      anon_sym_LBRACK,
    ACTIONS(5817), 1,
      sym_identifier,
    STATE(3387), 1,
      sym_variable_declarator,
    STATE(2893), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [107331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      anon_sym_LBRACK,
    ACTIONS(5817), 1,
      sym_identifier,
    STATE(3391), 1,
      sym_variable_declarator,
    STATE(2893), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [107352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      anon_sym_LBRACK,
    ACTIONS(5817), 1,
      sym_identifier,
    STATE(3382), 1,
      sym_variable_declarator,
    STATE(2893), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [107373] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1275), 1,
      anon_sym_LBRACE,
    ACTIONS(5811), 1,
      anon_sym_LT,
    ACTIONS(5813), 1,
      anon_sym_extends,
    STATE(3203), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_object_type,
    STATE(3590), 1,
      sym_extends_type_clause,
  [107398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(3287), 1,
      sym_statement_block,
    ACTIONS(1379), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107428] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(5819), 1,
      sym_identifier,
    ACTIONS(5821), 1,
      anon_sym_DOT,
    STATE(2808), 1,
      sym_nested_identifier,
    STATE(2907), 1,
      sym_string,
    STATE(3249), 1,
      sym__module,
  [107453] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5823), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_STAR,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3810), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [107478] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1972), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3843), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [107503] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5827), 1,
      sym_identifier,
    ACTIONS(5829), 1,
      anon_sym_STAR,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3890), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [107528] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      anon_sym_LBRACK,
    ACTIONS(5817), 1,
      sym_identifier,
    STATE(3536), 1,
      sym_variable_declarator,
    STATE(2893), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [107549] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3340), 1,
      sym_type_annotation,
    STATE(3564), 1,
      sym__initializer,
    ACTIONS(5525), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107570] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5831), 1,
      anon_sym_COLON,
    ACTIONS(5833), 1,
      anon_sym_QMARK,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3833), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [107595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [107608] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5833), 1,
      anon_sym_QMARK,
    ACTIONS(5837), 1,
      anon_sym_COLON,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3833), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [107633] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym_identifier,
    ACTIONS(5841), 1,
      anon_sym_STAR,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3890), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [107658] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3353), 1,
      sym_type_annotation,
    STATE(3522), 1,
      sym__initializer,
    ACTIONS(5546), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [107692] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3265), 1,
      sym_type_annotation,
    STATE(3635), 1,
      sym__initializer,
    ACTIONS(5845), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3349), 1,
      sym_type_annotation,
    ACTIONS(5847), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107730] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5851), 1,
      anon_sym_STAR,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3810), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [107755] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 1,
      anon_sym_import,
    ACTIONS(5853), 1,
      sym_identifier,
    STATE(2405), 1,
      sym__type_query_subscript_expression,
    STATE(2409), 1,
      sym__type_query_member_expression,
    STATE(2640), 1,
      sym__type_query_call_expression,
    STATE(2751), 1,
      sym__type_query_instantiation_expression,
    STATE(3493), 1,
      sym_import,
  [107780] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 1,
      anon_sym_import,
    ACTIONS(5855), 1,
      sym_identifier,
    STATE(2345), 1,
      sym__type_query_subscript_expression,
    STATE(2346), 1,
      sym__type_query_member_expression,
    STATE(2390), 1,
      sym__type_query_call_expression,
    STATE(2423), 1,
      sym__type_query_instantiation_expression,
    STATE(3419), 1,
      sym_import,
  [107805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 1,
      anon_sym_EQ,
    ACTIONS(3090), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [107820] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 1,
      anon_sym_import,
    ACTIONS(5860), 1,
      sym_identifier,
    STATE(2391), 1,
      sym__type_query_subscript_expression,
    STATE(2392), 1,
      sym__type_query_member_expression,
    STATE(2547), 1,
      sym__type_query_call_expression,
    STATE(2665), 1,
      sym__type_query_instantiation_expression,
    STATE(3459), 1,
      sym_import,
  [107845] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1956), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3976), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [107870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    STATE(1967), 1,
      sym_arguments,
    STATE(3920), 1,
      sym_type_arguments,
    ACTIONS(5809), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [107891] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      anon_sym_LBRACK,
    ACTIONS(5862), 1,
      sym_identifier,
    STATE(3382), 1,
      sym_variable_declarator,
    STATE(2784), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [107912] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3289), 1,
      sym_type_annotation,
    STATE(3571), 1,
      sym__initializer,
    ACTIONS(5537), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107933] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1948), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3842), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [107958] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(604), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3858), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [107983] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1996), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3734), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [108008] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 1,
      anon_sym_import,
    ACTIONS(5864), 1,
      sym_identifier,
    STATE(1529), 1,
      sym__type_query_member_expression,
    STATE(1533), 1,
      sym__type_query_subscript_expression,
    STATE(1811), 1,
      sym__type_query_instantiation_expression,
    STATE(1812), 1,
      sym__type_query_call_expression,
    STATE(3436), 1,
      sym_import,
  [108033] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1983), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3785), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [108058] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 1,
      anon_sym_import,
    ACTIONS(5866), 1,
      sym_identifier,
    STATE(1220), 1,
      sym__type_query_subscript_expression,
    STATE(1222), 1,
      sym__type_query_member_expression,
    STATE(1340), 1,
      sym__type_query_call_expression,
    STATE(1341), 1,
      sym__type_query_instantiation_expression,
    STATE(3468), 1,
      sym_import,
  [108083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1501), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [108096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [108109] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5868), 1,
      sym_identifier,
    ACTIONS(5870), 1,
      anon_sym_STAR,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3890), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [108134] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      anon_sym_LBRACK,
    ACTIONS(5872), 1,
      sym_identifier,
    STATE(3383), 1,
      sym_variable_declarator,
    STATE(2789), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [108155] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1921), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3805), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [108180] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      anon_sym_LBRACK,
    ACTIONS(5817), 1,
      sym_identifier,
    STATE(3383), 1,
      sym_variable_declarator,
    STATE(2893), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [108201] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5874), 1,
      sym_identifier,
    ACTIONS(5876), 1,
      anon_sym_STAR,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3810), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [108226] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_extends,
    ACTIONS(5654), 1,
      anon_sym_implements,
    STATE(1504), 1,
      sym_class_body,
    STATE(3604), 1,
      sym_extends_clause,
    STATE(3964), 1,
      sym_class_heritage,
    STATE(4248), 1,
      sym_implements_clause,
  [108251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [108264] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym_LT,
    ACTIONS(5760), 1,
      anon_sym_COMMA,
    ACTIONS(5880), 1,
      anon_sym_LBRACE,
    ACTIONS(5882), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3471), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3617), 1,
      sym_type_arguments,
  [108286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5884), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5886), 1,
      anon_sym_QMARK_COLON,
    STATE(3369), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [108304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5888), 1,
      anon_sym_BQUOTE,
    ACTIONS(5890), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5702), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2962), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [108322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_COLON,
    ACTIONS(5594), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3874), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [108338] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5894), 1,
      anon_sym_export,
    ACTIONS(5896), 1,
      anon_sym_class,
    ACTIONS(5898), 1,
      anon_sym_abstract,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
  [108360] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(595), 1,
      sym_nested_identifier,
    STATE(621), 1,
      sym_string,
    STATE(767), 1,
      sym__module,
  [108382] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5900), 1,
      sym_identifier,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3929), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [108404] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(595), 1,
      sym_nested_identifier,
    STATE(621), 1,
      sym_string,
    STATE(645), 1,
      sym__module,
  [108426] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5902), 1,
      sym_identifier,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3812), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [108448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2227), 1,
      sym_statement_block,
    ACTIONS(5772), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3252), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5906), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108480] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5908), 1,
      sym_identifier,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3812), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [108502] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5910), 1,
      anon_sym_QMARK,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3922), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [108524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3286), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5912), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108540] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(5914), 1,
      anon_sym_COMMA,
    ACTIONS(5916), 1,
      anon_sym_GT,
    STATE(3511), 1,
      aux_sym_implements_clause_repeat1,
  [108562] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    ACTIONS(5918), 1,
      anon_sym_QMARK,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3016), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [108584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5890), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5922), 1,
      anon_sym_BQUOTE,
    ACTIONS(5920), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3006), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [108602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_COLON,
    ACTIONS(5572), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3930), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [108618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2956), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3286), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5912), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108634] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5924), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3320), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [108656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2240), 1,
      sym_statement_block,
    ACTIONS(5766), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2229), 1,
      sym_statement_block,
    ACTIONS(5766), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108688] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5884), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5886), 1,
      anon_sym_QMARK_COLON,
    STATE(3292), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [108706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(3236), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
  [108720] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5926), 1,
      anon_sym_QMARK,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3975), 1,
      sym_type_parameters,
    STATE(3990), 1,
      sym__call_signature,
  [108742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2212), 1,
      sym_statement_block,
    ACTIONS(5756), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2245), 1,
      sym_statement_block,
    ACTIONS(5754), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108774] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(5928), 1,
      anon_sym_COMMA,
    ACTIONS(5930), 1,
      anon_sym_GT,
    STATE(3562), 1,
      aux_sym_implements_clause_repeat1,
  [108796] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5932), 1,
      sym_identifier,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3812), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [108818] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    ACTIONS(5934), 1,
      anon_sym_QMARK,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(2955), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [108840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2232), 1,
      sym_statement_block,
    ACTIONS(5756), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108856] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5890), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5936), 1,
      anon_sym_BQUOTE,
    ACTIONS(5920), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3006), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [108874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5884), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5886), 1,
      anon_sym_QMARK_COLON,
    STATE(3347), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [108892] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5938), 1,
      sym_identifier,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3929), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [108914] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(5819), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_nested_identifier,
    STATE(2907), 1,
      sym_string,
    STATE(3249), 1,
      sym__module,
  [108936] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5884), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5886), 1,
      anon_sym_QMARK_COLON,
    STATE(3291), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [108954] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    ACTIONS(5819), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_nested_identifier,
    STATE(2907), 1,
      sym_string,
    STATE(3296), 1,
      sym__module,
  [108976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2213), 1,
      sym_statement_block,
    ACTIONS(5754), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108992] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5940), 1,
      sym_identifier,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3812), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [109014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_default,
    ACTIONS(5944), 1,
      anon_sym_RBRACE,
    ACTIONS(5946), 1,
      anon_sym_case,
    STATE(3043), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [109032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2243), 1,
      sym_statement_block,
    ACTIONS(5772), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5884), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5886), 1,
      anon_sym_QMARK_COLON,
    STATE(3363), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [109066] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    ACTIONS(5724), 1,
      anon_sym_EQ,
    STATE(3437), 1,
      sym_type_annotation,
    STATE(3952), 1,
      sym__initializer,
    ACTIONS(5948), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [109086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2959), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5952), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5950), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5890), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5954), 1,
      anon_sym_BQUOTE,
    ACTIONS(5684), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2977), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [109120] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5956), 1,
      sym_identifier,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3929), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [109142] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(5958), 1,
      anon_sym_COMMA,
    ACTIONS(5960), 1,
      anon_sym_GT,
    STATE(3640), 1,
      aux_sym_implements_clause_repeat1,
  [109164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5884), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5886), 1,
      anon_sym_QMARK_COLON,
    STATE(3324), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [109182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1977), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109194] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3003), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5964), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5962), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1981), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1985), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5968), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5966), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109250] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(5970), 1,
      anon_sym_QMARK,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3857), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [109272] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(5972), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3277), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [109294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3009), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3272), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5974), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109310] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(5978), 1,
      anon_sym_QMARK,
    ACTIONS(5976), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [109330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3272), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5974), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109346] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(5982), 1,
      anon_sym_COMMA,
    STATE(3560), 1,
      aux_sym_implements_clause_repeat1,
  [109368] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(5984), 1,
      anon_sym_COMMA,
    ACTIONS(5986), 1,
      anon_sym_GT,
    STATE(3708), 1,
      aux_sym_implements_clause_repeat1,
  [109390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5991), 1,
      anon_sym_BQUOTE,
    ACTIONS(5993), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5988), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3006), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [109408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1973), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3242), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5996), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109448] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym_LT,
    ACTIONS(5762), 1,
      anon_sym_DOT,
    ACTIONS(5998), 1,
      anon_sym_LBRACE,
    STATE(3588), 1,
      sym_type_arguments,
    ACTIONS(6000), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [109468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6002), 1,
      anon_sym_COMMA,
    ACTIONS(6004), 1,
      anon_sym_GT,
    STATE(3576), 1,
      aux_sym_implements_clause_repeat1,
  [109490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3028), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6008), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6006), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109506] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5884), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5886), 1,
      anon_sym_QMARK_COLON,
    STATE(3270), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [109524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5884), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5886), 1,
      anon_sym_QMARK_COLON,
    STATE(3269), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [109542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2219), 1,
      sym_statement_block,
    ACTIONS(5774), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2218), 1,
      sym_statement_block,
    ACTIONS(5780), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109574] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6010), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3362), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [109596] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    ACTIONS(6012), 1,
      anon_sym_QMARK,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3037), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [109618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(5085), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3236), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [109634] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(6014), 1,
      sym_identifier,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3929), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [109656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3034), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3270), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6016), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2248), 1,
      sym_statement_block,
    ACTIONS(5774), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109688] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6018), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3259), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [109710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109722] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(6022), 1,
      anon_sym_QMARK,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3846), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [109744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(6024), 1,
      sym_identifier,
    ACTIONS(6026), 1,
      anon_sym_LBRACK,
    STATE(3458), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [109762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(6026), 1,
      anon_sym_LBRACK,
    ACTIONS(6028), 1,
      sym_identifier,
    STATE(3807), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [109780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3270), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6016), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6030), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3090), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6034), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6032), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109836] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3570), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [109858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6040), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3274), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6042), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2239), 1,
      sym_statement_block,
    ACTIONS(5793), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109902] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6044), 1,
      anon_sym_COMMA,
    ACTIONS(6046), 1,
      anon_sym_GT,
    STATE(3649), 1,
      aux_sym_implements_clause_repeat1,
  [109924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2238), 1,
      sym_statement_block,
    ACTIONS(5795), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3053), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6050), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2222), 1,
      sym_statement_block,
    ACTIONS(5744), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2226), 1,
      sym_statement_block,
    ACTIONS(5797), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [110000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(6026), 1,
      anon_sym_LBRACK,
    ACTIONS(6052), 1,
      sym_identifier,
    STATE(3689), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [110018] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_default,
    ACTIONS(5946), 1,
      anon_sym_case,
    ACTIONS(6054), 1,
      anon_sym_RBRACE,
    STATE(3088), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [110036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2247), 1,
      sym_statement_block,
    ACTIONS(5752), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110052] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6056), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2890), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [110074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(6060), 1,
      anon_sym_PIPE,
    ACTIONS(6062), 1,
      anon_sym_extends,
    ACTIONS(3585), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [110092] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6064), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2879), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [110114] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6066), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2865), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [110136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2220), 1,
      sym_statement_block,
    ACTIONS(5738), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [110164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3055), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3240), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6068), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110180] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    ACTIONS(6070), 1,
      anon_sym_QMARK,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(2976), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [110202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3240), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6068), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110218] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6072), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3183), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [110240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3276), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6074), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3070), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3278), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6076), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3278), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6076), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2236), 1,
      sym_statement_block,
    ACTIONS(5738), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2237), 1,
      sym_statement_block,
    ACTIONS(5744), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110320] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(6078), 1,
      anon_sym_QMARK,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3869), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [110342] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6080), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2856), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [110364] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5898), 1,
      anon_sym_abstract,
    ACTIONS(6082), 1,
      anon_sym_export,
    ACTIONS(6084), 1,
      anon_sym_class,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
  [110386] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    ACTIONS(6086), 1,
      anon_sym_QMARK,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3083), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [110408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(6060), 1,
      anon_sym_PIPE,
    ACTIONS(6062), 1,
      anon_sym_extends,
    ACTIONS(3737), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [110426] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(6060), 1,
      anon_sym_PIPE,
    ACTIONS(6062), 1,
      anon_sym_extends,
    ACTIONS(3727), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [110444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6091), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6088), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(6060), 1,
      anon_sym_PIPE,
    ACTIONS(6062), 1,
      anon_sym_extends,
    ACTIONS(3581), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [110478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(6060), 1,
      anon_sym_PIPE,
    ACTIONS(6062), 1,
      anon_sym_extends,
    ACTIONS(3605), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [110496] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6093), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3284), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [110518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3262), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6095), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110534] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(6097), 1,
      sym_identifier,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3960), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [110556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2235), 1,
      sym_statement_block,
    ACTIONS(5740), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3247), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6099), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110588] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6101), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2835), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [110610] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6103), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3631), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [110632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(3787), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [110646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(6060), 1,
      anon_sym_PIPE,
    ACTIONS(6062), 1,
      anon_sym_extends,
    ACTIONS(3810), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [110664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6105), 1,
      anon_sym_extends,
    ACTIONS(3842), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [110678] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6107), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [110696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2241), 1,
      sym_statement_block,
    ACTIONS(5742), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110712] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    ACTIONS(6109), 1,
      anon_sym_QMARK,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3058), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [110734] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    ACTIONS(5884), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5886), 1,
      anon_sym_QMARK_COLON,
    STATE(3220), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [110752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(2234), 1,
      sym_statement_block,
    ACTIONS(5742), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6111), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
  [110786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [110798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(3818), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [110812] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(6060), 1,
      anon_sym_PIPE,
    ACTIONS(6062), 1,
      anon_sym_extends,
    ACTIONS(3838), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [110830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6113), 1,
      anon_sym_default,
    ACTIONS(6116), 1,
      anon_sym_RBRACE,
    ACTIONS(6118), 1,
      anon_sym_case,
    STATE(3088), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [110848] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(6121), 1,
      sym_identifier,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3839), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [110870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3284), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6123), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3073), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3284), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6123), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110902] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2840), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [110924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [110936] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    ACTIONS(6127), 1,
      anon_sym_QMARK,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3799), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [110958] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    ACTIONS(6129), 1,
      anon_sym_SEMI,
    ACTIONS(6131), 1,
      sym__automatic_semicolon,
    ACTIONS(6133), 1,
      sym__function_signature_automatic_semicolon,
    STATE(602), 1,
      sym_statement_block,
  [110977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    ACTIONS(6135), 1,
      anon_sym_SEMI,
    ACTIONS(6137), 1,
      sym__automatic_semicolon,
    ACTIONS(6139), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3164), 1,
      sym_statement_block,
  [110996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111007] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6141), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [111024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [111052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111063] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3780), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [111082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111093] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3773), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [111112] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3800), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [111131] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(6147), 1,
      sym_identifier,
    STATE(3772), 2,
      sym__module_export_name,
      sym_string,
  [111148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111159] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      anon_sym_EQ,
    ACTIONS(6149), 1,
      anon_sym_COMMA,
    ACTIONS(6151), 1,
      anon_sym_RBRACE,
    STATE(3712), 1,
      aux_sym_enum_body_repeat1,
    STATE(3763), 1,
      sym__initializer,
  [111178] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3751), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [111197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2111), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_COLON,
    ACTIONS(6153), 1,
      anon_sym_EQ_GT,
    STATE(3930), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [111223] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(6129), 1,
      anon_sym_SEMI,
    ACTIONS(6131), 1,
      sym__automatic_semicolon,
    ACTIONS(6133), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1876), 1,
      sym_statement_block,
  [111242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1581), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111264] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3774), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [111283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1485), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [111316] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3779), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [111335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3782), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [111354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111365] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3163), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [111384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2363), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2419), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2451), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2411), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_COLON,
    ACTIONS(6158), 1,
      anon_sym_EQ_GT,
    STATE(3874), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [111487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_COLON,
    ACTIONS(6161), 1,
      anon_sym_EQ_GT,
    STATE(3930), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [111502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2263), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_in,
    ACTIONS(6168), 1,
      anon_sym_of,
    ACTIONS(6164), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 1,
      anon_sym_in,
    ACTIONS(6172), 1,
      anon_sym_of,
    ACTIONS(6164), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4731), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2291), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4725), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4725), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2423), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4725), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111675] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      anon_sym_EQ,
    ACTIONS(6174), 1,
      anon_sym_COMMA,
    ACTIONS(6176), 1,
      anon_sym_RBRACE,
    STATE(3504), 1,
      aux_sym_enum_body_repeat1,
    STATE(3763), 1,
      sym__initializer,
  [111694] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3059), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [111713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2291), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2431), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2447), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [111768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1411), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111845] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6178), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [111862] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    ACTIONS(6180), 1,
      anon_sym_SEMI,
    ACTIONS(6182), 1,
      sym__automatic_semicolon,
    ACTIONS(6184), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3207), 1,
      sym_statement_block,
  [111881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 1,
      sym__automatic_semicolon,
    ACTIONS(1505), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111916] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6186), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [111933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3638), 1,
      sym__initializer,
    ACTIONS(6188), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3836), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [111978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3614), 1,
      sym__initializer,
    ACTIONS(6190), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2383), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2862), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [112034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112045] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3112), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [112064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 1,
      anon_sym_BQUOTE,
    ACTIONS(6194), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6197), 1,
      sym__template_chars,
    STATE(3178), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [112122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112133] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3280), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [112152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5385), 1,
      anon_sym_LBRACK,
    ACTIONS(6200), 1,
      anon_sym_RBRACE,
    ACTIONS(3595), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112178] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3096), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [112197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5898), 1,
      anon_sym_abstract,
    ACTIONS(6084), 1,
      anon_sym_class,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
  [112216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6202), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [112233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_COLON,
    ACTIONS(6206), 1,
      anon_sym_EQ_GT,
    STATE(3930), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [112259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2351), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6030), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2159), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2155), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6209), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6091), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6040), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6211), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112402] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1275), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_extends,
    STATE(3128), 1,
      sym_object_type,
    STATE(3686), 1,
      sym_extends_type_clause,
  [112421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_COLON,
    ACTIONS(6213), 1,
      anon_sym_EQ_GT,
    STATE(3930), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [112436] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3273), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [112455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4760), 1,
      sym__automatic_semicolon,
    ACTIONS(1561), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 1,
      sym__automatic_semicolon,
    ACTIONS(1551), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6216), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [112503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112514] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3907), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [112533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112544] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2854), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [112563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_COLON,
    ACTIONS(6218), 1,
      anon_sym_EQ_GT,
    STATE(3874), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [112578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    STATE(3895), 1,
      sym_type_annotation,
    ACTIONS(3090), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [112604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4606), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [112615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6221), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112626] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(6060), 1,
      anon_sym_PIPE,
    ACTIONS(6062), 1,
      anon_sym_extends,
    ACTIONS(6223), 1,
      anon_sym_as,
    ACTIONS(6225), 1,
      anon_sym_RBRACK,
  [112645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6227), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112656] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(2983), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [112675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5752), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2439), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2427), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2455), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2171), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2239), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6229), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2371), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112769] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 1,
      anon_sym_LBRACE,
    ACTIONS(6129), 1,
      anon_sym_SEMI,
    ACTIONS(6131), 1,
      sym__automatic_semicolon,
    ACTIONS(6133), 1,
      sym__function_signature_automatic_semicolon,
    STATE(165), 1,
      sym_statement_block,
  [112788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3550), 1,
      sym__initializer,
    ACTIONS(6231), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4750), 1,
      sym__automatic_semicolon,
    ACTIONS(1427), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112816] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2863), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [112835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3329), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [112854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112865] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2871), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [112884] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3764), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [112903] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6233), 1,
      anon_sym_BQUOTE,
    ACTIONS(6235), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6237), 1,
      sym__template_chars,
    STATE(3178), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112920] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2889), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [112939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3703), 1,
      sym__initializer,
    ACTIONS(6239), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112954] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(2891), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [112973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2295), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4375), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [112995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4369), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [113006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2115), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2395), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3549), 1,
      sym__initializer,
    ACTIONS(6241), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2167), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113065] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3279), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [113084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_COLON,
    ACTIONS(6243), 1,
      anon_sym_EQ_GT,
    STATE(3874), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [113099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5797), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [113154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [113165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [113176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5795), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113187] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3255), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [113206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113217] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6246), 1,
      anon_sym_class,
    ACTIONS(6248), 1,
      anon_sym_abstract,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
  [113236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3040), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [113255] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3356), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [113274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3643), 1,
      sym__initializer,
    ACTIONS(6250), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113289] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3015), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [113308] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3723), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [113327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4668), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [113338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6252), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6254), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113371] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3972), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [113390] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(6256), 1,
      anon_sym_SEMI,
    ACTIONS(6258), 1,
      sym__automatic_semicolon,
    ACTIONS(6260), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1920), 1,
      sym_statement_block,
  [113409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113431] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3816), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [113450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5780), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3261), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [113480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113502] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3826), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [113521] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3840), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [113540] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3368), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [113559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5738), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113570] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3850), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [113589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3639), 1,
      sym__initializer,
    ACTIONS(6264), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6237), 1,
      sym__template_chars,
    ACTIONS(6266), 1,
      anon_sym_BQUOTE,
    STATE(3178), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3634), 1,
      sym__initializer,
    ACTIONS(6268), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5738), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6270), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6272), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6274), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6276), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113708] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3035), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [113727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1473), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    ACTIONS(6256), 1,
      anon_sym_SEMI,
    ACTIONS(6258), 1,
      sym__automatic_semicolon,
    ACTIONS(6260), 1,
      sym__function_signature_automatic_semicolon,
    STATE(605), 1,
      sym_statement_block,
  [113757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3854), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [113776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3892), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [113806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6278), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6280), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113828] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3095), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [113847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(6282), 1,
      sym_identifier,
    STATE(3859), 2,
      sym__module_export_name,
      sym_string,
  [113864] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6284), 1,
      anon_sym_BQUOTE,
    ACTIONS(6286), 1,
      sym__template_chars,
    STATE(3288), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6288), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6292), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5766), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3236), 1,
      anon_sym_COLON,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(6294), 1,
      anon_sym_RBRACE,
    STATE(3661), 1,
      aux_sym_object_pattern_repeat1,
  [113961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6296), 1,
      anon_sym_BQUOTE,
    ACTIONS(6298), 1,
      sym__template_chars,
    STATE(3341), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113978] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(210), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1226), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_extends,
    STATE(760), 1,
      sym_object_type,
    STATE(3632), 1,
      sym_extends_type_clause,
  [113997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym_LT,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(3617), 1,
      sym_type_arguments,
    ACTIONS(6302), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [114014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6304), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6306), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [114036] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6237), 1,
      sym__template_chars,
    ACTIONS(6308), 1,
      anon_sym_BQUOTE,
    STATE(3178), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [114053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_COLON,
    ACTIONS(6310), 1,
      anon_sym_EQ_GT,
    STATE(3874), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [114068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1501), 1,
      anon_sym_DOT,
    ACTIONS(3793), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(3795), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [114083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114094] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3875), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [114113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6313), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6237), 1,
      sym__template_chars,
    ACTIONS(6315), 1,
      anon_sym_BQUOTE,
    STATE(3178), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [114141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6317), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114152] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 1,
      anon_sym_LBRACE,
    ACTIONS(6256), 1,
      anon_sym_SEMI,
    ACTIONS(6258), 1,
      sym__automatic_semicolon,
    ACTIONS(6260), 1,
      sym__function_signature_automatic_semicolon,
    STATE(157), 1,
      sym_statement_block,
  [114171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5766), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114182] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3926), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [114201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3230), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [114220] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(6135), 1,
      anon_sym_SEMI,
    ACTIONS(6137), 1,
      sym__automatic_semicolon,
    ACTIONS(6139), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1957), 1,
      sym_statement_block,
  [114239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [114250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6319), 1,
      anon_sym_BQUOTE,
    ACTIONS(6321), 1,
      sym__template_chars,
    STATE(3323), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [114267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4559), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [114278] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6248), 1,
      anon_sym_abstract,
    ACTIONS(6323), 1,
      anon_sym_class,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
  [114297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3575), 1,
      sym__initializer,
    ACTIONS(6325), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3535), 1,
      sym__initializer,
    ACTIONS(6327), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3236), 1,
      anon_sym_COLON,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(6329), 1,
      anon_sym_RBRACE,
    STATE(3667), 1,
      aux_sym_object_pattern_repeat1,
  [114346] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3838), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [114365] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3853), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [114384] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3975), 1,
      sym_type_parameters,
    STATE(3978), 1,
      sym__call_signature,
  [114403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3612), 1,
      sym__initializer,
    ACTIONS(6331), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114418] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6237), 1,
      sym__template_chars,
    ACTIONS(6333), 1,
      anon_sym_BQUOTE,
    STATE(3178), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [114435] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3975), 1,
      sym_type_parameters,
    STATE(3984), 1,
      sym__call_signature,
  [114454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_EQ,
    ACTIONS(3075), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [114467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3622), 1,
      sym__initializer,
    ACTIONS(6337), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114482] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [114501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DQUOTE,
    ACTIONS(1927), 1,
      anon_sym_SQUOTE,
    ACTIONS(6339), 1,
      sym_identifier,
    STATE(3555), 2,
      sym__module_export_name,
      sym_string,
  [114518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6341), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114529] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3684), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [114548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5756), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6347), 1,
      anon_sym_BQUOTE,
    ACTIONS(6349), 1,
      sym__template_chars,
    STATE(3238), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [114598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(3566), 1,
      sym__initializer,
    ACTIONS(6351), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6353), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114635] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(6180), 1,
      anon_sym_SEMI,
    ACTIONS(6182), 1,
      sym__automatic_semicolon,
    ACTIONS(6184), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1998), 1,
      sym_statement_block,
  [114654] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5896), 1,
      anon_sym_class,
    ACTIONS(5898), 1,
      anon_sym_abstract,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
  [114673] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    ACTIONS(6355), 1,
      sym_identifier,
    STATE(4013), 2,
      sym__module_export_name,
      sym_string,
  [114690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 1,
      anon_sym_DOT,
    ACTIONS(3793), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(3795), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [114705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6357), 1,
      anon_sym_BQUOTE,
    ACTIONS(6359), 1,
      sym__template_chars,
    STATE(3317), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [114722] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(2967), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [114741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5756), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6361), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114763] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2686), 1,
      sym_formal_parameters,
    STATE(3326), 1,
      sym__call_signature,
    STATE(3910), 1,
      sym_type_parameters,
  [114782] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2754), 1,
      sym_formal_parameters,
    STATE(3325), 1,
      sym__call_signature,
    STATE(3744), 1,
      sym_type_parameters,
  [114801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4488), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [114812] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2949), 1,
      sym_formal_parameters,
    STATE(3934), 1,
      sym__call_signature,
    STATE(3975), 1,
      sym_type_parameters,
  [114831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6363), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114853] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5898), 1,
      anon_sym_abstract,
    ACTIONS(6365), 1,
      anon_sym_class,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
  [114872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3236), 1,
      anon_sym_COLON,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(6367), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [114886] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6369), 1,
      anon_sym_RBRACK,
  [114902] = 4,
    ACTIONS(6371), 1,
      anon_sym_DQUOTE,
    ACTIONS(6375), 1,
      sym_comment,
    STATE(3388), 1,
      aux_sym_string_repeat1,
    ACTIONS(6373), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [114916] = 4,
    ACTIONS(6371), 1,
      anon_sym_SQUOTE,
    ACTIONS(6375), 1,
      sym_comment,
    STATE(3389), 1,
      aux_sym_string_repeat2,
    ACTIONS(6377), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [114930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6379), 1,
      anon_sym_QMARK,
  [114946] = 5,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6381), 1,
      sym__glimmer_template_content,
    ACTIONS(6383), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(1915), 1,
      sym_glimmer_closing_tag,
    STATE(3392), 1,
      aux_sym_glimmer_template_repeat1,
  [114962] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6385), 1,
      anon_sym_QMARK,
  [114978] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6387), 1,
      anon_sym_QMARK,
  [114994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6389), 1,
      anon_sym_QMARK,
  [115010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_from,
    STATE(3849), 1,
      sym__from_clause,
    ACTIONS(6393), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6395), 1,
      anon_sym_class,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
  [115040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 1,
      anon_sym_COMMA,
    STATE(3406), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6399), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 1,
      anon_sym_COMMA,
    STATE(3407), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6401), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_COMMA,
    ACTIONS(6403), 1,
      anon_sym_EQ,
    ACTIONS(6405), 1,
      anon_sym_RBRACK,
    STATE(3701), 1,
      aux_sym_array_pattern_repeat1,
  [115084] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3834), 1,
      sym_type_parameters,
    STATE(4058), 1,
      sym_formal_parameters,
  [115100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_COMMA,
    ACTIONS(6403), 1,
      anon_sym_EQ,
    ACTIONS(6407), 1,
      anon_sym_RBRACK,
    STATE(3523), 1,
      aux_sym_array_pattern_repeat1,
  [115116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 1,
      anon_sym_COMMA,
    STATE(3431), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6409), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115130] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6411), 1,
      anon_sym_DQUOTE,
    STATE(3425), 1,
      aux_sym_string_repeat1,
    ACTIONS(6413), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [115144] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6411), 1,
      anon_sym_SQUOTE,
    STATE(3426), 1,
      aux_sym_string_repeat2,
    ACTIONS(6415), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [115158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6417), 1,
      anon_sym_RBRACK,
  [115174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 1,
      anon_sym_COMMA,
    STATE(3430), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6419), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115188] = 5,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6383), 1,
      anon_sym_LT_SLASHtemplate_GT,
    ACTIONS(6421), 1,
      sym__glimmer_template_content,
    STATE(1964), 1,
      sym_glimmer_closing_tag,
    STATE(3565), 1,
      aux_sym_glimmer_template_repeat1,
  [115204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_from,
    STATE(3939), 1,
      sym__from_clause,
    ACTIONS(4052), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115218] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6423), 1,
      anon_sym_RBRACK,
  [115234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6425), 1,
      anon_sym_RBRACK,
  [115250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(5119), 1,
      anon_sym_EQ_GT,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
  [115264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_LT,
    ACTIONS(6427), 1,
      anon_sym_EQ_GT,
    ACTIONS(3236), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
  [115278] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6429), 1,
      anon_sym_DQUOTE,
    STATE(3425), 1,
      aux_sym_string_repeat1,
    ACTIONS(6413), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [115292] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6429), 1,
      anon_sym_SQUOTE,
    STATE(3426), 1,
      aux_sym_string_repeat2,
    ACTIONS(6415), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [115306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6431), 1,
      anon_sym_RBRACK,
  [115322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_from,
    STATE(3814), 1,
      sym__from_clause,
    ACTIONS(6433), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6435), 1,
      anon_sym_QMARK,
  [115352] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3767), 1,
      sym_type_parameters,
    STATE(4059), 1,
      sym_formal_parameters,
  [115368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 1,
      anon_sym_LBRACE,
    ACTIONS(5441), 1,
      anon_sym_STAR,
    STATE(3999), 2,
      sym_namespace_import,
      sym_named_imports,
  [115382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym_formal_parameters,
  [115398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 1,
      anon_sym_COMMA,
    STATE(3432), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6437), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 1,
      anon_sym_COMMA,
    STATE(3432), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6439), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115426] = 5,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6441), 1,
      sym__glimmer_template_content,
    ACTIONS(6443), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(1444), 1,
      sym_glimmer_closing_tag,
    STATE(3481), 1,
      aux_sym_glimmer_template_repeat1,
  [115442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      anon_sym_EQ,
    STATE(3949), 1,
      sym__initializer,
    ACTIONS(6445), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [115456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6447), 1,
      anon_sym_COMMA,
    STATE(3410), 1,
      aux_sym_array_repeat1,
    ACTIONS(4291), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [115470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5137), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6452), 1,
      anon_sym_COMMA,
    STATE(3440), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6450), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [115494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3795), 1,
      sym_type_parameters,
    STATE(4252), 1,
      sym_formal_parameters,
  [115510] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6454), 1,
      anon_sym_SQUOTE,
    STATE(3399), 1,
      aux_sym_string_repeat2,
    ACTIONS(6456), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [115524] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6454), 1,
      anon_sym_DQUOTE,
    STATE(3398), 1,
      aux_sym_string_repeat1,
    ACTIONS(6458), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [115538] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3796), 1,
      sym_type_parameters,
    STATE(4259), 1,
      sym_formal_parameters,
  [115554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2845), 1,
      sym_formal_parameters,
    STATE(3923), 1,
      sym_type_parameters,
  [115570] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6460), 1,
      anon_sym_export,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
  [115586] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3014), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
  [115602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6462), 1,
      anon_sym_RPAREN,
  [115618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5505), 1,
      anon_sym_EQ,
    STATE(3886), 1,
      sym_default_type,
    ACTIONS(6464), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [115632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3884), 1,
      sym_type_parameters,
    STATE(4038), 1,
      sym_formal_parameters,
  [115648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6466), 1,
      anon_sym_COLON,
  [115664] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_const,
    ACTIONS(6468), 1,
      sym_identifier,
    ACTIONS(6470), 1,
      anon_sym_GT,
    STATE(3878), 1,
      sym_type_parameter,
  [115680] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6472), 1,
      anon_sym_DQUOTE,
    STATE(3425), 1,
      aux_sym_string_repeat1,
    ACTIONS(6474), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [115694] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym_SQUOTE,
    STATE(3426), 1,
      aux_sym_string_repeat2,
    ACTIONS(6479), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [115708] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6482), 1,
      sym_identifier,
    STATE(2946), 1,
      sym_nested_type_identifier,
    STATE(3455), 1,
      sym_generic_type,
    STATE(4082), 1,
      sym_nested_identifier,
  [115724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_type_parameters,
    STATE(4217), 1,
      sym_formal_parameters,
  [115740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3902), 1,
      sym_type_parameters,
    STATE(4181), 1,
      sym_formal_parameters,
  [115756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 1,
      anon_sym_COMMA,
    STATE(3432), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6484), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 1,
      anon_sym_COMMA,
    STATE(3432), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6486), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6488), 1,
      anon_sym_COMMA,
    STATE(3432), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6491), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115798] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6493), 1,
      anon_sym_RBRACK,
  [115814] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6495), 1,
      anon_sym_RBRACK,
  [115830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3965), 1,
      sym_type_parameters,
    STATE(4081), 1,
      sym_formal_parameters,
  [115846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    ACTIONS(3975), 1,
      anon_sym_LT,
    STATE(1769), 1,
      sym_type_arguments,
    STATE(1770), 1,
      sym_arguments,
  [115862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      anon_sym_EQ,
    STATE(3804), 1,
      sym__initializer,
    ACTIONS(6497), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [115876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_from,
    STATE(3879), 1,
      sym__from_clause,
    ACTIONS(4211), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115890] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6499), 1,
      anon_sym_RPAREN,
  [115906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6452), 1,
      anon_sym_COMMA,
    STATE(3464), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6501), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [115920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3961), 1,
      sym_type_parameters,
    STATE(4025), 1,
      sym_formal_parameters,
  [115936] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6503), 1,
      anon_sym_DQUOTE,
    STATE(3460), 1,
      aux_sym_string_repeat1,
    ACTIONS(6505), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [115950] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6503), 1,
      anon_sym_SQUOTE,
    STATE(3461), 1,
      aux_sym_string_repeat2,
    ACTIONS(6507), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [115964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_const,
    ACTIONS(6468), 1,
      sym_identifier,
    ACTIONS(6509), 1,
      anon_sym_GT,
    STATE(3878), 1,
      sym_type_parameter,
  [115980] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2888), 1,
      sym_formal_parameters,
    STATE(3752), 1,
      sym_type_parameters,
  [115996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5505), 1,
      anon_sym_EQ,
    STATE(3736), 1,
      sym_default_type,
    ACTIONS(6511), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [116010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      sym_escape_sequence,
    ACTIONS(6515), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [116022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6200), 1,
      anon_sym_RBRACE,
    ACTIONS(3595), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6518), 1,
      anon_sym_QMARK,
  [116050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_COMMA,
    STATE(3450), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(6111), 2,
      anon_sym_LBRACE,
      anon_sym_GT,
  [116064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6523), 1,
      anon_sym_RBRACK,
  [116080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6525), 1,
      anon_sym_RPAREN,
  [116096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_const,
    ACTIONS(6468), 1,
      sym_identifier,
    ACTIONS(6527), 1,
      anon_sym_GT,
    STATE(3878), 1,
      sym_type_parameter,
  [116112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [116122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_COMMA,
    ACTIONS(5880), 1,
      anon_sym_LBRACE,
    ACTIONS(5882), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3472), 1,
      aux_sym_extends_type_clause_repeat1,
  [116138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6531), 1,
      anon_sym_COLON,
  [116154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6533), 1,
      anon_sym_RBRACK,
  [116170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 1,
      anon_sym_EQ,
    STATE(3825), 1,
      sym__initializer,
    ACTIONS(5584), 2,
      anon_sym_in,
      anon_sym_of,
  [116184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_LPAREN,
    ACTIONS(2971), 1,
      anon_sym_LT,
    STATE(2580), 1,
      sym_arguments,
    STATE(2632), 1,
      sym_type_arguments,
  [116200] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6537), 1,
      anon_sym_DQUOTE,
    STATE(3425), 1,
      aux_sym_string_repeat1,
    ACTIONS(6413), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116214] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6537), 1,
      anon_sym_SQUOTE,
    STATE(3426), 1,
      aux_sym_string_repeat2,
    ACTIONS(6415), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116228] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_const,
    ACTIONS(6468), 1,
      sym_identifier,
    ACTIONS(6539), 1,
      anon_sym_GT,
    STATE(3878), 1,
      sym_type_parameter,
  [116244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3835), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_formal_parameters,
  [116260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 1,
      anon_sym_COMMA,
    STATE(3464), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6541), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [116274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3673), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [116284] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3786), 1,
      sym_type_parameters,
    STATE(4012), 1,
      sym_formal_parameters,
  [116300] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6546), 1,
      anon_sym_class,
    STATE(1138), 1,
      aux_sym_export_statement_repeat1,
    STATE(1162), 1,
      sym_decorator,
  [116316] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_LT,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    STATE(1253), 1,
      sym_type_arguments,
    STATE(1255), 1,
      sym_arguments,
  [116332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      sym_identifier,
    STATE(3314), 1,
      sym_nested_type_identifier,
    STATE(3506), 1,
      sym_generic_type,
    STATE(4082), 1,
      sym_nested_identifier,
  [116348] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_COMMA,
    ACTIONS(6550), 1,
      anon_sym_LBRACE,
    ACTIONS(6552), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3502), 1,
      aux_sym_extends_type_clause_repeat1,
  [116364] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_COMMA,
    ACTIONS(6554), 1,
      anon_sym_LBRACE,
    ACTIONS(6556), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3502), 1,
      aux_sym_extends_type_clause_repeat1,
  [116380] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_COMMA,
    ACTIONS(6554), 1,
      anon_sym_LBRACE,
    ACTIONS(6556), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3502), 1,
      aux_sym_extends_type_clause_repeat1,
  [116396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6558), 1,
      anon_sym_RBRACK,
  [116412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6560), 1,
      anon_sym_RPAREN,
  [116428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6562), 1,
      anon_sym_RBRACK,
  [116444] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6564), 1,
      anon_sym_SQUOTE,
    STATE(3426), 1,
      aux_sym_string_repeat2,
    ACTIONS(6415), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116458] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6564), 1,
      anon_sym_DQUOTE,
    STATE(3425), 1,
      aux_sym_string_repeat1,
    ACTIONS(6413), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116472] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6566), 1,
      anon_sym_SQUOTE,
    STATE(3476), 1,
      aux_sym_string_repeat2,
    ACTIONS(6568), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116486] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6566), 1,
      anon_sym_DQUOTE,
    STATE(3477), 1,
      aux_sym_string_repeat1,
    ACTIONS(6570), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6572), 1,
      anon_sym_COLON,
  [116516] = 5,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6421), 1,
      sym__glimmer_template_content,
    ACTIONS(6443), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(1406), 1,
      sym_glimmer_closing_tag,
    STATE(3565), 1,
      aux_sym_glimmer_template_repeat1,
  [116532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5519), 1,
      anon_sym_LPAREN,
    ACTIONS(5521), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2398), 1,
      sym_type_arguments,
  [116548] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6574), 1,
      anon_sym_SQUOTE,
    STATE(3426), 1,
      aux_sym_string_repeat2,
    ACTIONS(6415), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116562] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6574), 1,
      anon_sym_DQUOTE,
    STATE(3425), 1,
      aux_sym_string_repeat1,
    ACTIONS(6413), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116576] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6576), 1,
      anon_sym_SQUOTE,
    STATE(3483), 1,
      aux_sym_string_repeat2,
    ACTIONS(6578), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116590] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6576), 1,
      anon_sym_DQUOTE,
    STATE(3484), 1,
      aux_sym_string_repeat1,
    ACTIONS(6580), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116604] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6582), 1,
      anon_sym_COLON,
  [116620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6584), 1,
      anon_sym_RBRACK,
  [116636] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6586), 1,
      anon_sym_DQUOTE,
    STATE(3499), 1,
      aux_sym_string_repeat1,
    ACTIONS(6588), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116650] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6586), 1,
      anon_sym_SQUOTE,
    STATE(3492), 1,
      aux_sym_string_repeat2,
    ACTIONS(6590), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116664] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6592), 1,
      anon_sym_RPAREN,
  [116680] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6594), 1,
      anon_sym_SQUOTE,
    STATE(3426), 1,
      aux_sym_string_repeat2,
    ACTIONS(6415), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116694] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LPAREN,
    ACTIONS(5329), 1,
      anon_sym_LT,
    STATE(2628), 1,
      sym_arguments,
    STATE(2728), 1,
      sym_type_arguments,
  [116710] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6596), 1,
      anon_sym_SQUOTE,
    STATE(3426), 1,
      aux_sym_string_repeat2,
    ACTIONS(6415), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116724] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6596), 1,
      anon_sym_DQUOTE,
    STATE(3425), 1,
      aux_sym_string_repeat1,
    ACTIONS(6413), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116738] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6598), 1,
      anon_sym_SQUOTE,
    STATE(3494), 1,
      aux_sym_string_repeat2,
    ACTIONS(6600), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116752] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6598), 1,
      anon_sym_DQUOTE,
    STATE(3495), 1,
      aux_sym_string_repeat1,
    ACTIONS(6602), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6604), 1,
      anon_sym_COLON,
  [116782] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6594), 1,
      anon_sym_DQUOTE,
    STATE(3425), 1,
      aux_sym_string_repeat1,
    ACTIONS(6413), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
    ACTIONS(6606), 1,
      anon_sym_COLON,
  [116812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      anon_sym_EQ,
    STATE(3763), 1,
      sym__initializer,
    ACTIONS(6608), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [116826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6610), 1,
      anon_sym_LBRACE,
    ACTIONS(6612), 1,
      anon_sym_COMMA,
    ACTIONS(6615), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3502), 1,
      aux_sym_extends_type_clause_repeat1,
  [116842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(6617), 1,
      anon_sym_RBRACK,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [116855] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6619), 1,
      anon_sym_COMMA,
    ACTIONS(6621), 1,
      anon_sym_RBRACE,
    STATE(3606), 1,
      aux_sym_enum_body_repeat1,
  [116868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    ACTIONS(6302), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [116888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_RBRACK,
    ACTIONS(6625), 1,
      anon_sym_COMMA,
    STATE(3728), 1,
      aux_sym_tuple_type_repeat1,
  [116901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(6627), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [116914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_await,
    STATE(49), 1,
      sym__for_header,
  [116927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1329), 1,
      anon_sym_RPAREN,
    ACTIONS(6633), 1,
      anon_sym_COMMA,
    STATE(3548), 1,
      aux_sym_formal_parameters_repeat1,
  [116940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2753), 1,
      anon_sym_GT,
    ACTIONS(6635), 1,
      anon_sym_COMMA,
    STATE(3450), 1,
      aux_sym_implements_clause_repeat1,
  [116953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4385), 1,
      anon_sym_RBRACK,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [116966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6637), 1,
      sym_identifier,
    ACTIONS(6639), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [116977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6641), 1,
      sym_identifier,
    ACTIONS(6643), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [116988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(6645), 1,
      anon_sym_RBRACK,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [117001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6403), 1,
      anon_sym_EQ,
    ACTIONS(6647), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [117012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4287), 1,
      anon_sym_RPAREN,
    STATE(3636), 1,
      aux_sym_array_repeat1,
  [117034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 1,
      anon_sym_COMMA,
    ACTIONS(6653), 1,
      anon_sym_RPAREN,
    STATE(3510), 1,
      aux_sym_formal_parameters_repeat1,
  [117047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 1,
      sym_identifier,
    STATE(1128), 1,
      sym_decorator_member_expression,
    STATE(1170), 1,
      sym_decorator_call_expression,
  [117060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4287), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [117073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_COMMA,
    ACTIONS(6657), 1,
      anon_sym_RBRACK,
    STATE(3699), 1,
      aux_sym_array_pattern_repeat1,
  [117095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 1,
      anon_sym_as,
    ACTIONS(5445), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [117106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 1,
      anon_sym_type,
    ACTIONS(6661), 1,
      sym_identifier,
    STATE(3828), 1,
      sym__import_identifier,
  [117119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 1,
      anon_sym_type,
    ACTIONS(6663), 1,
      sym_identifier,
    STATE(3746), 1,
      sym__import_identifier,
  [117132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_from,
    ACTIONS(6665), 1,
      anon_sym_as,
    STATE(3872), 1,
      sym__from_clause,
  [117145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1806), 1,
      anon_sym_LBRACE,
    ACTIONS(6667), 1,
      sym_identifier,
    STATE(3393), 1,
      sym_export_clause,
  [117158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_COMMA,
    ACTIONS(6407), 1,
      anon_sym_RBRACK,
    STATE(3523), 1,
      aux_sym_array_pattern_repeat1,
  [117171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_RBRACE,
    ACTIONS(6669), 1,
      anon_sym_COMMA,
    STATE(3680), 1,
      aux_sym_named_imports_repeat1,
  [117184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_DOT,
    ACTIONS(6671), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [117195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5682), 1,
      anon_sym_DOT,
    ACTIONS(6671), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [117206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 1,
      anon_sym_EQ,
    ACTIONS(3090), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6678), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6491), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 1,
      anon_sym_RBRACE,
    ACTIONS(6682), 1,
      anon_sym_COMMA,
    STATE(3656), 1,
      aux_sym_export_clause_repeat1,
  [117275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_EQ,
    STATE(4190), 1,
      sym_type_parameters,
  [117288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(6686), 1,
      anon_sym_RBRACE,
    STATE(3669), 1,
      aux_sym_object_pattern_repeat1,
  [117301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym_COMMA,
    ACTIONS(6690), 1,
      anon_sym_RBRACE,
    STATE(3713), 1,
      aux_sym_object_repeat1,
  [117314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym_COMMA,
    ACTIONS(6690), 1,
      anon_sym_RBRACE,
    STATE(3672), 1,
      aux_sym_object_repeat1,
  [117327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(6686), 1,
      anon_sym_RBRACE,
    STATE(3677), 1,
      aux_sym_object_pattern_repeat1,
  [117340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6692), 1,
      sym_identifier,
    ACTIONS(6694), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      sym_private_property_identifier,
  [117353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_EQ,
    ACTIONS(6700), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [117364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [117373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6702), 1,
      anon_sym_COMMA,
    ACTIONS(6705), 1,
      anon_sym_RPAREN,
    STATE(3548), 1,
      aux_sym_formal_parameters_repeat1,
  [117386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6711), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6713), 1,
      sym_identifier,
    ACTIONS(6715), 1,
      anon_sym_LBRACK,
    ACTIONS(6717), 1,
      sym_private_property_identifier,
  [117426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [117435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6721), 1,
      anon_sym_COMMA,
    ACTIONS(6723), 1,
      anon_sym_RBRACK,
    STATE(3726), 1,
      aux_sym_tuple_type_repeat1,
  [117448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6725), 1,
      anon_sym_as,
    ACTIONS(6727), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [117459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6729), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_extends,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
  [117481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [117490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6731), 1,
      anon_sym_COMMA,
    ACTIONS(6733), 1,
      anon_sym_RPAREN,
    STATE(3718), 1,
      aux_sym_formal_parameters_repeat1,
  [117503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_COMMA,
    ACTIONS(6735), 1,
      anon_sym_LBRACE,
    STATE(3450), 1,
      aux_sym_implements_clause_repeat1,
  [117516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4481), 1,
      anon_sym_extends,
    ACTIONS(6737), 1,
      anon_sym_AMP,
    ACTIONS(6739), 1,
      anon_sym_PIPE,
  [117529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2785), 1,
      anon_sym_GT,
    ACTIONS(6741), 1,
      anon_sym_COMMA,
    STATE(3450), 1,
      aux_sym_implements_clause_repeat1,
  [117542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6743), 1,
      anon_sym_COMMA,
    ACTIONS(6745), 1,
      anon_sym_RPAREN,
    STATE(3666), 1,
      aux_sym_formal_parameters_repeat1,
  [117555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6711), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117564] = 4,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(6747), 1,
      sym__glimmer_template_content,
    ACTIONS(6750), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(3565), 1,
      aux_sym_glimmer_template_repeat1,
  [117577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6752), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 1,
      anon_sym_GT,
    ACTIONS(6754), 1,
      anon_sym_COMMA,
    STATE(3619), 1,
      aux_sym_type_parameters_repeat1,
  [117599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6756), 1,
      sym_identifier,
    ACTIONS(6758), 1,
      anon_sym_LBRACK,
    ACTIONS(6760), 1,
      sym_private_property_identifier,
  [117612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      anon_sym_COMMA,
    ACTIONS(6764), 1,
      anon_sym_RBRACK,
    STATE(3595), 1,
      aux_sym_tuple_type_repeat1,
  [117625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6766), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6768), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4285), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [117656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_PIPE,
    ACTIONS(5644), 1,
      anon_sym_extends,
  [117669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_COMMA,
    ACTIONS(6405), 1,
      anon_sym_RBRACK,
    STATE(3701), 1,
      aux_sym_array_pattern_repeat1,
  [117682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6770), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_GT,
    ACTIONS(6772), 1,
      anon_sym_COMMA,
    STATE(3450), 1,
      aux_sym_implements_clause_repeat1,
  [117704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4356), 1,
      anon_sym_RBRACK,
    STATE(3503), 1,
      aux_sym_array_repeat1,
  [117717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4285), 1,
      anon_sym_RPAREN,
    STATE(3642), 1,
      aux_sym_array_repeat1,
  [117730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4289), 1,
      anon_sym_RPAREN,
    STATE(3600), 1,
      aux_sym_array_repeat1,
  [117752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4289), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [117765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6776), 1,
      sym_identifier,
    ACTIONS(6778), 1,
      anon_sym_LBRACK,
    ACTIONS(6780), 1,
      sym_private_property_identifier,
  [117778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_LBRACK,
    ACTIONS(6786), 1,
      sym_private_property_identifier,
  [117791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4356), 1,
      anon_sym_RBRACK,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [117804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6768), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6788), 1,
      sym_identifier,
    ACTIONS(6790), 1,
      anon_sym_LBRACK,
    ACTIONS(6792), 1,
      sym_private_property_identifier,
  [117826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6794), 1,
      sym_identifier,
    ACTIONS(6796), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      sym_private_property_identifier,
  [117839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [117850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6800), 1,
      sym_identifier,
    ACTIONS(6802), 1,
      anon_sym_LBRACK,
    ACTIONS(6804), 1,
      sym_private_property_identifier,
  [117863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1275), 1,
      anon_sym_LBRACE,
    STATE(3129), 1,
      sym_object_type,
  [117876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6806), 1,
      sym_identifier,
    ACTIONS(6808), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      sym_private_property_identifier,
  [117889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6812), 1,
      anon_sym_COMMA,
    ACTIONS(6814), 1,
      anon_sym_RBRACK,
    STATE(3613), 1,
      aux_sym_tuple_type_repeat1,
  [117902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6816), 1,
      sym_identifier,
    ACTIONS(6818), 1,
      anon_sym_LBRACK,
    ACTIONS(6820), 1,
      sym_private_property_identifier,
  [117915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6822), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 1,
      anon_sym_RBRACK,
    ACTIONS(6824), 1,
      anon_sym_COMMA,
    STATE(3728), 1,
      aux_sym_tuple_type_repeat1,
  [117937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_COMMA,
    ACTIONS(6405), 1,
      anon_sym_RBRACK,
    STATE(3699), 1,
      aux_sym_array_pattern_repeat1,
  [117950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_const,
    ACTIONS(6468), 1,
      sym_identifier,
    STATE(3611), 1,
      sym_type_parameter,
  [117963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6826), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4379), 1,
      anon_sym_RPAREN,
    STATE(3691), 1,
      aux_sym_array_repeat1,
  [117985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(6828), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [117998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4379), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [118011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2489), 1,
      anon_sym_RBRACK,
    ACTIONS(6830), 1,
      anon_sym_COMMA,
    STATE(3728), 1,
      aux_sym_tuple_type_repeat1,
  [118024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 1,
      anon_sym_implements,
    ACTIONS(6834), 1,
      anon_sym_LBRACE,
    STATE(4087), 1,
      sym_implements_clause,
  [118046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4385), 1,
      anon_sym_RBRACK,
    STATE(3515), 1,
      aux_sym_array_repeat1,
  [118059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6836), 1,
      anon_sym_COMMA,
    ACTIONS(6839), 1,
      anon_sym_RBRACE,
    STATE(3606), 1,
      aux_sym_enum_body_repeat1,
  [118072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6841), 1,
      sym_identifier,
    ACTIONS(6843), 1,
      anon_sym_LBRACK,
    ACTIONS(6845), 1,
      sym_private_property_identifier,
  [118085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6847), 1,
      anon_sym_LBRACE,
    ACTIONS(6156), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [118096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6849), 1,
      sym_identifier,
    ACTIONS(6851), 1,
      anon_sym_LBRACK,
    ACTIONS(6853), 1,
      sym_private_property_identifier,
  [118109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(210), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1226), 1,
      anon_sym_LBRACE,
    STATE(766), 1,
      sym_object_type,
  [118122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6855), 1,
      anon_sym_COMMA,
    ACTIONS(6857), 1,
      anon_sym_GT,
    STATE(3623), 1,
      aux_sym_type_parameters_repeat1,
  [118135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6859), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2493), 1,
      anon_sym_RBRACK,
    ACTIONS(6861), 1,
      anon_sym_COMMA,
    STATE(3728), 1,
      aux_sym_tuple_type_repeat1,
  [118157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6863), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6711), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6865), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3858), 1,
      anon_sym_LBRACE,
    ACTIONS(3860), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [118195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6867), 1,
      anon_sym_COMMA,
    ACTIONS(6870), 1,
      anon_sym_GT,
    STATE(3619), 1,
      aux_sym_type_parameters_repeat1,
  [118217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [118226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6872), 1,
      sym_identifier,
    ACTIONS(6874), 1,
      anon_sym_LBRACK,
    ACTIONS(6876), 1,
      sym_private_property_identifier,
  [118239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_GT,
    ACTIONS(6880), 1,
      anon_sym_COMMA,
    STATE(3619), 1,
      aux_sym_type_parameters_repeat1,
  [118261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(6882), 1,
      anon_sym_RBRACE,
    STATE(3677), 1,
      aux_sym_object_pattern_repeat1,
  [118274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_DQUOTE,
    ACTIONS(1293), 1,
      anon_sym_SQUOTE,
    STATE(3937), 1,
      sym_string,
  [118287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym_COMMA,
    ACTIONS(6884), 1,
      anon_sym_RBRACE,
    STATE(3672), 1,
      aux_sym_object_repeat1,
  [118300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4295), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [118313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4295), 1,
      anon_sym_RPAREN,
    STATE(3508), 1,
      aux_sym_array_repeat1,
  [118335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym_COMMA,
    ACTIONS(6888), 1,
      anon_sym_RBRACE,
    STATE(3672), 1,
      aux_sym_object_repeat1,
  [118348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6826), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(210), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1226), 1,
      anon_sym_LBRACE,
    STATE(684), 1,
      sym_object_type,
  [118370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6822), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6890), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6892), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(6894), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [118410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6896), 1,
      anon_sym_COMMA,
    ACTIONS(6898), 1,
      anon_sym_RBRACE,
    STATE(3711), 1,
      aux_sym_enum_body_repeat1,
  [118423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6900), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6902), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2783), 1,
      anon_sym_GT,
    ACTIONS(6904), 1,
      anon_sym_COMMA,
    STATE(3450), 1,
      aux_sym_implements_clause_repeat1,
  [118454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6865), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(6906), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [118476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6908), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6865), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_COMMA,
    ACTIONS(6407), 1,
      anon_sym_RBRACK,
    STATE(3699), 1,
      aux_sym_array_pattern_repeat1,
  [118507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6910), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [118516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6912), 1,
      anon_sym_COMMA,
    ACTIONS(6914), 1,
      anon_sym_RBRACE,
    STATE(3539), 1,
      aux_sym_export_clause_repeat1,
  [118529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6822), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2751), 1,
      anon_sym_GT,
    ACTIONS(6916), 1,
      anon_sym_COMMA,
    STATE(3450), 1,
      aux_sym_implements_clause_repeat1,
  [118551] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(6918), 1,
      anon_sym_RBRACE,
    STATE(3677), 1,
      aux_sym_object_pattern_repeat1,
  [118564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4293), 1,
      anon_sym_RPAREN,
    STATE(3657), 1,
      aux_sym_array_repeat1,
  [118577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4293), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [118590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5776), 1,
      anon_sym_EQ,
    ACTIONS(3118), 2,
      anon_sym_in,
      anon_sym_of,
  [118601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6920), 1,
      anon_sym_as,
    ACTIONS(6922), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [118612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [118621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6926), 1,
      anon_sym_COMMA,
    ACTIONS(6929), 1,
      anon_sym_RBRACE,
    STATE(3656), 1,
      aux_sym_export_clause_repeat1,
  [118634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(6931), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [118647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6933), 1,
      anon_sym_LBRACE,
    ACTIONS(6216), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [118658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_AMP,
    ACTIONS(5421), 1,
      anon_sym_PIPE,
    ACTIONS(5423), 1,
      anon_sym_extends,
  [118671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym_COMMA,
    ACTIONS(6935), 1,
      anon_sym_RBRACE,
    STATE(3672), 1,
      aux_sym_object_repeat1,
  [118684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(6937), 1,
      anon_sym_RBRACE,
    STATE(3677), 1,
      aux_sym_object_pattern_repeat1,
  [118697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3591), 1,
      anon_sym_extends,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6941), 1,
      anon_sym_PIPE,
  [118710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(6882), 1,
      anon_sym_RBRACE,
    STATE(3650), 1,
      aux_sym_object_pattern_repeat1,
  [118723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_DOT,
    ACTIONS(6943), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [118734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5682), 1,
      anon_sym_DOT,
    ACTIONS(6943), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [118745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 1,
      anon_sym_RPAREN,
    ACTIONS(6945), 1,
      anon_sym_COMMA,
    STATE(3548), 1,
      aux_sym_formal_parameters_repeat1,
  [118758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(6947), 1,
      anon_sym_RBRACE,
    STATE(3677), 1,
      aux_sym_object_pattern_repeat1,
  [118771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 1,
      anon_sym_COMMA,
    ACTIONS(6951), 1,
      anon_sym_RBRACK,
    STATE(3507), 1,
      aux_sym_tuple_type_repeat1,
  [118784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4838), 1,
      anon_sym_COMMA,
    ACTIONS(6953), 1,
      anon_sym_RBRACE,
    STATE(3677), 1,
      aux_sym_object_pattern_repeat1,
  [118797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_COMMA,
    ACTIONS(6957), 1,
      anon_sym_GT,
    STATE(3567), 1,
      aux_sym_type_parameters_repeat1,
  [118810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym_COMMA,
    ACTIONS(6961), 1,
      anon_sym_RBRACK,
    STATE(3602), 1,
      aux_sym_tuple_type_repeat1,
  [118823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_COMMA,
    ACTIONS(6966), 1,
      anon_sym_RBRACE,
    STATE(3672), 1,
      aux_sym_object_repeat1,
  [118836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4349), 1,
      anon_sym_RPAREN,
    STATE(3675), 1,
      aux_sym_array_repeat1,
  [118849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(4349), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [118862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(6968), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [118875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 1,
      anon_sym_type,
    ACTIONS(6970), 1,
      sym_identifier,
    STATE(3808), 1,
      sym__import_identifier,
  [118888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6972), 1,
      anon_sym_COMMA,
    ACTIONS(6975), 1,
      anon_sym_RBRACE,
    STATE(3677), 1,
      aux_sym_object_pattern_repeat1,
  [118901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 1,
      anon_sym_type,
    ACTIONS(6977), 1,
      sym_identifier,
    STATE(3811), 1,
      sym__import_identifier,
  [118914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym_COMMA,
    ACTIONS(6979), 1,
      anon_sym_RBRACE,
    STATE(3672), 1,
      aux_sym_object_repeat1,
  [118927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 1,
      anon_sym_COMMA,
    ACTIONS(6984), 1,
      anon_sym_RBRACE,
    STATE(3680), 1,
      aux_sym_named_imports_repeat1,
  [118940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1242), 1,
      anon_sym_SQUOTE,
    STATE(4172), 1,
      sym_string,
  [118953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5445), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
  [118962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym_COMMA,
    ACTIONS(6888), 1,
      anon_sym_RBRACE,
    STATE(3626), 1,
      aux_sym_object_repeat1,
  [118975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6986), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [118993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1275), 1,
      anon_sym_LBRACE,
    STATE(3134), 1,
      sym_object_type,
  [119006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 1,
      anon_sym_EQ,
    ACTIONS(6700), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [119017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 1,
      anon_sym_COMMA,
    ACTIONS(6992), 1,
      anon_sym_RBRACE,
    STATE(3724), 1,
      aux_sym_enum_body_repeat1,
  [119030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    ACTIONS(6994), 1,
      anon_sym_RPAREN,
    STATE(4174), 1,
      sym_type_annotation,
  [119043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6996), 1,
      anon_sym_LPAREN,
    ACTIONS(6998), 1,
      anon_sym_await,
    STATE(45), 1,
      sym__for_header,
  [119056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    ACTIONS(7000), 1,
      anon_sym_RPAREN,
    STATE(3410), 1,
      aux_sym_array_repeat1,
  [119069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(6060), 1,
      anon_sym_PIPE,
    ACTIONS(6062), 1,
      anon_sym_extends,
  [119082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7002), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5137), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7002), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7004), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7002), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7006), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7008), 1,
      anon_sym_COMMA,
    ACTIONS(7011), 1,
      anon_sym_RBRACK,
    STATE(3699), 1,
      aux_sym_array_pattern_repeat1,
  [119149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7013), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [119158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_COMMA,
    ACTIONS(7015), 1,
      anon_sym_RBRACK,
    STATE(3699), 1,
      aux_sym_array_pattern_repeat1,
  [119171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7006), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7017), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7019), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [119198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2085), 1,
      anon_sym_while,
    ACTIONS(7021), 1,
      anon_sym_else,
    STATE(751), 1,
      sym_else_clause,
  [119211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_from,
    ACTIONS(6665), 1,
      anon_sym_as,
    STATE(3759), 1,
      sym__from_clause,
  [119224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1806), 1,
      anon_sym_LBRACE,
    ACTIONS(7023), 1,
      sym_identifier,
    STATE(3438), 1,
      sym_export_clause,
  [119237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2755), 1,
      anon_sym_GT,
    ACTIONS(7025), 1,
      anon_sym_COMMA,
    STATE(3450), 1,
      aux_sym_implements_clause_repeat1,
  [119250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6403), 1,
      anon_sym_EQ,
    ACTIONS(7011), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [119261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4291), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [119270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 1,
      anon_sym_COMMA,
    ACTIONS(7029), 1,
      anon_sym_RBRACE,
    STATE(3606), 1,
      aux_sym_enum_body_repeat1,
  [119283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 1,
      anon_sym_COMMA,
    ACTIONS(7033), 1,
      anon_sym_RBRACE,
    STATE(3606), 1,
      aux_sym_enum_body_repeat1,
  [119296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym_COMMA,
    ACTIONS(7035), 1,
      anon_sym_RBRACE,
    STATE(3672), 1,
      aux_sym_object_repeat1,
  [119309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7037), 1,
      anon_sym_as,
    ACTIONS(6700), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [119320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    ACTIONS(7039), 1,
      anon_sym_LPAREN,
    STATE(607), 1,
      sym_statement_block,
  [119333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym_COMMA,
    ACTIONS(7043), 1,
      anon_sym_RBRACE,
    STATE(3530), 1,
      aux_sym_named_imports_repeat1,
  [119346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7045), 1,
      sym_identifier,
    STATE(2208), 1,
      sym_decorator_member_expression,
    STATE(2277), 1,
      sym_decorator_call_expression,
  [119359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 1,
      anon_sym_RPAREN,
    ACTIONS(7047), 1,
      anon_sym_COMMA,
    STATE(3548), 1,
      aux_sym_formal_parameters_repeat1,
  [119372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 1,
      sym_identifier,
    ACTIONS(7051), 1,
      anon_sym_require,
    STATE(3532), 1,
      sym_nested_identifier,
  [119385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [119394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7053), 1,
      anon_sym_LBRACE,
    ACTIONS(6306), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [119405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_const,
    ACTIONS(6468), 1,
      sym_identifier,
    STATE(3878), 1,
      sym_type_parameter,
  [119418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7055), 1,
      anon_sym_COMMA,
    ACTIONS(7057), 1,
      anon_sym_RBRACE,
    STATE(3606), 1,
      aux_sym_enum_body_repeat1,
  [119440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_const,
    ACTIONS(6468), 1,
      sym_identifier,
    STATE(3670), 1,
      sym_type_parameter,
  [119453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 1,
      anon_sym_RBRACK,
    ACTIONS(7059), 1,
      anon_sym_COMMA,
    STATE(3728), 1,
      aux_sym_tuple_type_repeat1,
  [119466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7061), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [119475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7063), 1,
      anon_sym_COMMA,
    ACTIONS(7066), 1,
      anon_sym_RBRACK,
    STATE(3728), 1,
      aux_sym_tuple_type_repeat1,
  [119488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7068), 1,
      sym_identifier,
    ACTIONS(7070), 1,
      anon_sym_LBRACK,
    ACTIONS(7072), 1,
      sym_private_property_identifier,
  [119501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LT,
    ACTIONS(7074), 1,
      anon_sym_EQ,
    STATE(4144), 1,
      sym_type_parameters,
  [119514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7076), 1,
      anon_sym_EQ,
    ACTIONS(3118), 2,
      anon_sym_in,
      anon_sym_of,
  [119525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1932), 1,
      sym_class_body,
  [119553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5153), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [119561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [119569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_COLON,
    STATE(3534), 1,
      sym_type_annotation,
  [119579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4023), 1,
      sym_formal_parameters,
  [119589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7080), 1,
      sym_identifier,
    ACTIONS(7082), 1,
      sym_private_property_identifier,
  [119599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4093), 1,
      sym_formal_parameters,
  [119609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7066), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [119617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(755), 1,
      sym_enum_body,
  [119627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7086), 1,
      sym_identifier,
    ACTIONS(7088), 1,
      anon_sym_STAR,
  [119637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5409), 1,
      anon_sym_LPAREN,
    STATE(2792), 1,
      sym_formal_parameters,
  [119647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1954), 1,
      sym_class_body,
  [119657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [119665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_STAR,
  [119675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3210), 1,
      sym_class_body,
  [119685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(617), 1,
      sym_statement_block,
  [119695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 1,
      anon_sym_SEMI,
    ACTIONS(7098), 1,
      sym__automatic_semicolon,
  [119705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_LBRACE,
    STATE(1387), 1,
      sym_statement_block,
  [119715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2921), 1,
      sym_formal_parameters,
  [119725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym__for_header,
  [119735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3175), 1,
      sym_class_body,
  [119745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_LBRACE,
    STATE(662), 1,
      sym_class_body,
  [119755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7102), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [119763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 1,
      anon_sym_LBRACE,
    STATE(3206), 1,
      sym_enum_body,
  [119773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7106), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [119781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 1,
      anon_sym_SEMI,
    ACTIONS(7110), 1,
      sym__automatic_semicolon,
  [119791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LPAREN,
    STATE(3944), 1,
      sym_parenthesized_expression,
  [119801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4060), 1,
      sym_formal_parameters,
  [119811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(681), 1,
      sym_statement_block,
  [119821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [119829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 1,
      anon_sym_LBRACE,
    STATE(145), 1,
      sym_statement_block,
  [119839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3229), 1,
      sym_class_body,
  [119849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(3215), 1,
      sym_statement_block,
  [119859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4054), 1,
      sym_formal_parameters,
  [119869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(1389), 1,
      sym_class_body,
  [119879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_LBRACE,
    STATE(637), 1,
      sym_class_body,
  [119889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [119897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [119905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7120), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [119913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(615), 1,
      sym_statement_block,
  [119923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1835), 1,
      sym_statement_block,
  [119933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(613), 1,
      sym_class_body,
  [119943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(1416), 1,
      sym_class_body,
  [119953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [119961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_from,
    STATE(3977), 1,
      sym__from_clause,
  [119971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_LBRACE,
    STATE(1405), 1,
      sym_statement_block,
  [119981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3959), 1,
      sym_statement_block,
  [119991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5131), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [119999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_LBRACE,
    STATE(1425), 1,
      sym_statement_block,
  [120009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym_LPAREN,
    STATE(44), 1,
      sym_parenthesized_expression,
  [120019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3132), 1,
      sym_formal_parameters,
  [120029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1978), 1,
      sym_class_body,
  [120039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4072), 1,
      sym_formal_parameters,
  [120049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(1426), 1,
      sym_class_body,
  [120059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3158), 1,
      sym_class_body,
  [120069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
  [120079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 1,
      anon_sym_LBRACE,
    STATE(153), 1,
      sym_class_body,
  [120089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3155), 1,
      sym_class_body,
  [120099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7011), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [120107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(1427), 1,
      sym_class_body,
  [120117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1843), 1,
      sym_class_body,
  [120127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4221), 1,
      sym_formal_parameters,
  [120137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4253), 1,
      sym_formal_parameters,
  [120147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1836), 1,
      sym_class_body,
  [120157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym_LPAREN,
    STATE(32), 1,
      sym_parenthesized_expression,
  [120167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3898), 1,
      sym_statement_block,
  [120177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1849), 1,
      sym_statement_block,
  [120187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3116), 1,
      sym_class_body,
  [120197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(2067), 1,
      sym_class_body,
  [120207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(2063), 1,
      sym_class_body,
  [120217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [120225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1885), 1,
      sym_class_body,
  [120235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1850), 1,
      sym_class_body,
  [120245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 2,
      anon_sym_in,
      anon_sym_of,
  [120253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4255), 1,
      sym_formal_parameters,
  [120271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1887), 1,
      sym_statement_block,
  [120281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1890), 1,
      sym_statement_block,
  [120299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 1,
      anon_sym_SEMI,
    ACTIONS(7132), 1,
      sym__automatic_semicolon,
  [120309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7134), 1,
      anon_sym_SEMI,
    ACTIONS(7136), 1,
      sym__automatic_semicolon,
  [120319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3111), 1,
      sym_formal_parameters,
  [120329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1982), 1,
      sym_statement_block,
  [120339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    STATE(3895), 1,
      sym_type_annotation,
  [120349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      sym_identifier,
    STATE(3665), 1,
      sym_nested_identifier,
  [120359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5181), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 1,
      anon_sym_LBRACE,
    STATE(168), 1,
      sym_class_body,
  [120377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      sym_identifier,
    ACTIONS(7142), 1,
      sym_private_property_identifier,
  [120387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 1,
      sym_identifier,
    ACTIONS(7146), 1,
      sym_private_property_identifier,
  [120397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 1,
      sym_identifier,
    ACTIONS(7150), 1,
      sym_private_property_identifier,
  [120407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_in,
    ACTIONS(6168), 1,
      anon_sym_of,
  [120425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1947), 1,
      sym_statement_block,
  [120435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(2075), 1,
      sym_class_body,
  [120445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7152), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 1,
      sym_identifier,
    ACTIONS(7156), 1,
      sym_private_property_identifier,
  [120463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(606), 1,
      sym_statement_block,
  [120473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1949), 1,
      sym_class_body,
  [120483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3189), 1,
      sym_formal_parameters,
  [120493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3983), 1,
      sym_statement_block,
  [120503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4036), 1,
      sym_formal_parameters,
  [120513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4120), 1,
      sym_formal_parameters,
  [120523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1875), 1,
      sym_statement_block,
  [120533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1984), 1,
      sym_class_body,
  [120543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(3208), 1,
      sym_statement_block,
  [120553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_LBRACE,
    STATE(1432), 1,
      sym_statement_block,
  [120563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1946), 1,
      sym_statement_block,
  [120573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [120581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1881), 1,
      sym_class_body,
  [120591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1944), 1,
      sym_class_body,
  [120601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5185), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6966), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3781), 1,
      sym_statement_block,
  [120627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5181), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_SEMI,
    ACTIONS(7162), 1,
      sym__automatic_semicolon,
  [120653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3777), 1,
      sym_statement_block,
  [120663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_LBRACE,
    STATE(1436), 1,
      sym_statement_block,
  [120673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(601), 1,
      sym_class_body,
  [120683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(3232), 1,
      sym_statement_block,
  [120693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(616), 1,
      sym_statement_block,
  [120703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(1445), 1,
      sym_class_body,
  [120713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7164), 1,
      anon_sym_in,
    ACTIONS(7166), 1,
      anon_sym_COLON,
  [120723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3924), 1,
      sym_statement_block,
  [120733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(608), 1,
      sym_class_body,
  [120743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7168), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 1,
      anon_sym_SEMI,
    ACTIONS(7172), 1,
      sym__automatic_semicolon,
  [120761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6929), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 1,
      sym_identifier,
    ACTIONS(7176), 1,
      anon_sym_STAR,
  [120779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3117), 1,
      sym_class_body,
  [120789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5157), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(3198), 1,
      sym_class_body,
  [120807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_from,
    STATE(3813), 1,
      sym__from_clause,
  [120817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [120825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 1,
      anon_sym_LBRACE,
    STATE(158), 1,
      sym_class_body,
  [120835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3864), 1,
      sym_statement_block,
  [120845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5189), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 1,
      anon_sym_SEMI,
    ACTIONS(7184), 1,
      sym__automatic_semicolon,
  [120871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_LBRACE,
    STATE(672), 1,
      sym_class_body,
  [120881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [120889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3943), 1,
      sym_statement_block,
  [120899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 1,
      sym_identifier,
    ACTIONS(7188), 1,
      sym_private_property_identifier,
  [120909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5161), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6870), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [120925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 1,
      anon_sym_SEMI,
    ACTIONS(7192), 1,
      sym__automatic_semicolon,
  [120935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(682), 1,
      sym_enum_body,
  [120945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(675), 1,
      sym_statement_block,
  [120955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(1459), 1,
      sym_class_body,
  [120973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4149), 1,
      sym_formal_parameters,
  [120983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4048), 1,
      sym_formal_parameters,
  [120993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7196), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [121001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    STATE(1461), 1,
      sym_arguments,
  [121011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7198), 1,
      sym_identifier,
    ACTIONS(7200), 1,
      sym_private_property_identifier,
  [121021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1924), 1,
      sym_statement_block,
  [121039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4317), 1,
      sym_formal_parameters,
  [121049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3735), 1,
      sym_statement_block,
  [121059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5193), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [121075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [121083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    STATE(3867), 1,
      sym_type_annotation,
  [121093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1913), 1,
      sym_class_body,
  [121103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7206), 1,
      sym_identifier,
    ACTIONS(7208), 1,
      sym_private_property_identifier,
  [121121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(3204), 1,
      sym_formal_parameters,
  [121131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 1,
      sym_identifier,
    ACTIONS(7212), 1,
      sym_private_property_identifier,
  [121141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4157), 1,
      sym_formal_parameters,
  [121151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 1,
      sym_identifier,
    ACTIONS(7216), 1,
      sym_private_property_identifier,
  [121161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [121169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6794), 1,
      sym_identifier,
    ACTIONS(6798), 1,
      sym_private_property_identifier,
  [121179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7220), 1,
      sym_identifier,
    ACTIONS(7222), 1,
      sym_private_property_identifier,
  [121189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3877), 1,
      sym_statement_block,
  [121199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 1,
      sym_identifier,
    ACTIONS(7226), 1,
      sym_private_property_identifier,
  [121209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3673), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2680), 1,
      sym_formal_parameters,
  [121227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 1,
      sym_identifier,
    ACTIONS(7230), 1,
      sym_private_property_identifier,
  [121237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7232), 1,
      sym_identifier,
    ACTIONS(7234), 1,
      sym_private_property_identifier,
  [121247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4364), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4107), 1,
      sym_formal_parameters,
  [121265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4377), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6756), 1,
      sym_identifier,
    ACTIONS(6760), 1,
      sym_private_property_identifier,
  [121291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5131), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_LPAREN,
    STATE(1985), 1,
      sym_arguments,
  [121317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7238), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3871), 1,
      sym_statement_block,
  [121335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(2885), 1,
      sym_formal_parameters,
  [121345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6040), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [121361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 1,
      anon_sym_LBRACE,
    STATE(164), 1,
      sym_statement_block,
  [121371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [121387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1898), 1,
      sym_statement_block,
  [121397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6030), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [121405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1995), 1,
      sym_class_body,
  [121415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4334), 1,
      sym_formal_parameters,
  [121425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 1,
      sym_identifier,
    ACTIONS(7244), 1,
      sym_private_property_identifier,
  [121435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3893), 1,
      sym_statement_block,
  [121445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym__for_header,
  [121455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 1,
      anon_sym_LBRACE,
    STATE(142), 1,
      sym_class_body,
  [121465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7246), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7248), 1,
      anon_sym_LBRACE,
    STATE(753), 1,
      sym_switch_body,
  [121483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_SEMI,
    ACTIONS(7252), 1,
      sym__automatic_semicolon,
  [121493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7254), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7256), 1,
      sym_identifier,
    ACTIONS(7258), 1,
      sym_private_property_identifier,
  [121511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7260), 1,
      sym_identifier,
    ACTIONS(7262), 1,
      sym_private_property_identifier,
  [121521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7264), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7266), 1,
      sym_identifier,
    ACTIONS(7268), 1,
      sym_private_property_identifier,
  [121547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7270), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(2052), 1,
      sym_class_body,
  [121573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [121581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7274), 1,
      anon_sym_COMMA,
    ACTIONS(7276), 1,
      anon_sym_from,
  [121591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5161), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7278), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [121607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5157), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym_LPAREN,
    STATE(47), 1,
      sym_parenthesized_expression,
  [121633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_LT,
    ACTIONS(3216), 1,
      anon_sym_LPAREN,
  [121643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6705), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [121651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_from,
    STATE(3750), 1,
      sym__from_clause,
  [121661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_LBRACE,
    STATE(1513), 1,
      sym_statement_block,
  [121679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4220), 1,
      sym_formal_parameters,
  [121689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_LBRACE,
    STATE(741), 1,
      sym_class_body,
  [121699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_LBRACE,
    STATE(1503), 1,
      sym_statement_block,
  [121709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(1490), 1,
      sym_class_body,
  [121719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(4098), 1,
      sym_formal_parameters,
  [121729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_LBRACE,
    STATE(1507), 1,
      sym_statement_block,
  [121739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7280), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7282), 1,
      sym_identifier,
    ACTIONS(7284), 1,
      sym_private_property_identifier,
  [121757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6692), 1,
      sym_identifier,
    ACTIONS(6696), 1,
      sym_private_property_identifier,
  [121767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_from,
    STATE(3860), 1,
      sym__from_clause,
  [121777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 1,
      sym_identifier,
    ACTIONS(7288), 1,
      anon_sym_STAR,
  [121787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1997), 1,
      sym_statement_block,
  [121797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      anon_sym_LBRACE,
    STATE(1502), 1,
      sym_class_body,
  [121807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LPAREN,
    STATE(2963), 1,
      sym_formal_parameters,
  [121825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1993), 1,
      sym_class_body,
  [121835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7292), 1,
      anon_sym_SEMI,
    ACTIONS(7294), 1,
      sym__automatic_semicolon,
  [121845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    STATE(1968), 1,
      sym_statement_block,
  [121855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1953), 1,
      sym_class_body,
  [121865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4243), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(1974), 1,
      sym_class_body,
  [121891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5199), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3844), 1,
      sym_statement_block,
  [121909] = 2,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(7296), 2,
      sym__glimmer_template_content,
      anon_sym_LT_SLASHtemplate_GT,
  [121917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7298), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym_LPAREN,
    STATE(34), 1,
      sym_parenthesized_expression,
  [121943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(574), 1,
      sym_statement_block,
  [121953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LBRACE,
    STATE(3848), 1,
      sym_statement_block,
  [121963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_parenthesized_expression,
  [121981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 1,
      anon_sym_LBRACE,
    STATE(3146), 1,
      sym_enum_body,
  [121991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym_LPAREN,
    STATE(3938), 1,
      sym_parenthesized_expression,
  [122001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_LBRACE,
    STATE(620), 1,
      sym_class_body,
  [122011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7300), 1,
      sym_identifier,
    STATE(3532), 1,
      sym_nested_identifier,
  [122021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7302), 1,
      anon_sym_symbol,
  [122028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7304), 1,
      anon_sym_from,
  [122035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7306), 1,
      anon_sym_from,
  [122042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7308), 1,
      anon_sym_RPAREN,
  [122049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7310), 1,
      anon_sym_as,
  [122056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7312), 1,
      anon_sym_COLON,
  [122063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7314), 1,
      sym_identifier,
  [122070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7316), 1,
      anon_sym_LPAREN,
  [122077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7318), 1,
      anon_sym_from,
  [122084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7320), 1,
      anon_sym_require,
  [122091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4533), 1,
      anon_sym_RBRACK,
  [122098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_RBRACK,
  [122105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6723), 1,
      anon_sym_RBRACK,
  [122112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_RBRACK,
  [122119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
  [122126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7328), 1,
      anon_sym_EQ_GT,
  [122133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_from,
  [122140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7332), 1,
      sym_identifier,
  [122147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7334), 1,
      sym_identifier,
  [122154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 1,
      anon_sym_DOT,
  [122161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7338), 1,
      anon_sym_EQ_GT,
  [122168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7340), 1,
      sym_identifier,
  [122175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7342), 1,
      sym_identifier,
  [122182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7344), 1,
      anon_sym_EQ_GT,
  [122189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 1,
      anon_sym_EQ_GT,
  [122196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7348), 1,
      anon_sym_EQ_GT,
  [122203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 1,
      anon_sym_EQ_GT,
  [122210] = 2,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(7352), 1,
      sym_regex_pattern,
  [122217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 1,
      anon_sym_EQ_GT,
  [122224] = 2,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(7356), 1,
      sym_regex_pattern,
  [122231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_DOT,
  [122238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7360), 1,
      anon_sym_EQ_GT,
  [122245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4495), 1,
      anon_sym_RBRACK,
  [122252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7362), 1,
      anon_sym_EQ_GT,
  [122259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7364), 1,
      anon_sym_EQ_GT,
  [122266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_EQ,
  [122273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 1,
      anon_sym_EQ_GT,
  [122280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3993), 1,
      anon_sym_RPAREN,
  [122287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7368), 1,
      sym_identifier,
  [122294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 1,
      anon_sym_EQ_GT,
  [122301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_RBRACK,
  [122308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7372), 1,
      anon_sym_EQ_GT,
  [122315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 1,
      sym_identifier,
  [122322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7376), 1,
      sym_identifier,
  [122329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 1,
      anon_sym_SLASH2,
  [122336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4493), 1,
      anon_sym_RBRACE,
  [122343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6814), 1,
      anon_sym_RBRACK,
  [122350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7380), 1,
      sym_number,
  [122357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      anon_sym_RPAREN,
  [122364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7382), 1,
      anon_sym_COLON,
  [122371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7384), 1,
      sym_identifier,
  [122378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7386), 1,
      anon_sym_EQ_GT,
  [122385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4549), 1,
      anon_sym_RBRACK,
  [122392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7388), 1,
      sym_identifier,
  [122399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5359), 1,
      anon_sym_is,
  [122406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7390), 1,
      sym_identifier,
  [122413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7392), 1,
      anon_sym_RBRACK,
  [122420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7394), 1,
      anon_sym_EQ_GT,
  [122427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 1,
      sym_identifier,
  [122434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 1,
      anon_sym_RPAREN,
  [122441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 1,
      anon_sym_is,
  [122448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7398), 1,
      anon_sym_EQ_GT,
  [122455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_EQ_GT,
  [122462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7402), 1,
      anon_sym_EQ_GT,
  [122469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7404), 1,
      anon_sym_from,
  [122476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6961), 1,
      anon_sym_RBRACK,
  [122483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7406), 1,
      sym_identifier,
  [122490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 1,
      anon_sym_RBRACK,
  [122497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7410), 1,
      sym_identifier,
  [122504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7412), 1,
      anon_sym_RBRACK,
  [122511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7414), 1,
      anon_sym_RBRACK,
  [122518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 1,
      sym_identifier,
  [122525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_COLON,
  [122532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7418), 1,
      anon_sym_new,
  [122539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 1,
      anon_sym_RBRACK,
  [122546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7422), 1,
      anon_sym_EQ_GT,
  [122553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 1,
      anon_sym_EQ_GT,
  [122560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 1,
      anon_sym_RPAREN,
  [122567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7426), 1,
      anon_sym_EQ_GT,
  [122574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7428), 1,
      anon_sym_EQ_GT,
  [122581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 1,
      anon_sym_EQ_GT,
  [122588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7432), 1,
      anon_sym_EQ_GT,
  [122595] = 2,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(7434), 1,
      sym_regex_pattern,
  [122602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7436), 1,
      anon_sym_EQ_GT,
  [122609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 1,
      anon_sym_EQ_GT,
  [122616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym_DOT,
  [122623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 1,
      anon_sym_RPAREN,
  [122630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 1,
      anon_sym_RBRACK,
  [122637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7444), 1,
      anon_sym_RBRACK,
  [122644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_RPAREN,
  [122651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
  [122658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7448), 1,
      sym_identifier,
  [122665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 1,
      anon_sym_RBRACK,
  [122672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7452), 1,
      sym_identifier,
  [122679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5612), 1,
      anon_sym_is,
  [122686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7454), 1,
      anon_sym_RBRACK,
  [122693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7456), 1,
      anon_sym_EQ_GT,
  [122700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7458), 1,
      sym_identifier,
  [122707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7460), 1,
      anon_sym_EQ_GT,
  [122714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7462), 1,
      anon_sym_readonly,
  [122721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7464), 1,
      anon_sym_RBRACK,
  [122728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7466), 1,
      anon_sym_EQ_GT,
  [122735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7468), 1,
      anon_sym_DOT,
  [122742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 1,
      anon_sym_RBRACK,
  [122749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7472), 1,
      anon_sym_RBRACK,
  [122756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 1,
      anon_sym_RBRACK,
  [122763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7476), 1,
      anon_sym_RBRACK,
  [122770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 1,
      anon_sym_RPAREN,
  [122777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7480), 1,
      anon_sym_RBRACK,
  [122784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 1,
      anon_sym_RBRACK,
  [122791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7484), 1,
      anon_sym_EQ_GT,
  [122798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 1,
      anon_sym_RBRACK,
  [122805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7488), 1,
      anon_sym_RBRACK,
  [122812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 1,
      anon_sym_RBRACK,
  [122819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7492), 1,
      sym_identifier,
  [122826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7494), 1,
      anon_sym_RBRACK,
  [122833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7496), 1,
      anon_sym_RBRACK,
  [122840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7498), 1,
      anon_sym_class,
  [122847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7500), 1,
      anon_sym_RPAREN,
  [122854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7502), 1,
      anon_sym_EQ_GT,
  [122861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7504), 1,
      anon_sym_RBRACK,
  [122868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 1,
      anon_sym_EQ,
  [122875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7508), 1,
      anon_sym_namespace,
  [122882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 1,
      anon_sym_EQ_GT,
  [122889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7512), 1,
      anon_sym_RBRACK,
  [122896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 1,
      anon_sym_RBRACK,
  [122903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      anon_sym_RBRACK,
  [122910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 1,
      anon_sym_EQ_GT,
  [122917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7520), 1,
      anon_sym_RBRACK,
  [122924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 1,
      anon_sym_RBRACK,
  [122931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7524), 1,
      anon_sym_RBRACK,
  [122938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7526), 1,
      anon_sym_EQ_GT,
  [122945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7528), 1,
      anon_sym_RBRACK,
  [122952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7530), 1,
      anon_sym_EQ_GT,
  [122959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7532), 1,
      anon_sym_EQ_GT,
  [122966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5776), 1,
      anon_sym_EQ,
  [122973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7534), 1,
      anon_sym_RBRACK,
  [122980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7536), 1,
      anon_sym_new,
  [122987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7538), 1,
      sym_identifier,
  [122994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7540), 1,
      anon_sym_RBRACK,
  [123001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7542), 1,
      anon_sym_RBRACK,
  [123008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7023), 1,
      sym_identifier,
  [123015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7544), 1,
      anon_sym_class,
  [123022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7546), 1,
      anon_sym_RBRACK,
  [123029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7548), 1,
      anon_sym_RBRACK,
  [123036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7550), 1,
      anon_sym_EQ,
  [123043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7552), 1,
      sym_identifier,
  [123050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7554), 1,
      anon_sym_EQ,
  [123057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7556), 1,
      anon_sym_COLON,
  [123064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7558), 1,
      anon_sym_EQ_GT,
  [123071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7560), 1,
      anon_sym_RBRACK,
  [123078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7562), 1,
      anon_sym_DOT,
  [123085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7564), 1,
      anon_sym_EQ_GT,
  [123092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7566), 1,
      sym_identifier,
  [123099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7568), 1,
      anon_sym_RPAREN,
  [123106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7570), 1,
      anon_sym_RPAREN,
  [123113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7572), 1,
      anon_sym_as,
  [123120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7574), 1,
      anon_sym_RPAREN,
  [123127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7576), 1,
      anon_sym_RBRACK,
  [123134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7578), 1,
      anon_sym_RPAREN,
  [123141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7580), 1,
      anon_sym_EQ_GT,
  [123148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7582), 1,
      anon_sym_from,
  [123155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_RBRACE,
  [123162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7584), 1,
      anon_sym_RBRACK,
  [123169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7586), 1,
      anon_sym_RBRACK,
  [123176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7588), 1,
      anon_sym_COLON,
  [123183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7590), 1,
      anon_sym_RBRACK,
  [123190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7592), 1,
      sym_identifier,
  [123197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7594), 1,
      sym_identifier,
  [123204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7596), 1,
      sym_identifier,
  [123211] = 2,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(7598), 1,
      sym_regex_pattern,
  [123218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7600), 1,
      anon_sym_RBRACK,
  [123225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7602), 1,
      sym_identifier,
  [123232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7604), 1,
      anon_sym_RBRACK,
  [123239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7606), 1,
      anon_sym_from,
  [123246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7608), 1,
      anon_sym_RPAREN,
  [123253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7610), 1,
      anon_sym_RBRACK,
  [123260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7612), 1,
      anon_sym_RPAREN,
  [123267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7614), 1,
      anon_sym_RBRACK,
  [123274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7616), 1,
      sym_identifier,
  [123281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6951), 1,
      anon_sym_RBRACK,
  [123288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_EQ_GT,
  [123295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7620), 1,
      anon_sym_RBRACK,
  [123302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5529), 1,
      anon_sym_is,
  [123309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7622), 1,
      anon_sym_EQ_GT,
  [123316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7624), 1,
      anon_sym_EQ,
  [123323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7626), 1,
      anon_sym_RBRACK,
  [123330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_symbol,
  [123337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7630), 1,
      anon_sym_RBRACK,
  [123344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7632), 1,
      sym_identifier,
  [123351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7634), 1,
      anon_sym_RBRACK,
  [123358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7636), 1,
      sym_identifier,
  [123365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      sym_identifier,
  [123372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7640), 1,
      anon_sym_EQ,
  [123379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7642), 1,
      sym_identifier,
  [123386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7644), 1,
      anon_sym_COLON,
  [123393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7646), 1,
      anon_sym_RBRACK,
  [123400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7648), 1,
      sym_identifier,
  [123407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7650), 1,
      sym_identifier,
  [123414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7652), 1,
      anon_sym_RBRACK,
  [123421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7654), 1,
      anon_sym_EQ,
  [123428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7656), 1,
      anon_sym_RBRACK,
  [123435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7658), 1,
      sym_identifier,
  [123442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7660), 1,
      sym_identifier,
  [123449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6914), 1,
      anon_sym_RBRACE,
  [123456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7662), 1,
      sym_identifier,
  [123463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7664), 1,
      sym_identifier,
  [123470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7666), 1,
      anon_sym_RPAREN,
  [123477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7668), 1,
      anon_sym_RBRACK,
  [123484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7670), 1,
      sym_identifier,
  [123491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7672), 1,
      anon_sym_RBRACK,
  [123498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7674), 1,
      sym_number,
  [123505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7676), 1,
      anon_sym_class,
  [123512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7678), 1,
      anon_sym_RBRACK,
  [123519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_RBRACK,
  [123526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7682), 1,
      anon_sym_RBRACK,
  [123533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7684), 1,
      anon_sym_RBRACK,
  [123540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7686), 1,
      anon_sym_RBRACK,
  [123547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7688), 1,
      anon_sym_RBRACK,
  [123554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7690), 1,
      anon_sym_RBRACK,
  [123561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7692), 1,
      anon_sym_EQ_GT,
  [123568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7694), 1,
      anon_sym_RBRACK,
  [123575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6667), 1,
      sym_identifier,
  [123582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_EQ_GT,
  [123589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7698), 1,
      anon_sym_EQ_GT,
  [123596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7700), 1,
      anon_sym_RBRACK,
  [123603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_RBRACK,
  [123610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym_RBRACK,
  [123617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_RBRACK,
  [123624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7708), 1,
      anon_sym_EQ_GT,
  [123631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7710), 1,
      anon_sym_DOT,
  [123638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7712), 1,
      anon_sym_symbol,
  [123645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7714), 1,
      sym_identifier,
  [123652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7716), 1,
      anon_sym_new,
  [123659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_RBRACK,
  [123666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      sym_number,
  [123673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7722), 1,
      anon_sym_EQ_GT,
  [123680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7724), 1,
      anon_sym_RBRACK,
  [123687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7726), 1,
      anon_sym_EQ,
  [123694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7728), 1,
      anon_sym_EQ_GT,
  [123701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7730), 1,
      anon_sym_EQ_GT,
  [123708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7732), 1,
      anon_sym_EQ_GT,
  [123715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7734), 1,
      sym_identifier,
  [123722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7736), 1,
      anon_sym_SLASH2,
  [123729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7738), 1,
      anon_sym_target,
  [123736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_RBRACK,
  [123743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7742), 1,
      anon_sym_SLASH2,
  [123750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7744), 1,
      anon_sym_RBRACK,
  [123757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_EQ_GT,
  [123764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6427), 1,
      anon_sym_EQ_GT,
  [123771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5119), 1,
      anon_sym_EQ_GT,
  [123778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6834), 1,
      anon_sym_LBRACE,
  [123785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7748), 1,
      anon_sym_RBRACK,
  [123792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7750), 1,
      anon_sym_RBRACK,
  [123799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_is,
  [123806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7752), 1,
      anon_sym_EQ_GT,
  [123813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7754), 1,
      anon_sym_EQ_GT,
  [123820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7756), 1,
      sym_identifier,
  [123827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym_EQ_GT,
  [123834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_RPAREN,
  [123841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7760), 1,
      sym_identifier,
  [123848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7762), 1,
      sym_identifier,
  [123855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7764), 1,
      anon_sym_EQ_GT,
  [123862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 1,
      anon_sym_RBRACK,
  [123869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_while,
  [123876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7768), 1,
      anon_sym_target,
  [123883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3991), 1,
      anon_sym_RPAREN,
  [123890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7770), 1,
      anon_sym_RBRACK,
  [123897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7772), 1,
      anon_sym_RBRACK,
  [123904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7774), 1,
      sym_identifier,
  [123911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7776), 1,
      sym_identifier,
  [123918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7778), 1,
      sym_identifier,
  [123925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7780), 1,
      anon_sym_RBRACK,
  [123932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7782), 1,
      anon_sym_EQ_GT,
  [123939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7784), 1,
      anon_sym_symbol,
  [123946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7786), 1,
      sym_identifier,
  [123953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7788), 1,
      anon_sym_SLASH2,
  [123960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 1,
      anon_sym_from,
  [123967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7790), 1,
      sym_number,
  [123974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7792), 1,
      anon_sym_RBRACK,
  [123981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7794), 1,
      anon_sym_as,
  [123988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7796), 1,
      anon_sym_EQ,
  [123995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7798), 1,
      anon_sym_RBRACK,
  [124002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7800), 1,
      anon_sym_RBRACK,
  [124009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7802), 1,
      anon_sym_SLASH2,
  [124016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7804), 1,
      anon_sym_RBRACK,
  [124023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7806), 1,
      anon_sym_EQ,
  [124030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym_RBRACK,
  [124037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7810), 1,
      anon_sym_RBRACK,
  [124044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7812), 1,
      anon_sym_EQ_GT,
  [124051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7814), 1,
      anon_sym_RBRACK,
  [124058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7816), 1,
      anon_sym_EQ,
  [124065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7818), 1,
      anon_sym_RBRACK,
  [124072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7820), 1,
      anon_sym_RBRACK,
  [124079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7822), 1,
      anon_sym_EQ_GT,
  [124086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7824), 1,
      anon_sym_RBRACK,
  [124093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7826), 1,
      anon_sym_EQ_GT,
  [124100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      anon_sym_EQ_GT,
  [124107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7830), 1,
      anon_sym_EQ_GT,
  [124114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7832), 1,
      anon_sym_new,
  [124121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7834), 1,
      anon_sym_EQ_GT,
  [124128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7836), 1,
      anon_sym_EQ_GT,
  [124135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_RBRACK,
  [124142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7840), 1,
      anon_sym_RBRACK,
  [124149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 1,
      anon_sym_function,
  [124156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7844), 1,
      sym_identifier,
  [124163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7846), 1,
      sym_identifier,
  [124170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7848), 1,
      anon_sym_RBRACK,
  [124177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7850), 1,
      anon_sym_namespace,
  [124184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7852), 1,
      anon_sym_RBRACK,
  [124191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7854), 1,
      anon_sym_RBRACK,
  [124198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7856), 1,
      anon_sym_RBRACK,
  [124205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7858), 1,
      anon_sym_RBRACK,
  [124212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7860), 1,
      anon_sym_EQ,
  [124219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7862), 1,
      anon_sym_new,
  [124226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7864), 1,
      anon_sym_RBRACK,
  [124233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4166), 1,
      anon_sym_RPAREN,
  [124240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7866), 1,
      sym_number,
  [124247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7076), 1,
      anon_sym_EQ,
  [124254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_new,
  [124261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7870), 1,
      anon_sym_EQ_GT,
  [124268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7872), 1,
      anon_sym_EQ_GT,
  [124275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7874), 1,
      sym_identifier,
  [124282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7876), 1,
      ts_builtin_sym_end,
  [124289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7878), 1,
      sym_identifier,
  [124296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7880), 1,
      sym_identifier,
  [124303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7882), 1,
      anon_sym_function,
  [124310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7884), 1,
      sym_identifier,
  [124317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7886), 1,
      anon_sym_new,
  [124324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7888), 1,
      anon_sym_class,
  [124331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7890), 1,
      anon_sym_RBRACK,
  [124338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7892), 1,
      sym_identifier,
  [124345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7894), 1,
      anon_sym_RBRACK,
  [124352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7896), 1,
      sym_identifier,
  [124359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7898), 1,
      sym_identifier,
  [124366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7900), 1,
      anon_sym_RBRACK,
  [124373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7902), 1,
      anon_sym_RBRACK,
  [124380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7904), 1,
      anon_sym_EQ_GT,
  [124387] = 2,
    ACTIONS(6375), 1,
      sym_comment,
    ACTIONS(7906), 1,
      sym_regex_pattern,
  [124394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7908), 1,
      anon_sym_RBRACK,
  [124401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7910), 1,
      anon_sym_RBRACK,
  [124408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7912), 1,
      anon_sym_RBRACK,
  [124415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7914), 1,
      anon_sym_RBRACK,
  [124422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7916), 1,
      anon_sym_RBRACK,
  [124429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7918), 1,
      anon_sym_RBRACK,
  [124436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7920), 1,
      anon_sym_symbol,
  [124443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7922), 1,
      anon_sym_EQ_GT,
  [124450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_is,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(995)] = 0,
  [SMALL_STATE(996)] = 93,
  [SMALL_STATE(997)] = 184,
  [SMALL_STATE(998)] = 273,
  [SMALL_STATE(999)] = 362,
  [SMALL_STATE(1000)] = 453,
  [SMALL_STATE(1001)] = 544,
  [SMALL_STATE(1002)] = 633,
  [SMALL_STATE(1003)] = 726,
  [SMALL_STATE(1004)] = 815,
  [SMALL_STATE(1005)] = 906,
  [SMALL_STATE(1006)] = 994,
  [SMALL_STATE(1007)] = 1086,
  [SMALL_STATE(1008)] = 1174,
  [SMALL_STATE(1009)] = 1268,
  [SMALL_STATE(1010)] = 1360,
  [SMALL_STATE(1011)] = 1452,
  [SMALL_STATE(1012)] = 1541,
  [SMALL_STATE(1013)] = 1628,
  [SMALL_STATE(1014)] = 1715,
  [SMALL_STATE(1015)] = 1802,
  [SMALL_STATE(1016)] = 1893,
  [SMALL_STATE(1017)] = 1962,
  [SMALL_STATE(1018)] = 2049,
  [SMALL_STATE(1019)] = 2138,
  [SMALL_STATE(1020)] = 2227,
  [SMALL_STATE(1021)] = 2296,
  [SMALL_STATE(1022)] = 2365,
  [SMALL_STATE(1023)] = 2454,
  [SMALL_STATE(1024)] = 2543,
  [SMALL_STATE(1025)] = 2676,
  [SMALL_STATE(1026)] = 2745,
  [SMALL_STATE(1027)] = 2834,
  [SMALL_STATE(1028)] = 2925,
  [SMALL_STATE(1029)] = 3014,
  [SMALL_STATE(1030)] = 3105,
  [SMALL_STATE(1031)] = 3194,
  [SMALL_STATE(1032)] = 3281,
  [SMALL_STATE(1033)] = 3350,
  [SMALL_STATE(1034)] = 3419,
  [SMALL_STATE(1035)] = 3552,
  [SMALL_STATE(1036)] = 3621,
  [SMALL_STATE(1037)] = 3708,
  [SMALL_STATE(1038)] = 3795,
  [SMALL_STATE(1039)] = 3885,
  [SMALL_STATE(1040)] = 3973,
  [SMALL_STATE(1041)] = 4063,
  [SMALL_STATE(1042)] = 4131,
  [SMALL_STATE(1043)] = 4225,
  [SMALL_STATE(1044)] = 4293,
  [SMALL_STATE(1045)] = 4383,
  [SMALL_STATE(1046)] = 4469,
  [SMALL_STATE(1047)] = 4557,
  [SMALL_STATE(1048)] = 4629,
  [SMALL_STATE(1049)] = 4719,
  [SMALL_STATE(1050)] = 4805,
  [SMALL_STATE(1051)] = 4891,
  [SMALL_STATE(1052)] = 4982,
  [SMALL_STATE(1053)] = 5059,
  [SMALL_STATE(1054)] = 5136,
  [SMALL_STATE(1055)] = 5215,
  [SMALL_STATE(1056)] = 5292,
  [SMALL_STATE(1057)] = 5369,
  [SMALL_STATE(1058)] = 5446,
  [SMALL_STATE(1059)] = 5523,
  [SMALL_STATE(1060)] = 5602,
  [SMALL_STATE(1061)] = 5691,
  [SMALL_STATE(1062)] = 5780,
  [SMALL_STATE(1063)] = 5865,
  [SMALL_STATE(1064)] = 5954,
  [SMALL_STATE(1065)] = 6045,
  [SMALL_STATE(1066)] = 6130,
  [SMALL_STATE(1067)] = 6215,
  [SMALL_STATE(1068)] = 6304,
  [SMALL_STATE(1069)] = 6386,
  [SMALL_STATE(1070)] = 6468,
  [SMALL_STATE(1071)] = 6556,
  [SMALL_STATE(1072)] = 6632,
  [SMALL_STATE(1073)] = 6710,
  [SMALL_STATE(1074)] = 6788,
  [SMALL_STATE(1075)] = 6860,
  [SMALL_STATE(1076)] = 6932,
  [SMALL_STATE(1077)] = 7008,
  [SMALL_STATE(1078)] = 7080,
  [SMALL_STATE(1079)] = 7166,
  [SMALL_STATE(1080)] = 7254,
  [SMALL_STATE(1081)] = 7338,
  [SMALL_STATE(1082)] = 7422,
  [SMALL_STATE(1083)] = 7496,
  [SMALL_STATE(1084)] = 7584,
  [SMALL_STATE(1085)] = 7656,
  [SMALL_STATE(1086)] = 7730,
  [SMALL_STATE(1087)] = 7814,
  [SMALL_STATE(1088)] = 7888,
  [SMALL_STATE(1089)] = 7953,
  [SMALL_STATE(1090)] = 8024,
  [SMALL_STATE(1091)] = 8101,
  [SMALL_STATE(1092)] = 8172,
  [SMALL_STATE(1093)] = 8251,
  [SMALL_STATE(1094)] = 8322,
  [SMALL_STATE(1095)] = 8397,
  [SMALL_STATE(1096)] = 8474,
  [SMALL_STATE(1097)] = 8543,
  [SMALL_STATE(1098)] = 8618,
  [SMALL_STATE(1099)] = 8705,
  [SMALL_STATE(1100)] = 8770,
  [SMALL_STATE(1101)] = 8843,
  [SMALL_STATE(1102)] = 8916,
  [SMALL_STATE(1103)] = 8981,
  [SMALL_STATE(1104)] = 9046,
  [SMALL_STATE(1105)] = 9127,
  [SMALL_STATE(1106)] = 9198,
  [SMALL_STATE(1107)] = 9269,
  [SMALL_STATE(1108)] = 9340,
  [SMALL_STATE(1109)] = 9405,
  [SMALL_STATE(1110)] = 9470,
  [SMALL_STATE(1111)] = 9553,
  [SMALL_STATE(1112)] = 9618,
  [SMALL_STATE(1113)] = 9695,
  [SMALL_STATE(1114)] = 9778,
  [SMALL_STATE(1115)] = 9843,
  [SMALL_STATE(1116)] = 9914,
  [SMALL_STATE(1117)] = 9985,
  [SMALL_STATE(1118)] = 10060,
  [SMALL_STATE(1119)] = 10133,
  [SMALL_STATE(1120)] = 10202,
  [SMALL_STATE(1121)] = 10281,
  [SMALL_STATE(1122)] = 10346,
  [SMALL_STATE(1123)] = 10419,
  [SMALL_STATE(1124)] = 10506,
  [SMALL_STATE(1125)] = 10578,
  [SMALL_STATE(1126)] = 10650,
  [SMALL_STATE(1127)] = 10732,
  [SMALL_STATE(1128)] = 10804,
  [SMALL_STATE(1129)] = 10874,
  [SMALL_STATE(1130)] = 10944,
  [SMALL_STATE(1131)] = 11012,
  [SMALL_STATE(1132)] = 11082,
  [SMALL_STATE(1133)] = 11160,
  [SMALL_STATE(1134)] = 11236,
  [SMALL_STATE(1135)] = 11308,
  [SMALL_STATE(1136)] = 11378,
  [SMALL_STATE(1137)] = 11450,
  [SMALL_STATE(1138)] = 11520,
  [SMALL_STATE(1139)] = 11590,
  [SMALL_STATE(1140)] = 11666,
  [SMALL_STATE(1141)] = 11734,
  [SMALL_STATE(1142)] = 11810,
  [SMALL_STATE(1143)] = 11879,
  [SMALL_STATE(1144)] = 11952,
  [SMALL_STATE(1145)] = 12019,
  [SMALL_STATE(1146)] = 12090,
  [SMALL_STATE(1147)] = 12159,
  [SMALL_STATE(1148)] = 12228,
  [SMALL_STATE(1149)] = 12301,
  [SMALL_STATE(1150)] = 12372,
  [SMALL_STATE(1151)] = 12447,
  [SMALL_STATE(1152)] = 12516,
  [SMALL_STATE(1153)] = 12585,
  [SMALL_STATE(1154)] = 12654,
  [SMALL_STATE(1155)] = 12725,
  [SMALL_STATE(1156)] = 12798,
  [SMALL_STATE(1157)] = 12871,
  [SMALL_STATE(1158)] = 12940,
  [SMALL_STATE(1159)] = 13003,
  [SMALL_STATE(1160)] = 13072,
  [SMALL_STATE(1161)] = 13144,
  [SMALL_STATE(1162)] = 13212,
  [SMALL_STATE(1163)] = 13274,
  [SMALL_STATE(1164)] = 13346,
  [SMALL_STATE(1165)] = 13416,
  [SMALL_STATE(1166)] = 13482,
  [SMALL_STATE(1167)] = 13550,
  [SMALL_STATE(1168)] = 13616,
  [SMALL_STATE(1169)] = 13684,
  [SMALL_STATE(1170)] = 13746,
  [SMALL_STATE(1171)] = 13808,
  [SMALL_STATE(1172)] = 13878,
  [SMALL_STATE(1173)] = 13946,
  [SMALL_STATE(1174)] = 14013,
  [SMALL_STATE(1175)] = 14080,
  [SMALL_STATE(1176)] = 14149,
  [SMALL_STATE(1177)] = 14214,
  [SMALL_STATE(1178)] = 14281,
  [SMALL_STATE(1179)] = 14397,
  [SMALL_STATE(1180)] = 14513,
  [SMALL_STATE(1181)] = 14629,
  [SMALL_STATE(1182)] = 14745,
  [SMALL_STATE(1183)] = 14861,
  [SMALL_STATE(1184)] = 14977,
  [SMALL_STATE(1185)] = 15060,
  [SMALL_STATE(1186)] = 15180,
  [SMALL_STATE(1187)] = 15292,
  [SMALL_STATE(1188)] = 15404,
  [SMALL_STATE(1189)] = 15524,
  [SMALL_STATE(1190)] = 15636,
  [SMALL_STATE(1191)] = 15756,
  [SMALL_STATE(1192)] = 15868,
  [SMALL_STATE(1193)] = 15980,
  [SMALL_STATE(1194)] = 16092,
  [SMALL_STATE(1195)] = 16204,
  [SMALL_STATE(1196)] = 16316,
  [SMALL_STATE(1197)] = 16428,
  [SMALL_STATE(1198)] = 16548,
  [SMALL_STATE(1199)] = 16668,
  [SMALL_STATE(1200)] = 16780,
  [SMALL_STATE(1201)] = 16892,
  [SMALL_STATE(1202)] = 17004,
  [SMALL_STATE(1203)] = 17116,
  [SMALL_STATE(1204)] = 17228,
  [SMALL_STATE(1205)] = 17340,
  [SMALL_STATE(1206)] = 17452,
  [SMALL_STATE(1207)] = 17564,
  [SMALL_STATE(1208)] = 17676,
  [SMALL_STATE(1209)] = 17784,
  [SMALL_STATE(1210)] = 17840,
  [SMALL_STATE(1211)] = 17950,
  [SMALL_STATE(1212)] = 18058,
  [SMALL_STATE(1213)] = 18166,
  [SMALL_STATE(1214)] = 18274,
  [SMALL_STATE(1215)] = 18382,
  [SMALL_STATE(1216)] = 18490,
  [SMALL_STATE(1217)] = 18546,
  [SMALL_STATE(1218)] = 18654,
  [SMALL_STATE(1219)] = 18766,
  [SMALL_STATE(1220)] = 18829,
  [SMALL_STATE(1221)] = 18894,
  [SMALL_STATE(1222)] = 18965,
  [SMALL_STATE(1223)] = 19030,
  [SMALL_STATE(1224)] = 19095,
  [SMALL_STATE(1225)] = 19155,
  [SMALL_STATE(1226)] = 19209,
  [SMALL_STATE(1227)] = 19263,
  [SMALL_STATE(1228)] = 19317,
  [SMALL_STATE(1229)] = 19375,
  [SMALL_STATE(1230)] = 19435,
  [SMALL_STATE(1231)] = 19495,
  [SMALL_STATE(1232)] = 19593,
  [SMALL_STATE(1233)] = 19691,
  [SMALL_STATE(1234)] = 19747,
  [SMALL_STATE(1235)] = 19803,
  [SMALL_STATE(1236)] = 19859,
  [SMALL_STATE(1237)] = 19957,
  [SMALL_STATE(1238)] = 20017,
  [SMALL_STATE(1239)] = 20115,
  [SMALL_STATE(1240)] = 20213,
  [SMALL_STATE(1241)] = 20311,
  [SMALL_STATE(1242)] = 20365,
  [SMALL_STATE(1243)] = 20463,
  [SMALL_STATE(1244)] = 20525,
  [SMALL_STATE(1245)] = 20583,
  [SMALL_STATE(1246)] = 20641,
  [SMALL_STATE(1247)] = 20694,
  [SMALL_STATE(1248)] = 20777,
  [SMALL_STATE(1249)] = 20834,
  [SMALL_STATE(1250)] = 20887,
  [SMALL_STATE(1251)] = 20940,
  [SMALL_STATE(1252)] = 20993,
  [SMALL_STATE(1253)] = 21046,
  [SMALL_STATE(1254)] = 21099,
  [SMALL_STATE(1255)] = 21152,
  [SMALL_STATE(1256)] = 21205,
  [SMALL_STATE(1257)] = 21258,
  [SMALL_STATE(1258)] = 21311,
  [SMALL_STATE(1259)] = 21364,
  [SMALL_STATE(1260)] = 21417,
  [SMALL_STATE(1261)] = 21470,
  [SMALL_STATE(1262)] = 21523,
  [SMALL_STATE(1263)] = 21636,
  [SMALL_STATE(1264)] = 21689,
  [SMALL_STATE(1265)] = 21742,
  [SMALL_STATE(1266)] = 21795,
  [SMALL_STATE(1267)] = 21848,
  [SMALL_STATE(1268)] = 21901,
  [SMALL_STATE(1269)] = 21954,
  [SMALL_STATE(1270)] = 22007,
  [SMALL_STATE(1271)] = 22060,
  [SMALL_STATE(1272)] = 22113,
  [SMALL_STATE(1273)] = 22166,
  [SMALL_STATE(1274)] = 22225,
  [SMALL_STATE(1275)] = 22280,
  [SMALL_STATE(1276)] = 22333,
  [SMALL_STATE(1277)] = 22394,
  [SMALL_STATE(1278)] = 22453,
  [SMALL_STATE(1279)] = 22506,
  [SMALL_STATE(1280)] = 22559,
  [SMALL_STATE(1281)] = 22612,
  [SMALL_STATE(1282)] = 22725,
  [SMALL_STATE(1283)] = 22784,
  [SMALL_STATE(1284)] = 22841,
  [SMALL_STATE(1285)] = 22894,
  [SMALL_STATE(1286)] = 22955,
  [SMALL_STATE(1287)] = 23016,
  [SMALL_STATE(1288)] = 23069,
  [SMALL_STATE(1289)] = 23182,
  [SMALL_STATE(1290)] = 23235,
  [SMALL_STATE(1291)] = 23288,
  [SMALL_STATE(1292)] = 23401,
  [SMALL_STATE(1293)] = 23454,
  [SMALL_STATE(1294)] = 23507,
  [SMALL_STATE(1295)] = 23560,
  [SMALL_STATE(1296)] = 23637,
  [SMALL_STATE(1297)] = 23750,
  [SMALL_STATE(1298)] = 23809,
  [SMALL_STATE(1299)] = 23874,
  [SMALL_STATE(1300)] = 23927,
  [SMALL_STATE(1301)] = 23980,
  [SMALL_STATE(1302)] = 24033,
  [SMALL_STATE(1303)] = 24148,
  [SMALL_STATE(1304)] = 24201,
  [SMALL_STATE(1305)] = 24254,
  [SMALL_STATE(1306)] = 24307,
  [SMALL_STATE(1307)] = 24394,
  [SMALL_STATE(1308)] = 24449,
  [SMALL_STATE(1309)] = 24502,
  [SMALL_STATE(1310)] = 24555,
  [SMALL_STATE(1311)] = 24608,
  [SMALL_STATE(1312)] = 24661,
  [SMALL_STATE(1313)] = 24774,
  [SMALL_STATE(1314)] = 24875,
  [SMALL_STATE(1315)] = 24978,
  [SMALL_STATE(1316)] = 25035,
  [SMALL_STATE(1317)] = 25130,
  [SMALL_STATE(1318)] = 25189,
  [SMALL_STATE(1319)] = 25248,
  [SMALL_STATE(1320)] = 25345,
  [SMALL_STATE(1321)] = 25444,
  [SMALL_STATE(1322)] = 25497,
  [SMALL_STATE(1323)] = 25578,
  [SMALL_STATE(1324)] = 25631,
  [SMALL_STATE(1325)] = 25714,
  [SMALL_STATE(1326)] = 25767,
  [SMALL_STATE(1327)] = 25820,
  [SMALL_STATE(1328)] = 25873,
  [SMALL_STATE(1329)] = 25926,
  [SMALL_STATE(1330)] = 25979,
  [SMALL_STATE(1331)] = 26092,
  [SMALL_STATE(1332)] = 26145,
  [SMALL_STATE(1333)] = 26198,
  [SMALL_STATE(1334)] = 26251,
  [SMALL_STATE(1335)] = 26364,
  [SMALL_STATE(1336)] = 26423,
  [SMALL_STATE(1337)] = 26478,
  [SMALL_STATE(1338)] = 26531,
  [SMALL_STATE(1339)] = 26584,
  [SMALL_STATE(1340)] = 26643,
  [SMALL_STATE(1341)] = 26698,
  [SMALL_STATE(1342)] = 26751,
  [SMALL_STATE(1343)] = 26804,
  [SMALL_STATE(1344)] = 26857,
  [SMALL_STATE(1345)] = 26910,
  [SMALL_STATE(1346)] = 27001,
  [SMALL_STATE(1347)] = 27106,
  [SMALL_STATE(1348)] = 27181,
  [SMALL_STATE(1349)] = 27240,
  [SMALL_STATE(1350)] = 27311,
  [SMALL_STATE(1351)] = 27364,
  [SMALL_STATE(1352)] = 27417,
  [SMALL_STATE(1353)] = 27470,
  [SMALL_STATE(1354)] = 27525,
  [SMALL_STATE(1355)] = 27578,
  [SMALL_STATE(1356)] = 27633,
  [SMALL_STATE(1357)] = 27686,
  [SMALL_STATE(1358)] = 27741,
  [SMALL_STATE(1359)] = 27794,
  [SMALL_STATE(1360)] = 27847,
  [SMALL_STATE(1361)] = 27900,
  [SMALL_STATE(1362)] = 27953,
  [SMALL_STATE(1363)] = 28012,
  [SMALL_STATE(1364)] = 28065,
  [SMALL_STATE(1365)] = 28120,
  [SMALL_STATE(1366)] = 28179,
  [SMALL_STATE(1367)] = 28292,
  [SMALL_STATE(1368)] = 28405,
  [SMALL_STATE(1369)] = 28458,
  [SMALL_STATE(1370)] = 28511,
  [SMALL_STATE(1371)] = 28570,
  [SMALL_STATE(1372)] = 28625,
  [SMALL_STATE(1373)] = 28678,
  [SMALL_STATE(1374)] = 28791,
  [SMALL_STATE(1375)] = 28904,
  [SMALL_STATE(1376)] = 28957,
  [SMALL_STATE(1377)] = 29012,
  [SMALL_STATE(1378)] = 29065,
  [SMALL_STATE(1379)] = 29118,
  [SMALL_STATE(1380)] = 29171,
  [SMALL_STATE(1381)] = 29224,
  [SMALL_STATE(1382)] = 29305,
  [SMALL_STATE(1383)] = 29358,
  [SMALL_STATE(1384)] = 29413,
  [SMALL_STATE(1385)] = 29507,
  [SMALL_STATE(1386)] = 29619,
  [SMALL_STATE(1387)] = 29689,
  [SMALL_STATE(1388)] = 29741,
  [SMALL_STATE(1389)] = 29853,
  [SMALL_STATE(1390)] = 29905,
  [SMALL_STATE(1391)] = 29957,
  [SMALL_STATE(1392)] = 30009,
  [SMALL_STATE(1393)] = 30083,
  [SMALL_STATE(1394)] = 30163,
  [SMALL_STATE(1395)] = 30215,
  [SMALL_STATE(1396)] = 30275,
  [SMALL_STATE(1397)] = 30327,
  [SMALL_STATE(1398)] = 30379,
  [SMALL_STATE(1399)] = 30431,
  [SMALL_STATE(1400)] = 30513,
  [SMALL_STATE(1401)] = 30625,
  [SMALL_STATE(1402)] = 30681,
  [SMALL_STATE(1403)] = 30799,
  [SMALL_STATE(1404)] = 30917,
  [SMALL_STATE(1405)] = 30997,
  [SMALL_STATE(1406)] = 31049,
  [SMALL_STATE(1407)] = 31101,
  [SMALL_STATE(1408)] = 31153,
  [SMALL_STATE(1409)] = 31205,
  [SMALL_STATE(1410)] = 31257,
  [SMALL_STATE(1411)] = 31309,
  [SMALL_STATE(1412)] = 31361,
  [SMALL_STATE(1413)] = 31413,
  [SMALL_STATE(1414)] = 31465,
  [SMALL_STATE(1415)] = 31523,
  [SMALL_STATE(1416)] = 31577,
  [SMALL_STATE(1417)] = 31629,
  [SMALL_STATE(1418)] = 31745,
  [SMALL_STATE(1419)] = 31803,
  [SMALL_STATE(1420)] = 31915,
  [SMALL_STATE(1421)] = 31967,
  [SMALL_STATE(1422)] = 32079,
  [SMALL_STATE(1423)] = 32195,
  [SMALL_STATE(1424)] = 32311,
  [SMALL_STATE(1425)] = 32385,
  [SMALL_STATE(1426)] = 32437,
  [SMALL_STATE(1427)] = 32489,
  [SMALL_STATE(1428)] = 32541,
  [SMALL_STATE(1429)] = 32593,
  [SMALL_STATE(1430)] = 32709,
  [SMALL_STATE(1431)] = 32821,
  [SMALL_STATE(1432)] = 32933,
  [SMALL_STATE(1433)] = 32985,
  [SMALL_STATE(1434)] = 33037,
  [SMALL_STATE(1435)] = 33089,
  [SMALL_STATE(1436)] = 33153,
  [SMALL_STATE(1437)] = 33205,
  [SMALL_STATE(1438)] = 33257,
  [SMALL_STATE(1439)] = 33309,
  [SMALL_STATE(1440)] = 33363,
  [SMALL_STATE(1441)] = 33415,
  [SMALL_STATE(1442)] = 33483,
  [SMALL_STATE(1443)] = 33535,
  [SMALL_STATE(1444)] = 33587,
  [SMALL_STATE(1445)] = 33639,
  [SMALL_STATE(1446)] = 33691,
  [SMALL_STATE(1447)] = 33743,
  [SMALL_STATE(1448)] = 33855,
  [SMALL_STATE(1449)] = 33911,
  [SMALL_STATE(1450)] = 33963,
  [SMALL_STATE(1451)] = 34077,
  [SMALL_STATE(1452)] = 34189,
  [SMALL_STATE(1453)] = 34301,
  [SMALL_STATE(1454)] = 34353,
  [SMALL_STATE(1455)] = 34465,
  [SMALL_STATE(1456)] = 34517,
  [SMALL_STATE(1457)] = 34629,
  [SMALL_STATE(1458)] = 34719,
  [SMALL_STATE(1459)] = 34831,
  [SMALL_STATE(1460)] = 34883,
  [SMALL_STATE(1461)] = 34935,
  [SMALL_STATE(1462)] = 34987,
  [SMALL_STATE(1463)] = 35041,
  [SMALL_STATE(1464)] = 35093,
  [SMALL_STATE(1465)] = 35145,
  [SMALL_STATE(1466)] = 35203,
  [SMALL_STATE(1467)] = 35267,
  [SMALL_STATE(1468)] = 35321,
  [SMALL_STATE(1469)] = 35433,
  [SMALL_STATE(1470)] = 35545,
  [SMALL_STATE(1471)] = 35601,
  [SMALL_STATE(1472)] = 35653,
  [SMALL_STATE(1473)] = 35757,
  [SMALL_STATE(1474)] = 35847,
  [SMALL_STATE(1475)] = 35959,
  [SMALL_STATE(1476)] = 36071,
  [SMALL_STATE(1477)] = 36141,
  [SMALL_STATE(1478)] = 36193,
  [SMALL_STATE(1479)] = 36273,
  [SMALL_STATE(1480)] = 36371,
  [SMALL_STATE(1481)] = 36467,
  [SMALL_STATE(1482)] = 36519,
  [SMALL_STATE(1483)] = 36571,
  [SMALL_STATE(1484)] = 36653,
  [SMALL_STATE(1485)] = 36755,
  [SMALL_STATE(1486)] = 36855,
  [SMALL_STATE(1487)] = 36907,
  [SMALL_STATE(1488)] = 36959,
  [SMALL_STATE(1489)] = 37071,
  [SMALL_STATE(1490)] = 37123,
  [SMALL_STATE(1491)] = 37175,
  [SMALL_STATE(1492)] = 37227,
  [SMALL_STATE(1493)] = 37313,
  [SMALL_STATE(1494)] = 37365,
  [SMALL_STATE(1495)] = 37477,
  [SMALL_STATE(1496)] = 37589,
  [SMALL_STATE(1497)] = 37701,
  [SMALL_STATE(1498)] = 37753,
  [SMALL_STATE(1499)] = 37805,
  [SMALL_STATE(1500)] = 37909,
  [SMALL_STATE(1501)] = 37999,
  [SMALL_STATE(1502)] = 38117,
  [SMALL_STATE(1503)] = 38169,
  [SMALL_STATE(1504)] = 38221,
  [SMALL_STATE(1505)] = 38273,
  [SMALL_STATE(1506)] = 38325,
  [SMALL_STATE(1507)] = 38377,
  [SMALL_STATE(1508)] = 38429,
  [SMALL_STATE(1509)] = 38481,
  [SMALL_STATE(1510)] = 38593,
  [SMALL_STATE(1511)] = 38675,
  [SMALL_STATE(1512)] = 38787,
  [SMALL_STATE(1513)] = 38863,
  [SMALL_STATE(1514)] = 38915,
  [SMALL_STATE(1515)] = 38967,
  [SMALL_STATE(1516)] = 39043,
  [SMALL_STATE(1517)] = 39129,
  [SMALL_STATE(1518)] = 39229,
  [SMALL_STATE(1519)] = 39309,
  [SMALL_STATE(1520)] = 39411,
  [SMALL_STATE(1521)] = 39463,
  [SMALL_STATE(1522)] = 39545,
  [SMALL_STATE(1523)] = 39663,
  [SMALL_STATE(1524)] = 39715,
  [SMALL_STATE(1525)] = 39809,
  [SMALL_STATE(1526)] = 39871,
  [SMALL_STATE(1527)] = 39983,
  [SMALL_STATE(1528)] = 40097,
  [SMALL_STATE(1529)] = 40195,
  [SMALL_STATE(1530)] = 40257,
  [SMALL_STATE(1531)] = 40309,
  [SMALL_STATE(1532)] = 40405,
  [SMALL_STATE(1533)] = 40517,
  [SMALL_STATE(1534)] = 40579,
  [SMALL_STATE(1535)] = 40633,
  [SMALL_STATE(1536)] = 40728,
  [SMALL_STATE(1537)] = 40823,
  [SMALL_STATE(1538)] = 40918,
  [SMALL_STATE(1539)] = 41031,
  [SMALL_STATE(1540)] = 41120,
  [SMALL_STATE(1541)] = 41235,
  [SMALL_STATE(1542)] = 41346,
  [SMALL_STATE(1543)] = 41441,
  [SMALL_STATE(1544)] = 41554,
  [SMALL_STATE(1545)] = 41665,
  [SMALL_STATE(1546)] = 41722,
  [SMALL_STATE(1547)] = 41779,
  [SMALL_STATE(1548)] = 41894,
  [SMALL_STATE(1549)] = 42005,
  [SMALL_STATE(1550)] = 42056,
  [SMALL_STATE(1551)] = 42167,
  [SMALL_STATE(1552)] = 42282,
  [SMALL_STATE(1553)] = 42397,
  [SMALL_STATE(1554)] = 42456,
  [SMALL_STATE(1555)] = 42559,
  [SMALL_STATE(1556)] = 42618,
  [SMALL_STATE(1557)] = 42669,
  [SMALL_STATE(1558)] = 42780,
  [SMALL_STATE(1559)] = 42891,
  [SMALL_STATE(1560)] = 42988,
  [SMALL_STATE(1561)] = 43045,
  [SMALL_STATE(1562)] = 43156,
  [SMALL_STATE(1563)] = 43271,
  [SMALL_STATE(1564)] = 43386,
  [SMALL_STATE(1565)] = 43481,
  [SMALL_STATE(1566)] = 43576,
  [SMALL_STATE(1567)] = 43691,
  [SMALL_STATE(1568)] = 43786,
  [SMALL_STATE(1569)] = 43867,
  [SMALL_STATE(1570)] = 43982,
  [SMALL_STATE(1571)] = 44045,
  [SMALL_STATE(1572)] = 44118,
  [SMALL_STATE(1573)] = 44197,
  [SMALL_STATE(1574)] = 44308,
  [SMALL_STATE(1575)] = 44421,
  [SMALL_STATE(1576)] = 44532,
  [SMALL_STATE(1577)] = 44643,
  [SMALL_STATE(1578)] = 44712,
  [SMALL_STATE(1579)] = 44823,
  [SMALL_STATE(1580)] = 44882,
  [SMALL_STATE(1581)] = 44937,
  [SMALL_STATE(1582)] = 45032,
  [SMALL_STATE(1583)] = 45091,
  [SMALL_STATE(1584)] = 45150,
  [SMALL_STATE(1585)] = 45261,
  [SMALL_STATE(1586)] = 45372,
  [SMALL_STATE(1587)] = 45483,
  [SMALL_STATE(1588)] = 45538,
  [SMALL_STATE(1589)] = 45613,
  [SMALL_STATE(1590)] = 45668,
  [SMALL_STATE(1591)] = 45723,
  [SMALL_STATE(1592)] = 45808,
  [SMALL_STATE(1593)] = 45921,
  [SMALL_STATE(1594)] = 46036,
  [SMALL_STATE(1595)] = 46131,
  [SMALL_STATE(1596)] = 46188,
  [SMALL_STATE(1597)] = 46245,
  [SMALL_STATE(1598)] = 46356,
  [SMALL_STATE(1599)] = 46435,
  [SMALL_STATE(1600)] = 46534,
  [SMALL_STATE(1601)] = 46649,
  [SMALL_STATE(1602)] = 46744,
  [SMALL_STATE(1603)] = 46805,
  [SMALL_STATE(1604)] = 46918,
  [SMALL_STATE(1605)] = 47029,
  [SMALL_STATE(1606)] = 47130,
  [SMALL_STATE(1607)] = 47211,
  [SMALL_STATE(1608)] = 47306,
  [SMALL_STATE(1609)] = 47401,
  [SMALL_STATE(1610)] = 47494,
  [SMALL_STATE(1611)] = 47555,
  [SMALL_STATE(1612)] = 47666,
  [SMALL_STATE(1613)] = 47719,
  [SMALL_STATE(1614)] = 47772,
  [SMALL_STATE(1615)] = 47825,
  [SMALL_STATE(1616)] = 47875,
  [SMALL_STATE(1617)] = 47925,
  [SMALL_STATE(1618)] = 48035,
  [SMALL_STATE(1619)] = 48087,
  [SMALL_STATE(1620)] = 48197,
  [SMALL_STATE(1621)] = 48307,
  [SMALL_STATE(1622)] = 48417,
  [SMALL_STATE(1623)] = 48527,
  [SMALL_STATE(1624)] = 48637,
  [SMALL_STATE(1625)] = 48739,
  [SMALL_STATE(1626)] = 48795,
  [SMALL_STATE(1627)] = 48851,
  [SMALL_STATE(1628)] = 48939,
  [SMALL_STATE(1629)] = 48991,
  [SMALL_STATE(1630)] = 49041,
  [SMALL_STATE(1631)] = 49121,
  [SMALL_STATE(1632)] = 49199,
  [SMALL_STATE(1633)] = 49295,
  [SMALL_STATE(1634)] = 49389,
  [SMALL_STATE(1635)] = 49481,
  [SMALL_STATE(1636)] = 49561,
  [SMALL_STATE(1637)] = 49661,
  [SMALL_STATE(1638)] = 49759,
  [SMALL_STATE(1639)] = 49843,
  [SMALL_STATE(1640)] = 49917,
  [SMALL_STATE(1641)] = 49971,
  [SMALL_STATE(1642)] = 50029,
  [SMALL_STATE(1643)] = 50087,
  [SMALL_STATE(1644)] = 50197,
  [SMALL_STATE(1645)] = 50307,
  [SMALL_STATE(1646)] = 50417,
  [SMALL_STATE(1647)] = 50527,
  [SMALL_STATE(1648)] = 50581,
  [SMALL_STATE(1649)] = 50643,
  [SMALL_STATE(1650)] = 50705,
  [SMALL_STATE(1651)] = 50817,
  [SMALL_STATE(1652)] = 50873,
  [SMALL_STATE(1653)] = 50923,
  [SMALL_STATE(1654)] = 50979,
  [SMALL_STATE(1655)] = 51037,
  [SMALL_STATE(1656)] = 51093,
  [SMALL_STATE(1657)] = 51155,
  [SMALL_STATE(1658)] = 51217,
  [SMALL_STATE(1659)] = 51329,
  [SMALL_STATE(1660)] = 51439,
  [SMALL_STATE(1661)] = 51507,
  [SMALL_STATE(1662)] = 51617,
  [SMALL_STATE(1663)] = 51689,
  [SMALL_STATE(1664)] = 51799,
  [SMALL_STATE(1665)] = 51909,
  [SMALL_STATE(1666)] = 51971,
  [SMALL_STATE(1667)] = 52025,
  [SMALL_STATE(1668)] = 52077,
  [SMALL_STATE(1669)] = 52133,
  [SMALL_STATE(1670)] = 52243,
  [SMALL_STATE(1671)] = 52321,
  [SMALL_STATE(1672)] = 52371,
  [SMALL_STATE(1673)] = 52421,
  [SMALL_STATE(1674)] = 52471,
  [SMALL_STATE(1675)] = 52521,
  [SMALL_STATE(1676)] = 52633,
  [SMALL_STATE(1677)] = 52745,
  [SMALL_STATE(1678)] = 52857,
  [SMALL_STATE(1679)] = 52969,
  [SMALL_STATE(1680)] = 53027,
  [SMALL_STATE(1681)] = 53077,
  [SMALL_STATE(1682)] = 53127,
  [SMALL_STATE(1683)] = 53177,
  [SMALL_STATE(1684)] = 53227,
  [SMALL_STATE(1685)] = 53311,
  [SMALL_STATE(1686)] = 53361,
  [SMALL_STATE(1687)] = 53411,
  [SMALL_STATE(1688)] = 53461,
  [SMALL_STATE(1689)] = 53511,
  [SMALL_STATE(1690)] = 53621,
  [SMALL_STATE(1691)] = 53731,
  [SMALL_STATE(1692)] = 53805,
  [SMALL_STATE(1693)] = 53889,
  [SMALL_STATE(1694)] = 54001,
  [SMALL_STATE(1695)] = 54051,
  [SMALL_STATE(1696)] = 54101,
  [SMALL_STATE(1697)] = 54151,
  [SMALL_STATE(1698)] = 54201,
  [SMALL_STATE(1699)] = 54251,
  [SMALL_STATE(1700)] = 54335,
  [SMALL_STATE(1701)] = 54385,
  [SMALL_STATE(1702)] = 54435,
  [SMALL_STATE(1703)] = 54485,
  [SMALL_STATE(1704)] = 54535,
  [SMALL_STATE(1705)] = 54585,
  [SMALL_STATE(1706)] = 54635,
  [SMALL_STATE(1707)] = 54685,
  [SMALL_STATE(1708)] = 54735,
  [SMALL_STATE(1709)] = 54833,
  [SMALL_STATE(1710)] = 54933,
  [SMALL_STATE(1711)] = 55013,
  [SMALL_STATE(1712)] = 55105,
  [SMALL_STATE(1713)] = 55199,
  [SMALL_STATE(1714)] = 55295,
  [SMALL_STATE(1715)] = 55373,
  [SMALL_STATE(1716)] = 55453,
  [SMALL_STATE(1717)] = 55541,
  [SMALL_STATE(1718)] = 55643,
  [SMALL_STATE(1719)] = 55753,
  [SMALL_STATE(1720)] = 55863,
  [SMALL_STATE(1721)] = 55927,
  [SMALL_STATE(1722)] = 55991,
  [SMALL_STATE(1723)] = 56047,
  [SMALL_STATE(1724)] = 56097,
  [SMALL_STATE(1725)] = 56147,
  [SMALL_STATE(1726)] = 56197,
  [SMALL_STATE(1727)] = 56253,
  [SMALL_STATE(1728)] = 56303,
  [SMALL_STATE(1729)] = 56353,
  [SMALL_STATE(1730)] = 56403,
  [SMALL_STATE(1731)] = 56453,
  [SMALL_STATE(1732)] = 56503,
  [SMALL_STATE(1733)] = 56553,
  [SMALL_STATE(1734)] = 56603,
  [SMALL_STATE(1735)] = 56653,
  [SMALL_STATE(1736)] = 56703,
  [SMALL_STATE(1737)] = 56753,
  [SMALL_STATE(1738)] = 56803,
  [SMALL_STATE(1739)] = 56853,
  [SMALL_STATE(1740)] = 56903,
  [SMALL_STATE(1741)] = 56953,
  [SMALL_STATE(1742)] = 57003,
  [SMALL_STATE(1743)] = 57053,
  [SMALL_STATE(1744)] = 57103,
  [SMALL_STATE(1745)] = 57213,
  [SMALL_STATE(1746)] = 57323,
  [SMALL_STATE(1747)] = 57433,
  [SMALL_STATE(1748)] = 57543,
  [SMALL_STATE(1749)] = 57653,
  [SMALL_STATE(1750)] = 57763,
  [SMALL_STATE(1751)] = 57847,
  [SMALL_STATE(1752)] = 57897,
  [SMALL_STATE(1753)] = 57949,
  [SMALL_STATE(1754)] = 57999,
  [SMALL_STATE(1755)] = 58049,
  [SMALL_STATE(1756)] = 58105,
  [SMALL_STATE(1757)] = 58155,
  [SMALL_STATE(1758)] = 58207,
  [SMALL_STATE(1759)] = 58259,
  [SMALL_STATE(1760)] = 58309,
  [SMALL_STATE(1761)] = 58359,
  [SMALL_STATE(1762)] = 58409,
  [SMALL_STATE(1763)] = 58465,
  [SMALL_STATE(1764)] = 58519,
  [SMALL_STATE(1765)] = 58603,
  [SMALL_STATE(1766)] = 58653,
  [SMALL_STATE(1767)] = 58703,
  [SMALL_STATE(1768)] = 58753,
  [SMALL_STATE(1769)] = 58803,
  [SMALL_STATE(1770)] = 58853,
  [SMALL_STATE(1771)] = 58903,
  [SMALL_STATE(1772)] = 58953,
  [SMALL_STATE(1773)] = 59015,
  [SMALL_STATE(1774)] = 59099,
  [SMALL_STATE(1775)] = 59161,
  [SMALL_STATE(1776)] = 59273,
  [SMALL_STATE(1777)] = 59325,
  [SMALL_STATE(1778)] = 59381,
  [SMALL_STATE(1779)] = 59493,
  [SMALL_STATE(1780)] = 59543,
  [SMALL_STATE(1781)] = 59655,
  [SMALL_STATE(1782)] = 59711,
  [SMALL_STATE(1783)] = 59823,
  [SMALL_STATE(1784)] = 59879,
  [SMALL_STATE(1785)] = 59989,
  [SMALL_STATE(1786)] = 60099,
  [SMALL_STATE(1787)] = 60211,
  [SMALL_STATE(1788)] = 60321,
  [SMALL_STATE(1789)] = 60383,
  [SMALL_STATE(1790)] = 60433,
  [SMALL_STATE(1791)] = 60483,
  [SMALL_STATE(1792)] = 60595,
  [SMALL_STATE(1793)] = 60651,
  [SMALL_STATE(1794)] = 60763,
  [SMALL_STATE(1795)] = 60815,
  [SMALL_STATE(1796)] = 60867,
  [SMALL_STATE(1797)] = 60923,
  [SMALL_STATE(1798)] = 60979,
  [SMALL_STATE(1799)] = 61029,
  [SMALL_STATE(1800)] = 61079,
  [SMALL_STATE(1801)] = 61129,
  [SMALL_STATE(1802)] = 61181,
  [SMALL_STATE(1803)] = 61231,
  [SMALL_STATE(1804)] = 61281,
  [SMALL_STATE(1805)] = 61393,
  [SMALL_STATE(1806)] = 61505,
  [SMALL_STATE(1807)] = 61567,
  [SMALL_STATE(1808)] = 61629,
  [SMALL_STATE(1809)] = 61741,
  [SMALL_STATE(1810)] = 61797,
  [SMALL_STATE(1811)] = 61855,
  [SMALL_STATE(1812)] = 61905,
  [SMALL_STATE(1813)] = 61957,
  [SMALL_STATE(1814)] = 62009,
  [SMALL_STATE(1815)] = 62071,
  [SMALL_STATE(1816)] = 62121,
  [SMALL_STATE(1817)] = 62173,
  [SMALL_STATE(1818)] = 62223,
  [SMALL_STATE(1819)] = 62333,
  [SMALL_STATE(1820)] = 62383,
  [SMALL_STATE(1821)] = 62433,
  [SMALL_STATE(1822)] = 62483,
  [SMALL_STATE(1823)] = 62533,
  [SMALL_STATE(1824)] = 62643,
  [SMALL_STATE(1825)] = 62711,
  [SMALL_STATE(1826)] = 62783,
  [SMALL_STATE(1827)] = 62861,
  [SMALL_STATE(1828)] = 62913,
  [SMALL_STATE(1829)] = 63022,
  [SMALL_STATE(1830)] = 63071,
  [SMALL_STATE(1831)] = 63128,
  [SMALL_STATE(1832)] = 63181,
  [SMALL_STATE(1833)] = 63256,
  [SMALL_STATE(1834)] = 63365,
  [SMALL_STATE(1835)] = 63414,
  [SMALL_STATE(1836)] = 63467,
  [SMALL_STATE(1837)] = 63520,
  [SMALL_STATE(1838)] = 63587,
  [SMALL_STATE(1839)] = 63674,
  [SMALL_STATE(1840)] = 63783,
  [SMALL_STATE(1841)] = 63892,
  [SMALL_STATE(1842)] = 64001,
  [SMALL_STATE(1843)] = 64054,
  [SMALL_STATE(1844)] = 64107,
  [SMALL_STATE(1845)] = 64156,
  [SMALL_STATE(1846)] = 64205,
  [SMALL_STATE(1847)] = 64280,
  [SMALL_STATE(1848)] = 64381,
  [SMALL_STATE(1849)] = 64458,
  [SMALL_STATE(1850)] = 64507,
  [SMALL_STATE(1851)] = 64556,
  [SMALL_STATE(1852)] = 64607,
  [SMALL_STATE(1853)] = 64656,
  [SMALL_STATE(1854)] = 64709,
  [SMALL_STATE(1855)] = 64786,
  [SMALL_STATE(1856)] = 64835,
  [SMALL_STATE(1857)] = 64888,
  [SMALL_STATE(1858)] = 64983,
  [SMALL_STATE(1859)] = 65036,
  [SMALL_STATE(1860)] = 65087,
  [SMALL_STATE(1861)] = 65138,
  [SMALL_STATE(1862)] = 65191,
  [SMALL_STATE(1863)] = 65268,
  [SMALL_STATE(1864)] = 65325,
  [SMALL_STATE(1865)] = 65382,
  [SMALL_STATE(1866)] = 65491,
  [SMALL_STATE(1867)] = 65584,
  [SMALL_STATE(1868)] = 65693,
  [SMALL_STATE(1869)] = 65748,
  [SMALL_STATE(1870)] = 65801,
  [SMALL_STATE(1871)] = 65892,
  [SMALL_STATE(1872)] = 65947,
  [SMALL_STATE(1873)] = 66000,
  [SMALL_STATE(1874)] = 66053,
  [SMALL_STATE(1875)] = 66162,
  [SMALL_STATE(1876)] = 66215,
  [SMALL_STATE(1877)] = 66268,
  [SMALL_STATE(1878)] = 66317,
  [SMALL_STATE(1879)] = 66426,
  [SMALL_STATE(1880)] = 66505,
  [SMALL_STATE(1881)] = 66604,
  [SMALL_STATE(1882)] = 66657,
  [SMALL_STATE(1883)] = 66706,
  [SMALL_STATE(1884)] = 66783,
  [SMALL_STATE(1885)] = 66840,
  [SMALL_STATE(1886)] = 66889,
  [SMALL_STATE(1887)] = 66938,
  [SMALL_STATE(1888)] = 66987,
  [SMALL_STATE(1889)] = 67036,
  [SMALL_STATE(1890)] = 67085,
  [SMALL_STATE(1891)] = 67134,
  [SMALL_STATE(1892)] = 67187,
  [SMALL_STATE(1893)] = 67262,
  [SMALL_STATE(1894)] = 67311,
  [SMALL_STATE(1895)] = 67388,
  [SMALL_STATE(1896)] = 67439,
  [SMALL_STATE(1897)] = 67498,
  [SMALL_STATE(1898)] = 67595,
  [SMALL_STATE(1899)] = 67644,
  [SMALL_STATE(1900)] = 67753,
  [SMALL_STATE(1901)] = 67864,
  [SMALL_STATE(1902)] = 67925,
  [SMALL_STATE(1903)] = 68008,
  [SMALL_STATE(1904)] = 68057,
  [SMALL_STATE(1905)] = 68114,
  [SMALL_STATE(1906)] = 68187,
  [SMALL_STATE(1907)] = 68236,
  [SMALL_STATE(1908)] = 68345,
  [SMALL_STATE(1909)] = 68394,
  [SMALL_STATE(1910)] = 68443,
  [SMALL_STATE(1911)] = 68498,
  [SMALL_STATE(1912)] = 68575,
  [SMALL_STATE(1913)] = 68624,
  [SMALL_STATE(1914)] = 68673,
  [SMALL_STATE(1915)] = 68782,
  [SMALL_STATE(1916)] = 68831,
  [SMALL_STATE(1917)] = 68884,
  [SMALL_STATE(1918)] = 68959,
  [SMALL_STATE(1919)] = 69014,
  [SMALL_STATE(1920)] = 69063,
  [SMALL_STATE(1921)] = 69116,
  [SMALL_STATE(1922)] = 69165,
  [SMALL_STATE(1923)] = 69240,
  [SMALL_STATE(1924)] = 69349,
  [SMALL_STATE(1925)] = 69398,
  [SMALL_STATE(1926)] = 69447,
  [SMALL_STATE(1927)] = 69500,
  [SMALL_STATE(1928)] = 69549,
  [SMALL_STATE(1929)] = 69600,
  [SMALL_STATE(1930)] = 69653,
  [SMALL_STATE(1931)] = 69706,
  [SMALL_STATE(1932)] = 69783,
  [SMALL_STATE(1933)] = 69832,
  [SMALL_STATE(1934)] = 69941,
  [SMALL_STATE(1935)] = 70050,
  [SMALL_STATE(1936)] = 70159,
  [SMALL_STATE(1937)] = 70208,
  [SMALL_STATE(1938)] = 70261,
  [SMALL_STATE(1939)] = 70332,
  [SMALL_STATE(1940)] = 70385,
  [SMALL_STATE(1941)] = 70462,
  [SMALL_STATE(1942)] = 70519,
  [SMALL_STATE(1943)] = 70574,
  [SMALL_STATE(1944)] = 70683,
  [SMALL_STATE(1945)] = 70732,
  [SMALL_STATE(1946)] = 70785,
  [SMALL_STATE(1947)] = 70834,
  [SMALL_STATE(1948)] = 70883,
  [SMALL_STATE(1949)] = 70936,
  [SMALL_STATE(1950)] = 70985,
  [SMALL_STATE(1951)] = 71034,
  [SMALL_STATE(1952)] = 71143,
  [SMALL_STATE(1953)] = 71194,
  [SMALL_STATE(1954)] = 71247,
  [SMALL_STATE(1955)] = 71298,
  [SMALL_STATE(1956)] = 71357,
  [SMALL_STATE(1957)] = 71408,
  [SMALL_STATE(1958)] = 71461,
  [SMALL_STATE(1959)] = 71570,
  [SMALL_STATE(1960)] = 71631,
  [SMALL_STATE(1961)] = 71740,
  [SMALL_STATE(1962)] = 71789,
  [SMALL_STATE(1963)] = 71868,
  [SMALL_STATE(1964)] = 71923,
  [SMALL_STATE(1965)] = 71972,
  [SMALL_STATE(1966)] = 72081,
  [SMALL_STATE(1967)] = 72130,
  [SMALL_STATE(1968)] = 72179,
  [SMALL_STATE(1969)] = 72228,
  [SMALL_STATE(1970)] = 72287,
  [SMALL_STATE(1971)] = 72336,
  [SMALL_STATE(1972)] = 72393,
  [SMALL_STATE(1973)] = 72442,
  [SMALL_STATE(1974)] = 72501,
  [SMALL_STATE(1975)] = 72550,
  [SMALL_STATE(1976)] = 72599,
  [SMALL_STATE(1977)] = 72648,
  [SMALL_STATE(1978)] = 72703,
  [SMALL_STATE(1979)] = 72754,
  [SMALL_STATE(1980)] = 72863,
  [SMALL_STATE(1981)] = 72920,
  [SMALL_STATE(1982)] = 72969,
  [SMALL_STATE(1983)] = 73022,
  [SMALL_STATE(1984)] = 73073,
  [SMALL_STATE(1985)] = 73124,
  [SMALL_STATE(1986)] = 73173,
  [SMALL_STATE(1987)] = 73222,
  [SMALL_STATE(1988)] = 73277,
  [SMALL_STATE(1989)] = 73334,
  [SMALL_STATE(1990)] = 73391,
  [SMALL_STATE(1991)] = 73446,
  [SMALL_STATE(1992)] = 73497,
  [SMALL_STATE(1993)] = 73548,
  [SMALL_STATE(1994)] = 73599,
  [SMALL_STATE(1995)] = 73648,
  [SMALL_STATE(1996)] = 73697,
  [SMALL_STATE(1997)] = 73746,
  [SMALL_STATE(1998)] = 73799,
  [SMALL_STATE(1999)] = 73852,
  [SMALL_STATE(2000)] = 73928,
  [SMALL_STATE(2001)] = 74010,
  [SMALL_STATE(2002)] = 74116,
  [SMALL_STATE(2003)] = 74222,
  [SMALL_STATE(2004)] = 74272,
  [SMALL_STATE(2005)] = 74346,
  [SMALL_STATE(2006)] = 74400,
  [SMALL_STATE(2007)] = 74500,
  [SMALL_STATE(2008)] = 74554,
  [SMALL_STATE(2009)] = 74640,
  [SMALL_STATE(2010)] = 74718,
  [SMALL_STATE(2011)] = 74794,
  [SMALL_STATE(2012)] = 74900,
  [SMALL_STATE(2013)] = 74954,
  [SMALL_STATE(2014)] = 75060,
  [SMALL_STATE(2015)] = 75130,
  [SMALL_STATE(2016)] = 75236,
  [SMALL_STATE(2017)] = 75292,
  [SMALL_STATE(2018)] = 75362,
  [SMALL_STATE(2019)] = 75468,
  [SMALL_STATE(2020)] = 75544,
  [SMALL_STATE(2021)] = 75650,
  [SMALL_STATE(2022)] = 75756,
  [SMALL_STATE(2023)] = 75826,
  [SMALL_STATE(2024)] = 75896,
  [SMALL_STATE(2025)] = 75952,
  [SMALL_STATE(2026)] = 76024,
  [SMALL_STATE(2027)] = 76076,
  [SMALL_STATE(2028)] = 76126,
  [SMALL_STATE(2029)] = 76180,
  [SMALL_STATE(2030)] = 76250,
  [SMALL_STATE(2031)] = 76356,
  [SMALL_STATE(2032)] = 76412,
  [SMALL_STATE(2033)] = 76468,
  [SMALL_STATE(2034)] = 76520,
  [SMALL_STATE(2035)] = 76586,
  [SMALL_STATE(2036)] = 76680,
  [SMALL_STATE(2037)] = 76772,
  [SMALL_STATE(2038)] = 76862,
  [SMALL_STATE(2039)] = 76940,
  [SMALL_STATE(2040)] = 76996,
  [SMALL_STATE(2041)] = 77102,
  [SMALL_STATE(2042)] = 77200,
  [SMALL_STATE(2043)] = 77296,
  [SMALL_STATE(2044)] = 77402,
  [SMALL_STATE(2045)] = 77508,
  [SMALL_STATE(2046)] = 77614,
  [SMALL_STATE(2047)] = 77670,
  [SMALL_STATE(2048)] = 77730,
  [SMALL_STATE(2049)] = 77800,
  [SMALL_STATE(2050)] = 77906,
  [SMALL_STATE(2051)] = 77987,
  [SMALL_STATE(2052)] = 78058,
  [SMALL_STATE(2053)] = 78107,
  [SMALL_STATE(2054)] = 78176,
  [SMALL_STATE(2055)] = 78225,
  [SMALL_STATE(2056)] = 78274,
  [SMALL_STATE(2057)] = 78341,
  [SMALL_STATE(2058)] = 78422,
  [SMALL_STATE(2059)] = 78489,
  [SMALL_STATE(2060)] = 78560,
  [SMALL_STATE(2061)] = 78615,
  [SMALL_STATE(2062)] = 78664,
  [SMALL_STATE(2063)] = 78713,
  [SMALL_STATE(2064)] = 78762,
  [SMALL_STATE(2065)] = 78843,
  [SMALL_STATE(2066)] = 78896,
  [SMALL_STATE(2067)] = 78945,
  [SMALL_STATE(2068)] = 78994,
  [SMALL_STATE(2069)] = 79047,
  [SMALL_STATE(2070)] = 79128,
  [SMALL_STATE(2071)] = 79177,
  [SMALL_STATE(2072)] = 79258,
  [SMALL_STATE(2073)] = 79311,
  [SMALL_STATE(2074)] = 79364,
  [SMALL_STATE(2075)] = 79413,
  [SMALL_STATE(2076)] = 79462,
  [SMALL_STATE(2077)] = 79529,
  [SMALL_STATE(2078)] = 79582,
  [SMALL_STATE(2079)] = 79635,
  [SMALL_STATE(2080)] = 79704,
  [SMALL_STATE(2081)] = 79757,
  [SMALL_STATE(2082)] = 79828,
  [SMALL_STATE(2083)] = 79897,
  [SMALL_STATE(2084)] = 79968,
  [SMALL_STATE(2085)] = 80021,
  [SMALL_STATE(2086)] = 80102,
  [SMALL_STATE(2087)] = 80183,
  [SMALL_STATE(2088)] = 80232,
  [SMALL_STATE(2089)] = 80294,
  [SMALL_STATE(2090)] = 80356,
  [SMALL_STATE(2091)] = 80404,
  [SMALL_STATE(2092)] = 80478,
  [SMALL_STATE(2093)] = 80538,
  [SMALL_STATE(2094)] = 80590,
  [SMALL_STATE(2095)] = 80650,
  [SMALL_STATE(2096)] = 80700,
  [SMALL_STATE(2097)] = 80772,
  [SMALL_STATE(2098)] = 80824,
  [SMALL_STATE(2099)] = 80888,
  [SMALL_STATE(2100)] = 80952,
  [SMALL_STATE(2101)] = 81026,
  [SMALL_STATE(2102)] = 81088,
  [SMALL_STATE(2103)] = 81152,
  [SMALL_STATE(2104)] = 81224,
  [SMALL_STATE(2105)] = 81296,
  [SMALL_STATE(2106)] = 81360,
  [SMALL_STATE(2107)] = 81412,
  [SMALL_STATE(2108)] = 81474,
  [SMALL_STATE(2109)] = 81536,
  [SMALL_STATE(2110)] = 81584,
  [SMALL_STATE(2111)] = 81648,
  [SMALL_STATE(2112)] = 81710,
  [SMALL_STATE(2113)] = 81784,
  [SMALL_STATE(2114)] = 81846,
  [SMALL_STATE(2115)] = 81910,
  [SMALL_STATE(2116)] = 81982,
  [SMALL_STATE(2117)] = 82042,
  [SMALL_STATE(2118)] = 82102,
  [SMALL_STATE(2119)] = 82174,
  [SMALL_STATE(2120)] = 82234,
  [SMALL_STATE(2121)] = 82296,
  [SMALL_STATE(2122)] = 82370,
  [SMALL_STATE(2123)] = 82432,
  [SMALL_STATE(2124)] = 82484,
  [SMALL_STATE(2125)] = 82558,
  [SMALL_STATE(2126)] = 82618,
  [SMALL_STATE(2127)] = 82678,
  [SMALL_STATE(2128)] = 82738,
  [SMALL_STATE(2129)] = 82810,
  [SMALL_STATE(2130)] = 82872,
  [SMALL_STATE(2131)] = 82932,
  [SMALL_STATE(2132)] = 82994,
  [SMALL_STATE(2133)] = 83046,
  [SMALL_STATE(2134)] = 83108,
  [SMALL_STATE(2135)] = 83180,
  [SMALL_STATE(2136)] = 83244,
  [SMALL_STATE(2137)] = 83306,
  [SMALL_STATE(2138)] = 83370,
  [SMALL_STATE(2139)] = 83434,
  [SMALL_STATE(2140)] = 83494,
  [SMALL_STATE(2141)] = 83556,
  [SMALL_STATE(2142)] = 83630,
  [SMALL_STATE(2143)] = 83694,
  [SMALL_STATE(2144)] = 83756,
  [SMALL_STATE(2145)] = 83820,
  [SMALL_STATE(2146)] = 83894,
  [SMALL_STATE(2147)] = 83951,
  [SMALL_STATE(2148)] = 84008,
  [SMALL_STATE(2149)] = 84075,
  [SMALL_STATE(2150)] = 84132,
  [SMALL_STATE(2151)] = 84199,
  [SMALL_STATE(2152)] = 84256,
  [SMALL_STATE(2153)] = 84313,
  [SMALL_STATE(2154)] = 84370,
  [SMALL_STATE(2155)] = 84427,
  [SMALL_STATE(2156)] = 84484,
  [SMALL_STATE(2157)] = 84551,
  [SMALL_STATE(2158)] = 84608,
  [SMALL_STATE(2159)] = 84681,
  [SMALL_STATE(2160)] = 84738,
  [SMALL_STATE(2161)] = 84805,
  [SMALL_STATE(2162)] = 84882,
  [SMALL_STATE(2163)] = 84939,
  [SMALL_STATE(2164)] = 84996,
  [SMALL_STATE(2165)] = 85063,
  [SMALL_STATE(2166)] = 85130,
  [SMALL_STATE(2167)] = 85187,
  [SMALL_STATE(2168)] = 85244,
  [SMALL_STATE(2169)] = 85293,
  [SMALL_STATE(2170)] = 85350,
  [SMALL_STATE(2171)] = 85407,
  [SMALL_STATE(2172)] = 85464,
  [SMALL_STATE(2173)] = 85521,
  [SMALL_STATE(2174)] = 85588,
  [SMALL_STATE(2175)] = 85644,
  [SMALL_STATE(2176)] = 85710,
  [SMALL_STATE(2177)] = 85770,
  [SMALL_STATE(2178)] = 85826,
  [SMALL_STATE(2179)] = 85878,
  [SMALL_STATE(2180)] = 85930,
  [SMALL_STATE(2181)] = 85994,
  [SMALL_STATE(2182)] = 86054,
  [SMALL_STATE(2183)] = 86124,
  [SMALL_STATE(2184)] = 86181,
  [SMALL_STATE(2185)] = 86238,
  [SMALL_STATE(2186)] = 86295,
  [SMALL_STATE(2187)] = 86352,
  [SMALL_STATE(2188)] = 86409,
  [SMALL_STATE(2189)] = 86472,
  [SMALL_STATE(2190)] = 86529,
  [SMALL_STATE(2191)] = 86586,
  [SMALL_STATE(2192)] = 86647,
  [SMALL_STATE(2193)] = 86700,
  [SMALL_STATE(2194)] = 86757,
  [SMALL_STATE(2195)] = 86814,
  [SMALL_STATE(2196)] = 86867,
  [SMALL_STATE(2197)] = 86924,
  [SMALL_STATE(2198)] = 86983,
  [SMALL_STATE(2199)] = 87040,
  [SMALL_STATE(2200)] = 87097,
  [SMALL_STATE(2201)] = 87154,
  [SMALL_STATE(2202)] = 87211,
  [SMALL_STATE(2203)] = 87267,
  [SMALL_STATE(2204)] = 87346,
  [SMALL_STATE(2205)] = 87395,
  [SMALL_STATE(2206)] = 87474,
  [SMALL_STATE(2207)] = 87553,
  [SMALL_STATE(2208)] = 87632,
  [SMALL_STATE(2209)] = 87679,
  [SMALL_STATE(2210)] = 87758,
  [SMALL_STATE(2211)] = 87807,
  [SMALL_STATE(2212)] = 87872,
  [SMALL_STATE(2213)] = 87912,
  [SMALL_STATE(2214)] = 87952,
  [SMALL_STATE(2215)] = 88006,
  [SMALL_STATE(2216)] = 88062,
  [SMALL_STATE(2217)] = 88120,
  [SMALL_STATE(2218)] = 88166,
  [SMALL_STATE(2219)] = 88206,
  [SMALL_STATE(2220)] = 88246,
  [SMALL_STATE(2221)] = 88286,
  [SMALL_STATE(2222)] = 88328,
  [SMALL_STATE(2223)] = 88368,
  [SMALL_STATE(2224)] = 88410,
  [SMALL_STATE(2225)] = 88450,
  [SMALL_STATE(2226)] = 88506,
  [SMALL_STATE(2227)] = 88546,
  [SMALL_STATE(2228)] = 88586,
  [SMALL_STATE(2229)] = 88632,
  [SMALL_STATE(2230)] = 88672,
  [SMALL_STATE(2231)] = 88730,
  [SMALL_STATE(2232)] = 88788,
  [SMALL_STATE(2233)] = 88828,
  [SMALL_STATE(2234)] = 88884,
  [SMALL_STATE(2235)] = 88924,
  [SMALL_STATE(2236)] = 88964,
  [SMALL_STATE(2237)] = 89004,
  [SMALL_STATE(2238)] = 89044,
  [SMALL_STATE(2239)] = 89084,
  [SMALL_STATE(2240)] = 89124,
  [SMALL_STATE(2241)] = 89164,
  [SMALL_STATE(2242)] = 89204,
  [SMALL_STATE(2243)] = 89244,
  [SMALL_STATE(2244)] = 89284,
  [SMALL_STATE(2245)] = 89324,
  [SMALL_STATE(2246)] = 89364,
  [SMALL_STATE(2247)] = 89406,
  [SMALL_STATE(2248)] = 89446,
  [SMALL_STATE(2249)] = 89486,
  [SMALL_STATE(2250)] = 89542,
  [SMALL_STATE(2251)] = 89593,
  [SMALL_STATE(2252)] = 89644,
  [SMALL_STATE(2253)] = 89695,
  [SMALL_STATE(2254)] = 89746,
  [SMALL_STATE(2255)] = 89797,
  [SMALL_STATE(2256)] = 89838,
  [SMALL_STATE(2257)] = 89889,
  [SMALL_STATE(2258)] = 89940,
  [SMALL_STATE(2259)] = 89991,
  [SMALL_STATE(2260)] = 90042,
  [SMALL_STATE(2261)] = 90093,
  [SMALL_STATE(2262)] = 90144,
  [SMALL_STATE(2263)] = 90185,
  [SMALL_STATE(2264)] = 90236,
  [SMALL_STATE(2265)] = 90287,
  [SMALL_STATE(2266)] = 90338,
  [SMALL_STATE(2267)] = 90389,
  [SMALL_STATE(2268)] = 90440,
  [SMALL_STATE(2269)] = 90491,
  [SMALL_STATE(2270)] = 90554,
  [SMALL_STATE(2271)] = 90605,
  [SMALL_STATE(2272)] = 90656,
  [SMALL_STATE(2273)] = 90707,
  [SMALL_STATE(2274)] = 90745,
  [SMALL_STATE(2275)] = 90783,
  [SMALL_STATE(2276)] = 90833,
  [SMALL_STATE(2277)] = 90883,
  [SMALL_STATE(2278)] = 90921,
  [SMALL_STATE(2279)] = 90959,
  [SMALL_STATE(2280)] = 91019,
  [SMALL_STATE(2281)] = 91057,
  [SMALL_STATE(2282)] = 91107,
  [SMALL_STATE(2283)] = 91145,
  [SMALL_STATE(2284)] = 91195,
  [SMALL_STATE(2285)] = 91233,
  [SMALL_STATE(2286)] = 91283,
  [SMALL_STATE(2287)] = 91343,
  [SMALL_STATE(2288)] = 91393,
  [SMALL_STATE(2289)] = 91443,
  [SMALL_STATE(2290)] = 91493,
  [SMALL_STATE(2291)] = 91553,
  [SMALL_STATE(2292)] = 91591,
  [SMALL_STATE(2293)] = 91641,
  [SMALL_STATE(2294)] = 91691,
  [SMALL_STATE(2295)] = 91747,
  [SMALL_STATE(2296)] = 91785,
  [SMALL_STATE(2297)] = 91838,
  [SMALL_STATE(2298)] = 91891,
  [SMALL_STATE(2299)] = 91932,
  [SMALL_STATE(2300)] = 91985,
  [SMALL_STATE(2301)] = 92038,
  [SMALL_STATE(2302)] = 92091,
  [SMALL_STATE(2303)] = 92144,
  [SMALL_STATE(2304)] = 92197,
  [SMALL_STATE(2305)] = 92250,
  [SMALL_STATE(2306)] = 92301,
  [SMALL_STATE(2307)] = 92352,
  [SMALL_STATE(2308)] = 92405,
  [SMALL_STATE(2309)] = 92458,
  [SMALL_STATE(2310)] = 92505,
  [SMALL_STATE(2311)] = 92558,
  [SMALL_STATE(2312)] = 92611,
  [SMALL_STATE(2313)] = 92655,
  [SMALL_STATE(2314)] = 92699,
  [SMALL_STATE(2315)] = 92743,
  [SMALL_STATE(2316)] = 92787,
  [SMALL_STATE(2317)] = 92831,
  [SMALL_STATE(2318)] = 92875,
  [SMALL_STATE(2319)] = 92919,
  [SMALL_STATE(2320)] = 92963,
  [SMALL_STATE(2321)] = 93009,
  [SMALL_STATE(2322)] = 93053,
  [SMALL_STATE(2323)] = 93097,
  [SMALL_STATE(2324)] = 93141,
  [SMALL_STATE(2325)] = 93185,
  [SMALL_STATE(2326)] = 93229,
  [SMALL_STATE(2327)] = 93275,
  [SMALL_STATE(2328)] = 93319,
  [SMALL_STATE(2329)] = 93363,
  [SMALL_STATE(2330)] = 93407,
  [SMALL_STATE(2331)] = 93451,
  [SMALL_STATE(2332)] = 93497,
  [SMALL_STATE(2333)] = 93541,
  [SMALL_STATE(2334)] = 93585,
  [SMALL_STATE(2335)] = 93629,
  [SMALL_STATE(2336)] = 93673,
  [SMALL_STATE(2337)] = 93717,
  [SMALL_STATE(2338)] = 93761,
  [SMALL_STATE(2339)] = 93805,
  [SMALL_STATE(2340)] = 93849,
  [SMALL_STATE(2341)] = 93893,
  [SMALL_STATE(2342)] = 93937,
  [SMALL_STATE(2343)] = 93981,
  [SMALL_STATE(2344)] = 94025,
  [SMALL_STATE(2345)] = 94056,
  [SMALL_STATE(2346)] = 94096,
  [SMALL_STATE(2347)] = 94136,
  [SMALL_STATE(2348)] = 94176,
  [SMALL_STATE(2349)] = 94203,
  [SMALL_STATE(2350)] = 94230,
  [SMALL_STATE(2351)] = 94257,
  [SMALL_STATE(2352)] = 94284,
  [SMALL_STATE(2353)] = 94311,
  [SMALL_STATE(2354)] = 94338,
  [SMALL_STATE(2355)] = 94365,
  [SMALL_STATE(2356)] = 94392,
  [SMALL_STATE(2357)] = 94419,
  [SMALL_STATE(2358)] = 94446,
  [SMALL_STATE(2359)] = 94473,
  [SMALL_STATE(2360)] = 94500,
  [SMALL_STATE(2361)] = 94527,
  [SMALL_STATE(2362)] = 94554,
  [SMALL_STATE(2363)] = 94581,
  [SMALL_STATE(2364)] = 94608,
  [SMALL_STATE(2365)] = 94635,
  [SMALL_STATE(2366)] = 94662,
  [SMALL_STATE(2367)] = 94689,
  [SMALL_STATE(2368)] = 94716,
  [SMALL_STATE(2369)] = 94743,
  [SMALL_STATE(2370)] = 94770,
  [SMALL_STATE(2371)] = 94797,
  [SMALL_STATE(2372)] = 94824,
  [SMALL_STATE(2373)] = 94851,
  [SMALL_STATE(2374)] = 94878,
  [SMALL_STATE(2375)] = 94905,
  [SMALL_STATE(2376)] = 94932,
  [SMALL_STATE(2377)] = 94959,
  [SMALL_STATE(2378)] = 94986,
  [SMALL_STATE(2379)] = 95013,
  [SMALL_STATE(2380)] = 95040,
  [SMALL_STATE(2381)] = 95067,
  [SMALL_STATE(2382)] = 95094,
  [SMALL_STATE(2383)] = 95128,
  [SMALL_STATE(2384)] = 95165,
  [SMALL_STATE(2385)] = 95190,
  [SMALL_STATE(2386)] = 95215,
  [SMALL_STATE(2387)] = 95242,
  [SMALL_STATE(2388)] = 95269,
  [SMALL_STATE(2389)] = 95300,
  [SMALL_STATE(2390)] = 95325,
  [SMALL_STATE(2391)] = 95354,
  [SMALL_STATE(2392)] = 95391,
  [SMALL_STATE(2393)] = 95428,
  [SMALL_STATE(2394)] = 95452,
  [SMALL_STATE(2395)] = 95480,
  [SMALL_STATE(2396)] = 95504,
  [SMALL_STATE(2397)] = 95528,
  [SMALL_STATE(2398)] = 95552,
  [SMALL_STATE(2399)] = 95575,
  [SMALL_STATE(2400)] = 95598,
  [SMALL_STATE(2401)] = 95623,
  [SMALL_STATE(2402)] = 95656,
  [SMALL_STATE(2403)] = 95687,
  [SMALL_STATE(2404)] = 95710,
  [SMALL_STATE(2405)] = 95733,
  [SMALL_STATE(2406)] = 95766,
  [SMALL_STATE(2407)] = 95789,
  [SMALL_STATE(2408)] = 95810,
  [SMALL_STATE(2409)] = 95831,
  [SMALL_STATE(2410)] = 95864,
  [SMALL_STATE(2411)] = 95897,
  [SMALL_STATE(2412)] = 95918,
  [SMALL_STATE(2413)] = 95941,
  [SMALL_STATE(2414)] = 95964,
  [SMALL_STATE(2415)] = 95985,
  [SMALL_STATE(2416)] = 96008,
  [SMALL_STATE(2417)] = 96031,
  [SMALL_STATE(2418)] = 96054,
  [SMALL_STATE(2419)] = 96087,
  [SMALL_STATE(2420)] = 96108,
  [SMALL_STATE(2421)] = 96131,
  [SMALL_STATE(2422)] = 96156,
  [SMALL_STATE(2423)] = 96179,
  [SMALL_STATE(2424)] = 96202,
  [SMALL_STATE(2425)] = 96235,
  [SMALL_STATE(2426)] = 96266,
  [SMALL_STATE(2427)] = 96289,
  [SMALL_STATE(2428)] = 96312,
  [SMALL_STATE(2429)] = 96335,
  [SMALL_STATE(2430)] = 96358,
  [SMALL_STATE(2431)] = 96381,
  [SMALL_STATE(2432)] = 96404,
  [SMALL_STATE(2433)] = 96427,
  [SMALL_STATE(2434)] = 96450,
  [SMALL_STATE(2435)] = 96473,
  [SMALL_STATE(2436)] = 96496,
  [SMALL_STATE(2437)] = 96519,
  [SMALL_STATE(2438)] = 96542,
  [SMALL_STATE(2439)] = 96565,
  [SMALL_STATE(2440)] = 96588,
  [SMALL_STATE(2441)] = 96611,
  [SMALL_STATE(2442)] = 96644,
  [SMALL_STATE(2443)] = 96677,
  [SMALL_STATE(2444)] = 96700,
  [SMALL_STATE(2445)] = 96723,
  [SMALL_STATE(2446)] = 96746,
  [SMALL_STATE(2447)] = 96771,
  [SMALL_STATE(2448)] = 96794,
  [SMALL_STATE(2449)] = 96827,
  [SMALL_STATE(2450)] = 96848,
  [SMALL_STATE(2451)] = 96881,
  [SMALL_STATE(2452)] = 96902,
  [SMALL_STATE(2453)] = 96933,
  [SMALL_STATE(2454)] = 96966,
  [SMALL_STATE(2455)] = 96989,
  [SMALL_STATE(2456)] = 97022,
  [SMALL_STATE(2457)] = 97045,
  [SMALL_STATE(2458)] = 97068,
  [SMALL_STATE(2459)] = 97091,
  [SMALL_STATE(2460)] = 97114,
  [SMALL_STATE(2461)] = 97137,
  [SMALL_STATE(2462)] = 97160,
  [SMALL_STATE(2463)] = 97183,
  [SMALL_STATE(2464)] = 97206,
  [SMALL_STATE(2465)] = 97229,
  [SMALL_STATE(2466)] = 97252,
  [SMALL_STATE(2467)] = 97275,
  [SMALL_STATE(2468)] = 97308,
  [SMALL_STATE(2469)] = 97331,
  [SMALL_STATE(2470)] = 97362,
  [SMALL_STATE(2471)] = 97385,
  [SMALL_STATE(2472)] = 97406,
  [SMALL_STATE(2473)] = 97437,
  [SMALL_STATE(2474)] = 97460,
  [SMALL_STATE(2475)] = 97483,
  [SMALL_STATE(2476)] = 97506,
  [SMALL_STATE(2477)] = 97529,
  [SMALL_STATE(2478)] = 97552,
  [SMALL_STATE(2479)] = 97575,
  [SMALL_STATE(2480)] = 97598,
  [SMALL_STATE(2481)] = 97621,
  [SMALL_STATE(2482)] = 97644,
  [SMALL_STATE(2483)] = 97667,
  [SMALL_STATE(2484)] = 97690,
  [SMALL_STATE(2485)] = 97713,
  [SMALL_STATE(2486)] = 97738,
  [SMALL_STATE(2487)] = 97769,
  [SMALL_STATE(2488)] = 97792,
  [SMALL_STATE(2489)] = 97825,
  [SMALL_STATE(2490)] = 97858,
  [SMALL_STATE(2491)] = 97881,
  [SMALL_STATE(2492)] = 97914,
  [SMALL_STATE(2493)] = 97947,
  [SMALL_STATE(2494)] = 97970,
  [SMALL_STATE(2495)] = 97993,
  [SMALL_STATE(2496)] = 98026,
  [SMALL_STATE(2497)] = 98051,
  [SMALL_STATE(2498)] = 98074,
  [SMALL_STATE(2499)] = 98101,
  [SMALL_STATE(2500)] = 98124,
  [SMALL_STATE(2501)] = 98166,
  [SMALL_STATE(2502)] = 98208,
  [SMALL_STATE(2503)] = 98250,
  [SMALL_STATE(2504)] = 98274,
  [SMALL_STATE(2505)] = 98302,
  [SMALL_STATE(2506)] = 98330,
  [SMALL_STATE(2507)] = 98358,
  [SMALL_STATE(2508)] = 98386,
  [SMALL_STATE(2509)] = 98414,
  [SMALL_STATE(2510)] = 98456,
  [SMALL_STATE(2511)] = 98500,
  [SMALL_STATE(2512)] = 98528,
  [SMALL_STATE(2513)] = 98552,
  [SMALL_STATE(2514)] = 98580,
  [SMALL_STATE(2515)] = 98608,
  [SMALL_STATE(2516)] = 98636,
  [SMALL_STATE(2517)] = 98664,
  [SMALL_STATE(2518)] = 98692,
  [SMALL_STATE(2519)] = 98720,
  [SMALL_STATE(2520)] = 98748,
  [SMALL_STATE(2521)] = 98790,
  [SMALL_STATE(2522)] = 98832,
  [SMALL_STATE(2523)] = 98874,
  [SMALL_STATE(2524)] = 98902,
  [SMALL_STATE(2525)] = 98926,
  [SMALL_STATE(2526)] = 98961,
  [SMALL_STATE(2527)] = 98986,
  [SMALL_STATE(2528)] = 99007,
  [SMALL_STATE(2529)] = 99042,
  [SMALL_STATE(2530)] = 99063,
  [SMALL_STATE(2531)] = 99084,
  [SMALL_STATE(2532)] = 99105,
  [SMALL_STATE(2533)] = 99126,
  [SMALL_STATE(2534)] = 99147,
  [SMALL_STATE(2535)] = 99170,
  [SMALL_STATE(2536)] = 99193,
  [SMALL_STATE(2537)] = 99214,
  [SMALL_STATE(2538)] = 99249,
  [SMALL_STATE(2539)] = 99284,
  [SMALL_STATE(2540)] = 99305,
  [SMALL_STATE(2541)] = 99326,
  [SMALL_STATE(2542)] = 99347,
  [SMALL_STATE(2543)] = 99368,
  [SMALL_STATE(2544)] = 99389,
  [SMALL_STATE(2545)] = 99410,
  [SMALL_STATE(2546)] = 99431,
  [SMALL_STATE(2547)] = 99452,
  [SMALL_STATE(2548)] = 99477,
  [SMALL_STATE(2549)] = 99512,
  [SMALL_STATE(2550)] = 99533,
  [SMALL_STATE(2551)] = 99554,
  [SMALL_STATE(2552)] = 99575,
  [SMALL_STATE(2553)] = 99602,
  [SMALL_STATE(2554)] = 99623,
  [SMALL_STATE(2555)] = 99658,
  [SMALL_STATE(2556)] = 99679,
  [SMALL_STATE(2557)] = 99700,
  [SMALL_STATE(2558)] = 99721,
  [SMALL_STATE(2559)] = 99756,
  [SMALL_STATE(2560)] = 99777,
  [SMALL_STATE(2561)] = 99798,
  [SMALL_STATE(2562)] = 99819,
  [SMALL_STATE(2563)] = 99840,
  [SMALL_STATE(2564)] = 99861,
  [SMALL_STATE(2565)] = 99882,
  [SMALL_STATE(2566)] = 99903,
  [SMALL_STATE(2567)] = 99924,
  [SMALL_STATE(2568)] = 99945,
  [SMALL_STATE(2569)] = 99966,
  [SMALL_STATE(2570)] = 100001,
  [SMALL_STATE(2571)] = 100036,
  [SMALL_STATE(2572)] = 100057,
  [SMALL_STATE(2573)] = 100078,
  [SMALL_STATE(2574)] = 100115,
  [SMALL_STATE(2575)] = 100136,
  [SMALL_STATE(2576)] = 100157,
  [SMALL_STATE(2577)] = 100178,
  [SMALL_STATE(2578)] = 100213,
  [SMALL_STATE(2579)] = 100234,
  [SMALL_STATE(2580)] = 100255,
  [SMALL_STATE(2581)] = 100276,
  [SMALL_STATE(2582)] = 100306,
  [SMALL_STATE(2583)] = 100338,
  [SMALL_STATE(2584)] = 100374,
  [SMALL_STATE(2585)] = 100404,
  [SMALL_STATE(2586)] = 100440,
  [SMALL_STATE(2587)] = 100476,
  [SMALL_STATE(2588)] = 100498,
  [SMALL_STATE(2589)] = 100530,
  [SMALL_STATE(2590)] = 100560,
  [SMALL_STATE(2591)] = 100592,
  [SMALL_STATE(2592)] = 100622,
  [SMALL_STATE(2593)] = 100654,
  [SMALL_STATE(2594)] = 100686,
  [SMALL_STATE(2595)] = 100716,
  [SMALL_STATE(2596)] = 100746,
  [SMALL_STATE(2597)] = 100768,
  [SMALL_STATE(2598)] = 100798,
  [SMALL_STATE(2599)] = 100818,
  [SMALL_STATE(2600)] = 100838,
  [SMALL_STATE(2601)] = 100874,
  [SMALL_STATE(2602)] = 100904,
  [SMALL_STATE(2603)] = 100940,
  [SMALL_STATE(2604)] = 100978,
  [SMALL_STATE(2605)] = 101014,
  [SMALL_STATE(2606)] = 101046,
  [SMALL_STATE(2607)] = 101078,
  [SMALL_STATE(2608)] = 101110,
  [SMALL_STATE(2609)] = 101132,
  [SMALL_STATE(2610)] = 101164,
  [SMALL_STATE(2611)] = 101188,
  [SMALL_STATE(2612)] = 101208,
  [SMALL_STATE(2613)] = 101244,
  [SMALL_STATE(2614)] = 101264,
  [SMALL_STATE(2615)] = 101294,
  [SMALL_STATE(2616)] = 101326,
  [SMALL_STATE(2617)] = 101345,
  [SMALL_STATE(2618)] = 101364,
  [SMALL_STATE(2619)] = 101383,
  [SMALL_STATE(2620)] = 101404,
  [SMALL_STATE(2621)] = 101423,
  [SMALL_STATE(2622)] = 101440,
  [SMALL_STATE(2623)] = 101459,
  [SMALL_STATE(2624)] = 101494,
  [SMALL_STATE(2625)] = 101511,
  [SMALL_STATE(2626)] = 101530,
  [SMALL_STATE(2627)] = 101547,
  [SMALL_STATE(2628)] = 101566,
  [SMALL_STATE(2629)] = 101583,
  [SMALL_STATE(2630)] = 101602,
  [SMALL_STATE(2631)] = 101623,
  [SMALL_STATE(2632)] = 101644,
  [SMALL_STATE(2633)] = 101663,
  [SMALL_STATE(2634)] = 101682,
  [SMALL_STATE(2635)] = 101703,
  [SMALL_STATE(2636)] = 101722,
  [SMALL_STATE(2637)] = 101745,
  [SMALL_STATE(2638)] = 101768,
  [SMALL_STATE(2639)] = 101787,
  [SMALL_STATE(2640)] = 101806,
  [SMALL_STATE(2641)] = 101827,
  [SMALL_STATE(2642)] = 101846,
  [SMALL_STATE(2643)] = 101869,
  [SMALL_STATE(2644)] = 101888,
  [SMALL_STATE(2645)] = 101905,
  [SMALL_STATE(2646)] = 101924,
  [SMALL_STATE(2647)] = 101943,
  [SMALL_STATE(2648)] = 101964,
  [SMALL_STATE(2649)] = 101983,
  [SMALL_STATE(2650)] = 102002,
  [SMALL_STATE(2651)] = 102021,
  [SMALL_STATE(2652)] = 102042,
  [SMALL_STATE(2653)] = 102059,
  [SMALL_STATE(2654)] = 102082,
  [SMALL_STATE(2655)] = 102101,
  [SMALL_STATE(2656)] = 102120,
  [SMALL_STATE(2657)] = 102139,
  [SMALL_STATE(2658)] = 102158,
  [SMALL_STATE(2659)] = 102177,
  [SMALL_STATE(2660)] = 102196,
  [SMALL_STATE(2661)] = 102215,
  [SMALL_STATE(2662)] = 102234,
  [SMALL_STATE(2663)] = 102253,
  [SMALL_STATE(2664)] = 102274,
  [SMALL_STATE(2665)] = 102293,
  [SMALL_STATE(2666)] = 102312,
  [SMALL_STATE(2667)] = 102331,
  [SMALL_STATE(2668)] = 102350,
  [SMALL_STATE(2669)] = 102373,
  [SMALL_STATE(2670)] = 102396,
  [SMALL_STATE(2671)] = 102419,
  [SMALL_STATE(2672)] = 102438,
  [SMALL_STATE(2673)] = 102457,
  [SMALL_STATE(2674)] = 102476,
  [SMALL_STATE(2675)] = 102499,
  [SMALL_STATE(2676)] = 102518,
  [SMALL_STATE(2677)] = 102537,
  [SMALL_STATE(2678)] = 102556,
  [SMALL_STATE(2679)] = 102577,
  [SMALL_STATE(2680)] = 102596,
  [SMALL_STATE(2681)] = 102616,
  [SMALL_STATE(2682)] = 102632,
  [SMALL_STATE(2683)] = 102664,
  [SMALL_STATE(2684)] = 102692,
  [SMALL_STATE(2685)] = 102720,
  [SMALL_STATE(2686)] = 102754,
  [SMALL_STATE(2687)] = 102774,
  [SMALL_STATE(2688)] = 102808,
  [SMALL_STATE(2689)] = 102842,
  [SMALL_STATE(2690)] = 102872,
  [SMALL_STATE(2691)] = 102896,
  [SMALL_STATE(2692)] = 102930,
  [SMALL_STATE(2693)] = 102948,
  [SMALL_STATE(2694)] = 102982,
  [SMALL_STATE(2695)] = 103000,
  [SMALL_STATE(2696)] = 103022,
  [SMALL_STATE(2697)] = 103040,
  [SMALL_STATE(2698)] = 103074,
  [SMALL_STATE(2699)] = 103106,
  [SMALL_STATE(2700)] = 103140,
  [SMALL_STATE(2701)] = 103156,
  [SMALL_STATE(2702)] = 103178,
  [SMALL_STATE(2703)] = 103212,
  [SMALL_STATE(2704)] = 103246,
  [SMALL_STATE(2705)] = 103276,
  [SMALL_STATE(2706)] = 103310,
  [SMALL_STATE(2707)] = 103344,
  [SMALL_STATE(2708)] = 103361,
  [SMALL_STATE(2709)] = 103378,
  [SMALL_STATE(2710)] = 103393,
  [SMALL_STATE(2711)] = 103408,
  [SMALL_STATE(2712)] = 103429,
  [SMALL_STATE(2713)] = 103448,
  [SMALL_STATE(2714)] = 103473,
  [SMALL_STATE(2715)] = 103490,
  [SMALL_STATE(2716)] = 103505,
  [SMALL_STATE(2717)] = 103522,
  [SMALL_STATE(2718)] = 103545,
  [SMALL_STATE(2719)] = 103560,
  [SMALL_STATE(2720)] = 103591,
  [SMALL_STATE(2721)] = 103622,
  [SMALL_STATE(2722)] = 103653,
  [SMALL_STATE(2723)] = 103684,
  [SMALL_STATE(2724)] = 103699,
  [SMALL_STATE(2725)] = 103720,
  [SMALL_STATE(2726)] = 103751,
  [SMALL_STATE(2727)] = 103778,
  [SMALL_STATE(2728)] = 103793,
  [SMALL_STATE(2729)] = 103808,
  [SMALL_STATE(2730)] = 103823,
  [SMALL_STATE(2731)] = 103838,
  [SMALL_STATE(2732)] = 103859,
  [SMALL_STATE(2733)] = 103884,
  [SMALL_STATE(2734)] = 103915,
  [SMALL_STATE(2735)] = 103940,
  [SMALL_STATE(2736)] = 103955,
  [SMALL_STATE(2737)] = 103970,
  [SMALL_STATE(2738)] = 103985,
  [SMALL_STATE(2739)] = 104000,
  [SMALL_STATE(2740)] = 104015,
  [SMALL_STATE(2741)] = 104036,
  [SMALL_STATE(2742)] = 104053,
  [SMALL_STATE(2743)] = 104068,
  [SMALL_STATE(2744)] = 104085,
  [SMALL_STATE(2745)] = 104100,
  [SMALL_STATE(2746)] = 104131,
  [SMALL_STATE(2747)] = 104162,
  [SMALL_STATE(2748)] = 104179,
  [SMALL_STATE(2749)] = 104194,
  [SMALL_STATE(2750)] = 104209,
  [SMALL_STATE(2751)] = 104224,
  [SMALL_STATE(2752)] = 104239,
  [SMALL_STATE(2753)] = 104254,
  [SMALL_STATE(2754)] = 104269,
  [SMALL_STATE(2755)] = 104288,
  [SMALL_STATE(2756)] = 104315,
  [SMALL_STATE(2757)] = 104330,
  [SMALL_STATE(2758)] = 104345,
  [SMALL_STATE(2759)] = 104360,
  [SMALL_STATE(2760)] = 104375,
  [SMALL_STATE(2761)] = 104402,
  [SMALL_STATE(2762)] = 104433,
  [SMALL_STATE(2763)] = 104450,
  [SMALL_STATE(2764)] = 104465,
  [SMALL_STATE(2765)] = 104480,
  [SMALL_STATE(2766)] = 104495,
  [SMALL_STATE(2767)] = 104510,
  [SMALL_STATE(2768)] = 104531,
  [SMALL_STATE(2769)] = 104546,
  [SMALL_STATE(2770)] = 104561,
  [SMALL_STATE(2771)] = 104576,
  [SMALL_STATE(2772)] = 104597,
  [SMALL_STATE(2773)] = 104612,
  [SMALL_STATE(2774)] = 104643,
  [SMALL_STATE(2775)] = 104674,
  [SMALL_STATE(2776)] = 104689,
  [SMALL_STATE(2777)] = 104718,
  [SMALL_STATE(2778)] = 104749,
  [SMALL_STATE(2779)] = 104780,
  [SMALL_STATE(2780)] = 104811,
  [SMALL_STATE(2781)] = 104838,
  [SMALL_STATE(2782)] = 104853,
  [SMALL_STATE(2783)] = 104868,
  [SMALL_STATE(2784)] = 104899,
  [SMALL_STATE(2785)] = 104924,
  [SMALL_STATE(2786)] = 104939,
  [SMALL_STATE(2787)] = 104954,
  [SMALL_STATE(2788)] = 104969,
  [SMALL_STATE(2789)] = 104984,
  [SMALL_STATE(2790)] = 105009,
  [SMALL_STATE(2791)] = 105024,
  [SMALL_STATE(2792)] = 105055,
  [SMALL_STATE(2793)] = 105074,
  [SMALL_STATE(2794)] = 105099,
  [SMALL_STATE(2795)] = 105130,
  [SMALL_STATE(2796)] = 105157,
  [SMALL_STATE(2797)] = 105184,
  [SMALL_STATE(2798)] = 105205,
  [SMALL_STATE(2799)] = 105230,
  [SMALL_STATE(2800)] = 105257,
  [SMALL_STATE(2801)] = 105284,
  [SMALL_STATE(2802)] = 105299,
  [SMALL_STATE(2803)] = 105330,
  [SMALL_STATE(2804)] = 105351,
  [SMALL_STATE(2805)] = 105366,
  [SMALL_STATE(2806)] = 105381,
  [SMALL_STATE(2807)] = 105408,
  [SMALL_STATE(2808)] = 105439,
  [SMALL_STATE(2809)] = 105459,
  [SMALL_STATE(2810)] = 105473,
  [SMALL_STATE(2811)] = 105487,
  [SMALL_STATE(2812)] = 105505,
  [SMALL_STATE(2813)] = 105519,
  [SMALL_STATE(2814)] = 105543,
  [SMALL_STATE(2815)] = 105567,
  [SMALL_STATE(2816)] = 105591,
  [SMALL_STATE(2817)] = 105615,
  [SMALL_STATE(2818)] = 105635,
  [SMALL_STATE(2819)] = 105659,
  [SMALL_STATE(2820)] = 105683,
  [SMALL_STATE(2821)] = 105707,
  [SMALL_STATE(2822)] = 105731,
  [SMALL_STATE(2823)] = 105755,
  [SMALL_STATE(2824)] = 105775,
  [SMALL_STATE(2825)] = 105799,
  [SMALL_STATE(2826)] = 105823,
  [SMALL_STATE(2827)] = 105843,
  [SMALL_STATE(2828)] = 105863,
  [SMALL_STATE(2829)] = 105887,
  [SMALL_STATE(2830)] = 105910,
  [SMALL_STATE(2831)] = 105931,
  [SMALL_STATE(2832)] = 105956,
  [SMALL_STATE(2833)] = 105981,
  [SMALL_STATE(2834)] = 106006,
  [SMALL_STATE(2835)] = 106027,
  [SMALL_STATE(2836)] = 106044,
  [SMALL_STATE(2837)] = 106069,
  [SMALL_STATE(2838)] = 106086,
  [SMALL_STATE(2839)] = 106099,
  [SMALL_STATE(2840)] = 106116,
  [SMALL_STATE(2841)] = 106133,
  [SMALL_STATE(2842)] = 106158,
  [SMALL_STATE(2843)] = 106175,
  [SMALL_STATE(2844)] = 106192,
  [SMALL_STATE(2845)] = 106215,
  [SMALL_STATE(2846)] = 106232,
  [SMALL_STATE(2847)] = 106257,
  [SMALL_STATE(2848)] = 106274,
  [SMALL_STATE(2849)] = 106287,
  [SMALL_STATE(2850)] = 106312,
  [SMALL_STATE(2851)] = 106325,
  [SMALL_STATE(2852)] = 106338,
  [SMALL_STATE(2853)] = 106353,
  [SMALL_STATE(2854)] = 106378,
  [SMALL_STATE(2855)] = 106395,
  [SMALL_STATE(2856)] = 106420,
  [SMALL_STATE(2857)] = 106437,
  [SMALL_STATE(2858)] = 106462,
  [SMALL_STATE(2859)] = 106487,
  [SMALL_STATE(2860)] = 106512,
  [SMALL_STATE(2861)] = 106529,
  [SMALL_STATE(2862)] = 106546,
  [SMALL_STATE(2863)] = 106563,
  [SMALL_STATE(2864)] = 106580,
  [SMALL_STATE(2865)] = 106605,
  [SMALL_STATE(2866)] = 106622,
  [SMALL_STATE(2867)] = 106641,
  [SMALL_STATE(2868)] = 106658,
  [SMALL_STATE(2869)] = 106675,
  [SMALL_STATE(2870)] = 106700,
  [SMALL_STATE(2871)] = 106715,
  [SMALL_STATE(2872)] = 106732,
  [SMALL_STATE(2873)] = 106757,
  [SMALL_STATE(2874)] = 106782,
  [SMALL_STATE(2875)] = 106797,
  [SMALL_STATE(2876)] = 106812,
  [SMALL_STATE(2877)] = 106827,
  [SMALL_STATE(2878)] = 106852,
  [SMALL_STATE(2879)] = 106873,
  [SMALL_STATE(2880)] = 106890,
  [SMALL_STATE(2881)] = 106903,
  [SMALL_STATE(2882)] = 106928,
  [SMALL_STATE(2883)] = 106953,
  [SMALL_STATE(2884)] = 106966,
  [SMALL_STATE(2885)] = 106983,
  [SMALL_STATE(2886)] = 107000,
  [SMALL_STATE(2887)] = 107013,
  [SMALL_STATE(2888)] = 107028,
  [SMALL_STATE(2889)] = 107045,
  [SMALL_STATE(2890)] = 107062,
  [SMALL_STATE(2891)] = 107079,
  [SMALL_STATE(2892)] = 107096,
  [SMALL_STATE(2893)] = 107117,
  [SMALL_STATE(2894)] = 107138,
  [SMALL_STATE(2895)] = 107163,
  [SMALL_STATE(2896)] = 107188,
  [SMALL_STATE(2897)] = 107213,
  [SMALL_STATE(2898)] = 107234,
  [SMALL_STATE(2899)] = 107259,
  [SMALL_STATE(2900)] = 107284,
  [SMALL_STATE(2901)] = 107297,
  [SMALL_STATE(2902)] = 107310,
  [SMALL_STATE(2903)] = 107331,
  [SMALL_STATE(2904)] = 107352,
  [SMALL_STATE(2905)] = 107373,
  [SMALL_STATE(2906)] = 107398,
  [SMALL_STATE(2907)] = 107411,
  [SMALL_STATE(2908)] = 107428,
  [SMALL_STATE(2909)] = 107453,
  [SMALL_STATE(2910)] = 107478,
  [SMALL_STATE(2911)] = 107503,
  [SMALL_STATE(2912)] = 107528,
  [SMALL_STATE(2913)] = 107549,
  [SMALL_STATE(2914)] = 107570,
  [SMALL_STATE(2915)] = 107595,
  [SMALL_STATE(2916)] = 107608,
  [SMALL_STATE(2917)] = 107633,
  [SMALL_STATE(2918)] = 107658,
  [SMALL_STATE(2919)] = 107679,
  [SMALL_STATE(2920)] = 107692,
  [SMALL_STATE(2921)] = 107713,
  [SMALL_STATE(2922)] = 107730,
  [SMALL_STATE(2923)] = 107755,
  [SMALL_STATE(2924)] = 107780,
  [SMALL_STATE(2925)] = 107805,
  [SMALL_STATE(2926)] = 107820,
  [SMALL_STATE(2927)] = 107845,
  [SMALL_STATE(2928)] = 107870,
  [SMALL_STATE(2929)] = 107891,
  [SMALL_STATE(2930)] = 107912,
  [SMALL_STATE(2931)] = 107933,
  [SMALL_STATE(2932)] = 107958,
  [SMALL_STATE(2933)] = 107983,
  [SMALL_STATE(2934)] = 108008,
  [SMALL_STATE(2935)] = 108033,
  [SMALL_STATE(2936)] = 108058,
  [SMALL_STATE(2937)] = 108083,
  [SMALL_STATE(2938)] = 108096,
  [SMALL_STATE(2939)] = 108109,
  [SMALL_STATE(2940)] = 108134,
  [SMALL_STATE(2941)] = 108155,
  [SMALL_STATE(2942)] = 108180,
  [SMALL_STATE(2943)] = 108201,
  [SMALL_STATE(2944)] = 108226,
  [SMALL_STATE(2945)] = 108251,
  [SMALL_STATE(2946)] = 108264,
  [SMALL_STATE(2947)] = 108286,
  [SMALL_STATE(2948)] = 108304,
  [SMALL_STATE(2949)] = 108322,
  [SMALL_STATE(2950)] = 108338,
  [SMALL_STATE(2951)] = 108360,
  [SMALL_STATE(2952)] = 108382,
  [SMALL_STATE(2953)] = 108404,
  [SMALL_STATE(2954)] = 108426,
  [SMALL_STATE(2955)] = 108448,
  [SMALL_STATE(2956)] = 108464,
  [SMALL_STATE(2957)] = 108480,
  [SMALL_STATE(2958)] = 108502,
  [SMALL_STATE(2959)] = 108524,
  [SMALL_STATE(2960)] = 108540,
  [SMALL_STATE(2961)] = 108562,
  [SMALL_STATE(2962)] = 108584,
  [SMALL_STATE(2963)] = 108602,
  [SMALL_STATE(2964)] = 108618,
  [SMALL_STATE(2965)] = 108634,
  [SMALL_STATE(2966)] = 108656,
  [SMALL_STATE(2967)] = 108672,
  [SMALL_STATE(2968)] = 108688,
  [SMALL_STATE(2969)] = 108706,
  [SMALL_STATE(2970)] = 108720,
  [SMALL_STATE(2971)] = 108742,
  [SMALL_STATE(2972)] = 108758,
  [SMALL_STATE(2973)] = 108774,
  [SMALL_STATE(2974)] = 108796,
  [SMALL_STATE(2975)] = 108818,
  [SMALL_STATE(2976)] = 108840,
  [SMALL_STATE(2977)] = 108856,
  [SMALL_STATE(2978)] = 108874,
  [SMALL_STATE(2979)] = 108892,
  [SMALL_STATE(2980)] = 108914,
  [SMALL_STATE(2981)] = 108936,
  [SMALL_STATE(2982)] = 108954,
  [SMALL_STATE(2983)] = 108976,
  [SMALL_STATE(2984)] = 108992,
  [SMALL_STATE(2985)] = 109014,
  [SMALL_STATE(2986)] = 109032,
  [SMALL_STATE(2987)] = 109048,
  [SMALL_STATE(2988)] = 109066,
  [SMALL_STATE(2989)] = 109086,
  [SMALL_STATE(2990)] = 109102,
  [SMALL_STATE(2991)] = 109120,
  [SMALL_STATE(2992)] = 109142,
  [SMALL_STATE(2993)] = 109164,
  [SMALL_STATE(2994)] = 109182,
  [SMALL_STATE(2995)] = 109194,
  [SMALL_STATE(2996)] = 109210,
  [SMALL_STATE(2997)] = 109222,
  [SMALL_STATE(2998)] = 109234,
  [SMALL_STATE(2999)] = 109250,
  [SMALL_STATE(3000)] = 109272,
  [SMALL_STATE(3001)] = 109294,
  [SMALL_STATE(3002)] = 109310,
  [SMALL_STATE(3003)] = 109330,
  [SMALL_STATE(3004)] = 109346,
  [SMALL_STATE(3005)] = 109368,
  [SMALL_STATE(3006)] = 109390,
  [SMALL_STATE(3007)] = 109408,
  [SMALL_STATE(3008)] = 109420,
  [SMALL_STATE(3009)] = 109432,
  [SMALL_STATE(3010)] = 109448,
  [SMALL_STATE(3011)] = 109468,
  [SMALL_STATE(3012)] = 109490,
  [SMALL_STATE(3013)] = 109506,
  [SMALL_STATE(3014)] = 109524,
  [SMALL_STATE(3015)] = 109542,
  [SMALL_STATE(3016)] = 109558,
  [SMALL_STATE(3017)] = 109574,
  [SMALL_STATE(3018)] = 109596,
  [SMALL_STATE(3019)] = 109618,
  [SMALL_STATE(3020)] = 109634,
  [SMALL_STATE(3021)] = 109656,
  [SMALL_STATE(3022)] = 109672,
  [SMALL_STATE(3023)] = 109688,
  [SMALL_STATE(3024)] = 109710,
  [SMALL_STATE(3025)] = 109722,
  [SMALL_STATE(3026)] = 109744,
  [SMALL_STATE(3027)] = 109762,
  [SMALL_STATE(3028)] = 109780,
  [SMALL_STATE(3029)] = 109796,
  [SMALL_STATE(3030)] = 109808,
  [SMALL_STATE(3031)] = 109824,
  [SMALL_STATE(3032)] = 109836,
  [SMALL_STATE(3033)] = 109858,
  [SMALL_STATE(3034)] = 109870,
  [SMALL_STATE(3035)] = 109886,
  [SMALL_STATE(3036)] = 109902,
  [SMALL_STATE(3037)] = 109924,
  [SMALL_STATE(3038)] = 109940,
  [SMALL_STATE(3039)] = 109956,
  [SMALL_STATE(3040)] = 109972,
  [SMALL_STATE(3041)] = 109988,
  [SMALL_STATE(3042)] = 110000,
  [SMALL_STATE(3043)] = 110018,
  [SMALL_STATE(3044)] = 110036,
  [SMALL_STATE(3045)] = 110052,
  [SMALL_STATE(3046)] = 110074,
  [SMALL_STATE(3047)] = 110092,
  [SMALL_STATE(3048)] = 110114,
  [SMALL_STATE(3049)] = 110136,
  [SMALL_STATE(3050)] = 110152,
  [SMALL_STATE(3051)] = 110164,
  [SMALL_STATE(3052)] = 110180,
  [SMALL_STATE(3053)] = 110202,
  [SMALL_STATE(3054)] = 110218,
  [SMALL_STATE(3055)] = 110240,
  [SMALL_STATE(3056)] = 110256,
  [SMALL_STATE(3057)] = 110272,
  [SMALL_STATE(3058)] = 110288,
  [SMALL_STATE(3059)] = 110304,
  [SMALL_STATE(3060)] = 110320,
  [SMALL_STATE(3061)] = 110342,
  [SMALL_STATE(3062)] = 110364,
  [SMALL_STATE(3063)] = 110386,
  [SMALL_STATE(3064)] = 110408,
  [SMALL_STATE(3065)] = 110426,
  [SMALL_STATE(3066)] = 110444,
  [SMALL_STATE(3067)] = 110460,
  [SMALL_STATE(3068)] = 110478,
  [SMALL_STATE(3069)] = 110496,
  [SMALL_STATE(3070)] = 110518,
  [SMALL_STATE(3071)] = 110534,
  [SMALL_STATE(3072)] = 110556,
  [SMALL_STATE(3073)] = 110572,
  [SMALL_STATE(3074)] = 110588,
  [SMALL_STATE(3075)] = 110610,
  [SMALL_STATE(3076)] = 110632,
  [SMALL_STATE(3077)] = 110646,
  [SMALL_STATE(3078)] = 110664,
  [SMALL_STATE(3079)] = 110678,
  [SMALL_STATE(3080)] = 110696,
  [SMALL_STATE(3081)] = 110712,
  [SMALL_STATE(3082)] = 110734,
  [SMALL_STATE(3083)] = 110752,
  [SMALL_STATE(3084)] = 110768,
  [SMALL_STATE(3085)] = 110786,
  [SMALL_STATE(3086)] = 110798,
  [SMALL_STATE(3087)] = 110812,
  [SMALL_STATE(3088)] = 110830,
  [SMALL_STATE(3089)] = 110848,
  [SMALL_STATE(3090)] = 110870,
  [SMALL_STATE(3091)] = 110886,
  [SMALL_STATE(3092)] = 110902,
  [SMALL_STATE(3093)] = 110924,
  [SMALL_STATE(3094)] = 110936,
  [SMALL_STATE(3095)] = 110958,
  [SMALL_STATE(3096)] = 110977,
  [SMALL_STATE(3097)] = 110996,
  [SMALL_STATE(3098)] = 111007,
  [SMALL_STATE(3099)] = 111024,
  [SMALL_STATE(3100)] = 111035,
  [SMALL_STATE(3101)] = 111052,
  [SMALL_STATE(3102)] = 111063,
  [SMALL_STATE(3103)] = 111082,
  [SMALL_STATE(3104)] = 111093,
  [SMALL_STATE(3105)] = 111112,
  [SMALL_STATE(3106)] = 111131,
  [SMALL_STATE(3107)] = 111148,
  [SMALL_STATE(3108)] = 111159,
  [SMALL_STATE(3109)] = 111178,
  [SMALL_STATE(3110)] = 111197,
  [SMALL_STATE(3111)] = 111208,
  [SMALL_STATE(3112)] = 111223,
  [SMALL_STATE(3113)] = 111242,
  [SMALL_STATE(3114)] = 111253,
  [SMALL_STATE(3115)] = 111264,
  [SMALL_STATE(3116)] = 111283,
  [SMALL_STATE(3117)] = 111294,
  [SMALL_STATE(3118)] = 111305,
  [SMALL_STATE(3119)] = 111316,
  [SMALL_STATE(3120)] = 111335,
  [SMALL_STATE(3121)] = 111354,
  [SMALL_STATE(3122)] = 111365,
  [SMALL_STATE(3123)] = 111384,
  [SMALL_STATE(3124)] = 111395,
  [SMALL_STATE(3125)] = 111406,
  [SMALL_STATE(3126)] = 111417,
  [SMALL_STATE(3127)] = 111428,
  [SMALL_STATE(3128)] = 111439,
  [SMALL_STATE(3129)] = 111450,
  [SMALL_STATE(3130)] = 111461,
  [SMALL_STATE(3131)] = 111472,
  [SMALL_STATE(3132)] = 111487,
  [SMALL_STATE(3133)] = 111502,
  [SMALL_STATE(3134)] = 111513,
  [SMALL_STATE(3135)] = 111524,
  [SMALL_STATE(3136)] = 111535,
  [SMALL_STATE(3137)] = 111550,
  [SMALL_STATE(3138)] = 111565,
  [SMALL_STATE(3139)] = 111576,
  [SMALL_STATE(3140)] = 111587,
  [SMALL_STATE(3141)] = 111598,
  [SMALL_STATE(3142)] = 111609,
  [SMALL_STATE(3143)] = 111620,
  [SMALL_STATE(3144)] = 111631,
  [SMALL_STATE(3145)] = 111642,
  [SMALL_STATE(3146)] = 111653,
  [SMALL_STATE(3147)] = 111664,
  [SMALL_STATE(3148)] = 111675,
  [SMALL_STATE(3149)] = 111694,
  [SMALL_STATE(3150)] = 111713,
  [SMALL_STATE(3151)] = 111724,
  [SMALL_STATE(3152)] = 111735,
  [SMALL_STATE(3153)] = 111746,
  [SMALL_STATE(3154)] = 111757,
  [SMALL_STATE(3155)] = 111768,
  [SMALL_STATE(3156)] = 111779,
  [SMALL_STATE(3157)] = 111790,
  [SMALL_STATE(3158)] = 111801,
  [SMALL_STATE(3159)] = 111812,
  [SMALL_STATE(3160)] = 111823,
  [SMALL_STATE(3161)] = 111834,
  [SMALL_STATE(3162)] = 111845,
  [SMALL_STATE(3163)] = 111862,
  [SMALL_STATE(3164)] = 111881,
  [SMALL_STATE(3165)] = 111894,
  [SMALL_STATE(3166)] = 111905,
  [SMALL_STATE(3167)] = 111916,
  [SMALL_STATE(3168)] = 111933,
  [SMALL_STATE(3169)] = 111948,
  [SMALL_STATE(3170)] = 111959,
  [SMALL_STATE(3171)] = 111978,
  [SMALL_STATE(3172)] = 111993,
  [SMALL_STATE(3173)] = 112004,
  [SMALL_STATE(3174)] = 112015,
  [SMALL_STATE(3175)] = 112034,
  [SMALL_STATE(3176)] = 112045,
  [SMALL_STATE(3177)] = 112064,
  [SMALL_STATE(3178)] = 112075,
  [SMALL_STATE(3179)] = 112092,
  [SMALL_STATE(3180)] = 112103,
  [SMALL_STATE(3181)] = 112122,
  [SMALL_STATE(3182)] = 112133,
  [SMALL_STATE(3183)] = 112152,
  [SMALL_STATE(3184)] = 112163,
  [SMALL_STATE(3185)] = 112178,
  [SMALL_STATE(3186)] = 112197,
  [SMALL_STATE(3187)] = 112216,
  [SMALL_STATE(3188)] = 112233,
  [SMALL_STATE(3189)] = 112244,
  [SMALL_STATE(3190)] = 112259,
  [SMALL_STATE(3191)] = 112270,
  [SMALL_STATE(3192)] = 112281,
  [SMALL_STATE(3193)] = 112292,
  [SMALL_STATE(3194)] = 112303,
  [SMALL_STATE(3195)] = 112314,
  [SMALL_STATE(3196)] = 112325,
  [SMALL_STATE(3197)] = 112336,
  [SMALL_STATE(3198)] = 112347,
  [SMALL_STATE(3199)] = 112358,
  [SMALL_STATE(3200)] = 112369,
  [SMALL_STATE(3201)] = 112380,
  [SMALL_STATE(3202)] = 112391,
  [SMALL_STATE(3203)] = 112402,
  [SMALL_STATE(3204)] = 112421,
  [SMALL_STATE(3205)] = 112436,
  [SMALL_STATE(3206)] = 112455,
  [SMALL_STATE(3207)] = 112466,
  [SMALL_STATE(3208)] = 112479,
  [SMALL_STATE(3209)] = 112492,
  [SMALL_STATE(3210)] = 112503,
  [SMALL_STATE(3211)] = 112514,
  [SMALL_STATE(3212)] = 112533,
  [SMALL_STATE(3213)] = 112544,
  [SMALL_STATE(3214)] = 112563,
  [SMALL_STATE(3215)] = 112578,
  [SMALL_STATE(3216)] = 112589,
  [SMALL_STATE(3217)] = 112604,
  [SMALL_STATE(3218)] = 112615,
  [SMALL_STATE(3219)] = 112626,
  [SMALL_STATE(3220)] = 112645,
  [SMALL_STATE(3221)] = 112656,
  [SMALL_STATE(3222)] = 112675,
  [SMALL_STATE(3223)] = 112686,
  [SMALL_STATE(3224)] = 112697,
  [SMALL_STATE(3225)] = 112708,
  [SMALL_STATE(3226)] = 112719,
  [SMALL_STATE(3227)] = 112730,
  [SMALL_STATE(3228)] = 112741,
  [SMALL_STATE(3229)] = 112758,
  [SMALL_STATE(3230)] = 112769,
  [SMALL_STATE(3231)] = 112788,
  [SMALL_STATE(3232)] = 112803,
  [SMALL_STATE(3233)] = 112816,
  [SMALL_STATE(3234)] = 112835,
  [SMALL_STATE(3235)] = 112854,
  [SMALL_STATE(3236)] = 112865,
  [SMALL_STATE(3237)] = 112884,
  [SMALL_STATE(3238)] = 112903,
  [SMALL_STATE(3239)] = 112920,
  [SMALL_STATE(3240)] = 112939,
  [SMALL_STATE(3241)] = 112954,
  [SMALL_STATE(3242)] = 112973,
  [SMALL_STATE(3243)] = 112984,
  [SMALL_STATE(3244)] = 112995,
  [SMALL_STATE(3245)] = 113006,
  [SMALL_STATE(3246)] = 113017,
  [SMALL_STATE(3247)] = 113028,
  [SMALL_STATE(3248)] = 113039,
  [SMALL_STATE(3249)] = 113054,
  [SMALL_STATE(3250)] = 113065,
  [SMALL_STATE(3251)] = 113084,
  [SMALL_STATE(3252)] = 113099,
  [SMALL_STATE(3253)] = 113110,
  [SMALL_STATE(3254)] = 113121,
  [SMALL_STATE(3255)] = 113132,
  [SMALL_STATE(3256)] = 113143,
  [SMALL_STATE(3257)] = 113154,
  [SMALL_STATE(3258)] = 113165,
  [SMALL_STATE(3259)] = 113176,
  [SMALL_STATE(3260)] = 113187,
  [SMALL_STATE(3261)] = 113206,
  [SMALL_STATE(3262)] = 113217,
  [SMALL_STATE(3263)] = 113236,
  [SMALL_STATE(3264)] = 113255,
  [SMALL_STATE(3265)] = 113274,
  [SMALL_STATE(3266)] = 113289,
  [SMALL_STATE(3267)] = 113308,
  [SMALL_STATE(3268)] = 113327,
  [SMALL_STATE(3269)] = 113338,
  [SMALL_STATE(3270)] = 113349,
  [SMALL_STATE(3271)] = 113360,
  [SMALL_STATE(3272)] = 113371,
  [SMALL_STATE(3273)] = 113390,
  [SMALL_STATE(3274)] = 113409,
  [SMALL_STATE(3275)] = 113420,
  [SMALL_STATE(3276)] = 113431,
  [SMALL_STATE(3277)] = 113450,
  [SMALL_STATE(3278)] = 113461,
  [SMALL_STATE(3279)] = 113480,
  [SMALL_STATE(3280)] = 113491,
  [SMALL_STATE(3281)] = 113502,
  [SMALL_STATE(3282)] = 113521,
  [SMALL_STATE(3283)] = 113540,
  [SMALL_STATE(3284)] = 113559,
  [SMALL_STATE(3285)] = 113570,
  [SMALL_STATE(3286)] = 113589,
  [SMALL_STATE(3287)] = 113604,
  [SMALL_STATE(3288)] = 113615,
  [SMALL_STATE(3289)] = 113632,
  [SMALL_STATE(3290)] = 113647,
  [SMALL_STATE(3291)] = 113658,
  [SMALL_STATE(3292)] = 113669,
  [SMALL_STATE(3293)] = 113680,
  [SMALL_STATE(3294)] = 113691,
  [SMALL_STATE(3295)] = 113708,
  [SMALL_STATE(3296)] = 113727,
  [SMALL_STATE(3297)] = 113738,
  [SMALL_STATE(3298)] = 113757,
  [SMALL_STATE(3299)] = 113776,
  [SMALL_STATE(3300)] = 113787,
  [SMALL_STATE(3301)] = 113806,
  [SMALL_STATE(3302)] = 113817,
  [SMALL_STATE(3303)] = 113828,
  [SMALL_STATE(3304)] = 113847,
  [SMALL_STATE(3305)] = 113864,
  [SMALL_STATE(3306)] = 113881,
  [SMALL_STATE(3307)] = 113892,
  [SMALL_STATE(3308)] = 113909,
  [SMALL_STATE(3309)] = 113920,
  [SMALL_STATE(3310)] = 113931,
  [SMALL_STATE(3311)] = 113942,
  [SMALL_STATE(3312)] = 113961,
  [SMALL_STATE(3313)] = 113978,
  [SMALL_STATE(3314)] = 113997,
  [SMALL_STATE(3315)] = 114014,
  [SMALL_STATE(3316)] = 114025,
  [SMALL_STATE(3317)] = 114036,
  [SMALL_STATE(3318)] = 114053,
  [SMALL_STATE(3319)] = 114068,
  [SMALL_STATE(3320)] = 114083,
  [SMALL_STATE(3321)] = 114094,
  [SMALL_STATE(3322)] = 114113,
  [SMALL_STATE(3323)] = 114124,
  [SMALL_STATE(3324)] = 114141,
  [SMALL_STATE(3325)] = 114152,
  [SMALL_STATE(3326)] = 114171,
  [SMALL_STATE(3327)] = 114182,
  [SMALL_STATE(3328)] = 114201,
  [SMALL_STATE(3329)] = 114220,
  [SMALL_STATE(3330)] = 114239,
  [SMALL_STATE(3331)] = 114250,
  [SMALL_STATE(3332)] = 114267,
  [SMALL_STATE(3333)] = 114278,
  [SMALL_STATE(3334)] = 114297,
  [SMALL_STATE(3335)] = 114312,
  [SMALL_STATE(3336)] = 114327,
  [SMALL_STATE(3337)] = 114346,
  [SMALL_STATE(3338)] = 114365,
  [SMALL_STATE(3339)] = 114384,
  [SMALL_STATE(3340)] = 114403,
  [SMALL_STATE(3341)] = 114418,
  [SMALL_STATE(3342)] = 114435,
  [SMALL_STATE(3343)] = 114454,
  [SMALL_STATE(3344)] = 114467,
  [SMALL_STATE(3345)] = 114482,
  [SMALL_STATE(3346)] = 114501,
  [SMALL_STATE(3347)] = 114518,
  [SMALL_STATE(3348)] = 114529,
  [SMALL_STATE(3349)] = 114548,
  [SMALL_STATE(3350)] = 114559,
  [SMALL_STATE(3351)] = 114570,
  [SMALL_STATE(3352)] = 114581,
  [SMALL_STATE(3353)] = 114598,
  [SMALL_STATE(3354)] = 114613,
  [SMALL_STATE(3355)] = 114624,
  [SMALL_STATE(3356)] = 114635,
  [SMALL_STATE(3357)] = 114654,
  [SMALL_STATE(3358)] = 114673,
  [SMALL_STATE(3359)] = 114690,
  [SMALL_STATE(3360)] = 114705,
  [SMALL_STATE(3361)] = 114722,
  [SMALL_STATE(3362)] = 114741,
  [SMALL_STATE(3363)] = 114752,
  [SMALL_STATE(3364)] = 114763,
  [SMALL_STATE(3365)] = 114782,
  [SMALL_STATE(3366)] = 114801,
  [SMALL_STATE(3367)] = 114812,
  [SMALL_STATE(3368)] = 114831,
  [SMALL_STATE(3369)] = 114842,
  [SMALL_STATE(3370)] = 114853,
  [SMALL_STATE(3371)] = 114872,
  [SMALL_STATE(3372)] = 114886,
  [SMALL_STATE(3373)] = 114902,
  [SMALL_STATE(3374)] = 114916,
  [SMALL_STATE(3375)] = 114930,
  [SMALL_STATE(3376)] = 114946,
  [SMALL_STATE(3377)] = 114962,
  [SMALL_STATE(3378)] = 114978,
  [SMALL_STATE(3379)] = 114994,
  [SMALL_STATE(3380)] = 115010,
  [SMALL_STATE(3381)] = 115024,
  [SMALL_STATE(3382)] = 115040,
  [SMALL_STATE(3383)] = 115054,
  [SMALL_STATE(3384)] = 115068,
  [SMALL_STATE(3385)] = 115084,
  [SMALL_STATE(3386)] = 115100,
  [SMALL_STATE(3387)] = 115116,
  [SMALL_STATE(3388)] = 115130,
  [SMALL_STATE(3389)] = 115144,
  [SMALL_STATE(3390)] = 115158,
  [SMALL_STATE(3391)] = 115174,
  [SMALL_STATE(3392)] = 115188,
  [SMALL_STATE(3393)] = 115204,
  [SMALL_STATE(3394)] = 115218,
  [SMALL_STATE(3395)] = 115234,
  [SMALL_STATE(3396)] = 115250,
  [SMALL_STATE(3397)] = 115264,
  [SMALL_STATE(3398)] = 115278,
  [SMALL_STATE(3399)] = 115292,
  [SMALL_STATE(3400)] = 115306,
  [SMALL_STATE(3401)] = 115322,
  [SMALL_STATE(3402)] = 115336,
  [SMALL_STATE(3403)] = 115352,
  [SMALL_STATE(3404)] = 115368,
  [SMALL_STATE(3405)] = 115382,
  [SMALL_STATE(3406)] = 115398,
  [SMALL_STATE(3407)] = 115412,
  [SMALL_STATE(3408)] = 115426,
  [SMALL_STATE(3409)] = 115442,
  [SMALL_STATE(3410)] = 115456,
  [SMALL_STATE(3411)] = 115470,
  [SMALL_STATE(3412)] = 115480,
  [SMALL_STATE(3413)] = 115494,
  [SMALL_STATE(3414)] = 115510,
  [SMALL_STATE(3415)] = 115524,
  [SMALL_STATE(3416)] = 115538,
  [SMALL_STATE(3417)] = 115554,
  [SMALL_STATE(3418)] = 115570,
  [SMALL_STATE(3419)] = 115586,
  [SMALL_STATE(3420)] = 115602,
  [SMALL_STATE(3421)] = 115618,
  [SMALL_STATE(3422)] = 115632,
  [SMALL_STATE(3423)] = 115648,
  [SMALL_STATE(3424)] = 115664,
  [SMALL_STATE(3425)] = 115680,
  [SMALL_STATE(3426)] = 115694,
  [SMALL_STATE(3427)] = 115708,
  [SMALL_STATE(3428)] = 115724,
  [SMALL_STATE(3429)] = 115740,
  [SMALL_STATE(3430)] = 115756,
  [SMALL_STATE(3431)] = 115770,
  [SMALL_STATE(3432)] = 115784,
  [SMALL_STATE(3433)] = 115798,
  [SMALL_STATE(3434)] = 115814,
  [SMALL_STATE(3435)] = 115830,
  [SMALL_STATE(3436)] = 115846,
  [SMALL_STATE(3437)] = 115862,
  [SMALL_STATE(3438)] = 115876,
  [SMALL_STATE(3439)] = 115890,
  [SMALL_STATE(3440)] = 115906,
  [SMALL_STATE(3441)] = 115920,
  [SMALL_STATE(3442)] = 115936,
  [SMALL_STATE(3443)] = 115950,
  [SMALL_STATE(3444)] = 115964,
  [SMALL_STATE(3445)] = 115980,
  [SMALL_STATE(3446)] = 115996,
  [SMALL_STATE(3447)] = 116010,
  [SMALL_STATE(3448)] = 116022,
  [SMALL_STATE(3449)] = 116034,
  [SMALL_STATE(3450)] = 116050,
  [SMALL_STATE(3451)] = 116064,
  [SMALL_STATE(3452)] = 116080,
  [SMALL_STATE(3453)] = 116096,
  [SMALL_STATE(3454)] = 116112,
  [SMALL_STATE(3455)] = 116122,
  [SMALL_STATE(3456)] = 116138,
  [SMALL_STATE(3457)] = 116154,
  [SMALL_STATE(3458)] = 116170,
  [SMALL_STATE(3459)] = 116184,
  [SMALL_STATE(3460)] = 116200,
  [SMALL_STATE(3461)] = 116214,
  [SMALL_STATE(3462)] = 116228,
  [SMALL_STATE(3463)] = 116244,
  [SMALL_STATE(3464)] = 116260,
  [SMALL_STATE(3465)] = 116274,
  [SMALL_STATE(3466)] = 116284,
  [SMALL_STATE(3467)] = 116300,
  [SMALL_STATE(3468)] = 116316,
  [SMALL_STATE(3469)] = 116332,
  [SMALL_STATE(3470)] = 116348,
  [SMALL_STATE(3471)] = 116364,
  [SMALL_STATE(3472)] = 116380,
  [SMALL_STATE(3473)] = 116396,
  [SMALL_STATE(3474)] = 116412,
  [SMALL_STATE(3475)] = 116428,
  [SMALL_STATE(3476)] = 116444,
  [SMALL_STATE(3477)] = 116458,
  [SMALL_STATE(3478)] = 116472,
  [SMALL_STATE(3479)] = 116486,
  [SMALL_STATE(3480)] = 116500,
  [SMALL_STATE(3481)] = 116516,
  [SMALL_STATE(3482)] = 116532,
  [SMALL_STATE(3483)] = 116548,
  [SMALL_STATE(3484)] = 116562,
  [SMALL_STATE(3485)] = 116576,
  [SMALL_STATE(3486)] = 116590,
  [SMALL_STATE(3487)] = 116604,
  [SMALL_STATE(3488)] = 116620,
  [SMALL_STATE(3489)] = 116636,
  [SMALL_STATE(3490)] = 116650,
  [SMALL_STATE(3491)] = 116664,
  [SMALL_STATE(3492)] = 116680,
  [SMALL_STATE(3493)] = 116694,
  [SMALL_STATE(3494)] = 116710,
  [SMALL_STATE(3495)] = 116724,
  [SMALL_STATE(3496)] = 116738,
  [SMALL_STATE(3497)] = 116752,
  [SMALL_STATE(3498)] = 116766,
  [SMALL_STATE(3499)] = 116782,
  [SMALL_STATE(3500)] = 116796,
  [SMALL_STATE(3501)] = 116812,
  [SMALL_STATE(3502)] = 116826,
  [SMALL_STATE(3503)] = 116842,
  [SMALL_STATE(3504)] = 116855,
  [SMALL_STATE(3505)] = 116868,
  [SMALL_STATE(3506)] = 116877,
  [SMALL_STATE(3507)] = 116888,
  [SMALL_STATE(3508)] = 116901,
  [SMALL_STATE(3509)] = 116914,
  [SMALL_STATE(3510)] = 116927,
  [SMALL_STATE(3511)] = 116940,
  [SMALL_STATE(3512)] = 116953,
  [SMALL_STATE(3513)] = 116966,
  [SMALL_STATE(3514)] = 116977,
  [SMALL_STATE(3515)] = 116988,
  [SMALL_STATE(3516)] = 117001,
  [SMALL_STATE(3517)] = 117012,
  [SMALL_STATE(3518)] = 117021,
  [SMALL_STATE(3519)] = 117034,
  [SMALL_STATE(3520)] = 117047,
  [SMALL_STATE(3521)] = 117060,
  [SMALL_STATE(3522)] = 117073,
  [SMALL_STATE(3523)] = 117082,
  [SMALL_STATE(3524)] = 117095,
  [SMALL_STATE(3525)] = 117106,
  [SMALL_STATE(3526)] = 117119,
  [SMALL_STATE(3527)] = 117132,
  [SMALL_STATE(3528)] = 117145,
  [SMALL_STATE(3529)] = 117158,
  [SMALL_STATE(3530)] = 117171,
  [SMALL_STATE(3531)] = 117184,
  [SMALL_STATE(3532)] = 117195,
  [SMALL_STATE(3533)] = 117206,
  [SMALL_STATE(3534)] = 117217,
  [SMALL_STATE(3535)] = 117226,
  [SMALL_STATE(3536)] = 117235,
  [SMALL_STATE(3537)] = 117244,
  [SMALL_STATE(3538)] = 117253,
  [SMALL_STATE(3539)] = 117262,
  [SMALL_STATE(3540)] = 117275,
  [SMALL_STATE(3541)] = 117288,
  [SMALL_STATE(3542)] = 117301,
  [SMALL_STATE(3543)] = 117314,
  [SMALL_STATE(3544)] = 117327,
  [SMALL_STATE(3545)] = 117340,
  [SMALL_STATE(3546)] = 117353,
  [SMALL_STATE(3547)] = 117364,
  [SMALL_STATE(3548)] = 117373,
  [SMALL_STATE(3549)] = 117386,
  [SMALL_STATE(3550)] = 117395,
  [SMALL_STATE(3551)] = 117404,
  [SMALL_STATE(3552)] = 117413,
  [SMALL_STATE(3553)] = 117426,
  [SMALL_STATE(3554)] = 117435,
  [SMALL_STATE(3555)] = 117448,
  [SMALL_STATE(3556)] = 117459,
  [SMALL_STATE(3557)] = 117468,
  [SMALL_STATE(3558)] = 117481,
  [SMALL_STATE(3559)] = 117490,
  [SMALL_STATE(3560)] = 117503,
  [SMALL_STATE(3561)] = 117516,
  [SMALL_STATE(3562)] = 117529,
  [SMALL_STATE(3563)] = 117542,
  [SMALL_STATE(3564)] = 117555,
  [SMALL_STATE(3565)] = 117564,
  [SMALL_STATE(3566)] = 117577,
  [SMALL_STATE(3567)] = 117586,
  [SMALL_STATE(3568)] = 117599,
  [SMALL_STATE(3569)] = 117612,
  [SMALL_STATE(3570)] = 117625,
  [SMALL_STATE(3571)] = 117634,
  [SMALL_STATE(3572)] = 117643,
  [SMALL_STATE(3573)] = 117656,
  [SMALL_STATE(3574)] = 117669,
  [SMALL_STATE(3575)] = 117682,
  [SMALL_STATE(3576)] = 117691,
  [SMALL_STATE(3577)] = 117704,
  [SMALL_STATE(3578)] = 117717,
  [SMALL_STATE(3579)] = 117730,
  [SMALL_STATE(3580)] = 117739,
  [SMALL_STATE(3581)] = 117752,
  [SMALL_STATE(3582)] = 117765,
  [SMALL_STATE(3583)] = 117778,
  [SMALL_STATE(3584)] = 117791,
  [SMALL_STATE(3585)] = 117804,
  [SMALL_STATE(3586)] = 117813,
  [SMALL_STATE(3587)] = 117826,
  [SMALL_STATE(3588)] = 117839,
  [SMALL_STATE(3589)] = 117850,
  [SMALL_STATE(3590)] = 117863,
  [SMALL_STATE(3591)] = 117876,
  [SMALL_STATE(3592)] = 117889,
  [SMALL_STATE(3593)] = 117902,
  [SMALL_STATE(3594)] = 117915,
  [SMALL_STATE(3595)] = 117924,
  [SMALL_STATE(3596)] = 117937,
  [SMALL_STATE(3597)] = 117950,
  [SMALL_STATE(3598)] = 117963,
  [SMALL_STATE(3599)] = 117972,
  [SMALL_STATE(3600)] = 117985,
  [SMALL_STATE(3601)] = 117998,
  [SMALL_STATE(3602)] = 118011,
  [SMALL_STATE(3603)] = 118024,
  [SMALL_STATE(3604)] = 118033,
  [SMALL_STATE(3605)] = 118046,
  [SMALL_STATE(3606)] = 118059,
  [SMALL_STATE(3607)] = 118072,
  [SMALL_STATE(3608)] = 118085,
  [SMALL_STATE(3609)] = 118096,
  [SMALL_STATE(3610)] = 118109,
  [SMALL_STATE(3611)] = 118122,
  [SMALL_STATE(3612)] = 118135,
  [SMALL_STATE(3613)] = 118144,
  [SMALL_STATE(3614)] = 118157,
  [SMALL_STATE(3615)] = 118166,
  [SMALL_STATE(3616)] = 118175,
  [SMALL_STATE(3617)] = 118184,
  [SMALL_STATE(3618)] = 118195,
  [SMALL_STATE(3619)] = 118204,
  [SMALL_STATE(3620)] = 118217,
  [SMALL_STATE(3621)] = 118226,
  [SMALL_STATE(3622)] = 118239,
  [SMALL_STATE(3623)] = 118248,
  [SMALL_STATE(3624)] = 118261,
  [SMALL_STATE(3625)] = 118274,
  [SMALL_STATE(3626)] = 118287,
  [SMALL_STATE(3627)] = 118300,
  [SMALL_STATE(3628)] = 118313,
  [SMALL_STATE(3629)] = 118322,
  [SMALL_STATE(3630)] = 118335,
  [SMALL_STATE(3631)] = 118348,
  [SMALL_STATE(3632)] = 118357,
  [SMALL_STATE(3633)] = 118370,
  [SMALL_STATE(3634)] = 118379,
  [SMALL_STATE(3635)] = 118388,
  [SMALL_STATE(3636)] = 118397,
  [SMALL_STATE(3637)] = 118410,
  [SMALL_STATE(3638)] = 118423,
  [SMALL_STATE(3639)] = 118432,
  [SMALL_STATE(3640)] = 118441,
  [SMALL_STATE(3641)] = 118454,
  [SMALL_STATE(3642)] = 118463,
  [SMALL_STATE(3643)] = 118476,
  [SMALL_STATE(3644)] = 118485,
  [SMALL_STATE(3645)] = 118494,
  [SMALL_STATE(3646)] = 118507,
  [SMALL_STATE(3647)] = 118516,
  [SMALL_STATE(3648)] = 118529,
  [SMALL_STATE(3649)] = 118538,
  [SMALL_STATE(3650)] = 118551,
  [SMALL_STATE(3651)] = 118564,
  [SMALL_STATE(3652)] = 118577,
  [SMALL_STATE(3653)] = 118590,
  [SMALL_STATE(3654)] = 118601,
  [SMALL_STATE(3655)] = 118612,
  [SMALL_STATE(3656)] = 118621,
  [SMALL_STATE(3657)] = 118634,
  [SMALL_STATE(3658)] = 118647,
  [SMALL_STATE(3659)] = 118658,
  [SMALL_STATE(3660)] = 118671,
  [SMALL_STATE(3661)] = 118684,
  [SMALL_STATE(3662)] = 118697,
  [SMALL_STATE(3663)] = 118710,
  [SMALL_STATE(3664)] = 118723,
  [SMALL_STATE(3665)] = 118734,
  [SMALL_STATE(3666)] = 118745,
  [SMALL_STATE(3667)] = 118758,
  [SMALL_STATE(3668)] = 118771,
  [SMALL_STATE(3669)] = 118784,
  [SMALL_STATE(3670)] = 118797,
  [SMALL_STATE(3671)] = 118810,
  [SMALL_STATE(3672)] = 118823,
  [SMALL_STATE(3673)] = 118836,
  [SMALL_STATE(3674)] = 118849,
  [SMALL_STATE(3675)] = 118862,
  [SMALL_STATE(3676)] = 118875,
  [SMALL_STATE(3677)] = 118888,
  [SMALL_STATE(3678)] = 118901,
  [SMALL_STATE(3679)] = 118914,
  [SMALL_STATE(3680)] = 118927,
  [SMALL_STATE(3681)] = 118940,
  [SMALL_STATE(3682)] = 118953,
  [SMALL_STATE(3683)] = 118962,
  [SMALL_STATE(3684)] = 118975,
  [SMALL_STATE(3685)] = 118984,
  [SMALL_STATE(3686)] = 118993,
  [SMALL_STATE(3687)] = 119006,
  [SMALL_STATE(3688)] = 119017,
  [SMALL_STATE(3689)] = 119030,
  [SMALL_STATE(3690)] = 119043,
  [SMALL_STATE(3691)] = 119056,
  [SMALL_STATE(3692)] = 119069,
  [SMALL_STATE(3693)] = 119082,
  [SMALL_STATE(3694)] = 119091,
  [SMALL_STATE(3695)] = 119100,
  [SMALL_STATE(3696)] = 119109,
  [SMALL_STATE(3697)] = 119118,
  [SMALL_STATE(3698)] = 119127,
  [SMALL_STATE(3699)] = 119136,
  [SMALL_STATE(3700)] = 119149,
  [SMALL_STATE(3701)] = 119158,
  [SMALL_STATE(3702)] = 119171,
  [SMALL_STATE(3703)] = 119180,
  [SMALL_STATE(3704)] = 119189,
  [SMALL_STATE(3705)] = 119198,
  [SMALL_STATE(3706)] = 119211,
  [SMALL_STATE(3707)] = 119224,
  [SMALL_STATE(3708)] = 119237,
  [SMALL_STATE(3709)] = 119250,
  [SMALL_STATE(3710)] = 119261,
  [SMALL_STATE(3711)] = 119270,
  [SMALL_STATE(3712)] = 119283,
  [SMALL_STATE(3713)] = 119296,
  [SMALL_STATE(3714)] = 119309,
  [SMALL_STATE(3715)] = 119320,
  [SMALL_STATE(3716)] = 119333,
  [SMALL_STATE(3717)] = 119346,
  [SMALL_STATE(3718)] = 119359,
  [SMALL_STATE(3719)] = 119372,
  [SMALL_STATE(3720)] = 119385,
  [SMALL_STATE(3721)] = 119394,
  [SMALL_STATE(3722)] = 119405,
  [SMALL_STATE(3723)] = 119418,
  [SMALL_STATE(3724)] = 119427,
  [SMALL_STATE(3725)] = 119440,
  [SMALL_STATE(3726)] = 119453,
  [SMALL_STATE(3727)] = 119466,
  [SMALL_STATE(3728)] = 119475,
  [SMALL_STATE(3729)] = 119488,
  [SMALL_STATE(3730)] = 119501,
  [SMALL_STATE(3731)] = 119514,
  [SMALL_STATE(3732)] = 119525,
  [SMALL_STATE(3733)] = 119534,
  [SMALL_STATE(3734)] = 119543,
  [SMALL_STATE(3735)] = 119553,
  [SMALL_STATE(3736)] = 119561,
  [SMALL_STATE(3737)] = 119569,
  [SMALL_STATE(3738)] = 119579,
  [SMALL_STATE(3739)] = 119589,
  [SMALL_STATE(3740)] = 119599,
  [SMALL_STATE(3741)] = 119609,
  [SMALL_STATE(3742)] = 119617,
  [SMALL_STATE(3743)] = 119627,
  [SMALL_STATE(3744)] = 119637,
  [SMALL_STATE(3745)] = 119647,
  [SMALL_STATE(3746)] = 119657,
  [SMALL_STATE(3747)] = 119665,
  [SMALL_STATE(3748)] = 119675,
  [SMALL_STATE(3749)] = 119685,
  [SMALL_STATE(3750)] = 119695,
  [SMALL_STATE(3751)] = 119705,
  [SMALL_STATE(3752)] = 119715,
  [SMALL_STATE(3753)] = 119725,
  [SMALL_STATE(3754)] = 119735,
  [SMALL_STATE(3755)] = 119745,
  [SMALL_STATE(3756)] = 119755,
  [SMALL_STATE(3757)] = 119763,
  [SMALL_STATE(3758)] = 119773,
  [SMALL_STATE(3759)] = 119781,
  [SMALL_STATE(3760)] = 119791,
  [SMALL_STATE(3761)] = 119801,
  [SMALL_STATE(3762)] = 119811,
  [SMALL_STATE(3763)] = 119821,
  [SMALL_STATE(3764)] = 119829,
  [SMALL_STATE(3765)] = 119839,
  [SMALL_STATE(3766)] = 119849,
  [SMALL_STATE(3767)] = 119859,
  [SMALL_STATE(3768)] = 119869,
  [SMALL_STATE(3769)] = 119879,
  [SMALL_STATE(3770)] = 119889,
  [SMALL_STATE(3771)] = 119897,
  [SMALL_STATE(3772)] = 119905,
  [SMALL_STATE(3773)] = 119913,
  [SMALL_STATE(3774)] = 119923,
  [SMALL_STATE(3775)] = 119933,
  [SMALL_STATE(3776)] = 119943,
  [SMALL_STATE(3777)] = 119953,
  [SMALL_STATE(3778)] = 119961,
  [SMALL_STATE(3779)] = 119971,
  [SMALL_STATE(3780)] = 119981,
  [SMALL_STATE(3781)] = 119991,
  [SMALL_STATE(3782)] = 119999,
  [SMALL_STATE(3783)] = 120009,
  [SMALL_STATE(3784)] = 120019,
  [SMALL_STATE(3785)] = 120029,
  [SMALL_STATE(3786)] = 120039,
  [SMALL_STATE(3787)] = 120049,
  [SMALL_STATE(3788)] = 120059,
  [SMALL_STATE(3789)] = 120069,
  [SMALL_STATE(3790)] = 120079,
  [SMALL_STATE(3791)] = 120089,
  [SMALL_STATE(3792)] = 120099,
  [SMALL_STATE(3793)] = 120107,
  [SMALL_STATE(3794)] = 120117,
  [SMALL_STATE(3795)] = 120127,
  [SMALL_STATE(3796)] = 120137,
  [SMALL_STATE(3797)] = 120147,
  [SMALL_STATE(3798)] = 120157,
  [SMALL_STATE(3799)] = 120167,
  [SMALL_STATE(3800)] = 120177,
  [SMALL_STATE(3801)] = 120187,
  [SMALL_STATE(3802)] = 120197,
  [SMALL_STATE(3803)] = 120207,
  [SMALL_STATE(3804)] = 120217,
  [SMALL_STATE(3805)] = 120225,
  [SMALL_STATE(3806)] = 120235,
  [SMALL_STATE(3807)] = 120245,
  [SMALL_STATE(3808)] = 120253,
  [SMALL_STATE(3809)] = 120261,
  [SMALL_STATE(3810)] = 120271,
  [SMALL_STATE(3811)] = 120281,
  [SMALL_STATE(3812)] = 120289,
  [SMALL_STATE(3813)] = 120299,
  [SMALL_STATE(3814)] = 120309,
  [SMALL_STATE(3815)] = 120319,
  [SMALL_STATE(3816)] = 120329,
  [SMALL_STATE(3817)] = 120339,
  [SMALL_STATE(3818)] = 120349,
  [SMALL_STATE(3819)] = 120359,
  [SMALL_STATE(3820)] = 120367,
  [SMALL_STATE(3821)] = 120377,
  [SMALL_STATE(3822)] = 120387,
  [SMALL_STATE(3823)] = 120397,
  [SMALL_STATE(3824)] = 120407,
  [SMALL_STATE(3825)] = 120415,
  [SMALL_STATE(3826)] = 120425,
  [SMALL_STATE(3827)] = 120435,
  [SMALL_STATE(3828)] = 120445,
  [SMALL_STATE(3829)] = 120453,
  [SMALL_STATE(3830)] = 120463,
  [SMALL_STATE(3831)] = 120473,
  [SMALL_STATE(3832)] = 120483,
  [SMALL_STATE(3833)] = 120493,
  [SMALL_STATE(3834)] = 120503,
  [SMALL_STATE(3835)] = 120513,
  [SMALL_STATE(3836)] = 120523,
  [SMALL_STATE(3837)] = 120533,
  [SMALL_STATE(3838)] = 120543,
  [SMALL_STATE(3839)] = 120553,
  [SMALL_STATE(3840)] = 120563,
  [SMALL_STATE(3841)] = 120573,
  [SMALL_STATE(3842)] = 120581,
  [SMALL_STATE(3843)] = 120591,
  [SMALL_STATE(3844)] = 120601,
  [SMALL_STATE(3845)] = 120609,
  [SMALL_STATE(3846)] = 120617,
  [SMALL_STATE(3847)] = 120627,
  [SMALL_STATE(3848)] = 120635,
  [SMALL_STATE(3849)] = 120643,
  [SMALL_STATE(3850)] = 120653,
  [SMALL_STATE(3851)] = 120663,
  [SMALL_STATE(3852)] = 120673,
  [SMALL_STATE(3853)] = 120683,
  [SMALL_STATE(3854)] = 120693,
  [SMALL_STATE(3855)] = 120703,
  [SMALL_STATE(3856)] = 120713,
  [SMALL_STATE(3857)] = 120723,
  [SMALL_STATE(3858)] = 120733,
  [SMALL_STATE(3859)] = 120743,
  [SMALL_STATE(3860)] = 120751,
  [SMALL_STATE(3861)] = 120761,
  [SMALL_STATE(3862)] = 120769,
  [SMALL_STATE(3863)] = 120779,
  [SMALL_STATE(3864)] = 120789,
  [SMALL_STATE(3865)] = 120797,
  [SMALL_STATE(3866)] = 120807,
  [SMALL_STATE(3867)] = 120817,
  [SMALL_STATE(3868)] = 120825,
  [SMALL_STATE(3869)] = 120835,
  [SMALL_STATE(3870)] = 120845,
  [SMALL_STATE(3871)] = 120853,
  [SMALL_STATE(3872)] = 120861,
  [SMALL_STATE(3873)] = 120871,
  [SMALL_STATE(3874)] = 120881,
  [SMALL_STATE(3875)] = 120889,
  [SMALL_STATE(3876)] = 120899,
  [SMALL_STATE(3877)] = 120909,
  [SMALL_STATE(3878)] = 120917,
  [SMALL_STATE(3879)] = 120925,
  [SMALL_STATE(3880)] = 120935,
  [SMALL_STATE(3881)] = 120945,
  [SMALL_STATE(3882)] = 120955,
  [SMALL_STATE(3883)] = 120963,
  [SMALL_STATE(3884)] = 120973,
  [SMALL_STATE(3885)] = 120983,
  [SMALL_STATE(3886)] = 120993,
  [SMALL_STATE(3887)] = 121001,
  [SMALL_STATE(3888)] = 121011,
  [SMALL_STATE(3889)] = 121021,
  [SMALL_STATE(3890)] = 121029,
  [SMALL_STATE(3891)] = 121039,
  [SMALL_STATE(3892)] = 121049,
  [SMALL_STATE(3893)] = 121059,
  [SMALL_STATE(3894)] = 121067,
  [SMALL_STATE(3895)] = 121075,
  [SMALL_STATE(3896)] = 121083,
  [SMALL_STATE(3897)] = 121093,
  [SMALL_STATE(3898)] = 121103,
  [SMALL_STATE(3899)] = 121111,
  [SMALL_STATE(3900)] = 121121,
  [SMALL_STATE(3901)] = 121131,
  [SMALL_STATE(3902)] = 121141,
  [SMALL_STATE(3903)] = 121151,
  [SMALL_STATE(3904)] = 121161,
  [SMALL_STATE(3905)] = 121169,
  [SMALL_STATE(3906)] = 121179,
  [SMALL_STATE(3907)] = 121189,
  [SMALL_STATE(3908)] = 121199,
  [SMALL_STATE(3909)] = 121209,
  [SMALL_STATE(3910)] = 121217,
  [SMALL_STATE(3911)] = 121227,
  [SMALL_STATE(3912)] = 121237,
  [SMALL_STATE(3913)] = 121247,
  [SMALL_STATE(3914)] = 121255,
  [SMALL_STATE(3915)] = 121265,
  [SMALL_STATE(3916)] = 121273,
  [SMALL_STATE(3917)] = 121281,
  [SMALL_STATE(3918)] = 121291,
  [SMALL_STATE(3919)] = 121299,
  [SMALL_STATE(3920)] = 121307,
  [SMALL_STATE(3921)] = 121317,
  [SMALL_STATE(3922)] = 121325,
  [SMALL_STATE(3923)] = 121335,
  [SMALL_STATE(3924)] = 121345,
  [SMALL_STATE(3925)] = 121353,
  [SMALL_STATE(3926)] = 121361,
  [SMALL_STATE(3927)] = 121371,
  [SMALL_STATE(3928)] = 121379,
  [SMALL_STATE(3929)] = 121387,
  [SMALL_STATE(3930)] = 121397,
  [SMALL_STATE(3931)] = 121405,
  [SMALL_STATE(3932)] = 121415,
  [SMALL_STATE(3933)] = 121425,
  [SMALL_STATE(3934)] = 121435,
  [SMALL_STATE(3935)] = 121445,
  [SMALL_STATE(3936)] = 121455,
  [SMALL_STATE(3937)] = 121465,
  [SMALL_STATE(3938)] = 121473,
  [SMALL_STATE(3939)] = 121483,
  [SMALL_STATE(3940)] = 121493,
  [SMALL_STATE(3941)] = 121501,
  [SMALL_STATE(3942)] = 121511,
  [SMALL_STATE(3943)] = 121521,
  [SMALL_STATE(3944)] = 121529,
  [SMALL_STATE(3945)] = 121537,
  [SMALL_STATE(3946)] = 121547,
  [SMALL_STATE(3947)] = 121555,
  [SMALL_STATE(3948)] = 121563,
  [SMALL_STATE(3949)] = 121573,
  [SMALL_STATE(3950)] = 121581,
  [SMALL_STATE(3951)] = 121591,
  [SMALL_STATE(3952)] = 121599,
  [SMALL_STATE(3953)] = 121607,
  [SMALL_STATE(3954)] = 121615,
  [SMALL_STATE(3955)] = 121623,
  [SMALL_STATE(3956)] = 121633,
  [SMALL_STATE(3957)] = 121643,
  [SMALL_STATE(3958)] = 121651,
  [SMALL_STATE(3959)] = 121661,
  [SMALL_STATE(3960)] = 121669,
  [SMALL_STATE(3961)] = 121679,
  [SMALL_STATE(3962)] = 121689,
  [SMALL_STATE(3963)] = 121699,
  [SMALL_STATE(3964)] = 121709,
  [SMALL_STATE(3965)] = 121719,
  [SMALL_STATE(3966)] = 121729,
  [SMALL_STATE(3967)] = 121739,
  [SMALL_STATE(3968)] = 121747,
  [SMALL_STATE(3969)] = 121757,
  [SMALL_STATE(3970)] = 121767,
  [SMALL_STATE(3971)] = 121777,
  [SMALL_STATE(3972)] = 121787,
  [SMALL_STATE(3973)] = 121797,
  [SMALL_STATE(3974)] = 121807,
  [SMALL_STATE(3975)] = 121815,
  [SMALL_STATE(3976)] = 121825,
  [SMALL_STATE(3977)] = 121835,
  [SMALL_STATE(3978)] = 121845,
  [SMALL_STATE(3979)] = 121855,
  [SMALL_STATE(3980)] = 121865,
  [SMALL_STATE(3981)] = 121873,
  [SMALL_STATE(3982)] = 121881,
  [SMALL_STATE(3983)] = 121891,
  [SMALL_STATE(3984)] = 121899,
  [SMALL_STATE(3985)] = 121909,
  [SMALL_STATE(3986)] = 121917,
  [SMALL_STATE(3987)] = 121925,
  [SMALL_STATE(3988)] = 121933,
  [SMALL_STATE(3989)] = 121943,
  [SMALL_STATE(3990)] = 121953,
  [SMALL_STATE(3991)] = 121963,
  [SMALL_STATE(3992)] = 121971,
  [SMALL_STATE(3993)] = 121981,
  [SMALL_STATE(3994)] = 121991,
  [SMALL_STATE(3995)] = 122001,
  [SMALL_STATE(3996)] = 122011,
  [SMALL_STATE(3997)] = 122021,
  [SMALL_STATE(3998)] = 122028,
  [SMALL_STATE(3999)] = 122035,
  [SMALL_STATE(4000)] = 122042,
  [SMALL_STATE(4001)] = 122049,
  [SMALL_STATE(4002)] = 122056,
  [SMALL_STATE(4003)] = 122063,
  [SMALL_STATE(4004)] = 122070,
  [SMALL_STATE(4005)] = 122077,
  [SMALL_STATE(4006)] = 122084,
  [SMALL_STATE(4007)] = 122091,
  [SMALL_STATE(4008)] = 122098,
  [SMALL_STATE(4009)] = 122105,
  [SMALL_STATE(4010)] = 122112,
  [SMALL_STATE(4011)] = 122119,
  [SMALL_STATE(4012)] = 122126,
  [SMALL_STATE(4013)] = 122133,
  [SMALL_STATE(4014)] = 122140,
  [SMALL_STATE(4015)] = 122147,
  [SMALL_STATE(4016)] = 122154,
  [SMALL_STATE(4017)] = 122161,
  [SMALL_STATE(4018)] = 122168,
  [SMALL_STATE(4019)] = 122175,
  [SMALL_STATE(4020)] = 122182,
  [SMALL_STATE(4021)] = 122189,
  [SMALL_STATE(4022)] = 122196,
  [SMALL_STATE(4023)] = 122203,
  [SMALL_STATE(4024)] = 122210,
  [SMALL_STATE(4025)] = 122217,
  [SMALL_STATE(4026)] = 122224,
  [SMALL_STATE(4027)] = 122231,
  [SMALL_STATE(4028)] = 122238,
  [SMALL_STATE(4029)] = 122245,
  [SMALL_STATE(4030)] = 122252,
  [SMALL_STATE(4031)] = 122259,
  [SMALL_STATE(4032)] = 122266,
  [SMALL_STATE(4033)] = 122273,
  [SMALL_STATE(4034)] = 122280,
  [SMALL_STATE(4035)] = 122287,
  [SMALL_STATE(4036)] = 122294,
  [SMALL_STATE(4037)] = 122301,
  [SMALL_STATE(4038)] = 122308,
  [SMALL_STATE(4039)] = 122315,
  [SMALL_STATE(4040)] = 122322,
  [SMALL_STATE(4041)] = 122329,
  [SMALL_STATE(4042)] = 122336,
  [SMALL_STATE(4043)] = 122343,
  [SMALL_STATE(4044)] = 122350,
  [SMALL_STATE(4045)] = 122357,
  [SMALL_STATE(4046)] = 122364,
  [SMALL_STATE(4047)] = 122371,
  [SMALL_STATE(4048)] = 122378,
  [SMALL_STATE(4049)] = 122385,
  [SMALL_STATE(4050)] = 122392,
  [SMALL_STATE(4051)] = 122399,
  [SMALL_STATE(4052)] = 122406,
  [SMALL_STATE(4053)] = 122413,
  [SMALL_STATE(4054)] = 122420,
  [SMALL_STATE(4055)] = 122427,
  [SMALL_STATE(4056)] = 122434,
  [SMALL_STATE(4057)] = 122441,
  [SMALL_STATE(4058)] = 122448,
  [SMALL_STATE(4059)] = 122455,
  [SMALL_STATE(4060)] = 122462,
  [SMALL_STATE(4061)] = 122469,
  [SMALL_STATE(4062)] = 122476,
  [SMALL_STATE(4063)] = 122483,
  [SMALL_STATE(4064)] = 122490,
  [SMALL_STATE(4065)] = 122497,
  [SMALL_STATE(4066)] = 122504,
  [SMALL_STATE(4067)] = 122511,
  [SMALL_STATE(4068)] = 122518,
  [SMALL_STATE(4069)] = 122525,
  [SMALL_STATE(4070)] = 122532,
  [SMALL_STATE(4071)] = 122539,
  [SMALL_STATE(4072)] = 122546,
  [SMALL_STATE(4073)] = 122553,
  [SMALL_STATE(4074)] = 122560,
  [SMALL_STATE(4075)] = 122567,
  [SMALL_STATE(4076)] = 122574,
  [SMALL_STATE(4077)] = 122581,
  [SMALL_STATE(4078)] = 122588,
  [SMALL_STATE(4079)] = 122595,
  [SMALL_STATE(4080)] = 122602,
  [SMALL_STATE(4081)] = 122609,
  [SMALL_STATE(4082)] = 122616,
  [SMALL_STATE(4083)] = 122623,
  [SMALL_STATE(4084)] = 122630,
  [SMALL_STATE(4085)] = 122637,
  [SMALL_STATE(4086)] = 122644,
  [SMALL_STATE(4087)] = 122651,
  [SMALL_STATE(4088)] = 122658,
  [SMALL_STATE(4089)] = 122665,
  [SMALL_STATE(4090)] = 122672,
  [SMALL_STATE(4091)] = 122679,
  [SMALL_STATE(4092)] = 122686,
  [SMALL_STATE(4093)] = 122693,
  [SMALL_STATE(4094)] = 122700,
  [SMALL_STATE(4095)] = 122707,
  [SMALL_STATE(4096)] = 122714,
  [SMALL_STATE(4097)] = 122721,
  [SMALL_STATE(4098)] = 122728,
  [SMALL_STATE(4099)] = 122735,
  [SMALL_STATE(4100)] = 122742,
  [SMALL_STATE(4101)] = 122749,
  [SMALL_STATE(4102)] = 122756,
  [SMALL_STATE(4103)] = 122763,
  [SMALL_STATE(4104)] = 122770,
  [SMALL_STATE(4105)] = 122777,
  [SMALL_STATE(4106)] = 122784,
  [SMALL_STATE(4107)] = 122791,
  [SMALL_STATE(4108)] = 122798,
  [SMALL_STATE(4109)] = 122805,
  [SMALL_STATE(4110)] = 122812,
  [SMALL_STATE(4111)] = 122819,
  [SMALL_STATE(4112)] = 122826,
  [SMALL_STATE(4113)] = 122833,
  [SMALL_STATE(4114)] = 122840,
  [SMALL_STATE(4115)] = 122847,
  [SMALL_STATE(4116)] = 122854,
  [SMALL_STATE(4117)] = 122861,
  [SMALL_STATE(4118)] = 122868,
  [SMALL_STATE(4119)] = 122875,
  [SMALL_STATE(4120)] = 122882,
  [SMALL_STATE(4121)] = 122889,
  [SMALL_STATE(4122)] = 122896,
  [SMALL_STATE(4123)] = 122903,
  [SMALL_STATE(4124)] = 122910,
  [SMALL_STATE(4125)] = 122917,
  [SMALL_STATE(4126)] = 122924,
  [SMALL_STATE(4127)] = 122931,
  [SMALL_STATE(4128)] = 122938,
  [SMALL_STATE(4129)] = 122945,
  [SMALL_STATE(4130)] = 122952,
  [SMALL_STATE(4131)] = 122959,
  [SMALL_STATE(4132)] = 122966,
  [SMALL_STATE(4133)] = 122973,
  [SMALL_STATE(4134)] = 122980,
  [SMALL_STATE(4135)] = 122987,
  [SMALL_STATE(4136)] = 122994,
  [SMALL_STATE(4137)] = 123001,
  [SMALL_STATE(4138)] = 123008,
  [SMALL_STATE(4139)] = 123015,
  [SMALL_STATE(4140)] = 123022,
  [SMALL_STATE(4141)] = 123029,
  [SMALL_STATE(4142)] = 123036,
  [SMALL_STATE(4143)] = 123043,
  [SMALL_STATE(4144)] = 123050,
  [SMALL_STATE(4145)] = 123057,
  [SMALL_STATE(4146)] = 123064,
  [SMALL_STATE(4147)] = 123071,
  [SMALL_STATE(4148)] = 123078,
  [SMALL_STATE(4149)] = 123085,
  [SMALL_STATE(4150)] = 123092,
  [SMALL_STATE(4151)] = 123099,
  [SMALL_STATE(4152)] = 123106,
  [SMALL_STATE(4153)] = 123113,
  [SMALL_STATE(4154)] = 123120,
  [SMALL_STATE(4155)] = 123127,
  [SMALL_STATE(4156)] = 123134,
  [SMALL_STATE(4157)] = 123141,
  [SMALL_STATE(4158)] = 123148,
  [SMALL_STATE(4159)] = 123155,
  [SMALL_STATE(4160)] = 123162,
  [SMALL_STATE(4161)] = 123169,
  [SMALL_STATE(4162)] = 123176,
  [SMALL_STATE(4163)] = 123183,
  [SMALL_STATE(4164)] = 123190,
  [SMALL_STATE(4165)] = 123197,
  [SMALL_STATE(4166)] = 123204,
  [SMALL_STATE(4167)] = 123211,
  [SMALL_STATE(4168)] = 123218,
  [SMALL_STATE(4169)] = 123225,
  [SMALL_STATE(4170)] = 123232,
  [SMALL_STATE(4171)] = 123239,
  [SMALL_STATE(4172)] = 123246,
  [SMALL_STATE(4173)] = 123253,
  [SMALL_STATE(4174)] = 123260,
  [SMALL_STATE(4175)] = 123267,
  [SMALL_STATE(4176)] = 123274,
  [SMALL_STATE(4177)] = 123281,
  [SMALL_STATE(4178)] = 123288,
  [SMALL_STATE(4179)] = 123295,
  [SMALL_STATE(4180)] = 123302,
  [SMALL_STATE(4181)] = 123309,
  [SMALL_STATE(4182)] = 123316,
  [SMALL_STATE(4183)] = 123323,
  [SMALL_STATE(4184)] = 123330,
  [SMALL_STATE(4185)] = 123337,
  [SMALL_STATE(4186)] = 123344,
  [SMALL_STATE(4187)] = 123351,
  [SMALL_STATE(4188)] = 123358,
  [SMALL_STATE(4189)] = 123365,
  [SMALL_STATE(4190)] = 123372,
  [SMALL_STATE(4191)] = 123379,
  [SMALL_STATE(4192)] = 123386,
  [SMALL_STATE(4193)] = 123393,
  [SMALL_STATE(4194)] = 123400,
  [SMALL_STATE(4195)] = 123407,
  [SMALL_STATE(4196)] = 123414,
  [SMALL_STATE(4197)] = 123421,
  [SMALL_STATE(4198)] = 123428,
  [SMALL_STATE(4199)] = 123435,
  [SMALL_STATE(4200)] = 123442,
  [SMALL_STATE(4201)] = 123449,
  [SMALL_STATE(4202)] = 123456,
  [SMALL_STATE(4203)] = 123463,
  [SMALL_STATE(4204)] = 123470,
  [SMALL_STATE(4205)] = 123477,
  [SMALL_STATE(4206)] = 123484,
  [SMALL_STATE(4207)] = 123491,
  [SMALL_STATE(4208)] = 123498,
  [SMALL_STATE(4209)] = 123505,
  [SMALL_STATE(4210)] = 123512,
  [SMALL_STATE(4211)] = 123519,
  [SMALL_STATE(4212)] = 123526,
  [SMALL_STATE(4213)] = 123533,
  [SMALL_STATE(4214)] = 123540,
  [SMALL_STATE(4215)] = 123547,
  [SMALL_STATE(4216)] = 123554,
  [SMALL_STATE(4217)] = 123561,
  [SMALL_STATE(4218)] = 123568,
  [SMALL_STATE(4219)] = 123575,
  [SMALL_STATE(4220)] = 123582,
  [SMALL_STATE(4221)] = 123589,
  [SMALL_STATE(4222)] = 123596,
  [SMALL_STATE(4223)] = 123603,
  [SMALL_STATE(4224)] = 123610,
  [SMALL_STATE(4225)] = 123617,
  [SMALL_STATE(4226)] = 123624,
  [SMALL_STATE(4227)] = 123631,
  [SMALL_STATE(4228)] = 123638,
  [SMALL_STATE(4229)] = 123645,
  [SMALL_STATE(4230)] = 123652,
  [SMALL_STATE(4231)] = 123659,
  [SMALL_STATE(4232)] = 123666,
  [SMALL_STATE(4233)] = 123673,
  [SMALL_STATE(4234)] = 123680,
  [SMALL_STATE(4235)] = 123687,
  [SMALL_STATE(4236)] = 123694,
  [SMALL_STATE(4237)] = 123701,
  [SMALL_STATE(4238)] = 123708,
  [SMALL_STATE(4239)] = 123715,
  [SMALL_STATE(4240)] = 123722,
  [SMALL_STATE(4241)] = 123729,
  [SMALL_STATE(4242)] = 123736,
  [SMALL_STATE(4243)] = 123743,
  [SMALL_STATE(4244)] = 123750,
  [SMALL_STATE(4245)] = 123757,
  [SMALL_STATE(4246)] = 123764,
  [SMALL_STATE(4247)] = 123771,
  [SMALL_STATE(4248)] = 123778,
  [SMALL_STATE(4249)] = 123785,
  [SMALL_STATE(4250)] = 123792,
  [SMALL_STATE(4251)] = 123799,
  [SMALL_STATE(4252)] = 123806,
  [SMALL_STATE(4253)] = 123813,
  [SMALL_STATE(4254)] = 123820,
  [SMALL_STATE(4255)] = 123827,
  [SMALL_STATE(4256)] = 123834,
  [SMALL_STATE(4257)] = 123841,
  [SMALL_STATE(4258)] = 123848,
  [SMALL_STATE(4259)] = 123855,
  [SMALL_STATE(4260)] = 123862,
  [SMALL_STATE(4261)] = 123869,
  [SMALL_STATE(4262)] = 123876,
  [SMALL_STATE(4263)] = 123883,
  [SMALL_STATE(4264)] = 123890,
  [SMALL_STATE(4265)] = 123897,
  [SMALL_STATE(4266)] = 123904,
  [SMALL_STATE(4267)] = 123911,
  [SMALL_STATE(4268)] = 123918,
  [SMALL_STATE(4269)] = 123925,
  [SMALL_STATE(4270)] = 123932,
  [SMALL_STATE(4271)] = 123939,
  [SMALL_STATE(4272)] = 123946,
  [SMALL_STATE(4273)] = 123953,
  [SMALL_STATE(4274)] = 123960,
  [SMALL_STATE(4275)] = 123967,
  [SMALL_STATE(4276)] = 123974,
  [SMALL_STATE(4277)] = 123981,
  [SMALL_STATE(4278)] = 123988,
  [SMALL_STATE(4279)] = 123995,
  [SMALL_STATE(4280)] = 124002,
  [SMALL_STATE(4281)] = 124009,
  [SMALL_STATE(4282)] = 124016,
  [SMALL_STATE(4283)] = 124023,
  [SMALL_STATE(4284)] = 124030,
  [SMALL_STATE(4285)] = 124037,
  [SMALL_STATE(4286)] = 124044,
  [SMALL_STATE(4287)] = 124051,
  [SMALL_STATE(4288)] = 124058,
  [SMALL_STATE(4289)] = 124065,
  [SMALL_STATE(4290)] = 124072,
  [SMALL_STATE(4291)] = 124079,
  [SMALL_STATE(4292)] = 124086,
  [SMALL_STATE(4293)] = 124093,
  [SMALL_STATE(4294)] = 124100,
  [SMALL_STATE(4295)] = 124107,
  [SMALL_STATE(4296)] = 124114,
  [SMALL_STATE(4297)] = 124121,
  [SMALL_STATE(4298)] = 124128,
  [SMALL_STATE(4299)] = 124135,
  [SMALL_STATE(4300)] = 124142,
  [SMALL_STATE(4301)] = 124149,
  [SMALL_STATE(4302)] = 124156,
  [SMALL_STATE(4303)] = 124163,
  [SMALL_STATE(4304)] = 124170,
  [SMALL_STATE(4305)] = 124177,
  [SMALL_STATE(4306)] = 124184,
  [SMALL_STATE(4307)] = 124191,
  [SMALL_STATE(4308)] = 124198,
  [SMALL_STATE(4309)] = 124205,
  [SMALL_STATE(4310)] = 124212,
  [SMALL_STATE(4311)] = 124219,
  [SMALL_STATE(4312)] = 124226,
  [SMALL_STATE(4313)] = 124233,
  [SMALL_STATE(4314)] = 124240,
  [SMALL_STATE(4315)] = 124247,
  [SMALL_STATE(4316)] = 124254,
  [SMALL_STATE(4317)] = 124261,
  [SMALL_STATE(4318)] = 124268,
  [SMALL_STATE(4319)] = 124275,
  [SMALL_STATE(4320)] = 124282,
  [SMALL_STATE(4321)] = 124289,
  [SMALL_STATE(4322)] = 124296,
  [SMALL_STATE(4323)] = 124303,
  [SMALL_STATE(4324)] = 124310,
  [SMALL_STATE(4325)] = 124317,
  [SMALL_STATE(4326)] = 124324,
  [SMALL_STATE(4327)] = 124331,
  [SMALL_STATE(4328)] = 124338,
  [SMALL_STATE(4329)] = 124345,
  [SMALL_STATE(4330)] = 124352,
  [SMALL_STATE(4331)] = 124359,
  [SMALL_STATE(4332)] = 124366,
  [SMALL_STATE(4333)] = 124373,
  [SMALL_STATE(4334)] = 124380,
  [SMALL_STATE(4335)] = 124387,
  [SMALL_STATE(4336)] = 124394,
  [SMALL_STATE(4337)] = 124401,
  [SMALL_STATE(4338)] = 124408,
  [SMALL_STATE(4339)] = 124415,
  [SMALL_STATE(4340)] = 124422,
  [SMALL_STATE(4341)] = 124429,
  [SMALL_STATE(4342)] = 124436,
  [SMALL_STATE(4343)] = 124443,
  [SMALL_STATE(4344)] = 124450,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2904),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2942),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2828),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3955),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3994),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3992),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3989),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3988),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3513),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3987),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2939),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4335),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4326),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4321),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(330),
  [118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(378),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 1),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(4167),
  [166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(327),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(327),
  [178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4230),
  [202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4229),
  [204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4228),
  [208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2393),
  [210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(438),
  [215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1122),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(526),
  [326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1076),
  [331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(996),
  [334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(368),
  [340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1184),
  [343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2904),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2942),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2828),
  [352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(368),
  [355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3955),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3994),
  [361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3509),
  [364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(115),
  [367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(404),
  [370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3992),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(46),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3989),
  [379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3988),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3513),
  [385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3514),
  [388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3987),
  [391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(220),
  [394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(237),
  [397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(611),
  [400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(90),
  [403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(131),
  [406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3985),
  [409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2706),
  [412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(569),
  [415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2939),
  [418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(243),
  [421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4335),
  [424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(816),
  [427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(518),
  [430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(518),
  [433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3373),
  [436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3374),
  [439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2948),
  [442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1852),
  [445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1852),
  [448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1851),
  [451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3520),
  [454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1118),
  [457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(531),
  [460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(999),
  [463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4326),
  [466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4324),
  [469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4321),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 219),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 219),
  [476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 92),
  [478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 92),
  [480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, .production_id = 51),
  [482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3, .production_id = 51),
  [484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3798),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3690),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3789),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3783),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2702),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4167),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(116),
  [633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(133),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(816),
  [641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(2990),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4296),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4319),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4342),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4079),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2703),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4024),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [1000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [1002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [1004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [1006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [1008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4026),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [1012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [1020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [1032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [1038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [1048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [1060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [1072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [1074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [1076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [1086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [1102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [1104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [1106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [1110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [1124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [1140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [1142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [1144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [1146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [1150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [1152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [1154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [1156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [1158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [1160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [1162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [1164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [1166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [1174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [1176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [1178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [1180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [1182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [1184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [1186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [1188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2902),
  [1190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2816),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2693),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4114),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4166),
  [1206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4165),
  [1208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [1210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3385),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4232),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3597),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [1248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_rest_pattern, 2, .production_id = 31),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, .production_id = 31),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2926),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4314),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2649),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2929),
  [1365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [1379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 5),
  [1381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 5),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4188),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [1393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [1395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [1397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [1399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2),
  [1401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [1405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4189),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 153),
  [1413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 153),
  [1415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 153),
  [1417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 153),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3, .production_id = 86),
  [1423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3, .production_id = 86),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 200),
  [1429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 200),
  [1431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 200),
  [1433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 200),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [1437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [1459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 48),
  [1465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 48),
  [1467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 48),
  [1469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 48),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 106),
  [1487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 106),
  [1489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 106),
  [1491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 106),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3, .production_id = 87),
  [1503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3, .production_id = 87),
  [1505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 116),
  [1507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 116),
  [1509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 116),
  [1511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 116),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 178),
  [1517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 178),
  [1519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 178),
  [1521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 178),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [1525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [1527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [1529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 28),
  [1535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 28),
  [1537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 179),
  [1543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 179),
  [1545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 179),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 179),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 157),
  [1553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 157),
  [1555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 157),
  [1557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 157),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [1561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 157),
  [1563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 157),
  [1565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 157),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 157),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 107),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 107),
  [1575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 107),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 107),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 136),
  [1583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 136),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 136),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 136),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 214),
  [1593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 214),
  [1595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 214),
  [1597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 214),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [1606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [1608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [1610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [1612] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2444),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [1618] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2646),
  [1622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [1650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [1654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [1656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [1660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [1662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [1668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [1670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_modifier, 1),
  [1672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_modifier, 1),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [1682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3026),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [1726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4262),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4241),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3527),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4305),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [1818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(48),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [1830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3396),
  [1909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(2322),
  [1912] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(124),
  [1916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(359),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [1921] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3597),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2969),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4322),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [1973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [1975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [1977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [1983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4030),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4031),
  [1997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(124),
  [2000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [2002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3597),
  [2005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, .production_id = 31),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4297),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4298),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4293),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4291),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2833),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4246),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4247),
  [2021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(266),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [2028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4021),
  [2030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4020),
  [2032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(467),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4237),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4236),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [2043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [2045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3715),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3762),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4130),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4128),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2922),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4065),
  [2067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4068),
  [2069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4076),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [2073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [2075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 222),
  [2079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 222),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [2083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [2085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 36),
  [2087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 36),
  [2089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [2091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 244),
  [2097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 244),
  [2099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 179),
  [2105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 179),
  [2107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 97),
  [2109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 97),
  [2111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 141),
  [2113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 141),
  [2115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [2117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [2119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 38),
  [2121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 38),
  [2123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 83),
  [2125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 83),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 139),
  [2129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 139),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [2133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [2135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [2137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [2139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 216),
  [2141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 216),
  [2143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 215),
  [2145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 215),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [2149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [2151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 178),
  [2153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 178),
  [2155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 213),
  [2157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 213),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [2161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [2163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 147),
  [2165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 147),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 6),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 6),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [2173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [2175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 211),
  [2177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 211),
  [2179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 106),
  [2185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 106),
  [2187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 107),
  [2189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 107),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 156),
  [2193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 156),
  [2195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 116),
  [2197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 116),
  [2199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 115),
  [2201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 115),
  [2203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 85),
  [2205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 85),
  [2207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 209),
  [2209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 209),
  [2211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 48),
  [2213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 48),
  [2215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [2217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [2219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 91),
  [2221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 91),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 170),
  [2225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 170),
  [2227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 171),
  [2229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 171),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [2233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [2235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 214),
  [2237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 214),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 213),
  [2241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 213),
  [2243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 221),
  [2245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 221),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 48),
  [2249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 48),
  [2251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 104),
  [2253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 104),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [2257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [2259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 70),
  [2261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 70),
  [2263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 153),
  [2265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 153),
  [2267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, .production_id = 85),
  [2269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, .production_id = 85),
  [2271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [2273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [2275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, .production_id = 32),
  [2277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, .production_id = 32),
  [2279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [2281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [2283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [2285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [2287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [2289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [2291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 177),
  [2293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 177),
  [2295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [2297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 157),
  [2301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 157),
  [2303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 157),
  [2305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 157),
  [2307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 26),
  [2309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 26),
  [2311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 153),
  [2313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 153),
  [2315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 136),
  [2317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 136),
  [2319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 45),
  [2325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 45),
  [2327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [2329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [2331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 181),
  [2333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 181),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [2337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [2339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3, .production_id = 35),
  [2341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3, .production_id = 35),
  [2343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [2345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [2347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [2349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [2351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 81),
  [2353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 81),
  [2355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 139),
  [2357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 139),
  [2359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 47),
  [2361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 47),
  [2363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 135),
  [2365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 135),
  [2367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 188),
  [2369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 188),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 240),
  [2373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 240),
  [2375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 183),
  [2377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 183),
  [2379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 83),
  [2381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 83),
  [2383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 84),
  [2385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 84),
  [2387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4),
  [2389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4),
  [2391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 47),
  [2393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 47),
  [2395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 24),
  [2397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 24),
  [2399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 46),
  [2401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 46),
  [2403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [2405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [2407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 96),
  [2409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 96),
  [2411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 130),
  [2413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 130),
  [2415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 37),
  [2417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 37),
  [2419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [2421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [2423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 95),
  [2425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 95),
  [2427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, .production_id = 239),
  [2429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, .production_id = 239),
  [2431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4, .production_id = 35),
  [2433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4, .production_id = 35),
  [2435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 43),
  [2437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 43),
  [2439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 200),
  [2441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 200),
  [2443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 107),
  [2445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 107),
  [2447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [2449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [2451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 106),
  [2453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 106),
  [2455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 211),
  [2457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 211),
  [2459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2601),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [2505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 7, .production_id = 243),
  [2507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 7, .production_id = 243),
  [2509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 186),
  [2511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 186),
  [2513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 187),
  [2515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 187),
  [2517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 98),
  [2523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 98),
  [2525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 220),
  [2527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 220),
  [2529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2472),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [2533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [2541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4208),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4134),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2516),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4194),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4184),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2936),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4044),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4311),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2508),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4047),
  [2627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [2629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3997),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [2643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3416),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4275),
  [2661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2681),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [2671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2766),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [2679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4316),
  [2681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4272),
  [2685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [2687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4271),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [2695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2894),
  [2697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2876),
  [2705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4325),
  [2711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [2713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4135),
  [2715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [2719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [2721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [2723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [2725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [2727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [2729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [2731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2573),
  [2733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4239),
  [2735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [2759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [2763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [2779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [2781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2610),
  [2791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2797),
  [2795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2589),
  [2797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3417),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4096),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [2821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [2823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [2825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [2827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [2831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4070),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [2837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [2841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [2843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [2845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [2847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [2851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [2853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [2859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [2861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [2867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [2869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [2877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [2879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [2881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [2883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [2885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [2887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [2889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [2891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [2897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2614),
  [2899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [2905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [2907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [2909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [2925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [2933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [2937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [2939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3540),
  [2941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [2943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [2945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [2947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [2954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [2969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [2971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [2973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 133),
  [2975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 133),
  [2977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 73),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 73),
  [2981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 175),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 175),
  [2985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2701),
  [2987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [2989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1), REDUCE(aux_sym_object_pattern_repeat1, 1),
  [2992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [2996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [2998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [3000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [3002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [3004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 72),
  [3006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 72),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [3014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [3016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 75),
  [3018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 75),
  [3020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 74),
  [3022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 74),
  [3024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [3026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [3028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [3030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [3032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(323),
  [3035] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 13),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [3041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 13),
  [3044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4055),
  [3047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 13),
  [3050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(859),
  [3053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 13), SHIFT(3896),
  [3056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 13),
  [3058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [3062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4018),
  [3065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(889),
  [3068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [3070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2),
  [3081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(335),
  [3090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [3100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 13),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [3107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [3111] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 13), REDUCE(sym_rest_pattern, 2),
  [3115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(267),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [3122] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1), REDUCE(sym_rest_pattern, 2, .production_id = 31),
  [3126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3730),
  [3128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_rest_pattern, 2),
  [3131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [3135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4040),
  [3137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(473),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [3146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [3148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23), SHIFT_REPEAT(3520),
  [3151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23), SHIFT(2687),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 72),
  [3158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 72),
  [3160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [3162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [3164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [3166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [3168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2629),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [3184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [3188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [3192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4277),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [3212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [3216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2603),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4119),
  [3230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1457),
  [3233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1448),
  [3236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [3244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1587),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [3249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1618),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [3264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1462),
  [3267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2007),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3290] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 29), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 30),
  [3294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 13),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [3298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 58),
  [3304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 58),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [3310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 12),
  [3312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 12),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [3320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 57),
  [3322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 57),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [3328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instantiation_expression, 2, .production_id = 19),
  [3330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instantiation_expression, 2, .production_id = 19),
  [3332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 2, .production_id = 66),
  [3334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 2, .production_id = 66),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [3342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [3348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [3350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [3352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [3354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [3356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [3358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [3366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [3368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [3370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [3376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asserts, 2),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 2),
  [3380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [3382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [3386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 15),
  [3388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 15),
  [3390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [3394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [3396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [3398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [3400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [3404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [3410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [3412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [3414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [3416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [3418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [3420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [3422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2755),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [3426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [3428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [3430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [3432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [3434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [3436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [3438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [3442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [3444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [3446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [3448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [3450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [3452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [3454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [3458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [3460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [3462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [3464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [3466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [3468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [3472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [3474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 71),
  [3476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 71),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [3486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 71), SHIFT(81),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [3491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [3495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 121),
  [3497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 121),
  [3499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 236),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 236),
  [3503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 204),
  [3505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 204),
  [3507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, .production_id = 120),
  [3509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, .production_id = 120),
  [3511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 18),
  [3513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 18),
  [3515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 208),
  [3517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 208),
  [3519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [3521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [3523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 205),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 205),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 111),
  [3531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [3533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [3539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [3543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [3549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 235),
  [3565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 235),
  [3567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [3569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [3571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 6, .production_id = 238),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 6, .production_id = 238),
  [3575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 206),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 206),
  [3579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 169),
  [3581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 169),
  [3583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 258),
  [3585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 258),
  [3587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [3589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [3593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [3599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [3603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 4, .production_id = 65),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 4, .production_id = 65),
  [3607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [3609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 8),
  [3611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 8),
  [3613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4, .production_id = 168),
  [3615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4, .production_id = 168),
  [3617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [3619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2),
  [3621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [3623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [3626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [3629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [3631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [3634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, .production_id = 16),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, .production_id = 16),
  [3641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 69),
  [3643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [3645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 25),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 166),
  [3651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 166),
  [3653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 165),
  [3655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 165),
  [3657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [3659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [3661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [3663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2),
  [3665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2),
  [3667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 164),
  [3669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 164),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [3673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 68),
  [3675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, .production_id = 122),
  [3677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, .production_id = 122),
  [3679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 163),
  [3681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 163),
  [3683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 123),
  [3685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 123),
  [3687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 113),
  [3689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [3691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [3697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, .production_id = 124),
  [3699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, .production_id = 124),
  [3701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [3703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [3705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 162),
  [3707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 162),
  [3709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 161),
  [3711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 161),
  [3713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [3715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [3717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [3719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [3721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [3723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 174),
  [3725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 93),
  [3727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 93),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 207),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 207),
  [3735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 176),
  [3737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 176),
  [3739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 59),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 59),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [3745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 60),
  [3747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 60),
  [3749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 234),
  [3751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 234),
  [3753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [3755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(81),
  [3762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_satisfies_expression, 3),
  [3764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_satisfies_expression, 3),
  [3766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(81),
  [3773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [3775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [3777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 73),
  [3779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 73),
  [3781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 3),
  [3783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 3),
  [3785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [3787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [3789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 2),
  [3791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 2),
  [3793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 127),
  [3795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 127),
  [3797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3, .production_id = 87), REDUCE(sym_nested_type_identifier, 3, .production_id = 127),
  [3800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 62),
  [3802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 62),
  [3804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 72),
  [3806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 72),
  [3808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2),
  [3810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2),
  [3812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [3814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [3816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [3818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [3820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [3822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [3824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 114),
  [3826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 79),
  [3828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 237),
  [3830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 237),
  [3832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [3834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [3836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 129),
  [3838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 129),
  [3840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, .production_id = 65),
  [3842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, .production_id = 65),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 71),
  [3848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [3850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [3852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [3854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 133),
  [3856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 133),
  [3858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 67),
  [3860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 67),
  [3862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [3864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [3866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(81),
  [3869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3, .production_id = 86), REDUCE(sym_nested_type_identifier, 3, .production_id = 127),
  [3872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [3876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [3896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [3902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [3904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [3908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [3910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [3920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [3924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [3926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [3932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [3936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [3946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(82),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [3953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [3963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(82),
  [3966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(79),
  [3969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 11),
  [3971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 11),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [3975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 117),
  [3981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 117),
  [3983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 79),
  [3985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 71), SHIFT(79),
  [3988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [3995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(82),
  [3998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 3, .production_id = 78),
  [4000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 3, .production_id = 78),
  [4002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 77),
  [4004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 77),
  [4006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 76),
  [4008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 76),
  [4010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [4012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [4014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 15),
  [4017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 15),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [4022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 68), REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [4025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 68),
  [4027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [4030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [4033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [4035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [4037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 88), REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [4040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 88),
  [4042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 88), REDUCE(sym_assignment_expression, 3, .production_id = 25),
  [4045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(79),
  [4048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 180),
  [4050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 180),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [4054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 155),
  [4056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 155),
  [4058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [4060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [4064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [4066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [4068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_closing_tag, 1),
  [4070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_closing_tag, 1),
  [4072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 2, .production_id = 20),
  [4074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 2, .production_id = 20),
  [4076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [4078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 29),
  [4080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, .production_id = 30),
  [4082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 29),
  [4084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 29), REDUCE(sym_object_pattern, 3, .production_id = 30),
  [4087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 92),
  [4089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 92), SHIFT(413),
  [4092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 138),
  [4094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 138),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2866),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [4100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [4104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [4110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 137),
  [4112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 137),
  [4114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 134),
  [4116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 134),
  [4118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [4120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [4122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [4125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [4130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [4133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [4135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(79),
  [4138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 69),
  [4140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 82),
  [4142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 82),
  [4144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [4146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [4148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [4150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [4152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 110),
  [4154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 110),
  [4156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 111),
  [4158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 118),
  [4160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 118),
  [4162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [4164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [4168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 51),
  [4170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 51),
  [4172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 112),
  [4174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 112),
  [4176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 52),
  [4178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 52),
  [4180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 29),
  [4182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 29),
  [4184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 53),
  [4186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 53),
  [4188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [4190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [4192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 71), SHIFT(82),
  [4195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 112),
  [4197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 112),
  [4199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 114),
  [4201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [4203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [4207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 113),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [4221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [4227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [4229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [4233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [4247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [4253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [4275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [4291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [4297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2629),
  [4300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2314),
  [4303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(241),
  [4308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2136),
  [4311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4096),
  [4314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3489),
  [4317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3490),
  [4320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2502),
  [4323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3717),
  [4326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1883),
  [4329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2058),
  [4332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2172),
  [4335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2004),
  [4338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2095),
  [4341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2168),
  [4344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2306),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [4353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 71), SHIFT(85),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [4358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(85),
  [4361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(85),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [4366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(85),
  [4369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, .production_id = 30),
  [4375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [4383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 68),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [4389] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__extends_clause_single, 1, .production_id = 49),
  [4395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [4397] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [4403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [4405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [4417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [4421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [4423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [4429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [4433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [4441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [4443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [4449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [4453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [4459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [4465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [4479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [4483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 71), SHIFT(87),
  [4486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 9), REDUCE(sym__primary_type, 1, .production_id = 15),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [4497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 89),
  [4499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(87),
  [4502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(87),
  [4505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(87),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [4522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [4528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [4530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 71), SHIFT(86),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [4537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [4549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [4551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [4557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 39),
  [4559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 39),
  [4561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 15), REDUCE(sym__parameter_name, 2, .production_id = 39),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [4576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4579] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 9), REDUCE(sym__primary_type, 1, .production_id = 15),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [4587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 39),
  [4589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 39),
  [4591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [4593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(86),
  [4596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(86),
  [4599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(86),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [4604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 5, .production_id = 189),
  [4606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 5, .production_id = 189),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [4616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(78),
  [4619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [4623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [4627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [4633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [4647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [4659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 103),
  [4661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 103),
  [4663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 71), SHIFT(78),
  [4666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 99),
  [4668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 99),
  [4670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [4675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_computed_property_name, 3),
  [4680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [4683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [4685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [4688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [4692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 42),
  [4694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 42),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [4710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__extends_clause_single, 2, .production_id = 108),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 92), SHIFT(463),
  [4717] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1), REDUCE(sym_rest_pattern, 2),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [4723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 146),
  [4725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 146),
  [4727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [4729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 144),
  [4731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 144),
  [4733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(78),
  [4736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(78),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [4745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [4752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 29), REDUCE(sym_object_pattern, 3, .production_id = 30),
  [4755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [4762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(80),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [4767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [4777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [4779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [4789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [4793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [4803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [4805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [4807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [4809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 71), SHIFT(80),
  [4812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(80),
  [4815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(80),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [4822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [4826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [4828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [4830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 51), REDUCE(sym_class, 4, .production_id = 137),
  [4833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 51), REDUCE(sym_class, 4, .production_id = 137),
  [4836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [4844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 52), REDUCE(sym_class, 4, .production_id = 138),
  [4847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 52), REDUCE(sym_class, 4, .production_id = 138),
  [4850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [4854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [4858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [4862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [4864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [4866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 48), REDUCE(sym_class, 4, .production_id = 136),
  [4869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 48), REDUCE(sym_class, 4, .production_id = 136),
  [4872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 106), REDUCE(sym_class, 5, .production_id = 178),
  [4875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 106), REDUCE(sym_class, 5, .production_id = 178),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [4880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 107), REDUCE(sym_class, 5, .production_id = 179),
  [4883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 107), REDUCE(sym_class, 5, .production_id = 179),
  [4886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 110), REDUCE(sym_class, 5, .production_id = 180),
  [4889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 110), REDUCE(sym_class, 5, .production_id = 180),
  [4892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 11), REDUCE(sym_class, 3, .production_id = 82),
  [4895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 11), REDUCE(sym_class, 3, .production_id = 82),
  [4898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4142),
  [4900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 153), REDUCE(sym_class, 6, .production_id = 214),
  [4903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 153), REDUCE(sym_class, 6, .production_id = 214),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [4908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [4912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [4914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [4916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [4922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [4926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [4928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [4934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4197),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [4938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [4944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [4948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [4952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [4958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [4962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [4966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [4970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2268),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [4974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [4980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [4984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [4988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [4992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2272),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [4996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [5000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [5006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [5012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [5014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [5018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [5022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [5024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3371),
  [5026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 1),
  [5028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [5032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [5038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [5040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [5044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [5048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [5054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 29), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 30),
  [5057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [5059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [5061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [5065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [5067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [5069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [5071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [5073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [5079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [5081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [5083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [5085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 29),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [5097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4035),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [5107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [5109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [5111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 200),
  [5113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 200),
  [5115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 217),
  [5117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 217),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [5121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 260),
  [5123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 260),
  [5125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 259),
  [5127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 259),
  [5129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 157),
  [5131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 157),
  [5133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [5139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 184),
  [5141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 184),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [5149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [5151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 10, .production_id = 281),
  [5153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 10, .production_id = 281),
  [5155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 242),
  [5157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 242),
  [5159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 241),
  [5161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 241),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [5165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [5169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [5173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [5177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [5179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 116),
  [5181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 116),
  [5183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 142),
  [5185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 142),
  [5187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 272),
  [5189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 272),
  [5191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 271),
  [5193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 271),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [5197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 90),
  [5199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 90),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [5213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [5215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [5217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [5219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_static_block, 2, .production_id = 11),
  [5221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_static_block, 2, .production_id = 11),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [5231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [5233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [5241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [5249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [5257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [5259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [5261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2326),
  [5263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [5265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [5267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [5273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [5279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [5281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [5283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [5285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [5287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3856),
  [5289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4192),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [5329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4168),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [5401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 85),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [5413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [5425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [5427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2852),
  [5429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2421),
  [5431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [5433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 148),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [5439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3687),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [5443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3682),
  [5445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_identifier, 1, .production_id = 1),
  [5447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_identifier, 1, .production_id = 1),
  [5449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [5453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [5455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 198),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [5461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 232),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [5469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 232),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [5473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [5477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 85),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [5481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 198),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [5491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [5497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 148),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [5507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 13), REDUCE(sym_type_parameter, 1, .production_id = 14),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [5512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 13), SHIFT(925),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [5521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [5523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 232),
  [5525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 148),
  [5527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 85),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [5531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 148),
  [5533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 198),
  [5535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 85),
  [5537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 232),
  [5539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 13), SHIFT(3896),
  [5542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [5544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [5546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 198),
  [5548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3714),
  [5550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2689),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [5556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2844),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [5564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [5572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 22),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [5580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [5586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [5590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [5592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [5594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2777),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [5600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2778),
  [5602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3524),
  [5604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3525),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [5608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2721),
  [5610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2746),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [5614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [5616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [5620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2720),
  [5622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [5624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [5626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3654),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3346),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [5634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2761),
  [5636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [5648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2),
  [5650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [5662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 257),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [5666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, .production_id = 30),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [5670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [5674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [5678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [5692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2813),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [5698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4150),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [5718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [5720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [5722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4268),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [5726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, .production_id = 10),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [5736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 61),
  [5738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 156),
  [5740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 152),
  [5742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 115),
  [5744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 190),
  [5746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2, .production_id = 119),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [5752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 105),
  [5754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 223),
  [5756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 224),
  [5758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 131),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [5764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 131),
  [5766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 249),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [5772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 250),
  [5774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 261),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [5780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 262),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [5786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 159),
  [5788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(323),
  [5791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 160),
  [5793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 275),
  [5795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 280),
  [5797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 9, .production_id = 283),
  [5799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 14),
  [5801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2591),
  [5803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3956),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [5809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_chain, 1),
  [5811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3725),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [5815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [5835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [5843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [5845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 257),
  [5847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 203),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [5853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2410),
  [5855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [5857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(335),
  [5860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [5864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [5866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [5878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [5880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 132),
  [5882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 132),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [5948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, .production_id = 10),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [5976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [5980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [5988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(3006),
  [5991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [5993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(261),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [5998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 131),
  [6000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 131),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [6020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [6030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 80),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [6036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [6040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts_annotation, 2),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [6088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1215),
  [6091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [6107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [6111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [6113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(4002),
  [6116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [6118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(265),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [6127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [6151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [6153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(801),
  [6156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [6158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(878),
  [6161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(805),
  [6164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [6178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [6188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 150),
  [6190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 93),
  [6192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2),
  [6194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(923),
  [6197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(3178),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [6202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2),
  [6204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 158),
  [6206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(901),
  [6209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 150),
  [6211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 93),
  [6213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(929),
  [6216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [6218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(913),
  [6221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 34),
  [6223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [6225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 191),
  [6227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4, .production_id = 192),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [6231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 194),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [6239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 34),
  [6241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 196),
  [6243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(807),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [6250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 278),
  [6252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 274),
  [6254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 273),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [6262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 7, .production_id = 267),
  [6264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 270),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [6268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 267),
  [6270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 265),
  [6272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 264),
  [6274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 194),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [6278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 196),
  [6280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 202),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [6288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 256),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [6292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 253),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [6300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 132),
  [6302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 132),
  [6304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 201),
  [6306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [6310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(815),
  [6313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 56),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [6317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 245),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [6325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 256),
  [6327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [6331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 226),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [6337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 230),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [6341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 248),
  [6343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 5, .production_id = 233),
  [6345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 230),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [6351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 253),
  [6353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 226),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [6357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [6361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 247),
  [6363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5, .production_id = 231),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [6367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 30),
  [6369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [6371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [6373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [6375] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [6381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [6383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [6385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [6387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [6389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [6395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [6411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [6421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3565),
  [6423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [6429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [6431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 5, .production_id = 246),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [6441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3481),
  [6443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [6445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 41),
  [6447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(180),
  [6450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 50),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [6454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [6464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 64),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [6468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [6472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [6474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(3425),
  [6477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [6479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(3426),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [6488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2912),
  [6491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [6495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [6497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 101),
  [6499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [6501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 109),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [6505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [6509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [6511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 126),
  [6513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1),
  [6515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1), REDUCE(aux_sym_template_literal_type_repeat1, 1),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [6520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(953),
  [6523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [6527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [6529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [6531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [6535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [6537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [6541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 154),
  [6543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 154), SHIFT_REPEAT(288),
  [6546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [6550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 172),
  [6552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 172),
  [6554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 173),
  [6556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 173),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [6564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2753),
  [6566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [6574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [6576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2613),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [6586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [6594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [6596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [6598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [6608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 85),
  [6610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 210),
  [6612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 210), SHIFT_REPEAT(3469),
  [6615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 210),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [6623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 229),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [6639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [6647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, .production_id = 89),
  [6649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 252),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [6661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3828),
  [6663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3746),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [6667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [6669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [6671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [6673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(473),
  [6676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 93),
  [6678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 94),
  [6680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 255),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [6700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_identifier, 1),
  [6702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(130),
  [6705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 228),
  [6709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 227),
  [6711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 225),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [6719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [6721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [6723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [6727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 2, .production_id = 85),
  [6729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 33),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [6735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [6747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2), SHIFT_REPEAT(3565),
  [6750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2),
  [6752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 263),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [6766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 224),
  [6768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 266),
  [6770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 268),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [6774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 269),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [6786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [6800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [6802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [6822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 193),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [6826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 156),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [6832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 223),
  [6834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [6836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 212), SHIFT_REPEAT(2309),
  [6839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 212),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [6847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [6859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 251),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [6863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 199),
  [6865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 195),
  [6867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(3722),
  [6870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [6878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 254),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [6886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 190),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [6890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 276),
  [6892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 277),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [6900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 197),
  [6902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 279),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [6908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, .production_id = 282),
  [6910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [6922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 1, .production_id = 5),
  [6924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4),
  [6926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2815),
  [6929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [6933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [6963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(2161),
  [6966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [6970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3808),
  [6972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2), SHIFT_REPEAT(2137),
  [6975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2),
  [6977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3811),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [6981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2776),
  [6984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [6986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 249),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [7002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 149),
  [7004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 115),
  [7006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 151),
  [7008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2), SHIFT_REPEAT(176),
  [7011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2),
  [7013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [7017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 94),
  [7019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 50),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [7037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_export_name, 1),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [7049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3531),
  [7051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4004),
  [7053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [7061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 3),
  [7063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(784),
  [7066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [7078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4, .production_id = 167),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [7090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 3, .production_id = 140),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [7096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [7102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 1, .production_id = 5),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [7106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 40),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [7110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [7114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 33),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [7120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 4, .production_id = 182),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [7124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 145),
  [7126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 4, .production_id = 185),
  [7128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 4, .production_id = 182),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [7152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 3, .production_id = 143),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [7158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 63),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [7168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 3, .production_id = 140),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [7178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3, .production_id = 93),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [7196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 128),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [7202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [7204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2, .production_id = 34),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [7218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 125),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [7238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6, .production_id = 218),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [7246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 32),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [7258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [7262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [7268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [7272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 102),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [7276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [7278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 100),
  [7280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [7290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 2, .production_id = 85),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [7296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_opening_tag, 1),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [7304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3),
  [7306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [7318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [7330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_export, 3),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [7338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [7340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [7352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4041),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [7356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4273),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [7360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [7378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [7382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [7404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [7434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4281),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4257),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [7446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [7542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [7562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [7582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [7598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4243),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [7606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [7614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [7642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [7650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [7652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [7654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [7656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [7660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [7664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [7668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [7670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [7672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [7674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [7688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [7692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [7694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [7696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [7706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [7708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [7712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [7730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [7734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [7736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [7742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [7748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [7754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [7778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [7780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [7782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [7786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [7788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [7790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [7792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [7800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [7802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [7806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [7810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [7814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [7816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [7818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [7820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [7822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [7824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [7826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [7828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [7830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [7832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [7834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [7836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [7838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [7860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [7866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [7868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [7876] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [7878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [7880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [7884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [7894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [7904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [7906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4240),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [7912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [7916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
